(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`ActiveContour`"] = {2008,11,14,12,0,0};

Protect[TimeStamp];


(*:Name: MathVisionTools`ActiveContour` *)

(*:Author: Erik Pelgrim, Markus van Almsick, and Hans van Assen *)

(*:Email address: m.v.almsick@tue.nl *)

(*:Context: MathVisionTools`ActiveContour` *)

(*:Package Version: 1.0 *)

(*:Mathematica Version: 6.0 or higher *)

(*:Copyright: Copyright 2007, Markus van Almsick *)

(*:Title: ActiveContour *)

(*:Summary: This package active contours in 2D. *)

(*:Keywords: active contour, snake, splines *)

(*:Warning: None. *)

(*:Requirements: None *)

(*:Source: None *)

(*:History: Version 1.0 by Markus van Almsick, Decemeber 2007 *)

(*:Limitations: highly dependent on the Splines` packages. *)

(*:Discussion: *)

(*:To do: *)


BeginPackage[
"MathVisionTools`ActiveContour`", {"Splines`"}
]

Unprotect[ActiveContour,ActiveContourStep, ActiveContourPlot,CubicLoop,SplineLength,ApproximationOrder];


CubicLoop::usage="CubicLoop is a setting specifying the type of spline generated by Spline and SplineFit."


SplineLength::usage = "SplineLength[spline|splinefunction] renders the approximate path length of a cubic spline or loop given by a Spline graphic primitive or a SplineFunction. Use the option ApproximationOrder to determine the quality of the approximation.";


ApproximationOrder::usage = "ApproximationOrder is an Option of SplineLength to determine the order of a spline path length approximation. Possible values are 0,1,2, and \[Infinity] for a numerically exact solution. The default is 2nd order.";


ActiveContour::usage="ActiveContour[n] < NOT YET IMPLEMENTED >."


ActiveContourStep::usage="ActiveContourStep[n] < NOT YET IMPLEMENTED >."


ActiveContourPlot::usage="ActiveContourPlot[n] < NOT YET IMPLEMENTED >."


Begin["`Private`"]


Unprotect[Splines`SplineFit];


Splines`SplineFit[data_List?(MatrixQ[#1,NumberQ[N[#1]]&]&),CubicLoop]:=
Module[
{n = First[Dimensions[data]],d,b =RotateLeft[data]-RotateRight[data]},
d = Transpose[LinearSolve[
SparseArray[{Band[{1,1}]-> 4, Band[{1,2}]-> 1,Band[{2,1}]-> 1, {n,1}-> 1,{1,n}-> 1},{n,n}],#]&/@ Transpose[3b]];
Splines`SplineFunction@@{CubicLoop,N[{0,n}],data,Transpose[{#1,#3,3(#2-#1 ) -2 #3-#4,2(#1 - #2) + #3+#4},{3,1,2}]&[data,RotateLeft[data],d,RotateLeft[d]]}
]


Splines`Private`splineinternal[pts_List,CubicLoop] :=
		Transpose[Map[Splines`Private`splinecoord,Transpose[pts]]]


Splines`Private`evalspline[pt_?(# == 0 &), CubicLoop, pts_, internal_] :=
	internal[[1,All,1]]

Splines`Private`evalspline[pt_,CubicLoop,pts_,internal_]:=Module[{tmp},({1,#1,#1^2,#1^3}&)[If[(tmp=Mod[pt,1])==0,1,tmp]].Transpose[internal[[Ceiling[pt]]]]]


Protect[Splines`SplineFit];


Unprotect[Splines`Spline];


Splines`Spline/:Derivative[1][Splines`Spline[pts_List,type:(Cubic|CubicLoop),
		SplineFunction[t_,r_,cpts_,coefficients_List]],
		opts:(_Rule | _RuleDelayed)...] :=
Module[
{dcoeff,ddata},
dcoeff=Map[({0,1,2,3}#)[[{2,3,4,1}]]&,coefficients,{2}];
ddata = Append[dcoeff[[All,All,2]],Map[Total,dcoeff[[-1,All]]]];
Splines`Spline[ddata,type,Splines`SplineFunction@@{t,r,ddata,dcoeff},opts]
]/; pts === cpts && type === t


Splines`Spline/:Derivative[2][Splines`Spline[pts_List,type:(Cubic|CubicLoop),
		SplineFunction[t_,r_,cpts_,coefficients_List]],
		opts:(_Rule | _RuleDelayed)...] :=
Module[
{dcoeff,ddata},
dcoeff=Map[({0,0,2,6}#)[[{3,4,1,2}]]&,coefficients,{2}];
ddata = Append[dcoeff[[All,All,2]],Map[Total,dcoeff[[-1,All]]]];
Splines`Spline[ddata,type,Splines`SplineFunction@@{t,r,ddata,dcoeff},opts]
]/; pts === cpts && type === t


Protect[Splines`Spline];


Unprotect[Splines`SplineFunction];


Splines`SplineFunction/:Derivative[1][Splines`SplineFunction[type:(Cubic|CubicLoop), range_, data_, coefficients_]] := 
Module[
{dcoeff,ddata},
dcoeff=Map[({0,1,2,3}#)[[{2,3,4,1}]]&,coefficients,{2}];
ddata = Append[dcoeff[[All,All,2]],Map[Total,dcoeff[[-1,All]]]];
Splines`SplineFunction@@{type, range, ddata, dcoeff}
]


Splines`SplineFunction/:Derivative[2][Splines`SplineFunction[type:(Cubic|CubicLoop), range_, data_, coefficients_]] :=
Module[
{dcoeff,ddata},
dcoeff=Map[({0,0,2,6}#)[[{3,4,1,2}]]&,coefficients,{2}];
ddata = Append[dcoeff[[All,All,2]],Map[Total,dcoeff[[-1,All]]]];
Splines`SplineFunction@@{type, range, ddata, dcoeff}
]


Protect[Splines`SplineFunction];


Options[SplineLength] = {ApproximationOrder-> 2};


SplineLength[{{a0_,a1_,a2_,a3_},{b0_,b1_,b2_,b3_}},0]=Sqrt[(a1+a2+a3)^2+(b1+b2+b3)^2];


SplineLength[{{_,a1_,a2_,a3_},{_,b1_,b2_,b3_}},1]=Sqrt[(a1+a2+3 a3/4)^2+(b1+b2+3 b3/4)^2];


SplineLength[{{_,a1_,a2_,a3_},{_,b1_,b2_,b3_}},2|3]:=
Module[{x1=a1+a2+3 a3/4,y1=b1+b2+3 b3/4,x2=2 a2+3 a3,y2=2 b2+3 b3},
1/24 Sqrt[x1^2+y1^2] (24+(6 a3 x1 (x1^2+y1^2)+6 b3 y1 (x1^2+y1^2)+(x2 y1-x1 y2)^2)/(x1^2+y1^2)^2)]


SplineLength[{{_,a1_,a2_,a3_},{_,b1_,b2_,b3_}},4]:=
Module[{x1=a1+a2+3 a3/4,y1=b1+b2+3 b3/4,x2=2 a2+3 a3,y2=2 b2+3 b3},
1/(3840 (x1^2+y1^2)^(3/2)) (216 (a3^2+b3^2) (x1^2+y1^2)+3840 (x1^2+y1^2)^2+36 (2 a2 a3+3 a3^2+b3 y2) (x1 x2+y1 y2)+160 (6 a3 x1 (x1^2+y1^2)+6 b3 y1 (x1^2+y1^2)+(x2 y1-x1 y2)^2)-1/(x1^2+y1^2)6 (6 a3 x1+x2^2+6 b3 y1+y2^2) (6 a3 x1 (x1^2+y1^2)+6 b3 y1 (x1^2+y1^2)+(x2 y1-x1 y2)^2)-15 (x1 x2+y1 y2) (12 (2 a2 a3+3 a3^2+b3 y2)-(2 (x1 x2+y1 y2) (6 a3 x1 (x1^2+y1^2)+6 b3 y1 (x1^2+y1^2)+(x2 y1-x1 y2)^2))/(x1^2+y1^2)^2))]


SplineLength[{{_,a1_,a2_,a3_},{_,b1_,b2_,b3_}},\[Infinity]]:=NIntegrate[Sqrt[(a1+t (2 a2+3 a3 t))^2+(b1+t (2 b2+3 b3 t))^2],{t,0,1}]


SplineLength[splinefunc:SplineFunction[Cubic|CubicLoop,__],opts___?OptionQ]:=
Module[
{ord=ApproximationOrder/.{opts}/.Options[SplineLength]},
If[Not[MatchQ[ord,0|1|2|3|4|\[Infinity]]],ord=2];
Total[Map[SplineLength[#,ord]&,N[Last[splinefunc]]]]
];


SplineLength[spline:Spline[_,Cubic|CubicLoop,__],opts___?OptionQ]:=Module[
{ord = ApproximationOrder/.{opts}/.Options[SplineLength]},
If[Not[MatchQ[ord,0|1|2|3|4|\[Infinity]]],ord=2];
Total[Map[SplineLength[#,ord]&,N[Last[Last[spline]]]]]
];


End[]

SetAttributes[
{ActiveContour,ActiveContourStep, ActiveContourPlot,CubicLoop,SplineLength,ApproximationOrder},
{Protected}
];

EndPackage[]
