(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`CompletionField`"] = {2005,12,12,23,27,0};

Protect[TimeStamp];


(*:Name: MathVisionTools`CompletionField` *)

(*:Author: Markus van Almsick*)

(*:Email address: M.v.Almsick@tue.nl*)

(*:Context: MathVisionTools`CompletionField`*)

(*:Package Version: 1.2 *)

(*:Mathematica Version: 5.1 *)

(*:Copyright: Copyright 2005, Technische Universiteit Eindhoven*)

(*:Title: Stochastic Completion Field, Tensor Voting *)

(*:Summary: This package implements routines for line and edge completion *)

(*:Keywords: Stochastic Completion Field, Tensor Voting, Spline, Steerability *)

(*:Requirements: None *)

(*:Source: None *)

(*:History: Version 1.0 by Markus van Almsick, March 2005 *)

(*:Limitations: The analytic implentation of the stochastic completion kernel is
an approximation for small angels \[Alpha]. The tensor voting field is in accordance with the stochastic completion field. It is NOT Medioni's completion field *)

(*:Discussion: *)

(*:To do: *)


BeginPackage[
"MathVisionTools`CompletionField`",{"Splines`"}
]

Unprotect[
CompletionKernelAlongX,
NCompletionKernelAlongX,
NCompletionKernelxyMarginalAlongX,
CompletionKernel,
NCompletionKernel,
NCompletionKernelxyMarginal,
PolarCompletionKernel,
NPolarCompletionKernel,
NPolarCompletionKernelr\[Theta]Marginal,
PolarCompletionKernelM,
NPolarCompletionKernelM,
NPolarCompletionKernelMr\[Theta]Marginal,
CompletionField,
CompletionMode,
CompletionModeAlongX,
CompletionSpline,
TensorVotingKernel,
TensorVotingKernelM,
MedioniTensorVotingKernel
]


CompletionKernelAlongX::usage = "CompletionKernelAlongX[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,y,\[Alpha]]. CompletionKernelAlongX[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,y]"

NCompletionKernelAlongX::usage = "NCompletionKernelAlongX[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y,\[Alpha]]"

NCompletionKernelxyMarginalAlongX::usage = "NCompletionKernelxyMarginalAlongX[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y]"

CompletionKernel::usage = "CompletionKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,y,\[Alpha]]. CompletionKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,y]"

NCompletionKernel::usage = "NCompletionKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y,\[Alpha]]"

NCompletionKernelxyMarginal::usage = "NCompletionKernelxyMarginal[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y]"

PolarCompletionKernel::usage = "PolarCompletionKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][r,\[Theta],\[Alpha]]. PolarCompletionKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][r,\[Theta]]"

NPolarCompletionKernel::usage = "NPolarCompletionKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],r,\[Theta],\[Alpha]]"

NPolarCompletionKernelr\[Theta]Marginal::usage = "NPolarCompletionKernelr\[Theta]Marginal[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],r,\[Theta]]"

PolarCompletionKernelM::usage = "PolarCompletionKernelM[m,\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][r,\[Alpha]].PolarCompletionKernelM[m,\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][r]"

NPolarCompletionKernelM::usage = "NPolarCompletionKernelM[m,\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],r,\[Alpha]]"

NPolarCompletionKernelMrMarginal::usage = "NPolarCompletionKernelMr\[Theta]Marginal[m,\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],r]"

CompletionField::usage = "CompletionField[\[Sigma],\[Lambda],{x0,y0,\[Alpha]0,\[Kappa]0},{x1,y1,\[Alpha]1,\[Kappa]1}][x,y,\[Alpha]]. CompletionField[\[Sigma],\[Lambda],{x0,y0,\[Alpha]0,\[Kappa]0},{x1,y1,\[Alpha]1,\[Kappa]1}][x,y]"

CompletionMode::usage = "CompletionMode[{x0,y0,\[Alpha]0,\[Kappa]0},{x1,y1,\[Alpha]1,\[Kappa]1}][t]"

CompletionModeAlongX::usage = "CompletionModeAlongX[{x0,y0,\[Alpha]0,\[Kappa]0},{x1,y1,\[Alpha]1,\[Kappa]1}][t]"

CompletionSpline::usage = "CompletionSpline[{x0,y0,\[Alpha]0},{x1,y1,\[Alpha]1}]"

TensorVotingKernel::usage = "TensorVotingKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][r,\[Theta]]"

TensorVotingKernelM::usage = "TensorVotingKernelM[m,\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][r]"

MedioniTensorVotingKernel::usage = "MedioniTensorVotingKernel[\[Sigma],c][r,\[Theta]].MedioniTensorVotingKernel[1,\[Sigma],c][r,\[Theta]].MedioniTensorVotingKernel[2,\[Sigma],c][r,\[Theta]]"


Begin["`Private`"]


(* Completion Kernel Along X *)


(* Numeric Implementation *)

NCompletionKernelAlongX=Compile[
{{\[Sigma],_Real},{\[Lambda],_Real},{\[Alpha]0,_Real},{\[Kappa],_Real},{x,_Real},{y,_Real},{\[Alpha],_Real}},
If[x>0\[And] 2 Abs[\[Alpha]0]<\[Pi]\[And] 2 Abs[\[Alpha]]<\[Pi],Chop[(Sqrt[3]/(\[Pi] (x \[Sigma])^2) Exp[-x \[Lambda]-(2 (3 #1^2+(x #2-3 #1) x #2))/(x^3 \[Sigma]^2)])&[y-x(Tan[\[Alpha]0]+\[Kappa] x/2),Tan[\[Alpha]]-Tan[\[Alpha]0]-\[Kappa] x]],0.0]
];

CompletionKernelAlongX[\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][0|0.0, y_?NumberQ,\[Alpha]_?NumberQ]=DiracDelta[y] DiracDelta[\[Alpha]-\[Alpha]0];

CompletionKernelAlongX[\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][x_?NumberQ, y_?NumberQ,\[Alpha]_?NumberQ]:=NCompletionKernelAlongX[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y,\[Alpha]]


NCompletionKernelxyMarginalAlongX=Compile[
{{\[Sigma],_Real},{\[Lambda],_Real},{\[Alpha]0,_Real},{\[Kappa],_Real},{x,_Real},{y,_Real}},
If[x>0\[And] 2 Abs[\[Alpha]0]<\[Pi],Chop[Sqrt[3/(2 \[Pi] x^3 \[Sigma]^2)] Exp[-x \[Lambda]-3/(8 x^3 \[Sigma]^2) (x (2 Tan[\[Alpha]0]+x \[Kappa])-2 y)^2]] ,0.0]
];

CompletionKernelAlongX[\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][0|0.0, y_?NumberQ]=DiracDelta[y];

CompletionKernelAlongX[\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][x_?NumberQ, y_?NumberQ]:=NCompletionKernelxyMarginalAlongX[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y]


(* Symbolic Implementation *)

CompletionKernelAlongX[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][0|0.0, 0|0.0,\[Alpha]0_]=DirectedInfinity[1];

CompletionKernelAlongX[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][0|0.0, y_,\[Alpha]_]=0;

CompletionKernelAlongX[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][x_, y_,\[Alpha]_]= \[Piecewise]{
 {Sqrt[3]/(\[Pi] (x \[Sigma])^2) Exp[-\[Lambda] x]Exp[-(1/(2 x^3 \[Sigma]^2))( 3 (x (Tan[\[Alpha]]+Tan[\[Alpha]0])-2 y)^2+(x(Tan[\[Alpha]]-Tan[\[Alpha]0]-x \[Kappa]))^2)], x>0 \[And] 2 Abs[\[Alpha]]<\[Pi] \[And] 2 Abs[\[Alpha]0]<\[Pi]}
};


CompletionKernelAlongX[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][0|0.0, 0|0.0]=DirectedInfinity[1];

CompletionKernelAlongX[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][0|0.0, y_]=0;

CompletionKernelAlongX[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][x_, y_]=  \[Piecewise]{
 {Sqrt[3/(2 \[Pi] x^3 \[Sigma]^2)] Exp[-\[Lambda] x] Exp[-(3/(8 x^3 \[Sigma]^2)) (x (2 Tan[\[Alpha]0]+x \[Kappa])-2 y)^2], x>0 \[And] 2 Abs[\[Alpha]0]<\[Pi]}
};


(* Completion Kernel *)


(* Numeric Implementation *)

NCompletionKernel=Compile[
{{\[Sigma],_Real},{\[Lambda],_Real},{\[Alpha]0,_Real},{\[Kappa],_Real},{xp,_Real},{yp,_Real},{\[Alpha]p,_Real}},
Module[
{\[Alpha]=Mod[\[Alpha]p-\[Alpha]0,2\[Pi],-\[Pi]],x = Cos[\[Alpha]0] xp + Sin[\[Alpha]0] yp, y = -Sin[\[Alpha]0] xp + Cos[\[Alpha]0] yp},
If[x>0\[And] 2 Abs[\[Alpha]]<\[Pi],Chop[(Sqrt[3]/(\[Pi] (x \[Sigma])^2) Exp[-x \[Lambda]-(2 (3 #1^2+(x #2-3 #1) x #2))/(x^3 \[Sigma]^2)])&[y-\[Kappa] x^2/2,Tan[\[Alpha]]-\[Kappa] x]],0.0]
]
];

CompletionKernel[\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][0|0.0, y_?NumberQ,\[Alpha]_?NumberQ]=DiracDelta[y] DiracDelta[\[Alpha]-\[Alpha]0];

CompletionKernel[\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][x_?NumberQ, y_?NumberQ,\[Alpha]_?NumberQ]:=NCompletionKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y,\[Alpha]]


NCompletionKernelxyMarginal=Compile[
{{\[Sigma],_Real},{\[Lambda],_Real},{\[Alpha]0,_Real},{\[Kappa],_Real},{xp,_Real},{yp,_Real}},
Module[
{x = Cos[\[Alpha]0] xp + Sin[\[Alpha]0] yp, y = -Sin[\[Alpha]0] xp + Cos[\[Alpha]0] yp},If[x>0,Chop[Sqrt[3/(2 \[Pi] x^3 \[Sigma]^2)] Exp[-x \[Lambda]-3/(8 x^3 \[Sigma]^2) (\[Kappa] x^2-2 y)^2]] ,0.0]
]
];

CompletionKernel[\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][0|0.0, y_?NumberQ]=DiracDelta[y];

CompletionKernel[\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][x_?NumberQ, y_?NumberQ]:=NCompletionKernelAlongXxyMarginal[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y]


(* Symbolic Implementation *)

CompletionKernel[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][0|0.0, 0|0.0,\[Alpha]0_]=DirectedInfinity[1];

CompletionKernel[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][0|0.0, y_,\[Alpha]_]=0;

CompletionKernel[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][xp_, yp_,\[Alpha]p_]= 
Module[
{\[Alpha]=Mod[\[Alpha]p-\[Alpha]0,2\[Pi],-\[Pi]],x = Cos[\[Alpha]0] xp + Sin[\[Alpha]0] yp, y = -Sin[\[Alpha]0] xp + Cos[\[Alpha]0] yp},\[Piecewise]{
 {Sqrt[3]/(\[Pi] (x \[Sigma])^2) Exp[-\[Lambda] x]Exp[-(1/(2 x^3 \[Sigma]^2))( 3 (x Tan[\[Alpha]]-2 y)^2+(x(Tan[\[Alpha]]-x \[Kappa]))^2)], x>0 \[And] 2 Abs[\[Alpha]]<\[Pi] \[And] 2 Abs[\[Alpha]0]<\[Pi]}
}
];


CompletionKernel[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][0|0.0, 0|0.0]=DirectedInfinity[1];

CompletionKernel[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][0|0.0, y_]=0;

CompletionKernel[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][xp_, yp_]=  
Module[
{x = Cos[\[Alpha]0] xp + Sin[\[Alpha]0] yp, y = -Sin[\[Alpha]0] xp + Cos[\[Alpha]0] yp},\[Piecewise]{
 {Sqrt[3/(2 \[Pi] x^3 \[Sigma]^2)] Exp[-\[Lambda] x] Exp[-(3/(8 x^3 \[Sigma]^2)) (x (2 Tan[\[Alpha]0]+x \[Kappa])-2 y)^2], x>0 \[And] 2 Abs[\[Alpha]0]<\[Pi]}
}
];


(* Polar Completion Kernel *)


(* Numeric Implementation *)

NPolarCompletionKernel=Compile[
{{\[Sigma],_Real},{\[Lambda],_Real},{\[Alpha]0,_Real},{\[Kappa],_Real},{r,_Real},{\[Theta]p,_Real},{\[Alpha],_Real}},
Module[
{\[Theta] = Mod[\[Theta]p-\[Alpha]/2,2\[Pi],-\[Pi]]+\[Alpha]/2},

If[r>0,Chop[Sqrt[3]/(\[Pi] (r \[Sigma])^2) Exp[-\[Lambda] r-1/(2 r \[Sigma]^2) ( 3 (\[Alpha]+\[Alpha]0-2\[Theta])^2+(\[Alpha]-\[Alpha]0-r \[Kappa])^2)]],0.0]
]
];

PolarCompletionKernel[\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][0|0.0,\[Theta]_?NumberQ,\[Alpha]_?NumberQ]=DiracDelta[\[Theta]] DiracDelta[\[Alpha]-\[Alpha]0];

PolarCompletionKernel[\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][r_?NumberQ, \[Theta]_?NumberQ,\[Alpha]_?NumberQ]:=NCompletionKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],r,\[Theta],\[Alpha]]


NPolarCompletionKernelr\[Theta]Marginal=Compile[
{{\[Sigma],_Real},{\[Lambda],_Real},{\[Alpha]0,_Real},{\[Kappa],_Real},{r,_Real},{\[Theta],_Real}},
If[r>0,Chop[Sqrt[3/(2 \[Pi] r^3 \[Sigma]^2)] Exp[-\[Lambda] r-3/(8 r \[Sigma]^2) (2(\[Alpha]0-\[Theta])+r \[Kappa])^2]],0.0]
];

PolarCompletionKernel[\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][0|0.0, \[Theta]_?NumberQ]=DiracDelta[\[Theta]];

PolarCompletionKernel[\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][r_?NumberQ, \[Theta]_?NumberQ]:=NPolarCompletionKernelr\[Theta]Marginal[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],r,\[Theta]]


NPolarCompletionKernelM=Compile[
{{m,_Integer},{\[Sigma],_Real},{\[Lambda],_Real},{\[Alpha]0,_Real},{\[Kappa],_Real},{r,_Real},{\[Alpha],_Real}},

If[r>0,Chop[1/(Sqrt[(2\[Pi] r)^3] \[Sigma]) Exp[-I m/2 (\[Alpha]+\[Alpha]0)-r \[Lambda]-(\[Alpha]-\[Alpha]0-r \[Kappa])^2/(2 r \[Sigma]^2)-m^2/24 r \[Sigma]^2]],0]
];

PolarCompletionKernelM[0,\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][r_?NumberQ,\[Alpha]_?NumberQ]=DiracDelta[r]DiracDelta[\[Alpha]-\[Alpha]0];

PolarCompletionKernelM[m_Integer,\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][0|0.0,\[Alpha]_?NumberQ]=0;

PolarCompletionKernelM[m_Integer,\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][r_?NumberQ,\[Alpha]_?NumberQ]:=NPolarCompletionKernelM[m,\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],r,\[Alpha]]


NPolarCompletionKernelMr\[Theta]Marginal=Compile[
{{m,_Integer},{\[Sigma],_Real},{\[Lambda],_Real},{\[Alpha]0,_Real},{\[Kappa],_Real},{r,_Real}},

If[r>0,Chop[1/(2 \[Pi] r) Exp[-I m/2 (2 \[Alpha]0+r \[Kappa])-r \[Lambda]-m^2/6 r \[Sigma]^2]],0]
];

PolarCompletionKernelM[0,\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][r_?NumberQ]=DiracDelta[r];

PolarCompletionKernelM[m_Integer,\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][0|0.0]=0;

PolarCompletionKernelM[m_Integer,\[Sigma]_?NumberQ,\[Lambda]_?NumberQ,\[Alpha]0_?NumberQ,\[Kappa]_?NumberQ][r_?NumberQ]:=NPolarCompletionKernelMr\[Theta]Marginal[m,\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],r]


(* Symbolic Implementation *)

PolarCompletionKernel[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][0|0.0, 0|0.0,\[Alpha]0_]=DirectedInfinity[1];

PolarCompletionKernel[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][0|0.0, \[Theta]_,\[Alpha]_]=0;

PolarCompletionKernel[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][r_, \[Theta]_,\[Alpha]_]=Sqrt[3]/(\[Pi] (r \[Sigma])^2) Exp[-\[Lambda] r]Exp[-(1/(2 r \[Sigma]^2))( 3 (\[Alpha]+\[Alpha]0-2 \[Theta])^2+(\[Alpha]-\[Alpha]0-r \[Kappa])^2)];


PolarCompletionKernel[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][0|0.0, 0|0.0]=DirectedInfinity[1];

PolarCompletionKernel[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][0|0.0, \[Theta]_]=0;

PolarCompletionKernel[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][r_, \[Theta]_]= Sqrt[3/(2 \[Pi] r^3 \[Sigma]^2)] Exp[-\[Lambda] r] Exp[-(3/(8 r \[Sigma]^2)) (2(\[Alpha]0-\[Theta])+r \[Kappa])^2];


PolarCompletionKernelM[0,\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][0|0.0,\[Alpha]0_]=DirectedInfinity[1];

PolarCompletionKernelM[m_,\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][0|0.0,\[Alpha]_]=0;

PolarCompletionKernelM[m_,\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][r_,\[Alpha]_]=1/(Sqrt[(2\[Pi] r)^3] \[Sigma]) Exp[-I m/2 (\[Alpha]+\[Alpha]0)] Exp[-r \[Lambda]-(\[Alpha]-\[Alpha]0-r \[Kappa])^2/(2 r \[Sigma]^2)]Exp[-((r \[Sigma]^2 m^2)/24)];


PolarCompletionKernelM[m_,\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][0|0.0]=DirectedInfinity[1];

PolarCompletionKernelM[m_,\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][r_]= 1/(2 \[Pi] r) Exp[-I m/2 (2 \[Alpha]0+r \[Kappa])] Exp[-r \[Lambda]] Exp[-(m^2/6) r \[Sigma]^2];


(* Completion Field *)


(* Numeric Implementation *)


(* Symbolic Implementation *)

CompletionField[\[Sigma]_:1,\[Lambda]_:0,{x0_:0,y0_:0,\[Alpha]0_:0,\[Kappa]0_:0},{x1_:1,y1_:0,\[Alpha]1_:0,\[Kappa]1_:0}][x0_,y0_,\[Alpha]0_] = \!\(\*
TagBox[
StyleBox[
RowBox[{"DirectedInfinity", "[", "1", "]"}],
ShowSpecialCharacters->False,
ShowStringCharacters->True,
NumberMarks->True],
FullForm]\);

CompletionField[\[Sigma]_:1,\[Lambda]_:0,{x0_:0,y0_:0,\[Alpha]0_:0,\[Kappa]0_:0},{x1_:1,y1_:0,\[Alpha]1_:0,\[Kappa]1_:0}][x0_,y_,\[Alpha]_] = 0;

CompletionField[\[Sigma]_:1,\[Lambda]_:0,{x0_:0,y0_:0,\[Alpha]0_:0,\[Kappa]0_:0},{x1_:1,y1_:0,\[Alpha]1_:0,\[Kappa]1_:0}][x1_,y1_,\[Alpha]1_] = \!\(\*
TagBox[
StyleBox[
RowBox[{"DirectedInfinity", "[", "1", "]"}],
ShowSpecialCharacters->False,
ShowStringCharacters->True,
NumberMarks->True],
FullForm]\);

CompletionField[\[Sigma]_:1,\[Lambda]_:0,{x0_:0,y0_:0,\[Alpha]0_:0,\[Kappa]0_:0},{x1_:1,y1_:0,\[Alpha]1_:0,\[Kappa]1_:0}][x1_,y_,\[Alpha]_] = \!\(\*
TagBox[
StyleBox["0",
ShowSpecialCharacters->False,
ShowStringCharacters->True,
NumberMarks->True],
FullForm]\);

CompletionField[\[Sigma]_:1,\[Lambda]_:0,{x0_:0,y0_:0,\[Alpha]0p_:0,\[Kappa]0_:0},{x1_:1,y1_:0,\[Alpha]1p_:0,\[Kappa]1_:0}][x_, y_,\[Alpha]p_]:= 
Module[
{R = Sqrt[(x1-x0)^2+(y1-y0)^2],\[Theta] = ArcTan[x1-x0,y1-y0],r,s,\[Alpha],\[Alpha]0,\[Alpha]1},
\[Alpha]=Mod[\[Alpha]p-\[Theta],2\[Pi],-\[Pi]];\[Alpha]0=Mod[\[Alpha]0p-\[Theta],2\[Pi],-\[Pi]];\[Alpha]1=Mod[\[Alpha]1p-\[Theta],2\[Pi],-\[Pi]];
{r,s} = {{Cos[\[Theta]],Sin[\[Theta]]},{-Sin[\[Theta]],Cos[\[Theta]]}}.{x-x0,y-y0};
(3(E^(-R \[Lambda])) )/(\[Pi]^2 r^2 (R-r)^2 \[Sigma]^4) Exp[-(1/(2\[Sigma]^2))((3 (r (\[Alpha]+\[Alpha]0)-2s)^2)/r^3+ (\[Alpha]-\[Alpha]0-r \[Kappa]0)^2/r+(3 ((R-r) (\[Alpha]+\[Alpha]1)+2s)^2)/(R-r)^3+(\[Alpha]1-\[Alpha]-(R-r) \[Kappa]1)^2/(R-r))]
UnitStep[r] UnitStep[R-r] 
];


CompletionField[\[Sigma]_:1,\[Lambda]_:0,{x0_:0,y0_:0,\[Alpha]0_:0,\[Kappa]0_:0},{x1_:1,y1_:0,\[Alpha]1_:0,\[Kappa]1_:0}][x0_,y0_] = \!\(\*
TagBox[
StyleBox[
RowBox[{"DirectedInfinity", "[", "1", "]"}],
ShowSpecialCharacters->False,
ShowStringCharacters->True,
NumberMarks->True],
FullForm]\);

CompletionField[\[Sigma]_:1,\[Lambda]_:0,{x0_:0,y0_:0,\[Alpha]0_:0,\[Kappa]0_:0},{x1_:1,y1_:0,\[Alpha]1_:0,\[Kappa]1_:0}][x0_,y_] = \!\(\*
TagBox[
StyleBox["0",
ShowSpecialCharacters->False,
ShowStringCharacters->True,
NumberMarks->True],
FullForm]\);

CompletionField[\[Sigma]_:1,\[Lambda]_:0,{x0_:0,y0_:0,\[Alpha]0_:0,\[Kappa]0_:0},{x1_:1,y1_:0,\[Alpha]1_:0,\[Kappa]1_:0}][x1_,y1_] = \!\(\*
TagBox[
StyleBox[
RowBox[{"DirectedInfinity", "[", "1", "]"}],
ShowSpecialCharacters->False,
ShowStringCharacters->True,
NumberMarks->True],
FullForm]\);

CompletionField[\[Sigma]_:1,\[Lambda]_:0,{x0_:0,y0_:0,\[Alpha]0_:0,\[Kappa]0_:0},{x1_:1,y1_:0,\[Alpha]1_:0,\[Kappa]1_:0}][x1_,y_] = \!\(\*
TagBox[
StyleBox["0",
ShowSpecialCharacters->False,
ShowStringCharacters->True,
NumberMarks->True],
FullForm]\);

CompletionField[\[Sigma]_:1,\[Lambda]_:0,{x0_:0,y0_:0,\[Alpha]0p_:0,\[Kappa]0_:0},{x1_:1,y1_:0,\[Alpha]1p_:0,\[Kappa]1_:0}][x_, y_]= 
Module[
{R = \[Sqrt]((x1-x0)^2+(y1-y0)^2),\[Theta] = ArcTan[x1-x0,y1-y0],r,s,\[Alpha],\[Alpha]0,\[Alpha]1},
\[Alpha]0=Mod[\[Alpha]0p-\[Theta],2\[Pi],-\[Pi]];\[Alpha]1=Mod[\[Alpha]1p-\[Theta],2\[Pi],-\[Pi]];
{r,s} = {{Cos[\[Theta]],Sin[\[Theta]]},{-Sin[\[Theta]],Cos[\[Theta]]}}.{x-x0,y-y0};
(3 E^(-R \[Lambda]))/(Sqrt[2 \[Pi]^3 R  r^3 (R-r)^3] \[Sigma]^3)* 
Exp[-(1/\[Sigma]^2)((6(s-\[Alpha]0 r/2)^2)/r^3+ (\[Alpha]0+r \[Kappa]0)^2/(2 r))]*
 Exp[-(1/\[Sigma]^2)((6(s+\[Alpha]1 (R-r)/2)^2)/(R-r)^3+(\[Alpha]1+(r-R) \[Kappa]1)^2/(2 (R-r)))]*
Exp[-((r (r-R))/(8 \[Sigma]^2 R)) ((6 s-2 r \[Alpha]0)/r^2+(-6s-2 (R-r) \[Alpha]1)/(R-r)^2+\[Kappa]0-\[Kappa]1)^2]UnitStep[r] UnitStep[R-r]
]


(* Completion Mode and Spline *)


(* Numeric Implementation *)


(* Symbolic Implementation *)

CompletionModeAlongX[{x0_:0,y0_:0,\[Alpha]0_:0,\[Kappa]0_:0},{x1_:1,y1_:0,\[Alpha]1_:0,\[Kappa]1_:0}][t_]:= {x0+t (x1-x0),
(1-t) y0+t y1+(1-t)^2 t (y0-y1+(x1-x0) \[Alpha]0)+(1-t) t^2 (y1-y0+(x0-x1) \[Alpha]1)-1/2 (1-t)^2 t^2 (t-1+ t) (x0-x1)^2 (\[Kappa]0-\[Kappa]1),
\[Alpha]1 t + \[Alpha]0(1-t) + (6 (y0-y1)/(x0-x1)- 3 (\[Alpha]0+\[Alpha]1)) t (1-t)+ (x0-x1) (\[Kappa]0-\[Kappa]1) (3 t (1-t)-1)t (1-t)}


(* Symbolic Implementation *)

CompletionMode[{x0_:0,y0_:0,\[Alpha]0_:0,\[Kappa]0_:0},{x1_:1,y1_:0,\[Alpha]1_:0,\[Kappa]1_:0}][t_]:= With[
{R = Sqrt[(x1-x0)^2+(y1-y0)^2],\[Theta] = ArcTan[x1-x0,y1-y0]},{x0+R t Cos[\[Theta]]-R ((1-t)^2 t Mod[\[Alpha]0-\[Theta],2\[Pi],-\[Pi]]-(1-t) t^2 Mod[\[Alpha]1-\[Theta],2\[Pi],-\[Pi]]-1/2 R (1-t)^2 t^2 (-1+2 t) (\[Kappa]0-\[Kappa]1)) Sin[\[Theta]],y0+R ((1-t)^2 t Mod[\[Alpha]0-\[Theta],2\[Pi],-\[Pi]]-(1-t) t^2 Mod[\[Alpha]1-\[Theta],2\[Pi],-\[Pi]]-1/2 R (1-t)^2 t^2 (-1+2 t) (\[Kappa]0-\[Kappa]1)) Cos[\[Theta]]+R t Sin[\[Theta]],
Mod[\[Alpha]1-\[Theta],2\[Pi],-\[Pi]] t + Mod[\[Alpha]0-\[Theta],2\[Pi],-\[Pi]](1-t)- 3 Mod[\[Alpha]0+\[Alpha]1-2\[Theta],2\[Pi],-\[Pi]] t (1-t)+\[Theta]+R (\[Kappa]0-\[Kappa]1) (3 t (1-t)-1)t (1-t)}
]


(* Symbolic Implementation *)

CompletionSpline[{x0_:0,y0_:0,\[Alpha]0_:0},{x1_:1,y1_:0,\[Alpha]1_:0}]:= With[
{R = Sqrt[(x1-x0)^2+(y1-y0)^2],\[Theta] = ArcTan[x1-x0,y1-y0]},
Spline[
{{x0,y0},
{x0+1/3 R (Cos[\[Theta]]+(Mod[\[Theta]-\[Alpha]0,2 \[Pi],-\[Pi]]) Sin[\[Theta]]),y0+1/3 R (Cos[\[Theta]] Mod[\[Alpha]0-\[Theta],2 \[Pi],-\[Pi]]+Sin[\[Theta]])},
{x0+1/3 R (2 Cos[\[Theta]]+(Mod[\[Alpha]1-\[Theta],2 \[Pi],-\[Pi]]) Sin[\[Theta]]),y0+1/3 R (Cos[\[Theta]] Mod[\[Theta]-\[Alpha]1,2 \[Pi],-\[Pi]]+2 Sin[\[Theta]])},
{x0+R Cos[\[Theta]],y0+R Sin[\[Theta]]}},
Bezier
]
]


(* Tensor Voting Kernel *)


(* Numeric Implementation *)


(* Symbolic Implementation *)

TensorVotingKernel[\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][r_, \[Theta]_]= Sqrt[3/(2 \[Pi] r^3 \[Sigma]^2)] Exp[-\[Lambda] r] Exp[-((3 (2 Mod[\[Alpha]0-\[Theta],2\[Pi],-\[Pi]]+r \[Kappa])^2)/(8 r \[Sigma]^2))-(r \[Sigma]^2)/2] Exp[I (Mod[\[Theta]-\[Alpha]0,2\[Pi],-\[Pi]]+2 \[Theta]+(r \[Kappa])/2)];


TensorVotingKernelM[0,\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][r_]=DiracDelta[r];
TensorVotingKernelM[m_,\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][0|0.0]=0;
TensorVotingKernelM[m_,\[Sigma]_:1,\[Lambda]_:0,\[Alpha]0_:0,\[Kappa]_:0][r_]=1/(2 \[Pi] r) Exp[-r(\[Lambda] + \[Sigma]^2/2)]Exp[-((r \[Sigma]^2)/6) (3+m)^2]Exp[I ((m+2) \[Alpha]0+(m/2+2) r \[Kappa])];


(* Medioni Tensor Voting Kernel *)


(* Symbolic Implementation *)

MedioniTensorVotingKernel[m_:1,\[Sigma]_,c_][0|0.0,\[Theta]_] = DiracDelta[\[Theta]];MedioniTensorVotingKernel[\[Sigma]_,c_][r_,\[Theta]_] = Sqrt[c]/(Sqrt[\[Pi]] r \[Sigma]) Exp[-(1/\[Sigma]^2)(r^2+ c (\[Theta]/r)^2)] Exp[2I \[Theta]];
MedioniTensorVotingKernel[1,\[Sigma]_,c_][r_,\[Theta]_] = Sqrt[c]/(Sqrt[\[Pi]] r \[Sigma]) Exp[-(1/\[Sigma]^2)(r^2+ c (\[Theta]/r)^2)] Exp[2I \[Theta]];
MedioniTensorVotingKernel[2,\[Sigma]_,c_][r_,\[Theta]_] =  (r^2)/(2 Sqrt[3(12 c+r^4)] BesselK[1/4,(12 c+r^4)^2/(2 r^6 \[Sigma]^2)]) Exp[-((288 (12 c+r^4)^2+48 r^8 \[Theta]^2+r^8 \[Theta]^4)/(576 r^6 \[Sigma]^2))]Exp[2I \[Theta]] Exp[-(1/\[Sigma]^2)((r+(r \[Theta]^2)/24)^2+ c (\[Theta]/r)^2)];


End[]

SetAttributes[
{CompletionKernelAlongX,
NCompletionKernelAlongX,
NCompletionKernelxyMarginalAlongX,
CompletionKernel,
NCompletionKernel,
NCompletionKernelxyMarginal,
PolarCompletionKernel,
NPolarCompletionKernel,
NPolarCompletionKernelr\[Theta]Marginal,
PolarCompletionKernelM,
NPolarCompletionKernelM,
NPolarCompletionKernelMr\[Theta]Marginal,
CompletionField,
CompletionMode,
CompletionModeAlongX,
CompletionSpline,
TensorVotingKernel,
TensorVotingKernelM,
MedioniTensorVotingKernel},
{Protected, ReadProtected}
];

EndPackage[]
