(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`\!\(\*
StyleBox[\"Converters`BioRad\",\nFontColor->RGBColor[1, 0, 1]]\)`"] = {2004,9,9,16,33,0}

Protect[TimeStamp];


(*:Name: MathVisionTools`Converters`BioRad` *)

(*:Author: Edwin Bennink *)

(*:Email address: H.E.Bennink@student.tue.nl *)

(*:Context: MathVisionTools`Converters`BioRad` *)

(*:Package Version: 1.0 *)

(*:Mathematica Version: 5.0 *)

(*:Copyright: Copyright 2004, Technische Universiteit Eindhoven *)

(*:Title: BioRad *)

(*:Summary: This package implements a BioRad import routine. *)

(*:Keywords: BioRad, import, pic, microscopy *)

(*:Requirements: None *)

(*:Source: None *)

(*:History: Version 1.0 by Edwin Bennink, August 2004 *)

(*:Limitations: *)

(*:Discussion: *)

(*:To do: write export routine?*)


BeginPackage["MathVisionTools`Converters`BioRad`"]

Unprotect[
BioRadImport,
BioRad
]


BioRadImport::usage="BioRadImport[\"filename.pic\",n] loads slice n of the BioRad PIC file into Mathematica. n=1 by default; n=All loads all slices.\nBioRadImport[\"filename.pic\",{n,m}] loads slice n through m of the BioRad PIC files.\nBioRadImport[{\"filename1.pic\",\"filename2.pic\",...},{n,m}] loads slices n through m of each file within the List of BioRad PIC files.\nThe imported data is a Mathematica expression with the head BioRad. It's first argument is a z\[Times]y\[Times]x\[Times]N list, where z represents the number of slices and N the number of files. The second argument is a list of rules replacing BioRad tag names with their respective values. When the pic file contains notes, these will also be imported."

BioRadImport::file="Cannot find file `1`"

Options[BioRadImport]={Path:>$Path};


Begin["`Private`"]

(*Connection MathLink Binary*)MLBinaryName=Switch[$SystemID,
"Windows","Binary.exe",
"Darwin","Binary",
"Linux","Binary",
"MacOSX-x86","Binary",
_,"Binary"];

MLBinaryPath=Map[ToFileName[{#,"MathVisionTools","Converters","Binaries",$SystemID},MLBinaryName]&,$Path];

MLBinaryFiles=FileNames[MLBinaryPath];

BioRad::linkc="The LinkObject to the BioRad binary is dead; attempt to connect failed";

If[MLBinaryFiles==={},MLBinaryLink=$Failed,If[Links[First[MLBinaryFiles]]==={},CurrentDirectory=Directory[];
SetDirectory[DirectoryName[First[MLBinaryFiles]]];
Off[LinkConnect::"linkc"];
MLBinaryLink=Install[First[MLBinaryFiles]];
On[LinkConnect::"linkc"];
SetDirectory[CurrentDirectory],MLBinaryLink=First[Links[First[MLBinaryFiles]]]]];

If[Head[MLBinaryLink]===$Failed,Message[BioRad::linkc]];

(*BioRad data file Import*)

BioRadImport[fileList_,sliceRange_:1,opts___Rule]:=Module[{fnames,flist,header,streamList},
Needs["FastBinaryFiles`"];
flist={};
Map[AppendTo[flist,If[Length[fnames=FileNames[#,Join[{""},(Path/.{opts}/.Options[BioRadImport])]]]>0,First[fnames],Message[BioRadImport::file,#];$Failed]]&,If[Depth[fileList]==1,{fileList},fileList]];
streamList=OpenReadBinary[#,FilenameConversion->Identity]&/@flist;
header=ReadBinary[streamList[[1]],#]&/@{Int16,Int16,Int16,{Int16,Int16},Int32,Int16,Int16,Table[Byte,{32}],Int16,Int16,Int16,{Int16,Int16},Int16,Int16,Int16};
header[[5]]=If[header[[5]]==0,False,True];
header[[6]]=If[header[[6]]==1,8,16];
header[[8]]=FromCharacterCode[Take[header[[8]],Position[Append[header[[8]],0],0,1,1][[1,1]]-1]];
header[[11]]=If[header[[11]]==12345,True,False];
header[[14]]=If[header[[14]]==1,True,False];
header=MapThread[Rule,{{"Columns","Rows","Slices","LUT1 Range","Notes Included","Bits Allocated","Image Number","File Name","Merged","LUT1 Color Status","Valid PIC File","LUT2 Range","LUT2 Color Status","Edited","Magnification"},header}];
{n,m}={#[[1]],#[[-1]]}&[If[Depth[sliceRange]!=1,sliceRange,If[sliceRange===All,{1,"Slices"/.header},{sliceRange}]]];
SetStreamPosition[#,76+(n-1)"Columns""Rows"/.header]&/@streamList;
image=Transpose[Table[Partition[ReadListBinary[#,Byte,"Columns""Rows"/.header],"Rows"/.header],{1+m-n}]&/@streamList,{4,1,2,3}];
If["Notes Included"/.header,SetStreamPosition[streamList[[1]],76+"Slices""Columns""Rows"/.header];AppendTo[header,"Notes"->Map[FromCharacterCode[DeleteCases[Drop[#,16],0]]&,Drop[Drop[NestWhileList[ReadListBinary[streamList[[1]],Byte,96]&,{255},#[[1]]==255&],1],-1]]]];
If[Dimensions[image][[4]]==1,image=Map[Flatten,image,{2}]];
If[Dimensions[image][[1]]==1,image=Flatten[image,1]];
Close/@streamList;
BioRad[image,header]
];


End[]

SetAttributes[
{BioRadImport,BioRad},
{Protected, ReadProtected}
]

EndPackage[]



