(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`Converters`Raw3D`"] = {2010,2,2,12,0,0};

Protect[TimeStamp];


(*:Name: MathVisionTools`Converters`Raw3D` *)

(*:Author: Markus van Almsick*)

(*:Email address: M.v.Almsick@tue.nl*)

(*:Context: MathVisionTools`Converters`Raw3D`*)

(*:Package Version: 2.1 *)

(*:Mathematica Version: 6.2 *)

(*:Copyright: Copyright 2010, Technische Universiteit Eindhoven*)

(*:Title: Raw 3D *)

(*:Summary: This package implements raw 3D import/export routines. *)

(*:Keywords: Raw, 3D, Data, File, Import, Export *)

(*:Requirements: None *)

(*:Source: None *)

(*:History: Version 1.0 by Markus van Almsick, July 2003 *)
(*:History: Version 2.0 by Markus van Almsick, January 2008 *)

(*:Limitations: none *)

(*:Discussion: *)

(*:To do: *)


BeginPackage["MathVisionTools`Converters`Raw3D`"]

Unprotect[
Raw3DImport,
Raw3DExport
]


Raw3DImport::usage="Raw3DImport[fname] loads a 3D data file into Mathematica. The imported data is a Mathematica List expression of rank 3 with Integer or Real numbers. A 3D data file is a plain binary file format. The first 3 short integers denote the dimensions of the 3D data set. The rest of the file consists of a plain sequence of all short integer or all float data values"

Raw3DExport::usage="Raw3DExport[fname, data] saves a Mathematica List expression of rank 3 with Integer or Real numbers in a raw 3D data file. A raw 3D data file is a plain binary file format. The first 3 short integers denote the dimensions of the 3D data set. The rest of the file consists of a plain sequence of all short integer or all float data values."

Raw3DImport::file = "Cannot find 3D data file `1`"
Raw3DImport::corrupt="The internal data structure of `1` is inconsistent.";

Options[Raw3DImport]={ByteOrdering-> $ByteOrdering, Path:> $Path};
Options[Raw3DExport]={ByteOrdering-> $ByteOrdering};


Begin["`Private`"]


(* 3D data file Import *)

Raw3DImport[fname_String,opts___Rule]:=
Module[
{fileSize,strm,dims,data,path,byteOrd,fnames},
path = Path/.{opts}/.Options[Raw3DImport];
byteOrd = ByteOrdering/.{opts}/.Options[Raw3DImport];
fnames=FileNames[FileNameTake[fname],Prepend[path,DirectoryName[fname]]];
If[fnames==={},Message[Raw3DImport::file,fname];Return[$Failed]];
fileSize=FileByteCount[First[fnames]];
If[fileSize===$Failed,Return[$Failed]];
strm = OpenRead[First[fnames], BinaryFormat-> True];
dims=BinaryRead[strm,{"Integer16","Integer16","Integer16"},ByteOrdering-> byteOrd, Path-> path];
Switch[
(fileSize-6)/Times@@dims,
2,data =BinaryReadList[strm,"Integer16",ByteOrdering-> byteOrd, Path-> path],
4,data =BinaryReadList[strm,"Real32",ByteOrdering-> byteOrd, Path-> path],
_,Message[Raw3DImport::corrupt,fname];Return[$Failed]
];
Close[strm];
Fold[Partition,data,Rest[Reverse[dims]]]
]


If[
$VersionNumber<6,
 Experimental`RegisterConverter[Import,
"Raw3D",
{"*.dat","*.DAT"},
None,
Raw3DImport[
#1,
Apply[Sequence,ConversionOptions/.Rest[{##}]/.ConversionOptions->{}]
]&,
"TextFormat"->False
]
]


(* 3D data file Export *)

Raw3DExport[fname_String, data_?(ArrayQ[#,3,IntegerQ]&),opts___Rule]:=
Module[
{strm = OpenWrite[fname, BinaryFormat-> True],byteOrd},
byteOrd = ByteOrdering/.{opts}/.Options[Raw3DExport];
dims=BinaryWrite[strm,Reverse[Dimensions[data]],"Integer16",ByteOrdering-> byteOrd];
BinaryWrite[strm,Flatten[data],"Integer16",ByteOrdering-> byteOrd];
Close[strm];
fname
]

Raw3DExport[fname_String, data_?(ArrayQ[#,3,NumericQ]&),opts___Rule]:=
Module[
{strm = OpenWrite[fname, BinaryFormat-> True],byteOrd},
byteOrd = ByteOrdering/.{opts}/.Options[Raw3DExport];
dims=BinaryWrite[strm,Reverse[Dimensions[data]],"Integer16",ByteOrdering-> byteOrd];
BinaryWrite[strm,N[Flatten[data]],"Real32",ByteOrdering-> byteOrd];
Close[strm];
fname
]


If[
$VersionNumber<6,
Experimental`RegisterConverter[Export,
"Raw3D",
{"*.dat","*.DAT"},
None,
Raw3DExport[
#1,
#2,
Apply[Sequence,ConversionOptions/.Drop[{##},2]/.ConversionOptions->{}]
]&,
"TextFormat"->False
]
]


End[]

SetAttributes[
{Raw3DImport,
Raw3DExport},
{Protected, ReadProtected}
];

EndPackage[]
