(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`DisplayFunctions`"] = {2010,4,14,12,11,0};

Protect[TimeStamp];


(*:Name: MathVisionTools`DisplayFunctions` *)

(*:Author: Markus van Almsick*)

(*:Email address: M.v.Almsick@tue.nl*)

(*:Context: MathVisionTools`DisplayFunctions`*)

(*:Package Version: 1.3 *)

(*:Mathematica Version: 5.2 *)

(*:Copyright: Copyright 2009, Technische Universiteit Eindhoven*)

(*:Title: DisplayFunctions *)

(*:Summary: This package implements several functions to display image data *)

(*:Keywords: plot, display *)

(*:Requirements: None *)

(*:Source: *)

(*:History: Version 1.0 by  Markus van Almsick, May 2005 *)

(*:Limitations: *)

(*:Discussion: *)

(*:To do: Dynamic elements (e.g. PixelLabeling) in version 6 are currently disabled *)


BeginPackage["MathVisionTools`DisplayFunctions`"]

Unprotect[
  ListLuminocityPlot,
RasterPlot,
PixelLabeling,
ListEllipsePlot,
ListEllipsoidPlot3D
  ]


ListLuminocityPlot::usage = "ListLuminocityPlot[img] is obsolete. ListLuminocityPlot has been superseded by RasterPlot."


RasterPlot::usage = "RasterPlot[img] displays a 2-dimensional array of real values or real value tuples as an image with corresponding luminosity or color. The larger values are displayed in brighter, the smaller in darker colors. Complex values are encoded by color. Their argument is given by hue and their absolute value by brightness and saturation. One can provide via the option ColorFunction other color encodings than GrayLevel and RGBColor. GrayLevel and RGBColor are applied automatically, if simple values or 3-tuples of pixel data are provided."


PixelLabeling::usage = If[
$VersionNumber<6,"PixelLabeling is only available in Mathematica 6.0 or later.","CURRENTLY DISABLED! PixelLabeling is an option of RasterPlot. If set to True a Tooltip is assigned to each pixel in the image displaying the location and value."
];


Options[RasterPlot] = {AspectRatio->Automatic,Axes->False,AxesLabel->None,AxesOrigin->Automatic,AxesStyle->Automatic,Background->Automatic,ColorFunction->Automatic,ColorFunctionScaling->True,ColorOutput->Automatic,DefaultColor->Automatic,DataReversed->False,Epilog->{},Frame->True,FrameLabel->None,FrameStyle->Automatic,FrameTicks->Automatic,GridLines->None,ImageSize->Automatic,PlotLabel->None,PlotRange->All,PlotRange->Automatic,PlotRegion->Automatic,Prolog->{},RotateLabel->True,Ticks->Automatic,DefaultFont:>$DefaultFont,DisplayFunction:>$DisplayFunction,FormatType:>$FormatType,TextStyle:>$TextStyle}


ListEllipsePlot::usage = "ListEllipsePlot[img] displays a 1- or 2-dimensional array of real-valued, positive-definite, symmetric 2\[Times]2 matrices as a field of ellipses. The length and orientation of the main ellipse axes reflect the eigenvalues and eigenvectors of the matrices. One can provide via the option ColorFunction other color encodings. The first 2 arguments of the ColorFunction are the 2 eigenvalues and the last argument is the orientation angle (-\[Pi]/2,\[Pi]/2) of the main eigenvector. The option ScaleFactor allows to change the overall size of the ellipses with respect to the field size."


Options[ListEllipsePlot] = {ScaleFactor -> Automatic, ColorFunction -> Automatic,DataReversed->False};


ListEllipsoidPlot3D::usage = "ListEllipsoidPlot3D[img] displays a 1-,2-, or 3-dimensional array of real-valued,  positive-definite, symmetric 3\[Times]3 matrices as a field of ellipsoids. The length and orientation of the main ellipsoid axes reflect the eigenvalues and eigenvectors of the matrices. The option ScaleFactor allows to change the overall size of the ellipsoids with respect to the field extension."


Options[ListEllipsoidPlot3D] = {ScaleFactor -> Automatic};


Begin["`Private`"]


AutomaticTickRange[max_?NumberQ]:=
Module[
{scale = Power[10,Floor[Log[10,max]]]},
Which[
max==1,{1},
scale<=max<8scale/5,Prepend[Range[scale/5,max,scale/5],1],
8scale/5<=max<4scale,Prepend[Range[scale/2,max,scale/2],1],
4 scale<=max<8scale, Prepend[Range[scale,max,scale],1],
8 scale<=max<10 scale, Prepend[Range[2 scale,max,2 scale],1],
True,None
]
]


ListLuminocityPlot[img_?MatrixQ,opts___Rule] := 
RasterPlot[img,ImageSize->PadRight[Dimensions[img],2],Frame-> False,PlotRange-> All, AspectRatio->Automatic,opts]


ListLuminocityPlot[img_?MatrixQ,rng:{_,_},opts___Rule] := 
RasterPlot[img,ImageSize->PadRight[Dimensions[img],2],Frame-> False,PlotRange-> rng, AspectRatio->Automatic,opts]


ListLuminocityPlot[img_?MatrixQ,top_?NumericQ,opts___Rule] :=  
RasterPlot[img,ImageSize->PadRight[Dimensions[img],2],Frame-> False,PlotRange-> {0,top}, AspectRatio->Automatic,opts]


RasterPlot::optx="Unknown option `1`  in  `2` .";
RasterPlot::cfopt="Automatic colorfunction is not applicable to image data.";


RasterPlot[img_?(ArrayQ[#,2|3,NumericQ]&), opts___Rule] :=
If[
$VersionNumber<6,
RasterPlot5[img, opts],
RasterPlot6[img, opts]
]


AdjustPlotRange[img_List,rng_] :=
Module[
{rngXY = Thread[{{0,0},Dimensions[img][[{2,1}]]}]},
Switch[
rng,
_?NumericQ,Append[rngXY,{0,rng}],
{_?NumericQ,_?NumericQ},Append[rngXY,rng],
{{_?NumericQ,_?NumericQ},{_?NumericQ,_?NumericQ}},Append[rng,{Min[img],Max[img]}],
{{_?NumericQ,_?NumericQ},{_?NumericQ,_?NumericQ},{_?NumericQ,_?NumericQ}},rng,
All|Full,Append[rngXY,If[Equal@@#,#+{-1,1},#,#]&[{Min[img],Max[img]}]],
Automatic,Append[rngXY,Automatic],
_,Message[RasterPlot::optx,rng,RasterPlot];Return[$Failed]
]
]


AutomaticColorFunction[img_List,Automatic]:=
If[
$VersionNumber<6,
Switch[
Dimensions[img],
{_,_},GrayLevel,
{_,_,3},RGBColor,
{__},GrayLevel[Mean[#]]&,
_,Message[RasterPlot::cfopt];Return[$Failed]
],
Switch[
Dimensions[img],
{_,_}|{_,_,2},GrayLevel,
{_,_,3|4},RGBColor,
{__},GrayLevel[Mean[#]]&,
_,Message[RasterPlot::cfopt];Return[$Failed]
]
]

AutomaticColorFunction[img_List,cf_String]:=ColorData[cf]

AutomaticColorFunction[img_List,cf_]=cf


AutomaticColorFunctionScaling[img_List,{bot_,top_},cfs_]:=
If[
cfs \[And] ArrayDepth[img]=== 3,
Compile[{{rgb,_Real,3}},Evaluate[(rgb-bot)/(top-bot)]],
Identity
]


ComplexColor = Compile[{{z,_Complex,2},{zmin,_Real},{zmax,_Real}},
Transpose[
If[zmin<zmax,
{Arg[z]/(2\[Pi])+1/2,#,#}&[(Abs[z]-zmin)/Abs[zmax-zmin]],
{Arg[z]/(2\[Pi])+1/2,#,#}&[(#/Max[#])&[Abs[z]]]
],{3,1,2}]
]


RasterPlot5[img_?(MatrixQ[#]\[And]Not[FreeQ[#,Complex]]&), opts___Rule] :=
Module[
{dims = Dimensions[img][[{2,1}]],
rng = AdjustPlotRange[Abs[img],PlotRange /. {opts} /. Options[RasterPlot]],
cf = ColorFunction /. {opts}/. {ColorFunction-> (Hue@@#&)},
dr=DataReversed/. {opts}/. Options[RasterPlot],
rasterOpts=DeleteCases[First/@ Options[Raster],ColorFunction],
graphicsOpts=DeleteCases[ First/@Options[Graphics],PlotRange]},
Show[
Graphics[
Raster[ComplexColor[If[dr,img,Reverse[img],Reverse[img]],rng[[3,1]],rng[[3,2]]],{{0,0},dims}+1/2,Last[rng],
ColorFunction-> cf,ColorFunctionScaling-> False,
Sequence@@FilterRules[{opts},rasterOpts],Sequence@@FilterRules[Options[RasterPlot], rasterOpts]
],
PlotRange-> Most[rng]+1/2,FrameTicks->{AutomaticTickRange[dims[[1]]],If[dr,AutomaticTickRange[dims[[2]]],Map[{dims[[2]]-#+1,ToString[#]}&,AutomaticTickRange[dims[[2]]]]],None,None},
Sequence@@FilterRules[{opts}, graphicsOpts],Sequence@@FilterRules[Options[RasterPlot],graphicsOpts]
]
]]

RasterPlot5[img_List, opts___Rule] :=
Module[
{dims = Dimensions[img][[{2,1}]],
rng = AdjustPlotRange[img,PlotRange /. {opts} /. Options[RasterPlot]],
cf = AutomaticColorFunction[img,ColorFunction /. {opts} /. Options[RasterPlot]],
dr=DataReversed/. {opts}/. Options[RasterPlot],
rasterOpts=DeleteCases[First/@ Options[Raster],ColorFunction],
graphicsOpts=DeleteCases[ First/@Options[Graphics],PlotRange]},
Show[
Graphics[
Raster[If[dr,img,Reverse[img],Reverse[img]],{{0,0},dims}+1/2,Last[rng],
ColorFunction-> cf,
Sequence@@FilterRules[{opts},rasterOpts],Sequence@@FilterRules[Options[RasterPlot], rasterOpts]
],
PlotRange-> Most[rng]+1/2,FrameTicks->{AutomaticTickRange[dims[[1]]],If[dr,AutomaticTickRange[dims[[2]]],Map[{dims[[2]]-#+1,ToString[#]}&,AutomaticTickRange[dims[[2]]]]],None,None},
Sequence@@FilterRules[{opts}, graphicsOpts],Sequence@@FilterRules[Options[RasterPlot],graphicsOpts]
]
]]


RasterPlot6[img_?(MatrixQ[#]\[And]Not[FreeQ[#,Complex]]&), opts___Rule] :=
Module[
{dims = Dimensions[img][[{2,1}]],
rng = AdjustPlotRange[Abs[img],PlotRange /. {opts} /. Options[RasterPlot]],
cf = ColorFunction /. {opts}/. {ColorFunction-> (Hue@@#&)},
dr=DataReversed/. {opts}/. Options[RasterPlot],
rasterOpts=DeleteCases[First/@ Options[Raster],ColorFunction],
graphicsOpts=DeleteCases[ First/@Options[Graphics],PlotRange]},
Show[
Graphics[
Raster[ComplexColor[If[dr,img,Reverse[img],Reverse[img]],rng[[3,1]],rng[[3,2]]],{{0,0},dims}+1/2,Last[rng],
ColorFunction-> cf,ColorFunctionScaling-> False,
Sequence@@FilterRules[{opts},rasterOpts],Sequence@@FilterRules[Options[RasterPlot], rasterOpts]
],
PlotRange-> Most[rng]+1/2,
FrameTicks->{AutomaticTickRange[dims[[1]]],If[dr,AutomaticTickRange[dims[[2]]],Map[{dims[[2]]-#+1,ToString[#]}&,AutomaticTickRange[dims[[2]]]]],None,None},
Sequence@@FilterRules[{opts}, graphicsOpts],Sequence@@FilterRules[Options[RasterPlot],graphicsOpts]
]
]]

RasterPlot6[img_List, opts___Rule] :=
Module[
{dims = Dimensions[img][[{2,1}]],
rng = AdjustPlotRange[img,PlotRange /. {opts} /. Options[RasterPlot]],
cf = AutomaticColorFunction[img,ColorFunction /. {opts} /. Options[RasterPlot]],
cfs,
dr=DataReversed/. {opts}/. Options[RasterPlot],
rasterOpts=DeleteCases[First/@ Options[Raster],ColorFunction],
graphicsOpts=DeleteCases[ First/@Options[Graphics],PlotRange]},
cfs = AutomaticColorFunctionScaling[img,Last[rng],ColorFunctionScaling /. {opts} /. Options[RasterPlot]];
If[MatchQ[cf,RGBColor|Hue|GrayLevel|CMYKColor], cfs = Identity];
Graphics[
Raster[
cfs[If[dr,img,Reverse[img],Reverse[img]]],{{0,0},dims}+1/2,Last[rng],
ColorFunction-> cf,
Sequence@@FilterRules[{opts},rasterOpts],Sequence@@FilterRules[Options[RasterPlot], rasterOpts]
],
PlotRange-> Most[rng]+1/2,FrameTicks->{AutomaticTickRange[dims[[1]]],If[dr,AutomaticTickRange[dims[[2]]],Map[{dims[[2]]-#+1,ToString[#]}&,AutomaticTickRange[dims[[2]]]]],None,None},
Sequence@@FilterRules[{opts}, graphicsOpts],Sequence@@FilterRules[Options[RasterPlot],graphicsOpts]
]
]


ListEllipsePlot::vers = "ListEllipsePlot is not implemented for Mathematica versions prior 6.0.";


If[$VersionNumber<6,
ListEllipsePlot[__] := (Message[ListEllipsePlot::vers];$Failed),
ListEllipsePlot[matField_List, opts___Rule] :=
Module[
{eigenField = Map[Eigensystem,N[matField],{ArrayDepth[matField]-2}], 
ellipseScale = ScaleFactor /. {opts} /. Options[ListEllipsePlot],
colorFunction = ColorFunction/. {opts} /. Options[ListEllipsePlot],
dr=DataReversed/. {opts}/. Options[ListEllipsePlot],
maxEigenvalue,maxDet,autoColor,ellipseFunction, fieldRank = ArrayDepth[matField]-2},
{maxEigenvalue,maxDet} = {Abs[Max[#]], Abs[Max[Apply[Times,#,{1}]]]}&[Flatten[eigenField,fieldRank-1][[All,1]]];
autoColor=Hue[#1/\[Pi]+0.5,Abs[#1-#2]/(#1+#2), #1*#2/maxDet]&;
ellipseScale=Switch[
ellipseScale,
_?NumericQ, ellipseScale/(2maxEigenvalue),
Automatic | All,1/(Sqrt[2]maxEigenvalue),
None|_, 1/Sqrt[2]
];
colorFunction=Switch[
colorFunction,
_Function, colorFunction,
Automatic ,Hue[#3/\[Pi]+0.5,Abs[#1-#2]/(#1+#2), #1*#2/maxDet]&,
None|_, Gray&
];
ellipseFunction[{{e1_,e2_},{eVec_,_}},pos_List] := {colorFunction[Abs[e1],Abs[e2],#],Rotate[Disk[PadRight[pos,2],ellipseScale Abs[{e1,e2}]],#]}&[ArcTan@@eVec];
Graphics[
MapIndexed[ellipseFunction,If[dr,Reverse[eigenField],eigenField,eigenField],{fieldRank}],
FilterRules[{opts},Options[Graphics]]
]
] /; MatchQ[Dimensions[matField],{_,2,2}|{_,_,2,2}]
]


ListEllipsoidPlot3D::vers = "ListEllipsoidPlot3D is not implemented for Mathematica versions prior 6.0.";


If[$VersionNumber<6,
ListEllipsoidPlot3D[__] := (Message[ListEllipsePlot::vers];$Failed),
ListEllipsoidPlot3D[matField_List, opts___Rule] :=
Module[
{eigenField = Map[Eigensystem,N[matField],{ArrayDepth[matField]-2}], 
ellipsoidScale = ScaleFactor /. {opts} /. Options[ListEllipsePlot],
maxEigenvalue,ellipsoidFunction, fieldRank = ArrayDepth[matField]-2},
maxEigenvalue = Abs[Max[Flatten[eigenField,fieldRank-1][[All,1]]]];
ellipsoidScale=Switch[
ellipsoidScale,
_?NumericQ, ellipsoidScale/(2maxEigenvalue),
Automatic | All,1/(Sqrt[2]maxEigenvalue),
None|_, 1/Sqrt[2]
];
ellipsoidFunction[{eigenVals_,eigenVecs_},pos_List] := GeometricTransformation[Sphere[{0,0,0}],{Transpose[ellipsoidScale Abs[eigenVals]  eigenVecs],PadRight[pos,3]}];
Graphics3D[
MapIndexed[ellipsoidFunction,eigenField,{fieldRank}],
FilterRules[{opts},Options[Graphics3D]]
]
] /; MatchQ[Dimensions[matField],{_,3,3}|{_,_,3,3}|{_,_,_,3,3}]
]


End[]

SetAttributes[
{ListLuminocityPlot,RasterPlot,PixelLabeling,
ListEllipsePlot,ListEllipsoidPlot3D},
{Protected, ReadProtected}
];

EndPackage[]
