(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`GaussianDerivative`"] = {2010,11,14,15,35,0}

Protect[TimeStamp];


(*:Name: MathVisionTools`GaussianDerivative` *)

(*:Author: Bart M.ter Haar Romeny Ph.D.and Markus van Almsick*)

(*:Email address: B.terHaarRomeny@tue.nl, M.v.Almsick@tue.nl*)

(*:Context: MathVisionTools`GaussianDerivative`*)

(*:Package Version: 3.1 *)

(*:Mathematica Version: 7.0 *)

(*:Copyright: Copyright 2001-2007, Technische Universiteit Eindhoven*)

(*:Title: Gaussian Kernel, Gaussian Derivative, and Gaussian Filter *)

(*:Summary: This package implements the Gaussian derivative for Scale Space Theory. "Front-End Vision and Multiscale Image Analysis" by Bart M.ter Haar Romeny Kluwer Academic Publishers,2001.*)

(*:Keywords: Gaussian, Gaussian derivatives, multiscale, scale-space, computer vision, differential operator *)

(*:Requirements: None *)

(*:Source: "Front-End Vision and Multiscale Image Analysis", by Bart M.ter Haar Romeny Kluwer Academic Publishers,2003 *)

(*:History: Version 1.0 by Bart M.ter Haar Romeny and Markus van Almsick, October 2001
          Version 1.1 by Bart M.ter Haar Romeny and Markus van Almsick, May 2002
          Version 1.2 by Bart M.ter Haar Romeny and Markus van Almsick, Sept 2002
          Version 2.0 by Bart M.ter Haar Romeny and Markus van Almsick, Dec 2002
          Version 2.1 by Bart M.ter Haar Romeny and Markus van Almsick, Jan 2003
          Version 2.2 by Bart M.ter Haar Romeny and Markus van Almsick, Nov 2003
          Version 2.4 by Bart M.ter Haar Romeny and Markus van Almsick, Jan 2004
          Version 2.5 by Bart M.ter Haar Romeny and Markus van Almsick, April 2006
          Version 2.6 by Bart M.ter Haar Romeny and Markus van Almsick, June 2007
          Version 2.8 by Bart M.ter Haar Romeny and Markus van Almsick, Feb 2008
          Version 2.9 by Bart M.ter Haar Romeny and Markus van Almsick, Oct 2009
          Version 3.0 by Bart M.ter Haar Romeny and Markus van Almsick, Dec 2009
          Version 3.1 by Bart M.ter Haar Romeny and Markus van Almsick, Dec 2010 *)

(*:Limitations: *)

(*:Discussion: *)

(*:To do:  Recursive Implementation, Directional, Parallel *)


BeginPackage[
"MathVisionTools`GaussianDerivative`",
"MathVisionTools`Common`MathVisionToolsCommon`",
"MathVisionTools`ImageFrame`"
]


Unprotect[
G,
NGaussianKernel,
GaussianKernel,
AngularGaussianKernel,
NGaussianDKernel,
GaussianDKernel,
GaussianD,
GaussianBlur,
GaussianDerivative,
GaussianDerivativeJet,
GaussianDerivativeAt,
LocalMinimumMask,
LocalMaximumMask,
ThresholdFilter,
ScaleTToSigma,
SigmaToScaleT,
Method,
KernelRange,
ImageBoundary,
Fourier,
Cyclic,
Truncate,
Reflective,
Constant
]


DefaultScaleParameter::usage="The default linear scale parameter t = 1/2. Thus, the width or standard deviation of the Gaussian kernel is 1."

SigmaToScaleT::usage="SigmaToScaleT[\[Sigma]] converts the standard deviation \[Sigma] of the Gaussian kernel into the corresponding scale t.";

ScaleTToSigma::usage="ScaleTToSigma[t] converts the scale t into the corresponding standard deviation \[Sigma] of the Gaussian kernel.";

G::usage="\!\(\*SubscriptBox[\(G\), \(t\)]\)[x] is a short input notation for GaussianKernel[t,x]. \!\(\*SubsuperscriptBox[\(G\), \(t\), \((n)\)]\)[x] is a short input notation for GaussianDKernel[t,n,x]. \!\(\*SubsuperscriptBox[\(G\), \(t\), \((nx, ny)\)]\)[x,y]and \!\(\*SubsuperscriptBox[\(G\), \(tx, ty\), \((nx, ny)\)]\)[x,y] denote the 2-dimensional case GaussianDKernel[t, {nx,ny}, {x,y}] and GaussianDKernel[{tx,ty}, {nx,ny}, {x,y}]. This generalizes to any dimension."

GaussianKernel::usage="GaussianKernel[t,x] renders the gaussian kernel numerically and symbolically. Note, that t is half the variance, which is the square of the Gaussian kernel width \[Sigma]. GaussianKernel generalizes to higher dimensions if t and x are Lists."

AngularGaussianKernel::usage="AngularGaussianKernel[t,\[Alpha]] renders the angular gaussian kernel numerically and symbolically. The angular kernel is the Greens function of the diffusion equation on the interval [-\[Pi],\[Pi]] with periodic boundary conditions. Note, that t is half the variance, which is the square of the Gaussian kernel width \[Sigma]."

NGaussianKernel::usage="NGaussianKernel[t,x] renders the gaussian kernel numerically for Real t and x with compiled code. Note that t is half the variance, which is the square of the Gaussian kernel width \[Sigma]."

GaussianDKernel::usage="GaussianDKernel[t,n,x]. Note that t is half the variance, which is the square of the Gaussian kernel width \[Sigma]. n is the derivative order. GaussianDKernel generalizes to higher dimensions if t, n and x are Lists."

NGaussianDKernel::usage="NGaussianDKernel[n][t,x] renders the \!\(\*SuperscriptBox[\(n\), \(th\)]\) derivative of the gaussian kernel numerically for non-negative Integer n and Real t and x with compiled code. Note that t is half the variance, which is the square of the Gaussian kernel width \[Sigma]."

GaussianD::usage="GaussianD[f,{x,t,n}] performs the \!\(\*SuperscriptBox[\(n\), \(th\)]\) Gaussian partial derivation on function f with respect to x. The Gaussian kernel variance is 2t. GaussianD[f,{x,\!\(\*SubscriptBox[\(t\), \(x\)]\),\!\(\*SubscriptBox[\(n\), \(x\)]\)},{y,\!\(\*SubscriptBox[\(t\), \(y\)]\),\!\(\*SubscriptBox[\(n\), \(y\)]\)},...] is the \!\(\*SubsuperscriptBox[\(n\), \(x\), \(th\)]\) Gaussian partial derivation with respect to x, the \!\(\*SubsuperscriptBox[\(n\), \(y\), \(th\)]\) Gaussian partial derivation with respect to y, and so on."

GaussianBlur::usage="GaussianBlur[t][f] represents the Gaussian blur of function f at scale t, equivalent to GaussianDerivative[{t,0},{t,0},...][f]. GaussianBlur[{\!\(\*SubscriptBox[\(t\), \(x\)]\),\!\(\*SubscriptBox[\(t\), \(y\)]\),...}][f] represents the Gaussian blur of function f with a Gaussian kernel variance of 2\!\(\*SubscriptBox[\(t\), \(x\)]\) in x-direction, 2\!\(\*SubscriptBox[\(t\), \(y\)]\) in y-direction, and so forth."

GaussianDerivative::usage="GaussianDerivative[{t,n}][f] represents the n-th order Gaussian \
derivative of function f at scale t, similar to Derivative[n][f] \
representing f'. GaussianDerivative[{\!\(\*SubscriptBox[\(t\), \
\(x\)]\),\!\(\*SubscriptBox[\(n\), \(x\)]\)},{\!\(\*SubscriptBox[\(t\), \
\(y\)]\),\!\(\*SubscriptBox[\(n\), \(y\)]\)},...][f] denotes the \
(\!\(\*SubscriptBox[\(n\), \(x\)]\),\!\(\*SubscriptBox[\(n\), \
\(y\)]\),...\!\(\*SuperscriptBox[\()\), \(th\)]\) Gaussian derivative of \
a higher dimensional function f. Hereby, the Gaussian kernel variance is \
2\!\(\*SubscriptBox[\(t\), \(x\)]\) in x- and 2\!\(\*SubscriptBox[\(t\), \
\(y\)]\) in y-direction. GaussianDerivative[{\!\(\*SubscriptBox[\(t\), \
\(x\)]\),\!\(\*SubscriptBox[\(n\), \(x\)]\)},{\!\(\*SubscriptBox[\(t\), \
\(y\)]\),\!\(\*SubscriptBox[\(n\), \(y\)]\)},...][img] also acts on \
discrete arrays of numeric values that represent images or \
higher-dimensional datasets. \
GaussianDerivative[{\!\(\*SubscriptBox[\(t\), \
\(x\)]\),\!\(\*SubscriptBox[\(n\), \(x\)]\),\!\(\*SubscriptBox[\(s\), \
\(x\)]\)},{\!\(\*SubscriptBox[\(t\), \(y\)]\),\!\(\*SubscriptBox[\(n\), \
\(y\)]\),\!\(\*SubscriptBox[\(s\), \(y\)]\)},...][img] renders \
derivatives shifted by s in units of scale t."

GaussianDerivativeJet::usage="GaussianDerivativeJet[t,n][img] provides a jet of all Gaussian derivatives of total order n at scale t."

GaussianDerivativeAt::usage="GaussianDerivativeAt[{x,\!\(\*SubscriptBox[\(t\), \(x\)]\),\!\(\*SubscriptBox[\(n\), \(x\)]\)},{y,\!\(\*SubscriptBox[\(t\), \(y\)]\),\!\(\*SubscriptBox[\(n\), \(y\)]\)},...][img] repesents the (\!\(\*SubscriptBox[\(n\), \(x\)]\),\!\(\*SubscriptBox[\(n\), \(y,  ... \)]\)\!\(\*SuperscriptBox[\()\), \(th\)]\) Gaussian derivative of image img at the specified location (x,y,...) in scale space. The Gaussian kernel variance is 2\!\(\*SubscriptBox[\(t\), \(x\)]\) in x- and 2\!\(\*SubscriptBox[\(t\), \(y\)]\) in y-direction. To determine Gaussian derivatives at more than one location enter GaussianDerivativeAt[{{x1,\!\(\*SubscriptBox[\(t\), \(x1\)]\),\!\(\*SubscriptBox[\(n\), \(x1\)]\)},{y1,\!\(\*SubscriptBox[\(t\), \(y1\)]\),\!\(\*SubscriptBox[\(n\), \(y1\)]\)},...},{{x2,\!\(\*SubscriptBox[\(t\), \(x2\)]\),\!\(\*SubscriptBox[\(n\), \(x2\)]\)},{y2,\!\(\*SubscriptBox[\(t\), \(y2\)]\),\!\(\*SubscriptBox[\(n\), \(y2\)]\)},...},...][img]."

LocalMinimumMask::usage = "LocalMinimumMask[img] renders an image mask of 0s and 1s. The 1s are located at positions of minima where all immediate and diagonal neighboring pixels exhibit larger values.";

LocalMaximumMask::usage = "LocalMaximumMask[img] renders an image mask of 0s and 1s. The 1s are located at positions of maxima where all immediate and diagonal neighboring pixels exhibit smaller values.";

ThresholdFilter::usage="ThresholdFilter[img] renders all pixel values below 0 as 0. ThresholdFilter[c][img] renders all pixel values below c as 0.";

KernelRange::usage="KernelRange is an option of GaussianD and GaussianDerivative. It determines the default range of the kernel used in the convolution."

(* ImageBoundary-Option *)
If[
Head[ImageBoundary::usage]===MessageName,
ImageBoundary::usage="ImageBoundary is an option of GaussianD and GaussianDerivative working with the Convolve method. ImageBoundary determines the handling of an image frame in a convolution.",
If[
Not[StringMatchQ[ImageBoundary::usage,"*GaussianDerivative*"]],
ImageBoundary::usage=ImageBoundary::usage<>"\nImageBoundary is also an option of GaussianD and GaussianDerivative working with the Convolve method. ImageBoundary determines the handling of an image frame in a convolution."
]
]

(* Convolve-Option *)
If[
Head[Convolve::usage]===MessageName,
Convolve::usage="Is a value for the GaussianDerivative option Method. It calls upon the ListConvolve command to perform the convolution of the Gaussian derivation.",
If[
Not[StringMatchQ[Convolve::usage,"*GaussianDerivative*"]],
Convolve::usage=Convolve::usage<>"\nIt is also a value for the GaussianDerivative option Method. It calls upon the ListConvolve command to perform the convolution of the Gaussian derivation."
]
]

(* Fourier-Option *)
If[
Not[StringMatchQ[Fourier::usage,"*GaussianDerivative*"]],Fourier::usage=Fourier::usage<>"\nFourier is also an option value for the GaussianDerivative Method. The convolution of the Gaussian derivative is performed via multiplication in the Fourier domain."
]

(* Cyclic-Option *)
If[
Head[Cyclic::usage]===MessageName,
Cyclic::usage="Is a value for the GaussianDerivative option ImageBoundary. It calls upon the ListConvolve command to perform a cyclic convolution to maintain the image size.",
If[
Not[StringMatchQ[Cyclic::usage,"*GaussianDerivative*"]],
Cyclic::usage=Cyclic::usage<>"\nIt is also a value for the GaussianDerivative option ImageBoundary. It calls upon the ListConvolve command to perform a cyclic convolution to maintain the image size."
]
]

(* Truncate-Option *)
If[
Head[Truncate::usage]===MessageName,
Truncate::usage="Is a value for the GaussianDerivative option ImageBoundary. It calls upon the ListConvolve command to truncate the incomplete convolution of the Gaussian kernel at the image boundary.",
If[
Not[StringMatchQ[Truncate::usage,"*GaussianDerivative*"]],
Truncate::usage=Truncate::usage<>"\nIt is also a value for the GaussianDerivative option ImageBoundary. It calls upon the ListConvolve command to truncate the incomplete convolution of the Gaussian kernel at the image boundary."
]
]

(* Reflective-Option *)
If[
Head[Reflective::usage]===MessageName,
Reflective::usage="Is a value for the GaussianDerivative option ImageBoundary. It calls upon the ListConvolve command to ap-/prepend the reflected image on each image boundary before performing the convolution of the Gaussian kernel.",
If[
Not[StringMatchQ[Reflective::usage,"*GaussianDerivative*"]],
Reflective::usage=Reflective::usage<>"\nIt is also a value for the GaussianDerivative option ImageBoundary. It calls upon the ListConvolve command to ap-/prepend the reflected image on each image boundary before performing the convolution of the Gaussian kernel."
]
]

(* Constant-Option *)
If[
Not[StringMatchQ[Constant::usage,"*GaussianDerivative*"]],
Constant::usage=Constant::usage<>"\nIt is also a value for the GaussianDerivative option ImageBoundary. It calls upon the ListConvolve to extend the value of each boundary pixel to infinity."
]

Options[GaussianD]={Assumptions:> $Assumptions};

Options[GaussianDerivative]={KernelRange->Automatic,Method->Convolve,ImageBoundary->Cyclic, WorkingPrecision-> Log[10,2^16.]};

Options[GaussianDerivativeAt]={KernelRange->Automatic,ImageBoundary->Cyclic, WorkingPrecision-> Log[10,2^16.]};

Options[LocalMinimumMask]={ImageBoundary->Cyclic};

Options[LocalMaximumMask]={ImageBoundary->Cyclic};


Begin["`Private`"]


If[
Not[MathVisionTools`$RemoteOperation]\[And] Not[MathVisionTools`$ParallelOperation],
NotebookOpen[If[#=!={},First[#]]&[FileNames["GaussianDerivativePalette.nb",{ToFileName[{$UserAddOnsDirectory,"Applications","MathVisionTools","FrontEnd","Palettes"}],ToFileName[{$AddOnsDirectory,"Applications","MathVisionTools","FrontEnd","Palettes"}]}]]
]
];


(* Gaussian Kernel *)

\[Tau] = 4; (* global factor for the scaling parameter t, default is 4 (or 1) *)

DefaultScaleParameter=2/\[Tau];


ScaleTToSigma[t_] := Sqrt[t/DefaultScaleParameter]


SigmaToScaleT[\[Sigma]_]:=DefaultScaleParameter \[Sigma]^2


(* Numeric Implementation *)

NGaussianKernel=Compile[{{t,_Real},{x,_Real}},If[t===0.,DiracDelta[x],Exp[-x^2/(\[Tau] t)]/Sqrt[Pi (\[Tau] t)]]];

GaussianKernel[0]=1/Sqrt[Pi (\[Tau] DefaultScaleParameter)];

GaussianKernel[x_?NumberQ]:=NGaussianKernel[DefaultScaleParameter,x]

GaussianKernel[0|0.,x_?NumberQ]=DiracDelta[x];

GaussianKernel[t_?NumberQ,x_?NumberQ]:=NGaussianKernel[t,x]


(* Symbolic Implementation *)

GaussianKernel[0,{x__}]=DiracDelta[x];
GaussianKernel[0,x_]=DiracDelta[x];

GaussianKernel[t_:DefaultScaleParameter,x_]=Exp[-x^2/(\[Tau] t)]/Sqrt[Pi (\[Tau] t)];

GaussianKernel/:Derivative[0,n_][GaussianKernel]:=GaussianDKernel[#1,n,#2]&


(* Multidimensional Implementation *)

GaussianKernel[x_List]:=Apply[Times,Map[GaussianKernel,x]]

GaussianKernel[t_List,x_List]:=Inner[GaussianKernel,t,x,Times]/;Dimensions[t]==Dimensions[x]

GaussianKernel[t_,x_List]:=Apply[Times,Map[GaussianKernel[t,#]&,x]]


(* GaussianKernel Input Notation *)

MakeExpression[RowBox[{lhs___,"G","[",x__,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianKernel","[",RowBox[{"{",stripSpuriousRowBox[x],"}"}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianKernel[{x__}],StandardForm]:=RowBox[{"G","[",makeHeldRowBoxOfBoxes[{x},StandardForm,None],"]"}]


(* GaussianKernel Input Notation *)

MakeExpression[RowBox[{lhs___,"G","[",x_,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianKernel","[",x,"]"}],rhs}],StandardForm]

MakeBoxes[GaussianKernel[x_],StandardForm]:=RowBox[{"G","[",MakeBoxes[x,StandardForm],"]"}]


MakeExpression[RowBox[{lhs___,SubscriptBox["G",t_],"[",x_RowBox,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianKernel","[",RowBox[{t,",",RowBox[{"{",stripSpuriousRowBox[x],"}"}]}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianKernel[t_,{x__}],StandardForm]:=RowBox[{SubscriptBox["G",MakeBoxes[t,StandardForm]],"[",makeHeldRowBoxOfBoxes[{x},StandardForm,None],"]"}]


MakeExpression[RowBox[{lhs___,SubscriptBox["G",t_],"[",x_,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianKernel","[",RowBox[{t,",",x}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianKernel[t_,x_],StandardForm]:=RowBox[{SubscriptBox["G",MakeBoxes[t,StandardForm]],"[",MakeBoxes[x,StandardForm],"]"}]


MakeExpression[RowBox[{lhs___,SubscriptBox["G",t__],"[",x__,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianKernel","[",RowBox[{RowBox[{"{",stripSpuriousRowBox[t],"}"}],",",RowBox[{"{",stripSpuriousRowBox[x],"}"}]}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianKernel[{t__},{x__}],StandardForm]:=RowBox[{SubscriptBox["G",makeHeldRowBoxOfBoxes[{t},StandardForm,None]],"[",makeHeldRowBoxOfBoxes[{x},StandardForm,None],"]"}]


(* Symbolic Implementation *)

AngularGaussianKernel[0,\[CurlyPhi]_]=DiracDelta[\[CurlyPhi]];

AngularGaussianKernel[t_:DefaultScaleParameter,\[CurlyPhi]_]=1/(2\[Pi]) EllipticTheta[3,\[CurlyPhi]/2,E^-t];


(* Gaussian Derivative Kernel *)


(* Numeric Implementation *)

NGaussianDKernel[0]=Compile[{{t,_Real},{x,_Real}},Exp[-x^2/(\[Tau] t)]/Sqrt[Pi (\[Tau] t)]];

NGaussianDKernel[1]=Compile[{{t,_Real},{x,_Real}},With[{y=x/Sqrt[\[Tau] t]},(-2*y)/(E^y^2*Sqrt[Pi]*(\[Tau] t))],{{y,_Real}}];

NGaussianDKernel[2]=Compile[{{t,_Real},{x,_Real}},With[{y=x^2/(\[Tau] t)},(-2+4*y)/(E^y*Sqrt[Pi (\[Tau] t)^3])],{{y,_Real}}];

NGaussianDKernel[3]=Compile[{{t,_Real},{x,_Real}},With[{y=x/Sqrt[\[Tau] t]},(y*(12-8*y^2))/(E^y^2*Sqrt[Pi]*(\[Tau] t)^2)],{{y,_Real}}];

NGaussianDKernel[4]=Compile[{{t,_Real},{x,_Real}},With[{y=x^2/(\[Tau] t)},(12+y*(-48+16*y))/(E^y*Sqrt[Pi*(\[Tau] t)^5])],{{y,_Real}}];

NGaussianDKernel[5]=Compile[{{t,_Real},{x,_Real}},With[{y=x/Sqrt[\[Tau] t]},(y*(-120+y^2*(160-32*y^2)))/(E^y^2*Sqrt[Pi]*(\[Tau] t)^3)],{{y,_Real}}];

NGaussianDKernel[6]=Compile[{{t,_Real},{x,_Real}},With[{y=x^2/(\[Tau] t)},(-120+y*(720+y*(-480+64*y)))/(E^y*Sqrt[Pi*(\[Tau] t)^7])],{{y,_Real}}];

NGaussianDKernel[7]=Compile[{{t,_Real},{x,_Real}},With[{y=x/Sqrt[\[Tau] t]},(y*(1680+y^2*(-3360+y^2*(1344-128*y^2))))/(E^y^2*Sqrt[Pi]*(\[Tau] t)^4)],{{y,_Real}}];

NGaussianDKernel[8]=Compile[{{t,_Real},{x,_Real}},With[{y=x^2/(\[Tau] t)},(1680+y*(-13440+y*(13440+y*(-3584+256*y))))/(E^y*Sqrt[Pi*(\[Tau] t)^9])],{{y,_Real}}];

NGaussianDKernel[9]=Compile[{{t,_Real},{x,_Real}},With[{y=x/Sqrt[\[Tau] t]},(y*(-30240+y^2*(80640+y^2*(-48384+y^2*(9216-512*y^2)))))/(E^y^2*Sqrt[Pi]*(\[Tau] t)^5)],{{y,_Real}}];

NGaussianDKernel[10]=Compile[{{t,_Real},{x,_Real}},With[{y=x^2/(\[Tau] t)},(-30240+y*(302400+y*(-403200+y*(161280+y*(-23040+1024*y)))))/(E^y*Sqrt[Pi*(\[Tau] t)^11])],{{y,_Real}}];

NGaussianDKernel[11]=Compile[{{t,_Real},{x,_Real}},With[{y=x/Sqrt[\[Tau] t]},(y*(665280+y^2*(-2217600+y^2*(1774080+y^2*(-506880+y^2*(56320-2048*y^2))))))/(E^y^2*Sqrt[Pi]*(\[Tau] t)^6)],{{y,_Real}}];

NGaussianDKernel[12]=Compile[{{t,_Real},{x,_Real}},With[{y=x^2/(\[Tau] t)},(665280+y*(-7983360+y*(13305600+y*(-7096320+y*(1520640+y*(-135168+4096*y))))))/(E^y*Sqrt[Pi]*Sqrt[(\[Tau] t)^13])],{{y,_Real}}];

NGaussianDKernel[n_Integer?Positive]:=Compile[{{t,_Real},{x,_Real}},
With[{y=x/Sqrt[\[Tau] t]},
-HermiteH[n,y]/(Sqrt[Pi] (-Sqrt[\[Tau] t])^(n+1))*Exp[-y^2]
],{{y,_Real}}];


GaussianDKernel[0,x_?NumberQ]:=NGaussianKernel[DefaultScaleParameter,x]

GaussianDKernel[n_Integer,x_?NumberQ]:=NGaussianDKernel[n][DefaultScaleParameter,x]/;1<=n<=12

GaussianDKernel[0|0.,n_Integer,x_]:=Derivative[n][DiracDelta][x]

GaussianDKernel[t_?NumberQ,0,x_?NumberQ]:=NGaussianKernel[t,x]

GaussianDKernel[t_?NumberQ,n_Integer,x_?NumberQ]:=NGaussianDKernel[n][t,x]/;1<=n<=12


(* Symbolic Implementation *)

GaussianDKernel[t_:DefaultScaleParameter,0,x_]:=GaussianKernel[t,x]

GaussianDKernel[t_:DefaultScaleParameter,n_Integer?NonNegative,x_]:=Simplify[-(HermiteH[n,x$dummy/Sqrt[\[Tau] t]]/. x$dummy-> x)/(Sqrt[Pi] (-Sqrt[\[Tau] t])^(n+1))]*Exp[-x^2/(\[Tau] t)]

GaussianDKernel[t_:DefaultScaleParameter,n_Symbol,x_]:=
If[
N[t]=== 0.,
Derivative[n][DiracDelta][x],
-HermiteH[n,x/Sqrt[\[Tau] t]]/(Sqrt[Pi] (-Sqrt[\[Tau] t])^(n+1))*Exp[-x^2/(\[Tau] t)]
]

GaussianDKernel/:Derivative[0,0,n_][GaussianDKernel]:=GaussianDKernel[#1+n,#2,#3]&


(* Multidimensional Implementation *)

GaussianDKernel::dimfail1="The number of variables and the number of derivative indices do not match.";

GaussianDKernel::dimfail2="The number of variables, the number of derivative indices, and the number of scale parameters do not match.";

GaussianDKernel[{0 ..},x_List]:=GaussianKernel[x];

GaussianDKernel[n_List,x_List]:=Inner[GaussianDKernel,n,x,Times]/;Dimensions[n]==Dimensions[x];

GaussianDKernel[n_List,x_List]:=(Message[GaussianDKernel::dimfail1];Throw[$Failed])/;Dimensions[n]!=Dimensions[x];

GaussianDKernel[t_List,{0 ..},x_List]:=GaussianKernel[t,x];

GaussianDKernel[t_List,n_List,x_List]:=Apply[Times,Apply[GaussianDKernel,Transpose[{t,n,x}],{1}]]/;Dimensions[n]==Dimensions[t]==Dimensions[x];

GaussianDKernel[t_List,n_List,x_List]:=(Message[GaussianDKernel:dimfail2];Throw[$Failed])/;Not[Dimensions[n]==Dimensions[t]==Dimensions[x]];

GaussianDKernel[t_,{0 ..},x_List]:=GaussianKernel[t,x];

GaussianDKernel[t_,n_List,x_List]:=Apply[Times,Apply[GaussianDKernel[t,##]&,Transpose[{n,x}],{1}]]/;Dimensions[n]==Dimensions[x];

GaussianDKernel[t_,n_List,x_List]:=(Message[GaussianDKernel:dimfail2];Throw[$Failed])/;Dimensions[n]!=Dimensions[x];


(* GaussianDKernel Input Notation *)

MakeExpression[RowBox[{lhs___,SuperscriptBox["G","\[Prime]"],"[",x_,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianDKernel","[",RowBox[{"1",",",x}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianDKernel[1,x_],StandardForm]:=RowBox[{SuperscriptBox["G","\[Prime]",MultilineFunction->None],"[",MakeBoxes[x,StandardForm],"]"}]


 MakeExpression[RowBox[{lhs___,SubsuperscriptBox["G",t_,"\[Prime]"],"[",x_,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianDKernel","[",RowBox[{t,",","1",",",x}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianDKernel[t_,1,x_],StandardForm]:=RowBox[{SubsuperscriptBox["G",MakeBoxes[t,StandardForm],"\[Prime]",MultilineFunction->None],"[",MakeBoxes[x,StandardForm],"]"}]


 MakeExpression[RowBox[{lhs___,SuperscriptBox["G","\[Prime]\[Prime]"],"[",x_,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianDKernel","[",RowBox[{"2",",",x}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianDKernel[2,x_],StandardForm]:=RowBox[{SuperscriptBox["G","\[Prime]\[Prime]",MultilineFunction->None],"[",MakeBoxes[x,StandardForm],"]"}]


 MakeExpression[RowBox[{lhs___,SubsuperscriptBox["G",t_,"\[Prime]\[Prime]"],"[",x_,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianDKernel","[",RowBox[{t,",","2",",",x}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianDKernel[t_,2,x_],StandardForm]:=RowBox[{SubsuperscriptBox["G",MakeBoxes[t,StandardForm],"\[Prime]\[Prime]",MultilineFunction->None],"[",MakeBoxes[x,StandardForm],"]"}]


 MakeExpression[RowBox[{lhs___,SuperscriptBox["G",TagBox[RowBox[{"(",n_,")"}],Derivative]],"[",x_,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianDKernel","[",RowBox[{n,",",x}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianDKernel[n_,x_],StandardForm]:=RowBox[{SuperscriptBox["G",TagBox[RowBox[{"(",MakeBoxes[n,StandardForm],")"}],Derivative],MultilineFunction->None],"[",MakeBoxes[x,StandardForm],"]"}]


 MakeExpression[RowBox[{lhs___,SubsuperscriptBox["G",t_,TagBox[RowBox[{"(",n_,")"}],Derivative]],"[",x_,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianDKernel","[",RowBox[{t,",",n,",",x}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianDKernel[t_,n_,x_],StandardForm]:=RowBox[{SubsuperscriptBox["G",MakeBoxes[t,StandardForm],TagBox[RowBox[{"(",MakeBoxes[n,StandardForm],")"}],Derivative],MultilineFunction->None],"[",MakeBoxes[x,StandardForm],"]"}]


MakeExpression[RowBox[{lhs___,SuperscriptBox["G",TagBox[RowBox[{"(",n__,")"}],Derivative]],"[",x__,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianDKernel","[",RowBox[{RowBox[{"{",stripSpuriousRowBox[n],"}"}],",",RowBox[{"{",stripSpuriousRowBox[x],"}"}]}],"]"}],rhs}],StandardForm]

 MakeBoxes[GaussianDKernel[{n__},{x__}],StandardForm]:=RowBox[{SuperscriptBox["G",TagBox[RowBox[{"(",makeHeldRowBoxOfBoxes[{n},StandardForm,None],")"}],Derivative],MultilineFunction->None],"[",makeHeldRowBoxOfBoxes[{x},StandardForm,None],"]"}]


 MakeExpression[RowBox[{lhs___,SubsuperscriptBox["G",t_,TagBox[RowBox[{"(",n__,")"}],Derivative]],"[",x__,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianDKernel","[",RowBox[{t,",",RowBox[{"{",stripSpuriousRowBox[n],"}"}],",",RowBox[{"{",stripSpuriousRowBox[x],"}"}]}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianDKernel[t_,{n__},{x__}],StandardForm]:=RowBox[{SubsuperscriptBox["G",MakeBoxes[t,StandardForm],TagBox[RowBox[{"(",makeHeldRowBoxOfBoxes[{n},StandardForm,None],")"}],Derivative],MultilineFunction->None],"[",makeHeldRowBoxOfBoxes[{x},StandardForm,None],"]"}]


 MakeExpression[RowBox[{lhs___,SubsuperscriptBox["G",t__,TagBox[RowBox[{"(",n__,")"}],Derivative]],"[",x__,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianDKernel","[",RowBox[{RowBox[{"{",stripSpuriousRowBox[t],"}"}],",",RowBox[{"{",stripSpuriousRowBox[n],"}"}],",",RowBox[{"{",stripSpuriousRowBox[x],"}"}]}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianDKernel[{t__},{n__},{x__}],StandardForm]:=RowBox[{SubsuperscriptBox["G",makeHeldRowBoxOfBoxes[{t},StandardForm,None],TagBox[RowBox[{"(",makeHeldRowBoxOfBoxes[{n},StandardForm,None],")"}],Derivative],MultilineFunction->None],"[",makeHeldRowBoxOfBoxes[{x},StandardForm,None],"]"}]


GaussianBlur[t_][img_?ImageQ]:=Image[GaussianBlur[t][ImageData[img,Interleaving-> True]],Sequence@@Options[img]]


GaussianBlur[0|0.][img_List] =img;


GaussianBlur[t_?NumericQ][img_List] := GaussianDerivative[Sequence@@Table[{t,0},{ArrayDepth[img]}]][img];


GaussianBlur[{ts__?NumericQ}][img_List] := 
GaussianDerivative[Sequence@@Thread[{{ts},0}]][img]/;TensorRank[img]>=Length[{ts}]


(* N-dimensional Gaussian D operation *)


ConstantQ[f_,stns_List] := FreeQ[f,Alternatives@@Map[First,stns]]
ConstantQ[f_,symb] := FreeQ[f,symb]


GaussianDOrderQ=((IntegerQ[#] \[And] NonNegative[#])\[Or] Not[NumericQ[#]])&;


GaussianD::dvar= "Multiple Gaussian derivative specifier `1` does not have the form {variable, t, n} where n is a nonnegative machine integer.";


stnPattern={_Symbol|_Slot,_,_}?(If[GaussianDOrderQ[Last[#]],True,Message[GaussianD::dvar,#]]&);


GaussianD[f_,stns:{_Symbol|_Slot,__}..,opts___Rule]:= GaussianD[f,Sequence @@ Map[PadRight[#,3,1]&,{stns}],opts] /; Not[MatchQ[Dimensions[{stns}],{_,3}]]


GaussianD[f_,stn1:stnPattern...,{_Symbol|_Slot,0|0.0,0},stn2:stnPattern...,opts___Rule]:=
GaussianD[f,stn1,stn2,opts]


GaussianD[c_,stns:stnPattern..,opts___Rule]:=\[Piecewise]{
 {0, Or @@Thread[Map[Last,{stns}]>0]},
 {c, \!\(\*
    TagBox["True",
     "PiecewiseDefault",
     AutoDelete->False,
     DeletionWarning->True]\)}
} /; ConstantQ[c,{stns}]


GaussianD[c_ f_,stns:stnPattern..,opts___Rule]:=c GaussianD[f,stns,opts]/; ConstantQ[c,{stns}]


GaussianD[f_ * g_,stn1:stnPattern...,stn:{_Symbol|_Slot,_,_},stn2:stnPattern...,opts___Rule]:=
GaussianD[f,stn,opts] * GaussianD[g,stn1, stn2,opts]/; ConstantQ[f,{stn1,stn2}] \[And]  ConstantQ[g,{stn}]


GaussianD[f_+g_,stn:stnPattern..,opts___Rule]:=GaussianD[f,stn,opts] + GaussianD[g,stn,opts]


GaussianD[f_[a_. x_ + b_],{x_,t_,n_},opts___Rule] := 
Module[
{\[Tau]},
a^n (GaussianD[f[x],{x,\[Tau],n},opts]/.{x-> a x+b, \[Tau]-> a^2 t})
]/; ConstantQ[{a,b},x]

GaussianD[f_[a_ x_],{x_,t_,n_},opts___Rule] := 
Module[
{\[Tau]},
a^n (GaussianD[f[x],{x,\[Tau],n},opts]/.{x-> a x, \[Tau]-> a^2 t})
]/; ConstantQ[a,x]


GaussianD[x_,{x_,t_,n_?GaussianDOrderQ},opts___Rule]:=\[Piecewise]{
 {0, Refine[1<n/. {opts}/. Options[GaussianD]]},
 {n!, Refine[1==n/. {opts}/. Options[GaussianD]]},
 {(-1)^(1+n) (-t)^(n/2) x Pochhammer[-1,(2+n)/2] Hypergeometric1F1[n/2,3/2,-(x^2/(4 t))], Refine[n/2+1\[Element]Integers/. {opts}/. Options[GaussianD]]},
 {(-1)^n (-t)^((n-1)/2)  Pochhammer[-1,(n+1)/2] Hypergeometric1F1[(n-1)/2,1/2,-(x^2/(4 t))], Refine[(n+1)/2\[Element]Integers/. {opts}/. Options[GaussianD]]}
}


GaussianD[x_^p_/; FreeQ[p,x],{x_,t_,n_?GaussianDOrderQ},opts___Rule]:=\[Piecewise]{
 {0, Refine[0<=p<n\[And]p\[Element]Integers,Assumptions/. {opts}/. Options[GaussianD]]},
 {n!, Refine[0<=p\[And]p\[Element]Integers\[And]p==n,Assumptions/. {opts}/. Options[GaussianD]]},
 {(-1)^(n+1) (-t)^(1/2 (n-p+1)) x Pochhammer[-p,1/2 (n+p+1)] Hypergeometric1F1[1/2 (n-p+1),3/2,-(x^2/(4 t))], Refine[0<=p\[And]p\[Element]Integers\[And](n+p+1)/2\[Element]Integers,Assumptions/. {opts}/. Options[GaussianD]]},
 {(-1)^n (-t)^((n-p)/2) Pochhammer[-p,(n+p)/2] Hypergeometric1F1[(n-p)/2,1/2,-(x^2/(4 t))], Refine[0<=p\[And]p\[Element]Integers\[And](n+p)/2\[Element]Integers,Assumptions/. {opts}/. Options[GaussianD]]},
 {1/2 (-1)^n ((-t)^((n-p)/2) Pochhammer[-p,(n+p)/2] Hypergeometric1F1[(n-p)/2,1/2,-(x^2/(4 t))]-(-t)^((n-p+1)/2) x Pochhammer[-p,(n+p+1)/2] Hypergeometric1F1[(n-p+1)/2,3/2,-(x^2/(4 t))]), Refine[Not[p \[Element] Integers] \[Or] p< 0, Assumptions /. {opts} /. Options[GaussianD]]}
}


GaussianD[Cos[x_],{x_,t_,n_?GaussianDOrderQ},opts___Rule] = E^-t Derivative[n][Cos][x];
GaussianD[Sin[x_],{x_,t_,n_?GaussianDOrderQ},opts___Rule] = E^-t Derivative[n][Sin][x];


GaussianD[ArcTan[x_],{x_,t_,n_?GaussianDOrderQ},opts___Rule] := \[Piecewise]{
 {\[Pi]/2  Re[Erf[(x+I)/(2 Sqrt[t])]]+1/(4 t) Re[I (x+I)^2 HypergeometricPFQ[{1,1},{3/2,2},-((x+I)^2/(4 t))]]a, n===0},
 {Sqrt[\[Pi]] /(2 Sqrt[t]) (E^(-((x^2-1)/(4 t))) Cos[x/(2 t)]+Re[E^(-((x+I)^2/(4 t))) Erf[(I x-1)/(2 Sqrt[t])]]), n===1},
 {1/2  ( t^(-(n/2)) Gamma[n/2] Re[I^(n+1) Hypergeometric1F1[n/2,1/2,-((x+I)^2/(4 t))]]+t^(-((n+1)/2)) Gamma[(n+1)/2] Re[I^n (x+I) Hypergeometric1F1[(n+1)/2,3/2,-((x+I)^2/(4 t))]]), n >= 2}
}


GaussianD[Exp[x_],{x_,t_,n_?GaussianDOrderQ},opts___Rule]   = E^(t+x);
GaussianD[Cosh[x_],{x_,t_,n_?GaussianDOrderQ},opts___Rule] = E^t Derivative[n][Cosh][x];
GaussianD[Sinh[x_],{x_,t_,n_?GaussianDOrderQ},opts___Rule] = E^t Derivative[n][Sinh][x];


GaussianD[Erf[x_],{x_,t_,n_?GaussianDOrderQ},opts___Rule] := \[Piecewise]{
 {Erf[x/Sqrt[1+4 t]], n===0},
 {2 GaussianDKernel[t+1/4,n-1,x], n>=1}
}


GaussianD[DiracDelta[x_],{x_,t_,n_?GaussianDOrderQ},opts___Rule] := GaussianDKernel[t,n,x]


GaussianD[Abs[x_],{x_,t_,n_?GaussianDOrderQ},opts___Rule] := \[Piecewise]{
 {2 Sqrt[t/\[Pi]] E^(-(x^2/(4 t)))+x Erf[x/(2 Sqrt[t])], n===0},
 {Erf[x/(2 Sqrt[t])], n===1},
 {2 GaussianDKernel[t,n-2,x], n>=2}
}


GaussianD[UnitStep[x_],{x_,t_,n_?GaussianDOrderQ},opts___Rule] :=\[Piecewise]{
 {1/2 (1+Erf[x/(2 Sqrt[t])]), n===0},
 {GaussianDKernel[t,n-1,x], n>=1}
}


GaussianD[Sign[x_],{x_,t_,n_?GaussianDOrderQ},opts___Rule] :=\[Piecewise]{
 {Erf[x/(2 Sqrt[t])], n===0},
 {2 GaussianDKernel[t,n-1,x], n>=1}
}


GaussianD[Cos[\[Nu]_. x_] E^(s_. x_^2), {x_,t_,n_?GaussianDOrderQ},opts___Rule]:=
E^(-((t \[Nu]^2)/(1-4 s t)))/Sqrt[1-4 s t] D[E^((s x^2)/(1-4 s t)) Cos[(\[Nu] x)/(1-4 s t)],{x,n}]/; Refine[s<=0 , Assumptions /. {opts} /. Options[GaussianD]]


GaussianD[Sin[\[Nu]_. x_] E^(s_. x_^2), {x_,t_,n_?GaussianDOrderQ},opts___Rule]:=
E^(-((t \[Nu]^2)/(1-4 s t)))/Sqrt[1-4 s t] D[E^((s x^2)/(1-4 s t)) Sin[(\[Nu] x)/(1-4 s t)],{x,n}]/; Refine[s<=0, Assumptions /. {opts} /. Options[GaussianD]]


GaussianD[Exp[I \[Nu]_. x_] E^(s_. x_^2), {x_,t_,n_?GaussianDOrderQ},opts___Rule]:=
E^(-((t \[Nu]^2)/(1-4 s t)))/Sqrt[1-4 s t] D[E^((s x^2)/(1-4 s t)) Exp[(I \[Nu] x)/(1-4 s t)],{x,n}]/; Refine[s<=0, Assumptions /. {opts} /. Options[GaussianD]]


GaussianD[
GaussianDerivative[tn__][img_][s:_Symbol|_Slot..],
stns:stnPattern..,
opts___Rule
]:=
GaussianDerivative[
Sequence@@({tn}+Replace[{s},Append[Map[(First[#]->Rest[#])&,{stns}],_->{0,0}],{1}]),
opts
][img][s]


GaussianD[f_List,stns:stnPattern..,opts___Rule]:=Map[GaussianD[#,stns,opts]&,f] /; Not[ArrayQ[f,_,NumericQ]]


GaussianD[f_,stnFirst:stnPattern,stnRest:stnPattern.., opts___Rule]:=
GaussianD[
result,
stnRest,
Assumptions -> Prepend[
If[Head[#]===List,#,{#}]&[Assumptions /. {opts} /. Options[GaussianD]], stnFirst[[2]]>= 0
],
Sequence @@ DeleteCases[{opts},(Assumptions->_)|(Assumptions:>_)]
] /; FreeQ[result=GaussianD[f,stnFirst,opts],GaussianD|GaussianDerivative]


GaussianD[f_,stns:stnPattern.., opts___Rule]:=
Module[
{result,xs,ts,ns,
symbs = Thread[#-> Map[\!\(\*
TagBox[
StyleBox[
RowBox[{"Pattern", "[", 
RowBox[{"#", ",", 
RowBox[{"Blank", "[", "]"}]}], "]"}],
ShowSpecialCharacters->False,
ShowStringCharacters->True,
NumberMarks->True],
FullForm]\)&,#]]&[Union[Cases[{stns},_Symbol,{2}]]],
ys=Table[Unique["y"],{Length[{stns}]}],
\[Omega]s=Table[Unique["\[Omega]"],{Length[{stns}]}]},
{xs,ts,ns}=Transpose[{stns}];
(Unprotect[GaussianD];
PrependTo[DownValues[GaussianD],HoldPattern[GaussianD[#1,##2, opts]]->result];
Protect[GaussianD];
Return[result])&[f /.symbs, Sequence@@({stns} /. symbs)] /; 
If[
FreeQ[result=FourierTransform[f/.Thread[xs->ys],ys,\[Omega]s],FourierTransform],
{ts,ns}=Transpose[Map[Rest,{stns}]];
FreeQ[
result=InverseFourierTransform[
FullSimplify[
Apply[Times,(-I  \[Omega]s)^ns] Exp[-ts.( \[Omega]s^2)]  result,
Prepend[Thread[ts>0],Element[\[Omega]s,Reals]]
],
\[Omega]s,ys
]/.Thread[ys->xs],
InverseFourierTransform
],
False
]
]


GaussianD[f_Symbol[s:_Slot..],stns:{_Slot,_,_:0}..,opts___Rule]:=GaussianDerivative[Apply[Sequence,Replace[{s},Append[Map[(First[#]->Rest[#])&,{stns}],_->{0,0}],{1}]],opts][f]


GaussianD[f_Symbol[s:(_Symbol|_Slot)..],stns:stnPattern..,opts___Rule]:=GaussianDerivative[Apply[Sequence,Replace[{s},Append[Map[(First[#]->Rest[#])&,{stns}],_->{0,0}],{1}]],opts][f][s]


GaussianD[GaussianDerivative[tns:{_,_}..][f_Symbol][s:_Slot..],stns:{_Slot,_,_:0}..,opts___Rule]:=GaussianDerivative[Apply[Sequence,{tns}+Replace[{s},Append[Map[(First[#]->Rest[#])&,{stns}],_->{0,0}],{1}]],opts][f]


GaussianD[GaussianDerivative[tns:{_,_}..][f_Symbol][s:(_Symbol|_Slot)..],stns:stnPattern..,opts___Rule]:=GaussianDerivative[Apply[Sequence,{tns}+Replace[{s},Append[Map[(First[#]->Rest[#])&,{stns}],_->{0,0}],{1}]],opts][f][s]


(* GaussianD Input Notation *)

 MakeExpression[RowBox[{lhs___,SubscriptBox["\[PartialD]",RowBox[{SubscriptBox["G",t_],"[",x_,"]"}]],f_,rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianD","[",RowBox[{f,",",RowBox[{"{",RowBox[{x,",",t,",","1"}],"}"}]}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianD[f_,{x_,t_,1}],StandardForm]:=RowBox[{SubscriptBox["\[PartialD]",RowBox[{SubscriptBox["G",MakeBoxes[t,StandardForm]],"[",MakeBoxes[x,StandardForm],"]"}]],Parenthesize[f,StandardForm,D]}]


MakeExpression[RowBox[{lhs___,SubsuperscriptBox["\[PartialD]",RowBox[{SubscriptBox["G",t_],"[",x_,"]"}],RowBox[{"(",n_,")"}]],f_,rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianD","[",RowBox[{f,",",RowBox[{"{",RowBox[{x,",",t,",",n}],"}"}]}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianD[f_,{x_,t_,n_}],StandardForm]:=RowBox[{SubsuperscriptBox["\[PartialD]",RowBox[{SubscriptBox["G",MakeBoxes[t,StandardForm]],"[",MakeBoxes[x,StandardForm],"]"}],RowBox[{"(",MakeBoxes[n,StandardForm],")"}]],Parenthesize[f,StandardForm,D]}]


MakeExpression[RowBox[{lhs___,SubsuperscriptBox["\[PartialD]",RowBox[{SubscriptBox["G",RowBox[{t1_,",",t2_}]],"[",RowBox[{x1_,",",x2_}],"]"}],RowBox[{"(",RowBox[{n1_,",",n2_}],")"}]],f_,rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianD","[",RowBox[{f,",",RowBox[{"{",RowBox[{x1,",",t1,",",n1}],"}"}],",",RowBox[{"{",RowBox[{x2,",",t2,",",n2}],"}"}]}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianD[f_,{x1_,t1_,n1_},{x2_,t2_,n2_}],StandardForm]:=RowBox[{SubsuperscriptBox["\[PartialD]",RowBox[{SubscriptBox["G",RowBox[{MakeBoxes[t1,StandardForm],",",MakeBoxes[t2,StandardForm]}]],"[",RowBox[{MakeBoxes[x1,StandardForm],",",MakeBoxes[x2,StandardForm]}],"]"}],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm]}],")"}]],Parenthesize[f,StandardForm,D]}]


MakeExpression[RowBox[{lhs___,SubsuperscriptBox["\[PartialD]",RowBox[{SubscriptBox["G",t_],"[",RowBox[{x1_,",",x2_}],"]"}],RowBox[{"(",RowBox[{n1_,",",n2_}],")"}]],f_,rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianD","[",RowBox[{f,",",RowBox[{"{",RowBox[{x1,",",t,",",n1}],"}"}],",",RowBox[{"{",RowBox[{x2,",",t,",",n2}],"}"}]}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianD[f_,{x1_,t_,n1_},{x2_,t_,n2_}],StandardForm]:=RowBox[{SubsuperscriptBox["\[PartialD]",RowBox[{SubscriptBox["G",MakeBoxes[t,StandardForm]],"[",RowBox[{MakeBoxes[x1,StandardForm],",",MakeBoxes[x2,StandardForm]}],"]"}],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm]}],")"}]],Parenthesize[f,StandardForm,D]}]


MakeExpression[RowBox[{lhs___,SubsuperscriptBox["\[PartialD]",RowBox[{SubscriptBox["G",RowBox[{t1_,",",t2_,",",t3_}]],"[",RowBox[{x1_,",",x2_,",",x3_}],"]"}],RowBox[{"(",RowBox[{n1_,",",n2_,",",n3_}],")"}]],f_,rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianD","[",RowBox[{f,",",RowBox[{"{",RowBox[{x1,",",t1,",",n1}],"}"}],",",RowBox[{"{",RowBox[{x2,",",t2,",",n2}],"}"}],",",RowBox[{"{",RowBox[{x3,",",t3,",",n3}],"}"}]}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianD[f_,{x1_,t1_,n1_},{x2_,t2_,n2_},{x3_,t3_,n3_}],StandardForm]:=RowBox[{SubsuperscriptBox["\[PartialD]",RowBox[{SubscriptBox["G",RowBox[{MakeBoxes[t1,StandardForm],",",MakeBoxes[t2,StandardForm],",",MakeBoxes[t3,StandardForm]}]],"[",RowBox[{MakeBoxes[x1,StandardForm],",",MakeBoxes[x2,StandardForm],",",MakeBoxes[x3,StandardForm]}],"]"}],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm],",",MakeBoxes[n3,StandardForm]}],")"}]],Parenthesize[f,StandardForm,D]}]


MakeExpression[RowBox[{lhs___,SubsuperscriptBox["\[PartialD]",RowBox[{SubscriptBox["G",t_],"[",RowBox[{x1_,",",x2_,",",x3_}],"]"}],RowBox[{"(",RowBox[{n1_,",",n2_,",",n3_}],")"}]],f_,rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianD","[",RowBox[{f,",",RowBox[{"{",RowBox[{x1,",",t,",",n1}],"}"}],",",RowBox[{"{",RowBox[{x2,",",t,",",n2}],"}"}],",",RowBox[{"{",RowBox[{x3,",",t,",",n3}],"}"}]}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianD[f_,{x1_,t_,n1_},{x2_,t_,n2_},{x3_,t_,n3_}],StandardForm]:=RowBox[{SubsuperscriptBox["\[PartialD]",RowBox[{SubscriptBox["G",MakeBoxes[t,StandardForm]],"[",RowBox[{MakeBoxes[x1,StandardForm],",",MakeBoxes[x2,StandardForm],",",MakeBoxes[x3,StandardForm]}],"]"}],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm],",",MakeBoxes[n3,StandardForm]}],")"}]],Parenthesize[f,StandardForm,D]}]


MakeExpression[RowBox[{lhs___,SubsuperscriptBox["\[PartialD]",RowBox[{SubscriptBox["G",RowBox[{t1_,",",t2_,",",t3_,",",t4_}]],"[",RowBox[{x1_,",",x2_,",",x3_,",",x4_}],"]"}],RowBox[{"(",RowBox[{n1_,",",n2_,",",n3_,",",n4_}],")"}]],f_,rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianD","[",RowBox[{f,",",RowBox[{"{",RowBox[{x1,",",t1,",",n1}],"}"}],",",RowBox[{"{",RowBox[{x2,",",t2,",",n2}],"}"}],",",RowBox[{"{",RowBox[{x3,",",t3,",",n3}],"}"}],",",RowBox[{"{",RowBox[{x4,",",t4,",",n4}],"}"}]}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianD[f_,{x1_,t1_,n1_},{x2_,t2_,n2_},{x3_,t3_,n3_},{x4_,t4_,n4_}],StandardForm]:=RowBox[{SubsuperscriptBox["\[PartialD]",RowBox[{SubscriptBox["G",RowBox[{MakeBoxes[t1,StandardForm],",",MakeBoxes[t2,StandardForm],",",MakeBoxes[t3,StandardForm],",",MakeBoxes[t4,StandardForm]}]],"[",RowBox[{MakeBoxes[x1,StandardForm],",",MakeBoxes[x2,StandardForm],",",MakeBoxes[x3,StandardForm],",",MakeBoxes[x4,StandardForm]}],"]"}],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm],",",MakeBoxes[n3,StandardForm],",",MakeBoxes[n4,StandardForm]}],")"}]],Parenthesize[f,StandardForm,D]}]


MakeExpression[RowBox[{lhs___,SubsuperscriptBox["\[PartialD]",RowBox[{SubscriptBox["G",t_],"[",RowBox[{x1_,",",x2_,",",x3_,",",x4_}],"]"}],RowBox[{"(",RowBox[{n1_,",",n2_,",",n3_,",",n4_}],")"}]],f_,rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianD","[",RowBox[{f,",",RowBox[{"{",RowBox[{x1,",",t,",",n1}],"}"}],",",RowBox[{"{",RowBox[{x2,",",t,",",n2}],"}"}],",",RowBox[{"{",RowBox[{x3,",",t,",",n3}],"}"}],",",RowBox[{"{",RowBox[{x4,",",t,",",n4}],"}"}]}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianD[f_,{x1_,t_,n1_},{x2_,t_,n2_},{x3_,t_,n3_},{x4_,t_,n4_}],StandardForm]:=RowBox[{SubsuperscriptBox["\[PartialD]",RowBox[{SubscriptBox["G",MakeBoxes[t,StandardForm]],"[",RowBox[{MakeBoxes[x1,StandardForm],",",MakeBoxes[x2,StandardForm],",",MakeBoxes[x3,StandardForm],",",MakeBoxes[x4,StandardForm]}],"]"}],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm],",",MakeBoxes[n3,StandardForm],",",MakeBoxes[n4,StandardForm]}],")"}]],Parenthesize[f,StandardForm,D]}]


GaussianKernelRange[4]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(2.3243180666111423*(1+n)-0.9765965923097873*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[8]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(2.2224289812448683*(1+n)+1.6011247864558187*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[12]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(2.114376372864952*(1+n)+4.0288081480154725*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[16]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(1.998216846965191*(1+n)+6.392974885898669*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[20]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(1.874991609534614*(1+n)+8.723038909063387*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[24]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(1.7458525263268259*(1+n)+11.032362584249514*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[28]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(1.6117501067548536*(1+n)+13.328052128995822*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[32]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(1.473435732709178*(1+n)+15.61428837974991*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[36]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(1.3315035827972916*(1+n)+17.893710961739284*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[40]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(1.1864219273587364*(1+n)+20.168092531572174*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[44]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(1.0385758971718777*(1+n)+22.438510420428443*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[48]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(0.889875356726046*(1+n)+24.692137806054756*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[52]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(0.7367547195975274*(1+n)+26.829859007281208*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianDerivative::widthfail="Insufficient kernel width for `1`-order differentiation.";GaussianDerivative::nowidth="No kernel width specified.";


MinimalScale[4]=Compile[{{n,_Integer}},-0.07225602550763996` + 0.1934994115318552`  (1+n)^(1/3)+0.05458391922630867`  (1+n)];


MinimalScale[8]=Compile[{{n,_Integer}},0.04813185222160912`  + 0.31489231691130615`  (1+n)^(1/3)+0.05841271321345174`  (1+n)];


MinimalScale[12]=Compile[{{n,_Integer}},0.23138720823850856`  +0.3870206014942941`  (1+n)^(1/3)+0.06201023916198861`  (1+n)];


MinimalScale[16]=Compile[{{n,_Integer}},0.4427462125429202`  +0.43729757816428666`  (1+n)^(1/3)+0.06533784418156777`  (1+n)];


MinimalScale[20]=Compile[{{n,_Integer}},0.6700763376887527`  +0.47527046426284586`  (1+n)^(1/3)+0.06841700241661773`  (1+n)];


MinimalScale[24]=Compile[{{n,_Integer}},0.9076871517131073`  +0.5053978829196788`  (1+n)^(1/3)+0.07127851131749753`  (1+n)];


MinimalScale[28]=Compile[{{n,_Integer}},1.1524506471180527`  +0.5301181105158642`  (1+n)^(1/3)+0.07395088137222257`  (1+n)];


MinimalScale[32]=Compile[{{n,_Integer}},1.4024642991094307`  +0.5509059382924002`  (1+n)^(1/3)+0.0764583548853869`  (1+n)];


MinimalScale[36]=Compile[{{n,_Integer}},1.656487038699375`  +0.568717809132497`  (1+n)^(1/3)+0.07882117438223667`  (1+n)];


MinimalScale[40]=Compile[{{n,_Integer}},1.9136820125603298`  +0.5841887192822285`  (1+n)^(1/3)+0.08105828273659765`  (1+n)];


MinimalScale[44]=Compile[{{n,_Integer}},2.1736973881589376`  +0.5976246623874925`  (1+n)^(1/3)+0.0831900868437959`  (1+n)];


MinimalScale[48]=Compile[{{n,_Integer}},2.442533291990515`  +0.6028349507086076`  (1+n)^(1/3)+0.08585656496350498`  (1+n)];


MinimalScale[52]=Compile[{{n,_Integer}},2.627515797245066`  +0.6649239314410514`  (1+n)^(1/3)+0.08356758359896967`  (1+n)];


GaussianDerivative::scalefail="Scale too small for `1`-order differentiation.";


GaussianDerivative[tn:{0,0}..,opts___Rule][f_]=f;


GaussianDerivative[tn:{_,_Integer?Positive}..,opts___Rule][f_Symbol]:=0/; MemberQ[Attributes[f],Constant]


GaussianDerivative[tns:{0,0,0}..,opts___Rule][f_]=f;


GaussianDerivative[tns:{_,_Integer?Positive,_Real}..,opts___Rule][f_Symbol]:=0/; MemberQ[Attributes[f],Constant]


GaussianDerivative[tn__,opts___Rule][f:_Symbol|_Function]:= Condition[If[FreeQ[#,Slot],First[#],#]&[Evaluate[GaussianD[f @@ Table[Slot[i],{i,Length[{tn}]}],Sequence @@ MapIndexed[Prepend[#1,Slot@@#2]&,{tn}],opts ]]&],Stack[If[FreeQ[#,Slot],First[#],#]&[Evaluate[GaussianD[f @@ Table[Slot[i],{i,Length[{tn}]}],Sequence @@ MapIndexed[Prepend[#1,Slot@@#2]&,{tn}] ,opts]]&]]==={}]


GaussianDerivative[tn:{_,_Integer:0}.., opts___Rule][img_Symbol]:=
Module[
{result,ts,ns,
xs=Table[Unique["x"],{Length[{tn}]}],
\[Omega]s=Table[Unique["\[Omega]"],{Length[{tn}]}],
ys= Table[Unique["y"],{Length[{tn}]}]},
(Evaluate[result /. Thread[ys -> Table[Slot[i],{i,Length[ys]}]]]&) /; 
If[
FreeQ[result= FourierTransform[Apply[img,xs],xs,\[Omega]s],FourierTransform],
{ts,ns}=Transpose[{tn}];
FreeQ[result=  InverseFourierTransform[Apply[Times,(-I  \[Omega]s)^ns] Exp[-ts.( \[Omega]s^2)]  result,\[Omega]s,ys],InverseFourierTransform],
False
]
]


GaussianDerivative[tn:{_?NumericQ,_Integer:0}.., opts___Rule][img_?ImageQ]:=Image[GaussianDerivative[tn,opts][ImageData[img,Interleaving-> True]],Sequence@@Options[img]]


GaussianDerivative::nomethod = "Derivation Method `1` not implemented!";

GaussianDerivative[tn:{_?NumericQ,_Integer:0}.., opts___Rule][img_List]:=
Switch[
Method /. {opts} /. Options[GaussianDerivative],
Convolve, ListConvolveGaussianDerivative[tn,opts][img],
Fourier,FourierGaussianDerivative[Apply[Sequence,Reverse[{tn}]],opts][img],
_,Message[GaussianDerivative::nomethod,Method];Throw[$Failed]
]/;TensorRank[img]>=Length[{tn}]


GaussianDerivative[tns:{_?NumericQ,_Integer,_Real|_Rational|_Integer}.., opts___Rule][img_?ImageQ]:=Image[GaussianDerivative[tns,opts][ImageData[img,Interleaving-> True]],Sequence@@Options[img]]


GaussianDerivative[tns:{_?NumericQ,_Integer,_Real|_Rational|_Integer}.., opts___Rule][img_List]:=
Switch[
Method /. {opts} /. Options[GaussianDerivative],
Convolve, ListConvolveGaussianShiftDerivative[tns,opts][img],
Fourier,FourierGaussianShiftDerivative[Apply[Sequence,Reverse[{tns}]],opts][img],
_,Message[GaussianDerivative::nomethod,Method];Throw[$Failed]
]/;TensorRank[img]>=Length[{tns}]


GaussianDerivative::noboundopt="Invalid or undefined ImageBoundary option.";


GaussianKernelInterval[{0,0},_,rangeopt_:Automatic] ={-1,1};
GaussianKernelInterval[{0,0,_},_,rangeopt_:Automatic] ={-1,1};

GaussianKernelInterval[{t_,n_,s_:0},bits_,rangeopt_:Automatic] :=
(If[t<=0,Message[GaussianDerivative::scalefail,n]; Throw[$Failed]];
If[t<MinimalScale[bits][n],Message[GaussianDerivative::scalefail,n]];
Switch[
rangeopt,
Automatic,GaussianKernelRange[bits][t,n]+Floor[s],
Infinity,Floor[{-1,1}*Sqrt[-\[Tau] t*Log[$MinMachineNumber]]+s],
{-Infinity,Infinity},Floor[{-1,1}*Sqrt[-\[Tau] t*Log[$MinMachineNumber]]+s],
{_Integer,Infinity},{rangeopt[[1]], Floor[Sqrt[-\[Tau] t*Log[$MinMachineNumber]]+s]},
{-Infinity,_Integer},{-Floor[Sqrt[-\[Tau] t*Log[$MinMachineNumber]]-s],rangeopt[[2]]},
{_Integer,_Integer},rangeopt,
_,Message[GaussianDerivative::nowidth]; Throw[$Failed]
]);


ListConvolveGaussianDerivative1D[{{0,0},{kmin_,kmax_},boundaryopt_},img_, depth_,opts___]=img;

ListConvolveGaussianDerivative1D[{{t_,n_},{kmin_,kmax_},boundaryopt_},img_, depth_,opts___]:=
Module[
{kern=Nest[List,Table[NGaussianDKernel[n][t,x],{x,kmin,kmax}],depth-1]},
Switch[
boundaryopt,

Cyclic,
ListConvolve[kern,img,{PadLeft[{-kmin+1},depth,1],PadLeft[{-kmax-1},depth,1]}] ,

Truncate,
Map[AttachFrame1D[#,{-kmin,kmax}]&,
ListConvolve[kern,img,{PadLeft[{-1},depth,1],PadLeft[{1},depth,1]}],
{depth-1} ],

_?NumericQ,
ListConvolve[kern,img,{PadLeft[{-kmin+1},depth,1],PadLeft[{-kmax-1},depth,1]},N[boundaryopt]] ,

Constant,
ListConvolve[kern,ImageFrame1D[img,{{-kmin,kmax},depth, Constant}]] ,

Reflective,
ListConvolve[kern,ImageFrame1D[img,{{-kmin,kmax},depth, Reflective}]],

_,Message[GaussianDerivative::noboundopt]; Throw[$Failed]
]
]

ListConvolveGaussianDerivative[tn__List,opts___Rule][img_List]:=
Catch[Module[
{
dim=TensorRank[img],nn=Length[{tn}],dimrot,
bounds = (ImageBoundary /. {opts} /. Options[GaussianDerivative]),
kernrange = (KernelRange /. {opts} /. Options[GaussianDerivative]),
kernpbits = Min[52,Max[4,4*Ceiling[
Log[2,10^(WorkingPrecision /. {opts} /. Options[GaussianDerivative])
]/4]]]
},
If[
dim === nn,
dimrot=RotateLeft[Range[nn]];
Fold[
ListConvolveGaussianDerivative1D[#2,Transpose[#1,dimrot],dim,opts]&,
img,
Map[{#,GaussianKernelInterval[#,kernpbits,kernrange],bounds}&,RotateLeft[{tn}]]],
dimrot=Join[Range[1,dim-nn],RotateLeft[Range[dim-nn+1,dim]]];
Transpose[
Fold[
ListConvolveGaussianDerivative1D[#2,Transpose[#1,dimrot],dim,opts]&,
Transpose[img,Join[Range[dim-nn+1,dim],Range[1,dim-nn]]],
Map[{#,GaussianKernelInterval[#,kernpbits,kernrange],bounds}&,RotateLeft[{tn}]]
],
Join[Range[nn+1,dim],Range[1,nn]]
]
]
]]


ListConvolveGaussianShiftDerivative1D[{{0,0,0|0.0},{kmin_,kmax_},boundaryopt_},img_, depth_,opts___]=img;

ListConvolveGaussianShiftDerivative1D[{{t_,n_,s_},{kmin_,kmax_},boundaryopt_},img_, depth_,opts___]:=
Module[
{kern=Nest[List,Table[NGaussianDKernel[n][t,x-t s],{x,kmin,kmax}],depth-1]},
Switch[
boundaryopt,

Cyclic,
ListConvolve[kern,img,{PadLeft[{-kmin+1},depth,1],PadLeft[{-kmax-1},depth,1]}] ,

Truncate,
Map[AttachFrame1D[#,{-kmin,kmax}]&,
ListConvolve[kern,img,{PadLeft[{-1},depth,1],PadLeft[{1},depth,1]}],
{depth-1} ],

_?NumericQ,
ListConvolve[kern,img,{PadLeft[{-kmin+1},depth,1],PadLeft[{-kmax-1},depth,1]},N[boundaryopt]] ,

Constant,
ListConvolve[kern,ImageFrame1D[img,{{-kmin,kmax},depth, Constant}]] ,

Reflective,
ListConvolve[kern,ImageFrame1D[img,{{-kmin,kmax},depth, Reflective}]],

_,Message[GaussianDerivative::noboundopt]; Throw[$Failed]
]
]

ListConvolveGaussianShiftDerivative[tns__List,opts___Rule][img_List]:=
Catch[Module[
{
dim=TensorRank[img],nn=Length[{tns}],dimrot,
bounds = (ImageBoundary /. {opts} /. Options[GaussianDerivative]),
kernrange = (KernelRange /. {opts} /. Options[GaussianDerivative]),
kernpbits = Min[52,Max[4,4*Ceiling[
Log[2,10^(WorkingPrecision /. {opts} /. Options[GaussianDerivative])
]/4]]]
},
If[
dim === nn,
dimrot=RotateLeft[Range[nn]];
Fold[
ListConvolveGaussianShiftDerivative1D[#2,Transpose[#1,dimrot],dim,opts]&,
img,
Map[{#,GaussianKernelInterval[#,kernpbits,kernrange],bounds}&,RotateLeft[{tns}]]],
dimrot=Join[Range[1,dim-nn],RotateLeft[Range[dim-nn+1,dim]]];
Transpose[
Fold[
ListConvolveGaussianShiftDerivative1D[#2,Transpose[#1,dimrot],dim,opts]&,
Transpose[img,Join[Range[dim-nn+1,dim],Range[1,dim-nn]]],
Map[{#,GaussianKernelInterval[#,kernpbits,kernrange],bounds}&,RotateLeft[{tns}]]
],
Join[Range[nn+1,dim],Range[1,nn]]
]
]
]]


NFourierGaussianDKernelList = 
Compile[
{{t,_Real},{n,_Integer},{r,_Integer}},
Join[{If[n===0,1,0]},#,(-1)^n  Reverse[If[EvenQ[r],Drop[#,-1],#]]]&[With[{stepsize =2.Pi/r},
Table[(omega)^n * Exp[-omega^2 \[Tau] t/4],{omega,stepsize, Pi,stepsize}]
]
],
{{omega,_Real},{stepsize,_Real}}
];

FourierGaussianDerivative[tn__List, opts___Rule][img_List]:=
Module[
{dim=TensorRank[img],
nn=Length[{tn}],
kern,norm,res},
kern = 
Apply[
FastOuterTimes,
Apply[
NFourierGaussianDKernelList,
Transpose[Append[Transpose[{tn}],res=Take[Dimensions[img],nn]]],
{1}
]
];
If[Not[Apply[And,Positive[Transpose[{tn}][[1]]]]] && (Max[kern]>10.^($MachinePrecision-3)),kern=Map[Min[#,10.^($MachinePrecision-3)]&,kern,{-1}]];
norm = Apply[Times,(-I)^(Transpose[{tn}][[2]])] ;
If[
dim === nn,
Chop[Re[InverseFourier[norm * kern * Fourier[img]]]],
Transpose[
Map[
Chop[Re[InverseFourier[norm* kern * Fourier[#]]]]&,
Transpose[img,Join[Range[dim-nn+1,dim],Range[1,dim-nn]]],
{dim-nn}
],
Join[Range[nn+1,dim],Range[1,nn]]
]
]
]


NFourierGaussianShiftDKernelList =  
Compile[
{{t,_Real},{n,_Integer},{s,_Real},{r,_Integer}},
If[n===0,
Map[Exp[-#*(#-I s) \[Tau] t/4]&,N[(2\[Pi])/r ]Join[Range[0,Quotient[r,2]],Range[1+Quotient[-r,2],-1]]],
Map[(#)^n * Exp[-#*(#-I s) \[Tau] t/4]&,N[(2\[Pi])/r ]Join[Range[0,Quotient[r,2]],Range[1+Quotient[-r,2],-1]]]
]
];

FourierGaussianShiftDerivative[tns__List, opts___Rule][img_List]:=
Module[
{dim=TensorRank[img],
nn=Length[{tns}],
kern,norm,res},
kern = 
Apply[
FastOuterTimes,
Apply[
NFourierGaussianShiftDKernelList,
Transpose[Append[Transpose[{tns}],res=Take[Dimensions[img],nn]]],
{1}
]
];
If[Not[Apply[And,Positive[Transpose[{tns}][[1]]]]] && (Max[kern]>10.^($MachinePrecision-3)),kern=Map[Min[#,10.^($MachinePrecision-3)]&,kern,{-1}]];
norm = Apply[Times,(-I)^(Transpose[{tns}][[2]])] ;
If[
dim === nn,
Chop[Re[InverseFourier[norm * kern * Fourier[img]]]],
Transpose[
Map[
Chop[Re[InverseFourier[norm* kern * Fourier[#]]]]&,
Transpose[img,Join[Range[dim-nn+1,dim],Range[1,dim-nn]]],
{dim-nn}
],
Join[Range[nn+1,dim],Range[1,nn]]
]
]
]


(* GaussianDerivative Input Notation *)

MakeExpression[SubscriptBox[f_,SubscriptBox["G",t_]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{"{",RowBox[{t,",","0"}],"}"}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t_,0}][f_],StandardForm]:=SubscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",MakeBoxes[t,StandardForm]]]


MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",t_],"\[Prime]"],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{"{",RowBox[{t,",","1"}],"}"}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t_,1}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",MakeBoxes[t,StandardForm]],"\[Prime]",MultilineFunction->None]


MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",t_],"\[Prime]\[Prime]"],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{"{",RowBox[{t,",","2"}],"}"}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t_,2}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",MakeBoxes[t,StandardForm]],"\[Prime]\[Prime]",MultilineFunction->None]


MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",t_],RowBox[{"(",n_,")"}]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{"{",RowBox[{t,",",n}],"}"}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t_,n_}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",MakeBoxes[t,StandardForm]],RowBox[{"(",MakeBoxes[n,StandardForm],")"}]]


MakeExpression[SubscriptBox[f_,SubscriptBox["G",RowBox[{t1_,",",t2_}]]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t1,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t2,",","0"}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t1_,0},{t2_,0}][f_],StandardForm]:=SubscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",RowBox[{MakeBoxes[t1,StandardForm],",",MakeBoxes[t2,StandardForm]}]]]


MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",RowBox[{t1_,",",t2_}]],RowBox[{"(",RowBox[{n1_,",",n2_}],")"}]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t1,",",n1}],"}"}],",",RowBox[{"{",RowBox[{t2,",",n2}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t1_,n1_},{t2_,n2_}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",RowBox[{MakeBoxes[t1,StandardForm],",",MakeBoxes[t2,StandardForm]}]],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm]}],")"}]]


MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",t_],RowBox[{"(",RowBox[{n1_,",",n2_}],")"}]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t,",",n1}],"}"}],",",RowBox[{"{",RowBox[{t,",",n2}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t_,n1_},{t_,n2_}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",MakeBoxes[t,StandardForm]],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm]}],")"}]]


MakeExpression[SubscriptBox[f_,SubscriptBox["G",RowBox[{t1_,",",t2_,",",t3_}]]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t1,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t2,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t3,",","0"}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t1_,0},{t2_,0},{t3_,0}][f_],StandardForm]:=SubscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",RowBox[{MakeBoxes[t1,StandardForm],",",MakeBoxes[t2,StandardForm],",",MakeBoxes[t3,StandardForm]}]]]


MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",RowBox[{t1_,",",t2_,",",t3_}]],RowBox[{"(",RowBox[{n1_,",",n2_,",",n3_}],")"}]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t1,",",n1}],"}"}],",",RowBox[{"{",RowBox[{t2,",",n2}],"}"}],",",RowBox[{"{",RowBox[{t3,",",n3}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t1_,n1_},{t2_,n2_},{t3_,n3_}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",RowBox[{MakeBoxes[t1,StandardForm],",",MakeBoxes[t2,StandardForm],",",MakeBoxes[t3,StandardForm]}]],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm],",",MakeBoxes[n3,StandardForm]}],")"}]]


MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",t_],RowBox[{"(",RowBox[{n1_,",",n2_,",",n3_}],")"}]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t,",",n1}],"}"}],",",RowBox[{"{",RowBox[{t,",",n2}],"}"}],",",RowBox[{"{",RowBox[{t,",",n3}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t_,n1_},{t_,n2_},{t_,n3_}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",MakeBoxes[t,StandardForm]],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm],",",MakeBoxes[n3,StandardForm]}],")"}]]


 MakeExpression[SubscriptBox[f_,SubscriptBox["G",RowBox[{t1_,",",t2_,",",t3_,",",t4_}]]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t1,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t2,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t3,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t4,",","0"}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t1_,0},{t2_,0},{t3_,0},{t4_,0}][f_],StandardForm]:=SubscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",RowBox[{MakeBoxes[t1,StandardForm],",",MakeBoxes[t2,StandardForm],",",MakeBoxes[t3,StandardForm],",",MakeBoxes[t4,StandardForm]}]]]


 MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",RowBox[{t1_,",",t2_,",",t3_,",",t4_}]],RowBox[{"(",RowBox[{n1_,",",n2_,",",n3_,",",n4_}],")"}]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t1,",",n1}],"}"}],",",RowBox[{"{",RowBox[{t2,",",n2}],"}"}],",",RowBox[{"{",RowBox[{t3,",",n3}],"}"}],",",RowBox[{"{",RowBox[{t4,",",n4}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t1_,n1_},{t2_,n2_},{t3_,n3_},{t4_,n4_}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",RowBox[{MakeBoxes[t1,StandardForm],",",MakeBoxes[t2,StandardForm],",",MakeBoxes[t3,StandardForm],",",MakeBoxes[t4,StandardForm]}]],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm],",",MakeBoxes[n3,StandardForm],",",MakeBoxes[n4,StandardForm]}],")"}]]


 MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",t_],RowBox[{"(",RowBox[{n1_,",",n2_,",",n3_,",",n4_}],")"}]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t,",",n1}],"}"}],",",RowBox[{"{",RowBox[{t,",",n2}],"}"}],",",RowBox[{"{",RowBox[{t,",",n3}],"}"}],",",RowBox[{"{",RowBox[{t,",",n4}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t_,n1_},{t_,n2_},{t_,n3_},{t_,n4_}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",MakeBoxes[t,StandardForm]],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm],",",MakeBoxes[n3,StandardForm],",",MakeBoxes[n4,StandardForm]}],")"}]]


JetIndex[n_,1]={{n}};

JetIndex[n_,d_]:=Join@@Table[Map[Prepend[#,n-k]&,JetIndex[k,d-1]],{k,0,n}]


GaussianDerivativeJet[t_,n_][img_?ImageQ] := Apply[GaussianDerivative[##][ImageData[img,Interleaving-> True]]&,Map[{t,#}&,JetIndex[n,2],{2}],{1}]

GaussianDerivativeJet[t_,n_][img_List] := Apply[GaussianDerivative[##][img]&,Map[{t,#}&,JetIndex[n,ArrayDepth[img]],{2}],{1}]


GaussianDerivativeAt[tnp:{_?NumericQ,_?NumericQ,_Integer:0}.., opts___Rule][img_List]:=
Catch[Module[
{
bounds = (ImageBoundary /. {opts} /. Options[GaussianDerivativeAt]),
kernrange = (KernelRange /. {opts} /. Options[GaussianDerivativeAt]),
kernpbits = Min[52,Max[4,4*Ceiling[
Log[2,10^(WorkingPrecision /. {opts} /. Options[GaussianDerivativeAt])
]/4]]],
tnpList=Reverse[Map[PadRight[#,3]&,{tnp}]],
positions,intervals,frameWidth,offsets,framedImage,x
},
positions = tnpList[[All,1]];
intervals=Map[
GaussianKernelInterval[Rest[#],kernpbits,kernrange]&,
tnpList,{1}
];
frameWidth=Transpose[Apply[
{1-Map[Min[1,#]&,#1],
MapThread[(Max[#1,#2]-#2)&,{#2,Take[Dimensions[img],Length[#2]]}]}&,
Transpose[Round[positions]+intervals]
]];
offsets = frameWidth[[All,1]];
framedImage = ImageFrame[img,frameWidth,ImageBoundary-> bounds];
Fold[
Dot[#2,#1]&,
Apply[Take[framedImage,##]&,Round[positions] + offsets+intervals],
MapThread[
Table[
NGaussianDKernel[Last[#1]][#1[[-2]],x],Evaluate[Join[{x},Reverse[#2]+First[#1]-Round[First[#1]],{-1}]]
]&,
{tnpList,intervals}
]
]
]]/;TensorRank[img]>=Length[{tnp}]

GaussianDerivativeAt[tnps:{{_?NumericQ,_?NumericQ,_Integer:0}..}.., opts___Rule][img_List]:=
Catch[Module[
{
bounds = (ImageBoundary /. {opts} /. Options[GaussianDerivativeAt]),
kernrange = (KernelRange /. {opts} /. Options[GaussianDerivativeAt]),
kernpbits = Min[52,Max[4,4*Ceiling[
Log[2,10^(WorkingPrecision /. {opts} /. Options[GaussianDerivativeAt])
]/4]]],
tnpList=Map[Reverse,Map[PadRight[#,3]&,{tnps},{2}]],
positions,intervals,frameWidth,offsets,framedImage,x
},
positions = tnpList[[All,All,1]];
intervals=Map[GaussianKernelInterval[Rest[#],kernpbits,kernrange]&,tnpList,{2}];
frameWidth=MapThread[
{1-Min[1,First[#1]],Max[Last[#1],#2]-#2}&,{#,Take[Dimensions[img],Length[#]]}
]&[PseudoTranspose[Round[positions]+intervals,{3,1,2}]];
offsets = frameWidth[[All,1]];
framedImage = ImageFrame[img,frameWidth,ImageBoundary-> bounds];
MapThread[
Fold[Dot[#2,#1]&,Apply[Take[framedImage,##]&,#1],#2]&,
{Map[(# + offsets)&,Round[positions]]+intervals,
MapThread[
Table[
NGaussianDKernel[Last[#1]][#1[[-2]],x],
Evaluate[Join[{x},Reverse[#2]+First[#1]-Round[First[#1]],{-1}]]
]&,
{tnpList,intervals},2
]}
]
]]/;Apply[And,Map[(TensorRank[img]>=Length[#])&,{tnps}]]


LocalMaximumMask[img_?ImageQ,opts___?OptionQ]:=Image[LocalMaximumMask[ImageData[img],opts],"Bit"];


LocalMaximumMask[img_,opts___?OptionQ] := 
Map[
If[Position[#,Max[#]]==={{2}},1,0]&,
Partition[ImageFrame[img,1,ImageBoundary-> (ImageBoundary /. {opts} /. Options[LocalMaximumMask])],3,1]
]/; ArrayDepth[img]===1


LocalMaximumMask[img_,opts___?OptionQ] := 
Map[
If[Position[#,Max[#]]==={{2,2}},1,0]&,
Partition[ImageFrame[img,1,ImageBoundary-> (ImageBoundary /. {opts} /. Options[LocalMaximumMask])],{3,3},{1,1}],
{2}
]/; ArrayDepth[img]===2


LocalMaximumMask[img_,opts___?OptionQ] := 
Map[
If[Position[#,Max[#]]==={{2,2,2}},1,0]&,
Partition[ImageFrame[img,1,ImageBoundary-> (ImageBoundary /. {opts} /. Options[LocalMaximumMask])],{3,3,3},{1,1,1}],
{3}
]/; ArrayDepth[img]===3


LocalMaximumMask[img_,opts___?OptionQ] := 
Module[
{n=ArrayDepth[img],p},
p = {Table[2,{n}]};
Map[
If[Position[#,Max[#]]===p,1,0]&,
Partition[ImageFrame[img,1,ImageBoundary-> (ImageBoundary /. {opts} /. Options[LocalMaximumMask])],Table[3,{n}],Table[1,{n}]],
{n}
]
]/; ArrayDepth[img]>3


LocalMinimumMask[img_?ImageQ,opts___?OptionQ]:=Image[LocalMinimumMask[ImageData[img],opts],"Bit"];


LocalMinimumMask[img_,opts___?OptionQ] := 
Map[
If[Position[#,Min[#]]==={{2}},1,0]&,
Partition[ImageFrame[img,1,ImageBoundary-> (ImageBoundary /. {opts} /. Options[LocalMinimumMask])],3,1]
]/; ArrayDepth[img]===1


LocalMinimumMask[img_,opts___?OptionQ] := 
Map[
If[Position[#,Min[#]]==={{2,2}},1,0]&,
Partition[ImageFrame[img,1,ImageBoundary-> (ImageBoundary /. {opts} /. Options[LocalMinimumMask])],{3,3},{1,1}],
{2}
]/; ArrayDepth[img]===2


LocalMinimumMask[img_,opts___?OptionQ] := 
Map[
If[Position[#,Min[#]]==={{2,2,2}},1,0]&,
Partition[ImageFrame[img,1,ImageBoundary-> (ImageBoundary /. {opts} /. Options[LocalMinimumMask])],{3,3,3},{1,1,1}],
{3}
]/; ArrayDepth[img]===3


LocalMinimumMask[img_,opts___?OptionQ] := 
Module[
{n=ArrayDepth[img],p},
p = {Table[2,{n}]};
Map[
If[Position[#,Min[#]]===p,1,0]&,
Partition[ImageFrame[img,1,ImageBoundary-> (ImageBoundary /. {opts} /. Options[LocalMinimumMask])],Table[3,{n}],Table[1,{n}]],
{n}
]
]/; ArrayDepth[img]>3


ThresholdFilter[img_?ImageQ]:=Image[ThresholdFilter[ImageData[img]],Sequence@@Options[img]];
ThresholdFilter[c_][img_?ImageQ]:=Image[ThresholdFilter[c][ImageData[img]],Sequence@@Options[img]]


ThresholdFilter[img_List]= img UnitStep[img];
ThresholdFilter[c_][img_List]:= img UnitStep[img-c];


FastOuterTimes[x_List,y__List] := Fold[With[{v=#2},Map[Times[#,v]&,#1,{TensorRank[#1]}]]&,x,{y}];
FastOuterTimes[x_List] = x;


PseudoTranspose[expr:{{__}..}] :=
DeleteCases[Transpose[PadRight[expr,{Length[expr],Max[Map[Length,expr]]},Null]],Null,{2}]

PseudoTranspose[expr:{{__}..},perm_List] :=
With[
{dim=Drop[NestWhileList[Max[Map[Length,expr,{i++}]]&,i=1;Length[expr],(#>0)&],-1]},
If[Length[perm]>Length[dim], Message[Transpose::tperm,perm];Return[]];
DeleteCases[Transpose[PadRight[expr,dim,Null],perm],Null|{Null..},Length[perm]]
]


AttachFrame1D[data_List,{widthleft_Integer,widthright_Integer}] :=
If[widthleft==widthright,
Join[#,data,#]&[Table[0,{widthleft},##]&@@Transpose[{Dimensions[First[data]]}]],
Join[Table[0,{widthleft},##],data,Table[0,{widthright},##]]&@@Transpose[{Dimensions[First[data]]}]
]


End[]

SetAttributes[{
G,
NGaussianKernel,
GaussianKernel,
AngularGaussianKernel,
NGaussianDKernel,
GaussianDKernel,
GaussianD,
GaussianBlur,
GaussianDerivative,
GaussianDerivativeJet,
GaussianDerivativeAt,
LocalMinimumMask,
LocalMaximumMask,
ThresholdFilter,
ScaleTToSigma,
SigmaToScaleT,
Method,
KernelRange,
ImageBoundary,
Convolve,
Fourier,
Cyclic,
Truncate,
Reflective},
{Protected, ReadProtected}
]

EndPackage[]
