(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`HankelTransform`"] = {2009,10,1,15,40,0};

Protect[TimeStamp];


(*:Name: MathVisionTools`HankelTransform` *)

(*:Author: Markus van Almsick*)

(*:Email address: M.v.Almsick@tue.nl*)

(*:Context: MathVisionTools`HankelTransform`*)

(*:Package Version: 1.2 *)

(*:Mathematica Version: 5.0 *)

(*:Copyright: Copyright 2004, Technische Universiteit Eindhoven*)

(*:Title: HankelTransform *)

(*:Summary: This package implements the Hankel transformation *)

(*:Keywords: Hankel Transformation , Fourier-Bessel Transformation, Fourier Transformation *)

(*:Requirements: None *)

(*:Source: None *)

(*:History: Version 1.0 by Markus van Almsick, July 2004 *)

(*:Limitations: *)

(*:Discussion: *)

(*:To do: *)


BeginPackage["MathVisionTools`HankelTransform`",{"MathVisionTools`GaussianDerivative`"}]

Unprotect[HankelTransform,InverseHankelTransform,GaussHankelCoefficient,
HalfGaussHankelCoefficient,HankelBasis,NHankelBasis,HankelBasisEigenvalue,HankelBasisNList,NHankelBasisNList,HankelBasisNMList,NHankelBasisNMList,HankelBasisRadius,PolarFourierScale,PolarFourierNMax,PolarFourier,InversePolarFourier,RotatePolarFourierPhase,CenteredFourier,InverseCenteredFourier]


HankelTransform::usage="HankelTransform[expr, r, \[Rho]] gives the symbolic Hankel transform of expr. HankelTransform[m][expr, r, \[Rho]] gives the symbolic m-mode Hankel transform of expr for the radial component of an angular \!\(\*SuperscriptBox[\"\[ExponentialE]\", 
RowBox[{\"\[ImaginaryI]\", \" \", \"m\", \" \", \"\[CurlyPhi]\"}]]\) representaton.";

InverseHankelTransform::usage="InverseHankelTransform[expr, \[Rho], r] gives the symbolic inverse Hankel transform of expr. InverseHankelTransform[m][expr, \[Rho], r] gives the symbolic inverse Hankel transform of expr for the radial component of an angular \!\(\*SuperscriptBox[\"\[ExponentialE]\", 
RowBox[{\"\[ImaginaryI]\", \" \", \"m\", \" \", \"\[CurlyPhi]\"}]]\) representaton.";

GaussHankelCoefficient::usage= "GaussHankelCoefficient[t,{\!\(\*SubscriptBox[\"n\", \"x\"]\),\!\(\*SubscriptBox[\"n\", \"y\"]\)},n,m] renders the hermitian product of a 2-dimensional GaussianDKernel[t,{\!\(\*SubscriptBox[\"n\", \"x\"]\),\!\(\*SubscriptBox[\"n\", \"y\"]\)},{x,y}] and a HankelBasis[n,m,x+\[ImaginaryI]*y]. GaussHankelCoefficients help to decompose GaussianDKernels into a HankelBasis. The default scale is t = 1/2, which permits a finite decomposition with |m|\[LessEqual]\!\(\*SubscriptBox[\"n\", \"x\"]\)+\!\(\*SubscriptBox[\"n\", \"y\"]\) and n\[LessEqual]1+(\!\(\*SubscriptBox[\"n\", \"x\"]\)+\!\(\*SubscriptBox[\"n\", \"y\"]\))/2.";

HalfGaussHankelCoefficient::usage= "HalfGaussHankelCoefficient[t,n,m] renders the hermitian product of the 2-dimensional GaussianKernel[t,{x,y}]*UnitStep[x] on the positive x quadrants and a HankelBasis[n,m,x+\[ImaginaryI]*y]. HalfGaussHankelCoefficient[t,{ny},n,m] renders the hermitian product of the 2-dimensional GaussianDKernel[t,{0,ny},{x,y}]*UnitStep[x] on the positive x quadrants and a HankelBasis[n,m,x+\[ImaginaryI]*y. HalfGaussHankelCoefficients help to decompose one half of a GaussianKernel into a HankelBasis. The default scale is t = 1/2.";

HankelBasis::usage="HankelBasis[n,z] is an orthonormal basis of eigenfunctions of the Hankel transformation consisting of a Gaussian kernel and Laguerre polynomials. HankelBasis[n,m,z] is an orthonormal basis of eigenfunctions of the m-mode Hankel transformation.";

NHankelBasis::usage="NHankelBasis[n,z] is a fast numerical implementation of an orthonormal basis of eigenfunctions of the Hankel transformation consisting of a Gaussian kernel and Laguerre polynomials. NHankelBasis[n,m,z] is a fast numerical implementation of an orthonormal basis of eigenfunctions of the m-mode Hankel transformation.";

HankelBasisEigenvalue::usage="HankelBasisEigenvalue[n] renders the HankelTranform eigenvalues of the HankelBasis[n,z]. HankelBasisEigenvalue[n,m] renders the m-mode HankelTranform eigenvalues of the HankelBasis[n,m,z].";

HankelBasisNList::usage="HankelBasisNList[nmax,z] generates a List of the orthonormal basis of HankeTransform eigenfunctions HankelBasis[0,z] through HankelBasis[nmax,z]. HankelBasisNList[nmax,m,z] generates a List of the orthonormal basis of m-mode HankeTransform eigenfunctions HankelBasis[0,m,z] through HankelBasis[nmax,m,z].";

NHankelBasisNList::usage="NHankelBasisNList[nmax,z] numerically generates a List of values of the orthonormal basis of HankeTransform eigenfunctions HankelBasis[0,z] through HankelBasis[nmax,z]. HankelBasisNList[nmax,m,z] numerically generates a List of values of the orthonormal basis of m-mode HankeTransform eigenfunctions HankelBasis[0,m,z] through HankelBasis[nmax,m,z].";

HankelBasisNMList::usage="HankelBasisNMList[nmax,mmax,z] generates a 2-dimensional List of the orthonormal basis of m-mode HankeTransform eigenfunctions HankelBasis[0,m,z] through HankelBasis[nmax,m,z] for m = 0 to mmax.";

NHankelBasisNMList::usage="NHankelBasisNMList[nmax,mmax,z] numerically generates a 2-dimensional List of values of the orthonormal basis of m-mode HankeTransform eigenfunctions HankelBasis[0,m,z] through HankelBasis[nmax,m,z] for m = 0 to mmax.";

HankelBasisRadius::usage="HankelBasisRadius[n,m,t] renders the radius, in which the HankelBasis function is essentially unequal 0 and does not decay exponentially for r torwards infinity. n is the radial quantum number. m is the angular quantum number. t is the scale parameter.";

PolarFourierScale::usage="PolarFourierScale[{xdim,ydim}] determines the optimal scale parameter t for a PolarFourier transformation of a (xdim,ydim)-dimensional array.";

PolarFourierNMax::usage="PolarFourierNMax[{xdim,ydim}] determines the largest n-mode in a PolarFourier transformation so that the n-th Hankel basis function still fits into a (xdim,ydim)-dimensional array at optimal scale t (see PolarFourierScale). PolarFourierNMax[t,{xdim,ydim}] determines the largest n-mode for a given scale parameter t.";

PolarFourier::usage="PolarFourier[data,nmax,mmax] performs a polar Fourier transformation on 2-dimensional discrete data and renders the radial Fourier coefficients 0 to nmax and the angular Fourier coefficients -mmax to mmax. If omitted, optimal nmax and mmax are determined automatically (see PolarFourierNMax). PolarFourier[t,\[Alpha]][data,nmax,mmax] performs a polar Fourier transformation at scale t if \[Alpha] = \[Pi]/2. For \[Alpha] = 0 PolarFourier performs a basis transformation into the Hankel basis at scale t. If t is omitted, the optimal scale parameter is calculated via the PolarFourierScale function.";

InversePolarFourier::usage="InversePolarFourier[coefficients,{xdim,ydim}] performs an inverse polar Fourier transformation on the radial and angular Fourier coefficients and renders the result on a Cartesian grid of xdim and ydim dimensions. If the dimensions xdim and ydim are not given InversePolarFourier determines an appropriate set of dimensions automatically. InversePolarFourier[t,\[Alpha]][coefficients,{xdim,ydim}] performs an inverse polar Fourier transformation at scale t if \[Alpha] = -\[Pi]/2. For \[Alpha] = 0 InversePolarFourier performs a basis transformation from the Hankel basis at scale t back into regular Cartesian coordinates. If t is omitted, the optimal scale parameter is calculated via the PolarFourierScale function.";

RotatePolarFourierPhase::usage="RotatePolarFourierPhase[coefficients] multiplies the coefficients of a polar Fourier transformation with their Eigenvalues to perform a Fourier transformation of the Hankel basis. RotatePolarFourierPhase[coefficients,\[Alpha]] is a continuous transition of a Hankel basis to its Fourier transformed for \[Alpha] going from 0 to \[Pi]/2.";

CenteredFourier::usage="CenteredFourier[list] finds the discrete Cartesian Fourier transform of a n-dimensional list of complex numbers such that the rendered spectrum displays the negative frequencies to the left of the 0-frequency and the positive frequencies to the right. The center of the image and Fourier space is at Floor[dims]+1.";

InverseCenteredFourier::usage="InverseCenteredFourier[list] finds the discrete Cartesian inverse Fourier transform of a n-dimensional list of complex numbers that represents a spectrum with the negative frequencies to the left of the 0-frequency and the positive frequencies to the right. The center of the image and Fourier space is at Floor[dims]+1.";


Begin["`Private`"]


HankelTransform[f_,r_,\[Omega]_] := Integrate[f  r BesselJ[0,r \[Omega]],{r,0,\[Infinity]},Assumptions->{(r|\[Omega])\[Element]Reals,r>0, \[Omega]>0}]

HankelTransform[m_][f_,r_,\[Omega]_] := I^m  Integrate[f  r BesselJ[m,r \[Omega]],{r,0,\[Infinity]},Assumptions->{(r|\[Omega])\[Element]Reals,r>0, \[Omega]>0}]


InverseHankelTransform[g_,\[Omega]_,r_] := Integrate[g  \[Omega] BesselJ[0,r \[Omega]],{\[Omega],0,\[Infinity]},Assumptions->{(r|\[Omega])\[Element]Reals,r>0, \[Omega]>0}]

InverseHankelTransform[m_][g_,\[Omega]_,r_] := (-I)^m  Integrate[g  \[Omega] BesselJ[m,r \[Omega]],{\[Omega],0,\[Infinity]},Assumptions->{(r|\[Omega])\[Element]Reals,r>0, \[Omega]>0}]


HankelBasisEigenvalue[n_]=(-1)^n;

HankelBasisEigenvalue[n_,m_]=I^(Abs[m] +2 n);


GaussHankelCoefficient[{nx_,ny_},n_,m_]:=
Module[
{S=(nx+ny+Abs[m])/2},
If[
IntegerQ[S]\[And] nx+ny-Abs[m]>= 2n-2,
((-1)^nx I^ny)/2^(nx+ny+1) Sqrt[Binomial[n+Abs[m],n]/(\[Pi] Abs[m]!)]*
Sum[
((-1)^j nx!)/(j! (nx-2 j)!) ny!/(k! (ny-2 k)!) 2^(j+k) (S-j-k)! *Hypergeometric2F1[-n,S+1-j-k,Abs[m]+1,1] *
Sum[
(-1)^p Binomial[nx-2j,(nx+ny-m)/2-j-k-p]Binomial[ny-2k,p],
{p,0,ny-2k}
],
{k,0,Floor[ny/2]},{j,0,Floor[nx/2]}
],
0
]
]


GaussHankelCoefficient[1/2|0.5,{nx_,ny_},n_,m_]:=
Module[
{S=(nx+ny+Abs[m])/2},
If[
IntegerQ[S]\[And] nx+ny-Abs[m]>= 2n-2,
((-1)^nx I^ny)/2^(nx+ny+1) Sqrt[Binomial[n+Abs[m],n]/(\[Pi] Abs[m]!)]*
Sum[
 ((-1)^j nx!)/(j! (nx-2 j)!) ny!/(k! (ny-2 k)!) 2^(j+k) (S-j-k)! Hypergeometric2F1[-n,S+1-j-k,Abs[m]+1,1]*
Sum[
(-1)^p Binomial[nx-2j,(nx+ny-m)/2-j-k-p]Binomial[ny-2k,p],
{p,0,ny-2k}
],
{k,0,Floor[ny/2]},{j,0,Floor[nx/2]}
],
0
]
]


GaussHankelCoefficient[t_,{nx_,ny_},n_,m_]:=
Module[
{S=(nx+ny+Abs[m])/2},
If[
IntegerQ[S],
((-1)^nx I^ny)/(1+2 t)^(S+1) Sqrt[Binomial[n+Abs[m],n]/(\[Pi] Abs[m]!)] (4t)^((Abs[m]-nx-ny)/2)*
Sum[
 ((-1)^j nx!)/(j! (nx-2 j)!) ny!/(k! (ny-2 k)!) (1+2 t)^(j+k) (S-j-k)! Hypergeometric2F1[-n,S+1-j-k,Abs[m]+1,(4 t)/(1+2 t)]*
Sum[
(-1)^p Binomial[nx-2j,(nx+ny-m)/2-j-k-p]Binomial[ny-2k,p],
{p,0,ny-2k}
],
{k,0,Floor[ny/2]},{j,0,Floor[nx/2]}
],
0
]
]


HalfGaussHankelCoefficient[n_,m_]=
\[Piecewise]{
 {1/(4Sqrt[\[Pi]]) KroneckerDelta[n], m==0},
 {(( (-1)^((Abs[m]-1)/2) Gamma[n+Abs[m]/2])/(4Sqrt[\[Pi]^3 n! (n+Abs[m])!])) , Not[Divisible[m,2]]},
 {0, \!\(\*
    TagBox["True",
     "PiecewiseDefault",
     AutoDelete->False,
     DeletionWarning->True]\)}
};


HalfGaussHankelCoefficient[{ny_},n_,m_]:=
 (I^ny)/2^(ny+1) Sqrt[(n+Abs[m])!/(\[Pi]^3 n!)]Sum[(2^k ny!)/(k! (-2 k+ny)!)
Sum[(-1)^p Binomial[ny-2k,p] \[Pi]/2 Sinc[\[Pi]/2 (ny-m-2k-2p)],{p,0,ny-2k}]
Sum[((l-k+1/2 (ny+Abs[m]))! Pochhammer[-n,l])/(l! (l+Abs[m])!),{l,0,n}],
{k,0,Floor[ny/2]}];


HalfGaussHankelCoefficient[t_,n_,m_]=
\[Piecewise]{
 {(((1-2 t)^n (1+2 t)^(-1-n))/(2 Sqrt[\[Pi]])), m==0&&n!=0},
 {(1/(2 Sqrt[\[Pi]] (1+2 t))), m==0&&n==0},
 {((-1)^((Abs[m]-1)/2) (t/(1+2 t))^(1+Abs[m]/2) Sqrt[(n+Abs[m])!/n!] Hypergeometric2F1[1+Abs[m]/2,-n,1+Abs[m],(4 t)/(1+2 t)])/(\[Pi] t Abs[m] (1/2 (Abs[m]-1))!), !Divisible[m,2]},
 {0, \!\(\*
    TagBox["True",
     "PiecewiseDefault",
     AutoDelete->False,
     DeletionWarning->True]\)}
};


HalfGaussHankelCoefficient[t_,{ny_},n_,m_]:=
 (I^ny)/(4t)^(ny+1) Sqrt[(n+Abs[m])!/(\[Pi]^3 n!)]Sum[((4t)^k ny!)/(k! (ny-2 k)!) ((4t)/(1+2 t))^(1/2 (2-2 k+ny+Abs[m])) Sum[(-1)^p Binomial[ny-2k,p] \[Pi]/2 Sinc[\[Pi]/2 (ny-m-2k-2p)],{p,0,ny-2k}]  Sum[((l-k+1/2 (ny+Abs[m]))! Pochhammer[-n,l])/(l! (l+Abs[m])!) ((4 t)/(1+2 t))^l,{l,0,n}],
{k,0,Floor[ny/2]}];


 HankelBasis[n_,z_] =(E^(-(1/2) Abs[z]^2)  LaguerreL[n,Abs[z]^2])/Sqrt[\[Pi]] ;
HankelBasis[n_,0,z_] =(E^(-(1/2) Abs[z]^2)  LaguerreL[n,Abs[z]^2])/Sqrt[\[Pi]] ;
HankelBasis[n_,m_?Positive,z_] =z^m (E^(-(1/2) Abs[z]^2)  LaguerreL[n,m,Abs[z]^2])/Sqrt[\[Pi] Pochhammer[n+1,m]];
HankelBasis[n_,m_?Negative,z_] =Conjugate[z]^-m (E^(-(1/2) Abs[z]^2)  LaguerreL[n,-m,Abs[z]^2])/Sqrt[\[Pi] Pochhammer[n+1,-m]];
HankelBasis[n_,m_,z_] =Abs[z]^Abs[m] E^(I m Arg[z]) (E^(-(1/2) Abs[z]^2)  LaguerreL[n,Abs[m],Abs[z]^2])/Sqrt[\[Pi] Pochhammer[n+1,Abs[m]]];


HankelBasis3D[n_,0,m_,r_,\[CurlyTheta]_,\[CurlyPhi]] =Sqrt[(2(n!))/(n+1/2)!] E^(-(r^2/2)) LaguerreL[n,1/2,r^2]SphericalHarmonicY[0,m,\[Theta],\[Phi]];

HankelBasis3D[n_,l_,m_,r_,\[CurlyTheta]_,\[CurlyPhi]] =Sqrt[(2(n!))/(n+l+1/2)!] r^l E^(-(r^2/2)) LaguerreL[n,l+1/2,r^2]SphericalHarmonicY[l,m,\[Theta],\[Phi]];


NHankelBasis = Compile[{{n,_Integer},{m,_Integer},{z,_Complex}},
Which[
m===0,E^(-(1/2) Abs[z]^2)  LaguerreL[n,Abs[z]^2]/Sqrt[\[Pi]] ,
m>0\[And]z!=0.0,z^m E^(-(1/2) Abs[z]^2)  LaguerreL[n,m,Abs[z]^2]/Sqrt[Pochhammer[n+1.,m] \[Pi]] ,
m<0\[And]z!=0.0,Conjugate[z]^-m E^(-(1/2) Abs[z]^2)  LaguerreL[n,-m,Abs[z]^2]/Sqrt[Pochhammer[n+1.,-m] \[Pi]] ,
True,0] ,
{{Which[__],_Complex},{LaguerreL[_,_,_],_Real},
{Pochhammer[_,_],_Real},{Abs[z],_Real}}];


NHankelBasis3D[n_,l_,m_]:=NHankelBasis3D[n,l,m]=
Compile[
{{r,_Real},{\[Theta],_Real},{\[Phi],_Real}},
Evaluate[
Which[
l==0&&r==0,(Binomial[n+1/2,1/2] Sqrt[n!/(1/2+n)!])/Sqrt[2 \[Pi]],
True,Sqrt[(2(n!))/(n+l+1/2)!] r^l E^(-(r^2/2)) LaguerreL[n,l+1/2,r^2]SphericalHarmonicY[l,m,\[Theta],\[Phi]]
]
],
{{Which[__],_Complex},{SphericalHarmonicY[_,_,_,_],_Complex},{LaguerreL[_,_,_],_Real}}
];


HankelBasisNList[nmax_,z_]:=HankelBasisNList[nmax,0,z];

HankelBasisNList[nmax_,0,z_] :=With[{r = Abs[z]^2}, Rest[Fold[Append[#,{1- #2,2 #2-1-r}.Take[#1,-2]/#2]&, {0,1/Sqrt[\[Pi] E^z2]},Range[nmax]]]];

HankelBasisNList[nmax_,m_?Positive,z_]:=
With[{r = Abs[z]^2},z^m/Sqrt[\[Pi] E^r]*
Rest[Fold[Append[#,{1- #2-m,2 #2+m-1-r}.Take[#1,-2]/#2]&, {0,1},Range[nmax]]]/
Sqrt[FoldList[(#1 (m/#2+1))&,Factorial[m],Range[nmax]]]
];

HankelBasisNList[nmax_,m_?Negative,z_]:=
With[{r = Abs[z]^2},Conjugate[z]^-m/Sqrt[\[Pi] E^r]*
Rest[Fold[Append[#,{1- #2+m,2 #2-m-1-r}.Take[#1,-2]/#2]&, {0,1},Range[nmax]]]/
Sqrt[FoldList[(#1 (-m/#2+1))&,Factorial[-m],Range[nmax]]]
];


NHankelBasisNList = 
Compile[
{{nmax,_Integer},{m,_Integer},{z,_Complex}},
Module[{r = Abs[z]^2},
If[
r>708.,
Table[0.,{nmax+1}],
Which[m===0,
Rest[Fold[Append[#,((2 #2-1.-r)#1[[-1]] - (#2-1.)#1[[-2]])/#2]&, {0,E^(-r/2)},Range[nmax]]]/Sqrt[\[Pi]],
m>0\[And]z!=0.0,z^m*Rest[Fold[Append[#,((2 #2+m-1.-r)#1[[-1]] + (1.-#2-m)#1[[-2]])/#2]&, {0,E^(-r/2)},Range[nmax]]]/
Sqrt[\[Pi] FoldList[(#1 (m/#2+1.))&,Factorial[m],Range[nmax]]],
m<0\[And]z!=0.0,
Conjugate[z]^-m* Rest[Fold[Append[#,((2 #2-m-1.-r)#1[[-1]] + (1.-#2+m)#1[[-2]])/#2]&, {0,E^(-r/2)},Range[nmax]]]/
Sqrt[\[Pi] FoldList[(#1 (-m/#2+1.))&,Factorial[-m],Range[nmax]]],
True,Table[0.,{nmax+1}]
]
]
],
{{Which[__],_Complex,1},{Append[_,_],_Real,1},{Factorial[_],_Real},{Range[_],_Real,1},{Fold[_,_,_],_Real,1},{FoldList[_,_,_],_Real,1},{r,_Real}}
];


HankelBasisNMList[nmax_,mmax_,z_]:= 
With[
{r = Abs[z]^2},
NestList[(z*#)&,1/Sqrt[\[Pi] E^r],mmax] *
NestList[
Accumulate,
Rest[Fold[Append[#,{1- #2,2 #2-1-r}.Take[#1,-2]/#2]&, {0,1},Range[nmax]]],
mmax
]/Sqrt[Transpose[Partition[FoldList[Times,1,Range[nmax+mmax]],mmax+1,1]/FoldList[Times,1,Range[nmax]]]]
];


NHankelBasisNMList =
Compile[{{nmax,_Integer},{mmax,_Integer},{z,_Complex}},
With[
{r = Abs[z]^2},
If[
r>708.,
Table[0.,{mmax+1},{nmax+1}],
NestList[(z*#)&,1,mmax] *
FoldList[
With[{m=#2},Fold[Append[#1,Last[#1] +  #2]&,{First[#]},Rest[#]]]&,
Rest[Fold[Append[#,((2 #2-1-r)Last[#1] -(#2-1) #1[[-2]])/#2]&, {0,E^(-r/2)},Range[nmax]]],
Range[mmax]
]/\[Sqrt](\[Pi] Transpose[Partition[FoldList[Times,1.,Range[nmax+mmax]],mmax+1,1]/FoldList[Times,1.,Range[nmax]]])
]
],
{{r,_Real},{If[_,_,_],_Complex,2}}
];


HankelBasisRadius[n_,m_:0,t_:DefaultScaleParameter] =Sqrt[4t (2n+m+1)];


PolarFourierScale[dims:{_Integer,_Integer}]:=
Module[
{r = (Min[dims]-1)/2},
r^2/(4( Sqrt[2] r-1))
];


PolarFourierNMax[t:(_?Positive|Automatic):Automatic,dims:{_Integer,_Integer}]:=
Module[
{r = (Min[dims]-1)/2},
Round[If[t===Automatic,r/Sqrt[2]-1,(r^2-4 t)/(8 t)]]
];


PolarFourier::scalefail = "Scale `1` too small to support Hankel basis function for n up to `2`."
PolarFourier::scalechoice = "Choosing scale `1` for the Hankel basis."
Off[PolarFourier::scalechoice];


PolarFourier[img_List,nmax:(_Integer?NonNegative|Automatic):Automatic,mmax:(_Integer?NonNegative|Automatic):Automatic] :=PolarFourier[DefaultScaleParameter,\[Pi]/2][img,nmax,mmax];

PolarFourier[t_:DefaultScaleParameter,\[Alpha]_:\[Pi]/2][img_List,nmax:(_Integer?NonNegative|Automatic):Automatic,mmax:(_Integer?NonNegative|Automatic):Automatic] :=
Module[
{xmax,ymax, filter,r = (Min[Dimensions[img]]-1)/2.,tt,nn,mm},
If[nmax===Automatic,nn =PolarFourierNMax[t,Dimensions[img]],nn=nmax];
If[mmax===Automatic,mm =Round[\[Pi]/Sqrt[2] nn],mm=mmax];
If[t===Automatic,tt = N[PolarFourierScale[Dimensions[img]]];Message[PolarFourier::scalechoice,tt],tt=N[t]];
{xmax,ymax} = (Dimensions[img]-1)/(2Sqrt[2tt]);
If[(nn+1)^2/(4 nn+2)-1/8> tt, Message[PolarFourier::scalefail,tt,nn]];
filter=Table[NHankelBasisNMList[nn,mm,x+I y],{x,-xmax,xmax,1/Sqrt[2tt]},{y,-ymax,ymax,1/Sqrt[2tt]}];
If[\[Alpha]!=0,Table[E^(I \[Alpha] (2 n+Abs[m])),{n,0,nn},{m,-mm,mm}],1] * Transpose[Chop[If[
FreeQ[img,Complex],
Join[Conjugate[Reverse[Rest[#]]],#]&[Flatten[img].Flatten[filter,1]],
Flatten[img].Map[Join[Conjugate[Reverse[Rest[#]]],#]&,Flatten[filter,1],{1}]
]]]/Sqrt[2tt]
];


InversePolarFourier::scalefail = "Scale `1` too small to support Hankel basis function for n up to `2`."


InversePolarFourier[coeff_List,dims:{Automatic,Automatic}] :=InversePolarFourier[DefaultScaleParameter,\[Pi]/2][coeff,dims];

InversePolarFourier[t_:DefaultScaleParameter,\[Alpha]_:-\[Pi]/2][coeff_List,
dims:{_Integer?Positive|Automatic,_Integer?Positive|Automatic}:{Automatic,Automatic}] :=
Module[
{conjfilter,fourierCoeff,xn,yn,nmax,mmax,xmax, ymax,r,tt},
{xn,yn}=dims;r = (Min[{xn,yn}]-1)/2;
{nmax,mmax} = Dimensions[coeff]-1;mmax /=2;
If[Not[FreeQ[r,Automatic]],r = Sqrt[2](nmax+1)];
If[t===Automatic,tt = N[r^2/(4( Sqrt[2] r-1))],tt=N[t]];
If[xn===Automatic,xmax=Round[2r]/(2Sqrt[2tt]),xmax=(xn-1)/(2Sqrt[2tt])];
If[yn===Automatic,ymax=Round[2r]/(2Sqrt[2tt]),ymax=(yn-1)/(2Sqrt[2tt])];
If[(nmax+1)^2/(4 nmax+2)-1/8> tt, Message[InversePolarFourier::scalefail,tt,nmax]];
conjfilter=Table[NHankelBasisNMList[nmax,mmax,x-I y],{x,-xmax,xmax,1/Sqrt[2tt]},{y,-ymax,ymax,1/Sqrt[2tt]}];
fourierCoeff=If[\[Alpha]!=0,Table[E^(I \[Alpha] (2 n+Abs[m])),{m,-mmax,mmax},{n,0,nmax}],1]*Transpose[coeff];
Chop[If[
Conjugate[Reverse[Take[fourierCoeff,mmax]]]===Take[fourierCoeff,-mmax];False,
Re[Map[Flatten,conjfilter,{2}].Flatten[Prepend[Table[2,{mmax}],1] Take[fourierCoeff,-mmax-1]]],
 Map[Flatten[Join[Conjugate[Reverse[Rest[#]]],#]]&,conjfilter,{2}].Flatten[fourierCoeff]
]]/Sqrt[2tt]
];


RotatePolarFourierPhase[coeff_List,\[Alpha]_:\[Pi]/2] := Module[{nmax ,mmax},
{mmax,nmax} = Dimensions[coeff]-1;mmax /=2;
Table[E^(I (2 n+Abs[m])\[Alpha]),{m,-mmax,mmax},{n,0,nmax}] * coeff
];


CenteredFourier[img_?(ArrayQ[#,_,NumericQ]&)]:= 
Module[
{dims=Dimensions[img], shifts = Floor[Dimensions[img]/2]},
 RotateRight[Array[E^((-2\[Pi] I  shifts/dims).({##}-1))&,dims] Fourier[img],shifts]
];


InverseCenteredFourier[img_?(ArrayQ[#,_,NumericQ]&)] := 
Module[
{dims=Dimensions[img],shifts = Floor[Dimensions[img]/2]},
InverseFourier[Array[E^(2\[Pi] I (shifts/dims).({##}-1))&,dims] RotateLeft[img,shifts]]
];


End[]

SetAttributes[
{HankelTransform,
InverseHankelTransform,
GaussHankelCoefficient,
HalfGaussHankelCoefficient,
HankelBasis,
NHankelBasis,
HankelBasisEigenvalue,
HankelBasisNList,
NHankelBasisNList,
HankelBasisNMList,
NHankelBasisNMList,
HankelBasisRadius,
PolarFourierScale,
PolarFourierNMax,
PolarFourier,
InversePolarFourier,
RotatePolarFourierPhase,
CenteredFourier,
InverseCenteredFourier},
{Protected}
];

EndPackage[]
