(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`HermiteFilter`"] = {2005,5,19,10,0,0};

Protect[TimeStamp];


(*:Name: MathVisionTools`HermiteFilter` *)

(*:Author: Markus van Almsick*)

(*:Email address: M.v.Almsick@tue.nl*)

(*:Context: MathVisionTools`HermiteFilter`*)

(*:Package Version: 1.0 *)

(*:Mathematica Version: 5.1 *)

(*:Copyright: Copyright 2005, Technische Universiteit Eindhoven*)

(*:Title: Hermite Filter *)

(*:Summary: This package implements the filters of orhtogonal Hermite polynomials *)

(*:Keywords: Hermite polynomials, orhtogonal basis *)

(*:Requirements: None *)

(*:Source: none *)

(*:History: Version 1.0 by Markus van Almsick, May 2005 *)

(*:Limitations: *)

(*:Discussion: *)

(*:To do: *)


If[
$VersionNumber>= 6,
NotationPackageString="Notation`";
Notation`AutoLoadNotationPalette = False,
NotationPackageString="Utilities`Notation`";
Utilities`Notation`AutoLoadNotationPalette = False
];

BeginPackage[
"MathVisionTools`HermiteFilter`",
"MathVisionTools`Common`MathVisionToolsCommon`",
"MathVisionTools`ImageFrame`",
NotationPackageString
]

Unprotect[
NHermiteKernel,
HermiteKernel,
HermiteKernelRange,
HermiteFilter,
HermiteFilterAt,
Method,
KernelRange,
ImageBoundary,
Convolve,
Fourier,
Cyclic,
Truncate,
Reflective,
Constant
]


DefaultScaleParameter::usage="The default linear scale parameter t = \!\(\*FractionBox[SuperscriptBox[\"\[Sigma]\", \"2\"], \"2\"]\). Thus the width or standard deviation of the Gaussian kernel is 1."

HermiteKernel::usage="HermiteKernel[t,n,x] renders the Hermite kernel of n-th order numerically and symbolically. Note that t is half the variance, which is the square of the Gaussian kernel width \[Sigma]."

NHermiteKernel::usage="NGaussianKernel[t,n,x] renders the Hermite kernel of n-th order numerically for Real t, Integer n, and Real x with compiled code. Note that t is half the variance, which is the square of the Gaussian kernel width \[Sigma]."

HermiteFilter::usage="HermiteFilter[{\!\(\*SubscriptBox[\"t\", \"x\"]\),\!\(\*SubscriptBox[\"n\", \"x\"]\)},{\!\(\*SubscriptBox[\"t\", \"y\"]\),\!\(\*SubscriptBox[\"n\", \"y\"]\)},...][img] runs the (\!\(\*SubscriptBox[\"n\", \"x\"]\),\!\(\*SubscriptBox[\"n\", \"y\"]\)\!\(\*SuperscriptBox[\")\", \"th\"]\) order Hermite filter on image img. The Gaussian kernel variance is 2\!\(\*SubscriptBox[\"t\", \"x\"]\) in x- and 2\!\(\*SubscriptBox[\"t\", \"y\"]\) in y-direction."

HermiteFilterAt::usage="HermiteFilterAt[{x,\!\(\*SubscriptBox[\"t\", \"x\"]\),\!\(\*SubscriptBox[\"n\", \"x\"]\)},{y,\!\(\*SubscriptBox[\"t\", \"y\"]\),\!\(\*SubscriptBox[\"n\", \"y\"]\)},...][img] run the (\!\(\*SubscriptBox[\"n\", \"x\"]\),\!\(\*SubscriptBox[\"n\", \"y\"]\)\!\(\*SuperscriptBox[\")\", \"th\"]\) order Hermite filter on image img at the specified location (x,y) in scale space. The Gaussian kernel variance is 2\!\(\*SubscriptBox[\"t\", \"x\"]\) in x- and 2\!\(\*SubscriptBox[\"t\", \"y\"]\) in y-direction. To determine the Heritian filter response at more than one location enter HermiteFilterAt[{{x1,\!\(\*SubscriptBox[\"t\", \"x1\"]\),\!\(\*SubscriptBox[\"n\", \"x1\"]\)},{y1,\!\(\*SubscriptBox[\"t\", \"y1\"]\),\!\(\*SubscriptBox[\"n\", \"y1\"]\)},...},{{x2,\!\(\*SubscriptBox[\"t\", \"x2\"]\),\!\(\*SubscriptBox[\"n\", \"x2\"]\)},{y2,\!\(\*SubscriptBox[\"t\", \"y2\"]\),\!\(\*SubscriptBox[\"n\", \"y2\"]\)},...},...][img]."

KernelRange::usage="KernelRange is an option of HermiteFilter. It determines the default range of the kernel used in the convolution."

(* ImageBoundary-Option *)
If[
Head[ImageBoundary::usage]===MessageName,
ImageBoundary::usage="ImageBoundary is an option of HermiteFilter working with the Convolve method. ImageBoundary determines the handling of an image frame in a convolution.",
If[
Not[StringMatchQ[ImageBoundary::usage,"*HermiteFilter*"]],
ImageBoundary::usage=ImageBoundary::usage<>"\nImageBoundary is also an option HermiteFilter working with the Convolve method. ImageBoundary determines the handling of an image frame in a convolution."
]
]

(* Convolve-Option *)
If[
Head[Convolve::usage]===MessageName,
Convolve::usage="Is a value for the HermiteFilter option Method. It calls upon the ListConvolve command to perform the convolution with the Hermite filter.",
If[
Not[StringMatchQ[Convolve::usage,"*HermiteFilter*"]],
Convolve::usage=Convolve::usage<>"\nIt is also a value for the HermiteFilter option Method. It calls upon the ListConvolve command to perform the convolution with the Hermite filter."
]
]

(* Fourier-Option *)
If[
Not[StringMatchQ[Fourier::usage,"*HermiteFilter*"]],Fourier::usage=Fourier::usage<>"\nFourier is also an option value for the HermiteFilter Method. The convolution of the Hermite fitler is performed via multiplication in the Fourier domain."
]

(* Cyclic-Option *)
If[
Head[Cyclic::usage]===MessageName,
Cyclic::usage="Is a value for the HermiteFilter option ImageBoundary. It calls upon the ListConvolve command to perform a cyclic convolution to maintain the image size.",
If[
Not[StringMatchQ[Cyclic::usage,"*HermiteFilter*"]],
Cyclic::usage=Cyclic::usage<>"\nIt is also a value for the HermiteFilter option ImageBoundary. It calls upon the ListConvolve command to perform a cyclic convolution to maintain the image size."
]
]

(* Truncate-Option *)
If[
Head[Truncate::usage]===MessageName,
Truncate::usage="Is a value for the HermiteFilter option ImageBoundary. It calls upon the ListConvolve command to truncate the incomplete convolution of the Hermite filter at the image boundary.",
If[
Not[StringMatchQ[Truncate::usage,"*HermiteFilter*"]],
Truncate::usage=Truncate::usage<>"\nIt is also a value for the HermiteFilter option ImageBoundary. It calls upon the ListConvolve command to truncate the incomplete convolution of the Hermite filter at the image boundary."
]
]

(* Reflective-Option *)
If[
Head[Reflective::usage]===MessageName,
Reflective::usage="Is a value for the HermiteFilter option ImageBoundary. It calls upon the ListConvolve command to ap-/prepend the reflected image on each image boundary before performing the convolution of the Hermite filter.",
If[
Not[StringMatchQ[Reflective::usage,"*HermiteFilter*"]],
Reflective::usage=Reflective::usage<>"\nIt is also a value for the HermiteFilter option ImageBoundary. It calls upon the ListConvolve command to ap-/prepend the reflected image on each image boundary before performing the convolution of the Hermite filter."
]
]

(* Constant-Option *)
If[
Not[StringMatchQ[Constant::usage,"*HermiteFilter*"]],
Constant::usage=Constant::usage<>"\nIt is also a value for the HermiteFilter option ImageBoundary. It calls upon the ListConvolve to extend the value of each boundary pixel to infinity."
]

Options[GaussianDerivative]={KernelRange->Automatic,Method->Convolve,ImageBoundary->Cyclic, WorkingPrecision-> Log[10,2^16.]};

Options[GaussianDerivativeAt]={KernelRange->Automatic,ImageBoundary->Cyclic, WorkingPrecision-> Log[10,2^16.]};


Begin["`Private`"]


(* Hermite Filter Kernel *)

\[Tau] = 4; (* global factor for the scaling parameter t, default is 4 (or 1) *)

DefaultScaleParameter=2/\[Tau];


(* Numeric Implementation *)

NHermiteKernel=Compile[{{t,_Real},{x,_Real}},Exp[-x^2/(\[Tau] t)]/Sqrt[Pi (\[Tau] t)]];

HermiteKernel[x_?NumberQ]:=NGaussianKernel[DefaultScaleParameter,x]

HermiteKernel[0|0.,x_?NumberQ]=DiracDelta[x];

HermiteKernel[t_?NumberQ,x_?NumberQ]:=NHermiteKernel[t,x]


(* Symbolic Implementation *)

GaussianKernel[0,{x__}]=DiracDelta[x];
GaussianKernel[0,x_]=DiracDelta[x];

GaussianKernel[t_:DefaultScaleParameter,x_]=Exp[-x^2/(\[Tau] t)]/Sqrt[Pi (\[Tau] t)];

GaussianKernel/:Derivative[0,n_][GaussianKernel]:=GaussianDKernel[n,#1,#2]&


(* Multidimensional Implementation *)

GaussianKernel[x_List]:=Apply[Times,Map[GaussianKernel,x]]

GaussianKernel[t_List,x_List]:=Inner[GaussianKernel,t,x,Times]/;Dimensions[t]==Dimensions[x]

GaussianKernel[t_,x_List]:=Apply[Times,Map[GaussianKernel[t,#]&,x]]


(* GaussianKernel Input Notation *)

MakeExpression[RowBox[{lhs___,"G","[",x__,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianKernel","[",RowBox[{"{",Utilities`Notation`Private`stripSpuriousRowBox[x],"}"}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianKernel[{x__}],StandardForm]:=RowBox[{"G","[",Utilities`Notation`Private`makeHeldRowBoxOfBoxes[{x},StandardForm,None],"]"}]


(* GaussianKernel Input Notation *)

MakeExpression[RowBox[{lhs___,"G","[",x_,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianKernel","[",x,"]"}],rhs}],StandardForm]

MakeBoxes[GaussianKernel[x_],StandardForm]:=RowBox[{"G","[",MakeBoxes[x,StandardForm],"]"}]


MakeExpression[RowBox[{lhs___,SubscriptBox["G",t_],"[",x_RowBox,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianKernel","[",RowBox[{t,",",RowBox[{"{",Utilities`Notation`Private`stripSpuriousRowBox[x],"}"}]}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianKernel[t_,{x__}],StandardForm]:=RowBox[{SubscriptBox["G",MakeBoxes[t,StandardForm]],"[",Utilities`Notation`Private`makeHeldRowBoxOfBoxes[{x},StandardForm,None],"]"}]


MakeExpression[RowBox[{lhs___,SubscriptBox["G",t_],"[",x_,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianKernel","[",RowBox[{t,",",x}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianKernel[t_,x_],StandardForm]:=RowBox[{SubscriptBox["G",MakeBoxes[t,StandardForm]],"[",MakeBoxes[x,StandardForm],"]"}]


MakeExpression[RowBox[{lhs___,SubscriptBox["G",t__],"[",x__,"]",rhs___}],StandardForm]:=MakeExpression[RowBox[{lhs,RowBox[{"GaussianKernel","[",RowBox[{RowBox[{"{",Utilities`Notation`Private`stripSpuriousRowBox[t],"}"}],",",RowBox[{"{",Utilities`Notation`Private`stripSpuriousRowBox[x],"}"}]}],"]"}],rhs}],StandardForm]

MakeBoxes[GaussianKernel[{t__},{x__}],StandardForm]:=RowBox[{SubscriptBox["G",Utilities`Notation`Private`makeHeldRowBoxOfBoxes[{t},StandardForm,None]],"[",Utilities`Notation`Private`makeHeldRowBoxOfBoxes[{x},StandardForm,None],"]"}]


GaussianKernelRange[4]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(2.3243180666111423+2.3243180666111423*n-0.9765965923097873*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[8]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(2.2224289812448683+2.2224289812448683*n+1.6011247864558187*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[12]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(2.114376372864952+2.114376372864952*n+4.0288081480154725*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[16]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(1.998216846965191+1.998216846965191*n+6.392974885898669*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[20]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(1.874991609534614+1.874991609534614*n+8.723038909063387*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[24]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(1.7458525263268259+1.7458525263268259*n+11.032362584249514*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[28]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(1.6117501067548536+1.6117501067548536*n+13.328052128995822*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[32]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(1.473435732709178+1.473435732709178*n+15.61428837974991*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[36]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(1.3315035827972916+1.3315035827972916*n+17.893710961739284*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[40]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(1.1864219273587364+1.1864219273587364*n+20.168092531572174*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[44]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(1.0385758971718777+1.0385758971718777*n+22.438510420428443*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[48]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(0.889875356726046+0.889875356726046*n+24.692137806054756*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianKernelRange[52]=Compile[{{t,_Real},{n,_Integer}},{-#,#}&[Ceiling[Sqrt[(0.7367547195975274+0.7367547195975274*n+26.829859007281208*(1+n)^(1/3))*t*\[Tau]]]]]


GaussianDerivative::widthfail="Insufficient kernel width for `1`-order differentiation.";GaussianDerivative::nowidth="No kernel width specified.";


MinimalScale[4]=Compile[{{n,_Integer}},-0.07225602550763996`+0.1934994115318552` (1+n)^(1/3)+0.05458391922630867` (1+n)];


MinimalScale[8]=Compile[{{n,_Integer}},0.04813185222160912` +0.31489231691130615` (1+n)^(1/3)+0.05841271321345174` (1+n)];


MinimalScale[12]=Compile[{{n,_Integer}},0.23138720823850856` +0.3870206014942941` (1+n)^(1/3)+0.06201023916198861` (1+n)];


MinimalScale[16]=Compile[{{n,_Integer}},0.4427462125429202` +0.43729757816428666` (1+n)^(1/3)+0.06533784418156777` (1+n)];


MinimalScale[20]=Compile[{{n,_Integer}},0.6700763376887527` +0.47527046426284586` (1+n)^(1/3)+0.06841700241661773` (1+n)];


MinimalScale[24]=Compile[{{n,_Integer}},0.9076871517131073` +0.5053978829196788` (1+n)^(1/3)+0.07127851131749753` (1+n)];


MinimalScale[28]=Compile[{{n,_Integer}},1.1524506471180527` +0.5301181105158642` (1+n)^(1/3)+0.07395088137222257` (1+n)];


MinimalScale[32]=Compile[{{n,_Integer}},1.4024642991094307` +0.5509059382924002` (1+n)^(1/3)+0.0764583548853869` (1+n)];


MinimalScale[36]=Compile[{{n,_Integer}},1.656487038699375` +0.568717809132497` (1+n)^(1/3)+0.07882117438223667` (1+n)];


MinimalScale[40]=Compile[{{n,_Integer}},1.9136820125603298` +0.5841887192822285` (1+n)^(1/3)+0.08105828273659765` (1+n)];


MinimalScale[44]=Compile[{{n,_Integer}},2.1736973881589376` +0.5976246623874925` (1+n)^(1/3)+0.0831900868437959` (1+n)];


MinimalScale[48]=Compile[{{n,_Integer}},2.442533291990515` +0.6028349507086076` (1+n)^(1/3)+0.08585656496350498` (1+n)];


MinimalScale[52]=Compile[{{n,_Integer}},2.627515797245066` +0.6649239314410514` (1+n)^(1/3)+0.08356758359896967` (1+n)];


GaussianDerivative::scalefail="Scale too small for `1`-order differentiation.";


GaussianDerivative[{t_,0}][UnitStep]:=1/2 (1+Erf[#/(2 Sqrt[t])])&


GaussianDerivative[tn:{0,0}..][img_Symbol]=img;

GaussianDerivative[tn:{_,_Integer?Positive}..][img_Symbol]:=0/; MemberQ[Attributes[img],Constant]

GaussianDerivative[tn1:{_,_Integer:0}.., opts1___Rule][GaussianDerivative[tn2:{_,_Integer:0}.., opts2___Rule][img_Symbol]]:=GaussianDerivative[Apply[Sequence,{tn1}+{tn2}], Apply[Sequence,Union[{opts1},{opts2}]]][img]/;Length[{tn1}]===Length[{tn2}]

GaussianDerivative[tn:{_,_Integer:0}.., opts___Rule][img_Symbol]:=
Module[
{result,ts,ns,
xs=Table[Unique["x"],{Length[{tn}]}],
\[Omega]s=Table[Unique["\[Omega]"],{Length[{tn}]}],
ys= Table[Unique["y"],{Length[{tn}]}]},
(Evaluate[result /. Thread[ys -> Table[Slot[i],{i,Length[ys]}]]]&) /; 
If[
FreeQ[result= FourierTransform[Apply[img,xs],xs,\[Omega]s],FourierTransform],
{ts,ns}=Transpose[{tn}];
FreeQ[result=  InverseFourierTransform[Apply[Times,(-I  \[Omega]s)^ns] Exp[-ts.( \[Omega]s^2)]  result,\[Omega]s,ys],InverseFourierTransform],
False
]
]


GaussianDerivative::nomethod = "Derivation Method `1` not implemented!";

GaussianDerivative[tn:{_?NumericQ,_Integer:0}.., opts___Rule][img_List]:=
Switch[
Method /. {opts} /. Options[GaussianDerivative],
Convolve, ListConvolveGaussianDerivative[tn,opts][img],
Fourier,FourierGaussianDerivative[Apply[Sequence,Reverse[{tn}]],opts][img],
_,Message[GaussianDerivative::nomethod,Method];Throw[$Failed]
]/;TensorRank[img]>=Length[{tn}]


GaussianDerivative::noboundopt="Invalid ImageBoundary option.";

GaussianKernelInterval[{0,0},_,rangeopt_:Automatic] ={-1,1};

GaussianKernelInterval[{t_,n_},bits_,rangeopt_:Automatic] :=
(If[t<=0,Message[GaussianDerivative::scalefail,n]; Throw[$Failed]];
If[t<MinimalScale[bits][n],Message[GaussianDerivative::scalefail,n]];
Switch[
rangeopt,
Automatic,GaussianKernelRange[bits][t,n],
Infinity,{-1,1}*Floor[Sqrt[-\[Tau] t*Log[$MinMachineNumber]]],
{-Infinity,Infinity},{-1,1}*Floor[Sqrt[-\[Tau] t*Log[$MinMachineNumber]]],
{_Integer,Infinity},{rangeopt[[1]], Floor[Sqrt[-\[Tau] t*Log[$MinMachineNumber]]]},
{-Infinity,_Integer},{-Floor[Sqrt[-\[Tau] t*Log[$MinMachineNumber]]],rangeopt[[2]]},
{_Integer,_Integer},rangeopt,
_,Message[GaussianDerivative::nowidth]; Throw[$Failed]
]);

ListConvolveGaussianDerivative1D[{{0,0},{kmin_,kmax_},boundaryopt_},img_, depth_,opts___]=img;

ListConvolveGaussianDerivative1D[{{t_,n_},{kmin_,kmax_},boundaryopt_},img_, depth_,opts___]:=
Module[
{kern=Nest[List,Table[NGaussianDKernel[n][t,x],{x,kmin,kmax}],depth-1]},
Switch[
boundaryopt,

Cyclic,
ListConvolve[kern,img,{PadLeft[{-kmin+1},depth,1],PadLeft[{-kmax-1},depth,1]}] ,

Truncate,
Map[AttachFrame1D[#,{-kmin,kmax}]&,
ListConvolve[kern,img,{PadLeft[{-1},depth,1],PadLeft[{1},depth,1]}],
{depth-1} ],

_?NumericQ,
ListConvolve[kern,img,{PadLeft[{-kmin+1},depth,1],PadLeft[{-kmax-1},depth,1]},N[boundaryopt]] ,

Constant,
ListConvolve[kern,ImageFrame1D[img,{{-kmin,kmax},depth, Constant}]] ,

Reflective,
ListConvolve[kern,ImageFrame1D[img,{{-kmin,kmax},depth, Reflective}]],

_,Message[GaussianDerivative::nobound]; Throw[$Failed]
]
]

ListConvolveGaussianDerivative[tn__List,opts___Rule][img_List]:=
Catch[Module[
{
dim=TensorRank[img],nn=Length[{tn}],dimrot,
bounds = (ImageBoundary /. {opts} /. Options[GaussianDerivative]),
kernrange = (KernelRange /. {opts} /. Options[GaussianDerivative]),
kernpbits = Min[52,Max[4,4*Ceiling[
Log[2,10^(WorkingPrecision /. {opts} /. Options[GaussianDerivative])
]/4]]]
},
If[
dim === nn,
dimrot=RotateLeft[Range[nn]];
Fold[
ListConvolveGaussianDerivative1D[#2,Transpose[#1,dimrot],dim,opts]&,
img,
Map[{#,GaussianKernelInterval[#,kernpbits,kernrange],bounds}&,RotateLeft[{tn}]]],
dimrot=Join[Range[1,dim-nn],RotateLeft[Range[dim-nn+1,dim]]];
Transpose[
Fold[
ListConvolveGaussianDerivative1D[#2,Transpose[#1,dimrot],dim,opts]&,
Transpose[img,Join[Range[nn+1,dim],Range[nn]]],
Map[{#,GaussianKernelInterval[#,kernpbits,kernrange],bounds}&,RotateLeft[{tn}]]
],
Join[Range[dim-nn+1,dim],Range[1,dim-nn]]
]
]
]]


NFourierGaussianDKernelList = 
Compile[
{{t,_Real},{n,_Integer},{r,_Integer}},
Join[{If[n===0,1,0]},#,(-1)^n  Reverse[If[EvenQ[r],Drop[#,-1],#]]]&[With[{stepsize =2.Pi/r},
Table[(omega)^n * Exp[-omega^2 \[Tau] t/4],{omega,stepsize, Pi,stepsize}]
]
],
{{omega,_Real},{stepsize,_Real}}
];

FourierGaussianDerivative[tn__List, opts___Rule][img_List]:=
Module[
{dim=TensorRank[img],
nn=Length[{tn}],
kern,norm,res},
kern = 
Apply[
FastOuterTimes,
Apply[
NFourierGaussianDKernelList,
Transpose[Append[Transpose[{tn}],res=Take[Dimensions[img],nn]]],
{1}
]
];
If[Not[Apply[And,Positive[Transpose[{tn}][[1]]]]] && (Max[kern]>10.^($MachinePrecision-3)),kern=Map[Min[#,10.^($MachinePrecision-3)]&,kern,{-1}]];
norm = Apply[Times,(-I)^(Transpose[{tn}][[2]])] ;
If[
dim === nn,
Chop[Re[InverseFourier[norm * kern * Fourier[img]]]],
Transpose[
Map[
Chop[Re[InverseFourier[norm* kern * Fourier[#]]]]&,
Transpose[img,Join[Range[nn+1,dim],Range[nn]]],
{dim-nn}
],
Join[Range[dim-nn+1,dim],Range[1,dim-nn]]
]
]
]


(* GaussianDerivative Input Notation *)

MakeExpression[SubscriptBox[f_,SubscriptBox["G",t_]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{"{",RowBox[{t,",","0"}],"}"}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t_,0}][f_],StandardForm]:=SubscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",MakeBoxes[t,StandardForm]]]


MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",t_],"\[Prime]"],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{"{",RowBox[{t,",","1"}],"}"}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t_,1}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",MakeBoxes[t,StandardForm]],"\[Prime]",MultilineFunction->None]


MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",t_],"\[Prime]\[Prime]"],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{"{",RowBox[{t,",","2"}],"}"}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t_,2}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",MakeBoxes[t,StandardForm]],"\[Prime]\[Prime]",MultilineFunction->None]


MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",t_],RowBox[{"(",n_,")"}]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{"{",RowBox[{t,",",n}],"}"}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t_,n_}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",MakeBoxes[t,StandardForm]],RowBox[{"(",MakeBoxes[n,StandardForm],")"}]]


MakeExpression[SubscriptBox[f_,SubscriptBox["G",RowBox[{t1_,",",t2_}]]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t1,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t2,",","0"}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t1_,0},{t2_,0}][f_],StandardForm]:=SubscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",RowBox[{MakeBoxes[t1,StandardForm],",",MakeBoxes[t2,StandardForm]}]]]


MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",RowBox[{t1_,",",t2_}]],RowBox[{"(",RowBox[{n1_,",",n2_}],")"}]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t1,",",n1}],"}"}],",",RowBox[{"{",RowBox[{t2,",",n2}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t1_,n1_},{t2_,n2_}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",RowBox[{MakeBoxes[t1,StandardForm],",",MakeBoxes[t2,StandardForm]}]],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm]}],")"}]]


MakeExpression[SubscriptBox[f_,SubscriptBox["G",t_]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t,",","0"}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t_,0},{t_,0}][f_],StandardForm]:=SubscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",MakeBoxes[t,StandardForm]]]


MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",t_],RowBox[{"(",RowBox[{n1_,",",n2_}],")"}]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t,",",n1}],"}"}],",",RowBox[{"{",RowBox[{t,",",n2}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t_,n1_},{t_,n2_}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",MakeBoxes[t,StandardForm]],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm]}],")"}]]


MakeExpression[SubscriptBox[f_,SubscriptBox["G",RowBox[{t1_,",",t2_,",",t3_}]]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t1,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t2,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t3,",","0"}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t1_,0},{t2_,0},{t3_,0}][f_],StandardForm]:=SubscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",RowBox[{MakeBoxes[t1,StandardForm],",",MakeBoxes[t2,StandardForm],",",MakeBoxes[t3,StandardForm]}]]]


MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",RowBox[{t1_,",",t2_,",",t3_}]],RowBox[{"(",RowBox[{n1_,",",n2_,",",n3_}],")"}]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t1,",",n1}],"}"}],",",RowBox[{"{",RowBox[{t2,",",n2}],"}"}],",",RowBox[{"{",RowBox[{t3,",",n3}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t1_,n1_},{t2_,n2_},{t3_,n3_}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",RowBox[{MakeBoxes[t1,StandardForm],",",MakeBoxes[t2,StandardForm],",",MakeBoxes[t3,StandardForm]}]],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm],",",MakeBoxes[n3,StandardForm]}],")"}]]


MakeExpression[SubscriptBox[f_,SubscriptBox["G",t_]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t,",","0"}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t_,0},{t_,0},{t_,0}][f_],StandardForm]:=SubscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",MakeBoxes[t,StandardForm]]]


MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",t_],RowBox[{"(",RowBox[{n1_,",",n2_,",",n3_}],")"}]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t,",",n1}],"}"}],",",RowBox[{"{",RowBox[{t,",",n2}],"}"}],",",RowBox[{"{",RowBox[{t,",",n3}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t_,n1_},{t_,n2_},{t_,n3_}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",MakeBoxes[t,StandardForm]],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm],",",MakeBoxes[n3,StandardForm]}],")"}]]


 MakeExpression[SubscriptBox[f_,SubscriptBox["G",RowBox[{t1_,",",t2_,",",t3_,",",t4_}]]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t1,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t2,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t3,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t4,",","0"}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t1_,0},{t2_,0},{t3_,0},{t4_,0}][f_],StandardForm]:=SubscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",RowBox[{MakeBoxes[t1,StandardForm],",",MakeBoxes[t2,StandardForm],",",MakeBoxes[t3,StandardForm],",",MakeBoxes[t4,StandardForm]}]]]


 MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",RowBox[{t1_,",",t2_,",",t3_,",",t4_}]],RowBox[{"(",RowBox[{n1_,",",n2_,",",n3_,",",n4_}],")"}]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t1,",",n1}],"}"}],",",RowBox[{"{",RowBox[{t2,",",n2}],"}"}],",",RowBox[{"{",RowBox[{t3,",",n3}],"}"}],",",RowBox[{"{",RowBox[{t4,",",n4}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t1_,n1_},{t2_,n2_},{t3_,n3_},{t4_,n4_}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",RowBox[{MakeBoxes[t1,StandardForm],",",MakeBoxes[t2,StandardForm],",",MakeBoxes[t3,StandardForm],",",MakeBoxes[t4,StandardForm]}]],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm],",",MakeBoxes[n3,StandardForm],",",MakeBoxes[n4,StandardForm]}],")"}]]


 MakeExpression[SubscriptBox[f_,SubscriptBox["G",t_]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t,",","0"}],"}"}],",",RowBox[{"{",RowBox[{t,",","0"}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t_,0},{t_,0},{t_,0},{t_,0}][f_],StandardForm]:=SubscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",MakeBoxes[t,StandardForm]]]


 MakeExpression[SubsuperscriptBox[f_,SubscriptBox["G",t_],RowBox[{"(",RowBox[{n1_,",",n2_,",",n3_,",",n4_}],")"}]],StandardForm]:=MakeExpression[RowBox[{RowBox[{"GaussianDerivative","[",RowBox[{RowBox[{"{",RowBox[{t,",",n1}],"}"}],",",RowBox[{"{",RowBox[{t,",",n2}],"}"}],",",RowBox[{"{",RowBox[{t,",",n3}],"}"}],",",RowBox[{"{",RowBox[{t,",",n4}],"}"}]}],"]"}],"[",f,"]"}],StandardForm]

MakeBoxes[GaussianDerivative[{t_,n1_},{t_,n2_},{t_,n3_},{t_,n4_}][f_],StandardForm]:=SubsuperscriptBox[MakeBoxes[f,StandardForm],SubscriptBox["G",MakeBoxes[t,StandardForm]],RowBox[{"(",RowBox[{MakeBoxes[n1,StandardForm],",",MakeBoxes[n2,StandardForm],",",MakeBoxes[n3,StandardForm],",",MakeBoxes[n4,StandardForm]}],")"}]]


GaussianDerivativeAt[tnp:{_?NumericQ,_?NumericQ,_Integer:0}.., opts___Rule][img_List]:=
Catch[Module[
{
bounds = (ImageBoundary /. {opts} /. Options[GaussianDerivativeAt]),
kernrange = (KernelRange /. {opts} /. Options[GaussianDerivativeAt]),
kernpbits = Min[52,Max[4,4*Ceiling[
Log[2,10^(WorkingPrecision /. {opts} /. Options[GaussianDerivativeAt])
]/4]]],
tnpList=Reverse[Map[PadRight[#,3]&,{tnp}]],
positions,intervals,frameWidth,offsets,framedImage,x
},
positions = tnpList[[All,1]];
intervals=Map[
GaussianKernelInterval[Rest[#],kernpbits,kernrange]&,
tnpList,{1}
];
frameWidth=Transpose[Apply[
{1-Map[Min[1,#]&,#1],
MapThread[(Max[#1,#2]-#2)&,{#2,Take[Dimensions[img],Length[#2]]}]}&,
Transpose[Round[positions]+intervals]
]];
offsets = frameWidth[[All,1]];
framedImage = ImageFrame[img,frameWidth,ImageBoundary-> bounds];
Fold[
Dot[#2,#1]&,
Apply[Take[framedImage,##]&,Round[positions] + offsets+intervals],
MapThread[
Table[
NGaussianDKernel[Last[#1]][#1[[-2]],x],Evaluate[Join[{x},Reverse[#2]+First[#1]-Round[First[#1]],{-1}]]
]&,
{tnpList,intervals}
]
]
]]/;TensorRank[img]>=Length[{tnp}]

GaussianDerivativeAt[tnps:{{_?NumericQ,_?NumericQ,_Integer:0}..}.., opts___Rule][img_List]:=
Catch[Module[
{
bounds = (ImageBoundary /. {opts} /. Options[GaussianDerivativeAt]),
kernrange = (KernelRange /. {opts} /. Options[GaussianDerivativeAt]),
kernpbits = Min[52,Max[4,4*Ceiling[
Log[2,10^(WorkingPrecision /. {opts} /. Options[GaussianDerivativeAt])
]/4]]],
tnpList=Map[Reverse,Map[PadRight[#,3]&,{tnps},{2}]],
positions,intervals,frameWidth,offsets,framedImage,x
},
positions = tnpList[[All,All,1]];
intervals=Map[GaussianKernelInterval[Rest[#],kernpbits,kernrange]&,tnpList,{2}];
frameWidth=MapThread[
{1-Min[1,First[#1]],Max[Last[#1],#2]-#2}&,{#,Take[Dimensions[img],Length[#]]}
]&[PseudoTranspose[Round[positions]+intervals,{3,1,2}]];
offsets = frameWidth[[All,1]];
framedImage = ImageFrame[img,frameWidth,ImageBoundary-> bounds];
MapThread[
Fold[Dot[#2,#1]&,Apply[Take[framedImage,##]&,#1],#2]&,
{Map[(# + offsets)&,Round[positions]]+intervals,
MapThread[
Table[
NGaussianDKernel[Last[#1]][#1[[-2]],x],
Evaluate[Join[{x},Reverse[#2]+First[#1]-Round[First[#1]],{-1}]]
]&,
{tnpList,intervals},2
]}
]
]]/;Apply[And,Map[(TensorRank[img]>=Length[#])&,{tnps}]]


FastOuterTimes[x_List,y__List] := Fold[With[{v=#2},Map[Times[#,v]&,#1,{TensorRank[#1]}]]&,x,{y}];
FastOuterTimes[x_List] = x;


PseudoTranspose[expr:{{__}..}] :=
DeleteCases[Transpose[PadRight[expr,{Length[expr],Max[Map[Length,expr]]},Null]],Null,{2}]

PseudoTranspose[expr:{{__}..},perm_List] :=
With[
{dim=Drop[NestWhileList[Max[Map[Length,expr,{i++}]]&,i=1;Length[expr],(#>0)&],-1]},
If[Length[perm]>Length[dim], Message[Transpose::tperm,perm];Return[]];
DeleteCases[Transpose[PadRight[expr,dim,Null],perm],Null|{Null..},Length[perm]]
]


AttachFrame1D[data_List,{widthleft_Integer,widthright_Integer}] :=
If[widthleft==widthright,
Join[#,data,#]&[Table[0,{widthleft},##]&@@Transpose[{Dimensions[First[data]]}]],
Join[Table[0,{widthleft},##],data,Table[0,{widthright},##]]&@@Transpose[{Dimensions[First[data]]}]
]


End[]

Protect[
ImageBoundary,
Cyclic,
Truncate,
Reflexive
];

SetAttributes[
{G,
GaussianKernelRange,
NGaussianKernel,
GaussianKernel,
NGaussianDKernel,
GaussianDKernel,
GaussianD,
GaussianDerivative,
GaussianDerivativeAt,
Method,
KernelRange,
Convolve,
Fourier},
{Protected, ReadProtected}
];

EndPackage[]
