(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`Histogram`"] = {2010,7,23,17,29,0};

Protect[TimeStamp];


(*:Name: MathVisionTools`Histogram` *)

(*:Author: Markus van Almsick *)

(*:Email address: m.v.almsick@tue.nl *)

(*:Context: MathVisionTools`Histogram` *)

(*:Package Version: 1.4 *)

(*:Mathematica Version: 7.0 *)

(*:Copyright: Copyright 2004, Technische Universiteit Eindhoven *)

(*:Title: Histogram*)

(*:Summary: A standard way to generaty histograms of a grayscale image *)

(*:Keywords: keywords that describe the content *)

(*:Requirements: None *)

(*:Source: None *)

(*:History: Version 1.0 by Markus van Almsick, May 2003 *)

(*:Limitations: *)

(*:Discussion: *)

(*:To do: *)


BeginPackage["MathVisionTools`Histogram7`"]

Unprotect[
HistogramList,
HistogramListEntropy,
HistogramListRange,
HistogramListBinRange,
HistogramListRangeSpecified,
HistogramListNormalized,
HistogramListBinFunction
]


HistogramList::usage="HistogramList[data] determines the distribution of values in the given data list. Use the options HistogramListRange, HistogramListBinRange, HistogramListRangeSpecified, HistogramListNormalized, and HistogramListBinFunction to alter the structure of the rendered histogram list."

HistogramListEntropy::usage="HistogramListEntropy[histogram] renders the information in bits needed to specify a (range-) value in the given normalized histogram. For single probability values p between 0 and 1, HistogramListEntropy[p] renders the information density -p Log[2,p]."

HistogramListRange::usage="HistogramListRange is an option for HistogramList that determines the range that will bound the resulting histogram list and that will generate a range of bins if option HistogramListBinRange is set to True. The default is Automatic leading to typical integer intervals of [0,15], [0,255], [0,1024], or [0,4096]. The option also accepts lists containing the 1, 2, or 3 arguments admissable in the Range command."

HistogramListBinRange::usage ="HistogramListBinRange is an option for HistogramList. To render a histogram list with frequency counts for every value within the specified histogram range, use the default True. To obatin a histogram list that omits null frequency counts and that works for arbitrary data values, set this option to False."

HistogramListRangeSpecified::usage ="HistogramListRangeSpecified is an option for HistogramList that, if set to True, causes the command to render a histogram list with specified range in the continuous case, and specified integer values for each frequency count in the discontinuous case. The default is True."

HistogramListNormalized::usage ="HistogramListNormalized is an option for HistogramList that converts the frequency counts into probabilities. The default is False."

HistogramListBinFunction::usage ="HistogramListBinFunction is an option for HistogramList that converts aribtrary values in the data set to bin enumerating Integers. The default is Round."

Options[HistogramList]={HistogramListRange->Automatic,HistogramListBinRange->True,HistogramListBinFunction->Identity, HistogramListRangeSpecified-> True, HistogramListNormalized-> False};


Begin["`Private`"]


(* Utility Functions *)

RangeLength[min_,max_,dx_:1] = Floor[(max-min)/dx+1];


(* HistogramList *)

HistogramList::syntax = "The histogram range is not correctly defined.";
HistogramList::toolarge = "The histogram range contains more than 4096 bins.";
HistogramList::nonint = "The data contains non-integer values. Please, set the option HistogramListBinRange";

HistogramList[data_List, opts___Rule]:=
Module[{spec,specrange,rangeOpt,specifiedOpt,normalizeOpt,binrangeOpt,toBin, toProbability},

(* reading all options *) 
{rangeOpt,binrangeOpt,specifiedOpt,normalizeOpt} = {HistogramListRange,HistogramListBinRange,HistogramListRangeSpecified,HistogramListNormalized} /. {opts} /. Options[HistogramList];

(* determining histogram range *) 
Switch[
rangeOpt,
Automatic,specrange = {Min[0,Min[data]],4^Ceiling[Log[4,Max[data]+1.0]]-1,1},
All,specrange = {Min[data],Max[data],1},
{_,_}|{_,_,_},specrange = {
rangeOpt[[1]]/.{Automatic->Min[0,Min[data]],All-> Min[data]},rangeOpt[[2]]/.{Automatic->4^Ceiling[Log[4,Max[data]+1.0]]-1,All->Max[data] },
If[Length[rangeOpt]===3,rangeOpt[[3]],1]
},
_,Message[HistogramList::syntax];If[binrangeOpt || specifiedOpt, Return[$Failed]]
];
If[(RangeLength@@specrange)>2^12, Message[HistogramList::toolarge]];

(* generating bin function *)
If[
binrangeOpt, 
toBin = Evaluate[Round[(#-First[specrange])/ Last[specrange]]*Last[specrange]+First[specrange]]&;
If[Not[FreeQ[specrange, Real]],toBin = N[toBin[#]]&],
toBin = Identity,toBin = Identity
];

(* generating normalization function *)
If[
normalizeOpt,
toProbability = (#/Total[N[#]])&,
toProbability = Identity;
];

If[$VersionNumber<6,
If[specifiedOpt || binrangeOpt,
If[binrangeOpt,
If[specifiedOpt,{specrange,#},#]&[Apply[Range,specrange]/.Dispatch[Append[Apply[Rule,#,{1}],_Integer->0]]],
#
]&[Transpose[{Map[First,#],toProbability[Map[Length,#]]}]&[Split[Sort[toBin[Flatten[data]]]]]],
toProbability[Map[Length,Split[Sort[toBin[Flatten[data]]]]]]
],
If[specifiedOpt || binrangeOpt,
If[binrangeOpt,
If[specifiedOpt,{specrange,#},#]&[Apply[Range,specrange]/.Dispatch[Append[Apply[Rule,#,{1}],_Integer->0]]],
Sort[#]
]&[Transpose[{#[[All,1]],toProbability[#[[All,2]]]}]&[Tally[toBin[Flatten[data]]]]],
toProbability[Sort[Tally[toBin[Flatten[data]]]][[All,2]]]
]
]
];


(* Entropy *)

Entropy1D= Compile[{{p,_Real,1}},Total[Map[If[#===0.0,0,-# Log[2,#]]&,p]]];

HistogramListEntropy[0|0.0]=0;

HistogramListEntropy[p_] := -p Log[2,p];

HistogramListEntropy[spec:{___?NumericQ}] := Entropy1D[spec];

HistogramListEntropy[spec:{{_,_Real|_Integer|_Rational}..}] := Entropy1D[Transpose[spec][[2]]];

HistogramListEntropy[{{_,_,_:1},spec:_?(ArrayQ[#,1,NumericQ]&)}] := Entropy1D[spec/Total[spec]];

HistogramListEntropy[spec:_?(ArrayQ[#,2|3|4|5|6,NumericQ]&)] := Entropy1D[Flatten[spec]];


End[]

SetAttributes[
{HistogramList,
HistogramList,
HistogramListRange,
HistogramListBinRange,
HistogramListRangeSpecified,
HistogramListNormalized,
HistogramListBinFunction},
{Protected, ReadProtected}
];

EndPackage[]
