(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`ImageDerivative`"]={2010,9,7,17,38,0}

Protect[TimeStamp];


(*:Name:MathVisionTools`ImageDerivative`*)

(*:Author:Markus van Almsick*)

(*:Email address:M.v.Almsick@tue.nl*)

(*:Context:MathVisionTools`ImageDerivative`*)

(*:Package Version:1.0*)

(*:Mathematica Version:7*)

(*:Copyright:Copyright 2009, Technische Universiteit Eindhoven*)

(*:Title:Image Derivative*)

(*:Summary:This package implements the derivation of images via B-spline interpolation*)

(*:Keywords:Interpolation, BSpline, Derivative*)

(*:Requirements:None*)

(*:Source:None*)

(*:History:Version 1.0 by Markus van Almsick, December 2009*)

(*:Limitations: Only odd B-spline orders up to 9th order supported.*)

(*:Discussion:*)

(*:To do:*)


BeginPackage["MathVisionTools`ImageDerivative`", {"MathVisionTools`ImageInterpolation`","MathVisionTools`Common`MathVisionToolsCommon`"}]

Unprotect[
ImageDerivative
]


ImageDerivative::usage="\!\(\*FormBox[FormBox[\n  RowBox[{\n   RowBox[{\n    RowBox[{\n     RowBox[{\"ImageDerivative\", \"[\", \n      RowBox[{SubscriptBox[\"n\", \"1\"], \",\", SubscriptBox[\"n\", \"2\"], \",\", \"\[Ellipsis]\"}], \"]\"}], \"[\", \n     StyleBox[\"image\",\nFontSlant->\"Italic\"], \"]\"}], \" \", \"generates\", \" \", \"an\", \" \", \"image\", \" \", \"array\", \" \", \"obtained\", \" \", \"from\", \" \", \n    StyleBox[\"image\",\nFontSlant->\"Italic\"], \" \", \"by\", \" \", \"differentiating\", \" \", SubscriptBox[\"n\", \"1\"], \" \", \"times\", \" \", \"with\", \" \", \"respect\", \" \", \"to\", \" \", \"the\", \" \", \"first\", \" \", \"dimension\"}], \",\", \" \", \n   RowBox[{SubscriptBox[\"n\", \"2\"], \" \", \"times\", \" \", \"with\", \" \", \"respect\", \" \", \"to\", \" \", \"the\", \" \", \"second\", \" \", \"dimension\"}], \",\", \" \", \n   RowBox[{\n    RowBox[{\"and\", \" \", \"so\", \" \", \n     RowBox[{\"on\", \".\", \" \", \"The\"}], \" \", \"derivatives\", \" \", \"are\", \" \", \"formed\", \" \", \"via\", \" \", \"interpolating\", \" \", \"B\"}], \"-\", \n    RowBox[{\"spline\", \" \", \"of\", \" \", \"odd\", \" \", \n     RowBox[{\"order\", \".\", \" \", \"Their\"}], \" \", \"order\", \" \", \"can\", \" \", \"be\", \" \", \"set\", \" \", \"by\", \" \", \"the\", \" \", \"option\", \" \", \n     RowBox[{\n      StyleBox[\"InterpolationOrder\", \"MR\"], \".\", \" \", \"The\"}], \" \", \"option\", \" \", \n     StyleBox[\"ImageBoundary\", \"MR\"], \" \", \"is\", \" \", \"also\", \" \", \n     RowBox[{\"supported\", \".\"}]}]}]}],\n  TraditionalForm],\n TraditionalForm]\)";


Begin["`Private`"]


ImageDerivativeFilter[0,3]={1,4,1};
ImageDerivativeFilter[1,3]={3,0,-3};
ImageDerivativeFilter[2,3]={6,-12,6};


ImageDerivativeFilter[0,5]={1,26,66,26,1};
ImageDerivativeFilter[1,5]={5,50,0,-50,-5};
ImageDerivativeFilter[2,5]={20,40,-120,40,20};
ImageDerivativeFilter[3,5]={60,-120,0,120,-60};
ImageDerivativeFilter[4,5]={120,-480,720,-480,120};


ImageDerivativeFilter[0,7]={1,120,1191,2416,1191,120,1};ImageDerivativeFilter[1,7]={7,392,1715,0,-1715,-392,-7};
ImageDerivativeFilter[2,7]={42,1008,630,-3360,630,1008,42};
ImageDerivativeFilter[3,7]={210,1680,-3990,0,3990,-1680,-210};
ImageDerivativeFilter[4,7]={840,0,-7560,13440,-7560,0,840};
ImageDerivativeFilter[5,7]={2520,-10080,12600,0,-12600,10080,-2520};
ImageDerivativeFilter[6,7]={5040,-30240,75600,-100800,75600,-30240,5040};


ImageDerivativeFilter[0,9]={1,502,14608,88234,156190,88234,14608,502,1};
ImageDerivativeFilter[1,9]={9,2214,36414,101934,0,-101934,-36414,-2214,-9};
ImageDerivativeFilter[2,9]={72,8496,68544,11088,-176400,11088,68544,8496,72};
ImageDerivativeFilter[3,9]={504,27216,67536,-218736,0,218736,-67536,-27216,-504};
ImageDerivativeFilter[4,9]={3024,66528,-96768,-260064,574560,-260064,-96768,66528,3024};
ImageDerivativeFilter[5,9]={15120,90720,-514080,695520,0,-695520,514080,-90720,-15120};
ImageDerivativeFilter[6,9]={60480,-120960,-483840,2056320,-3024000,2056320,-483840,-120960,60480};
ImageDerivativeFilter[7,9]={181440,-1088640,2540160,-2540160,0,2540160,-2540160,1088640,-181440};
ImageDerivativeFilter[8,9]={362880,-2903040,10160640,-20321280,25401600,-20321280,10160640,-2903040,362880};


ImageDerivative1D[{0,ord:(1|3|5|7|9),boundary_},depth_Integer:1][img_]:=img;


ImageDerivative::ordnotdef="The B-spline order `1` is not implemented.";
ImageDerivative::ordtoolow = "A B-spline of order `1` does not support derivatives of `2`-order.";


ImageDerivative1D[{0,ord_Integer?Positive,boundary_},depth_Integer:1][img_]:= (Message[ImageDerivative::ordnotdef,ord];$Failed) /;EvenQ[ord] \[Or] ord>7;


ImageDerivative1D[{n_,ord:(1|3|5|7|9),boundary_},depth_Integer:1][img_]:= (Message[ImageDerivative::ordtoolow,ord,n];Array[(0.)&,Dimensions[img]]) /;n>=ord;


ImageDerivative1D[{n_Integer?NonNegative,ord:(1|3|5|7|9),boundary_},depth_Integer:1][img_]:=
ListConvolve[Map[Nest[List,#,depth-1]&,ImageDerivativeFilter[n,ord]],BSplineInterpolationFilter1D[{ord,boundary,(ord-1)/2},img]]


Options[ImageDerivative]={ImageBoundary-> {Reflective},InterpolationOrder-> 5};


ImageDerivative::toomanyn = "ImageDerivative encountered with more derivative indices than dimensions in the data.";


ImageDerivative[ny_Integer,nx_Integer,opts___?OptionQ][img_?ImageQ]:=Image[ImageDerivative[ny,nx,opts][ImageData[img,Interleaving-> True]],Sequence@@Options[img]]


ImageDerivative[ns__Integer,opts___?OptionQ][img_List]:=
Module[
{dim=TensorRank[img],nn=Length[{ns}],dimrot,
bounds = (ImageBoundary /. {opts} /. Options[ImageDerivative]),
orders =(InterpolationOrder/.{opts}/.Options[ImageDerivative])},
If[dim<nn,Message[ImageDerivative::toomanyn];Return[$Failed]];
If[Head[bounds]=!=List,bounds={bounds}];
bounds=PadRight[bounds,nn,Last[bounds]];
If[Head[orders]=!=List,orders={orders}];
orders=PadRight[orders,nn,Last[orders]];
dimrot=Join[RotateRight[Range[nn]],Range[nn+1,dim]];
Fold[
Transpose[ImageDerivative1D[#2,dim][#1],dimrot]&,
img,
Transpose[{{ns},orders,bounds}]
]
]


ImageDerivative[ns:{__Integer}..,opts___?OptionQ][img_List]:=
Module[
{dim=TensorRank[img],nn=Last[Dimensions[{ns}]],dimrot,
bounds = (ImageBoundary /. {opts} /. Options[ImageDerivative]),
orders =(InterpolationOrder/.{opts}/.Options[ImageDerivative]),
filtered},
If[dim<nn,Message[ImageDerivative::toomanyn];Return[$Failed]];
If[Head[bounds]=!=List,bounds={bounds}];
bounds=PadRight[bounds,nn,Last[bounds]];
If[Head[orders]=!=List,orders={orders}];
orders=PadRight[orders,nn,Last[orders]];
dimrot=Join[RotateRight[Range[nn]],Range[nn+1,dim]];
filtered=Fold[
Transpose[BSplineInterpolationFilter1D[{#2[[1]],#2[[2]],(#2[[1]]-1)/2},#1],dimrot]&,
img,
Transpose[{orders,bounds}]
];
Map[
Fold[
Transpose[
ListConvolve[Map[Nest[List,#,dim-1]&,Evaluate[ImageDerivativeFilter[#2[[1]],#2[[2]]]]],#1],dimrot]&,
filtered,
Transpose[{#,orders}]
]&,
{ns}
]
]/; MatrixQ[{ns}]


End[]

SetAttributes[
{ImageDerivative},
{Protected,ReadProtected}
];

EndPackage[]
