(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`ImageFrame`"] = {2008,8,9,11,30,0};

Protect[TimeStamp];


(*:Name: MathVisionTools`ImageFrame` *)

(*:Author: Markus van Almsick*)

(*:Email address: M.v.Almsick@tue.nl*)

(*:Context: MathVisionTools`ImageFrame`*)

(*:Package Version: 1.3 *)

(*:Mathematica Version: 5.0 *)

(*:Copyright: Copyright 2004, Technische Universiteit Eindhoven*)

(*:Title: Padding, Frame, Boundary *)

(*:Summary: This package implements the ImageFrame function, which wraps a frame around an n-dimensional dataset with scalar, vectorial, or tensorial data values. The frame can emulate cylcic, reflective, and constant boundary conditions. *)

(*:Keywords: Padding, Frame, Boundary *)

(*:Requirements: None *)

(*:Source: None *)

(*:History: Version 1.0 by Markus van Almsick, November 2003 *)

(*:Limitations: *)

(*:Discussion: *)

(*:To do: *)


Unprotect[Take];
Take[expr_List,seq___,{0,_?Positive,-1},___] :=Replace[Take[expr,seq],_List-> {},{Length[{seq}]}]
Take[expr_List,seq___,{_?Negative,0,-1},___] :=Replace[Take[expr,seq],_List-> {},{Length[{seq}]}]
Protect[Take];


BeginPackage[
"MathVisionTools`ImageFrame`",
"MathVisionTools`Common`MathVisionToolsCommon`"
]

Unprotect[
ImageFrame,
RemoveImageFrame,
ImageFrame1D,
ImageBoundary,
Cyclic,
Truncate,
Reflective,
Constant
]


ImageFrame::usage="ImageFrame[data, d, opts] wraps a frame around an n-dimensional data set with width d. The frame type is specified by the ImageBoundary option. ImageFrame[data, d, level, opts] applies a frame to the specified level only. Width d can also be a List of {left, right} width specifications for each data level respectively. Note that the sequence of these level specifications are in reverse order to the intuative x,y,z-order exhibited when plotting the data. The default ImageBoundary is Cyclic emulating cylcic boundary conditions. Other types are Reflective, Truncate, and Constant. These type spcifications can also be given in a List for each data level respectively."

RemoveImageFrame::usage="ImageFrame[data, d, opts] removes a frame of width d around an n-dimensional data set. RemoveImageFrame[data, d, level, opts] removes a frame at the specified level only. Width d can also be a List of {left, right} width specifications for each data level respectively. Note that the sequence of these level specifications are in reverse order to the intuative x,y,z-order exhibited when plotting the data."

ImageFrame1D::usage="ImageFrame1D[data, {{widthLeft, widthRight}, level, mode}] adds a frame around an n-dimensional data set at the given level with width {widthLeft, widthRight} in the modes Cyclic, Truncate, Constant, or Refelctive."

If[
Head[ImageBoundary::usage]===MessageName,
ImageBoundary::usage="ImageBoundary is an option of ImageFrame to determine the frame type.",
If[
Not[StringMatchQ[ImageBoundary::usage,"*ImageFrame*"]],
ImageBoundary::usage=ImageBoundary::usage<>"\nImageBoundary is also an option of ImageFrame to specify the frame type."
]
]

If[
Head[Cyclic::usage]===MessageName,
Cyclic::usage="Is a value for the ImageFrame option ImageBoundary. It generates a frame with cyclic image values.",
If[
Not[StringMatchQ[Cyclic::usage,"*ImageFrame*"]],
Cyclic::usage=Cyclic::usage<>"\nIt is also a value for the ImageFrame option ImageBoundary. It generates a frame with cyclic image values."
]
]

If[
Head[Truncate::usage]===MessageName,
Truncate::usage="Is a value for the ImageFrame option ImageBoundary. It generates a frame with zero image values.",
If[
Not[StringMatchQ[Truncate::usage,"*ImageFrame*"]],
Truncate::usage=Truncate::usage<>"\nIt is also a value for the ImageFrame option ImageBoundary. It generates a frame with zero image values."
]
]

If[
Head[Reflective::usage]===MessageName,
Reflective::usage="Is a value for the ImageFrame option ImageBoundary. It generates a frame with reflected image values.",
If[
Not[StringMatchQ[Reflective::usage,"*ImageFrame*"]],
Reflective::usage=Reflective::usage<>"\nIt is also a value for the ImageFrame option ImageBoundary. It generates a frame with reflected image values."
]
]

If[
Not[StringMatchQ[Constant::usage,"*ImageFrame*"]],
Constant::usage=Constant::usage<>"\nIt is also a value for the ImageFrame option ImageBoundary. It generates a frame by extending the value of each boundary pixel as a constant across the frame."
]

Options[ImageFrame]={ImageBoundary -> Cyclic};


Begin["`Private`"]


RemoveImageFrame[img_List,0|{(0|{0,0})..},___]=img;

RemoveImageFrame[img_List,width_,opts___Rule]:=RemoveImageFrame[img,width,Range[TensorRank[img]],opts];

RemoveImageFrame[img_List,width_,maxrank_Integer?Positive,opts___Rule]:=RemoveImageFrame[img,width,Range[maxrank],opts];

RemoveImageFrame[img_List,width_,All,opts___Rule]:=RemoveImageFrame[img,width,Range[TensorRank[img]],opts];


RemoveImageFrame[img_List,width_,ranks:{firstRank__Integer?Positive},opts___Rule]:=
Module[
{rng=Table[All,{Max[ranks]}]},
rng[[ranks]]=
Map[
Switch[#,_Integer?Positive,{#+1,-#-1},{_,_},{1,-1}(#+1),_,All]&,If[Head[width]===List,
PadRight[width,Length[ranks],width],
PadRight[{width},Length[ranks],{width}]
]
];
Print[rng];
Apply[Take[img,##]&,rng]
];


ImageFrame[img_List,0|{(0|{0,0})..},___]=img;

ImageFrame[img_List,width_,opts___Rule]:=ImageFrame[img,width,Range[TensorRank[img]],opts];

ImageFrame[img_List,width_,maxrank_Integer?Positive,opts___Rule]:=ImageFrame[img,width,Range[maxrank],opts];

ImageFrame[img_List,width_,All,opts___Rule]:=ImageFrame[img,width,Range[TensorRank[img]],opts];


ImageFrame[img_List,width_,ranks:{firstRank__Integer?Positive},opts___Rule]:=
Module[
{type=ImageBoundary /. {opts}/.  Options[ImageFrame]},
Fold[
ImageFrame1D[#1,#2]&,
img,
Transpose[{
Map[
Round[If[NumericQ[#],{#,#},#]]&,
If[Head[width]===List,
PadRight[width,Length[ranks],width],
PadRight[{width},Length[ranks],{width}]
]
],
ranks,
If[Head[type]===List,
PadRight[type,Length[ranks],type],
PadRight[{type},Length[ranks],{type}]
]
}]
]
];


ImageFrame1D[img_List,{{0,0},rank_Integer?Positive,_}]:=img;


ImageFrame1D[img_List,
{{0,widthRight_Integer?Positive},
rank_Integer?Positive,
Reflective}]:=
With[
{w = Dimensions[img][[rank]]},
Apply[
 MapThread[
Join,
{##,
If[
EvenQ[Quotient[widthRight,w]],
Take[img,##]&@@PadLeft[{{-1,-Mod[widthRight,w],-1}},rank,All],
Take[img,##]&@@PadLeft[{{1,Mod[widthRight,w],1}},rank,All]
]},
rank-1
]&,
Join[{img},PadRight[{},Quotient[widthRight,w],{#,img}]]&[Take[img,##]&@@PadLeft[{{-1,1,-1}},rank,All]]
]
];

ImageFrame1D[img_List,
{{widthLeft_Integer?Positive,0},
rank_Integer?Positive,
Reflective}]:=
With[
{w = Dimensions[img][[rank]]},
Apply[
 MapThread[
Join,
{If[
EvenQ[Quotient[widthLeft,w]],
Take[img,##]&@@PadLeft[If[widthLeft===0,{{1,0}},{{Mod[widthLeft,w],1,-1}}],rank,All],
Take[img,##]&@@PadLeft[{{-Mod[widthLeft,w],-1,1}},rank,All]
],
##},
rank-1
]&,
Join[PadLeft[{},Quotient[widthLeft,w],{img,#}],{img}]&[Take[img,##]&@@PadLeft[{{-1,1,-1}},rank,All]]
]
];

ImageFrame1D[img_List,
{{widthLeft_Integer?Positive,widthRight_Integer?Positive},
rank_Integer?Positive,
Reflective}]:=
With[
{w = Dimensions[img][[rank]]},
Apply[
 MapThread[
Join,
{If[
EvenQ[Quotient[widthLeft,w]],
Take[img,##]&@@PadLeft[If[widthLeft===0,{{1,0}},{{Mod[widthLeft,w],1,-1}}],rank,All],
Take[img,##]&@@PadLeft[{{-Mod[widthLeft,w],-1,1}},rank,All]
],
##,
If[
EvenQ[Quotient[widthRight,w]],
Take[img,##]&@@PadLeft[{{-1,-Mod[widthRight,w],-1}},rank,All],
Take[img,##]&@@PadLeft[{{1,Mod[widthRight,w],1}},rank,All]
]},
rank-1
]&,
Join[PadLeft[{},Quotient[widthLeft,w],{img,#}],{img},PadRight[{},Quotient[widthRight,w],{#,img}]]&[Take[img,##]&@@PadLeft[{{-1,1,-1}},rank,All]]
]
];


ImageFrame1D[
img_List,
{{widthLeft_Integer?NonNegative,widthRight_Integer?NonNegative},
rank_Integer?Positive, 
Cyclic}]:=
With[
{w = Dimensions[img][[rank]]},
 Apply[
MapThread[
Join,
{Take[img,##]&@@PadLeft[{{-Mod[widthLeft,w],-1}},rank,All],
##,
Take[img,##]&@@PadLeft[{{1,Mod[widthRight,w]}},rank,All]},
rank-1
]&,
Table[img,{Quotient[widthLeft,w]+Quotient[widthRight,w]+1}]
]
];


ImageFrame1D[
img_List,
{{width_Integer?NonNegative,width_},
rank_Integer?Positive,
b_?NumericQ}]:=
 MapThread[
Join,
{#,img,#},
rank-1
]&[Table[b,##]&@@Transpose[{ReplacePart[Dimensions[img],width,rank]}]];

ImageFrame1D[
img_List,
{{widthLeft_Integer?NonNegative,widthRight_Integer?NonNegative},
rank_Integer?Positive,
b_?NumericQ}]:=
 MapThread[
Join,
{Table[b,##]&@@Transpose[{ReplacePart[Dimensions[img],widthLeft,rank]}],
img,
Table[b,##]&@@Transpose[{ReplacePart[Dimensions[img],widthRight,rank]}]},
rank-1
];


ImageFrame1D[
img_List,
{{width_Integer?Positive,width_},
rank_Integer?Positive,
Truncate}]:=
 MapThread[
Join,
{#,img,#},
rank-1
]&[Table[0,##]&@@Transpose[{ReplacePart[Dimensions[img],width,rank]}]];

ImageFrame1D[
img_List,
{{0,widthRight_Integer?Positive},
rank_Integer?Positive,
Truncate}]:=
 MapThread[
Join,
{img,
Table[0,##]&@@Transpose[{ReplacePart[Dimensions[img],widthRight,rank]}]},
rank-1
];
ImageFrame1D[
img_List,
{{widthLeft_Integer?Positive,0},
rank_Integer?Positive,
Truncate}]:=
 MapThread[
Join,
{Table[0,##]&@@Transpose[{ReplacePart[Dimensions[img],widthLeft,rank]}],
img},
rank-1
];

ImageFrame1D[
img_List,
{{widthLeft_Integer?Positive,widthRight_Integer?Positive},
rank_Integer?Positive,
Truncate}]:=
 MapThread[
Join,
{Table[0,##]&@@Transpose[{ReplacePart[Dimensions[img],widthLeft,rank]}],
img,
Table[0,##]&@@Transpose[{ReplacePart[Dimensions[img],widthRight,rank]}]},
rank-1
];


ImageFrame1D[
img_List,
{{0,widthRight_Integer?Positive},
rank_Integer?Positive, 
Constant}]:=
 MapThread[
Join,
{img,
Transpose[Table[Part[img,##]&@@PadLeft[{-1},rank,All],{widthRight}],RotateRight[Range[rank]]]},
rank-1
];

ImageFrame1D[
img_List,
{{widthLeft_Integer?Positive,0},
rank_Integer?Positive, 
Constant}]:=
 MapThread[
Join,
{Transpose[Table[Part[img,##]&@@PadLeft[{1},rank,All],{widthLeft}],RotateRight[Range[rank]]],
img},
rank-1
];

ImageFrame1D[
img_List,
{{widthLeft_Integer?NonNegative,widthRight_Integer?NonNegative},
rank_Integer?Positive, 
Constant}]:=
 MapThread[
Join,
{Transpose[Table[Part[img,##]&@@PadLeft[{1},rank,All],{widthLeft}],RotateRight[Range[rank]]],
img,
Transpose[Table[Part[img,##]&@@PadLeft[{-1},rank,All],{widthRight}],RotateRight[Range[rank]]]},
rank-1
];


End[]

SetAttributes[
{ImageFrame,
RemoveImageFrame,
ImageFrame1D,
Constant},
{Protected, ReadProtected}
];

EndPackage[]
