(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`ImageInterpolation`"]={2010,8,26,10,22,0}

Protect[TimeStamp];


(*:Name:MathVisionTools`ImageInterpolation`*)

(*:Author:Markus van Almsick*)

(*:Email address:M.v.Almsick@tue.nl*)

(*:Context:MathVisionTools`ImageInterpolation`*)

(*:Package Version:2.2*)

(*:Mathematica Version:7*)

(*:Copyright:Copyright 2009,Technische Universiteit Eindhoven*)

(*:Title:Image Transformation*)

(*:Summary:This package implements linear and cubic interpolation schemes*)

(*:Keywords:Interpolation,BSpline*)

(*:Requirements:None*)

(*:Source:None*)

(*:History:Version 1.0 by Markus van Almsick, September 2008*)
(*:History:Version 2.0 by Markus van Almsick, November 2008*)

(*:Limitations:*)

(*:Discussion:*)

(*:To do:*)


BeginPackage["MathVisionTools`ImageInterpolation`", {"MathVisionTools`Common`MathVisionToolsCommon`"}]

Unprotect[
ImageInterpolation,
InterpolatingImage,
NBSplineInterpolationFilter1D,
BSplineInterpolationFilter1D,
BSplineInterpolationFilter
]


ImageInterpolation::usage=
"ImageInterpolation[array] constructs an InterpolatingImage object, which represents a function that interpolates the 1-, 2-, or 3-dimensional image array with B-splines of 1\!\(\*FormBox[SuperscriptBox[\(\[Null]\), \(st\)],
TraditionalForm]\), 3\!\(\*FormBox[SuperscriptBox[\(\[Null]\), \(rd\)],
TraditionalForm]\), 5\!\(\*FormBox[SuperscriptBox[\(\[Null]\), \(th\)],
TraditionalForm]\), 7\!\(\*FormBox[SuperscriptBox[\(\[Null]\), \(th\)],
TraditionalForm]\), or 9\!\(\*FormBox[SuperscriptBox[\(\[Null]\), \(th\)],
TraditionalForm]\) order. The variables of the interpolating function are in the order x, y, and z. The default is set to InterpolationOrder \[Rule] 3. The option ImageBoundary is also supported.
ImageInterpolation[array, off] constructs an InterpolatingImage function that returns off  if sampled outside the image domain. The default off-value is 0.";

InterpolatingImage::usage= "InterpolatingImage[domain, order, boundary, table] represents a 1-, 2-, or 3-dimensional image function whose values are found by interpolation with B-spline of 1\!\(\*FormBox[SuperscriptBox[\(\[Null]\), \(st\)],
TraditionalForm]\), 3\!\(\*FormBox[SuperscriptBox[\(\[Null]\), \(rd\)],
TraditionalForm]\), 5\!\(\*FormBox[SuperscriptBox[\(\[Null]\), \(th\)],
TraditionalForm]\), 7\!\(\*FormBox[SuperscriptBox[\(\[Null]\), \(th\)],
TraditionalForm]\), or 9\!\(\*FormBox[SuperscriptBox[\(\[Null]\), \(th\)],
TraditionalForm]\) order.";

NBSplineInterpolationFilter1D::usage="For internal use only.";

BSplineInterpolationFilter1D::usage="For internal use only.";

BSplineInterpolationFilter::usage="BSplineInterpolationFilter[rank,{orders},{boundaries}][data] performs a B-spline preprocessing filter on image data. Parameter rank determines the number of dimensions that will be filter with the respective B-spline orders and boundary conditions.";


Begin["`Private`"]


NBSplineInterpolationFilter1D[{1,Reflective,w_Integer:1}]:=
ArrayPad[#,w,"Reversed"]&;


NBSplineInterpolationFilter1D[{1,Cyclic,w_Integer:1}]:=
ArrayPad[#,w,"Cyclic"]&;


NBSplineInterpolationFilter1D[{1,Constant,w_Integer:1}]:=
ArrayPad[#,w,"Fixed"]&;


NBSplineInterpolationFilter1D[{1,c_?NumberQ,w_Integer:1}]:=
ArrayPad[#,w,c]&;


NBSplineInterpolationFilter1D[{3,Reflective,w_Integer:2}]:=
Compile[
{{img,_Real,1}},
Block[
{\[Alpha]=-0.2679491924311228`,nmax=12},
ArrayPad[#,w,"Reversed"]&[
(0.28867513459481303`*(#1+Reverse[#2]-img))&[
#,
Rest[FoldList[(\[Alpha] #1+#2)&,Last[#],Reverse[img]]]
]&[Drop[FoldList[(\[Alpha] #1+#2)&,0,ArrayPad[img,{nmax,0},"Reversed"]],nmax+1]]
]
]
];


NBSplineInterpolationFilter1D[{3,Cyclic,w_Integer:2}]:=
Compile[
{{img,_Real,1}},
Block[
{\[Alpha]=-0.2679491924311228`,nmax=12},
ArrayPad[#,w,"Cyclic"]&[
(0.28867513459481303`*(#1+Reverse[#2]-img))&[Drop[FoldList[(\[Alpha] #1+#2)&,0,ArrayPad[img,{nmax,0},"Cyclic"]],nmax+1],
Drop[FoldList[(\[Alpha] #1+#2)&,0,ArrayPad[Reverse[img],{nmax,0},"Cyclic"]],nmax+1]]
]
]
];


NBSplineInterpolationFilter1D[{3,Constant,w_Integer:2}]:=
Compile[
{{img,_Real,1}},
Block[
{\[Alpha]=-0.2679491924311228`},
(0.28867513459481303`*(#2+Reverse[#3]-#1))&[
#,
Rest[FoldList[(\[Alpha] #1+#2)&,First[#]/(1-\[Alpha]),#]],
Rest[FoldList[(\[Alpha] #1+#2)&,Last[#]/(1-\[Alpha]),Reverse[#]]]
]&[ArrayPad[img,w,"Fixed"]]
]
];


NBSplineInterpolationFilter1D[{3,c_?NumberQ,w_Integer:2}]:=
Compile[
{{img,_Real,1}},
Block[
{\[Alpha]=-0.2679491924311228`},
(0.28867513459481303`*(#2+Reverse[#3]-#1))&[
#,
Rest[FoldList[(\[Alpha] #1+#2)&,c/(1-\[Alpha]),#]],
Rest[FoldList[(\[Alpha] #1+#2)&,c/(1-\[Alpha]),Reverse[#]]]
]&[ArrayPad[img,w,c]]
]
];


NBSplineInterpolationFilter1D[{5,Reflective,w_Integer:3}]:=
Compile[
{{img,_Real,1}},
Block[
{\[Alpha]1=-0.04309628820326239`,n1max=5,
\[Alpha]2=-0.43057534709997025`,n2max=19},
ArrayPad[#,w,"Reversed"]&[
(-0.023684757703449577` img-0.002106796542648226` #1+0.025791554151510354` #2)&[
#1+Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,Last[#1],Reverse[img]]]],#2+Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,Last[#2],Reverse[img]]]]
]&[
Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[img,{n1max,0},"Reversed"]],n1max+1],
Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[img,{n2max,0},"Reversed"]],n2max+1]]
]
]
];


NBSplineInterpolationFilter1D[{5,Cyclic,w_Integer:3}]:=
Compile[
{{img,_Real,1}},
Block[
{\[Alpha]1=-0.04309628820326239`,n1max=5,
\[Alpha]2=-0.43057534709997025`,n2max=19},
ArrayPad[#,w,"Cyclic"]&[
(-0.023684757703449577` img-0.002106796542648226` #1+0.025791554151510354` #2)&[
Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[img,{n1max,0},"Cyclic"]],n1max+1]+
Reverse[Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[Reverse[img],{n1max,0},"Cyclic"]],n1max+1]],
Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[img,{n2max,0},"Cyclic"]],n2max+1]+
Reverse[Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[Reverse[img],{n2max,0},"Cyclic"]],n2max+1]]]
]
]
];


NBSplineInterpolationFilter1D[{5,Constant,w_Integer:3}]:=
Compile[
{{img,_Real,1}},
Block[
{\[Alpha]1=-0.04309628820326239`,
\[Alpha]2=-0.43057534709997025`},
(-0.023684757703449577` #1-0.002106796542648226` #2+0.025791554151510354` #3)&[
#,
Rest[FoldList[(\[Alpha]1 #1+#2)&,First[#]/(1-\[Alpha]1),#]]+
Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,Last[#]/(1-\[Alpha]1),Reverse[#]]]],
Rest[FoldList[(\[Alpha]2 #1+#2)&,First[#]/(1-\[Alpha]2),#]]+
Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,Last[#]/(1-\[Alpha]2),Reverse[#]]]]
]&[ArrayPad[img,w,"Fixed"]]
]
];


NBSplineInterpolationFilter1D[{5,c_?NumberQ,w_Integer:3}]:=
Compile[
{{img,_Real,1}},
Block[
{\[Alpha]1=-0.04309628820326239`,
\[Alpha]2=-0.43057534709997025`},(-0.023684757703449577` #1-0.002106796542648226` #2+0.025791554151510354` #3)&[
#,
Rest[FoldList[(\[Alpha]1 #1+#2)&,c/(1-\[Alpha]1),#]]+
Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,c/(1-\[Alpha]1),Reverse[#]]]],
Rest[FoldList[(\[Alpha]2 #1+#2)&,c/(1-\[Alpha]2),#]]+
Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,c/(1-\[Alpha]2),Reverse[#]]]]
]&[ArrayPad[img,w,c]]
]
];


NBSplineInterpolationFilter1D[{7,Reflective,w_Integer:4}]:=
Compile[
{{img,_Real,1}},
Block[
{\[Alpha]1=-0.009148694809608277`,n1max=4,
\[Alpha]2=-0.12255461519232669`,n2max=8,
\[Alpha]3=-0.5352804307964383`,n3max=26},
ArrayPad[#,w,"Reversed"]&[
(-0.000985066048869381` img+8.470592879244762`*^-7 #1-0.00020948815361334196` #2+0.0011937071431947985` #3)&[
#1+Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,Last[#1],Reverse[img]]]],#2+Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,Last[#2],Reverse[img]]]],
#3+Reverse[Rest[FoldList[(\[Alpha]3 #1+#2)&,Last[#3],Reverse[img]]]]
]&[
Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[img,{n1max,0},"Reversed"]],n1max+1],
Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[img,{n2max,0},"Reversed"]],n2max+1],
Drop[FoldList[(\[Alpha]3 #1+#2)&,0,ArrayPad[img,{n3max,0},"Reversed"]],n3max+1]]
]
]
];


NBSplineInterpolationFilter1D[{7,Cyclic,w_Integer:4}]:=
Compile[
{{img,_Real,1}},
Block[
{\[Alpha]1=-0.009148694809608277`,n1max=4,
\[Alpha]2=-0.12255461519232669`,n2max=8,
\[Alpha]3=-0.5352804307964383`,n3max=26},
ArrayPad[#,w,"Cyclic"]&[(-0.000985066048869381` img+8.470592879244762`*^-7 #1-0.00020948815361334196` #2+0.0011937071431947985` #3)&[
Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[img,{n1max,0},"Cyclic"]],n1max+1]+
Reverse[Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[Reverse[img],{n1max,0},"Cyclic"]],n1max+1]],
Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[img,{n2max,0},"Cyclic"]],n2max+1]+
Reverse[Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[Reverse[img],{n2max,0},"Cyclic"]],n2max+1]],
Drop[FoldList[(\[Alpha]3 #1+#2)&,0,ArrayPad[img,{n3max,0},"Cyclic"]],n3max+1]+
Reverse[Drop[FoldList[(\[Alpha]3 #1+#2)&,0,ArrayPad[Reverse[img],{n3max,0},"Cyclic"]],n3max+1]]]
]
]
];


NBSplineInterpolationFilter1D[{7,Constant,w_Integer:4}]:=
Compile[
{{img,_Real,1}},
Block[
{\[Alpha]1=-0.009148694809608277`,
\[Alpha]2=-0.12255461519232669`,
\[Alpha]3=-0.5352804307964383`},
(-0.000985066048869381` #1+8.470592879244762`*^-7 #2-0.00020948815361334196` #3+0.0011937071431947985` #4)&[
#,
Rest[FoldList[(\[Alpha]1 #1+#2)&,First[#]/(1-\[Alpha]1),#]]+
Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,Last[#]/(1-\[Alpha]1),Reverse[#]]]],
Rest[FoldList[(\[Alpha]2 #1+#2)&,First[#]/(1-\[Alpha]2),#]]+
Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,Last[#]/(1-\[Alpha]2),Reverse[#]]]],
Rest[FoldList[(\[Alpha]3 #1+#2)&,First[#]/(1-\[Alpha]3),#]]+
Reverse[Rest[FoldList[(\[Alpha]3 #1+#2)&,Last[#]/(1-\[Alpha]3),Reverse[#]]]]
]&[ArrayPad[img,w,"Fixed"]]
]
];


NBSplineInterpolationFilter1D[{7,c_?NumberQ,w_Integer:4}]:=
Compile[
{{img,_Real,1}},
Block[
{\[Alpha]1=-0.009148694809608277`,
\[Alpha]2=-0.12255461519232669`,
\[Alpha]3=-0.5352804307964383`},
(-0.000985066048869381` #1+8.470592879244762`*^-7 #2-0.00020948815361334196` #3+0.0011937071431947985` #4)&[
#,
Rest[FoldList[(\[Alpha]1 #1+#2)&,c/(1-\[Alpha]1),#]]+
Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,c/(1-\[Alpha]1),Reverse[#]]]],
Rest[FoldList[(\[Alpha]2 #1+#2)&,c/(1-\[Alpha]2),#]]+
Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,c/(1-\[Alpha]2),Reverse[#]]]],Rest[FoldList[(\[Alpha]3 #1+#2)&,c/(1-\[Alpha]3),#]]+
Reverse[Rest[FoldList[(\[Alpha]3 #1+#2)&,c/(1-\[Alpha]3),Reverse[#]]]]
]&[ArrayPad[img,w,c]]
]
];


NBSplineInterpolationFilter1D[{9,Reflective,w_Integer:5}]:=
Compile[
{{img,_Real,1}},
Block[
{\[Alpha]1=-0.002121306903180818`,n1max=3,
\[Alpha]2=-0.04322260854048175`,n2max=5,
\[Alpha]3=-0.2017505201931532`,n3max=10,
\[Alpha]4=-0.6079973891686256`,n4max=32},
ArrayPad[#,w,"Reversed"]&[
(-0.000025453882305777692` img-2.163545673286295`*^-11 #1+2.561818738752173`*^-7 #2-8.614411452377346`*^-6 #3+0.00003381213351973659` #4)&[
#1+Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,Last[#1],Reverse[img]]]],#2+Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,Last[#2],Reverse[img]]]],
#3+Reverse[Rest[FoldList[(\[Alpha]3 #1+#2)&,Last[#3],Reverse[img]]]],
#4+Reverse[Rest[FoldList[(\[Alpha]4 #1+#2)&,Last[#4],Reverse[img]]]]
]&[
Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[img,{n1max,0},"Reversed"]],n1max+1],
Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[img,{n2max,0},"Reversed"]],n2max+1],
Drop[FoldList[(\[Alpha]3 #1+#2)&,0,ArrayPad[img,{n3max,0},"Reversed"]],n3max+1],Drop[FoldList[(\[Alpha]4 #1+#2)&,0,ArrayPad[img,{n4max,0},"Reversed"]],n4max+1]]
]
]
];


NBSplineInterpolationFilter1D[{9,Cyclic,w_Integer:5}]:=
Compile[
{{img,_Real,1}},
Block[
{\[Alpha]1=-0.002121306903180818`,n1max=3,
\[Alpha]2=-0.04322260854048175`,n2max=5,
\[Alpha]3=-0.2017505201931532`,n3max=10,
\[Alpha]4=-0.6079973891686256`,n4max=32},
ArrayPad[#,w,"Cyclic"]&[(-0.000025453882305777692` img-2.163545673286295`*^-11 #1+2.561818738752173`*^-7 #2-8.614411452377346`*^-6 #3+0.00003381213351973659` #4)&[
Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[img,{n1max,0},"Cyclic"]],n1max+1]+
Reverse[Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[Reverse[img],{n1max,0},"Cyclic"]],n1max+1]],
Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[img,{n2max,0},"Cyclic"]],n2max+1]+
Reverse[Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[Reverse[img],{n2max,0},"Cyclic"]],n2max+1]],
Drop[FoldList[(\[Alpha]3 #1+#2)&,0,ArrayPad[img,{n3max,0},"Cyclic"]],n3max+1]+
Reverse[Drop[FoldList[(\[Alpha]3 #1+#2)&,0,ArrayPad[Reverse[img],{n3max,0},"Cyclic"]],n3max+1]],
Drop[FoldList[(\[Alpha]4 #1+#2)&,0,ArrayPad[img,{n4max,0},"Cyclic"]],n4max+1]+
Reverse[Drop[FoldList[(\[Alpha]4 #1+#2)&,0,ArrayPad[Reverse[img],{n4max,0},"Cyclic"]],n4max+1]]]
]
]
];


NBSplineInterpolationFilter1D[{9,Constant,w_Integer:5}]:=
Compile[
{{img,_Real,1}},
Block[
{\[Alpha]1=-0.002121306903180818`,
\[Alpha]2=-0.04322260854048175`,
\[Alpha]3=-0.2017505201931532`,
\[Alpha]4=-0.6079973891686256`},
(-0.000025453882305777692` #1-2.163545673286295`*^-11 #2+2.561818738752173`*^-7 #3-8.614411452377346`*^-6 #4+0.00003381213351973659` #5)&[
#,
Rest[FoldList[(\[Alpha]1 #1+#2)&,First[#]/(1-\[Alpha]1),#]]+
Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,Last[#]/(1-\[Alpha]1),Reverse[#]]]],
Rest[FoldList[(\[Alpha]2 #1+#2)&,First[#]/(1-\[Alpha]2),#]]+
Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,Last[#]/(1-\[Alpha]2),Reverse[#]]]],
Rest[FoldList[(\[Alpha]3 #1+#2)&,First[#]/(1-\[Alpha]3),#]]+
Reverse[Rest[FoldList[(\[Alpha]3 #1+#2)&,Last[#]/(1-\[Alpha]3),Reverse[#]]]],Rest[FoldList[(\[Alpha]4 #1+#2)&,First[#]/(1-\[Alpha]4),#]]+
Reverse[Rest[FoldList[(\[Alpha]4 #1+#2)&,Last[#]/(1-\[Alpha]4),Reverse[#]]]]
]&[ArrayPad[img,w,"Fixed"]]
]
];


NBSplineInterpolationFilter1D[{9,c_?NumberQ,w_Integer:5}]:=
Compile[
{{img,_Real,1}},
Block[
{\[Alpha]1=-0.002121306903180818`,
\[Alpha]2=-0.04322260854048175`,
\[Alpha]3=-0.2017505201931532`,
\[Alpha]4=-0.6079973891686256`},
(-0.000025453882305777692` #1-2.163545673286295`*^-11 #2+2.561818738752173`*^-7 #3-8.614411452377346`*^-6 #4+0.00003381213351973659` #5)&[
#,
Rest[FoldList[(\[Alpha]1 #1+#2)&,c/(1-\[Alpha]1),#]]+
Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,c/(1-\[Alpha]1),Reverse[#]]]],
Rest[FoldList[(\[Alpha]2 #1+#2)&,c/(1-\[Alpha]2),#]]+
Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,c/(1-\[Alpha]2),Reverse[#]]]],Rest[FoldList[(\[Alpha]3 #1+#2)&,c/(1-\[Alpha]3),#]]+
Reverse[Rest[FoldList[(\[Alpha]3 #1+#2)&,c/(1-\[Alpha]3),Reverse[#]]]],
Rest[FoldList[(\[Alpha]4 #1+#2)&,c/(1-\[Alpha]4),#]]+
Reverse[Rest[FoldList[(\[Alpha]4 #1+#2)&,c/(1-\[Alpha]4),Reverse[#]]]]
]&[ArrayPad[img,w,c]]
]
];


BSplineInterpolationFilter1D[{1,Reflective,w_Integer:1},img_]:=
ArrayPad[img,{w},"Reversed"];


BSplineInterpolationFilter1D[{1,Cyclic,w_Integer:1},img_]:=
ArrayPad[img,{w},"Cyclic"];


BSplineInterpolationFilter1D[{1,Constant,w_Integer:1},img_]:=
ArrayPad[img,{w},"Fixed"];


BSplineInterpolationFilter1D[{1,c_?NumberQ,w_Integer:1},img_]:=
ArrayPad[img,{w},c];


BSplineInterpolationFilter1D[{3,Reflective,w_Integer:2},img_]:=
Module[
{\[Alpha]=-0.2679491924311228`,nmax=12},
ArrayPad[#,{w},"Reversed"]&[
(0.28867513459481303`*(#1+Reverse[#2]-img))&[
#,
Rest[FoldList[(\[Alpha] #1+#2)&,Last[#],Reverse[img]]]
]&[Drop[FoldList[(\[Alpha] #1+#2)&,0,ArrayPad[img,{{nmax,0}},"Reversed"]],nmax+1]]
]
];


BSplineInterpolationFilter1D[{3,Cyclic,w_Integer:2},img_]:=
Module[
{\[Alpha]=-0.2679491924311228`,nmax=12},
ArrayPad[#,{w},"Cyclic"]&[
(0.28867513459481303`*(#1+Reverse[#2]-img))&[Drop[FoldList[(\[Alpha] #1+#2)&,0,ArrayPad[img,{{nmax,0}},"Cyclic"]],nmax+1],
Drop[FoldList[(\[Alpha] #1+#2)&,0,ArrayPad[Reverse[img],{{nmax,0}},"Cyclic"]],nmax+1]]
]
];


BSplineInterpolationFilter1D[{3,Constant,w_Integer:2},img_]:=
Module[
{\[Alpha]=-0.2679491924311228`},
(0.28867513459481303`*(#2+Reverse[#3]-#1))&[
#,
Rest[FoldList[(\[Alpha] #1+#2)&,First[#]/(1-\[Alpha]),#]],
Rest[FoldList[(\[Alpha] #1+#2)&,Last[#]/(1-\[Alpha]),Reverse[#]]]
]&[ArrayPad[img,{w},"Fixed"]]
];


BSplineInterpolationFilter1D[{3,c_?NumberQ,w_Integer:2},img_]:=
Module[
{\[Alpha]=-0.2679491924311228`},
(0.28867513459481303`*(#2+Reverse[#3]-#1))&[
#,
Rest[FoldList[(\[Alpha] #1+#2)&,c/(1-\[Alpha]),#]],
Rest[FoldList[(\[Alpha] #1+#2)&,c/(1-\[Alpha]),Reverse[#]]]
]&[ArrayPad[img,{w},c]]
];


BSplineInterpolationFilter1D[{5,Reflective,w_Integer:3},img_]:=
Module[
{\[Alpha]1=-0.04309628820326239`,n1max=5,
\[Alpha]2=-0.43057534709997025`,n2max=19},
ArrayPad[#,{w},"Reversed"]&[(-0.023684757703449577` img-0.002106796542648226` #1+0.025791554151510354` #2)&[
#1+Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,Last[#1],Reverse[img]]]],#2+Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,Last[#2],Reverse[img]]]]
]&[
Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[img,{{n1max,0}},"Reversed"]],n1max+1],
Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[img,{{n2max,0}},"Reversed"]],n2max+1]]
]
];


BSplineInterpolationFilter1D[{5,Cyclic,w_Integer:3},img_]:=
Module[
{\[Alpha]1=-0.04309628820326239`,n1max=5,
\[Alpha]2=-0.43057534709997025`,n2max=19},
ArrayPad[#,{w},"Cyclic"]&[
(-0.023684757703449577` img-0.002106796542648226` #1+0.025791554151510354` #2)&[
Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[img,{{n1max,0}},"Cyclic"]],n1max+1]+
Reverse[Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[Reverse[img],{{n1max,0}},"Cyclic"]],n1max+1]],
Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[img,{{n2max,0}},"Cyclic"]],n2max+1]+
Reverse[Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[Reverse[img],{{n2max,0}},"Cyclic"]],n2max+1]]]
]
];


BSplineInterpolationFilter1D[{5,Constant,w_Integer:3},img_]:=
Module[
{\[Alpha]1=-0.04309628820326239`,
\[Alpha]2=-0.43057534709997025`},
(-0.023684757703449577` #1-0.002106796542648226` #2+0.025791554151510354` #3)&[
#,
Rest[FoldList[(\[Alpha]1 #1+#2)&,First[#]/(1-\[Alpha]1),#]]+
Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,Last[#]/(1-\[Alpha]1),Reverse[#]]]],
Rest[FoldList[(\[Alpha]2 #1+#2)&,First[#]/(1-\[Alpha]2),#]]+
Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,Last[#]/(1-\[Alpha]2),Reverse[#]]]]
]&[ArrayPad[img,{w},"Fixed"]]
];


BSplineInterpolationFilter1D[{5,c_?NumberQ,w_Integer:3},img_]:=
Module[
{\[Alpha]1=-0.04309628820326239`,
\[Alpha]2=-0.43057534709997025`},
(-0.023684757703449577` #1-0.002106796542648226` #2+0.025791554151510354` #3)&[
#,
Rest[FoldList[(\[Alpha]1 #1+#2)&,c/(1-\[Alpha]1),#]]+
Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,c/(1-\[Alpha]1),Reverse[#]]]],
Rest[FoldList[(\[Alpha]2 #1+#2)&,c/(1-\[Alpha]2),#]]+
Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,c/(1-\[Alpha]2),Reverse[#]]]]
]&[ArrayPad[img,{w},c]]
];


BSplineInterpolationFilter1D[{7,Reflective,w_Integer:4},img_]:=
Module[
{\[Alpha]1=-0.009148694809608277`,n1max=4,
\[Alpha]2=-0.12255461519232669`,n2max=8,
\[Alpha]3=-0.5352804307964383`,n3max=26},
ArrayPad[#,{w},"Reversed"]&[(-0.000985066048869381` img+8.470592879244762`*^-7 #1-0.00020948815361334196` #2+0.0011937071431947985` #3)&[
#1+Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,Last[#1],Reverse[img]]]],#2+Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,Last[#2],Reverse[img]]]],
#3+Reverse[Rest[FoldList[(\[Alpha]3 #1+#2)&,Last[#3],Reverse[img]]]]
]&[
Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[img,{{n1max,0}},"Reversed"]],n1max+1],
Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[img,{{n2max,0}},"Reversed"]],n2max+1],
Drop[FoldList[(\[Alpha]3 #1+#2)&,0,ArrayPad[img,{{n3max,0}},"Reversed"]],n3max+1]]
]
];


BSplineInterpolationFilter1D[{7,Cyclic,w_Integer:4},img_]:=
Module[
{\[Alpha]1=-0.009148694809608277`,n1max=4,
\[Alpha]2=-0.12255461519232669`,n2max=8,
\[Alpha]3=-0.5352804307964383`,n3max=26},
ArrayPad[#,{w},"Cyclic"]&[
(-0.000985066048869381` img+8.470592879244762`*^-7 #1-0.00020948815361334196` #2+0.0011937071431947985` #3)&[
Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[img,{{n1max,0}},"Cyclic"]],n1max+1]+
Reverse[Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[Reverse[img],{{n1max,0}},"Cyclic"]],n1max+1]],
Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[img,{{n2max,0}},"Cyclic"]],n2max+1]+
Reverse[Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[Reverse[img],{{n2max,0}},"Cyclic"]],n2max+1]],
Drop[FoldList[(\[Alpha]3 #1+#2)&,0,ArrayPad[img,{{n3max,0}},"Cyclic"]],n3max+1]+
Reverse[Drop[FoldList[(\[Alpha]3 #1+#2)&,0,ArrayPad[Reverse[img],{{n3max,0}},"Cyclic"]],n3max+1]]]
]
];


BSplineInterpolationFilter1D[{7,Constant,w_Integer:4},img_]:=
Module[
{\[Alpha]1=-0.009148694809608277`,
\[Alpha]2=-0.12255461519232669`,
\[Alpha]3=-0.5352804307964383`},
(-0.000985066048869381` #1+8.470592879244762`*^-7 #2-0.00020948815361334196` #3+0.0011937071431947985` #4)&[
#,
Rest[FoldList[(\[Alpha]1 #1+#2)&,First[#]/(1-\[Alpha]1),#]]+
Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,Last[#]/(1-\[Alpha]1),Reverse[#]]]],
Rest[FoldList[(\[Alpha]2 #1+#2)&,First[#]/(1-\[Alpha]2),#]]+
Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,Last[#]/(1-\[Alpha]2),Reverse[#]]]],
Rest[FoldList[(\[Alpha]3 #1+#2)&,First[#]/(1-\[Alpha]3),#]]+
Reverse[Rest[FoldList[(\[Alpha]3 #1+#2)&,Last[#]/(1-\[Alpha]3),Reverse[#]]]]
]&[ArrayPad[img,{w},"Fixed"]]
];


BSplineInterpolationFilter1D[{7,c_?NumberQ,w_Integer:4},img_]:=
Module[
{\[Alpha]1=-0.009148694809608277`,
\[Alpha]2=-0.12255461519232669`,
\[Alpha]3=-0.5352804307964383`},
(-0.000985066048869381` #1+8.470592879244762`*^-7 #2-0.00020948815361334196` #3+0.0011937071431947985` #4)&[
#,
Rest[FoldList[(\[Alpha]1 #1+#2)&,c/(1-\[Alpha]1),#]]+
Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,c/(1-\[Alpha]1),Reverse[#]]]],
Rest[FoldList[(\[Alpha]2 #1+#2)&,c/(1-\[Alpha]2),#]]+
Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,c/(1-\[Alpha]2),Reverse[#]]]],
Rest[FoldList[(\[Alpha]3 #1+#2)&,c/(1-\[Alpha]3),#]]+
Reverse[Rest[FoldList[(\[Alpha]3 #1+#2)&,c/(1-\[Alpha]3),Reverse[#]]]]
]&[ArrayPad[img,{w},c]]
];


BSplineInterpolationFilter1D[{9,Reflective,w_Integer:5},img_]:=
Module[
{\[Alpha]1=-0.002121306903180818`,n1max=3,
\[Alpha]2=-0.04322260854048175`,n2max=5,
\[Alpha]3=-0.2017505201931532`,n3max=10,
\[Alpha]4=-0.6079973891686256`,n4max=32},
ArrayPad[#,{w},"Reversed"]&[(-0.000025453882305777692` img-2.163545673286295`*^-11  #1+2.561818738752173`*^-7  #2-8.614411452377346`*^-6 #3+0.00003381213351973659` #4)&[
#1+Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,Last[#1],Reverse[img]]]],#2+Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,Last[#2],Reverse[img]]]],
#3+Reverse[Rest[FoldList[(\[Alpha]3 #1+#2)&,Last[#3],Reverse[img]]]],
#4+Reverse[Rest[FoldList[(\[Alpha]4 #1+#2)&,Last[#4],Reverse[img]]]]
]&[
Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[img,{{n1max,0}},"Reversed"]],n1max+1],
Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[img,{{n2max,0}},"Reversed"]],n2max+1],
Drop[FoldList[(\[Alpha]3 #1+#2)&,0,ArrayPad[img,{{n3max,0}},"Reversed"]],n3max+1],
Drop[FoldList[(\[Alpha]4 #1+#2)&,0,ArrayPad[img,{{n4max,0}},"Reversed"]],n4max+1]]
]
];


BSplineInterpolationFilter1D[{9,Cyclic,w_Integer:5},img_]:=
Module[
{\[Alpha]1=-0.002121306903180818`,n1max=3,
\[Alpha]2=-0.04322260854048175`,n2max=5,
\[Alpha]3=-0.2017505201931532`,n3max=10,
\[Alpha]4=-0.6079973891686256`,n4max=32},
ArrayPad[#,{w},"Cyclic"]&[(-0.000025453882305777692` img-2.163545673286295`*^-11 #1+2.561818738752173`*^-7 #2-8.614411452377346`*^-6 #3+0.00003381213351973659` #4)&[
Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[img,{n1max,0},"Cyclic"]],n1max+1]+
Reverse[Drop[FoldList[(\[Alpha]1 #1+#2)&,0,ArrayPad[Reverse[img],{n1max,0},"Cyclic"]],n1max+1]],
Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[img,{n2max,0},"Cyclic"]],n2max+1]+
Reverse[Drop[FoldList[(\[Alpha]2 #1+#2)&,0,ArrayPad[Reverse[img],{n2max,0},"Cyclic"]],n2max+1]],
Drop[FoldList[(\[Alpha]3 #1+#2)&,0,ArrayPad[img,{n3max,0},"Cyclic"]],n3max+1]+
Reverse[Drop[FoldList[(\[Alpha]3 #1+#2)&,0,ArrayPad[Reverse[img],{n3max,0},"Cyclic"]],n3max+1]],
Drop[FoldList[(\[Alpha]4 #1+#2)&,0,ArrayPad[img,{n4max,0},"Cyclic"]],n4max+1]+
Reverse[Drop[FoldList[(\[Alpha]4 #1+#2)&,0,ArrayPad[Reverse[img],{n4max,0},"Cyclic"]],n4max+1]]]
]
];


BSplineInterpolationFilter1D[{9,Constant,w_Integer:5},img_]:=
Module[
{\[Alpha]1=-0.002121306903180818`,
\[Alpha]2=-0.04322260854048175`,
\[Alpha]3=-0.2017505201931532`,
\[Alpha]4=-0.6079973891686256`},
(-0.000025453882305777692` #1-2.163545673286295`*^-11 #2+2.561818738752173`*^-7 #3-8.614411452377346`*^-6 #4+0.00003381213351973659` #5)&[
#,
Rest[FoldList[(\[Alpha]1 #1+#2)&,First[#]/(1-\[Alpha]1),#]]+
Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,Last[#]/(1-\[Alpha]1),Reverse[#]]]],
Rest[FoldList[(\[Alpha]2 #1+#2)&,First[#]/(1-\[Alpha]2),#]]+
Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,Last[#]/(1-\[Alpha]2),Reverse[#]]]],
Rest[FoldList[(\[Alpha]3 #1+#2)&,First[#]/(1-\[Alpha]3),#]]+
Reverse[Rest[FoldList[(\[Alpha]3 #1+#2)&,Last[#]/(1-\[Alpha]3),Reverse[#]]]],Rest[FoldList[(\[Alpha]4 #1+#2)&,First[#]/(1-\[Alpha]4),#]]+
Reverse[Rest[FoldList[(\[Alpha]4 #1+#2)&,Last[#]/(1-\[Alpha]4),Reverse[#]]]]
]&[ArrayPad[img,{w},"Fixed"]]
];


BSplineInterpolationFilter1D[{9,c_?NumberQ,w_Integer:5},img_]:=
Module[
{\[Alpha]1=-0.002121306903180818`,
\[Alpha]2=-0.04322260854048175`,
\[Alpha]3=-0.2017505201931532`,
\[Alpha]4=-0.6079973891686256`},
(-0.000025453882305777692` #1-2.163545673286295`*^-11 #2+2.561818738752173`*^-7 #3-8.614411452377346`*^-6 #4+0.00003381213351973659` #5)&[
#,
Rest[FoldList[(\[Alpha]1 #1+#2)&,c/(1-\[Alpha]1),#]]+
Reverse[Rest[FoldList[(\[Alpha]1 #1+#2)&,c/(1-\[Alpha]1),Reverse[#]]]],
Rest[FoldList[(\[Alpha]2 #1+#2)&,c/(1-\[Alpha]2),#]]+
Reverse[Rest[FoldList[(\[Alpha]2 #1+#2)&,c/(1-\[Alpha]2),Reverse[#]]]],Rest[FoldList[(\[Alpha]3 #1+#2)&,c/(1-\[Alpha]3),#]]+
Reverse[Rest[FoldList[(\[Alpha]3 #1+#2)&,c/(1-\[Alpha]3),Reverse[#]]]],
Rest[FoldList[(\[Alpha]4 #1+#2)&,c/(1-\[Alpha]4),#]]+
Reverse[Rest[FoldList[(\[Alpha]4 #1+#2)&,c/(1-\[Alpha]4),Reverse[#]]]]
]&[ArrayPad[img,{w},c]]
];


BSplineInterpolationFilter[nn_Integer,orders:{(1|3|5|7|9)..},boundaries:{(Reflective|Cyclic|Constant|_?NumberQ)..}][img_List]:=
Module[
{n = Min[nn,ArrayDepth[img]],shift,tmp=img,boundaryList,orderList,j},
boundaryList=PadRight[boundaries,n,Last[boundaries]];
orderList=PadRight[orders,n,Last[orders]];
shift=RotateRight[Range[n]];
Do[
tmp=Transpose[BSplineInterpolationFilter1D[{orderList[[j]],boundaryList[[j]]},tmp],shift],
{j,n}
];
tmp
]


Options[ImageInterpolation]={ImageBoundary->Reflective,InterpolationOrder ->3};


ImageInterpolation::notimpl= "ImageInterpolation is not implemented for these parameters."


ImageInterpolation[img_,opts___?OptionQ]:=ImageInterpolation[img,0,opts];

ImageInterpolation[img_,offValue_?NumberQ,opts___?OptionQ]:=
Module[
{rank=ArrayDepth[img],dims= Reverse[Dimensions[img]],
boundary=ImageBoundary/.{opts}/.Options[ImageInterpolation],
order=InterpolationOrder/.{opts}/.Options[ImageInterpolation]},
If[Head[order]===List,order=Max[order]];
If[
MatchQ[boundary,None|Cyclic|Reflective|Constant|_?NumberQ],
boundary=Table[boundary,{rank}]/. Truncate-> 0
];
Switch[
{rank,order,boundary},
{1,1|3|5|7|9,{Reflective|Cyclic|Constant|_?NumberQ}},
InterpolatingImage[
Map[{1,#}&,dims],boundary,offValue,order,{0},rank,dims,NBSplineInterpolationFilter1D[Prepend[boundary,order]][img]
],
{_Integer?(0<#<4&),(1|3|5|7|9),{(Reflective|Cyclic|Constant|_?NumberQ)..}},
InterpolatingImage[
Map[{1,#}&,dims],boundary,offValue,order,Table[0,{rank}],rank,dims,BSplineInterpolationFilter[rank,{order},Reverse[boundary]][img]
],
{_,_,_},Message[ImageInterpolation::notimpl];Return[$Failed]
]
]



Format[
InterpolatingImage[
domain:{{_,_}..},
boundary:{(None|Cyclic|Reflective|Constant|_?NumberQ)..},
offcolor_?NumberQ,
order:_Integer?NonNegative,
derivorders:{__Integer?NonNegative}, 
rank_Integer?Positive,
dims:{__Integer?Positive},
data_List]]:=Row[{"InterpolatingImage","[",domain,", ",Switch[order,0,"Nearest Neighbor",1,"Linear", 2,"Quadratic",3,"Cubic",4,"Quartic",5,"Quintic",5,"Sextic",7,"Septic",8,"Octic",9,"Nonic"],", ",derivorders,", ",boundary,", ","<>","]"}]


InterpolatingImage/: 
HoldPattern[Derivative[ds__Integer?NonNegative][InterpolatingImage[
domain:{{_,_}..},
boundary:{(None|Cyclic|Reflective|Constant|_?NumberQ)..},
offcolor_?NumberQ,
order:_Integer?NonNegative,
derivorders:{__Integer?NonNegative}, 
rank_Integer?Positive,
dims:{__Integer?Positive},
data_List]]]:=
InterpolatingImage[domain,boundary,offcolor,order,derivorders+{ds},rank,dims,data]/;Length[derivorders] === Length[{ds}]; 


BSplineFilter[1,d_]={{1-d,d},{-1,1}};


MonicInterpolation[1,{kx_Integer}/;0<=kx<=1]:=
MonicInterpolation[1,{kx}]=
Compile[
{{img,_Real,1},{off, _Real},{nx, _Integer},{x, _Real}},
Block[
{x0 = Floor[x], dx},
dx = x - x0;
If[
0.5<=x<=nx+0.5,
Take[img,{x0+1,x0+2}].#1,
off
]
]
]&[BSplineFilter[1,dx][[kx+1]]];


MonicInterpolation[1,{ks_Integer?NonNegative}/; ks>=2]=
Compile[
{{img,_Real,1},{off, _Real},{nx, _Integer},{x, _Real}},
If[
0.5<=x<=nx+0.5,
0.0,
off
]
];


MonicInterpolation[2,{kx_Integer,ky_Integer}/;(0<=kx<=1 \[And] 0<=ky<=1)]:=
MonicInterpolation[2,{kx,ky}]=
Compile[
{{img,_Real,2},{off, _Real},{nx, _Integer},{ny, _Integer},{x, _Real},{y, _Real}},
Block[
{x0 = Floor[x], dx ,y0 = Floor[y], dy },
dx = x - x0;dy = y - y0;
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5,
#2.Take[img,{y0+1,y0+2},{x0+1,x0+2}].#1,
off
]
]
]&[BSplineFilter[1,dx][[kx+1]],BSplineFilter[1,dy][[ky+1]]];


MonicInterpolation[2,{ks__Integer?NonNegative}/; Max[ks]>=2]=
Compile[
{{img,_Real,2},{off, _Real},{nx, _Integer},{ny, _Integer},{x, _Real},{y, _Real}},
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5,
0.0,
off
]
];


MonicInterpolation[3,{kx_Integer,ky_Integer,kz_Integer}/;(0<=kx<=1 \[And] 0<=ky<=1 \[And] 0<=kz<=1)]:=
MonicInterpolation[3,{kx,ky,kz}]=
Compile[
{{img,_Real,3},{off, _Real},{nx, _Integer},{ny, _Integer},{nz, _Integer},{x, _Real},{y, _Real},{z, _Real}},
Block[
{x0 = Floor[x], dx ,y0 = Floor[y], dy,z0 = Floor[z], dz },
dx = x - x0;dy = y - y0;dz = z - z0;
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5 \[And] 0.5<=z<=nz+0.5,
((Take[img,{z0+1,z0+2},{y0+1,y0+2},{x0+1,x0+2}].#1).#2).#3,
off
]
]
]&[BSplineFilter[1,dx][[kx+1]],BSplineFilter[1,dy][[ky+1]],BSplineFilter[1,dz][[kz+1]]];


MonicInterpolation[3,{ks__Integer?NonNegative}/; Max[ks]>=2]=
Compile[
{{img,_Real,3},{off, _Real},{nx, _Integer},{ny, _Integer},{nz, _Integer},{x, _Real},{y, _Real},{z, _Real}},
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5 \[And] 0.5<=z<=nz+0.5,
0.0,
off
]
];


InterpolatingImage[_,_,off_,{1},ds_List,1,{xn_},data_][x_?NumberQ]:=
MonicInterpolation[1,ds][data,off,xn,x]


InterpolatingImage[_,_,off_,{1},ds_List,2,{xn_,yn_},data_][x_?NumberQ,y_?NumberQ]:=
MonicInterpolation[2,ds][data,off,xn,yn,x,y]


InterpolatingImage[_,_,off_,{1},ds_List,3,{xn_,yn_,zn_},data_][x_?NumberQ,y_?NumberQ,z_?NumberQ]:=
MonicInterpolation[3,ds][data,off,xn,yn,zn,x,y,z]


BSplineFilter[3,d_] ={{(1-d)^3,4+3 (-2+d) d^2,1+3 d (1+d-d^2),d^3},{-(-1+d)^2,d (-4+3 d),1+2 d-3 d^2,d^2},{1-d,-2+3 d,1-3 d,d},{-1,3,-3,1}};


CubicInterpolation[1,{kx_Integer}/;0<=kx<=3]:=
CubicInterpolation[1,{kx}]=
Compile[
{{img,_Real,1},{off, _Real},{nx, _Integer},{x, _Real}},
Block[
{x0 = Floor[x], dx },
dx = x - x0;
If[
0.5<=x<=nx+0.5,
#1*(Take[img,{x0+1,x0+4}].#2),
off
]
]
]&[3!/(3-kx)!,BSplineFilter[3,dx][[kx+1]]];


CubicInterpolation[1,{ks_Integer?NonNegative}/; ks>=4]=
Compile[
{{img,_Real,1},{off, _Real},{nx, _Integer},{x, _Real}},
If[
0.5<=x<=nx+0.5,
0.0,
off
]
];


CubicInterpolation[2,{kx_Integer,ky_Integer}/;(0<=kx<=3 \[And] 0<=ky<=3)]:=
CubicInterpolation[2,{kx,ky}]=
Compile[
{{img,_Real,2},{off, _Real},{nx, _Integer},{ny, _Integer},{x, _Real},{y, _Real}},
Block[
{x0 = Floor[x], dx ,y0 = Floor[y], dy },
dx = x - x0;dy = y - y0;
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5,
#1*(#3.Take[img,{y0+1,y0+4},{x0+1,x0+4}].#2),
off
]
]
]&[(3!)^2/((3-kx)! (3-ky)!),BSplineFilter[3,dx][[kx+1]],BSplineFilter[3,dy][[ky+1]]];


CubicInterpolation[2,{ks__Integer?NonNegative}/; Max[ks]>=4]=
Compile[
{{img,_Real,2},{off, _Real},{nx, _Integer},{ny, _Integer},{x, _Real},{y, _Real}},
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5,
0.0,
off
]
];


CubicInterpolation[3,{kx_Integer,ky_Integer,kz_Integer}/;(0<=kx<=3 \[And] 0<=ky<=3 \[And] 0<=kz<=3)]:=
CubicInterpolation[3,{kx,ky,kz}]=
Compile[
{{img,_Real,3},{off, _Real},{nx, _Integer},{ny, _Integer},{nz, _Integer},{x, _Real},{y, _Real},{z, _Real}},
Block[
{x0 = Floor[x], dx ,y0 = Floor[y], dy,z0 = Floor[z], dz },
dx = x - x0;dy = y - y0;dz = z - z0;
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5 \[And] 0.5<=z<=nz+0.5,
#1*(((Take[img,{z0+1,z0+4},{y0+1,y0+4},{x0+1,x0+4}].#2).#3).#4),
off
]
]
]&[(3!)^3/((3-kx)! (3-ky)! (3-kz)!),BSplineFilter[3,dx][[kx+1]],BSplineFilter[3,dy][[ky+1]],BSplineFilter[3,dz][[kz+1]]];


CubicInterpolation[3,{ks__Integer?NonNegative}/; Max[ks]>=4]=
Compile[
{{img,_Real,3},{off, _Real},{nx, _Integer},{ny, _Integer},{nz, _Integer},{x, _Real},{y, _Real},{z, _Real}},
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5 \[And] 0.5<=z<=nz+0.5,
0.0,
off
]
];


InterpolatingImage[_,_,off_,3,ds_List,1,{xn_},data_][x_?NumberQ]:=
CubicInterpolation[1,ds][data,off,xn,x]


InterpolatingImage[_,_,off_,3,ds_List,2,{xn_,yn_},data_][x_?NumberQ,y_?NumberQ]:=
CubicInterpolation[2,ds][data,off,xn,yn,x,y]


InterpolatingImage[_,_,off_,3,ds_List,3,{xn_,yn_,zn_},data_][x_?NumberQ,y_?NumberQ,z_?NumberQ]:=
CubicInterpolation[3,ds][data,off,xn,yn,zn,x,y,z]


BSplineFilter[5,d_] ={{(1-d)^5,26+5 d (-10+d (4+(-2+d)^2 d)),66-10 d^2 (6+(-3+d) d^2),26+10 d (5+d (2+d (-2+(-2+d) d))),1+5 d (1+d (2+d (2+d-d^2))),d^5},{-(-1+d)^4,-10+d (8+(-2+d) d (-6+5 d)),-2 d (12+d^2 (-12+5 d)),2 (5+(-2+d) d (-2+d (2+5 d))),1+d (4+d (6+(4-5 d) d)),d^4},{(1-d)^3,2+d (6+d (-12+5 d)),-2 (3+d^2 (-9+5 d)),2 (1+d (-3+d (-6+5 d))),1+d (3+(3-5 d) d),d^3},{-(-1+d)^2,2+d (-8+5 d),2 (6-5 d) d,2 (-1+d) (1+5 d),1+(2-5 d) d,d^2},{1-d,-4+5 d,6-10 d,-4+10 d,1-5 d,d},{-1,5,-10,10,-5,1}};


QuinticInterpolation[1,{kx_Integer}/;0<=kx<=5]:=
QuinticInterpolation[1,{kx}]=
Compile[
{{img,_Real,1},{off, _Real},{nx, _Integer},{x, _Real}},
Block[
{x0 = Floor[x], dx},
dx = x - x0;
If[
0.5<=x<=nx+0.5 ,
#1*(Take[img,{x0+1,x0+6}].#2),
off
]
]
]&[5!/(5-kx)!,BSplineFilter[5,dx][[kx+1]]];


QuinticInterpolation[1,{kx_Integer?NonNegative}/; kx>=6]=
Compile[
{{img,_Real,1},{off, _Real},{nx, _Integer},{x, _Real}},
If[
0.5<=x<=nx+0.5,
0.0,
off
]
];


QuinticInterpolation[2,{kx_Integer,ky_Integer}/;(0<=kx<=5 \[And] 0<=ky<=5)]:=
QuinticInterpolation[2,{kx,ky}]=
Compile[
{{img,_Real,2},{off, _Real},{nx, _Integer},{ny, _Integer},{x, _Real},{y, _Real}},
Block[
{x0 = Floor[x], dx ,y0 = Floor[y], dy },
dx = x - x0;dy = y - y0;
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5,
#1*(#3.Take[img,{y0+1,y0+6},{x0+1,x0+6}].#2),
off
]
]
]&[(5!)^2/((5-kx)! (5-ky)!),BSplineFilter[5,dx][[kx+1]],BSplineFilter[5,dy][[ky+1]]];


QuinticInterpolation[2,{ks__Integer?NonNegative}/; Max[ks]>=6]=
Compile[
{{img,_Real,2},{off, _Real},{nx, _Integer},{ny, _Integer},{x, _Real},{y, _Real}},
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5,
0.0,
off
]
];


QuinticInterpolation[3,{kx_Integer,ky_Integer,kz_Integer}/;(0<=kx<=5 \[And] 0<=ky<=5 \[And] 0<=kz<=5)]:=
QuinticInterpolation[3,{kx,ky,kz}]=
Compile[
{{img,_Real,3},{off, _Real},{nx, _Integer},{ny, _Integer},{nz, _Integer},{x, _Real},{y, _Real},{z, _Real}},
Block[
{x0 = Floor[x], dx ,y0 = Floor[y], dy  ,z0 = Floor[z], dz},
dx = x - x0;dy = y - y0;dz = z - z0;
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5 \[And] 0.5<=z<=nz+0.5,
#1*(((Take[img,{z0+1,z0+6},{y0+1,y0+6},{x0+1,x0+6}].#2).#3).#4),
off
]
]
]&[(5!)^3/((5-kx)! (5-ky)! (5-kz)!),BSplineFilter[5,dx][[kx+1]],BSplineFilter[5,dy][[ky+1]],BSplineFilter[5,dz][[kz+1]]];


QuinticInterpolation[3,{ks__Integer?NonNegative}/; Max[ks]>=6]=
Compile[
{{img,_Real,3},{off, _Real},{nx, _Integer},{ny, _Integer},{nz, _Integer},{x, _Real},{y, _Real},{z, _Real}},
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5 \[And] 0.5<=z<=nz+0.5,
0.0,
off
]
];


InterpolatingImage[_,_,off_,5,ds_List,1,{xn_},data_][x_?NumberQ]:=
QuinticInterpolation[1,ds][data,off,xn,x]


InterpolatingImage[_,_,off_,5,ds_List,2,{xn_,yn_},data_][x_?NumberQ,y_?NumberQ]:=
QuinticInterpolation[2,ds][data,off,xn,yn,x,y]


InterpolatingImage[_,_,off_,5,ds_List,3,{xn_,yn_,zn_},data_][x_?NumberQ,y_?NumberQ,z_?NumberQ]:=
QuinticInterpolation[3,ds][data,off,xn,yn,yn,x,y,z]


BSplineFilter[7,d_] ={{(1-d)^7,120+7 d (-56+d (72+d (-40+d^2 (12+(-6+d) d)))),1191-7 d (245+d (-45+d (-95+3 d (15+d (5+(-5+d) d))))),2416+35 d^2 (-48+16 d^2-4 d^4+d^5),1191-35 d (-49+d (-9+d (19+(-3+d) d (-3+d^2)))),120+7 d (56+d (72+d (40+3 d^2 (-4+(-2+d) d)))),1+7 d (1+d (3+d (5+d (5+d (3+d-d^2))))),d^7},{-(-1+d)^6,(-2+d^2) (28+d (-72+d (74+d (-36+7 d)))),-245+3 d (30+d (95-d (60+d (25+d (-30+7 d))))),5 d (-96+64 d^2-24 d^4+7 d^5),-5 (-1+d) (1+d) (49+d (18+d (-8+d (-18+7 d)))),56+3 d (48+d (40+d^2 (-20+d (-12+7 d)))),(1-(-2+d) d) (1+d (4+d (8+d (8+7 d)))),d^6},{(1-d)^5,24+d (-40+d^2 (40+d (-30+7 d))),15+d (95-d (90+d (50+3 d (-25+7 d)))),5 (-16+32 d^2-20 d^4+7 d^5),15-5 d (19+(-1+d) d (-18+d (-8+7 d))),24+d (40+d^2 (-40+3 d (-10+7 d))),1+d (5+d (10+d (10+(5-7 d) d))),d^5},{-(-1+d)^4,-8+d^2 (24+d (-24+7 d)),19-3 d (12+d (10+d (-20+7 d))),d (64+5 d^2 (-16+7 d)),-19+d (-36+5 d (6+(12-7 d) d)),8+3 d^2 (-8+d (-8+7 d)),1+d (4+d (6+(4-7 d) d)),d^4},{(1-d)^3,d (12+d (-18+7 d)),-3 (-1+d) (-3+d (-8+7 d)),16+5 d^2 (-12+7 d),-9+5 d (3+(9-7 d) d),3 d (-4+d (-6+7 d)),1+d (3+(3-7 d) d),d^3},{-(-1+d)^2,4+d (-12+7 d),-5+3 (10-7 d) d,5 d (-8+7 d),-5 (-1+d) (1+7 d),-4+3 d (-4+7 d),1+(2-7 d) d,d^2},{1-d,-6+7 d,15-21 d,5 (-4+7 d),15-35 d,-6+21 d,1-7 d,d},{-1,7,-21,35,-35,21,-7,1}};


SepticInterpolation[1,{kx_Integer}/;0<=kx<=7]:=
SepticInterpolation[1,{kx}]=
Compile[
{{img,_Real,1},{off, _Real},{nx, _Integer},{x, _Real}},
Block[
{x0 = Floor[x], dx},
dx = x - x0;
If[
0.5<=x<=nx+0.5,
#1*(Take[img,{x0+1,x0+8}].#2),
off
]
]
]&[7!/(7-kx)!,BSplineFilter[7,dx][[kx+1]]];


SepticInterpolation[1,{kx_Integer?NonNegative}/; kx>=8]=
Compile[
{{img,_Real,1},{off, _Real},{nx, _Integer},{x, _Real}},
If[
0.5<=x<=nx+0.5,
0.0,
off
]
];


SepticInterpolation[2,{kx_Integer,ky_Integer}/;(0<=kx<=7 \[And] 0<=ky<=7)]:=
SepticInterpolation[2,{kx,ky}]=
Compile[
{{img,_Real,2},{off, _Real},{nx, _Integer},{ny, _Integer},{x, _Real},{y, _Real}},
Block[
{x0 = Floor[x], dx ,y0 = Floor[y], dy },
dx = x - x0;dy = y - y0;
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5,
#1*(#3.Take[img,{y0+1,y0+8},{x0+1,x0+8}].#2),
off
]
]
]&[(7!)^2/((7-kx)! (7-ky)!),BSplineFilter[7,dx][[kx+1]],BSplineFilter[7,dy][[ky+1]]];


SepticInterpolation[2,{ks__Integer?NonNegative}/; Max[ks]>=8]=
Compile[
{{img,_Real,2},{off, _Real},{nx, _Integer},{ny, _Integer},{x, _Real},{y, _Real}},
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5,
0.0,
off
]
];


SepticInterpolation[3,{kx_Integer,ky_Integer,kz_Integer}/;(0<=kx<=7 \[And] 0<=ky<=7 \[And] 0<=kz<=7)]:=
SepticInterpolation[3,{kx,ky,kz}]=
Compile[
{{img,_Real,3},{off, _Real},{nx, _Integer},{ny, _Integer},{nz, _Integer},{x, _Real},{y, _Real},{z, _Real}},
Block[
{x0 = Floor[x], dx ,y0 = Floor[y], dy  ,z0 = Floor[z], dz},
dx = x - x0;dy = y - y0;dz = z - z0;
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5 \[And] 0.5<=z<=nz+0.5,
#1*(((Take[img,{z0+1,z0+8},{y0+1,y0+8},{x0+1,x0+8}].#2).#3).#4),
off
]
]
]&[(7!)^3/((7-kx)! (7-ky)! (7-kz)!),BSplineFilter[7,dx][[kx+1]],BSplineFilter[7,dy][[ky+1]],BSplineFilter[7,dz][[kz+1]]];


SepticInterpolation[3,{ks__Integer?NonNegative}/; Max[ks]>=8]=
Compile[
{{img,_Real,3},{off, _Real},{nx, _Integer},{ny, _Integer},{nz, _Integer},{x, _Real},{y, _Real},{z, _Real}},
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5 \[And] 0.5<=z<=nz+0.5,
0.0,
off
]
];


InterpolatingImage[_,_,off_,7,ds_List,1,{xn_},data_][x_?NumberQ]:=
SepticInterpolation[1,ds][data,off,xn,x]


InterpolatingImage[_,_,off_,7,ds_List,2,{xn_,yn_},data_][x_?NumberQ,y_?NumberQ]:=
SepticInterpolation[2,ds][data,off,xn,yn,x,y]


InterpolatingImage[_,_,off_,7,ds_List,3,{xn_,yn_,zn_},data_][x_?NumberQ,y_?NumberQ,z_?NumberQ]:=
SepticInterpolation[3,ds][data,off,xn,yn,yn,x,y,z]


BSplineFilter[9,d_] ={{(1-d)^9,502+3 d (-738+d (1416+d (-1512+d (924+d (-252+d (-56+3 d (24+(-8+d) d))))))),-2 (-7304+3 d (6069+2 d (-2856+d (938+d (336+d (-357+d (56+3 d (14+(-7+d) d)))))))),2 (44117+21 d (-2427+2 d (66+d (434+d (-129+d (-69+d (34+d (6+(-6+d) d)))))))),156190-42 d^2 (2100+d^2 (-570+d^2 (100+3 (-5+d) d^2))),2 (44117+21 d (2427+d (132+d (-868+d (-258+d (138+d (68+3 d (-4+(-4+d) d)))))))),14608-42 d (-867+2 d (-408+d (-134+d (48+d (51+(-4+d) (-1+d) d (2+d)))))),502+6 d (369+2 d (354+d (378+d (231+d (63+d (-14+3 d (-6+(-2+d) d))))))),1+3 d (3+d (12+d (28+d (42+d (42+d (28+3 d (4+d-d^2))))))),d^9},{-(-1+d)^8,-246+d (944+d (-1512+d (1232+d (-420+d (-112+d (168+d (-64+9 d))))))),-2 (2023+2 d (-1904+d (938+d (448+d (-595+d (112+d (98+d (-56+9 d)))))))),14 (-809+2 d (44+d (434+d (-172+d (-115+d (68+d (14+d (-16+3 d)))))))),-14 d (1400-760 d^2+200 d^4-40 d^6+9 d^7),14 (-1+d) (-809+d (-897+d (-29+d (315+d (85+d (-51+d (-23+9 d))))))),-14 (-289+2 d (-272+d (-134+d (64+d (85+d (16+d (-14+d (-8+3 d)))))))),2 (123+2 d (236+d (378+d (308+d (105+d (-28+d (-42+d (-16+9 d)))))))),1+d (8+d (28+d (56+d (70+d (56+d (28+(8-9 d) d)))))),d^8},{-(-1+d)^7,118+d (-378+d (462+d (-210+d (-70+d (126+d (-56+9 d)))))),-2 (-476+d (469+d (336+d (-595+d (140+d (147+2 d (-49+9 d))))))),14 (11+d (217+d (-129+d (-115+d (85+d (21-28 d+6 d^2)))))),-14 (175-285 d^2+125 d^4-35 d^6+9 d^7),14 (11+d (-217+d (-129+d (115+d (85+d (-21+d (-28+9 d))))))),-14 (-68+d (-67+d (48+d (85+d (20+d (-21+2 d (-7+3 d))))))),2 (59+d (189+d (231+d (105+d (-35+d (-63+2 d (-14+9 d))))))),1+d (7+d (21+d (35+d (35+d (21+(7-9 d) d))))),d^7},{-(-1+d)^6,-54+d (132+d (-90+d (-40+3 d (30+d (-16+3 d))))),-2 (67+d (96+d (-255+d (80+3 d (35-28 d+6 d^2))))),2 (217+d (-258+d (-345+d (340+21 d (5+2 (-4+d) d))))),2 d (570-500 d^2+210 d^4-63 d^5),2 (-1+d) (217+d (475+d (130+21 d (-10+d (-5+3 d))))),-2 (-67+d (96+d (255+d (80+21 d (-5+2 (-2+d) d))))),2 (27+d (66+d (45+d (-20+3 d (-15-8 d+6 d^2))))),1+d (6+d (15+d (20+3 d (5+(2-3 d) d)))),d^6},{-(-1+d)^5,22+d (-30+d (-20+d (60+d (-40+9 d)))),-2 (16+d (-85+2 d (20+d (35+d (-35+9 d))))),2 (-43+d (-115+2 d (85+7 d (5+d (-10+3 d))))),-2 (-95+d^2 (250+7 d^2 (-25+9 d))),2 (-43+d (115+d (170+7 d (-10+d (-20+9 d))))),-2 (16+d (85+2 d (20+7 d (-5+d (-5+3 d))))),2 (11+d (15+2 d (-5+d (-15+d (-10+9 d))))),1+d (5+d (10+d (10+(5-9 d) d))),d^5},{-(-1+d)^4,-6+d (-8+d (36+d (-32+9 d))),-2 (-17+2 d (8+d (21+d (-28+9 d)))),2 (-23+2 d (34+7 d (3+d (-8+3 d)))),-2 d (100+7 d^2 (-20+9 d)),2 (-1+d) (-23+7 d (-13+d (-7+9 d))),-2 (17+2 d (8+7 d (-3+d (-4+3 d)))),2 (3+2 d (-2+d (-9+d (-8+9 d)))),1+d (4+d (6+(4-9 d) d)),d^4},{-(-1+d)^3,-2+3 d (6+d (-8+3 d)),-2 (-4+3 d) (-1+6 (-1+d) d),2 (17+21 d (1+2 (-2+d) d)),-2 (25+21 d^2 (-5+3 d)),2 (17+21 d (-1+d (-4+3 d))),-2 (4+21 d (-1+2 (-1+d) d)),2 (1+3 d) (-1+6 (-1+d) d),1+3 d (1+d-3 d^2),d^3},{-(-1+d)^2,6+d (-16+9 d),-2 (7+2 d (-14+9 d)),14 (1-8 d+6 d^2),14 (10-9 d) d,14 (-1+d) (1+9 d),14+28 (2-3 d) d,2 (-3+2 d (-4+9 d)),1+(2-9 d) d,d^2},{1-d,-8+9 d,28-36 d,-56+84 d,70-126 d,14 (-4+9 d),28-84 d,-8+36 d,1-9 d,d},{-1,9,-36,84,-126,126,-84,36,-9,1}};


NonicInterpolation[1,{kx_Integer}/;0<=kx<=9]:=
NonicInterpolation[1,{kx}]=
Compile[
{{img,_Real,1},{off, _Real},{nx, _Integer},{x, _Real}},
Block[
{x0 = Floor[x], dx},
dx = x - x0;
If[
0.5<=x<=nx+0.5,
#1*(Take[img,{x0+1,x0+10}].#2),
off
]
]
]&[9!/(9-kx)!,BSplineFilter[9,dx][[kx+1]]];


NonicInterpolation[1,{kx_Integer?NonNegative}/; kx>=10]=
Compile[
{{img,_Real,1},{off, _Real},{nx, _Integer},{x, _Real}},
If[
0.5<=x<=nx+0.5,
0.0,
off
]
];


NonicInterpolation[2,{kx_Integer,ky_Integer}/;(0<=kx<=9 \[And] 0<=ky<=9)]:=
NonicInterpolation[2,{kx,ky}]=
Compile[
{{img,_Real,2},{off, _Real},{nx, _Integer},{ny, _Integer},{x, _Real},{y, _Real}},
Block[
{x0 = Floor[x], dx ,y0 = Floor[y], dy },
dx = x - x0;dy = y - y0;
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5,
#1*(#3.Take[img,{y0+1,y0+10},{x0+1,x0+10}].#2),
off
]
]
]&[(9!)^2/((9-kx)! (9-ky)!),BSplineFilter[9,dx][[kx+1]],BSplineFilter[9,dy][[ky+1]]];


NonicInterpolation[2,{ks__Integer?NonNegative}/; Max[ks]>=10]=
Compile[
{{img,_Real,2},{off, _Real},{nx, _Integer},{ny, _Integer},{x, _Real},{y, _Real}},
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5,
0.0,
off
]
];


NonicInterpolation[3,{kx_Integer,ky_Integer,kz_Integer}/;(0<=kx<=9 \[And] 0<=ky<=9 \[And] 0<=kz<=9)]:=
NonicInterpolation[3,{kx,ky,kz}]=
Compile[
{{img,_Real,3},{off, _Real},{nx, _Integer},{ny, _Integer},{nz, _Integer},{x, _Real},{y, _Real},{z, _Real}},
Block[
{x0 = Floor[x], dx ,y0 = Floor[y], dy  ,z0 = Floor[z], dz},
dx = x - x0;dy = y - y0;dz = z - z0;
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5 \[And] 0.5<=z<=nz+0.5,
#1*(((Take[img,{z0+1,z0+10},{y0+1,y0+10},{x0+1,x0+10}].#2).#3).#4),
off
]
]
]&[(9!)^3/((9-kx)! (9-ky)! (9-kz)!),BSplineFilter[9,dx][[kx+1]],BSplineFilter[9,dy][[ky+1]],BSplineFilter[9,dz][[kz+1]]];


NonicInterpolation[3,{ks__Integer?NonNegative}/; Max[ks]>=10]=
Compile[
{{img,_Real,3},{off, _Real},{nx, _Integer},{ny, _Integer},{nz, _Integer},{x, _Real},{y, _Real},{z, _Real}},
If[
0.5<=x<=nx+0.5 \[And] 0.5<=y<=ny+0.5 \[And] 0.5<=z<=nz+0.5,
0.0,
off
]
];


InterpolatingImage[_,_,off_,9,ds_List,1,{xn_},data_][x_?NumberQ]:=
NonicInterpolation[1,ds][data,off,xn,x]


InterpolatingImage[_,_,off_,9,ds_List,2,{xn_,yn_},data_][x_?NumberQ,y_?NumberQ]:=
NonicInterpolation[2,ds][data,off,xn,yn,x,y]


InterpolatingImage[_,_,off_,9,ds_List,3,{xn_,yn_,zn_},data_][x_?NumberQ,y_?NumberQ,z_?NumberQ]:=
NonicInterpolation[3,ds][data,off,xn,yn,yn,x,y,z]


End[]

SetAttributes[
{ImageInterpolation,
InterpolatingImage,
NBSplineInterpolationFilter1D,
BSplineInterpolationFilter1D,
BSplineInterpolationFilter},
{Protected,ReadProtected}
];

EndPackage[]
