(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`ImageTransformation`"]={2010,8,8,21,0,0}

Protect[TimeStamp];


(*:Name:MathVisionTools`ImageTransformation`*)

(*:Author:Markus van Almsick*)

(*:Email address:M.v.Almsick@tue.nl*)

(*:Context:MathVisionTools`ImageTransformation`*)

(*:Package Version:1.6.1*)

(*:Mathematica Version:5.2*)

(*:Copyright:Copyright 2005,Technische Universiteit Eindhoven*)

(*:Title:Image Transformation*)

(*:Summary:This package implements rigid transformations of pixel/voxel arrays*)

(*:Keywords:Transformation,Translation,Rotation*)

(*:Requirements:None*)

(*:Source:None*)

(*:History:Version 1.0 by Markus van Almsick, March 2005*)
(*:History:Version 1.5 by Markus van Almsick, January 2008*)
(*:History:Version 1.6 by Markus van Almsick, September 2008*)

(*:Limitations:*)

(*:Discussion:*)

(*:To do:*)


BeginPackage["MathVisionTools`ImageTransformation`"]

Unprotect[
NConstantImageInterpolation,NConstantImageInterpolation3D,NConstant2DImageInterpolation3D,NLinearImageInterpolation,NLinearImageInterpolation3D,NLinear2DImageInterpolation3D,CubicBSplineImageInterpolationFilter,NCubicBSplineImageInterpolation,NCubicBSplineImageInterpolation3D,NCubicBSpline2DImageInterpolation3D,TranslateArray,RotateArray,ScaleArray,NLinearAffineTransform,NConstantAffineTransform,NLinearAffineTransform3D,NConstantAffineTransform3D,NLinearAffine2DTransform3D,NConsantAffine2DTransform3D,NCubicBSplineAffineTransform,NCubicBSplineAffineTransform3D,NCubicBSplineAffine2DTransform3D,PerspectiveTransformArray,ArrayInterpolation,
ConstantInterpolation, LinearInterpolation,CubicBSplineInterpolation,NCubicBSplineInterpolation
]


NConstantImageInterpolation::usage="NConstantImageInterpolation[data,x,y,xn,yn,offcol] performs a fast numerical constant interpolation of 2-dimensional image data with dimensions {xn,yn} at position {x,y}. Positions {x,y} outside the image domain render offcol."

NConstant2DImageInterpolation3D::usage="NConstant2DImageInterpolation3D[data,x,y,xn,yn,zoffcol] performs a fast numerical 2-dimensional constant interpolation of 3-dimensional image data with dimensions {xn,yn,zn} at position {x,y}. Positions {x,y} outside the image domain render offcol."

NConstantImageInterpolation3D::usage="NConstantImageInterpolation3D[data,x,y,z,xn,yn,zn,offcol] performs a fast numerical constant interpolation of 3-dimensional image data with dimensions {xn,yn,zn} at position {x,y,z}. Positions {x,y,z} outside the image domain render offcol."

NLinearImageInterpolation::usage="NLinearImageInterpolation[data,x,y,xn,yn,offcol] performs a fast numerical linear interpolation of 2-dimensional image data with dimensions {xn,yn} at position {x,y}. Positions {x,y,z} outside the image domain render offcol."

NLinear2DImageInterpolation3D::usage="NLinear2DImageInterpolation3D[data,x,y,xn,yn,zn,offcol] performs a fast numerical 2-dimensional linear interpolation of 3-dimensional image data with dimensions {xn,yn,zn} at position {x,y}. Positions {x,y} outside the image domain render offcol."

NLinearImageInterpolation3D::usage="NLinearImageInterpolation3D[data,x,y,z,xn,yn,zn,offcol] performs a fast numerical linear interpolation of 3-dimensional image data with dimensions {xn,yn,zn} at position {x,y,z}. Positions {x,y,z} outside the image domain render offcol."

CubicBSplineImageInterpolationFilter::usage=
"CubicBSplineImageInterpolationFilter[data] performs the prefiltering for a cubic B-spline interpolation with NCubicBSplineImageInterpolation for n-dimensional image data. CubicBSplineImageInterpolationFilter[data,m] filters only the first m dimensions."

NCubicBSplineImageInterpolation::usage="NCubicBSplineImageInterpolation[data,x,y,xn,yn,offcol] performs a fast numerical cubic B-spline interpolation of 2-dimensional preprocessed image data with dimensions {xn,yn} at position {x,y}. The image data need to be preprocessed by CubicBSplineImageInterpolationFilter to counteract blur. Positions {x,y} outside the image domain render offcol. Note, that the grid of the preprocessed image data is larger than the one of the original image. Nevertheless, coordinates x, y, xn, and yn refer to the original image grid."

NCubicBSplineInterpolation::usage="NCubicBSplineInterpolation[data,x,xn,offcol] performs a fast numerical cubic B-spline interpolation of 1-dimensional preprocessed data list with length xn at position x. The line data need to be preprocessed by CubicBSplineImageInterpolationFilter to counteract blur. Positions x outside the image domain render offcol. Note, that the grid of the preprocessed image data is larger than the one of the original image. Nevertheless, coordinates x and xn refer to the original line grid."

NCubicBSplineImageInterpolation3D::usage="NCubicBSplineImageInterpolation[data,x,y,z,xn,yn,zn,offcol] performs a fast numerical cubic B-spline interpolation of 3-dimensional preprocessed image data with dimensions {xn,yn,zn} at position {x,y,z}. The image data need to be preprocessed by CubicBSplineImageInterpolationFilter to counteract blur. Positions {x,y,z} outside the image domain render offcol. Note, that the grid of the preprocessed image data is larger than the one of the original image. Nevertheless, coordinates x, y, z, xn, yn, and zn refer to the original image grid."

NCubicBSpline2DImageInterpolation3D::usage=
"NLinear2DImageInterpolation3D[data,x,y,xn,yn,zn,zoffcol] performs a fast numerical 2-dimensional cubic B-spline interpolation of 3-dimensional image data with dimensions {xn,yn,zn} at position {x,y}. The image data need to be preprocessed by CubicBSplineImageInterpolationFilter[img,2] to counteract blur. Positions {x,y} outside the image domain render offcol. Note, that the grid of the preprocessed image data is larger than the one of the original image. Nevertheless, coordinates x, y, xn, and yn refer to the original image grid."

TranslateArray::usage="TranslateArray[img,{x,y},offcol:0] translates a 2-dimensional image by {x,y}. TranslateArray[img,{x,y,z},offcol:0] translates a 3-dimensional image by {x,y,z}. Pixel and voxel elements outside the image domain are set to offcol."

RotateArray::usage="RotateArray[img,\[Alpha],{x0,y0},offcol:0] rotates a 2-dimensional image by \[Alpha] around {x0,y0}. RotateArray[img,\[Alpha]] rotates the image around its center. RotateArray[img,\[Alpha],\[Beta],\[Gamma],{x0,y0,z0}] rotates a 3-dimensional image by Euler angles \[Alpha],\[Beta],\[Gamma] around {x0,y0,z0}. RotateArray[img,\[Alpha],\[Beta],\[Gamma]] rotates the image around its center. Pixel and voxel elements outside the image domain are set to offcol."

ScaleArray::usage="ScaleArray[img,s,{x0,y0},offcol:0] scales a 2-dimensional image by factor s around {x0,y0}. ScaleArray[img,{sx,sy},{x0,y0},offcol:0] scales a 2-dimensional image by factor sx in x-direction and sy in y-direction around {x0,y0}. ScaleArray[img,{sx,sy,sz},{x0,y0,z0},offcol:0] scales a 3-dimensional image by factor sx in x-direction, sy in y-direction, and sz in z-direction around {x0,y0,z0}. Pixel and voxel elements outside the image domain are set to offcol."

NCubicBSplineAffineTransform::usage=
"NCubicBSplineAffineTransform[img,x0,y0,x1,y1,rxx,rxy,ryx,ryy,offcol:0] performs an affine transformation of a 2-dimensional image using cubic B-spline interpolation. The image is first translated by {x0,y0}, transformed by (\*GridBox[{
{rxx, rxy},
{ryx, ryy}
}]), and then translated back by {x1,y1}. Pixel elements outside the image domain are set to offcol."

NConstantAffineTransform::usage="NConstantAffineTransform[img,x0,y0,x1,y1,rxx,rxy,ryx,ryy,offcol:0] performs an affine transformation of a 2-dimensional image using constant interpolation. The image is first translated by {x0,y0}, linearly transformed by (\*GridBox[{
{rxx, rxy},
{ryx, ryy}
}]), and then translated back by {x1,y1}. Pixel elements outside the image domain are set to offcol."

NLinearAffineTransform::usage="NLinearAffineTransform[img,x0,y0,x1,y1,rxx,rxy,ryx,ryy,offcol:0] performs an affine transformation of a 2-dimensional image using linear interpolation. The image is first translated by {x0,y0}, linearly transformed by (\*GridBox[{
{rxx, rxy},
{ryx, ryy}
}]), and then translated back by {x1,y1}. Pixel elements outside the image domain are set to offcol."

NCubicBSplineAffine2DTransform3D::usage=
"NCubicBSplineAffine2DTransform3D[img,x0,y0,x1,y1,rxx,rxy,ryx,ryy,offcol:0] performs an affine transformation in x-y of a 3-dimensional image using cubic B-spline interpolation. The image is first translated by (\*GridBox[{
{x0},
{y0},
{0}
}]), transformed by (\*GridBox[{
{rxx, rxy, 0},
{ryx, ryy, 0},
{0, 0, 1}
}]), and then translated back by (\*GridBox[{
{x1},
{y1},
{0}
}]). Voxel elements outside the image domain are set to offcol."

NLinearAffine2DTransform3D::usage="NLinearAffine2DTransform3D[img,x0,y0,x1,y1,rxx,rxy,ryx,ryy,offcol:0] performs an affine transformation in x-y of a 3-dimensional image using linear interpolation. The image is first translated by (\*GridBox[{
{x0},
{y0},
{0}
}]), linearly transformed by (\*GridBox[{
{rxx, rxy, 0},
{ryx, ryy, 0},
{0, 0, 1}
}]), and then translated back by (\*GridBox[{
{x1},
{y1},
{0}
}]). Voxel elements outside the image domain are set to offcol."

NConstantAffine2DTransform3D::usage="NConstantAffine2DTransform3D[img,x0,y0,x1,y1,rxx,rxy,ryx,ryy,offcol:0] performs an affine transformation in x-y of a 3-dimensional image using constant interpolation. The image is first translated by (\*GridBox[{
{x0},
{y0},
{0}
}]), linearly transformed by (\*GridBox[{
{rxx, rxy, 0},
{ryx, ryy, 0},
{0, 0, 1}
}]), and then translated back by (\*GridBox[{
{x1},
{y1},
{0}
}]). Voxel elements outside the image domain are set to offcol."

NCubicBSplineAffineTransform3D::usage=
"NCubicBSplineAffineTransform3D[img,x0,y0,z0,x1,y1,z1,rxx,rxy,rxz,ryx,ryy,ryz,rzx,rzy,rzz,offcol] performs an affine transformation of a 3-dimensional image using cubic B-spline interpolation. The image is first translated by (\*GridBox[{
{x0},
{y0},
{z0}
}]), transformed by (\*GridBox[{
{rxx, rxy, rxz},
{ryx, ryy, ryz},
{rzx, rzy, rzz}
}]), and then translated back by (\*GridBox[{
{x1},
{y1},
{z1}
}]). Voxel elements outside the image domain are set to offcol."

NLinearAffineTransform3D::usage="NLinearAffineTransform3D[img,x0,y0,z0,x1,y1,z1,rxx,rxy,rxz,ryx,ryy,ryz,rzx,rzy,rzz,offcol] performs an affine transformation of a 3-dimensional image using linear interpolation. The image is first translated by (\*GridBox[{
{x0},
{y0},
{z0}
}]), linearly transformed by (\*GridBox[{
{rxx, rxy, rxz},
{ryx, ryy, ryz},
{rzx, rzy, rzz}
}]), and then translated back by (\*GridBox[{
{x1},
{y1},
{z1}
}]). Voxel elements outside the image domain are set to offcol."

NConstantAffineTransform3D::usage="NConstantAffineTransform3D[img,x0,y0,z0,x1,y1,z1,rxx,rxy,rxz,ryx,ryy,ryz,rzx,rzy,rzz,offcol] performs an affine transformation of a 3-dimensional image using constant interpolation. The image is first translated by (\*GridBox[{
{x0},
{y0},
{z0}
}]), linearly transformed by (\*GridBox[{
{rxx, rxy, rxz},
{ryx, ryy, ryz},
{rzx, rzy, rzz}
}]), and then translated back by (\*GridBox[{
{x1},
{y1},
{z1}
}]). Voxel elements outside the image domain are set to offcol."

PerspectiveTransformArray::usage="PerspectiveTransformArray[image,{y0,dyl,dyr},offcol:0] contracts or dilates an image in y direction around y0 by the factor dyl on the left and by the factor dyr on the right. PerspectiveTransformArray[image,{x0,dxb,dxt},{y0,dyb,dyt},offcol:0] contracts or dilates the 3D image in x-direction around x0 by the factor dxb on the bottom (z-minimum side) and by the factor dxt on the top (z-maximum side) and contracts or dilates in y-direction around y0 by the factor dyb on the bottom and by the factor by dyt on the top. Pixels or voxels outside the image domain are set to offcol."

ArrayInterpolation::usage="ArrayInterpolation is an Option for ScaleArray, RotateArray, TranslateArray, and PerspectiveTransformArray. It determines the kind of interpolation used in the transformation. Possible values are: ConstantInterpolation, LinearInterpolation, or CubicBSplineInterpolation."

ConstantInterpolation::usage="ConstantInterpolation is an Option-value of ArrayInterpolation. Interpolating values assume the value of the nearest pixel or voxel."

LinearInterpolation::usage="LinearInterpolation is an Option-value of ArrayInterpolation. Interpolating values assume the linear distance-weighted average value of the nearest 4 pixels or nearest 8 voxels."

CubicBSplineInterpolation::usage="CubicBSplineInterpolation is an Option-value of ArrayInterpolation. Interpolating values are determined via 3rd order BSpline interpolation with reflective boundary conditions."


Begin["`Private`"]


NConstantImageInterpolation=
Compile[
{{img,_Real,2},
{x,_Real},{y,_Real},
{xn,_Integer},{yn,_Integer},
{offColor,_Real}},
Block[
{x0=Round[x],y0=Round[y]},
If[0<x0<xn\[And]0<y0<yn,img[[y0,x0]],offColor]
]
];


NConstantImageInterpolation3D=
Compile[
{{img,_Real,3},
{x,_Real},{y,_Real},{z,_Real},
{xn,_Integer},{yn,_Integer},{zn,_Integer},
{offColor,_Real}},
Block[
{x0=Round[x],y0=Round[y],z0=Round[z]},
If[0<x0<xn\[And]0<y0<yn\[And]0<z0<zn,img[[z0,y0,x0]],offColor]
]
];


NConstant2DImageInterpolation3D=
Compile[
{{img,_Real,3},
{x,_Real},{y,_Real},
{xn,_Integer},{yn,_Integer},{zn,_Integer},
{offColor,_Real}
},
Block[
{x0=Round[x],y0=Round[y]},
If[0<x0<xn\[And]0<y0<yn,img[[All,y0,x0]],Table[offColor,{zn}]]
]
];


NLinearImageInterpolation=
Compile[
{{img,_Real,2},
{x,_Real},{y,_Real},
{xn,_Integer},{yn,_Integer},
{offColor,_Real}},
Block[
{x0=Floor[x],y0=Floor[y],dx=x-x0,dy=y-y0},
Which[
0<x0<xn\[And]0<y0<yn,(1-dx)((1-dy) img[[y0,x0]]+dy img[[y0+1,x0]])+dx((1-dy) img[[y0,x0+1]]+dy img[[y0+1,x0+1]]),
x==xn\[And]0<y0<yn,(1-dy) img[[y0,x0]]+dy img[[y0+1,x0]],
y==yn\[And]0<x0<xn,(1-dx)img[[y0,x0]]+dx img[[y0,x0+1]],
x==xn\[And]y==yn,img[[y0,x0]],
True,offColor
]
]
];


NLinearImageInterpolation3D=
Compile[
{{img,_Real,3},
{x,_Real},{y,_Real},{z,_Real},
{xn,_Integer},{yn,_Integer},{zn,_Integer},
{offColor,_Real}},
Block[
{x0=Floor[x],y0=Floor[y],z0=Floor[z],dx=x-x0,dy=y-y0,dz=z-z0},
Which[
0<x0<xn\[And]0<y0<yn\[And]0<z0<zn,(1-dx)((1-dy) ((1-dz) img[[z0,y0,x0]]+dz img[[z0+1,y0,x0]])+dy ((1-dz) img[[z0,y0+1,x0]]+dz img[[z0+1,y0+1,x0]]))+dx((1-dy) ((1-dz) img[[z0,y0,x0+1]]+dz img[[z0+1,y0,x0+1]])+dy ((1-dz) img[[z0,y0+1,x0+1]]+dz img[[z0+1,y0+1,x0+1]])),
x==xn\[And]0<y0<yn\[And]0<z0<zn,(1-dy) ((1-dz) img[[z0,y0,x0]]+dz img[[z0+1,y0,x0]])+dy ((1-dz) img[[z0,y0+1,x0]]+dz img[[z0+1,y0+1,x0]]),
y==yn\[And]0<x0<xn\[And]0<z0<zn,(1-dx) ((1-dz) img[[z0,y0,x0]]+dz img[[z0+1,y0,x0]])+dx ((1-dz) img[[z0,y0,x0+1]]+dz img[[1+z0,y0,x0+1]]),
z==zn\[And]0<x0<xn\[And]0<y0<yn,(1-dx) ((1-dy) img[[z0,y0,x0]]+dy img[[z0,y0+1,x0]])+dx ((1-dy) img[[z0,y0,x0+1]]+dy img[[z0,y0+1,x0+1]]),
x==xn\[And]y==yn\[And]0<z0<zn,(1-dz) img[[z0,y0,x0]]+dz img[[z0+1,y0,x0]],
x==xn\[And]z==zn\[And]0<y0<yn,(1-dy) img[[z0,y0,x0]]+dy img[[z0,y0+1,x0]],
y==yn\[And]z==zn\[And]0<x0<xn,(1-dx) img[[z0,y0,x0]]+dx img[[z0,y0,x0+1]],
x==xn\[And]y==yn\[And]z==zn,img[[z0,y0,x0]],
True,offColor
]
]
];


NLinear2DImageInterpolation3D= 
Compile[
{{img,_Real,3},
{x,_Real},{y,_Real},
{xn,_Integer},{yn,_Integer},{zn,_Integer},
{offColor,_Real}
},
Block[
{x0=Floor[x],y0=Floor[y],dx=x-x0,dy=y-y0},
Which[
0<x0<xn\[And]0<y0<yn,
	(1-dx)((1-dy) img[[All,y0,x0]]+dy img[[All,y0+1,x0]])+dx((1-dy) img[[All,y0,x0+1]]+dy img[[All,y0+1,x0+1]]),
x==xn \[And] 0<y0<yn,
	(1-dy) img[[All,y0,x0]]+dy img[[All,y0+1,x0]],
y==yn \[And] 0<x0<xn,
	(1-dx)img[[All,y0,x0]]+dx img[[All,y0,x0+1]],
x==xn \[And] y==yn,
	img[[All,y0,x0]],
True,
	Table[offColor,{zn}]
]
]
];


CubicBSplineImageInterpolationFilter[img_,nn_Integer:256]:=
Module[
{n = Min[nn,ArrayDepth[img]],\[Alpha]=N[Sqrt[3]-2],shift,tmp=img},
shift=RotateRight[Range[n]];
Do[
tmp=Transpose[
FoldList[(\[Alpha] #1+#2)&,{1,\[Alpha],\[Alpha]^2,\[Alpha]^3}.tmp[[{1,2,3,4}]],Append[tmp, Last[tmp]]]+Reverse[FoldList[(\[Alpha] #1+#2)&,{1,\[Alpha],\[Alpha]^2,\[Alpha]^3}.tmp[[{-1,-2,-3,-4}]],Append[Reverse[tmp], First[tmp]]]]-
Prepend[Append[tmp, Last[tmp]],First[tmp]],
shift
],
{n}
];
Return[(-((6\[Alpha])/(1-\[Alpha]^2)))^n*tmp]
]


NCubicBSplineInterpolation =
  Compile[
   {{img, _Real, 1},
    {x, _Real},
    {xn, _Integer},
    {offColor, _Real}},
 Block[
 {x0 = Floor[x], dx = x - x0},
Which[
0 < x0 < xn ,
Take[img,{x0,x0+3}].{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2),dx^3}/6,
x == xn ,
Take[img,{x0,x0+2}].{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2)}/6, True, offColor
 ]
 ],
{{Take[_,_],_Real,1}}
];


NCubicBSplineImageInterpolation =
  Compile[
   {{img, _Real, 2},
    {x, _Real}, {y, _Real},
    {xn, _Integer}, {yn, _Integer},
    {offColor, _Real}},
   Block[
    {x0 = Floor[x], y0 = Floor[y], dx = x - x0, dy = y - y0},
    Which[
     0 < x0 < xn \[And] 0 < y0 < yn, 
({(1-dy)^3,4+3 dy^2 (dy-2 ),1+3 dy(1+dy-dy^2),dy^3}.
Take[img,{y0,y0+3},{x0,x0+3}].
{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2),dx^3})/36,
     x == xn \[And] 0 < y0 < yn, 
({(1-dy)^3,4+3 dy^2 (dy-2 ),1+3 dy(1+dy-dy^2),dy^3}.
Take[img,{y0,y0+3},{x0,x0+2}].
{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2)})/36,
     y == yn \[And] 0 < x0 < xn, 
({(1-dy)^3,4+3 dy^2 (dy-2 ),1+3 dy(1+dy-dy^2)}.
Take[img,{y0,y0+2},{x0,x0+3}].
{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2),dx^3})/36,
     x == xn \[And] y == yn,
({(1-dy)^3,4+3 dy^2 (dy-2 ),1+3 dy(1+dy-dy^2)}.
Take[img,{y0,y0+2},{x0,x0+2}].
{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2)})/36,
     True, offColor
     ]
    ],
{{Take[_,_,_],_Real,2}}
   ];


NCubicBSplineImageInterpolation3D =
  Compile[
   {{img, _Real, 3},
    {x, _Real}, {y, _Real},{z, _Real},
    {xn, _Integer}, {yn, _Integer}, {zn, _Integer},
    {offColor, _Real}},
   Block[
    {x0=Floor[x],y0=Floor[y],z0=Floor[z],dx=x-x0,dy=y-y0,dz=z-z0},
    Which[
0<x0<xn\[And]0<y0<yn\[And]0<z0<zn,
({(1-dy)^3,4+3 dy^2 (dy-2 ),1+3 dy(1+dy-dy^2),dy^3}.(
{(1-dz)^3,4+3 dz^2 (dz-2 ),1+3 dz(1+dz-dz^2),dz^3}.
Take[img,{z0,z0+3},{y0,y0+3},{x0,x0+3}].
{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2),dx^3}))/36,
x==xn\[And]0<y0<yn\[And]0<z0<zn,
({(1-dy)^3,4+3 dy^2 (dy-2 ),1+3 dy(1+dy-dy^2),dy^3}.(
{(1-dz)^3,4+3 dz^2 (dz-2 ),1+3 dz(1+dz-dz^2),dz^3}.
Take[img,{z0,z0+3},{y0,y0+3},{x0,x0+2}].
{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2)}))/36,
y==yn\[And]0<x0<xn\[And]0<z0<zn,
({(1-dy)^3,4+3 dy^2 (dy-2 ),1+3 dy(1+dy-dy^2)}.(
{(1-dz)^3,4+3 dz^2 (dz-2 ),1+3 dz(1+dz-dz^2),dz^3}.
Take[img,{z0,z0+3},{y0,y0+2},{x0,x0+3}].
{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2),dx^3}))/36,
z==zn\[And]0<x0<xn\[And]0<y0<yn,
({(1-dy)^3,4+3 dy^2 (dy-2 ),1+3 dy(1+dy-dy^2),dy^3}.(
{(1-dz)^3,4+3 dz^2 (dz-2 ),1+3 dz(1+dz-dz^2)}.
Take[img,{z0,z0+2},{y0,y0+3},{x0,x0+3}].
{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2),dx^3}))/36,
x==xn\[And]y==yn\[And]0<z0<zn,
({(1-dy)^3,4+3 dy^2 (dy-2 ),1+3 dy(1+dy-dy^2)}.(
{(1-dz)^3,4+3 dz^2 (dz-2 ),1+3 dz(1+dz-dz^2),dz^3}.
Take[img,{z0,z0+3},{y0,y0+2},{x0,x0+2}].
{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2)}))/36,
x==xn\[And]z==zn\[And]0<y0<yn,
({(1-dy)^3,4+3 dy^2 (dy-2 ),1+3 dy(1+dy-dy^2),dy^3}.(
{(1-dz)^3,4+3 dz^2 (dz-2 ),1+3 dz(1+dz-dz^2)}.
Take[img,{z0,z0+2},{y0,y0+3},{x0,x0+2}].
{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2)}))/36,
y==yn\[And]z==zn\[And]0<x0<xn,
({(1-dy)^3,4+3 dy^2 (dy-2 ),1+3 dy(1+dy-dy^2)}.(
{(1-dz)^3,4+3 dz^2 (dz-2 ),1+3 dz(1+dz-dz^2)}.
Take[img,{z0,z0+2},{y0,y0+2},{x0,x0+3}].
{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2),dx^3}))/36,
x==xn\[And]y==yn\[And]z==zn,
({(1-dy)^3,4+3 dy^2 (dy-2 ),1+3 dy(1+dy-dy^2)}.(
{(1-dz)^3,4+3 dz^2 (dz-2 ),1+3 dz(1+dz-dz^2)}.
Take[img,{z0,z0+2},{y0,y0+2},{x0,x0+2}].
{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2)}))/36,
True,offColor
] 
    ],
{{Take[_,_,_,_],_Real,3}}
   ];


NCubicBSpline2DImageInterpolation3D =
  Compile[
   {{img, _Real, 3},
    {x, _Real}, {y, _Real},
    {xn, _Integer}, {yn, _Integer}, {zn, _Integer},
    {offColor, _Real}},
   Block[
    {x0=Floor[x],y0=Floor[y],dx=x-x0,dy=y-y0},
    Which[
0<x0<xn\[And]0<y0<yn,
	((Take[img,All,{y0,y0+3},{x0,x0+3}].
{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2),dx^3}).{(1-dy)^3,4+3 dy^2 (dy-2 ),1+3 dy(1+dy-dy^2),dy^3})/36,
x==xn \[And] 0<y0<yn,
	((Take[img,All,{y0,y0+3},{x0,x0+2}].
{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2)}).{(1-dy)^3,4+3 dy^2 (dy-2 ),1+3 dy(1+dy-dy^2),dy^3})/36,
y==yn \[And] 0<x0<xn,
	((Take[img,All,{y0,y0+2},{x0,x0+3}].
{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2),dx^3}).{(1-dy)^3,4+3 dy^2 (dy-2 ),1+3 dy(1+dy-dy^2)})/36,
x==xn \[And] y==yn,
	((Take[img,All,{y0,y0+2},{x0,x0+2}].
{(1-dx)^3,4+3 dx^2 (dx-2 ),1+3 dx(1+dx-dx^2)}).{(1-dy)^3,4+3 dy^2 (dy-2 ),1+3 dy(1+dy-dy^2)})/36,
True,
	Table[offColor,{zn}]
] 
    ],
{{Take[_,_,_,_],_Real,3},{Table[_,_],_Real,1}}
   ];


NConstantAffineTransform=
Compile[
{{img,_Real,2},
{x0,_Real},{y0,_Real},
{x1,_Real},{y1,_Real},
{rxx,_Real},{rxy,_Real},
{ryx,_Real},{ryy,_Real},
{offColor,_Real}},
With[
{xn=Dimensions[img][[2]],yn=Dimensions[img][[1]]},
Table[
NConstantImageInterpolation[img,rxx x+rxy y+x1,ryx x+ryy y+y1,xn,yn,offColor],
{y,1-y0,yn-y0},
{x,1-x0,xn-x0}
]
],
{{NConstantImageInterpolation[_,_,_,_,_,_],_Real}}
];


NLinearAffineTransform=
Compile[
{{img,_Real,2},
{x0,_Real},{y0,_Real},
{x1,_Real},{y1,_Real},
{rxx,_Real},{rxy,_Real},
{ryx,_Real},{ryy,_Real},
{offColor,_Real}},
With[
{xn=Dimensions[img][[2]],yn=Dimensions[img][[1]]},
Table[
NLinearImageInterpolation[img,rxx x+rxy y+x1,ryx x+ryy y+y1,xn,yn,offColor],
{y,1-y0,yn-y0},
{x,1-x0,xn-x0}
]
],
{{NLinearImageInterpolation[_,_,_,_,_,_],_Real}}
];


NCubicBSplineAffineTransform=
Compile[
{{img,_Real,2},
{x0,_Real},{y0,_Real},
{x1,_Real},{y1,_Real},
{rxx,_Real},{rxy,_Real},
{ryx,_Real},{ryy,_Real},
{offColor,_Real}},
Module[
{xn=Dimensions[img][[2]],yn=Dimensions[img][[1]],tmp=CubicBSplineImageInterpolationFilter[img]},
Table[
NCubicBSplineImageInterpolation[tmp,rxx x+rxy y+x1,ryx x+ryy y+y1,xn,yn,offColor],
{y,1-y0,yn-y0},
{x,1-x0,xn-x0}
]
],
{{NCubicBSplineImageInterpolation[_,_,_,_,_,_],_Real},{CubicBSplineImageInterpolationFilter[_],_Real,2}}
];


NConstantAffineTransform3D=
Compile[
{{img,_Real,3},
{x0,_Real},{y0,_Real},{z0,_Real},
{x1,_Real},{y1,_Real},{z1,_Real},
{rxx,_Real},{rxy,_Real},{rxz,_Real},
{ryx,_Real},{ryy,_Real},{ryz,_Real},
{rzx,_Real},{rzy,_Real},{rzz,_Real},
{offColor,_Real}},
With[
{xn=Dimensions[img][[3]],yn=Dimensions[img][[2]],zn=Dimensions[img][[1]]},
Table[
NConstantImageInterpolation3D[
img,
rxx x+x1+rxy y+rxz z,
ryx x+ryy y+y1+ryz z,
rzx x+rzy y+rzz z+z1,
xn,yn,zn,offColor],
{z,1-z0,zn-z0},
{y,1-y0,yn-y0},
{x,1-x0,xn-x0}
]
],
{{NConstantImageInterpolation3D[_,_,_,_,_,_,_,_],_Real}}
];


NLinearAffineTransform3D=
Compile[
{{img,_Real,3},
{x0,_Real},{y0,_Real},{z0,_Real},
{x1,_Real},{y1,_Real},{z1,_Real},
{rxx,_Real},{rxy,_Real},{rxz,_Real},
{ryx,_Real},{ryy,_Real},{ryz,_Real},
{rzx,_Real},{rzy,_Real},{rzz,_Real},
{offColor,_Real}},
With[
{xn=Dimensions[img][[3]],yn=Dimensions[img][[2]],zn=Dimensions[img][[1]]},
Table[
NLinearImageInterpolation3D[
img,
rxx x+x1+rxy y+rxz z,
ryx x+ryy y+y1+ryz z,
rzx x+rzy y+rzz z+z1,
xn,yn,zn,offColor],
{z,1-z0,zn-z0},
{y,1-y0,yn-y0},
{x,1-x0,xn-x0}
]
],
{{NLinearImageInterpolation3D[_,_,_,_,_,_,_,_],_Real}}
];


NCubicBSplineAffineTransform3D=
Compile[
{{img,_Real,3},
{x0,_Real},{y0,_Real},{z0,_Real},
{x1,_Real},{y1,_Real},{z1,_Real},
{rxx,_Real},{rxy,_Real},{rxz,_Real},
{ryx,_Real},{ryy,_Real},{ryz,_Real},
{rzx,_Real},{rzy,_Real},{rzz,_Real},
{offColor,_Real}},
Module[
{xn=Dimensions[img][[3]],yn=Dimensions[img][[2]],zn=Dimensions[img][[1]],tmp=CubicBSplineImageInterpolationFilter[img]},
Table[
NCubicBSplineImageInterpolation3D[
tmp,
rxx x+x1+rxy y+rxz z,
ryx x+ryy y+y1+ryz z,
rzx x+rzy y+rzz z+z1,
xn,yn,zn,offColor],
{z,1-z0,zn-z0},
{y,1-y0,yn-y0},
{x,1-x0,xn-x0}
]
],
{{NCubicBSplineImageInterpolation3D[_,_,_,_,_,_,_,_],_Real},{CubicBSplineImageInterpolationFilter[_],_Real,3}}
];


NConstantAffine2DTransform3D=
Compile[
{{img,_Real,3},
{x0,_Real},{y0,_Real},
{x1,_Real},{y1,_Real},
{rxx,_Real},{rxy,_Real},
{ryx,_Real},{ryy,_Real},
{offColor,_Real}},
With[
{xn=Dimensions[img][[3]],yn=Dimensions[img][[2]],zn=Dimensions[img][[1]]},
Table[
NConstant2DImageInterpolation3D[
img,
rxx x-rxy y+x1,
ryx x+ryy y+y1,
xn,yn,zn,offColor],
{y,1-y0,yn-y0},
{x,1-x0,xn-x0}
]
],
{{NConstant2DImageInterpolation3D[_,_,_,_,_,_,_],_Real,1}}
];


NLinearAffine2DTransform3D=
Compile[
{{img,_Real,3},
{x0,_Real},{y0,_Real},
{x1,_Real},{y1,_Real},
{rxx,_Real},{rxy,_Real},
{ryx,_Real},{ryy,_Real},
{offColor,_Real}},
With[
{xn=Dimensions[img][[3]],yn=Dimensions[img][[2]],zn=Dimensions[img][[1]]},
Table[
NLinear2DImageInterpolation3D[
img,
rxx x-rxy y+x1,
ryx x+ryy y+y1,
xn,yn,zn,offColor],
{y,1-y0,yn-y0},
{x,1-x0,xn-x0}
]
],
{{NLinear2DImageInterpolation3D[_,_,_,_,_,_,_],_Real,1}}
];


NCubicBSplineAffine2DTransform3D=
Compile[
{{img,_Real,3},
{x0,_Real},{y0,_Real},
{x1,_Real},{y1,_Real},
{rxx,_Real},{rxy,_Real},
{ryx,_Real},{ryy,_Real},
{offColor,_Real}},
Module[
{xn=Dimensions[img][[3]],yn=Dimensions[img][[2]],zn=Dimensions[img][[1]],tmp=CubicBSplineImageInterpolationFilter[img,2]},
Table[
NCubicBSpline2DImageInterpolation3D[
tmp,
rxx x+rxy y+x1,
ryx x+ryy y+y1,
xn,yn,offColor],
{y,1-y0,yn-y0},
{x,1-x0,xn-x0}
]
],
{{NCubicBSpline2DImageInterpolation3D[_,_,_,_,_,_,_],_Real,1},{CubicBSplineImageInterpolationFilter[_,_],_Real,3}}
];


SetAttributes[Translate,HoldFirst];
SetAttributes[Rotate,HoldFirst];
SetAttributes[Scale,HoldFirst];


TranslateArray[
ScaleArray[
RotateArray[
img_?ArrayQ,
\[Alpha]_?NumericQ,{x0_?NumberQ,y0_?NumberQ},offColor_:0,opts1___?OptionQ
],
{sx_?NumberQ,sy_?NumberQ},{x0_?NumberQ,y0_?NumberQ},offColor_:0,opts2___?OptionQ
],
{tx_?NumberQ,ty_?NumberQ},offColor_:0,opts3___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts3},{opts2},{opts1}]/.Join[Options[TranslateArray],Options[ScaleArray],Options[RotateArray]],
ConstantInterpolation,
NConstantAffineTransform[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sy,-Sin[N[\[Alpha]]]/sx,Cos[N[\[Alpha]]]/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sy,-Sin[N[\[Alpha]]]/sx,Cos[N[\[Alpha]]]/sy,offColor],
LinearInterpolation|_,
NLinearAffineTransform[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sy,-Sin[N[\[Alpha]]]/sx,Cos[N[\[Alpha]]]/sy,offColor]
]/; ArrayDepth[img]===2


TranslateArray[
RotateArray[
ScaleArray[
img_?ArrayQ,
{sx_?NumberQ,sy_?NumberQ},{x0_?NumberQ,y0_?NumberQ},offColor_:0,opts1___?OptionQ
],
\[Alpha]_?NumericQ,{x0_?NumberQ,y0_?NumberQ},offColor_:0,opts2___?OptionQ
],
{tx_?NumberQ,ty_?NumberQ},offColor_:0,opts3___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts3},{opts2},{opts1}]/.Join[Options[TranslateArray],Options[RotateArray],Options[ScaleArray]],
ConstantInterpolation,
NConstantAffineTransform[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sx,-Sin[N[\[Alpha]]]/sy,Cos[N[\[Alpha]]]/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sx,-Sin[N[\[Alpha]]]/sy,Cos[N[\[Alpha]]]/sy,offColor],
LinearInterpolation|_,
NLinearAffineTransform[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sx,-Sin[N[\[Alpha]]]/sy,Cos[N[\[Alpha]]]/sy,offColor]
]/; ArrayDepth[img]===2


ScaleArray[
RotateArray[
TranslateArray[
img_?ArrayQ,
{tx_?NumberQ,ty_?NumberQ},offColor_:0,opts1___?OptionQ
],
\[Alpha]_?NumericQ,{x0_?NumberQ,y0_?NumberQ},offColor_:0,opts2___?OptionQ
],
{sx_?NumberQ,sy_?NumberQ},{x0_?NumberQ,y0_?NumberQ},offColor_:0,opts3___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2},{opts3}]/.Join[Options[TranslateArray],Options[RotateArray],Options[ScaleArray]],
ConstantInterpolation,
NConstantAffineTransform[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sy,-Sin[N[\[Alpha]]]/sx,Cos[N[\[Alpha]]]/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sy,-Sin[N[\[Alpha]]]/sx,Cos[N[\[Alpha]]]/sy,offColor],
LinearInterpolation|_,
NLinearAffineTransform[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sy,-Sin[N[\[Alpha]]]/sx,Cos[N[\[Alpha]]]/sy,offColor]
]/; ArrayDepth[img]===2


RotateArray[
ScaleArray[
TranslateArray[
img_?ArrayQ,
{tx_?NumberQ,ty_?NumberQ},offColor_:0,opts1___?OptionQ
],
{sx_?NumberQ,sy_?NumberQ},{x0_?NumberQ,y0_?NumberQ},offColor_:0,opts2___?OptionQ
],
\[Alpha]_?NumericQ,{x0_?NumberQ,y0_?NumberQ},offColor_:0,opts3___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2},{opts3}]/.Join[Options[TranslateArray],Options[ScaleArray],Options[RotateArray]],
ConstantInterpolation,
NConstantAffineTransform[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sx,-Sin[N[\[Alpha]]]/sy,Cos[N[\[Alpha]]]/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sx,-Sin[N[\[Alpha]]]/sy,Cos[N[\[Alpha]]]/sy,offColor],
LinearInterpolation|_,
NLinearAffineTransform[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sx,-Sin[N[\[Alpha]]]/sy,Cos[N[\[Alpha]]]/sy,offColor]
]/; ArrayDepth[img]===2


TranslateArray[
ScaleArray[
RotateArray[
img_?ArrayQ,
\[Alpha]_?NumericQ,\[Beta]_?NumericQ,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor_:0,opts1___?OptionQ
],
{sx_?NumberQ,sy_?NumberQ,sz_?NumberQ},{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor_:0,opts2___?OptionQ
],
{tx_?NumberQ,ty_?NumberQ,tz_?NumberQ},offColor_:0,opts3___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2},{opts3}]/.Join[Options[RotateArray],Options[ScaleArray],Options[TranslateArray]],
ConstantInterpolation,
NConstantAffineTransform3D[img,x0+tx,y0+ty,z0+tz,x0,y0,z0,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sy,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sz,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sz,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sx,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sy,Cos[N[\[Beta]]]/sz,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform3D[img,x0+tx,y0+ty,z0+tz,x0,y0,z0,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sy,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sz,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sz,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sx,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sy,Cos[N[\[Beta]]]/sz,offColor],
LinearInterpolation|_,
NLinearAffineTransform3D[img,x0+tx,y0+ty,z0+tz,x0,y0,z0,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sy,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sz,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sz,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sx,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sy,Cos[N[\[Beta]]]/sz,offColor]
]/; ArrayDepth[img]===3


TranslateArray[
ScaleArray[
RotateArray[
img_?ArrayQ,
\[Alpha]_?NumericQ,0|0.0,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,_},offColor_:0,opts1___?OptionQ
],
{sx_?NumberQ,sy_?NumberQ,1|1.0},{x0_?NumberQ,y0_?NumberQ,_},offColor_:0,opts2___?OptionQ
],
{tx_?NumberQ,ty_?NumberQ,0|0.0},offColor_:0,opts3___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2},{opts3}]/.Join[Options[RotateArray],Options[ScaleArray],Options[TranslateArray]],
ConstantInterpolation,
NConstantAffine2DTransform3D[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sy,-Sin[N[\[Alpha]+\[Gamma]]]/sx,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffine2DTransform3D[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sy,-Sin[N[\[Alpha]+\[Gamma]]]/sx,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor],
LinearInterpolation|_,
NLinearAffine2DTransform3D[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sy,-Sin[N[\[Alpha]+\[Gamma]]]/sx,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor]
]/; ArrayDepth[img]===3


TranslateArray[
RotateArray[
ScaleArray[
img_?ArrayQ,
{sx_?NumberQ,sy_?NumberQ,sz_?NumberQ},{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor_:0,opts1___?OptionQ
],
\[Alpha]_?NumericQ,\[Beta]_?NumericQ,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor_:0,opts2___?OptionQ
],
{tx_?NumberQ,ty_?NumberQ,tz_?NumberQ},offColor_:0,opts3___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2},{opts3}]/.Join[Options[ScaleArray],Options[RotateArray],Options[TranslateArray]],
ConstantInterpolation,
NConstantAffineTransform3D[img,x0+tx,y0+ty,z0+tz,x0,y0,z0,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sy,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,Cos[N[\[Beta]]]/sz,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform3D[img,x0+tx,y0+ty,z0+tz,x0,y0,z0,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sy,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,Cos[N[\[Beta]]]/sz,offColor],
LinearInterpolation|_,
NLinearAffineTransform3D[img,x0+tx,y0+ty,z0+tz,x0,y0,z0,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sy,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,Cos[N[\[Beta]]]/sz,offColor]
]/; ArrayDepth[img]===3


TranslateArray[
RotateArray[
ScaleArray[
img_?ArrayQ,
{sx_?NumberQ,sy_?NumberQ,1|1.0},{x0_?NumberQ,y0_?NumberQ,_},offColor_:0,opts1___?OptionQ
],
\[Alpha]_?NumericQ,0|0.0,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,_},offColor_:0,opts2___?OptionQ
],
{tx_?NumberQ,ty_?NumberQ,0|0.0},offColor_:0,opts3___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2},{opts3}]/.Join[Options[ScaleArray],Options[RotateArray],Options[TranslateArray]],
ConstantInterpolation,
NConstantAffine2DTransform3D[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sx,-Sin[N[\[Alpha]+\[Gamma]]]/sy,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffine2DTransform3D[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sx,-Sin[N[\[Alpha]+\[Gamma]]]/sy,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor],
LinearInterpolation|_,
NLinearAffine2DTransform3D[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sx,-Sin[N[\[Alpha]+\[Gamma]]]/sy,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor]
]/; ArrayDepth[img]===3


ScaleArray[
RotateArray[
TranslateArray[
img_?ArrayQ,
{tx_?NumberQ,ty_?NumberQ,tz_?NumberQ},offColor_:0,opts1___?OptionQ
],
\[Alpha]_?NumericQ,\[Beta]_?NumericQ,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor_:0,opts2___?OptionQ
],
{sx_?NumberQ,sy_?NumberQ,sz_?NumberQ},{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor_:0,opts3___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2},{opts3}]/.Join[Options[TranslateArray],Options[RotateArray],Options[ScaleArray]],
ConstantInterpolation,
NConstantAffineTransform3D[img,x0,y0,z0,x0-tx,y0-ty,z0-tz,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sy,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sz,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sz,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sx,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sy,Cos[N[\[Beta]]]/sz,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform3D[img,x0,y0,z0,x0-tx,y0-ty,z0-tz,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sy,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sz,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sz,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sx,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sy,Cos[N[\[Beta]]]/sz,offColor],
LinearInterpolation|_,
NLinearAffineTransform3D[img,x0,y0,z0,x0-tx,y0-ty,z0-tz,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sy,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sz,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sz,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sx,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sy,Cos[N[\[Beta]]]/sz,offColor]
]/; ArrayDepth[img]===3


ScaleArray[
RotateArray[
TranslateArray[
img_?ArrayQ,
{tx_?NumberQ,ty_?NumberQ,0|0.0},offColor_:0,opts1___?OptionQ
],
\[Alpha]_?NumericQ,0|0.0,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,_},offColor_:0,opts2___?OptionQ
],
{sx_?NumberQ,sy_?NumberQ,1|1.0},{x0_?NumberQ,y0_?NumberQ,_},offColor_:0,opts3___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2},{opts3}]/.Join[Options[TranslateArray],Options[RotateArray],Options[ScaleArray]],
ConstantInterpolation,
NConstantAffine2DTransform3D[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sy,-Sin[N[\[Alpha]+\[Gamma]]]/sx,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffine2DTransform3D[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sy,-Sin[N[\[Alpha]+\[Gamma]]]/sx,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor],
LinearInterpolation|_,
NLinearAffine2DTransform3D[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sy,-Sin[N[\[Alpha]+\[Gamma]]]/sx,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor]
]/; ArrayDepth[img]===3


RotateArray[
ScaleArray[
TranslateArray[
img_?ArrayQ,
{tx_?NumberQ,ty_?NumberQ,tz_?NumberQ},offColor_:0,opts1___?OptionQ
],
{sx_?NumberQ,sy_?NumberQ,sz_?NumberQ},{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor_:0,opts2___?OptionQ
],
\[Alpha]_?NumericQ,\[Beta]_?NumericQ,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor_:0,opts3___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2},{opts3}]/.Join[Options[TranslateArray],Options[ScaleArray],Options[RotateArray]],
ConstantInterpolation,
NConstantAffineTransform3D[img,x0,y0,z0,x0-tx,y0-ty,z0-tz,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sy,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,Cos[N[\[Beta]]]/sz,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform3D[img,x0,y0,z0,x0-tx,y0-ty,z0-tz,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sy,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,Cos[N[\[Beta]]]/sz,offColor],
LinearInterpolation|_,
NLinearAffineTransform3D[img,x0,y0,z0,x0-tx,y0-ty,z0-tz,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sy,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,Cos[N[\[Beta]]]/sz,offColor]
]/; ArrayDepth[img]===3


RotateArray[
ScaleArray[
TranslateArray[
img_?ArrayQ,
{tx_?NumberQ,ty_?NumberQ,0|0.0},offColor_:0,opts1___?OptionQ
],
{sx_?NumberQ,sy_?NumberQ,1|1.0},{x0_?NumberQ,y0_?NumberQ,_},offColor_:0,opts2___?OptionQ
],
\[Alpha]_?NumericQ,0|0.0,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,_},offColor_:0,opts3___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2},{opts3}]/.Join[Options[TranslateArray],Options[ScaleArray],Options[RotateArray]],
ConstantInterpolation,
NConstantAffine2DTransform3D[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sx,-Sin[N[\[Alpha]+\[Gamma]]]/sy,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffine2DTransform3D[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sx,-Sin[N[\[Alpha]+\[Gamma]]]/sy,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor],
LinearInterpolation|_,
NLinearAffine2DTransform3D[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sx,-Sin[N[\[Alpha]+\[Gamma]]]/sy,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor]
]/; ArrayDepth[img]===3


RotateArray[
TranslateArray[
img_,{tx_,ty_},offColor_:0,opts1___?OptionQ
],
\[Alpha]_,{x0_,y0_},offColor_:0,opts2___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[TranslateArray],Options[RotateArray]],
ConstantInterpolation,
NConstantAffineTransform[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]]],Sin[N[\[Alpha]]],-Sin[N[\[Alpha]]],Cos[N[\[Alpha]]],offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]]],Sin[N[\[Alpha]]],-Sin[N[\[Alpha]]],Cos[N[\[Alpha]]],offColor],
LinearInterpolation|_,
NLinearAffineTransform[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]]],Sin[N[\[Alpha]]],-Sin[N[\[Alpha]]],Cos[N[\[Alpha]]],offColor]
]/; ArrayDepth[img]===2


TranslateArray[
RotateArray[
img_?ArrayQ,\[Alpha]_?NumericQ,{x0_?NumberQ,y0_?NumberQ},offColor_:0,opts1___?OptionQ
],
{tx_?NumberQ,ty_?NumberQ},offColor_:0,opts2___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[RotateArray],Options[TranslateArray]],
ConstantInterpolation,
NConstantAffineTransform[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]]],Sin[N[\[Alpha]]],-Sin[N[\[Alpha]]],Cos[N[\[Alpha]]],offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]]],Sin[N[\[Alpha]]],-Sin[N[\[Alpha]]],Cos[N[\[Alpha]]],offColor],
LinearInterpolation|_,
NLinearAffineTransform[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]]],Sin[N[\[Alpha]]],-Sin[N[\[Alpha]]],Cos[N[\[Alpha]]],offColor]
]/; ArrayDepth[img]===2


RotateArray[
TranslateArray[
img_?ArrayQ,{tx_?NumberQ,ty_?NumberQ,tz_?NumberQ},offColor_:0,opts1___?OptionQ
],
\[Alpha]_?NumericQ,\[Beta]_?NumericQ,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor_:0,opts2___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[TranslateArray],Options[RotateArray]],
ConstantInterpolation,
NConstantAffineTransform3D[img,x0,y0,z0,x0-tx,y0-ty,z0-tz,Cos[N[\[Alpha]]] Cos[N[\[Gamma]]]-Cos[N[\[Beta]]] Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Sin[N[\[Gamma]]],Sin[N[\[Beta]]] Sin[N[\[Gamma]]],-Cos[N[\[Beta]]] Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]-Cos[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Beta]]],Sin[N[\[Alpha]]] Sin[N[\[Beta]]],-Cos[N[\[Alpha]]] Sin[N[\[Beta]]],Cos[N[\[Beta]]],offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform3D[img,x0,y0,z0,x0-tx,y0-ty,z0-tz,Cos[N[\[Alpha]]] Cos[N[\[Gamma]]]-Cos[N[\[Beta]]] Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Sin[N[\[Gamma]]],Sin[N[\[Beta]]] Sin[N[\[Gamma]]],-Cos[N[\[Beta]]] Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]-Cos[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Beta]]],Sin[N[\[Alpha]]] Sin[N[\[Beta]]],-Cos[N[\[Alpha]]] Sin[N[\[Beta]]],Cos[N[\[Beta]]],offColor],
LinearInterpolation|_,
NLinearAffineTransform3D[img,x0,y0,z0,x0-tx,y0-ty,z0-tz,Cos[N[\[Alpha]]] Cos[N[\[Gamma]]]-Cos[N[\[Beta]]] Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Sin[N[\[Gamma]]],Sin[N[\[Beta]]] Sin[N[\[Gamma]]],-Cos[N[\[Beta]]] Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]-Cos[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Beta]]],Sin[N[\[Alpha]]] Sin[N[\[Beta]]],-Cos[N[\[Alpha]]] Sin[N[\[Beta]]],Cos[N[\[Beta]]],offColor]
]/; ArrayDepth[img]===3


RotateArray[
TranslateArray[
img_?ArrayQ,{tx_?NumberQ,ty_?NumberQ,0|0.0},offColor_:0,opts1___?OptionQ
],
\[Alpha]_?NumericQ,0|0.0,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,_},offColor_:0,opts2___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[TranslateArray],Options[RotateArray]],
ConstantInterpolation,
NConstantAffine2DTransform3D[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]+\[Gamma]]],Sin[N[\[Alpha]+\[Gamma]]],-Sin[N[\[Alpha]+\[Gamma]]],Cos[N[\[Alpha]+\[Gamma]]],offColor],
CubicBSplineInterpolation,
NCubicBSplineAffine2DTransform3D[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]+\[Gamma]]],Sin[N[\[Alpha]+\[Gamma]]],-Sin[N[\[Alpha]+\[Gamma]]],Cos[N[\[Alpha]+\[Gamma]]],offColor],
LinearInterpolation|_,
NLinearAffine2DTransform3D[img,x0,y0,x0-tx,y0-ty,Cos[N[\[Alpha]+\[Gamma]]],Sin[N[\[Alpha]+\[Gamma]]],-Sin[N[\[Alpha]+\[Gamma]]],Cos[N[\[Alpha]+\[Gamma]]],offColor]
]/; ArrayDepth[img]===3


TranslateArray[
RotateArray[
img_?ArrayQ,
\[Alpha]_?NumericQ,\[Beta]_?NumericQ,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor_:0,opts1___?OptionQ
],
{tx_?NumberQ,ty_?NumberQ,tz_?NumberQ},offColor_:0,opts2___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[RotateArray],Options[TranslateArray]],
ConstantInterpolation,
NConstantAffineTransform3D[img,x0+tx,y0+ty,z0+tz,x0,y0,z0,Cos[N[\[Alpha]]] Cos[N[\[Gamma]]]-Cos[N[\[Beta]]] Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Sin[N[\[Gamma]]],Sin[N[\[Beta]]] Sin[N[\[Gamma]]],-Cos[N[\[Beta]]] Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]-Cos[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Beta]]],Sin[N[\[Alpha]]] Sin[N[\[Beta]]],-Cos[N[\[Alpha]]] Sin[N[\[Beta]]],Cos[N[\[Beta]]],offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform3D[img,x0+tx,y0+ty,z0+tz,x0,y0,z0,Cos[N[\[Alpha]]] Cos[N[\[Gamma]]]-Cos[N[\[Beta]]] Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Sin[N[\[Gamma]]],Sin[N[\[Beta]]] Sin[N[\[Gamma]]],-Cos[N[\[Beta]]] Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]-Cos[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Beta]]],Sin[N[\[Alpha]]] Sin[N[\[Beta]]],-Cos[N[\[Alpha]]] Sin[N[\[Beta]]],Cos[N[\[Beta]]],offColor],
LinearInterpolation|_,
NLinearAffineTransform3D[img,x0+tx,y0+ty,z0+tz,x0,y0,z0,Cos[N[\[Alpha]]] Cos[N[\[Gamma]]]-Cos[N[\[Beta]]] Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Sin[N[\[Gamma]]],Sin[N[\[Beta]]] Sin[N[\[Gamma]]],-Cos[N[\[Beta]]] Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]-Cos[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Beta]]],Sin[N[\[Alpha]]] Sin[N[\[Beta]]],-Cos[N[\[Alpha]]] Sin[N[\[Beta]]],Cos[N[\[Beta]]],offColor]
]/; ArrayDepth[img]===3


TranslateArray[
RotateArray[
img_?ArrayQ,\[Alpha]_?NumericQ,0|0.0,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,_},offColor_:0,opts1___?OptionQ
],{tx_?NumberQ,ty_?NumberQ,0|0.0},offColor_:0,opts2___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[RotateArray],Options[TranslateArray]],
ConstantInterpolation,
NConstantAffine2DTransform3D[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]+\[Gamma]]],Sin[N[\[Alpha]+\[Gamma]]],-Sin[N[\[Alpha]+\[Gamma]]],Cos[N[\[Alpha]+\[Gamma]]],offColor],
CubicBSplineInterpolation,
NCubicBSplineAffine2DTransform3D[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]+\[Gamma]]],Sin[N[\[Alpha]+\[Gamma]]],-Sin[N[\[Alpha]+\[Gamma]]],Cos[N[\[Alpha]+\[Gamma]]],offColor],
LinearInterpolation|_,
NLinearAffine2DTransform3D[img,x0+tx,y0+ty,x0,y0,Cos[N[\[Alpha]+\[Gamma]]],Sin[N[\[Alpha]+\[Gamma]]],-Sin[N[\[Alpha]+\[Gamma]]],Cos[N[\[Alpha]+\[Gamma]]],offColor]
]/; ArrayDepth[img]===3


ScaleArray[
TranslateArray[
img_?ArrayQ,
{tx_?NumberQ,ty_?NumberQ},offColor_:0,opts1___?OptionQ
],
{sx_?NumberQ,sy_?NumberQ},{x0_?NumberQ,y0_?NumberQ},offColor_:0,opts1___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[TranslateArray],Options[ScaleArray]],
ConstantInterpolation,
NConstantAffineTransform[img,x0,y0,x0-tx,y0-ty,1/sx,0,0,1/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform[img,x0,y0,x0-tx,y0-ty,1/sx,0,0,1/sy,offColor],
LinearInterpolation|_,
NLinearAffineTransform[img,x0,y0,x0-tx,y0-ty,1/sx,0,0,1/sy,offColor]
]/; ArrayDepth[img]===2


TranslateArray[
ScaleArray[
img_?ArrayQ,
{sx_?NumberQ,sy_?NumberQ},{x0_?NumberQ,y0_?NumberQ},offColor_:0,opts1___?OptionQ
],
{tx_?NumberQ,ty_?NumberQ},offColor_:0,opts2___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[ScaleArray],Options[TranslateArray]],
ConstantInterpolation,
NConstantAffineTransform[img,x0+tx,y0+ty,x0,y0,1/sx,0,0,1/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform[img,x0+tx,y0+ty,x0,y0,1/sx,0,0,1/sy,offColor],
LinearInterpolation|_,
NLinearAffineTransform[img,x0+tx,y0+ty,x0,y0,1/sx,0,0,1/sy,offColor]
]/; ArrayDepth[img]===2


ScaleArray[
TranslateArray[
img_?ArrayQ,
{tx_?NumberQ,ty_?NumberQ,tz_?NumberQ},offColor_:0,opts1___?OptionQ
],
{sx_?NumberQ,sy_?NumberQ,sz_?NumberQ},{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor_:0,opts2___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[TranslateArray],Options[ScaleArray]],
ConstantInterpolation,
NConstantAffineTransform3D[img,x0,y0,z0,x0-tx,y0-ty,z0-tz,1/sx,0,0,0,1/sy,0,0,0,1/sz,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform3D[img,x0,y0,z0,x0-tx,y0-ty,z0-tz,1/sx,0,0,0,1/sy,0,0,0,1/sz,offColor],
LinearInterpolation|_,
NLinearAffineTransform3D[img,x0,y0,z0,x0-tx,y0-ty,z0-tz,1/sx,0,0,0,1/sy,0,0,0,1/sz,offColor]
]/; ArrayDepth[img]===3


TranslateArray[
ScaleArray[
img_?ArrayQ,
{sx_?NumberQ,sy_?NumberQ,sz_?NumberQ},{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor_:0,opts1___?OptionQ
],
{tx_?NumberQ,ty_?NumberQ,tz_?NumberQ},offColor_:0,opts2___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[ScaleArray],Options[TranslateArray]],
ConstantInterpolation,
NConstantAffineTransform3D[img,x0+tx,y0+ty,z0+tz,x0,y0,z0,1/sx,0,0,0,1/sy,0,0,0,1/sz,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform3D[img,x0+tx,y0+ty,z0+tz,x0,y0,z0,1/sx,0,0,0,1/sy,0,0,0,1/sz,offColor],
LinearInterpolation|_,
NLinearAffineTransform3D[img,x0+tx,y0+ty,z0+tz,x0,y0,z0,1/sx,0,0,0,1/sy,0,0,0,1/sz,offColor]
]/; ArrayDepth[img]===3


ScaleArray[
TranslateArray[
img_?ArrayQ,
{tx_?NumberQ,ty_?NumberQ,0|0.0},offColor:Except[_Rule | _RuleDelayed, _]:0,opts1___?OptionQ
],
{sx_?NumberQ,sy_?NumberQ,1|1.0},{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor:Except[_Rule | _RuleDelayed, _]:0,opts2___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[TranslateArray],Options[ScaleArray]],
ConstantInterpolation,
NConstantAffineTransform3D[img,x0,y0,x0-tx,y0-ty,1/sx,0,0,1/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform3D[img,x0,y0,x0-tx,y0-ty,1/sx,0,0,1/sy,offColor],
LinearInterpolation|_,
NLinearAffineTransform3D[img,x0,y0,x0-tx,y0-ty,1/sx,0,0,1/sy,offColor]
]/; ArrayDepth[img]===3


TranslateArray[
ScaleArray[
img_?ArrayQ,{sx_?NumberQ,sy_?NumberQ,1|1.0},{x0_?NumberQ,y0_?NumberQ,_},offColor:Except[_Rule | _RuleDelayed, _]:0,opts1___?OptionQ
],
{tx_?NumberQ,ty_?NumberQ,0|0.0},offColor:Except[_Rule | _RuleDelayed, _]:0,opts2___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[ScaleArray],Options[TranslateArray]],
ConstantInterpolation,
NConstantAffine2DTransform3D[img,x0+tx,y0+ty,x0,y0,1/sx,0,0,1/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffine2DTransform3D[img,x0+tx,y0+ty,x0,y0,1/sx,0,0,1/sy,offColor],
LinearInterpolation|_,
NLinearAffine2DTransform3D[img,x0+tx,y0+ty,x0,y0,1/sx,0,0,1/sy,offColor]
]/; ArrayDepth[img]===3


ScaleArray[
RotateArray[
img_?ArrayQ,
\[Alpha]_?NumericQ,{x0_?NumberQ,y0_?NumberQ},offColor:Except[_Rule | _RuleDelayed, _]:0,opts1___?OptionQ
],
{sx_?NumberQ,sy_?NumberQ},{x0_?NumberQ,y0_?NumberQ},offColor:Except[_Rule | _RuleDelayed, _]:0,opts2___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[RotateArray],Options[ScaleArray]],
ConstantInterpolation,
NConstantAffineTransform[img,x0,y0,x0,y0,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sy,-Sin[N[\[Alpha]]]/sx,Cos[N[\[Alpha]]]/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform[img,x0,y0,x0,y0,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sy,-Sin[N[\[Alpha]]]/sx,Cos[N[\[Alpha]]]/sy,offColor],
LinearInterpolation|_,
NLinearAffineTransform[img,x0,y0,x0,y0,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sy,-Sin[N[\[Alpha]]]/sx,Cos[N[\[Alpha]]]/sy,offColor]
]/; ArrayDepth[img]===2


RotateArray[
ScaleArray[
img_?ArrayQ,
{sx_?NumberQ,sy_?NumberQ},{x0_?NumberQ,y0_?NumberQ},offColor:Except[_Rule | _RuleDelayed, _]:0,opts1___?OptionQ
],
\[Alpha]_?NumericQ,{x0_?NumberQ,y0_?NumberQ},offColor:Except[_Rule | _RuleDelayed, _]:0,opts2___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[ScaleArray],Options[RotateArray]],
ConstantInterpolation,
NConstantAffineTransform[img,x0,y0,x0,y0,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sx,-Sin[N[\[Alpha]]]/sy,Cos[N[\[Alpha]]]/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform[img,x0,y0,x0,y0,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sx,-Sin[N[\[Alpha]]]/sy,Cos[N[\[Alpha]]]/sy,offColor],
LinearInterpolation|_,
NLinearAffineTransform[img,x0,y0,x0,y0,Cos[N[\[Alpha]]]/sx,Sin[N[\[Alpha]]]/sx,-Sin[N[\[Alpha]]]/sy,Cos[N[\[Alpha]]]/sy,offColor]
]/; ArrayDepth[img]===2


ScaleArray[
RotateArray[
img_?ArrayQ,
\[Alpha]_?NumericQ,\[Beta]_?NumericQ,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor:Except[_Rule | _RuleDelayed, _]:0,opts1___?OptionQ
],
{sx_?NumberQ,sy_?NumberQ,sz_?NumberQ},{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor:Except[_Rule | _RuleDelayed, _]:0,opts2___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[RotateArray],Options[ScaleArray]],
ConstantInterpolation,
NConstantAffineTransform3D[img,x0,y0,z0,x0,y0,z0,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sy,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sz,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sz,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sx,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sy,Cos[N[\[Beta]]]/sz,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform3D[img,x0,y0,z0,x0,y0,z0,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sy,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sz,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sz,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sx,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sy,Cos[N[\[Beta]]]/sz,offColor],
LinearInterpolation|_,
NLinearAffineTransform3D[img,x0,y0,z0,x0,y0,z0,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sy,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sz,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sz,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sx,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sy,Cos[N[\[Beta]]]/sz,offColor]
]/; ArrayDepth[img]===3


ScaleArray[
RotateArray[
img_?ArrayQ,
\[Alpha]_?NumericQ,0|0.0,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,_},offColor:Except[_Rule | _RuleDelayed, _]:0,opts1___?OptionQ
],
{sx_?NumberQ,sy_?NumberQ,1|1.0},{x0_?NumberQ,y0_?NumberQ,_},offColor:Except[_Rule | _RuleDelayed, _]:0,opts2___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[RotateArray],Options[ScaleArray]],
ConstantInterpolation,
NConstantAffine2DTransform3D[img,x0,y0,x0,y0,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sy,-Sin[N[\[Alpha]+\[Gamma]]]/sx,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffine2DTransform3D[img,x0,y0,x0,y0,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sy,-Sin[N[\[Alpha]+\[Gamma]]]/sx,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor],
LinearInterpolation|_,
NLinearAffine2DTransform3D[img,x0,y0,x0,y0,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sy,-Sin[N[\[Alpha]+\[Gamma]]]/sx,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor]
]/; ArrayDepth[img]===3


RotateArray[
ScaleArray[
img_?ArrayQ,
{sx_?NumberQ,sy_?NumberQ,sz_?NumberQ},{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor:Except[_Rule | _RuleDelayed, _]:0,opts1___?OptionQ
],
\[Alpha]_?NumericQ,\[Beta]_?NumericQ,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor:Except[_Rule | _RuleDelayed, _]:0,opts2___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[ScaleArray],Options[RotateArray]],
ConstantInterpolation,
NConstantAffineTransform3D[img,x0,y0,z0,x0,y0,z0,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sy,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,Cos[N[\[Beta]]]/sz,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform3D[img,x0,y0,z0,x0,y0,z0,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sy,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,Cos[N[\[Beta]]]/sz,offColor],
LinearInterpolation|_,
NLinearAffineTransform3D[img,x0,y0,z0,x0,y0,z0,(Cos[N[\[Alpha]]]*Cos[N[\[Gamma]]]-Cos[N[\[Beta]]]*Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sx,(Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(Sin[N[\[Beta]]]*Sin[N[\[Gamma]]])/sx,(-(Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]*Sin[N[\[Alpha]]])-Cos[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,(Cos[N[\[Alpha]]]*Cos[N[\[Beta]]]*Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]]*Sin[N[\[Gamma]]])/sy,Cos[N[\[Gamma]]]*Sin[N[\[Beta]]]/sy,Sin[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,-Cos[N[\[Alpha]]]*Sin[N[\[Beta]]]/sz,Cos[N[\[Beta]]]/sz,offColor]
]/; ArrayDepth[img]===3


RotateArray[
ScaleArray[
img_?ArrayQ,
{sx_?NumberQ,sy_?NumberQ,1|1.0},{x0_?NumberQ,y0_?NumberQ,_},offColor:Except[_Rule | _RuleDelayed, _]:0,opts1___?OptionQ
],
\[Alpha]_?NumericQ,0|0.0,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,_},offColor:Except[_Rule | _RuleDelayed, _]:0,opts2___?OptionQ
]:=
Switch[
ArrayInterpolation/. Join[{opts1},{opts2}]/.Join[Options[ScaleArray],Options[RotateArray]],
ConstantInterpolation,
NConstantAffine2DTransform3D[img,x0,y0,x0,y0,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sx,-Sin[N[\[Alpha]+\[Gamma]]]/sy,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffine2DTransform3D[img,x0,y0,x0,y0,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sx,-Sin[N[\[Alpha]+\[Gamma]]]/sy,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor],
LinearInterpolation|_,
NLinearAffine2DTransform3D[img,x0,y0,x0,y0,Cos[N[\[Alpha]+\[Gamma]]]/sx,Sin[N[\[Alpha]+\[Gamma]]]/sx,-Sin[N[\[Alpha]+\[Gamma]]]/sy,Cos[N[\[Alpha]+\[Gamma]]]/sy,offColor]
]/; ArrayDepth[img]===3


Options[TranslateArray] = {ArrayInterpolation-> LinearInterpolation};


TranslateArray[img_?ArrayQ,{tx_?NumberQ,ty_?NumberQ},offColor:Except[_Rule | _RuleDelayed, _]:0, opts___?OptionQ]:=
Switch[
ArrayInterpolation/. {opts}/.Options[TranslateArray],
ConstantInterpolation,
NConstantAffineTransform[img,tx,ty,0,0,1,0,0,1,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform[img,tx,ty,0,0,1,0,0,1,offColor],
LinearInterpolation|_,
NLinearAffineTransform[img,tx,ty,0,0,1,0,0,1,offColor]
]/; ArrayDepth[img]===2


TranslateArray[img_?ArrayQ,{tx_?NumberQ,ty_?NumberQ,0|0.0},offColor:Except[_Rule | _RuleDelayed, _]:0, opts___?OptionQ]:=
Switch[
ArrayInterpolation/. {opts}/.Options[TranslateArray],
ConstantInterpolation,
NConstantAffine2DTransform3D[img,tx,ty,0,0,1,0,0,1,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffine2DTransform3D[img,tx,ty,0,0,1,0,0,1,offColor],
LinearInterpolation|_,
NLinearAffine2DTransform3D[img,tx,ty,0,0,1,0,0,1,offColor]
]NLinearAffine2DTransform3D[img,tx,ty,0,0,1,0,0,1,offColor]/; ArrayDepth[img]===3


TranslateArray[img_?ArrayQ,{tx_?NumberQ,ty_?NumberQ,tz_?NumberQ},offColor:Except[_Rule | _RuleDelayed, _]:0, opts___?OptionQ]:=Switch[
ArrayInterpolation/. {opts}/.Options[TranslateArray],
ConstantInterpolation,
NConstantAffineTransform3D[img,tx,ty,tz,0,0,0,1,0,0,0,1,0,0,0,1,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform3D[img,tx,ty,tz,0,0,0,1,0,0,0,1,0,0,0,1,offColor],
LinearInterpolation|_,
NLinearAffineTransform3D[img,tx,ty,tz,0,0,0,1,0,0,0,1,0,0,0,1,offColor]
]/; ArrayDepth[img]===3


Options[RotateArray] = {ArrayInterpolation-> LinearInterpolation};


RotateArray[img_,\[Alpha]_,offColor:Except[_Rule | _RuleDelayed, _]:0,opts___?OptionQ]:=RotateArray[img,\[Alpha],Reverse[Dimensions[img]+1]/2,offColor,opts]/; ArrayDepth[img]===2


RotateArray[img_?ArrayQ,\[Alpha]_?NumericQ,{x0_?NumberQ,y0_?NumberQ},offColor:Except[_?OptionQ, _]:0,opts___?OptionQ]:=
Switch[
ArrayInterpolation/. {opts}/.Options[RotateArray],
ConstantInterpolation,
NConstantAffineTransform[img,x0,y0,x0,y0,Cos[N[\[Alpha]]],Sin[N[\[Alpha]]],-Sin[N[\[Alpha]]],Cos[N[\[Alpha]]],offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform[img,x0,y0,x0,y0,Cos[N[\[Alpha]]],Sin[N[\[Alpha]]],-Sin[N[\[Alpha]]],Cos[N[\[Alpha]]],offColor],
LinearInterpolation|_,
NLinearAffineTransform[img,x0,y0,x0,y0,Cos[N[\[Alpha]]],Sin[N[\[Alpha]]],-Sin[N[\[Alpha]]],Cos[N[\[Alpha]]],offColor]
]/; ArrayDepth[img]===2


RotateArray[img_,\[Alpha]_?NumericQ,{x0_,y0_,z0_},offColor:Except[_?OptionQ, _]:0,opts___?OptionQ]:=RotateArray[img,\[Alpha],0,0,{x0,y0,z0},offColor,opts]/; ArrayDepth[img]===3


RotateArray[img_,\[Alpha]_?NumericQ,\[Beta]_?NumericQ,{x0_,y0_,z0_},offColor:Except[_?OptionQ, _]:0,opts___?OptionQ]:=RotateArray[img,\[Alpha],\[Beta],0,{x0,y0,z0},offColor,opts]/; ArrayDepth[img]===3


RotateArray[img_,\[Alpha]_?NumericQ,\[Beta]_?NumericQ,\[Gamma]_?NumericQ,{x0_,y0_,z0_},offColor:Except[_?OptionQ, _]:0,opts___?OptionQ]:=RotateArray[img,\[Alpha],\[Beta],\[Gamma],{x0,y0,z0},offColor,opts]/; ArrayDepth[img]===3


RotateArray[img_,\[Alpha]_?NumericQ,\[Beta]_?NumericQ,\[Gamma]_?NumericQ,offColor:Except[_?OptionQ|_List, _]:0,opts___?OptionQ]:=RotateArray[img,\[Alpha],\[Beta],\[Gamma],Reverse[Dimensions[img]+1]/2,offColor,opts]/; ArrayDepth[img]===3


RotateArray[img_?ArrayQ,\[Alpha]_?NumericQ,0|0.0,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,_},offColor:Except[_?OptionQ, _],opts___?OptionQ]:=
Switch[
ArrayInterpolation/. {opts}/.Options[RotateArray],
ConstantInterpolation,
NConstantAffine2DTransform3D[img,x0,y0,x0,y0,Cos[N[\[Alpha]+\[Gamma]]],Sin[N[\[Alpha]+\[Gamma]]],-Sin[N[\[Alpha]+\[Gamma]]],Cos[N[\[Alpha]+\[Gamma]]],offColor],
CubicBSplineInterpolation,
NCubicBSplineAffine2DTransform3D[img,x0,y0,x0,y0,Cos[N[\[Alpha]+\[Gamma]]],Sin[N[\[Alpha]+\[Gamma]]],-Sin[N[\[Alpha]+\[Gamma]]],Cos[N[\[Alpha]+\[Gamma]]],offColor],
LinearInterpolation|_,
NLinearAffine2DTransform3D[img,x0,y0,x0,y0,Cos[N[\[Alpha]+\[Gamma]]],Sin[N[\[Alpha]+\[Gamma]]],-Sin[N[\[Alpha]+\[Gamma]]],Cos[N[\[Alpha]+\[Gamma]]],offColor]
]/; ArrayDepth[img]===3


RotateArray[img_?ArrayQ,\[Alpha]_?NumericQ,\[Beta]_?NumericQ,\[Gamma]_?NumericQ,{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor:Except[_?OptionQ, _],opts___?OptionQ]:=
Switch[
ArrayInterpolation/. {opts}/.Options[RotateArray],
ConstantInterpolation,
NConstantAffineTransform3D[img,x0,y0,z0,x0,y0,z0,
Cos[N[\[Alpha]]] Cos[N[\[Gamma]]]-Cos[N[\[Beta]]] Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Sin[N[\[Gamma]]],Sin[N[\[Beta]]] Sin[N[\[Gamma]]],-Cos[N[\[Beta]]] Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]-Cos[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Beta]]],Sin[N[\[Alpha]]] Sin[N[\[Beta]]],-Cos[N[\[Alpha]]] Sin[N[\[Beta]]],Cos[N[\[Beta]]],offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform3D[img,x0,y0,z0,x0,y0,z0,
Cos[N[\[Alpha]]] Cos[N[\[Gamma]]]-Cos[N[\[Beta]]] Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Sin[N[\[Gamma]]],Sin[N[\[Beta]]] Sin[N[\[Gamma]]],-Cos[N[\[Beta]]] Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]-Cos[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Beta]]],Sin[N[\[Alpha]]] Sin[N[\[Beta]]],-Cos[N[\[Alpha]]] Sin[N[\[Beta]]],Cos[N[\[Beta]]],offColor],
LinearInterpolation|_,
NLinearAffineTransform3D[img,x0,y0,z0,x0,y0,z0,
Cos[N[\[Alpha]]] Cos[N[\[Gamma]]]-Cos[N[\[Beta]]] Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]+Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Sin[N[\[Gamma]]],Sin[N[\[Beta]]] Sin[N[\[Gamma]]],-Cos[N[\[Beta]]] Cos[N[\[Gamma]]] Sin[N[\[Alpha]]]-Cos[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Alpha]]] Cos[N[\[Beta]]] Cos[N[\[Gamma]]]-Sin[N[\[Alpha]]] Sin[N[\[Gamma]]],Cos[N[\[Gamma]]] Sin[N[\[Beta]]],Sin[N[\[Alpha]]] Sin[N[\[Beta]]],-Cos[N[\[Alpha]]] Sin[N[\[Beta]]],Cos[N[\[Beta]]],offColor]
]/; ArrayDepth[img]===3


Options[ScaleArray] = {ArrayInterpolation-> LinearInterpolation};


ScaleArray[img_,s:Except[_List,_],offColor:Except[_?OptionQ|_List, _]:0,opts___?OptionQ]:=ScaleArray[img,Table[s, {ArrayDepth[img]}],Reverse[Dimensions[img]],offColor,opts]


ScaleArray[img_,s:Except[_List,_],{pos0__},offColor:Except[_?OptionQ, _]:0,opts___?OptionQ]:=ScaleArray[img,Table[s, {ArrayDepth[img]}],{pos0},offColor,opts]


ScaleArray[img_,{s__},{pos0__},opts___?OptionQ]:=ScaleArray[img,{s},{pos0},0,opts]


ScaleArray[img_?ArrayQ,{sx_?NumericQ,sy_?NumericQ},{x0_?NumberQ,y0_?NumberQ},offColor:Except[_?OptionQ, _]:0,opts___?OptionQ]:=
Switch[
ArrayInterpolation/. {opts}/.Options[ScaleArray],
ConstantInterpolation,
NConstantAffineTransform[img,x0,y0,x0,y0,1/sx,0,0,1/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform[img,x0,y0,x0,y0,1/sx,0,0,1/sy,offColor],
LinearInterpolation|_,
NLinearAffineTransform[img,x0,y0,x0,y0,1/sx,0,0,1/sy,offColor]
]/; ArrayDepth[img]===2


ScaleArray[img_?ArrayQ,{sx_?NumericQ,sy_?NumericQ,1|1.0},{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor:Except[_?OptionQ, _]:0,opts___?OptionQ]:=
Switch[
ArrayInterpolation/. {opts}/.Options[ScaleArray],
ConstantInterpolation,
NConstantAffine2DTransform3D[img,x0,y0,x0,y0,1/sx,0,0,1/sy,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffine2DTransform3D[img,x0,y0,x0,y0,1/sx,0,0,1/sy,offColor],
LinearInterpolation|_,
NLinearAffine2DTransform3D[img,x0,y0,x0,y0,1/sx,0,0,1/sy,offColor]
]/; ArrayDepth[img]===3


ScaleArray[img_?ArrayQ,{sx_?NumericQ,sy_?NumericQ,sz_?NumericQ},{x0_?NumberQ,y0_?NumberQ,z0_?NumberQ},offColor:Except[_?OptionQ, _]:0,opts___?OptionQ]:=
Switch[
ArrayInterpolation/. {opts}/.Options[ScaleArray],
ConstantInterpolation,
NConstantAffineTransform3D[img,x0,y0,z0,x0,y0,z0,1/sx,0,0,0,1/sy,0,0,0,1/sz,offColor],
CubicBSplineInterpolation,
NCubicBSplineAffineTransform3D[img,x0,y0,z0,x0,y0,z0,1/sx,0,0,0,1/sy,0,0,0,1/sz,offColor],
LinearInterpolation|_,
NLinearAffineTransform3D[img,x0,y0,z0,x0,y0,z0,1/sx,0,0,0,1/sy,0,0,0,1/sz,offColor]
]/; ArrayDepth[img]===3


Options[PerspectiveTransformArray] = {ArrayInterpolation-> LinearInterpolation};


PerspectiveTransformArray[img_?ArrayQ,{y0_?NumberQ,a_?NumberQ,b_?NumberQ},offColor:Except[_?OptionQ|_List,_]:0,opts___?OptionQ]:=
Switch[
ArrayInterpolation/. {opts}/.Options[PerspectiveTransformArray],
ConstantInterpolation,
NConstantPerspectiveTransform[img,a,b,y0,offColor],
CubicBSplineInterpolation,
NCubicBSplinePerspectiveTransform[img,a,b,y0,offColor],
LinearInterpolation|_,
NLinearPerspectiveTransform[img,a,b,y0,offColor]
]/; ArrayDepth[img]===2


NConstantPerspectiveTransform=
Compile[
{{img,_Real,2},{a,_Real},{b,_Real},{y0,_Real},{offColor,_Real}},
With[
{xn=Dimensions[img][[2]],yn=Dimensions[img][[1]]},
Table[
NConstantImageInterpolation[img,x,((a*(x-1)+b*(xn-x))/(xn-1))*y+y0,xn,yn,offColor],
{y,1-y0,yn-y0},
{x,1,xn}
]
],
{{NConstantImageInterpolation[_,_,_,_,_,_],_Real}}
];


NLinearPerspectiveTransform=
Compile[
{{img,_Real,2},{a,_Real},{b,_Real},{y0,_Real},{offColor,_Real}},
With[
{xn=Dimensions[img][[2]],yn=Dimensions[img][[1]]},
Table[
NLinearImageInterpolation[img,x,((a*(x-1)+b*(xn-x))/(xn-1))*y+y0,xn,yn,offColor],
{y,1-y0,yn-y0},
{x,1,xn}
]
],
{{NLinearImageInterpolation[_,_,_,_,_,_],_Real}}
];


NCubicBSplinePerspectiveTransform=
Compile[
{{img,_Real,2},{a,_Real},{b,_Real},{y0,_Real},{offColor,_Real}},
With[
{xn=Dimensions[img][[2]],yn=Dimensions[img][[1]],tmp=CubicBSplineImageInterpolationFilter[img]},
Table[
NCubicBSplineImageInterpolation[tmp,x,((a*(x-1)+b*(xn-x))/(xn-1))*y+y0,xn,yn,offColor],
{y,1-y0,yn-y0},
{x,1,xn}
]
],
{{NCubicBSplineImageInterpolation[_,_,_,_,_,_],_Real},{CubicBSplineImageInterpolationFilter[_],_Real,2}}
];


PerspectiveTransformArray[img_?ArrayQ,{x0_?NumberQ,ax_?NumberQ,bx_?NumberQ},{y0_?NumberQ,ay_?NumberQ,by_?NumberQ},offColor:Except[_?OptionQ,_]:0,opts___?OptionQ]:=
Switch[
ArrayInterpolation/. {opts}/.Options[PerspectiveTransformArray],
ConstantInterpolation,
NConstantPerspectiveTransform3D[img,ax,bx,ay,by,x0,y0,offColor],
CubicBSplineInterpolation,
NCubicBSplinePerspectiveTransform3D[img,ax,bx,ay,by,x0,y0,offColor],
LinearInterpolation|_,
NLinearPerspectiveTransform3D[img,ax,bx,ay,by,x0,y0,offColor]
]/; ArrayDepth[img]===3


NConstantPerspectiveTransform3D=
Compile[
{{img,_Real,3},{ax,_Real},{bx,_Real},{ay,_Real},{by,_Real},{x0,_Real},{y0,_Real},{offColor,_Real}},
With[
{xn=Dimensions[img][[3]],yn=Dimensions[img][[2]],zn=Dimensions[img][[1]]},
Table[
NConstantImageInterpolation3D[img,((ax*(z-1)+bx*(zn-z))/(zn-1))*x+x0,((ay*(z-1)+by*(zn-z))/(zn-1))*y+y0,z,xn,yn,zn,offColor],
{z,1,zn},
{y,1-y0,yn-y0},
{x,1-x0,xn-x0}
]
],
{{NConstantImageInterpolation3D[_,_,_,_,_,_,_,_],_Real}}
];


NLinearPerspectiveTransform3D=
Compile[
{{img,_Real,3},{ax,_Real},{bx,_Real},{ay,_Real},{by,_Real},{x0,_Real},{y0,_Real},{offColor,_Real}},
With[
{xn=Dimensions[img][[3]],yn=Dimensions[img][[2]],zn=Dimensions[img][[1]]},
Table[
NLinearImageInterpolation3D[img,((ax*(z-1)+bx*(zn-z))/(zn-1))*x+x0,((ay*(z-1)+by*(zn-z))/(zn-1))*y+y0,z,xn,yn,zn,offColor],
{z,1,zn},
{y,1-y0,yn-y0},
{x,1-x0,xn-x0}
]
],
{{NLinearImageInterpolation3D[_,_,_,_,_,_,_,_],_Real}}
];


NCubicBSplinePerspectiveTransform3D=
Compile[
{{img,_Real,3},{ax,_Real},{bx,_Real},{ay,_Real},{by,_Real},{x0,_Real},{y0,_Real},{offColor,_Real}},
With[
{xn=Dimensions[img][[3]],yn=Dimensions[img][[2]],zn=Dimensions[img][[1]],
tmp=CubicBSplineImageInterpolationFilter[img]},
Table[
NCubicBSplineImageInterpolation3D[tmp,((ax*(z-1)+bx*(zn-z))/(zn-1))*x+x0,((ay*(z-1)+by*(zn-z))/(zn-1))*y+y0,z,xn,yn,zn,offColor],
{z,1,zn},
{y,1-y0,yn-y0},
{x,1-x0,xn-x0}
]
],
{{NCubicBSplineImageInterpolation3D[_,_,_,_,_,_,_,_],_Real},{CubicBSplineImageInterpolationFilter[_],_Real,3}}
];


End[]

SetAttributes[
{NConstantImageInterpolation,NConstantImageInterpolation3D,NConstant2DImageInterpolation3D,NLinearImageInterpolation,NLinearImageInterpolation3D,NLinear2DImageInterpolation3D,CubicBSplineImageInterpolationFilter,NCubicBSplineImageInterpolation,NCubicBSplineImageInterpolation3D,NCubicBSpline2DImageInterpolation3D,TranslateArray,RotateArray,ScaleArray,NLinearAffineTransform,NConstantAffineTransform,NLinearAffineTransform3D,NConstantAffineTransform3D,NLinearAffine2DTransform3D,NConsantAffine2DTransform3D,NCubicBSplineAffineTransform,NCubicBSplineAffineTransform3D,NCubicBSplineAffine2DTransform3D,PerspectiveTransformArray,ArrayInterpolation,
ConstantInterpolation, LinearInterpolation,CubicBSplineInterpolation,NCubicBSplineInterpolation},
{Protected,ReadProtected}
];

EndPackage[]
