(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`ImageVectorCalculus`"] = {2010,9,7,17,40,0};

Protect[TimeStamp];


(*:Name: MathVisionTools`ImageVectorCalculus` *)

(*:Author: Markus van Almsick*)

(*:Email address: M.v.Almsick@tue.nl*)

(*:Context: MathVisionTools`ImageVectorCalculus`*)

(*:Package Version: 1.0 *)

(*:Mathematica Version: 7.0 *)

(*:Copyright: Copyright 2009, Technische Universiteit Eindhoven*)

(*:Title: ImageVectorCalculus *)

(*:Summary: This package implements vector calculus operators with Image derivatives *)

(*:Keywords: Grad, Curl, Div, gauge, invariant, B-spline*)

(*:Requirements: Mathematica 7 or higher *)

(*:Source: *)

(*:History: Version 1.0 by  Markus van Almsick, December 2009 *)

(*:Limitations: *)

(*:Discussion: *)

(*:To do: *)


BeginPackage["MathVisionTools`ImageVectorCalculus`",
"MathVisionTools`ImageDerivative`",
"MathVisionTools`Common`MathVisionToolsCommon`"]

Unprotect[
  ImageGrad,
ImageCurl,
ImageDiv,
ImageLaplacian,
ImageStructureTensor,
ImageHessian,
ImageGaugeDerivative
]


ImageGrad::usage = "\!\(\*\nStyleBox[\"ImageGrad\", \"MR\"]\)[\!\(\*\nStyleBox[\"img\", \"IT\"]\)] gives the gradient of the image array \!\(\*\nStyleBox[\"img\",\nFontSlant->\"Italic\"]\) in the Cartesian coordinate system obtained via \!\(\*\nStyleBox[\"ImageDerivatives\", \"MR\"]\).";


ImageCurl::usage = "\!\(\*\nStyleBox[\"ImageCurl\", \"MR\"]\)[\!\(\*\nStyleBox[\"img\", \"IT\"]\)] gives the curl of the vector-valued image array \!\(\*\nStyleBox[\"img\",\nFontSlant->\"Italic\"]\) in the Cartesian coordinate system obtained via \!\(\*\nStyleBox[\"ImageDerivatives\", \"MR\"]\)";


ImageDiv::usage = "\!\(\*\nStyleBox[\"ImageDiv\", \"MR\"]\)[\!\(\*\nStyleBox[\"img\", \"IT\"]\)] gives the divergence of the vector-valued image array \!\(\*\nStyleBox[\"img\",\nFontSlant->\"Italic\"]\) in the Cartesian coordinate system obtained via \!\(\*\nStyleBox[\"ImageDerivatives\", \"MR\"]\).";


ImageLaplacian::usage = "\!\(\*\nStyleBox[\"ImageLaplacian\", \"MR\"]\)[\!\(\*\nStyleBox[\"img\", \"IT\"]\)] gives the Laplacian of the scalar or vector-valued image array \!\(\*\nStyleBox[\"img\",\nFontSlant->\"Italic\"]\) in the Cartesian coordinate system obtained via \!\(\*\nStyleBox[\"ImageDerivatives\", \"MR\"]\).";


ImageStructureTensor::usage = "\!\(\*\nStyleBox[\"ImageStructureTensor\", \"MR\"]\)[\!\(\*\nStyleBox[\"img\", \"IT\"]\)] gives the structure tensor of the scalar- or tensor-valued image array \!\(\*\nStyleBox[\"img\", \"IT\"]\) in the Cartesian coordinate system obtained via Image derivatives.";


ImageHessian::usage = "\!\(\*\nStyleBox[\"ImageHessian\", \"MR\"]\)[\!\(\*\nStyleBox[\"img\", \"IT\"]\)] renders the hessian matrix of Image derivatives.";


ImageGaugeDerivative::usage = "\!\(\*\nStyleBox[\"ImageGaugeDerivative\", \"MR\"]\)[\!\(\*\nStyleBox[\"nv\", \"IT\"]\), \!\(\*\nStyleBox[\"nw\", \"IT\"]\)][\!\(\*\nStyleBox[\"img\", \"IT\"]\)] renders the Image derivative of a 2-dimensional image or luminosity function \!\(\*\nStyleBox[\"img\", \"IT\"]\) in the gauge coordinates \!\(\*\nStyleBox[\"v\", \"IT\"]\) and \!\(\*\nStyleBox[\"w\", \"IT\"]\)\!\(\*\nStyleBox[\".\", \"IT\"]\)\!\(\*\nStyleBox[\"  \", \"IT\"]\)\!\(\*\nStyleBox[\"w\", \"IT\"]\) is the gauge coordinate in the direction of the gradient and \!\(\*\nStyleBox[\"v\", \"IT\"]\) is the gauge coordinate along the isophote tangent.  \!\(\*\nStyleBox[\"nv\", \"IT\"]\) denotes the derivative order in \!\(\*\nStyleBox[\"v\", \"IT\"]\) and \!\(\*\nStyleBox[\"nw\", \"IT\"]\) the derivative order in \!\(\*\nStyleBox[\"w\", \"IT\"]\).";


Begin["`Private`"]


ImageGrad[img_?ImageQ]:=Image[ImageGrad[2][ImageData[img,Interleaving-> True]]]


ImageGrad[r_Integer?Positive][img_] := Transpose[Apply[ImageDerivative[##][img]&,IdentityMatrix[r],{1}],RotateRight[Range[r+1]]]/; r <= ArrayDepth[img]


ImageGrad[img_?ArrayQ] := ImageGrad[ArrayDepth[img]][img]


ImageCurl[img_?ImageQ]:=Image[ImageCurl[ImageData[img,Interleaving-> True]]]/;MatchQ[ImageDimensions[img],{_,_,2}]


ImageCurl[img_] := 
ImageDerivative[1,0][img[[All,All,2]]]-ImageDerivative[0,1][img[[All,All,1]]]/; MatchQ[Dimensions[img],{_,_,2}]


ImageCurl[img_] := 
Transpose[
{ImageDerivative[0,1,0][img[[All,All,3]]]-ImageDerivative[0,0,1][img[[All,All,2]]],
ImageDerivative[0,0,1][img[[All,All,1]]]-ImageDerivative[1,0,0][img[[All,All,3]]],
ImageDerivative[1,0,0][img[[All,All,2]]]-ImageDerivative[0,1,0][img[[All,All,1]]]
},{3,1,2}]/;MatchQ[Dimensions[img],{_,_,_,3}]


ImageDiv[img_] := 
Image[ImageDiv[ImageData[img,Interleaving-> True]]]/;MatchQ[ImageDimensions[img],{_,_,2}]


ImageDiv[img_] := 
ImageDerivative[1][img[[All,1]]]/; MatchQ[Dimensions[img],{_,1}]


ImageDiv[img_] := 
ImageDerivative[1,0][img[[All,All,1]]]+ImageDerivative[0,1][img[[All,All,2]]]/; MatchQ[Dimensions[img],{_,_,2}]


ImageDiv[img_] := 
ImageDerivative[1,0,0][img[[All,All,All,1]]]+
ImageDerivative[0,1,0][img[[All,All,All,2]]]+
ImageDerivative[0,0,1][img[[All,All,All,3]]]/; MatchQ[Dimensions[img],{_,_,_,3}]


ImageDiv[img_] := 
ImageDerivative[1,0,0,0][img[[All,All,All,All,1]]]+
ImageDerivative[0,1,0,0][img[[All,All,All,All,2]]]+
ImageDerivative[0,0,1,0][img[[All,All,All,All,3]]]+
ImageDerivative[0,0,0,1][img[[All,All,All,All,4]]]/; MatchQ[Dimensions[img],{_,_,_,_,4}]


ImageLaplacian[img_?ImageQ]:=Image[ImageLaplacian[2][ImageData[img,Interleaving-> True]],Sequence@@Options[img]]


ImageLaplacian[r_Integer?Positive][img_] := Total[Apply[ImageDerivative[##][img]&,2 IdentityMatrix[r],{1}]]/; r <= ArrayDepth[img]


ImageLaplacian[img_?ArrayQ] := ImageLaplacian[ArrayDepth[img]][img]


ImageStructureTensor[img_?ImageQ]:=ImageStructureTensor[2][ImageData[img,Interleaving-> True]]


ImageStructureTensor[r_Integer?Positive][img_] := MapThread[Outer[Times,#1,#2,1]&,{ImageGrad[r][img],ImageGrad[r][img]},r]/; r <= ArrayDepth[img]


ImageStructureTensor[img_?ArrayQ] := ImageStructureTensor[ArrayDepth[img]][img]


ImageHessian[img_?ImageQ]:=ImageHessian[2][ImageData[img,Interleaving-> True]]


ImageHessian[r_Integer?Positive][img_] := Transpose[Apply[ImageDerivative[##][img]&,Outer[Plus,IdentityMatrix[r],IdentityMatrix[r],1],{2}],RotateRight[Range[r+2],2]]/; r <= ArrayDepth[img]


ImageHessian[img_?ArrayQ] := ImageHessian[ArrayDepth[img]][img]


ImageGaugeDerivative[Nv_Integer?NonNegative,Nw_Integer?NonNegative][img_?ImageQ]:=Image[ImageGaugeDerivative[Nv,Nw][ImageData[img,Interleaving-> True]],Sequence@@Options[img]]


ImageGaugeDerivative[1,0][img_?ArrayQ]:= Array[0.0&,Dimensions[img]];


ImageGaugeDerivative[Nv_Integer?NonNegative,Nw_Integer?NonNegative][img_?ArrayQ]:=
Module[
{Lx = ImageDerivative[1,0][img],
Ly = ImageDerivative[0,1][img]},
Total[Table[Sum[((-1)^nv Binomial[Nv,nv] Binomial[Nw,nv+q]) Lx^(2 nv+q) Ly^(Nv+Nw-(2 nv+q)) , {nv,Max[-q,0],Min[Nv,Nw-q]}
],{q,-Nv,Nw}]*Apply[ImageDerivative[##][img]&,Table[{Nv+q,Nw-q},{q,-Nv,Nw}]] ](Lx^2 +Ly^2)^(-(Nv+Nw)/2)
]


End[]

SetAttributes[
{ImageGrad,ImageCurl,ImageDiv,ImageLaplacian,ImageStructureTensor,ImageHessian,ImageGaugeDerivative},
{Protected, ReadProtected, Locked}
];

EndPackage[]
