(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`"] = {2010,11,14,16,06,0};

Protect[TimeStamp];


(*:Name: MathVisionTools`Kernel`init *)

(*:Authors: BMIA at TU Eindhoven, edited by Markus van Almsick *)

(*:Email address: m.v.almsick@tue.nl *)

(*:Context: MathVisionTools` *)

(*:Package Version: 3.2 *)

(*:Mathematica Version: 7.0 *)

(*:Copyright: Copyright 2010, Technische Universiteit Eindhoven *)

(*:Title: Math Vision Tools *)

(*:Summary: Addon initialization file *)

(*:Keywords: init, path, stub, MathVisionTools *)

(*:Requirements: None *)

(*:Source: None *)

(*:History: Version 1.0 by Markus van Almsick, May 2003 *)
(*:History: Version 2.4 by Markus van Almsick, March 2005 *)
(*:History: Version 2.8 by Markus van Almsick, December 2005 *)
(*:History: Version 2.9 by Markus van Almsick, May 2006 *)
(*:History: Version 2.12 by Markus van Almsick, July 2007 *)
(*:History: Version 2.15 by Markus van Almsick, September 2008 *)
(*:History: Version 2.21 by Markus van Almsick, February 2009 *)
(*:History: Version 3.0  by Markus van Almsick, December 2009 *)
(*:History: Version 3.1  by Markus van Almsick, February 2010 *)
(*:History: Version 3.2  by Markus van Almsick, November 2010 *)

(*:Limitations: *)

(*:Discussion: *)

(*:To do: *)


BeginPackage["MathVisionTools`"]


$MathVisionToolsVersion="3.2 (November 14th, 2010)";


$RemoteOperation=Not[StringFreeQ[First[$ParentLink],"@"]];


$ParallelOperation=Not[StringFreeQ[First[$ParentLink],"ParentLink"]];


InsertCopyrightNote[]:=
Module[
{nb = InputNotebook[]},
(* delete old copyright note *)
NotebookLocate["MathVisionToolsCopyrightNote"];
If[NotebookRead[nb]=!={},
SetOptions[NotebookSelection[nb],Editable->True,Deletable->True];
NotebookDelete[nb]
];
(* move to insertion point *)
NotebookFind[nb,"MathVisionTools`",Previous,CellContents, AutoScroll-> False];
SelectionMove[nb,All,Cell, AutoScroll-> False];
SetOptions[
NotebookSelection[nb],
MathVisionToolsCopyRight->
PadRight[
Join[ 
{StringJoin[ToString[Take[Date[],5]],": version ",$MathVisionToolsVersion," loaded by ",ToString[$UserName]," on ",ToString[$MachineID],"."]},
(MathVisionToolsCopyRight/.Options[NotebookSelection[nb]])/.MathVisionToolsCopyRight-> {}
],
6,
Null
]/. Null-> Sequence[]
];
SelectionMove[nb,After,Cell,AutoScroll-> False];
(* insert copyright note *)
NotebookWrite[
nb,
Cell[
TextData[{
ButtonBox[
StyleBox["MathVisionTools",FontWeight->"Bold"],ButtonData:>{URL["http://www.mathvisiontools.net/"],None},ButtonStyle->"Hyperlink"
],
"\n\[Copyright]2008 Biomedical Image-Analysis, Technische Universiteit Eindhoven, the Netherlands\nThis ",StyleBox["Mathematica",FontSlant->"Italic"]," add-on, version "<>$MathVisionToolsVersion<>" is for ",
StyleBox["academic use only",FontVariations->{"Underline"->True}],
".\nPlease, contact ",
ButtonBox[
"Dr. Markus van Almsick",ButtonData:>{URL["mailto:m.v.almsick@tue.nl"],None},ButtonStyle->"Hyperlink"
],
" or ",
ButtonBox[
"Prof. Bart ter Haar Romeny",ButtonData:>{URL["mailto:B.M.terhaarRomeny@tue.nl"],None},ButtonStyle->"Hyperlink"
],
" for bug reports and commercial use."}
],
"Text",
Editable->False,
Deletable->True,
CellFrame->True,
ShowCellBracket->False,
ShowSelection->False,
Background->RGBColor[1,0.4,0.4],
CellTags->"MathVisionToolsCopyrightNote"
]
]
];


If[
Not[$ParallelOperation],
If[
$RemoteOperation,
Print[
"MathVisionTools \[Copyright]2008 Biomedical Image-Analysis, Technische Universiteit Eindhoven, the Netherlands\n",
"This Mathematica package, version ",$MathVisionToolsVersion," is for academic use only.\n",
"Please, contact Markus van Almsick, m.v.almsick@tue.nl, for bug reports and commercial use."
],
InsertCopyrightNote[]
]
]


AppendTo[$Path,ToFileName[{$UserAddOnsDirectory,"Applications","MathVisionTools","Data"}]];
AppendTo[$Path,ToFileName[{$AddOnsDirectory,"Applications","MathVisionTools","Data"}]];
AppendTo[$Path,ToFileName[{$InstallationDirectory,"AddOns","Applications","MathVisionTools","Data"}]];
If[$SystemID==="Windows",AppendTo[$Path,ToFileName[{$TopDirectory,"AddOns","Applications","MathVisionTools","Data"}]]];


EndPackage[]


Needs["MathVisionTools`VersionCompatibility`"]


(*Declarations for package MathVisionTools`Common`MathVisionToolsCommon`*)

DeclarePackage["MathVisionTools`Common`MathVisionToolsCommon`",{"ImageBoundary","Cyclic","Reflective","Truncate"}]


(*Declarations for package MathVisionTools`ActiveContours`*)

DeclarePackage["MathVisionTools`ActiveContour`",{"ActiveContour","ActiveContourStep","ActiveContourPlot","CubicLoop","SplineLength","ApproximationOrder"}]


(*Declarations for package MathVisionTools`ImageFrame`*)

DeclarePackage["MathVisionTools`ImageFrame`",{"RemoveImageFrame","ImageFrame","ImageFrame1D"}]


(*Declarations for package MathVisionTools`Convolve`*)
If[Not[$VersionNumber>=7],
DeclarePackage["MathVisionTools`Convolve`",{"Convolve","Convolute"}]
]


(*Declarations for package MathVisionTools`ImageDerivative`*)

DeclarePackage["MathVisionTools`ImageDerivative`",
{"ImageDerivative"}]


(*Declarations for package MathVisionTools`ImageVectorCalculus`*)

DeclarePackage["MathVisionTools`ImageVectorCalculus`",
{"ImageGrad","ImageCurl","ImageDiv","ImageLaplacian","ImageStructureTensor","ImageHessian","ImageGaugeDerivative"}]


(*Declarations for package MathVisionTools`GaussianDerivative`*)

DeclarePackage["MathVisionTools`GaussianDerivative`",
{"DefaultScaleParameter","G","SigmaToScaleT",
"ScaleTToSigma","NGaussianKernel","GaussianKernel","AngularGaussianKernel","NGaussianDKernel","GaussianDKernel","GaussianD","GaussianBlur","GaussianDerivative","GaussianDerivativeJet","GaussianDerivativeAt","LocalMinimumMask","LocalMaximumMask","ThresholdFilter","KernelRange"}]


(*Declarations for package MathVisionTools`GaussianVectorCalculus`*)

DeclarePackage["MathVisionTools`GaussianVectorCalculus`",
{"GaussianGrad","GaussianCurl","GaussianDiv","GaussianLaplacian","GaussianStructureTensor","GaussianHessian","GaussianGaugeDerivative"}]


(*Declarations for package MathVisionTools`Histogram`*)

If[
$VersionNumber<8,
DeclarePackage["MathVisionTools`Histogram7`",{"HistogramList","HistogramListEntropy","HistogramListRange","HistogramListBinRange","HistogramListRangeSpecified","HistogramListNormalized","HistogramListBinFunction"}],
DeclarePackage["MathVisionTools`Histogram`",{"mvtHistogramList","HistogramListEntropy","HistogramListRange","HistogramListBinRange","HistogramListRangeSpecified","HistogramListNormalized","HistogramListBinFunction"}]
]


(*Declarations for package MathVisionTools`OrientationBundle`*)

DeclarePackage["MathVisionTools`OrientationBundle`",{"OrientationTransform","OrientationBundleTransform","InverseOrientationBundleTransform","DirectionalFourierFilter","FourierOrientationBundleTransform","InverseFourierOrientationBundleTransform"}]


(*Declarations for package MathVisionTools`HankelTransform`*)

DeclarePackage["MathVisionTools`HankelTransform`",{"HankelTransform","InverseHankelTransform","HalfGaussHankelCoefficient","GaussHankelCoefficient","HankelBasis","NHankelBasis","HankelBasisEigenvalue","HankelBasisNList","NHankelBasisNList","HankelBasisRadius","HankelBasisNMList","NHankelBasisNMList","HankelBasis","PolarFourierScale","PolarFourierNMax","PolarFourier","InversePolarFourier","RotatePolarFourierPhase","CenteredFourier","InverseCenteredFourier"}]


(*Declarations for package MathVisionTools`GeometryDrivenDiffusion`*)

DeclarePackage["MathVisionTools`GeometryDrivenDiffusion`",{"GeometryDrivenDiffusion","DiffusionEquation","EuclideanShorten","PeronaMalik1","PeronaMalik2","ForwardEuler","RungeKutta"}]


(*Declarations for package MathVisionTools`BilateralFilter`*)

If[
$VersionNumber<8,
DeclarePackage["MathVisionTools`BilateralFilter7`",{"BilateralFilter","BilateralColorFilter"}],
DeclarePackage["MathVisionTools`BilateralFilter7`",{"BilateralGrayscaleFilter","BilateralColorFilter"}]
]


(*Declarations for package MathVisionTools`RegionGrowing`*)

DeclarePackage["MathVisionTools`RegionGrowing`",{"RegionGrowing","AdjacencyNumbers"}]


(*Declarations for package MathVisionTools`ImageTransformation`*)

DeclarePackage["MathVisionTools`ImageInterpolation`",{"ImageInterpolation",
"InterpolatingImage","NBSplineInterpolationFilter1D","BSplineInterpolationFilter","BSplineInterpolationFilter1D"}]


(*Declarations for package MathVisionTools`ImageTransformation`*)

DeclarePackage["MathVisionTools`ImageTransformation`",{"NConstantImageInterpolation","NConstantImageInterpolation3D","NConstant2DImageInterpolation3D","NLinearImageInterpolation","NLinearImageInterpolation3D","NLinear2DImageInterpolation3D","NCubicBSplineImageInterpolation","NCubicBSplineImageInterpolation3D","NCubicBSpline2DImageInterpolation3D","CubicBSplineImageInterpolationFilter","TranslateArray","RotateArray","ScaleArray","NLinearAffineTransform","NLinearAffineTransform3D","NLinearAffine2DTransform3D","NConstantAffineTransform","NConstantAffineTransform3D","NConstantAffine2DTransform3D","NCubicBSplineAffineTransform","NCubicBSplineAffineTransform3D","NCubicBSplineAffine2DTransform3D","PerspectiveTransformArray","ArrayInterpolation",
"ConstantInterpolation", "LinearInterpolation","CubicBSplineInterpolation"}]


(*Declarations for package MathVisionTools`RadialBasisInterpolation`*)

DeclarePackage["MathVisionTools`RadialBasisInterpolation`",{"ThinPlateSplineNorm","GaussianNorm","RadialBasisInterpolation",
"RadialBasisNorm","Smoothness"}]


(*Declarations for package MathVisionTools`RadialBasisInterpolation`*)

DeclarePackage["MathVisionTools`LogicLinearOperators`",{"LinearAnd","LinearOr","LinearTrue","LinearSigma","LinearTrue"}]


(*Declarations for package MathVisionTools`VolumeRendering`*)

DeclarePackage["MathVisionTools`VolumeRendering`",{"IntensityProjection","MaximumIntensityProjection"}]


(*Declarations for package MathVisionTools`VolumeRenderer`*)

(* DeclarePackage["MathVisionTools`VolumeRenderer`",
{"ListDensityPlot3D","TransferFunction", "CUDADevices"}] *)


(*Declarations for package MathVisionTools`SphericalTesselation`*)

DeclarePackage["MathVisionTools`SphericalTesselation`",
{"IcosahedralComplex","OctahedralComplex","TetrahedralComplex","DualTesselate","DualComplex","VertexAreas","TriangularTesselate","BalancedTriangularTesselate","Triangulate","SphericalAngels"}]


(*Declarations for package MathVisionTools`GConvolution`*)

DeclarePackage["MathVisionTools`GConvolution`",{"GConjugateKernel","GListConvolve","GListCorrelate"}]


(*Declarations for package MathVisionTools`CompletionField`*)

DeclarePackage["MathVisionTools`CompletionField`",{"CompletionKernelAlongX","NCompletionKernelAlongX","NCompletionKernelxyMarginalAlongX","CompletionKernel","NCompletionKernel","NCompletionKernelxyMarginal","PolarCompletionKernel","NPolarCompletionKernel","NPolarCompletionKernelr\[Theta]Marginal","PolarCompletionKernelM","NPolarCompletionKernelM","NPolarCompletionKernelMr\[Theta]Marginal","CompletionField","CompletionMode","CompletionModeAlongX","CompletionSpline","TensorVotingKernel","TensorVotingKernelM","MedioniTensorVotingKernel"}]


(*Declarations for package MathVisionTools`LineKernel` *)

DeclarePackage["MathVisionTools`LineKernel`",{"LineKernel","FourierInfiniteLineKernel","FourierInfiniteLineDiffusionKernel","FourierInfiniteLineKernelPolar","FourierLineKernel","FourierLineKernelPolar","FourierCyclicLineKernel","FourierCyclicLineKernelPolar","FourierLineKernelApproximation","LineKernelApproximation","NLineKernelApproximation","NLineKernelApproximationList","NLineKernelApproximationMarginal","LineKernelDensityApproximation","NLineKernelDensityApproximation","NLineKernelDensityApproximationList","LineKernelMean","LineKernelMeanAngle","LineKernelMeanRadius","NLineKernelDensityApproximationMarginal"}]


(*Declarations for package MathVisionTools`ListFourierTransform` *)

DeclarePackage["MathVisionTools`ListFourierTransform`",{"ListFourierTransform","ListInverseFourierTransform","ArrayTimes","ListFourierPositions","ListFourierFrequencies"}]


(*Declarations for package MathVisionTools`BSpline` *)
If[
$VersionNumber<6,
DeclarePackage["MathVisionTools`BSplineV5`",{"BSplineDistribution"}],
DeclarePackage["MathVisionTools`BSpline`",{"BSplineDistribution"}]
]


(*Declarations for package MathVisionTools`DisplayFunctions`*)

DeclarePackage["MathVisionTools`DisplayFunctions`",{"ListLuminocityPlot", "RasterPlot", "PixelLabeling","ListEllipsePlot", "ListEllipsoidPlot3D"}]


(*Declarations for package MathVisionTools`DisplayFunctions`*)
If[
$VersionNumber >= 6.,
DeclarePackage["MathVisionTools`SelectFunctions`",{"SelectSubimageDialog", "SelectPathDialog","ExtractCrossSection"}]
]


(*Declarations for package MathVisionTools`EllipseFit`*)

DeclarePackage["MathVisionTools`EllipseFit`",{"ListEllipseFit","EllipseProperties","EllipseOrigin","EllipseRadii","EllipseOrientation","QuadraticCurve"}]


(*Declarations for package MathVisionTools`FrontEndVision` *)
(* If[
 $VersionNumber < 6,
 DeclarePackage["MathVisionTools`FrontEndVision`FEV`", {"arrow3D", "binarydilate", "binaryerode", "bundle", "colorToBW", "deform2D", "dilate", "displayNewNotebook", "erode", "gauge2D", "gauge2DN", "gauss", "gaussc", "gD", "gD1D", "gDc", "gDf", "gDf1D", "gDn", "gD\[Phi]", "gD\[Phi]N", "g\[ScriptCapitalG]", "g\[ScriptCapitalN]", "g\[ScriptCapitalW]", "heq", "invertbundle", "laplaceG", "liveForm", "liveAnimationForm", "liveFormWrite", "liveAnimationFormWrite", "rasterpixels", "RDSPlot", "shortnotation", "showarray", "sortrefs", "writeimage"}],
 DeclarePackage["MathVisionTools`FrontEndVision`FEV6`", {"arrow3D", "binarydilate", "binaryerode", "bundle", "colorToBW", "deform2D", "dilate", "displayNewNotebook", "erode", "gauge2D", "gauge2DN", "gauss", "gaussc", "gD", "gD1D", "gDc", "gDf", "gDf1D", "gDn", "gD\[Phi]", "gD\[Phi]N", "g\[ScriptCapitalG]", "g\[ScriptCapitalN]", "g\[ScriptCapitalW]", "heq", "invertbundle", "laplaceG", "liveForm", "liveAnimationForm", "liveFormWrite", "liveAnimationFormWrite", "rasterpixels", "RDSPlot", "shortnotation", "showarray", "sortrefs", "writeimage"}]
 ] *)


(*Declarations for package MathVisionTools`NAlgebra`*)

DeclarePackage["MathVisionTools`NAlgebra`",{"NQuadraticRootsReal","NCubicRootsReal","NQuarticRootsReal","NQuadraticRootsComplex","NCubicRootsComplex","NQuarticRootsComplex","NQuadraticUnitRootsComplex","NCubicUnitRootsComplex","NQuarticUnitRootsComplex"}]


(*Declarations for package MathVisionTools`MRITagging`*)

DeclarePackage["MathVisionTools`MRITagging`",{"SO2ReductionMatrix","CartesianToSO2Irreducible","SO2IrreducibleNorm","SO2UnitJet","SO2SpectrumToMaxAngle","SO2SpectrumToExtremaAngles","SO2SpectrumOfTaggingWave","ComplexTaggingWave","DirectionOfTaggingWave"}]


Off[Experimental`RegisterConverter::"obsalt"]


(*Loading package MathVisionTools`Converters`Dicom` to register Import*)

DeclarePackage["MathVisionTools`Converters`Dicom`",{"Dicom","DicomImport","DicomDictionary","DicomTags","DicomExport","$DicomTags"}]


(*Use built-in version of DICOM I/O*)

(*MathVisionTools`Converters`DicomImportDummy:=Symbol["DicomImport"][#1,"ImageIndex"/.(ConversionOptions/.Rest[{##}]/.ConversionOptions->{})/."ImageIndex"->All,Apply[Sequence,ConversionOptions/.Rest[{##}]/.ConversionOptions->{}]]&*)

(*Experimental`RegisterConverter[Import,"DICOM",{"*.dcm","*.DCM","*.dicom","*.DICOM","*.ani","*.ANI","*.spi","*.SPI"},None,MathVisionTools`Converters`DicomImportDummy,"TextFormat"->False]*)

(*Declarations for package MathVisionTools`Converters`DicomExport`*)
(*NOTE: DicomExport has been merged with Dicom! MvA 2007*)

(* DeclarePackage["MathVisionTools`Converters`DicomExport`",{"DicomExport","$DicomTags"}] *)


(*Loading package MathVisionTools`Converters`Raw3D` to register Import and Export*)

DeclarePackage["MathVisionTools`Converters`Raw3D`",{"Raw3DImport","Raw3DExport"}]

MathVisionTools`Converters`Raw3DImport:=Symbol["Raw3DImport"][#1,Apply[Sequence,ConversionOptions/.Rest[{##}]/.ConversionOptions->{}]]&

Experimental`RegisterConverter[Import,"Raw3D",{"*.dat","*.DAT"},None,MathVisionTools`Converters`Raw3DImport,"TextFormat"->False]

MathVisionTools`Converters`Raw3DExport:=Symbol["Raw3DExport"][#1,#2,Apply[Sequence,ConversionOptions/.Drop[{##},2]/.ConversionOptions->{}]]&

Experimental`RegisterConverter[Export,"Raw3D",{"*.dat","*.DAT"},None,MathVisionTools`Converters`Raw3DExport,"TextFormat"->False]


(*Loading package MathVisionTools`Converters`KretzVolume` to register Import*)

DeclarePackage["MathVisionTools`Converters`KretzVolume`",{"KretzVolumeImport","KretzVolume","KretzHeader"}]

MathVisionTools`Converters`KretzVolumeImportDummy:=Symbol["KretzVolumeImport"][#1,Apply[Sequence,ConversionOptions/.Rest[{##}]/.ConversionOptions->{}]]&

Experimental`RegisterConverter[Import,"KretzVolume",{"*.v@","*.V@"},None,MathVisionTools`Converters`KretzVolumeImportDummy,"TextFormat"->False]


(*Loading package MathVisionTools`Converters`FDF` to register Import*)

DeclarePackage["MathVisionTools`Converters`FDF`",{"FDFImport","FDFHeaderImport","FDF","FDFHeader","FDFSelection","FDFHeaderParsing"}]

MathVisionTools`Converters`FDFImportDummy:=Symbol["FDFImport"][#1,Apply[Sequence,ConversionOptions/.Rest[{##}]/.ConversionOptions->{}]]&

Experimental`RegisterConverter[Import,"FDF",{"*.fdf","*.FDF"},None,MathVisionTools`Converters`FDFImportDummy,"TextFormat"->False]


(*Declarations for package MathVisionTools`Converters`BioRad`*)

DeclarePackage["MathVisionTools`Converters`BioRad`",{"BioRadImport","BioRad"}]


(*Declarations for package MathVisionTools`Converters`BinaryArray`*)

DeclarePackage["MathVisionTools`Converters`BinaryArray`",{"BinaryArrayDimensions","BinaryArrayDataType","BinaryArrayImport","BinaryArrayExport"}]


(*End of Master package*)

Null


On[Experimental`RegisterConverter::"obsalt"]
