(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`LineKernel`"] = {2009,2,23,22,23,0};

Protect[TimeStamp];


(*:Name: MathVisionTools`LineKernel` *)

(*:Author: Markus van Almsick*)

(*:Email address: M.v.Almsick@tue.nl*)

(*:Context: MathVisionTools`LineKernel`*)

(*:Package Version: 2.1 *)

(*:Mathematica Version: 5.2 *)

(*:Copyright: Copyright 2009, Technische Universiteit Eindhoven*)

(*:Title: Stochastic Completion Field, Line and Contour Propagation *)

(*:Summary: This package implements routines for line and edge propagation *)

(*:Keywords: Stochastic Completion Field, Tensor Voting, Line and Contour Propagation *)

(*:Requirements: None *)

(*:Source: None *)

(*:History: Version 1.0 by Markus van Almsick, December 2005 *)
(*:History: Version 2.1 by Markus van Almsick, Febraury 2009 *)

(*:Limitations: *)

(*:Discussion: *)

(*:To do: *)


BeginPackage[
"MathVisionTools`LineKernel`"
]

Unprotect[
LineKernel,
LineKernelMean,
FourierLineKernel,
FourierInfiniteLineKernel,
FourierInfiniteLineDiffusionKernel,
FourierLineKernelPolar,
FourierInfiniteLineKernelPolar,
FourierCyclicLineKernel,
FourierCyclicLineKernelPolar,
FourierLineKernelApproximation,
LineKernelApproximation,
NLineKernelApproximation,
NLineKernelApproximationList,
NLineKernelApproximationMarginal,
LineKernelDensityApproximation,
NLineKernelDensityApproximation,
NLineKernelDensityApproximationList,
NLineKernelDensityApproximationMarginal,
FloquetSign,
FloquetExponent
]


LineKernel::usage = "LineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Alpha]] renders the \[Alpha]-marginal of the exact kernel of the stochastic line propagation with periodic boundaries for \[Alpha] at \[PlusMinus]\[Pi]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation. The LineKernel for x, y, and \[Alpha] has to be generated via the FourierLineKernel command and a subsequent inverse Fourier transformation."

LineKernelMean::usage="LineKernelMean[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Alpha]] renders the average {x,y} position with final direction \[Alpha] for the exact stochastic line propagation kernel with periodic boundaries for \[Alpha] at \[PlusMinus]\[Pi]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation."

LineKernelMeanAngle::usage="LineKernelMeanAngle[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Alpha]] renders the average polar angle with final direction \[Alpha] for the exact stochastic line propagation kernel with periodic boundaries for \[Alpha] at \[PlusMinus]\[Pi]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation."

LineKernelMeanRadius::usage="LineKernelMeanRadius[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Alpha]] renders the average polar radius with final direction \[Alpha] for the exact stochastic line propagation kernel with periodic boundaries for \[Alpha] at \[PlusMinus]\[Pi]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation."

FourierInfiniteLineKernel::usage = "FourierInfiniteLineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]x,\[Omega]y,\[Alpha]] renders a spatially Fourier-transformed, exact kernel of the stochastic line propagation with absorbing, non-periodic boundaries for \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation. \[Omega]x and \[Omega]y are the Cartesian variables of Fourier space and \[Alpha] is the line direction, that is not Fourier-transformed. FourierLineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]x,\[Omega]y,{min\[Alpha],max\[Alpha],d\[Alpha]}] renders a range of kernel values for \[Alpha]=min\[Alpha], min\[Alpha]+d\[Alpha],... max\[Alpha]. FourierLineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]x,\[Omega]y,{n\[Alpha]}] renders the range of n\[Alpha] kernel values for \[Alpha]=-\[Pi]+2\[Pi]/n\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \[Pi]."

FourierInfiniteLineDiffusionKernel::usage = "FourierInfiniteLineDiffusionKernel[\[Sigma],\[Sigma]\[Alpha],\[Lambda],\[Alpha]0][\[Omega]x,\[Omega]y,\[Alpha]] renders a spatially Fourier-transformed, exact kernel of the stochastic line diffusion with absorbing, non-periodic boundaries for \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the spatial diffusion constant in \[Alpha]-direction. \[Sigma]\[Alpha] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction of line propagation. \[Omega]x and \[Omega]y are the Cartesian variables of Fourier space and \[Alpha] is the line direction, that is not Fourier-transformed. FourierInfiniteLineDiffusionKernel[\[Sigma],\[Sigma]\[Alpha],\[Lambda],\[Alpha]0][\[Omega]x,\[Omega]y,{min\[Alpha],max\[Alpha],d\[Alpha]}] renders a range of kernel values for \[Alpha]=min\[Alpha], min\[Alpha]+d\[Alpha],... max\[Alpha]. FourierInfiniteLineDiffusionKernel[\[Sigma],\[Sigma]\[Alpha],\[Lambda],\[Alpha]0][\[Omega]x,\[Omega]y,{n\[Alpha]}] renders the range of n\[Alpha] kernel values for \[Alpha]=-\[Pi]+2\[Pi]/n\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \[Pi]."


FourierLineKernel::usage = "FourierLineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]x,\[Omega]y,\[Alpha]] renders a spatially Fourier-transformed, exact kernel of the stochastic line propagation with periodic boundaries for \[Alpha] at \[PlusMinus]\[Pi]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation. \[Omega]x and \[Omega]y are the Cartesian variables of Fourier space and \[Alpha] is the line direction, that is not Fourier-transformed. FourierLineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]x,\[Omega]y,{min\[Alpha],max\[Alpha],d\[Alpha]}] renders a range of kernel values for \[Alpha]=min\[Alpha], min\[Alpha]+d\[Alpha],... max\[Alpha]. FourierLineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]x,\[Omega]y,{n\[Alpha]}] renders the range of n\[Alpha] kernel values for \[Alpha]=-\[Pi]+2\[Pi]/n\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \[Pi]."

FourierInfiniteLineKernelPolar::usage = "FourierLineKernelPolar[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]r,\[Omega]\[CurlyPhi],\[Alpha]] renders a spatially Fourier-transformed, exact kernel of the stochastic line propagation with absorbing, non-periodic boundaries for \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation. \[Omega]r and \[Omega]\[CurlyPhi] are the polar variables of Fourier space and \[Alpha] is the line direction, that is not Fourier-transformed. FourierLineKernelPolar[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]r,\[Omega]\[CurlyPhi],{min\[Alpha],max\[Alpha],d\[Alpha]}] renders a range of kernel values for \[Alpha]=min\[Alpha], min\[Alpha]+d\[Alpha],... max\[Alpha]. FourierLineKernelPolar[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]r,\[Omega]\[CurlyPhi],{n\[Alpha]}] renders the range of n\[Alpha] kernel values for \[Alpha]=-\[Pi]+2\[Pi]/n\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \[Pi]."

FourierLineKernelPolar::usage = "FourierLineKernelPolar[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]r,\[Omega]\[CurlyPhi],\[Alpha]] renders a spatially Fourier-transformed, exact kernel of the stochastic line propagation with periodic boundaries for \[Alpha] at \[PlusMinus]\[Pi]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation. \[Omega]r and \[Omega]\[CurlyPhi] are the polar variables of Fourier space and \[Alpha] is the line direction, that is not Fourier-transformed. FourierLineKernelPolar[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]r,\[Omega]\[CurlyPhi],{min\[Alpha],max\[Alpha],d\[Alpha]}] renders a range of kernel values for \[Alpha]=min\[Alpha], min\[Alpha]+d\[Alpha],... max\[Alpha]. FourierLineKernelPolar[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]r,\[Omega]\[CurlyPhi],{n\[Alpha]}] renders the range of n\[Alpha] kernel values for \[Alpha]=-\[Pi]+2\[Pi]/n\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \[Pi]."

FourierCyclicLineKernel::usage = "FourierCyclicLineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],n][\[Omega]x,\[Omega]y,\[Alpha]] renders a spatially Fourier-transformed, exact kernel of the stochastic line propagation with periodic boundaries for \[Alpha] at \[PlusMinus]\[Pi]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation. n denotes the number of 2\[Pi] intervals to the left and the right of [-\[Pi],\[Pi]], from which nonperiodic kernel values are mapped into [-\[Pi],\[Pi]] to achieve periodicity. \[Omega]x and \[Omega]y are the Cartesian variables of Fourier space and \[Alpha] is the line direction, that is not Fourier-transformed. FourierCyclicLineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],n][\[Omega]x,\[Omega]y,{n\[Alpha]}] renders the range of n\[Alpha] kernel values for \[Alpha]=-\[Pi]+2\[Pi]/n\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \[Pi]."

FourierCyclicLineKernelPolar::usage = "FourierCyclicLineKernelPolar[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],n][\[Omega]r,\[Omega]\[CurlyPhi],\[Alpha]] renders a spatially Fourier-transformed, exact kernel of the stochastic line propagation with periodic boundaries for \[Alpha] at \[PlusMinus]\[Pi]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation. n denotes the number of 2\[Pi] intervals to the left and the right of [-\[Pi],\[Pi]], from which nonperiodic kernel values are mapped into [-\[Pi],\[Pi]] to achieve periodicity. \[Omega]r and \[Omega]\[CurlyPhi] are the polar variables of Fourier space and \[Alpha] is the line direction, that is not Fourier-transformed. FourierCyclicLineKernelPolar[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],n][\[Omega]r,\[Omega]\[CurlyPhi],{n\[Alpha]}] renders the range of n\[Alpha] kernel values for \[Alpha]=-\[Pi]+2\[Pi]/n\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \[Pi]."

FourierLineKernelApproximation::usage = "FourierLineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]x,\[Omega]y,\[Alpha]] renders a spatially Fourier-transformed,approximate kernel of the stochastic line propagation with absorbing, non-periodic boundaries for \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation. \[Omega]x and \[Omega]y are the Cartesian variables of Fourier space and \[Alpha] is the line direction, that is not Fourier-transformed. FourierLineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]x,\[Omega]y,{min\[Alpha],max\[Alpha],d\[Alpha]}] renders a range of kernel values for \[Alpha]=min\[Alpha], min\[Alpha]+d\[Alpha],... max\[Alpha]. FourierLineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]x,\[Omega]y,{n\[Alpha]}] renders the range of n\[Alpha] kernel values for \[Alpha]=-\[Pi]+2\[Pi]/n\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \[Pi]."

LineKernelApproximation::usage = "LineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,y,\[Alpha]] renders the approximate kernel of the stochastic line propagation with absorbing, non-periodic boundaries for \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation. x and y are the Cartesian spatial variables and \[Alpha] is the line direction. LineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,y,{min\[Alpha],max\[Alpha],d\[Alpha]}] renders a range of kernel values for \[Alpha]=min\[Alpha], min\[Alpha]+d\[Alpha],... max\[Alpha]. LineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,y,{n\[Alpha]}] renders the range of n\[Alpha] kernel values for \[Alpha]=-\[Pi]+2\[Pi]/n\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \[Pi]. LineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,y] returns the values of the xy-marginal."

NLineKernelApproximation::usage = "NLineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y,\[Alpha]] calculates numerically the approximate kernel of the stochastic line propagation with absorbing, non-periodic boundaries for \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation. x and y are the Cartesian spatial variables and \[Alpha] is the line direction."

NLineKernelApproximationList::usage = "NLineKernelApproximationList[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y,min\[Alpha],max\[Alpha],d\[Alpha]] calculates numerically a range of  approximate kernel values of the stochastic line propagation with absorbing, non-periodic boundaries for \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation. x and y are the Cartesian spatial variables and \[Alpha] is the line direction. NLineKernelApproximationList[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y,min\[Alpha],max\[Alpha],d\[Alpha]] renders the range of kernel values for \[Alpha]=min\[Alpha], min\[Alpha]+d\[Alpha],... max\[Alpha]."

NLineKernelApproximationMarginal::usage = "NLineKernelApproximationMarginal[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y] calculates numerically the marginal kernel values of the stochastic line propagation with absorbing, non-periodic boundaries for the line direction \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation. x and y are the Cartesian spatial variables."

LineKernelDensityApproximation::usage = "LineKernelDensityApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,dx,y,dy,\[Alpha],d\[Alpha]] renders the approximate kernel density of the stochastic line propagation with absorbing, non-periodic boundaries for \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation. x and y are the Cartesian spatial variables and \[Alpha] is the line direction. dx, dy, and d\[Alpha] are the sampling step sizes. LineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,dx,y,dy,{min\[Alpha],max\[Alpha],d\[Alpha]}] renders a range of kernel density values for \[Alpha]=min\[Alpha], min\[Alpha]+d\[Alpha],... max\[Alpha]. LineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,dx,y,dy,{n\[Alpha]}] renders the range of n\[Alpha] kernel density values for \[Alpha]=-\[Pi]+2\[Pi]/n\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \[Pi]. LineKernelDensityApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,dx,y,dy] returns the density values of the xy-marginal."

NLineKernelDensityApproximation::usage = "NLineKernelDensityApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,dx,y,dy,\[Alpha],d\[Alpha]] calculates numerically the approximate kernel density of the stochastic line propagation with absorbing, non-periodic boundaries for \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation. x and y are the Cartesian spatial variables and \[Alpha] is the line direction. dx, dy, and d\[Alpha] are the the sampling step sizes."

NLineKernelDensityApproximationList::usage = "NLineKernelDensityApproximationList[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,dx,y,dy,min\[Alpha],max\[Alpha],d\[Alpha]] calculates numerically a range of  approximate kernel values of the stochastic line propagation with absorbing, non-periodic boundaries for \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation. x and y are the Cartesian spatial variables and \[Alpha] is the line direction. dx, dy, and d\[Alpha] are the the sampling step sizes. NLineKernelDensityApproximationList[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,dx,y,dy,min\[Alpha],max\[Alpha],d\[Alpha]] renders the range of kernel values for \[Alpha]=min\[Alpha], min\[Alpha]+d\[Alpha],... max\[Alpha]."

NLineKernelDensityApproximationMarginal::usage = "NLineKernelDensityApproximationMarginal[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,dx,y,dy] calculates numerically the marginal kernel density values of the stochastic line propagation with absorbing, non-periodic boundaries for the line direction \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the angular diffusion constant randomizing the direction of line propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant curvature of line propagation. x and y are the Cartesian spatial variables. dx and dy are the the sampling step sizes."

FloquetSign::usage= "FloquetSign[a,q] provides the sign \[Chi] of the Floquet function FloquetF[a,q,z] = MathieuC[a,q,z]+ \[Chi] MathieuS[a,q,z]."

FloquetExponent::usage="FloquetExponent[a,q] provides the Floquet exponent."

Angle::usage="Angle[x,y] renders like ArcTan the angle between -\[Pi] and \[Pi] between the vector {x,y} and the x-axis. Angle[0,0] renders 0 without a warning."

Radius::usage="Radius[x,y] renders the length of vector {x,y}."


Begin["`Private`"]


(* Utility Functions *)


PreviousTick[min_,d_:1][val_]:= val+Mod[min-val,d,-d];


NextTick[min_,d_:1][val_]:= val-Mod[val-min,d]+d;


OnTick[min_,d_:1][val_]:= val-Mod[val-min,d,-d/2];


Angle=Compile[
{{x,_Real},{y,_Real}},
If[Chop[x]===0. \[And] Chop[y]===0.,0,ArcTan[x,y]],
{{ArcTan[_,_],_Real}}
];


Radius= Sqrt[#1^2+ #2^2]&;


FloquetCutoff=Compile[{{a,_Real},{b,_Real}},24/Sqrt[-a+(b+1)/2]];


FloquetSign=
Compile[
{{a,_Complex},{q,_Complex}},
I Tan[\[Pi] Sign[Im[#]] #/2]&[MathieuCharacteristicExponent[a,q]] MathieuC[a,q,\[Pi]/2]/MathieuS[a,q,\[Pi]/2]//Chop,
{{Tanh[_],_Complex},{MathieuCharacteristicExponent[_,_],_Complex},{MathieuC[_,_,_],_Complex},{MathieuS[_,_,_],_Complex}}
];


FloquetExponent = (Mod[Re[#],2]+I Im[#])&[Sign[Im[#]] #]&[MathieuCharacteristicExponent[#1,#2]]&


Unprotect[AiryAi];
AiryAi[z_] := (E^(-((2 z^(3/2))/3)) (385-480 z^(3/2)+4608 z^3))/(9216 Sqrt[\[Pi]] z^(13/4))/; Re[z]>5\[And]Re[z]>Abs[Im[z]]
Protect[AiryAi];


(* Fourier Line Kernel *)


(* Numeric Implementation *)

(* no speed gain *)


(* Symbolic Implementation *)

FourierLineKernel[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][\[Omega]x_,\[Omega]y_, \[Alpha]_]:=
Module[
{a = -4 (\[Kappa]^2+2 \[Lambda] \[Sigma]^2)/\[Sigma]^4,
b = -4 I Radius[\[Omega]x,\[Omega]y]/\[Sigma]^2, 
z\[Omega]=N[Angle[\[Omega]x,\[Omega]y]-\[Alpha]0]/2,\[Zeta]\[Omega],
z\[Alpha]=N[\[Alpha]-\[Alpha]0]/2,
z\[Delta]=(\[Alpha]-Angle[\[Omega]x,\[Omega]y])/2,\[Zeta]\[Delta],
\[Kappa]\[Sigma] =2\[Kappa]/\[Sigma]^2,\[Chi],i\[Nu],
mp\[Omega],mm\[Omega]},
\[Chi]   = FloquetSign[a,b];
i\[Nu] = -Abs[Im[MathieuCharacteristicExponent[a,b]]];
\[Zeta]\[Omega] = Mod[z\[Omega],\[Pi]];
\[Zeta]\[Delta] = Mod[z\[Delta],\[Pi]];
mp\[Omega] = MathieuC[a,b,\[Zeta]\[Omega]-\[Pi]]+\[Chi] MathieuS[a,b,\[Zeta]\[Omega]-\[Pi]];
mm\[Omega] = MathieuC[a,b,\[Zeta]\[Omega]]-\[Chi] MathieuS[a,b,\[Zeta]\[Omega]];
(\[Chi] E^(\[Kappa]\[Sigma] z\[Alpha]))/(\[Pi] \[Sigma]^2  MathieuSPrime[a,b,0] MathieuC[a,b,0])*Piecewise[{{(E^(2*i\[Nu]*Pi - #1)*mp\[Omega]*#2)/(1 - E^(Pi*(i\[Nu] + \[Kappa]\[Sigma]))) + 
    (E^(Pi*(i\[Nu] - \[Kappa]\[Sigma]) + #1)*mm\[Omega]*#3)/(1 - E^(Pi*(i\[Nu] - \[Kappa]\[Sigma]))), 
   Positive[z\[Alpha]]}, {(E^(Pi*(3*i\[Nu] + \[Kappa]\[Sigma]) - #1)*mp\[Omega]*#2)/
     (1 - E^(Pi*(i\[Nu] + \[Kappa]\[Sigma]))) + (E^#1*mm\[Omega]*#3)/
     (1 - E^(Pi*(i\[Nu] - \[Kappa]\[Sigma]))), Negative[z\[Alpha]]}}, 
 (E^(i\[Nu]*Pi)*(1 - E^(2*i\[Nu]*Pi))*mm\[Omega]*mp\[Omega])/((1 - E^(Pi*(i\[Nu] - \[Kappa]\[Sigma])))*
   (1 - E^(Pi*(i\[Nu] + \[Kappa]\[Sigma]))))]&[i\[Nu] (\[Zeta]\[Delta]-z\[Delta]+\[Zeta]\[Omega]-z\[Omega]),MathieuC[a,b,\[Zeta]\[Delta]-\[Pi]]+\[Chi] MathieuS[a,b,\[Zeta]\[Delta]-\[Pi]],MathieuC[a,b,\[Zeta]\[Delta]]-\[Chi] MathieuS[a,b,\[Zeta]\[Delta]]]
];


(* Symbolic Implementation *)

FourierLineKernel[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][\[Omega]x_,\[Omega]y_,{n\[Alpha]_Integer?Positive}]:=
Module[
{a  = -4 (\[Kappa]^2+2 \[Lambda] \[Sigma]^2)/\[Sigma]^4,
b  = -4 I Radius[\[Omega]x,\[Omega]y]/\[Sigma]^2, 
z\[Omega]=N[Angle[\[Omega]x,\[Omega]y]-\[Alpha]0]/2,\[Zeta]\[Omega],
\[Alpha]  = Range[-\[Pi]+2\[Pi]/n\[Alpha],\[Pi],2\[Pi]/n\[Alpha]],z\[Delta],\[Zeta]\[Delta],
\[Kappa]\[Sigma]=2\[Kappa]/\[Sigma]^2,\[Chi],i\[Nu],
mp\[Omega],mm\[Omega]},
\[Chi]   =FloquetSign[a,b];
i\[Nu] =-Abs[Im[MathieuCharacteristicExponent[a,b]]];
\[Zeta]\[Omega] = Mod[z\[Omega],\[Pi]];
z\[Delta] =(\[Alpha]-Angle[\[Omega]x,\[Omega]y])/2;
\[Zeta]\[Delta] = Mod[z\[Delta],\[Pi]];
mp\[Omega] = MathieuC[a,b,\[Zeta]\[Omega]-\[Pi]]+\[Chi] MathieuS[a,b,\[Zeta]\[Omega]-\[Pi]];
mm\[Omega] = MathieuC[a,b,\[Zeta]\[Omega]]-\[Chi] MathieuS[a,b,\[Zeta]\[Omega]];
\[Chi]/(\[Pi] \[Sigma]^2  MathieuSPrime[a,b,0] MathieuC[a,b,0])*
MapThread[Piecewise[
 {{E^(\[Kappa]\[Sigma]*#1)*((E^(2*i\[Nu]*Pi - #2)*mp\[Omega]*#3)/(1 - E^(Pi*(i\[Nu] + \[Kappa]\[Sigma]))) + 
     (E^(Pi*(i\[Nu] - \[Kappa]\[Sigma]) + #2)*mm\[Omega]*#4)/(1 - E^(Pi*(i\[Nu] - \[Kappa]\[Sigma])))), 
   Positive[#1]}, {E^(\[Kappa]\[Sigma]*#1)*((E^(Pi*(3*i\[Nu] + \[Kappa]\[Sigma]) - #2)*mp\[Omega]*#3)/
      (1 - E^(Pi*(i\[Nu] + \[Kappa]\[Sigma]))) + (E^#2*mm\[Omega]*#4)/
      (1 - E^(Pi*(i\[Nu] - \[Kappa]\[Sigma])))), Negative[#1]}}, 
 (E^(i\[Nu]*Pi)*(1 - E^(2*i\[Nu]*Pi))*mm\[Omega]*mp\[Omega])/((1 - E^(Pi*(i\[Nu] - \[Kappa]\[Sigma])))*
   (1 - E^(Pi*(i\[Nu] + \[Kappa]\[Sigma]))))]&,
{N[\[Alpha]-\[Alpha]0]/2,i\[Nu] (\[Zeta]\[Delta]-z\[Delta]+\[Zeta]\[Omega]-z\[Omega]),MathieuC[a,b,\[Zeta]\[Delta]-\[Pi]]+\[Chi] MathieuS[a,b,\[Zeta]\[Delta]-\[Pi]],MathieuC[a,b,\[Zeta]\[Delta]]-\[Chi] MathieuS[a,b,\[Zeta]\[Delta]]}]
];


(* Symbolic Implementation *)

FourierLineKernel[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][\[Omega]x_,\[Omega]y_,{min\[Alpha]_,max\[Alpha]_,d\[Alpha]_}]:=
Module[
{a  = -4 (\[Kappa]^2+2 \[Lambda] \[Sigma]^2)/\[Sigma]^4,
b  = -4 I Radius[\[Omega]x,\[Omega]y]/\[Sigma]^2, 
z\[Omega]=N[Angle[\[Omega]x,\[Omega]y]-\[Alpha]0]/2,\[Zeta]\[Omega],
\[Alpha]  = Range[min\[Alpha],max\[Alpha],d\[Alpha]],z\[Delta],\[Zeta]\[Delta],
\[Kappa]\[Sigma]=2\[Kappa]/\[Sigma]^2,\[Chi],i\[Nu],
mp\[Omega],mm\[Omega]},
\[Chi]   =FloquetSign[a,b];
i\[Nu] =-Abs[Im[MathieuCharacteristicExponent[a,b]]];
z\[Delta] =(\[Alpha]-Angle[\[Omega]x,\[Omega]y])/2;
\[Zeta]\[Omega] = Mod[z\[Omega],\[Pi]];
\[Zeta]\[Delta] = Mod[z\[Delta],\[Pi]];
mp\[Omega] = MathieuC[a,b,\[Zeta]\[Omega]-\[Pi]]+\[Chi] MathieuS[a,b,\[Zeta]\[Omega]-\[Pi]];
mm\[Omega] = MathieuC[a,b,\[Zeta]\[Omega]]-\[Chi] MathieuS[a,b,\[Zeta]\[Omega]];
\[Chi]/(\[Pi] \[Sigma]^2  MathieuSPrime[a,b,0] MathieuC[a,b,0])*
MapThread[ Piecewise[{{E^(\[Kappa]\[Sigma]*#1)*((E^(2*i\[Nu]*Pi-#2)*mp\[Omega]*#3)/(1-E^(Pi*(i\[Nu]+\[Kappa]\[Sigma])))+(E^(Pi*(i\[Nu]-\[Kappa]\[Sigma])+#2)*mm\[Omega]*#4)/(1-E^(Pi*(i\[Nu]-\[Kappa]\[Sigma])))),Positive[#1]},{E^(\[Kappa]\[Sigma]*#1)*((E^(Pi*(3*i\[Nu]+\[Kappa]\[Sigma])-#2)*mp\[Omega]*#3)/(1-E^(Pi*(i\[Nu]+\[Kappa]\[Sigma])))+(E^#2*mm\[Omega]*#4)/(1-E^(Pi*(i\[Nu]-\[Kappa]\[Sigma])))),Negative[#1]}},(E^(i\[Nu]*Pi)*(1-E^(2*i\[Nu]*Pi))*mm\[Omega]*mp\[Omega])/((1-E^(Pi*(i\[Nu]-\[Kappa]\[Sigma])))*(1-E^(Pi*(i\[Nu]+\[Kappa]\[Sigma]))))]&,
{N[\[Alpha]-\[Alpha]0]/2,i\[Nu] (\[Zeta]\[Delta]-z\[Delta]+\[Zeta]\[Omega]-z\[Omega]),MathieuC[a,b,\[Zeta]\[Delta]-\[Pi]]+\[Chi] MathieuS[a,b,\[Zeta]\[Delta]-\[Pi]],MathieuC[a,b,\[Zeta]\[Delta]]-\[Chi] MathieuS[a,b,\[Zeta]\[Delta]]}]
];


(* Fourier Line Kernel Polar *)


(* Numeric Implementation *)

(* no speed gain *)


(* Symbolic Implementation *)

FourierLineKernelPolar[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][\[Omega]r_,\[Omega]\[CurlyPhi]_, \[Alpha]_]:=
Module[
{a = -4 (\[Kappa]^2+2 \[Lambda] \[Sigma]^2)/\[Sigma]^4,
b = -4 I \[Omega]r/\[Sigma]^2, 
c = (Mod[\[Alpha]0,2\[Pi],-\[Pi]]-Mod[\[Omega]\[CurlyPhi],2\[Pi],-\[Pi]])/2,
d = (Mod[\[Alpha],2\[Pi],-\[Pi]]-Mod[\[Alpha]0,2\[Pi],-\[Pi]])/2,
mc0,ms0,wdet,\[Chi]},
mc0 = MathieuC[a,b,c];
ms0 = MathieuS[a,b,c];
wdet = 1/(\[Pi] \[Sigma]^2  MathieuSPrime[a,b,0] MathieuC[a,b,0]);
\[Chi]   = -I Sign[Im[(mc0^2+ms0^2)wdet]];
\[Chi]  wdet *Piecewise[{{0, Abs[c + d] > FloquetCutoff[a, Im[b]]}, 
  {E^(d*#4)*((E^(Pi*(#3 - #4))*(mc0 + ms0*\[Chi])*(#1 - \[Chi]*#2))/
      (1 - E^(Pi*(#3 - #4))) + ((mc0 - ms0*\[Chi])*(#1 + \[Chi]*#2))/
      (1 - E^(Pi*(#3 + #4)))), Positive[d]}, 
  {E^(d*#4)*(((mc0 + ms0*\[Chi])*(#1 - \[Chi]*#2))/(1 - E^(Pi*(#3 - #4))) + 
     (E^(Pi*(#3 + #4))*(mc0 - ms0*\[Chi])*(#1 + \[Chi]*#2))/(1 - E^(Pi*(#3 + #4)))), 
   Negative[d]}}, ((1 - E^(2*Pi*#3))*(mc0^2 + ms0^2))/
  ((1 - E^(Pi*(#3 - #4)))*(1 - E^(Pi*(#3 + #4))))]&[MathieuC[a,b,c+d],MathieuS[a,b,c+d],I FloquetExponent[a,b],2\[Kappa]/\[Sigma]^2]//Chop
];


FourierLineKernelPolar[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][\[Omega]r_,\[Omega]\[CurlyPhi]_, {n\[Alpha]_Integer?Positive}]:=
Module[
{a = -4 (\[Kappa]^2+2 \[Lambda] \[Sigma]^2)/\[Sigma]^4,
b = -4 I \[Omega]r/\[Sigma]^2, 
c = (Mod[\[Alpha]0,2\[Pi],-\[Pi]]-Mod[\[Omega]\[CurlyPhi],2\[Pi],-\[Pi]])/2, 
dmin = (2\[Pi]/n\[Alpha]-Mod[\[Alpha]0,2\[Pi],-\[Pi]]-\[Pi])/2,
dmax = (\[Pi]-Mod[\[Alpha]0,2\[Pi],-\[Pi]])/2,
dd = \[Pi]/n\[Alpha],
cc,wdet,mc0,ms0,\[Chi],i\[Nu],\[Kappa]\[Sigma],f},
cc   = FloquetCutoff[a,Im[b]];
mc0 = MathieuC[a,b,c];
ms0 = MathieuS[a,b,c];
wdet= 1/(\[Pi] \[Sigma]^2  MathieuSPrime[a,b,0] MathieuC[a,b,0]);
\[Chi]   = -I Sign[Im[(mc0^2+ms0^2)wdet]];
i\[Nu] = I FloquetExponent[a,b];
\[Kappa]\[Sigma] = 2\[Kappa]/\[Sigma]^2;
f   = Compile[{{mc,_Complex},{ms,_Complex},{d,_Real}},Evaluate[Chop[\[Chi] wdet*Piecewise[{{0, Abs[c + d] > cc}, 
  {E^(d*\[Kappa]\[Sigma])*(((mc + ms*\[Chi])*(mc0 - ms0*\[Chi]))/(1 - E^(Pi*(i\[Nu] + \[Kappa]\[Sigma]))) + 
     (E^(Pi*(i\[Nu] - \[Kappa]\[Sigma]))*(mc - ms*\[Chi])*(mc0 + ms0*\[Chi]))/
      (1 - E^(Pi*(i\[Nu] - \[Kappa]\[Sigma])))), Positive[d]}, 
  {E^(d*\[Kappa]\[Sigma])*((E^(Pi*(i\[Nu] + \[Kappa]\[Sigma]))*(mc + ms*\[Chi])*(mc0 - ms0*\[Chi]))/
      (1 - E^(Pi*(i\[Nu] + \[Kappa]\[Sigma]))) + ((mc - ms*\[Chi])*(mc0 + ms0*\[Chi]))/
      (1 - E^(Pi*(i\[Nu] - \[Kappa]\[Sigma])))), Negative[d]}}, 
 ((1 - E^(2*i\[Nu]*Pi))*(mc0^2 + ms0^2))/((1 - E^(Pi*(i\[Nu] - \[Kappa]\[Sigma])))*
   (1 - E^(Pi*(i\[Nu] + \[Kappa]\[Sigma]))))]]]];
Table[
f[MathieuC[a,b,c+d],MathieuS[a,b,c+d],d],
{d,dmin,dmax,dd}
]
];


FourierLineKernelPolar[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][\[Omega]r_,\[Omega]\[CurlyPhi]_, {min\[Alpha]_,max\[Alpha]_,d\[Alpha]_}]:=
Module[
{a = -4 (\[Kappa]^2+2 \[Lambda] \[Sigma]^2)/\[Sigma]^4,
b = -4 I \[Omega]r/\[Sigma]^2, 
c = (\[Alpha]0-\[Omega]\[CurlyPhi])/2, 
dmin = (min\[Alpha]-\[Alpha]0)/2,dmax = (max\[Alpha]-\[Alpha]0)/2,dd = d\[Alpha]/2,
cc,wdet,mc0,ms0,\[Chi],i\[Nu],\[Kappa]\[Sigma],f},
cc   = FloquetCutoff[a,Im[b]];
mc0 = MathieuC[a,b,c];
ms0 = MathieuS[a,b,c];
wdet= 1/(\[Pi] \[Sigma]^2  MathieuSPrime[a,b,0] MathieuC[a,b,0]);
\[Chi]   = -I Sign[Im[(mc0^2+ms0^2)wdet]];
i\[Nu] = I FloquetExponent[a,b];
\[Kappa]\[Sigma] = 2\[Kappa]/\[Sigma]^2;
f   = Compile[{{mc,_Complex},{ms,_Complex},{d,_Real}},Evaluate[Chop[\[Chi] wdet*Piecewise[{{0, Abs[c + d] > cc}, 
  {E^(d*\[Kappa]\[Sigma])*(((mc + ms*\[Chi])*(mc0 - ms0*\[Chi]))/(1 - E^(Pi*(i\[Nu] + \[Kappa]\[Sigma]))) + 
     (E^(Pi*(i\[Nu] - \[Kappa]\[Sigma]))*(mc - ms*\[Chi])*(mc0 + ms0*\[Chi]))/
      (1 - E^(Pi*(i\[Nu] - \[Kappa]\[Sigma])))), Positive[d]}, 
  {E^(d*\[Kappa]\[Sigma])*((E^(Pi*(i\[Nu] + \[Kappa]\[Sigma]))*(mc + ms*\[Chi])*(mc0 - ms0*\[Chi]))/
      (1 - E^(Pi*(i\[Nu] + \[Kappa]\[Sigma]))) + ((mc - ms*\[Chi])*(mc0 + ms0*\[Chi]))/
      (1 - E^(Pi*(i\[Nu] - \[Kappa]\[Sigma])))), Negative[d]}}, 
 ((1 - E^(2*i\[Nu]*Pi))*(mc0^2 + ms0^2))/((1 - E^(Pi*(i\[Nu] - \[Kappa]\[Sigma])))*
   (1 - E^(Pi*(i\[Nu] + \[Kappa]\[Sigma]))))]]]];
Table[
f[MathieuC[a,b,c+d],MathieuS[a,b,c+d],d],
{d,dmin,dmax,dd}
]
];


(* Fourier Infinite Line Kernel *)


(* Numeric Implementation *)

(* no speed gain *)


(* Symbolic Implementation *)

FourierInfiniteLineKernel[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][\[Omega]x_,\[Omega]y_, {n\[Alpha]_Integer?Positive}]:=FourierInfiniteLineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]x,\[Omega]y,{-\[Pi]+(2\[Pi])/n\[Alpha], \[Pi],(2\[Pi])/n\[Alpha]}]


FourierInfiniteLineKernel[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][\[Omega]x_,\[Omega]y_, {min\[Alpha]_,max\[Alpha]_,d\[Alpha]_}]:=
Module[
{a = -4 (\[Kappa]^2+2 \[Lambda] \[Sigma]^2)/\[Sigma]^4,
b = 4 I Radius[\[Omega]x,\[Omega]y]/\[Sigma]^2, 
c = (\[Alpha]0-Angle[\[Omega]x,\[Omega]y])/2, 
dmin = (min\[Alpha]-\[Alpha]0)/2,dmax = (max\[Alpha]-\[Alpha]0)/2,dd = d\[Alpha]/2,
cc,wdet,mc,ms,s},
cc = FloquetCutoff[a,Im[b]];
mc = MathieuC[a,b,c];
ms = MathieuS[a,b,c];
wdet = 1/(\[Pi] \[Sigma]^2  MathieuSPrime[a,b,0] MathieuC[a,b,0]);
\[Chi] = Sign[Im[(mc^2+ms^2)wdet]];
-\[Chi] wdet* Table[
\[Piecewise]{
 {0, Abs[c+d]>cc},
 {E^((2 d \[Kappa])/\[Sigma]^2) (I mc+\[Chi] ms) (MathieuC[a,b,c+d]+I \[Chi] MathieuS[a,b,c+d]), Negative[d]},
 {E^((2 d \[Kappa])/\[Sigma]^2) (mc+I \[Chi] ms) (I MathieuC[a,b,c+d]+\[Chi] MathieuS[a,b,c+d]), Positive[d]},
 {I (mc^2+ms^2), True}
},
{d,dmin,dmax,dd}
]
];


FourierInfiniteLineKernel[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][\[Omega]x_,\[Omega]y_, \[Alpha]_]:=
Module[
{a = -4 (\[Kappa]^2+2 \[Lambda] \[Sigma]^2)/\[Sigma]^4,
b = 4 I Radius[\[Omega]x,\[Omega]y]/\[Sigma]^2, 
c = (\[Alpha]0-Angle[\[Omega]x,\[Omega]y])/2,
d = (\[Alpha]-\[Alpha]0)/2,
cc,mc,ms,wdet,s},
cc = FloquetCutoff[a,Im[b]];
mc = MathieuC[a,b,c];
ms = MathieuS[a,b,c];
wdet = 1/(\[Pi] \[Sigma]^2  MathieuSPrime[a,b,0] MathieuC[a,b,0]);
\[Chi] = Sign[Im[(mc^2+ms^2)wdet]];
-\[Chi] wdet*\[Piecewise]{
 {0, Abs[c+d]>cc},
 {E^((2 d \[Kappa])/\[Sigma]^2) (I mc+\[Chi] ms) (MathieuC[a,b,c+d]+I \[Chi] MathieuS[a,b,c+d]), Negative[d]},
 {E^((2 d \[Kappa])/\[Sigma]^2) (mc+I \[Chi] ms) (I MathieuC[a,b,c+d]+\[Chi] MathieuS[a,b,c+d]), Positive[d]},
 {I (mc^2+ms^2), True}
}
];


(* Fourier Infinite Line Diffusion Kernel *)


(* Numeric Implementation *)

(* no speed gain *)


(* Symbolic Implementation *)

FourierInfiniteLineDiffusionKernel[\[Sigma]_,\[Sigma]\[Alpha]_,\[Lambda]_,\[Alpha]0_:0][\[Omega]x_,\[Omega]y_, {n\[Alpha]_Integer?Positive}]:=
FourierInfiniteLineDiffusionKernel[\[Sigma],\[Sigma]\[Alpha],\[Lambda],\[Alpha]0][\[Omega]x,\[Omega]y,{-\[Pi]+(2\[Pi])/n\[Alpha], \[Pi],(2\[Pi])/n\[Alpha]}]


FourierInfiniteLineDiffusionKernel[\[Sigma]_,\[Sigma]\[Alpha]_,\[Lambda]_,\[Alpha]0_:0][\[Omega]x_,\[Omega]y_, {min\[Alpha]_,max\[Alpha]_,d\[Alpha]_}]:=
Module[
{a = -((4 \[Lambda]+\[Sigma]^2 (\[Omega]x^2+\[Omega]y^2))/(2 \[Sigma]\[Alpha]^2)),
b = (\[Sigma]^2 (\[Omega]x^2+\[Omega]y^2))/(4 \[Sigma]\[Alpha]^2), 
c = \[Alpha]-Angle[\[Omega]x,\[Omega]y], 
dmin = (min\[Alpha]-\[Alpha]0),
dmax = (max\[Alpha]-\[Alpha]0),
dd = d\[Alpha],
cc,wdet,mc,ms,s},
mc = MathieuC[a,b,c];
ms = MathieuS[a,b,c];
wdet = 1/(2 \[Pi] \[Sigma]\[Alpha]^2  MathieuSPrime[a,b,0] MathieuC[a,b,0]);
\[Chi] = Sign[Im[(mc^2+ms^2)wdet]];
-\[Chi] wdet* Table[
\[Piecewise]{
 {(I mc+\[Chi] ms) (MathieuC[a,b,c+d]+I \[Chi] MathieuS[a,b,c+d]), Negative[d]},
 {(mc+I \[Chi] ms) (I MathieuC[a,b,c+d]+\[Chi] MathieuS[a,b,c+d]), Positive[d]},
 {I (mc^2+ms^2), True}
},
{d,dmin,dmax,dd}
]
];


FourierInfiniteLineDiffusionKernel[\[Sigma]_,\[Sigma]\[Alpha]_,\[Lambda]_,\[Alpha]0_:0][\[Omega]x_,\[Omega]y_, \[Alpha]_]:=
Module[
{a = -((2 \[Lambda])/\[Sigma]^2)+(\[Sigma]^2 (\[Omega]x^2+\[Omega]y^2))/(2 \[Sigma]\[Alpha]^2),
b = -((\[Sigma]^2 (\[Omega]x^2+\[Omega]y^2))/(4 \[Sigma]\[Alpha]^2)), 
c = \[Alpha]-Angle[\[Omega]x,\[Omega]y], 
d = (\[Alpha]-\[Alpha]0),
cc,mc,ms,wdet,s},
mc = MathieuC[a,b,c];
ms = MathieuS[a,b,c];
wdet = 1/(2 \[Pi] \[Sigma]\[Alpha]^2  MathieuSPrime[a,b,0] MathieuC[a,b,0]);
\[Chi] = Sign[Im[(mc^2+ms^2)wdet]];
-\[Chi] wdet*\[Piecewise]{
 {(I mc+\[Chi] ms) (MathieuC[a,b,c+d]+I \[Chi] MathieuS[a,b,c+d]), Negative[d]},
 {(mc+I \[Chi] ms) (I MathieuC[a,b,c+d]+\[Chi] MathieuS[a,b,c+d]), Positive[d]},
 {(mc^2+ms^2), True}
}
];


(* Fourier Infinite Line Kernel Polar *)


(* Numeric Implementation *)

(* no speed gain *)


(* Symbolic Implementation *)

FourierInfiniteLineKernelPolar[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][\[Omega]r_,\[Omega]\[CurlyPhi]_, {n\[Alpha]_Integer?Positive}]:=FourierInfiniteLineKernelPolar[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]r,\[Omega]\[CurlyPhi],{-\[Pi]+(2\[Pi])/n\[Alpha], \[Pi],(2\[Pi])/n\[Alpha]}]


FourierInfiniteLineKernelPolar[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][\[Omega]r_,\[Omega]\[CurlyPhi]_, {min\[Alpha]_,max\[Alpha]_,d\[Alpha]_}]:=
Module[
{a = -4 (\[Kappa]^2+2 \[Lambda] \[Sigma]^2)/\[Sigma]^4,
b = 4 I \[Omega]r/\[Sigma]^2, 
c = (\[Alpha]0-\[Omega]\[CurlyPhi])/2, 
dmin = (min\[Alpha]-\[Alpha]0)/2,dmax = (max\[Alpha]-\[Alpha]0)/2,dd = d\[Alpha]/2,
cc,wdet,mc,ms,s},
cc = FloquetCutoff[a,Im[b]];
mc = MathieuC[a,b,c];
ms = MathieuS[a,b,c];
wdet = 1/(\[Pi] \[Sigma]^2  MathieuSPrime[a,b,0] MathieuC[a,b,0]);
\[Chi] = Sign[Im[(mc^2+ms^2)wdet]];
-\[Chi] wdet* Table[
\[Piecewise]{
 {0, Abs[c+d]>cc},
 {E^((2 d \[Kappa])/\[Sigma]^2) (I mc+\[Chi] ms) (MathieuC[a,b,c+d]+I \[Chi] MathieuS[a,b,c+d]), Negative[d]},
 {E^((2 d \[Kappa])/\[Sigma]^2) (mc+I \[Chi] ms) (I MathieuC[a,b,c+d]+\[Chi] MathieuS[a,b,c+d]), Positive[d]},
 {I (mc^2+ms^2), True}
},
{d,dmin,dmax,dd}
]
];


FourierInfiniteLineKernelPolar[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][\[Omega]r_,\[Omega]\[CurlyPhi]_, \[Alpha]_]:=
Module[
{a = -4 (\[Kappa]^2+2 \[Lambda] \[Sigma]^2)/\[Sigma]^4,
b = 4 I \[Omega]r/\[Sigma]^2, 
c = (\[Alpha]0-\[Omega]\[CurlyPhi])/2,
d = (\[Alpha]-\[Alpha]0)/2,
cc,wdet,mc,ms,s},
cc = FloquetCutoff[a,Im[b]];
mc = MathieuC[a,b,c];
ms = MathieuS[a,b,c];
wdet = 1/(\[Pi] \[Sigma]^2  MathieuSPrime[a,b,0] MathieuC[a,b,0]);
\[Chi] = Sign[Im[(mc^2+ms^2)wdet]];
-\[Chi] wdet*\[Piecewise]{
 {0, Abs[c+d]>cc},
 {E^((2 d \[Kappa])/\[Sigma]^2) (I mc+\[Chi] ms) (MathieuC[a,b,c+d]+I \[Chi] MathieuS[a,b,c+d]), Negative[d]},
 {E^((2 d \[Kappa])/\[Sigma]^2) (mc+I \[Chi] ms) (I MathieuC[a,b,c+d]+\[Chi] MathieuS[a,b,c+d]), Positive[d]},
 {I (mc^2+ms^2), True}
}
];


(* Fourier Cyclic Line Kernel *)


(* Numeric Implementation *)

(* no speed gain *)


(* Symbolic Implementation *)

FourierCyclicLineKernel[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0,n_Integer:1][\[Omega]x_,\[Omega]y_, {n\[Alpha]_Integer?Positive}]:=
Module[
{a = -4 (\[Kappa]^2+2 \[Lambda] \[Sigma]^2)/\[Sigma]^4,
b = 4 I Radius[\[Omega]x,\[Omega]y]/\[Sigma]^2, 
c = (\[Alpha]0-Mod[Angle[\[Omega]x,\[Omega]y],\[Pi],-\[Pi]/2])/2, 
dmin = -\[Pi](n+1/2)-\[Alpha]0/2,dmax = \[Pi] (n+1/2-1/n\[Alpha])-\[Alpha]0/2,dd = \[Pi]/n\[Alpha],
cc,wdet,mc,ms,s,dbot,dtop},
cc = FloquetCutoff[a,Im[b]];
mc = MathieuC[a,b,c];
ms = MathieuS[a,b,c];
wdet = 1/(\[Pi] \[Sigma]^2  MathieuSPrime[a,b,0] MathieuC[a,b,0]);
\[Chi]= Sign[Im[(mc^2+ms^2)wdet]];
dbot = Round[OnTick[dmin,dd][-cc-c]/dd] dd;
dtop = Round[OnTick[dmin,dd][cc-c]/dd] dd;
-\[Chi] wdet*
Total[
Partition[
Join[
Table[0,{d,dmin,dbot-dd,dd}],
(I mc+\[Chi] ms) Table[E^((2d \[Kappa])/\[Sigma]^2) (MathieuC[a,b,c+d]+I \[Chi] MathieuS[a,b,c+d]),{d,Max[dmin,dbot],PreviousTick[dmin,dd][0],dd}],
If[EvenQ[n\[Alpha]],{I (mc^2+ms^2)},{}],
(mc+I \[Chi] ms) Table[ E^((2d \[Kappa])/\[Sigma]^2) (I MathieuC[a,b,c+d]+\[Chi] MathieuS[a,b,c+d]),{d,NextTick[dmin,dd][0],Min[dmax,dtop],dd}],
Table[0,{d,dtop+dd,dmax,dd}]
],
n\[Alpha]
]
]
];


FourierCyclicLineKernel::notimpl = "This function call is not implemented, since the \[Alpha]-sequence should always match the cyclic boundary. Just specify the number of \[Alpha]-values between -\[Pi] and \[Pi] instead.";

FourierCyclicLineKernel[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0,n_Integer:1][\[Omega]x_,\[Omega]y_, {min\[Alpha]_,max\[Alpha]_,d\[Alpha]_}]:=
Message[FourierCyclicLineKernel::notimpl];


(* Note order of implementation. Do not move this function up. *)

FourierCyclicLineKernel[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0,n_Integer:1][\[Omega]x_,\[Omega]y_, \[Alpha]_]:=
Module[
{a = -4 (\[Kappa]^2+2 \[Lambda] \[Sigma]^2)/\[Sigma]^4,
b = 4 I Radius[\[Omega]x,\[Omega]y]/\[Sigma]^2, 
c = (\[Alpha]0-Mod[Angle[\[Omega]x,\[Omega]y],\[Pi],-\[Pi]/2])/2,
dmod = Mod[(\[Alpha]-\[Alpha]0)/2,\[Pi],-\[Pi]/2],
cc,wdet,mc0,ms0,s},
cc = FloquetCutoff[a,Im[b]];
mc = MathieuC[a,b,c];
ms = MathieuS[a,b,c];
wdet = 1/(\[Pi] \[Sigma]^2  MathieuSPrime[a,b,0] MathieuC[a,b,0]);
\[Chi] = Sign[Im[(mc^2+ms^2)wdet]];
-\[Chi] wdet* Sum[
\[Piecewise]{
 {0, Abs[c+d]>cc},
 {E^((2 d \[Kappa])/\[Sigma]^2) (I mc+\[Chi] ms) (MathieuC[a,b,c+d]+I \[Chi] MathieuS[a,b,c+d]), Negative[d]},
 {E^((2 d \[Kappa])/\[Sigma]^2) (mc+I \[Chi] ms) (I MathieuC[a,b,c+d]+\[Chi] MathieuS[a,b,c+d]), Positive[d]},
 {I (mc^2+ms^2), True}
},
{d,dmod-n \[Pi],dmod+n \[Pi],\[Pi]}
]
];


(* Fourier Cyclic Line Kernel Polar *)


(* Numeric Implementation *)

(* no speed gain *)


(* Symbolic Implementation *)

FourierCyclicLineKernelPolar[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0,n_Integer:1][\[Omega]r_,\[Omega]\[CurlyPhi]_, {n\[Alpha]_Integer?Positive}]:=
Module[
{a = -4 (\[Kappa]^2+2 \[Lambda] \[Sigma]^2)/\[Sigma]^4,
b = 4 I \[Omega]r/\[Sigma]^2, 
c = (Mod[\[Alpha]0,2\[Pi],-\[Pi]]-\[Omega]\[CurlyPhi])/2, 
dmin = -\[Pi](n+1/2)-Mod[\[Alpha]0,2\[Pi],-\[Pi]]/2,dmax = \[Pi] (n+1/2-1/n\[Alpha])-Mod[\[Alpha]0,2\[Pi],-\[Pi]]/2,dd = \[Pi]/n\[Alpha],
cc,wdet,mc,ms,s,dbot,dtop},
cc = FloquetCutoff[a,Im[b]];
mc = MathieuC[a,b,c];
mmma= MathieuS[a,b,c];
wdet = 1/(\[Pi] \[Sigma]^2  MathieuSPrime[a,b,0] MathieuC[a,b,0]);
\[Chi] = Sign[Im[(mc^2+ms^2)wdet]];
dbot = Round[OnTick[dmin,dd][-cc-c]/dd] dd;
dtop = Round[OnTick[dmin,dd][cc-c]/dd] dd;
-\[Chi] wdet*
Total[
Partition[
Join[
Table[0,{d,dmin,dbot-dd,dd}],
(I mc+\[Chi] ms) Table[E^((2d \[Kappa])/\[Sigma]^2) (MathieuC[a,b,c+d]+I \[Chi] MathieuS[a,b,c+d]),{d,Max[dmin,dbot],PreviousTick[dmin,dd][0],dd}],
If[EvenQ[n\[Alpha]],{I (mc^2+ms^2)},{}],
(mc+I \[Chi] ms) Table[ E^((2d \[Kappa])/\[Sigma]^2) (I MathieuC[a,b,c+d]+\[Chi] MathieuS[a,b,c+d]),{d,NextTick[dmin,dd][0],Min[dmax,dtop],dd}],
Table[0,{d,dtop+dd,dmax,dd}]
],
n\[Alpha]
]
]
];


FourierCyclicLineKernelPolar::notimpl = "This function call is not implemented, since the \[Alpha]-sequence should always match the cyclic boundary. Just specify the number of \[Alpha]-values between -\[Pi] and \[Pi] instead.";

FourierCyclicLineKernelPolar[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0,n_Integer:1][\[Omega]r_,\[Omega]\[CurlyPhi]_, {min\[Alpha]_,max\[Alpha]_,d\[Alpha]_}]:=
Message[FourierCyclicLineKernelPolar::notimpl];


(* Note order of implementation. Do not move this function up. *)

FourierCyclicLineKernelPolar[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0,n_Integer:1][\[Omega]r_,\[Omega]\[CurlyPhi]_, \[Alpha]_]:=
Module[
{a = -4 (\[Kappa]^2+2 \[Lambda] \[Sigma]^2)/\[Sigma]^4,
b = 4 I \[Omega]r/\[Sigma]^2, 
c = (Mod[\[Alpha]0,2\[Pi],-\[Pi]]-\[Omega]\[CurlyPhi])/2,
dmod = Mod[\[Alpha]-\[Alpha]0,2\[Pi],-\[Pi]]/2,
cc,wdet,mc,ms,s},
cc = FloquetCutoff[a,Im[b]];
mc = MathieuC[a,b,c+d0];
ms = MathieuS[a,b,c+d0];
wdet = 1/(\[Pi] \[Sigma]^2  MathieuSPrime[a,b,0] MathieuC[a,b,0]);
\[Chi] = Sign[Im[(mc^2+ms^2)wdet]];
-\[Chi] wdet* Sum[
\[Piecewise]{
 {0, Abs[c+d]>cc},
 {E^((2 d \[Kappa])/\[Sigma]^2) (I mc+\[Chi] ms) (MathieuC[a,b,c+d]+I \[Chi] MathieuS[a,b,c+d]), Negative[d]},
 {E^((2 d \[Kappa])/\[Sigma]^2) (mc+I \[Chi] ms) (I MathieuC[a,b,c+d]+\[Chi] MathieuS[a,b,c+d]), Positive[d]},
 {I (mc^2+ms^2), True}
},
{d,dmod-n \[Pi],dmod+n \[Pi],\[Pi]}
]
];


(* Fourier Line Kernel Approximation *)


(* Numeric Implementation *)

(* no speed gain *)


(* Symbolic Implementation *)

FourierLineKernelApproximation[\[Sigma]_,\[Lambda]_][\[Omega]x_,0|0.,{min\[Alpha]_,max\[Alpha]_,d\[Alpha]_}]:=
1/(2\[Pi] Sqrt[2\[Sigma]^2 (\[Lambda]-I \[Omega]x)]) Table[Exp[-Sqrt[2(\[Lambda]-I \[Omega]x)] Abs[\[Alpha]]/\[Sigma]],{\[Alpha],min\[Alpha],max\[Alpha],d\[Alpha]}]


FourierLineKernelApproximation[\[Sigma]_,\[Lambda]_,0|0.,\[Kappa]_:0][\[Omega]x_,0|0.,{min\[Alpha]_,max\[Alpha]_,d\[Alpha]_}]:=
1/(2\[Pi] Sqrt[\[Kappa]^2+2 \[Sigma]^2 (\[Lambda]-I \[Omega]x)]) Table[Exp[(\[Kappa] \[Alpha]-Sqrt[\[Kappa]^2+2 \[Sigma]^2 (\[Lambda]-I \[Omega]x)]Abs[\[Alpha]])/\[Sigma]^2],{\[Alpha],min\[Alpha],max\[Alpha],d\[Alpha]}]


FourierLineKernelApproximation[\[Sigma]_,\[Lambda]_][\[Omega]x_,\[Omega]y_,{min\[Alpha]_,max\[Alpha]_,d\[Alpha]_}]:=
Module[
{a =-((2I )/ (\[Sigma]^2))\[Omega]y, c =2/\[Sigma]^2 (\[Lambda]-I \[Omega]x)},
2/(\[Sigma]^2 Abs[a]^(1/3))*
Join[
AiryAi[c/a^(2/3)] Table[AiryAi[(c+a \[Alpha])/Conjugate[a^(2/3)]],{\[Alpha],min\[Alpha],PreviousTick[min\[Alpha],d\[Alpha]][0],d\[Alpha]}],
If[Mod[min\[Alpha],d\[Alpha]]==0 \[And] min\[Alpha] <= 0 <= max\[Alpha],{AiryAi[c/a^(2/3)] AiryAi[c/Conjugate[a^(2/3)]]},{}],
AiryAi[c/Conjugate[a^(2/3)]]  Table[AiryAi[(c+a \[Alpha])/a^(2/3)] ,{\[Alpha],NextTick[min\[Alpha],d\[Alpha]][0],max\[Alpha],d\[Alpha]}]
]
]


FourierLineKernelApproximation[\[Sigma]_,\[Lambda]_,0|0.,\[Kappa]_:0][\[Omega]x_,\[Omega]y_,{min\[Alpha]_,max\[Alpha]_,d\[Alpha]_}]:=
Module[
{a =-((2I )/\[Sigma]^2)\[Omega]y, c =2/\[Sigma]^2 (\[Lambda]-I \[Omega]x),d = \[Kappa] /\[Sigma]^2},
2/(\[Sigma]^2 Abs[a]^(1/3))*
Join[
AiryAi[(c+d^2)/a^(2/3)] Table[E^(d \[Alpha]) AiryAi[(c+d^2+a \[Alpha])/Conjugate[a^(2/3)]],{\[Alpha],min\[Alpha],PreviousTick[min\[Alpha],d\[Alpha]][0],d\[Alpha]}],
If[Mod[min\[Alpha],d\[Alpha]]==0 \[And] min\[Alpha] <= 0 <= max\[Alpha],{AiryAi[(c+d^2)/a^(2/3)] AiryAi[(c+d^2)/Conjugate[a^(2/3)]]},{}],
AiryAi[(c+d^2)/Conjugate[a^(2/3)]]  Table[E^(d \[Alpha]) AiryAi[(c+d^2+a \[Alpha])/a^(2/3)] ,{\[Alpha],NextTick[min\[Alpha],d\[Alpha]][0],max\[Alpha],d\[Alpha]}]
]
]


FourierLineKernelApproximation[\[Sigma]_,\[Lambda]_,\[Alpha]0_,\[Kappa]_:0][\[Omega]x_,\[Omega]y_,{min\[Alpha]_,max\[Alpha]_,d\[Alpha]_}]:=
Module[
{a =-((2I )/ (\[Sigma]^2))(-Sin[\[Alpha]0] \[Omega]x + Cos[\[Alpha]0] \[Omega]y),
c =2/\[Sigma]^2 (\[Lambda]-I (Cos[\[Alpha]0] \[Omega]x + Sin[\[Alpha]0] \[Omega]y)),
d = \[Kappa] /\[Sigma]^2},
If[
a==0,
1/(2 \[Pi] \[Sigma]^2 Sqrt[c+d^2]) Table[Exp[d \[Alpha]-Sqrt[c+d^2] Abs[\[Alpha]]],{\[Alpha],min\[Alpha],max\[Alpha],d\[Alpha]}],
2/(\[Sigma]^2 Abs[a]^(1/3))*Join[
AiryAi[(c+d^2)/a^(2/3)] Table[E^(d \[Alpha]) AiryAi[(c+d^2+a \[Alpha])/Conjugate[a^(2/3)]],{\[Alpha],min\[Alpha],PreviousTick[min\[Alpha],d\[Alpha]][0],d\[Alpha]}],
If[Mod[min\[Alpha],d\[Alpha]]==0 \[And] min\[Alpha] <= 0 <= max\[Alpha],{AiryAi[(c+d^2)/a^(2/3)] AiryAi[(c+d^2)/Conjugate[a^(2/3)]]},{}],
AiryAi[(c+d^2)/Conjugate[a^(2/3)]]  Table[E^(d \[Alpha]) AiryAi[(c+d^2+a \[Alpha])/a^(2/3)] ,{\[Alpha],NextTick[min\[Alpha],d\[Alpha]][0],max\[Alpha],d\[Alpha]}]
]
]
]


FourierLineKernelApproximation[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][\[Omega]x_,\[Omega]y_,{n\[Alpha]_}]:=
FourierLineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]x,\[Omega]y,{-\[Pi]+2\[Pi]/n\[Alpha],\[Pi],2\[Pi]/n\[Alpha]}]


(* Note the order of implemtation. Do not move the following code up *)

FourierLineKernelApproximation[\[Sigma]_,\[Lambda]_][\[Omega]x_,0|0.,\[Alpha]_]=
Exp[-Sqrt[2(\[Lambda]-I \[Omega]x)] Abs[\[Alpha]]/\[Sigma]]/(2\[Pi] Sqrt[2\[Sigma]^2 (\[Lambda]-I \[Omega]x)]);


FourierLineKernelApproximation[\[Sigma]_,\[Lambda]_,0|0.,\[Kappa]_:0][\[Omega]x_,0|0.,\[Alpha]_]=
Exp[(\[Kappa] \[Alpha]-Sqrt[\[Kappa]^2+2 \[Sigma]^2 (\[Lambda]-I \[Omega]x)]Abs[\[Alpha]])/\[Sigma]^2]/(2\[Pi] Sqrt[\[Kappa]^2+2 \[Sigma]^2 (\[Lambda]-I \[Omega]x)]);


FourierLineKernelApproximation[\[Sigma]_,\[Lambda]_][\[Omega]x_,\[Omega]y_,\[Alpha]_]:=
Module[
{a =-((2I )/ (\[Sigma]^2))\[Omega]y, c =2/\[Sigma]^2 (\[Lambda]-I \[Omega]x)},
2/(\[Sigma]^2 Abs[a]^(1/3)) \[Piecewise]{
 {AiryAi[c/a^(2/3)] AiryAi[(c+a \[Alpha])/Conjugate[a^(2/3)]] , \[Alpha]<0},
 {AiryAi[(c+a \[Alpha])/a^(2/3)] AiryAi[c/Conjugate[a^(2/3)]] , \[Alpha]>0},
 {AiryAi[c/a^(2/3)] AiryAi[c/Conjugate[a^(2/3)]] , \[Alpha]==0}
}
]


FourierLineKernelApproximation[\[Sigma]_,\[Lambda]_,0|0.,\[Kappa]_:0][\[Omega]x_,\[Omega]y_,\[Alpha]_]:=
Module[
{a =-((2I )/ (\[Sigma]^2))\[Omega]y, c =2/\[Sigma]^2 (\[Lambda]-I \[Omega]x),d = \[Kappa] /\[Sigma]^2},
2/(\[Sigma]^2 Abs[a]^(1/3)) \[Piecewise]{
 {(E^(d \[Alpha])) AiryAi[(c+d^2)/a^(2/3)] AiryAi[(c+d^2+a \[Alpha])/Conjugate[a^(2/3)]] , \[Alpha]<0},
 {(E^(d \[Alpha])) AiryAi[(c+d^2+a \[Alpha])/a^(2/3)] AiryAi[(c+d^2)/Conjugate[a^(2/3)]] , \[Alpha]>0},
 {AiryAi[(c+d^2)/a^(2/3)] AiryAi[(c+d^2)/Conjugate[a^(2/3)]] , \[Alpha]==0}
}
]


FourierLineKernelApproximation[\[Sigma]_,\[Lambda]_,\[Alpha]0_,\[Kappa]_:0][\[Omega]x_,\[Omega]y_,\[Alpha]_]:=
Module[
{a =-((2I )/ (\[Sigma]^2))(-Sin[\[Alpha]0] \[Omega]x + Cos[\[Alpha]0] \[Omega]y),
c =2/\[Sigma]^2 (\[Lambda]-I (Cos[\[Alpha]0] \[Omega]x + Sin[\[Alpha]0] \[Omega]y)),
d = \[Kappa] /\[Sigma]^2},
If[
a==0,
1/(2 \[Pi] \[Sigma]^2 Sqrt[c+d^2]) Exp[d \[Alpha]-Sqrt[c+d^2] Abs[\[Alpha]]],
2/(\[Sigma]^2 Abs[a]^(1/3)) \[Piecewise]{
 {(E^(d \[Alpha])) AiryAi[(c+d^2)/a^(2/3)] AiryAi[(c+d^2+a \[Alpha])/Conjugate[a^(2/3)]] , \[Alpha]<0},
 {(E^(d \[Alpha])) AiryAi[(c+d^2+a \[Alpha])/a^(2/3)] AiryAi[(c+d^2)/Conjugate[a^(2/3)]] , \[Alpha]>0},
 {AiryAi[(c+d^2)/a^(2/3)] AiryAi[(c+d^2)/Conjugate[a^(2/3)]] , \[Alpha]==0}
}
]
]


(* Line Kernel \[Alpha]-Marginal *)


 LineKernel[\[Sigma]_,\[Lambda]_,\[Alpha]0_][\[Alpha]_]=Cosh[Sqrt[2\[Lambda]] /\[Sigma] (\[Pi]-Abs[\[Alpha]-\[Alpha]0])] /(Sqrt[2\[Lambda]]  \[Sigma] Sinh[Sqrt[2\[Lambda]] /\[Sigma] \[Pi]]);


 LineKernel[\[Sigma]_,\[Lambda]_,\[Alpha]0_,0][\[Alpha]_]=Cosh[Sqrt[2\[Lambda]] /\[Sigma] (\[Pi]-Abs[\[Alpha]-\[Alpha]0])] /(Sqrt[2\[Lambda]]  \[Sigma] Sinh[Sqrt[2\[Lambda]] /\[Sigma] \[Pi]]);


LineKernel[\[Sigma]_,\[Lambda]_,\[Alpha]0_,\[Kappa]_:0][\[Alpha]_]:=
Module[
{sa = 2 Sqrt[\[Kappa]^2+2 \[Lambda] \[Sigma]^2]/\[Sigma]^2},
2/(sa \[Sigma]^2) E^((\[Alpha]-\[Alpha]0) \[Kappa]/\[Sigma]^2)  \[Piecewise]{
 {E^(-sa (\[Alpha]-\[Alpha]0)/2)/(1-E^(-sa \[Pi]+2 \[Pi] \[Kappa]/\[Sigma]^2))-E^(sa (\[Alpha]-\[Alpha]0)/2)/(1-E^(sa \[Pi]+2 \[Pi] \[Kappa]/\[Sigma]^2)), \[Alpha]>\[Alpha]0},
 {(Sinh[sa \[Pi]]/(Cosh[sa \[Pi]]-Cosh[(2 \[Pi] \[Kappa])/\[Sigma]^2])), \[Alpha]==\[Alpha]0},
 {E^(sa (\[Alpha]-\[Alpha]0)/2)/(1-E^(-sa \[Pi]-2 \[Pi] \[Kappa]/\[Sigma]^2))-E^(-sa (\[Alpha]-\[Alpha]0)/2)/(1-E^(sa \[Pi]-2 \[Pi] \[Kappa]/\[Sigma]^2)), \[Alpha]<\[Alpha]0}
}
]


LineKernelMean[\[Sigma]_,\[Lambda]_,\[Alpha]0_,\[Kappa]_][\[Alpha]_] :=
Module[
{a = -4 (\[Kappa]^2+2 \[Lambda] \[Sigma]^2)/\[Sigma]^4,\[Mu]p,\[Mu]m},
\[Mu]p = \[Kappa]/\[Sigma]^2+Sqrt[-a]/2;\[Mu]m= \[Kappa]/\[Sigma]^2-Sqrt[-a]/2;
2/(LineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Alpha]](a-1) \[Sigma]^4 Sqrt[-a]) * {E^((\[Alpha]-\[Alpha]0) \[Mu]m)*\[Piecewise]{
 { (Coth[\[Pi] \[Mu]m]-1-E^(Sqrt[-a] (\[Alpha]-\[Alpha]0)) (Coth[\[Pi] \[Mu]p]-1)) (Cos[\[Alpha]]+Cos[\[Alpha]0])+
  Sqrt[-a] (Coth[\[Pi] \[Mu]m]-1+E^(Sqrt[-a] (\[Alpha]-\[Alpha]0)) (Coth[\[Pi] \[Mu]p]-1)) (Sin[\[Alpha]]-Sin[\[Alpha]0]), \[Alpha]>\[Alpha]0},
 {  (Coth[\[Pi] \[Mu]m]+1-E^(Sqrt[-a] (\[Alpha]-\[Alpha]0)) (Coth[\[Pi] \[Mu]p]+1))(Cos[\[Alpha]]+Cos[\[Alpha]0])+
  Sqrt[-a] (Coth[\[Pi] \[Mu]m]+1+E^(Sqrt[-a] (\[Alpha]-\[Alpha]0)) (Coth[\[Pi] \[Mu]p]+1)) (Sin[\[Alpha]]-Sin[\[Alpha]0]), \[Alpha]<\[Alpha]0},
 {-((4  Sinh[Sqrt[-a] \[Pi]])/(Cosh[Sqrt[-a] \[Pi]]-Cosh[(2 \[Pi] \[Kappa])/\[Sigma]^2]))Cos[\[Alpha]0], \[Alpha]==\[Alpha]0}
},E^((\[Alpha]-\[Alpha]0) \[Mu]p)*\[Piecewise]{
 { Sqrt[-a]  (E^(Sqrt[-a] (-\[Alpha]+\[Alpha]0)) (1-Coth[\[Pi] \[Mu]m])-Coth[\[Pi] \[Mu]p]+1)(Cos[\[Alpha]]-Cos[\[Alpha]0])-
  (E^(Sqrt[-a] (-\[Alpha]+\[Alpha]0)) (1-Coth[\[Pi] \[Mu]m])+Coth[\[Pi] \[Mu]p]-1) (Sin[\[Alpha]]+Sin[\[Alpha]0]), \[Alpha]>\[Alpha]0},
 { Sqrt[-a]  (-E^(Sqrt[-a] (-\[Alpha]+\[Alpha]0)) (1+Coth[\[Pi] \[Mu]m])-Coth[\[Pi] \[Mu]p]-1)(Cos[\[Alpha]]-Cos[\[Alpha]0])-
  (-E^(Sqrt[-a] (-\[Alpha]+\[Alpha]0)) (1+Coth[ \[Pi] \[Mu]m])+Coth[\[Pi] \[Mu]p]+1) (Sin[\[Alpha]]+Sin[\[Alpha]0]), \[Alpha]<\[Alpha]0},
 {-((4  Sinh[Sqrt[-a] \[Pi]])/(Cosh[Sqrt[-a] \[Pi]]-Cosh[(2 \[Pi] \[Kappa])/\[Sigma]^2]))Sin[\[Alpha]0], \[Alpha]==\[Alpha]0}
}}
]


LineKernelMeanAngle[\[Sigma]_,\[Lambda]_,\[Alpha]0_,\[Kappa]_][\[Alpha]_] =(\[Alpha]+\[Alpha]0)/2;


LineKernelMeanRadius[\[Sigma]_,\[Lambda]_,\[Alpha]0_,\[Kappa]_][\[Alpha]_] :=
Module[
{a = -4 (\[Kappa]^2+2 \[Lambda] \[Sigma]^2)/\[Sigma]^4,\[Mu]p,\[Mu]m},
\[Mu]p = \[Kappa]/\[Sigma]^2+Sqrt[-a]/2;\[Mu]m= \[Kappa]/\[Sigma]^2-Sqrt[-a]/2;
1 /LineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Alpha]] *(8 E^(((\[Alpha]-\[Alpha]0) \[Kappa])/\[Sigma]^2))/(Sqrt[-a] \[Sigma]^4 (a-1))  *\[Piecewise]{
 { E^(1/2 Sqrt[-a] (\[Alpha]-\[Alpha]0))/(E^(2\[Pi] \[Mu]p)-1) (-Cos[(\[Alpha]-\[Alpha]0)/2]+Sqrt[-a] Sin[(\[Alpha]-\[Alpha]0)/2])+ (E^(-(1/2) Sqrt[-a] (\[Alpha]-\[Alpha]0)))/(E^(2\[Pi] \[Mu]m)-1) (Cos[(\[Alpha]-\[Alpha]0)/2]+Sqrt[-a] Sin[(\[Alpha]-\[Alpha]0)/2]), \[Alpha]>\[Alpha]0},
 {  E^(1/2 Sqrt[-a] (\[Alpha]-\[Alpha]0))/(E^(-2\[Pi] \[Mu]p)-1) (Cos[(\[Alpha]-\[Alpha]0)/2]-Sqrt[-a] Sin[(\[Alpha]-\[Alpha]0)/2])-E^(-(1/2) Sqrt[-a] (\[Alpha]-\[Alpha]0))/(E^(-2\[Pi] \[Mu]m)-1) (Cos[(\[Alpha]-\[Alpha]0)/2]+Sqrt[-a] Sin[(\[Alpha]-\[Alpha]0)/2]), \[Alpha]<\[Alpha]0},
 {1/2 (Coth[\[Pi] \[Mu]m]-Coth[\[Pi] \[Mu]p]), \!\(\*
    TagBox[
     RowBox[{"\[Alpha]", "==", "\[Alpha]0"}],
     "PiecewiseDefault",
     AutoDelete->False,
     DeletionWarning->True]\)}
}//Chop
]


(* Line Kernel Approximation *)


(* Numeric Implementation *)

NLineKernelApproximation=Compile[
{{\[Sigma],_Real},{\[Lambda],_Real},{\[Alpha]0,_Real},{\[Kappa],_Real},{x,_Real},{y,_Real},{\[Alpha],_Real}},
Module[
{xr = Cos[\[Alpha]0] x + Sin[\[Alpha]0] y,
yr = -Sin[\[Alpha]0] x + Cos[\[Alpha]0] y},
Piecewise[{
{Chop[(Sqrt[3]/(\[Pi] (xr \[Sigma])^2) Exp[-xr \[Lambda]-(2 (3 #1^2+(#2-3 #1) #2))/(xr^3 \[Sigma]^2)])&[yr-\[Kappa]/2 xr^2,(\[Alpha]-\[Kappa] xr)xr],$MachineEpsilon],xr>0},
{0,xr<0},
{$MaxMachineNumber,yr==0\[And]\[Alpha]==0}},
0
]
]
];


NLineKernelApproximationList=Compile[
{{\[Sigma],_Real},{\[Lambda],_Real},{\[Alpha]0,_Real},{\[Kappa],_Real},{x,_Real},{y,_Real},{min\[Alpha],_Real},{max\[Alpha],_Real},{d\[Alpha],_Real}},
Module[
{xr = Cos[\[Alpha]0] x + Sin[\[Alpha]0] y,
yr = -Sin[\[Alpha]0] x + Cos[\[Alpha]0] y},
Piecewise[{
{Chop[Sqrt[3]/(\[Pi] (xr \[Sigma])^2) Exp[-xr \[Lambda]-2/(xr^3 \[Sigma]^2) Table[(3 #1^2+(xr (\[Alpha]-\[Kappa] xr)-3 #1) xr (\[Alpha]-\[Kappa] xr))&[yr-\[Kappa]/2 xr^2],{\[Alpha],min\[Alpha],max\[Alpha],d\[Alpha]}]],$MachineEpsilon],xr>0},
{Table[0,{\[Alpha],min\[Alpha],max\[Alpha],d\[Alpha]}],xr<0},
{Table[If[\[Alpha]===0,$MaxMachineNumber,0],{\[Alpha],min\[Alpha],max\[Alpha],d\[Alpha]}],yr==0}},
Table[0,{\[Alpha],min\[Alpha],max\[Alpha],d\[Alpha]}]
]
]
]


NLineKernelApproximationMarginal=Compile[
{{\[Sigma],_Real},{\[Lambda],_Real},{\[Alpha]0,_Real},{\[Kappa],_Real},{x,_Real},{y,_Real}},
Module[
{xr = Cos[\[Alpha]0] x + Sin[\[Alpha]0] y,
yr = -Sin[\[Alpha]0] x + Cos[\[Alpha]0] y},
Piecewise[{
{Chop[1/\[Sigma] Sqrt[3/(2 \[Pi] xr^3)]Exp[-xr \[Lambda]-(3 (-2 yr+xr^2 \[Kappa])^2)/(8 xr^3 \[Sigma]^2)],$MachineEpsilon],xr>0},
{0,xr<0},
{$MaxMachineNumber,yr==0}},
0
]
]
]


NLineKernelDensityApproximation=Compile[
{{\[Sigma],_Real},{\[Lambda],_Real},{\[Alpha]0,_Real},{\[Kappa],_Real},{x,_Real},{dx,_Real},{y,_Real},{dy,_Real},{\[Alpha],_Real},{d\[Alpha],_Real}},
Module[
{xr = Cos[\[Alpha]0] x + Sin[\[Alpha]0] y,
yr = -Sin[\[Alpha]0] x + Cos[\[Alpha]0] y,
dyr = -Sin[\[Alpha]0] dx + Cos[\[Alpha]0] dy},
Piecewise[{
{Chop[Exp[-xr \[Lambda]-(\[Alpha]-xr \[Kappa])^2/(2 xr \[Sigma]^2)]/(2 dyr Sqrt[2 \[Pi] xr] \[Sigma]) (Erf[Sqrt[3/(2 xr^3)] (dyr+2 yr-xr \[Alpha])/\[Sigma]]+Erf[Sqrt[3/(2 xr^3)] (dyr-2 yr+xr \[Alpha])/\[Sigma]]),$MachineEpsilon],xr>0},
{0,xr<0},
{(1-E^(-\[Lambda] Abs[Cos[\[Alpha]0] dx + Sin[\[Alpha]0] dy]/2))/(\[Lambda] Abs[Cos[\[Alpha]0] dx + Sin[\[Alpha]0] dy]),yr==0\[And]\[Alpha]==0}},
0
]
]
];


NLineKernelDensityApproximationList=Compile[
{{\[Sigma],_Real},{\[Lambda],_Real},{\[Alpha]0,_Real},{\[Kappa],_Real},{x,_Real},{dx,_Real},{y,_Real},{dy,_Real},{min\[Alpha],_Real},{max\[Alpha],_Real},{d\[Alpha],_Real}},
Module[
{xr = Cos[\[Alpha]0] x + Sin[\[Alpha]0] y,
yr = -Sin[\[Alpha]0] x + Cos[\[Alpha]0] y,
dyr = -Sin[\[Alpha]0] dx + Cos[\[Alpha]0] dy},
Piecewise[{
{Chop[Exp[-xr \[Lambda]-(\[Alpha]-xr \[Kappa])^2/(2 xr \[Sigma]^2)]/(2 dyr Sqrt[2 \[Pi] xr] \[Sigma]) Table[Erf[Sqrt[3/(2 xr^3)] (dyr+2 yr-xr \[Alpha])/\[Sigma]]+Erf[Sqrt[3/(2 xr^3)] (dyr-2 yr+xr \[Alpha])/\[Sigma]],{\[Alpha],min\[Alpha],max\[Alpha],d\[Alpha]}],$MachineEpsilon],xr>0},
{Table[0,{\[Alpha],min\[Alpha],max\[Alpha],d\[Alpha]}],xr<0},
{Table[If[\[Alpha]===0,(1-E^(-\[Lambda] Abs[Cos[\[Alpha]0] dx + Sin[\[Alpha]0] dy]/2))/(\[Lambda] Abs[Cos[\[Alpha]0] dx + Sin[\[Alpha]0] dy]),0],{\[Alpha],min\[Alpha],max\[Alpha],d\[Alpha]}],yr==0}},
Table[0,{\[Alpha],min\[Alpha],max\[Alpha],d\[Alpha]}]
]
]
]


NLineKernelDensityApproximationMarginal=Compile[
{{\[Sigma],_Real},{\[Lambda],_Real},{\[Alpha]0,_Real},{\[Kappa],_Real},{x,_Real},{dx,_Real},{y,_Real},{dy,_Real}},
Module[
{xr = Cos[\[Alpha]0] x + Sin[\[Alpha]0] y,
yr = -Sin[\[Alpha]0] x + Cos[\[Alpha]0] y,
dyr = -Sin[\[Alpha]0] dx + Cos[\[Alpha]0] dy},
Piecewise[{
{Chop[Exp[-xr \[Lambda]]/(2 dyr) (Erf[Sqrt[3/(8xr^3)] (dyr+2 yr-xr^2 \[Kappa])/\[Sigma]]+Erf[Sqrt[3/(8xr^3)] (dyr-2 yr+xr^2 \[Kappa])/\[Sigma]]),$MachineEpsilon],xr>0},
{0,xr<0},
{(1-E^(-\[Lambda] Abs[Cos[\[Alpha]0] dx + Sin[\[Alpha]0] dy]/2))/(\[Lambda] Abs[Cos[\[Alpha]0] dx + Sin[\[Alpha]0] dy]),yr==0}},
0
]
]
]


(* Symbolic Implementation *)

LineKernelApproximation[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][x_,y_,{min\[Alpha]_,max\[Alpha]_,d\[Alpha]_}]:=
NLineKernelApproximationList[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y,min\[Alpha],max\[Alpha],d\[Alpha]]


LineKernelApproximation[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][x_,y_,{n\[Alpha]_}]:=
Module[
{kernel=NLineKernelApproximationList[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y,-\[Pi],\[Pi],2\[Pi]/n\[Alpha]]},
MapAt[(#+First[kernel])&,Rest[kernel],-1]
]


(* Note the order of implementation. Do not move the following code up. *)

LineKernelApproximation[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][0|0.,y_,\[Alpha]_]=DiracDelta[y] 


LineKernelApproximation[\[Sigma]_,\[Lambda]_][x_,y_,\[Alpha]_]:=
UnitStep[x] Chop[Sqrt[3]/(\[Pi] (x \[Sigma])^2) Exp[-x \[Lambda]-(2 (3 y^2+(x \[Alpha]-3 y) x \[Alpha]))/(x^3 \[Sigma]^2)],$MachineEpsilon]


LineKernelApproximation[\[Sigma]_,\[Lambda]_,0|0.,\[Kappa]_:0][x_,y_,\[Alpha]_]:=
UnitStep[x] Chop[Sqrt[3]/(\[Pi] (x \[Sigma])^2) Exp[-x \[Lambda]-(2 (3 #1^2+(#2-3 #1) #2))/(x^3 \[Sigma]^2)],$MachineEpsilon]&[y-\[Kappa]/2 x^2,x (\[Alpha]-\[Kappa] x)]


LineKernelApproximation[\[Sigma]_,\[Lambda]_,\[Alpha]0_,\[Kappa]_:0][x_,y_,\[Alpha]_]:=
Module[
{xr = Cos[\[Alpha]0] x + Sin[\[Alpha]0] y,
yr = -Sin[\[Alpha]0] x + Cos[\[Alpha]0] y},
UnitStep[xr] Chop[Sqrt[3]/(\[Pi] (xr \[Sigma])^2) Exp[-xr \[Lambda]-(2 (3 #1^2+(#2-3 #1) #2))/(xr^3 \[Sigma]^2)],$MachineEpsilon]&[yr-\[Kappa]/2 xr^2,xr (\[Alpha]-\[Kappa] xr)]
]


LineKernelApproximation[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][0|0.,y_]=DiracDelta[y]


LineKernelApproximation[\[Sigma]_,\[Lambda]_][x_,y_]:=
UnitStep[x] 1/\[Sigma] Sqrt[3/(2 \[Pi] x^3)]Chop[Exp[-x \[Lambda]-(3 y^2)/(2 x^3 \[Sigma]^2)],$MachineEpsilon]


LineKernelApproximation[\[Sigma]_,\[Lambda]_,0|0.,\[Kappa]_:0][x_,y_]:=
UnitStep[x] 1/\[Sigma] Sqrt[3/(2 \[Pi] x^3)]Chop[Exp[-x \[Lambda]-(3 (-2 y+x^2 \[Kappa])^2)/(8 x^3 \[Sigma]^2)],$MachineEpsilon]


LineKernelApproximation[\[Sigma]_,\[Lambda]_,\[Alpha]0_,\[Kappa]_:0][x_,y_]:=
Module[
{xr = Cos[\[Alpha]0] x + Sin[\[Alpha]0] y,
yr = -Sin[\[Alpha]0] x + Cos[\[Alpha]0] y},
UnitStep[xr]  Chop[1/\[Sigma] Sqrt[3/(2 \[Pi] xr^3)]Exp[-xr \[Lambda]-(3 (-2 yr+xr^2 \[Kappa])^2)/(8 xr^3 \[Sigma]^2)],$MachineEpsilon]
]


LineKernelDensityApproximation[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][x_,dx_,y_,dy_,{min\[Alpha]_,max\[Alpha]_,d\[Alpha]_}]:=
NLineKernelDensityApproximationList[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,dx,y,dy,min\[Alpha],max\[Alpha],d\[Alpha]]


LineKernelDensityApproximation[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][x_,dx_,y_,dy_,{n\[Alpha]_}]:=
NLineKernelDensityApproximationList[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,dx,y,dy,-\[Pi]+2\[Pi]/n\[Alpha],\[Pi],2\[Pi]/n\[Alpha]]


(* Note the order of implementation. Do not move the following code up. *)

LineKernelDensityApproximation[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][0|0.,dx_,0|0.,dy_,0|0.,d\[Alpha]_:0]=(1-E^(-\[Lambda] Abs[Cos[\[Alpha]0] dx + Sin[\[Alpha]0] dy]/2))/(\[Lambda] Abs[Cos[\[Alpha]0] dx + Sin[\[Alpha]0] dy]);


LineKernelDensityApproximation[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][0|0.,dx_,y_,dy_,\[Alpha]_,d\[Alpha]_:0]=0;


LineKernelDensityApproximation[\[Sigma]_,\[Lambda]_][x_,dx_,y_,dy_,\[Alpha]_,d\[Alpha]_]:=
UnitStep[x]Chop[Exp[-x \[Lambda]-(\[Alpha]/\[Sigma])^2/(2 x)]/(2 dy Sqrt[2 \[Pi] x] \[Sigma]) (Erf[Sqrt[3/(2 x^3)] (dy+2 y-x \[Alpha])/\[Sigma]]+Erf[Sqrt[3/(2 x^3)] (dy-2 y+x \[Alpha])/\[Sigma]]),$MachineEpsilon]


LineKernelDensityApproximation[\[Sigma]_,\[Lambda]_,0|0.,\[Kappa]_:0][x_,dx_,y_,dy_,\[Alpha]_,d\[Alpha]_:0]:=
UnitStep[x]Chop[Exp[-x \[Lambda]-(\[Alpha]-x \[Kappa])^2/(2 x \[Sigma]^2)]/(2 dy Sqrt[2 \[Pi] x] \[Sigma]) (Erf[Sqrt[3/(2 x^3)] (dy+2 y-x \[Alpha])/\[Sigma]]+Erf[Sqrt[3/(2 x^3)] (dy-2 y+x \[Alpha])/\[Sigma]]),$MachineEpsilon]


LineKernelDensityApproximation[\[Sigma]_,\[Lambda]_,\[Alpha]0_,\[Kappa]_:0][x_,dx_,y_,dy_,\[Alpha]_,d\[Alpha]_:0]:=
Module[
{xr   = Cos[\[Alpha]0] x + Sin[\[Alpha]0] y,
yr   = -Sin[\[Alpha]0] x + Cos[\[Alpha]0] y,
dyr = -Sin[\[Alpha]0] dx + Cos[\[Alpha]0] dy},
UnitStep[xr]Chop[Exp[-xr \[Lambda]-(\[Alpha]-xr \[Kappa])^2/(2 xr \[Sigma]^2)]/(2 dyr Sqrt[2 \[Pi] xr] \[Sigma])*(Erf[Sqrt[3/(2 xr^3)] (dyr+2 yr-xr \[Alpha])/\[Sigma]]+Erf[Sqrt[3/(2 xr^3)] (dyr-2 yr+xr \[Alpha])/\[Sigma]]),$MachineEpsilon]
]


LineKernelDensityApproximation[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][0|0.,dx_,0|0.,dy_]=(1-E^(-\[Lambda] Abs[Cos[\[Alpha]0] dx + Sin[\[Alpha]0] dy]/2))/(\[Lambda] Abs[Cos[\[Alpha]0] dx + Sin[\[Alpha]0] dy]);


LineKernelDensityApproximation[\[Sigma]_,\[Lambda]_,\[Alpha]0_:0,\[Kappa]_:0][0|0.,dx_,y_,dy_]=0;


LineKernelDensityApproximation[\[Sigma]_,\[Lambda]_][x_,dx_,y_,dy_]:=
UnitStep[x] Chop[Exp[-x \[Lambda]]/(2 dy) (Erf[Sqrt[3/(8 x^3)] (dy-2 y)/\[Sigma]]+Erf[Sqrt[3/(8 x^3)] (dy+2 y)/\[Sigma]]),$MachineEpsilon]


LineKernelDensityApproximation[\[Sigma]_,\[Lambda]_,0|0.,\[Kappa]_:0][x_,dx_,y_,dy_]:=
UnitStep[x]Chop[Exp[-x \[Lambda]]/(2 dy) (Erf[Sqrt[3/(8 x^3)] (dy+2 y-x^2 \[Kappa])/\[Sigma]]+Erf[Sqrt[3/(8 x^3)] (dy-2 y+x^2 \[Kappa])/\[Sigma]]),$MachineEpsilon]


LineKernelDensityApproximation[\[Sigma]_,\[Lambda]_,\[Alpha]0_,\[Kappa]_:0][x_,dx_,y_,dy_]:=
Module[
{xr = Cos[\[Alpha]0] x + Sin[\[Alpha]0] y,
yr = -Sin[\[Alpha]0] x + Cos[\[Alpha]0] y,
dyr = -Sin[\[Alpha]0] dx + Cos[\[Alpha]0] dy},
Chop[Exp[-xr \[Lambda]]/(2 dx dy) (Erf[Sqrt[3/(8xr^3)] (dyr+2 yr-xr^2 \[Kappa])/\[Sigma]]+Erf[Sqrt[3/(8xr^3)] (dyr-2 yr+xr^2 \[Kappa])/\[Sigma]]),$MachineEpsilon]
]


End[]

SetAttributes[
{LineKernel,
LineKernelMean,
FourierLineKernel,
FourierInfiniteLineKernel,
FourierInfiniteLineDiffusionKernel,
FourierLineKernelPolar,
FourierInfiniteLineKernelPolar,
FourierCyclicLineKernel,
FourierCyclicLineKernelPolar,
FourierLineKernelApproximation,
LineKernelApproximation,
NLineKernelApproximation,
NLineKernelApproximationList,
NLineKernelApproximationMarginal,
LineKernelDensityApproximation,
NLineKernelDensityApproximation,
NLineKernelDensityApproximationList,
NLineKernelDensityApproximationMarginal,
FloquetSign,
FloquetExponent},
{Protected, ReadProtected}
];

EndPackage[]
