(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`LogicLinearOperators`"] = {2009,10,7,22,15,0};

Protect[TimeStamp];


This is a dummy cell!


(*:Name: MathVisionTools`LogicLinearOperators` *)

(*:Author: Markus van Almsick *)

(*:Email address: m.v.almsick@tue.nl*)

(*:Context: MathVisionTools`LogicLinearOperators`*)

(*:Package Version: 1.0 *)

(*:Mathematica Version: 6.0 *)

(*:Copyright: Copyright 2009, Technische Universiteit Eindhoven*)

(*:Title: Logic-Linear Operators *)

(*:Summary: This package implements logic-linear operators *)

(*:Keywords: logic, linear, Iverson, Zucker *)

(*:Requirements: None *)

(*:Source: Logical/Linear Operators for Image Curves, L.A.Iverson and S.W.Zucker, 1995 *)

(*:History: Version 1.0 by Markus van Almsick, October 2009 *)

(*:Limitations: the logical-linear operators are not Flat and do not exhibit the OneIdentity attribute *)

(*:Discussion: *)

(*:To do: *)


BeginPackage["MathVisionTools`LogicLinearOperators`",
"MathVisionTools`Common`MathVisionToolsCommon`"]

Unprotect[
LinearAnd,LinearOr,LinearTrue,LinearSigma,LinearTrue
]


LinearAnd::usage="LinearAnd[\[Infinity]][x,y] renders the logical-linear And of the real numbers x and y.\nLinearAnd[0][x,y] renders the linear combination 3/4 (x+y).\nLinearAnd[\[Rho]][x,y] consitutes a smooth transition between these two cases.";

LinearOr::usage="LinearOr[\[Infinity]][x,y] renders the logical-linear Or of the real numbers x and y.\nLinearOr[0][x,y] renders the linear combination 3/4 (x+y).\nLinearOr[\[Rho]][x,y] consitutes a smooth transition between these two cases.";

LinearTrue::usage="LinearTrue[x] is 0 for negative x and x for non-negative values.";

LinearSigma::usage="LinearSigma[x] is a logical-linear utility function renders a smooth transition between 0 at x=-1/2 to 1 at x=+1/2.";


Begin["`Private`"]


LinearSigma = Compile[{{x,_Real}},Which[0.48<=x,1,-0.48<x<0.48,1/(1+Exp[8 x/(4 x^2-1)]),True,0]];


LinearTrue=Compile[{{x,_Real}},Piecewise[{{x,x>0}},0]];


LinearAnd[0]=Compile[{{x,_Real},{y,_Real}},0.75(x+y)];


LinearAnd[\[Infinity]]=Compile[{{x,_Real},{y,_Real}},\[Piecewise]{
 {x, y>0\[And]x<=0},
 {y, y<=0\[And]x>0},
 {x+y, \!\(\*
    TagBox["True",
     "PiecewiseDefault",
     AutoDelete->False,
     DeletionWarning->True]\)}
}];


LinearAnd[\[Rho]_]:=
Compile[{{x,_Real},{y,_Real}},
With[
{\[Rho]x=\[Rho] x,\[Rho]y= \[Rho] y},
Which[
0.48<=\[Rho]x \[And] \[Rho]y<=-0.48,y,
\[Rho]x<=-0.48 \[And] 0.48<=\[Rho]y,x,
-0.48<\[Rho]x<0.48\[And] \[Rho]y<=-0.48,x/(1+Exp[(8 \[Rho]x)/(1-4 \[Rho]x^2)])+y,
\[Rho]x<=-0.48\[And] -0.48<\[Rho]y<0.48,x+y/(1+Exp[(8 \[Rho]y)/(1-4 \[Rho]y^2)]),
0.48<=\[Rho]x \[And]-0.48<\[Rho]y<0.48,x/(1+Exp[(8 \[Rho]y)/(4 \[Rho]y^2-1)])+y,
-0.48<\[Rho]x<0.48\[And]0.48<=\[Rho]y,x+y/(1+Exp[(8 \[Rho]x)/(4 \[Rho]x^2-1)]),
-0.48<\[Rho]x<0.48\[And]-0.48<\[Rho]y<0.48,((x+y+x #1+y #2+x #1 #2+y #1 #2)/(1+#1+#2+#1 #2))&[Exp[(8 \[Rho]x)/(4 \[Rho]x^2-1)],Exp[(8 \[Rho]y)/(4 \[Rho]y^2-1)] ],
True,x+y
]
]
];


LinearOr[0]=Compile[{{x,_Real},{y,_Real}},0.75(x+y)];


LinearOr[\[Infinity]]=Compile[{{x,_Real},{y,_Real}},\[Piecewise]{
 {x, y<=0\[And]x>0},
 {y, y>0\[And]x<=0},
 {x+y, \!\(\*
    TagBox["True",
     "PiecewiseDefault",
     AutoDelete->False,
     DeletionWarning->True]\)}
}];


LinearOr[\[Rho]_]:=
Compile[{{x,_Real},{y,_Real}},
With[
{\[Rho]x=\[Rho] x,\[Rho]y= \[Rho] y},
Which[
0.48<=\[Rho]x \[And] \[Rho]y<=-0.48,x,
\[Rho]x<=-0.48 \[And] 0.48<=\[Rho]y,y,
-0.48<\[Rho]x<0.48\[And] \[Rho]y<=-0.48,x+y/(1+Exp[(8 \[Rho]x)/(1-4 \[Rho]x^2)]),
\[Rho]x<=-0.48\[And] -0.48<\[Rho]y<0.48,x/(1+Exp[(8 \[Rho]y)/(1-4 \[Rho]y^2)])+y,
0.48<=\[Rho]x \[And]-0.48<\[Rho]y<0.48,x+y/(1+Exp[(8 \[Rho]y)/(4 \[Rho]y^2-1)]),
-0.48<\[Rho]x<0.48\[And]0.48<=\[Rho]y,x/(1+Exp[(8 \[Rho]x)/(4 \[Rho]x^2-1)])+y,
-0.48<\[Rho]x<0.48\[And]-0.48<\[Rho]y<0.48,((x+y+y #1+x #2+x #1 #2+y #1 #2)/(1+#1+#2+#1 #2))&[Exp[(8 \[Rho]x)/(4 \[Rho]x^2-1)],Exp[(8 \[Rho]y)/(4 \[Rho]y^2-1)]],
True,x+y]
]
]


End[]

SetAttributes[
{LinearAnd,LinearOr,LinearTrue,LinearSigma,LinearTrue},
{Protected, ReadProtected}
];

EndPackage[]
