(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`MRITagging`"] = {2010,2,2,10,0,0};

Protect[TimeStamp];


(*:Name: MathVisionTools`MRITagging` *)

(*:Author: Markus van Almsick *)

(*:Email address: m.v.almsick@tue.nl *)

(*:Context: MathVisionTools`BSpline` *)

(*:Package Version: 1.0 *)

(*:Mathematica Version: 7.0 *)

(*:Copyright: Copyright 2010, Markus van Almsick *)

(*:Title: MRITagging *)

(*:Summary: This package provides functions needed in the processing to MRI tagging. *)

(*:Keywords: MRI, tagging *)

(*:Warning: None *)

(*:Requirements: None *)

(*:Source: None *)

(*:History: Version 1.0 by Markus van Almsick, February 2010 *)

(*:Limitations: Works only for Mathematica 7.0 or later. *)

(*:Discussion: *)

(*:To do: *)


BeginPackage[
"MathVisionTools`MRITagging`",
{"MathVisionTools`GaussianDerivative`","MathVisionTools`NAlgebra`"}
]

Unprotect[SO2ReductionMatrix,CartesianToSO2Irreducible,SO2IrreducibleNorm,SO2UnitJet,SO2SpectrumToMaxAngle,SO2SpectrumToExtremaAngles,SO2SpectrumOfTaggingWave,
ComplexTaggingWave,DirectionOfTaggingWave]


SO2ReductionMatrix::usage = "For internal use only.";

CartesianToSO2Irreducible::usage = "CartesianToSO2Irreducible[jet] converts a Cartesian jet into a jet of irreducible SO(2)-invariant subspaces.";

SO2IrreducibleNorm::usage = "SO2IrreducibleNorm[jet] renders the Norm of a SO(2)-jet.";

SO2UnitJet::usage = "SO2UnitJet[n,\[CurlyPhi]] is an n-th order SO(2)-jet of unit norm.";

SO2SpectrumToMaxAngle::usage = "SO2SpectrumToMaxAngle[spectrum] renders the angle of the ...";

SO2SpectrumToExtremaAngles::usage = "SO2SpectrumToExtremaAngles[\[Kappa]min,amin][spectrum] ...";

SO2SpectrumOfTaggingWave::usage = "SO2SpectrumOfTaggingWave[\[Omega]0,n][img] ...";

ComplexTaggingWave::usage = "ComplexTaggingWave[\[Omega]0,\[CurlyPhi]0,n][img] ...";

DirectionOfTaggingWave::usage = "DirectionOfTaggingWave[\[Omega]0,\[CurlyPhi]0,n][img] ...";


Begin["`Private`"]


(* SO (2) ReductionMatrix *)

Clear[SO2ReductionMatrixInternal];
SO2ReductionMatrix[n_Integer] = SO2ReductionMatrixInternal[n];
SO2ReductionMatrixInternal[n_Integer]:=SO2ReductionMatrixInternal[n]=
Transpose[CoefficientList[Table[(-I)^k/2^n Binomial[n,k] (1-Q)^k (1+Q)^(n-k),{k,0,n}],Q]]


(* Cartesian to SO (2) Irreducible *)

CartesianToSO2Irreducible[jet_List]:=SO2ReductionMatrixInternal[Length[jet]-1].jet


(* SO (2) Irreducible Norm *)

SO2IrreducibleNorm[jet_List]:=Reverse[jet].((Binomial[#,Range[0,#]]&[Length[jet]-1])jet)


(* SO (2) ReductionMatrix *)

SO2UnitJet[0,\[CurlyPhi]_]= {1};
SO2UnitJet[1,\[CurlyPhi]_]= {Cos[\[CurlyPhi]],-Sin[\[CurlyPhi]]};
SO2UnitJet[n_Integer?Positive, \[CurlyPhi]_]:=
Module[
{s = Sin[\[CurlyPhi]],c=Cos[\[CurlyPhi]]},
Binomial[n,Range[0,n]] NestList[(s #)&,1,n] Reverse[NestList[(c #)&,1,n]]
];


SO2SpectrumOfTaggingWave[\[Omega]0_?NumericQ,n_Integer][img_List]:=
Module[
{ jet1=GaussianDerivativeJet[(n-1)/(2 \[Omega]0^2),n-1][E^((n-1)/2) / (\[Omega]0^(n-1)) img],spectrum1,amplitude1,
jet2=GaussianDerivativeJet[n/(2 \[Omega]0^2),n][E^(n/2) / (\[Omega]0^n) img],spectrum2,amplitude2},
spectrum1 = SO2ReductionMatrix[n-1].jet1;
spectrum2 = SO2ReductionMatrix[n].jet2;
amplitude1=Binomial[n-1,Range[0,n-1]].jet1^2;
amplitude2=Binomial[n,Range[0,n]].jet2^2;
Riffle[
Transpose[amplitude2 Transpose[spectrum2,{3,1,2}],{2,3,1}],Transpose[amplitude1 Transpose[spectrum1,{3,1,2}],{2,3,1}]
]
]/; ArrayDepth[img]===2 \[And] 2<=n<=20


ComplexTaggingWave[\[Omega]0_?NumericQ,\[CurlyPhi]0_,n_Integer][img_List]:=
Module[
{ jet1=GaussianDerivativeJet[(n-1)/(2 \[Omega]0^2),n-1][E^((n-1)/2) / (\[Omega]0^(n-1)) img],spectrum1,amplitude1,
jet2=GaussianDerivativeJet[n/(2 \[Omega]0^2),n][E^(n/2) / (\[Omega]0^n) img],spectrum2,amplitude2,angles},
spectrum1 = SO2ReductionMatrix[n-1].jet1;
spectrum2 = SO2ReductionMatrix[n].jet2;
amplitude1=Binomial[n-1,Range[0,n-1]].jet1^2;
amplitude2=Binomial[n,Range[0,n]].jet2^2;
angles=Mod[SO2SpectrumToMaxAngle[Riffle[
Transpose[amplitude2 Transpose[spectrum2,{3,1,2}],{2,3,1}],Transpose[amplitude1 Transpose[spectrum1,{3,1,2}],{2,3,1}]
]],\[Pi],\[CurlyPhi]0-\[Pi]/2]/.Indeterminate-> \[CurlyPhi]0;
Total[SO2UnitJet[n-1,angles] jet1] + I Total[SO2UnitJet[n,angles]jet2]
]/; ArrayDepth[img]===2 \[And] 2<=n<=20


DirectionOfTaggingWave[\[Omega]0_?NumericQ,\[CurlyPhi]0_,n_Integer][img_List]:=
Module[
{ jet1=GaussianDerivativeJet[(n-1)/(2 \[Omega]0^2),n-1][E^((n-1)/2) / (\[Omega]0^(n-1)) img],spectrum1,amplitude1,
jet2=GaussianDerivativeJet[n/(2 \[Omega]0^2),n][E^(n/2) / (\[Omega]0^n) img],spectrum2,amplitude2,angles},
spectrum1 = SO2ReductionMatrix[n-1].jet1;
spectrum2 = SO2ReductionMatrix[n].jet2;
amplitude1=Binomial[n-1,Range[0,n-1]].jet1^2;
amplitude2=Binomial[n,Range[0,n]].jet2^2;
angles=Mod[SO2SpectrumToMaxAngle[Riffle[
Transpose[amplitude2 Transpose[spectrum2,{3,1,2}],{2,3,1}],Transpose[amplitude1 Transpose[spectrum1,{3,1,2}],{2,3,1}]
]],\[Pi],\[CurlyPhi]0-\[Pi]/2]/.Indeterminate-> \[CurlyPhi]0
]/; ArrayDepth[img]===2 \[And] 2<=n<=20


(* SO (2) Spectrum To Max Angle *)


ComplexUnitQ = Compile[{{z,_Complex}},Abs[z]==1.];


SO2SpectrumToMaxAngle[phases_List]:=
Module[
{n=(Length[phases]-1)/2,angles,amplitudes,z},
angles = Map[Select[List@@NRoots[#==0,z][[All,-1]],ComplexUnitQ]&,(Range[-n,n] z^Range[0,2n]).phases,{2}]; 
amplitudes=Abs[Total[Table[angles^k,{k,-n,n}] phases]]; 
MapThread[Arg[Conjugate[Extract[#1,Ordering[#2,-1]]]]&,{angles,amplitudes},2] /.
Arg[Conjugate[Extract[{},Ordering[{},-1]]]]-> Indeterminate
]/; MatchQ[Dimensions[phases],{_?((OddQ[#]\[And] #>5)&),_,_}]


SO2SpectrumToMaxAngle[phases_List]:=
Module[
{angles,amplitudes,z},
angles = MapThread[NQuadraticUnitRootsComplex,Reverse[{-1,0,1}phases],2]; 
amplitudes=Abs[Total[Table[angles^k,{k,-1,1}] phases]]; 
MapThread[Arg[Conjugate[Extract[#1,Ordering[#2,-1]]]]&,{angles,amplitudes},2] /.
Arg[Conjugate[Extract[{},Ordering[{},-1]]]]-> Indeterminate
]/; MatchQ[Dimensions[phases],{3,_,_}]


SO2SpectrumToMaxAngle[phases_List]:=
Module[
{angles,amplitudes,z},
angles = MapThread[NQuarticUnitRootsComplex,Reverse[Range[-2,2]phases],2]; 
amplitudes=Abs[Total[Table[angles^k,{k,-2,2}] phases]]; 
MapThread[Arg[Conjugate[Extract[#1,Ordering[#2,-1]]]]&,{angles,amplitudes},2] /.
Arg[Conjugate[Extract[{},Ordering[{},-1]]]]-> Indeterminate
]/; MatchQ[Dimensions[phases],{5,_,_}]


SO2SpectrumToMaxAngle[phases_List]:=
Module[
{n=(Length[phases]-1)/2,angles,amplitudes,z},
angles = Select[List@@NRoots[(Range[-n,n] z^Range[0,2n]).phases==0,z][[All,-1]],ComplexUnitQ];
amplitudes=Abs[Total[Table[angles^k,{k,-n,n}] phases]];
Arg[Conjugate[Extract[angles,Ordering[amplitudes,-1]]]]/.
Arg[Conjugate[Extract[{},Ordering[{},-1]]]]-> Indeterminate
]/; MatchQ[Dimensions[phases],{_?((OddQ[#]\[And] #>5)&)}]


SO2SpectrumToMaxAngle[phases_List]:=
Module[
{angles,amplitudes,z},
angles = NQuadraticUnitRootsComplex@@Reverse[{-1,0,1}phases];
amplitudes=Abs[Total[Table[angles^k,{k,-1,1}] phases]];
Arg[Conjugate[Extract[angles,Ordering[amplitudes,-1]]]]/.
Arg[Conjugate[Extract[{},Ordering[{},-1]]]]-> Indeterminate
]/; MatchQ[Dimensions[phases],{3}]


SO2SpectrumToMaxAngle[phases_List]:=
Module[
{angles,amplitudes,z},
angles = NQuarticUnitRootsComplex@@Reverse[Range[-2,2]phases];
amplitudes=Abs[Total[Table[angles^k,{k,-2,2}] phases]];
Arg[Conjugate[Extract[angles,Ordering[amplitudes,-1]]]]/.
Arg[Conjugate[Extract[{},Ordering[{},-1]]]]-> Indeterminate
]/; MatchQ[Dimensions[phases],{5}]


(* SO (2) Spectrum To Extremal Angles *)


SO2SpectrumToExtremaAngles[\[Kappa]min_,amin_][phases_List]:=
Module[
{n=(Length[phases]-1)/2,angles,pos,z,famin=Sqrt[2\[Pi]]amin,f\[Kappa]min=-Sqrt[2\[Pi]]\[Kappa]min},
angles = Map[Select[List@@NRoots[#==0,z][[All,-1]],ComplexUnitQ]&,(Range[-n,n] z^Range[0,2n]).phases,{2}];
pos=Map[Position[Transpose[{Re[(Range[-n,n]^2).#],Abs[Total[#]]}],{_?(#>f\[Kappa]min&),_?(#>famin&)},{1}]&,Transpose[Table[angles^k,{k,-n,n}] phases,{3,1,2}],{2}];
Arg[Conjugate[MapThread[Extract,{angles,pos},2]]]
]/; MatchQ[Dimensions[phases],{_?OddQ,_,_}]


SO2SpectrumToExtremaAngles[\[Kappa]min_,amin_][phases_List]:=
Module[
{n=(Length[phases]-1)/2,angles,pos,z,famin=Sqrt[2\[Pi]]amin,f\[Kappa]min=-Sqrt[2\[Pi]]\[Kappa]min},
angles = Select[List@@NRoots[#==0,z][[All,-1]],ComplexUnitQ]&[(Range[-n,n] z^Range[0,2n]).phases];
pos=Position[Transpose[{Re[(Range[-n,n]^2).#],Abs[Total[#]]}]&[Table[angles^k,{k,-n,n}] phases],{_?(#>f\[Kappa]min&),_?(#>famin&)},{1}];
Arg[Conjugate[Extract[angles,pos]]]
]/; MatchQ[Dimensions[phases],{_?OddQ}]


End[]

SetAttributes[
{SO2ReductionMatrix,CartesianToSO2Irreducible,SO2IrreducibleNorm,SO2UnitJet,SO2SpectrumToMaxAngle,SO2SpectrumToExtremaAngles,SO2SpectrumOfTaggingWave,
ComplexTaggingWave,DirectionOfTaggingWave},
{Protected, ReadProtected}
];

EndPackage[]
