(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* Copyright (C) 2005, E.G.W. ter Voert, MarchingCubes for Mathematica 5.1 *)


Print["MarchingCubes package version 0.3"];


BeginPackage["MarchingCubes`","Geometry`Rotations`"]


MCfindSurfaceInCubes::usage="MCfindSurfaceInCubes[cubes,isolevel,image]; cubes={{x,y,z},...}, isolevel=0, {dimZ,dimY,dimX}=Dimensions[image].\n   This function returns a list of estimated coordinates {{{ex,ey,ez},...},...} on the surface inside the given cubes and a list of polygons connecting these points. {coordinates,polygons}";

MCfindSurfaceInCube::usage="MCfindIsoSurfaceInCube[cube,isolevel,image]; cube={x,y,z}, isolevel=0, {dimZ,dimY,dimX}=Dimensions[image].\n   This function returns a list of estimated coordinates {{ex,ey,ez},...} on the surface inside the given cube and a list of polygons connecting these points. {coordinates,polygons}";

MCcubeIndexC::usage="MCcubeIndexC[isolevel,vertexValues]; isolevel=0, vertexValues={vertext8,vertext7,vertext6,vertext5,vertext4,vertext3,vertext2,vertext1}. Calculates the cubeindex of the cube. \n   returns:0,if all verticeValues are < isolevel;(inside)\n   returns:255,if all verticeValues are \[GreaterEqual] isolevel;(outside)\n   returns:1-254 otherwise;(surface)\n   example:MCcubeIndexC[0.5,{0.1,0.2,0.1,0.5,0.6,0.7,0.0,1.0}].";


basicMarchingCubePatterns::usage="This are the 23 basic MarchingCube Patterns. First colomn is the cubeIndex in binary and the second colomn are the 'triangles'. 'triangles' is a list of 3 edge numbers indicating the edges of the cube on which a triangle vertex is located. {1,4,9} means that there is a triangle with a vertex on cube edge 1, a vertex on cube edge 4 and a vertex on cube edge 9.";
showCubeLayOut::usage="This shows the used cube layout";
plotMarchingCube::usage="Example: plotMarchingCube[{{1,0,1,0,1,1,0,1},{{1,8,9},{1,7,8},{1,2,7},{2,7,11},{5,6,10}}}]. The first list is a vertex list. It is the cubeIndex in binary form. The second list is a list of 'triangles'. 'triangles' is a list of 3 edge numbers indicating the edges of the cube on which a triangle vertex is located. {1,4,9} means that there is a triangle with a vertex on cube edge 1, a vertex on cube edge 4 and a vertex on cube edge 9.";
findAllRotations::usage="given the vertices and the triangles {{0,1,0,0,0,0,1,1},{{2,4,9},{2,9,10},{6,7,11}}} it returns a list of all posible rotations:{{{0,1,0,0,0,0,1,1},{{2,4,9},{2,9,10},{6,7,11}}},...}";
MCfindSurfaceInCubeA::usage="bla";


Begin["`Private`"]


showCubeLayOut[]:=Module[
{},
Show[Graphics3D[
{Line[{{0,0,0},{1,0,0},{1,1,0},{0,1,0},{0,0,0}}],
Line[{{0,0,1},{1,0,1},{1,1,1},{0,1,1},{0,0,1}}],
Line[{{0,0,0},{0,0,1}}],Line[{{1,0,0},{1,0,1}}],
Line[{{1,1,0},{1,1,1}}],Line[{{0,1,0},{0,1,1}}],
RGBColor[1,0,0],Text["1",{0,0-.1,0}],Text["2",{1+.1,0-.1,0}],Text["3",{1+.1,1-.1,0}],
Text["4",{0-.1,1-.1,0}],Text["5",{0,0-.1,1}],Text["6",{1+.1,0-.1,1}],Text["7",{1+.1,1-.1,1}],Text["8",{0-.1,1-.1,1}],
RGBColor[0,0,1],Text["1",{0.5,0-.1,0}],Text["2",{1+.1,.5,0}],Text["3",{0.5,1-.1,0}],Text["4",{0+.1,.5,0}],Text["5",{0.5+.1,0-.1,1}],Text["6",{1+.1,.5-.1,1}],Text["7",{0.5,1-.1,1}],Text["8",{0+.1,.5,1}],Text["9",{0,0-.1,.5}],Text["10",{1+.1,0,.5+.1}],Text["11",{1+.1,1,.5}],Text["12",{0+.1,1+.1,.5}]
}
],Boxed->False,Axes->False];
];



basicMarchingCubePatterns={
{{0,0,0,0,0,0,0,0},{}},
{{0,0,0,0,0,0,0,1},{{1,4,9}}},
{{0,0,0,0,0,0,1,1},{{2,4,9},{2,9,10}}},
{{0,0,1,0,0,0,0,1},{{1,4,9},{5,6,10}}},
{{0,0,0,0,1,1,1,0},{{10,11,12},{1,10,4},{4,10,12}}},
{{0,0,0,0,1,1,1,1},{{10,11,12},{9,10,12}}},
{{0,0,0,1,1,1,1,0},{{10,11,12},{1,10,4},{4,10,12},{5,9,8}}},
{{1,0,1,0,0,1,0,1},{{1,4,9},{5,6,10},{2,11,3},{7,8,12}}},
{{1,0,0,0,1,1,0,1},{{7,8,9},{1,7,9},{1,11,7},{1,2,11}}},
{{1,0,0,0,1,1,1,0},{{1,8,4},{1,8,10},{8,10,11},{7,8,11}}},
{{0,1,0,0,0,0,0,1},{{1,4,9},{6,7,11}}},
{{0,1,0,0,0,0,1,1},{{2,4,9},{2,9,10},{6,7,11}}},
{{0,1,0,1,0,0,1,0},{{1,10,2},{6,7,11},{5,9,8}}},
{{0,1,0,1,0,1,0,1},{{1,4,8},{1,8,5},{2,7,3},{2,6,7}}},
{{0,1,0,0,1,1,0,1},{{1,12,9},{1,6,12},{1,2,6},{6,7,12}}},
{{1,0,0,0,1,1,1,1},{{8,9,10},{8,10,11},{7,8,11}}},
{{1,1,0,0,1,0,1,1},{{6,8,9},{3,6,9},{3,11,6},{3,9,10},{2,3,10}}},
{{1,1,0,0,1,1,1,1},{{6,8,10},{8,9,10}}},
{{1,0,1,0,1,1,0,1},{{1,8,9},{1,7,8},{1,2,7},{2,11,7},{5,6,10}}},
{{1,0,1,0,1,1,1,1},{{7,8,9},{7,9,11},{5,11,9},{5,6,11}}},
{{1,1,1,0,1,0,1,1},{{5,8,9},{2,3,11}}},
{{1,1,1,0,1,1,1,1},{{5,8,9}}},
{{1,1,1,1,1,1,1,1},{}}
};


rotations=Module[
{bottom,top,front,left,back,right},
bottom={{0,0,0},{(1/2)\[Pi],0,0},{\[Pi],0,0},{(3/2)\[Pi],0,0}} ;
top={{0,\[Pi],0},{(1/2)\[Pi],\[Pi],0},{\[Pi],\[Pi],0},{(3/2)\[Pi],\[Pi],0}};
front={{0,(1/2)\[Pi],0},{(1/2)\[Pi],(1/2)\[Pi],0},{\[Pi],(1/2)\[Pi],0},{(3/2)\[Pi],(1/2)\[Pi],0}};
left={{0,(1/2)\[Pi],(1/2)\[Pi]},{(1/2)\[Pi],(1/2)\[Pi],(1/2)\[Pi]},{\[Pi],(1/2)\[Pi],(1/2)\[Pi]},{(3/2)\[Pi],(1/2)\[Pi],(1/2)\[Pi]}};
back={{0,(1/2)\[Pi],\[Pi]},{(1/2)\[Pi],(1/2)\[Pi],\[Pi]},{\[Pi],(1/2)\[Pi],\[Pi]},{(3/2)\[Pi],(1/2)\[Pi],\[Pi]}};
right={{0,(1/2)\[Pi],(3/2)\[Pi]},{(1/2)\[Pi],(1/2)\[Pi],(3/2)\[Pi]},{\[Pi],(1/2)\[Pi],(3/2)\[Pi]},{(3/2)\[Pi],(1/2)\[Pi],(3/2)\[Pi]}};
Flatten[{top,bottom,front,left,back,right},1]
];


getVertexCoordinate[vertexNumber_Integer]:=Module[
{coordVertices},

(* debug stuff *)
If[vertexNumber<1, Print[StyleForm["->Error: getVertexCoordinate <1",FontColor->RGBColor[1,0,0]]];Abort[]];
If[vertexNumber>8, Print[StyleForm["->Error: getVertexCoordinate >8",FontColor->RGBColor[1,0,0]]];Abort[]];

(* Vertices: 1,    2,         3,          4,           5,         6,       7,         8 *)
{{-1,-1,-1},{1,-1,-1},{1,1,-1},{-1,1,-1},{-1,-1,1},{1,-1,1},{1,1,1},{-1,1,1}}[[vertexNumber]]
];


getVertexNumber[vertexCoordinate_List]:=Module[
{coordVertices},
(* Vertex:           1             2          3           4          5          6        7          8    *)
coordVertices={{-1,-1,-1},{1,-1,-1},{1,1,-1},{-1,1,-1},{-1,-1,1},{1,-1,1},{1,1,1},{-1,1,1}};
Position[coordVertices,vertexCoordinate][[1,1]]
]


getVertexCoordinates[edgeNumber_Integer]:=Module[
{vertexNumbers},

(* debug stuff *)
If[\[Not](1<=edgeNumber<=12), Print[StyleForm["->Error: getVertexCoordinates \[Not](1\[LessEqual]edgeNumber\[LessEqual]12)",FontColor->RGBColor[1,0,0]]];Abort[]
];

(* Edge:           1      2      3      4      5      6       7      8      9      10     11      12 *)
vertexNumbers={{1,2},{2,3},{3,4},{4,1},{5,6},{6,7},{7,8},{8,5},{1,5},{2,6},{3,7},{4,8}};
{getVertexCoordinate[vertexNumbers[[edgeNumber,1]]],getVertexCoordinate[vertexNumbers[[edgeNumber,2]]]}];


getEdgeNumber[edgeCoordinates_List]:=Module[
{vertexNumbers,a,b},
(* Edge:           1      2      3      4      5      6       7      8      9      10     11      12 *)
vertexNumbers={{1,2},{2,3},{3,4},{4,1},{5,6},{6,7},{7,8},{8,5},{1,5},{2,6},{3,7},{4,8}};
a=getVertexNumber[edgeCoordinates[[1]]];
b=getVertexNumber[edgeCoordinates[[2]]];
Flatten[{Position[vertexNumbers,{a,b}],Position[vertexNumbers,{b,a}]}][[1]]
];


findAllRotations[{vertices_List,triangles_List}]:=Module[
{pointsInside,pointsOutside,edgeCoords,rotatedCoordinates,phi,theta,psi,r,newPointsInside,newPointsOutside,newEdgeCoords,newVertices,newTriangles,coordinate,i,allRotatedVerticesAndTriangleList},

(* replace vertex numbers from vertices with coordinates *)
pointsInside=MapIndexed[(If[#1==1,getVertexCoordinate[9-#2[[1]] ],{}])&,vertices];
pointsInside=Select[pointsInside,(#!={})&];
pointsOutside=MapIndexed[(If[#1==0,getVertexCoordinate[9-#2[[1]] ],{}])&,vertices];
pointsOutside=Select[pointsOutside,(#!={})&];

(* replace each edges from triangles with 2 vertex coordinates *)
edgeCoords=Map[(Map[(getVertexCoordinates[#])&,#])&,triangles];

(*
Print["pointsInside: "<>ToString[pointsInside]];
Print["pointsOutside: "<>ToString[pointsOutside]];
Print["edgeCoords: "<>ToString[edgeCoords]];
*)

(* rotate all the coordinates with the aid of "rotations" defined else where outside this function *)
rotatedCoordinates=Map[(
phi=#[[1]];
theta=#[[2]];
psi=#[[3]];
r=RotationMatrix3D[phi,theta,psi];
newPointsInside=Map[(Dot[r, #])&,pointsInside];
newPointsOutside=Map[(Dot[r, #])&,pointsOutside];
newEdgeCoords=Map[(Dot[r, #])&,edgeCoords,{3}];
(*
Print["newPointsInside: "<>ToString[newPointsInside]];
Print["newPointsOutside: "<>ToString[newPointsOutside]];
Print["newEdgeCoords: "<>ToString[newEdgeCoords]];
*)
{newPointsInside,newPointsOutside,newEdgeCoords}
)&,
rotations
];

(* convert coordinates back to a vertex list and a triangle list *)
allRotatedVerticesAndTriangleList=Map[(
newPointsInside=#[[1]];
newPointsOutside=#[[2]];
newEdgeCoords=#[[3]];
(* the vertices *)
newVertices=Table[
coordinate=getVertexCoordinate[i];
(* check out function: memberQ *)
If[Length[Select[newPointsInside,(#==coordinate)&]]==1,
1,
If[Length[Select[newPointsOutside,(#==coordinate)&]]==1,
0,
(* debug stuff *)
Print[StyleForm["->Error: findAllRotations",FontColor->RGBColor[1,0,0]]];Abort[];
]
],
{i,8,1,-1}];
(* the triangles *)
newTriangles=Map[(getEdgeNumber[#])&,newEdgeCoords,{2}];
{newVertices,newTriangles}
)&,
rotatedCoordinates
];
Union[allRotatedVerticesAndTriangleList,SameTest->((#1[[1]]===#2[[1]])&)]
];


plotMarchingCube[{vertices_List,triangles_List}]:=Module[
{coordVertices,coordTriangles,myPoints,myTriangles,liveApplet,liveFrame},
coordVertices={{0,1,1},{1,1,1},{1,0,1},{0,0,1},{0,1,0},{1,1,0},{1,0,0},{0,0,0}};
coordTriangles={{0.5,0,0},{1,0.5,0},{0.5,1,0},{0,0.5,0},{0.5,0,1},{1,0.5,1},{0.5,1,1},{0,0.5,1},{0,0,0.5},{1,0,0.5},{1,1,0.5},{0,1,0.5}};

myPoints=Graphics3D[MapThread[
(If[#1==0,
{RGBColor[0,0,0],PointSize[0.02],Point[{#2[[1]],#2[[2]],#2[[3]]}]},
{RGBColor[1,0,0],PointSize[0.02],Point[{#2[[1]],#2[[2]],#2[[3]]}]}
])&,
{vertices,coordVertices}]
];

myTriangles=Graphics3D[Map[
(Polygon[{coordTriangles[[ #[[1]] ]],coordTriangles[[ #[[2]] ]],coordTriangles[[ #[[3]] ]]}])&,
triangles
]
];

Show[{myPoints,myTriangles},BoxRatios->Automatic,Boxed->True,Axes->True,AxesLabel->{"x","y","z"}];

(*
(* If there is the java live applet installed *)
liveApplet=JavaNew["Live"];
liveFrame=JavaNew["com.wolfram.jlink.MathAppletFrame",liveApplet,
{"INPUT="<>ToString[InputForm[N[
Show[{myPoints,myTriangles},BoxRatios->Automatic,Boxed->True,Axes->True,AxesLabel->{"x","y","z"}]
]]],"WIDTH=600","HEIGHT=600"}];
*)
];


triangleTable=Sort[
Map[
{FromDigits[#[[1]],2],#[[1]],#[[2]]}&,
Flatten[Map[(findAllRotations[#])&,basicMarchingCubePatterns],1]
],
(#1[[1]]<#2[[1]])&][[All,3]];
(*Dimensions[triangleTable]*)


edgeTable=Map[(Union[Flatten[#]])&,triangleTable];
(*Dimensions[edgeTable]*)


MCinterpolationC=Compile[{{isolevel,_Real},{vertex1,_Integer,1},{vertex2,_Integer,1},{value1,_Real},{value2,_Real}},
Module[{},

(* debug stuff *)
If[((isolevel<value1) && (isolevel<value2)),
Print[StyleForm["->Error: MCinterpolationC",FontColor->RGBColor[1,0,0]]];
Print[StyleForm["->       Vertex1:"<>ToString[vertex1]<>" Vertex2:"<>ToString[vertex2],FontColor->RGBColor[1,0,0]]];
Abort[]
];
If[((isolevel>value1) && (isolevel>value2)),
Print[StyleForm["->Error: MCinterpolationC",FontColor->RGBColor[1,0,0]]];
Print[StyleForm["->       Vertex1:"<>ToString[vertex1]<>" Vertex2:"<>ToString[vertex2],FontColor->RGBColor[1,0,0]]];
Abort[]
];

(* tune if you want *)
If[Abs[isolevel-value1]<0.00001,vertex1,
If[Abs[isolevel-value2]<0.00001,vertex2,
If[Abs[value1-value2]<0.00001,vertex1,
N[vertex1 +(vertex2-vertex1)((isolevel-value1)/(value2-value1))]
]]]
]];


MCgetInterceptionCoordinateC=Compile[{{edgeNumber,_Integer},{isolevel,_Real},{vertexCoordinates, _Integer,2},{vertexValues,_Real,1}},
Module[
{vertex1,vertex2,vertexCoordinate1,vertexCoordinate2,vertexValue1,vertexValue2,coordinateIntercept},

(* debug stuff *)
If[\[Not](1<=edgeNumber<=12), Print[StyleForm["->Error: MCgetInterceptionCoordinateC \[Not](1\[LessEqual]edgeNumber\[LessEqual]12)",FontColor->RGBColor[1,0,0]]];Abort[]
];

(* Find the vertex numbers connected with the edge *)
(*      Edge:      1      2      3       4      5      6      7      8      9      10     11     12 *)
{vertex1,vertex2}={{1,2},{2,3},{3,4},{4,1},{5,6},{6,7},{7,8},{8,5},{1,5},{2,6},{3,7},{4,8}}[[edgeNumber]];

(* Find the vertex coordinates connected with the edge *)
(* Mind the vertex order: {8,7,6,5,4,3,2,1} in vertexCoordinates *)
vertexCoordinate1=vertexCoordinates[[9-vertex1]];
vertexCoordinate2=vertexCoordinates[[9-vertex2]];

(* Find the values at the vertex coordinates connected with the edge *)
(* Mind the vertex order: {8,7,6,5,4,3,2,1} in vertexValues*)
vertexValue1=vertexValues[[9-vertex1]];
vertexValue2=vertexValues[[9-vertex2]];

(* debug stuff *)
If[((isolevel<vertexValue1) && (isolevel<vertexValue2)),
Print[StyleForm["->Error: MCgetInterceptionCoordinateC",FontColor->RGBColor[1,0,0]]];Print[StyleForm["         Cube"<>ToString[cube]<>" edgenr:"<>ToString[edgeNumber]<>" Vertex1:"<>ToString[vertexCoordinate1]<>" Vertex2:"<>ToString[vertexCoordinate2],FontColor->RGBColor[1,0,0]]];
Abort[]
];
If[((isolevel>vertexValue1) && (isolevel>vertexValue2)),
Print[StyleForm["->Error: MCgetInterceptionCoordinateC",FontColor->RGBColor[1,0,0]]];Print[StyleForm["         Cube"<>ToString[cube]<>" edgenr:"<>ToString[edgeNumber]<>" Vertex1:"<>ToString[vertexCoordinate1]<>" Vertex2:"<>ToString[vertexCoordinate2],FontColor->RGBColor[1,0,0]]];
Abort[]
];

coordinateIntercept=MCinterpolationC[
isolevel,vertexCoordinate1,vertexCoordinate2,vertexValue1,vertexValue2
]
]];


MCtriangleTable[cubeIndex_Integer]:=Module[
{},
triangleTable[[cubeIndex+1]]
];


MCedgeTable[cubeIndex_Integer]:=Module[
{},
edgeTable[[cubeIndex+1]]
];


MCfindSurfaceInCubeA[vertexCoordinates_,vertexValues_,isolevel_]:=Module[
{ cubeIndex,edgesInterceptingSurface,interceptionCoordinate,edgeToCoordinateTable,interceptionCoordinates,triangleVerticesOnEdges,polygons },

(* calculate the cubeIndex *)
cubeIndex= MCcubeIndexC[isolevel,vertexValues];

(* get the edges that intercept the surface *)
edgesInterceptingSurface=MCedgeTable[cubeIndex];

(* Build a lookup table: given a edge number, it returns the interception coordinate of the edge with the iso-surface *)
edgeToCoordinateTable=Table[{},{12}];
interceptionCoordinates=Map[
(
interceptionCoordinate=MCgetInterceptionCoordinateC[#,isolevel,vertexCoordinates,vertexValues];
edgeToCoordinateTable[[#]]=interceptionCoordinate;
interceptionCoordinate
)&,
edgesInterceptingSurface
];

(* for edges and polygons only; *)
(* get the edges on which the vertices of the triangles are *)
triangleVerticesOnEdges=MCtriangleTable[cubeIndex];
(* use this to find the coordinates of the triangle vertices *)
polygons=Map[(Polygon[Map[( edgeToCoordinateTable[[#]])&, #]])&,triangleVerticesOnEdges];

{interceptionCoordinates,polygons}
]


MCfindSurfaceInCubes[cubes_,isolevel_,data_]:=Module[
{x,y,z,vertexCoordinates,vertexValues},
Transpose[
Map[
(
{x,y,z}=#;
vertexCoordinates={{x,y+1,z+1},{x+1,y+1,z+1},{x+1,y,z+1},{x,y,z+1},{x,y+1,z},{x+1,y+1,z},{x+1,y,z},{x,y,z}};
vertexValues=Extract[data,Map[Reverse[#]&,vertexCoordinates]];
MCfindSurfaceInCubeA[vertexCoordinates,vertexValues,isolevel]
)&,
cubes]
]
]


MCfindSurfaceInCube[cube_,isolevel_,data_]:=Module[
{ x,y,z,vertexCoordinates,vertexValues},

{x,y,z}=cube;
vertexCoordinates={{x,y+1,z+1},{x+1,y+1,z+1},{x+1,y,z+1},{x,y,z+1},{x,y+1,z},{x+1,y+1,z},{x+1,y,z},{x,y,z}};
vertexValues=Extract[data,Map[Reverse[#]&,vertexCoordinates]];

MCfindSurfaceInCubeA[vertexCoordinates,vertexValues,isolevel]
]


MCcubeIndexC=Compile[{{isolevel,_Real},{vertexValues,_Real,1}},

(* debug stuff *)
If[Length[vertexValues] != 8, Print[StyleForm["->Error: MCcubeIndexC",FontColor->RGBColor[1,0,0]]];Abort[]
];

(Plus@@MapIndexed[(If[#1<isolevel,0,2^(#2[[1]]-1)])&,Reverse[vertexValues]])
];


End[]


EndPackage[]
