(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`NAlgebra`"] = {2010,2,10,10,0,0};

Protect[TimeStamp];


(*:Name: MathVisionTools`NAlgebra` *)

(*:Author: Markus van Almsick*)

(*:Email address: M.v.Almsick@tue.nl*)

(*:Context: MathVisionTools`NAlgebra`*)

(*:Package Version: 1.0 *)

(*:Mathematica Version: 7.0 *)

(*:Copyright: Copyright 2010, Technische Universiteit Eindhoven*)

(*:Title: NAlgebra *)

(*:Summary: This package implements fast routines to solve polynomials. *)

(*:Keywords: quartic, cubic, quadratic, polynomial, algebra *)

(*:Requirements: None *)

(*:Source: None *)

(*:History: Version 1.0 by Markus van Almsick, February 2010 *)

(*:Limitations: none *)

(*:Discussion: *)

(*:To do: *)


BeginPackage["MathVisionTools`NAlgebra`"]

Unprotect[
NQuadraticRootsReal,NCubicRootsReal,NQuarticRootsReal,NQuadraticRootsComplex,NCubicRootsComplex,NQuarticRootsComplex,NQuadraticUnitRootsComplex,NCubicUnitRootsComplex,NQuarticUnitRootsComplex
]


NQuadraticRootsReal::usage="NQuadraticRootsReal[a,b,c] caluclates the roots of the polynomial a*\!\(\*SuperscriptBox[\(z\), \(2\)]\)+b*z+c==0 for real-valued coefficients a, b, and c.";

NCubicRootsReal::usage="NCubicRootsReal[a,b,c,d] caluclates the roots of the polynomial a*\!\(\*SuperscriptBox[\(z\), \(3\)]\)+b*\!\(\*SuperscriptBox[\(z\), \(2\)]\)+c*z+d==0 for real-valued coefficients a, b, c, and d.";

NQuarticRootsReal::usage="NQuarticRootsReal[a,b,c,d,e] caluclates the roots of the polynomial a*\!\(\*SuperscriptBox[\(z\), \(4\)]\)+b*\!\(\*SuperscriptBox[\(z\), \(3\)]\)+c*\!\(\*SuperscriptBox[\(z\), \(2\)]\)+d*z+e==0 for real-valued coefficients a, b, c, d, and e.";

NQuadraticRootsComplex::usage="NQuadraticRootsComplex[a,b,c] caluclates the roots of the polynomial a*\!\(\*SuperscriptBox[\(z\), \(2\)]\)+b*z+c==0 for complex-valued coefficients a, b, and c.";

NCubicRootsComplex::usage="NCubicRootsComplex[a,b,c,d] caluclates the roots of the polynomial a*\!\(\*SuperscriptBox[\(z\), \(3\)]\)+b*\!\(\*SuperscriptBox[\(z\), \(2\)]\)+c*z+d==0 for complex-valued coefficients a, b, c, and d.";

NQuarticRootsComplex::usage="NQuarticRootsComplex[a,b,c,d,e] caluclates the roots of the polynomial a*\!\(\*SuperscriptBox[\(z\), \(4\)]\)+b*\!\(\*SuperscriptBox[\(z\), \(3\)]\)+c*\!\(\*SuperscriptBox[\(z\), \(2\)]\)+d*z+e==0 for complex-valued coefficients a, b, c, d, and e.";

NQuadraticUnitRootsComplex::usage="NQuadraticUnitRootsComplex[a,b,c] renders the List of roots with norm 1 of the polynomial a*\!\(\*SuperscriptBox[\(z\), \(2\)]\)+b*z+c==0 for complex-valued coefficients a, b, and c.";

NCubicUnitRootsComplex::usage="NCubicUnitRootsComplex[a,b,c,d] renders the List of roots with norm 1 of the polynomial a*\!\(\*SuperscriptBox[\(z\), \(3\)]\)+b*\!\(\*SuperscriptBox[\(z\), \(2\)]\)+c*z+d==0 for complex-valued coefficients a, b, c, and d.";

NQuarticUnitRootsComplex::usage="NQuarticUnitRootsComplex[a,b,c,d,e] renders the List of roots with norm 1 of the polynomial a*\!\(\*SuperscriptBox[\(z\), \(4\)]\)+b*\!\(\*SuperscriptBox[\(z\), \(3\)]\)+c*\!\(\*SuperscriptBox[\(z\), \(2\)]\)+d*z+e==0 for complex-valued coefficients a, b, c, d, and e.";


Begin["`Private`"]


(* NQuadratic *)

NQuadraticRootsReal=
Compile[
{{c,_Real},{d,_Real},{e,_Real}},
If[
c== 0,
If[d== 0,{},{-(e/d)}],
({-1,1}Sqrt[#^2-e/c] - #)&[d/(2 c)]
]
];

NQuadraticRootsComplex=
Compile[
{{c,_Complex},{d,_Complex},{e,_Complex}},
If[
c== 0,
If[d== 0,{},{-(e/d)}],
({-1,1}Sqrt[#^2-e/c] - #)&[d/(2 c)]
]
];

NQuadraticUnitRootsComplex=
Compile[
{{c,_Complex},{d,_Complex},{e,_Complex}},
Select[
If[
c== 0,
If[d== 0,{},{-(e/d)}],
({-1,1}Sqrt[#^2-e/c] - #)&[d/(2 c)]
],
(Round[Abs[#],0.00000001`]===1.`)&
]
]


(* NCubic *)

NCubicRootsReal=
Compile[
{{b,_Real},{c,_Real},{d,_Real},{e,_Real}},
Block[
{mc,md,P,Q},
If[
b== 0,
If[
c== 0,
If[d== 0,{},{-(e/d)}],
({-1,1}Sqrt[#^2-e/c] - #)&[d/(2 c)]
],
mc=c/(3b);md=d/b;
P = md/3 - mc^2; Q = e/(2b) + (mc^2-md/2)mc; 
(#-P/#-mc)&[{1,(-1+I Sqrt[3])/2,(-1-I Sqrt[3])/2} (-Q+ Sqrt[Q^2+P^3])^(1/3)]
]
]
]

NCubicRootsComplex=
Compile[
{{b,_Complex},{c,_Complex},{d,_Complex},{e,_Complex}},
Block[
{mc,md,P,Q},
If[
b== 0,
If[
c== 0,
If[d== 0,{},{-(e/d)}],
({-1,1}Sqrt[#^2-e/c] - #)&[d/(2 c)]
],
mc=c/(3b);md=d/b;
P = md/3 - mc^2; Q = e/(2b) + (mc^2-md/2)mc; 
(#-P/#-mc)&[{1,(-1+I Sqrt[3])/2,(-1-I Sqrt[3])/2} (-Q+ Sqrt[Q^2+P^3])^(1/3)]
]
]
];

NCubicUnitRootsComplex=
Compile[
{{b,_Complex},{c,_Complex},{d,_Complex},{e,_Complex}},
Block[
{mc,md,P,Q},
Select[
If[
b== 0,
If[
c== 0,
If[d== 0,{},{-(e/d)}],
({-1,1}Sqrt[#^2-e/c] - #)&[d/(2 c)]
],
mc=c/(3b);md=d/b;
P = md/3 - mc^2; Q = e/(2b) + (mc^2-md/2)mc; 
(#-P/#-mc)&[{1,(-1+I Sqrt[3])/2,(-1-I Sqrt[3])/2} (-Q+ Sqrt[Q^2+P^3])^(1/3)]
],
(Round[Abs[#],0.00000001`]===1.`)&
]
]
]


(* NQuartic *)

NQuarticRootsReal=
Compile[
{{a,_Real},{b,_Real},{c,_Real},{d,_Real},{e,_Real}},
Block[
{mb,mc,md,P,Q,R,S,\[Alpha],\[Beta],\[Gamma]},
If[
a==0,
If[
b== 0,
If[
c== 0,
If[d== 0,{},{-(e/d)}],
({-1,1}Sqrt[#^2-e/c] - #)&[d/(2 c)]
],
mc=c/(3b);md=d/b;
P = md/3 - mc^2; Q = e/(2b) + (mc^2-md/2)mc; 
(#-P/#-mc)&[{1,(-1+I Sqrt[3])/2,(-1-I Sqrt[3])/2} (-Q+ Sqrt[Q^2+P^3])^(1/3)]
],
mb=b/(4a);mc=c/a;md=d/a;
\[Alpha]=-6 mb^2+mc;\[Beta]=(8mb^2-2mc )mb+md;\[Gamma]=((-3 mb^2+mc) mb- md) mb+e/a;
If[
\[Beta]===0,
Q=Sqrt[\[Alpha]^2-4\[Gamma]];{-#1,-#2,#1,#2}&[Sqrt[(-\[Alpha]-Q)/2],Sqrt[(-\[Alpha]+Q)/2]]-mb,
P=-((\[Alpha]^2+12\[Gamma])/36);Q = ((36\[Gamma]-\[Alpha]^2)\[Alpha])/216- \[Beta]^2/16;
R = -(5/6)\[Alpha]-(If[#==0,(2 Q)^(1/3), P/#-#]&[(-Q+Sqrt[Q^2+P^3])^(1/3)]);
S = Sqrt[\[Alpha] + 2R]/2;
({-#1-S,#1-S,-#2+S,#2+S}&[Sqrt[#1+#2]/2,Sqrt[#1-#2]/2])&[-3\[Alpha] -2 R,\[Beta]/S]-mb
]
]
]
]

NQuarticRootsComplex=
Compile[
{{a,_Complex},{b,_Complex},{c,_Complex},{d,_Complex},{e,_Complex}},
Block[
{mb,mc,md,P,Q,R,S,\[Alpha],\[Beta],\[Gamma]},
If[
a==0,
If[
b== 0,
If[
c== 0,
If[d== 0,{},{-(e/d)}],
({-1,1}Sqrt[#^2-e/c] - #)&[d/(2 c)]
],
mc=c/(3b);md=d/b;
P = md/3 - mc^2; Q = e/(2b) + (mc^2-md/2)mc; 
(#-P/#-mc)&[{1,(-1+I Sqrt[3])/2,(-1-I Sqrt[3])/2} (-Q+ Sqrt[Q^2+P^3])^(1/3)]
],
mb=b/(4a);mc=c/a;md=d/a;
\[Alpha]=-6 mb^2+mc;\[Beta]=(8mb^2-2mc )mb+md;\[Gamma]=((-3 mb^2+mc) mb- md) mb+e/a;
If[
\[Beta]===0,
Q=Sqrt[\[Alpha]^2-4\[Gamma]];{-#1,-#2,#1,#2}&[Sqrt[(-\[Alpha]-Q)/2],Sqrt[(-\[Alpha]+Q)/2]]-mb,
P=-((\[Alpha]^2+12\[Gamma])/36);Q = ((36\[Gamma]-\[Alpha]^2)\[Alpha])/216- \[Beta]^2/16;
R = -(5/6)\[Alpha]-(If[#==0,(2 Q)^(1/3), P/#-#]&[(-Q+Sqrt[Q^2+P^3])^(1/3)]);
S = Sqrt[\[Alpha] + 2R]/2;
({-#1-S,#1-S,-#2+S,#2+S}&[Sqrt[#1+#2]/2,Sqrt[#1-#2]/2])&[-3\[Alpha] -2 R,\[Beta]/S]-mb
]
]
]
];

NQuarticUnitRootsComplex=
Compile[
{{a,_Complex},{b,_Complex},{c,_Complex},{d,_Complex},{e,_Complex}},
Block[
{mb,mc,md,P,Q,R,S,\[Alpha],\[Beta],\[Gamma]},
Select[
If[
a==0,
If[
b== 0,
If[
c== 0,
If[d== 0,{},{-(e/d)}],
({-1,1}Sqrt[#^2-e/c] - #)&[d/(2 c)]
],
mc=c/(3b);md=d/b;
P = md/3 - mc^2; Q = e/(2b) + (mc^2-md/2)mc; 
(#-P/#-mc)&[{1,(-1+I Sqrt[3])/2,(-1-I Sqrt[3])/2} (-Q+ Sqrt[Q^2+P^3])^(1/3)]
],
mb=b/(4a);mc=c/a;md=d/a;
\[Alpha]=-6 mb^2+mc;\[Beta]=(8mb^2-2mc )mb+md;\[Gamma]=((-3 mb^2+mc) mb- md) mb+e/a;
If[
\[Beta]===0,
Q=Sqrt[\[Alpha]^2-4\[Gamma]];{-#1,-#2,#1,#2}&[Sqrt[(-\[Alpha]-Q)/2],Sqrt[(-\[Alpha]+Q)/2]]-mb,
P=-((\[Alpha]^2+12\[Gamma])/36);Q = ((36\[Gamma]-\[Alpha]^2)\[Alpha])/216- \[Beta]^2/16;
R = -(5/6)\[Alpha]-(If[#==0,(2 Q)^(1/3), P/#-#]&[(-Q+Sqrt[Q^2+P^3])^(1/3)]);
S = Sqrt[\[Alpha] + 2R]/2;
({-#1-S,#1-S,-#2+S,#2+S}&[Sqrt[#1+#2]/2,Sqrt[#1-#2]/2])&[-3\[Alpha] -2 R,\[Beta]/S]-mb
]
],
(Round[Abs[#],0.00000001`]===1.`)&
]
]
]


End[]

SetAttributes[
{NQuadraticRootsReal,NCubicRootsReal,NQuarticRootsReal,NQuadraticRootsComplex,NCubicRootsComplex,NQuarticRootsComplex,NQuadraticUnitRootsComplex,NCubicUnitRootsComplex,NQuarticUnitRootsComplex},
{Protected, ReadProtected}
];

EndPackage[]
