(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`SelectFunctions`"] = {2010,4,14,12,10,0};

Protect[TimeStamp];


(*:Name: MathVisionTools`SelectFunctions` *)

(*:Author: Markus van Almsick*)

(*:Email address: M.v.Almsick@tue.nl*)

(*:Context: MathVisionTools`SelectFunctions`*)

(*:Package Version: 1.0 *)

(*:Mathematica Version: 6 *)

(*:Copyright: Copyright 2008, Technische Universiteit Eindhoven*)

(*:Title: SelectFunctions *)

(*:Summary: This package implements several functions to display image data *)

(*:Keywords: plot, display *)

(*:Requirements: None *)

(*:Source: *)

(*:History: Version 1.0 by  Markus van Almsick, Septmeber 2008 *)

(*:Limitations: needs Mathematica 6 or later *)

(*:Discussion: *)

(*:To do: *)


BeginPackage["MathVisionTools`SelectFunctions`",{"MathVisionTools`DisplayFunctions`","MathVisionTools`ImageTransformation`"}]

Unprotect[
  SelectSubimageDialog, SelectPathDialog,ExtractCrossSection 
  ]


SelectSubimageDialog::usage = "SelectSubimageDialog[img] puts up a dialog notebook that displays the image. Two movable locators determine the rectangle that defines the subimage. To select the choosen subimage, hit the proceed button or \[ReturnKey]. The dialog will disapear and SelectSubimageDialog will return the subimage array."


SelectPathDialog::usage = "SelectPathDialog[img] puts up a dialog notebook that displays the image. Initially two locators determine the end points of a linear path. Click the locators to move these end points around. Additional points can be added to or deleted from the path by \[CommandKey]+click or \[AltKey]+click. To select the choosen path, hit the proceed button or \[ReturnKey]. The dialog will disapear and SelectPathDialog will return the two Lists of points that define the path. The first List is given in Image-coordinates, the second in matrix-indices."


ExtractCrossSection::usage = "ExtractCrossSection[img, {p0, p1,\[Ellipsis]} ds:1] renders the List of pixel values along the path given by {p0,p1,\[Ellipsis]} in steps of ds. Cubic B-spline interpolation is used."


Begin["`Private`"]


SelectSubimageDialog[img_]:=
Module[
{dims = Reverse[Dimensions[img]],p},
p={dims/3,2dims/3};
DialogInput[
DialogNotebook[{
Manipulate[
RasterPlot[img,Epilog-> {EdgeForm[Orange],FaceForm[{Green,Opacity[1/8]}],Rectangle@@p}, Frame-> False,ImageSize->Large],
{p,{1,1},dims,Locator},
Deployed->True,
Paneled-> False,
LocalizeVariables-> False
],
Button["Proceed",DialogReturn[Take[img,##]&@@Map[Sort,Reverse[Transpose[Round[p]]]]]]
}]
]
]


SelectPathDialog[img_]:=
Module[
{dims = Reverse[Dimensions[img]],p},
p={dims/3,2dims/3};
DialogInput[
DialogNotebook[{
Manipulate[
RasterPlot[img,Epilog-> {Orange,Line[p]}, Frame-> False,ImageSize->Large],
{p,{1,1},dims,Locator,LocatorAutoCreate->True},
Deployed->True,
Paneled-> False,
LocalizeVariables-> False
],
Button["Proceed",DialogReturn[{p,Round[Map[({0,Length[img]}+{1,-1}#)&,p]]}]]
}]
]
]


ExtractCrossSection::off="One or both end-points of the cross-section are outside the image.";


ExtractCrossSection[img_,{pt1_List,pt2_List},ds_:1]:=
Module[
{dims = Reverse[Dimensions[img]],
tmp=CubicBSplineImageInterpolationFilter[img],
len=Norm[pt2-pt1]},
If[Not[And@@Thread[{1,1}<=pt1<=dims] \[And] And@@Thread[{1,1}<=pt2<= dims]],Message[ExtractCrossSection::off]; Return[$Failed]];
Table[
Apply[NCubicBSplineImageInterpolation[tmp,#1,dims[[2]]-#2+1,dims[[1]],dims[[2]],0]&, pt1+s*(pt2-pt1)/len],
{s,(len-Floor[len/ds]ds)/2,len,ds}
]
]


ExtractCrossSection[img_,pts:{{_,_}..},ds_:1]:=
Module[
{dims = Reverse[Dimensions[img]],
tmp=CubicBSplineImageInterpolationFilter[img],
lens=FoldList[Plus,0,Apply[Norm[#2-#1]&,Partition[pts,2,1],{1}]],
len,path},
len=Last[lens];
If[
Not[And@@Map[And@@Thread[{1,1}<=#<=dims]&,pts]],
Message[ExtractCrossSection::off]; Return[$Failed]
];
path=Map[Interpolation[Transpose[{lens,#}],InterpolationOrder->1]&,Transpose[pts]];
Table[
NCubicBSplineImageInterpolation[tmp,path[[1]][s],dims[[2]]-path[[2]][s]+1,dims[[1]],dims[[2]],0],
{s,(len-Floor[len/ds]ds)/2,len,ds}
]
]


End[]

SetAttributes[
{SelectSubimageDialog, SelectPathDialog,ExtractCrossSection},
{Protected}
];

EndPackage[]
