(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`SphericalTesselation`"] = {2010,3,4,11,0,0};

Protect[TimeStamp];


(*:Name: MathVisionTools`SphericalTesselation` *)

(*:Author: Markus van Almsick *)

(*:Email address: m.v.almsick@tue.nl *)

(*:Context: MathVisionTools`SphericalTesselation` *)

(*:Package Version: 1.0 *)

(*:Mathematica Version: 2.0 *)

(*:Copyright: Copyright 2010, Markus van Almsick *)

(*:Title: SphericalTesselation *)

(*:Summary: This package provides a discrete grid for numerical calculations on a sphere. *)

(*:Keywords: tesselation, spherical *)

(*:Warning: None *)

(*:Requirements: None *)

(*:Source: None *)

(*:History: Version 1.0 by Markus van Almsick, March 2010 *)

(*:Limitations: Works for Mathematica 7.0 or later. *)

(*:Discussion: *)

(*:To do: *)


BeginPackage[
"MathVisionTools`SphericalTesselation`"
]

Unprotect[{IcosahedralComplex,OctahedralComplex,TetrahedralComplex,DualTesselate,DualComplex,VertexAreas,TriangularTesselate,BalancedTriangularTesselate,Triangulate,SphericalAngels}];


IcosahedralComplex::usage="IcosahedralComplex render a GraphicsComplex of an icosahedron with unit radius.";

OctahedralComplex::usage="OctahedralComplex render a GraphicsComplex of an octahedron with unit radius.";

TetrahedralComplex::usage="TetrahedralComplex render a GraphicsComplex of an tetrahedron with unit radius.";

DualTesselate::usage="DualTesselate[gc]...";

DualComplex::usage="DualComplex[gc]...";

VertexAreas::usage="VertexAreas[gc]...";

TriangularTesselate::usage="TriangularTesselate[gc,n]...";

BalancedTriangularTesselate::usage="BalancedTriangularTesselate[gc,n]...";

Triangulate::usage="Triangulate[gc]...";

SphericalAngels::usage="SphericalAngels[gc]...";


Begin["`Private`"]


IcosahedralComplex=
GraphicsComplex[
{{#1,#2,0},{-#1,#2,0},{-#1,-#2,0},{#1,-#2,0},{#2,0,#1},{#2,0,-#1},{-#2,0,-#1},{-#2,0,#1},{0,#1,#2},{0,-#1,#2},{0,-#1,-#2},{0,#1,-#2}}&[Sqrt[0.1` (5+Sqrt[5])],Sqrt[0.1` (5-Sqrt[5])]],
Polygon[
{{5,9,8},{5,8,10},{6,7,12},{6,11,7},{1,5,4},{1,4,6},{3,8,2},{3,2,7},{9,1,12},{9,12,2},{10,11,4},{10,3,11},{9,5,1},{12,1,6},{5,10,4},{6,4,11},{8,9,2},{7,2,12},{8,3,10},{7,11,3}}]
];

OctahedralComplex = 
GraphicsComplex[
{{1,0,0},{-1,0,0},{0,1,0},{0,-1,0},{0,0,1},{0,0,-1}},
Polygon[
{{1,5,3},{3,5,2},{2,5,4},{4,5,1},{1,3,6},{3,2,6},{2,4,6},{4,1,6}}]
];

TetrahedralComplex = 
GraphicsComplex[
{{#,#,#},{-#,-#,#},{-#,#,-#},{#,-#,-#}}&[N[1/Sqrt[3]]],
Polygon[
{{1,2,3},{1,4,2},{3,2,4},{1,3,4}}]
];


TriangularNeighborhoods[triangles:{{_,_,_}..}]:=
Flatten[Last[Reap[Scan[Sow[#,#]&,triangles],_,TriangularNeighbors]],1]


TriangularNeighbors[a_,triangles:{{_,_,_}..}]:=
Last[Reap[Scan[Sow[#,#]&,triangles],Except[a],SortTriangularNeighbors[a,##]&]]


SortTriangularNeighbors[a_,b_,{t1:({a_,b_,_}|{_,a_,b_}|{b_,_,a_}),t2_}]:={a,t1,t2}
SortTriangularNeighbors[a_,b_,{t1:({b_,a_,_}|{_,b_,a_}|{a_,_,b_}),t2_}]:={a,t2,t1}


 DualTesselate[
GraphicsComplex[vectors_List,Polygon[triangles:{{_Integer,_Integer,_Integer}..}],opts:OptionsPattern[]]
]:=
Module[
{n = Length[vectors],dualVectorRules},
dualVectorRules=Dispatch[MapIndexed[(#1-> First[#2]+n)&,triangles]];
GraphicsComplex[
Join[vectors,Map[Normalize[Plus@@vectors[[#]]]&,triangles]],
Polygon[Replace[TriangularNeighborhoods[triangles],dualVectorRules,{2}]],
opts
]
]


VertexCycles[faces_List]:=
Last[Reap[Scan[Sow[#,#]&,faces],_,VertexCycle]]


VertexCycle[a_,faces_List]:=
Module[
{segmentRules=Last[Reap[Scan[Sow[#,#]&,faces],Except[a],VertexCycleSegment[a,##]&]]},
NestList[(#/.segmentRules)&,segmentRules[[1,1]],Length[segmentRules]-1]
]


VertexCycleSegment[a_,b_,{t1:({___,a_,b_,___}|{b_,__,a_}),t2_}]:=Rule[t1,t2]
VertexCycleSegment[a_,b_,{t1:({___,b_,a_,___}|{a_,__,b_}),t2_}]:=Rule[t2,t1]
VertexCycleSegment[a_,b_,{{__}}]:=Sequence[];


 DualComplex[
GraphicsComplex[vectors_List,Polygon[faces:{{__Integer}..}],opts:OptionsPattern[]]
]:=
Module[
{n = Length[vectors],dualVectorRules},
dualVectorRules=Dispatch[MapIndexed[(#1-> First[#2])&,faces]];
GraphicsComplex[
Map[Normalize[Plus@@vectors[[#]]]&,faces],
Polygon[Replace[VertexCycles[faces],dualVectorRules,{2}]],
opts
]
]


PolygonArea[vertices_List]:=
Module[
{segements=Partition[vertices,2,1,1],center = Normalize[Total[vertices]]},
Total[Map[Norm,Apply[Cross,Map[(#-center)&,segements,{2}],{1}]]]/2
]


 VertexAreas[
GraphicsComplex[vectors_List,Polygon[faces:{{__Integer}..}],opts:OptionsPattern[]]
]:=
Module[
{n = Length[vectors],dualVectorRules},
dualVectorRules=Dispatch[Map[(#1-> Normalize[Total[vectors[[#]]]])&,faces]];
Map[PolygonArea,Replace[VertexCycles[faces],dualVectorRules,{2}]]
]


SphericalAngels[GraphicsComplex[vectors_List,Polygon[triangels_List],OptionsPattern[]]]:=
Transpose[{
Arg[vectors[[All,3]]+I Map[Norm,vectors[[All,{1,2}]]]],
Arg[vectors[[All,1]]+I vectors[[All,2]]]
}]


TriangularTesselateFunction[0] = {Vertex$[#1],Vertex$[#2],Vertex$[#3]};

TriangularTesselateFunction[ord_Integer?Positive]:= 
TriangularTesselateFunction[ord]=
Module[
{indices = Table[{i,j,ord-i-j}.TriangularTesselateFunction[0],{i,0,ord},{j,0,ord-i}]},
Join[
Outer[Plus,indices//Flatten,TriangularTesselateFunction[0],1],
Outer[Plus,Rest[indices]//Flatten,{Vertex$[#3],Vertex$[#2],Vertex$[#2]+Vertex$[#3]-Vertex$[#1]},1]
]
]


TriangularTesselate[
GraphicsComplex[vectors_List,Polygon[triangels_List],OptionsPattern[]],
ord_Integer?Positive
]:=
Module[
{newIndexPairs,n = Length[vectors],tesselate=Evaluate[TriangularTesselateFunction[ord]]&},
newTriangels=Flatten[Apply[tesselate,triangels,{1}],1];
newVertices=Union[Flatten[newTriangels]];
GraphicsComplex[
Map[Normalize,newVertices/. Vertex$[n_]:> vectors[[n]]],
Polygon[newTriangels/.Dispatch[MapIndexed[(#1-> First[#2])&,newVertices]]]
]
]


BalancingRules[1]={};

BalancingRules[2]={Vertex$[b_]+2 Vertex$[c_]:>1.0858615683827177` Vertex$[b]+2 Vertex$[c]};

BalancingRules[3]={Vertex$[b_]+3 Vertex$[c_]:>1.1312435506880292` Vertex$[b]+3 Vertex$[c],Vertex$[a_]+Vertex$[b_]+2 Vertex$[c_]:>1.0679419913043333` Vertex$[a]+1.0679419913043333` Vertex$[b]+2 Vertex$[c]};

BalancingRules[4]={Vertex$[b_]+4 Vertex$[c_]:>1.159612058563206` Vertex$[b]+4 Vertex$[c],2 Vertex$[b_]+3 Vertex$[c_]:>2 1.0500456653876376` Vertex$[b]+3 Vertex$[c],Vertex$[a_]+Vertex$[b_]+3 Vertex$[c_]:>1.1092032654023123` Vertex$[a]+1.1092032654023123` Vertex$[b]+3 Vertex$[c],Vertex$[a_]+2 Vertex$[b_]+2 Vertex$[c_]:>1.0569979621981365` Vertex$[a]+2 Vertex$[b]+2 Vertex$[c]};

BalancingRules[5]={Vertex$[b_]+5 Vertex$[c_]:>1.1790886969862926` Vertex$[b]+5 Vertex$[c],2 Vertex$[b_]+4 Vertex$[c_]:>2 1.0848630641601036` Vertex$[b]+4 Vertex$[c],Vertex$[a_]+Vertex$[b_]+4 Vertex$[c_]:>1.1371039124915192` Vertex$[a]+1.1371039124915192` Vertex$[b]+4 Vertex$[c],Vertex$[a_]+2 Vertex$[b_]+3 Vertex$[c_]:>1.0945559999639352` Vertex$[a]+2 1.0433273564827867` Vertex$[b]+3 Vertex$[c]};

BalancingRules[6]={Vertex$[b_]+6 Vertex$[c_]:>1.193307628481359` Vertex$[b]+6 Vertex$[c],2 Vertex$[b_]+5 Vertex$[c_]:>2 1.1105774350715019` Vertex$[b]+5 Vertex$[c],3 Vertex$[b_]+4 Vertex$[c_]:>3 1.035382890602149` Vertex$[b]+4 Vertex$[c],Vertex$[a_]+Vertex$[b_]+5 Vertex$[c_]:>1.1572858923237752` Vertex$[a]+1.1572858923237752` Vertex$[b]+5 Vertex$[c],Vertex$[a_]+2 Vertex$[b_]+4 Vertex$[c_]:>1.121275988251519` Vertex$[a]+2 1.0749655628681625` Vertex$[b]+4 Vertex$[c],Vertex$[a_]+3 Vertex$[b_]+3 Vertex$[c_]:>1.0834737406672839` Vertex$[a]+3 Vertex$[b]+3 Vertex$[c],2 Vertex$[a_]+2 Vertex$[b_]+3 Vertex$[c_]:>2 1.0385576766414544` Vertex$[a]+2 1.0385576766414544` Vertex$[b]+3 Vertex$[c]};

BalancingRules[7]={Vertex$[b_]+7 Vertex$[c_]:>1.2041522924759` Vertex$[b]+7 Vertex$[c],2 Vertex$[b_]+6 Vertex$[c_]:>2 1.1303817950664596` Vertex$[b]+6 Vertex$[c],3 Vertex$[b_]+5 Vertex$[c_]:>3 1.0627900356246538` Vertex$[b]+5 Vertex$[c],Vertex$[a_]+Vertex$[b_]+6 Vertex$[c_]:>1.1725851519248613` Vertex$[a]+1.1725851519248613` Vertex$[b]+6 Vertex$[c],Vertex$[a_]+2 Vertex$[b_]+5 Vertex$[c_]:>1.1413056150541134` Vertex$[a]+2 1.0991641548014388` Vertex$[b]+5 Vertex$[c],Vertex$[a_]+3 Vertex$[b_]+4 Vertex$[c_]:>1.1089131007193087` Vertex$[a]+3 1.031854526113556` Vertex$[b]+4 Vertex$[c],2 Vertex$[a_]+2 Vertex$[b_]+4 Vertex$[c_]:>2 1.067665644162049` Vertex$[a]+2 1.067665644162049` Vertex$[b]+4 Vertex$[c],2 Vertex$[a_]+3 Vertex$[b_]+3 Vertex$[c_]:>2 1.0347993783289484` Vertex$[a]+3 Vertex$[b]+3 Vertex$[c]};

BalancingRules[_]={};


BalancedTriangularTesselate[
GraphicsComplex[vectors_List,Polygon[triangels_List],OptionsPattern[]],
ord_Integer?Positive
]:=
Module[
{newIndexPairs,n = Length[vectors],tesselate=Evaluate[TriangularTesselateFunction[ord]]&},
newTriangels=Flatten[Apply[tesselate,triangels,{1}],1];
newVertices=Union[Flatten[newTriangels]];
GraphicsComplex[
Map[Normalize,(newVertices/.BalancingRules[ord])/. Vertex$[n_]:> vectors[[n]]],
Polygon[newTriangels/.Dispatch[MapIndexed[(#1-> First[#2])&,newVertices]]]
]
]


 TriangulateFace[face:{__Integer}]:=Map[Prepend[#,face]&,Partition[face,2,1,1]]


Triangulate[
GraphicsComplex[vectors_List,Polygon[faces:{{__Integer}..}],opts:OptionsPattern[]]
]:=
Module[
{n=Length[vectors],centerVectorRules,polyangles=DeleteCases[faces,{_,_,_}]},
centerVectorRules=Dispatch[MapIndexed[(#1-> First[#2]+n)&,polyangles]];
GraphicsComplex[
Join[vectors,Map[Normalize[Plus@@vectors[[#]]]&,polyangles]],
Polygon[
Join[
Cases[faces,{_,_,_}],
Replace[Flatten[Map[TriangulateFace,polyangles],1],centerVectorRules,{2}]
]
],
opts
]
]


End[]

SetAttributes[
{IcosahedralComplex,OctahedralComplex,TetrahedralComplex,DualTesselate,DualComplex,VertexAreas,TriangularTesselate,BalancedTriangularTesselate,Triangulate,SphericalAngels},
{Protected, ReadProtected}
];

EndPackage[]
