(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* TimeSamp for Package Version Control *)

Unprotect[TimeStamp];

TimeStamp::usage="TimeStamp[context] should be set to a Date[]-List indicating the version of the corresponding package.";

TimeStamp["MathVisionTools`VolumeRendering`"] = {2005,3,25,23,30,0};

Protect[TimeStamp];


(*:Name: MathVisionTools`VolumeRendering` *)

(*:Author: Markus van Almsick*)

(*:Email address: M.v.Almsick@tue.nl*)

(*:Context: MathVisionTools`VolumeRendering`*)

(*:Package Version: 1.1 *)

(*:Mathematica Version: 5.1 *)

(*:Copyright: Copyright 2005, Technische Universiteit Eindhoven*)

(*:Title: Padding, Frame, Boundary *)

(*:Summary: This package implements the Maximum Intensity Projection for 3D data sets *)

(*:Keywords: MIP, Volume Rendering, Maximum Intensity Projection *)

(*:Requirements: None *)

(*:Source: None *)

(*:History: Version 1.0 by Markus van Almsick, March 2005 *)

(*:Limitations: *)

(*:Discussion: *)

(*:To do: *)


BeginPackage[
"MathVisionTools`VolumeRendering`","MathVisionTools`ImageTransformation`"
]

Unprotect[
IntensityProjection,
MaximumIntensityProjection
]


IntensityProjection::usage="IntensityProjection[image,a] performs an intensity projection of a 3D image dataset with a focal length of 1/a in units of dataset thickness in z-direction. The projection is a simple summation over the z-dimension.";

MaximumIntensityProjection::usage="MaximumIntensityProjection[image,a] performs a maximum intensity projection of a 3D image dataset with a focal length of 1/a in units of dataset thickness in z-direction.";


Begin["`Private`"]


Options[IntensityProjection] = {ArrayInterpolation-> LinearInterpolation};


IntensityProjection[img_?ArrayQ,opts___?OptionQ]:=
Total[img]/; ArrayDepth[img] ===3

IntensityProjection[img_?ArrayQ,0|0.0,opts___?OptionQ]:=
Total[img]/; ArrayDepth[img] ===3

IntensityProjection[img_?ArrayQ,a_?NumberQ,opts___?OptionQ]:=
Module[
{y0,x0},
{y0,x0}=Floor[Rest[Dimensions[img]]/2];
Total[PerspectiveTransformArray[img,{x0,1-a,1+a},{y0,1-a,1+a},0,ArrayInterpolation->(ArrayInterpolation/.{opts}/.Options[MaximumIntensityProjection])]]
]/; ArrayDepth[img] ===3


Options[MaximumIntensityProjection] = {ArrayInterpolation-> LinearInterpolation};


MaximumIntensityProjection[img_?ArrayQ,opts___?OptionQ]:=
Map[Max,Transpose[img,{3,1,2}],{2}]/; ArrayDepth[img] ===3

MaximumIntensityProjection[img_?ArrayQ,0|0.0,opts___?OptionQ]:=
Map[Max,Transpose[img,{3,1,2}],{2}]/; ArrayDepth[img] ===3

MaximumIntensityProjection[img_?ArrayQ,a_?NumberQ,opts___?OptionQ]:=
Module[
{y0,x0},
{y0,x0}=Floor[Rest[Dimensions[img]]/2];
Map[Max,Transpose[PerspectiveTransformArray[img,{x0,1-a,1+a},{y0,1-a,1+a},0,
ArrayInterpolation->(ArrayInterpolation/.{opts}/.Options[MaximumIntensityProjection])],{3,1,2}],{2}]
]/; ArrayDepth[img] ===3


End[]

SetAttributes[
{IntensityProjection,MaximumIntensityProjection},
{Protected, ReadProtected}
];

EndPackage[]
