(* ::Package:: *)

(* ::Section:: *)
(*Init*)


BeginPackage["Retina`",{"MathVisionTools`GaussianDerivative`"},{"MathVisionTools`DisplayFunctions`"}]
(*BeginPackage["Retina`",{"MathVisionTools`GaussianDerivative`"},{"MathVisionTools`DisplayFunctions`"},{"MathVisionCpp`"}]*)
Unprotect@@Names["Retina`*"];
ClearAll @@Names["Retina`*"];
$HistoryLength = 1;


ClosingIm::usage="ClosingIm[list, r] = Closing for matrices.";
CreateGMM::usage="CreateGMM[k,data,i,(savename)] creates a Gaussian Mixture Model for the data with k gaussians and max i iterations.";
CreateMask::usage="CCreateMask[im,(pt),(r)] creates a mask of the aperture.\nUse an inverted colored retina image as input.";
CreateSamplematrix::usage="CreateSamplematrix[im,classifier,mask] creates samplematrix used for segmenting images.";
CreateTrainingSamplematrix::usage="Create samplematrix used for training.";
DeleteNoiseandElongation::usage="DeleteNoiseandElongation[image,\[Sigma],compsize,elongation,cl] deletes noise and elongation in \!\(\*
	StyleBox[\"image\",\nFontSlant->\"Italic\"]\). Noise is deleted using closing (scale \!\(\*
	StyleBox[\"\[Sigma]\",\nFontSlant->\"Italic\"]\)) and the fraction (needs to be larger than \!\(\*
	StyleBox[\"cl\",\nFontSlant->\"Italic\"]\) to be included) of pixelincrease. Structures smaller than \!\(\*
	StyleBox[\"compsize\",\nFontSlant->\"Italic\"]\) need to be more elongated than \!\(\*
	StyleBox[\"elongation\",\nFontSlant->\"Italic\"]\).";
DeleteSmallStructures::usage="DeleteSmallStructures[list,size] deletes small structures in \!\(\*
	StyleBox[\"list\",\nFontSlant->\"Italic\"]\) smaller than \!\(\*
	StyleBox[\"size\",\nFontSlant->\"Italic\"]\).";
Dilate::usage="Dilate[list, r] = Dilation for matrices.";
Erode::usage="Erode[list, r] = Erosion for lists.";
FractalDimensionBoxcounting::usage="FractalDimensionBoxcounting[list,point (opt.) ,radius (opt.),diskradius (opt.) ,extrainfo (opt.)] calculates the fractal dimension for \!\(\*
	StyleBox[\"list\",\nFontSlant->\"Italic\"]\)\!\(\* StyleBox[\" \",\nFontSlant->\"Italic\"]\)using the box-counting method and can also return the FD of a disk image centered on the center point \!\(\*
StyleBox[\"point\",\nFontSlant->\"Italic\"]\) with radius \!\(\*
StyleBox[\"radius\",\nFontSlant->\"Italic\"]\) and optionally discarding the optic disk with radius\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"diskradius\",\nFontSlant->\"Italic\"]\). \!\(\*
StyleBox[\"Extrainfo\",\nFontSlant->\"Italic\"]\) is a boolean for additional information. ";
FractalDimensionMass::usage="FractalDimensionMass[\!\(\*
	StyleBox[\"list\",\nFontSlant->\"Italic\"]\), \!\(\*
	StyleBox[\"point\",\nFontSlant->\"Italic\"]\)] calculates the fractal dimension and image using the mass-radius method centered on \!\(\*
	StyleBox[\"point\",\nFontSlant->\"Italic\"]\).";
FractalDimensionMass2::usage="";
FractalDimensionDilation::usage="FractalDimensionDilation[list,r (=40: opt.),point (opt.) ,radius (opt.),diskradius (opt.) ,extrainfo (opt.)] calculates the fractal dimension for \!\(\*
	StyleBox[\"list\",\nFontSlant->\"Italic\"]\)\!\(\* StyleBox[\" \",\nFontSlant->\"Italic\"]\)using the dilation method with a maximum dilation of \!\(\*
StyleBox[\"r\",\nFontSlant->\"Italic\"]\) and can also return the FD of a disk image centered on the center point \!\(\*
StyleBox[\"point\",\nFontSlant->\"Italic\"]\) with radius \!\(\*
StyleBox[\"radius\",\nFontSlant->\"Italic\"]\) and optionally discarding the optic disk with radius\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"diskradius\",\nFontSlant->\"Italic\"]\). \!\(\*
StyleBox[\"Extrainfo\",\nFontSlant->\"Italic\"]\) is a boolean for additional information. ";
FractalDimensionCorrelation::usage="FractalDimensionDilation[list,r (=40: opt.),point (opt.) ,radius (opt.),diskradius (opt.) ,extrainfo (opt.)] calculates the fractal dimension for \!\(\*
	StyleBox[\"list\",\nFontSlant->\"Italic\"]\)\!\(\* StyleBox[\" \",\nFontSlant->\"Italic\"]\)using the correlation method with a maximum dilation of \!\(\*
StyleBox[\"r\",\nFontSlant->\"Italic\"]\) and can also return the FD of a disk image centered on the center point \!\(\*
StyleBox[\"point\",\nFontSlant->\"Italic\"]\) with radius \!\(\*
StyleBox[\"radius\",\nFontSlant->\"Italic\"]\) and optionally discarding the optic disk with radius\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"diskradius\",\nFontSlant->\"Italic\"]\). \!\(\*
StyleBox[\"Extrainfo\",\nFontSlant->\"Italic\"]\) is a boolean for additional information. ";
FrangiVesselnessFilter::usage="FrangiVesselnessFilter[data,\[Beta],\[Epsilon],\[Sigma]] calculates the vesselness with given parameters.";
FrangiVesselnessFilterMask::usage="FrangiVesselnessFilter[data,\[Beta],\[Epsilon],\[Sigma]] calculates the vesselness with given parameters.";
FrangiVesselnessFilterS::usage="FrangiVesselnessFilterS[data,\[Beta],\[Epsilon],\[Sigma],mask,size] calculates the vesselness with given parameters and adapting parameter S.";
VesselnessFilterCrossing::usage="FrangiVesselnessFilter[data,\[Beta],\[Epsilon],\[Sigma]] calculates the vesselness with given parameters.";
GaborResponse::usage="GaborResponse[list,a_Integer,\[Epsilon]_Integer,k_List,mask_List] calculates the gaborreponse for im and mask with the choosen parameters.";
GaborFilter::usage="GaborFilter[a,\[Epsilon],k] calculates the filters that are used for the GaborResponse function.";
GaborFilterTranslated::usageTranslated="GaborFilterTranslated[a,\[Epsilon],k] calculates the filters that are used for the GaborResponse function.";
H::usage="H[\[Sigma]][im] calculates the Hessian matrix at scale \[Sigma]";
ImagePlot::usage="ImagePlot[im] = RasterPlot with rescaled Epilog.";
Initialize::usage = "Initialize[name] loads the green channel of a colored retina image, invert it and rescale it between 0 and 1.";
InitializeReference::usage = "InitializeReference[name] loads the image as a binary reference image.";
InitializeMask::usage = "InitializeMask[name] load a mask of the image.";
ListToMatrix::usage="ListToMatrix[list_,x_,y_] creates a x*y matrix from list.";
Load::usage="Load[] loads an image using an open dialog window.";
LoadMask::usage="LoadMask[] loads a mask image using an open dialog window.";
LoadReference::usage="LoadReference[name] loads a reference image using an open dialog window.";
LoadTrainingSet::usage="LoadTrainingSet[start,end,{gray,\[Sigma],lum,type}] loads the trainingset in range start:end, Gray = True/False, \[Sigma] = scales (List), lum is a boolean for luminance correction and type = Gabor/Vesselness.";
LoadTrainingSetLarge::usage="LoadTrainingSet[start,end,{gray,\[Sigma],lum,type}] loads the trainingset in range start:end, Gray = True/False, \[Sigma] = scales (List), lum is a boolean for luminance correction and type = Gabor/Vesselness.";
LocalThresholding::usage="LocalThresholding[im,\[Sigma],mask] thresholds im at scale \[Sigma] and multiplies with mask.";
LuminanceCorrection::usage = "LuminanceCoreection[im,\[Sigma]] corrects the image for uneven luminance. \[Sigma] represents the scale for the median filter.";
MethodAccuracy::usage="MethodAccuracy[image,mask,reference] calculates the [SPEC,SENS and ACC].";
OpeningIm::usage="OpeningIm[im,r] = Opening[im,DiskMatrix@r] for matrices.";
OpticDisk::usage="OpticDisk[\!\(\*
StyleBox[\"image\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Opt\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\":\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"ImageSize\",\nFontSlant->\"Italic\"]\)] gives a locatorpane to determine size and position of the optic disk.";
PadImage::usage="PadImage[im_,nrofit_,mask_,es_,ps_] pads image (ps px) after eroding (es px) the original image and then enlarges the image (nrofit px).";
PadImageOld::usage="";
SegmentImage::usage="SegmentImage[image,classifier,mask] segments an image using classifier and mask";
ShoujunVesselnessFilter::usage="ShoujunVesselnessFilter[data,\[Sigma]] calculates the vesselness at scale \[Sigma].";
UpdateStatus::usage="updates the status of a calculation and stores it in variable message.";
V::usage="V[\[Beta],\[Epsilon],\[Sigma]][im] calculates the vesselness with given parameters.";
VFast::usage="Vesselness[\[Beta],\[Epsilon],\[Sigma]][im] calculates the vesselness with given parameters.";
VVFast::usage="Vesselness[\[Beta],\[Epsilon],\[Sigma]][im] calculates the vesselness with given parameters.";



Begin["`Private`"];


(* ::Section::Closed:: *)
(*Load functions*)


Initialize[name_]:=Module[{Ifg}, (*Load, rescale and invert an image*)
	Ifg = Rescale[1-ImageData[Import[name]]];
	Rescale[If[Length@Dimensions[Ifg]==3,Ifg[[All,All,2]],Ifg]]
	
	(*Rescale[-ImageData[Import[name]][[All,All,2]]]*)
];


InitializeMask[name_]:=Module[{},
	ImageData@Binarize[Import[name]]
]


InitializeReference[name_]:=Module[{},
	ImageData@Binarize[Import[name]]
]


Load:=Initialize[SystemDialogInput["FileOpen",WindowTitle->"Select an image to open"]]; (*Load an image with a windows open folder*)
LoadMask:=InitializeMask[SystemDialogInput["FileOpen",WindowTitle->"Select an image to open"]]; (*Load an image with a windows open folder*)
LoadReference:=InitializeReference[SystemDialogInput["FileOpen",WindowTitle->"Select an image to open"]]; (*Load an image with a windows open folder*)


(* ::Section::Closed:: *)
(*Create Mask*)


CreateMask[im_,pt_:{0,0},r_:0]:=Module[{x,y,maskOD=ConstantArray[0,Dimensions[im]],im1,coord,\[Theta]},
	UpdateStatus["Creating mask..."];
	(*Binarize an image using regionbinarize (pad image to make sure both left and right background are connected *)
	mask = Erode[Rescale@ArrayPad[-ImageData@RegionBinarize[Image@ArrayPad[im,4,1],{{50,50}},0.05],-4],0];
	
	If[r>0, (*Make a correction for the optic disk by creating a diskmatrix and pad it to the right position.*)
		maskOD = ArrayPad[RotateLeft[DiskMatrix[r,Dimensions[im]+2r],Round[Dimensions[im]/2-{pt[[1]],pt[[2]]}]],-r];
	];
	Round[mask-mask*maskOD] (*mask*maskOD *)
];


(* ::Section::Closed:: *)
(*Padding*)


PadImageNew[im_,nrofit_,maskim_,erodesize_,paddingsize_]:=Module[{kernel,d,impaddedflat,oldmask,dilmask,border,pos,replval,impadded},
	UpdateStatus["Padding image..."];
	(*Pad image by calculating the positions just around the aperture. Replace these pixelvalues by the average of the pixels around it without taking zeros into account.*)
	d = Dimensions[im]+2*paddingsize;
	kernel = {{-d[[2]]-1},{-d[[2]]},{-d[[2]]+1},{-1},{0},{1},{d[[2]]-1},{d[[2]]},{d[[2]]+1}}; (*Surrounding pixel positions*)
	oldmask = Erode[maskim,erodesize]; (*Old mask*)
	impadded = Flatten@ArrayPad[(oldmask*im),paddingsize]; 
	oldmask=ArrayPad[oldmask,paddingsize];

	Table[
		UpdateStatus["Padding image..."<>ToString[i]<>" of "<> ToString[nrofit]];	
		dilmask =Dilate[oldmask,1];
		border= dilmask - oldmask; (*Border = dilated mask - old mask*)
		oldmask = dilmask;
		pos = Position[Flatten@border,1.]; (*Positions of the border around the aperture.*)
		replval = Mean/@DeleteCases[Partition[Chop[Extract[impadded, Flatten[kernel+#&/@pos[[All,1]],1]]],9],0,{2}]; (*Replacement values for every pixel on the border*)
		Table[impadded[[pos[[i]][[1]]]]=replval[[i]];,{i,1,Length[pos]}];
	,{i,1,nrofit}];
	ListToMatrix[impadded,Dimensions[impadded]]
];


PointAverage[{a_,b_},kernel_,im_]:=Module[{values,p}, (*Calculate the average of the surrounding pixels.*)
	values=Chop@Extract[im,Map[#+{a,b}&,kernel,{1}]]; (*Extract values of surrounding pixels*)
	Mean[DeleteCases[values,0]] (*Delete zeros and take mean*)
];


PadImage2[im_,nrofit_,maskim_,erodesize_,paddingsize_]:=Module[{kernel,oldmask,dilmask,border,pos,replval,impadded},
	
 UpdateStatus["Padding image..."];
  (*Pad image by calculating the positions just around the aperture. Replace these pixelvalues by the average of the pixels around it without taking zeros into account.*)
  	kernel = Flatten[Table[{x,y},{x,-1,1},{y,-1,1}],1]; (*Surrounding pixel positions*)
  	oldmask = Erode[maskim,erodesize]; (*Old mask*)
  	impadded = ArrayPad[(oldmask*im),paddingsize];
  	oldmask=ArrayPad[oldmask,paddingsize];
  	Table[
  		dilmask =Dilate[oldmask,1];
  		border = dilmask - oldmask; (*Border = dilated mask - old mask*)
  		oldmask = dilmask;
  		pos = Position[border,1.]; (*Positions of the border around the aperture.*)
  		replval = Map[PointAverage[#,kernel,impadded]&,pos,{1}]; (*Replacement values for every pixel on the border*)
  		Table[
  			impadded[[pos[[i]][[1]],pos[[i]][[2]]]]=replval[[i]]; (*Replace values for pixels on the border*)
  		,{i,1,Length[pos]}];
  	,{i,1,nrofit}];
  	impadded

];


PadImage[im_,nrofit_,maskim_,erodesize_,paddingsize_]:=Module[{kernel,oldmask,dilmask,border,pos,replval,impadded},
	
 UpdateStatus["Padding image..."];
  (*Pad image by calculating the positions just around the aperture. Replace these pixelvalues by the average of the pixels around it without taking zeros into account.*)
  	kernel = Flatten[Table[{x,y},{x,-1,1},{y,-1,1}],1]; (*Surrounding pixel positions*)
  	oldmask = Erode[maskim,erodesize]; (*Old mask*)
  	impadded = ArrayPad[(oldmask*im),paddingsize];
  	oldmask=ArrayPad[oldmask,paddingsize];
  	Table[
		  UpdateStatus["Padding image..."<>ToString[i]<>" of "<> ToString[nrofit]];	
  		dilmask =Dilate[oldmask,1];
  		border = dilmask - oldmask; (*Border = dilated mask - old mask*)
  		oldmask = dilmask;
  		pos = Position[Round@border,1]; (*Positions of the border around the aperture.*)
  		replval = Map[PointAverage[#,kernel,impadded]&,pos,{1}]; (*Replacement values for every pixel on the border*)
  		Table[
  			impadded[[pos[[i]][[1]],pos[[i]][[2]]]]=replval[[i]]; (*Replace values for pixels on the border*)
  		,{i,1,Length[pos]}];
  	,{i,1,nrofit}];
  	impadded

];


(* ::Section:: *)
(*Gabor-wavelet*)


GaborResponse[im_List,a_,\[Epsilon]_Integer,k_List,mask_List]:=Module[{wvltsize=Round[10a],A={\[Epsilon]^-0.5,1},dim=Dimensions[im]/2,padding,x,x1,y,y1,wvlt,cwvlt,fimg,fwvlt,fimgwv,imgwv,wvlts,resp,gabor,xx,yy},
	UpdateStatus["Calculating Gabor response at scale "<>ToString[a]<>"..."];
	padding= {{Ceiling@dim[[1]],Floor@dim[[1]]},{Ceiling@dim[[2]],Floor@dim[[2]]}}-wvltsize;
	x = Table[N@Range[-wvltsize,wvltsize-1]/a,{2wvltsize}];
	y=Transpose[x];
	fimg = Fourier[im,FourierParameters->{1,1}];
	gabor = Exp[I(k[[1]]xx+k[[2]]yy)-0.5*((A[[1]]xx)^2+(A[[2]]yy)^2)];
	
	wvlts = 
		Table[
			UpdateStatus["Calculating Gabor response at scale "<>ToString[a]<>" - "<> ToString[\[Theta]]<>" Degree ..."];
			{x1,y1} =Apply[Plus,({{x,-y},{x,-y}}Transpose@N@RotationMatrix[-\[Theta] Degree]),1];
			wvlt=gabor/.{xx->x1,yy->y1};
			cwvlt = ArrayPad[Conjugate@wvlt,padding];
			fwvlt = Fourier[RotateLeft[cwvlt,Ceiling[Dimensions[cwvlt]/2]],FourierParameters->{1,1}];
			fimgwv = fimg * Conjugate[fwvlt];
			imgwv = Abs[InverseFourier[fimgwv,FourierParameters->{1,1}]]
		,{\[Theta],0,170,10}];

	Map[Max,Transpose[wvlts,{3,1,2}],{2}]/a*mask
]


GaborFilter[a_Integer,\[Epsilon]_Integer,k_List]:=Module[{wvltsize=5a,A={\[Epsilon]^-0.5,1},x,x1,y,y1,wvlt,cwvlt,fimg,fwvlt,fimgwv,imgwv,wvlts,resp,gabor,xx,yy},
	UpdateStatus["Calculating Gabor response at scale "<>ToString[a]<>"..."];
	x = Table[N@Range[-wvltsize,wvltsize-1]/a,{2wvltsize}];
	y=Transpose[x];
	
	gabor = Exp[I(k[[1]]xx+k[[2]]yy)-0.5*((A[[1]]xx)^2+(A[[2]]yy)^2)];
	
	wvlts = 
		Table[
			{x1,y1} =Apply[Plus,({{x,-y},{x,-y}}Transpose@N@RotationMatrix[-\[Theta] Degree]),1];
			wvlt=gabor/.{xx->x1,yy->y1};
			Conjugate@wvlt
		,{\[Theta],0,170,10}];
	wvlts
	
]


GaborFilterTranslated[im_List,a_Integer,\[Epsilon]_Integer,k_List,filter_:False]:=Module[{wvltsize=5a,A={\[Epsilon]^-0.5,1},wvltpad,dim=Dimensions[im]/2,padding,x,x1,y,y1,wvlt,cwvlt,fimg,fwvlt,fimgwv,imgwv,wvlts,resp,gabor,xx,yy,real,imaginary,wvltsout},
	UpdateStatus["Calculating Gabor translated response at scale "<>ToString[a]<>"..."];
	
	x = Table[N@Range[-wvltsize,wvltsize-1]/a,{2wvltsize}];
	y=Transpose[x];
	
	gabor = Exp[I(k[[1]]xx+k[[2]]yy)-0.5*((A[[1]]xx)^2+(A[[2]]yy)^2)];
	{x1,y1} =Apply[Plus,({{x,-y},{x,-y}}Transpose@N@RotationMatrix[0 Degree]),1];
	wvlt=gabor/.{xx->x1,yy->y1};
	wvlt = Conjugate@wvlt;
	
	dim = Dimensions[wvlt];
	wvlts = Table[real = ImageRotate[ArrayPad[wvlt,{{0,0},{Round[0.5First@dim],0}}]//Re//Image,\[Theta] Degree,2dim]//ImageData;
	imaginary = ImageRotate[ArrayPad[wvlt,{{0,0},{Round[0.5First@dim],0}}]//Im//Image,\[Theta] Degree,2dim]//ImageData;
	real+imaginary,{\[Theta],0,355,5}];

	dim=Dimensions[im]/2;
	padding= {{Ceiling@dim[[1]],Floor@dim[[1]]},{Ceiling@dim[[2]],Floor@dim[[2]]}}-Dimensions[wvlt][[1]];	
	fimg = Fourier[im,FourierParameters->{1,1}];

	
	wvltsout = 
		Table[
			UpdateStatus["Calculating Gabor response at scale "<>ToString[a]<>" - "<> ToString[\[Theta]]<>" Degree ..."];
			wvltpad=ArrayPad[Conjugate[wvlts[[i]]],padding];
			fwvlt = Fourier[RotateLeft[wvltpad,Ceiling[Dimensions[wvltpad]/2]],FourierParameters->{1,1}];
			fimgwv = fimg * Conjugate[fwvlt];
			imgwv = Abs[InverseFourier[fimgwv,FourierParameters->{1,1}]]/a
		,{i,1,Length[wvlts]}];
	
If[filter,{wvltsout,wvlts},wvltsout]
	
]


(* ::Section::Closed:: *)
(*Vesselness Filter*)


(* ::Subsection::Closed:: *)
(*Old*)


H[\[Sigma]_][L_]:=Transpose[{{GaussianDerivative[{\[Sigma],2},{\[Sigma],0}][L],H12=GaussianDerivative[{\[Sigma],1},{\[Sigma],1}][L]}, {H12,GaussianDerivative[{\[Sigma],0},{\[Sigma],2}][L]}},{3,4,1,2}];


Rb={\[Lambda]1,\[Lambda]2}\[Function]Abs@\[Lambda]2/Abs@\[Lambda]1;


S={\[Lambda]1,\[Lambda]2}\[Function]Sqrt[\[Lambda]1^2+\[Lambda]2^2];


V[\[Beta]_,\[Epsilon]_,\[Sigma]_][im_]:=Module[{\[Lambda]1,\[Lambda]2,c},
	UpdateStatus["Calculating vesselness at scale "<>ToString[\[Sigma]]];
	{\[Lambda]1,\[Lambda]2}=Transpose[Map[Eigenvalues,H[\[Sigma]][im],{2}],{2,3,1}];
	c=\[Epsilon] Max@S[\[Lambda]1,\[Lambda]2];
	MapThread[If[#1>=0,0,Exp[-(Rb[#1,#2]^2/(2\[Beta]^2))]*(1-Exp[-(S[#1,#2]^2/(2c^2))])]&,{\[Lambda]1,\[Lambda]2},2]
];



VFast[\[Beta]_,\[Epsilon]_,\[Sigma]_][im_]:=Module[{gd,evgd,x,evsort,evgdt,S,VV},
	UpdateStatus["Calculating vesselness at \[Beta]= "<>ToString[\[Beta]]<>", \[Epsilon]="<>ToString[\[Epsilon]]<>" and \[Sigma]="<>ToString[\[Sigma]]];
	gd = {Flatten@GaussianDerivative[{\[Sigma],2},{\[Sigma],0}][im],Flatten@GaussianDerivative[{\[Sigma],1},{\[Sigma],1}][im],Flatten@GaussianDerivative[{\[Sigma],0},{\[Sigma],2}][im]};
	Block[{root = .5Sqrt[gd[[1]]^2+4gd[[2]]^2-2gd[[1]]gd[[3]]+gd[[3]]^2],tmp = .5(gd[[1]] + gd[[3]])},evgd = Re@{(tmp-root),(tmp+root)}];
	x=Positive[Abs[evgd[[2]]]-Abs[evgd[[1]]]]/.{False->-1,True->1};
	evsort = {Extract[evgdt = Transpose@evgd, Transpose@{Range@Length[x],x}],Extract[evgdt, Transpose@{Range@Length[x],-x}]};
	Remove[evgd,x,gd,evgdt];
	S = Sqrt[evsort[[1]]^2+evsort[[2]]^2];
	VV = ListToMatrix[(Positive[evsort[[2]]]/.{True->0,False->1})*Exp[-((evsort[[1]]/evsort[[2]])^2/(2(\[Beta])^2))](1-Exp[-(S^2/(2(\[Epsilon] *Max@S)^2))]),Dimensions[im]]
];


VVFast[\[Beta]_,\[Epsilon]_,\[Sigma]_][im_]:=Module[{Lxx,Lxy,Lyy,ev,x,evgdt,S,Lcomp,Vcomp},
	
(*Calculate eigenvalues*)
If[\[Sigma]>2, {Lxx,Lxy,Lyy} = {Flatten@GaussianFilter[im,{3\[Sigma],\[Sigma]},{0,2}],Flatten@GaussianFilter[im,{3\[Sigma],\[Sigma]},{1,1}],Flatten@GaussianFilter[im,{3\[Sigma],\[Sigma]},{2,0}]},{Lxx,Lxy,Lyy}= DerivativeFilter[im,{{0,2},{1,1},{2,0}},\[Sigma]]];
	Block[{root =Sqrt[(Lxx-Lyy)^2+4Lxy^2],tmp = Lxx + Lyy},ev = {(tmp-root),(tmp+root)}/2];

(*Sort eigenvalues*)
	x=Sign[Abs[ev[[2]]]-Abs[ev[[1]]]] ;
	{\[Lambda]1,\[Lambda]2} = {Extract[ev = Transpose@ev, Transpose@{Range@Length[x],x}],Extract[ev, Transpose@{Range@Length[x],-x}]};

(*Calculate vesselness*)
Vcomp = Compile[{{ev1,_Real,1},{ev2,_Real,1},{\[Beta]2,_Real},{S2,_Real,1},{m,_Real}},(1-Exp[-(S2/(2m))])Exp[-(ev1/ev2)^2/(2(\[Beta]2)^2)]];
	S = \[Lambda]1^2+\[Lambda]2^2;
	ListToMatrix[UnitStep[-\[Lambda]2]*Vcomp[\[Lambda]1,\[Lambda]2,\[Beta],S,\[Epsilon] Max@S],Dimensions[im]][[1]]
]


VVFastOld[\[Beta]_,\[Epsilon]_,\[Sigma]_][im_]:=Module[{L,evgd,x,evsort,evgdt,S,Lcomp,Vcomp},
	UpdateStatus["Calculating vesselness at \[Beta]= "<>ToString[\[Beta]]<>", \[Epsilon]="<>ToString[\[Epsilon]]<>" and \[Sigma]="<>ToString[\[Sigma]]];

	Lcomp = Compile[{{Lxx,_Real,1},{Lxy,_Real,1},{Lyy,_Real,1}},(Lxx-Lyy)^2+4Lxy^2];	
	Vcomp = Compile[{{ev1,_Real,1},{ev2,_Real,1},{\[Beta]2,_Real},{S2,_Real,1},{m,_Real}},(1-Exp[-(S2/(2m))])Exp[-(ev1/ev2)^2/(2(\[Beta]2)^2)]];

(*Calculate eigenvalues*)
	L = {Flatten@GaussianFilter[im,{3\[Sigma],\[Sigma]},{0,2}],Flatten@GaussianFilter[im,{3\[Sigma],\[Sigma]},{1,1}],Flatten@GaussianFilter[im,{3\[Sigma],\[Sigma]},{2,0}]};
	Block[{root =Sqrt[Lcomp[L[[1]],L[[2]],L[[3]]]],tmp = L[[1]] + L[[3]]},evgd = {(tmp-root),(tmp+root)}/2];

(*Sort eigenvalues*)
	x=Sign[Abs[evgd[[2]]]-Abs[evgd[[1]]]] ;
	evsort = {Extract[evgdt = Transpose@evgd, Transpose@{Range@Length[x],x}],Extract[evgdt, Transpose@{Range@Length[x],-x}]};


	S = evsort[[1]]^2+evsort[[2]]^2;
	ListToMatrix[UnitStep[-evsort[[2]]]*Vcomp[evsort[[1]],evsort[[2]],\[Beta],S,\[Epsilon] Max@S],Dimensions[im]]
]


VVVVVFast[\[Beta]_,\[Epsilon]_,\[Sigma]_][im_]:=Module[{gd,evgd,x,evsort,evgdt,S,comp1,comp2},
	UpdateStatus["Calculating vesselness at \[Beta]= "<>ToString[\[Beta]]<>", \[Epsilon]="<>ToString[\[Epsilon]]<>" and \[Sigma]="<>ToString[\[Sigma]]];

	comp1 = Compile[{{gd1,_Real,1},{gd2,_Real,1},{gd3,_Real,1}},gd1^2+4gd2^2-2gd1*gd3+gd3^2];	
	comp2 = Compile[{{ev1,_Real,1},{ev2,_Real,1},{\[Beta]2,_Real},{S2,_Real,1},{m,_Real}},(1-Exp[-(S2^2/(2m^2))])Exp[-(ev1/ev2)^2/(2(\[Beta]2)^2)]];

	gd = {Flatten@GaussianDerivative[{\[Sigma],2},{\[Sigma],0}][im],Flatten@GaussianDerivative[{\[Sigma],1},{\[Sigma],1}][im],Flatten@GaussianDerivative[{\[Sigma],0},{\[Sigma],2}][im]};
	(*gd = {Flatten@GaussianFilter[im,{3\[Sigma],\[Sigma]},{0,2}],Flatten@GaussianFilter[im,{3\[Sigma],\[Sigma]},{1,1}],Flatten@GaussianFilter[im,{3\[Sigma],\[Sigma]},{2,0}]};*)
	Block[{root =Sqrt[comp1[gd[[1]],gd[[2]],gd[[3]]]]/2,tmp = .5(gd[[1]] + gd[[3]])},evgd = Re@{(tmp-root),(tmp+root)}];
	x=Sign[Abs[evgd[[2]]]-Abs[evgd[[1]]]] ;
	If[Count[x,0]!=0,x = x /. 0->1];
	evsort = {Extract[evgdt = Transpose@evgd, Transpose@{Range@Length[x],x}],Extract[evgdt, Transpose@{Range@Length[x],-x}]};
	Remove[x,gd,evgdt];
	S = Sqrt[evsort[[1]]^2+evsort[[2]]^2];
	ListToMatrix[UnitStep[-evsort[[2]]]*comp2[evsort[[1]],evsort[[2]],\[Beta],S,\[Epsilon] Max@S],Dimensions[im]]
]


(* ::Subsection:: *)
(*New and Fast*)


FrangiVesselnessFilter=
Compile[
{{data,_Real,2},{\[Beta],_Real},{\[Epsilon],_Real},{\[Sigma],_Real}},
Module[
{Lxx,Lxy,Lyy,\[Lambda],\[Lambda]\[Delta],\[Lambda]1,\[Lambda]2,R2,nR2,S2,nS2,\[Gamma] = 3/4,mf},
UpdateStatus["Calculating vesselness at \[Beta]= "<>ToString[\[Beta]]<>", \[Epsilon]="<>ToString[\[Epsilon]]<>" and \[Sigma]="<>ToString[\[Sigma]]];

(* Calculate Hessian derivatives *)
{Lxx,Lxy,Lyy}=If[
\[Sigma]>2,
{GaussianFilter[data,{3\[Sigma],\[Sigma]},{0,2}],
GaussianFilter[data,{3\[Sigma],\[Sigma]},{1,1}],
GaussianFilter[data,{3\[Sigma],\[Sigma]},{2,0}]},
DerivativeFilter[data,{{0,2},{1,1},{2,0}},\[Sigma]]
];

(* Calculate eigenvalues *)
\[Lambda] = Lxx+Lyy;
\[Lambda]\[Delta] = Sign[\[Lambda]]Sqrt[(2 Lxy)^2+(Lxx-Lyy)^2];
{\[Lambda]1,\[Lambda]2}=N[\[Sigma]^\[Gamma]/2]{\[Lambda]+\[Lambda]\[Delta],\[Lambda]-\[Lambda]\[Delta]};

(* Calculate vesselness *)
R2 =(\[Lambda]2/(\[Lambda]1 + $MachineEpsilon))^2;

nR2=-1/(2\[Beta]^2);
S2 = \[Lambda]1^2+\[Lambda]2^2;
nS2 = -1/(2 \[Epsilon]^2 Max[S2]);

Exp[nR2 R2^2](1-Exp[nS2 S2])UnitStep[-\[Lambda]1]
],
{{GaussianFilter[__],_Real,2},{DerivativeFilter[__],_Real,3}}
];


FrangiVesselnessFilterMask=
Compile[
{{data,_Real,2},{\[Beta],_Real},{\[Epsilon],_Real},{\[Sigma],_Real},{mask,_Real,2}},
Module[
{Lxx,Lxy,Lyy,\[Lambda],\[Lambda]\[Delta],\[Lambda]1,\[Lambda]2,R2,nR2,S2,nS2,\[Gamma] = 3/4,mf},
UpdateStatus["Calculating vesselness at \[Beta]= "<>ToString[\[Beta]]<>", \[Epsilon]="<>ToString[\[Epsilon]]<>" and \[Sigma]="<>ToString[\[Sigma]]];

(* Calculate Hessian derivatives *)
{Lxx,Lxy,Lyy}=If[
\[Sigma]>2,
{GaussianFilter[data,{3\[Sigma],\[Sigma]},{0,2}],
GaussianFilter[data,{3\[Sigma],\[Sigma]},{1,1}],
GaussianFilter[data,{3\[Sigma],\[Sigma]},{2,0}]},
DerivativeFilter[data,{{0,2},{1,1},{2,0}},\[Sigma]]
];

(* Calculate eigenvalues *)
\[Lambda] = Lxx+Lyy;
\[Lambda]\[Delta] = Sign[\[Lambda]]Sqrt[(2 Lxy)^2+(Lxx-Lyy)^2];
{\[Lambda]1,\[Lambda]2}=N[\[Sigma]^\[Gamma]/2]{\[Lambda]+\[Lambda]\[Delta],\[Lambda]-\[Lambda]\[Delta]};

(* Calculate vesselness *)
R2 =(\[Lambda]2/(\[Lambda]1 + $MachineEpsilon))^2;

nR2=-1/(2\[Beta]^2);
S2 = (\[Lambda]1^2+\[Lambda]2^2)*mask;
nS2 = -1/(2 \[Epsilon]^2 Max[S2]);

Exp[nR2 R2^2](1-Exp[nS2 S2])UnitStep[-\[Lambda]1]
],
{{GaussianFilter[__],_Real,2},{DerivativeFilter[__],_Real,3}}
];


FrangiVesselnessFilterS[data_,\[Beta]_,\[Epsilon]_,\[Sigma]_,mask_,size_,blur_]:=
Module[
{Lxx,Lxy,Lyy,\[Lambda],\[Lambda]\[Delta],\[Lambda]1,\[Lambda]2,R2,nR2,S2,nS2,\[Gamma] = 3/4,mf,maximage,maxs},
UpdateStatus["Calculating vesselness at \[Beta]= "<>ToString[\[Beta]]<>", \[Epsilon]="<>ToString[\[Epsilon]]<>" and \[Sigma]="<>ToString[\[Sigma]]];

(* Calculate Hessian derivatives *)
{Lxx,Lxy,Lyy}=If[
\[Sigma]>2,
{GaussianFilter[data,{3\[Sigma],\[Sigma]},{0,2}],
GaussianFilter[data,{3\[Sigma],\[Sigma]},{1,1}],
GaussianFilter[data,{3\[Sigma],\[Sigma]},{2,0}]},
DerivativeFilter[data,{{0,2},{1,1},{2,0}},\[Sigma]]
];
(* Calculate eigenvalues *)
\[Lambda] = Lxx+Lyy;
\[Lambda]\[Delta] = Sign[\[Lambda]]Sqrt[(2 Lxy)^2+(Lxx-Lyy)^2];
{\[Lambda]1,\[Lambda]2}=N[\[Sigma]^\[Gamma]/2]{\[Lambda]+\[Lambda]\[Delta],\[Lambda]-\[Lambda]\[Delta]};
(* Calculate vesselness *)
R2 =(\[Lambda]2/(\[Lambda]1 + $MachineEpsilon))^2;

nR2=-1/(2\[Beta]^2);
S2 = \[Lambda]1^2+\[Lambda]2^2;

nS2 = -1/(2 \[Epsilon]^2 Max[Erode[S2,20]]);

Exp[nR2 R2^2](1-Exp[nS2 S2])UnitStep[-\[Lambda]1]
]


FrangiVesselnessFilterS2[data_,\[Beta]_,\[Epsilon]_,\[Sigma]_,mask_,size_,blur_]:=
Module[
{Lxx,Lxy,Lyy,\[Lambda],\[Lambda]\[Delta],\[Lambda]1,\[Lambda]2,R2,nR2,S2,nS2,\[Gamma] = 3/4,mf,maximage,maxs},
UpdateStatus["Calculating vesselness at \[Beta]= "<>ToString[\[Beta]]<>", \[Epsilon]="<>ToString[\[Epsilon]]<>" and \[Sigma]="<>ToString[\[Sigma]]];

(* Calculate Hessian derivatives *)
{Lxx,Lxy,Lyy}=If[
\[Sigma]>2,
{GaussianFilter[data,{3\[Sigma],\[Sigma]},{0,2}],
GaussianFilter[data,{3\[Sigma],\[Sigma]},{1,1}],
GaussianFilter[data,{3\[Sigma],\[Sigma]},{2,0}]},
DerivativeFilter[data,{{0,2},{1,1},{2,0}},\[Sigma]]
];
(* Calculate eigenvalues *)
\[Lambda] = Lxx+Lyy;
\[Lambda]\[Delta] = Sign[\[Lambda]]Sqrt[(2 Lxy)^2+(Lxx-Lyy)^2];
{\[Lambda]1,\[Lambda]2}=N[\[Sigma]^\[Gamma]/2]{\[Lambda]+\[Lambda]\[Delta],\[Lambda]-\[Lambda]\[Delta]};
(* Calculate vesselness *)
R2 =(\[Lambda]2/(\[Lambda]1 + $MachineEpsilon))^2;

nR2=-1/(2\[Beta]^2);
S2 = \[Lambda]1^2+\[Lambda]2^2(*;
(*nS2 = -1/(2 \[Epsilon]^2 ImageData[Blur[Image[MaxFilter[Erode[mask,10],200]],300]]+$MachineEpsilon);*)
(*Print@AbsoluteTiming[maximage = Map[ConstantArray[Max[#],{size,size}]&,Partition[Erode[mask,10]*S2,{size,size},size,{1,1}],{2}];]*)
maximage = Map[ConstantArray[Max[#],{size,size}]&,Partition[ImageData[ImageMultiply[Erosion[Image[mask],10],Image[S2]]],{size,size},size,{1,1}],{2}];
(*Partition[ImageData[ImageMultiply[Erosion[Image[mask],10],Image[im]]],{size=100,size},size,{1,1}]*)
maxs = Take[ArrayFlatten[maximage],{1,Dimensions[data][[1]]},{1,Dimensions[data][[2]]}];
nS2 = -1/(2 \[Epsilon]^2 ImageData[Blur[Image@maxs,blur]] + $MachineEpsilon);
nS2 = Chop[nS2];
Print@AbsoluteTiming[Exp[nR2 R2^2](1-Exp[nS2 S2])UnitStep[-\[Lambda]1]]*)
]


VesselnessFilterCrossing= 
Compile[
{{data,_Real,2},{\[Beta],_Real},{\[Epsilon],_Real},{\[Sigma],_Real}},
Module[
{Lxx,Lxy,Lyy,\[Lambda],\[Lambda]\[Delta],\[Lambda]1,\[Lambda]2,R2,nR2,S2,nS2,cros,\[Gamma] = 3/4,mf,\[Lambda]3},
UpdateStatus["Calculating vesselness at \[Beta]= "<>ToString[\[Beta]]<>", \[Epsilon]="<>ToString[\[Epsilon]]<>" and \[Sigma]="<>ToString[\[Sigma]]];

(* Calculate Hessian derivatives *)
{Lxx,Lxy,Lyy}=If[
\[Sigma]>2,
{GaussianFilter[data,{3\[Sigma],\[Sigma]},{0,2}],
GaussianFilter[data,{3\[Sigma],\[Sigma]},{1,1}],
GaussianFilter[data,{3\[Sigma],\[Sigma]},{2,0}]},
DerivativeFilter[data,{{0,2},{1,1},{2,0}},\[Sigma]]
];

(* Calculate eigenvalues *)
\[Lambda] = Lxx+Lyy;
\[Lambda]\[Delta] = Sign[\[Lambda]]Sqrt[(2 Lxy)^2+(Lxx-Lyy)^2];
{\[Lambda]1,\[Lambda]2}=N[\[Sigma]^\[Gamma]/2]{\[Lambda]+\[Lambda]\[Delta],\[Lambda]-\[Lambda]\[Delta]};
(*\[Lambda]3=N[\[Sigma]^\[Gamma]/2]{\[Lambda]+\[Lambda]\[Delta],\[Lambda]-\[Lambda]\[Delta]};*)


(* Calculate vesselness *)
R2 =(\[Lambda]2/(\[Lambda]1 + $MachineEpsilon))^2;
nR2=-1/(2\[Beta]^2);
S2 = \[Lambda]1^2+\[Lambda]2^2;
nS2 = -1/(2 \[Epsilon]^2 Max[S2]);
cros = Abs[UnitStep[-\[Lambda]1*\[Lambda]2]*\[Lambda]1*\[Lambda]2];


Exp[nR2 R2^2](1-Exp[nS2 S2])(UnitStep[-\[Lambda]1]+UnitStep[cros-0.000005])

],
{{GaussianFilter[__],_Real,2},{DerivativeFilter[__],_Real,3}}
];


ShoujunVesselnessFilter=
Compile[
{{data,_Real,2},{\[Sigma],_Real}},
Module[
{Lxx,Lxy,Lyy,\[Lambda],\[Lambda]\[Delta],\[Lambda]1,\[Lambda]2,R2,nR2,S2,nS2,\[Gamma] = 3/4,r\[Lambda]},


(* Calculate Hessian derivatives *)
{Lxx,Lxy,Lyy}=If[
\[Sigma]>2,
{GaussianFilter[data,{3\[Sigma],\[Sigma]},{0,2}],
GaussianFilter[data,{3\[Sigma],\[Sigma]},{1,1}],
GaussianFilter[data,{3\[Sigma],\[Sigma]},{2,0}]},
DerivativeFilter[data,{{0,2},{1,1},{2,0}},\[Sigma]]
];

(* Calculate eigenvalues *)
\[Lambda] = Lxx+Lyy;
\[Lambda]\[Delta] = Sign[\[Lambda]]Sqrt[(2 Lxy)^2+(Lxx-Lyy)^2];
{\[Lambda]1,\[Lambda]2}=N[\[Sigma]^2/2]{\[Lambda]+\[Lambda]\[Delta],\[Lambda]-\[Lambda]\[Delta]};

r\[Lambda] = -Sqrt[2\[Pi] \[Sigma]];

UnitStep[-\[Lambda]1+r\[Lambda]]*Log[Abs[\[Lambda]1]]


],
{{GaussianFilter[__],_Real,2},{DerivativeFilter[__],_Real,3}}
];


(* ::Subsection:: *)
(*Postprocessing*)


LocalThresholding[im_,\[Sigma]_,mask_]:= Module[{blur,us,mc}, (*Local thresholding by comparing with the gaussian blurred image*)
	UpdateStatus["Applying local threshold..."];
	blur = GaussianFilter[im*mask,\[Sigma],{0,0}];
	us = UnitStep[im-2*blur]*mask(*Volgende berekening is een test*)
	(*us = UnitStep[im-blur-0.1]*mask*)
];


DeleteSmallStructures[im_,size_] := Module[{}, (*Delete structues that are smaller in size than a certain threshold*)
	UpdateStatus["Deleting small components..."];
	MorphologicalComponents[DeleteSmallComponents[Image@im,size]]
];


DeleteNoiseandElongationWerkend[im_,\[Sigma]_,compsize_,elongation_,cl_]:=Module[{cmp,cmpcount,cmpelongation,ruleset,small,small2,c,meas,elongated},
	UpdateStatus["Deleting noisy and non-elongated structures..."];
	cmp = ComponentMeasurements[im ,"BoundingBox"]; (*Calculate boundingbox to take out seperate components*)
	cmpcount = ComponentMeasurements[im ,"Count"]; 
	cmpelongation = ComponentMeasurements[im ,"Elongation"];
	ruleset = Table[
		small  =(im)[[Round@(Dimensions[im][[1]]-cmp[[x,2,2,2]]+1);;Round@(Dimensions[im][[1]]-cmp[[x,2,1,2]]),Round@cmp[[x,2,1,1]]+1;;Round@cmp[[x,2,2,1]]]];
		small2 = ArrayPad[ImageData@Binarize[small//Image,{cmp[[x,1]],cmp[[x,1]]}],20];
		c = Closing[Image@small2,\[Sigma]];
		meas = (c//ImageData//Flatten//Total)/(small2//Flatten//Total)//N;
		If[cmpcount[[x,2]]<compsize,If[cmpelongation[[x,2]]>elongation,elongated=True,elongated=False],elongated = True];
		If[meas<cl&&elongated,{cmp[[x,1]],1},{cmp[[x,1]],0}]
	,{x,1,Length[cmp],1}];

	im/.Dispatch[Apply[Rule,ruleset,{1}]]
]


DeleteNoiseandElongation[im_,\[Sigma]_,compsize_,elongation_,cl_]:=Module[{cmp,cmpcount,cmpelongation,ruleset,small,small2,c,meas,elongated},
	UpdateStatus["Deleting noisy and non-elongated structures..."];
	cmp = ComponentMeasurements[im ,"BoundingBox"]; (*Calculate boundingbox to take out seperate components*)
	cmpcount = ComponentMeasurements[im ,"Count"]; 
	cmpelongation = ComponentMeasurements[im ,"Elongation"];
	ruleset = Table[
		small  =(im)[[Round@(Dimensions[im][[1]]-cmp[[x,2,2,2]]+1);;Round@(Dimensions[im][[1]]-cmp[[x,2,1,2]]),Round@cmp[[x,2,1,1]];;Round@cmp[[x,2,2,1]]]];
		small2 = ArrayPad[ImageData@Binarize[small//Image,{cmp[[x,1]],cmp[[x,1]]}],20];
		c = Closing[Image@small2,\[Sigma]];
		meas = (c//ImageData//Flatten//Total)/(small2//Flatten//Total)//N;
		If[cmpcount[[x,2]]<compsize,If[cmpelongation[[x,2]]>elongation,elongated=True,elongated=False],elongated = True];
		If[meas<cl&&elongated,{cmp[[x,1]],1},{cmp[[x,1]],0}]
	,{x,1,Length[cmp],1}];

	im/.Dispatch[Apply[Rule,ruleset,{1}]]
]


(* ::Section:: *)
(*Training*)


LoadTrainingImages[folder_,name_,lum_]:=Module[{LTIim,LTIref,LTImask},
	LTIim=Initialize[StringJoin[folder,"images/",name,"_training.tif"]];
	If[lum,LTIim = LuminanceCorrection[LTIim,20]];
	LTIref=Rescale[ImageData[Import[StringJoin[folder,"1st_manual/",If[name<10,"0",""]<>ToString@name,"_manual1.gif"]]][[All,All,2]]];
	LTImask=Chop@Rescale[ImageData[Import[StringJoin[folder,"mask/",If[name<10,"0",""]<>ToString@name,"_training_mask.gif"]]][[All,All,2]]];
	{LTIim,LTIref,LTImask}
]


LoadTrainingImagesLarge[fname_,refname_,lum_]:=Module[{LTIim,LTIref,LTImask},
	LTIim=Initialize[fname];
	If[lum,LTIim = LuminanceCorrection[LTIim,20]];
	LTIref=Initialize[refname];
	LTImask=CreateMask[LTIim];
	{LTIim,LTIref,LTImask}
]


LoadTrainingImagesLargesubimage[fname_,refname_,lum_]:=Module[{LTIim,LTIref,LTImask},
	LTIim=Initialize[fname][[500;;2000,500;;2000]];(*!!!!!TERUG AANPASSEN!!!!!*)
	If[lum,LTIim = LuminanceCorrection[LTIim,20]];
	LTIref=Initialize[refname][[500;;2000,500;;2000]];(*!!!!!TERUG AANPASSEN!!!!!*)
	(*LTImask=CreateMask[LTIim];*)(*!!!!!TERUG AANPASSEN!!!!!*)
	LTImask = ConstantArray[1,Dimensions[LTIim]];(*!!!!!TERUG AANPASSEN!!!!!*)
	{LTIim,LTIref,LTImask}
]


CreateTrainingSamplematrix[CTSim_,CTSref_,CTSmask_,CTSGray_,CTS\[Sigma]_List,CTStype_]:=Module[{pos,vesselpos,nonvesselpos,mask,im,size=50,imgs,vessel,nonvessel},
	mask = CTSmask;(*mask = CreateMask[CTSim];*) (*!!!!!TERUG AANPASSEN!!!!!*)
	pos = Position[Flatten@CTSmask,_?(#>0&)][[All,1]];
	vesselpos= Flatten[Position[Flatten[ CTSref][[pos]],_?(#>0&)]];
	nonvesselpos= Flatten[Position[Flatten[(1-CTSref)][[pos]]*Flatten[CTSmask][[pos]],_?(#>0&)]];

	im=PadImage[(mask*CTSim),20,mask,5,size];
	im=im[[Range[(size+1),Dimensions[im][[1]]-size],Range[(size+1),Dimensions[im][[2]]-size]]];

(*	If[CTStype=="Gabor",*)
		imgs =Map[Flatten[GaborResponse[im,#,4,{0,3},CTSmask]][[pos]]&,CTS\[Sigma]];
(*,
		If[CTStype=="Vesselness",imgs = Map[Flatten[V[0.5,0.05,mask,#][CTSim+1-mask]][[pos]]&,CTS\[Sigma]];
	,Print@"Unknown type"]];*)
	If[CTSGray,imgs = Prepend[imgs,Flatten[im][[pos]]]];
	imgs =NormalizeFeatures[imgs,imgs];
	vessel = Transpose[Table[imgs[[i]][[vesselpos]],{i,1,Length[imgs]}]];
	nonvessel =  Transpose[Table[imgs[[i]][[nonvesselpos]],{i,1,Length[imgs]}]];
	{vessel,nonvessel}
]


CreateTrainingSamplematrixsubimage[CTSim_,CTSref_,CTSmask_,CTSGray_,CTS\[Sigma]_List,CTStype_]:=Module[{pos,vesselpos,nonvesselpos,mask,im,size=50,imgs,vessel,nonvessel},
	mask = CTSmask;(*mask = CreateMask[CTSim];*) (*!!!!!TERUG AANPASSEN!!!!!*)
	pos = Position[Flatten@CTSmask,_?(#>0&)][[All,1]];
	vesselpos= Flatten[Position[Flatten[ CTSref][[pos]],_?(#>0&)]];
	nonvesselpos= Flatten[Position[Flatten[(1-CTSref)][[pos]]*Flatten[CTSmask][[pos]],_?(#>0&)]];
	im = CTSim;  (*!!!!!TERUG AANPASSEN!!!!!*)
(*	im=PadImage[(mask*CTSim),20,mask,5,size];
	im=im[[Range[(size+1),Dimensions[im][[1]]-size],Range[(size+1),Dimensions[im][[2]]-size]]];*) (*!!!!!TERUG AANPASSEN!!!!!*)

(*	If[CTStype=="Gabor",*)
		imgs =Map[Flatten[GaborResponse[im,#,4,{0,3},CTSmask]][[pos]]&,CTS\[Sigma]];
(*,
		If[CTStype=="Vesselness",imgs = Map[Flatten[V[0.5,0.05,mask,#][CTSim+1-mask]][[pos]]&,CTS\[Sigma]];
	,Print@"Unknown type"]];*)
	If[CTSGray,imgs = Prepend[imgs,Flatten[im][[pos]]]];
	imgs =NormalizeFeatures[imgs,imgs];
	vessel = Transpose[Table[imgs[[i]][[vesselpos]],{i,1,Length[imgs]}]];
	nonvessel =  Transpose[Table[imgs[[i]][[nonvesselpos]],{i,1,Length[imgs]}]];
	{vessel,nonvessel}
]


NormalizeFeatures[feat_,flatfeat_]:=Module[{Tflatfeat = Transpose@flatfeat,\[Mu],\[Sigma]},
	\[Mu] =  Mean[Tflatfeat];
	\[Sigma] = StandardDeviation[Tflatfeat];
	Transpose[(#-\[Mu])/\[Sigma]&/@Transpose[feat]]
];


LoadTrainingSet[start_,end_,{gray_,\[Sigma]_List,lum_,type_String}]:=Module[{vessel = {},rest = {},trainim,trainref,trainmask,v,r,randindex,priors},
	PrintTemporary[Framed[Row[{ProgressIndicator[Dynamic@LTS,{start,end}],LTS=start;(Dynamic[" "<>ToString[Round[(LTS-start)/(end-start+1)*100]]<>"%"])}]]];
	Table[
		{trainim,trainref,trainmask} = LoadTrainingImages["D:/Documents/Dropbox/Mathematica/DRIVE/training/",LTS,lum];
		{v,r} = CreateTrainingSamplematrix[trainim,trainref,trainmask,gray,\[Sigma],type];
		vessel = Join[vessel,v];
		rest = Join[rest,r];
		Print[LTS];
	,{LTS,start,end}];
	priors = {Length[vessel],Length[rest]}/(Length[vessel]+Length[rest])//N;

	If[Length[rest] >5000000,
		randindex= RandomSample[Range[Length[rest]],5000000];
		rest = Table[rest[[randindex[[i]]]],{i,1,5000000}];
	];
	
	If[Length[vessel] >5000000,
		randindex= RandomSample[Range[Length[vessel]],5000000];
		vessel = Table[vessel[[randindex[[i]]]],{i,1,5000000}];
	];
	
	{vessel,rest,priors}
]


LoadTrainingSetLarge[fnames_,refnames_,{gray_,\[Sigma]_List,lum_,type_String}]:=Module[{vessel = {},rest = {},vessellength=0,restlength=0,trainim,trainref,trainmask,v,r,randindex,priors},
	(*PrintTemporary[Framed[Row[{ProgressIndicator[Dynamic@LTS,{start,end}],LTS=start;(Dynamic[" "<>ToString[Round[(LTS-start)/(end-start+1)*100]]<>"%"])}]]];*)
Table[
		UpdateStatus[fnames[[LTS]]];
		Print@fnames[[LTS]];
		{trainim,trainref,trainmask} = LoadTrainingImagesLarge[fnames[[LTS]],refnames[[LTS]],lum];
		{v,r} = CreateTrainingSamplematrix[trainim,trainref,trainmask,gray,\[Sigma],type];
		vessellength +=Length[v];
		restlength += Length[r]; 
		If[Length[r] >1000000,
			randindex= RandomSample[Range[Length[r]],1000000];
			r = Table[r[[randindex[[i]]]],{i,1,1000000}];
		];

		If[Length[v] > 1000000,
			randindex= RandomSample[Range[Length[v]],1000000];
			v = Table[v[[randindex[[i]]]],{i,1,1000000}];
		];

		Print[MemoryInUse[]/1000000//N];
		vessel = Join[vessel,v];
		rest = Join[rest,r];
		Export["temp_15images_"<>ToString@{gray,\[Sigma],lum,type}<>"_"<>ToString[LTS]<>".h5",{vessel,rest,{vessellength,restlength},\[Sigma]},{"Datasets",{"vessel","rest","priors","feat"}}];
	,{LTS,1,Length[fnames]}];
	priors = {vessellength,restlength}/(vessellength+restlength)//N;

	If[Length[rest] >15000000,
		randindex= RandomSample[Range[Length[rest]],15000000];
		rest = Table[rest[[randindex[[i]]]],{i,1,15000000}];
	];

	If[Length[vessel] > 15000000,
		randindex= RandomSample[Range[Length[vessel]],15000000];
		vessel = Table[vessel[[randindex[[i]]]],{i,1,15000000}];
	];
	
	{vessel,rest,priors}
]


LoadTrainingSetLarge2[fnames_,refnames_,{gray_,\[Sigma]_List,lum_,type_String}]:=Module[{vessel = {},rest = {},trainim,trainref,trainmask,v,r,randindex,priors},
	(*PrintTemporary[Framed[Row[{ProgressIndicator[Dynamic@LTS,{start,end}],LTS=start;(Dynamic[" "<>ToString[Round[(LTS-start)/(end-start+1)*100]]<>"%"])}]]];*)
Table[
		UpdateStatus[fnames[[LTS]]];
		Print@fnames[[LTS]];
		{trainim,trainref,trainmask} = LoadTrainingImagesLarge[fnames[[LTS]],refnames[[LTS]],lum];
		{v,r} = CreateTrainingSamplematrix[trainim,trainref,trainmask,gray,\[Sigma],type];
		vessel = Join[vessel,v];
		rest = Join[rest,r];
	,{LTS,1,Length[fnames]}];
	priors = {Length[vessel],Length[rest]}/(Length[vessel]+Length[rest])//N;

	If[Length[rest] >5000000,
		randindex= RandomSample[Range[Length[rest]],2000000];
		rest = Table[rest[[randindex[[i]]]],{i,1,2000000}];
	];

	If[Length[vessel] > 5000000,
		randindex= RandomSample[Range[Length[vessel]],2000000];
		vessel = Table[vessel[[randindex[[i]]]],{i,1,2000000}];
	];
	
	{vessel,rest,priors}
]


(* ::Section::Closed:: *)
(*Create GMM*)


CreateGMM[k_,samplematrix_,maxiterations_,savename_,loadname_]:=Module[{tmp=0,nsamples,nfeatures,randindex,scale=1000,gaussians,\[Epsilon]=0.0001,T,iterations=0,minvar=(1/(10*k))^2,Q=-1*10^10,difference,condlimit=10^7},
	{nsamples,nfeatures}=Dimensions[samplematrix];
	randindex= RandomSample[Range[nsamples],k];
	gaussians = Transpose[{Table[samplematrix[[randindex[[i]],All]],{i,1,k}],ConstantArray[1/k,{k}], Table[IdentityMatrix[nfeatures]*scale,{k}]}];
	T=\[Epsilon]*nsamples;
	difference = T+1;
	If[loadname!="",{iterations,difference,gaussians,Q} = ToExpression@Import[NotebookDirectory[]<>loadname]];
	PrintTemporary[Framed[Row[{ProgressIndicator[Dynamic@iterations,{0,maxiterations}],Dynamic[" "<>ToString[Round[((iterations)/(maxiterations)*100)]]<>"%"]}]]];

	While[tmp<2\[Or](difference>T\[And]iterations<maxiterations),
		Print@"Hij doet het";
		tmp+=1;
		iterations +=1;
		{difference,gaussians,Q} = CalculateNewParameters[gaussians,nsamples,nfeatures,samplematrix,Q,condlimit];
		PrintTemporary[iterations];
		If[savename!="",Export[NotebookDirectory[]<>savename,{iterations,difference,gaussians,Q},"String"]];
	];

	Print[StringJoin["Iterations used: ",ToString[iterations]]];
	gaussians
];


pdf[g_,nfeatures_,samplematrix_]:=Module[{func,z},
	func =PDF[MultinormalDistribution[g[[1]],g[[3]]],Map[z[#]&,Range@nfeatures]]*g[[2]];
	func/.Map[Rule[z[#],samplematrix[[All,#]]]&,Range@nfeatures]
];


ExpectedLogLikelihood[p_,g_]:=Module[{llh},
	llh=Dot[p,Map[If[#>0,Log[#],0]&,p]]
];


CalculateNewParameters[gaussians_,nsamples_,nfeatures_,samplematrix_,Q_,condlimit_] :=Module[{difference,gaussiansold,p,expectedloglikelihood,tot,sampleprob,somaprob,a},
	gaussiansold = gaussians;
	p=Map[pdf[#,nfeatures,samplematrix]&,gaussians,{1}];
	expectedloglikelihood=Total[Map[ExpectedLogLikelihood[#,gaussians]&,Transpose@p,{1}]];

	(*p = Transpose@Map[# /Total[#]&,Transpose@p];*)
	p = Transpose@Map[(tot =Total[#];If[tot!=0, # /tot,ConstantArray[1/Dimensions[gaussiansold][[1]],{Dimensions[gaussiansold][[1]]}]])&,Transpose@p];

	Table[
		UpdateStatus["Currently at:"<>ToString[i]];
		somaprob = Total[p[[i,All]]];
		gaussiansold[[i,3]] =Total[MapIndexed[{a=#1-gaussiansold[[i,1]],p[[i,#2[[1]]]]KroneckerProduct[a,a]}&,samplematrix]][[2]]/somaprob;
		gaussiansold[[i,1]]= Dot[p[[i,All]],samplematrix]/somaprob;
		gaussiansold[[i,2]]=somaprob/nsamples;
	,{i,1,Dimensions[gaussiansold][[1]]}];
	
	difference = Abs[expectedloglikelihood-Q];
	gaussiansold=Delete[gaussiansold,Position[gaussiansold[[All,3]],_?(LinearAlgebra`MatrixConditionNumber@#>condlimit&),3]];
	{difference,gaussiansold,expectedloglikelihood}
];


(* ::Section:: *)
(*Segment Image*)


CreateSamplematrix[CSim_,{CSGray_,CS\[Sigma]_List,CSlum_,CStype_},mask_]:=
	Module[{im,pos,imgspos,size=50,lim,imgs,vessel,nonvessel},
		If[CSlum,lim = LuminanceCorrection[CSim,20],lim=CSim]; (*Correct for luminance if needed*)
		pim=PadImage[(mask*lim),20,mask,5,size]; (*Pad image*)
		If[NumericQ[Max@pim],im=pim[[Range[(size+1),Dimensions[pim][[1]]-size],Range[(size+1),Dimensions[pim][[2]]-size]]],im=lim]; (*Delete padding but containing the padded part*)
		pos = Flatten@Position[Flatten@Round@mask,1]; (*Positions of the mask*)

		(*If[CStype=="Gabor",Print@"gyes",Print@"gno"];*)

		(*If[CStype=="Gabor", (*Calculate the image features*)
			imgs =Map[Flatten[GaborResponse[im,#,4,{0,3},mask]]&,CS\[Sigma]];Print@"po";, 
			If[CStype=="Vesselness",imgs = Map[Flatten[V[0.5,0.2,mask,#][im]]&,CS\[Sigma]];
		,Print@"Unknown type"]];*)
		
		imgs =Map[Flatten[GaborResponse[im,#,4,{0,3},mask]]&,CS\[Sigma]];

		If[CSGray,imgs = Prepend[imgs,Flatten@(im*mask)]]; (*Append the grey values if desired*)

		imgspos = Map[#[[pos]]&,imgs]; 

		imgs = NormalizeFeatures[imgs,imgspos]; (*Normalize features at the positions*)

		imgs = Map[ListToMatrix[#,Dimensions[CSim][[1]],Dimensions[CSim][[2]]]&,imgs]
]


(*ClassImage[gaussians_,samplematrix_,prior_]:=Module[{class ,z,nfeat=Dimensions[gaussians[[1,1]]][[1]]},
	class = Total[ Map[#[[2]]*PDF[MultinormalDistribution[#[[1]],#[[3]]],Map[z[#]&,Range[nfeat]]]&,gaussians]];
	class = (class/.Map[Rule[z[#],samplematrix[[#]]]&,Range[nfeat]])*prior (**)
]*)


ClassImage = Compile[{{samplematrix,_Real,3},{gaussian,_Real,2},{cov,_Real,3},{weight,_Real,1},{prior,_Real}},Module[{xminmu,constant,inv},
	Plus@@Table[
		inv = Inverse[cov[[i]]];
		xminmu=Transpose[ samplematrix-gaussian[[i]],{3,1,2}];
		constant = prior*weight[[i]]*1/((2\[Pi])^(Length[gaussian[[i]]]/2)*Det[cov[[i]]]^(1/2));
		constant*Exp[-0.5Map[#.inv.#&,xminmu,{2}] ],{i,1,Length[gaussian]}]
]];


SegmentImage[SIim_,{SIgvessel_,SIgrest_,SIprior_,{SIgray_,SI\[Sigma]_,SIlum_,SItype_}},mask_]:=Module[{grest=Transpose[SIgrest],gvessel=Transpose[SIgvessel],samplematrix,vesselclass,restclass,imsegm,postprob},

	UpdateStatus["Calculating SampleMatrix..."];
	samplematrix = CreateSamplematrix[SIim,{SIgray,SI\[Sigma],SIlum,SItype},mask];
	UpdateStatus["Calculating vessel class probabilities..."];
	vesselclass = ClassImage[samplematrix,gvessel[[1]],gvessel[[3]],gvessel[[2]],SIprior[[1]]];
	UpdateStatus["Calculating rest class probabilities..."];
	restclass = ClassImage[samplematrix,grest[[1]],grest[[3]],grest[[2]],SIprior[[2]]];
	UpdateStatus["Segmenting image..."];
	imsegm = UnitStep[vesselclass-restclass];
	UpdateStatus["Done..."];
	imsegm
	(*postprob = vesselclass/(vesselclass+restclass);*)
	(*UpdateStatus["Done..."];
	{imsegm,postprob}*)
];


(* ::Section::Closed:: *)
(*Features*)


FractalDimensionBoxcounting[FDBim_,FDBdiskcenter_:{0,0},FDBr_:0,FDBdisk_:0]:=Module[{data,fit,maxR,disk,disk2,x,im=FDBim},	
	UpdateStatus["Calculating fractal dimension - Box-counting..."];
	If[FDBr>0,
		maxR=Min@{Round[FDBr],Round@FDBdiskcenter,Dimensions[FDBim]-FDBdiskcenter};
		disk=ArrayPad[RotateLeft[DiskMatrix[maxR,Dimensions[FDBim]+2maxR],Round[Dimensions[FDBim]/2-{FDBdiskcenter[[1]],FDBdiskcenter[[2]]}]],-maxR];
		If[FDBdisk>0,disk2=ArrayPad[RotateLeft[DiskMatrix[FDBdisk,Dimensions[FDBim]+2maxR],Round[Dimensions[FDBim]/2-{FDBdiskcenter[[1]],FDBdiskcenter[[2]]}]],-maxR],disk2=ConstantArray[0,Dimensions[FDBim]]];
		im=UnitStep[ImageData[ImageCrop[Image[FDBim*disk+disk-disk2]]]-1.1];
	];

		data=Table[{Log[1/x],Log[Total@UnitStep[Map[Total,Flatten[Partition[im,{x,x}],1],2]-0.1]]},{x,NestWhileList[#*2&,1,#<Min@Dimensions[im]/2&]}];
		fit=LinearModelFit[data,x,x];
		{fit[[1,2,2]],fit,fit["RSquared"],data}
];


FractalDimensionDilation[FDDim_,FDDmaxdilation_:40,FDDdiskcenter_:{0,0},FDDr_:0,FDDdisk_:0]:=Module[{data,fit,maxR,disk,disk2,x,im=FDDim},
	UpdateStatus["Calculating fractal dimension - Dilation..."];
	If[FDDr>0,
		maxR=Min@{Round[FDDr],Round@FDDdiskcenter,Dimensions[FDDim]-FDDdiskcenter};
		disk=ArrayPad[RotateLeft[DiskMatrix[maxR,Dimensions[FDDim]+2maxR],Round[Dimensions[FDDim]/2-{FDDdiskcenter[[1]],FDDdiskcenter[[2]]}]],-maxR];
		If[FDDdisk>0,disk2=ArrayPad[RotateLeft[DiskMatrix[FDDdisk,Dimensions[FDDim]+2maxR],Round[Dimensions[FDDim]/2-{FDDdiskcenter[[1]],FDDdiskcenter[[2]]}]],-maxR],disk2=ConstantArray[0,Dimensions[FDDim]]];
		im=UnitStep[ImageData[ImageCrop[Image[FDDim*disk+disk-disk2]]]-1.1];
	];
	
	(*data =Table[{Log@r,Log@Count[Flatten@Dilate[im,DiskMatrix[r]],1.]},{r,5,FDDmaxdilation,5}];(*Dilate images and count nr of pixels.*)*) (*Slow version*)
	data =Table[{Log@r,Log@Count[UnitStep[ListConvolve[DiskMatrix[r],im,Round[Dimensions[DiskMatrix[r]]/2]]-0.1],1,{2}]},{r,5,FDDmaxdilation,5}];
	fit = LinearModelFit[data,x,x];(*Fit parameters*)
	
	{2-fit[[1,2,2]],fit,fit["RSquared"],data}(*Gives the fractal dimension*)
	
];


FractalDimensionMass[FDMim_,FDMpoint_,FDMextrainf_:False]:=Module[{data,fit,im=FDMim,maxR,x},
	UpdateStatus["Calculating fractal dimension - Mass-radius..."];
	maxR = Min@{FDMpoint,Dimensions[FDMim]-FDMpoint}; (*Maximum radius that can be used without falling out of the image*)
	data = Table[
		{r,Total[Flatten[im*ArrayPad[RotateLeft[DiskMatrix[r,Dimensions[im]+2r],Round[Dimensions[im]/2-{FDMpoint[[1]],FDMpoint[[2]]}]],-r]]]}
			,{r,200,maxR,100}]; (*Number of pixels within circles.*)
	data = Log@DeleteCases[data,_?(MemberQ[#,0]&),{1}]; (*Delete radii (circles) containing zero pixels*)
	fit = LinearModelFit[data,x,x];(*Fit parameters*)
	(*{{fit[[1]],fit[[2,1]]},Log@data,ImagePlot[FDMim,Epilog->{Thick ,Red,Table[Circle[FDMpoint,r],{r,50,maxR,100}]}]}*)(*Gives all output*)
	(*{fit[[2,1]],ImagePlot[FDMim,Epilog->{Thick ,Red,Table[Circle[FDMpoint,r],{r,50,maxR,100}]}]}(*Gives the fractal dimension and image back*)*)
(*	If[FDMextrainf,{fit[[1,2,2]],fit[[1,2,1]],Log@data,"\!\(\*SuperscriptBox[\(R\), \(2\)]\) = "<>ToString@fit["RSquared"],ImagePlot[FDMim,Epilog->{Thick ,Red,Table[Circle[FDMpoint,r],{r,50,maxR,100}]}]},{fit[[1,2,2]],"\!\(\*SuperscriptBox[\(R\), \(2\)]\) = "<>ToString@fit["RSquared"]}]*)
	If[FDMextrainf,{fit[[1,2,2]],fit,fit["RSquared"],data,ImagePlot[FDMim,Epilog->{Thick ,Red,Table[Circle[FDMpoint,r],{r,50,maxR,100}]}]},{fit[[1,2,2]],fit,fit["RSquared"],data}]
];


FractalDimensionMass2[FDMim_,FDMpoint_,FDMr_]:=Module[{data,fit,im=FDMim,maxR,x},
	UpdateStatus["Calculating fractal dimension - Mass-radius..."];
	maxR = Min@{FDMpoint,Round@FDMr,Dimensions[FDMim]-FDMpoint}; (*Maximum radius that can be used without falling out of the image*)
	
	data = Table[
		{r,Total[Flatten[im*ArrayPad[RotateLeft[DiskMatrix[r,Dimensions[im]+2r],Round[Dimensions[im]/2-{FDMpoint[[1]],FDMpoint[[2]]}]],-r]]]}
			,{r,200,maxR,100}]; (*Number of pixels within circles.*)
	data = Log@DeleteCases[data,_?(MemberQ[#,0]&),{1}]; (*Delete radii (circles) containing zero pixels*)
	fit = LinearModelFit[data,x,x];(*Fit parameters*)
	{fit[[1,2,2]],fit,fit["RSquared"],data,ImagePlot[FDMim,Epilog->{Thick ,Red,Table[Circle[FDMpoint,r],{r,50,maxR,100}]}]}
];


FractalDimensionCorrelation[FDCim_,FDCdiskcenter_:{0,0},FDCr_:0,FDCdisk_:0]:=Module[{data,fit,maxR,disk,disk2,x,im=FDCim, dim = Dimensions[FDCim],nr},
	UpdateStatus["Calculating fractal dimension - Correlation..."];
	If[FDCr>0,
		maxR=Min@{Round[FDCr],Round@FDCdiskcenter,dim-FDCdiskcenter};
		disk=ArrayPad[RotateLeft[DiskMatrix[maxR,dim+2maxR],Round[dim/2-{FDCdiskcenter[[1]],FDCdiskcenter[[2]]}]],-maxR];
		If[FDCdisk>0,disk2=ArrayPad[RotateLeft[DiskMatrix[FDCdisk,Dimensions[FDCim]+2maxR],Round[dim/2-{FDCdiskcenter[[1]],FDCdiskcenter[[2]]}]],-maxR],disk2=ConstantArray[0,dim]];
		im=UnitStep[ImageData[ImageCrop[Image[FDCim*disk+disk-disk2]]]-1.1];
	];
	
	nr = Times@@dim;
	data =Table[{Log@r,Log@N[(Total[ ListConvolve[DiskMatrix[r],FDCim,{r,r}]*FDCim,2]/2)]},{r,{1,2,4,8,16,32,64,128,256}}];(*Exclude i=j: - Times@@dim*)
	fit = LinearModelFit[data,x,x];(*Fit parameters*)
	
	{fit[[1,2,2]],fit,fit["RSquared"],data}(*Gives the fractal dimension*)
	
];


MethodAccuracy[im_,mask_,ref_]:=Module[{tmp,TP=0,TN=0,FP=0,FN=0}, (*Calculate accuracy parameters*)
	tmp = (3(Round@ref+1)-(Round@im+1))*mask; (*Gives every pixel a different number representing 4=TP, 5=FN,1=FP,2=TN*)
	{FP,TN,TP,FN}= Sort[Tally[Flatten@Join@{tmp,{0,1,2,4,5}}]][[2;;5,2]]-1; (*Ad additional numbers to make sure every number is present to prevent errors and subtract in the end*)
	{1-FP/(TN+FP), TP/(TP+FN+$MachineEpsilon),(TN+TP)/(TP+TN+FP+FN)}//N (*Specificity,Sensitivity, Accuracy*)
];


(* ::Section:: *)
(*Other*)


LuminanceCorrection[im_,\[Sigma]_]:=Module[{filt,m,coco}, (*Correct for the luminance *)
	UpdateStatus["Correcting luminance..."];
	filt = ImageData[MedianFilter[Image@im,\[Sigma]]]*Erode[CreateMask[im],7];
	(*Derive lumination by blurring at a large scale and correcting every pixel to the max of this luminance map*)
	coco = Map[m = Max@filt;If[#>0,m/#,0]&,filt,{2}];
	Rescale@-(im * coco)
];


ListToMatrix[im_,x_,y_]:=Partition[Partition[im,y],x][[1]];(*Transform a list to a matrix*)
ListToMatrix[im_,{x_,y_}]:=Partition[Partition[im,y],x][[1]]; (*Transform a list to a matrix*)


OpticDisk[ODim_,VisSize_:500] :=DynamicModule[{ ODpt,ODr,pt}, (*Show the optic disk selector using a locatorpane*)
	ODpt = Dynamic[{Dimensions[ODim][[1]]-pt[[2]],pt[[1]]}]; (*Center of optic disk*)
	ODr = Round[Dimensions[ODim][[2]]/20]; (*Radius of optic disk*)
	Panel@Column@{LocatorPane[Dynamic[pt],Show[{RasterPlot[ODim,Frame->False],Graphics[{Opacity[0.4],Green,Disk[Dynamic@pt,Dynamic[ODr]]}]},ImageSize->{VisSize}],Appearance->Graphics[{Red,Disk[{200,200},1]},ImageSize->1]],Panel[Row[{Slider[Dynamic[ODr],{10,Round[Dimensions[ODim][[1]]/2],1},ImageSize->VisSize-120],Dynamic@{Round@ODpt[[1]],ODr}},ImageSize->VisSize]]} (*Locatorpane with optic disk*)
]


Options[ImagePlot]={PlotRange->Automatic,ImageSize->Large,Epilog->{}};  (*Plot an image with epilog working as expected*)
ImagePlot[image_,OptionsPattern[]]:=Show[{Image[Rescale[image,If[OptionValue[PlotRange]===Automatic,Through[{Min,Max}@image],OptionValue@PlotRange]],ImageSize->OptionValue@ImageSize],Graphics[GeometricTransformation[OptionValue@Epilog,{{{0,1},{-1,0}},{-.5,Dimensions[image][[1]]+.5}}]]}];


Erode[im_List,p_]:=ImageData@Erosion[Image@im,DiskMatrix@p]; (*Erosion for lists*)


Dilate[im_List,p_]:=ImageData@Dilation[Image@im,p]; (*Dilation for lists*)


ClosingIm[im_List,p_]:=ImageData@Closing[Image@im,DiskMatrix@p]; (*Closing for lists*)


OpeningIm[im_List,p_]:=ImageData@Opening[Image@im,DiskMatrix@p]; (*Opening for lists*)


(* ::Section::Closed:: *)
(*Rest*)


End[];


UpdateStatus[mes_]:=message=mes;
blauw = RGBColor[50/255,125/255,200/255];
donkerblauw = RGBColor[30/255,80/255,130/255];
kleur2 = RGBColor[55/255,128/255,200/255];


Protect@@Names["Retina`*"];


Unprotect[message];
Unprotect[kleur];
Unprotect[ODr];


EndPackage[ ]



