(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    101167,       2468]
NotebookOptionsPosition[     51585,       1404]
NotebookOutlinePosition[     98478,       2394]
CellTagsIndexPosition[     98435,       2391]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
 "ActiveContour",
 StyleBox[" ",
  FontColor->RGBColor[1, 0, 1]],
 "Package"
}], "Title",
 CellChangeTimes->{{3.488872095304613*^9, 3.4888720955570097`*^9}}],

Cell["\<\
Erik Pelgrim, Markus van Almsick, Hans van Assen
\[Copyright]2008 TU Eindhoven\
\>", "Subsubtitle",
 CellChangeTimes->{{3.435653884731786*^9, 3.43565390483914*^9}}],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\[IndentingNewLine]", 
   "\n", 
   RowBox[{
    RowBox[{
     RowBox[{
     "TimeStamp", "[", "\"\<MathVisionTools`ActiveContour`\>\"", "]"}], " ", 
     "=", " ", 
     RowBox[{"{", 
      RowBox[{"2008", ",", "11", ",", "14", ",", "12", ",", "0", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput",
 CellChangeTimes->{{3.43564934582205*^9, 3.4356493506577063`*^9}}],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`ActiveContour`"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Author", ":", " ", 
      RowBox[{"Erik", " ", "Pelgrim"}]}]}], ",", " ", 
    RowBox[{"Markus", " ", "van", " ", "Almsick"}], ",", " ", 
    RowBox[{"and", " ", "Hans", " ", "van", " ", "Assen"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"m", ".", "v", ".", 
       RowBox[{"almsick", "@", "tue"}], ".", "nl"}]}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`ActiveContour`"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "1.0"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", 
      RowBox[{"6.0", " ", "or", " ", "higher"}]}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2007"}]}]}], ",", " ", 
    RowBox[{"Markus", " ", "van", " ", "Almsick"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "ActiveContour"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "active", " ", "contours", " ", "in", " ", 
      "2", 
      RowBox[{"D", "."}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", 
      RowBox[{"active", " ", "contour"}]}]}], ",", " ", "snake", ",", " ", 
    "splines"}], " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Warning", ":", " ", 
     RowBox[{"None", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"Decemeber", " ", "2007"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":", " ", 
     RowBox[{
     "highly", " ", "dependent", " ", "on", " ", "the", " ", "Splines`", " ", 
      
      RowBox[{"packages", "."}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.435649900201017*^9, 3.4356499078070374`*^9}, {
  3.435653054474843*^9, 3.435653059764864*^9}, {3.435925649239369*^9, 
  3.435925660538353*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeginPackage", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<MathVisionTools`ActiveContour`\>\"", ",", " ", 
    RowBox[{"{", "\"\<Splines`\>\"", "}"}]}], "\[IndentingNewLine]", "]"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{
   "ActiveContour", ",", "ActiveContourStep", ",", " ", "ActiveContourPlot", 
    ",", "CubicLoop", ",", "SplineLength", ",", "ApproximationOrder"}], "]"}],
   ";"}]}], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.4356493591041927`*^9, 3.435649385088579*^9}, 
   3.4356496525668287`*^9, 3.435654021968498*^9, {3.4356544870942593`*^9, 
   3.43565449747421*^9}, 3.435749940945112*^9, {3.435995317151505*^9, 
   3.435995322342567*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CubicLoop", "::", "usage"}], "=", 
  "\"\<CubicLoop is a setting specifying the type of spline generated by \
Spline and SplineFit.\>\""}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.435649407224173*^9, 3.4356494220081673`*^9}, {
   3.435649456500287*^9, 3.435649560663575*^9}, {3.4356497180987*^9, 
   3.435649781977086*^9}, 3.4356541419636097`*^9, {3.435749906470078*^9, 
   3.4357499326376543`*^9}, 3.435831581217794*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SplineLength", "::", "usage"}], " ", "=", " ", 
   "\"\<SplineLength[spline|splinefunction] renders the approximate path \
length of a cubic spline or loop given by a Spline graphic primitive or a \
SplineFunction. Use the option ApproximationOrder to determine the quality of \
the approximation.\>\""}], ";"}]], "PackageInput",
 CellChangeTimes->{{3.4359927491458197`*^9, 3.435992813300714*^9}, {
   3.4359928877646027`*^9, 3.435992903204632*^9}, 3.435993946557548*^9, {
   3.435994299380425*^9, 3.435994300149178*^9}, {3.435995492728074*^9, 
   3.435995575954627*^9}, {3.4360312065286617`*^9, 3.436031212061953*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ApproximationOrder", "::", "usage"}], " ", "=", " ", 
   "\"\<ApproximationOrder is an Option of SplineLength to determine the \
order of a spline path length approximation. Possible values are 0,1,2, and \
\[Infinity] for a numerically exact solution. The default is 2nd \
order.\>\""}], ";"}]], "PackageInput",
 CellChangeTimes->{{3.435993805080657*^9, 3.435993872416716*^9}, 
   3.435993947642797*^9, {3.435994307998036*^9, 3.4359943299456673`*^9}, {
   3.435995432114855*^9, 3.435995452840719*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ActiveContour", "::", "usage"}], "=", 
  "\"\<ActiveContour[n] < NOT YET IMPLEMENTED >.\>\""}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.435649619596157*^9, 3.43564962617953*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ActiveContourStep", "::", "usage"}], "=", 
  "\"\<ActiveContourStep[n] < NOT YET IMPLEMENTED >.\>\""}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{3.435649397995232*^9, 3.435649631302183*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ActiveContourPlot", "::", "usage"}], "=", 
  "\"\<ActiveContourPlot[n] < NOT YET IMPLEMENTED >.\>\""}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{3.435649399795362*^9, 3.435649632933975*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["SplineFit & CubicLoop", "Subsection",
 CellChangeTimes->{{3.435649671332958*^9, 3.4356497070669403`*^9}, {
  3.435749957094241*^9, 3.435749961108144*^9}}],

Cell["non-cylic case, as in FitSpline.", "Text",
 CellChangeTimes->{{3.4356499556658907`*^9, 3.435649974479589*^9}, {
  3.435653924067939*^9, 3.4356539242394857`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SplineFit", "[", 
   RowBox[{
    RowBox[{"data_List", "?", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"MatrixQ", "[", 
        RowBox[{"#1", ",", 
         RowBox[{
          RowBox[{"NumberQ", "[", 
           RowBox[{"N", "[", "#1", "]"}], "]"}], "&"}]}], "]"}], "&"}], 
      ")"}]}], ",", "Cubic"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", " ", "=", " ", 
       RowBox[{"First", "[", 
        RowBox[{"Dimensions", "[", "data", "]"}], "]"}]}], ",", "d", ",", 
      RowBox[{"b", " ", "=", 
       RowBox[{
        RowBox[{"Append", "[", 
         RowBox[{
          RowBox[{"Rest", "[", "data", " ", "]"}], ",", 
          RowBox[{"Last", "[", "data", "]"}]}], "]"}], "-", 
        RowBox[{"Prepend", "[", 
         RowBox[{
          RowBox[{"Most", "[", "data", " ", "]"}], ",", 
          RowBox[{"First", "[", "data", "]"}]}], "]"}]}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"d", " ", "=", " ", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"LinearSolve", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"SparseArray", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"Band", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"n", "-", "1"}], ",", 
                    RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}], "\[Rule]", " ",
                 "4"}], ",", " ", 
               RowBox[{
                RowBox[{"Band", "[", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "]"}], "\[Rule]", " ", 
                "1"}], ",", 
               RowBox[{
                RowBox[{"Band", "[", 
                 RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "]"}], "\[Rule]", " ", 
                "1"}], ",", " ", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", " ", "2"}], ",", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"n", ",", "n"}], "}"}], "\[Rule]", " ", "2"}]}], 
              "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "n"}], "}"}]}], "]"}], ",", "#"}], "]"}], 
         "&"}], "/@", " ", 
        RowBox[{"Transpose", "[", 
         RowBox[{"3", "b"}], "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"SplineFunction", "@@", 
      RowBox[{"{", 
       RowBox[{"Cubic", ",", 
        RowBox[{"N", "[", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"n", "-", "1"}]}], "}"}], "]"}], ",", "data", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Most", "[", 
           RowBox[{"Transpose", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"#1", ",", "#3", ",", 
               RowBox[{
                RowBox[{"3", 
                 RowBox[{"(", 
                  RowBox[{"#2", "-", "#1"}], " ", ")"}]}], " ", "-", 
                RowBox[{"2", " ", "#3"}], "-", "#4"}], ",", 
               RowBox[{
                RowBox[{"2", 
                 RowBox[{"(", 
                  RowBox[{"#1", " ", "-", " ", "#2"}], ")"}]}], " ", "+", " ",
                 "#3", "+", "#4"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}], "]"}], "&"}],
          "[", 
         RowBox[{"data", ",", 
          RowBox[{"RotateLeft", "[", "data", "]"}], ",", "d", ",", 
          RowBox[{"RotateLeft", "[", "d", "]"}]}], "]"}]}], "}"}]}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.435749981813774*^9, 3.435749984768715*^9}}],

Cell["Cyclic case :", "Text",
 CellChangeTimes->{{3.435649988422153*^9, 3.435650001752364*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Unprotect", "[", "Splines`SplineFit", "]"}], ";"}]], "PackageInput",\

 CellChangeTimes->{{3.4356545809767113`*^9, 3.435654586655931*^9}, 
   3.435750046608823*^9, 3.435830726580652*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Splines`SplineFit", "[", 
   RowBox[{
    RowBox[{"data_List", "?", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"MatrixQ", "[", 
        RowBox[{"#1", ",", 
         RowBox[{
          RowBox[{"NumberQ", "[", 
           RowBox[{"N", "[", "#1", "]"}], "]"}], "&"}]}], "]"}], "&"}], 
      ")"}]}], ",", "CubicLoop"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", " ", "=", " ", 
       RowBox[{"First", "[", 
        RowBox[{"Dimensions", "[", "data", "]"}], "]"}]}], ",", "d", ",", 
      RowBox[{"b", " ", "=", 
       RowBox[{
        RowBox[{"RotateLeft", "[", "data", "]"}], "-", 
        RowBox[{"RotateRight", "[", "data", "]"}]}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"d", " ", "=", " ", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"LinearSolve", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"SparseArray", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"Band", "[", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "1"}], "}"}], "]"}], "\[Rule]", " ", 
                "4"}], ",", " ", 
               RowBox[{
                RowBox[{"Band", "[", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "2"}], "}"}], "]"}], "\[Rule]", " ", 
                "1"}], ",", 
               RowBox[{
                RowBox[{"Band", "[", 
                 RowBox[{"{", 
                  RowBox[{"2", ",", "1"}], "}"}], "]"}], "\[Rule]", " ", 
                "1"}], ",", " ", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"n", ",", "1"}], "}"}], "\[Rule]", " ", "1"}], ",", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "n"}], "}"}], "\[Rule]", " ", "1"}]}], 
              "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "n"}], "}"}]}], "]"}], ",", "#"}], "]"}], 
         "&"}], "/@", " ", 
        RowBox[{"Transpose", "[", 
         RowBox[{"3", "b"}], "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Splines`SplineFunction", "@@", 
      RowBox[{"{", 
       RowBox[{"CubicLoop", ",", 
        RowBox[{"N", "[", 
         RowBox[{"{", 
          RowBox[{"0", ",", "n"}], "}"}], "]"}], ",", "data", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"#1", ",", "#3", ",", 
              RowBox[{
               RowBox[{"3", 
                RowBox[{"(", 
                 RowBox[{"#2", "-", "#1"}], " ", ")"}]}], " ", "-", 
               RowBox[{"2", " ", "#3"}], "-", "#4"}], ",", 
              RowBox[{
               RowBox[{"2", 
                RowBox[{"(", 
                 RowBox[{"#1", " ", "-", " ", "#2"}], ")"}]}], " ", "+", " ", 
               "#3", "+", "#4"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}], "&"}], "[", 
         RowBox[{"data", ",", 
          RowBox[{"RotateLeft", "[", "data", "]"}], ",", "d", ",", 
          RowBox[{"RotateLeft", "[", "d", "]"}]}], "]"}]}], "}"}]}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 CellChangeTimes->{{3.435649823769853*^9, 3.4356498479260883`*^9}, {
   3.435749807119281*^9, 3.43574982001169*^9}, {3.43574985795253*^9, 
   3.4357498741240797`*^9}, {3.4357608535735607`*^9, 3.4357608542511272`*^9}, 
   3.435830724847765*^9, 3.435830790670451*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Splines`Private`splineinternal", "[", 
   RowBox[{"pts_List", ",", "CubicLoop"}], "]"}], " ", ":=", "\n", "\t\t", 
  RowBox[{"Transpose", "[", 
   RowBox[{"Map", "[", 
    RowBox[{"Splines`Private`splinecoord", ",", 
     RowBox[{"Transpose", "[", "pts", "]"}]}], "]"}], "]"}]}]], "PackageInput",\

 CellChangeTimes->{{3.435848460227191*^9, 3.435848461673502*^9}, {
   3.435848506410882*^9, 3.4358485111741123`*^9}, 3.4358495189218807`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Splines`Private`evalspline", "[", 
    RowBox[{
     RowBox[{"pt_", "?", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"#", " ", "==", " ", "0"}], " ", "&"}], ")"}]}], ",", " ", 
     "CubicLoop", ",", " ", "pts_", ",", " ", "internal_"}], "]"}], " ", ":=",
    "\n", "\t", 
   RowBox[{"internal", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "All", ",", "1"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Splines`Private`evalspline", "[", 
   RowBox[{"pt_", ",", "CubicLoop", ",", "pts_", ",", "internal_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "tmp", "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "#1", ",", 
          SuperscriptBox["#1", "2"], ",", 
          SuperscriptBox["#1", "3"]}], "}"}], "&"}], ")"}], "[", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"tmp", "=", 
           RowBox[{"Mod", "[", 
            RowBox[{"pt", ",", "1"}], "]"}]}], ")"}], "\[Equal]", "0"}], ",", 
        "1", ",", "tmp"}], "]"}], "]"}], ".", 
     RowBox[{"Transpose", "[", 
      RowBox[{"internal", "\[LeftDoubleBracket]", 
       RowBox[{"Ceiling", "[", "pt", "]"}], "\[RightDoubleBracket]"}], 
      "]"}]}]}], "]"}]}]}], "PackageInput",
 CellChangeTimes->{{3.435850176435845*^9, 3.435850194961487*^9}, {
   3.4358613719891157`*^9, 3.435861417455969*^9}, 3.435863266380746*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Protect", "[", "Splines`SplineFit", "]"}], ";"}]], "PackageInput",
 CellChangeTimes->{{3.4356545809767113`*^9, 3.435654586655931*^9}, {
   3.435750038362702*^9, 3.435750049152133*^9}, 3.4358307285083237`*^9}],

Cell["Definition of cubic spline derivatives.", "Text",
 CellChangeTimes->{{3.435653450034627*^9, 3.43565347968134*^9}, 
   3.435654613008843*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Unprotect", "[", "Splines`Spline", "]"}], ";"}]], "PackageInput",
 CellChangeTimes->{{3.4356545809767113`*^9, 3.435654586655931*^9}, 
   3.43575009359473*^9, 3.43583073370861*^9}],

Cell[BoxData[
 RowBox[{"Splines`Spline", "/:", 
  RowBox[{
   RowBox[{"Derivative", "[", "1", "]"}], "[", 
   RowBox[{
    RowBox[{"Splines`Spline", "[", 
     RowBox[{"pts_List", ",", 
      RowBox[{"type", ":", 
       RowBox[{"(", 
        RowBox[{"Cubic", "|", "CubicLoop"}], ")"}]}], ",", "\n", "\t\t", 
      RowBox[{"SplineFunction", "[", 
       RowBox[{"t_", ",", "r_", ",", "cpts_", ",", "coefficients_List"}], 
       "]"}]}], "]"}], ",", "\n", "\t\t", 
    RowBox[{"opts", ":", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"_Rule", " ", "|", " ", "_RuleDelayed"}], ")"}], "..."}]}]}], 
   "]"}], " ", ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"dcoeff", ",", "ddata"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"dcoeff", "=", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], "#"}], 
            ")"}], "\[LeftDoubleBracket]", 
           RowBox[{"{", 
            RowBox[{"2", ",", "3", ",", "4", ",", "1"}], "}"}], 
           "\[RightDoubleBracket]"}], "&"}], ",", "coefficients", ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ddata", " ", "=", " ", 
       RowBox[{"Append", "[", 
        RowBox[{
         RowBox[{"dcoeff", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "All", ",", "2"}], "\[RightDoubleBracket]"}], 
         ",", 
         RowBox[{"Map", "[", 
          RowBox[{"Total", ",", 
           RowBox[{"dcoeff", "\[LeftDoubleBracket]", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "All"}], "\[RightDoubleBracket]"}]}], 
          "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Splines`Spline", "[", 
       RowBox[{"ddata", ",", "type", ",", 
        RowBox[{"Splines`SplineFunction", "@@", 
         RowBox[{"{", 
          RowBox[{"t", ",", "r", ",", "ddata", ",", "dcoeff"}], "}"}]}], ",", 
        "opts"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{
    RowBox[{"pts", " ", "===", " ", "cpts"}], " ", "&&", " ", 
    RowBox[{"type", " ", "===", " ", "t"}]}]}]}]], "PackageInput",
 CellChangeTimes->{{3.4356535018087797`*^9, 3.435653512022202*^9}, {
   3.435750218192713*^9, 3.4357504261203337`*^9}, {3.435750493604681*^9, 
   3.435750495097411*^9}, {3.435750554178925*^9, 3.435750564698998*^9}, {
   3.435750748552289*^9, 3.435750756365839*^9}, {3.435757207223304*^9, 
   3.4357573303460703`*^9}, {3.435760577041634*^9, 3.43576075772965*^9}, {
   3.435761000565716*^9, 3.4357610041087523`*^9}, {3.435761298551242*^9, 
   3.435761312208514*^9}, {3.435761410221299*^9, 3.4357614108180647`*^9}, {
   3.435761889592925*^9, 3.435761892816573*^9}, {3.435830740712207*^9, 
   3.435830749500759*^9}, 3.435830782356138*^9, {3.4358934554513187`*^9, 
   3.435893460357501*^9}}],

Cell[BoxData[
 RowBox[{"Splines`Spline", "/:", 
  RowBox[{
   RowBox[{"Derivative", "[", "2", "]"}], "[", 
   RowBox[{
    RowBox[{"Splines`Spline", "[", 
     RowBox[{"pts_List", ",", 
      RowBox[{"type", ":", 
       RowBox[{"(", 
        RowBox[{"Cubic", "|", "CubicLoop"}], ")"}]}], ",", "\n", "\t\t", 
      RowBox[{"SplineFunction", "[", 
       RowBox[{"t_", ",", "r_", ",", "cpts_", ",", "coefficients_List"}], 
       "]"}]}], "]"}], ",", "\n", "\t\t", 
    RowBox[{"opts", ":", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"_Rule", " ", "|", " ", "_RuleDelayed"}], ")"}], "..."}]}]}], 
   "]"}], " ", ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"dcoeff", ",", "ddata"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"dcoeff", "=", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", "2", ",", "6"}], "}"}], "#"}], 
            ")"}], "\[LeftDoubleBracket]", 
           RowBox[{"{", 
            RowBox[{"3", ",", "4", ",", "1", ",", "2"}], "}"}], 
           "\[RightDoubleBracket]"}], "&"}], ",", "coefficients", ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ddata", " ", "=", " ", 
       RowBox[{"Append", "[", 
        RowBox[{
         RowBox[{"dcoeff", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "All", ",", "2"}], "\[RightDoubleBracket]"}], 
         ",", 
         RowBox[{"Map", "[", 
          RowBox[{"Total", ",", 
           RowBox[{"dcoeff", "\[LeftDoubleBracket]", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "All"}], "\[RightDoubleBracket]"}]}], 
          "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Splines`Spline", "[", 
       RowBox[{"ddata", ",", "type", ",", 
        RowBox[{"Splines`SplineFunction", "@@", 
         RowBox[{"{", 
          RowBox[{"t", ",", "r", ",", "ddata", ",", "dcoeff"}], "}"}]}], ",", 
        "opts"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{
    RowBox[{"pts", " ", "===", " ", "cpts"}], " ", "&&", " ", 
    RowBox[{"type", " ", "===", " ", "t"}]}]}]}]], "PackageInput",
 CellChangeTimes->{{3.4356535018087797`*^9, 3.435653512022202*^9}, {
  3.435750218192713*^9, 3.4357504261203337`*^9}, {3.435750493604681*^9, 
  3.435750495097411*^9}, {3.435750554178925*^9, 3.435750564698998*^9}, {
  3.435750748552289*^9, 3.435750756365839*^9}, {3.435757207223304*^9, 
  3.4357573303460703`*^9}, {3.435760577041634*^9, 3.43576075772965*^9}, {
  3.435760881604828*^9, 3.435760898011857*^9}, {3.435760964119026*^9, 
  3.4357609666294947`*^9}, {3.435761014605813*^9, 3.435761030940288*^9}, {
  3.435761645785376*^9, 3.435761687207006*^9}, {3.435761748566247*^9, 
  3.435761749237422*^9}, {3.435761866450801*^9, 3.435761869296116*^9}, {
  3.4358307512916327`*^9, 3.435830801628655*^9}, {3.435893463199719*^9, 
  3.4358934655753736`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Protect", "[", "Splines`Spline", "]"}], ";"}]], "PackageInput",
 CellChangeTimes->{{3.4356545895235786`*^9, 3.43565459593534*^9}, 
   3.435750097106522*^9, 3.4358307598370123`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Unprotect", "[", "Splines`SplineFunction", "]"}], 
  ";"}]], "PackageInput",
 CellChangeTimes->{{3.4356545809767113`*^9, 3.435654586655931*^9}, 
   3.435830764869875*^9}],

Cell[BoxData[
 RowBox[{"Splines`SplineFunction", "/:", 
  RowBox[{
   RowBox[{"Derivative", "[", "1", "]"}], "[", 
   RowBox[{"Splines`SplineFunction", "[", 
    RowBox[{
     RowBox[{"type", ":", 
      RowBox[{"(", 
       RowBox[{"Cubic", "|", "CubicLoop"}], ")"}]}], ",", " ", "range_", ",", 
     " ", "data_", ",", " ", "coefficients_"}], "]"}], "]"}], " ", ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"dcoeff", ",", "ddata"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"dcoeff", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}], "#"}], ")"}],
           "\[LeftDoubleBracket]", 
          RowBox[{"{", 
           RowBox[{"2", ",", "3", ",", "4", ",", "1"}], "}"}], 
          "\[RightDoubleBracket]"}], "&"}], ",", "coefficients", ",", 
        RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"ddata", " ", "=", " ", 
      RowBox[{"Append", "[", 
       RowBox[{
        RowBox[{"dcoeff", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "All", ",", "2"}], "\[RightDoubleBracket]"}], 
        ",", 
        RowBox[{"Map", "[", 
         RowBox[{"Total", ",", 
          RowBox[{"dcoeff", "\[LeftDoubleBracket]", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "All"}], "\[RightDoubleBracket]"}]}], 
         "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Splines`SplineFunction", "@@", 
      RowBox[{"{", 
       RowBox[{
       "type", ",", " ", "range", ",", " ", "ddata", ",", " ", "dcoeff"}], 
       "}"}]}]}]}], "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 CellChangeTimes->{
  3.4357504380583887`*^9, {3.4357505068615503`*^9, 3.4357505137379637`*^9}, 
   3.435750760616742*^9, 3.435757237149847*^9, {3.435761764319233*^9, 
   3.435761826078574*^9}, {3.435830766354094*^9, 3.435830770058392*^9}, {
   3.435893336631701*^9, 3.4358933451473627`*^9}}],

Cell[BoxData[
 RowBox[{"Splines`SplineFunction", "/:", 
  RowBox[{
   RowBox[{"Derivative", "[", "2", "]"}], "[", 
   RowBox[{"Splines`SplineFunction", "[", 
    RowBox[{
     RowBox[{"type", ":", 
      RowBox[{"(", 
       RowBox[{"Cubic", "|", "CubicLoop"}], ")"}]}], ",", " ", "range_", ",", 
     " ", "data_", ",", " ", "coefficients_"}], "]"}], "]"}], " ", ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"dcoeff", ",", "ddata"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"dcoeff", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "2", ",", "6"}], "}"}], "#"}], ")"}],
           "\[LeftDoubleBracket]", 
          RowBox[{"{", 
           RowBox[{"3", ",", "4", ",", "1", ",", "2"}], "}"}], 
          "\[RightDoubleBracket]"}], "&"}], ",", "coefficients", ",", 
        RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"ddata", " ", "=", " ", 
      RowBox[{"Append", "[", 
       RowBox[{
        RowBox[{"dcoeff", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "All", ",", "2"}], "\[RightDoubleBracket]"}], 
        ",", 
        RowBox[{"Map", "[", 
         RowBox[{"Total", ",", 
          RowBox[{"dcoeff", "\[LeftDoubleBracket]", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "All"}], "\[RightDoubleBracket]"}]}], 
         "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Splines`SplineFunction", "@@", 
      RowBox[{"{", 
       RowBox[{
       "type", ",", " ", "range", ",", " ", "ddata", ",", " ", "dcoeff"}], 
       "}"}]}]}]}], "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 CellChangeTimes->{{3.4356535018087797`*^9, 3.435653512022202*^9}, 
   3.4357504402484627`*^9, {3.435750519523603*^9, 3.4357505266924267`*^9}, 
   3.435750762607608*^9, {3.435761812519067*^9, 3.43576181275762*^9}, {
   3.4358308096764193`*^9, 3.4358308132685957`*^9}, {3.435893352544456*^9, 
   3.435893356155828*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Protect", "[", "Splines`SplineFunction", "]"}], 
  ";"}]], "PackageInput",
 CellChangeTimes->{{3.4356545895235786`*^9, 3.43565459593534*^9}, 
   3.435830819062941*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Spline Length", "Subsection",
 CellChangeTimes->{{3.435995156277722*^9, 3.435995159233666*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "SplineLength", "]"}], " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"ApproximationOrder", "\[Rule]", " ", "2"}], "}"}]}], 
  ";"}]], "PackageInput",
 CellChangeTimes->{{3.435992972174522*^9, 3.4359929859174223`*^9}, {
   3.4359934927122517`*^9, 3.435993507048438*^9}, 3.43599433466686*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SplineLength", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a0_", ",", "a1_", ",", "a2_", ",", "a3_"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"b0_", ",", "b1_", ",", "b2_", ",", "b3_"}], "}"}]}], "}"}], 
     ",", "0"}], "]"}], "=", 
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a1", "+", "a2", "+", "a3"}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"b1", "+", "b2", "+", "b3"}], ")"}], "2"]}]]}], 
  ";"}]], "PackageInput",
 CellChangeTimes->{{3.435993359362741*^9, 3.435993369384956*^9}, {
   3.4359934316785707`*^9, 3.435993452968844*^9}, {3.435993571446437*^9, 
   3.435993576531942*^9}, {3.435993661853817*^9, 3.4359936625572653`*^9}, 
   3.4359943367406473`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SplineLength", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"_", ",", "a1_", ",", "a2_", ",", "a3_"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"_", ",", "b1_", ",", "b2_", ",", "b3_"}], "}"}]}], "}"}], 
     ",", "1"}], "]"}], "=", 
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a1", "+", "a2", "+", 
        RowBox[{"3", " ", 
         RowBox[{"a3", "/", "4"}]}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"b1", "+", "b2", "+", 
        RowBox[{"3", " ", 
         RowBox[{"b3", "/", "4"}]}]}], ")"}], "2"]}]]}], 
  ";"}]], "PackageInput",
 CellChangeTimes->{{3.435927094937237*^9, 3.435927140352421*^9}, 
   3.4359272868809633`*^9, 3.4359273917542048`*^9, 3.435927470944673*^9, 
   3.435927517913411*^9, {3.4359276648896627`*^9, 3.4359276664385233`*^9}, {
   3.435928201810793*^9, 3.435928227449032*^9}, 3.4359287653788147`*^9, {
   3.435941241031674*^9, 3.4359412440426064`*^9}, 3.4359927144767523`*^9, 
   3.435993573883704*^9, {3.435993665261525*^9, 3.435993665373384*^9}, 
   3.435994337668745*^9}],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"SplineLength", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"_", ",", "a1_", ",", "a2_", ",", "a3_"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"_", ",", "b1_", ",", "b2_", ",", "b3_"}], "}"}]}], "}"}], 
     ",", "2"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x1", "=", 
        RowBox[{"a1", "+", "a2", "+", 
         RowBox[{"3", " ", 
          RowBox[{"a3", "/", "4"}]}]}]}], ",", 
       RowBox[{"y1", "=", 
        RowBox[{"b1", "+", "b2", "+", 
         RowBox[{"3", " ", 
          RowBox[{"b3", "/", "4"}]}]}]}], ",", 
       RowBox[{"x2", "=", 
        RowBox[{
         RowBox[{"2", " ", "a2"}], "+", 
         RowBox[{"3", " ", "a3"}]}]}], ",", 
       RowBox[{"y2", "=", 
        RowBox[{
         RowBox[{"2", " ", "b2"}], "+", 
         RowBox[{"3", " ", "b3"}]}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     " ", 
     RowBox[{
      SqrtBox[
       RowBox[{
        SuperscriptBox["x1", "2"], "+", 
        SuperscriptBox["y1", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            FractionBox["1", 
             RowBox[{"24", 
              SqrtBox["2"]}]]}], 
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"x1", " ", "x2"}], "+", 
               RowBox[{"y1", " ", "y2"}]}], ")"}], "2"], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["x1", "2"], "+", 
               SuperscriptBox["y1", "2"]}], ")"}], "2"]]}], "+", 
          RowBox[{
           FractionBox["1", 
            RowBox[{"24", 
             SqrtBox["2"]}]], 
           FractionBox[
            RowBox[{
             RowBox[{"6", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"a3", " ", "x1"}], "+", 
                RowBox[{"b3", " ", "y1"}]}], ")"}]}], "+", 
             SuperscriptBox["x2", "2"], "+", 
             SuperscriptBox["y2", "2"]}], 
            RowBox[{
             SuperscriptBox["x1", "2"], "+", 
             SuperscriptBox["y1", "2"]}]]}]}], ")"}]}], ")"}]}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.4702215492608128`*^9, 3.470221549456769*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SplineLength", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "a1_", ",", "a2_", ",", "a3_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"_", ",", "b1_", ",", "b2_", ",", "b3_"}], "}"}]}], "}"}], ",", 
    RowBox[{"2", "|", "3"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x1", "=", 
       RowBox[{"a1", "+", "a2", "+", 
        RowBox[{"3", " ", 
         RowBox[{"a3", "/", "4"}]}]}]}], ",", 
      RowBox[{"y1", "=", 
       RowBox[{"b1", "+", "b2", "+", 
        RowBox[{"3", " ", 
         RowBox[{"b3", "/", "4"}]}]}]}], ",", 
      RowBox[{"x2", "=", 
       RowBox[{
        RowBox[{"2", " ", "a2"}], "+", 
        RowBox[{"3", " ", "a3"}]}]}], ",", 
      RowBox[{"y2", "=", 
       RowBox[{
        RowBox[{"2", " ", "b2"}], "+", 
        RowBox[{"3", " ", "b3"}]}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     FractionBox["1", "24"], " ", 
     SqrtBox[
      RowBox[{
       SuperscriptBox["x1", "2"], "+", 
       SuperscriptBox["y1", "2"]}]], " ", 
     RowBox[{"(", 
      RowBox[{"24", "+", 
       FractionBox[
        RowBox[{
         RowBox[{"6", " ", "a3", " ", "x1", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["x1", "2"], "+", 
            SuperscriptBox["y1", "2"]}], ")"}]}], "+", 
         RowBox[{"6", " ", "b3", " ", "y1", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["x1", "2"], "+", 
            SuperscriptBox["y1", "2"]}], ")"}]}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x2", " ", "y1"}], "-", 
            RowBox[{"x1", " ", "y2"}]}], ")"}], "2"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["x1", "2"], "+", 
           SuperscriptBox["y1", "2"]}], ")"}], "2"]]}], ")"}]}]}], 
   "]"}]}]], "PackageInput",
 CellChangeTimes->{{3.435927094937237*^9, 3.435927140352421*^9}, 
   3.4359272868809633`*^9, 3.4359273917542048`*^9, 3.435927470944673*^9, 
   3.435927517913411*^9, {3.435927792626712*^9, 3.435928054076056*^9}, {
   3.435928092348894*^9, 3.435928127394459*^9}, {3.435928769237129*^9, 
   3.435928771547299*^9}, 3.435929281736524*^9, {3.4359365028511972`*^9, 
   3.4359365186195307`*^9}, {3.435936564037943*^9, 3.4359365667857428`*^9}, {
   3.435936643845686*^9, 3.435936645571019*^9}, {3.435936695964758*^9, 
   3.435936697870028*^9}, {3.435936737798869*^9, 3.4359367563331833`*^9}, {
   3.435936791504197*^9, 3.4359368429170837`*^9}, 3.435993635809884*^9, {
   3.435993670769128*^9, 3.435993670920562*^9}, 3.435994338624114*^9, 
   3.470221557641848*^9, {3.470221802819045*^9, 3.470221803129424*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SplineLength", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "a1_", ",", "a2_", ",", "a3_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"_", ",", "b1_", ",", "b2_", ",", "b3_"}], "}"}]}], "}"}], ",",
     "4"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x1", "=", 
       RowBox[{"a1", "+", "a2", "+", 
        RowBox[{"3", " ", 
         RowBox[{"a3", "/", "4"}]}]}]}], ",", 
      RowBox[{"y1", "=", 
       RowBox[{"b1", "+", "b2", "+", 
        RowBox[{"3", " ", 
         RowBox[{"b3", "/", "4"}]}]}]}], ",", 
      RowBox[{"x2", "=", 
       RowBox[{
        RowBox[{"2", " ", "a2"}], "+", 
        RowBox[{"3", " ", "a3"}]}]}], ",", 
      RowBox[{"y2", "=", 
       RowBox[{
        RowBox[{"2", " ", "b2"}], "+", 
        RowBox[{"3", " ", "b3"}]}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"3840", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["x1", "2"], "+", 
          SuperscriptBox["y1", "2"]}], ")"}], 
        RowBox[{"3", "/", "2"}]]}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"216", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["a3", "2"], "+", 
          SuperscriptBox["b3", "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["x1", "2"], "+", 
          SuperscriptBox["y1", "2"]}], ")"}]}], "+", 
       RowBox[{"3840", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["x1", "2"], "+", 
           SuperscriptBox["y1", "2"]}], ")"}], "2"]}], "+", 
       RowBox[{"36", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "a2", " ", "a3"}], "+", 
          RowBox[{"3", " ", 
           SuperscriptBox["a3", "2"]}], "+", 
          RowBox[{"b3", " ", "y2"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"x1", " ", "x2"}], "+", 
          RowBox[{"y1", " ", "y2"}]}], ")"}]}], "+", 
       RowBox[{"160", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"6", " ", "a3", " ", "x1", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["x1", "2"], "+", 
             SuperscriptBox["y1", "2"]}], ")"}]}], "+", 
          RowBox[{"6", " ", "b3", " ", "y1", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["x1", "2"], "+", 
             SuperscriptBox["y1", "2"]}], ")"}]}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"x2", " ", "y1"}], "-", 
             RowBox[{"x1", " ", "y2"}]}], ")"}], "2"]}], ")"}]}], "-", 
       RowBox[{
        RowBox[{"1", "/", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["x1", "2"], "+", 
           SuperscriptBox["y1", "2"]}], ")"}]}], "6", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"6", " ", "a3", " ", "x1"}], "+", 
          SuperscriptBox["x2", "2"], "+", 
          RowBox[{"6", " ", "b3", " ", "y1"}], "+", 
          SuperscriptBox["y2", "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"6", " ", "a3", " ", "x1", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["x1", "2"], "+", 
             SuperscriptBox["y1", "2"]}], ")"}]}], "+", 
          RowBox[{"6", " ", "b3", " ", "y1", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["x1", "2"], "+", 
             SuperscriptBox["y1", "2"]}], ")"}]}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"x2", " ", "y1"}], "-", 
             RowBox[{"x1", " ", "y2"}]}], ")"}], "2"]}], ")"}]}], "-", 
       RowBox[{"15", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"x1", " ", "x2"}], "+", 
          RowBox[{"y1", " ", "y2"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"12", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "a2", " ", "a3"}], "+", 
             RowBox[{"3", " ", 
              SuperscriptBox["a3", "2"]}], "+", 
             RowBox[{"b3", " ", "y2"}]}], ")"}]}], "-", 
          FractionBox[
           RowBox[{"2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"x1", " ", "x2"}], "+", 
              RowBox[{"y1", " ", "y2"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"6", " ", "a3", " ", "x1", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["x1", "2"], "+", 
                 SuperscriptBox["y1", "2"]}], ")"}]}], "+", 
              RowBox[{"6", " ", "b3", " ", "y1", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["x1", "2"], "+", 
                 SuperscriptBox["y1", "2"]}], ")"}]}], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"x2", " ", "y1"}], "-", 
                 RowBox[{"x1", " ", "y2"}]}], ")"}], "2"]}], ")"}]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["x1", "2"], "+", 
              SuperscriptBox["y1", "2"]}], ")"}], "2"]]}], ")"}]}]}], 
      ")"}]}]}], "]"}]}]], "PackageInput",
 CellChangeTimes->{{3.435927094937237*^9, 3.435927140352421*^9}, 
   3.4359272868809633`*^9, 3.4359273917542048`*^9, 3.435927470944673*^9, 
   3.435927517913411*^9, {3.435927792626712*^9, 3.435928054076056*^9}, {
   3.435928092348894*^9, 3.435928127394459*^9}, {3.435928769237129*^9, 
   3.435928771547299*^9}, 3.435929281736524*^9, {3.4359365028511972`*^9, 
   3.4359365186195307`*^9}, {3.435936564037943*^9, 3.4359365667857428`*^9}, {
   3.435936643845686*^9, 3.435936645571019*^9}, {3.435936695964758*^9, 
   3.435936697870028*^9}, {3.435936737798869*^9, 3.4359367563331833`*^9}, {
   3.435936791504197*^9, 3.4359368429170837`*^9}, 3.435993635809884*^9, {
   3.435993670769128*^9, 3.435993670920562*^9}, 3.435994338624114*^9, 
   3.470221557641848*^9, {3.470221805515223*^9, 3.470221815706778*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SplineLength", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "a1_", ",", "a2_", ",", "a3_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"_", ",", "b1_", ",", "b2_", ",", "b3_"}], "}"}]}], "}"}], ",",
     "\[Infinity]"}], "]"}], ":=", 
  RowBox[{"NIntegrate", "[", 
   RowBox[{
    SqrtBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a1", "+", 
         RowBox[{"t", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "a2"}], "+", 
            RowBox[{"3", " ", "a3", " ", "t"}]}], ")"}]}]}], ")"}], "2"], "+", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"b1", "+", 
         RowBox[{"t", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "b2"}], "+", 
            RowBox[{"3", " ", "b3", " ", "t"}]}], ")"}]}]}], ")"}], "2"]}]], 
    ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "1"}], "}"}]}], "]"}]}]], "PackageInput",
 CellChangeTimes->{{3.435993094748768*^9, 3.435993106772434*^9}, {
   3.435993331005653*^9, 3.435993352519794*^9}, {3.435993673486732*^9, 
   3.43599367412811*^9}, 3.435994339733652*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SplineLength", "[", 
    RowBox[{
     RowBox[{"splinefunc", ":", 
      RowBox[{"SplineFunction", "[", 
       RowBox[{
        RowBox[{"Cubic", "|", "CubicLoop"}], ",", "__"}], "]"}]}], ",", 
     RowBox[{"opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ord", "=", 
       RowBox[{
        RowBox[{"ApproximationOrder", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "SplineLength", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"ord", ",", 
           RowBox[{
           "0", "|", "1", "|", "2", "|", "3", "|", "4", "|", 
            "\[Infinity]"}]}], "]"}], "]"}], ",", 
        RowBox[{"ord", "=", "2"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Total", "[", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"SplineLength", "[", 
           RowBox[{"#", ",", "ord"}], "]"}], "&"}], ",", 
         RowBox[{"N", "[", 
          RowBox[{"Last", "[", "splinefunc", "]"}], "]"}]}], "]"}], "]"}]}]}],
     "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput",
 CellChangeTimes->{{3.435928795116095*^9, 3.435928870179932*^9}, {
  3.435928924955895*^9, 3.43592895269311*^9}, {3.435992730041277*^9, 
  3.435992736584963*^9}, {3.435993602171471*^9, 3.435993613123909*^9}, {
  3.435993686413291*^9, 3.4359937217584743`*^9}, {3.435993757776144*^9, 
  3.4359937774450483`*^9}, {3.435994046118428*^9, 3.435994059062214*^9}, {
  3.43599434078128*^9, 3.435994349980583*^9}, {3.4359943995252857`*^9, 
  3.435994436438262*^9}, {3.470221825166834*^9, 3.470221825939315*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SplineLength", "[", 
    RowBox[{
     RowBox[{"spline", ":", 
      RowBox[{"Spline", "[", 
       RowBox[{"_", ",", 
        RowBox[{"Cubic", "|", "CubicLoop"}], ",", "__"}], "]"}]}], ",", 
     RowBox[{"opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ord", " ", "=", " ", 
       RowBox[{
        RowBox[{"ApproximationOrder", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "SplineLength", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"ord", ",", 
           RowBox[{
           "0", "|", "1", "|", "2", "|", "3", "|", "4", "|", 
            "\[Infinity]"}]}], "]"}], "]"}], ",", 
        RowBox[{"ord", "=", "2"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Total", "[", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"SplineLength", "[", 
           RowBox[{"#", ",", "ord"}], "]"}], "&"}], ",", 
         RowBox[{"N", "[", 
          RowBox[{"Last", "[", 
           RowBox[{"Last", "[", "spline", "]"}], "]"}], "]"}]}], "]"}], 
       "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput",
 CellChangeTimes->{{3.435928895899023*^9, 3.4359289176203403`*^9}, {
  3.43592895542624*^9, 3.435928961651227*^9}, {3.435929028323532*^9, 
  3.4359290286584587`*^9}, {3.435992734041753*^9, 3.435992738657135*^9}, {
  3.435993617207285*^9, 3.435993620014502*^9}, {3.435993712032671*^9, 
  3.435993715928903*^9}, {3.435993779937207*^9, 3.435993794032506*^9}, {
  3.435994061646401*^9, 3.435994063806234*^9}, {3.435994342781578*^9, 
  3.4359943511088457`*^9}, {3.435994443816284*^9, 3.435994443960451*^9}, {
  3.470221837189002*^9, 3.470221838314291*^9}}]
}, Open  ]],

Cell["Image Force Functions", "Subsection"],

Cell["Active Contour", "Subsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ActiveContour", ",", "ActiveContourStep", ",", " ", 
       "ActiveContourPlot", ",", "CubicLoop", ",", "SplineLength", ",", 
       "ApproximationOrder"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", "Protected", "}"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.435649595159842*^9, 3.4356496140779543`*^9}, 
   3.435649711322654*^9, 3.4356540275598907`*^9, {3.435654162010419*^9, 
   3.4356541625254602`*^9}, 3.4357499491218557`*^9, {3.435995335239883*^9, 
   3.435995337317792*^9}}]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1014, 736},
WindowMargins->{{214, Automatic}, {Automatic, 0}},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (November 10, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    CellGroupData[{
      Cell["Style Definitions", "Subtitle"], 
      Cell[
      "Modify the definitions below to change the default appearance of all \
cells in a given style.  Make modifications to any definition using commands \
in the Format menu.", "Text"], 
      Cell[
       CellGroupData[{
         Cell["Style Environment Names", "Section"], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{12, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 9], 
         Cell[
          StyleData[All, "Presentation"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 12], 
         Cell[
          StyleData[All, "Condensed"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{8, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 8], 
         Cell[
          StyleData[All, "Printout"], PageWidth -> PaperWidth, 
          CellLabelMargins -> {{2, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 5, 
          PrivateFontOptions -> {"FontType" -> "Outline"}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Notebook Options", "Section"], 
         Cell[
         "The options defined for the style below will be used at the \
Notebook level.", "Text"], 
         Cell[
          StyleData["Notebook"], PageHeaders -> {{
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"], None, 
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"]}, {
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"], None, 
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"]}}, CellFrameLabelMargins -> 
          6, StyleMenuListing -> None]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headings", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Title"], CellMargins -> {{12, Inherited}, {20, 40}}, 
             CellGroupingRules -> {"TitleGrouping", 0}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LineSpacing -> {1, 11}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "Title", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subtitle", 0}, {"Subsubtitle", 0}}, FontFamily -> 
             "Helvetica", FontSize -> 36, FontWeight -> "Bold"], 
            Cell[
             StyleData["Title", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 40}}, LineSpacing -> {1, 0}, 
             FontSize -> 44], 
            Cell[
             StyleData["Title", "Condensed"], 
             CellMargins -> {{8, 10}, {4, 8}}, FontSize -> 20], 
            Cell[
             StyleData["Title", "Printout"], 
             CellMargins -> {{2, 10}, {12, 30}}, FontSize -> 24]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subtitle"], 
             CellMargins -> {{12, Inherited}, {20, 15}}, 
             CellGroupingRules -> {"TitleGrouping", 10}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subtitle", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subsubtitle", 0}}, FontFamily -> "Helvetica", 
             FontSize -> 24], 
            Cell[
             StyleData["Subtitle", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 20}}, LineSpacing -> {1, 0}, 
             FontSize -> 36], 
            Cell[
             StyleData["Subtitle", "Condensed"], 
             CellMargins -> {{8, 10}, {4, 4}}, FontSize -> 14], 
            Cell[
             StyleData["Subtitle", "Printout"], 
             CellMargins -> {{2, 10}, {12, 8}}, FontSize -> 18]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubtitle"], 
             CellMargins -> {{12, Inherited}, {20, 15}}, 
             CellGroupingRules -> {"TitleGrouping", 20}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsubtitle", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}}, FontFamily -> "Helvetica", FontSize -> 14, 
             FontSlant -> "Italic"], 
            Cell[
             StyleData["Subsubtitle", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 20}}, LineSpacing -> {1, 0}, 
             FontSize -> 24], 
            Cell[
             StyleData["Subsubtitle", "Condensed"], 
             CellMargins -> {{8, 10}, {8, 8}}, FontSize -> 12], 
            Cell[
             StyleData["Subsubtitle", "Printout"], 
             CellMargins -> {{2, 10}, {12, 8}}, FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellDingbat -> "\[FilledSquare]", 
             CellMargins -> {{25, Inherited}, {8, 24}}, 
             CellGroupingRules -> {"SectionGrouping", 30}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LineSpacing -> {1, 7}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "Section", 
             CounterAssignments -> {{"Subsection", 0}, {"Subsubsection", 0}}, 
             FontFamily -> "Helvetica", FontSize -> 16, FontWeight -> "Bold"], 
            Cell[
             StyleData["Section", "Presentation"], 
             CellMargins -> {{40, 10}, {11, 32}}, LineSpacing -> {1, 0}, 
             FontSize -> 24], 
            Cell[
             StyleData["Section", "Condensed"], 
             CellMargins -> {{18, Inherited}, {6, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Section", "Printout"], 
             CellMargins -> {{13, 0}, {7, 22}}, FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> "\[FilledSmallSquare]", 
             CellMargins -> {{22, Inherited}, {8, 20}}, 
             CellGroupingRules -> {"SectionGrouping", 40}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsection", CounterAssignments -> {{"Subsubsection", 0}}, 
             FontFamily -> "Times", FontSize -> 14, FontWeight -> "Bold"], 
            Cell[
             StyleData["Subsection", "Presentation"], 
             CellMargins -> {{36, 10}, {11, 32}}, LineSpacing -> {1, 0}, 
             FontSize -> 22], 
            Cell[
             StyleData["Subsection", "Condensed"], 
             CellMargins -> {{16, Inherited}, {6, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Subsection", "Printout"], 
             CellMargins -> {{9, 0}, {7, 22}}, FontSize -> 12]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsection"], CellDingbat -> 
             "\[FilledSmallSquare]", 
             CellMargins -> {{22, Inherited}, {8, 18}}, 
             CellGroupingRules -> {"SectionGrouping", 50}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsubsection", FontFamily -> "Times", FontWeight -> "Bold"], 
            Cell[
             StyleData["Subsubsection", "Presentation"], 
             CellMargins -> {{34, 10}, {11, 26}}, LineSpacing -> {1, 0}, 
             FontSize -> 18], 
            Cell[
             StyleData["Subsubsection", "Condensed"], 
             CellMargins -> {{17, Inherited}, {6, 12}}, FontSize -> 10], 
            Cell[
             StyleData["Subsubsection", "Printout"], 
             CellMargins -> {{9, 0}, {7, 14}}, FontSize -> 11]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Body Text", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Text"], CellMargins -> {{12, 10}, {7, 7}}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             Hyphenation -> True, LineSpacing -> {1, 3}, CounterIncrements -> 
             "Text"], 
            Cell[
             StyleData["Text", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["Text", "Condensed"], CellMargins -> {{8, 10}, {6, 6}},
              LineSpacing -> {1, 1}, FontSize -> 11], 
            Cell[
             StyleData["Text", "Printout"], CellMargins -> {{2, 2}, {6, 6}}, 
             TextJustification -> 0.5, FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SmallText"], CellMargins -> {{12, 10}, {6, 6}}, 
             DefaultNewInlineCellStyle -> "None", Hyphenation -> True, 
             LineSpacing -> {1, 3}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "SmallText", FontFamily -> "Helvetica", 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Presentation"], 
             CellMargins -> {{24, 10}, {8, 8}}, LineSpacing -> {1, 5}, 
             FontSize -> 12], 
            Cell[
             StyleData["SmallText", "Condensed"], 
             CellMargins -> {{8, 10}, {5, 5}}, LineSpacing -> {1, 2}, 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Printout"], 
             CellMargins -> {{2, 2}, {5, 5}}, TextJustification -> 0.5, 
             FontSize -> 7]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Input/Output", "Section"], 
         Cell[
         "The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names. Some attributes for these styles are actually set in FormatType Styles \
(in the last section of this stylesheet). ", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Input"], CellMargins -> {{45, 10}, {5, 7}}, 
             Evaluatable -> True, CellGroupingRules -> "InputGrouping", 
             CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, DefaultFormatType -> 
             DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
             FormatType -> InputForm, ShowStringCharacters -> True, 
             NumberMarks -> True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1},
              CounterIncrements -> "Input", FontWeight -> "Bold"], 
            Cell[
             StyleData["Input", "Presentation"], 
             CellMargins -> {{72, Inherited}, {8, 10}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["Input", "Condensed"], 
             CellMargins -> {{40, 10}, {2, 3}}, FontSize -> 11], 
            Cell[
             StyleData["Input", "Printout"], CellMargins -> {{39, 0}, {4, 6}},
              LinebreakAdjustments -> {0.85, 2, 10, 1, 1}, FontSize -> 9]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PackageInput"], CellMargins -> {{45, 10}, {5, 7}}, 
             Evaluatable -> True, CellGroupingRules -> "InputGrouping", 
             CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, InitializationCell -> True, 
             DefaultFormatType -> DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
             FormatType -> InputForm, ShowStringCharacters -> True, 
             NumberMarks -> True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1},
              CounterIncrements -> "Input", FontWeight -> "Bold", Background -> 
             RGBColor[0.500008, 1, 0.566644]], 
            Cell[
             StyleData["PackageInput", "Presentation"], 
             CellMargins -> {{72, Inherited}, {8, 10}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["PackageInput", "Condensed"], 
             CellMargins -> {{40, 10}, {2, 3}}, FontSize -> 11], 
            Cell[
             StyleData["PackageInput", "Printout"], 
             CellMargins -> {{39, 0}, {4, 6}}, 
             LinebreakAdjustments -> {0.85, 2, 10, 1, 1}, FontSize -> 9, 
             Background -> GrayLevel[1]]}, Closed]], 
         Cell[
          StyleData["InputOnly"], Evaluatable -> True, CellGroupingRules -> 
          "InputGrouping", CellHorizontalScrolling -> True, DefaultFormatType -> 
          DefaultInputFormatType, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
          FormatType -> InputForm, ShowStringCharacters -> True, NumberMarks -> 
          True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, 
          CounterIncrements -> "Input", StyleMenuListing -> None, FontWeight -> 
          "Bold"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Output"], CellMargins -> {{47, 10}, {7, 5}}, 
             CellEditDuplicate -> True, CellGroupingRules -> "OutputGrouping",
              CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, DefaultFormatType -> 
             DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Output"], 
            Cell[
             StyleData["Output", "Presentation"], 
             CellMargins -> {{72, Inherited}, {10, 8}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["Output", "Condensed"], 
             CellMargins -> {{41, Inherited}, {3, 2}}, FontSize -> 11], 
            Cell[
             StyleData["Output", "Printout"], 
             CellMargins -> {{39, 0}, {6, 4}}, FontSize -> 9]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Message"], 
             CellMargins -> {{45, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Message", StyleMenuListing -> 
             None, FontSize -> 11, FontColor -> RGBColor[0, 0, 1]], 
            Cell[
             StyleData["Message", "Presentation"], 
             CellMargins -> {{72, Inherited}, {Inherited, Inherited}}, 
             LineSpacing -> {1, 0}, FontSize -> 16], 
            Cell[
             StyleData["Message", "Condensed"], 
             CellMargins -> {{41, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 11], 
            Cell[
             StyleData["Message", "Printout"], 
             CellMargins -> {{39, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 7, FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Print"], 
             CellMargins -> {{45, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, ShowCellLabel -> 
             False, DefaultFormatType -> DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Print", StyleMenuListing -> 
             None], 
            Cell[
             StyleData["Print", "Presentation"], 
             CellMargins -> {{72, Inherited}, {Inherited, Inherited}}, 
             LineSpacing -> {1, 0}, FontSize -> 16], 
            Cell[
             StyleData["Print", "Condensed"], 
             CellMargins -> {{41, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 11], 
            Cell[
             StyleData["Print", "Printout"], 
             CellMargins -> {{39, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 8]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Graphics"], 
             CellMargins -> {{4, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "GraphicsGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, LanguageCategory -> 
             None, FormatType -> InputForm, CounterIncrements -> "Graphics", 
             ImageMargins -> {{43, Inherited}, {Inherited, 0}}, 
             StyleMenuListing -> None, FontFamily -> "Courier", FontSize -> 
             10], 
            Cell[
             StyleData["Graphics", "Presentation"], 
             ImageMargins -> {{62, Inherited}, {Inherited, 0}}], 
            Cell[
             StyleData["Graphics", "Condensed"], 
             ImageMargins -> {{38, Inherited}, {Inherited, 0}}, Magnification -> 
             0.6], 
            Cell[
             StyleData["Graphics", "Printout"], 
             ImageMargins -> {{30, Inherited}, {Inherited, 0}}, Magnification -> 
             0.8]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["CellLabel"], LanguageCategory -> None, 
             StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 
             9, FontColor -> RGBColor[0, 0, 1]], 
            Cell[
             StyleData["CellLabel", "Presentation"], FontSize -> 12], 
            Cell[
             StyleData["CellLabel", "Condensed"], FontSize -> 9], 
            Cell[
             StyleData["CellLabel", "Printout"], FontFamily -> "Courier", 
             FontSize -> 8, FontSlant -> "Italic", FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Inline Formatting", "Section"], 
         Cell[
         "These styles are for modifying individual words or letters in a \
cell exclusive of the cell tag.", "Text"], 
         Cell[
          StyleData["RM"], StyleMenuListing -> None, FontWeight -> "Plain", 
          FontSlant -> "Plain"], 
         Cell[
          StyleData["BF"], StyleMenuListing -> None, FontWeight -> "Bold"], 
         Cell[
          StyleData["IT"], StyleMenuListing -> None, FontSlant -> "Italic"], 
         Cell[
          StyleData["TR"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["TI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["TB"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["TBI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["MR"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["MO"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["MB"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["MBO"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["SR"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["SO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["SB"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["SBO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SO10"], StyleMenuListing -> None, FontFamily -> 
             "Helvetica", FontSize -> 10, FontWeight -> "Plain", FontSlant -> 
             "Italic"], 
            Cell[
             StyleData["SO10", "Printout"], StyleMenuListing -> None, 
             FontFamily -> "Helvetica", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"], 
            Cell[
             StyleData["SO10", "EnhancedPrintout"], StyleMenuListing -> None, 
             FontFamily -> "Futura", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Formulas and Programming", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["InlineFormula"], CellMargins -> {{10, 4}, {0, 8}}, 
             CellHorizontalScrolling -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", ScriptLevel -> 1, SingleLetterItalics -> True], 
            Cell[
             StyleData["InlineFormula", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["InlineFormula", "Condensed"], 
             CellMargins -> {{8, 10}, {6, 6}}, LineSpacing -> {1, 1}, 
             FontSize -> 11], 
            Cell[
             StyleData["InlineFormula", "Printout"], 
             CellMargins -> {{2, 0}, {6, 6}}, FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["DisplayFormula"], 
             CellMargins -> {{42, Inherited}, {Inherited, Inherited}}, 
             CellHorizontalScrolling -> True, DefaultFormatType -> 
             DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", ScriptLevel -> 0, SingleLetterItalics -> True, 
             UnderoverscriptBoxOptions -> {LimitsPositioning -> True}], 
            Cell[
             StyleData["DisplayFormula", "Presentation"], 
             LineSpacing -> {1, 5}, FontSize -> 16], 
            Cell[
             StyleData["DisplayFormula", "Condensed"], LineSpacing -> {1, 1}, 
             FontSize -> 11], 
            Cell[
             StyleData["DisplayFormula", "Printout"], FontSize -> 10]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Program"], CellFrame -> {{0, 0}, {0.5, 0.5}}, 
             CellMargins -> {{10, 4}, {0, 8}}, CellHorizontalScrolling -> 
             True, Hyphenation -> False, LanguageCategory -> "Formula", 
             ScriptLevel -> 1, FontFamily -> "Courier"], 
            Cell[
             StyleData["Program", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["Program", "Condensed"], 
             CellMargins -> {{8, 10}, {6, 6}}, LineSpacing -> {1, 1}, 
             FontSize -> 11], 
            Cell[
             StyleData["Program", "Printout"], 
             CellMargins -> {{2, 0}, {6, 6}}, FontSize -> 9]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Outline Styles", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline1"], CellMargins -> {{12, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 50}, 
             ParagraphIndent -> -38, CounterIncrements -> "Outline1", 
             FontSize -> 18, FontWeight -> "Bold", 
             CounterBoxOptions -> {CounterFunction :> CapitalRomanNumeral}], 
            Cell[
             StyleData["Outline1", "Printout"], 
             CounterBoxOptions -> {CounterFunction :> CapitalRomanNumeral}]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline2"], CellMargins -> {{59, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 60}, 
             ParagraphIndent -> -27, CounterIncrements -> "Outline2", 
             FontSize -> 15, FontWeight -> "Bold", 
             CounterBoxOptions -> {CounterFunction :> (Part[
                 CharacterRange["A", "Z"], #]& )}], 
            Cell[
             StyleData["Outline2", "Printout"], 
             CounterBoxOptions -> {CounterFunction :> (Part[
                 CharacterRange["A", "Z"], #]& )}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline3"], CellMargins -> {{108, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 70}, 
             ParagraphIndent -> -21, CounterIncrements -> "Outline3", 
             FontSize -> 12, 
             CounterBoxOptions -> {CounterFunction :> Identity}], 
            Cell[
             StyleData["Outline3", "Printout"], 
             CounterBoxOptions -> {CounterFunction :> Identity}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline4"], CellMargins -> {{158, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 80}, 
             ParagraphIndent -> -18, CounterIncrements -> "Outline4", 
             FontSize -> 10, CounterBoxOptions -> {CounterFunction :> (Part[
                 CharacterRange["a", "z"], #]& )}], 
            Cell[
             StyleData["Outline4", "Printout"]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Hyperlink Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same Notebook, \
or between Notebooks.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Hyperlink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonNote -> 
               ButtonData}], 
            Cell[
             StyleData["Hyperlink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["Hyperlink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["Hyperlink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
         "The following styles are for linking automatically to the on-line \
help system.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["MainBookLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["MainBook", #]}]& )}], 
            Cell[
             StyleData["MainBookLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["MainBookLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["MainBookLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["AddOnsLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["AddOns", #]}]& )}], 
            Cell[
             StyleData["AddOnsLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["AddOnsLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["AddOnsLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["RefGuideLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["RefGuide", #]}]& )}], 
            Cell[
             StyleData["RefGuideLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["RefGuideLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["RefGuideLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["GettingStartedLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["GettingStarted", #]}]& )}], 
            Cell[
             StyleData["GettingStartedLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["GettingStartedLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["GettingStartedLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["OtherInformationLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["OtherInformation", #]}]& )}], 
            Cell[
             StyleData["OtherInformationLink", "Presentation"], FontSize -> 
             16], 
            Cell[
             StyleData["OtherInformationLink", "Condensed"], FontSize -> 11], 
            
            Cell[
             StyleData["OtherInformationLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headers and Footers", "Section"], 
         Cell[
          StyleData["Header"], CellMargins -> {{0, 0}, {4, 1}}, 
          DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
          "NaturalLanguage", StyleMenuListing -> None, FontSize -> 10, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["Footer"], CellMargins -> {{0, 0}, {0, 4}}, 
          DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
          "NaturalLanguage", StyleMenuListing -> None, FontSize -> 9, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["PageNumber"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Times", FontSize -> 10]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Palette Styles", "Section"], 
         Cell[
         "The cells below define styles that define standard ButtonFunctions, \
for use in palette buttons.", "Text"], 
         Cell[
          StyleData["Paste"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, After]}]& )}], 
         Cell[
          StyleData["Evaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["EvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionMove[
                FrontEnd`InputNotebook[], All, Cell, 1], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Placeholder Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making placeholder objects \
in palette templates.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Placeholder"], Placeholder -> True, StyleMenuListing -> 
             None, FontSlant -> "Italic", FontColor -> 
             RGBColor[0.890623, 0.864698, 0.384756], 
             TagBoxOptions -> {
              Editable -> False, Selectable -> False, StripWrapperBoxes -> 
               False}], 
            Cell[
             StyleData["Placeholder", "Presentation"]], 
            Cell[
             StyleData["Placeholder", "Condensed"]], 
            Cell[
             StyleData["Placeholder", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PrimaryPlaceholder"], StyleMenuListing -> None, 
             DrawHighlighted -> True, FontSlant -> "Italic", Background -> 
             RGBColor[0.912505, 0.891798, 0.507774], 
             TagBoxOptions -> {
              Editable -> False, Selectable -> False, StripWrapperBoxes -> 
               False}], 
            Cell[
             StyleData["PrimaryPlaceholder", "Presentation"]], 
            Cell[
             StyleData["PrimaryPlaceholder", "Condensed"]], 
            Cell[
             StyleData["PrimaryPlaceholder", "Printout"]]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["FormatType Styles", "Section"], 
         Cell[
         "The cells below define styles that are mixed in with the styles of \
most cells.  If a cell's FormatType matches the name of one of the styles \
defined below, then that style is applied between the cell's style and its \
own options. This is particularly true of Input and Output.", "Text"], 
         Cell[
          StyleData["CellExpression"], PageWidth -> Infinity, 
          CellMargins -> {{6, Inherited}, {Inherited, Inherited}}, 
          ShowCellLabel -> False, ShowSpecialCharacters -> False, 
          AllowInlineCells -> False, Hyphenation -> False, 
          AutoItalicWords -> {}, StyleMenuListing -> None, FontFamily -> 
          "Courier", FontSize -> 12, Background -> GrayLevel[1]], 
         Cell[
          StyleData["InputForm"], InputAutoReplacements -> {}, 
          AllowInlineCells -> False, Hyphenation -> False, StyleMenuListing -> 
          None, FontFamily -> "Courier"], 
         Cell[
          StyleData["OutputForm"], PageWidth -> Infinity, TextAlignment -> 
          Left, LineSpacing -> {0.6, 1}, StyleMenuListing -> None, FontFamily -> 
          "Courier"], 
         Cell[
          StyleData["StandardForm"], 
          InputAutoReplacements -> {
           "->" -> "\[Rule]", ":>" -> "\[RuleDelayed]", "<=" -> 
            "\[LessEqual]", ">=" -> "\[GreaterEqual]", "!=" -> "\[NotEqual]", 
            "==" -> "\[Equal]", Inherited}, LineSpacing -> {1.25, 0}, 
          StyleMenuListing -> None, FontFamily -> "Courier"], 
         Cell[
          StyleData["TraditionalForm"], 
          InputAutoReplacements -> {
           "->" -> "\[Rule]", ":>" -> "\[RuleDelayed]", "<=" -> 
            "\[LessEqual]", ">=" -> "\[GreaterEqual]", "!=" -> "\[NotEqual]", 
            "==" -> "\[Equal]", Inherited}, LineSpacing -> {1.25, 0}, 
          SingleLetterItalics -> True, TraditionalFunctionNotation -> True, 
          DelimiterMatching -> None, StyleMenuListing -> None], 
         Cell[
         "The style defined below is mixed in to any cell that is in an \
inline cell within another.", "Text"], 
         Cell[
          StyleData["InlineCell"], LanguageCategory -> "Formula", ScriptLevel -> 
          1, StyleMenuListing -> None], 
         Cell[
          StyleData["InlineCellEditing"], StyleMenuListing -> None, 
          Background -> RGBColor[1, 0.749996, 0.8]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Automatic Styles", "Section"], 
         Cell[
         "The cells below define styles that are used to affect the display \
of certain types of objects in typeset expressions.  For example, \
\"UnmatchedBracket\" style defines how unmatched bracket, curly bracket, and \
parenthesis characters are displayed (typically by coloring them to make them \
stand out).", "Text"], 
         Cell[
          StyleData["UnmatchedBracket"], StyleMenuListing -> None, FontColor -> 
          RGBColor[0.760006, 0.330007, 0.8]]}, Closed]]}, Open]]}, Visible -> 
  False, FrontEndVersion -> 
  "7.0 for Mac OS X x86 (32-bit) (November 10, 2008)", StyleDefinitions -> 
  "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 173, 6, 144, "Title"],
Cell[743, 30, 174, 4, 96, "Subsubtitle"],
Cell[CellGroupData[{
Cell[942, 38, 25, 0, 72, "Section"],
Cell[970, 40, 1021, 26, 291, "PackageInput"],
Cell[1994, 68, 128, 3, 39, "Text"],
Cell[2125, 73, 3718, 102, 797, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[5880, 180, 32, 0, 108, "Section"],
Cell[5915, 182, 92, 2, 58, "Text"],
Cell[6010, 186, 758, 16, 264, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[6805, 207, 42, 0, 108, "Section"],
Cell[6850, 209, 482, 9, 160, "PackageInput",
 InitializationCell->True],
Cell[7335, 220, 666, 11, 229, "PackageInput"],
Cell[8004, 233, 549, 10, 229, "PackageInput"],
Cell[8556, 245, 239, 5, 90, "PackageInput",
 InitializationCell->True],
Cell[8798, 252, 246, 5, 90, "PackageInput",
 InitializationCell->True],
Cell[9047, 259, 246, 5, 90, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[9330, 269, 31, 0, 108, "Section"],
Cell[9364, 271, 60, 0, 58, "Text"],
Cell[9427, 273, 108, 2, 90, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[9560, 279, 160, 2, 94, "Subsection"],
Cell[9723, 283, 167, 2, 58, "Text"],
Cell[9893, 287, 3967, 106, 402, "Input",
 Evaluatable->False],
Cell[13863, 395, 95, 1, 58, "Text"],
Cell[13961, 398, 221, 5, 90, "PackageInput"],
Cell[14185, 405, 3654, 94, 438, "PackageInput"],
Cell[17842, 501, 475, 10, 127, "PackageInput"],
Cell[18320, 513, 1543, 42, 288, "PackageInput"],
Cell[19866, 557, 243, 4, 90, "PackageInput"],
Cell[20112, 563, 146, 2, 58, "Text"],
Cell[20261, 567, 214, 4, 90, "PackageInput"],
Cell[20478, 573, 3004, 68, 444, "PackageInput"],
Cell[23485, 643, 3068, 69, 444, "PackageInput"],
Cell[26556, 714, 215, 4, 90, "PackageInput"],
Cell[26774, 720, 205, 5, 90, "PackageInput"],
Cell[26982, 727, 2103, 51, 372, "PackageInput"],
Cell[29088, 780, 2124, 51, 372, "PackageInput"],
Cell[31215, 833, 202, 5, 90, "PackageInput"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31454, 843, 101, 1, 94, "Subsection"],
Cell[31558, 846, 351, 8, 90, "PackageInput"],
Cell[31912, 856, 843, 24, 153, "PackageInput"],
Cell[32758, 882, 1177, 31, 153, "PackageInput"],
Cell[33938, 915, 2437, 75, 222, "Input"],
Cell[36378, 992, 2800, 72, 258, "PackageInput"],
Cell[39181, 1066, 6266, 168, 798, "PackageInput"],
Cell[45450, 1236, 1216, 36, 160, "PackageInput"],
Cell[46669, 1274, 1857, 45, 306, "PackageInput"],
Cell[48529, 1321, 1927, 46, 235, "PackageInput"]
}, Open  ]],
Cell[50471, 1370, 43, 0, 94, "Subsection"],
Cell[50517, 1372, 36, 0, 55, "Subsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[50590, 1377, 34, 0, 108, "Section"],
Cell[50627, 1379, 64, 0, 87, "Text"],
Cell[50694, 1381, 863, 19, 550, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
