(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    155858,       4394]
NotebookOptionsPosition[    102377,       3224]
NotebookOutlinePosition[    149299,       4215]
CellTagsIndexPosition[    149256,       4212]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
 "B-Spline",
 StyleBox[" ",
  FontColor->RGBColor[1, 0, 1]],
 "Package"
}], "Title"],

Cell[TextData[{
 "for ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Version 6 or later"
}], "Subtitle",
 CellChangeTimes->{{3.488872106143853*^9, 3.4888721064048367`*^9}}],

Cell["\<\
Markus van Almsick
\[Copyright]2005, \[Copyright]2008\
\>", "Subsubtitle"],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "[", "\"\<MathVisionTools`BSpline`\>\"", "]"}], " ",
      "=", " ", 
     RowBox[{"{", 
      RowBox[{"2010", ",", "11", ",", "14", ",", "15", ",", "0", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput",
 CellChangeTimes->{{3.498731793358157*^9, 3.498731802509767*^9}}],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`BSpline`"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Author", ":", " ", 
     RowBox[{"Markus", " ", "van", " ", "Almsick"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"m", ".", "v", ".", 
       RowBox[{"almsick", "@", "tue"}], ".", "nl"}]}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`BSpline`"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "2.0"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "5.1"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{
       RowBox[{"Copyright", " ", "2005"}], "-", "2010"}]}]}], ",", " ", 
    RowBox[{"Markus", " ", "van", " ", "Almsick"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "BSplineDistribution"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{
     RowBox[{"Summary", ":", " ", 
      RowBox[{
      "This", " ", "package", " ", "provides", " ", "properties", " ", "and", 
       " ", "functionals", " ", "of", " ", "the", " ", "uniform"}]}], "\n", 
     RowBox[{
      RowBox[{
      "probability", " ", "distribution", " ", "and", " ", "sums", " ", 
       "there", " ", "of", " ", "called", " ", "B"}], "-", 
      RowBox[{"splines", "."}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", 
      RowBox[{"continuous", " ", "distribution"}]}]}], ",", " ", 
    RowBox[{"uniform", " ", "distribution"}], ",", " ", 
    RowBox[{"B", "-", "spline"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Warning", ":", 
      RowBox[{
      "This", " ", "package", " ", "extends", " ", "the", " ", "definition", 
       " ", "of", " ", "several", " ", "descriptive", " ", "statistics", " ", 
       "functions", " ", "and", " ", "the", " ", "definition", " ", "of", " ", 
       RowBox[{"Random", ".", "If"}], " ", "the", " ", "original", " ", 
       "usage", " ", "messages", " ", "are", " ", "reloaded", " ", "this", 
       " ", "change", " ", "will", " ", "not", " ", "be", " ", "reflected", 
       " ", "in", " ", "the", " ", "usage", " ", "message"}]}]}], ",", " ", 
    RowBox[{
    "although", " ", "the", " ", "extended", " ", "functionality", " ", 
     "will", " ", 
     RowBox[{"remain", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"Decemeber", " ", "2004"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":", " ", 
     RowBox[{
     "Works", " ", "only", " ", "for", " ", "Mathematica", " ", "6.0", " ", 
      "or", " ", 
      RowBox[{"later", "."}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.498731788159917*^9, 3.4987317886252117`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.
\"Statistics`Common`DistributionsCommon`\"\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "BeginPackage", "[", "\[IndentingNewLine]", 
   "\"\<MathVisionTools`BSpline`\>\"", "\[IndentingNewLine]", "]"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "[", "BSplineDistribution", "]"}], 
  ";"}]}], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{
  3.498730759261795*^9, {3.498731414104849*^9, 3.498731414587902*^9}}],

Cell["\<\
 
Removed: \[OpenCurlyDoubleQuote]Statistics`ContinuousDistributions`\
\[CloseCurlyDoubleQuote], \
\[OpenCurlyDoubleQuote]Statistics`DescriptiveStatistics`\
\[CloseCurlyDoubleQuote]\
\>", "Text",
 CellChangeTimes->{{3.498730760931767*^9, 3.498730774559111*^9}, {
  3.498731404326926*^9, 3.49873141136868*^9}}],

Cell[TextData[{
 "Users may set ",
 StyleBox["Assumptions", "Input"],
 " option of ",
 StyleBox["ExpectedValue", "Input"],
 ", which is then passed on to ",
 StyleBox["Integrate", "Input"],
 ", in addition to the built-in assumptions regarding parameters."
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Options", "[", "ExpectedValue", "]"}], "=", 
  RowBox[{"{", 
   RowBox[{"Assumptions", "\[Rule]", 
    RowBox[{"{", "}"}]}], "}"}]}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "::", "usage"}], "=", 
  "\"\<BSplineDistribution[n] represents the cardinal n-th B-spline, which is \
the convolution of (n+1) uniform distributions that range from -1/2 to 1/2. \
The resulting B-spline distribution thus reaches from -n/2 to n/2. To obtain \
a B-spline distribution in the domain [min,max] use BSplineDistribution[n, \
min, max]. All of Mathematica's statistics functions like PDF, CDF, Mean, ... \
apply.\>\""}]], "PackageInput",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["B-Spline Distribution", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"B", "-", 
   RowBox[{"Spline", " ", "Distribution"}]}], " ", "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["DistributionParameterQ", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"DistributionParameterQ", "[", 
    RowBox[{"BSplineDistribution", "[", "n_", "]"}], "]"}], ":=", " ", 
   RowBox[{
    RowBox[{"IntegerQ", "[", "n", "]"}], " ", "&&", " ", 
    RowBox[{"n", "\[GreaterEqual]", "0"}]}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "::", "order"}], "=", 
  "\"\<The lower boundary `1` of the distribution must be smaller than the \
upper boundary `2`.\>\""}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"DistributionParameterQ", "[", 
   RowBox[{"BSplineDistribution", "[", 
    RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], "]"}], ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"min", "\[LessEqual]", "max"}], ",", 
    RowBox[{
     RowBox[{"IntegerQ", "[", "n", "]"}], " ", "&&", " ", 
     RowBox[{"n", "\[GreaterEqual]", "0"}]}], ",", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"BSplineDistribution", "::", "order"}], ",", "min", ",", 
       "max"}], "]"}], ";", "False"}]}], "]"}]}]], "PackageInput"]
}, Open  ]],

Cell[CellGroupData[{

Cell["DistributionDomainQ", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"DistributionDomainQ", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", "n_", "]"}], ",", "x_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"N", "[", "x", "]"}], ",", "Complex"}], "]"}], "&&", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"n", "+", "1"}], "2"]}], "\[LessEqual]", " ", "x", 
      "\[LessEqual]", " ", 
      FractionBox[
       RowBox[{"n", "+", "1"}], "2"]}], "]"}]}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"DistributionDomainQ", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", "n_", "]"}], ",", 
     RowBox[{"list_", "?", "VectorQ"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"N", "[", "list", "]"}], ",", "Complex"}], "]"}], "&&", 
    RowBox[{"TrueQ", "[", 
     RowBox[{"And", "@@", 
      RowBox[{"Thread", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"n", "+", "1"}], "2"]}], "\[LessEqual]", " ", "list", 
        "\[LessEqual]", " ", 
        FractionBox[
         RowBox[{"n", "+", "1"}], "2"]}], "]"}]}], "]"}]}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"DistributionDomainQ", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", 
      RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], ",", 
     RowBox[{"list_", "?", "VectorQ"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"N", "[", "list", "]"}], ",", "Complex"}], "]"}], "&&", 
    RowBox[{"TrueQ", "[", 
     RowBox[{"And", "@@", 
      RowBox[{"Thread", "[", 
       RowBox[{
       "min", "\[LessEqual]", " ", "list", "\[LessEqual]", " ", "max"}], 
       "]"}]}], "]"}]}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"DistributionDomainQ", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", 
      RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], ",", "x_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"N", "[", "x", "]"}], ",", "Complex"}], "]"}], "&&", 
    RowBox[{"TrueQ", "[", 
     RowBox[{"min", "\[LessEqual]", "x", "\[LessEqual]", "max"}], "]"}]}]}], 
  ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Domain", "Subsubsection"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"Domain", "[", 
   RowBox[{"BSplineDistribution", "[", "n_", "]"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Interval", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"n", "+", "1"}], "2"]}], ",", 
      FractionBox[
       RowBox[{"n", "+", "1"}], "2"]}], "}"}], "]"}], " ", "/;", 
   RowBox[{"DistributionParameterQ", "[", 
    RowBox[{"BSplineDistribution", "[", "n", "]"}], "]"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"Domain", "[", 
   RowBox[{"BSplineDistribution", "[", 
    RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Interval", "[", 
    RowBox[{"{", 
     RowBox[{"min", ",", "max"}], "}"}], "]"}], "/;", 
   RowBox[{"DistributionParameterQ", "[", 
    RowBox[{"BSplineDistribution", "[", 
     RowBox[{"n", ",", "min", ",", "max"}], "]"}], "]"}]}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["PDF", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["0", "th"], "Order"}]], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"PDF", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", "0", "]"}], ",", "x_"}], "]"}], "=", 
   
   RowBox[{"Piecewise", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "/", "2"}], ",", 
         RowBox[{
          RowBox[{"x", "\[Equal]", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "2"}]}], "||", 
          RowBox[{"x", "\[Equal]", 
           RowBox[{"1", "/", "2"}]}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "1"}], "/", "2"}], "<", "x", "<", 
          RowBox[{"1", "/", "2"}]}]}], "}"}]}], "}"}], ",", "0"}], "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"PDF", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", 
      RowBox[{"0", ",", "min_", ",", "max_"}], "]"}], ",", "x_"}], "]"}], "=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"2", 
          RowBox[{"(", 
           RowBox[{"max", "-", "min"}], ")"}]}]], ",", 
        RowBox[{
         RowBox[{"x", "\[Equal]", "min"}], "||", 
         RowBox[{"x", "\[Equal]", "max"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"max", "-", "min"}]], ",", 
        RowBox[{"0", "<", 
         FractionBox[
          RowBox[{"x", "-", "min"}], 
          RowBox[{"max", "-", "min"}]], "<", "1"}]}], "}"}]}], "}"}], "]"}]}],
   ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["1", "st"], "Order"}]], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"PDF", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", "1", "]"}], ",", "x_"}], "]"}], "=", 
   
   RowBox[{"Piecewise", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "+", "x"}], ",", 
         RowBox[{
          RowBox[{"-", "1"}], "<", "x", "<=", "0"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "-", "x"}], ",", 
         RowBox[{"0", "<", "x", "<", "1"}]}], "}"}]}], "}"}], ",", "0"}], 
    "]"}]}], ";"}]], "PackageInput",
 Evaluatable->False],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"PDF", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", 
      RowBox[{"1", ",", "min_", ",", "max_"}], "]"}], ",", "x_"}], "]"}], "=", 
   RowBox[{
    FractionBox["1", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"max", "-", "min"}], ")"}], "2"]], "*", " ", 
    RowBox[{"Piecewise", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"4", "*", 
           RowBox[{"(", 
            RowBox[{"x", "-", "min"}], ")"}]}], ",", 
          RowBox[{
           RowBox[{"-", "2"}], "<", 
           RowBox[{"2", "*", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", "*", "x"}], "-", "max", "-", "min"}], ")"}], "/", 
             
             RowBox[{"(", 
              RowBox[{"max", "-", "min"}], ")"}]}]}], "<=", "0"}]}], "}"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"4", "*", 
           RowBox[{"(", 
            RowBox[{"max", "-", "x"}], ")"}]}], ",", 
          RowBox[{"0", "<", 
           RowBox[{"2", "*", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", "*", "x"}], "-", "max", "-", "min"}], ")"}], "/", 
             
             RowBox[{"(", 
              RowBox[{"max", "-", "min"}], ")"}]}]}], "<", "2"}]}], "}"}]}], 
       "}"}], ",", "0"}], "]"}]}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["2", "nd"], "Order"}]], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"PDF", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", "2", "]"}], ",", "x_"}], "]"}], "=", 
   
   RowBox[{"Piecewise", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"3", "+", 
             RowBox[{"2", "*", "x"}]}], ")"}], "^", "2"}], "/", "8"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "3"}], "/", "2"}], "<", "x", "<=", 
          RowBox[{
           RowBox[{"-", "1"}], "/", "2"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"3", "/", "4"}], "-", 
          RowBox[{"x", "^", "2"}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "1"}], "/", "2"}], "<", "x", "<=", 
          RowBox[{"1", "/", "2"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"3", "-", 
             RowBox[{"2", "*", "x"}]}], ")"}], "^", "2"}], "/", "8"}], ",", 
         RowBox[{
          RowBox[{"1", "/", "2"}], "<", "x", "<", 
          RowBox[{"3", "/", "2"}]}]}], "}"}]}], "}"}], ",", "0"}], "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"PDF", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", 
      RowBox[{"2", ",", "min_", ",", "max_"}], "]"}], ",", "x_"}], "]"}], "=", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", "*", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"max", "-", "min"}], ")"}], "3"]}]], "*", 
    RowBox[{"Piecewise", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"27", "*", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"min", "-", "x"}], ")"}], "^", "2"}]}], ",", 
          RowBox[{
           RowBox[{"-", "3"}], "<", 
           RowBox[{"3", "*", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "max"}], "-", "min", "+", 
               RowBox[{"2", "*", "x"}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"max", "-", "min"}], ")"}]}]}], "<=", 
           RowBox[{"-", "1"}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "9"}], "*", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"max", "^", "2"}], "+", 
             RowBox[{"4", "*", "max", "*", "min"}], "+", 
             RowBox[{"min", "^", "2"}], "-", 
             RowBox[{"6", "*", 
              RowBox[{"(", 
               RowBox[{"max", "+", "min"}], ")"}], "*", "x"}], "+", 
             RowBox[{"6", "*", 
              RowBox[{"x", "^", "2"}]}]}], ")"}]}], ",", 
          RowBox[{
           RowBox[{"-", "1"}], "<", 
           RowBox[{"3", "*", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "max"}], "-", "min", "+", 
               RowBox[{"2", "*", "x"}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"max", "-", "min"}], ")"}]}]}], "<=", "1"}]}], "}"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"27", "*", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"max", "-", "x"}], ")"}], "^", "2"}]}], ",", 
          RowBox[{"1", "<", 
           RowBox[{"3", "*", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "max"}], "-", "min", "+", 
               RowBox[{"2", "*", "x"}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"max", "-", "min"}], ")"}]}]}], "<", "3"}]}], "}"}]}], 
       "}"}], ",", "0"}], "]"}]}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["3", "rd"], "Order"}]], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"PDF", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", "3", "]"}], ",", "x_"}], "]"}], "=", 
   "\[IndentingNewLine]", 
   RowBox[{"Piecewise", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"2", "+", "x"}], ")"}], "^", "3"}], "/", "6"}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], "<", "x", "<=", 
          RowBox[{"-", "1"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"4", "-", 
            RowBox[{"3", "*", 
             RowBox[{"x", "^", "2"}], "*", 
             RowBox[{"(", 
              RowBox[{"2", "+", "x"}], ")"}]}]}], ")"}], "/", "6"}], ",", 
         RowBox[{
          RowBox[{"-", "1"}], "<", "x", "<=", "0"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"4", "+", 
            RowBox[{"3", "*", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "2"}], "+", "x"}], ")"}], "*", 
             RowBox[{"x", "^", "2"}]}]}], ")"}], "/", "6"}], ",", 
         RowBox[{"0", "<", "x", "<=", "1"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "2"}], "+", "x"}], ")"}], "^", "3"}]}], "/", "6"}],
          ",", 
         RowBox[{"1", "<", "x", "<", "2"}]}], "}"}]}], "}"}], ",", "0"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"PDF", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", 
      RowBox[{"3", ",", "min_", ",", "max_"}], "]"}], ",", "x_"}], "]"}], "=",
    "\[IndentingNewLine]", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"3", "*", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"max", "-", "min"}], ")"}], "4"]}]], "*", 
    "\[IndentingNewLine]", 
    RowBox[{"Piecewise", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "128"}], "*", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"min", "-", "x"}], ")"}], "^", "3"}]}], ",", 
          RowBox[{
           RowBox[{"-", "4"}], "<", 
           RowBox[{"4", "*", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "max"}], "-", "min", "+", 
               RowBox[{"2", "*", "x"}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"max", "-", "min"}], ")"}]}]}], "<=", 
           RowBox[{"-", "2"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"8", "*", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"max", "^", "3"}], "+", 
             RowBox[{"11", "*", 
              RowBox[{"min", "^", "3"}]}], "+", 
             RowBox[{"3", "*", 
              RowBox[{"max", "^", "2"}], "*", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"3", "*", "min"}], "-", 
                RowBox[{"4", "*", "x"}]}], ")"}]}], "+", 
             RowBox[{"3", "*", "max", "*", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"3", "*", "min"}], "-", 
                 RowBox[{"4", "*", "x"}]}], ")"}], "^", "2"}]}], "-", 
             RowBox[{"60", "*", 
              RowBox[{"min", "^", "2"}], "*", "x"}], "+", 
             RowBox[{"96", "*", "min", "*", 
              RowBox[{"x", "^", "2"}]}], "-", 
             RowBox[{"48", "*", 
              RowBox[{"x", "^", "3"}]}]}], ")"}]}], ",", 
          RowBox[{
           RowBox[{"-", "2"}], "<", 
           RowBox[{"4", "*", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "max"}], "-", "min", "+", 
               RowBox[{"2", "*", "x"}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"max", "-", "min"}], ")"}]}]}], "<=", "0"}]}], "}"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"-", "8"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"11", "*", 
               RowBox[{"max", "^", "3"}]}], "+", 
              RowBox[{"27", "*", 
               RowBox[{"max", "^", "2"}], "*", "min"}], "+", 
              RowBox[{"9", "*", "max", "*", 
               RowBox[{"min", "^", "2"}]}], "+", 
              RowBox[{"min", "^", "3"}]}], ")"}]}], "+", 
           RowBox[{"96", "*", 
            RowBox[{"(", 
             RowBox[{"max", "+", "min"}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"5", "*", "max"}], "+", "min"}], ")"}], "*", "x"}], "-", 
           RowBox[{"384", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "*", "max"}], "+", "min"}], ")"}], "*", 
            RowBox[{"x", "^", "2"}]}], "+", 
           RowBox[{"384", "*", 
            RowBox[{"x", "^", "3"}]}]}], ",", 
          RowBox[{"0", "<", 
           RowBox[{"4", "*", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "max"}], "-", "min", "+", 
               RowBox[{"2", "*", "x"}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"max", "-", "min"}], ")"}]}]}], "<=", "2"}]}], "}"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"128", "*", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"max", "-", "x"}], ")"}], "^", "3"}]}], ",", 
          RowBox[{"2", "<", 
           RowBox[{"4", "*", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "max"}], "-", "min", "+", 
               RowBox[{"2", "*", "x"}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"max", "-", "min"}], ")"}]}]}], "<", "4"}]}], "}"}]}], 
       "}"}], ",", "0"}], "\[IndentingNewLine]", "]"}]}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["n", "th"], "Order"}]], "Text"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"PDF", "[", 
   RowBox[{
    RowBox[{"BSplineDistribution", "[", "n_", "]"}], ",", "x_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", " ", 
      RowBox[{"n", "!"}]}]], 
    RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"k", "=", "0"}], 
      RowBox[{"n", "+", "1"}]], 
     RowBox[{
      RowBox[{"Binomial", "[", 
       RowBox[{
        RowBox[{"n", "+", "1"}], ",", "k"}], "]"}], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"x", "+", 
         FractionBox[
          RowBox[{"n", "+", "1"}], "2"], "-", "k"}], ")"}], "n"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], "k"], " ", 
      RowBox[{"Sign", "[", 
       RowBox[{"x", "+", 
        FractionBox[
         RowBox[{"n", "+", "1"}], "2"], "-", "k"}], "]"}]}]}]}], "/;", " ", 
   RowBox[{"NumberQ", "[", "x", "]"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"PDF", "[", 
   RowBox[{
    RowBox[{"BSplineDistribution", "[", "n_", "]"}], ",", "x_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Piecewise", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Simplify", "[", 
         RowBox[{
          FractionBox["1", 
           RowBox[{"2", " ", 
            RowBox[{"n", "!"}]}]], 
          RowBox[{
           UnderoverscriptBox["\[Sum]", 
            RowBox[{"k", "=", "0"}], 
            RowBox[{"n", "+", "1"}]], 
           RowBox[{
            RowBox[{"Binomial", "[", 
             RowBox[{
              RowBox[{"n", "+", "1"}], ",", "k"}], "]"}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"x", "+", 
               FractionBox[
                RowBox[{"n", "+", "1"}], "2"], "-", "k"}], ")"}], "n"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], "k"], " ", 
            RowBox[{"Sign", "[", 
             RowBox[{"i", "+", 
              FractionBox[
               RowBox[{"n", "+", "1"}], "2"], "-", "k"}], "]"}]}]}]}], "]"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"Simplify", "[", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "<", 
            FractionBox["n", "2"]}], ",", 
           RowBox[{
            RowBox[{"i", "-", 
             FractionBox["1", "2"]}], "<", "x", "\[LessEqual]", " ", 
            RowBox[{"i", "+", 
             FractionBox["1", "2"]}]}], ",", 
           RowBox[{
            RowBox[{"i", "-", 
             FractionBox["1", "2"]}], "<", "x", "<", " ", 
            RowBox[{"i", "+", 
             FractionBox["1", "2"]}]}]}], "]"}], "]"}]}], 
       "\[IndentingNewLine]", "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        FractionBox[
         RowBox[{"-", "n"}], "2"], ",", 
        FractionBox["n", "2"]}], "}"}]}], "]"}], "]"}], "/;", 
   RowBox[{"DistributionParameterQ", "[", 
    RowBox[{"BSplineDistribution", "[", "n", "]"}], "]"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"PDF", "[", 
   RowBox[{
    RowBox[{"BSplineDistribution", "[", 
     RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], ",", "x_"}], "]"}], ":=", 
  RowBox[{
   FractionBox[
    RowBox[{"n", "+", "1"}], 
    RowBox[{"max", "-", "min"}]], 
   RowBox[{"PDF", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", "n", "]"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"n", "+", "1"}], ")"}], 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"x", "-", "min"}], 
         RowBox[{"max", "-", "min"}]], "-", 
        FractionBox["1", "2"]}], ")"}]}]}], "]"}]}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "CDF ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"CDF", "[", "x", "]"}], "  ", "=", " ", 
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     RowBox[{"-", "\[Infinity]"}], "x"], 
    RowBox[{
     RowBox[{"PDF", "[", "y", "]"}], 
     RowBox[{"\[DifferentialD]", "y"}]}]}]}]]]
}], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["0", "th"], "Order"}]], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"CDF", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", "0", "]"}], ",", "x_"}], "]"}], "=", 
   
   RowBox[{"Piecewise", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["1", "2"], "+", "x"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], "<", "x", "<=", 
          FractionBox["1", "2"]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{
          FractionBox["1", "2"], "<", "x"}]}], "}"}]}], "}"}], ",", "0"}], 
    "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"CDF", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", 
      RowBox[{"0", ",", "min_", ",", "max_"}], "]"}], ",", "x_"}], "]"}], "=",
    "\[IndentingNewLine]", 
   RowBox[{"Piecewise", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "min"}], "+", "x"}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"max", "-", "min"}], ")"}]}], ",", 
         RowBox[{
          RowBox[{"-", "1"}], "<", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", "*", "x"}], "-", "max", "-", "min"}], ")"}], "/", 
           RowBox[{"(", 
            RowBox[{"max", "-", "min"}], ")"}]}], "<=", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"max", "<", "x"}]}], "}"}]}], "}"}], ",", "0"}], "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["1", "st"], "Order"}]], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"CDF", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", "1", "]"}], ",", "x_"}], "]"}], "=", 
   
   RowBox[{"Piecewise", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["1", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", "x"}], ")"}], "2"]}], ",", 
         RowBox[{
          RowBox[{"-", "1"}], " ", "<", "x", "\[LessEqual]", "0"}]}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["1", "2"], "+", "x", "-", 
          FractionBox[
           SuperscriptBox["x", "2"], "2"]}], ",", 
         RowBox[{"0", "<", "x", "\[LessEqual]", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"1", "<", "x"}]}], "}"}]}], "}"}], ",", "0"}], "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"CDF", "[", 
   RowBox[{
    RowBox[{"BSplineDistribution", "[", 
     RowBox[{"1", ",", "min_", ",", "max_"}], "]"}], ",", "x_"}], "]"}], "=", 
  
  RowBox[{"Piecewise", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", "*", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"min", "-", "x"}], ")"}], "^", "2"}]}], ")"}], "/", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"max", "-", "min"}], ")"}], "^", "2"}]}], ",", 
        RowBox[{
         RowBox[{"-", "1"}], "<", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "*", "x"}], "-", "max", "-", "min"}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"max", "-", "min"}], ")"}]}], "<=", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"max", "^", "2"}]}], "-", 
           RowBox[{"2", "*", "max", "*", "min"}], "+", 
           RowBox[{"min", "^", "2"}], "+", 
           RowBox[{"4", "*", "max", "*", "x"}], "-", 
           RowBox[{"2", "*", 
            RowBox[{"x", "^", "2"}]}]}], ")"}], "/", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"max", "-", "min"}], ")"}], "^", "2"}]}], ",", 
        RowBox[{"0", "<", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "*", "x"}], "-", "max", "-", "min"}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"max", "-", "min"}], ")"}]}], "<=", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"max", "<", "x"}]}], "}"}]}], "}"}], ",", "0"}], 
   "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["2", "nd"], "Order"}]], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"CDF", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", "2", "]"}], ",", "x_"}], "]"}], "=", 
   
   RowBox[{"Piecewise", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["1", "48"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"3", "+", 
             RowBox[{"2", " ", "x"}]}], ")"}], "3"]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], "<", "x", "\[LessEqual]", 
          RowBox[{"-", 
           FractionBox["1", "2"]}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["1", "12"], " ", 
          RowBox[{"(", 
           RowBox[{"6", "+", 
            RowBox[{"9", " ", "x"}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["x", "3"]}]}], ")"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], "<", "x", "\[LessEqual]", 
          FractionBox["1", "2"]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["1", "48"], " ", 
          RowBox[{"(", 
           RowBox[{"21", "+", 
            RowBox[{"2", " ", "x", " ", 
             RowBox[{"(", 
              RowBox[{"27", "+", 
               RowBox[{"2", " ", "x", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "9"}], "+", 
                  RowBox[{"2", " ", "x"}]}], ")"}]}]}], ")"}]}]}], ")"}]}], 
         ",", 
         RowBox[{
          FractionBox["1", "2"], "<", "x", "\[LessEqual]", 
          FractionBox["3", "2"]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{
          FractionBox["3", "2"], "<", "x"}]}], "}"}]}], "}"}], ",", "0"}], 
    "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"CDF", "[", 
   RowBox[{
    RowBox[{"BSplineDistribution", "[", 
     RowBox[{"2", ",", "min_", ",", "max_"}], "]"}], ",", "x_"}], "]"}], "=", 
  
  RowBox[{"Piecewise", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "9"}], "*", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"min", "-", "x"}], ")"}], "^", "3"}]}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"2", "*", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"max", "-", "min"}], ")"}], "^", "3"}]}], ")"}]}], ",", 
        RowBox[{
         RowBox[{"-", "1"}], "<", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "*", "x"}], "-", "max", "-", "min"}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"max", "-", "min"}], ")"}]}], "<=", 
         RowBox[{
          RowBox[{"-", "1"}], "/", "3"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"4", "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"36", "*", 
              RowBox[{"(", 
               RowBox[{"max", "+", "min", "-", 
                RowBox[{"2", "*", "x"}]}], ")"}], "*", 
              RowBox[{"(", 
               RowBox[{"max", "-", "x"}], ")"}], "*", 
              RowBox[{"(", 
               RowBox[{"min", "-", "x"}], ")"}]}], ")"}], "/", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"max", "-", "min"}], ")"}], "^", "3"}]}]}], ")"}], "/", 
         "8"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "1"}], "/", "3"}], "<", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "*", "x"}], "-", "max", "-", "min"}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"max", "-", "min"}], ")"}]}], "<=", 
         RowBox[{"1", "/", "3"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "7"}], "*", 
            RowBox[{"max", "^", "3"}]}], "-", 
           RowBox[{"2", "*", 
            RowBox[{"min", "^", "3"}]}], "+", 
           RowBox[{"9", "*", 
            RowBox[{"x", "^", "3"}]}], "+", 
           RowBox[{"3", "*", 
            RowBox[{"max", "^", "2"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "2"}], "*", "min"}], "+", 
              RowBox[{"9", "*", "x"}]}], ")"}]}], "+", 
           RowBox[{"3", "*", "max", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "*", 
               RowBox[{"min", "^", "2"}]}], "-", 
              RowBox[{"9", "*", 
               RowBox[{"x", "^", "2"}]}]}], ")"}]}]}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"2", "*", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"max", "-", "min"}], ")"}], "^", "3"}]}], ")"}]}], ",", 
        RowBox[{
         RowBox[{"1", "/", "3"}], "<", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "*", "x"}], "-", "max", "-", "min"}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"max", "-", "min"}], ")"}]}], "<=", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"max", "<", "x"}]}], "}"}]}], "}"}], ",", "0"}], 
   "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["3", "rd"], "Order"}]], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"CDF", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", "3", "]"}], ",", "x_"}], "]"}], "=", 
   
   RowBox[{"Piecewise", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["1", "24"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"2", "+", "x"}], ")"}], "4"]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], "<", "x", "\[LessEqual]", 
          RowBox[{"-", "1"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["1", "24"], " ", 
          RowBox[{"(", 
           RowBox[{"2", "-", 
            SuperscriptBox["x", "2"]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"6", "+", 
            RowBox[{"x", " ", 
             RowBox[{"(", 
              RowBox[{"8", "+", 
               RowBox[{"3", " ", "x"}]}], ")"}]}]}], ")"}]}], ",", 
         RowBox[{
          RowBox[{"-", "1"}], "<", "x", "\[LessEqual]", "0"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["1", "24"], " ", 
          RowBox[{"(", 
           RowBox[{"12", "+", 
            RowBox[{"16", " ", "x"}], "-", 
            RowBox[{"8", " ", 
             SuperscriptBox["x", "3"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["x", "4"]}]}], ")"}]}], ",", 
         RowBox[{"0", "<", "x", "\[LessEqual]", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "-", 
          RowBox[{
           FractionBox["1", "24"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "2"}], "+", "x"}], ")"}], "4"]}]}], ",", 
         RowBox[{"1", "<", "x", "\[LessEqual]", "2"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"2", "<", "x"}]}], "}"}]}], "}"}], ",", "0"}], "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"CDF", "[", 
   RowBox[{
    RowBox[{"BSplineDistribution", "[", 
     RowBox[{"3", ",", "min_", ",", "max_"}], "]"}], ",", "x_"}], "]"}], "=", 
  
  RowBox[{"Piecewise", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"32", "*", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"min", "-", "x"}], ")"}], "^", "4"}]}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"3", "*", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"max", "-", "min"}], ")"}], "^", "4"}]}], ")"}]}], ",", 
        RowBox[{
         RowBox[{"-", "1"}], "<", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "*", "x"}], "-", "max", "-", "min"}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"max", "-", "min"}], ")"}]}], "<=", 
         RowBox[{
          RowBox[{"-", "1"}], "/", "2"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"max", "^", "2"}], "+", 
              RowBox[{"6", "*", "max", "*", "min"}], "+", 
              RowBox[{"min", "^", "2"}], "-", 
              RowBox[{"8", "*", 
               RowBox[{"(", 
                RowBox[{"max", "+", "min"}], ")"}], "*", "x"}], "+", 
              RowBox[{"8", "*", 
               RowBox[{"x", "^", "2"}]}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"max", "^", "2"}], "+", 
              RowBox[{"6", "*", "max", "*", "min"}], "+", 
              RowBox[{"17", "*", 
               RowBox[{"min", "^", "2"}]}], "-", 
              RowBox[{"8", "*", 
               RowBox[{"(", 
                RowBox[{"max", "+", 
                 RowBox[{"5", "*", "min"}]}], ")"}], "*", "x"}], "+", 
              RowBox[{"24", "*", 
               RowBox[{"x", "^", "2"}]}]}], ")"}]}], ")"}]}], "/", 
         RowBox[{"(", 
          RowBox[{"6", "*", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"max", "-", "min"}], ")"}], "^", "4"}]}], ")"}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "1"}], "/", "2"}], "<", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "*", "x"}], "-", "max", "-", "min"}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"max", "-", "min"}], ")"}]}], "<=", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"12", "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"32", "*", 
              RowBox[{"(", 
               RowBox[{"max", "+", "min", "-", 
                RowBox[{"2", "*", "x"}]}], ")"}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"max", "-", "min"}], ")"}]}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"64", "*", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"max", "+", "min", "-", 
                 RowBox[{"2", "*", "x"}]}], ")"}], "^", "3"}]}], ")"}], "/", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"max", "-", "min"}], ")"}], "^", "3"}]}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"48", "*", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"max", "+", "min", "-", 
                 RowBox[{"2", "*", "x"}]}], ")"}], "^", "4"}]}], ")"}], "/", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"max", "-", "min"}], ")"}], "^", "4"}]}]}], ")"}], "/", 
         "24"}], ",", 
        RowBox[{"0", "<", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "*", "x"}], "-", "max", "-", "min"}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"max", "-", "min"}], ")"}]}], "<=", 
         RowBox[{"1", "/", "2"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"32", "*", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"max", "-", "x"}], ")"}], "^", "4"}]}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"3", "*", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"max", "-", "min"}], ")"}], "^", "4"}]}], ")"}]}]}], 
        ",", 
        RowBox[{
         RowBox[{"1", "/", "2"}], "<", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "*", "x"}], "-", "max", "-", "min"}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"max", "-", "min"}], ")"}]}], "<=", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"max", "<", "x"}]}], "}"}]}], "}"}], ",", "0"}], 
   "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["n", "nt"], "Order"}]], "Text"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"CDF", "[", 
   RowBox[{
    RowBox[{"BSplineDistribution", "[", "n_", "]"}], ",", "x_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], "+", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"2", " ", 
       RowBox[{"n", "!"}]}]], 
     RowBox[{
      UnderoverscriptBox["\[Sum]", 
       RowBox[{"k", "=", "0"}], 
       RowBox[{"n", "+", "1"}]], 
      RowBox[{
       RowBox[{"Binomial", "[", 
        RowBox[{
         RowBox[{"n", "+", "1"}], ",", "k"}], "]"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"x", "+", 
          FractionBox[
           RowBox[{"n", "+", "1"}], "2"], "-", "k"}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"n", "+", "1"}], ")"}]}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", "1"}], ")"}], "^", "k"}], "*", 
       RowBox[{
        RowBox[{"Sign", "[", 
         RowBox[{"x", "+", 
          FractionBox[
           RowBox[{"n", "+", "1"}], "2"], "-", "k"}], "]"}], "/", 
        RowBox[{"(", 
         RowBox[{"n", "+", "1"}], ")"}]}]}]}]}]}], "/;", " ", 
   RowBox[{"NumberQ", "[", "x", "]"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"CDF", "[", 
   RowBox[{
    RowBox[{"BSplineDistribution", "[", "n_", "]"}], ",", "x_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Piecewise", "[", 
    RowBox[{"Append", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Simplify", "[", 
           RowBox[{
            FractionBox["1", "2"], "+", 
            RowBox[{
             FractionBox["1", 
              RowBox[{"2", " ", 
               RowBox[{"n", "!"}]}]], 
             RowBox[{
              UnderoverscriptBox["\[Sum]", 
               RowBox[{"k", "=", "0"}], 
               RowBox[{"n", "+", "1"}]], 
              RowBox[{
               RowBox[{"Binomial", "[", 
                RowBox[{
                 RowBox[{"n", "+", "1"}], ",", "k"}], "]"}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"x", "+", 
                  FractionBox[
                   RowBox[{"n", "+", "1"}], "2"], "-", "k"}], ")"}], "^", 
                RowBox[{"(", 
                 RowBox[{"n", "+", "1"}], ")"}]}], "*", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"-", "1"}], ")"}], "^", "k"}], "*", 
               RowBox[{
                RowBox[{"Sign", "[", 
                 RowBox[{"i", "+", 
                  FractionBox[
                   RowBox[{"n", "+", "1"}], "2"], "-", "k"}], "]"}], "/", 
                RowBox[{"(", 
                 RowBox[{"n", "+", "1"}], ")"}]}]}]}]}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"i", "-", 
            FractionBox["1", "2"]}], "<", "x", "\[LessEqual]", " ", 
           RowBox[{"i", "+", 
            FractionBox["1", "2"]}]}]}], "\[IndentingNewLine]", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{"-", 
           FractionBox["n", "2"]}], ",", 
          FractionBox["n", "2"]}], "}"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{
         FractionBox[
          RowBox[{"n", "+", "1"}], "2"], "<", "x"}]}], "}"}]}], "]"}], "]"}], 
   "/;", 
   RowBox[{"DistributionParameterQ", "[", 
    RowBox[{"BSplineDistribution", "[", "n", "]"}], "]"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"CDF", "[", 
   RowBox[{
    RowBox[{"BSplineDistribution", "[", 
     RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], ",", "x_"}], "]"}], ":=",
   " ", 
  RowBox[{"CDF", "[", 
   RowBox[{
    RowBox[{"BSplineDistribution", "[", "n", "]"}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"n", "+", "1"}], ")"}], 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"x", "-", "min"}], 
        RowBox[{"max", "-", "min"}]], "-", 
       FractionBox["1", "2"]}], ")"}]}]}], "]"}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Mean ",
 Cell[BoxData[
  RowBox[{"\[Mu]", " ", "=", " ", 
   RowBox[{
    SubscriptBox["\[Mu]", "1"], "=", " ", 
    RowBox[{"\[LeftAngleBracket]", "x", "\[RightAngleBracket]"}]}]}]]]
}], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"Mean", "[", 
    RowBox[{"BSplineDistribution", "[", "n_", "]"}], "]"}], "=", "0"}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"Mean", "[", 
   RowBox[{"BSplineDistribution", "[", 
    RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], "]"}], "=", 
  FractionBox[
   RowBox[{"max", "+", "min"}], "2"]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Variance ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["\[Mu]", "2"], "=", 
   RowBox[{
    RowBox[{"\[LeftAngleBracket]", 
     SuperscriptBox["x", "2"], "\[RightAngleBracket]"}], " ", "-", " ", 
    SuperscriptBox[
     RowBox[{"\[LeftAngleBracket]", "x", "\[RightAngleBracket]"}], "2"]}]}]]]
}], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"Variance", "[", 
    RowBox[{"BSplineDistribution", "[", "n_", "]"}], "]"}], "=", 
   FractionBox[
    RowBox[{"n", "+", "1"}], "12"]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"Variance", "[", 
    RowBox[{"BSplineDistribution", "[", 
     RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], "]"}], "=", 
   RowBox[{
    FractionBox["1", "12"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"max", "+", "min"}], ")"}], "2"]}], "+", 
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"max", "-", "min"}], ")"}], "2"], 
       RowBox[{"1", "+", "n"}]]}], ")"}]}]}], ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Standard Deviation ",
 Cell[BoxData[
  RowBox[{"\[Sigma]", " ", "=", " ", 
   SqrtBox[
    SubscriptBox["\[Mu]", "2"]]}]]]
}], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"StandardDeviation", "[", 
    RowBox[{"BSplineDistribution", "[", "n_", "]"}], "]"}], "=", 
   SqrtBox[
    FractionBox[
     RowBox[{"n", "+", "1"}], "12"]]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"StandardDeviation", "[", 
    RowBox[{"BSplineDistribution", "[", 
     RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], "]"}], "=", 
   SqrtBox[
    RowBox[{
     FractionBox["1", "12"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"max", "+", "min"}], ")"}], "2"]}], "+", 
       FractionBox[
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"max", "-", "min"}], ")"}], "2"], 
        RowBox[{"1", "+", "n"}]]}], ")"}]}]]}], ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Skewness  ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["\[Gamma]", "1"], "=", " ", 
   FractionBox[
    SubscriptBox["\[Mu]", "3"], 
    SuperscriptBox[
     SubscriptBox["\[Mu]", "2"], 
     RowBox[{"3", "/", "2"}]]]}]]]
}], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"Skewness", "[", 
    RowBox[{"BSplineDistribution", "[", "n_", "]"}], "]"}], "=", "0"}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"Skewness", "[", 
    RowBox[{"BSplineDistribution", "[", 
     RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], "]"}], "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"3", "*", 
      RowBox[{"Sqrt", "[", "3", "]"}], "*", 
      RowBox[{"(", 
       RowBox[{"max", "+", "min"}], ")"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"max", "^", "2"}], "+", 
           RowBox[{"min", "^", "2"}]}], ")"}]}], "+", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"max", "+", "min"}], ")"}], "^", "2"}], "*", "n"}]}], 
       ")"}]}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "n"}], ")"}], "*", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", "*", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"max", "+", "min"}], ")"}], "^", "2"}]}], "+", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"max", "-", "min"}], ")"}], "^", "2"}], "/", 
          RowBox[{"(", 
           RowBox[{"1", "+", "n"}], ")"}]}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"3", "/", "2"}], ")"}]}]}], ")"}]}]}], ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Kurtosis  ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["\[Beta]", "2"], "=", " ", 
   FractionBox[
    SubscriptBox["\[Mu]", "4"], 
    SuperscriptBox[
     SubscriptBox["\[Mu]", "2"], "2"]]}]]]
}], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"Kurtosis", "[", 
    RowBox[{"BSplineDistribution", "[", "n_", "]"}], "]"}], "=", 
   FractionBox[
    RowBox[{"9", "+", 
     RowBox[{"15", " ", "n"}]}], 
    RowBox[{"5", " ", 
     RowBox[{"(", 
      RowBox[{"n", "+", "1"}], ")"}]}]]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"Kurtosis", "[", 
    RowBox[{"BSplineDistribution", "[", 
     RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], "]"}], "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"5", "-", 
      RowBox[{"6", "/", 
       RowBox[{"(", 
        RowBox[{"1", "+", "n"}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"8", "*", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"max", "-", "min"}], ")"}], "^", "2"}], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"max", "^", "2"}], "+", 
           RowBox[{"7", "*", "max", "*", "min"}], "+", 
           RowBox[{"min", "^", "2"}]}], ")"}]}], ")"}], "/", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"4", "*", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"max", "^", "2"}], "+", 
             RowBox[{"max", "*", "min"}], "+", 
             RowBox[{"min", "^", "2"}]}], ")"}]}], "+", 
          RowBox[{"3", "*", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"max", "+", "min"}], ")"}], "^", "2"}], "*", "n"}]}], 
         ")"}], "^", "2"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"38", "*", 
          RowBox[{"max", "^", "2"}]}], "-", 
         RowBox[{"4", "*", "max", "*", "min"}], "+", 
         RowBox[{"38", "*", 
          RowBox[{"min", "^", "2"}]}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"4", "*", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"max", "^", "2"}], "+", 
            RowBox[{"max", "*", "min"}], "+", 
            RowBox[{"min", "^", "2"}]}], ")"}]}], "+", 
         RowBox[{"3", "*", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"max", "+", "min"}], ")"}], "^", "2"}], "*", "n"}]}], 
        ")"}]}]}], ")"}], "/", "5"}]}], ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "KurtosisExcess ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["\[Gamma]", "2"], "=", " ", 
   RowBox[{
    FractionBox[
     SubscriptBox["\[Mu]", "4"], 
     SuperscriptBox[
      SubscriptBox["\[Mu]", "2"], "2"]], "-", "3"}]}]]]
}], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"KurtosisExcess", "[", 
    RowBox[{"BSplineDistribution", "[", "n_", "]"}], "]"}], "=", 
   RowBox[{"-", 
    FractionBox["6", 
     RowBox[{"5", " ", 
      RowBox[{"(", 
       RowBox[{"n", "+", "1"}], ")"}]}]]}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"KurtosisExcess", "[", 
    RowBox[{"BSplineDistribution", "[", 
     RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], "]"}], "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "10"}], "-", 
      RowBox[{"6", "/", 
       RowBox[{"(", 
        RowBox[{"1", "+", "n"}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"8", "*", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"max", "-", "min"}], ")"}], "^", "2"}], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"max", "^", "2"}], "+", 
           RowBox[{"7", "*", "max", "*", "min"}], "+", 
           RowBox[{"min", "^", "2"}]}], ")"}]}], ")"}], "/", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"4", "*", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"max", "^", "2"}], "+", 
             RowBox[{"max", "*", "min"}], "+", 
             RowBox[{"min", "^", "2"}]}], ")"}]}], "+", 
          RowBox[{"3", "*", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"max", "+", "min"}], ")"}], "^", "2"}], "*", "n"}]}], 
         ")"}], "^", "2"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"38", "*", 
          RowBox[{"max", "^", "2"}]}], "-", 
         RowBox[{"4", "*", "max", "*", "min"}], "+", 
         RowBox[{"38", "*", 
          RowBox[{"min", "^", "2"}]}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"4", "*", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"max", "^", "2"}], "+", 
            RowBox[{"max", "*", "min"}], "+", 
            RowBox[{"min", "^", "2"}]}], ")"}]}], "+", 
         RowBox[{"3", "*", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"max", "+", "min"}], ")"}], "^", "2"}], "*", "n"}]}], 
        ")"}]}]}], ")"}], "/", "5"}]}], ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "CharacteristicFunction ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"\[Phi]", "[", "t", "]"}], "=", 
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     RowBox[{"-", "\[Infinity]"}], "\[Infinity]"], 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", "t", " ", "x"}]], " ", 
     RowBox[{"PDF", "[", "x", "]"}], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]]]
}], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", " ", 
   RowBox[{"CharacteristicFunction", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", "n_", "]"}], ",", "t_"}], "]"}], " ",
    "=", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox[
      RowBox[{"2", " ", 
       RowBox[{"Sin", "[", 
        FractionBox["t", "2"], "]"}]}], "t"], ")"}], 
    RowBox[{"n", "+", "1"}]]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", " ", 
   RowBox[{"CharacteristicFunction", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", 
      RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], ",", "t_"}], "]"}], 
   " ", "=", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"n", "+", "1"}], ")"}], 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"\[ImaginaryI]", " ", 
            FractionBox["min", 
             RowBox[{"n", "+", "1"}]], " ", "t"}]], "-", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"\[ImaginaryI]", " ", 
            FractionBox["max", 
             RowBox[{"n", "+", "1"}]], " ", "t"}]]}], ")"}]}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"max", "-", "min"}], ")"}], " ", "t"}]]}], ")"}], 
    RowBox[{"n", "+", "1"}]]}], ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Quantile ",
 Cell[BoxData[
  RowBox[{
   SuperscriptBox["CDF", 
    RowBox[{"-", "1"}]], "[", "x", "]"}]]]
}], "Subsubsection"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["0", "th"], "Order"}]], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"Quantile", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", "0", "]"}], ",", "x_"}], "]"}], "=", 
   
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", "2"]}], ",", 
        RowBox[{"x", "<", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          FractionBox["1", "2"]}], "+", "x"}], ",", 
        RowBox[{"0", "\[LessEqual]", "x", "\[LessEqual]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        FractionBox["1", "2"], ",", 
        RowBox[{"1", "<", "x"}]}], "}"}]}], "}"}], "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"Quantile", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", 
      RowBox[{"0", ",", "min_", ",", "max_"}], "]"}], ",", "x_"}], "]"}], "=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"min", ",", 
        RowBox[{"x", "<", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"min", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"max", "-", "min"}], ")"}], " ", "x"}]}], ",", 
        RowBox[{"0", "\[LessEqual]", "x", "\[LessEqual]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"max", ",", 
        RowBox[{"1", "<", "x"}]}], "}"}]}], "}"}], "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["1", "st"], "Order"}]], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"Quantile", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", "1", "]"}], ",", "x_"}], "]"}], "=", 
   
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"x", "<", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", " ", 
         SqrtBox[
          RowBox[{"2", "x"}]]}], ",", 
        RowBox[{"0", "\[LessEqual]", "x", "\[LessEqual]", 
         FractionBox["1", "2"]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "-", " ", 
         SqrtBox[
          RowBox[{"2", 
           RowBox[{"(", 
            RowBox[{"1", "-", "x"}], ")"}]}]]}], ",", 
        RowBox[{
         FractionBox["1", "2"], "<", "x", "\[LessEqual]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"1", "<", "x"}]}], "}"}]}], "}"}], "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"Quantile", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", 
      RowBox[{"1", ",", "min_", ",", "max_"}], "]"}], ",", "x_"}], "]"}], "=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"min", ",", 
        RowBox[{"x", "<", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"min", "+", 
         RowBox[{
          FractionBox[
           RowBox[{"max", "-", "min"}], "2"], " ", 
          SqrtBox[
           RowBox[{"2", "x"}]]}]}], ",", 
        RowBox[{"0", "\[LessEqual]", "x", "\[LessEqual]", 
         FractionBox["1", "2"]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"min", "+", 
         RowBox[{
          FractionBox[
           RowBox[{"max", "-", "min"}], "2"], " ", 
          RowBox[{"(", 
           RowBox[{"2", "-", 
            SqrtBox[
             RowBox[{"2", "-", 
              RowBox[{"2", " ", "x"}]}]]}], ")"}]}]}], ",", 
        RowBox[{
         FractionBox["1", "2"], "<", "x", "\[LessEqual]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"max", ",", 
        RowBox[{"1", "<", "x"}]}], "}"}]}], "}"}], "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["2", "nd"], "Order"}]], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"Quantile", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", "2", "]"}], ",", "x_"}], "]"}], "=", 
   
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["3", "2"]}], ",", 
        RowBox[{"x", "<", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          FractionBox["3", "2"]}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"6", " ", "x"}], ")"}], 
          RowBox[{"1", "/", "3"}]]}], ",", 
        RowBox[{"0", "\[LessEqual]", "x", "\[LessEqual]", 
         FractionBox["1", "6"]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        FractionBox[
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "3"}], ")"}], 
           RowBox[{"2", "/", "3"}]], "-", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "3"}], ")"}], 
            RowBox[{"1", "/", "3"}]], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"2", "-", 
              RowBox[{"4", " ", "x"}], "+", 
              SqrtBox[
               RowBox[{"1", "+", 
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "1"}], "+", "x"}], ")"}], " ", "x"}]}]]}], 
             ")"}], 
            RowBox[{"2", "/", "3"}]]}]}], 
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"2", "-", 
             RowBox[{"4", " ", "x"}], "+", 
             SqrtBox[
              RowBox[{"1", "+", 
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", "x"}], ")"}], " ", "x"}]}]]}], 
            ")"}], 
           RowBox[{"1", "/", "3"}]]}]], ",", 
        RowBox[{
         FractionBox["1", "6"], "<", "x", "\[LessEqual]", 
         FractionBox["5", "6"]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         FractionBox["3", "2"], "-", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"6", "-", 
            RowBox[{"6", " ", "x"}]}], ")"}], 
          RowBox[{"1", "/", "3"}]]}], ",", 
        RowBox[{
         FractionBox["5", "6"], "<", "x", "\[LessEqual]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        FractionBox["3", "2"], ",", 
        RowBox[{"1", "<", "x"}]}], "}"}]}], "}"}], "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"Quantile", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", 
      RowBox[{"2", ",", "min_", ",", "max_"}], "]"}], ",", "x_"}], "]"}], "=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"min", ",", 
        RowBox[{"x", "<", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"min", "+", 
         RowBox[{
          FractionBox[
           RowBox[{"max", "-", "min"}], "3"], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"6", " ", "x"}], ")"}], 
           RowBox[{"1", "/", "3"}]]}]}], ",", 
        RowBox[{"0", "\[LessEqual]", "x", "\[LessEqual]", 
         FractionBox["1", "6"]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"min", "+", 
         RowBox[{
          FractionBox[
           RowBox[{"max", "-", "min"}], "3"], 
          RowBox[{"(", " ", 
           RowBox[{
            FractionBox["3", "2"], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"-", "3"}], ")"}], 
               RowBox[{"2", "/", "3"}]], "-", 
              RowBox[{
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"-", "3"}], ")"}], 
                RowBox[{"1", "/", "3"}]], " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"2", "-", 
                  RowBox[{"4", " ", "x"}], "+", 
                  SqrtBox[
                   RowBox[{"1", "+", 
                    RowBox[{"16", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", "x"}], ")"}], " ", "x"}]}]]}], 
                 ")"}], 
                RowBox[{"2", "/", "3"}]]}]}], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"2", "-", 
                 RowBox[{"4", " ", "x"}], "+", 
                 SqrtBox[
                  RowBox[{"1", "+", 
                   RowBox[{"16", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", "x"}], ")"}], " ", "x"}]}]]}], 
                ")"}], 
               RowBox[{"1", "/", "3"}]]}]]}], ")"}]}]}], ",", 
        RowBox[{
         FractionBox["1", "6"], "<", "x", "\[LessEqual]", 
         FractionBox["5", "6"]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"min", "+", " ", 
         RowBox[{
          FractionBox[
           RowBox[{"max", "-", "min"}], "3"], 
          RowBox[{"(", 
           RowBox[{"3", "-", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"6", "-", 
               RowBox[{"6", " ", "x"}]}], ")"}], 
             RowBox[{"1", "/", "3"}]]}], ")"}]}]}], ",", 
        RowBox[{
         FractionBox["5", "6"], "<", "x", "\[LessEqual]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"max", ",", 
        RowBox[{"1", "<", "x"}]}], "}"}]}], "}"}], "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["3", "rd"], "Order"}]], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"Quantile", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", "3", "]"}], ",", "x_"}], "]"}], "=", 
   
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "2"}], ",", 
        RowBox[{"x", "<", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"24", "x"}], ")"}], 
          RowBox[{"1", "/", "4"}]], "-", "2"}], ",", 
        RowBox[{"0", "\[LessEqual]", "x", "\[LessEqual]", 
         FractionBox["1", "24"]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"sqrt$", "=", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"3", " ", 
                SqrtBox[
                 RowBox[{"3", "-", 
                  RowBox[{"162", " ", "x"}], "+", 
                  RowBox[{"14580", " ", 
                   SuperscriptBox["x", "2"]}], "-", 
                  RowBox[{"17496", " ", 
                   SuperscriptBox["x", "3"]}]}]]}], "+", 
               RowBox[{"324", " ", "x"}]}], ")"}], 
             RowBox[{"1", "/", "3"}]]}], "}"}], ",", 
          RowBox[{
           FractionBox["1", "3"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "2"}], "+", 
             SqrtBox[
              RowBox[{"4", "+", "sqrt$", "+", 
               FractionBox[
                RowBox[{
                 RowBox[{"54", " ", "x"}], "-", "3"}], "sqrt$"]}]], "-", 
             RowBox[{
              FractionBox["1", "2"], " ", 
              SqrtBox[
               RowBox[{"32", "-", 
                RowBox[{"4", " ", "sqrt$"}], "+", 
                FractionBox[
                 RowBox[{"12", "-", 
                  RowBox[{"216", " ", "x"}]}], "sqrt$"], "+", 
                FractionBox["80", 
                 SqrtBox[
                  RowBox[{"4", "+", "sqrt$", "+", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"54", " ", "x"}], "-", "3"}], "sqrt$"]}]]]}]]}]}],
             ")"}]}]}], "]"}], ",", 
        RowBox[{
         FractionBox["1", "24"], "<", "x", "\[LessEqual]", 
         FractionBox["1", "2"]}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"sqrt$", " ", "=", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"3", " ", 
                SqrtBox[
                 RowBox[{
                  RowBox[{"-", "3075"}], "+", 
                  RowBox[{"23490", " ", "x"}], "-", 
                  RowBox[{"37908", " ", 
                   SuperscriptBox["x", "2"]}], "+", 
                  RowBox[{"17496", " ", 
                   SuperscriptBox["x", "3"]}]}]]}], "+", 
               RowBox[{"324", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "x"}], ")"}]}]}], ")"}], 
             RowBox[{"1", "/", "3"}]]}], "}"}], ",", 
          RowBox[{
           FractionBox["1", "3"], " ", 
           RowBox[{"(", 
            RowBox[{"2", "+", 
             RowBox[{
              FractionBox["1", "2"], " ", 
              SqrtBox[
               RowBox[{"32", "-", 
                RowBox[{"4", " ", "sqrt$"}], "+", 
                FractionBox["80", 
                 SqrtBox[
                  RowBox[{"4", "+", "sqrt$", "+", 
                   FractionBox[
                    RowBox[{"51", "-", 
                    RowBox[{"54", " ", "x"}]}], "sqrt$"]}]]], "+", 
                FractionBox[
                 RowBox[{
                  RowBox[{"-", "204"}], "+", 
                  RowBox[{"216", " ", "x"}]}], "sqrt$"]}]]}], "-", 
             SqrtBox[
              RowBox[{"4", "+", "sqrt$", "+", 
               FractionBox[
                RowBox[{"51", "-", 
                 RowBox[{"54", " ", "x"}]}], "sqrt$"]}]]}], ")"}]}]}], "]"}], 
        ",", 
        RowBox[{
         FractionBox["1", "2"], "<", "x", "\[LessEqual]", 
         FractionBox["23", "24"]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"2", "-", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"24", "-", 
            RowBox[{"24", " ", "x"}]}], ")"}], 
          RowBox[{"1", "/", "4"}]]}], ",", 
        RowBox[{
         FractionBox["23", "24"], "<", "x", "\[LessEqual]", "1"}]}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", 
        RowBox[{"1", "<", "x"}]}], "}"}]}], "}"}], "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BSplineDistribution", "/:", 
   RowBox[{"Quantile", "[", 
    RowBox[{
     RowBox[{"BSplineDistribution", "[", 
      RowBox[{"3", ",", "min_", ",", "max_"}], "]"}], ",", "x_"}], "]"}], "=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"min", ",", 
        RowBox[{"x", "<", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"min", "+", 
         RowBox[{
          FractionBox[
           RowBox[{"max", "-", "min"}], "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"24", " ", "x"}], ")"}], 
           RowBox[{"1", "/", "4"}]]}]}], ",", 
        RowBox[{"0", "\[LessEqual]", "x", "\[LessEqual]", 
         FractionBox["1", "24"]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"sqrt$", "=", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"3", " ", 
                SqrtBox[
                 RowBox[{"3", "-", 
                  RowBox[{"162", " ", "x"}], "+", 
                  RowBox[{"14580", " ", 
                   SuperscriptBox["x", "2"]}], "-", 
                  RowBox[{"17496", " ", 
                   SuperscriptBox["x", "3"]}]}]]}], "+", 
               RowBox[{"324", " ", "x"}]}], ")"}], 
             RowBox[{"1", "/", "3"}]]}], "}"}], ",", 
          RowBox[{"min", "+", 
           RowBox[{
            FractionBox[
             RowBox[{"max", "-", "min"}], "12"], "  ", 
            RowBox[{"(", 
             RowBox[{"4", "+", 
              SqrtBox[
               RowBox[{"4", "+", "sqrt$", "+", 
                FractionBox[
                 RowBox[{
                  RowBox[{"54", " ", "x"}], "-", "3"}], "sqrt$"]}]], "-", 
              RowBox[{
               FractionBox["1", "2"], " ", 
               SqrtBox[
                RowBox[{"32", "-", 
                 RowBox[{"4", " ", "sqrt$"}], "+", 
                 FractionBox[
                  RowBox[{"12", "-", 
                   RowBox[{"216", " ", "x"}]}], "sqrt$"], "+", 
                 FractionBox["80", 
                  SqrtBox[
                   RowBox[{"4", "+", "sqrt$", "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"54", " ", "x"}], "-", "3"}], "sqrt$"]}]]]}]]}]}],
              ")"}]}]}]}], "]"}], ",", 
        RowBox[{
         FractionBox["1", "24"], "<", "x", "\[LessEqual]", 
         FractionBox["1", "2"]}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"sqrt$", " ", "=", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"324", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "x"}], ")"}]}], "-", 
               RowBox[{"3", " ", 
                SqrtBox[
                 RowBox[{
                  RowBox[{"-", "3075"}], "+", 
                  RowBox[{"23490", " ", "x"}], "-", 
                  RowBox[{"37908", " ", 
                   SuperscriptBox["x", "2"]}], "+", 
                  RowBox[{"17496", " ", 
                   SuperscriptBox["x", "3"]}]}]]}]}], ")"}], 
             RowBox[{"1", "/", "3"}]]}], "}"}], ",", 
          RowBox[{
           FractionBox[
            RowBox[{"min", "+", "max"}], "2"], "+", 
           RowBox[{
            FractionBox[
             RowBox[{"max", "-", "min"}], "12"], " ", 
            RowBox[{"(", 
             RowBox[{"2", "+", 
              RowBox[{
               FractionBox["1", "2"], " ", 
               SqrtBox[
                RowBox[{"32", "-", 
                 RowBox[{"4", " ", "sqrt$"}], "+", 
                 FractionBox["80", 
                  SqrtBox[
                   RowBox[{"4", "+", "sqrt$", "+", 
                    FractionBox[
                    RowBox[{"51", "-", 
                    RowBox[{"54", " ", "x"}]}], "sqrt$"]}]]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{"-", "204"}], "+", 
                   RowBox[{"216", " ", "x"}]}], "sqrt$"]}]]}], "-", 
              SqrtBox[
               RowBox[{"4", "+", "sqrt$", "+", 
                FractionBox[
                 RowBox[{"51", "-", 
                  RowBox[{"54", " ", "x"}]}], "sqrt$"]}]]}], ")"}]}]}]}], 
         "]"}], ",", 
        RowBox[{
         FractionBox["1", "2"], "<", "x", "\[LessEqual]", 
         FractionBox["23", "24"]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"min", "+", 
         RowBox[{
          FractionBox[
           RowBox[{"max", "-", "min"}], "4"], " ", 
          RowBox[{"(", 
           RowBox[{"4", "-", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"24", "-", 
               RowBox[{"24", " ", "x"}]}], ")"}], 
             RowBox[{"1", "/", "4"}]]}], ")"}]}]}], ",", 
        RowBox[{
         FractionBox["23", "24"], "<", "x", "\[LessEqual]", "1"}]}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"max", ",", 
        RowBox[{"1", "<", "x"}]}], "}"}]}], "}"}], "]"}]}], 
  ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "ExpectedValue ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"E", "[", 
    RowBox[{"f", "[", "x", "]"}], "]"}], " ", "=", " ", 
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     RowBox[{"-", "\[Infinity]"}], "\[Infinity]"], 
    RowBox[{
     RowBox[{"f", "[", "x", "]"}], " ", 
     RowBox[{"PDF", "[", "x", "]"}], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]]]
}], "Subsubsection"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"ExpectedValue", "[", 
   RowBox[{"f_Function", ",", 
    RowBox[{"BSplineDistribution", "[", "n_", "]"}], ",", 
    RowBox[{"opts___", "?", "OptionQ"}]}], "]"}], ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x", ",", "integral", ",", 
      RowBox[{"assmp", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Assumptions", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "ExpectedValue", "]"}]}], "}"}], "]"}]}]}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"(", "integral", ")"}], "/;", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"integral", "=", 
        RowBox[{"Integrate", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"f", "[", "x", "]"}], " ", 
           RowBox[{"PDF", "[", 
            RowBox[{
             RowBox[{"BSplineDistribution", "[", "n", "]"}], ",", "x"}], 
            "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"(", 
               RowBox[{"n", "+", "1"}], ")"}]}], "/", "2"}], ",", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"n", "+", "1"}], ")"}], "/", "2"}]}], "}"}], ",", 
          RowBox[{"Assumptions", "\[Rule]", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"n", "\[GreaterEqual]", "0"}], ",", " ", 
               RowBox[{"n", "\[Element]", "Integers"}]}], "}"}], ",", 
             "assmp"}], "]"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"FreeQ", "[", 
        RowBox[{"integral", ",", "Integrate"}], "]"}]}], ")"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"ExpectedValue", "[", 
   RowBox[{"f_", ",", 
    RowBox[{"BSplineDistribution", "[", "n_", "]"}], ",", "x_Symbol", ",", 
    RowBox[{"opts___", "?", "OptionQ"}]}], "]"}], ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"integral", ",", 
      RowBox[{"assmp", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Assumptions", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "ExpectedValue", "]"}]}], "}"}], "]"}]}]}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"(", "integral", ")"}], "/;", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"integral", "=", 
        RowBox[{"Integrate", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"f", "[", "x", "]"}], " ", 
           RowBox[{"PDF", "[", 
            RowBox[{
             RowBox[{"BSplineDistribution", "[", "n", "]"}], ",", "x"}], 
            "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"(", 
               RowBox[{"n", "+", "1"}], ")"}]}], "/", "2"}], ",", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"n", "+", "1"}], ")"}], "/", "2"}]}], "}"}], ",", 
          RowBox[{"Assumptions", "\[Rule]", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"n", "\[GreaterEqual]", "0"}], ",", " ", 
               RowBox[{"n", "\[Element]", "Integers"}]}], "}"}], ",", 
             "assmp"}], "]"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"FreeQ", "[", 
        RowBox[{"integral", ",", "Integrate"}], "]"}]}], ")"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"ExpectedValue", "[", 
   RowBox[{"f_Function", ",", 
    RowBox[{"BSplineDistribution", "[", 
     RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], ",", 
    RowBox[{"opts___", "?", "OptionQ"}]}], "]"}], ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x", ",", "integral", ",", 
      RowBox[{"assmp", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Assumptions", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "ExpectedValue", "]"}]}], "}"}], "]"}]}]}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"(", "integral", ")"}], "/;", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"integral", "=", 
        RowBox[{"Integrate", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"f", "[", "x", "]"}], " ", 
           RowBox[{"PDF", "[", 
            RowBox[{
             RowBox[{"BSplineDistribution", "[", 
              RowBox[{"n", ",", "min", ",", "max"}], "]"}], ",", "x"}], 
            "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", "min", ",", "max"}], "}"}], ",", 
          RowBox[{"Assumptions", "\[Rule]", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"n", "\[GreaterEqual]", "0"}], ",", " ", 
               RowBox[{"n", "\[Element]", "Integers"}], ",", 
               RowBox[{"min", "<", "max"}], ",", 
               RowBox[{"min", "\[Element]", "Reals"}], ",", 
               RowBox[{"max", "\[Element]", "Reals"}]}], "}"}], ",", 
             "assmp"}], "]"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"FreeQ", "[", 
        RowBox[{"integral", ",", "Integrate"}], "]"}]}], ")"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"ExpectedValue", "[", 
   RowBox[{"f_", ",", 
    RowBox[{"BSplineDistribution", "[", 
     RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], ",", "x_Symbol", ",", 
    RowBox[{"opts___", "?", "OptionQ"}]}], "]"}], ":=", " ", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"integral", ",", 
      RowBox[{"assmp", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Assumptions", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "ExpectedValue", "]"}]}], "}"}], "]"}]}]}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"(", "integral", ")"}], "/;", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"integral", "=", 
        RowBox[{"Integrate", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"f", "[", "x", "]"}], " ", 
           RowBox[{"PDF", "[", 
            RowBox[{
             RowBox[{"BSplineDistribution", "[", 
              RowBox[{"n", ",", "min", ",", "max"}], "]"}], ",", "x"}], 
            "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", "min", ",", "max"}], "}"}], ",", 
          RowBox[{"Assumptions", "\[Rule]", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"n", "\[GreaterEqual]", "0"}], ",", " ", 
               RowBox[{"n", "\[Element]", "Integers"}], ",", 
               RowBox[{"min", "<", "max"}], ",", 
               RowBox[{"min", "\[Element]", "Reals"}], ",", 
               RowBox[{"max", "\[Element]", "Reals"}]}], "}"}], ",", 
             "assmp"}], "]"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"FreeQ", "[", 
        RowBox[{"integral", ",", "Integrate"}], "]"}]}], ")"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["RandomReal", "Subsubsection"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"RandomReal", "[", 
   RowBox[{"BSplineDistribution", "[", "n_", "]"}], "]"}], ":=", 
  RowBox[{"Total", "[", 
   RowBox[{"RandomReal", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "1"}], "/", "2"}], ",", 
       RowBox[{"1", "/", "2"}]}], "}"}], ",", 
     RowBox[{"n", "+", "1"}]}], "]"}], "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"RandomReal", "[", 
   RowBox[{"BSplineDistribution", "[", 
    RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], "]"}], ":=", 
  RowBox[{"Total", "[", 
   RowBox[{"RandomReal", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       FractionBox["min", 
        RowBox[{"n", "+", "1"}]], ",", 
       FractionBox["max", 
        RowBox[{"n", "+", "1"}]]}], "}"}], ",", 
     RowBox[{"n", "+", "1"}]}], "]"}], "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"RandomReal", "[", 
   RowBox[{
    RowBox[{"BSplineDistribution", "[", "n_", "]"}], ",", 
    RowBox[{"dim_Integer", "?", "Positive"}]}], "]"}], ":=", " ", 
  RowBox[{"Map", "[", 
   RowBox[{"Total", ",", 
    RowBox[{"RandomReal", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "/", "2"}], ",", 
        RowBox[{"1", "/", "2"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"dim", ",", 
        RowBox[{"n", "+", "1"}]}], "}"}]}], "]"}]}], "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"RandomReal", "[", 
   RowBox[{
    RowBox[{"BSplineDistribution", "[", 
     RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], ",", 
    RowBox[{"dim_Integer", "?", "Positive"}]}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Total", ",", 
    RowBox[{"RandomReal", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        FractionBox["min", 
         RowBox[{"n", "+", "1"}]], ",", 
        FractionBox["max", 
         RowBox[{"n", "+", "1"}]]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"dim", ",", 
        RowBox[{"n", "+", "1"}]}], "}"}]}], "]"}]}], "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"RandomReal", "[", 
   RowBox[{
    RowBox[{"BSplineDistribution", "[", "n_", "]"}], ",", 
    RowBox[{"dims", ":", 
     RowBox[{"{", 
      RowBox[{"__Integer", "?", "Positive"}], "}"}]}]}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Total", ",", 
    RowBox[{"RandomReal", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "/", "2"}], ",", 
        RowBox[{"1", "/", "2"}]}], "}"}], ",", 
      RowBox[{"Append", "[", 
       RowBox[{"dims", ",", 
        RowBox[{"n", "+", "1"}]}], "]"}]}], "]"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"Length", "[", "dims", "]"}], "}"}]}], "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"BSplineDistribution", "/:", 
  RowBox[{"RandomReal", "[", 
   RowBox[{
    RowBox[{"BSplineDistribution", "[", 
     RowBox[{"n_", ",", "min_", ",", "max_"}], "]"}], ",", 
    RowBox[{"dims", ":", 
     RowBox[{"{", 
      RowBox[{"__Integer", "?", "Positive"}], "}"}]}]}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Total", ",", 
    RowBox[{"RandomReal", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        FractionBox["min", 
         RowBox[{"n", "+", "1"}]], ",", 
        FractionBox["max", 
         RowBox[{"n", "+", "1"}]]}], "}"}], ",", 
      RowBox[{"Append", "[", 
       RowBox[{"dims", ",", 
        RowBox[{"n", "+", "1"}]}], "]"}]}], "]"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"Length", "[", "dims", "]"}], "}"}]}], "]"}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Centralized Moments", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Mu]", "n"], " ", "=", " ", 
  RowBox[{"\[LeftAngleBracket]", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"x", " ", "-", " ", 
      RowBox[{"\[LeftAngleBracket]", "x", "\[RightAngleBracket]"}]}], ")"}], 
    "n"], "\[RightAngleBracket]"}]}]], "Input",
 Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["Cummulants", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[LeftAngleBracket]", 
   RowBox[{"\[LeftAngleBracket]", 
    RowBox[{
     SuperscriptBox["\[Eta]", "1"], "[", "t", "]"}], "\[RightAngleBracket]"}],
    "\[RightAngleBracket]"}], " ", "=", " ", 
  RowBox[{"\[LeftAngleBracket]", 
   RowBox[{
    SuperscriptBox["\[Eta]", "1"], "[", "t", "]"}], 
   "\[RightAngleBracket]"}]}]], "Input",
 Evaluatable->False],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[LeftAngleBracket]", 
   RowBox[{"\[LeftAngleBracket]", 
    RowBox[{
     SuperscriptBox["\[Eta]", "2"], "[", "t", "]"}], "\[RightAngleBracket]"}],
    "\[RightAngleBracket]"}], " ", "=", " ", 
  RowBox[{
   RowBox[{"\[LeftAngleBracket]", 
    RowBox[{
     SuperscriptBox["\[Eta]", "2"], "[", "t", "]"}], "\[RightAngleBracket]"}],
    "-", 
   SuperscriptBox[
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{
      SuperscriptBox["\[Eta]", "1"], "[", "t", "]"}], 
     "\[RightAngleBracket]"}], "2"]}]}]], "Input",
 Evaluatable->False],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[LeftAngleBracket]", 
   RowBox[{"\[LeftAngleBracket]", 
    RowBox[{
     SuperscriptBox["\[Eta]", "3"], "[", "t", "]"}], "\[RightAngleBracket]"}],
    "\[RightAngleBracket]"}], " ", "=", " ", 
  RowBox[{
   RowBox[{"2", 
    SuperscriptBox[
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{
       SuperscriptBox["\[Eta]", "1"], "[", "t", "]"}], 
      "\[RightAngleBracket]"}], "3"]}], "-", 
   RowBox[{"3", 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{
      SuperscriptBox["\[Eta]", "1"], "[", "t", "]"}], 
     "\[RightAngleBracket]"}], 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{
      SuperscriptBox["\[Eta]", "2"], "[", "t", "]"}], 
     "\[RightAngleBracket]"}]}], "+", 
   RowBox[{"\[LeftAngleBracket]", 
    RowBox[{
     SuperscriptBox["\[Eta]", "3"], "[", "t", "]"}], 
    "\[RightAngleBracket]"}]}]}]], "Input",
 Evaluatable->False],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[LeftAngleBracket]", 
   RowBox[{"\[LeftAngleBracket]", 
    RowBox[{
     SuperscriptBox["\[Eta]", "4"], "[", "t", "]"}], "\[RightAngleBracket]"}],
    "\[RightAngleBracket]"}], " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "6"}], 
    SuperscriptBox[
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{
       SuperscriptBox["\[Eta]", "1"], "[", "t", "]"}], 
      "\[RightAngleBracket]"}], "4"]}], "+", 
   RowBox[{"12", 
    SuperscriptBox[
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{
       SuperscriptBox["\[Eta]", "1"], "[", "t", "]"}], 
      "\[RightAngleBracket]"}], "2"], 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{
      SuperscriptBox["\[Eta]", "2"], "[", "t", "]"}], 
     "\[RightAngleBracket]"}]}], "-", " ", 
   RowBox[{"3", " ", 
    SuperscriptBox[
     RowBox[{"\[LeftAngleBracket]", 
      RowBox[{
       SuperscriptBox["\[Eta]", "2"], "[", "t", "]"}], 
      "\[RightAngleBracket]"}], "2"]}], "-", " ", 
   RowBox[{"4", 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{
      SuperscriptBox["\[Eta]", "1"], "[", "t", "]"}], 
     "\[RightAngleBracket]"}], 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{
      SuperscriptBox["\[Eta]", "3"], "[", "t", "]"}], 
     "\[RightAngleBracket]"}]}], "+", 
   RowBox[{"\[LeftAngleBracket]", 
    RowBox[{
     SuperscriptBox["\[Eta]", "4"], "[", "t", "]"}], 
    "\[RightAngleBracket]"}]}]}]], "Input",
 Evaluatable->False]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "BSplineDistribution", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Protected", ",", " ", "ReadProtected"}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1195, 814},
WindowMargins->{{50, Automatic}, {Automatic, 0}},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 7, \
2010)",
StyleDefinitions->Notebook[{
   Cell[
    CellGroupData[{
      Cell["Style Definitions", "Subtitle"], 
      Cell[
      "Modify the definitions below to change the default appearance of all \
cells in a given style.  Make modifications to any definition using commands \
in the Format menu.", "Text"], 
      Cell[
       CellGroupData[{
         Cell["Style Environment Names", "Section"], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{12, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 9], 
         Cell[
          StyleData[All, "Presentation"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 12], 
         Cell[
          StyleData[All, "Condensed"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{8, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 8], 
         Cell[
          StyleData[All, "Printout"], PageWidth -> PaperWidth, 
          CellLabelMargins -> {{2, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 5, 
          PrivateFontOptions -> {"FontType" -> "Outline"}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Notebook Options", "Section"], 
         Cell[
         "The options defined for the style below will be used at the \
Notebook level.", "Text"], 
         Cell[
          StyleData["Notebook"], PageHeaders -> {{
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"], None, 
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"]}, {
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"], None, 
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"]}}, CellFrameLabelMargins -> 
          6, StyleMenuListing -> None]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headings", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Title"], CellMargins -> {{12, Inherited}, {20, 40}}, 
             CellGroupingRules -> {"TitleGrouping", 0}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LineSpacing -> {1, 11}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "Title", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subtitle", 0}, {"Subsubtitle", 0}}, FontFamily -> 
             "Helvetica", FontSize -> 36, FontWeight -> "Bold"], 
            Cell[
             StyleData["Title", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 40}}, LineSpacing -> {1, 0}, 
             FontSize -> 44], 
            Cell[
             StyleData["Title", "Condensed"], 
             CellMargins -> {{8, 10}, {4, 8}}, FontSize -> 20], 
            Cell[
             StyleData["Title", "Printout"], 
             CellMargins -> {{2, 10}, {12, 30}}, FontSize -> 24]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subtitle"], 
             CellMargins -> {{12, Inherited}, {20, 15}}, 
             CellGroupingRules -> {"TitleGrouping", 10}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subtitle", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subsubtitle", 0}}, FontFamily -> "Helvetica", 
             FontSize -> 24], 
            Cell[
             StyleData["Subtitle", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 20}}, LineSpacing -> {1, 0}, 
             FontSize -> 36], 
            Cell[
             StyleData["Subtitle", "Condensed"], 
             CellMargins -> {{8, 10}, {4, 4}}, FontSize -> 14], 
            Cell[
             StyleData["Subtitle", "Printout"], 
             CellMargins -> {{2, 10}, {12, 8}}, FontSize -> 18]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubtitle"], 
             CellMargins -> {{12, Inherited}, {20, 15}}, 
             CellGroupingRules -> {"TitleGrouping", 20}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsubtitle", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}}, FontFamily -> "Helvetica", FontSize -> 14, 
             FontSlant -> "Italic"], 
            Cell[
             StyleData["Subsubtitle", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 20}}, LineSpacing -> {1, 0}, 
             FontSize -> 24], 
            Cell[
             StyleData["Subsubtitle", "Condensed"], 
             CellMargins -> {{8, 10}, {8, 8}}, FontSize -> 12], 
            Cell[
             StyleData["Subsubtitle", "Printout"], 
             CellMargins -> {{2, 10}, {12, 8}}, FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellDingbat -> "\[FilledSquare]", 
             CellMargins -> {{25, Inherited}, {8, 24}}, 
             CellGroupingRules -> {"SectionGrouping", 30}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LineSpacing -> {1, 7}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "Section", 
             CounterAssignments -> {{"Subsection", 0}, {"Subsubsection", 0}}, 
             FontFamily -> "Helvetica", FontSize -> 16, FontWeight -> "Bold"], 
            Cell[
             StyleData["Section", "Presentation"], 
             CellMargins -> {{40, 10}, {11, 32}}, LineSpacing -> {1, 0}, 
             FontSize -> 24], 
            Cell[
             StyleData["Section", "Condensed"], 
             CellMargins -> {{18, Inherited}, {6, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Section", "Printout"], 
             CellMargins -> {{13, 0}, {7, 22}}, FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> "\[FilledSmallSquare]", 
             CellMargins -> {{22, Inherited}, {8, 20}}, 
             CellGroupingRules -> {"SectionGrouping", 40}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsection", CounterAssignments -> {{"Subsubsection", 0}}, 
             FontFamily -> "Times", FontSize -> 14, FontWeight -> "Bold"], 
            Cell[
             StyleData["Subsection", "Presentation"], 
             CellMargins -> {{36, 10}, {11, 32}}, LineSpacing -> {1, 0}, 
             FontSize -> 22], 
            Cell[
             StyleData["Subsection", "Condensed"], 
             CellMargins -> {{16, Inherited}, {6, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Subsection", "Printout"], 
             CellMargins -> {{9, 0}, {7, 22}}, FontSize -> 12]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsection"], CellDingbat -> 
             "\[FilledSmallSquare]", 
             CellMargins -> {{22, Inherited}, {8, 18}}, 
             CellGroupingRules -> {"SectionGrouping", 50}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsubsection", FontFamily -> "Times", FontWeight -> "Bold"], 
            Cell[
             StyleData["Subsubsection", "Presentation"], 
             CellMargins -> {{34, 10}, {11, 26}}, LineSpacing -> {1, 0}, 
             FontSize -> 18], 
            Cell[
             StyleData["Subsubsection", "Condensed"], 
             CellMargins -> {{17, Inherited}, {6, 12}}, FontSize -> 10], 
            Cell[
             StyleData["Subsubsection", "Printout"], 
             CellMargins -> {{9, 0}, {7, 14}}, FontSize -> 11]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Body Text", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Text"], CellMargins -> {{12, 10}, {7, 7}}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             Hyphenation -> True, LineSpacing -> {1, 3}, CounterIncrements -> 
             "Text"], 
            Cell[
             StyleData["Text", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["Text", "Condensed"], CellMargins -> {{8, 10}, {6, 6}},
              LineSpacing -> {1, 1}, FontSize -> 11], 
            Cell[
             StyleData["Text", "Printout"], CellMargins -> {{2, 2}, {6, 6}}, 
             TextJustification -> 0.5, FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SmallText"], CellMargins -> {{12, 10}, {6, 6}}, 
             DefaultNewInlineCellStyle -> "None", Hyphenation -> True, 
             LineSpacing -> {1, 3}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "SmallText", FontFamily -> "Helvetica", 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Presentation"], 
             CellMargins -> {{24, 10}, {8, 8}}, LineSpacing -> {1, 5}, 
             FontSize -> 12], 
            Cell[
             StyleData["SmallText", "Condensed"], 
             CellMargins -> {{8, 10}, {5, 5}}, LineSpacing -> {1, 2}, 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Printout"], 
             CellMargins -> {{2, 2}, {5, 5}}, TextJustification -> 0.5, 
             FontSize -> 7]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Input/Output", "Section"], 
         Cell[
         "The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names. Some attributes for these styles are actually set in FormatType Styles \
(in the last section of this stylesheet). ", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Input"], CellMargins -> {{45, 10}, {5, 7}}, 
             Evaluatable -> True, CellGroupingRules -> "InputGrouping", 
             CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, DefaultFormatType -> 
             DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
             FormatType -> InputForm, ShowStringCharacters -> True, 
             NumberMarks -> True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1},
              CounterIncrements -> "Input", FontWeight -> "Bold"], 
            Cell[
             StyleData["Input", "Presentation"], 
             CellMargins -> {{72, Inherited}, {8, 10}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["Input", "Condensed"], 
             CellMargins -> {{40, 10}, {2, 3}}, FontSize -> 11], 
            Cell[
             StyleData["Input", "Printout"], CellMargins -> {{39, 0}, {4, 6}},
              LinebreakAdjustments -> {0.85, 2, 10, 1, 1}, FontSize -> 9]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PackageInput"], CellMargins -> {{45, 10}, {5, 7}}, 
             Evaluatable -> True, CellGroupingRules -> "InputGrouping", 
             CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, InitializationCell -> True, 
             DefaultFormatType -> DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
             FormatType -> InputForm, ShowStringCharacters -> True, 
             NumberMarks -> True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1},
              CounterIncrements -> "Input", FontWeight -> "Bold", Background -> 
             RGBColor[0.500008, 1, 0.566644]], 
            Cell[
             StyleData["PackageInput", "Presentation"], 
             CellMargins -> {{72, Inherited}, {8, 10}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["PackageInput", "Condensed"], 
             CellMargins -> {{40, 10}, {2, 3}}, FontSize -> 11], 
            Cell[
             StyleData["PackageInput", "Printout"], 
             CellMargins -> {{39, 0}, {4, 6}}, 
             LinebreakAdjustments -> {0.85, 2, 10, 1, 1}, FontSize -> 9, 
             Background -> GrayLevel[1]]}, Closed]], 
         Cell[
          StyleData["InputOnly"], Evaluatable -> True, CellGroupingRules -> 
          "InputGrouping", CellHorizontalScrolling -> True, DefaultFormatType -> 
          DefaultInputFormatType, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
          FormatType -> InputForm, ShowStringCharacters -> True, NumberMarks -> 
          True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, 
          CounterIncrements -> "Input", StyleMenuListing -> None, FontWeight -> 
          "Bold"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Output"], CellMargins -> {{47, 10}, {7, 5}}, 
             CellEditDuplicate -> True, CellGroupingRules -> "OutputGrouping",
              CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, DefaultFormatType -> 
             DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Output"], 
            Cell[
             StyleData["Output", "Presentation"], 
             CellMargins -> {{72, Inherited}, {10, 8}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["Output", "Condensed"], 
             CellMargins -> {{41, Inherited}, {3, 2}}, FontSize -> 11], 
            Cell[
             StyleData["Output", "Printout"], 
             CellMargins -> {{39, 0}, {6, 4}}, FontSize -> 9]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Message"], 
             CellMargins -> {{45, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Message", StyleMenuListing -> 
             None, FontSize -> 11, FontColor -> RGBColor[0, 0, 1]], 
            Cell[
             StyleData["Message", "Presentation"], 
             CellMargins -> {{72, Inherited}, {Inherited, Inherited}}, 
             LineSpacing -> {1, 0}, FontSize -> 16], 
            Cell[
             StyleData["Message", "Condensed"], 
             CellMargins -> {{41, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 11], 
            Cell[
             StyleData["Message", "Printout"], 
             CellMargins -> {{39, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 7, FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Print"], 
             CellMargins -> {{45, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, ShowCellLabel -> 
             False, DefaultFormatType -> DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Print", StyleMenuListing -> 
             None], 
            Cell[
             StyleData["Print", "Presentation"], 
             CellMargins -> {{72, Inherited}, {Inherited, Inherited}}, 
             LineSpacing -> {1, 0}, FontSize -> 16], 
            Cell[
             StyleData["Print", "Condensed"], 
             CellMargins -> {{41, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 11], 
            Cell[
             StyleData["Print", "Printout"], 
             CellMargins -> {{39, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 8]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Graphics"], 
             CellMargins -> {{4, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "GraphicsGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, LanguageCategory -> 
             None, FormatType -> InputForm, CounterIncrements -> "Graphics", 
             ImageMargins -> {{43, Inherited}, {Inherited, 0}}, 
             StyleMenuListing -> None, FontFamily -> "Courier", FontSize -> 
             10], 
            Cell[
             StyleData["Graphics", "Presentation"], 
             ImageMargins -> {{62, Inherited}, {Inherited, 0}}], 
            Cell[
             StyleData["Graphics", "Condensed"], 
             ImageMargins -> {{38, Inherited}, {Inherited, 0}}, Magnification -> 
             0.6], 
            Cell[
             StyleData["Graphics", "Printout"], 
             ImageMargins -> {{30, Inherited}, {Inherited, 0}}, Magnification -> 
             0.8]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["CellLabel"], LanguageCategory -> None, 
             StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 
             9, FontColor -> RGBColor[0, 0, 1]], 
            Cell[
             StyleData["CellLabel", "Presentation"], FontSize -> 12], 
            Cell[
             StyleData["CellLabel", "Condensed"], FontSize -> 9], 
            Cell[
             StyleData["CellLabel", "Printout"], FontFamily -> "Courier", 
             FontSize -> 8, FontSlant -> "Italic", FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Inline Formatting", "Section"], 
         Cell[
         "These styles are for modifying individual words or letters in a \
cell exclusive of the cell tag.", "Text"], 
         Cell[
          StyleData["RM"], StyleMenuListing -> None, FontWeight -> "Plain", 
          FontSlant -> "Plain"], 
         Cell[
          StyleData["BF"], StyleMenuListing -> None, FontWeight -> "Bold"], 
         Cell[
          StyleData["IT"], StyleMenuListing -> None, FontSlant -> "Italic"], 
         Cell[
          StyleData["TR"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["TI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["TB"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["TBI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["MR"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["MO"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["MB"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["MBO"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["SR"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["SO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["SB"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["SBO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SO10"], StyleMenuListing -> None, FontFamily -> 
             "Helvetica", FontSize -> 10, FontWeight -> "Plain", FontSlant -> 
             "Italic"], 
            Cell[
             StyleData["SO10", "Printout"], StyleMenuListing -> None, 
             FontFamily -> "Helvetica", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"], 
            Cell[
             StyleData["SO10", "EnhancedPrintout"], StyleMenuListing -> None, 
             FontFamily -> "Futura", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Formulas and Programming", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["InlineFormula"], CellMargins -> {{10, 4}, {0, 8}}, 
             CellHorizontalScrolling -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", ScriptLevel -> 1, SingleLetterItalics -> True], 
            Cell[
             StyleData["InlineFormula", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["InlineFormula", "Condensed"], 
             CellMargins -> {{8, 10}, {6, 6}}, LineSpacing -> {1, 1}, 
             FontSize -> 11], 
            Cell[
             StyleData["InlineFormula", "Printout"], 
             CellMargins -> {{2, 0}, {6, 6}}, FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["DisplayFormula"], 
             CellMargins -> {{42, Inherited}, {Inherited, Inherited}}, 
             CellHorizontalScrolling -> True, DefaultFormatType -> 
             DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", ScriptLevel -> 0, SingleLetterItalics -> True, 
             UnderoverscriptBoxOptions -> {LimitsPositioning -> True}], 
            Cell[
             StyleData["DisplayFormula", "Presentation"], 
             LineSpacing -> {1, 5}, FontSize -> 16], 
            Cell[
             StyleData["DisplayFormula", "Condensed"], LineSpacing -> {1, 1}, 
             FontSize -> 11], 
            Cell[
             StyleData["DisplayFormula", "Printout"], FontSize -> 10]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Program"], CellFrame -> {{0, 0}, {0.5, 0.5}}, 
             CellMargins -> {{10, 4}, {0, 8}}, CellHorizontalScrolling -> 
             True, Hyphenation -> False, LanguageCategory -> "Formula", 
             ScriptLevel -> 1, FontFamily -> "Courier"], 
            Cell[
             StyleData["Program", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["Program", "Condensed"], 
             CellMargins -> {{8, 10}, {6, 6}}, LineSpacing -> {1, 1}, 
             FontSize -> 11], 
            Cell[
             StyleData["Program", "Printout"], 
             CellMargins -> {{2, 0}, {6, 6}}, FontSize -> 9]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Outline Styles", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline1"], CellMargins -> {{12, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 50}, 
             ParagraphIndent -> -38, CounterIncrements -> "Outline1", 
             FontSize -> 18, FontWeight -> "Bold", 
             CounterBoxOptions -> {CounterFunction :> CapitalRomanNumeral}], 
            Cell[
             StyleData["Outline1", "Printout"], 
             CounterBoxOptions -> {CounterFunction :> CapitalRomanNumeral}]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline2"], CellMargins -> {{59, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 60}, 
             ParagraphIndent -> -27, CounterIncrements -> "Outline2", 
             FontSize -> 15, FontWeight -> "Bold", 
             CounterBoxOptions -> {CounterFunction :> (Part[
                 CharacterRange["A", "Z"], #]& )}], 
            Cell[
             StyleData["Outline2", "Printout"], 
             CounterBoxOptions -> {CounterFunction :> (Part[
                 CharacterRange["A", "Z"], #]& )}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline3"], CellMargins -> {{108, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 70}, 
             ParagraphIndent -> -21, CounterIncrements -> "Outline3", 
             FontSize -> 12, 
             CounterBoxOptions -> {CounterFunction :> Identity}], 
            Cell[
             StyleData["Outline3", "Printout"], 
             CounterBoxOptions -> {CounterFunction :> Identity}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline4"], CellMargins -> {{158, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 80}, 
             ParagraphIndent -> -18, CounterIncrements -> "Outline4", 
             FontSize -> 10, CounterBoxOptions -> {CounterFunction :> (Part[
                 CharacterRange["a", "z"], #]& )}], 
            Cell[
             StyleData["Outline4", "Printout"]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Hyperlink Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same Notebook, \
or between Notebooks.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Hyperlink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonNote -> 
               ButtonData}], 
            Cell[
             StyleData["Hyperlink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["Hyperlink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["Hyperlink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
         "The following styles are for linking automatically to the on-line \
help system.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["MainBookLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["MainBook", #]}]& )}], 
            Cell[
             StyleData["MainBookLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["MainBookLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["MainBookLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["AddOnsLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["AddOns", #]}]& )}], 
            Cell[
             StyleData["AddOnsLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["AddOnsLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["AddOnsLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["RefGuideLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["RefGuide", #]}]& )}], 
            Cell[
             StyleData["RefGuideLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["RefGuideLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["RefGuideLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["GettingStartedLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["GettingStarted", #]}]& )}], 
            Cell[
             StyleData["GettingStartedLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["GettingStartedLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["GettingStartedLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["OtherInformationLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["OtherInformation", #]}]& )}], 
            Cell[
             StyleData["OtherInformationLink", "Presentation"], FontSize -> 
             16], 
            Cell[
             StyleData["OtherInformationLink", "Condensed"], FontSize -> 11], 
            
            Cell[
             StyleData["OtherInformationLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headers and Footers", "Section"], 
         Cell[
          StyleData["Header"], CellMargins -> {{0, 0}, {4, 1}}, 
          DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
          "NaturalLanguage", StyleMenuListing -> None, FontSize -> 10, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["Footer"], CellMargins -> {{0, 0}, {0, 4}}, 
          DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
          "NaturalLanguage", StyleMenuListing -> None, FontSize -> 9, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["PageNumber"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Times", FontSize -> 10]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Palette Styles", "Section"], 
         Cell[
         "The cells below define styles that define standard ButtonFunctions, \
for use in palette buttons.", "Text"], 
         Cell[
          StyleData["Paste"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, After]}]& )}], 
         Cell[
          StyleData["Evaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["EvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionMove[
                FrontEnd`InputNotebook[], All, Cell, 1], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Placeholder Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making placeholder objects \
in palette templates.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Placeholder"], Placeholder -> True, StyleMenuListing -> 
             None, FontSlant -> "Italic", FontColor -> 
             RGBColor[0.890623, 0.864698, 0.384756], 
             TagBoxOptions -> {
              Editable -> False, Selectable -> False, StripWrapperBoxes -> 
               False}], 
            Cell[
             StyleData["Placeholder", "Presentation"]], 
            Cell[
             StyleData["Placeholder", "Condensed"]], 
            Cell[
             StyleData["Placeholder", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PrimaryPlaceholder"], StyleMenuListing -> None, 
             DrawHighlighted -> True, FontSlant -> "Italic", Background -> 
             RGBColor[0.912505, 0.891798, 0.507774], 
             TagBoxOptions -> {
              Editable -> False, Selectable -> False, StripWrapperBoxes -> 
               False}], 
            Cell[
             StyleData["PrimaryPlaceholder", "Presentation"]], 
            Cell[
             StyleData["PrimaryPlaceholder", "Condensed"]], 
            Cell[
             StyleData["PrimaryPlaceholder", "Printout"]]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["FormatType Styles", "Section"], 
         Cell[
         "The cells below define styles that are mixed in with the styles of \
most cells.  If a cell's FormatType matches the name of one of the styles \
defined below, then that style is applied between the cell's style and its \
own options. This is particularly true of Input and Output.", "Text"], 
         Cell[
          StyleData["CellExpression"], PageWidth -> Infinity, 
          CellMargins -> {{6, Inherited}, {Inherited, Inherited}}, 
          ShowCellLabel -> False, ShowSpecialCharacters -> False, 
          AllowInlineCells -> False, Hyphenation -> False, 
          AutoItalicWords -> {}, StyleMenuListing -> None, FontFamily -> 
          "Courier", FontSize -> 12, Background -> GrayLevel[1]], 
         Cell[
          StyleData["InputForm"], InputAutoReplacements -> {}, 
          AllowInlineCells -> False, Hyphenation -> False, StyleMenuListing -> 
          None, FontFamily -> "Courier"], 
         Cell[
          StyleData["OutputForm"], PageWidth -> Infinity, TextAlignment -> 
          Left, LineSpacing -> {0.6, 1}, StyleMenuListing -> None, FontFamily -> 
          "Courier"], 
         Cell[
          StyleData["StandardForm"], 
          InputAutoReplacements -> {
           "->" -> "\[Rule]", ":>" -> "\[RuleDelayed]", "<=" -> 
            "\[LessEqual]", ">=" -> "\[GreaterEqual]", "!=" -> "\[NotEqual]", 
            "==" -> "\[Equal]", Inherited}, LineSpacing -> {1.25, 0}, 
          StyleMenuListing -> None, FontFamily -> "Courier"], 
         Cell[
          StyleData["TraditionalForm"], 
          InputAutoReplacements -> {
           "->" -> "\[Rule]", ":>" -> "\[RuleDelayed]", "<=" -> 
            "\[LessEqual]", ">=" -> "\[GreaterEqual]", "!=" -> "\[NotEqual]", 
            "==" -> "\[Equal]", Inherited}, LineSpacing -> {1.25, 0}, 
          SingleLetterItalics -> True, TraditionalFunctionNotation -> True, 
          DelimiterMatching -> None, StyleMenuListing -> None], 
         Cell[
         "The style defined below is mixed in to any cell that is in an \
inline cell within another.", "Text"], 
         Cell[
          StyleData["InlineCell"], LanguageCategory -> "Formula", ScriptLevel -> 
          1, StyleMenuListing -> None], 
         Cell[
          StyleData["InlineCellEditing"], StyleMenuListing -> None, 
          Background -> RGBColor[1, 0.749996, 0.8]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Automatic Styles", "Section"], 
         Cell[
         "The cells below define styles that are used to affect the display \
of certain types of objects in typeset expressions.  For example, \
\"UnmatchedBracket\" style defines how unmatched bracket, curly bracket, and \
parenthesis characters are displayed (typically by coloring them to make them \
stand out).", "Text"], 
         Cell[
          StyleData["UnmatchedBracket"], StyleMenuListing -> None, FontColor -> 
          RGBColor[0.760006, 0.330007, 0.8]]}, Closed]]}, Open]]}, Visible -> 
  False, FrontEndVersion -> 
  "8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 100, 5, 144, "Title"],
Cell[670, 29, 180, 6, 88, "Subtitle"],
Cell[853, 37, 84, 3, 96, "Subsubtitle"],
Cell[CellGroupData[{
Cell[962, 44, 25, 0, 72, "Section"],
Cell[990, 46, 1008, 25, 291, "PackageInput"],
Cell[2001, 73, 128, 3, 39, "Text"],
Cell[2132, 78, 4458, 116, 889, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[6627, 199, 32, 0, 72, "Section"],
Cell[6662, 201, 135, 3, 62, "Text"],
Cell[6800, 206, 400, 11, 153, "PackageInput",
 InitializationCell->True],
Cell[7203, 219, 319, 8, 62, "Text"],
Cell[7525, 229, 268, 8, 62, "Text"],
Cell[7796, 239, 178, 5, 36, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8011, 249, 42, 0, 72, "Section"],
Cell[8056, 251, 532, 9, 176, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[8625, 265, 31, 0, 72, "Section"],
Cell[8659, 267, 60, 0, 39, "Text"],
Cell[8722, 269, 108, 2, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[8855, 275, 43, 0, 63, "Subsection"],
Cell[8901, 277, 158, 4, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[9084, 285, 47, 0, 57, "Subsubsection"],
Cell[9134, 287, 319, 7, 62, "PackageInput"],
Cell[9456, 296, 201, 4, 84, "PackageInput"],
Cell[9660, 302, 638, 16, 85, "PackageInput"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10335, 323, 44, 0, 57, "Subsubsection"],
Cell[10382, 325, 589, 17, 112, "PackageInput"],
Cell[10974, 344, 713, 21, 112, "PackageInput"],
Cell[11690, 367, 624, 17, 85, "PackageInput"],
Cell[12317, 386, 492, 13, 85, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[12846, 404, 31, 0, 34, "Subsubsection"],
Cell[12880, 406, 511, 14, 832, "PackageInput"],
Cell[13394, 422, 461, 11, 640, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[13892, 438, 28, 0, 34, "Subsubsection"],
Cell[13923, 440, 72, 2, 324, "Text"],
Cell[13998, 444, 803, 26, 640, "PackageInput"],
Cell[14804, 472, 876, 27, 879, "PackageInput"],
Cell[15683, 501, 72, 2, 316, "Text"],
Cell[15758, 505, 635, 21, 640, "PackageInput",
 Evaluatable->False],
Cell[16396, 528, 1492, 46, 1081, "PackageInput"],
Cell[17891, 576, 72, 2, 324, "Text"],
Cell[17966, 580, 1313, 42, 819, "PackageInput"],
Cell[19282, 624, 2534, 74, 1608, "PackageInput"],
Cell[21819, 700, 72, 2, 324, "Text"],
Cell[21894, 704, 1806, 54, 1518, "PackageInput"],
Cell[23703, 760, 4591, 127, 2308, "PackageInput"],
Cell[28297, 889, 72, 2, 324, "Text"],
Cell[28372, 893, 960, 30, 973, "PackageInput"],
Cell[29335, 925, 2131, 59, 1851, "PackageInput"],
Cell[31469, 986, 682, 21, 852, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[32188, 1012, 313, 11, 43, "Subsubsection"],
Cell[32504, 1025, 72, 2, 324, "Text"],
Cell[32579, 1029, 691, 23, 832, "PackageInput"],
Cell[33273, 1054, 1013, 31, 640, "PackageInput"],
Cell[34289, 1087, 72, 2, 316, "Text"],
Cell[34364, 1091, 970, 31, 864, "PackageInput"],
Cell[35337, 1124, 1829, 55, 991, "PackageInput"],
Cell[37169, 1181, 72, 2, 324, "Text"],
Cell[37244, 1185, 1914, 59, 1243, "PackageInput"],
Cell[39161, 1246, 3546, 106, 1338, "PackageInput"],
Cell[42710, 1354, 72, 2, 324, "Text"],
Cell[42785, 1358, 2019, 61, 1216, "PackageInput"],
Cell[44807, 1421, 4960, 144, 1864, "PackageInput"],
Cell[49770, 1567, 72, 2, 316, "Text"],
Cell[49845, 1571, 1179, 37, 973, "PackageInput"],
Cell[51027, 1610, 2313, 63, 2169, "PackageInput"],
Cell[53343, 1675, 584, 18, 852, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[53964, 1698, 222, 7, 34, "Subsubsection"],
Cell[54189, 1707, 187, 5, 468, "PackageInput"],
Cell[54379, 1714, 254, 6, 649, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[54670, 1725, 332, 10, 42, "Subsubsection"],
Cell[55005, 1737, 236, 6, 640, "PackageInput"],
Cell[55244, 1745, 593, 18, 913, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[55874, 1768, 161, 6, 39, "Subsubsection"],
Cell[56038, 1776, 260, 7, 748, "PackageInput"],
Cell[56301, 1785, 628, 19, 1107, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[56966, 1809, 260, 10, 55, "Subsubsection"],
Cell[57229, 1821, 191, 5, 468, "PackageInput"],
Cell[57423, 1828, 1336, 42, 819, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[58796, 1875, 233, 9, 54, "Subsubsection"],
Cell[59032, 1886, 340, 10, 670, "PackageInput"],
Cell[59375, 1898, 1924, 57, 991, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[61336, 1960, 267, 10, 54, "Subsubsection"],
Cell[61606, 1972, 317, 9, 670, "PackageInput"],
Cell[61926, 1983, 1953, 58, 991, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[63916, 2046, 434, 13, 43, "Subsubsection"],
Cell[64353, 2061, 436, 13, 823, "PackageInput"],
Cell[64792, 2076, 991, 28, 1278, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[65820, 2109, 145, 6, 37, "Subsubsection"],
Cell[65968, 2117, 72, 2, 324, "Text"],
Cell[66043, 2121, 765, 25, 832, "PackageInput"],
Cell[66811, 2148, 774, 23, 640, "PackageInput"],
Cell[67588, 2173, 72, 2, 316, "Text"],
Cell[67663, 2177, 1046, 34, 832, "PackageInput"],
Cell[68712, 2213, 1270, 39, 1156, "PackageInput"],
Cell[69985, 2254, 72, 2, 324, "Text"],
Cell[70060, 2258, 2629, 82, 1963, "PackageInput"],
Cell[72692, 2342, 3137, 91, 1986, "PackageInput"],
Cell[75832, 2435, 72, 2, 324, "Text"],
Cell[75907, 2439, 4745, 134, 4132, "PackageInput"],
Cell[80655, 2575, 5266, 146, 5487, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[85958, 2726, 401, 13, 43, "Subsubsection"],
Cell[86362, 2741, 1916, 51, 751, "PackageInput"],
Cell[88281, 2794, 1915, 51, 751, "PackageInput"],
Cell[90199, 2847, 1948, 49, 832, "PackageInput"],
Cell[92150, 2898, 1921, 48, 756, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[94108, 2951, 35, 0, 34, "Subsubsection"],
Cell[94146, 2953, 425, 12, 640, "PackageInput"],
Cell[94574, 2967, 500, 14, 850, "PackageInput"],
Cell[95077, 2983, 590, 17, 640, "PackageInput"],
Cell[95670, 3002, 662, 19, 850, "PackageInput"],
Cell[96335, 3023, 729, 21, 640, "PackageInput"],
Cell[97067, 3046, 806, 23, 1032, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[97910, 3074, 44, 0, 34, "Subsubsection"],
Cell[97957, 3076, 321, 9, 285, "Input",
 Evaluatable->False]
}, Closed]],
Cell[CellGroupData[{
Cell[98315, 3090, 35, 0, 34, "Subsubsection"],
Cell[98353, 3092, 391, 11, 337, "Input",
 Evaluatable->False],
Cell[98747, 3105, 574, 17, 352, "Input",
 Evaluatable->False],
Cell[99324, 3124, 897, 27, 352, "Input",
 Evaluatable->False],
Cell[100224, 3153, 1452, 44, 352, "Input",
 Evaluatable->False]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[101737, 3204, 34, 0, 72, "Section"],
Cell[101774, 3206, 64, 0, 292, "Text"],
Cell[101841, 3208, 508, 12, 1683, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
