(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    119345,       3425]
NotebookOptionsPosition[    113322,       3234]
NotebookOutlinePosition[    113760,       3253]
CellTagsIndexPosition[    113717,       3250]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Completion Field Package", "Title"],

Cell["\<\
Markus van Almsick
Technische Universiteit Eindhoven
\[Copyright]2005\
\>", "Subsubtitle"],

Cell[CellGroupData[{

Cell["Prefix", "Section",
 CellChangeTimes->{{3.488872136461623*^9, 3.488872137145133*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
     "TimeStamp", "[", "\"\<MathVisionTools`CompletionField`\>\"", "]"}], " ",
      "=", " ", 
     RowBox[{"{", 
      RowBox[{"2005", ",", "12", ",", "12", ",", "23", ",", "27", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput"],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`CompletionField`"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Author", ":", " ", 
     RowBox[{"Markus", " ", "van", " ", "Almsick"}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"M", ".", "v", ".", 
       RowBox[{"Almsick", "@", "tue"}], ".", "nl"}]}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`CompletionField`"}]}], 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "1.2"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "5.1"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2005"}]}]}], ",", " ", 
    RowBox[{"Technische", " ", "Universiteit", " ", "Eindhoven"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Title", ":", " ", 
      RowBox[{"Stochastic", " ", "Completion", " ", "Field"}]}]}], ",", " ", 
    RowBox[{"Tensor", " ", "Voting"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "implements", " ", "routines", " ", "for", 
      " ", "line", " ", "and", " ", "edge", " ", "completion"}]}]}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", 
      RowBox[{"Stochastic", " ", "Completion", " ", "Field"}]}]}], ",", " ", 
    RowBox[{"Tensor", " ", "Voting"}], ",", " ", "Spline", ",", " ", 
    "Steerability"}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"March", " ", "2005"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{
     RowBox[{"Limitations", ":", " ", 
      RowBox[{
      "The", " ", "analytic", " ", "implentation", " ", "of", " ", "the", " ",
        "stochastic", " ", "completion", " ", "kernel", " ", "is"}]}], 
     "\[IndentingNewLine]", 
     RowBox[{
     "an", " ", "approximation", " ", "for", " ", "small", " ", "angels", " ", 
      RowBox[{"\[Alpha]", ".", " ", "The"}], " ", "tensor", " ", "voting", 
      " ", "field", " ", "is", " ", "in", " ", "accordance", " ", "with", " ",
       "the", " ", "stochastic", " ", "completion", " ", 
      RowBox[{"field", ".", " ", "It"}], " ", "is", " ", "NOT", " ", 
      RowBox[{"Medioni", "'"}], "s", " ", "completion", " ", "field"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeginPackage", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<MathVisionTools`CompletionField`\>\"", ",", 
    RowBox[{"{", "\"\<Splines`\>\"", "}"}]}], "\[IndentingNewLine]", "]"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{"Unprotect", "[", "\[IndentingNewLine]", 
  RowBox[{
  "CompletionKernelAlongX", ",", "\[IndentingNewLine]", 
   "NCompletionKernelAlongX", ",", "\[IndentingNewLine]", 
   "NCompletionKernelxyMarginalAlongX", ",", "\[IndentingNewLine]", 
   "CompletionKernel", ",", "\[IndentingNewLine]", "NCompletionKernel", ",", 
   "\[IndentingNewLine]", "NCompletionKernelxyMarginal", ",", 
   "\[IndentingNewLine]", "PolarCompletionKernel", ",", "\[IndentingNewLine]",
    "NPolarCompletionKernel", ",", "\[IndentingNewLine]", 
   "NPolarCompletionKernelr\[Theta]Marginal", ",", "\[IndentingNewLine]", 
   "PolarCompletionKernelM", ",", "\[IndentingNewLine]", 
   "NPolarCompletionKernelM", ",", "\[IndentingNewLine]", 
   "NPolarCompletionKernelMr\[Theta]Marginal", ",", "\[IndentingNewLine]", 
   "CompletionField", ",", "\[IndentingNewLine]", "CompletionMode", ",", 
   "\[IndentingNewLine]", "CompletionModeAlongX", ",", "\[IndentingNewLine]", 
   "CompletionSpline", ",", "\[IndentingNewLine]", "TensorVotingKernel", ",", 
   "\[IndentingNewLine]", "TensorVotingKernelM", ",", "\[IndentingNewLine]", 
   "MedioniTensorVotingKernel"}], "\[IndentingNewLine]", 
  "]"}]}], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.498732254153695*^9, 3.4987322570131817`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CompletionKernelAlongX", "::", "usage"}], " ", "=", " ", 
   "\"\<CompletionKernelAlongX[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,y,\
\[Alpha]]. CompletionKernelAlongX[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,y]\
\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NCompletionKernelAlongX", "::", "usage"}], " ", "=", " ", 
   "\"\<NCompletionKernelAlongX[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y,\
\[Alpha]]\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NCompletionKernelxyMarginalAlongX", "::", "usage"}], " ", "=", 
   " ", "\"\<NCompletionKernelxyMarginalAlongX[\[Sigma],\[Lambda],\[Alpha]0,\
\[Kappa],x,y]\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CompletionKernel", "::", "usage"}], " ", "=", " ", 
   "\"\<CompletionKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,y,\[Alpha]].\
 CompletionKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,y]\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NCompletionKernel", "::", "usage"}], " ", "=", " ", 
   "\"\<NCompletionKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y,\[Alpha]]\
\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NCompletionKernelxyMarginal", "::", "usage"}], " ", "=", " ", 
   "\"\<NCompletionKernelxyMarginal[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y]\
\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PolarCompletionKernel", "::", "usage"}], " ", "=", " ", 
   "\"\<PolarCompletionKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][r,\
\[Theta],\[Alpha]]. PolarCompletionKernel[\[Sigma],\[Lambda],\[Alpha]0,\
\[Kappa]][r,\[Theta]]\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 

 RowBox[{
  RowBox[{
   RowBox[{"NPolarCompletionKernel", "::", "usage"}], " ", "=", " ", 
   "\"\<NPolarCompletionKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],r,\
\[Theta],\[Alpha]]\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NPolarCompletionKernelr\[Theta]Marginal", "::", "usage"}], " ", 
   "=", " ", 
   "\"\<NPolarCompletionKernelr\[Theta]Marginal[\[Sigma],\[Lambda],\[Alpha]0,\
\[Kappa],r,\[Theta]]\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PolarCompletionKernelM", "::", "usage"}], " ", "=", " ", 
   "\"\<PolarCompletionKernelM[m,\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][r,\
\[Alpha]].PolarCompletionKernelM[m,\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][r]\>\
\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NPolarCompletionKernelM", "::", "usage"}], " ", "=", " ", 
   "\"\<NPolarCompletionKernelM[m,\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],r,\
\[Alpha]]\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NPolarCompletionKernelMrMarginal", "::", "usage"}], " ", "=", 
   " ", "\"\<NPolarCompletionKernelMr\[Theta]Marginal[m,\[Sigma],\[Lambda],\
\[Alpha]0,\[Kappa],r]\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 

 RowBox[{
  RowBox[{
   RowBox[{"CompletionField", "::", "usage"}], " ", "=", " ", 
   "\"\<CompletionField[\[Sigma],\[Lambda],{x0,y0,\[Alpha]0,\[Kappa]0},{x1,y1,\
\[Alpha]1,\[Kappa]1}][x,y,\[Alpha]]. \
CompletionField[\[Sigma],\[Lambda],{x0,y0,\[Alpha]0,\[Kappa]0},{x1,y1,\[Alpha]\
1,\[Kappa]1}][x,y]\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CompletionMode", "::", "usage"}], " ", "=", " ", 
   "\"\<CompletionMode[{x0,y0,\[Alpha]0,\[Kappa]0},{x1,y1,\[Alpha]1,\[Kappa]1}\
][t]\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CompletionModeAlongX", "::", "usage"}], " ", "=", " ", 
   "\"\<CompletionModeAlongX[{x0,y0,\[Alpha]0,\[Kappa]0},{x1,y1,\[Alpha]1,\
\[Kappa]1}][t]\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CompletionSpline", "::", "usage"}], " ", "=", " ", 
   "\"\<CompletionSpline[{x0,y0,\[Alpha]0},{x1,y1,\[Alpha]1}]\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TensorVotingKernel", "::", "usage"}], " ", "=", " ", 
   "\"\<TensorVotingKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][r,\[Theta]]\
\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TensorVotingKernelM", "::", "usage"}], " ", "=", " ", 
   "\"\<TensorVotingKernelM[m,\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][r]\>\""}]\
, "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MedioniTensorVotingKernel", "::", "usage"}], " ", "=", " ", 
  "\"\<MedioniTensorVotingKernel[\[Sigma],c][r,\[Theta]].\
MedioniTensorVotingKernel[1,\[Sigma],c][r,\[Theta]].MedioniTensorVotingKernel[\
2,\[Sigma],c][r,\[Theta]]\>\""}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Completion Kernel Along X", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Completion", " ", "Kernel", " ", "Along", " ", "X"}], " ", 
  "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Numeric Implementation", "Subsubsection"],

Cell["Implementing a compiled version of the completion kernel.", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Numeric", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"NCompletionKernelAlongX", "=", 
     RowBox[{"Compile", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\[Sigma]", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Lambda]", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Alpha]0", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Kappa]", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"y", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Alpha]", ",", "_Real"}], "}"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"x", ">", "0"}], "\[And]", " ", 
          RowBox[{
           RowBox[{"2", " ", 
            RowBox[{"Abs", "[", "\[Alpha]0", "]"}]}], "<", "\[Pi]"}], 
          "\[And]", " ", 
          RowBox[{
           RowBox[{"2", " ", 
            RowBox[{"Abs", "[", "\[Alpha]", "]"}]}], "<", "\[Pi]"}]}], ",", 
         RowBox[{"Chop", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               SqrtBox["3"], 
               RowBox[{"\[Pi]", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"x", " ", "\[Sigma]"}], ")"}], "2"]}]], 
              RowBox[{"Exp", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", "x"}], " ", "\[Lambda]"}], "-", 
                FractionBox[
                 RowBox[{"2", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"3", " ", 
                    SuperscriptBox["#1", "2"]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"x", " ", "#2"}], "-", 
                    RowBox[{"3", " ", "#1"}]}], ")"}], " ", "x", " ", 
                    "#2"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["x", "3"], " ", 
                  SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], ")"}], "&"}],
            "[", 
           RowBox[{
            RowBox[{"y", "-", 
             RowBox[{"x", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Tan", "[", "\[Alpha]0", "]"}], "+", 
                RowBox[{"\[Kappa]", " ", 
                 RowBox[{"x", "/", "2"}]}]}], ")"}]}]}], ",", 
            RowBox[{
             RowBox[{"Tan", "[", "\[Alpha]", "]"}], "-", 
             RowBox[{"Tan", "[", "\[Alpha]0", "]"}], "-", 
             RowBox[{"\[Kappa]", " ", "x"}]}]}], "]"}], "]"}], ",", "0.0"}], 
        "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]",
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CompletionKernelAlongX", "[", 
       RowBox[{
        RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
        RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
        RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
        RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
      RowBox[{
       RowBox[{"0", "|", "0.0"}], ",", " ", 
       RowBox[{"y_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Alpha]_", "?", "NumberQ"}]}], "]"}], "=", 
     RowBox[{
      RowBox[{"DiracDelta", "[", "y", "]"}], " ", 
      RowBox[{"DiracDelta", "[", 
       RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CompletionKernelAlongX", "[", 
      RowBox[{
       RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
     RowBox[{
      RowBox[{"x_", "?", "NumberQ"}], ",", " ", 
      RowBox[{"y_", "?", "NumberQ"}], ",", 
      RowBox[{"\[Alpha]_", "?", "NumberQ"}]}], "]"}], ":=", 
    RowBox[{"NCompletionKernelAlongX", "[", 
     RowBox[{
     "\[Sigma]", ",", "\[Lambda]", ",", "\[Alpha]0", ",", "\[Kappa]", ",", 
      "x", ",", "y", ",", "\[Alpha]"}], "]"}]}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"NCompletionKernelxyMarginalAlongX", "=", 
    RowBox[{"Compile", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Sigma]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Lambda]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Alpha]0", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Kappa]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"y", ",", "_Real"}], "}"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"x", ">", "0"}], "\[And]", " ", 
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Abs", "[", "\[Alpha]0", "]"}]}], "<", "\[Pi]"}]}], ",", 
        RowBox[{"Chop", "[", 
         RowBox[{
          SqrtBox[
           FractionBox["3", 
            RowBox[{"2", " ", "\[Pi]", " ", 
             SuperscriptBox["x", "3"], " ", 
             SuperscriptBox["\[Sigma]", "2"]}]]], " ", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "x"}], " ", "\[Lambda]"}], "-", 
            RowBox[{
             FractionBox["3", 
              RowBox[{"8", " ", 
               SuperscriptBox["x", "3"], " ", 
               SuperscriptBox["\[Sigma]", "2"]}]], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"x", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", 
                    RowBox[{"Tan", "[", "\[Alpha]0", "]"}]}], "+", 
                   RowBox[{"x", " ", "\[Kappa]"}]}], ")"}]}], "-", 
                RowBox[{"2", " ", "y"}]}], ")"}], "2"]}]}], "]"}]}], "]"}], 
        " ", ",", "0.0"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CompletionKernelAlongX", "[", 
      RowBox[{
       RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
     RowBox[{
      RowBox[{"0", "|", "0.0"}], ",", " ", 
      RowBox[{"y_", "?", "NumberQ"}]}], "]"}], "=", 
    RowBox[{"DiracDelta", "[", "y", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CompletionKernelAlongX", "[", 
    RowBox[{
     RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"x_", "?", "NumberQ"}], ",", " ", 
    RowBox[{"y_", "?", "NumberQ"}]}], "]"}], ":=", 
  RowBox[{"NCompletionKernelxyMarginalAlongX", "[", 
   RowBox[{
   "\[Sigma]", ",", "\[Lambda]", ",", "\[Alpha]0", ",", "\[Kappa]", ",", "x", 
    ",", "y"}], "]"}]}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Symbolic Implementation", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CompletionKernelAlongX", "[", 
       RowBox[{
        RowBox[{"\[Sigma]_:", "1"}], ",", 
        RowBox[{"\[Lambda]_:", "0"}], ",", 
        RowBox[{"\[Alpha]0_:", "0"}], ",", 
        RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
      RowBox[{
       RowBox[{"0", "|", "0.0"}], ",", " ", 
       RowBox[{"0", "|", "0.0"}], ",", "\[Alpha]0_"}], "]"}], "=", 
     RowBox[{"DirectedInfinity", "[", "1", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CompletionKernelAlongX", "[", 
       RowBox[{
        RowBox[{"\[Sigma]_:", "1"}], ",", 
        RowBox[{"\[Lambda]_:", "0"}], ",", 
        RowBox[{"\[Alpha]0_:", "0"}], ",", 
        RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
      RowBox[{
       RowBox[{"0", "|", "0.0"}], ",", " ", "y_", ",", "\[Alpha]_"}], "]"}], 
     "=", "0"}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CompletionKernelAlongX", "[", 
       RowBox[{
        RowBox[{"\[Sigma]_:", "1"}], ",", 
        RowBox[{"\[Lambda]_:", "0"}], ",", 
        RowBox[{"\[Alpha]0_:", "0"}], ",", 
        RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
      RowBox[{"x_", ",", " ", "y_", ",", "\[Alpha]_"}], "]"}], "=", " ", 
     RowBox[{"\[Piecewise]", GridBox[{
        {
         RowBox[{
          FractionBox[
           SqrtBox["3"], 
           RowBox[{"\[Pi]", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"x", " ", "\[Sigma]"}], ")"}], "2"]}]], 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "\[Lambda]"}], " ", "x"}], "]"}], 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", 
             FractionBox["1", 
              RowBox[{"2", " ", 
               SuperscriptBox["x", "3"], " ", 
               SuperscriptBox["\[Sigma]", "2"]}]]}], 
            RowBox[{"(", " ", 
             RowBox[{
              RowBox[{"3", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"x", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Tan", "[", "\[Alpha]", "]"}], "+", 
                    RowBox[{"Tan", "[", "\[Alpha]0", "]"}]}], ")"}]}], "-", 
                  RowBox[{"2", " ", "y"}]}], ")"}], "2"]}], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"x", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Tan", "[", "\[Alpha]", "]"}], "-", 
                   RowBox[{"Tan", "[", "\[Alpha]0", "]"}], "-", 
                   RowBox[{"x", " ", "\[Kappa]"}]}], ")"}]}], ")"}], "2"]}], 
             ")"}]}], "]"}]}], 
         RowBox[{
          RowBox[{"x", ">", "0"}], " ", "\[And]", " ", 
          RowBox[{
           RowBox[{"2", " ", 
            RowBox[{"Abs", "[", "\[Alpha]", "]"}]}], "<", "\[Pi]"}], " ", 
          "\[And]", " ", 
          RowBox[{
           RowBox[{"2", " ", 
            RowBox[{"Abs", "[", "\[Alpha]0", "]"}]}], "<", "\[Pi]"}]}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]}]}], ";"}]}]}]], "PackageInput",\

 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CompletionKernelAlongX", "[", 
      RowBox[{
       RowBox[{"\[Sigma]_:", "1"}], ",", 
       RowBox[{"\[Lambda]_:", "0"}], ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{
      RowBox[{"0", "|", "0.0"}], ",", " ", 
      RowBox[{"0", "|", "0.0"}]}], "]"}], "=", 
    RowBox[{"DirectedInfinity", "[", "1", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CompletionKernelAlongX", "[", 
      RowBox[{
       RowBox[{"\[Sigma]_:", "1"}], ",", 
       RowBox[{"\[Lambda]_:", "0"}], ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{
      RowBox[{"0", "|", "0.0"}], ",", " ", "y_"}], "]"}], "=", "0"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CompletionKernelAlongX", "[", 
     RowBox[{
      RowBox[{"\[Sigma]_:", "1"}], ",", 
      RowBox[{"\[Lambda]_:", "0"}], ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{"x_", ",", " ", "y_"}], "]"}], "=", "  ", 
   RowBox[{"\[Piecewise]", GridBox[{
      {
       RowBox[{
        SqrtBox[
         FractionBox["3", 
          RowBox[{"2", " ", "\[Pi]", " ", 
           SuperscriptBox["x", "3"], " ", 
           SuperscriptBox["\[Sigma]", "2"]}]]], " ", 
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"-", "\[Lambda]"}], " ", "x"}], "]"}], " ", 
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", 
            RowBox[{"8", " ", 
             SuperscriptBox["x", "3"], " ", 
             SuperscriptBox["\[Sigma]", "2"]}]]}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"x", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", 
                 RowBox[{"Tan", "[", "\[Alpha]0", "]"}]}], "+", 
                RowBox[{"x", " ", "\[Kappa]"}]}], ")"}]}], "-", 
             RowBox[{"2", " ", "y"}]}], ")"}], "2"]}], "]"}]}], 
       RowBox[{
        RowBox[{"x", ">", "0"}], " ", "\[And]", " ", 
        RowBox[{
         RowBox[{"2", " ", 
          RowBox[{"Abs", "[", "\[Alpha]0", "]"}]}], "<", "\[Pi]"}]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.84]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}]}]}], ";"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Completion Kernel", "Subsection"],

Cell["\<\
Same as completion kernel along x but with the \"x-axis\" aligned along \
\[Alpha]0.\
\>", "Text"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Completion", " ", "Kernel"}], " ", "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Numeric Implementation", "Subsubsection"],

Cell["Implementing a compiled version of the completion kernel.", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Numeric", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"NCompletionKernel", "=", 
     RowBox[{"Compile", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\[Sigma]", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Lambda]", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Alpha]0", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Kappa]", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"xp", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"yp", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Alpha]p", ",", "_Real"}], "}"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Module", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\[Alpha]", "=", 
            RowBox[{"Mod", "[", 
             RowBox[{
              RowBox[{"\[Alpha]p", "-", "\[Alpha]0"}], ",", 
              RowBox[{"2", "\[Pi]"}], ",", 
              RowBox[{"-", "\[Pi]"}]}], "]"}]}], ",", 
           RowBox[{"x", " ", "=", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "xp"}], " ", "+", 
             " ", 
             RowBox[{
              RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "yp"}]}]}], ",", 
           " ", 
           RowBox[{"y", " ", "=", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "xp"}], " ", 
             "+", " ", 
             RowBox[{
              RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "yp"}]}]}]}], 
          "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"x", ">", "0"}], "\[And]", " ", 
            RowBox[{
             RowBox[{"2", " ", 
              RowBox[{"Abs", "[", "\[Alpha]", "]"}]}], "<", "\[Pi]"}]}], ",", 
           
           RowBox[{"Chop", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                FractionBox[
                 SqrtBox["3"], 
                 RowBox[{"\[Pi]", " ", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{"x", " ", "\[Sigma]"}], ")"}], "2"]}]], 
                RowBox[{"Exp", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "x"}], " ", "\[Lambda]"}], "-", 
                  FractionBox[
                   RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"3", " ", 
                    SuperscriptBox["#1", "2"]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"x", " ", "#2"}], "-", 
                    RowBox[{"3", " ", "#1"}]}], ")"}], " ", "x", " ", 
                    "#2"}]}], ")"}]}], 
                   RowBox[{
                    SuperscriptBox["x", "3"], " ", 
                    SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], ")"}], 
              "&"}], "[", 
             RowBox[{
              RowBox[{"y", "-", 
               RowBox[{"\[Kappa]", " ", 
                RowBox[{
                 SuperscriptBox["x", "2"], "/", "2"}]}]}], ",", 
              RowBox[{
               RowBox[{"Tan", "[", "\[Alpha]", "]"}], "-", 
               RowBox[{"\[Kappa]", " ", "x"}]}]}], "]"}], "]"}], ",", "0.0"}],
           "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CompletionKernel", "[", 
       RowBox[{
        RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
        RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
        RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
        RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
      RowBox[{
       RowBox[{"0", "|", "0.0"}], ",", " ", 
       RowBox[{"y_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Alpha]_", "?", "NumberQ"}]}], "]"}], "=", 
     RowBox[{
      RowBox[{"DiracDelta", "[", "y", "]"}], " ", 
      RowBox[{"DiracDelta", "[", 
       RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CompletionKernel", "[", 
      RowBox[{
       RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
     RowBox[{
      RowBox[{"x_", "?", "NumberQ"}], ",", " ", 
      RowBox[{"y_", "?", "NumberQ"}], ",", 
      RowBox[{"\[Alpha]_", "?", "NumberQ"}]}], "]"}], ":=", 
    RowBox[{"NCompletionKernel", "[", 
     RowBox[{
     "\[Sigma]", ",", "\[Lambda]", ",", "\[Alpha]0", ",", "\[Kappa]", ",", 
      "x", ",", "y", ",", "\[Alpha]"}], "]"}]}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"NCompletionKernelxyMarginal", "=", 
    RowBox[{"Compile", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Sigma]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Lambda]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Alpha]0", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Kappa]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"xp", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"yp", ",", "_Real"}], "}"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Module", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x", " ", "=", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "xp"}], " ", "+", 
            " ", 
            RowBox[{
             RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "yp"}]}]}], ",", 
          " ", 
          RowBox[{"y", " ", "=", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"-", 
              RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "xp"}], " ", "+",
             " ", 
            RowBox[{
             RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "yp"}]}]}]}], "}"}],
         ",", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"x", ">", "0"}], ",", 
          RowBox[{"Chop", "[", 
           RowBox[{
            SqrtBox[
             FractionBox["3", 
              RowBox[{"2", " ", "\[Pi]", " ", 
               SuperscriptBox["x", "3"], " ", 
               SuperscriptBox["\[Sigma]", "2"]}]]], " ", 
            RowBox[{"Exp", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "x"}], " ", "\[Lambda]"}], "-", 
              RowBox[{
               FractionBox["3", 
                RowBox[{"8", " ", 
                 SuperscriptBox["x", "3"], " ", 
                 SuperscriptBox["\[Sigma]", "2"]}]], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Kappa]", " ", 
                   SuperscriptBox["x", "2"]}], "-", 
                  RowBox[{"2", " ", "y"}]}], ")"}], "2"]}]}], "]"}]}], "]"}], 
          " ", ",", "0.0"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CompletionKernel", "[", 
      RowBox[{
       RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
     RowBox[{
      RowBox[{"0", "|", "0.0"}], ",", " ", 
      RowBox[{"y_", "?", "NumberQ"}]}], "]"}], "=", 
    RowBox[{"DiracDelta", "[", "y", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CompletionKernel", "[", 
    RowBox[{
     RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"x_", "?", "NumberQ"}], ",", " ", 
    RowBox[{"y_", "?", "NumberQ"}]}], "]"}], ":=", 
  RowBox[{"NCompletionKernelAlongXxyMarginal", "[", 
   RowBox[{
   "\[Sigma]", ",", "\[Lambda]", ",", "\[Alpha]0", ",", "\[Kappa]", ",", "x", 
    ",", "y"}], "]"}]}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Symbolic Implementation", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CompletionKernel", "[", 
       RowBox[{
        RowBox[{"\[Sigma]_:", "1"}], ",", 
        RowBox[{"\[Lambda]_:", "0"}], ",", 
        RowBox[{"\[Alpha]0_:", "0"}], ",", 
        RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
      RowBox[{
       RowBox[{"0", "|", "0.0"}], ",", " ", 
       RowBox[{"0", "|", "0.0"}], ",", "\[Alpha]0_"}], "]"}], "=", 
     RowBox[{"DirectedInfinity", "[", "1", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CompletionKernel", "[", 
       RowBox[{
        RowBox[{"\[Sigma]_:", "1"}], ",", 
        RowBox[{"\[Lambda]_:", "0"}], ",", 
        RowBox[{"\[Alpha]0_:", "0"}], ",", 
        RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
      RowBox[{
       RowBox[{"0", "|", "0.0"}], ",", " ", "y_", ",", "\[Alpha]_"}], "]"}], 
     "=", "0"}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CompletionKernel", "[", 
       RowBox[{
        RowBox[{"\[Sigma]_:", "1"}], ",", 
        RowBox[{"\[Lambda]_:", "0"}], ",", 
        RowBox[{"\[Alpha]0_:", "0"}], ",", 
        RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
      RowBox[{"xp_", ",", " ", "yp_", ",", "\[Alpha]p_"}], "]"}], "=", " ", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Alpha]", "=", 
          RowBox[{"Mod", "[", 
           RowBox[{
            RowBox[{"\[Alpha]p", "-", "\[Alpha]0"}], ",", 
            RowBox[{"2", "\[Pi]"}], ",", 
            RowBox[{"-", "\[Pi]"}]}], "]"}]}], ",", 
         RowBox[{"x", " ", "=", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "xp"}], " ", "+", 
           " ", 
           RowBox[{
            RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "yp"}]}]}], ",", " ", 
         RowBox[{"y", " ", "=", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"-", 
             RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "xp"}], " ", "+", 
           " ", 
           RowBox[{
            RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "yp"}]}]}]}], "}"}], 
       ",", 
       RowBox[{"\[Piecewise]", GridBox[{
          {
           RowBox[{
            FractionBox[
             SqrtBox["3"], 
             RowBox[{"\[Pi]", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"x", " ", "\[Sigma]"}], ")"}], "2"]}]], 
            RowBox[{"Exp", "[", 
             RowBox[{
              RowBox[{"-", "\[Lambda]"}], " ", "x"}], "]"}], 
            RowBox[{"Exp", "[", 
             RowBox[{
              RowBox[{"-", 
               FractionBox["1", 
                RowBox[{"2", " ", 
                 SuperscriptBox["x", "3"], " ", 
                 SuperscriptBox["\[Sigma]", "2"]}]]}], 
              RowBox[{"(", " ", 
               RowBox[{
                RowBox[{"3", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"x", " ", 
                    RowBox[{"Tan", "[", "\[Alpha]", "]"}]}], "-", 
                    RowBox[{"2", " ", "y"}]}], ")"}], "2"]}], "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"x", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Tan", "[", "\[Alpha]", "]"}], "-", 
                    RowBox[{"x", " ", "\[Kappa]"}]}], ")"}]}], ")"}], "2"]}], 
               ")"}]}], "]"}]}], 
           RowBox[{
            RowBox[{"x", ">", "0"}], " ", "\[And]", " ", 
            RowBox[{
             RowBox[{"2", " ", 
              RowBox[{"Abs", "[", "\[Alpha]", "]"}]}], "<", "\[Pi]"}], " ", 
            "\[And]", " ", 
            RowBox[{
             RowBox[{"2", " ", 
              RowBox[{"Abs", "[", "\[Alpha]0", "]"}]}], "<", "\[Pi]"}]}]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.84]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}]}]}], "\[IndentingNewLine]", 
      "]"}]}], ";"}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CompletionKernel", "[", 
      RowBox[{
       RowBox[{"\[Sigma]_:", "1"}], ",", 
       RowBox[{"\[Lambda]_:", "0"}], ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{
      RowBox[{"0", "|", "0.0"}], ",", " ", 
      RowBox[{"0", "|", "0.0"}]}], "]"}], "=", 
    RowBox[{"DirectedInfinity", "[", "1", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CompletionKernel", "[", 
      RowBox[{
       RowBox[{"\[Sigma]_:", "1"}], ",", 
       RowBox[{"\[Lambda]_:", "0"}], ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{
      RowBox[{"0", "|", "0.0"}], ",", " ", "y_"}], "]"}], "=", "0"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CompletionKernel", "[", 
     RowBox[{
      RowBox[{"\[Sigma]_:", "1"}], ",", 
      RowBox[{"\[Lambda]_:", "0"}], ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{"xp_", ",", " ", "yp_"}], "]"}], "=", "  ", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x", " ", "=", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "xp"}], " ", "+", " ", 
         
         RowBox[{
          RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "yp"}]}]}], ",", " ", 
       RowBox[{"y", " ", "=", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "xp"}], " ", "+", 
         " ", 
         RowBox[{
          RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "yp"}]}]}]}], "}"}], 
     ",", 
     RowBox[{"\[Piecewise]", GridBox[{
        {
         RowBox[{
          SqrtBox[
           FractionBox["3", 
            RowBox[{"2", " ", "\[Pi]", " ", 
             SuperscriptBox["x", "3"], " ", 
             SuperscriptBox["\[Sigma]", "2"]}]]], " ", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "\[Lambda]"}], " ", "x"}], "]"}], " ", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", 
             FractionBox["3", 
              RowBox[{"8", " ", 
               SuperscriptBox["x", "3"], " ", 
               SuperscriptBox["\[Sigma]", "2"]}]]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"x", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"2", " ", 
                   RowBox[{"Tan", "[", "\[Alpha]0", "]"}]}], "+", 
                  RowBox[{"x", " ", "\[Kappa]"}]}], ")"}]}], "-", 
               RowBox[{"2", " ", "y"}]}], ")"}], "2"]}], "]"}]}], 
         RowBox[{
          RowBox[{"x", ">", "0"}], " ", "\[And]", " ", 
          RowBox[{
           RowBox[{"2", " ", 
            RowBox[{"Abs", "[", "\[Alpha]0", "]"}]}], "<", "\[Pi]"}]}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Polar Completion Kernel", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Polar", " ", "Completion", " ", "Kernel"}], " ", 
  "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Numeric Implementation", "Subsubsection"],

Cell["Implementing a compiled version of the completion kernel.", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Numeric", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"NPolarCompletionKernel", "=", 
     RowBox[{"Compile", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\[Sigma]", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Lambda]", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Alpha]0", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Kappa]", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"r", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Theta]p", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Alpha]", ",", "_Real"}], "}"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Module", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\[Theta]", " ", "=", " ", 
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{
              RowBox[{"\[Theta]p", "-", 
               RowBox[{"\[Alpha]", "/", "2"}]}], ",", 
              RowBox[{"2", "\[Pi]"}], ",", 
              RowBox[{"-", "\[Pi]"}]}], "]"}], "+", 
            RowBox[{"\[Alpha]", "/", "2"}]}]}], "}"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"r", ">", "0"}], ",", 
           RowBox[{"Chop", "[", 
            RowBox[{
             FractionBox[
              SqrtBox["3"], 
              RowBox[{"\[Pi]", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"r", " ", "\[Sigma]"}], ")"}], "2"]}]], 
             RowBox[{"Exp", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "\[Lambda]"}], " ", "r"}], "-", 
               RowBox[{
                FractionBox["1", 
                 RowBox[{"2", " ", "r", " ", 
                  SuperscriptBox["\[Sigma]", "2"]}]], 
                RowBox[{"(", " ", 
                 RowBox[{
                  RowBox[{"3", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"\[Alpha]", "+", "\[Alpha]0", "-", 
                    RowBox[{"2", "\[Theta]"}]}], ")"}], "2"]}], "+", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{"\[Alpha]", "-", "\[Alpha]0", "-", 
                    RowBox[{"r", " ", "\[Kappa]"}]}], ")"}], "2"]}], 
                 ")"}]}]}], "]"}]}], "]"}], ",", "0.0"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}],
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"PolarCompletionKernel", "[", 
       RowBox[{
        RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
        RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
        RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
        RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
      RowBox[{
       RowBox[{"0", "|", "0.0"}], ",", 
       RowBox[{"\[Theta]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Alpha]_", "?", "NumberQ"}]}], "]"}], "=", 
     RowBox[{
      RowBox[{"DiracDelta", "[", "\[Theta]", "]"}], " ", 
      RowBox[{"DiracDelta", "[", 
       RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PolarCompletionKernel", "[", 
      RowBox[{
       RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
     RowBox[{
      RowBox[{"r_", "?", "NumberQ"}], ",", " ", 
      RowBox[{"\[Theta]_", "?", "NumberQ"}], ",", 
      RowBox[{"\[Alpha]_", "?", "NumberQ"}]}], "]"}], ":=", 
    RowBox[{"NCompletionKernel", "[", 
     RowBox[{
     "\[Sigma]", ",", "\[Lambda]", ",", "\[Alpha]0", ",", "\[Kappa]", ",", 
      "r", ",", "\[Theta]", ",", "\[Alpha]"}], "]"}]}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"NPolarCompletionKernelr\[Theta]Marginal", "=", 
    RowBox[{"Compile", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Sigma]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Lambda]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Alpha]0", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Kappa]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"r", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "_Real"}], "}"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"r", ">", "0"}], ",", 
        RowBox[{"Chop", "[", 
         RowBox[{
          SqrtBox[
           FractionBox["3", 
            RowBox[{"2", " ", "\[Pi]", " ", 
             SuperscriptBox["r", "3"], " ", 
             SuperscriptBox["\[Sigma]", "2"]}]]], " ", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "\[Lambda]"}], " ", "r"}], "-", 
            RowBox[{
             FractionBox["3", 
              RowBox[{"8", " ", "r", " ", 
               SuperscriptBox["\[Sigma]", "2"]}]], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", 
                 RowBox[{"(", 
                  RowBox[{"\[Alpha]0", "-", "\[Theta]"}], ")"}]}], "+", 
                RowBox[{"r", " ", "\[Kappa]"}]}], ")"}], "2"]}]}], "]"}]}], 
         "]"}], ",", "0.0"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"PolarCompletionKernel", "[", 
      RowBox[{
       RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
     RowBox[{
      RowBox[{"0", "|", "0.0"}], ",", " ", 
      RowBox[{"\[Theta]_", "?", "NumberQ"}]}], "]"}], "=", 
    RowBox[{"DiracDelta", "[", "\[Theta]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PolarCompletionKernel", "[", 
    RowBox[{
     RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"r_", "?", "NumberQ"}], ",", " ", 
    RowBox[{"\[Theta]_", "?", "NumberQ"}]}], "]"}], ":=", 
  RowBox[{"NPolarCompletionKernelr\[Theta]Marginal", "[", 
   RowBox[{
   "\[Sigma]", ",", "\[Lambda]", ",", "\[Alpha]0", ",", "\[Kappa]", ",", "r", 
    ",", "\[Theta]"}], "]"}]}]}], "PackageInput",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"NPolarCompletionKernelM", "=", 
    RowBox[{"Compile", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"m", ",", "_Integer"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Sigma]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Lambda]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Alpha]0", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Kappa]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"r", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Alpha]", ",", "_Real"}], "}"}]}], "}"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"r", ">", "0"}], ",", 
        RowBox[{"Chop", "[", 
         RowBox[{
          FractionBox["1", 
           RowBox[{
            SqrtBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"2", "\[Pi]", " ", "r"}], ")"}], "3"]], " ", 
            "\[Sigma]"}]], " ", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "\[ImaginaryI]"}], 
             FractionBox["m", "2"], 
             RowBox[{"(", 
              RowBox[{"\[Alpha]", "+", "\[Alpha]0"}], ")"}]}], "-", 
            RowBox[{"r", " ", "\[Lambda]"}], "-", 
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"\[Alpha]", "-", "\[Alpha]0", "-", 
                RowBox[{"r", " ", "\[Kappa]"}]}], ")"}], "2"], 
             RowBox[{"2", " ", "r", " ", 
              SuperscriptBox["\[Sigma]", "2"]}]], "-", 
            RowBox[{
             FractionBox[
              SuperscriptBox["m", "2"], "24"], "r", " ", 
             SuperscriptBox["\[Sigma]", "2"]}]}], "]"}]}], "]"}], ",", "0"}], 
       "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"PolarCompletionKernelM", "[", 
      RowBox[{"0", ",", 
       RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
     RowBox[{
      RowBox[{"r_", "?", "NumberQ"}], ",", 
      RowBox[{"\[Alpha]_", "?", "NumberQ"}]}], "]"}], "=", 
    RowBox[{
     RowBox[{"DiracDelta", "[", "r", "]"}], 
     RowBox[{"DiracDelta", "[", 
      RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"PolarCompletionKernelM", "[", 
      RowBox[{"m_Integer", ",", 
       RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
     RowBox[{
      RowBox[{"0", "|", "0.0"}], ",", 
      RowBox[{"\[Alpha]_", "?", "NumberQ"}]}], "]"}], "=", "0"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PolarCompletionKernelM", "[", 
    RowBox[{"m_Integer", ",", 
     RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"r_", "?", "NumberQ"}], ",", 
    RowBox[{"\[Alpha]_", "?", "NumberQ"}]}], "]"}], ":=", 
  RowBox[{"NPolarCompletionKernelM", "[", 
   RowBox[{
   "m", ",", "\[Sigma]", ",", "\[Lambda]", ",", "\[Alpha]0", ",", "\[Kappa]", 
    ",", "r", ",", "\[Alpha]"}], "]"}]}]}], "PackageInput",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"NPolarCompletionKernelMr\[Theta]Marginal", "=", 
    RowBox[{"Compile", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"m", ",", "_Integer"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Sigma]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Lambda]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Alpha]0", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Kappa]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"r", ",", "_Real"}], "}"}]}], "}"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"r", ">", "0"}], ",", 
        RowBox[{"Chop", "[", 
         RowBox[{
          FractionBox["1", 
           RowBox[{"2", " ", "\[Pi]", " ", "r"}]], 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "\[ImaginaryI]"}], " ", 
             FractionBox["m", "2"], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", "\[Alpha]0"}], "+", 
               RowBox[{"r", " ", "\[Kappa]"}]}], ")"}]}], "-", 
            RowBox[{"r", " ", "\[Lambda]"}], "-", 
            RowBox[{
             FractionBox[
              SuperscriptBox["m", "2"], "6"], " ", "r", " ", 
             SuperscriptBox["\[Sigma]", "2"]}]}], "]"}]}], "]"}], ",", "0"}], 
       "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"PolarCompletionKernelM", "[", 
      RowBox[{"0", ",", 
       RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
     RowBox[{"r_", "?", "NumberQ"}], "]"}], "=", 
    RowBox[{"DiracDelta", "[", "r", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"PolarCompletionKernelM", "[", 
      RowBox[{"m_Integer", ",", 
       RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
       RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
     RowBox[{"0", "|", "0.0"}], "]"}], "=", "0"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PolarCompletionKernelM", "[", 
    RowBox[{"m_Integer", ",", 
     RowBox[{"\[Sigma]_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Lambda]_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Alpha]0_", "?", "NumberQ"}], ",", 
     RowBox[{"\[Kappa]_", "?", "NumberQ"}]}], "]"}], "[", 
   RowBox[{"r_", "?", "NumberQ"}], "]"}], ":=", 
  RowBox[{"NPolarCompletionKernelMr\[Theta]Marginal", "[", 
   RowBox[{
   "m", ",", "\[Sigma]", ",", "\[Lambda]", ",", "\[Alpha]0", ",", "\[Kappa]", 
    ",", "r"}], "]"}]}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Symbolic Implementation", "Subsubsection"],

Cell["Full kernel in position and angle. ", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"PolarCompletionKernel", "[", 
       RowBox[{
        RowBox[{"\[Sigma]_:", "1"}], ",", 
        RowBox[{"\[Lambda]_:", "0"}], ",", 
        RowBox[{"\[Alpha]0_:", "0"}], ",", 
        RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
      RowBox[{
       RowBox[{"0", "|", "0.0"}], ",", " ", 
       RowBox[{"0", "|", "0.0"}], ",", "\[Alpha]0_"}], "]"}], "=", 
     RowBox[{"DirectedInfinity", "[", "1", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"PolarCompletionKernel", "[", 
       RowBox[{
        RowBox[{"\[Sigma]_:", "1"}], ",", 
        RowBox[{"\[Lambda]_:", "0"}], ",", 
        RowBox[{"\[Alpha]0_:", "0"}], ",", 
        RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
      RowBox[{
       RowBox[{"0", "|", "0.0"}], ",", " ", "\[Theta]_", ",", "\[Alpha]_"}], 
      "]"}], "=", "0"}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"PolarCompletionKernel", "[", 
       RowBox[{
        RowBox[{"\[Sigma]_:", "1"}], ",", 
        RowBox[{"\[Lambda]_:", "0"}], ",", 
        RowBox[{"\[Alpha]0_:", "0"}], ",", 
        RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
      RowBox[{"r_", ",", " ", "\[Theta]_", ",", "\[Alpha]_"}], "]"}], "=", 
     RowBox[{
      FractionBox[
       SqrtBox["3"], 
       RowBox[{"\[Pi]", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"r", " ", "\[Sigma]"}], ")"}], "2"]}]], 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"-", "\[Lambda]"}], " ", "r"}], "]"}], 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", 
          RowBox[{"2", " ", "r", " ", 
           SuperscriptBox["\[Sigma]", "2"]}]]}], 
        RowBox[{"(", " ", 
         RowBox[{
          RowBox[{"3", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[Alpha]", "+", "\[Alpha]0", "-", 
              RowBox[{"2", " ", "\[Theta]"}]}], ")"}], "2"]}], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[Alpha]", "-", "\[Alpha]0", "-", 
             RowBox[{"r", " ", "\[Kappa]"}]}], ")"}], "2"]}], ")"}]}], 
       "]"}]}]}], ";"}]}]}]], "PackageInput",
 InitializationCell->True],

Cell["The xy-Marginal of the kernel.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"PolarCompletionKernel", "[", 
      RowBox[{
       RowBox[{"\[Sigma]_:", "1"}], ",", 
       RowBox[{"\[Lambda]_:", "0"}], ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{
      RowBox[{"0", "|", "0.0"}], ",", " ", 
      RowBox[{"0", "|", "0.0"}]}], "]"}], "=", 
    RowBox[{"DirectedInfinity", "[", "1", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"PolarCompletionKernel", "[", 
      RowBox[{
       RowBox[{"\[Sigma]_:", "1"}], ",", 
       RowBox[{"\[Lambda]_:", "0"}], ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{
      RowBox[{"0", "|", "0.0"}], ",", " ", "\[Theta]_"}], "]"}], "=", "0"}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PolarCompletionKernel", "[", 
     RowBox[{
      RowBox[{"\[Sigma]_:", "1"}], ",", 
      RowBox[{"\[Lambda]_:", "0"}], ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{"r_", ",", " ", "\[Theta]_"}], "]"}], "=", " ", 
   RowBox[{
    SqrtBox[
     FractionBox["3", 
      RowBox[{"2", " ", "\[Pi]", " ", 
       SuperscriptBox["r", "3"], " ", 
       SuperscriptBox["\[Sigma]", "2"]}]]], " ", 
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"-", "\[Lambda]"}], " ", "r"}], "]"}], " ", 
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["3", 
        RowBox[{"8", " ", "r", " ", 
         SuperscriptBox["\[Sigma]", "2"]}]]}], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", 
          RowBox[{"(", 
           RowBox[{"\[Alpha]0", "-", "\[Theta]"}], ")"}]}], "+", 
         RowBox[{"r", " ", "\[Kappa]"}]}], ")"}], "2"]}], "]"}]}]}], 
  ";"}]}], "PackageInput",
 InitializationCell->True],

Cell["m-modes of the polar completion kernel for steerability:", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"PolarCompletionKernelM", "[", 
      RowBox[{"0", ",", 
       RowBox[{"\[Sigma]_:", "1"}], ",", 
       RowBox[{"\[Lambda]_:", "0"}], ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{
      RowBox[{"0", "|", "0.0"}], ",", "\[Alpha]0_"}], "]"}], "=", 
    RowBox[{"DirectedInfinity", "[", "1", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"PolarCompletionKernelM", "[", 
      RowBox[{"m_", ",", 
       RowBox[{"\[Sigma]_:", "1"}], ",", 
       RowBox[{"\[Lambda]_:", "0"}], ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{
      RowBox[{"0", "|", "0.0"}], ",", "\[Alpha]_"}], "]"}], "=", "0"}], ";"}],
   "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PolarCompletionKernelM", "[", 
     RowBox[{"m_", ",", 
      RowBox[{"\[Sigma]_:", "1"}], ",", 
      RowBox[{"\[Lambda]_:", "0"}], ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{"r_", ",", "\[Alpha]_"}], "]"}], "=", 
   RowBox[{
    FractionBox["1", 
     RowBox[{
      SqrtBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"2", "\[Pi]", " ", "r"}], ")"}], "3"]], " ", "\[Sigma]"}]], 
    " ", 
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], 
      FractionBox["m", "2"], 
      RowBox[{"(", 
       RowBox[{"\[Alpha]", "+", "\[Alpha]0"}], ")"}]}], "]"}], " ", 
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "r"}], " ", "\[Lambda]"}], "-", 
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"\[Alpha]", "-", "\[Alpha]0", "-", 
          RowBox[{"r", " ", "\[Kappa]"}]}], ")"}], "2"], 
       RowBox[{"2", " ", "r", " ", 
        SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}], 
    RowBox[{"Exp", "[", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"r", " ", 
        SuperscriptBox["\[Sigma]", "2"], 
        SuperscriptBox["m", "2"]}], "24"]}], "]"}]}]}], 
  ";"}]}], "PackageInput",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"PolarCompletionKernelM", "[", 
      RowBox[{"m_", ",", 
       RowBox[{"\[Sigma]_:", "1"}], ",", 
       RowBox[{"\[Lambda]_:", "0"}], ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{"0", "|", "0.0"}], "]"}], "=", 
    RowBox[{"DirectedInfinity", "[", "1", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PolarCompletionKernelM", "[", 
     RowBox[{"m_", ",", 
      RowBox[{"\[Sigma]_:", "1"}], ",", 
      RowBox[{"\[Lambda]_:", "0"}], ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", "r_", "]"}], "=", " ", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", " ", "\[Pi]", " ", "r"}]], 
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", 
      FractionBox["m", "2"], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "\[Alpha]0"}], "+", 
        RowBox[{"r", " ", "\[Kappa]"}]}], ")"}]}], "]"}], " ", 
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"-", "r"}], " ", "\[Lambda]"}], "]"}], " ", 
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        SuperscriptBox["m", "2"], "6"]}], " ", "r", " ", 
      SuperscriptBox["\[Sigma]", "2"]}], "]"}]}]}], ";"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Completion Field", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Completion", " ", "Field"}], " ", "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Numeric Implementation", "Subsubsection"],

Cell["Implementing a compiled version of the completion field.", "Text"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Numeric", " ", "Implementation"}], " ", "*)"}]], "PackageInput",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Symbolic Implementation", "Subsubsection"],

Cell["3D", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CompletionField", "[", 
       RowBox[{
        RowBox[{"\[Sigma]_:", "1"}], ",", 
        RowBox[{"\[Lambda]_:", "0"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x0_:", "0"}], ",", 
          RowBox[{"y0_:", "0"}], ",", 
          RowBox[{"\[Alpha]0_:", "0"}], ",", 
          RowBox[{"\[Kappa]0_:", "0"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x1_:", "1"}], ",", 
          RowBox[{"y1_:", "0"}], ",", 
          RowBox[{"\[Alpha]1_:", "0"}], ",", 
          RowBox[{"\[Kappa]1_:", "0"}]}], "}"}]}], "]"}], "[", 
      RowBox[{"x0_", ",", "y0_", ",", "\[Alpha]0_"}], "]"}], " ", "=", " ", 
     TagBox[
      StyleBox[
       RowBox[{"DirectedInfinity", "[", "1", "]"}],
       ShowSpecialCharacters->False,
       ShowStringCharacters->True,
       NumberMarks->True],
      FullForm]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CompletionField", "[", 
       RowBox[{
        RowBox[{"\[Sigma]_:", "1"}], ",", 
        RowBox[{"\[Lambda]_:", "0"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x0_:", "0"}], ",", 
          RowBox[{"y0_:", "0"}], ",", 
          RowBox[{"\[Alpha]0_:", "0"}], ",", 
          RowBox[{"\[Kappa]0_:", "0"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x1_:", "1"}], ",", 
          RowBox[{"y1_:", "0"}], ",", 
          RowBox[{"\[Alpha]1_:", "0"}], ",", 
          RowBox[{"\[Kappa]1_:", "0"}]}], "}"}]}], "]"}], "[", 
      RowBox[{"x0_", ",", "y_", ",", "\[Alpha]_"}], "]"}], " ", "=", " ", 
     "0"}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CompletionField", "[", 
       RowBox[{
        RowBox[{"\[Sigma]_:", "1"}], ",", 
        RowBox[{"\[Lambda]_:", "0"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x0_:", "0"}], ",", 
          RowBox[{"y0_:", "0"}], ",", 
          RowBox[{"\[Alpha]0_:", "0"}], ",", 
          RowBox[{"\[Kappa]0_:", "0"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x1_:", "1"}], ",", 
          RowBox[{"y1_:", "0"}], ",", 
          RowBox[{"\[Alpha]1_:", "0"}], ",", 
          RowBox[{"\[Kappa]1_:", "0"}]}], "}"}]}], "]"}], "[", 
      RowBox[{"x1_", ",", "y1_", ",", "\[Alpha]1_"}], "]"}], " ", "=", " ", 
     TagBox[
      StyleBox[
       RowBox[{"DirectedInfinity", "[", "1", "]"}],
       ShowSpecialCharacters->False,
       ShowStringCharacters->True,
       NumberMarks->True],
      FullForm]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CompletionField", "[", 
       RowBox[{
        RowBox[{"\[Sigma]_:", "1"}], ",", 
        RowBox[{"\[Lambda]_:", "0"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x0_:", "0"}], ",", 
          RowBox[{"y0_:", "0"}], ",", 
          RowBox[{"\[Alpha]0_:", "0"}], ",", 
          RowBox[{"\[Kappa]0_:", "0"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x1_:", "1"}], ",", 
          RowBox[{"y1_:", "0"}], ",", 
          RowBox[{"\[Alpha]1_:", "0"}], ",", 
          RowBox[{"\[Kappa]1_:", "0"}]}], "}"}]}], "]"}], "[", 
      RowBox[{"x1_", ",", "y_", ",", "\[Alpha]_"}], "]"}], " ", "=", " ", 
     TagBox[
      StyleBox["0",
       ShowSpecialCharacters->False,
       ShowStringCharacters->True,
       NumberMarks->True],
      FullForm]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CompletionField", "[", 
       RowBox[{
        RowBox[{"\[Sigma]_:", "1"}], ",", 
        RowBox[{"\[Lambda]_:", "0"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x0_:", "0"}], ",", 
          RowBox[{"y0_:", "0"}], ",", 
          RowBox[{"\[Alpha]0p_:", "0"}], ",", 
          RowBox[{"\[Kappa]0_:", "0"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x1_:", "1"}], ",", 
          RowBox[{"y1_:", "0"}], ",", 
          RowBox[{"\[Alpha]1p_:", "0"}], ",", 
          RowBox[{"\[Kappa]1_:", "0"}]}], "}"}]}], "]"}], "[", 
      RowBox[{"x_", ",", " ", "y_", ",", "\[Alpha]p_"}], "]"}], ":=", " ", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"R", " ", "=", " ", 
          SqrtBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"x1", "-", "x0"}], ")"}], "2"], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"y1", "-", "y0"}], ")"}], "2"]}]]}], ",", 
         RowBox[{"\[Theta]", " ", "=", " ", 
          RowBox[{"ArcTan", "[", 
           RowBox[{
            RowBox[{"x1", "-", "x0"}], ",", 
            RowBox[{"y1", "-", "y0"}]}], "]"}]}], ",", "r", ",", "s", ",", 
         "\[Alpha]", ",", "\[Alpha]0", ",", "\[Alpha]1"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\[Alpha]", "=", 
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"\[Alpha]p", "-", "\[Theta]"}], ",", 
           RowBox[{"2", "\[Pi]"}], ",", 
           RowBox[{"-", "\[Pi]"}]}], "]"}]}], ";", 
        RowBox[{"\[Alpha]0", "=", 
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"\[Alpha]0p", "-", "\[Theta]"}], ",", 
           RowBox[{"2", "\[Pi]"}], ",", 
           RowBox[{"-", "\[Pi]"}]}], "]"}]}], ";", 
        RowBox[{"\[Alpha]1", "=", 
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"\[Alpha]1p", "-", "\[Theta]"}], ",", 
           RowBox[{"2", "\[Pi]"}], ",", 
           RowBox[{"-", "\[Pi]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"r", ",", "s"}], "}"}], " ", "=", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Cos", "[", "\[Theta]", "]"}], ",", 
              RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", 
               RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
              RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "}"}]}], "}"}], ".", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x", "-", "x0"}], ",", 
            RowBox[{"y", "-", "y0"}]}], "}"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         FractionBox[
          RowBox[{"3", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             RowBox[{"-", "R"}], " ", "\[Lambda]"}]], " "}], 
          RowBox[{
           SuperscriptBox["\[Pi]", "2"], " ", 
           SuperscriptBox["r", "2"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"R", "-", "r"}], ")"}], "2"], 
           SuperscriptBox["\[Sigma]", "4"]}]], 
         RowBox[{"Exp", "[", 
          RowBox[{
           RowBox[{"-", 
            FractionBox["1", 
             RowBox[{"2", 
              SuperscriptBox["\[Sigma]", "2"]}]]}], 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"3", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"r", " ", 
                   RowBox[{"(", 
                    RowBox[{"\[Alpha]", "+", "\[Alpha]0"}], ")"}]}], "-", 
                  RowBox[{"2", "s"}]}], ")"}], "2"]}], 
              SuperscriptBox["r", "3"]], "+", " ", 
             FractionBox[
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"\[Alpha]", "-", "\[Alpha]0", "-", 
                 RowBox[{"r", " ", "\[Kappa]0"}]}], ")"}], "2"], "r"], "+", 
             FractionBox[
              RowBox[{"3", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"R", "-", "r"}], ")"}], " ", 
                   RowBox[{"(", 
                    RowBox[{"\[Alpha]", "+", "\[Alpha]1"}], ")"}]}], "+", 
                  RowBox[{"2", "s"}]}], ")"}], "2"]}], 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"R", "-", "r"}], ")"}], "3"]], "+", 
             FractionBox[
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"\[Alpha]1", "-", "\[Alpha]", "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"R", "-", "r"}], ")"}], " ", "\[Kappa]1"}]}], 
                ")"}], "2"], 
              RowBox[{"R", "-", "r"}]]}], ")"}]}], "]"}], 
         "\[IndentingNewLine]", 
         RowBox[{"UnitStep", "[", "r", "]"}], " ", 
         RowBox[{"UnitStep", "[", 
          RowBox[{"R", "-", "r"}], "]"}]}]}]}], " ", "\[IndentingNewLine]", 
      "]"}]}], ";"}]}]}]], "PackageInput",
 InitializationCell->True],

Cell["2D", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CompletionField", "[", 
      RowBox[{
       RowBox[{"\[Sigma]_:", "1"}], ",", 
       RowBox[{"\[Lambda]_:", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"x0_:", "0"}], ",", 
         RowBox[{"y0_:", "0"}], ",", 
         RowBox[{"\[Alpha]0_:", "0"}], ",", 
         RowBox[{"\[Kappa]0_:", "0"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"x1_:", "1"}], ",", 
         RowBox[{"y1_:", "0"}], ",", 
         RowBox[{"\[Alpha]1_:", "0"}], ",", 
         RowBox[{"\[Kappa]1_:", "0"}]}], "}"}]}], "]"}], "[", 
     RowBox[{"x0_", ",", "y0_"}], "]"}], " ", "=", " ", 
    TagBox[
     StyleBox[
      RowBox[{"DirectedInfinity", "[", "1", "]"}],
      ShowSpecialCharacters->False,
      ShowStringCharacters->True,
      NumberMarks->True],
     FullForm]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CompletionField", "[", 
      RowBox[{
       RowBox[{"\[Sigma]_:", "1"}], ",", 
       RowBox[{"\[Lambda]_:", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"x0_:", "0"}], ",", 
         RowBox[{"y0_:", "0"}], ",", 
         RowBox[{"\[Alpha]0_:", "0"}], ",", 
         RowBox[{"\[Kappa]0_:", "0"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"x1_:", "1"}], ",", 
         RowBox[{"y1_:", "0"}], ",", 
         RowBox[{"\[Alpha]1_:", "0"}], ",", 
         RowBox[{"\[Kappa]1_:", "0"}]}], "}"}]}], "]"}], "[", 
     RowBox[{"x0_", ",", "y_"}], "]"}], " ", "=", " ", 
    TagBox[
     StyleBox["0",
      ShowSpecialCharacters->False,
      ShowStringCharacters->True,
      NumberMarks->True],
     FullForm]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CompletionField", "[", 
      RowBox[{
       RowBox[{"\[Sigma]_:", "1"}], ",", 
       RowBox[{"\[Lambda]_:", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"x0_:", "0"}], ",", 
         RowBox[{"y0_:", "0"}], ",", 
         RowBox[{"\[Alpha]0_:", "0"}], ",", 
         RowBox[{"\[Kappa]0_:", "0"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"x1_:", "1"}], ",", 
         RowBox[{"y1_:", "0"}], ",", 
         RowBox[{"\[Alpha]1_:", "0"}], ",", 
         RowBox[{"\[Kappa]1_:", "0"}]}], "}"}]}], "]"}], "[", 
     RowBox[{"x1_", ",", "y1_"}], "]"}], " ", "=", " ", 
    TagBox[
     StyleBox[
      RowBox[{"DirectedInfinity", "[", "1", "]"}],
      ShowSpecialCharacters->False,
      ShowStringCharacters->True,
      NumberMarks->True],
     FullForm]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CompletionField", "[", 
      RowBox[{
       RowBox[{"\[Sigma]_:", "1"}], ",", 
       RowBox[{"\[Lambda]_:", "0"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"x0_:", "0"}], ",", 
         RowBox[{"y0_:", "0"}], ",", 
         RowBox[{"\[Alpha]0_:", "0"}], ",", 
         RowBox[{"\[Kappa]0_:", "0"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"x1_:", "1"}], ",", 
         RowBox[{"y1_:", "0"}], ",", 
         RowBox[{"\[Alpha]1_:", "0"}], ",", 
         RowBox[{"\[Kappa]1_:", "0"}]}], "}"}]}], "]"}], "[", 
     RowBox[{"x1_", ",", "y_"}], "]"}], " ", "=", " ", 
    TagBox[
     StyleBox["0",
      ShowSpecialCharacters->False,
      ShowStringCharacters->True,
      NumberMarks->True],
     FullForm]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CompletionField", "[", 
    RowBox[{
     RowBox[{"\[Sigma]_:", "1"}], ",", 
     RowBox[{"\[Lambda]_:", "0"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x0_:", "0"}], ",", 
       RowBox[{"y0_:", "0"}], ",", 
       RowBox[{"\[Alpha]0p_:", "0"}], ",", 
       RowBox[{"\[Kappa]0_:", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x1_:", "1"}], ",", 
       RowBox[{"y1_:", "0"}], ",", 
       RowBox[{"\[Alpha]1p_:", "0"}], ",", 
       RowBox[{"\[Kappa]1_:", "0"}]}], "}"}]}], "]"}], "[", 
   RowBox[{"x_", ",", " ", "y_"}], "]"}], "=", " ", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"R", " ", "=", " ", 
       RowBox[{"\[Sqrt]", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"x1", "-", "x0"}], ")"}], "2"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"y1", "-", "y0"}], ")"}], "2"]}], ")"}]}]}], ",", 
      RowBox[{"\[Theta]", " ", "=", " ", 
       RowBox[{"ArcTan", "[", 
        RowBox[{
         RowBox[{"x1", "-", "x0"}], ",", 
         RowBox[{"y1", "-", "y0"}]}], "]"}]}], ",", "r", ",", "s", ",", 
      "\[Alpha]", ",", "\[Alpha]0", ",", "\[Alpha]1"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Alpha]0", "=", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"\[Alpha]0p", "-", "\[Theta]"}], ",", 
        RowBox[{"2", "\[Pi]"}], ",", 
        RowBox[{"-", "\[Pi]"}]}], "]"}]}], ";", 
     RowBox[{"\[Alpha]1", "=", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"\[Alpha]1p", "-", "\[Theta]"}], ",", 
        RowBox[{"2", "\[Pi]"}], ",", 
        RowBox[{"-", "\[Pi]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"r", ",", "s"}], "}"}], " ", "=", " ", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Cos", "[", "\[Theta]", "]"}], ",", 
           RowBox[{"Sin", "[", "\[Theta]", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
           RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "}"}]}], "}"}], ".", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"x", "-", "x0"}], ",", 
         RowBox[{"y", "-", "y0"}]}], "}"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      FractionBox[
       RowBox[{"3", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "R"}], " ", "\[Lambda]"}]]}], 
       RowBox[{
        SqrtBox[
         RowBox[{"2", " ", 
          SuperscriptBox["\[Pi]", "3"], "R", "  ", 
          SuperscriptBox["r", "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"R", "-", "r"}], ")"}], "3"]}]], " ", 
        SuperscriptBox["\[Sigma]", "3"]}]], "*", " ", "\[IndentingNewLine]", 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", 
          SuperscriptBox["\[Sigma]", "2"]]}], 
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"6", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"s", "-", 
               RowBox[{"\[Alpha]0", " ", 
                RowBox[{"r", "/", "2"}]}]}], ")"}], "2"]}], 
           SuperscriptBox["r", "3"]], "+", " ", 
          FractionBox[
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[Alpha]0", "+", 
              RowBox[{"r", " ", "\[Kappa]0"}]}], ")"}], "2"], 
           RowBox[{"2", " ", "r"}]]}], ")"}]}], "]"}], "*", 
      "\[IndentingNewLine]", " ", 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", 
          SuperscriptBox["\[Sigma]", "2"]]}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"6", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"s", "+", 
                RowBox[{"\[Alpha]1", " ", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"R", "-", "r"}], ")"}], "/", "2"}]}]}], ")"}], 
              "2"]}], ")"}], "/", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"R", "-", "r"}], ")"}], "3"]}], "+", 
          FractionBox[
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[Alpha]1", "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"r", "-", "R"}], ")"}], " ", "\[Kappa]1"}]}], ")"}], 
            "2"], 
           RowBox[{"2", " ", 
            RowBox[{"(", 
             RowBox[{"R", "-", "r"}], ")"}]}]]}], ")"}]}], "]"}], "*", 
      "\[IndentingNewLine]", 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"r", " ", 
           RowBox[{"(", 
            RowBox[{"r", "-", "R"}], ")"}]}], 
          RowBox[{"8", " ", 
           SuperscriptBox["\[Sigma]", "2"], "R"}]]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{
             RowBox[{"6", " ", "s"}], "-", 
             RowBox[{"2", " ", "r", " ", "\[Alpha]0"}]}], 
            SuperscriptBox["r", "2"]], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "6"}], "s"}], "-", 
              RowBox[{"2", " ", 
               RowBox[{"(", 
                RowBox[{"R", "-", "r"}], ")"}], " ", "\[Alpha]1"}]}], ")"}], 
            "/", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"R", "-", "r"}], ")"}], "2"]}], "+", "\[Kappa]0", "-", 
           "\[Kappa]1"}], ")"}], "2"]}], "]"}], 
      RowBox[{"UnitStep", "[", "r", "]"}], " ", 
      RowBox[{"UnitStep", "[", 
       RowBox[{"R", "-", "r"}], "]"}]}]}]}], "\[IndentingNewLine]", 
   "]"}]}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Completion Mode and Spline", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Completion", " ", "Mode", " ", "and", " ", "Spline"}], " ", 
  "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Numeric Implementation", "Subsubsection"],

Cell["Implementing a compiled version of the completion spline.", "Text"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Numeric", " ", "Implementation"}], " ", "*)"}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Symbolic Implementation", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"CompletionModeAlongX", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"x0_:", "0"}], ",", 
        RowBox[{"y0_:", "0"}], ",", 
        RowBox[{"\[Alpha]0_:", "0"}], ",", 
        RowBox[{"\[Kappa]0_:", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"x1_:", "1"}], ",", 
        RowBox[{"y1_:", "0"}], ",", 
        RowBox[{"\[Alpha]1_:", "0"}], ",", 
        RowBox[{"\[Kappa]1_:", "0"}]}], "}"}]}], "]"}], "[", "t_", "]"}], ":=",
    " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x0", "+", 
      RowBox[{"t", " ", 
       RowBox[{"(", 
        RowBox[{"x1", "-", "x0"}], ")"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", "t"}], ")"}], " ", "y0"}], "+", 
      RowBox[{"t", " ", "y1"}], "+", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "-", "t"}], ")"}], "2"], " ", "t", " ", 
       RowBox[{"(", 
        RowBox[{"y0", "-", "y1", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"x1", "-", "x0"}], ")"}], " ", "\[Alpha]0"}]}], ")"}]}], 
      "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "-", "t"}], ")"}], " ", 
       SuperscriptBox["t", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"y1", "-", "y0", "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"x0", "-", "x1"}], ")"}], " ", "\[Alpha]1"}]}], ")"}]}], 
      "-", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "-", "t"}], ")"}], "2"], " ", 
       SuperscriptBox["t", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"t", "-", "1", "+", " ", "t"}], ")"}], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"x0", "-", "x1"}], ")"}], "2"], " ", 
       RowBox[{"(", 
        RowBox[{"\[Kappa]0", "-", "\[Kappa]1"}], ")"}]}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"\[Alpha]1", " ", "t"}], " ", "+", " ", 
      RowBox[{"\[Alpha]0", 
       RowBox[{"(", 
        RowBox[{"1", "-", "t"}], ")"}]}], " ", "+", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"6", 
          FractionBox[
           RowBox[{"y0", "-", "y1"}], 
           RowBox[{"x0", "-", "x1"}]]}], "-", " ", 
         RowBox[{"3", " ", 
          RowBox[{"(", 
           RowBox[{"\[Alpha]0", "+", "\[Alpha]1"}], ")"}]}]}], ")"}], " ", 
       "t", " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", "t"}], ")"}]}], "+", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x0", "-", "x1"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"\[Kappa]0", "-", "\[Kappa]1"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", " ", "t", " ", 
          RowBox[{"(", 
           RowBox[{"1", "-", "t"}], ")"}]}], "-", "1"}], ")"}], "t", " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", "t"}], ")"}]}]}]}], "}"}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"CompletionMode", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"x0_:", "0"}], ",", 
        RowBox[{"y0_:", "0"}], ",", 
        RowBox[{"\[Alpha]0_:", "0"}], ",", 
        RowBox[{"\[Kappa]0_:", "0"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"x1_:", "1"}], ",", 
        RowBox[{"y1_:", "0"}], ",", 
        RowBox[{"\[Alpha]1_:", "0"}], ",", 
        RowBox[{"\[Kappa]1_:", "0"}]}], "}"}]}], "]"}], "[", "t_", "]"}], ":=",
    " ", 
   RowBox[{"With", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"R", " ", "=", " ", 
        SqrtBox[
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"x1", "-", "x0"}], ")"}], "2"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"y1", "-", "y0"}], ")"}], "2"]}]]}], ",", 
       RowBox[{"\[Theta]", " ", "=", " ", 
        RowBox[{"ArcTan", "[", 
         RowBox[{
          RowBox[{"x1", "-", "x0"}], ",", 
          RowBox[{"y1", "-", "y0"}]}], "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x0", "+", 
        RowBox[{"R", " ", "t", " ", 
         RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "-", 
        RowBox[{"R", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"1", "-", "t"}], ")"}], "2"], " ", "t", " ", 
            RowBox[{"Mod", "[", 
             RowBox[{
              RowBox[{"\[Alpha]0", "-", "\[Theta]"}], ",", 
              RowBox[{"2", "\[Pi]"}], ",", 
              RowBox[{"-", "\[Pi]"}]}], "]"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "-", "t"}], ")"}], " ", 
            SuperscriptBox["t", "2"], " ", 
            RowBox[{"Mod", "[", 
             RowBox[{
              RowBox[{"\[Alpha]1", "-", "\[Theta]"}], ",", 
              RowBox[{"2", "\[Pi]"}], ",", 
              RowBox[{"-", "\[Pi]"}]}], "]"}]}], "-", 
           RowBox[{
            FractionBox["1", "2"], " ", "R", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"1", "-", "t"}], ")"}], "2"], " ", 
            SuperscriptBox["t", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", "t"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{"\[Kappa]0", "-", "\[Kappa]1"}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ",", 
       RowBox[{"y0", "+", 
        RowBox[{"R", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"1", "-", "t"}], ")"}], "2"], " ", "t", " ", 
            RowBox[{"Mod", "[", 
             RowBox[{
              RowBox[{"\[Alpha]0", "-", "\[Theta]"}], ",", 
              RowBox[{"2", "\[Pi]"}], ",", 
              RowBox[{"-", "\[Pi]"}]}], "]"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "-", "t"}], ")"}], " ", 
            SuperscriptBox["t", "2"], " ", 
            RowBox[{"Mod", "[", 
             RowBox[{
              RowBox[{"\[Alpha]1", "-", "\[Theta]"}], ",", 
              RowBox[{"2", "\[Pi]"}], ",", 
              RowBox[{"-", "\[Pi]"}]}], "]"}]}], "-", 
           RowBox[{
            FractionBox["1", "2"], " ", "R", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"1", "-", "t"}], ")"}], "2"], " ", 
            SuperscriptBox["t", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", "t"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{"\[Kappa]0", "-", "\[Kappa]1"}], ")"}]}]}], ")"}], " ", 
         RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
        RowBox[{"R", " ", "t", " ", 
         RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"\[Alpha]1", "-", "\[Theta]"}], ",", 
           RowBox[{"2", "\[Pi]"}], ",", 
           RowBox[{"-", "\[Pi]"}]}], "]"}], " ", "t"}], " ", "+", " ", 
        RowBox[{
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"\[Alpha]0", "-", "\[Theta]"}], ",", 
           RowBox[{"2", "\[Pi]"}], ",", 
           RowBox[{"-", "\[Pi]"}]}], "]"}], 
         RowBox[{"(", 
          RowBox[{"1", "-", "t"}], ")"}]}], "-", " ", 
        RowBox[{"3", " ", 
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"\[Alpha]0", "+", "\[Alpha]1", "-", 
            RowBox[{"2", "\[Theta]"}]}], ",", 
           RowBox[{"2", "\[Pi]"}], ",", 
           RowBox[{"-", "\[Pi]"}]}], "]"}], " ", "t", " ", 
         RowBox[{"(", 
          RowBox[{"1", "-", "t"}], ")"}]}], "+", "\[Theta]", "+", 
        RowBox[{"R", " ", 
         RowBox[{"(", 
          RowBox[{"\[Kappa]0", "-", "\[Kappa]1"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"3", " ", "t", " ", 
            RowBox[{"(", 
             RowBox[{"1", "-", "t"}], ")"}]}], "-", "1"}], ")"}], "t", " ", 
         RowBox[{"(", 
          RowBox[{"1", "-", "t"}], ")"}]}]}]}], "}"}]}], 
    "\[IndentingNewLine]", "]"}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"CompletionSpline", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x0_:", "0"}], ",", 
       RowBox[{"y0_:", "0"}], ",", 
       RowBox[{"\[Alpha]0_:", "0"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x1_:", "1"}], ",", 
       RowBox[{"y1_:", "0"}], ",", 
       RowBox[{"\[Alpha]1_:", "0"}]}], "}"}]}], "]"}], ":=", " ", 
   RowBox[{"With", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"R", " ", "=", " ", 
        SqrtBox[
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"x1", "-", "x0"}], ")"}], "2"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"y1", "-", "y0"}], ")"}], "2"]}]]}], ",", 
       RowBox[{"\[Theta]", " ", "=", " ", 
        RowBox[{"ArcTan", "[", 
         RowBox[{
          RowBox[{"x1", "-", "x0"}], ",", 
          RowBox[{"y1", "-", "y0"}]}], "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Spline", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x0", ",", "y0"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x0", "+", 
            RowBox[{
             FractionBox["1", "3"], " ", "R", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Cos", "[", "\[Theta]", "]"}], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"Mod", "[", 
                  RowBox[{
                   RowBox[{"\[Theta]", "-", "\[Alpha]0"}], ",", 
                   RowBox[{"2", " ", "\[Pi]"}], ",", 
                   RowBox[{"-", "\[Pi]"}]}], "]"}], ")"}], " ", 
                RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ")"}]}]}], ",", 
           RowBox[{"y0", "+", 
            RowBox[{
             FractionBox["1", "3"], " ", "R", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                RowBox[{"Mod", "[", 
                 RowBox[{
                  RowBox[{"\[Alpha]0", "-", "\[Theta]"}], ",", 
                  RowBox[{"2", " ", "\[Pi]"}], ",", 
                  RowBox[{"-", "\[Pi]"}]}], "]"}]}], "+", 
               RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ")"}]}]}]}], "}"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x0", "+", 
            RowBox[{
             FractionBox["1", "3"], " ", "R", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"Mod", "[", 
                  RowBox[{
                   RowBox[{"\[Alpha]1", "-", "\[Theta]"}], ",", 
                   RowBox[{"2", " ", "\[Pi]"}], ",", 
                   RowBox[{"-", "\[Pi]"}]}], "]"}], ")"}], " ", 
                RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ")"}]}]}], ",", 
           RowBox[{"y0", "+", 
            RowBox[{
             FractionBox["1", "3"], " ", "R", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"Cos", "[", "\[Theta]", "]"}], " ", 
                RowBox[{"Mod", "[", 
                 RowBox[{
                  RowBox[{"\[Theta]", "-", "\[Alpha]1"}], ",", 
                  RowBox[{"2", " ", "\[Pi]"}], ",", 
                  RowBox[{"-", "\[Pi]"}]}], "]"}]}], "+", 
               RowBox[{"2", " ", 
                RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}], ")"}]}]}]}], "}"}],
          ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x0", "+", 
            RowBox[{"R", " ", 
             RowBox[{"Cos", "[", "\[Theta]", "]"}]}]}], ",", 
           RowBox[{"y0", "+", 
            RowBox[{"R", " ", 
             RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}]}], "}"}]}], "}"}], ",",
        "\[IndentingNewLine]", "Bezier"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Tensor Voting Kernel", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Tensor", " ", "Voting", " ", "Kernel"}], " ", 
  "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Numeric Implementation", "Subsubsection"],

Cell["Implementing a compiled version of the tensor voting field.", "Text"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Numeric", " ", "Implementation"}], " ", "*)"}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Symbolic Implementation", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"TensorVotingKernel", "[", 
      RowBox[{
       RowBox[{"\[Sigma]_:", "1"}], ",", 
       RowBox[{"\[Lambda]_:", "0"}], ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{"r_", ",", " ", "\[Theta]_"}], "]"}], "=", " ", 
    RowBox[{
     SqrtBox[
      FractionBox["3", 
       RowBox[{"2", " ", "\[Pi]", " ", 
        SuperscriptBox["r", "3"], " ", 
        SuperscriptBox["\[Sigma]", "2"]}]]], " ", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", "\[Lambda]"}], " ", "r"}], "]"}], " ", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", 
              RowBox[{"Mod", "[", 
               RowBox[{
                RowBox[{"\[Alpha]0", "-", "\[Theta]"}], ",", 
                RowBox[{"2", "\[Pi]"}], ",", 
                RowBox[{"-", "\[Pi]"}]}], "]"}]}], "+", 
             RowBox[{"r", " ", "\[Kappa]"}]}], ")"}], "2"]}], 
         RowBox[{"8", " ", "r", " ", 
          SuperscriptBox["\[Sigma]", "2"]}]]}], "-", 
       FractionBox[
        RowBox[{"r", " ", 
         SuperscriptBox["\[Sigma]", "2"]}], "2"]}], "]"}], " ", 
     RowBox[{"Exp", "[", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"\[Theta]", "-", "\[Alpha]0"}], ",", 
           RowBox[{"2", "\[Pi]"}], ",", 
           RowBox[{"-", "\[Pi]"}]}], "]"}], "+", 
         RowBox[{"2", " ", "\[Theta]"}], "+", 
         FractionBox[
          RowBox[{"r", " ", "\[Kappa]"}], "2"]}], ")"}]}], "]"}]}]}], 
   ";"}]}]], "PackageInput",
 InitializationCell->True],

Cell["m-modes of the polar completion kernel for steerability:", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TensorVotingKernelM", "[", 
     RowBox[{"0", ",", 
      RowBox[{"\[Sigma]_:", "1"}], ",", 
      RowBox[{"\[Lambda]_:", "0"}], ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", "r_", "]"}], "=", 
   RowBox[{"DiracDelta", "[", "r", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TensorVotingKernelM", "[", 
     RowBox[{"m_", ",", 
      RowBox[{"\[Sigma]_:", "1"}], ",", 
      RowBox[{"\[Lambda]_:", "0"}], ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{"0", "|", "0.0"}], "]"}], "=", "0"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TensorVotingKernelM", "[", 
     RowBox[{"m_", ",", 
      RowBox[{"\[Sigma]_:", "1"}], ",", 
      RowBox[{"\[Lambda]_:", "0"}], ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", "r_", "]"}], "=", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", " ", "\[Pi]", " ", "r"}]], 
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"-", "r"}], 
      RowBox[{"(", 
       RowBox[{"\[Lambda]", " ", "+", " ", 
        RowBox[{
         SuperscriptBox["\[Sigma]", "2"], "/", "2"}]}], ")"}]}], "]"}], 
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"r", " ", 
         SuperscriptBox["\[Sigma]", "2"]}], "6"]}], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"3", "+", "m"}], ")"}], "2"]}], "]"}], 
    RowBox[{"Exp", "[", 
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"m", "+", "2"}], ")"}], " ", "\[Alpha]0"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"m", "/", "2"}], "+", "2"}], ")"}], " ", "r", " ", 
         "\[Kappa]"}]}], ")"}]}], "]"}]}]}], ";"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Medioni Tensor Voting Kernel", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Medioni", " ", "Tensor", " ", "Voting", " ", "Kernel"}], " ", 
  "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Symbolic Implementation", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"MedioniTensorVotingKernel", "[", 
       RowBox[{
        RowBox[{"m_:", "1"}], ",", "\[Sigma]_", ",", "c_"}], "]"}], "[", 
      RowBox[{
       RowBox[{"0", "|", "0.0"}], ",", "\[Theta]_"}], "]"}], " ", "=", " ", 
     RowBox[{"DiracDelta", "[", "\[Theta]", "]"}]}], ";", 
    RowBox[{
     RowBox[{
      RowBox[{"MedioniTensorVotingKernel", "[", 
       RowBox[{"\[Sigma]_", ",", "c_"}], "]"}], "[", 
      RowBox[{"r_", ",", "\[Theta]_"}], "]"}], " ", "=", " ", 
     RowBox[{
      FractionBox[
       SqrtBox["c"], 
       RowBox[{
        SqrtBox["\[Pi]"], " ", "r", " ", "\[Sigma]"}]], 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", 
          SuperscriptBox["\[Sigma]", "2"]]}], 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["r", "2"], "+", " ", 
          RowBox[{"c", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["\[Theta]", "r"], ")"}], "2"]}]}], ")"}]}], "]"}], 
      " ", 
      RowBox[{"Exp", "[", 
       RowBox[{"2", "\[ImaginaryI]", " ", "\[Theta]"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"MedioniTensorVotingKernel", "[", 
       RowBox[{"1", ",", "\[Sigma]_", ",", "c_"}], "]"}], "[", 
      RowBox[{"r_", ",", "\[Theta]_"}], "]"}], " ", "=", " ", 
     RowBox[{
      FractionBox[
       SqrtBox["c"], 
       RowBox[{
        SqrtBox["\[Pi]"], " ", "r", " ", "\[Sigma]"}]], 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", 
          SuperscriptBox["\[Sigma]", "2"]]}], 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["r", "2"], "+", " ", 
          RowBox[{"c", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["\[Theta]", "r"], ")"}], "2"]}]}], ")"}]}], "]"}], 
      " ", 
      RowBox[{"Exp", "[", 
       RowBox[{"2", "\[ImaginaryI]", " ", "\[Theta]"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"MedioniTensorVotingKernel", "[", 
       RowBox[{"2", ",", "\[Sigma]_", ",", "c_"}], "]"}], "[", 
      RowBox[{"r_", ",", "\[Theta]_"}], "]"}], " ", "=", " ", 
     RowBox[{
      FractionBox[
       RowBox[{" ", 
        SuperscriptBox["r", "2"]}], 
       RowBox[{"2", " ", 
        SqrtBox[
         RowBox[{"3", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"12", " ", "c"}], "+", 
            SuperscriptBox["r", "4"]}], ")"}]}]], " ", 
        RowBox[{"BesselK", "[", 
         RowBox[{
          FractionBox["1", "4"], ",", 
          FractionBox[
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"12", " ", "c"}], "+", 
              SuperscriptBox["r", "4"]}], ")"}], "2"], 
           RowBox[{"2", " ", 
            SuperscriptBox["r", "6"], " ", 
            SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}]], 
      RowBox[{"Exp", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"288", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"12", " ", "c"}], "+", 
              SuperscriptBox["r", "4"]}], ")"}], "2"]}], "+", 
          RowBox[{"48", " ", 
           SuperscriptBox["r", "8"], " ", 
           SuperscriptBox["\[Theta]", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["r", "8"], " ", 
           SuperscriptBox["\[Theta]", "4"]}]}], 
         RowBox[{"576", " ", 
          SuperscriptBox["r", "6"], " ", 
          SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}], 
      RowBox[{"Exp", "[", 
       RowBox[{"2", "\[ImaginaryI]", " ", "\[Theta]"}], "]"}], " ", 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", 
          SuperscriptBox["\[Sigma]", "2"]]}], 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"r", "+", 
             FractionBox[
              RowBox[{"r", " ", 
               SuperscriptBox["\[Theta]", "2"]}], "24"]}], ")"}], "2"], "+", 
          " ", 
          RowBox[{"c", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["\[Theta]", "r"], ")"}], "2"]}]}], ")"}]}], 
       "]"}]}]}], ";"}]}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "CompletionKernelAlongX", ",", "\[IndentingNewLine]", 
       "NCompletionKernelAlongX", ",", "\[IndentingNewLine]", 
       "NCompletionKernelxyMarginalAlongX", ",", "\[IndentingNewLine]", 
       "CompletionKernel", ",", "\[IndentingNewLine]", "NCompletionKernel", 
       ",", "\[IndentingNewLine]", "NCompletionKernelxyMarginal", ",", 
       "\[IndentingNewLine]", "PolarCompletionKernel", ",", 
       "\[IndentingNewLine]", "NPolarCompletionKernel", ",", 
       "\[IndentingNewLine]", "NPolarCompletionKernelr\[Theta]Marginal", ",", 
       "\[IndentingNewLine]", "PolarCompletionKernelM", ",", 
       "\[IndentingNewLine]", "NPolarCompletionKernelM", ",", 
       "\[IndentingNewLine]", "NPolarCompletionKernelMr\[Theta]Marginal", ",",
        "\[IndentingNewLine]", "CompletionField", ",", "\[IndentingNewLine]", 
       "CompletionMode", ",", "\[IndentingNewLine]", "CompletionModeAlongX", 
       ",", "\[IndentingNewLine]", "CompletionSpline", ",", 
       "\[IndentingNewLine]", "TensorVotingKernel", ",", 
       "\[IndentingNewLine]", "TensorVotingKernelM", ",", 
       "\[IndentingNewLine]", "MedioniTensorVotingKernel"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Protected", ",", " ", "ReadProtected"}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1026, 967},
WindowMargins->{{Automatic, 79}, {-75, Automatic}},
ShowSelection->True,
Magnification->1,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 7, \
2010)",
StyleDefinitions->"PackageNotebook.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 41, 0, 96, "Title"],
Cell[611, 24, 100, 4, 79, "Subsubtitle"],
Cell[CellGroupData[{
Cell[736, 32, 91, 1, 48, "Section"],
Cell[830, 35, 957, 25, 161, "PackageInput"],
Cell[1790, 62, 128, 3, 26, "Text"],
Cell[1921, 67, 3947, 102, 521, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[5905, 174, 32, 0, 48, "Section"],
Cell[5940, 176, 92, 2, 26, "Text"],
Cell[6035, 180, 1535, 26, 401, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[7607, 211, 42, 0, 48, "Section"],
Cell[7652, 213, 4930, 105, 701, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[12619, 323, 31, 0, 28, "Section"],
Cell[12653, 325, 60, 0, 32, "Text"],
Cell[12716, 327, 108, 2, 43, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[12849, 333, 47, 0, 46, "Subsection"],
Cell[12899, 335, 159, 4, 43, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[13083, 343, 47, 0, 42, "Subsubsection"],
Cell[13133, 345, 73, 0, 32, "Text"],
Cell[13209, 347, 4482, 117, 240, "PackageInput",
 InitializationCell->True],
Cell[17694, 466, 3193, 86, 206, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[20924, 557, 48, 0, 28, "Subsubsection"],
Cell[20975, 559, 3826, 103, 169, "PackageInput",
 InitializationCell->True],
Cell[24804, 664, 2890, 83, 134, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[27743, 753, 39, 0, 30, "Subsection"],
Cell[27785, 755, 108, 3, 32, "Text"],
Cell[27896, 760, 132, 3, 43, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[28053, 767, 47, 0, 42, "Subsubsection"],
Cell[28103, 769, 73, 0, 32, "Text"],
Cell[28179, 771, 5274, 137, 295, "PackageInput",
 InitializationCell->True],
Cell[33456, 910, 3658, 100, 245, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[37151, 1015, 48, 0, 28, "Subsubsection"],
Cell[37202, 1017, 4709, 126, 225, "PackageInput",
 InitializationCell->True],
Cell[41914, 1145, 3668, 104, 190, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[45631, 1255, 45, 0, 30, "Subsection"],
Cell[45679, 1257, 149, 4, 43, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[45853, 1265, 47, 0, 42, "Subsubsection"],
Cell[45903, 1267, 73, 0, 32, "Text"],
Cell[45979, 1269, 4252, 107, 325, "PackageInput",
 InitializationCell->True],
Cell[50234, 1378, 2919, 78, 206, "PackageInput",
 InitializationCell->True],
Cell[53156, 1458, 3868, 103, 270, "PackageInput",
 InitializationCell->True],
Cell[57027, 1563, 3132, 82, 247, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[60196, 1650, 48, 0, 28, "Subsubsection"],
Cell[60247, 1652, 51, 0, 32, "Text"],
Cell[60301, 1654, 2482, 71, 180, "PackageInput",
 InitializationCell->True],
Cell[62786, 1727, 46, 0, 32, "Text"],
Cell[62835, 1729, 2015, 62, 133, "PackageInput",
 InitializationCell->True],
Cell[64853, 1793, 72, 0, 32, "Text"],
Cell[64928, 1795, 2276, 70, 149, "PackageInput",
 InitializationCell->True],
Cell[67207, 1867, 1444, 43, 95, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[68700, 1916, 38, 0, 30, "Subsection"],
Cell[68741, 1918, 131, 3, 43, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[68897, 1925, 47, 0, 42, "Subsubsection"],
Cell[68947, 1927, 72, 0, 32, "Text"],
Cell[69022, 1929, 137, 3, 43, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[69196, 1937, 48, 0, 42, "Subsubsection"],
Cell[69247, 1939, 18, 0, 32, "Text"],
Cell[69268, 1941, 9181, 250, 389, "PackageInput",
 InitializationCell->True],
Cell[78452, 2193, 18, 0, 32, "Text"],
Cell[78473, 2195, 9675, 287, 452, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[88197, 2488, 48, 0, 30, "Subsection"],
Cell[88248, 2490, 160, 4, 42, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[88433, 2498, 47, 0, 41, "Subsubsection"],
Cell[88483, 2500, 73, 0, 31, "Text"],
Cell[88559, 2502, 137, 3, 42, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[88733, 2510, 48, 0, 26, "Subsubsection"],
Cell[88784, 2512, 3171, 97, 176, "PackageInput",
 InitializationCell->True],
Cell[91958, 2611, 5570, 152, 289, "PackageInput",
 InitializationCell->True],
Cell[97531, 2765, 4361, 115, 316, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[101941, 2886, 42, 0, 30, "Subsection"],
Cell[101986, 2888, 146, 4, 43, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[102157, 2896, 47, 0, 42, "Subsubsection"],
Cell[102207, 2898, 75, 0, 31, "Text"],
Cell[102285, 2900, 137, 3, 42, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[102459, 2908, 48, 0, 28, "Subsubsection"],
Cell[102510, 2910, 1972, 57, 149, "PackageInput",
 InitializationCell->True],
Cell[104485, 2969, 72, 0, 31, "Text"],
Cell[104560, 2971, 2020, 62, 109, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[106629, 3039, 50, 0, 30, "Subsection"],
Cell[106682, 3041, 162, 4, 42, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[106869, 3049, 48, 0, 41, "Subsubsection"],
Cell[106920, 3051, 4554, 137, 289, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[111535, 3195, 34, 0, 28, "Section"],
Cell[111572, 3197, 64, 0, 31, "Text"],
Cell[111639, 3199, 1655, 31, 425, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
