(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     30988,        857]
NotebookOptionsPosition[     28983,        787]
NotebookOutlinePosition[     29421,        806]
CellTagsIndexPosition[     29378,        803]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["FDF Package", "Title"],

Cell["\<\
Markus van Almsick
Technische Universiteit Eindhoven
\[Copyright]2010\
\>", "Subsubtitle",
 CellChangeTimes->{{3.4740977798294153`*^9, 3.474097780228993*^9}, {
  3.4888721819726133`*^9, 3.4888721822565613`*^9}}],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
     "TimeStamp", "[", "\"\<MathVisionTools`Converters`FDF`\>\"", "]"}], " ", 
     "=", " ", 
     RowBox[{"{", 
      RowBox[{"2010", ",", "2", ",", "2", ",", "12", ",", "0", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput",
 CellChangeTimes->{{3.4740977715417137`*^9, 3.4740977752051163`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`Converters`FDF`"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Author", ":", " ", 
     RowBox[{"Markus", " ", "van", " ", "Almsick"}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"M", ".", "v", ".", 
       RowBox[{"Almsick", "@", "tue"}], ".", "nl"}]}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`Converters`FDF`"}]}], 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "1.1"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2010"}]}]}], ",", " ", 
    RowBox[{"Technische", " ", "Universiteit", " ", "Eindhoven"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "FDF"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "implements", " ", "the", " ", "import", 
      " ", "of", " ", "FDF", " ", "headers", " ", "and", " ", "the", " ", 
      "retrieval", " ", "of", " ", "2", "Dfov", " ", "and", " ", "3", "Dfov", 
      " ", "data", " ", "matrices", " ", "from", " ", "FDF", " ", 
      RowBox[{"files", "."}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", "MR"}]}], ",", " ", "Data", ",", " ", 
    "File", ",", " ", "Import", ",", " ", "FDF"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", 
     RowBox[{"MathLink", " ", "Binaries"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"July", " ", "2003"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.1", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"February", " ", "2010"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Limitations", ":", " ", 
      RowBox[{"Binaries", " ", "for", " ", "Windows"}]}]}], ",", " ", "Linux",
     ",", " ", 
    RowBox[{"and", " ", "MacOSX", " ", "only"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.474097785606494*^9, 3.4740978158882*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "BeginPackage", "[", "\"\<MathVisionTools`Converters`FDF`\>\"", "]"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{"Unprotect", "[", "\[IndentingNewLine]", 
  RowBox[{
  "FDFImport", ",", "\[IndentingNewLine]", "FDFHeaderImport", ",", 
   "\[IndentingNewLine]", "FDF", ",", "\[IndentingNewLine]", "FDFHeader", ",",
    "\[IndentingNewLine]", "FDFSelection", ",", "\[IndentingNewLine]", 
   "FDFHeaderParsing"}], "\[IndentingNewLine]", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FDFImport", "::", "usage"}], "=", 
   "\"\<FDFImport[fname] loads an FDF data file into Mathematica. The \
imported data is a nested List expression of Real numbers. If option \
FDFHeader is set to True FDF header information is attached to the FDF data \
within a Mathematica expression with head FDF.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FDFHeaderImport", "::", "usage"}], "=", 
   "\"\<FDFHeaderImport[fname] loads the String that constitutes the header \
of the FDF data file. Set FDFHeaderParsing to True to obtain a list of \
substitution rules instead of a simple String, which is the default.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FDF", "::", "usage"}], "=", 
   "\"\<FDF[data, {tags}] is a Mathematica expression to represent FDF files. \
The first argument is a nested List containing the data of the FDF file. The \
second argument is a list of rules replacing FDF header keywords with their \
respective values.\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FDFHeader", "::", "usage"}], "=", 
   "\"\<FDFHeader is an option of FDFImport. If set to True, FDFImport \
renders a Mathematica expression with head FDF that contains as its first \
argument a nested List of data and as its second argument a List of FDF \
header information encoded as Mathematica replacement rules. The default is \
False, so that FDFImport simply renders the data.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FDFSelection", "::", "usage"}], "=", 
   "\"\<FDFSelection is an option of FDFImport. It can be set to a List of \
Range specifications to extract a subset of data from an FDF file. The \
default is All.\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FDFHeaderParsing", "::", "usage"}], "=", 
   "\"\<FDFHeaderParsing is an option of FDFHeaderImport. If FDFHeaderParsing \
is set to True, FDFHeaderImport converts the FDF header string into a List of \
Mathematica substitution rules.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FDF", "::", "file"}], " ", "=", " ", 
   "\"\<Cannot find FDF file `1`\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FDF", "::", "nosup"}], " ", "=", " ", 
   "\"\<Data format in FDF file `1` is no supported.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Options", "[", "FDFImport", "]"}], "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Path", "\[RuleDelayed]", " ", "$Path"}], ",", " ", 
      RowBox[{"FDFHeader", "\[Rule]", " ", "False"}], ",", 
      RowBox[{"FDFSelection", "\[Rule]", " ", "All"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "FDFHeaderImport", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Path", "\[RuleDelayed]", " ", "$Path"}], ",", " ", 
     RowBox[{"FDFHeaderParsing", "\[Rule]", " ", "False"}]}], "}"}]}], 
  ";"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell[TextData[{
 "Connecting ",
 StyleBox["MathLink",
  FontSlant->"Italic"],
 " Binary"
}], "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Connection", " ", "MathLink", " ", "Binary"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"MLBinaryName", " ", "=", " ", 
     RowBox[{"Switch", "[", 
      RowBox[{
      "$SystemID", ",", "\[IndentingNewLine]", "\"\<Windows\>\"", ",", 
       "\"\<FDF.exe\>\"", ",", "\[IndentingNewLine]", "\"\<Darwin\>\"", ",", 
       "\"\<FDF\>\"", ",", "\[IndentingNewLine]", "\"\<Linux\>\"", ",", 
       "\"\<FDF\>\"", ",", "\[IndentingNewLine]", "\"\<MacOSX-x86\>\"", ",", 
       "\"\<FDF\>\"", ",", "\[IndentingNewLine]", "_", ",", "\"\<FDF\>\""}], 
      "]"}]}], ";"}], "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MLBinaryPath", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ToFileName", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "#", ",", "\"\<MathVisionTools\>\"", ",", "\"\<Converters\>\"", 
            ",", "\"\<Binaries\>\"", ",", "$SystemID"}], "}"}], ",", 
          "MLBinaryName"}], "]"}], "&"}], ",", "$Path"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{"MLBinaryFiles", " ", "=", " ", 
     RowBox[{"FileNames", "[", "MLBinaryPath", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"FDF", "::", "linkc"}], "=", 
     "\"\<The LinkObject to the FDF I/O binary is dead; attempt to connect \
failed\>\""}], ";"}], "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"MLBinaryFiles", "===", 
       RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"MLBinaryLink", "=", "$Failed"}], ",", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Links", "[", 
          RowBox[{"First", "[", "MLBinaryFiles", "]"}], "]"}], "===", 
         RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Off", "[", 
          RowBox[{"LinkConnect", "::", "\"\<linkc\>\""}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"MLBinaryLink", " ", "=", " ", 
          RowBox[{"Install", "[", 
           RowBox[{"First", "[", "MLBinaryFiles", "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"On", "[", 
          RowBox[{"LinkConnect", "::", "\"\<linkc\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"MLBinaryLink", " ", "=", " ", 
         RowBox[{"First", "[", 
          RowBox[{"Links", "[", 
           RowBox[{"First", "[", "MLBinaryFiles", "]"}], "]"}], "]"}]}]}], 
       "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
   "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Head", "[", "MLBinaryLink", "]"}], "===", "$Failed"}], ",", 
      RowBox[{"Message", "[", 
       RowBox[{"FDF", "::", "linkc"}], "]"}]}], "]"}], 
    ";"}]}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["FDF  Header Import", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"FDF", " ", "Header", " ", "Import", " ", "Function"}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"FDFHeaderImport", "[", 
    RowBox[{"fname_String", ",", " ", "opts___Rule"}], "]"}], ":=", " ", 
   "\[IndentingNewLine]", 
   RowBox[{"If", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", 
       RowBox[{"fnames", " ", "=", " ", 
        RowBox[{"FileNames", "[", 
         RowBox[{"fname", ",", 
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"{", "\"\<\>\"", "}"}], ",", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Path", " ", "/.", " ", 
               RowBox[{"{", "opts", "}"}]}], " ", "/.", " ", 
              RowBox[{"Options", "[", "FDFHeaderImport", "]"}]}], ")"}]}], 
           "]"}]}], "]"}]}], "\[IndentingNewLine]", "]"}], ">", "0"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"\"\<FDFHeaderParsing\>\"", "/.", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"{", "opts", "}"}], " ", "/.", " ", "StringRule"}], 
          ")"}]}], " ", "/.", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Options", "[", "FDFHeaderImport", "]"}], " ", "/.", " ", 
          "StringRule"}], ")"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"First", "[", 
        RowBox[{"Rest", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"ParseFDFHeader", "[", 
           RowBox[{"ReadFDFHeader", "[", 
            RowBox[{"First", "[", "fnames", "]"}], "]"}], "]"}], "]"}], "]"}],
         "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"ReadFDFHeader", "[", 
        RowBox[{"First", "[", "fnames", "]"}], "]"}], ",", 
       RowBox[{"ReadFDFHeader", "[", 
        RowBox[{"First", "[", "fnames", "]"}], "]"}]}], "\[IndentingNewLine]",
       "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"FDF", "::", "file"}], ",", 
        RowBox[{"First", "[", "fnames", "]"}]}], "]"}], ";", "$Failed"}]}], 
    "\[IndentingNewLine]", "]"}]}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["FDF  Import", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Selection", " ", "To", " ", "Range", " ", "Conversion", " ", "Function"}],
    " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"SelectionToRange", "[", 
      RowBox[{"sel_Integer", ",", " ", "max_Integer"}], "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"#", ",", "#", ",", "1"}], "}"}], "&"}], "[", 
      RowBox[{"Max", "[", 
       RowBox[{
        RowBox[{"Min", "[", 
         RowBox[{"sel", ",", "max"}], "]"}], ",", "1"}], "]"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectionToRange", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"sel1_Integer", ",", "sel2_Integer", ",", 
         RowBox[{"sel3_Integer:", "1"}]}], "}"}], ",", " ", "max_Integer"}], 
      "]"}], ":=", 
     RowBox[{"Append", "[", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Max", "[", 
           RowBox[{
            RowBox[{"Min", "[", 
             RowBox[{"#", ",", "max"}], "]"}], ",", "1"}], "]"}], "&"}], ",", 
         
         RowBox[{"{", 
          RowBox[{"sel1", ",", "sel2"}], "}"}]}], "]"}], ",", "sel3"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectionToRange", "[", 
      RowBox[{"All", ",", " ", "max_Integer"}], "]"}], "=", 
     RowBox[{"{", 
      RowBox[{"1", ",", "max", ",", "1"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectionToRange", "[", 
      RowBox[{"sel_List", ",", " ", "max_List"}], "]"}], ":=", 
     RowBox[{"MapThread", "[", 
      RowBox[{"SelectionToRange", ",", 
       RowBox[{"{", 
        RowBox[{"sel", ",", "max"}], "}"}], ",", "1"}], "]"}]}], 
    ";"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Parsing", " ", "FDF", " ", "Header", " ", "C"}], "-", "String"}],
    " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ParseFDFHeader", "[", "header_String", "]"}], ":=", 
     RowBox[{"Prepend", "[", 
      RowBox[{
       RowBox[{"Apply", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"First", "[", "#1", "]"}], ",", 
              RowBox[{"Rule", "[", 
               RowBox[{
                RowBox[{"Last", "[", "#1", "]"}], ",", "#2"}], "]"}]}], "}"}],
             "&"}], "[", 
           RowBox[{
            RowBox[{"ImportString", "[", 
             RowBox[{"#1", ",", "\"\<Words\>\""}], "]"}], ",", 
            RowBox[{"ToExpression", "[", "#2", "]"}]}], "]"}], "&"}], ",", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"mtvStringSplit", "[", 
             RowBox[{"#", ",", "\"\< = \>\""}], "]"}], "&"}], ",", 
           RowBox[{"Cases", "[", 
            RowBox[{
             RowBox[{"ImportString", "[", 
              RowBox[{
               RowBox[{"StringReplace", "[", 
                RowBox[{"header", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"\"\<char *\>\"", "\[Rule]", "\"\<char* \>\""}], 
                   ",", 
                   RowBox[{"\"\<char  *\>\"", "\[Rule]", "\"\<char*  \>\""}], 
                   ",", 
                   RowBox[{"\"\<[]\>\"", "\[Rule]", "\"\<\>\""}], ",", 
                   RowBox[{"\"\<\\f\>\"", "\[Rule]", "\"\<\>\""}], ",", 
                   RowBox[{"\"\<;\>\"", "\[Rule]", "\"\<\>\""}]}], "}"}]}], 
                "]"}], ",", "\"\<Lines\>\""}], "]"}], ",", 
             RowBox[{"_String", "?", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"StringMatchQ", "[", 
                 RowBox[{"#", ",", "\"\<*=*\>\""}], "]"}], "&"}], ")"}]}]}], 
            "]"}]}], "]"}], ",", 
         RowBox[{"{", "1", "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"\"\<int\>\"", ",", 
         RowBox[{"\"\<headerlength\>\"", "\[Rule]", 
          RowBox[{
           RowBox[{"StringLength", "[", "header", "]"}], "+", "1"}]}]}], 
        "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"mtvStringSplit", "[", 
      RowBox[{"s_String", ",", "token_String"}], "]"}], ":=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"StringTake", "[", 
         RowBox[{"s", ",", "#"}], "]"}], "&"}], ",", 
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"Flatten", "[", 
          RowBox[{"Append", "[", 
           RowBox[{
            RowBox[{"Prepend", "[", 
             RowBox[{
              RowBox[{"StringPosition", "[", 
               RowBox[{"s", ",", "token"}], "]"}], ",", "1"}], "]"}], ",", 
            RowBox[{"StringLength", "[", "s", "]"}]}], "]"}], "]"}], ",", 
         "2"}], "]"}]}], "]"}]}], ";"}]}]}]], "PackageInput",
 CellChangeTimes->{{3.4987377869611807`*^9, 3.498737795558577*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"FDF", " ", "data", " ", "file", " ", "Import"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"StringRule", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"HoldPattern", "[", 
         RowBox[{"s_", "\[Rule]", "r_"}], "]"}], "\[RuleDelayed]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"ToString", "[", "s", "]"}], "\[Rule]", "r"}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"HoldPattern", "[", 
         RowBox[{"s_", "\[RuleDelayed]", "r_"}], "]"}], ":>", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"ToString", "[", "s", "]"}], "\[RuleDelayed]", "r"}], 
         ")"}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"FDFImport", "[", 
     RowBox[{"fname_String", ",", " ", 
      RowBox[{"selections", ":", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"_Integer", "|", 
          RowBox[{"{", "__Integer", "}"}], "|", "All"}], ")"}], "..."}]}], 
      ",", "opts___Rule"}], "]"}], ":=", " ", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", "fnames", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{"fnames", " ", "=", " ", 
           RowBox[{"FileNames", "[", 
            RowBox[{
             RowBox[{"FileNameTake", "[", "fname", "]"}], ",", 
             RowBox[{"Prepend", "[", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Path", " ", "/.", " ", 
                  RowBox[{"{", "opts", "}"}]}], " ", "/.", " ", 
                 RowBox[{"Options", "[", "FDFImport", "]"}]}], ")"}], ",", 
               RowBox[{"DirectoryName", "[", "fname", "]"}]}], "]"}]}], 
            "]"}]}], "\[IndentingNewLine]", "]"}], ">", "0"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"FDFHead", " ", "=", " ", 
          RowBox[{"First", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"Transpose", "[", 
             RowBox[{"ParseFDFHeader", "[", 
              RowBox[{"ReadFDFHeader", "[", 
               RowBox[{"First", "[", "fnames", "]"}], "]"}], "]"}], "]"}], 
            "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"FDFRange", " ", "=", " ", 
          RowBox[{
           RowBox[{"\"\<FDFSelection\>\"", " ", "/.", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], " ", "/.", " ", "StringRule"}], 
             ")"}]}], " ", "/.", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Options", "[", "FDFImport", "]"}], " ", "/.", " ", 
             "StringRule"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"FDFRange", "===", "All"}], ",", " ", 
           RowBox[{"FDFRange", "=", 
            RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", "selections", "}"}], "=!=", 
            RowBox[{"{", "}"}]}], ",", " ", 
           RowBox[{"FDFRange", " ", "=", 
            RowBox[{"{", "selections", "}"}]}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"FDFRange", " ", "=", " ", 
          RowBox[{"SelectionToRange", "[", 
           RowBox[{
            RowBox[{"PadRight", "[", 
             RowBox[{"FDFRange", ",", 
              RowBox[{"Length", "[", " ", 
               RowBox[{"\"\<matrix\>\"", "/.", "FDFHead"}], "]"}], ",", 
              "All"}], "]"}], ",", 
            RowBox[{"\"\<matrix\>\"", "/.", "FDFHead"}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"FDFData", " ", "=", " ", 
          RowBox[{"ReadFDFMatrix", " ", "@@", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"First", "[", "fnames", "]"}], ",", " ", 
               "\"\<float\>\"", ",", " ", 
               RowBox[{"Round", "[", "\"\<bits\>\"", "]"}], ",", " ", 
               "\"\<headerlength\>\"", ",", 
               RowBox[{"Round", "[", " ", "\"\<rank\>\"", "]"}], ",", 
               "\"\<matrix\>\"", ",", "FDFRange"}], "}"}], "/.", "FDFHead"}], 
            ")"}]}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", "\[IndentingNewLine]", 
          RowBox[{"False", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"FDF", "::", "nosup"}], ",", 
              RowBox[{"First", "[", "fnames", "]"}]}], "]"}], ";", 
            "$Failed"}], ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"\"\<FDFHeader\>\"", "/.", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"{", "opts", "}"}], " ", "/.", " ", "StringRule"}], 
                ")"}]}], " ", "/.", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Options", "[", "FDFImport", "]"}], " ", "/.", " ", 
                "StringRule"}], ")"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"FDF", "[", 
              RowBox[{"FDFData", ",", "FDFHead"}], "]"}], ",", 
             "\[IndentingNewLine]", "FDFData", ",", "FDFData"}], 
            "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"FDF", "::", "file"}], ",", 
           RowBox[{"First", "[", "fnames", "]"}]}], "]"}], ";", "$Failed"}]}],
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
     "]"}]}]}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.474097689610124*^9, 3.474097736773704*^9}}],

Cell[CellGroupData[{

Cell["Register Import", "Subsubsection"],

Cell[BoxData[
 RowBox[{"If", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"$VersionNumber", "<", "6"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Experimental`RegisterConverter", "[", 
    RowBox[{
    "Import", ",", "\[IndentingNewLine]", "\"\<FDF\>\"", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<*.fdf\>\"", ",", "\"\<*.FDF\>\""}], "}"}], ",", 
     "\[IndentingNewLine]", "None", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FDFImport", "[", "\[IndentingNewLine]", 
       RowBox[{"#1", ",", "\[IndentingNewLine]", 
        RowBox[{"Apply", "[", 
         RowBox[{"Sequence", ",", 
          RowBox[{
           RowBox[{"ConversionOptions", "/.", 
            RowBox[{"Rest", "[", 
             RowBox[{"{", "##", "}"}], "]"}]}], "/.", 
           RowBox[{"ConversionOptions", "\[Rule]", 
            RowBox[{"{", "}"}]}]}]}], "]"}]}], "\[IndentingNewLine]", "]"}], 
      "&"}], ",", "\[IndentingNewLine]", 
     RowBox[{"\"\<TextFormat\>\"", "\[Rule]", "False"}]}], 
    "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
  "]"}]], "PackageInput"]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "FDFImport", ",", "\[IndentingNewLine]", "FDFHeaderImport", ",", 
       "\[IndentingNewLine]", "FDF", ",", "\[IndentingNewLine]", "FDFHeader", 
       ",", "\[IndentingNewLine]", "FDFSelection", ",", "\[IndentingNewLine]",
        "FDFHeaderParsing"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Protected", ",", " ", "ReadProtected"}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{957, 789},
WindowMargins->{{15, Automatic}, {Automatic, 17}},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 7, \
2010)",
StyleDefinitions->"PackageNotebook.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 28, 0, 144, "Title"],
Cell[598, 24, 221, 6, 118, "Subsubtitle"],
Cell[CellGroupData[{
Cell[844, 34, 25, 0, 72, "Section"],
Cell[872, 36, 128, 3, 87, "Text"],
Cell[1003, 41, 1023, 26, 706, "PackageInput"],
Cell[2029, 69, 3801, 102, 1998, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5867, 176, 32, 0, 40, "Section"],
Cell[5902, 178, 92, 2, 235, "Text"],
Cell[5997, 182, 524, 11, 235, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6558, 198, 42, 0, 40, "Section"],
Cell[6603, 200, 3261, 73, 235, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[9901, 278, 31, 0, 40, "Section"],
Cell[9935, 280, 60, 0, 39, "Text"],
Cell[9998, 282, 108, 2, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[10131, 288, 106, 5, 63, "Subsection"],
Cell[10240, 295, 3022, 75, 2539, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[13299, 375, 40, 0, 37, "Subsection"],
Cell[13342, 377, 2242, 55, 235, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[15621, 437, 33, 0, 37, "Subsection"],
Cell[15657, 439, 1936, 56, 319, "PackageInput"],
Cell[17596, 497, 3217, 82, 409, "PackageInput"],
Cell[20816, 581, 6040, 143, 940, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[26881, 728, 40, 0, 57, "Subsubsection"],
Cell[26924, 730, 1105, 25, 1215, "PackageInput"]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[28090, 762, 34, 0, 72, "Section"],
Cell[28127, 764, 64, 0, 235, "Text"],
Cell[28194, 766, 761, 17, 235, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
