(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     21431,        614]
NotebookOptionsPosition[     19544,        547]
NotebookOutlinePosition[     19967,        565]
CellTagsIndexPosition[     19924,        562]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Raw 3D Package", "Title"],

Cell["\<\
Markus van Almsick
Technische Universiteit Eindhoven
\[Copyright]2010\
\>", "Subsubtitle",
 CellChangeTimes->{{3.47409741254074*^9, 3.47409741294421*^9}, {
  3.488872196908045*^9, 3.488872197287531*^9}}],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
     "TimeStamp", "[", "\"\<MathVisionTools`Converters`Raw3D`\>\"", "]"}], 
     " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"2010", ",", "2", ",", "2", ",", "12", ",", "0", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput",
 CellChangeTimes->{{3.474097388121497*^9, 3.474097392272758*^9}}],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`Converters`Raw3D`"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Author", ":", " ", 
     RowBox[{"Markus", " ", "van", " ", "Almsick"}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"M", ".", "v", ".", 
       RowBox[{"Almsick", "@", "tue"}], ".", "nl"}]}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`Converters`Raw3D`"}]}], 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "2.1"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "6.2"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2010"}]}]}], ",", " ", 
    RowBox[{"Technische", " ", "Universiteit", " ", "Eindhoven"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", 
     RowBox[{"Raw", " ", "3", "D"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "implements", " ", "raw", " ", "3", "D", 
      " ", 
      RowBox[{"import", "/", "export"}], " ", 
      RowBox[{"routines", "."}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", "Raw"}]}], ",", " ", 
    RowBox[{"3", "D"}], ",", " ", "Data", ",", " ", "File", ",", " ", 
    "Import", ",", " ", "Export"}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"July", " ", "2003"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "2.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"January", " ", "2008"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":", " ", "none"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.474097397062664*^9, 3.4740974046909447`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "BeginPackage", "[", "\"\<MathVisionTools`Converters`Raw3D`\>\"", "]"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{"Unprotect", "[", "\[IndentingNewLine]", 
  RowBox[{"Raw3DImport", ",", "\[IndentingNewLine]", "Raw3DExport"}], 
  "\[IndentingNewLine]", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Raw3DImport", "::", "usage"}], "=", 
   "\"\<Raw3DImport[fname] loads a 3D data file into Mathematica. The \
imported data is a Mathematica List expression of rank 3 with Integer or Real \
numbers. A 3D data file is a plain binary file format. The first 3 short \
integers denote the dimensions of the 3D data set. The rest of the file \
consists of a plain sequence of all short integer or all float data \
values\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Raw3DExport", "::", "usage"}], "=", 
   "\"\<Raw3DExport[fname, data] saves a Mathematica List expression of rank \
3 with Integer or Real numbers in a raw 3D data file. A raw 3D data file is a \
plain binary file format. The first 3 short integers denote the dimensions of \
the 3D data set. The rest of the file consists of a plain sequence of all \
short integer or all float data values.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Raw3DImport", "::", "file"}], " ", "=", " ", 
  "\"\<Cannot find 3D data file `1`\>\""}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Raw3DImport", "::", "corrupt"}], "=", 
    "\"\<The internal data structure of `1` is inconsistent.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Raw3DImport", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ByteOrdering", "\[Rule]", " ", "$ByteOrdering"}], ",", " ", 
     RowBox[{"Path", "\[RuleDelayed]", " ", "$Path"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Raw3DExport", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"ByteOrdering", "\[Rule]", " ", "$ByteOrdering"}], "}"}]}], 
  ";"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Raw 3D Import", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"3", "D", " ", "data", " ", "file", " ", "Import"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Raw3DImport", "[", 
    RowBox[{"fname_String", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "fileSize", ",", "strm", ",", "dims", ",", "data", ",", "path", ",", 
       "byteOrd", ",", "fnames"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"path", " ", "=", " ", 
       RowBox[{
        RowBox[{"Path", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Raw3DImport", "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"byteOrd", " ", "=", " ", 
       RowBox[{
        RowBox[{"ByteOrdering", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Raw3DImport", "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"fnames", "=", 
       RowBox[{"FileNames", "[", 
        RowBox[{
         RowBox[{"FileNameTake", "[", "fname", "]"}], ",", 
         RowBox[{"Prepend", "[", 
          RowBox[{"path", ",", 
           RowBox[{"DirectoryName", "[", "fname", "]"}]}], "]"}]}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"fnames", "===", 
         RowBox[{"{", "}"}]}], ",", 
        RowBox[{
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"Raw3DImport", "::", "file"}], ",", "fname"}], "]"}], ";", 
         
         RowBox[{"Return", "[", "$Failed", "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"fileSize", "=", 
       RowBox[{"FileByteCount", "[", 
        RowBox[{"First", "[", "fnames", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"fileSize", "===", "$Failed"}], ",", 
        RowBox[{"Return", "[", "$Failed", "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"strm", " ", "=", " ", 
       RowBox[{"OpenRead", "[", 
        RowBox[{
         RowBox[{"First", "[", "fnames", "]"}], ",", " ", 
         RowBox[{"BinaryFormat", "\[Rule]", " ", "True"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"dims", "=", 
       RowBox[{"BinaryRead", "[", 
        RowBox[{"strm", ",", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Integer16\>\"", ",", "\"\<Integer16\>\"", ",", 
           "\"\<Integer16\>\""}], "}"}], ",", 
         RowBox[{"ByteOrdering", "\[Rule]", " ", "byteOrd"}], ",", " ", 
         RowBox[{"Path", "\[Rule]", " ", "path"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Switch", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"fileSize", "-", "6"}], ")"}], "/", 
         RowBox[{"Times", "@@", "dims"}]}], ",", "\[IndentingNewLine]", "2", 
        ",", 
        RowBox[{"data", " ", "=", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"strm", ",", "\"\<Integer16\>\"", ",", 
           RowBox[{"ByteOrdering", "\[Rule]", " ", "byteOrd"}], ",", " ", 
           RowBox[{"Path", "\[Rule]", " ", "path"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", "4", ",", 
        RowBox[{"data", " ", "=", 
         RowBox[{"BinaryReadList", "[", 
          RowBox[{"strm", ",", "\"\<Real32\>\"", ",", 
           RowBox[{"ByteOrdering", "\[Rule]", " ", "byteOrd"}], ",", " ", 
           RowBox[{"Path", "\[Rule]", " ", "path"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", "_", ",", 
        RowBox[{
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"Raw3DImport", "::", "corrupt"}], ",", "fname"}], "]"}], 
         ";", 
         RowBox[{"Return", "[", "$Failed", "]"}]}]}], "\[IndentingNewLine]", 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Close", "[", "strm", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Fold", "[", 
       RowBox[{"Partition", ",", "data", ",", 
        RowBox[{"Rest", "[", 
         RowBox[{"Reverse", "[", "dims", "]"}], "]"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.474097348404682*^9, 3.4740973556307173`*^9}}],

Cell[CellGroupData[{

Cell["Register Import", "Subsubsection"],

Cell[BoxData[
 RowBox[{"If", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"$VersionNumber", "<", "6"}], ",", "\[IndentingNewLine]", " ", 
   RowBox[{"Experimental`RegisterConverter", "[", 
    RowBox[{
    "Import", ",", "\[IndentingNewLine]", "\"\<Raw3D\>\"", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<*.dat\>\"", ",", "\"\<*.DAT\>\""}], "}"}], ",", 
     "\[IndentingNewLine]", "None", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Raw3DImport", "[", "\[IndentingNewLine]", 
       RowBox[{"#1", ",", "\[IndentingNewLine]", 
        RowBox[{"Apply", "[", 
         RowBox[{"Sequence", ",", 
          RowBox[{
           RowBox[{"ConversionOptions", "/.", 
            RowBox[{"Rest", "[", 
             RowBox[{"{", "##", "}"}], "]"}]}], "/.", 
           RowBox[{"ConversionOptions", "\[Rule]", 
            RowBox[{"{", "}"}]}]}]}], "]"}]}], "\[IndentingNewLine]", "]"}], 
      "&"}], ",", "\[IndentingNewLine]", 
     RowBox[{"\"\<TextFormat\>\"", "\[Rule]", "False"}]}], 
    "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
  "]"}]], "PackageInput"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Raw 3D Export", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"3", "D", " ", "data", " ", "file", " ", "Export"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Raw3DExport", "[", 
     RowBox[{"fname_String", ",", " ", 
      RowBox[{"data_", "?", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"ArrayQ", "[", 
          RowBox[{"#", ",", "3", ",", "IntegerQ"}], "]"}], "&"}], ")"}]}], 
      ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"strm", " ", "=", " ", 
         RowBox[{"OpenWrite", "[", 
          RowBox[{"fname", ",", " ", 
           RowBox[{"BinaryFormat", "\[Rule]", " ", "True"}]}], "]"}]}], ",", 
        "byteOrd"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"byteOrd", " ", "=", " ", 
        RowBox[{
         RowBox[{"ByteOrdering", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Raw3DExport", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"dims", "=", 
        RowBox[{"BinaryWrite", "[", 
         RowBox[{"strm", ",", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Dimensions", "[", "data", "]"}], "]"}], ",", 
          "\"\<Integer16\>\"", ",", 
          RowBox[{"ByteOrdering", "\[Rule]", " ", "byteOrd"}]}], "]"}]}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"BinaryWrite", "[", 
        RowBox[{"strm", ",", 
         RowBox[{"Flatten", "[", "data", "]"}], ",", "\"\<Integer16\>\"", ",", 
         RowBox[{"ByteOrdering", "\[Rule]", " ", "byteOrd"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Close", "[", "strm", "]"}], ";", "\[IndentingNewLine]", 
       "fname"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Raw3DExport", "[", 
     RowBox[{"fname_String", ",", " ", 
      RowBox[{"data_", "?", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"ArrayQ", "[", 
          RowBox[{"#", ",", "3", ",", "NumericQ"}], "]"}], "&"}], ")"}]}], 
      ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"strm", " ", "=", " ", 
         RowBox[{"OpenWrite", "[", 
          RowBox[{"fname", ",", " ", 
           RowBox[{"BinaryFormat", "\[Rule]", " ", "True"}]}], "]"}]}], ",", 
        "byteOrd"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"byteOrd", " ", "=", " ", 
        RowBox[{
         RowBox[{"ByteOrdering", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Raw3DExport", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"dims", "=", 
        RowBox[{"BinaryWrite", "[", 
         RowBox[{"strm", ",", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Dimensions", "[", "data", "]"}], "]"}], ",", 
          "\"\<Integer16\>\"", ",", 
          RowBox[{"ByteOrdering", "\[Rule]", " ", "byteOrd"}]}], "]"}]}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"BinaryWrite", "[", 
        RowBox[{"strm", ",", 
         RowBox[{"N", "[", 
          RowBox[{"Flatten", "[", "data", "]"}], "]"}], ",", "\"\<Real32\>\"",
          ",", 
         RowBox[{"ByteOrdering", "\[Rule]", " ", "byteOrd"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Close", "[", "strm", "]"}], ";", "\[IndentingNewLine]", 
       "fname"}]}], "\[IndentingNewLine]", "]"}]}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Register Export", "Subsubsection"],

Cell[BoxData[
 RowBox[{"If", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"$VersionNumber", "<", "6"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Experimental`RegisterConverter", "[", 
    RowBox[{
    "Export", ",", "\[IndentingNewLine]", "\"\<Raw3D\>\"", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<*.dat\>\"", ",", "\"\<*.DAT\>\""}], "}"}], ",", 
     "\[IndentingNewLine]", "None", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Raw3DExport", "[", "\[IndentingNewLine]", 
       RowBox[{
       "#1", ",", "\[IndentingNewLine]", "#2", ",", "\[IndentingNewLine]", 
        RowBox[{"Apply", "[", 
         RowBox[{"Sequence", ",", 
          RowBox[{
           RowBox[{"ConversionOptions", "/.", 
            RowBox[{"Drop", "[", 
             RowBox[{
              RowBox[{"{", "##", "}"}], ",", "2"}], "]"}]}], "/.", 
           RowBox[{"ConversionOptions", "\[Rule]", 
            RowBox[{"{", "}"}]}]}]}], "]"}]}], "\[IndentingNewLine]", "]"}], 
      "&"}], ",", "\[IndentingNewLine]", 
     RowBox[{"\"\<TextFormat\>\"", "\[Rule]", "False"}]}], 
    "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
  "]"}]], "PackageInput"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Raw3DImport", ",", "\[IndentingNewLine]", "Raw3DExport"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Protected", ",", " ", "ReadProtected"}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1014, 736},
WindowMargins->{{21, Automatic}, {Automatic, 11}},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (November 10, 2008)",
StyleDefinitions->"PackageNotebook.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 31, 0, 144, "Title"],
Cell[601, 24, 213, 6, 118, "Subsubtitle"],
Cell[CellGroupData[{
Cell[839, 34, 25, 0, 72, "Section"],
Cell[867, 36, 1021, 26, 436, "PackageInput"],
Cell[1891, 64, 128, 3, 58, "Text"],
Cell[2022, 69, 3538, 98, 1159, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5597, 172, 32, 0, 40, "Section"],
Cell[5632, 174, 92, 2, 87, "Text"],
Cell[5727, 178, 344, 8, 396, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6108, 191, 42, 0, 40, "Section"],
Cell[6153, 193, 1853, 42, 1171, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[8043, 240, 31, 0, 40, "Section"],
Cell[8077, 242, 60, 0, 58, "Text"],
Cell[8140, 244, 108, 2, 90, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[8273, 250, 35, 0, 94, "Subsection"],
Cell[8311, 252, 4309, 105, 922, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[12645, 361, 40, 0, 85, "Subsubsection"],
Cell[12688, 363, 1114, 25, 757, "PackageInput"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[13851, 394, 35, 0, 55, "Subsection"],
Cell[13889, 396, 3641, 89, 853, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[17555, 489, 40, 0, 85, "Subsubsection"],
Cell[17598, 491, 1186, 27, 810, "PackageInput"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[18845, 525, 34, 0, 40, "Section"],
Cell[18882, 527, 64, 0, 87, "Text"],
Cell[18949, 529, 567, 14, 550, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
