(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     70653,       1979]
NotebookOptionsPosition[     66389,       1843]
NotebookOutlinePosition[     66811,       1861]
CellTagsIndexPosition[     66768,       1858]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Convolve", "Title"],

Cell["\<\
Markus van Almsick
Technische Universiteit Eindhoven
\[Copyright]2002\
\>", "Subsubtitle",
 CellChangeTimes->{{3.488872203644658*^9, 3.488872203848102*^9}}],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`Convolution`"}]}], " ", "*)"}],
   "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Author", ":", " ", 
     RowBox[{"Bart", " ", 
      RowBox[{"M", ".", "ter"}], " ", "Haar", " ", "Romeny", " ", 
      RowBox[{"Ph", ".", "D", ".", "and"}], " ", "Markus", " ", "van", " ", 
      "Almsick"}]}]}], "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Email", " ", 
      RowBox[{"address", ":", " ", 
       RowBox[{"B", ".", 
        RowBox[{"terHaarRomeny", "@", "isi"}], ".", "uu", ".", "nl"}]}]}]}], 
    ",", " ", 
    RowBox[{"M", ".", "v", ".", 
     RowBox[{"Almsick", "@", "tue"}], ".", "nl"}]}], "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`Convolution`"}]}], "*)"}], 
  "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "1.0"}]}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "4.0"}]}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2002"}]}]}], ",", " ", 
    RowBox[{"Technische", " ", "Universiteit", " ", "Eindhoven"}]}], "*)"}], 
  "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "Convolution"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "implements", " ", "symbolic", " ", 
      "convolution", " ", "with", " ", "the", " ", "commands", " ", 
      "convolve", " ", "and", " ", "convolute"}]}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", "Convolve"}]}], ",", " ", "Fourier", ",", 
    " ", 
    RowBox[{"scale", "-", "space"}], ",", " ", 
    RowBox[{"computer", " ", "vision"}], ",", " ", "\n", "  ", 
    RowBox[{"differential", " ", "operator"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{"Version", " ", "1.0", " ", "by", " ", "Bart", " ", 
       RowBox[{"M", ".", "ter"}], " ", "Haar", " ", "Romeny", " ", "and", " ",
        "Markus", " ", "van", " ", "Almsick"}]}]}], ",", " ", "\n", "  ", 
    RowBox[{"October", " ", "2002"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], "  ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[{
 RowBox[{"BeginPackage", "[", "\"\<MathVisionTools`Convolve`\>\"", 
  "]"}], "\n", 
 RowBox[{"Needs", "[", "\"\<MathVisionTools`GaussianDerivative`\>\"", 
  "]"}], "\n", 
 RowBox[{"Unprotect", "[", "\n", "  ", 
  RowBox[{
  "Convolve", ",", "\n", "  ", "Convolute", ",", "\n", "  ", "GaussianKernel",
    ",", "\n", "  ", "GaussianDKernel"}], "\n", "  ", "]"}]}], "PackageInput",\

 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Convolve", "::", "usage"}], " ", "=", " ", 
   "\"\<Convolve[f, g, y, x] gives the convolute of f and g with respect to y \
and resulting variable x.\>\""}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"Convolute", "::", "usage"}], " ", "=", " ", 
  "\"\<Convolute[{sf1,sg1},{sf2,sg2},...][f,g] represents the convolute of f \
and g with slot sf1 of f convolved with slot sg1 of g, and slot sf2 of f \
convolved with slot sg2 of g and so on for higher-dimensional \
cases.\>\""}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Convolve", "Subsection"],

Cell[CellGroupData[{

Cell["Atttributes", "Subsubsection"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"Convolve", ",", "HoldAll"}], "]"}]], "PackageInput",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["1-dimesional case", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Convolve", "[", 
   RowBox[{"f_", ",", "g_", ",", 
    RowBox[{"{", "t_", "}"}], ",", 
    RowBox[{"{", "x_", "}"}]}], "]"}], " ", ":=", " ", 
  RowBox[{"Convolve", "[", 
   RowBox[{"f", ",", "g", ",", "t", ",", "x"}], "]"}], " "}]], "PackageInput",\

 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Commutativity", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Convolve", "[", 
   RowBox[{"f_", ",", "g_", ",", "t_", ",", "x_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Convolve", "[", 
    RowBox[{"g", ",", "f", ",", "t", ",", "x"}], "]"}], "/;", 
   RowBox[{"Not", "[", 
    RowBox[{"ConvolveOrderedQ", "[", 
     RowBox[{"f", ",", "g"}], "]"}], "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{"ConvolveOrderedQ", "[", 
   RowBox[{"f_", ",", "g_"}], "]"}], ":=", " ", 
  RowBox[{"OrderedQ", "[", 
   RowBox[{"{", 
    RowBox[{"f", ",", "g"}], "}"}], "]"}]}]}], "PackageInput",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Linearity", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Convolve", "[", 
    RowBox[{
     RowBox[{"f_", " ", "+", " ", "g_"}], ",", "h_", ",", "t_", ",", "x_"}], 
    "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"Convolve", "[", 
     RowBox[{"f", ",", "h", ",", "t", ",", "x"}], "]"}], " ", "+", " ", 
    RowBox[{"Convolve", "[", 
     RowBox[{"g", ",", "h", ",", "t", ",", "x"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Convolve", "[", 
    RowBox[{"f_", " ", ",", 
     RowBox[{"g_", "+", " ", "h_"}], ",", "t_", ",", "x_"}], "]"}], " ", ":=",
    " ", 
   RowBox[{
    RowBox[{"Convolve", "[", 
     RowBox[{"f", ",", "g", ",", "t", ",", "x"}], "]"}], " ", "+", " ", 
    RowBox[{"Convolve", "[", 
     RowBox[{"f", ",", "h", ",", "t", ",", "x"}], "]"}]}]}], 
  ";"}]}], "PackageInput",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Convolve", "[", 
    RowBox[{"f_", ",", 
     RowBox[{"c_", " ", "g_"}], ",", "t_List", ",", "x_List"}], "]"}], " ", ":=",
    " ", "\n", "    ", 
   RowBox[{
    RowBox[{"c", " ", 
     RowBox[{"Convolve", "[", 
      RowBox[{"f", ",", "g", ",", "t", ",", "x"}], "]"}]}], " ", "/;", " ", 
    RowBox[{"Apply", "[", 
     RowBox[{"And", ",", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"FreeQ", "[", 
          RowBox[{"c", ",", "#"}], "]"}], "&"}], ",", "t"}], "]"}]}], 
     "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Convolve", "[", 
    RowBox[{"f_", ",", 
     RowBox[{"c_", " ", "g_"}], ",", "t_List", ",", "x_List"}], "]"}], " ", ":=",
    " ", "\n", "    ", 
   RowBox[{
    RowBox[{"c", " ", 
     RowBox[{"Convolve", "[", 
      RowBox[{"f", ",", "g", ",", "t", ",", "x"}], "]"}]}], " ", "/;", " ", 
    RowBox[{"Apply", "[", 
     RowBox[{"And", ",", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"FreeQ", "[", 
          RowBox[{"c", ",", "#"}], "]"}], "&"}], ",", "t"}], "]"}]}], 
     "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Convolve", "[", 
    RowBox[{
     RowBox[{"c_", " ", "f_"}], ",", "g_", ",", "t_", ",", "x_"}], "]"}], " ",
    ":=", " ", 
   RowBox[{
    RowBox[{"c", " ", 
     RowBox[{"Convolve", "[", 
      RowBox[{"f", ",", "g", ",", "t", ",", "x"}], "]"}]}], " ", "/;", " ", 
    RowBox[{"FreeQ", "[", 
     RowBox[{"c", ",", "t"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Convolve", "[", 
    RowBox[{"f_", ",", 
     RowBox[{"c_", " ", "g_"}], ",", "t_", ",", "x_"}], "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"c", " ", 
     RowBox[{"Convolve", "[", 
      RowBox[{"f", ",", "g", ",", "t", ",", "x"}], "]"}]}], " ", "/;", " ", 
    RowBox[{"FreeQ", "[", 
     RowBox[{"c", ",", "t"}], "]"}]}]}], ";"}]}], "PackageInput",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Separability", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Convolve", "[", "\n", "    ", 
   RowBox[{
    RowBox[{
     RowBox[{"fSineXi_", "?", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"FreeQ", "[", 
         RowBox[{"#", ",", "xi"}], "]"}], "&"}], ")"}]}], " ", "*", " ", 
     RowBox[{"fCumXi_", "?", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"FreeQ", "[", 
          RowBox[{"#", ",", "xi"}], "]"}], "]"}], "&"}], ")"}]}]}], ",", "\n",
     "    ", "g_", ",", "\n", "    ", 
    RowBox[{"xs", ":", 
     RowBox[{"{", 
      RowBox[{"x1___", ",", "xi_", ",", "x2___"}], "}"}]}], ",", "\n", "    ",
     "ys_List"}], "\n", "    ", "]"}], ":=", "\n", "  ", 
  RowBox[{"Module", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"xipos", "=", 
      RowBox[{"First", "[", 
       RowBox[{"Position", "[", 
        RowBox[{"xs", ",", "xi", ",", "1"}], "]"}], "]"}]}], "}"}], ",", "\n",
     "    ", 
    RowBox[{"Convolve", "[", "\n", "      ", 
     RowBox[{
      RowBox[{"fSineXi", " ", "*", " ", 
       RowBox[{"Convolve", "[", 
        RowBox[{"fCumXi", ",", "g", ",", "xi", ",", 
         RowBox[{"Take", "[", 
          RowBox[{"ys", ",", "xipos"}], "]"}]}], "]"}]}], ",", "\n", "      ",
       "g", ",", "\n", "      ", 
      RowBox[{"{", 
       RowBox[{"x1", ",", "x2"}], "}"}], ",", "\n", "      ", 
      RowBox[{"Drop", "[", 
       RowBox[{"ys", ",", "xipos"}], "]"}]}], "]"}]}], "\n", "    ", 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Convolve", "[", "\n", "    ", 
   RowBox[{"f_", ",", "\n", "    ", 
    RowBox[{
     RowBox[{"gSineXi_", "?", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"FreeQ", "[", 
         RowBox[{"#", ",", "xi"}], "]"}], "&"}], ")"}]}], " ", "*", " ", 
     RowBox[{"gCumXi_", "?", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"FreeQ", "[", 
          RowBox[{"#", ",", "xi"}], "]"}], "]"}], "&"}], ")"}]}]}], ",", "\n",
     "    ", 
    RowBox[{"xs", ":", 
     RowBox[{"{", 
      RowBox[{"x1___", ",", "xi_", ",", "x2___"}], "}"}]}], ",", "\n", "    ",
     "ys_List"}], "\n", "    ", "]"}], ":=", "\n", "  ", 
  RowBox[{"Module", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"xipos", "=", 
      RowBox[{"First", "[", 
       RowBox[{"Position", "[", 
        RowBox[{"xs", ",", "xi", ",", "1"}], "]"}], "]"}]}], "}"}], ",", "\n",
     "    ", 
    RowBox[{"Convolve", "[", "\n", "      ", 
     RowBox[{"f", ",", "\n", "      ", 
      RowBox[{"gSineXi", " ", "*", " ", 
       RowBox[{"Convolve", "[", 
        RowBox[{"f", ",", "gCumXi", ",", "xi", ",", 
         RowBox[{"Take", "[", 
          RowBox[{"ys", ",", "xipos"}], "]"}]}], "]"}]}], ",", "\n", "      ", 
      RowBox[{"{", 
       RowBox[{"x1", ",", "x2"}], "}"}], ",", "\n", "      ", 
      RowBox[{"Drop", "[", 
       RowBox[{"ys", ",", "xipos"}], "]"}]}], "]"}]}], "\n", "    ", 
   "]"}]}]}], "PackageInput",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["GaussianDerivative", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"GaussianKernel", "/:", 
    RowBox[{"Convolve", "[", 
     RowBox[{
      RowBox[{"GaussianKernel", "[", 
       RowBox[{"t_List", ",", 
        RowBox[{"{", "x__", "}"}]}], "]"}], ",", "f_", ",", 
      RowBox[{"{", "x__", "}"}], ",", 
      RowBox[{"{", "y__", "}"}]}], "]"}], " ", ":=", " ", "\n", "    ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"GaussianDerivative", "[", 
        RowBox[{"Apply", "[", 
         RowBox[{"Sequence", ",", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"#", ",", "0"}], "}"}], "&"}], ",", "t"}], "]"}]}], 
         "]"}], "]"}], "[", "f", "]"}], "[", "y", "]"}], "/;", " ", "\n", 
     "      ", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"f", ",", 
       RowBox[{"func_", "[", "x", "]"}]}], "]"}]}]}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"GaussianKernel", "/:", 
    RowBox[{"Convolve", "[", 
     RowBox[{
      RowBox[{"GaussianKernel", "[", 
       RowBox[{"t_", ",", 
        RowBox[{"{", "x__", "}"}]}], "]"}], ",", "f_", ",", 
      RowBox[{"{", "x__", "}"}], ",", 
      RowBox[{"{", "y__", "}"}]}], "]"}], " ", ":=", " ", "\n", "    ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"GaussianDerivative", "[", 
        RowBox[{"Apply", "[", 
         RowBox[{"Sequence", ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"t", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Length", "[", "t", "]"}], "}"}]}], "]"}]}], "]"}], 
        "]"}], "[", "f", "]"}], "[", "y", "]"}], "/;", " ", "\n", "      ", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"f", ",", 
       RowBox[{"func_", "[", "x", "]"}]}], "]"}]}]}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"GaussianKernel", "/:", 
   RowBox[{"Convolve", "[", 
    RowBox[{
     RowBox[{"GaussianKernel", "[", 
      RowBox[{"t_", ",", "x_"}], "]"}], ",", "f_", ",", "x_", ",", "y_"}], 
    "]"}], " ", ":=", " ", "\n", "    ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"GaussianDerivative", "[", 
       RowBox[{"{", 
        RowBox[{"t", ",", "0"}], "}"}], "]"}], "[", "f", "]"}], "[", "y", 
     "]"}], "/;", " ", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"f", ",", 
      RowBox[{"func_", "[", "x", "]"}]}], "]"}]}]}], ";"}]}], "PackageInput",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"GaussianDKernel", "/:", "\n", "    ", 
    RowBox[{"Convolve", "[", 
     RowBox[{
      RowBox[{"GaussianDKernel", "[", 
       RowBox[{"t_List", ",", "n_List", ",", 
        RowBox[{"{", "x__", "}"}]}], "]"}], ",", "f_", ",", 
      RowBox[{"{", "x__", "}"}], ",", 
      RowBox[{"{", "y__", "}"}]}], "]"}], " ", ":=", " ", "\n", "    ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"GaussianDerivative", "[", 
        RowBox[{"Apply", "[", 
         RowBox[{"Sequence", ",", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"t", ",", "n"}], "}"}], "]"}]}], "]"}], "]"}], "[", "f", 
       "]"}], "[", "y", "]"}], "/;", " ", "\n", "      ", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"f", ",", 
       RowBox[{"func_", "[", "x", "]"}]}], "]"}]}]}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"GaussianDKernel", "/:", 
    RowBox[{"Convolve", "[", 
     RowBox[{
      RowBox[{"GaussianDKernel", "[", 
       RowBox[{"t_", ",", "n_List", ",", 
        RowBox[{"{", "x__", "}"}]}], "]"}], ",", "f_", ",", 
      RowBox[{"{", "x__", "}"}], ",", 
      RowBox[{"{", "y__", "}"}]}], "]"}], " ", ":=", " ", "\n", "    ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"GaussianDerivative", "[", 
        RowBox[{"Apply", "[", 
         RowBox[{"Sequence", ",", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"t", ",", "#"}], "}"}], "&"}], ",", "n"}], "]"}]}], 
         "]"}], "]"}], "[", "f", "]"}], "[", "y", "]"}], "/;", " ", "\n", 
     "      ", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"f", ",", 
       RowBox[{"func_", "[", "x", "]"}]}], "]"}]}]}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"GaussianDKernel", "/:", 
    RowBox[{"Convolve", "[", 
     RowBox[{
      RowBox[{"GaussianDKernel", "[", 
       RowBox[{"t_List", ",", "n_", ",", 
        RowBox[{"{", "x__", "}"}]}], "]"}], ",", "f_", ",", 
      RowBox[{"{", "x__", "}"}], ",", 
      RowBox[{"{", "y__", "}"}]}], "]"}], " ", ":=", " ", "\n", "    ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"GaussianDerivative", "[", 
        RowBox[{"Apply", "[", 
         RowBox[{"Sequence", ",", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"#", ",", "n"}], "}"}], "&"}], ",", "t"}], "]"}]}], 
         "]"}], "]"}], "[", "f", "]"}], "[", "y", "]"}], "/;", " ", "\n", 
     "      ", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"f", ",", 
       RowBox[{"func_", "[", "x", "]"}]}], "]"}]}]}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"GaussianDKernel", "/:", 
   RowBox[{"Convolve", "[", 
    RowBox[{
     RowBox[{"GaussianDKernel", "[", 
      RowBox[{"t_", ",", "n_", ",", "x_"}], "]"}], ",", "f_", ",", "x_", ",", 
     "y_"}], "]"}], " ", ":=", " ", "\n", "    ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"GaussianDerivative", "[", 
       RowBox[{"{", 
        RowBox[{"t", ",", "n"}], "}"}], "]"}], "[", "f", "]"}], "[", "y", 
     "]"}], "/;", " ", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"f", ",", 
      RowBox[{"func_", "[", "x", "]"}]}], "]"}]}]}], ";"}]}], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"Convolute", "/:", 
  RowBox[{
   RowBox[{"Derivative", "[", "n__Integer", "]"}], "[", 
   RowBox[{
    RowBox[{"Convolute", "[", "ord__List", "]"}], "[", 
    RowBox[{"f_", ",", "g_"}], "]"}], "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{"Convolute", "[", "ord", "]"}], "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Derivative", "[", 
      RowBox[{"Apply", "[", 
       RowBox[{"Sequence", ",", 
        RowBox[{"Part", "[", "\n", "            ", 
         RowBox[{
          RowBox[{"PadRight", "[", 
           RowBox[{
            RowBox[{"{", "n", "}"}], ",", 
            RowBox[{"Length", "[", 
             RowBox[{"{", "ord", "}"}], "]"}], ",", "0"}], "]"}], ",", "\n", 
          "            ", 
          RowBox[{"First", "[", 
           RowBox[{"Transpose", "[", 
            RowBox[{"{", "ord", "}"}], "]"}], "]"}]}], "\n", "            ", 
         "]"}]}], "\n", "          ", "]"}], "\n", "        ", "]"}], "[", 
     "f", "]"}], ",", "\n", "    ", "g"}], "\n", "    ", "]"}], 
  " "}]], "PackageInput",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Default", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Convolve", "[", 
    RowBox[{"f_", ",", "g_", ",", "t_List", ",", "x_List"}], "]"}], " ", ":=",
    "\n", "  ", 
   RowBox[{
    RowBox[{"Module", "[", "\n", "      ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"F", ",", "G", ",", "fg", ",", 
        RowBox[{"\[Omega]", " ", "=", " ", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Unique", "[", "\[Omega]", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"Length", "[", "t", "]"}], "}"}]}], "]"}]}]}], "}"}], ",",
       "\n", "      ", 
      RowBox[{
       RowBox[{"Simplify", "[", 
        RowBox[{"fg", ",", 
         RowBox[{"x", "\[Element]", "Reals"}]}], "]"}], "/;", " ", "\n", 
       "        ", 
       RowBox[{
        RowBox[{"FreeQ", "[", 
         RowBox[{
          RowBox[{"F", "=", " ", 
           RowBox[{"FourierTransform", "[", 
            RowBox[{"f", ",", "t", ",", "\[Omega]"}], "]"}]}], ",", 
          "FourierTransform"}], "]"}], " ", "\[And]", " ", "\n", "          ", 
        RowBox[{"FreeQ", "[", 
         RowBox[{
          RowBox[{"G", "=", " ", 
           RowBox[{"FourierTransform", "[", 
            RowBox[{"g", ",", "t", ",", "\[Omega]"}], "]"}]}], ",", 
          "FourierTransform"}], "]"}], " ", "\[And]", " ", "\n", "          ", 
        RowBox[{"FreeQ", "[", 
         RowBox[{
          RowBox[{"fg", "=", 
           RowBox[{"InverseFourierTransform", "[", 
            RowBox[{
             RowBox[{"Simplify", "[", 
              RowBox[{
               RowBox[{"F", " ", "*", " ", "G"}], ",", 
               RowBox[{"\[Omega]", "\[Element]", "Reals"}]}], "]"}], ",", 
             "\[Omega]", ",", "x"}], "]"}]}], ",", "\n", "            ", 
          "InverseFourierTransform"}], "]"}]}]}]}], "\n", "      ", "]"}], "/;",
     " ", 
    RowBox[{
     RowBox[{"Length", "[", "t", "]"}], "===", " ", 
     RowBox[{"Length", "[", "x", "]"}]}]}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Convolve", "[", 
   RowBox[{"f_", ",", "g_", ",", "t_", ",", "x_"}], "]"}], " ", ":=", "\n", 
  "  ", 
  RowBox[{"Module", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"F", ",", "G", ",", "fg", ",", "\[Omega]"}], "}"}], ",", "\n", 
    "    ", 
    RowBox[{
     RowBox[{"Simplify", "[", 
      RowBox[{"fg", ",", 
       RowBox[{"x", "\[Element]", "Reals"}]}], "]"}], "/;", " ", "\n", 
     "      ", 
     RowBox[{
      RowBox[{"FreeQ", "[", 
       RowBox[{
        RowBox[{"F", "=", " ", 
         RowBox[{"FourierTransform", "[", 
          RowBox[{"f", ",", "t", ",", "\[Omega]"}], "]"}]}], ",", 
        "FourierTransform"}], "]"}], " ", "\[And]", " ", "\n", "        ", 
      RowBox[{"FreeQ", "[", 
       RowBox[{
        RowBox[{"G", "=", " ", 
         RowBox[{"FourierTransform", "[", 
          RowBox[{"g", ",", "t", ",", "\[Omega]"}], "]"}]}], ",", 
        "FourierTransform"}], "]"}], " ", "\[And]", " ", "\n", "        ", 
      RowBox[{"FreeQ", "[", 
       RowBox[{
        RowBox[{"fg", "=", "  ", 
         RowBox[{"InverseFourierTransform", "[", 
          RowBox[{
           RowBox[{"Simplify", "[", 
            RowBox[{
             RowBox[{"F", " ", "*", " ", "G"}], ",", 
             RowBox[{"\[Omega]", "\[Element]", "Reals"}]}], "]"}], ",", 
           "\[Omega]", ",", "x"}], "]"}]}], ",", "\n", "          ", 
        "InverseFourierTransform"}], "]"}]}]}]}], "\n", "    ", 
   "]"}]}]}], "PackageInput",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Convolute", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Convolve", "[", 
    RowBox[{"f_", ",", "g_", ",", "t_", ",", "x_"}], "]"}], " ", ":=", " ", 
   "\n", "  ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Convolute", "[", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], "]"}], "[", 
      RowBox[{"f", ",", "g"}], "]"}], "[", "x", "]"}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{"f", ",", 
       RowBox[{"func_", "[", "t", "]"}]}], "]"}], " ", "&&", " ", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"g", ",", 
       RowBox[{"func_", "[", "t", "]"}]}], "]"}]}]}]}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"Convolve", "[", 
   RowBox[{"f_", ",", "g_", ",", 
    RowBox[{"{", "t__", "}"}], ",", 
    RowBox[{"{", "x__", "}"}]}], "]"}], " ", ":=", " ", "\n", "  ", 
  RowBox[{
   RowBox[{"Apply", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Convolute", "[", "##", "]"}], "[", 
        RowBox[{"f", ",", "g"}], "]"}], "[", "x", "]"}], "&"}], ",", "\n", 
     "      ", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Ordering", "[", 
         RowBox[{"Ordering", "[", 
          RowBox[{
           RowBox[{"{", "t", "}"}], "[", 
           RowBox[{"[", 
            RowBox[{"Ordering", "[", 
             RowBox[{"{", "tf", "}"}], "]"}], "]"}], "]"}], "]"}], "]"}], ",",
         "\n", "          ", 
        RowBox[{"Ordering", "[", 
         RowBox[{"Ordering", "[", 
          RowBox[{
           RowBox[{"{", "t", "}"}], "[", 
           RowBox[{"[", 
            RowBox[{"Ordering", "[", 
             RowBox[{"{", "tg", "}"}], "]"}], "]"}], "]"}], "]"}], "]"}]}], 
       "}"}], "]"}]}], "]"}], "/;", "\n", "    ", 
   RowBox[{
    RowBox[{"MatchQ", "[", 
     RowBox[{"f", ",", 
      RowBox[{"func_", "[", 
       RowBox[{"__", "?", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Sort", "[", 
            RowBox[{"{", "##", "}"}], "]"}], "===", 
           RowBox[{"Sort", "[", 
            RowBox[{"{", "t", "}"}], "]"}]}], "&"}], ")"}]}], "]"}]}], "]"}], 
    " ", "&&", " ", "\n", "      ", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"g", ",", 
      RowBox[{"func_", "[", 
       RowBox[{"__", "?", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Sort", "[", 
            RowBox[{"{", "##", "}"}], "]"}], "===", 
           RowBox[{"Sort", "[", 
            RowBox[{"{", "t", "}"}], "]"}]}], "&"}], ")"}]}], "]"}]}], 
     "]"}]}]}]}]}], "PackageInput",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Notation", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"IndexRangeQ", "[", "n_Integer", "]"}], "[", "x_", "]"}], " ", ":=",
   " ", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{"And", "[", 
     RowBox[{
      RowBox[{"IntegerQ", "[", "#", "]"}], ",", 
      RowBox[{"Positive", "[", "#", "]"}], ",", 
      RowBox[{"#", "\[LessEqual]", "n"}]}], "]"}], "&"}], "[", 
   RowBox[{"ToExpression", "[", "x", "]"}], "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"1", "-", "dimensional"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeExpression", "[", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{
      "lhs___", ",", "f_", ",", "\"\<\[Star]\>\"", ",", "g_", ",", "rhs___"}],
       "}"}], "]"}], ",", "StandardForm"}], "]"}], ":=", "\n", "  ", 
  RowBox[{"MakeExpression", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"lhs", ",", "\n", "        ", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"RowBox", "[", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Convolute\>\"", ",", "\"\<[\>\"", ",", "\n", 
             "                ", 
             RowBox[{"RowBox", "[", 
              RowBox[{"{", 
               RowBox[{"\"\<{\>\"", ",", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<1\>\"", ",", "\"\<,\>\"", ",", "\"\<1\>\""}], 
                  "}"}], "]"}], ",", "\"\<}\>\""}], "}"}], "]"}], ",", 
             "\"\<]\>\""}], "}"}], "]"}], ",", "\"\<[\>\"", ",", "\n", 
          "            ", 
          RowBox[{"RowBox", "[", 
           RowBox[{"{", 
            RowBox[{"f", ",", "\"\<,\>\"", ",", "g"}], "}"}], "]"}], ",", 
          "\"\<]\>\""}], "}"}], "]"}], ",", "rhs"}], "}"}], "]"}], ",", 
    "StandardForm"}], "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeBoxes", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Convolute", "[", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "]"}], "[", 
     RowBox[{"f_", ",", "g_"}], "]"}], ",", "StandardForm"}], "]"}], ":=", 
  "\n", "  ", 
  RowBox[{"RowBox", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Parenthesize", "[", 
      RowBox[{"f", ",", "StandardForm", ",", "Star"}], "]"}], ",", 
     "\"\<\[Star]\>\"", ",", "\n", "      ", 
     RowBox[{"Parenthesize", "[", 
      RowBox[{"g", ",", "StandardForm", ",", "Star"}], "]"}]}], "}"}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeExpression", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"lhs___", ",", "f_", ",", 
       RowBox[{"OverscriptBox", "[", 
        RowBox[{"\"\<\[Star]\>\"", ",", 
         RowBox[{"RowBox", "[", 
          RowBox[{"{", 
           RowBox[{"\"\<(\>\"", ",", "\"\<1\>\"", ",", "\"\<)\>\""}], "}"}], 
          "]"}]}], "]"}], ",", "g_", ",", "\n", "        ", "rhs___"}], "}"}],
      "]"}], ",", "StandardForm"}], "]"}], ":=", "\n", "  ", 
  RowBox[{"MakeExpression", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"lhs", ",", "\n", "        ", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"RowBox", "[", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Convolute\>\"", ",", "\"\<[\>\"", ",", "\n", 
             "                ", 
             RowBox[{"RowBox", "[", 
              RowBox[{"{", 
               RowBox[{"\"\<{\>\"", ",", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<1\>\"", ",", "\"\<,\>\"", ",", "\"\<1\>\""}], 
                  "}"}], "]"}], ",", "\"\<}\>\""}], "}"}], "]"}], ",", 
             "\"\<]\>\""}], "}"}], "]"}], ",", "\"\<[\>\"", ",", "\n", 
          "            ", 
          RowBox[{"RowBox", "[", 
           RowBox[{"{", 
            RowBox[{"f", ",", "\"\<,\>\"", ",", "g"}], "}"}], "]"}], ",", 
          "\"\<]\>\""}], "}"}], "]"}], ",", "rhs"}], "}"}], "]"}], ",", 
    "StandardForm"}], "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeExpression", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"lhs___", ",", "f_", ",", "\n", "        ", 
       RowBox[{"OverscriptBox", "[", 
        RowBox[{"\"\<\[Star]\>\"", ",", "\n", "          ", 
         RowBox[{"RowBox", "[", 
          RowBox[{"{", 
           RowBox[{"\"\<(\>\"", ",", 
            RowBox[{"RowBox", "[", 
             RowBox[{"{", 
              RowBox[{
              "\"\<1\>\"", ",", "\"\<\[LeftRightArrow]\>\"", ",", 
               "\"\<1\>\""}], "}"}], "]"}], ",", "\"\<)\>\""}], "}"}], 
          "]"}]}], "]"}], ",", "g_", ",", "\n", "        ", "rhs___"}], "}"}],
      "]"}], ",", "StandardForm"}], "]"}], ":=", "\n", "  ", 
  RowBox[{"MakeExpression", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"lhs", ",", "\n", "        ", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"RowBox", "[", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Convolute\>\"", ",", "\"\<[\>\"", ",", "\n", 
             "                ", 
             RowBox[{"RowBox", "[", 
              RowBox[{"{", 
               RowBox[{"\"\<{\>\"", ",", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<1\>\"", ",", "\"\<,\>\"", ",", "\"\<1\>\""}], 
                  "}"}], "]"}], ",", "\"\<}\>\""}], "}"}], "]"}], ",", 
             "\"\<]\>\""}], "}"}], "]"}], ",", "\"\<[\>\"", ",", "\n", 
          "            ", 
          RowBox[{"RowBox", "[", 
           RowBox[{"{", 
            RowBox[{"f", ",", "\"\<,\>\"", ",", "g"}], "}"}], "]"}], ",", 
          "\"\<]\>\""}], "}"}], "]"}], ",", "rhs"}], "}"}], "]"}], ",", 
    "StandardForm"}], "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"2", "-", "dimensional"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeExpression", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"lhs___", ",", "f_", ",", 
       RowBox[{"OverscriptBox", "[", 
        RowBox[{"\"\<\[Star]\>\"", ",", 
         RowBox[{"RowBox", "[", 
          RowBox[{"{", 
           RowBox[{"\"\<(\>\"", ",", "\"\<2\>\"", ",", "\"\<)\>\""}], "}"}], 
          "]"}]}], "]"}], ",", "g_", ",", "\n", "        ", "rhs___"}], "}"}],
      "]"}], ",", "StandardForm"}], "]"}], ":=", "\n", "  ", 
  RowBox[{"MakeExpression", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"lhs", ",", "\n", "        ", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"RowBox", "[", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Convolute\>\"", ",", "\"\<[\>\"", ",", "\n", 
             "                ", 
             RowBox[{"RowBox", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<{\>\"", ",", 
                   RowBox[{"RowBox", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<1\>\"", ",", "\"\<,\>\"", ",", "\"\<1\>\""}],
                     "}"}], "]"}], ",", "\"\<}\>\""}], "}"}], "]"}], ",", 
                "\"\<,\>\"", ",", "\n", "                    ", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<{\>\"", ",", 
                   RowBox[{"RowBox", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<2\>\"", ",", "\"\<,\>\"", ",", "\"\<2\>\""}],
                     "}"}], "]"}], ",", "\"\<}\>\""}], "}"}], "]"}]}], "}"}], 
              "]"}], ",", "\"\<]\>\""}], "}"}], "]"}], ",", "\"\<[\>\"", ",", 
          "\n", "            ", 
          RowBox[{"RowBox", "[", 
           RowBox[{"{", 
            RowBox[{"f", ",", "\"\<,\>\"", ",", "g"}], "}"}], "]"}], ",", 
          "\"\<]\>\""}], "}"}], "]"}], ",", "rhs"}], "}"}], "]"}], ",", 
    "StandardForm"}], "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeBoxes", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Convolute", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "2"}], "}"}]}], "]"}], "[", 
     RowBox[{"f_", ",", "g_"}], "]"}], ",", "StandardForm"}], "]"}], ":=", 
  "\n", "  ", 
  RowBox[{"RowBox", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Parenthesize", "[", 
      RowBox[{"f", ",", "StandardForm", ",", "Star"}], "]"}], ",", "\n", 
     "      ", 
     RowBox[{"OverscriptBox", "[", 
      RowBox[{"\"\<\[Star]\>\"", ",", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{"\"\<(\>\"", ",", "\"\<2\>\"", ",", "\"\<)\>\""}], "}"}], 
        "]"}]}], "]"}], ",", "\n", "      ", 
     RowBox[{"Parenthesize", "[", 
      RowBox[{"g", ",", "StandardForm", ",", "Star"}], "]"}]}], "}"}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeExpression", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"lhs___", ",", "f_", ",", "\n", "        ", 
       RowBox[{"OverscriptBox", "[", 
        RowBox[{"\"\<\[Star]\>\"", ",", "\n", "          ", 
         RowBox[{"RowBox", "[", 
          RowBox[{"{", 
           RowBox[{"\"\<(\>\"", ",", "\n", "              ", 
            RowBox[{"GridBox", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"sf1_", "?", 
                    RowBox[{"(", 
                    RowBox[{"IndexRangeQ", "[", "2", "]"}], ")"}]}], ",", 
                   "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                   "                        ", 
                   RowBox[{"sg1_", "?", 
                    RowBox[{"(", 
                    RowBox[{"IndexRangeQ", "[", "2", "]"}], ")"}]}]}], "}"}], 
                 "]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"sf2_", "?", 
                    RowBox[{"(", 
                    RowBox[{
                    "IndexRangeQ", "[", "\n", 
                    "                              ", "2", "]"}], ")"}]}], 
                   ",", "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                   "                        ", 
                   RowBox[{"sg2_", "?", 
                    RowBox[{"(", 
                    RowBox[{"IndexRangeQ", "[", "2", "]"}], ")"}]}]}], "}"}], 
                 "]"}], "}"}]}], "}"}], "]"}], ",", "\"\<)\>\""}], "}"}], 
          "]"}]}], "]"}], ",", "g_", ",", "rhs___"}], "}"}], "]"}], ",", "\n",
     "    ", "StandardForm"}], "]"}], ":=", "\n", "  ", 
  RowBox[{"MakeExpression", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"lhs", ",", "\n", "        ", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"RowBox", "[", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Convolute\>\"", ",", "\"\<[\>\"", ",", "\n", 
             "                ", 
             RowBox[{"RowBox", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<{\>\"", ",", 
                   RowBox[{"RowBox", "[", 
                    RowBox[{"{", 
                    RowBox[{"sf1", ",", "\"\<,\>\"", ",", "sg1"}], "}"}], 
                    "]"}], ",", "\"\<}\>\""}], "}"}], "]"}], ",", "\"\<,\>\"",
                 ",", "\n", "                    ", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<{\>\"", ",", 
                   RowBox[{"RowBox", "[", 
                    RowBox[{"{", 
                    RowBox[{"sf2", ",", "\"\<,\>\"", ",", "sg2"}], "}"}], 
                    "]"}], ",", "\"\<}\>\""}], "}"}], "]"}]}], "}"}], "]"}], 
             ",", "\"\<]\>\""}], "}"}], "]"}], ",", "\"\<[\>\"", ",", "\n", 
          "            ", 
          RowBox[{"RowBox", "[", 
           RowBox[{"{", 
            RowBox[{"f", ",", "\"\<,\>\"", ",", "g"}], "}"}], "]"}], ",", 
          "\"\<]\>\""}], "}"}], "]"}], ",", "rhs"}], "}"}], "]"}], ",", 
    "StandardForm"}], "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeBoxes", "[", "\n", "    ", 
   RowBox[{
    RowBox[{
     RowBox[{"Convolute", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"sf1_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "2", "]"}], ")"}]}], ",", "\n", 
         "          ", 
         RowBox[{"sg1_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "2", "]"}], ")"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"sf2_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "2", "]"}], ")"}]}], ",", "\n", 
         "          ", 
         RowBox[{"sg2_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "2", "]"}], ")"}]}]}], "}"}]}], "]"}], 
     "[", 
     RowBox[{"f_", ",", "g_"}], "]"}], ",", "StandardForm"}], "]"}], ":=", 
  "\n", "  ", 
  RowBox[{"RowBox", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Parenthesize", "[", 
      RowBox[{"f", ",", "StandardForm", ",", "Star"}], "]"}], ",", "\n", 
     "      ", 
     RowBox[{"OverscriptBox", "[", 
      RowBox[{"\"\<\[Star]\>\"", ",", "\n", "        ", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{"\"\<(\>\"", ",", "\n", "            ", 
          RowBox[{"GridBox", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"RowBox", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{"sf1", ",", "StandardForm", ",", "LeftRightArrow"}],
                   "]"}], ",", "\n", "                      ", 
                 "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                 "                      ", 
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{
                  "sg1", ",", "StandardForm", ",", "\n", 
                   "                        ", "LeftRightArrow"}], "]"}]}], 
                "}"}], "]"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"RowBox", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{
                  "sf2", ",", "\n", "                        ", 
                   "StandardForm", ",", "LeftRightArrow"}], "]"}], ",", 
                 "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                 "                      ", 
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{"sg2", ",", "StandardForm", ",", "LeftRightArrow"}],
                   "]"}]}], "}"}], "]"}], "}"}]}], "}"}], "]"}], ",", "\n", 
          "            ", "\"\<)\>\""}], "}"}], "]"}]}], "]"}], ",", 
     RowBox[{"Parenthesize", "[", 
      RowBox[{"g", ",", "StandardForm", ",", "Star"}], "]"}]}], "}"}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"3", "-", "dimensional"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeBoxes", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Convolute", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "3"}], "}"}]}], "]"}], "[", 
     RowBox[{"f_", ",", "g_"}], "]"}], ",", "StandardForm"}], "]"}], ":=", 
  "\n", "  ", 
  RowBox[{"RowBox", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Parenthesize", "[", 
      RowBox[{"f", ",", "StandardForm", ",", "Star"}], "]"}], ",", "\n", 
     "      ", 
     RowBox[{"OverscriptBox", "[", 
      RowBox[{"\"\<\[Star]\>\"", ",", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{"\"\<(\>\"", ",", "\"\<3\>\"", ",", "\"\<)\>\""}], "}"}], 
        "]"}]}], "]"}], ",", "\n", "      ", 
     RowBox[{"Parenthesize", "[", 
      RowBox[{"g", ",", "StandardForm", ",", "Star"}], "]"}]}], "}"}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeExpression", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"lhs___", ",", "f_", ",", "\n", "        ", 
       RowBox[{"OverscriptBox", "[", 
        RowBox[{"\"\<\[Star]\>\"", ",", "\n", "          ", 
         RowBox[{"RowBox", "[", 
          RowBox[{"{", 
           RowBox[{"\"\<(\>\"", ",", "\n", "              ", 
            RowBox[{"GridBox", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"sf1_", "?", 
                    RowBox[{"(", 
                    RowBox[{"IndexRangeQ", "[", "3", "]"}], ")"}]}], ",", 
                   "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                   "                        ", 
                   RowBox[{"sg1_", "?", 
                    RowBox[{"(", 
                    RowBox[{"IndexRangeQ", "[", "3", "]"}], ")"}]}]}], "}"}], 
                 "]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"sf2_", "?", 
                    RowBox[{"(", 
                    RowBox[{
                    "IndexRangeQ", "[", "\n", 
                    "                              ", "3", "]"}], ")"}]}], 
                   ",", "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                   "                        ", 
                   RowBox[{"sg2_", "?", 
                    RowBox[{"(", 
                    RowBox[{"IndexRangeQ", "[", "3", "]"}], ")"}]}]}], "}"}], 
                 "]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"sf3_", "?", 
                    RowBox[{"(", 
                    RowBox[{
                    "IndexRangeQ", "[", "\n", 
                    "                              ", "3", "]"}], ")"}]}], 
                   ",", "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                   "                        ", 
                   RowBox[{"sg3_", "?", 
                    RowBox[{"(", 
                    RowBox[{"IndexRangeQ", "[", "3", "]"}], ")"}]}]}], "}"}], 
                 "]"}], "}"}]}], "}"}], "]"}], ",", "\"\<)\>\""}], "}"}], 
          "]"}]}], "]"}], ",", "g_", ",", "rhs___"}], "}"}], "]"}], ",", "\n",
     "    ", "StandardForm"}], "]"}], ":=", "\n", "  ", 
  RowBox[{"MakeExpression", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"lhs", ",", "\n", "        ", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"RowBox", "[", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Convolute\>\"", ",", "\"\<[\>\"", ",", "\n", 
             "                ", 
             RowBox[{"RowBox", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<{\>\"", ",", 
                   RowBox[{"RowBox", "[", 
                    RowBox[{"{", 
                    RowBox[{"sf1", ",", "\"\<,\>\"", ",", "sg1"}], "}"}], 
                    "]"}], ",", "\"\<}\>\""}], "}"}], "]"}], ",", "\"\<,\>\"",
                 ",", "\n", "                    ", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<{\>\"", ",", 
                   RowBox[{"RowBox", "[", 
                    RowBox[{"{", 
                    RowBox[{"sf2", ",", "\"\<,\>\"", ",", "sg2"}], "}"}], 
                    "]"}], ",", "\"\<}\>\""}], "}"}], "]"}], ",", "\"\<,\>\"",
                 ",", "\n", "                    ", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<{\>\"", ",", 
                   RowBox[{"RowBox", "[", 
                    RowBox[{"{", 
                    RowBox[{"sf3", ",", "\"\<,\>\"", ",", "sg3"}], "}"}], 
                    "]"}], ",", "\"\<}\>\""}], "}"}], "]"}]}], "}"}], "]"}], 
             ",", "\"\<]\>\""}], "}"}], "]"}], ",", "\"\<[\>\"", ",", "\n", 
          "            ", 
          RowBox[{"RowBox", "[", 
           RowBox[{"{", 
            RowBox[{"f", ",", "\"\<,\>\"", ",", "g"}], "}"}], "]"}], ",", 
          "\"\<]\>\""}], "}"}], "]"}], ",", "rhs"}], "}"}], "]"}], ",", 
    "StandardForm"}], "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeBoxes", "[", "\n", "    ", 
   RowBox[{
    RowBox[{
     RowBox[{"Convolute", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"sf1_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "3", "]"}], ")"}]}], ",", "\n", 
         "          ", 
         RowBox[{"sg1_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "3", "]"}], ")"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"sf2_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "3", "]"}], ")"}]}], ",", "\n", 
         "          ", 
         RowBox[{"sg2_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "3", "]"}], ")"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"sf3_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "3", "]"}], ")"}]}], ",", "\n", 
         "          ", 
         RowBox[{"sg3_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "3", "]"}], ")"}]}]}], "}"}]}], "]"}], 
     "[", 
     RowBox[{"f_", ",", "g_"}], "]"}], ",", "StandardForm"}], "]"}], ":=", 
  "\n", "  ", 
  RowBox[{"RowBox", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Parenthesize", "[", 
      RowBox[{"f", ",", "StandardForm", ",", "Star"}], "]"}], ",", "\n", 
     "      ", 
     RowBox[{"OverscriptBox", "[", 
      RowBox[{"\"\<\[Star]\>\"", ",", "\n", "        ", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{"\"\<(\>\"", ",", "\n", "            ", 
          RowBox[{"GridBox", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"RowBox", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{"sf1", ",", "StandardForm", ",", "LeftRightArrow"}],
                   "]"}], ",", "\n", "                      ", 
                 "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                 "                      ", 
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{
                  "sg1", ",", "StandardForm", ",", "\n", 
                   "                        ", "LeftRightArrow"}], "]"}]}], 
                "}"}], "]"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"RowBox", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{
                  "sf2", ",", "\n", "                        ", 
                   "StandardForm", ",", "LeftRightArrow"}], "]"}], ",", 
                 "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                 "                      ", 
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{
                  "sg2", ",", "StandardForm", ",", "\n", 
                   "                        ", "LeftRightArrow"}], "]"}]}], 
                "}"}], "]"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"RowBox", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{
                  "sf3", ",", "\n", "                        ", 
                   "StandardForm", ",", "LeftRightArrow"}], "]"}], ",", 
                 "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                 "                      ", 
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{"sg3", ",", "StandardForm", ",", "LeftRightArrow"}],
                   "]"}]}], "}"}], "]"}], "}"}]}], "}"}], "]"}], ",", "\n", 
          "            ", "\"\<)\>\""}], "}"}], "]"}]}], "]"}], ",", 
     RowBox[{"Parenthesize", "[", 
      RowBox[{"g", ",", "StandardForm", ",", "Star"}], "]"}]}], "}"}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"4", "-", "dimensional"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeExpression", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"lhs___", ",", "f_", ",", 
       RowBox[{"OverscriptBox", "[", 
        RowBox[{"\"\<\[Star]\>\"", ",", 
         RowBox[{"RowBox", "[", 
          RowBox[{"{", 
           RowBox[{"\"\<(\>\"", ",", "\"\<4\>\"", ",", "\"\<)\>\""}], "}"}], 
          "]"}]}], "]"}], ",", "g_", ",", "\n", "        ", "rhs___"}], "}"}],
      "]"}], ",", "StandardForm"}], "]"}], ":=", "\n", "  ", 
  RowBox[{"MakeExpression", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"lhs", ",", "\n", "        ", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"RowBox", "[", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Convolute\>\"", ",", "\"\<[\>\"", ",", "\n", 
             "                ", 
             RowBox[{"RowBox", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<{\>\"", ",", 
                   RowBox[{"RowBox", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<1\>\"", ",", "\"\<,\>\"", ",", "\"\<1\>\""}],
                     "}"}], "]"}], ",", "\"\<}\>\""}], "}"}], "]"}], ",", 
                "\"\<,\>\"", ",", "\n", "                    ", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<{\>\"", ",", 
                   RowBox[{"RowBox", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<2\>\"", ",", "\"\<,\>\"", ",", "\"\<2\>\""}],
                     "}"}], "]"}], ",", "\"\<}\>\""}], "}"}], "]"}], ",", 
                "\"\<,\>\"", ",", "\n", "                    ", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<{\>\"", ",", 
                   RowBox[{"RowBox", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<3\>\"", ",", "\"\<,\>\"", ",", "\"\<3\>\""}],
                     "}"}], "]"}], ",", "\"\<}\>\""}], "}"}], "]"}], ",", 
                "\"\<,\>\"", ",", "\n", "                    ", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<{\>\"", ",", 
                   RowBox[{"RowBox", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<4\>\"", ",", "\"\<,\>\"", ",", "\"\<4\>\""}],
                     "}"}], "]"}], ",", "\"\<}\>\""}], "}"}], "]"}]}], "}"}], 
              "]"}], ",", "\"\<]\>\""}], "}"}], "]"}], ",", "\"\<[\>\"", ",", 
          "\n", "            ", 
          RowBox[{"RowBox", "[", 
           RowBox[{"{", 
            RowBox[{"f", ",", "\"\<,\>\"", ",", "g"}], "}"}], "]"}], ",", 
          "\"\<]\>\""}], "}"}], "]"}], ",", "rhs"}], "}"}], "]"}], ",", 
    "StandardForm"}], "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeBoxes", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Convolute", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"4", ",", "4"}], "}"}]}], "]"}], "[", 
     RowBox[{"f_", ",", "g_"}], "]"}], ",", "StandardForm"}], "]"}], ":=", 
  "\n", "  ", 
  RowBox[{"RowBox", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Parenthesize", "[", 
      RowBox[{"f", ",", "StandardForm", ",", "Star"}], "]"}], ",", "\n", 
     "      ", 
     RowBox[{"OverscriptBox", "[", 
      RowBox[{"\"\<\[Star]\>\"", ",", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{"\"\<(\>\"", ",", "\"\<4\>\"", ",", "\"\<)\>\""}], "}"}], 
        "]"}]}], "]"}], ",", "\n", "      ", 
     RowBox[{"Parenthesize", "[", 
      RowBox[{"g", ",", "StandardForm", ",", "Star"}], "]"}]}], "}"}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeExpression", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"lhs___", ",", "f_", ",", "\n", "        ", 
       RowBox[{"OverscriptBox", "[", 
        RowBox[{"\"\<\[Star]\>\"", ",", "\n", "          ", 
         RowBox[{"RowBox", "[", 
          RowBox[{"{", 
           RowBox[{"\"\<(\>\"", ",", "\n", "              ", 
            RowBox[{"GridBox", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"sf1_", "?", 
                    RowBox[{"(", 
                    RowBox[{"IndexRangeQ", "[", "4", "]"}], ")"}]}], ",", 
                   "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                   "                        ", 
                   RowBox[{"sg1_", "?", 
                    RowBox[{"(", 
                    RowBox[{"IndexRangeQ", "[", "4", "]"}], ")"}]}]}], "}"}], 
                 "]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"sf2_", "?", 
                    RowBox[{"(", 
                    RowBox[{
                    "IndexRangeQ", "[", "\n", 
                    "                              ", "4", "]"}], ")"}]}], 
                   ",", "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                   "                        ", 
                   RowBox[{"sg2_", "?", 
                    RowBox[{"(", 
                    RowBox[{"IndexRangeQ", "[", "4", "]"}], ")"}]}]}], "}"}], 
                 "]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"sf3_", "?", 
                    RowBox[{"(", 
                    RowBox[{
                    "IndexRangeQ", "[", "\n", 
                    "                              ", "4", "]"}], ")"}]}], 
                   ",", "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                   "                        ", 
                   RowBox[{"sg3_", "?", 
                    RowBox[{"(", 
                    RowBox[{"IndexRangeQ", "[", "4", "]"}], ")"}]}]}], "}"}], 
                 "]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"sf4_", "?", 
                    RowBox[{"(", 
                    RowBox[{
                    "IndexRangeQ", "[", "\n", 
                    "                              ", "4", "]"}], ")"}]}], 
                   ",", "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                   "                        ", 
                   RowBox[{"sg4_", "?", 
                    RowBox[{"(", 
                    RowBox[{"IndexRangeQ", "[", "4", "]"}], ")"}]}]}], "}"}], 
                 "]"}], "}"}]}], "}"}], "]"}], ",", "\"\<)\>\""}], "}"}], 
          "]"}]}], "]"}], ",", "g_", ",", "rhs___"}], "}"}], "]"}], ",", "\n",
     "    ", "StandardForm"}], "]"}], ":=", "\n", "  ", 
  RowBox[{"MakeExpression", "[", "\n", "    ", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", 
      RowBox[{"lhs", ",", "\n", "        ", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"RowBox", "[", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Convolute\>\"", ",", "\"\<[\>\"", ",", "\n", 
             "                ", 
             RowBox[{"RowBox", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<{\>\"", ",", 
                   RowBox[{"RowBox", "[", 
                    RowBox[{"{", 
                    RowBox[{"sf1", ",", "\"\<,\>\"", ",", "sg1"}], "}"}], 
                    "]"}], ",", "\"\<}\>\""}], "}"}], "]"}], ",", "\"\<,\>\"",
                 ",", "\n", "                    ", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<{\>\"", ",", 
                   RowBox[{"RowBox", "[", 
                    RowBox[{"{", 
                    RowBox[{"sf2", ",", "\"\<,\>\"", ",", "sg2"}], "}"}], 
                    "]"}], ",", "\"\<}\>\""}], "}"}], "]"}], ",", "\"\<,\>\"",
                 ",", "\n", "                    ", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<{\>\"", ",", 
                   RowBox[{"RowBox", "[", 
                    RowBox[{"{", 
                    RowBox[{"sf3", ",", "\"\<,\>\"", ",", "sg3"}], "}"}], 
                    "]"}], ",", "\"\<}\>\""}], "}"}], "]"}], ",", "\"\<,\>\"",
                 ",", "\n", "                    ", 
                RowBox[{"RowBox", "[", 
                 RowBox[{"{", 
                  RowBox[{"\"\<{\>\"", ",", 
                   RowBox[{"RowBox", "[", 
                    RowBox[{"{", 
                    RowBox[{"sf4", ",", "\"\<,\>\"", ",", "sg4"}], "}"}], 
                    "]"}], ",", "\"\<}\>\""}], "}"}], "]"}]}], "}"}], "]"}], 
             ",", "\"\<]\>\""}], "}"}], "]"}], ",", "\"\<[\>\"", ",", "\n", 
          "            ", 
          RowBox[{"RowBox", "[", 
           RowBox[{"{", 
            RowBox[{"f", ",", "\"\<,\>\"", ",", "g"}], "}"}], "]"}], ",", 
          "\"\<]\>\""}], "}"}], "]"}], ",", "rhs"}], "}"}], "]"}], ",", 
    "StandardForm"}], "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeBoxes", "[", "\n", "    ", 
   RowBox[{
    RowBox[{
     RowBox[{"Convolute", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"sf1_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "4", "]"}], ")"}]}], ",", "\n", 
         "          ", 
         RowBox[{"sg1_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "4", "]"}], ")"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"sf2_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "4", "]"}], ")"}]}], ",", "\n", 
         "          ", 
         RowBox[{"sg2_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "4", "]"}], ")"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"sf3_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "4", "]"}], ")"}]}], ",", "\n", 
         "          ", 
         RowBox[{"sg3_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "4", "]"}], ")"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"sf4_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "4", "]"}], ")"}]}], ",", "\n", 
         "          ", 
         RowBox[{"sg4_", "?", 
          RowBox[{"(", 
           RowBox[{"IndexRangeQ", "[", "4", "]"}], ")"}]}]}], "}"}]}], "]"}], 
     "[", 
     RowBox[{"f_", ",", "g_"}], "]"}], ",", "StandardForm"}], "]"}], ":=", 
  "\n", "  ", 
  RowBox[{"RowBox", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Parenthesize", "[", 
      RowBox[{"f", ",", "StandardForm", ",", "Star"}], "]"}], ",", "\n", 
     "      ", 
     RowBox[{"OverscriptBox", "[", 
      RowBox[{"\"\<\[Star]\>\"", ",", "\n", "        ", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{"\"\<(\>\"", ",", "\n", "            ", 
          RowBox[{"GridBox", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"RowBox", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{"sf1", ",", "StandardForm", ",", "LeftRightArrow"}],
                   "]"}], ",", "\n", "                      ", 
                 "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                 "                      ", 
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{
                  "sg1", ",", "StandardForm", ",", "\n", 
                   "                        ", "LeftRightArrow"}], "]"}]}], 
                "}"}], "]"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"RowBox", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{
                  "sf2", ",", "\n", "                        ", 
                   "StandardForm", ",", "LeftRightArrow"}], "]"}], ",", 
                 "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                 "                      ", 
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{
                  "sg2", ",", "StandardForm", ",", "\n", 
                   "                        ", "LeftRightArrow"}], "]"}]}], 
                "}"}], "]"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"RowBox", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{
                  "sf3", ",", "\n", "                        ", 
                   "StandardForm", ",", "LeftRightArrow"}], "]"}], ",", 
                 "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                 "                      ", 
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{
                  "sg3", ",", "StandardForm", ",", "\n", 
                   "                        ", "LeftRightArrow"}], "]"}]}], 
                "}"}], "]"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"RowBox", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{
                  "sf4", ",", "\n", "                        ", 
                   "StandardForm", ",", "LeftRightArrow"}], "]"}], ",", 
                 "\"\<\[LeftRightArrow]\>\"", ",", "\n", 
                 "                      ", 
                 RowBox[{"Parenthesize", "[", 
                  RowBox[{"sg4", ",", "StandardForm", ",", "LeftRightArrow"}],
                   "]"}]}], "}"}], "]"}], "}"}]}], "}"}], "]"}], ",", "\n", 
          "            ", "\"\<)\>\""}], "}"}], "]"}]}], "]"}], ",", 
     RowBox[{"Parenthesize", "[", 
      RowBox[{"g", ",", "StandardForm", ",", "Star"}], "]"}]}], "}"}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"Protect", "[", "\[IndentingNewLine]", 
   RowBox[{
   "Convolve", ",", "\[IndentingNewLine]", "Convolute", ",", 
    "\[IndentingNewLine]", "GaussianKernel", ",", "\[IndentingNewLine]", 
    "GaussianDKernel"}], "\[IndentingNewLine]", "]"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{993, 706},
WindowMargins->{{15, Automatic}, {Automatic, 10}},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (November 10, 2008)",
StyleDefinitions->"PackageNotebook.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 25, 0, 144, "Title"],
Cell[595, 24, 166, 5, 118, "Subsubtitle"],
Cell[CellGroupData[{
Cell[786, 33, 25, 0, 72, "Section"],
Cell[814, 35, 128, 3, 70, "Text"],
Cell[945, 40, 3051, 84, 1233, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[4033, 129, 32, 0, 40, "Section"],
Cell[4068, 131, 92, 2, 70, "Text"],
Cell[4163, 135, 423, 10, 336, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[4623, 150, 42, 0, 40, "Section"],
Cell[4668, 152, 564, 12, 370, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5269, 169, 31, 0, 40, "Section"],
Cell[5303, 171, 60, 0, 39, "Text"],
Cell[5366, 173, 108, 2, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[5499, 179, 30, 0, 63, "Subsection"],
Cell[CellGroupData[{
Cell[5554, 183, 36, 0, 57, "Subsubsection"],
Cell[5593, 185, 136, 3, 60, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[5766, 193, 42, 0, 57, "Subsubsection"],
Cell[5811, 195, 313, 9, 62, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[6161, 209, 38, 0, 93, "Subsubsection"],
Cell[6202, 211, 568, 16, 129, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[6807, 232, 34, 0, 93, "Subsubsection"],
Cell[6844, 234, 832, 24, 129, "PackageInput",
 InitializationCell->True],
Cell[7679, 260, 1952, 60, 267, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[9668, 325, 37, 0, 93, "Subsubsection"],
Cell[9708, 327, 2961, 82, 1026, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[12706, 414, 43, 0, 93, "Subsubsection"],
Cell[12752, 416, 2430, 70, 439, "PackageInput",
 InitializationCell->True],
Cell[15185, 488, 3286, 93, 646, "PackageInput",
 InitializationCell->True],
Cell[18474, 583, 1080, 28, 370, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[19591, 616, 32, 0, 57, "Subsubsection"],
Cell[19626, 618, 3481, 90, 477, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[23144, 713, 34, 0, 57, "Subsubsection"],
Cell[23181, 715, 2588, 79, 250, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[25806, 799, 33, 0, 57, "Subsubsection"],
Cell[25842, 801, 456, 13, 85, "PackageInput",
 InitializationCell->True],
Cell[26301, 816, 59, 1, 36, "Input"],
Cell[26363, 819, 1389, 36, 177, "PackageInput",
 InitializationCell->True],
Cell[27755, 857, 640, 19, 108, "PackageInput",
 InitializationCell->True],
Cell[28398, 878, 1635, 41, 224, "PackageInput",
 InitializationCell->True],
Cell[30036, 921, 1858, 46, 271, "PackageInput",
 InitializationCell->True],
Cell[31897, 969, 59, 1, 36, "Input"],
Cell[31959, 972, 2172, 52, 247, "PackageInput",
 InitializationCell->True],
Cell[34134, 1026, 952, 28, 131, "PackageInput",
 InitializationCell->True],
Cell[35089, 1056, 3523, 83, 387, "PackageInput",
 InitializationCell->True],
Cell[38615, 1141, 2880, 73, 386, "PackageInput",
 InitializationCell->True],
Cell[41498, 1216, 59, 1, 36, "Input"],
Cell[41560, 1219, 1019, 30, 131, "PackageInput",
 InitializationCell->True],
Cell[42582, 1251, 4581, 106, 481, "PackageInput",
 InitializationCell->True],
Cell[47166, 1359, 3884, 97, 479, "PackageInput",
 InitializationCell->True],
Cell[51053, 1458, 59, 1, 36, "Input"],
Cell[51115, 1461, 2996, 68, 293, "PackageInput",
 InitializationCell->True],
Cell[54114, 1531, 1086, 32, 131, "PackageInput",
 InitializationCell->True],
Cell[55203, 1565, 5639, 129, 575, "PackageInput",
 InitializationCell->True],
Cell[60845, 1696, 4888, 121, 853, "PackageInput",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[65794, 1824, 34, 0, 40, "Section"],
Cell[65831, 1826, 64, 0, 70, "Text"],
Cell[65898, 1828, 463, 11, 405, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

