(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     86695,       2210]
NotebookOptionsPosition[     83291,       2106]
NotebookOutlinePosition[     83824,       2127]
CellTagsIndexPosition[     83781,       2124]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Display Functions", "Title"],

Cell["\<\
Markus van Almsick
Technische Universiteit Eindhoven
\[Copyright]2009\
\>", "Subsubtitle",
 CellChangeTimes->{{3.47014013701049*^9, 3.470140137472267*^9}}],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
     "TimeStamp", "[", "\"\<MathVisionTools`DisplayFunctions`\>\"", "]"}], 
     " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"2010", ",", "4", ",", "14", ",", "12", ",", "11", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput",
 CellChangeTimes->{{3.430048861129287*^9, 3.430048867337655*^9}, {
  3.4701401426707373`*^9, 3.470140150886137*^9}, {3.473165445168838*^9, 
  3.4731654523969793`*^9}, {3.47650707661055*^9, 3.476507090466752*^9}, {
  3.4828206615747004`*^9, 3.482820666121655*^9}, {3.4888722259024057`*^9, 
  3.488872226074719*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`DisplayFunctions`"}]}], " ", 
   "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Author", ":", " ", 
     RowBox[{"Markus", " ", "van", " ", "Almsick"}]}]}], "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"M", ".", "v", ".", 
       RowBox[{"Almsick", "@", "tue"}], ".", "nl"}]}]}]}], "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`DisplayFunctions`"}]}], 
   "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "1.3"}]}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "5.2"}]}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2009"}]}]}], ",", " ", 
    RowBox[{"Technische", " ", "Universiteit", " ", "Eindhoven"}]}], "*)"}], 
  "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "DisplayFunctions"}]}], " ", "*)"}], "\n", 
  "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "implements", " ", "several", " ", 
      "functions", " ", "to", " ", "display", " ", "image", " ", "data"}]}]}],
    " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", "plot"}]}], ",", " ", "display"}], " ", 
   "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", "  ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"May", " ", "2005"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":", " ", 
      RowBox[{"Dynamic", " ", "elements", " ", 
       RowBox[{"(", 
        RowBox[{"e", ".", "g", ".", " ", "PixelLabeling"}], ")"}], " ", "in", 
       " ", "version", " ", "6", " ", "are", " ", "currently", " ", 
       "disabled"}]}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.4701401553287287`*^9, 3.4701401654094877`*^9}, 
   3.473165460643483*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "BeginPackage", "[", "\"\<MathVisionTools`DisplayFunctions`\>\"", "]"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{"Unprotect", "[", "\n", "  ", 
  RowBox[{
  "ListLuminocityPlot", ",", "\[IndentingNewLine]", "RasterPlot", ",", 
   "\[IndentingNewLine]", "PixelLabeling", ",", "\[IndentingNewLine]", 
   "ListEllipsePlot", ",", "\[IndentingNewLine]", "ListEllipsoidPlot3D"}], 
  "\n", "  ", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ListLuminocityPlot", "::", "usage"}], " ", "=", " ", 
  "\"\<ListLuminocityPlot[img] is obsolete. ListLuminocityPlot has been \
superseded by RasterPlot.\>\""}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"RasterPlot", "::", "usage"}], " ", "=", " ", 
  "\"\<RasterPlot[img] displays a 2-dimensional array of real values or real \
value tuples as an image with corresponding luminosity or color. The larger \
values are displayed in brighter, the smaller in darker colors. Complex \
values are encoded by color. Their argument is given by hue and their \
absolute value by brightness and saturation. One can provide via the option \
ColorFunction other color encodings than GrayLevel and RGBColor. GrayLevel \
and RGBColor are applied automatically, if simple values or 3-tuples of pixel \
data are provided.\>\""}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PixelLabeling", "::", "usage"}], " ", "=", " ", 
   RowBox[{"If", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"$VersionNumber", "<", "6"}], ",", 
     "\"\<PixelLabeling is only available in Mathematica 6.0 or later.\>\"", 
     ",", "\"\<CURRENTLY DISABLED! PixelLabeling is an option of RasterPlot. \
If set to True a Tooltip is assigned to each pixel in the image displaying \
the location and value.\>\""}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Options", "[", "RasterPlot", "]"}], " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", "None"}], ",", 
    RowBox[{"AxesOrigin", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"AxesStyle", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"Background", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"ColorFunction", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}], ",", 
    RowBox[{"ColorOutput", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"DefaultColor", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"DataReversed", "\[Rule]", "False"}], ",", 
    RowBox[{"Epilog", "\[Rule]", 
     RowBox[{"{", "}"}]}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", "None"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"FrameTicks", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"GridLines", "\[Rule]", "None"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"PlotLabel", "\[Rule]", "None"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"PlotRegion", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"Prolog", "\[Rule]", 
     RowBox[{"{", "}"}]}], ",", 
    RowBox[{"RotateLabel", "\[Rule]", "True"}], ",", 
    RowBox[{"Ticks", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"DefaultFont", "\[RuleDelayed]", "$DefaultFont"}], ",", 
    RowBox[{"DisplayFunction", "\[RuleDelayed]", "$DisplayFunction"}], ",", 
    RowBox[{"FormatType", "\[RuleDelayed]", "$FormatType"}], ",", 
    RowBox[{"TextStyle", "\[RuleDelayed]", "$TextStyle"}]}], 
   "}"}]}]], "PackageInput",
 CellChangeTimes->{{3.445081533625499*^9, 3.445081553846263*^9}, {
  3.445099591999017*^9, 3.445099592534651*^9}, {3.445250808933426*^9, 
  3.445250809580307*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ListEllipsePlot", "::", "usage"}], " ", "=", " ", 
  "\"\<ListEllipsePlot[img] displays a 1- or 2-dimensional array of \
real-valued, positive-definite, symmetric 2\[Times]2 matrices as a field of \
ellipses. The length and orientation of the main ellipse axes reflect the \
eigenvalues and eigenvectors of the matrices. One can provide via the option \
ColorFunction other color encodings. The first 2 arguments of the \
ColorFunction are the 2 eigenvalues and the last argument is the orientation \
angle (-\[Pi]/2,\[Pi]/2) of the main eigenvector. The option ScaleFactor \
allows to change the overall size of the ellipses with respect to the field \
size.\>\""}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.409906135749034*^9, 3.409906136257309*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ListEllipsePlot", "]"}], " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ScaleFactor", " ", "\[Rule]", " ", "Automatic"}], ",", " ", 
     RowBox[{"ColorFunction", " ", "\[Rule]", " ", "Automatic"}], ",", 
     RowBox[{"DataReversed", "\[Rule]", "False"}]}], "}"}]}], 
  ";"}]], "PackageInput",
 CellChangeTimes->{{3.445081591606163*^9, 3.4450815938845577`*^9}, {
  3.4450996174978848`*^9, 3.4450996194237213`*^9}, {3.445099751321043*^9, 
  3.445099755541411*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ListEllipsoidPlot3D", "::", "usage"}], " ", "=", " ", 
  "\"\<ListEllipsoidPlot3D[img] displays a 1-,2-, or 3-dimensional array of \
real-valued,  positive-definite, symmetric 3\[Times]3 matrices as a field of \
ellipsoids. The length and orientation of the main ellipsoid axes reflect the \
eigenvalues and eigenvectors of the matrices. The option ScaleFactor allows \
to change the overall size of the ellipsoids with respect to the field \
extension.\>\""}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ListEllipsoidPlot3D", "]"}], " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"ScaleFactor", " ", "\[Rule]", " ", "Automatic"}], "}"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$VersionNumber", "<", "6"}], ",", 
    RowBox[{
     RowBox[{"Options", "[", "RasterPlot", "]"}], " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"Axes", "\[Rule]", "False"}], ",", 
       RowBox[{"AxesLabel", "\[Rule]", "None"}], ",", 
       RowBox[{"AxesOrigin", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"AxesStyle", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"Background", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"ColorFunction", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}], ",", 
       RowBox[{"ColorOutput", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"DefaultColor", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", "None"}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"FrameTicks", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"GridLines", "\[Rule]", "None"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"PlotLabel", "\[Rule]", "None"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"PlotRegion", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"Prolog", "\[Rule]", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"RotateLabel", "\[Rule]", "True"}], ",", 
       RowBox[{"Ticks", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"DefaultFont", "\[RuleDelayed]", "$DefaultFont"}], ",", 
       RowBox[{"DisplayFunction", "\[RuleDelayed]", "$DisplayFunction"}], ",", 
       RowBox[{"FormatType", "\[RuleDelayed]", "$FormatType"}], ",", 
       RowBox[{"TextStyle", "\[RuleDelayed]", "$TextStyle"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Options", "[", "RasterPlot", "]"}], " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"Axes", "\[Rule]", "False"}], ",", 
       RowBox[{"AxesLabel", "\[Rule]", "None"}], ",", 
       RowBox[{"AxesOrigin", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"AxesStyle", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"Background", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"ColorFunction", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"ColorFunctionScaling", "\[Rule]", "True"}], ",", 
       RowBox[{"ColorOutput", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"DefaultColor", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"Epilog", "\[Rule]", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"Frame", "\[Rule]", "True"}], ",", 
       RowBox[{"FrameLabel", "\[Rule]", "None"}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"FrameTicks", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"GridLines", "\[Rule]", "None"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"PixelLabeling", "\[Rule]", " ", "False"}], ",", 
       RowBox[{"PlotLabel", "\[Rule]", "None"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"PlotRegion", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"Prolog", "\[Rule]", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"RotateLabel", "\[Rule]", "True"}], ",", 
       RowBox[{"Ticks", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"DefaultFont", "\[RuleDelayed]", "$DefaultFont"}], ",", 
       RowBox[{"DisplayFunction", "\[RuleDelayed]", "$DisplayFunction"}], ",", 
       RowBox[{"FormatType", "\[RuleDelayed]", "$FormatType"}], ",", 
       RowBox[{"TextStyle", "\[RuleDelayed]", "$TextStyle"}]}], "}"}]}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{3.43004884952042*^9}],

Cell[CellGroupData[{

Cell["Utility Functions", "Subsection",
 CellChangeTimes->{{3.470131457151704*^9, 3.4701314596847067`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"AutomaticTickRange", "[", 
   RowBox[{"max_", "?", "NumberQ"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"scale", " ", "=", " ", 
      RowBox[{"Power", "[", 
       RowBox[{"10", ",", 
        RowBox[{"Floor", "[", 
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "max"}], "]"}], "]"}]}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"max", "==", "1"}], ",", 
      RowBox[{"{", "1", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"scale", "\[LessEqual]", "max", "<", 
       RowBox[{"8", 
        RowBox[{"scale", "/", "5"}]}]}], ",", 
      RowBox[{"Prepend", "[", 
       RowBox[{
        RowBox[{"Range", "[", 
         RowBox[{
          RowBox[{"scale", "/", "5"}], ",", "max", ",", 
          RowBox[{"scale", "/", "5"}]}], "]"}], ",", "1"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"8", 
        RowBox[{"scale", "/", "5"}]}], "\[LessEqual]", "max", "<", 
       RowBox[{"4", "scale"}]}], ",", 
      RowBox[{"Prepend", "[", 
       RowBox[{
        RowBox[{"Range", "[", 
         RowBox[{
          RowBox[{"scale", "/", "2"}], ",", "max", ",", 
          RowBox[{"scale", "/", "2"}]}], "]"}], ",", "1"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"4", " ", "scale"}], "\[LessEqual]", "max", "<", 
       RowBox[{"8", "scale"}]}], ",", " ", 
      RowBox[{"Prepend", "[", 
       RowBox[{
        RowBox[{"Range", "[", 
         RowBox[{"scale", ",", "max", ",", "scale"}], "]"}], ",", "1"}], 
       "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"8", " ", "scale"}], "\[LessEqual]", "max", "<", 
       RowBox[{"10", " ", "scale"}]}], ",", " ", 
      RowBox[{"Prepend", "[", 
       RowBox[{
        RowBox[{"Range", "[", 
         RowBox[{
          RowBox[{"2", " ", "scale"}], ",", "max", ",", 
          RowBox[{"2", " ", "scale"}]}], "]"}], ",", "1"}], "]"}], ",", 
      "\[IndentingNewLine]", "True", ",", "None"}], "\[IndentingNewLine]", 
     "]"}]}], "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 CellChangeTimes->{{3.4701307702162333`*^9, 3.470130824356172*^9}, {
   3.470130891118587*^9, 3.470130945372583*^9}, {3.470131028913168*^9, 
   3.4701311588723993`*^9}, {3.470131324205234*^9, 3.470131361502973*^9}, {
   3.470131400712577*^9, 3.4701314288143787`*^9}, 3.470131656164291*^9, {
   3.470132449546101*^9, 3.470132527390932*^9}, {3.470132581818581*^9, 
   3.4701326188159847`*^9}, {3.470132662290423*^9, 3.470132705602522*^9}, {
   3.4701327532382936`*^9, 3.470132766874646*^9}, {3.470132893296421*^9, 
   3.470132904917292*^9}, {3.470137302219678*^9, 3.470137334379356*^9}, {
   3.470139354336286*^9, 3.470139377990864*^9}, {3.4701394863223248`*^9, 
   3.470139525746092*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"AutomaticTickRange", "[", 
   RowBox[{"max_", "?", "NumberQ"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"scale", " ", "=", " ", 
      RowBox[{"Power", "[", 
       RowBox[{"10", ",", 
        RowBox[{"Floor", "[", 
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "max"}], "]"}], "]"}]}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Which", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"max", "\[LessEqual]", "10"}], ",", 
      RowBox[{"Range", "[", "max", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"max", "\[LessEqual]", 
       RowBox[{"scale", "+", "1"}]}], ",", 
      RowBox[{"Range", "[", 
       RowBox[{
        RowBox[{"scale", "/", "5"}], ",", "max", ",", 
        RowBox[{"scale", "/", "5"}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"max", "\[LessEqual]", 
       RowBox[{
        RowBox[{
         RowBox[{"5", "/", "2"}], "scale"}], "+", "1"}]}], ",", " ", 
      RowBox[{"Range", "[", 
       RowBox[{
        RowBox[{"scale", "/", "2"}], ",", "max", ",", 
        RowBox[{"scale", "/", "2"}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"max", "\[LessEqual]", 
       RowBox[{
        RowBox[{"5", " ", "scale"}], "+", "1"}]}], ",", " ", 
      RowBox[{"Range", "[", 
       RowBox[{"scale", ",", "max", ",", "scale"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"max", "\[LessEqual]", 
       RowBox[{
        RowBox[{"10", " ", "scale"}], "+", "1"}]}], ",", " ", 
      RowBox[{"Range", "[", 
       RowBox[{
        RowBox[{"2", "scale"}], ",", "max", ",", 
        RowBox[{"2", "scale"}]}], "]"}], ",", "\[IndentingNewLine]", "True", 
      ",", "None"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.470131463560288*^9, 3.470131478196087*^9}, {
  3.4701372912452097`*^9, 3.4701372993386393`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["ListLuminocityPlot", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ListLuminocityPlot", "[", 
   RowBox[{
    RowBox[{"img_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], " ", ":=", 
  " ", "\[IndentingNewLine]", 
  RowBox[{"RasterPlot", "[", 
   RowBox[{"img", ",", 
    RowBox[{"ImageSize", "\[Rule]", 
     RowBox[{"PadRight", "[", 
      RowBox[{
       RowBox[{"Dimensions", "[", "img", "]"}], ",", "2"}], "]"}]}], ",", 
    RowBox[{"Frame", "\[Rule]", " ", "False"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", " ", "All"}], ",", " ", 
    RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", "opts"}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ListLuminocityPlot", "[", 
   RowBox[{
    RowBox[{"img_", "?", "MatrixQ"}], ",", 
    RowBox[{"rng", ":", 
     RowBox[{"{", 
      RowBox[{"_", ",", "_"}], "}"}]}], ",", "opts___Rule"}], "]"}], " ", ":=",
   " ", "\[IndentingNewLine]", 
  RowBox[{"RasterPlot", "[", 
   RowBox[{"img", ",", 
    RowBox[{"ImageSize", "\[Rule]", 
     RowBox[{"PadRight", "[", 
      RowBox[{
       RowBox[{"Dimensions", "[", "img", "]"}], ",", "2"}], "]"}]}], ",", 
    RowBox[{"Frame", "\[Rule]", " ", "False"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", " ", "rng"}], ",", " ", 
    RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", "opts"}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ListLuminocityPlot", "[", 
   RowBox[{
    RowBox[{"img_", "?", "MatrixQ"}], ",", 
    RowBox[{"top_", "?", "NumericQ"}], ",", "opts___Rule"}], "]"}], " ", ":=",
   "  ", "\[IndentingNewLine]", 
  RowBox[{"RasterPlot", "[", 
   RowBox[{"img", ",", 
    RowBox[{"ImageSize", "\[Rule]", 
     RowBox[{"PadRight", "[", 
      RowBox[{
       RowBox[{"Dimensions", "[", "img", "]"}], ",", "2"}], "]"}]}], ",", 
    RowBox[{"Frame", "\[Rule]", " ", "False"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{"0", ",", "top"}], "}"}]}], ",", " ", 
    RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", "opts"}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["RasterPlot", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RasterPlot", "::", "optx"}], "=", 
   "\"\<Unknown option `1`  in  `2` .\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RasterPlot", "::", "cfopt"}], "=", 
   "\"\<Automatic colorfunction is not applicable to image data.\>\""}], 
  ";"}]}], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RasterPlot", "[", 
   RowBox[{
    RowBox[{"img_", "?", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"ArrayQ", "[", 
        RowBox[{"#", ",", 
         RowBox[{"2", "|", "3"}], ",", "NumericQ"}], "]"}], "&"}], ")"}]}], 
    ",", " ", "opts___Rule"}], "]"}], " ", ":=", "\[IndentingNewLine]", 
  RowBox[{"If", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$VersionNumber", "<", "6"}], ",", "\[IndentingNewLine]", 
    RowBox[{"RasterPlot5", "[", 
     RowBox[{"img", ",", " ", "opts"}], "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{"RasterPlot6", "[", 
     RowBox[{"img", ",", " ", "opts"}], "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AdjustPlotRange", "[", 
   RowBox[{"img_List", ",", "rng_"}], "]"}], " ", ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"rngXY", " ", "=", " ", 
      RowBox[{"Thread", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", 
         RowBox[{
          RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1"}], "}"}], "\[RightDoubleBracket]"}]}], "}"}],
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Switch", "[", "\[IndentingNewLine]", 
     RowBox[{"rng", ",", "\[IndentingNewLine]", 
      RowBox[{"_", "?", "NumericQ"}], ",", 
      RowBox[{"Append", "[", 
       RowBox[{"rngXY", ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "rng"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
      RowBox[{"Append", "[", 
       RowBox[{"rngXY", ",", "rng"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}], ",", 
      RowBox[{"Append", "[", 
       RowBox[{"rng", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Min", "[", "img", "]"}], ",", 
          RowBox[{"Max", "[", "img", "]"}]}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}], ",", "rng", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"All", "|", "Full"}], ",", 
      RowBox[{"Append", "[", 
       RowBox[{"rngXY", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"Equal", "@@", "#"}], ",", 
            RowBox[{"#", "+", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", "#", ",", "#"}], 
           "]"}], "&"}], "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Min", "[", "img", "]"}], ",", 
           RowBox[{"Max", "[", "img", "]"}]}], "}"}], "]"}]}], "]"}], ",", 
      "\[IndentingNewLine]", "Automatic", ",", 
      RowBox[{"Append", "[", 
       RowBox[{"rngXY", ",", "Automatic"}], "]"}], ",", "\[IndentingNewLine]",
       "_", ",", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"RasterPlot", "::", "optx"}], ",", "rng", ",", 
         "RasterPlot"}], "]"}], ";", 
       RowBox[{"Return", "[", "$Failed", "]"}]}]}], "\[IndentingNewLine]", 
     "]"}]}], "\[IndentingNewLine]", "]"}]}]], "PackageInput"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"AutomaticColorFunction", "[", 
    RowBox[{"img_List", ",", "Automatic"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"If", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"$VersionNumber", "<", "6"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Switch", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Dimensions", "[", "img", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_"}], "}"}], ",", "GrayLevel", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", "3"}], "}"}], ",", "RGBColor", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", "__", "}"}], ",", 
       RowBox[{
        RowBox[{"GrayLevel", "[", 
         RowBox[{"Mean", "[", "#", "]"}], "]"}], "&"}], ",", 
       "\[IndentingNewLine]", "_", ",", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{"RasterPlot", "::", "cfopt"}], "]"}], ";", 
        RowBox[{"Return", "[", "$Failed", "]"}]}]}], "\[IndentingNewLine]", 
      "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Switch", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Dimensions", "[", "img", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], "|", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_", ",", "2"}], "}"}]}], ",", "GrayLevel", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", 
         RowBox[{"3", "|", "4"}]}], "}"}], ",", "RGBColor", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", "__", "}"}], ",", 
       RowBox[{
        RowBox[{"GrayLevel", "[", 
         RowBox[{"Mean", "[", "#", "]"}], "]"}], "&"}], ",", 
       "\[IndentingNewLine]", "_", ",", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{"RasterPlot", "::", "cfopt"}], "]"}], ";", 
        RowBox[{"Return", "[", "$Failed", "]"}]}]}], "\[IndentingNewLine]", 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AutomaticColorFunction", "[", 
    RowBox[{"img_List", ",", "cf_String"}], "]"}], ":=", 
   RowBox[{"ColorData", "[", "cf", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AutomaticColorFunction", "[", 
   RowBox[{"img_List", ",", "cf_"}], "]"}], "=", "cf"}]}], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AutomaticColorFunctionScaling", "[", 
   RowBox[{"img_List", ",", 
    RowBox[{"{", 
     RowBox[{"bot_", ",", "top_"}], "}"}], ",", "cfs_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"If", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"cfs", " ", "\[And]", " ", 
     RowBox[{
      RowBox[{"ArrayDepth", "[", "img", "]"}], "===", " ", "3"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Compile", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"rgb", ",", "_Real", ",", "3"}], "}"}], "}"}], ",", 
      RowBox[{"Evaluate", "[", 
       FractionBox[
        RowBox[{"rgb", "-", "bot"}], 
        RowBox[{"top", "-", "bot"}]], "]"}]}], "]"}], ",", 
    "\[IndentingNewLine]", "Identity"}], "\[IndentingNewLine]", 
   "]"}]}]], "PackageInput"],

Cell[BoxData[
 StyleBox[
  RowBox[{
   RowBox[{
    StyleBox[
     RowBox[{"(", "*"}]], " ", 
    RowBox[{"faulty", " ", "-", " ", 
     RowBox[{"replacement", " ", 
      RowBox[{"below", "!"}]}]}], " ", 
    StyleBox[
     RowBox[{"*", ")"}]]}], "\[IndentingNewLine]", 
   RowBox[{"ComplexColor", " ", "=", " ", 
    RowBox[{"Compile", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"z", ",", "_Complex", ",", "2"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"zmin", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"zmax", ",", "_Real"}], "}"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"MapThread", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"#1", ",", "#2", ",", "#2"}], "}"}], "&"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"zmin", "<", "zmax"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"Arg", "[", "z", "]"}], "/", 
              RowBox[{"(", 
               RowBox[{"2", "\[Pi]"}], ")"}]}], "+", 
             RowBox[{"1", "/", "2"}]}], ",", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Abs", "[", "z", "]"}], "-", "zmin"}], ")"}], "/", 
             RowBox[{"Abs", "[", 
              RowBox[{"zmax", "-", "zmin"}], "]"}]}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"Arg", "[", "z", "]"}], "/", 
              RowBox[{"(", 
               RowBox[{"2", "\[Pi]"}], ")"}]}], "+", 
             RowBox[{"1", "/", "2"}]}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "/", 
                RowBox[{"Max", "[", "#", "]"}]}], ")"}], "&"}], "[", 
             RowBox[{"Abs", "[", "z", "]"}], "]"}]}], "}"}]}], 
         "\[IndentingNewLine]", "]"}], ",", "2"}], "]"}]}], "]"}]}]}], 
  "Input"]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.4731647429893513`*^9, 3.473164911109226*^9}, {
  3.473164946198312*^9, 3.473164979535159*^9}, {3.473165041955538*^9, 
  3.473165044332666*^9}, {3.473165082306295*^9, 3.473165155501555*^9}, {
  3.482819212559415*^9, 3.482819214419697*^9}, {3.482819256154252*^9, 
  3.482819268596826*^9}}],

Cell[BoxData[
 RowBox[{"ComplexColor", " ", "=", " ", 
  RowBox[{"Compile", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"z", ",", "_Complex", ",", "2"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"zmin", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"zmax", ",", "_Real"}], "}"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Transpose", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"zmin", "<", "zmax"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"Arg", "[", "z", "]"}], "/", 
              RowBox[{"(", 
               RowBox[{"2", "\[Pi]"}], ")"}]}], "+", 
             RowBox[{"1", "/", "2"}]}], ",", "#", ",", "#"}], "}"}], "&"}], 
         "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Abs", "[", "z", "]"}], "-", "zmin"}], ")"}], "/", 
          RowBox[{"Abs", "[", 
           RowBox[{"zmax", "-", "zmin"}], "]"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"Arg", "[", "z", "]"}], "/", 
              RowBox[{"(", 
               RowBox[{"2", "\[Pi]"}], ")"}]}], "+", 
             RowBox[{"1", "/", "2"}]}], ",", "#", ",", "#"}], "}"}], "&"}], 
         "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#", "/", 
             RowBox[{"Max", "[", "#", "]"}]}], ")"}], "&"}], "[", 
          RowBox[{"Abs", "[", "z", "]"}], "]"}], "]"}]}], 
       "\[IndentingNewLine]", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RasterPlot5", "[", 
    RowBox[{
     RowBox[{"img_", "?", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"MatrixQ", "[", "#", "]"}], "\[And]", 
         RowBox[{"Not", "[", 
          RowBox[{"FreeQ", "[", 
           RowBox[{"#", ",", "Complex"}], "]"}], "]"}]}], "&"}], ")"}]}], ",",
      " ", "opts___Rule"}], "]"}], " ", ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"dims", " ", "=", " ", 
        RowBox[{
         RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}], "\[RightDoubleBracket]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"rng", " ", "=", " ", 
        RowBox[{"AdjustPlotRange", "[", 
         RowBox[{
          RowBox[{"Abs", "[", "img", "]"}], ",", 
          RowBox[{
           RowBox[{"PlotRange", " ", "/.", " ", 
            RowBox[{"{", "opts", "}"}]}], " ", "/.", " ", 
           RowBox[{"Options", "[", "RasterPlot", "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"cf", " ", "=", " ", 
        RowBox[{
         RowBox[{"ColorFunction", " ", "/.", " ", 
          RowBox[{"{", "opts", "}"}]}], "/.", " ", 
         RowBox[{"{", 
          RowBox[{"ColorFunction", "\[Rule]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Hue", "@@", "#"}], "&"}], ")"}]}], "}"}]}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"dr", "=", 
        RowBox[{
         RowBox[{"DataReversed", "/.", " ", 
          RowBox[{"{", "opts", "}"}]}], "/.", " ", 
         RowBox[{"Options", "[", "RasterPlot", "]"}]}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"rasterOpts", "=", 
        RowBox[{"DeleteCases", "[", 
         RowBox[{
          RowBox[{"First", "/@", " ", 
           RowBox[{"Options", "[", "Raster", "]"}]}], ",", "ColorFunction"}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"graphicsOpts", "=", 
        RowBox[{"DeleteCases", "[", " ", 
         RowBox[{
          RowBox[{"First", "/@", 
           RowBox[{"Options", "[", "Graphics", "]"}]}], ",", "PlotRange"}], 
         "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Show", "[", "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Raster", "[", 
         RowBox[{
          RowBox[{"ComplexColor", "[", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{"dr", ",", "img", ",", 
              RowBox[{"Reverse", "[", "img", "]"}], ",", 
              RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], ",", 
            RowBox[{"rng", "\[LeftDoubleBracket]", 
             RowBox[{"3", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
            RowBox[{"rng", "\[LeftDoubleBracket]", 
             RowBox[{"3", ",", "2"}], "\[RightDoubleBracket]"}]}], "]"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}], ",", "dims"}], "}"}], "+", 
           RowBox[{"1", "/", "2"}]}], ",", 
          RowBox[{"Last", "[", "rng", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"ColorFunction", "\[Rule]", " ", "cf"}], ",", 
          RowBox[{"ColorFunctionScaling", "\[Rule]", " ", "False"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", 
            RowBox[{
             RowBox[{"{", "opts", "}"}], ",", "rasterOpts"}], "]"}]}], ",", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", 
            RowBox[{
             RowBox[{"Options", "[", "RasterPlot", "]"}], ",", " ", 
             "rasterOpts"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"PlotRange", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"Most", "[", "rng", "]"}], "+", 
          RowBox[{"1", "/", "2"}]}]}], ",", 
        RowBox[{"FrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"AutomaticTickRange", "[", 
            RowBox[{
            "dims", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
            "]"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{"dr", ",", 
             RowBox[{"AutomaticTickRange", "[", 
              RowBox[{
              "dims", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
              "]"}], ",", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                   "dims", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}], "-", "#", "+", "1"}], ",", 
                  RowBox[{"ToString", "[", "#", "]"}]}], "}"}], "&"}], ",", 
               RowBox[{"AutomaticTickRange", "[", 
                RowBox[{
                "dims", "\[LeftDoubleBracket]", "2", 
                 "\[RightDoubleBracket]"}], "]"}]}], "]"}]}], "]"}], ",", 
           "None", ",", "None"}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"FilterRules", "[", 
          RowBox[{
           RowBox[{"{", "opts", "}"}], ",", " ", "graphicsOpts"}], "]"}]}], 
        ",", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"FilterRules", "[", 
          RowBox[{
           RowBox[{"Options", "[", "RasterPlot", "]"}], ",", "graphicsOpts"}],
           "]"}]}]}], "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", 
      "]"}]}], "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RasterPlot5", "[", 
   RowBox[{"img_List", ",", " ", "opts___Rule"}], "]"}], " ", ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"dims", " ", "=", " ", 
       RowBox[{
        RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}], "\[RightDoubleBracket]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"rng", " ", "=", " ", 
       RowBox[{"AdjustPlotRange", "[", 
        RowBox[{"img", ",", 
         RowBox[{
          RowBox[{"PlotRange", " ", "/.", " ", 
           RowBox[{"{", "opts", "}"}]}], " ", "/.", " ", 
          RowBox[{"Options", "[", "RasterPlot", "]"}]}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"cf", " ", "=", " ", 
       RowBox[{"AutomaticColorFunction", "[", 
        RowBox[{"img", ",", 
         RowBox[{
          RowBox[{"ColorFunction", " ", "/.", " ", 
           RowBox[{"{", "opts", "}"}]}], " ", "/.", " ", 
          RowBox[{"Options", "[", "RasterPlot", "]"}]}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"dr", "=", 
       RowBox[{
        RowBox[{"DataReversed", "/.", " ", 
         RowBox[{"{", "opts", "}"}]}], "/.", " ", 
        RowBox[{"Options", "[", "RasterPlot", "]"}]}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"rasterOpts", "=", 
       RowBox[{"DeleteCases", "[", 
        RowBox[{
         RowBox[{"First", "/@", " ", 
          RowBox[{"Options", "[", "Raster", "]"}]}], ",", "ColorFunction"}], 
        "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"graphicsOpts", "=", 
       RowBox[{"DeleteCases", "[", " ", 
        RowBox[{
         RowBox[{"First", "/@", 
          RowBox[{"Options", "[", "Graphics", "]"}]}], ",", "PlotRange"}], 
        "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Show", "[", "\[IndentingNewLine]", 
     RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Raster", "[", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{"dr", ",", "img", ",", 
           RowBox[{"Reverse", "[", "img", "]"}], ",", 
           RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0"}], "}"}], ",", "dims"}], "}"}], "+", 
          RowBox[{"1", "/", "2"}]}], ",", 
         RowBox[{"Last", "[", "rng", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"ColorFunction", "\[Rule]", " ", "cf"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", 
           RowBox[{
            RowBox[{"{", "opts", "}"}], ",", "rasterOpts"}], "]"}]}], ",", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", 
           RowBox[{
            RowBox[{"Options", "[", "RasterPlot", "]"}], ",", " ", 
            "rasterOpts"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"Most", "[", "rng", "]"}], "+", 
         RowBox[{"1", "/", "2"}]}]}], ",", 
       RowBox[{"FrameTicks", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"AutomaticTickRange", "[", 
           RowBox[{
           "dims", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
           "]"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{"dr", ",", 
            RowBox[{"AutomaticTickRange", "[", 
             RowBox[{
             "dims", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
             "]"}], ",", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                  "dims", "\[LeftDoubleBracket]", "2", 
                   "\[RightDoubleBracket]"}], "-", "#", "+", "1"}], ",", 
                 RowBox[{"ToString", "[", "#", "]"}]}], "}"}], "&"}], ",", 
              RowBox[{"AutomaticTickRange", "[", 
               RowBox[{
               "dims", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
                "]"}]}], "]"}]}], "]"}], ",", "None", ",", "None"}], "}"}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"FilterRules", "[", 
         RowBox[{
          RowBox[{"{", "opts", "}"}], ",", " ", "graphicsOpts"}], "]"}]}], 
       ",", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"FilterRules", "[", 
         RowBox[{
          RowBox[{"Options", "[", "RasterPlot", "]"}], ",", "graphicsOpts"}], 
         "]"}]}]}], "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", 
     "]"}]}], "]"}]}]}], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.4325423523826*^9, 3.432542356643173*^9}, {
  3.4450817241513653`*^9, 3.445081765901433*^9}, {3.445081826420033*^9, 
  3.445081858635581*^9}, {3.445098532064335*^9, 3.445098541677672*^9}, {
  3.445098597891385*^9, 3.445098617965177*^9}, {3.445099118601699*^9, 
  3.4450991553100433`*^9}, {3.4452508701814747`*^9, 3.445250891339719*^9}, {
  3.445251596761792*^9, 3.445251618499214*^9}, {3.4701371429800987`*^9, 
  3.47013715408007*^9}, {3.470139618287887*^9, 3.470139654782317*^9}, {
  3.473165220888589*^9, 3.4731652477437067`*^9}, {3.476507049511162*^9, 
  3.476507054953999*^9}}],

Cell[BoxData[
 RowBox[{"DynamicModule", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"gr", " ", "=", " ", 
     RowBox[{"Raster", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{"cfs", ",", "img", ",", 
         RowBox[{"{", "2", "}"}]}], "]"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", "dims"}], "}"}], "+", 
        RowBox[{"1", "/", "2"}]}], ",", 
       RowBox[{"Last", "[", "rng", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"ColorFunction", "\[Rule]", " ", "cf"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"FilterRules", "[", 
         RowBox[{
          RowBox[{"{", "opts", "}"}], ",", "rasterOpts"}], "]"}]}], ",", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"FilterRules", "[", 
         RowBox[{
          RowBox[{"Options", "[", "RasterPlot", "]"}], ",", " ", 
          "rasterOpts"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "}"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Tooltip", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Raster", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{"cfs", ",", "img", ",", 
           RowBox[{"{", "2", "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0"}], "}"}], ",", "dims"}], "}"}], "+", 
          RowBox[{"1", "/", "2"}]}], ",", 
         RowBox[{"Last", "[", "rng", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"ColorFunction", "\[Rule]", " ", "cf"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", 
           RowBox[{
            RowBox[{"{", "opts", "}"}], ",", "rasterOpts"}], "]"}]}], ",", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", 
           RowBox[{
            RowBox[{"Options", "[", "RasterPlot", "]"}], ",", " ", 
            "rasterOpts"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"And", "@@", 
            RowBox[{"Thread", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "0"}], "}"}], "<", "#", "\[LessEqual]", 
              "dims"}], "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"#", "\[Rule]", 
            RowBox[{"Short", "[", 
             RowBox[{"img", "\[LeftDoubleBracket]", 
              RowBox[{"Sequence", "@@", 
               RowBox[{"Reverse", "[", "#", "]"}]}], 
              "\[RightDoubleBracket]"}], "]"}]}], ",", "\[IndentingNewLine]", 
           "\"\<Frame\>\"", ",", "\"\<Frame\>\""}], "\[IndentingNewLine]", 
          "]"}], "&"}], "@", 
        RowBox[{"Round", "[", 
         RowBox[{"MousePosition", "[", 
          RowBox[{"\"\<Graphics\>\"", ",", "Indeterminate"}], "]"}], "]"}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"ActionDelay", "\[Rule]", " ", "0.2"}]}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"PlotRange", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"Most", "[", "rng", "]"}], "+", 
       RowBox[{"1", "/", "2"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Sequence", "@@", 
      RowBox[{"FilterRules", "[", 
       RowBox[{
        RowBox[{"{", "opts", "}"}], ",", " ", "graphicsOpts"}], "]"}]}], ",", 
     
     RowBox[{"Sequence", "@@", 
      RowBox[{"FilterRules", "[", 
       RowBox[{
        RowBox[{"Options", "[", "RasterPlot", "]"}], ",", "graphicsOpts"}], 
       "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
  "]"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RasterPlot6", "[", 
    RowBox[{
     RowBox[{"img_", "?", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"MatrixQ", "[", "#", "]"}], "\[And]", 
         RowBox[{"Not", "[", 
          RowBox[{"FreeQ", "[", 
           RowBox[{"#", ",", "Complex"}], "]"}], "]"}]}], "&"}], ")"}]}], ",",
      " ", "opts___Rule"}], "]"}], " ", ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"dims", " ", "=", " ", 
        RowBox[{
         RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}], "\[RightDoubleBracket]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"rng", " ", "=", " ", 
        RowBox[{"AdjustPlotRange", "[", 
         RowBox[{
          RowBox[{"Abs", "[", "img", "]"}], ",", 
          RowBox[{
           RowBox[{"PlotRange", " ", "/.", " ", 
            RowBox[{"{", "opts", "}"}]}], " ", "/.", " ", 
           RowBox[{"Options", "[", "RasterPlot", "]"}]}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"cf", " ", "=", " ", 
        RowBox[{
         RowBox[{"ColorFunction", " ", "/.", " ", 
          RowBox[{"{", "opts", "}"}]}], "/.", " ", 
         RowBox[{"{", 
          RowBox[{"ColorFunction", "\[Rule]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Hue", "@@", "#"}], "&"}], ")"}]}], "}"}]}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"dr", "=", 
        RowBox[{
         RowBox[{"DataReversed", "/.", " ", 
          RowBox[{"{", "opts", "}"}]}], "/.", " ", 
         RowBox[{"Options", "[", "RasterPlot", "]"}]}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"rasterOpts", "=", 
        RowBox[{"DeleteCases", "[", 
         RowBox[{
          RowBox[{"First", "/@", " ", 
           RowBox[{"Options", "[", "Raster", "]"}]}], ",", "ColorFunction"}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"graphicsOpts", "=", 
        RowBox[{"DeleteCases", "[", " ", 
         RowBox[{
          RowBox[{"First", "/@", 
           RowBox[{"Options", "[", "Graphics", "]"}]}], ",", "PlotRange"}], 
         "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Show", "[", "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Raster", "[", 
         RowBox[{
          RowBox[{"ComplexColor", "[", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{"dr", ",", "img", ",", 
              RowBox[{"Reverse", "[", "img", "]"}], ",", 
              RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], ",", 
            RowBox[{"rng", "\[LeftDoubleBracket]", 
             RowBox[{"3", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
            RowBox[{"rng", "\[LeftDoubleBracket]", 
             RowBox[{"3", ",", "2"}], "\[RightDoubleBracket]"}]}], "]"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}], ",", "dims"}], "}"}], "+", 
           RowBox[{"1", "/", "2"}]}], ",", 
          RowBox[{"Last", "[", "rng", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"ColorFunction", "\[Rule]", " ", "cf"}], ",", 
          RowBox[{"ColorFunctionScaling", "\[Rule]", " ", "False"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", 
            RowBox[{
             RowBox[{"{", "opts", "}"}], ",", "rasterOpts"}], "]"}]}], ",", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", 
            RowBox[{
             RowBox[{"Options", "[", "RasterPlot", "]"}], ",", " ", 
             "rasterOpts"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"PlotRange", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"Most", "[", "rng", "]"}], "+", 
          RowBox[{"1", "/", "2"}]}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"FrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"AutomaticTickRange", "[", 
            RowBox[{
            "dims", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
            "]"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{"dr", ",", 
             RowBox[{"AutomaticTickRange", "[", 
              RowBox[{
              "dims", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
              "]"}], ",", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                   "dims", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}], "-", "#", "+", "1"}], ",", 
                  RowBox[{"ToString", "[", "#", "]"}]}], "}"}], "&"}], ",", 
               RowBox[{"AutomaticTickRange", "[", 
                RowBox[{
                "dims", "\[LeftDoubleBracket]", "2", 
                 "\[RightDoubleBracket]"}], "]"}]}], "]"}]}], "]"}], ",", 
           "None", ",", "None"}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"FilterRules", "[", 
          RowBox[{
           RowBox[{"{", "opts", "}"}], ",", " ", "graphicsOpts"}], "]"}]}], 
        ",", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"FilterRules", "[", 
          RowBox[{
           RowBox[{"Options", "[", "RasterPlot", "]"}], ",", "graphicsOpts"}],
           "]"}]}]}], "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", 
      "]"}]}], "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RasterPlot6", "[", 
   RowBox[{"img_List", ",", " ", "opts___Rule"}], "]"}], " ", ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"dims", " ", "=", " ", 
       RowBox[{
        RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}], "\[RightDoubleBracket]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"rng", " ", "=", " ", 
       RowBox[{"AdjustPlotRange", "[", 
        RowBox[{"img", ",", 
         RowBox[{
          RowBox[{"PlotRange", " ", "/.", " ", 
           RowBox[{"{", "opts", "}"}]}], " ", "/.", " ", 
          RowBox[{"Options", "[", "RasterPlot", "]"}]}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"cf", " ", "=", " ", 
       RowBox[{"AutomaticColorFunction", "[", 
        RowBox[{"img", ",", 
         RowBox[{
          RowBox[{"ColorFunction", " ", "/.", " ", 
           RowBox[{"{", "opts", "}"}]}], " ", "/.", " ", 
          RowBox[{"Options", "[", "RasterPlot", "]"}]}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", "cfs", ",", "\[IndentingNewLine]", 
      RowBox[{"dr", "=", 
       RowBox[{
        RowBox[{"DataReversed", "/.", " ", 
         RowBox[{"{", "opts", "}"}]}], "/.", " ", 
        RowBox[{"Options", "[", "RasterPlot", "]"}]}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"rasterOpts", "=", 
       RowBox[{"DeleteCases", "[", 
        RowBox[{
         RowBox[{"First", "/@", " ", 
          RowBox[{"Options", "[", "Raster", "]"}]}], ",", "ColorFunction"}], 
        "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"graphicsOpts", "=", 
       RowBox[{"DeleteCases", "[", " ", 
        RowBox[{
         RowBox[{"First", "/@", 
          RowBox[{"Options", "[", "Graphics", "]"}]}], ",", "PlotRange"}], 
        "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"cfs", " ", "=", " ", 
      RowBox[{"AutomaticColorFunctionScaling", "[", 
       RowBox[{"img", ",", 
        RowBox[{"Last", "[", "rng", "]"}], ",", 
        RowBox[{
         RowBox[{"ColorFunctionScaling", " ", "/.", " ", 
          RowBox[{"{", "opts", "}"}]}], " ", "/.", " ", 
         RowBox[{"Options", "[", "RasterPlot", "]"}]}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MatchQ", "[", 
        RowBox[{"cf", ",", 
         RowBox[{
         "RGBColor", "|", "Hue", "|", "GrayLevel", "|", "CMYKColor"}]}], 
        "]"}], ",", " ", 
       RowBox[{"cfs", " ", "=", " ", "Identity"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Raster", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"cfs", "[", 
          RowBox[{"If", "[", 
           RowBox[{"dr", ",", "img", ",", 
            RowBox[{"Reverse", "[", "img", "]"}], ",", 
            RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "0"}], "}"}], ",", "dims"}], "}"}], "+", 
          RowBox[{"1", "/", "2"}]}], ",", 
         RowBox[{"Last", "[", "rng", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"ColorFunction", "\[Rule]", " ", "cf"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", 
           RowBox[{
            RowBox[{"{", "opts", "}"}], ",", "rasterOpts"}], "]"}]}], ",", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", 
           RowBox[{
            RowBox[{"Options", "[", "RasterPlot", "]"}], ",", " ", 
            "rasterOpts"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", " ", 
        RowBox[{
         RowBox[{"Most", "[", "rng", "]"}], "+", 
         RowBox[{"1", "/", "2"}]}]}], ",", 
       RowBox[{"FrameTicks", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"AutomaticTickRange", "[", 
           RowBox[{
           "dims", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
           "]"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{"dr", ",", 
            RowBox[{"AutomaticTickRange", "[", 
             RowBox[{
             "dims", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
             "]"}], ",", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                  "dims", "\[LeftDoubleBracket]", "2", 
                   "\[RightDoubleBracket]"}], "-", "#", "+", "1"}], ",", 
                 RowBox[{"ToString", "[", "#", "]"}]}], "}"}], "&"}], ",", 
              RowBox[{"AutomaticTickRange", "[", 
               RowBox[{
               "dims", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
                "]"}]}], "]"}]}], "]"}], ",", "None", ",", "None"}], "}"}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"FilterRules", "[", 
         RowBox[{
          RowBox[{"{", "opts", "}"}], ",", " ", "graphicsOpts"}], "]"}]}], 
       ",", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"FilterRules", "[", 
         RowBox[{
          RowBox[{"Options", "[", "RasterPlot", "]"}], ",", "graphicsOpts"}], 
         "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]}], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{
  3.4325423645118303`*^9, {3.4450985476629744`*^9, 3.445098553058343*^9}, {
   3.445098613404235*^9, 3.4450986490914717`*^9}, {3.445099164387714*^9, 
   3.4450991751942997`*^9}, {3.445250903827588*^9, 3.4452509173523417`*^9}, {
   3.445251624620205*^9, 3.445251637290242*^9}, {3.470133175864842*^9, 
   3.4701331984698477`*^9}, {3.470133230894846*^9, 3.470133234116572*^9}, {
   3.470133340295824*^9, 3.4701333502538*^9}, {3.4701333840158253`*^9, 
   3.470133405232369*^9}, {3.4701371324642143`*^9, 3.47013713412669*^9}, {
   3.470139660570714*^9, 3.4701396674689207`*^9}, 3.473165298003255*^9, {
   3.476506960477015*^9, 3.476506960786449*^9}, {3.476506997835289*^9, 
   3.476506998091894*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RasterPlot6", "[", 
   RowBox[{"img_List", ",", " ", "opts___Rule"}], "]"}], " ", ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"dims", " ", "=", " ", 
       RowBox[{
        RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}], "\[RightDoubleBracket]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"rng", " ", "=", " ", 
       RowBox[{"AdjustPlotRange", "[", 
        RowBox[{"img", ",", 
         RowBox[{
          RowBox[{"PlotRange", " ", "/.", " ", 
           RowBox[{"{", "opts", "}"}]}], " ", "/.", " ", 
          RowBox[{"Options", "[", "RasterPlot", "]"}]}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"cf", " ", "=", " ", 
       RowBox[{"AutomaticColorFunction", "[", 
        RowBox[{"img", ",", 
         RowBox[{
          RowBox[{"ColorFunction", " ", "/.", " ", 
           RowBox[{"{", "opts", "}"}]}], " ", "/.", " ", 
          RowBox[{"Options", "[", "RasterPlot", "]"}]}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"cfs", " ", "=", " ", 
       RowBox[{"AutomaticColorFunctionScaling", "[", 
        RowBox[{"img", ",", 
         RowBox[{
          RowBox[{"ColorFunctionScaling", " ", "/.", " ", 
           RowBox[{"{", "opts", "}"}]}], " ", "/.", " ", 
          RowBox[{"Options", "[", "RasterPlot", "]"}]}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"pl", " ", "=", " ", 
       RowBox[{
        RowBox[{"PixelLabeling", "/.", " ", 
         RowBox[{"{", "opts", "}"}]}], " ", "/.", " ", 
        RowBox[{"Options", "[", "RasterPlot", "]"}]}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"rasterOpts", "=", 
       RowBox[{"DeleteCases", "[", 
        RowBox[{
         RowBox[{"First", "/@", " ", 
          RowBox[{"Options", "[", "Raster", "]"}]}], ",", "ColorFunction"}], 
        "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"graphicsOpts", "=", 
       RowBox[{"DeleteCases", "[", " ", 
        RowBox[{
         RowBox[{"First", "/@", 
          RowBox[{"Options", "[", "Graphics", "]"}]}], ",", "PlotRange"}], 
        "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"If", "[", "\[IndentingNewLine]", 
     RowBox[{"pl", ",", "\[IndentingNewLine]", 
      RowBox[{"DynamicModule", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"gr", " ", "=", " ", 
          RowBox[{"Raster", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Map", "[", 
             RowBox[{"cfs", ",", "img", ",", 
              RowBox[{"{", "2", "}"}]}], "]"}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", "0"}], "}"}], ",", "dims"}], "}"}], "+", 
             RowBox[{"1", "/", "2"}]}], ",", 
            RowBox[{"Last", "[", "rng", "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"ColorFunction", "\[Rule]", " ", "cf"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"FilterRules", "[", 
              RowBox[{
               RowBox[{"{", "opts", "}"}], ",", "rasterOpts"}], "]"}]}], ",", 
            
            RowBox[{"Sequence", "@@", 
             RowBox[{"FilterRules", "[", 
              RowBox[{
               RowBox[{"Options", "[", "RasterPlot", "]"}], ",", " ", 
               "rasterOpts"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
         "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Tooltip", "[", "\[IndentingNewLine]", 
           RowBox[{"gr", ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"If", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"And", "@@", 
                 RowBox[{"Thread", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], "<", "#", "\[LessEqual]", 
                   "dims"}], "]"}]}], ",", "\[IndentingNewLine]", 
                RowBox[{"#", "\[Rule]", 
                 RowBox[{"Short", "[", 
                  RowBox[{"img", "\[LeftDoubleBracket]", 
                   RowBox[{"Sequence", "@@", 
                    RowBox[{"Reverse", "[", "#", "]"}]}], 
                   "\[RightDoubleBracket]"}], "]"}]}], ",", 
                "\[IndentingNewLine]", "\"\<Frame\>\"", ",", 
                "\"\<Frame\>\""}], "\[IndentingNewLine]", "]"}], "&"}], "@", 
             RowBox[{"Round", "[", 
              RowBox[{"MousePosition", "[", 
               RowBox[{"\"\<Graphics\>\"", ",", "Indeterminate"}], "]"}], 
              "]"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"ActionDelay", "\[Rule]", " ", "0.2"}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"PlotRange", "\[Rule]", " ", 
           RowBox[{
            RowBox[{"Most", "[", "rng", "]"}], "+", 
            RowBox[{"1", "/", "2"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", 
            RowBox[{
             RowBox[{"{", "opts", "}"}], ",", " ", "graphicsOpts"}], "]"}]}], 
          ",", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", 
            RowBox[{
             RowBox[{"Options", "[", "RasterPlot", "]"}], ",", 
             "graphicsOpts"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Raster", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Map", "[", 
           RowBox[{"cfs", ",", "img", ",", 
            RowBox[{"{", "2", "}"}]}], "]"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}], ",", "dims"}], "}"}], "+", 
           RowBox[{"1", "/", "2"}]}], ",", 
          RowBox[{"Last", "[", "rng", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"ColorFunction", "\[Rule]", " ", "cf"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", 
            RowBox[{
             RowBox[{"{", "opts", "}"}], ",", "rasterOpts"}], "]"}]}], ",", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", 
            RowBox[{
             RowBox[{"Options", "[", "RasterPlot", "]"}], ",", " ", 
             "rasterOpts"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"PlotRange", "\[Rule]", " ", 
         RowBox[{
          RowBox[{"Most", "[", "rng", "]"}], "+", 
          RowBox[{"1", "/", "2"}]}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"FilterRules", "[", 
          RowBox[{
           RowBox[{"{", "opts", "}"}], ",", " ", "graphicsOpts"}], "]"}]}], 
        ",", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"FilterRules", "[", 
          RowBox[{
           RowBox[{"Options", "[", "RasterPlot", "]"}], ",", "graphicsOpts"}],
           "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
     "]"}]}], "\[IndentingNewLine]", "]"}]}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["ListEllipsePlot", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ListEllipsePlot", "::", "vers"}], " ", "=", " ", 
   "\"\<ListEllipsePlot is not implemented for Mathematica versions prior \
6.0.\>\""}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"$VersionNumber", "<", "6"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ListEllipsePlot", "[", "__", "]"}], " ", ":=", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"ListEllipsePlot", "::", "vers"}], "]"}], ";", "$Failed"}], 
     ")"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ListEllipsePlot", "[", 
     RowBox[{"matField_List", ",", " ", "opts___Rule"}], "]"}], " ", ":=", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"eigenField", " ", "=", " ", 
          RowBox[{"Map", "[", 
           RowBox[{"Eigensystem", ",", 
            RowBox[{"N", "[", "matField", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"ArrayDepth", "[", "matField", "]"}], "-", "2"}], 
             "}"}]}], "]"}]}], ",", " ", "\[IndentingNewLine]", 
         RowBox[{"ellipseScale", " ", "=", " ", 
          RowBox[{
           RowBox[{"ScaleFactor", " ", "/.", " ", 
            RowBox[{"{", "opts", "}"}]}], " ", "/.", " ", 
           RowBox[{"Options", "[", "ListEllipsePlot", "]"}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"colorFunction", " ", "=", " ", 
          RowBox[{
           RowBox[{"ColorFunction", "/.", " ", 
            RowBox[{"{", "opts", "}"}]}], " ", "/.", " ", 
           RowBox[{"Options", "[", "ListEllipsePlot", "]"}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"dr", "=", 
          RowBox[{
           RowBox[{"DataReversed", "/.", " ", 
            RowBox[{"{", "opts", "}"}]}], "/.", " ", 
           RowBox[{"Options", "[", "ListEllipsePlot", "]"}]}]}], ",", 
         "\[IndentingNewLine]", "maxEigenvalue", ",", "maxDet", ",", 
         "autoColor", ",", "ellipseFunction", ",", " ", 
         RowBox[{"fieldRank", " ", "=", " ", 
          RowBox[{
           RowBox[{"ArrayDepth", "[", "matField", "]"}], "-", "2"}]}]}], 
        "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"maxEigenvalue", ",", "maxDet"}], "}"}], " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"Max", "[", "#", "]"}], "]"}], ",", " ", 
             RowBox[{"Abs", "[", 
              RowBox[{"Max", "[", 
               RowBox[{"Apply", "[", 
                RowBox[{"Times", ",", "#", ",", 
                 RowBox[{"{", "1", "}"}]}], "]"}], "]"}], "]"}]}], "}"}], 
           "&"}], "[", 
          RowBox[{
           RowBox[{"Flatten", "[", 
            RowBox[{"eigenField", ",", 
             RowBox[{"fieldRank", "-", "1"}]}], "]"}], "\[LeftDoubleBracket]", 
           RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "]"}]}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"autoColor", "=", 
         RowBox[{
          RowBox[{"Hue", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"#1", "/", "\[Pi]"}], "+", "0.5"}], ",", 
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"#1", "-", "#2"}], "]"}], "/", 
             RowBox[{"(", 
              RowBox[{"#1", "+", "#2"}], ")"}]}], ",", " ", 
            RowBox[{"#1", "*", 
             RowBox[{"#2", "/", "maxDet"}]}]}], "]"}], "&"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"ellipseScale", "=", 
         RowBox[{"Switch", "[", "\[IndentingNewLine]", 
          RowBox[{"ellipseScale", ",", "\[IndentingNewLine]", 
           RowBox[{"_", "?", "NumericQ"}], ",", " ", 
           RowBox[{"ellipseScale", "/", 
            RowBox[{"(", 
             RowBox[{"2", "maxEigenvalue"}], ")"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Automatic", " ", "|", " ", "All"}], ",", 
           RowBox[{"1", "/", 
            RowBox[{"(", 
             RowBox[{
              SqrtBox["2"], "maxEigenvalue"}], ")"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"None", "|", "_"}], ",", " ", 
           RowBox[{"1", "/", 
            SqrtBox["2"]}]}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"colorFunction", "=", 
         RowBox[{"Switch", "[", "\[IndentingNewLine]", 
          RowBox[{
          "colorFunction", ",", "\[IndentingNewLine]", "_Function", ",", " ", 
           "colorFunction", ",", "\[IndentingNewLine]", "Automatic", " ", ",", 
           RowBox[{
            RowBox[{"Hue", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"#3", "/", "\[Pi]"}], "+", "0.5"}], ",", 
              RowBox[{
               RowBox[{"Abs", "[", 
                RowBox[{"#1", "-", "#2"}], "]"}], "/", 
               RowBox[{"(", 
                RowBox[{"#1", "+", "#2"}], ")"}]}], ",", " ", 
              RowBox[{"#1", "*", 
               RowBox[{"#2", "/", "maxDet"}]}]}], "]"}], "&"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"None", "|", "_"}], ",", " ", 
           RowBox[{"Gray", "&"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ellipseFunction", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"e1_", ",", "e2_"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"eVec_", ",", "_"}], "}"}]}], "}"}], ",", "pos_List"}], 
          "]"}], " ", ":=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"colorFunction", "[", 
              RowBox[{
               RowBox[{"Abs", "[", "e1", "]"}], ",", 
               RowBox[{"Abs", "[", "e2", "]"}], ",", "#"}], "]"}], ",", 
             RowBox[{"Rotate", "[", 
              RowBox[{
               RowBox[{"Disk", "[", 
                RowBox[{
                 RowBox[{"PadRight", "[", 
                  RowBox[{"pos", ",", "2"}], "]"}], ",", 
                 RowBox[{"ellipseScale", " ", 
                  RowBox[{"Abs", "[", 
                   RowBox[{"{", 
                    RowBox[{"e1", ",", "e2"}], "}"}], "]"}]}]}], "]"}], ",", 
               "#"}], "]"}]}], "}"}], "&"}], "[", 
          RowBox[{"ArcTan", "@@", "eVec"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"MapIndexed", "[", 
           RowBox[{"ellipseFunction", ",", 
            RowBox[{"If", "[", 
             RowBox[{"dr", ",", 
              RowBox[{"Reverse", "[", "eigenField", "]"}], ",", "eigenField", 
              ",", "eigenField"}], "]"}], ",", 
            RowBox[{"{", "fieldRank", "}"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"FilterRules", "[", 
           RowBox[{
            RowBox[{"{", "opts", "}"}], ",", 
            RowBox[{"Options", "[", "Graphics", "]"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}], " ", 
     "/;", " ", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"Dimensions", "[", "matField", "]"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "2", ",", "2"}], "}"}], "|", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_", ",", "2", ",", "2"}], "}"}]}]}], "]"}]}]}]}], 
  "\[IndentingNewLine]", "]"}]], "PackageInput",
 CellChangeTimes->{{3.445100292465343*^9, 3.4451002943394547`*^9}, {
   3.445100657662822*^9, 3.445100676259324*^9}, {3.4452509323075953`*^9, 
   3.4452509406202*^9}, 3.470140100815892*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["ListEllipsoidPlot3D", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ListEllipsoidPlot3D", "::", "vers"}], " ", "=", " ", 
   "\"\<ListEllipsoidPlot3D is not implemented for Mathematica versions prior \
6.0.\>\""}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"$VersionNumber", "<", "6"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ListEllipsoidPlot3D", "[", "__", "]"}], " ", ":=", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"ListEllipsePlot", "::", "vers"}], "]"}], ";", "$Failed"}], 
     ")"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ListEllipsoidPlot3D", "[", 
     RowBox[{"matField_List", ",", " ", "opts___Rule"}], "]"}], " ", ":=", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"eigenField", " ", "=", " ", 
          RowBox[{"Map", "[", 
           RowBox[{"Eigensystem", ",", 
            RowBox[{"N", "[", "matField", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"ArrayDepth", "[", "matField", "]"}], "-", "2"}], 
             "}"}]}], "]"}]}], ",", " ", "\[IndentingNewLine]", 
         RowBox[{"ellipsoidScale", " ", "=", " ", 
          RowBox[{
           RowBox[{"ScaleFactor", " ", "/.", " ", 
            RowBox[{"{", "opts", "}"}]}], " ", "/.", " ", 
           RowBox[{"Options", "[", "ListEllipsePlot", "]"}]}]}], ",", 
         "\[IndentingNewLine]", "maxEigenvalue", ",", "ellipsoidFunction", 
         ",", " ", 
         RowBox[{"fieldRank", " ", "=", " ", 
          RowBox[{
           RowBox[{"ArrayDepth", "[", "matField", "]"}], "-", "2"}]}]}], 
        "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"maxEigenvalue", " ", "=", " ", 
         RowBox[{"Abs", "[", 
          RowBox[{"Max", "[", 
           RowBox[{
            RowBox[{"Flatten", "[", 
             RowBox[{"eigenField", ",", 
              RowBox[{"fieldRank", "-", "1"}]}], "]"}], 
            "\[LeftDoubleBracket]", 
            RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ellipsoidScale", "=", 
         RowBox[{"Switch", "[", "\[IndentingNewLine]", 
          RowBox[{"ellipsoidScale", ",", "\[IndentingNewLine]", 
           RowBox[{"_", "?", "NumericQ"}], ",", " ", 
           RowBox[{"ellipsoidScale", "/", 
            RowBox[{"(", 
             RowBox[{"2", "maxEigenvalue"}], ")"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Automatic", " ", "|", " ", "All"}], ",", 
           RowBox[{"1", "/", 
            RowBox[{"(", 
             RowBox[{
              SqrtBox["2"], "maxEigenvalue"}], ")"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"None", "|", "_"}], ",", " ", 
           RowBox[{"1", "/", 
            SqrtBox["2"]}]}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ellipsoidFunction", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"eigenVals_", ",", "eigenVecs_"}], "}"}], ",", 
           "pos_List"}], "]"}], " ", ":=", " ", 
         RowBox[{"GeometricTransformation", "[", 
          RowBox[{
           RowBox[{"Sphere", "[", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "0"}], "}"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"ellipsoidScale", " ", 
               RowBox[{"Abs", "[", "eigenVals", "]"}], "  ", "eigenVecs"}], 
              "]"}], ",", 
             RowBox[{"PadRight", "[", 
              RowBox[{"pos", ",", "3"}], "]"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Graphics3D", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"MapIndexed", "[", 
           RowBox[{"ellipsoidFunction", ",", "eigenField", ",", 
            RowBox[{"{", "fieldRank", "}"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"FilterRules", "[", 
           RowBox[{
            RowBox[{"{", "opts", "}"}], ",", 
            RowBox[{"Options", "[", "Graphics3D", "]"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}], " ", 
     "/;", " ", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"Dimensions", "[", "matField", "]"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "3", ",", "3"}], "}"}], "|", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_", ",", "3", ",", "3"}], "}"}], "|", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_", ",", "_", ",", "3", ",", "3"}], "}"}]}]}], 
      "]"}]}]}]}], "\[IndentingNewLine]", "]"}]], "PackageInput"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ListLuminocityPlot", ",", "RasterPlot", ",", "PixelLabeling", ",", 
       "\[IndentingNewLine]", "ListEllipsePlot", ",", "ListEllipsoidPlot3D"}],
       "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Protected", ",", " ", "ReadProtected"}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1270, 967},
WindowMargins->{{Automatic, 76}, {Automatic, 0}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (November 10, 2008)",
StyleDefinitions->"PackageNotebook.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 34, 0, 144, "Title"],
Cell[604, 24, 165, 5, 118, "Subsubtitle"],
Cell[CellGroupData[{
Cell[794, 33, 25, 0, 72, "Section"],
Cell[822, 35, 128, 3, 39, "Text"],
Cell[953, 40, 1272, 30, 291, "PackageInput"],
Cell[2228, 72, 2830, 82, 751, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[5095, 159, 32, 0, 72, "Section"],
Cell[5130, 161, 92, 2, 130, "Text"],
Cell[5225, 165, 482, 11, 825, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5744, 181, 42, 0, 40, "Section"],
Cell[5789, 183, 240, 5, 283, "PackageInput",
 InitializationCell->True],
Cell[6032, 190, 689, 11, 748, "PackageInput",
 InitializationCell->True],
Cell[6724, 203, 528, 11, 514, "PackageInput"],
Cell[7255, 216, 1998, 39, 670, "PackageInput"],
Cell[9256, 257, 812, 13, 748, "PackageInput",
 InitializationCell->True],
Cell[10071, 272, 539, 12, 202, "PackageInput"],
Cell[10613, 286, 540, 9, 594, "PackageInput",
 InitializationCell->True],
Cell[11156, 297, 223, 6, 202, "PackageInput"],
Cell[11382, 305, 3972, 75, 1365, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[15391, 385, 31, 0, 40, "Section"],
Cell[15425, 387, 60, 0, 39, "Text"],
Cell[15488, 389, 149, 3, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[15662, 396, 107, 1, 94, "Subsection"],
Cell[15772, 399, 2914, 67, 472, "PackageInput"],
Cell[18689, 468, 1980, 48, 436, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20706, 521, 40, 0, 94, "Subsection"],
Cell[20749, 523, 635, 16, 4144, "PackageInput",
 InitializationCell->True],
Cell[21387, 541, 725, 19, 4144, "PackageInput",
 InitializationCell->True],
Cell[22115, 562, 734, 19, 4144, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[22886, 586, 32, 0, 55, "Subsection"],
Cell[22921, 588, 329, 9, 126, "PackageInput"],
Cell[23253, 599, 705, 18, 267, "PackageInput"],
Cell[23961, 619, 3378, 91, 552, "PackageInput"],
Cell[27342, 712, 2439, 60, 835, "PackageInput"],
Cell[29784, 774, 827, 23, 546, "PackageInput"],
Cell[30614, 799, 2456, 68, 393, "Input",
 Evaluatable->False],
Cell[33073, 869, 1918, 56, 450, "PackageInput"],
Cell[34994, 927, 11195, 267, 2574, "PackageInput",
 InitializationCell->True],
Cell[46192, 1196, 3904, 95, 1324, "Input"],
Cell[50099, 1293, 12099, 288, 2785, "PackageInput",
 InitializationCell->True],
Cell[62201, 1583, 7466, 171, 3543, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[69704, 1759, 37, 0, 82, "Subsection"],
Cell[69744, 1761, 209, 5, 454, "PackageInput"],
Cell[69956, 1768, 7633, 184, 7066, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[77626, 1957, 41, 0, 82, "Subsection"],
Cell[77670, 1959, 217, 5, 3219, "PackageInput"],
Cell[77890, 1966, 4575, 110, 26820, "PackageInput"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[82514, 2082, 34, 0, 162, "Section"],
Cell[82551, 2084, 64, 0, 195, "Text"],
Cell[82618, 2086, 645, 16, 1237, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
