(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     36815,       1050]
NotebookOptionsPosition[     34329,        965]
NotebookOutlinePosition[     34754,        983]
CellTagsIndexPosition[     34711,        980]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["G-Convolution Package", "Title"],

Cell["\<\
Renske de Boer, Erik Franken, Markus van Almsick
Technische Universiteit Eindhoven
\[Copyright]2005\
\>", "Subsubtitle",
 CellChangeTimes->{{3.488887319230188*^9, 3.488887319399323*^9}}],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\[IndentingNewLine]", 
   "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "[", "\"\<MathVisionTools`GConvolution`\>\"", "]"}],
      " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"2005", ",", "4", ",", "25", ",", "12", ",", "30", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput"],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`GConvolution`"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Author", ":", " ", 
      RowBox[{"Renske", " ", "de", " ", "Boer"}]}]}], ",", " ", 
    RowBox[{"Erik", " ", "Franken"}], ",", " ", 
    RowBox[{"Markus", " ", "van", " ", "Almsick"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"M", ".", "v", ".", 
       RowBox[{"Almsick", "@", "tue"}], ".", "nl"}]}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`GConvolution`"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "1.1"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "5.1"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2005"}]}]}], ",", " ", 
    RowBox[{"Technische", " ", "Universiteit", " ", "Eindhoven"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", 
     RowBox[{"G", "-", 
      RowBox[{
      "Convolution", " ", "of", " ", "the", " ", "2", "D", " ", "Euclidean", 
       " ", "Group"}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
      RowBox[{
      "This", " ", "package", " ", "implements", " ", "the", " ", "left", " ",
        "invariant", " ", "G"}], "-", 
      RowBox[{
      "convolution", " ", "of", " ", "the", " ", "Euclidean", " ", "group", 
       " ", "in", " ", "2", 
       RowBox[{"D", "."}]}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", 
      RowBox[{"Euclidean", " ", "group"}]}]}], ",", " ", 
    RowBox[{"rigid", " ", "transformation"}], ",", " ", 
    RowBox[{"symmetry", " ", "group"}], ",", " ", "convolution", ",", " ", 
    "gconvolution"}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"March", " ", "2005"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeginPackage", "[", "\[IndentingNewLine]", 
   RowBox[{
   "\"\<MathVisionTools`GConvolution`\>\"", ",", "\[IndentingNewLine]", 
    "\"\<MathVisionTools`ImageTransformation`\>\""}], "\[IndentingNewLine]", 
   "]"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{"Unprotect", "[", "\[IndentingNewLine]", 
  RowBox[{
  "GConjugateKernel", ",", "\[IndentingNewLine]", "GListConvolve", ",", 
   "GListCorrelate"}], "\[IndentingNewLine]", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"GConjugateKernel", "::", "usage"}], " ", "=", " ", 
   "\[IndentingNewLine]", 
   "\"\<GConjugateKernel[ker, \[CapitalDelta]\[Alpha]] transforms a \
G-convolution kernel into the corresponding G-correlation kernel and vice \
versa. \[CapitalDelta]\[Alpha] is the step size of the kernel in \
\[Alpha].\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GListConvolve", "::", "usage"}], "=", 
   "\"\<GListConvolve[ker, bndl] forms the G-convolution of the kernel ker \
with an orientation bundle bndl. Both, kernel and bundle, must be \
3-dimensional arrays. The first dimension is orientation, the second and \
third dimensions are spatial. The kernel in the G-convolution is rotated \
around its center axis. The default boundary conditions are cyclic in \
direction and space.\\n GListConvolve[{mmin,mmax,\[CapitalDelta]m},{mker,..}, \
bndl] performs the G-convolution of a steerable kernel with an orientation \
bundle bndl. The steerable kernel components mker are given in a List \
starting with the mmin-component and ending with the mmax-component in steps \
of \[CapitalDelta]m.\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"GListCorrelate", "::", "usage"}], "=", 
  "\"\<GListCorrelate[ker, bndl] forms the G-correlation of the kernel ker \
with an orientation bundle bndl. Both, kernel and bundle, must be \
3-dimensional arrays. The first dimension is orientation, the second and \
third dimensions are spatial. The kernel in the G-convolution is rotated \
around its center axis. The default boundary conditions are cyclic in \
direction and space.\\n \
GListCorrelate[{mmin,mmax,\[CapitalDelta]m},{mker,..}, bndl] performs the \
G-correlation of a steerable kernel with an orientation bundle bndl. The \
steerable kernel components mker are given in a List starting with the \
mmin-component and ending with the mmax-component in steps of \
\[CapitalDelta]m.\>\""}]}], "PackageInput",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Utility Functions", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CyclicTake", "[", 
   RowBox[{
    RowBox[{"a_", "?", "ArrayQ"}], ",", 
    RowBox[{"{", 
     RowBox[{"lower_Integer", ",", "upper_Integer"}], "}"}]}], "]"}], ":=", 
  " ", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"n", "=", 
      RowBox[{"Length", "[", "a", "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
    
    RowBox[{"If", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"lower", "\[LessEqual]", "upper"}], ",", "\[IndentingNewLine]", 
      
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Quotient", "[", 
          RowBox[{
           RowBox[{"lower", "-", "1"}], ",", "n"}], "]"}], "===", " ", 
         RowBox[{"Quotient", "[", 
          RowBox[{
           RowBox[{"upper", "-", "1"}], ",", "n"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Take", "[", 
         RowBox[{"a", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"Mod", "[", 
              RowBox[{
               RowBox[{"lower", "-", "1"}], ",", "n"}], "]"}], "+", "1"}], 
            ",", 
            RowBox[{
             RowBox[{"Mod", "[", 
              RowBox[{
               RowBox[{"upper", "-", "1"}], ",", "n"}], "]"}], "+", "1"}]}], 
           "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"Take", "[", 
           RowBox[{"a", ",", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"Mod", "[", 
               RowBox[{
                RowBox[{"-", "lower"}], ",", "n"}], "]"}]}], "-", "1"}]}], 
           "]"}], ",", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"Table", "[", 
            RowBox[{"a", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Quotient", "[", 
                RowBox[{
                 RowBox[{"upper", "-", "1"}], ",", "n"}], "]"}], "-", 
               RowBox[{"Quotient", "[", 
                RowBox[{
                 RowBox[{"lower", "-", "1"}], ",", "n"}], "]"}], "-", "1"}], 
              "}"}]}], "]"}]}], ",", 
          RowBox[{"Take", "[", 
           RowBox[{"a", ",", 
            RowBox[{
             RowBox[{"Mod", "[", 
              RowBox[{
               RowBox[{"upper", "-", "1"}], ",", "n"}], "]"}], "+", "1"}]}], 
           "]"}]}], "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", "}"}]}], "\[IndentingNewLine]", "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["GConjugateKernel", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GConjugateKernel", "[", 
   RowBox[{"Kern", "[", 
    RowBox[{"b", ",", "\[Alpha]"}], "]"}], "]"}], " ", "=", " ", 
  RowBox[{"Kern", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      SubsuperscriptBox["R", "\[Alpha]", 
       RowBox[{"-", "1"}]]}], " ", "b"}], ",", 
    RowBox[{"-", "\[Alpha]"}]}], "]"}]}]], "Input",
 Evaluatable->False],

Cell[BoxData[
 RowBox[{
  RowBox[{"GConjugateKernel", "[", 
   RowBox[{
    RowBox[{"kernel_", "?", "ArrayQ"}], ",", 
    RowBox[{"d\[Alpha]_", "?", "NumericQ"}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"kernelCenter", " ", "=", " ", 
       RowBox[{"Ceiling", "[", 
        RowBox[{
         RowBox[{"Dimensions", "[", "kernel", "]"}], "/", "2"}], "]"}]}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Map", "[", 
      RowBox[{"Reverse", ",", 
       RowBox[{"Rotate3DConvoluteKernel", "[", 
        RowBox[{"kernel", ",", "0", ",", 
         RowBox[{
         "kernelCenter", "\[LeftDoubleBracket]", "1", 
          "\[RightDoubleBracket]"}], ",", 
         RowBox[{
         "kernelCenter", "\[LeftDoubleBracket]", "2", 
          "\[RightDoubleBracket]"}], ",", 
         RowBox[{
         "kernelCenter", "\[LeftDoubleBracket]", "3", 
          "\[RightDoubleBracket]"}], ",", 
         RowBox[{"N", "[", 
          RowBox[{"-", "d\[Alpha]"}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "2"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
    "]"}], "/;", " ", 
   RowBox[{
    RowBox[{"ArrayDepth", "[", "kernel", "]"}], "===", 
    "3"}]}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Steerable GConjugateKernel", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GConjugateKernel", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"mmin_", ",", "mmax_", ",", "dm_"}], "}"}], ",", 
    RowBox[{"mkernels_", "?", "ArrayQ"}], ",", 
    RowBox[{"d\[Alpha]_", "?", "NumericQ"}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"kn", " ", "=", " ", 
       RowBox[{
        RowBox[{"Dimensions", "[", "mkernels", "]"}], "\[LeftDoubleBracket]", 
        "2", "\[RightDoubleBracket]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"k0", "=", 
       RowBox[{"Ceiling", "[", 
        RowBox[{"kn", "/", "2"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Map", "[", 
       RowBox[{"Reverse", ",", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Exp", "[", 
            RowBox[{"\[ImaginaryI]", " ", "m", " ", "d\[Alpha]", " ", "k"}], 
            "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", "mmin", ",", "mmax", ",", "dm"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"k", ",", 
             RowBox[{"1", "-", "k0"}], ",", 
             RowBox[{"kn", "-", "k0"}]}], "}"}]}], "]"}], " ", "mkernels"}], 
        ",", "3"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"ArrayDepth", "[", "mkernels", "]"}], "===", "4"}], "\[And]", 
    " ", 
    RowBox[{
     RowBox[{"Length", "[", "mkernels", "]"}], "===", 
     RowBox[{"Length", "[", 
      RowBox[{"Range", "[", 
       RowBox[{"mmin", ",", "mmax", ",", "dm"}], "]"}], 
      "]"}]}]}]}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["GListCorrelate", "Subsection"],

Cell[BoxData[
 RowBox[{
  SubsuperscriptBox["\[Integral]", 
   RowBox[{"-", "\[Infinity]"}], "\[Infinity]"], 
  RowBox[{
   SubsuperscriptBox["\[Integral]", "0", 
    RowBox[{"2", "\[Pi]"}]], 
   RowBox[{
    RowBox[{"Kern", "[", 
     RowBox[{
      RowBox[{
       SubsuperscriptBox["R", "\[Alpha]", 
        RowBox[{"-", "1"}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"b", "'"}], "-", "b"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{"\[Alpha]", "'"}], "-", "\[Alpha]"}]}], "]"}], " ", 
    RowBox[{"U", "[", 
     RowBox[{
      RowBox[{"b", "'"}], ",", 
      RowBox[{"\[Alpha]", "'"}]}], "]"}], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{"\[Alpha]", "'"}]}], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{"b", "'"}]}]}]}]}]], "Input",
 Evaluatable->False],

Cell[BoxData[
 RowBox[{
  RowBox[{"Rotate3DCorrelateKernel", "=", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Alpha]", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y0", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x0", ",", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"kn", ",", "yn", ",", "xn", ",", 
         RowBox[{"s", " ", "=", " ", 
          RowBox[{"Sin", "[", "\[Alpha]", "]"}]}], ",", " ", 
         RowBox[{"c", " ", "=", " ", 
          RowBox[{"Cos", "[", "\[Alpha]", "]"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"kn", ",", "yn", ",", "xn"}], "}"}], " ", "=", " ", 
         RowBox[{"Dimensions", "[", "img", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Transpose", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Table", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"NLinear2DImageInterpolation3D", "[", 
             RowBox[{"img", ",", 
              RowBox[{
               RowBox[{"c", " ", "x"}], "-", 
               RowBox[{"s", " ", "y"}], "+", "x0"}], ",", 
              RowBox[{
               RowBox[{"s", " ", "x"}], "+", 
               RowBox[{"c", " ", "y"}], "+", "y0"}], ",", "xn", ",", "yn", 
              ",", "kn", ",", "0"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"y", ",", 
              RowBox[{"1", "-", "y0"}], ",", 
              RowBox[{"yn", "-", "y0"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"x", ",", 
              RowBox[{"1", "-", "x0"}], ",", 
              RowBox[{"xn", "-", "x0"}]}], "}"}]}], "\[IndentingNewLine]", 
           "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"2", ",", "3", ",", "1"}], "}"}]}], "\[IndentingNewLine]", 
         "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"NLinear2DImageInterpolation3D", "[", 
         RowBox[{
         "_", ",", "_", ",", "_", ",", "_", ",", "_", ",", "_", ",", "_"}], 
         "]"}], ",", "_Real", ",", "1"}], "}"}], "}"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GListCorrelate", "[", 
   RowBox[{
    RowBox[{"kernel_", "?", "ArrayQ"}], ",", 
    RowBox[{"bndl_", "?", "ArrayQ"}]}], "]"}], " ", ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"kernelHeight", " ", "=", " ", 
        RowBox[{"Length", "[", "kernel", "]"}]}], ",", 
       RowBox[{"kernelCenter", " ", "=", " ", 
        RowBox[{"Ceiling", "[", 
         RowBox[{
          RowBox[{"Dimensions", "[", "kernel", "]"}], "/", "2"}], "]"}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"bndlHeight", "=", 
        RowBox[{"Length", "[", "bndl", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"2", 
      RowBox[{"\[Pi]", " ", "/", " ", "bndlHeight"}], " ", "*", " ", 
      "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"With", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"rotKernel", " ", "=", " ", 
            RowBox[{"Rotate3DCorrelateKernel", "[", 
             RowBox[{"kernel", ",", 
              RowBox[{
               RowBox[{"-", "2"}], "\[Pi]", " ", 
               RowBox[{"\[Alpha]k", "/", "bndlHeight"}]}], ",", 
              RowBox[{
              "kernelCenter", "\[LeftDoubleBracket]", "2", 
               "\[RightDoubleBracket]"}], ",", 
              RowBox[{
              "kernelCenter", "\[LeftDoubleBracket]", "3", 
               "\[RightDoubleBracket]"}]}], "]"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"First", "[", 
           RowBox[{"ListCorrelate", "[", 
            RowBox[{"rotKernel", ",", 
             RowBox[{"CyclicTake", "[", 
              RowBox[{"bndl", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\[Alpha]k", "-", 
                  RowBox[{
                  "kernelCenter", "\[LeftDoubleBracket]", "1", 
                   "\[RightDoubleBracket]"}], "+", "2"}], ",", 
                 RowBox[{"\[Alpha]k", "+", 
                  RowBox[{
                  "kernelCenter", "\[LeftDoubleBracket]", "1", 
                   "\[RightDoubleBracket]"}]}]}], "}"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{"#", ",", 
                 RowBox[{"-", "#"}]}], "}"}], "&"}], "[", 
              RowBox[{"Prepend", "[", 
               RowBox[{
                RowBox[{"Rest", "[", "kernelCenter", "]"}], ",", "1"}], "]"}],
               "]"}], ",", "0"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"\[Alpha]k", ",", "0", ",", 
          RowBox[{"bndlHeight", "-", "1"}]}], "}"}]}], "\[IndentingNewLine]", 
       "]"}]}]}], "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{
    RowBox[{"ArrayDepth", "[", "kernel", "]"}], " ", "===", " ", 
    RowBox[{"ArrayDepth", "[", "bndl", "]"}], " ", "===", 
    "3"}]}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["GListConvolve", "Subsection"],

Cell[BoxData[
 RowBox[{
  SubsuperscriptBox["\[Integral]", 
   RowBox[{"-", "\[Infinity]"}], "\[Infinity]"], 
  RowBox[{
   SubsuperscriptBox["\[Integral]", "0", 
    RowBox[{"2", "\[Pi]"}]], 
   RowBox[{
    RowBox[{"Kern", "[", 
     RowBox[{
      RowBox[{
       SubsuperscriptBox["R", 
        RowBox[{"\[Alpha]", "'"}], 
        RowBox[{"-", "1"}]], 
       RowBox[{"(", 
        RowBox[{"b", "-", 
         RowBox[{"b", "'"}]}], ")"}]}], ",", 
      RowBox[{"\[Alpha]", "-", 
       RowBox[{"\[Alpha]", "'"}]}]}], "]"}], " ", 
    RowBox[{"U", "[", 
     RowBox[{
      RowBox[{"b", "'"}], ",", 
      RowBox[{"\[Alpha]", "'"}]}], "]"}], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{"\[Alpha]", "'"}]}], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{"b", "'"}]}]}]}]}]], "Input",
 Evaluatable->False],

Cell[BoxData[
 RowBox[{
  RowBox[{"Rotate3DConvoluteKernel", "=", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Alpha]", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"k0", ",", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y0", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x0", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"d\[Alpha]", ",", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"kn", ",", "yn", ",", "xn"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"kn", ",", "yn", ",", "xn"}], "}"}], " ", "=", " ", 
         RowBox[{"Dimensions", "[", "img", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"With", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"s", " ", "=", " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"\[Alpha]", "-", 
                 RowBox[{"k", " ", "d\[Alpha]"}]}], "]"}]}], ",", " ", 
              RowBox[{"c", " ", "=", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Alpha]", "-", 
                 RowBox[{"k", " ", "d\[Alpha]"}]}], "]"}]}]}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"NLinearImageInterpolation", "[", 
               RowBox[{
                RowBox[{"img", "\[LeftDoubleBracket]", 
                 RowBox[{"k", "+", "k0"}], "\[RightDoubleBracket]"}], ",", 
                RowBox[{
                 RowBox[{"c", " ", "x"}], "-", 
                 RowBox[{"s", " ", "y"}], "+", "x0"}], ",", 
                RowBox[{
                 RowBox[{"s", " ", "x"}], "+", 
                 RowBox[{"c", " ", "y"}], "+", "y0"}], ",", "xn", ",", "yn", 
                ",", "0"}], "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"y", ",", 
                RowBox[{"1", "-", "y0"}], ",", 
                RowBox[{"yn", "-", "y0"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"x", ",", 
                RowBox[{"1", "-", "x0"}], ",", 
                RowBox[{"xn", "-", "x0"}]}], "}"}]}], "\[IndentingNewLine]", 
             "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"k", ",", 
            RowBox[{"1", "-", "k0"}], ",", 
            RowBox[{"kn", "-", "k0"}]}], "}"}]}], "\[IndentingNewLine]", 
         "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"NLinearImageInterpolation", "[", 
         RowBox[{"_", ",", "_", ",", "_", ",", "_", ",", "_", ",", "_"}], 
         "]"}], ",", "_Real"}], "}"}], "}"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GListConvolve", "[", 
   RowBox[{
    RowBox[{"kernel_", "?", "ArrayQ"}], ",", 
    RowBox[{"bndl_", "?", "ArrayQ"}]}], "]"}], " ", ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"kernelHeight", " ", "=", " ", 
        RowBox[{"Length", "[", "kernel", "]"}]}], ",", 
       RowBox[{"kernelCenter", " ", "=", " ", 
        RowBox[{"Ceiling", "[", 
         RowBox[{
          RowBox[{"Dimensions", "[", "kernel", "]"}], "/", "2"}], "]"}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"bndlHeight", "=", 
        RowBox[{"Length", "[", "bndl", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"2", 
      RowBox[{"\[Pi]", " ", "/", " ", "bndlHeight"}], " ", "*", " ", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"With", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"rotKernel", " ", "=", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"Rotate3DConvoluteKernel", "[", 
               RowBox[{"kernel", ",", 
                RowBox[{
                 RowBox[{"-", "2"}], "\[Pi]", " ", 
                 RowBox[{"\[Alpha]k", "/", "bndlHeight"}]}], ",", "##", ",", 
                RowBox[{
                 RowBox[{"-", "2"}], " ", 
                 RowBox[{"\[Pi]", "/", "bndlHeight"}]}]}], "]"}], "&"}], "@@",
              "kernelCenter"}]}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"First", "[", 
           RowBox[{"ListConvolve", "[", 
            RowBox[{"rotKernel", ",", 
             RowBox[{"CyclicTake", "[", 
              RowBox[{"bndl", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\[Alpha]k", "-", 
                  RowBox[{
                  "kernelCenter", "\[LeftDoubleBracket]", "1", 
                   "\[RightDoubleBracket]"}], "+", "2"}], ",", 
                 RowBox[{"\[Alpha]k", "+", 
                  RowBox[{
                  "kernelCenter", "\[LeftDoubleBracket]", "1", 
                   "\[RightDoubleBracket]"}]}]}], "}"}]}], "]"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "#"}], ",", "#"}], "}"}], "&"}], "[", 
              RowBox[{"Prepend", "[", 
               RowBox[{
                RowBox[{"Rest", "[", "kernelCenter", "]"}], ",", "1"}], "]"}],
               "]"}], ",", "0"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"\[Alpha]k", ",", "0", ",", 
          RowBox[{"bndlHeight", "-", "1"}]}], "}"}]}], "\[IndentingNewLine]", 
       "]"}]}]}], "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{
    RowBox[{"ArrayDepth", "[", "kernel", "]"}], " ", "===", " ", 
    RowBox[{"ArrayDepth", "[", "bndl", "]"}], " ", "===", 
    "3"}]}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Steerable GListCorrelate", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GListCorrelate", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"mmin_", ",", "mmax_", ",", "dm_"}], "}"}], ",", 
    RowBox[{"mkernels_", "?", "ArrayQ"}], ",", 
    RowBox[{"bndl_", "?", "ArrayQ"}]}], "]"}], " ", ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"kernelHeight", " ", "=", " ", 
        RowBox[{"Length", "[", 
         RowBox[{
         "mkernels", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
         "]"}]}], ",", 
       RowBox[{"kernelCenter", " ", "=", " ", 
        RowBox[{"Ceiling", "[", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"Dimensions", "[", "mkernels", "]"}], "]"}], "/", "2"}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"bndlHeight", "=", 
        RowBox[{"Length", "[", "bndl", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"2", 
      RowBox[{"\[Pi]", " ", "/", " ", "bndlHeight"}], " ", "*", " ", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"With", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"rotKernel", " ", "=", " ", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Exp", "[", 
                RowBox[{
                 RowBox[{"-", "2"}], "\[ImaginaryI]", " ", "\[Pi]", " ", "m", 
                 " ", 
                 RowBox[{"\[Alpha]k", "/", "bndlHeight"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"m", ",", "mmin", ",", "mmax", ",", "dm"}], "}"}]}], 
              "]"}], ".", "mkernels"}]}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"First", "[", 
           RowBox[{"ListCorrelate", "[", 
            RowBox[{"rotKernel", ",", 
             RowBox[{"CyclicTake", "[", 
              RowBox[{"bndl", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\[Alpha]k", "-", 
                  RowBox[{
                  "kernelCenter", "\[LeftDoubleBracket]", "1", 
                   "\[RightDoubleBracket]"}], "+", "2"}], ",", 
                 RowBox[{"\[Alpha]k", "+", 
                  RowBox[{
                  "kernelCenter", "\[LeftDoubleBracket]", "1", 
                   "\[RightDoubleBracket]"}]}]}], "}"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{"#", ",", 
                 RowBox[{"-", "#"}]}], "}"}], "&"}], "[", 
              RowBox[{"Prepend", "[", 
               RowBox[{
                RowBox[{"Rest", "[", "kernelCenter", "]"}], ",", "1"}], "]"}],
               "]"}], ",", "0"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"\[Alpha]k", ",", "0", ",", 
          RowBox[{"bndlHeight", "-", "1"}]}], "}"}]}], "\[IndentingNewLine]", 
       "]"}]}]}], "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"ArrayDepth", "[", "mkernels", "]"}], "===", "4"}], " ", 
    "\[And]", " ", 
    RowBox[{
     RowBox[{"ArrayDepth", "[", "bndl", "]"}], " ", "===", "3"}], "\[And]", 
    " ", 
    RowBox[{
     RowBox[{"Length", "[", "mkernels", "]"}], "===", 
     RowBox[{"Length", "[", 
      RowBox[{"Range", "[", 
       RowBox[{"mmin", ",", "mmax", ",", "dm"}], "]"}], 
      "]"}]}]}]}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Steerable GListConvolve", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GListConvolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"mmin_", ",", "mmax_", ",", "dm_"}], "}"}], ",", 
    RowBox[{"mkernels_", "?", "ArrayQ"}], ",", 
    RowBox[{"bndl_", "?", "ArrayQ"}]}], "]"}], " ", ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"GListCorrelate", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"mmin", ",", "mmax", ",", "dm"}], "}"}], ",", 
     RowBox[{"GConjugateKernel", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"mmin", ",", "mmax", ",", "dm"}], "}"}], ",", "mkernels", ",", 
       RowBox[{"2", 
        RowBox[{"\[Pi]", "/", 
         RowBox[{"Length", "[", "bndl", "]"}]}]}]}], "]"}], ",", "bndl"}], 
    "]"}], "/;", "  ", 
   RowBox[{
    RowBox[{
     RowBox[{"ArrayDepth", "[", "mkernels", "]"}], "===", "4"}], " ", 
    "\[And]", " ", 
    RowBox[{
     RowBox[{"ArrayDepth", "[", "bndl", "]"}], " ", "===", "3"}], "\[And]", 
    " ", 
    RowBox[{
     RowBox[{"Length", "[", "mkernels", "]"}], "===", 
     RowBox[{"Length", "[", 
      RowBox[{"Range", "[", 
       RowBox[{"mmin", ",", "mmax", ",", "dm"}], "]"}], 
      "]"}]}]}]}]}]], "PackageInput"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "GConjugateKernel", ",", "\[IndentingNewLine]", "GListConvolve", ",", 
       "GListCorrelate"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Protected", ",", " ", "ReadProtected", ",", "Locked"}], 
      "}"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1221, 744},
WindowMargins->{{4, Automatic}, {Automatic, 0}},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"PackageNotebook.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 38, 0, 153, "Title"],
Cell[608, 24, 196, 5, 127, "Subsubtitle"],
Cell[CellGroupData[{
Cell[829, 33, 25, 0, 77, "Section"],
Cell[857, 35, 947, 24, 436, "PackageInput"],
Cell[1807, 61, 128, 3, 58, "Text"],
Cell[1938, 66, 3597, 100, 1195, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5572, 171, 32, 0, 45, "Section"],
Cell[5607, 173, 92, 2, 105, "Text"],
Cell[5702, 177, 517, 11, 555, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6256, 193, 42, 0, 45, "Section"],
Cell[6301, 195, 2044, 35, 712, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[8382, 235, 31, 0, 77, "Section"],
Cell[8416, 237, 60, 0, 58, "Text"],
Cell[8479, 239, 108, 2, 90, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[8612, 245, 39, 0, 94, "Subsection"],
Cell[8654, 247, 2627, 73, 865, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[11318, 325, 38, 0, 55, "Subsection"],
Cell[11359, 327, 381, 12, 67, "Input",
 Evaluatable->False],
Cell[11743, 341, 1311, 36, 265, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[13091, 382, 48, 0, 55, "Subsection"],
Cell[13142, 384, 1681, 45, 400, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[14860, 434, 36, 0, 55, "Subsection"],
Cell[14899, 436, 786, 26, 96, "Input",
 Evaluatable->False],
Cell[15688, 464, 2610, 64, 612, "PackageInput"],
Cell[18301, 530, 3113, 76, 610, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[21451, 611, 35, 0, 55, "Subsection"],
Cell[21489, 613, 810, 27, 96, "Input",
 Evaluatable->False],
Cell[22302, 642, 3337, 81, 715, "PackageInput"],
Cell[25642, 725, 3011, 73, 576, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[28690, 803, 46, 0, 55, "Subsection"],
Cell[28739, 805, 3534, 89, 918, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[32310, 899, 45, 0, 55, "Subsection"],
Cell[32358, 901, 1165, 34, 348, "PackageInput"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[33572, 941, 34, 0, 45, "Section"],
Cell[33609, 943, 64, 0, 105, "Text"],
Cell[33676, 945, 625, 16, 555, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
