(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    133649,       3760]
NotebookOptionsPosition[    128089,       3587]
NotebookOutlinePosition[    128510,       3605]
CellTagsIndexPosition[    128467,       3602]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["HankelTransform Package", "Title"],

Cell["\<\
Markus van Almsick
Technische Universiteit Eindhoven
\[Copyright]2009\
\>", "Subsubtitle",
 CellChangeTimes->{{3.4633932300481157`*^9, 3.46339323038628*^9}, {
  3.488887391267486*^9, 3.488887391685356*^9}}],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
     "TimeStamp", "[", "\"\<MathVisionTools`HankelTransform`\>\"", "]"}], " ",
      "=", " ", 
     RowBox[{"{", 
      RowBox[{"2009", ",", "10", ",", "1", ",", "15", ",", "40", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput",
 CellChangeTimes->{{3.4633932038413467`*^9, 3.46339321430049*^9}}],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contemns, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`HankelTransform`"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Author", ":", " ", 
     RowBox[{"Markus", " ", "van", " ", "Almsick"}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"M", ".", "v", ".", 
       RowBox[{"Almsick", "@", "tue"}], ".", "nl"}]}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`HankelTransform`"}]}], 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "1.2"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "5.0"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2004"}]}]}], ",", " ", 
    RowBox[{"Technische", " ", "Universiteit", " ", "Eindhoven"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "HankelTransform"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "implements", " ", "the", " ", "Hankel", 
      " ", "transformation"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", 
      RowBox[{"Hankel", " ", "Transformation"}]}]}], " ", ",", " ", 
    RowBox[{"Fourier", "-", 
     RowBox[{"Bessel", " ", "Transformation"}]}], ",", " ", 
    RowBox[{"Fourier", " ", "Transformation"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"July", " ", "2004"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.4633932216267776`*^9, 3.4633932248980227`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<MathVisionTools`HankelTransform`\>\"", ",", 
    RowBox[{"{", "\"\<MathVisionTools`GaussianDerivative`\>\"", "}"}]}], 
   "]"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{"Unprotect", "[", 
  RowBox[{
  "HankelTransform", ",", "InverseHankelTransform", ",", 
   "GaussHankelCoefficient", ",", "\[IndentingNewLine]", 
   "HalfGaussHankelCoefficient", ",", "HankelBasis", ",", "NHankelBasis", ",",
    "HankelBasisEigenvalue", ",", "HankelBasisNList", ",", 
   "NHankelBasisNList", ",", "HankelBasisNMList", ",", "NHankelBasisNMList", 
   ",", "HankelBasisRadius", ",", "PolarFourierScale", ",", 
   "PolarFourierNMax", ",", "PolarFourier", ",", "InversePolarFourier", ",", 
   "RotatePolarFourierPhase", ",", "CenteredFourier", ",", 
   "InverseCenteredFourier"}], "]"}]}], "PackageInput",
 CellChangeTimes->{{3.463392850968161*^9, 3.463392851306054*^9}, 
   3.464082989186309*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HankelTransform", "::", "usage"}], "=", 
    "\"\<HankelTransform[expr, r, \[Rho]] gives the symbolic Hankel transform \
of expr. HankelTransform[m][expr, r, \[Rho]] gives the symbolic m-mode Hankel \
transform of expr for the radial component of an angular \
\!\(\*SuperscriptBox[\(\[ExponentialE]\), \(\[ImaginaryI]\\\ m\\\ \[CurlyPhi]\
\)]\) representaton.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"InverseHankelTransform", "::", "usage"}], "=", 
    "\"\<InverseHankelTransform[expr, \[Rho], r] gives the symbolic inverse \
Hankel transform of expr. InverseHankelTransform[m][expr, \[Rho], r] gives \
the symbolic inverse Hankel transform of expr for the radial component of an \
angular \!\(\*SuperscriptBox[\(\[ExponentialE]\), \(\[ImaginaryI]\\\ m\\\ \
\[CurlyPhi]\)]\) representaton.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"GaussHankelCoefficient", "::", "usage"}], "=", " ", 
    "\"\<GaussHankelCoefficient[t,{\!\(\*SubscriptBox[\(n\), \
\(x\)]\),\!\(\*SubscriptBox[\(n\), \(y\)]\)},n,m] renders the hermitian \
product of a 2-dimensional GaussianDKernel[t,{\!\(\*SubscriptBox[\(n\), \
\(x\)]\),\!\(\*SubscriptBox[\(n\), \(y\)]\)},{x,y}] and a HankelBasis[n,m,x+\
\[ImaginaryI]*y]. GaussHankelCoefficients help to decompose GaussianDKernels \
into a HankelBasis. The default scale is t = 1/2, which permits a finite \
decomposition with |m|\[LessEqual]\!\(\*SubscriptBox[\(n\), \
\(x\)]\)+\!\(\*SubscriptBox[\(n\), \(y\)]\) and \
n\[LessEqual]1+(\!\(\*SubscriptBox[\(n\), \(x\)]\)+\!\(\*SubscriptBox[\(n\), \
\(y\)]\))/2.\>\""}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HalfGaussHankelCoefficient", "::", "usage"}], "=", " ", 
    "\"\<HalfGaussHankelCoefficient[t,n,m] renders the hermitian product of \
the 2-dimensional GaussianKernel[t,{x,y}]*UnitStep[x] on the positive x \
quadrants and a HankelBasis[n,m,x+\[ImaginaryI]*y]. \
HalfGaussHankelCoefficient[t,{ny},n,m] renders the hermitian product of the \
2-dimensional GaussianDKernel[t,{0,ny},{x,y}]*UnitStep[x] on the positive x \
quadrants and a HankelBasis[n,m,x+\[ImaginaryI]*y. \
HalfGaussHankelCoefficients help to decompose one half of a GaussianKernel \
into a HankelBasis. The default scale is t = 1/2.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HankelBasis", "::", "usage"}], "=", 
    "\"\<HankelBasis[n,z] is an orthonormal basis of eigenfunctions of the \
Hankel transformation consisting of a Gaussian kernel and Laguerre \
polynomials. HankelBasis[n,m,z] is an orthonormal basis of eigenfunctions of \
the m-mode Hankel transformation.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NHankelBasis", "::", "usage"}], "=", 
    "\"\<NHankelBasis[n,z] is a fast numerical implementation of an \
orthonormal basis of eigenfunctions of the Hankel transformation consisting \
of a Gaussian kernel and Laguerre polynomials. NHankelBasis[n,m,z] is a fast \
numerical implementation of an orthonormal basis of eigenfunctions of the \
m-mode Hankel transformation.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HankelBasisEigenvalue", "::", "usage"}], "=", 
    "\"\<HankelBasisEigenvalue[n] renders the HankelTranform eigenvalues of \
the HankelBasis[n,z]. HankelBasisEigenvalue[n,m] renders the m-mode \
HankelTranform eigenvalues of the HankelBasis[n,m,z].\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HankelBasisNList", "::", "usage"}], "=", 
    "\"\<HankelBasisNList[nmax,z] generates a List of the orthonormal basis \
of HankeTransform eigenfunctions HankelBasis[0,z] through \
HankelBasis[nmax,z]. HankelBasisNList[nmax,m,z] generates a List of the \
orthonormal basis of m-mode HankeTransform eigenfunctions HankelBasis[0,m,z] \
through HankelBasis[nmax,m,z].\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NHankelBasisNList", "::", "usage"}], "=", 
    "\"\<NHankelBasisNList[nmax,z] numerically generates a List of values of \
the orthonormal basis of HankeTransform eigenfunctions HankelBasis[0,z] \
through HankelBasis[nmax,z]. HankelBasisNList[nmax,m,z] numerically generates \
a List of values of the orthonormal basis of m-mode HankeTransform \
eigenfunctions HankelBasis[0,m,z] through HankelBasis[nmax,m,z].\>\""}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HankelBasisNMList", "::", "usage"}], "=", 
    "\"\<HankelBasisNMList[nmax,mmax,z] generates a 2-dimensional List of the \
orthonormal basis of m-mode HankeTransform eigenfunctions HankelBasis[0,m,z] \
through HankelBasis[nmax,m,z] for m = 0 to mmax.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NHankelBasisNMList", "::", "usage"}], "=", 
    "\"\<NHankelBasisNMList[nmax,mmax,z] numerically generates a \
2-dimensional List of values of the orthonormal basis of m-mode \
HankeTransform eigenfunctions HankelBasis[0,m,z] through \
HankelBasis[nmax,m,z] for m = 0 to mmax.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HankelBasisRadius", "::", "usage"}], "=", 
    "\"\<HankelBasisRadius[n,m,t] renders the radius, in which the \
HankelBasis function is essentially unequal 0 and does not decay \
exponentially for r torwards infinity. n is the radial quantum number. m is \
the angular quantum number. t is the scale parameter.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PolarFourierScale", "::", "usage"}], "=", 
    "\"\<PolarFourierScale[{xdim,ydim}] determines the optimal scale \
parameter t for a PolarFourier transformation of a (xdim,ydim)-dimensional \
array.\>\""}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PolarFourierNMax", "::", "usage"}], "=", 
    "\"\<PolarFourierNMax[{xdim,ydim}] determines the largest n-mode in a \
PolarFourier transformation so that the n-th Hankel basis function still fits \
into a (xdim,ydim)-dimensional array at optimal scale t (see \
PolarFourierScale). PolarFourierNMax[t,{xdim,ydim}] determines the largest \
n-mode for a given scale parameter t.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PolarFourier", "::", "usage"}], "=", 
    "\"\<PolarFourier[data,nmax,mmax] performs a polar Fourier transformation \
on 2-dimensional discrete data and renders the radial Fourier coefficients 0 \
to nmax and the angular Fourier coefficients -mmax to mmax. If omitted, \
optimal nmax and mmax are determined automatically (see PolarFourierNMax). \
PolarFourier[t,\[Alpha]][data,nmax,mmax] performs a polar Fourier \
transformation at scale t if \[Alpha] = \[Pi]/2. For \[Alpha] = 0 \
PolarFourier performs a basis transformation into the Hankel basis at scale \
t. If t is omitted, the optimal scale parameter is calculated via the \
PolarFourierScale function.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"InversePolarFourier", "::", "usage"}], "=", 
    "\"\<InversePolarFourier[coefficients,{xdim,ydim}] performs an inverse \
polar Fourier transformation on the radial and angular Fourier coefficients \
and renders the result on a Cartesian grid of xdim and ydim dimensions. If \
the dimensions xdim and ydim are not given InversePolarFourier determines an \
appropriate set of dimensions automatically. \
InversePolarFourier[t,\[Alpha]][coefficients,{xdim,ydim}] performs an inverse \
polar Fourier transformation at scale t if \[Alpha] = -\[Pi]/2. For \[Alpha] \
= 0 InversePolarFourier performs a basis transformation from the Hankel basis \
at scale t back into regular Cartesian coordinates. If t is omitted, the \
optimal scale parameter is calculated via the PolarFourierScale \
function.\>\""}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"RotatePolarFourierPhase", "::", "usage"}], "=", 
    "\"\<RotatePolarFourierPhase[coefficients] multiplies the coefficients of \
a polar Fourier transformation with their Eigenvalues to perform a Fourier \
transformation of the Hankel basis. RotatePolarFourierPhase[coefficients,\
\[Alpha]] is a continuous transition of a Hankel basis to its Fourier \
transformed for \[Alpha] going from 0 to \[Pi]/2.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CenteredFourier", "::", "usage"}], "=", 
    "\"\<CenteredFourier[list] finds the discrete Cartesian Fourier transform \
of a n-dimensional list of complex numbers such that the rendered spectrum \
displays the negative frequencies to the left of the 0-frequency and the \
positive frequencies to the right. The center of the image and Fourier space \
is at Floor[dims]+1.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"InverseCenteredFourier", "::", "usage"}], "=", 
   "\"\<InverseCenteredFourier[list] finds the discrete Cartesian inverse \
Fourier transform of a n-dimensional list of complex numbers that represents \
a spectrum with the negative frequencies to the left of the 0-frequency and \
the positive frequencies to the right. The center of the image and Fourier \
space is at Floor[dims]+1.\>\""}], ";"}]}], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.463392862879758*^9, 3.463393151694189*^9}, {
  3.464082998518482*^9, 3.464083177661978*^9}, {3.464120490846053*^9, 
  3.4641205249442368`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Hankel Transform", "Subsection"],

Cell[TextData[{
 "Note, that the Hankel transform is the same for ",
 Cell[BoxData["m"]],
 " and ",
 Cell[BoxData[
  RowBox[{"-", "m"}]]],
 "."
}], "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"HankelTransform", "[", 
    RowBox[{"f_", ",", "r_", ",", "\[Omega]_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{"f", "  ", "r", " ", 
      RowBox[{"BesselJ", "[", 
       RowBox[{"0", ",", 
        RowBox[{"r", " ", "\[Omega]"}]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", "\[Infinity]"}], "}"}], ",", 
     RowBox[{"Assumptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"r", "|", "\[Omega]"}], ")"}], "\[Element]", "Reals"}], ",", 
        RowBox[{"r", ">", "0"}], ",", " ", 
        RowBox[{"\[Omega]", ">", "0"}]}], "}"}]}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"HankelTransform", "[", "m_", "]"}], "[", 
   RowBox[{"f_", ",", "r_", ",", "\[Omega]_"}], "]"}], " ", ":=", " ", 
  RowBox[{
   SuperscriptBox["\[ImaginaryI]", 
    RowBox[{"m", " "}]], " ", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{"f", "  ", "r", " ", 
      RowBox[{"BesselJ", "[", 
       RowBox[{"m", ",", 
        RowBox[{"r", " ", "\[Omega]"}]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", "\[Infinity]"}], "}"}], ",", 
     RowBox[{"Assumptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"r", "|", "\[Omega]"}], ")"}], "\[Element]", "Reals"}], ",", 
        RowBox[{"r", ">", "0"}], ",", " ", 
        RowBox[{"\[Omega]", ">", "0"}]}], "}"}]}]}], 
    "]"}]}]}]}], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Inverse Hankel Transform", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"InverseHankelTransform", "[", 
    RowBox[{"g_", ",", "\[Omega]_", ",", "r_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{"g", "  ", "\[Omega]", " ", 
      RowBox[{"BesselJ", "[", 
       RowBox[{"0", ",", 
        RowBox[{"r", " ", "\[Omega]"}]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Omega]", ",", "0", ",", "\[Infinity]"}], "}"}], ",", 
     RowBox[{"Assumptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"r", "|", "\[Omega]"}], ")"}], "\[Element]", "Reals"}], ",", 
        RowBox[{"r", ">", "0"}], ",", " ", 
        RowBox[{"\[Omega]", ">", "0"}]}], "}"}]}]}], "]"}]}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"InverseHankelTransform", "[", "m_", "]"}], "[", 
   RowBox[{"g_", ",", "\[Omega]_", ",", "r_"}], "]"}], " ", ":=", " ", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"-", "\[ImaginaryI]"}], ")"}], 
    RowBox[{"m", " "}]], " ", 
   RowBox[{"Integrate", "[", 
    RowBox[{
     RowBox[{"g", "  ", "\[Omega]", " ", 
      RowBox[{"BesselJ", "[", 
       RowBox[{"m", ",", 
        RowBox[{"r", " ", "\[Omega]"}]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Omega]", ",", "0", ",", "\[Infinity]"}], "}"}], ",", 
     RowBox[{"Assumptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"r", "|", "\[Omega]"}], ")"}], "\[Element]", "Reals"}], ",", 
        RowBox[{"r", ">", "0"}], ",", " ", 
        RowBox[{"\[Omega]", ">", "0"}]}], "}"}]}]}], 
    "]"}]}]}]}], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Hankel Basis Eigenvalue", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HankelBasisEigenvalue", "[", "n_", "]"}], "=", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], "n"]}], ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HankelBasisEigenvalue", "[", 
    RowBox[{"n_", ",", "m_"}], "]"}], "=", 
   SuperscriptBox["\[ImaginaryI]", 
    RowBox[{
     RowBox[{"Abs", "[", "m", "]"}], " ", "+", 
     RowBox[{"2", " ", "n"}]}]]}], ";"}]}], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["GaussHankelCoefficient", "Subsection",
 CellChangeTimes->{{3.463392706826065*^9, 3.4633927122146273`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GaussHankelCoefficient", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"nx_", ",", "ny_"}], "}"}], ",", "n_", ",", "m_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"S", "=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"nx", "+", "ny", "+", 
         RowBox[{"Abs", "[", "m", "]"}]}], ")"}], "/", "2"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"IntegerQ", "[", "S", "]"}], "\[And]", " ", 
       RowBox[{
        RowBox[{"nx", "+", "ny", "-", 
         RowBox[{"Abs", "[", "m", "]"}]}], "\[GreaterEqual]", " ", 
        RowBox[{
         RowBox[{"2", "n"}], "-", "2"}]}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
       FractionBox[
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "nx"], " ", 
         SuperscriptBox["\[ImaginaryI]", "ny"]}], 
        SuperscriptBox["2", 
         RowBox[{"nx", "+", "ny", "+", "1"}]]], 
       SqrtBox[
        FractionBox[
         RowBox[{"Binomial", "[", 
          RowBox[{
           RowBox[{"n", "+", 
            RowBox[{"Abs", "[", "m", "]"}]}], ",", "n"}], "]"}], 
         RowBox[{"\[Pi]", " ", 
          RowBox[{
           RowBox[{"Abs", "[", "m", "]"}], "!"}]}]]], "*", 
       "\[IndentingNewLine]", 
       RowBox[{"Sum", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], "j"], 
            RowBox[{"nx", "!"}]}], 
           RowBox[{
            RowBox[{"j", "!"}], " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"nx", "-", 
               RowBox[{"2", " ", "j"}]}], ")"}], "!"}]}]], 
          FractionBox[
           RowBox[{"ny", "!"}], 
           RowBox[{
            RowBox[{"k", "!"}], " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"ny", "-", 
               RowBox[{"2", " ", "k"}]}], ")"}], "!"}]}]], 
          SuperscriptBox["2", 
           RowBox[{"j", "+", "k"}]], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"S", "-", "j", "-", "k"}], ")"}], "!"}], " ", "*", 
          RowBox[{"Hypergeometric2F1", "[", 
           RowBox[{
            RowBox[{"-", "n"}], ",", 
            RowBox[{"S", "+", "1", "-", "j", "-", "k"}], ",", 
            RowBox[{
             RowBox[{"Abs", "[", "m", "]"}], "+", "1"}], ",", "1"}], "]"}], 
          " ", "*", "\[IndentingNewLine]", 
          RowBox[{"Sum", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], "p"], 
             RowBox[{"Binomial", "[", 
              RowBox[{
               RowBox[{"nx", "-", 
                RowBox[{"2", "j"}]}], ",", 
               RowBox[{
                FractionBox[
                 RowBox[{"nx", "+", "ny", "-", "m"}], "2"], "-", "j", "-", 
                "k", "-", "p"}]}], "]"}], 
             RowBox[{"Binomial", "[", 
              RowBox[{
               RowBox[{"ny", "-", 
                RowBox[{"2", "k"}]}], ",", "p"}], "]"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"p", ",", "0", ",", 
              RowBox[{"ny", "-", 
               RowBox[{"2", "k"}]}]}], "}"}]}], "\[IndentingNewLine]", 
           "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"k", ",", "0", ",", 
           RowBox[{"Floor", "[", 
            RowBox[{"ny", "/", "2"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "0", ",", 
           RowBox[{"Floor", "[", 
            RowBox[{"nx", "/", "2"}], "]"}]}], "}"}]}], "\[IndentingNewLine]",
         "]"}]}], ",", "\[IndentingNewLine]", "0"}], "\[IndentingNewLine]", 
     "]"}]}], "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 CellChangeTimes->{{3.463389665181458*^9, 3.4633896656731787`*^9}, {
   3.463389726351915*^9, 3.463389742918357*^9}, {3.463389828063179*^9, 
   3.463389911143785*^9}, 3.4633899534030447`*^9, {3.463390007751981*^9, 
   3.4633900246225643`*^9}, {3.463390068808337*^9, 3.463390080032878*^9}, {
   3.463390237479246*^9, 3.463390238046226*^9}, {3.463390288109624*^9, 
   3.463390329368692*^9}, {3.463390450273615*^9, 3.463390483457439*^9}, {
   3.463390689252599*^9, 3.4633907049002037`*^9}, 3.463390818453602*^9, {
   3.4633909487743883`*^9, 3.4633909514222517`*^9}, {3.463391021462407*^9, 
   3.463391024928424*^9}, {3.463391951202223*^9, 3.463391974842091*^9}, {
   3.4633920683230333`*^9, 3.46339207245077*^9}, {3.463392102994327*^9, 
   3.4633921459198847`*^9}, {3.463392278230289*^9, 3.463392284057763*^9}, {
   3.463392399581987*^9, 3.463392403307839*^9}, {3.463392465000867*^9, 
   3.463392468560318*^9}, {3.463392581274741*^9, 3.463392583936617*^9}, {
   3.463720229765135*^9, 3.463720376586231*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GaussHankelCoefficient", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"1", "/", "2"}], "|", "0.5"}], ",", 
    RowBox[{"{", 
     RowBox[{"nx_", ",", "ny_"}], "}"}], ",", "n_", ",", "m_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"S", "=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"nx", "+", "ny", "+", 
         RowBox[{"Abs", "[", "m", "]"}]}], ")"}], "/", "2"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"IntegerQ", "[", "S", "]"}], "\[And]", " ", 
       RowBox[{
        RowBox[{"nx", "+", "ny", "-", 
         RowBox[{"Abs", "[", "m", "]"}]}], "\[GreaterEqual]", " ", 
        RowBox[{
         RowBox[{"2", "n"}], "-", "2"}]}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
       FractionBox[
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "nx"], " ", 
         SuperscriptBox["\[ImaginaryI]", "ny"]}], 
        SuperscriptBox["2", 
         RowBox[{"nx", "+", "ny", "+", "1"}]]], 
       SqrtBox[
        FractionBox[
         RowBox[{"Binomial", "[", 
          RowBox[{
           RowBox[{"n", "+", 
            RowBox[{"Abs", "[", "m", "]"}]}], ",", "n"}], "]"}], 
         RowBox[{"\[Pi]", " ", 
          RowBox[{
           RowBox[{"Abs", "[", "m", "]"}], "!"}]}]]], "*", 
       "\[IndentingNewLine]", 
       RowBox[{"Sum", "[", "\[IndentingNewLine]", " ", 
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], "j"], 
            RowBox[{"nx", "!"}]}], 
           RowBox[{
            RowBox[{"j", "!"}], " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"nx", "-", 
               RowBox[{"2", " ", "j"}]}], ")"}], "!"}]}]], 
          FractionBox[
           RowBox[{"ny", "!"}], 
           RowBox[{
            RowBox[{"k", "!"}], " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"ny", "-", 
               RowBox[{"2", " ", "k"}]}], ")"}], "!"}]}]], 
          SuperscriptBox["2", 
           RowBox[{"j", "+", "k"}]], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"S", "-", "j", "-", "k"}], ")"}], "!"}], " ", 
          RowBox[{"Hypergeometric2F1", "[", 
           RowBox[{
            RowBox[{"-", "n"}], ",", 
            RowBox[{"S", "+", "1", "-", "j", "-", "k"}], ",", 
            RowBox[{
             RowBox[{"Abs", "[", "m", "]"}], "+", "1"}], ",", "1"}], "]"}], 
          "*", "\[IndentingNewLine]", 
          RowBox[{"Sum", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], "p"], 
             RowBox[{"Binomial", "[", 
              RowBox[{
               RowBox[{"nx", "-", 
                RowBox[{"2", "j"}]}], ",", 
               RowBox[{
                FractionBox[
                 RowBox[{"nx", "+", "ny", "-", "m"}], "2"], "-", "j", "-", 
                "k", "-", "p"}]}], "]"}], 
             RowBox[{"Binomial", "[", 
              RowBox[{
               RowBox[{"ny", "-", 
                RowBox[{"2", "k"}]}], ",", "p"}], "]"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"p", ",", "0", ",", 
              RowBox[{"ny", "-", 
               RowBox[{"2", "k"}]}]}], "}"}]}], "\[IndentingNewLine]", 
           "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"k", ",", "0", ",", 
           RowBox[{"Floor", "[", 
            RowBox[{"ny", "/", "2"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "0", ",", 
           RowBox[{"Floor", "[", 
            RowBox[{"nx", "/", "2"}], "]"}]}], "}"}]}], "\[IndentingNewLine]",
         "]"}]}], ",", "\[IndentingNewLine]", "0"}], "\[IndentingNewLine]", 
     "]"}]}], "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 CellChangeTimes->{{3.46339278280899*^9, 3.4633927861270227`*^9}, {
  3.463720406729541*^9, 3.4637204580877037`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GaussHankelCoefficient", "[", 
   RowBox[{"t_", ",", 
    RowBox[{"{", 
     RowBox[{"nx_", ",", "ny_"}], "}"}], ",", "n_", ",", "m_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"S", "=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"nx", "+", "ny", "+", 
         RowBox[{"Abs", "[", "m", "]"}]}], ")"}], "/", "2"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"IntegerQ", "[", "S", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       FractionBox[
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "nx"], " ", 
         SuperscriptBox["\[ImaginaryI]", "ny"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"2", " ", "t"}]}], ")"}], 
         RowBox[{"S", "+", "1"}]]], 
       SqrtBox[
        FractionBox[
         RowBox[{"Binomial", "[", 
          RowBox[{
           RowBox[{"n", "+", 
            RowBox[{"Abs", "[", "m", "]"}]}], ",", "n"}], "]"}], 
         RowBox[{"\[Pi]", " ", 
          RowBox[{
           RowBox[{"Abs", "[", "m", "]"}], "!"}]}]]], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"4", "t"}], ")"}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Abs", "[", "m", "]"}], "-", "nx", "-", "ny"}], ")"}], "/",
          "2"}]], "*", "\[IndentingNewLine]", 
       RowBox[{"Sum", "[", "\[IndentingNewLine]", " ", 
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], "j"], 
            RowBox[{"nx", "!"}]}], 
           RowBox[{
            RowBox[{"j", "!"}], " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"nx", "-", 
               RowBox[{"2", " ", "j"}]}], ")"}], "!"}]}]], 
          FractionBox[
           RowBox[{"ny", "!"}], 
           RowBox[{
            RowBox[{"k", "!"}], " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"ny", "-", 
               RowBox[{"2", " ", "k"}]}], ")"}], "!"}]}]], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"2", " ", "t"}]}], ")"}], 
           RowBox[{"j", "+", "k"}]], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"S", "-", "j", "-", "k"}], ")"}], "!"}], " ", 
          RowBox[{"Hypergeometric2F1", "[", 
           RowBox[{
            RowBox[{"-", "n"}], ",", 
            RowBox[{"S", "+", "1", "-", "j", "-", "k"}], ",", 
            RowBox[{
             RowBox[{"Abs", "[", "m", "]"}], "+", "1"}], ",", 
            FractionBox[
             RowBox[{"4", " ", "t"}], 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", "t"}]}]]}], "]"}], "*", "\[IndentingNewLine]", 
          RowBox[{"Sum", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], "p"], 
             RowBox[{"Binomial", "[", 
              RowBox[{
               RowBox[{"nx", "-", 
                RowBox[{"2", "j"}]}], ",", 
               RowBox[{
                FractionBox[
                 RowBox[{"nx", "+", "ny", "-", "m"}], "2"], "-", "j", "-", 
                "k", "-", "p"}]}], "]"}], 
             RowBox[{"Binomial", "[", 
              RowBox[{
               RowBox[{"ny", "-", 
                RowBox[{"2", "k"}]}], ",", "p"}], "]"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"p", ",", "0", ",", 
              RowBox[{"ny", "-", 
               RowBox[{"2", "k"}]}]}], "}"}]}], "\[IndentingNewLine]", 
           "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"k", ",", "0", ",", 
           RowBox[{"Floor", "[", 
            RowBox[{"ny", "/", "2"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "0", ",", 
           RowBox[{"Floor", "[", 
            RowBox[{"nx", "/", "2"}], "]"}]}], "}"}]}], "\[IndentingNewLine]",
         "]"}]}], ",", "\[IndentingNewLine]", "0"}], "\[IndentingNewLine]", 
     "]"}]}], "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 CellChangeTimes->{{3.46260570598573*^9, 3.462605731853595*^9}, {
   3.462617071844246*^9, 3.4626170915072412`*^9}, {3.462617606878109*^9, 
   3.462617614189475*^9}, {3.4626177657214727`*^9, 3.4626178553587103`*^9}, {
   3.462617927456194*^9, 3.4626179761615868`*^9}, {3.462629463206855*^9, 
   3.462629474597951*^9}, {3.4626308140757923`*^9, 3.462630840717183*^9}, {
   3.462630908778446*^9, 3.4626309419906282`*^9}, {3.462632143087064*^9, 
   3.462632156321684*^9}, {3.462632195362768*^9, 3.4626322047215242`*^9}, {
   3.462632294540669*^9, 3.462632347756688*^9}, {3.4626325671323643`*^9, 
   3.462632572379158*^9}, 3.462632629218223*^9, {3.4626333847274847`*^9, 
   3.4626334100713577`*^9}, 3.462908016259177*^9, {3.462908168527013*^9, 
   3.4629081982892323`*^9}, 3.463021965847272*^9, {3.463040334289839*^9, 
   3.463040378225471*^9}, {3.463040419032134*^9, 3.463040680045515*^9}, {
   3.463040796566264*^9, 3.463040846560714*^9}, 3.463384680343143*^9, {
   3.463384714430036*^9, 3.463384715101212*^9}, {3.463384919066277*^9, 
   3.4633849771933804`*^9}, 3.463385400862454*^9, {3.4633855194914227`*^9, 
   3.463385559465025*^9}, {3.4633855928548183`*^9, 3.463385599596354*^9}, {
   3.463385675279956*^9, 3.463385702209875*^9}, {3.463385972310491*^9, 
   3.4633860050965977`*^9}, {3.463386888303224*^9, 3.463386888545583*^9}, 
   3.463388756538727*^9, 3.463390815840042*^9, {3.4633909965853853`*^9, 
   3.463391010374908*^9}, {3.463392046447752*^9, 3.46339206115737*^9}, 
   3.463392160710721*^9, {3.4633922918359833`*^9, 3.463392297336514*^9}, {
   3.463392393897002*^9, 3.463392396884256*^9}, {3.463392503832467*^9, 
   3.463392506073124*^9}, {3.46339256156567*^9, 3.463392578467183*^9}, {
   3.463392760319553*^9, 3.463392760980687*^9}, {3.463720486215259*^9, 
   3.463720540334861*^9}, {3.4637207255675507`*^9, 3.463720737825933*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["HalfGaussHankelCoefficient", "Subsection",
 CellChangeTimes->{{3.463392706826065*^9, 3.4633927122146273`*^9}, {
  3.4640753137435904`*^9, 3.464075314716069*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HalfGaussHankelCoefficient", "[", 
    RowBox[{"n_", ",", "m_"}], "]"}], "=", "\[IndentingNewLine]", 
   RowBox[{"\[Piecewise]", GridBox[{
      {
       RowBox[{
        FractionBox["1", 
         RowBox[{"4", 
          SqrtBox["\[Pi]"]}]], " ", 
        RowBox[{"KroneckerDelta", "[", "n", "]"}]}], 
       RowBox[{"m", "\[Equal]", "0"}]},
      {
       RowBox[{
        FractionBox[
         RowBox[{" ", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"-", "1"}], ")"}], 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Abs", "[", "m", "]"}], "-", "1"}], ")"}], "/", "2"}]],
            " ", 
           RowBox[{"Gamma", "[", 
            RowBox[{"n", "+", 
             FractionBox[
              RowBox[{"Abs", "[", "m", "]"}], "2"]}], "]"}]}]}], 
         RowBox[{"4", 
          SqrtBox[
           RowBox[{
            SuperscriptBox["\[Pi]", "3"], " ", 
            RowBox[{"n", "!"}], " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"n", "+", 
               RowBox[{"Abs", "[", "m", "]"}]}], ")"}], "!"}]}]]}]], " "}], 
       RowBox[{"Not", "[", 
        RowBox[{"Divisible", "[", 
         RowBox[{"m", ",", "2"}], "]"}], "]"}]},
      {"0", 
       TagBox["True",
        "PiecewiseDefault",
        AutoDelete->False,
        DeletionWarning->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.84]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}]}]}], ";"}]], "PackageInput",
 CellChangeTimes->{{3.463389665181458*^9, 3.4633896656731787`*^9}, {
   3.463389726351915*^9, 3.463389742918357*^9}, {3.463389828063179*^9, 
   3.463389911143785*^9}, 3.4633899534030447`*^9, {3.463390007751981*^9, 
   3.4633900246225643`*^9}, {3.463390068808337*^9, 3.463390080032878*^9}, {
   3.463390237479246*^9, 3.463390238046226*^9}, {3.463390288109624*^9, 
   3.463390329368692*^9}, {3.463390450273615*^9, 3.463390483457439*^9}, {
   3.463390689252599*^9, 3.4633907049002037`*^9}, 3.463390818453602*^9, {
   3.4633909487743883`*^9, 3.4633909514222517`*^9}, {3.463391021462407*^9, 
   3.463391024928424*^9}, {3.463391951202223*^9, 3.463391974842091*^9}, {
   3.4633920683230333`*^9, 3.46339207245077*^9}, {3.463392102994327*^9, 
   3.4633921459198847`*^9}, {3.463392278230289*^9, 3.463392284057763*^9}, {
   3.463392399581987*^9, 3.463392403307839*^9}, {3.463392465000867*^9, 
   3.463392468560318*^9}, {3.463392581274741*^9, 3.463392583936617*^9}, {
   3.463720229765135*^9, 3.463720376586231*^9}, 3.4640753507482967`*^9, {
   3.464075390428516*^9, 3.464075396422933*^9}, {3.464076712895752*^9, 
   3.464076716304603*^9}, {3.464076878679964*^9, 3.46407691286165*^9}, {
   3.464077040428862*^9, 3.464077050177812*^9}, {3.464077683186761*^9, 
   3.464077704987236*^9}, {3.4640778426785173`*^9, 3.464077850348981*^9}, 
   3.4640780670541897`*^9, {3.464082583285823*^9, 3.464082588094589*^9}, {
   3.464120376866857*^9, 3.464120377430657*^9}, 3.464120408261827*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HalfGaussHankelCoefficient", "[", 
    RowBox[{
     RowBox[{"{", "ny_", "}"}], ",", "n_", ",", "m_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    FractionBox[
     RowBox[{" ", 
      SuperscriptBox["\[ImaginaryI]", "ny"]}], 
     SuperscriptBox["2", 
      RowBox[{"ny", "+", "1"}]]], 
    SqrtBox[
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"n", "+", 
         RowBox[{"Abs", "[", "m", "]"}]}], ")"}], "!"}], 
      RowBox[{
       SuperscriptBox["\[Pi]", "3"], " ", 
       RowBox[{"n", "!"}]}]]], 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{
         SuperscriptBox["2", "k"], " ", 
         RowBox[{"ny", "!"}]}], 
        RowBox[{
         RowBox[{"k", "!"}], " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "2"}], " ", "k"}], "+", "ny"}], ")"}], "!"}]}]], 
       "\[IndentingNewLine]", 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "p"], 
          RowBox[{"Binomial", "[", 
           RowBox[{
            RowBox[{"ny", "-", 
             RowBox[{"2", "k"}]}], ",", "p"}], "]"}], " ", 
          FractionBox["\[Pi]", "2"], " ", 
          RowBox[{"Sinc", "[", 
           RowBox[{
            FractionBox["\[Pi]", "2"], 
            RowBox[{"(", 
             RowBox[{"ny", "-", "m", "-", 
              RowBox[{"2", "k"}], "-", 
              RowBox[{"2", "p"}]}], ")"}]}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"p", ",", "0", ",", 
           RowBox[{"ny", "-", 
            RowBox[{"2", "k"}]}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
       RowBox[{"Sum", "[", 
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"l", "-", "k", "+", 
              RowBox[{
               FractionBox["1", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"ny", "+", 
                 RowBox[{"Abs", "[", "m", "]"}]}], ")"}]}]}], ")"}], "!"}], 
           " ", 
           RowBox[{"Pochhammer", "[", 
            RowBox[{
             RowBox[{"-", "n"}], ",", "l"}], "]"}]}], 
          RowBox[{
           RowBox[{"l", "!"}], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"l", "+", 
              RowBox[{"Abs", "[", "m", "]"}]}], ")"}], "!"}]}]], ",", 
         RowBox[{"{", 
          RowBox[{"l", ",", "0", ",", "n"}], "}"}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"k", ",", "0", ",", 
        RowBox[{"Floor", "[", 
         RowBox[{"ny", "/", "2"}], "]"}]}], "}"}]}], "]"}]}]}], 
  ";"}]], "PackageInput",
 CellChangeTimes->{{3.463389665181458*^9, 3.4633896656731787`*^9}, {
   3.463389726351915*^9, 3.463389742918357*^9}, {3.463389828063179*^9, 
   3.463389911143785*^9}, 3.4633899534030447`*^9, {3.463390007751981*^9, 
   3.4633900246225643`*^9}, {3.463390068808337*^9, 3.463390080032878*^9}, {
   3.463390237479246*^9, 3.463390238046226*^9}, {3.463390288109624*^9, 
   3.463390329368692*^9}, {3.463390450273615*^9, 3.463390483457439*^9}, {
   3.463390689252599*^9, 3.4633907049002037`*^9}, 3.463390818453602*^9, {
   3.4633909487743883`*^9, 3.4633909514222517`*^9}, {3.463391021462407*^9, 
   3.463391024928424*^9}, {3.463391951202223*^9, 3.463391974842091*^9}, {
   3.4633920683230333`*^9, 3.46339207245077*^9}, {3.463392102994327*^9, 
   3.4633921459198847`*^9}, {3.463392278230289*^9, 3.463392284057763*^9}, {
   3.463392399581987*^9, 3.463392403307839*^9}, {3.463392465000867*^9, 
   3.463392468560318*^9}, {3.463392581274741*^9, 3.463392583936617*^9}, {
   3.463720229765135*^9, 3.463720376586231*^9}, 3.4640753507482967`*^9, {
   3.464075390428516*^9, 3.464075396422933*^9}, {3.464076712895752*^9, 
   3.464076716304603*^9}, {3.464076878679964*^9, 3.46407691286165*^9}, {
   3.464077040428862*^9, 3.464077050177812*^9}, {3.464077683186761*^9, 
   3.464077704987236*^9}, {3.4640778426785173`*^9, 3.464077850348981*^9}, 
   3.4640780670541897`*^9, {3.464082583285823*^9, 3.464082588094589*^9}, {
   3.464120376866857*^9, 3.464120377430657*^9}, 3.464120408261827*^9, 
   3.464120968724265*^9, {3.4641211082791862`*^9, 3.464121167618348*^9}, {
   3.464121277289638*^9, 3.464121302510895*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HalfGaussHankelCoefficient", "[", 
    RowBox[{"t_", ",", "n_", ",", "m_"}], "]"}], "=", "\[IndentingNewLine]", 
   RowBox[{"\[Piecewise]", GridBox[{
      {
       FractionBox[
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"2", " ", "t"}]}], ")"}], "n"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"2", " ", "t"}]}], ")"}], 
          RowBox[{
           RowBox[{"-", "1"}], "-", "n"}]]}], 
        RowBox[{"2", " ", 
         SqrtBox["\[Pi]"]}]], 
       RowBox[{
        RowBox[{"m", "\[Equal]", "0"}], "&&", 
        RowBox[{"n", "\[NotEqual]", "0"}]}]},
      {
       FractionBox["1", 
        RowBox[{"2", " ", 
         SqrtBox["\[Pi]"], " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"2", " ", "t"}]}], ")"}]}]], 
       RowBox[{
        RowBox[{"m", "\[Equal]", "0"}], "&&", 
        RowBox[{"n", "==", "0"}]}]},
      {
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Abs", "[", "m", "]"}], "-", "1"}], ")"}], "/", "2"}]], 
          " ", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["t", 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", "t"}]}]], ")"}], 
           RowBox[{"1", "+", 
            FractionBox[
             RowBox[{"Abs", "[", "m", "]"}], "2"]}]], " ", 
          SqrtBox[
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{"n", "+", 
               RowBox[{"Abs", "[", "m", "]"}]}], ")"}], "!"}], 
            RowBox[{"n", "!"}]]], " ", 
          RowBox[{"Hypergeometric2F1", "[", 
           RowBox[{
            RowBox[{"1", "+", 
             FractionBox[
              RowBox[{"Abs", "[", "m", "]"}], "2"]}], ",", 
            RowBox[{"-", "n"}], ",", 
            RowBox[{"1", "+", 
             RowBox[{"Abs", "[", "m", "]"}]}], ",", 
            FractionBox[
             RowBox[{"4", " ", "t"}], 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", "t"}]}]]}], "]"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"\[Pi]", " ", "t", " ", 
          RowBox[{"Abs", "[", "m", "]"}], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             FractionBox["1", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Abs", "[", "m", "]"}], "-", "1"}], ")"}]}], ")"}], 
           "!"}]}], ")"}]}], 
       RowBox[{"!", 
        RowBox[{"Divisible", "[", 
         RowBox[{"m", ",", "2"}], "]"}]}]},
      {"0", 
       TagBox["True",
        "PiecewiseDefault",
        AutoDelete->False,
        DeletionWarning->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.84]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}]}]}], ";"}]], "PackageInput",
 CellChangeTimes->{{3.46339278280899*^9, 3.4633927861270227`*^9}, {
   3.463720406729541*^9, 3.4637204580877037`*^9}, {3.464075358759614*^9, 
   3.4640753851324778`*^9}, {3.464076867460631*^9, 3.464076876296493*^9}, 
   3.464077786912777*^9, 3.464077946069025*^9, 3.464078007589712*^9, 
   3.464078071960698*^9, {3.4640785107829437`*^9, 3.464078530459464*^9}, 
   3.464078627086007*^9, {3.4640823508604107`*^9, 3.464082369988515*^9}, {
   3.464120391727023*^9, 3.464120396542056*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HalfGaussHankelCoefficient", "[", 
    RowBox[{"t_", ",", 
     RowBox[{"{", "ny_", "}"}], ",", "n_", ",", "m_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    FractionBox[
     RowBox[{" ", 
      SuperscriptBox["\[ImaginaryI]", "ny"]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"4", "t"}], ")"}], 
      RowBox[{"ny", "+", "1"}]]], " ", 
    SqrtBox[
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"n", "+", 
         RowBox[{"Abs", "[", "m", "]"}]}], ")"}], "!"}], 
      RowBox[{
       SuperscriptBox["\[Pi]", "3"], " ", 
       RowBox[{"n", "!"}]}]]], 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"4", "t"}], ")"}], "k"], " ", 
         RowBox[{"ny", "!"}]}], 
        RowBox[{
         RowBox[{"k", "!"}], " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"ny", "-", 
            RowBox[{"2", " ", "k"}]}], ")"}], "!"}]}]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{"4", "t"}], 
          RowBox[{"1", "+", 
           RowBox[{"2", " ", "t"}]}]], ")"}], 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"2", "-", 
           RowBox[{"2", " ", "k"}], "+", "ny", "+", 
           RowBox[{"Abs", "[", "m", "]"}]}], ")"}]}]], 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "p"], 
          RowBox[{"Binomial", "[", 
           RowBox[{
            RowBox[{"ny", "-", 
             RowBox[{"2", "k"}]}], ",", "p"}], "]"}], " ", 
          FractionBox["\[Pi]", "2"], " ", 
          RowBox[{"Sinc", "[", 
           RowBox[{
            FractionBox["\[Pi]", "2"], 
            RowBox[{"(", 
             RowBox[{"ny", "-", "m", "-", 
              RowBox[{"2", "k"}], "-", 
              RowBox[{"2", "p"}]}], ")"}]}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"p", ",", "0", ",", 
           RowBox[{"ny", "-", 
            RowBox[{"2", "k"}]}]}], "}"}]}], "]"}], "  ", 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"l", "-", "k", "+", 
               RowBox[{
                FractionBox["1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"ny", "+", 
                  RowBox[{"Abs", "[", "m", "]"}]}], ")"}]}]}], ")"}], "!"}], 
            " ", 
            RowBox[{"Pochhammer", "[", 
             RowBox[{
              RowBox[{"-", "n"}], ",", "l"}], "]"}]}], 
           RowBox[{
            RowBox[{"l", "!"}], " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"l", "+", 
               RowBox[{"Abs", "[", "m", "]"}]}], ")"}], "!"}]}]], 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox[
             RowBox[{"4", " ", "t"}], 
             RowBox[{"1", "+", 
              RowBox[{"2", " ", "t"}]}]], ")"}], "l"]}], ",", 
         RowBox[{"{", 
          RowBox[{"l", ",", "0", ",", "n"}], "}"}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"k", ",", "0", ",", 
        RowBox[{"Floor", "[", 
         RowBox[{"ny", "/", "2"}], "]"}]}], "}"}]}], "]"}]}]}], 
  ";"}]], "PackageInput",
 CellChangeTimes->{{3.46339278280899*^9, 3.4633927861270227`*^9}, {
   3.463720406729541*^9, 3.4637204580877037`*^9}, {3.464075358759614*^9, 
   3.4640753851324778`*^9}, {3.464076867460631*^9, 3.464076876296493*^9}, 
   3.464077786912777*^9, 3.464077946069025*^9, 3.464078007589712*^9, 
   3.464078071960698*^9, {3.4640785107829437`*^9, 3.464078530459464*^9}, 
   3.464078627086007*^9, {3.4640823508604107`*^9, 3.464082369988515*^9}, {
   3.464120391727023*^9, 3.464120396542056*^9}, {3.464120980911099*^9, 
   3.464121095770895*^9}, 3.4641213043189898`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Hankel Basis", "Subsection"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"HankelBasis", "[", 
      RowBox[{"n_", ",", "z_"}], "]"}], " ", "=", 
     FractionBox[
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", 
          FractionBox["1", "2"]}], " ", 
         SuperscriptBox[
          RowBox[{"Abs", "[", "z", "]"}], "2"]}]], "  ", 
       RowBox[{"LaguerreL", "[", 
        RowBox[{"n", ",", 
         SuperscriptBox[
          RowBox[{"Abs", "[", "z", "]"}], "2"]}], "]"}]}], 
      RowBox[{
       SqrtBox["\[Pi]"], " "}]]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"HankelBasis", "[", 
      RowBox[{"n_", ",", "0", ",", "z_"}], "]"}], " ", "=", 
     FractionBox[
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", 
          FractionBox["1", "2"]}], " ", 
         SuperscriptBox[
          RowBox[{"Abs", "[", "z", "]"}], "2"]}]], "  ", 
       RowBox[{"LaguerreL", "[", 
        RowBox[{"n", ",", 
         SuperscriptBox[
          RowBox[{"Abs", "[", "z", "]"}], "2"]}], "]"}]}], 
      RowBox[{
       SqrtBox["\[Pi]"], " "}]]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"HankelBasis", "[", 
      RowBox[{"n_", ",", 
       RowBox[{"m_", "?", "Positive"}], ",", "z_"}], "]"}], " ", "=", 
     RowBox[{
      SuperscriptBox["z", "m"], 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          SuperscriptBox[
           RowBox[{"Abs", "[", "z", "]"}], "2"]}]], "  ", 
        RowBox[{"LaguerreL", "[", 
         RowBox[{"n", ",", "m", ",", 
          SuperscriptBox[
           RowBox[{"Abs", "[", "z", "]"}], "2"]}], "]"}]}], 
       SqrtBox[
        RowBox[{"\[Pi]", " ", 
         RowBox[{"Pochhammer", "[", 
          RowBox[{
           RowBox[{"n", "+", "1"}], ",", "m"}], "]"}]}]]]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"HankelBasis", "[", 
      RowBox[{"n_", ",", 
       RowBox[{"m_", "?", "Negative"}], ",", "z_"}], "]"}], " ", "=", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"Conjugate", "[", "z", "]"}], 
       RowBox[{"-", "m"}]], 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          SuperscriptBox[
           RowBox[{"Abs", "[", "z", "]"}], "2"]}]], "  ", 
        RowBox[{"LaguerreL", "[", 
         RowBox[{"n", ",", 
          RowBox[{"-", "m"}], ",", 
          SuperscriptBox[
           RowBox[{"Abs", "[", "z", "]"}], "2"]}], "]"}]}], 
       SqrtBox[
        RowBox[{"\[Pi]", " ", 
         RowBox[{"Pochhammer", "[", 
          RowBox[{
           RowBox[{"n", "+", "1"}], ",", 
           RowBox[{"-", "m"}]}], "]"}]}]]]}]}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"HankelBasis", "[", 
      RowBox[{"n_", ",", "m_", ",", "z_"}], "]"}], " ", "=", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"Abs", "[", "z", "]"}], 
       RowBox[{"Abs", "[", "m", "]"}]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"\[ImaginaryI]", " ", "m", " ", 
        RowBox[{"Arg", "[", "z", "]"}]}]], 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          SuperscriptBox[
           RowBox[{"Abs", "[", "z", "]"}], "2"]}]], "  ", 
        RowBox[{"LaguerreL", "[", 
         RowBox[{"n", ",", 
          RowBox[{"Abs", "[", "m", "]"}], ",", 
          SuperscriptBox[
           RowBox[{"Abs", "[", "z", "]"}], "2"]}], "]"}]}], 
       SqrtBox[
        RowBox[{"\[Pi]", " ", 
         RowBox[{"Pochhammer", "[", 
          RowBox[{
           RowBox[{"n", "+", "1"}], ",", 
           RowBox[{"Abs", "[", "m", "]"}]}], "]"}]}]]]}]}], 
    ";"}]}]}]], "PackageInput",
 CellChangeTimes->{{3.462296760464551*^9, 3.4622968447125463`*^9}, {
  3.4622970177381563`*^9, 3.4622970264318047`*^9}, {3.4633882116392117`*^9, 
  3.463388212602085*^9}}],

Cell["Old version:", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HankelEigenvector", "[", 
   RowBox[{"l_", ",", "m_", ",", "r_"}], "]"}], ":=", " ", 
  RowBox[{
   SqrtBox[
    FractionBox[
     RowBox[{"2", " ", 
      RowBox[{"l", "!"}]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Abs", "[", "m", "]"}], "+", "l"}], ")"}], "!"}]]], 
   SuperscriptBox["r", 
    RowBox[{"Abs", "[", "m", "]"}]], 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["r", "2"]}], "/", "2"}]], 
   RowBox[{"LaguerreL", "[", 
    RowBox[{"l", ",", 
     RowBox[{"Abs", "[", "m", "]"}], ",", 
     SuperscriptBox["r", "2"]}], "]"}]}]}]], "Input",
 Evaluatable->False],

Cell[BoxData[
 RowBox[{
  RowBox[{"HankelEigenvalue", "[", 
   RowBox[{"l_", ",", "m_"}], "]"}], ":=", 
  SuperscriptBox["\[ImaginaryI]", 
   RowBox[{
    RowBox[{"Abs", "[", "m", "]"}], " ", "+", 
    RowBox[{"2", " ", "l"}]}]]}]], "Input",
 Evaluatable->False],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "r"], "\[Equal]", " ", 
  RowBox[{
   SqrtBox["\[Pi]"], 
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"l", "=", "0"}], "\[Infinity]"], 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", "l"}], "-", "1"}], ")"}], "!!"}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"2", "l"}], ")"}], "!!"}]], 
     RowBox[{"HankelEigenvector", "[", 
      RowBox[{
       RowBox[{"2", "l"}], ",", "0", ",", "r"}], "]"}]}]}]}]}]], "Input",
 Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["Hankel Basis 3D", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HankelBasis3D", "[", 
     RowBox[{
     "n_", ",", "0", ",", "m_", ",", "r_", ",", "\[CurlyTheta]_", ",", 
      "\[CurlyPhi]"}], "]"}], " ", "=", 
    RowBox[{
     SqrtBox[
      FractionBox[
       RowBox[{"2", 
        RowBox[{"(", 
         RowBox[{"n", "!"}], ")"}]}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"n", "+", 
          FractionBox["1", "2"]}], ")"}], "!"}]]], 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"-", 
       FractionBox[
        SuperscriptBox["r", "2"], "2"]}]], 
     RowBox[{"LaguerreL", "[", 
      RowBox[{"n", ",", 
       FractionBox["1", "2"], ",", 
       SuperscriptBox["r", "2"]}], "]"}], 
     RowBox[{"SphericalHarmonicY", "[", 
      RowBox[{"0", ",", "m", ",", "\[Theta]", ",", "\[Phi]"}], "]"}]}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HankelBasis3D", "[", 
    RowBox[{
    "n_", ",", "l_", ",", "m_", ",", "r_", ",", "\[CurlyTheta]_", ",", 
     "\[CurlyPhi]"}], "]"}], " ", "=", 
   RowBox[{
    SqrtBox[
     FractionBox[
      RowBox[{"2", 
       RowBox[{"(", 
        RowBox[{"n", "!"}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"n", "+", "l", "+", 
         FractionBox["1", "2"]}], ")"}], "!"}]]], 
    SuperscriptBox["r", "l"], 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"-", 
      FractionBox[
       SuperscriptBox["r", "2"], "2"]}]], 
    RowBox[{"LaguerreL", "[", 
     RowBox[{"n", ",", 
      RowBox[{"l", "+", 
       FractionBox["1", "2"]}], ",", 
      SuperscriptBox["r", "2"]}], "]"}], 
    RowBox[{"SphericalHarmonicY", "[", 
     RowBox[{"l", ",", "m", ",", "\[Theta]", ",", "\[Phi]"}], "]"}]}]}], 
  ";"}]}], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Numerical Hankel Basis", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NHankelBasis", " ", "=", " ", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"n", ",", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "_Complex"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Which", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"m", "===", "0"}], ",", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          SuperscriptBox[
           RowBox[{"Abs", "[", "z", "]"}], "2"]}]], "  ", 
        RowBox[{
         RowBox[{"LaguerreL", "[", 
          RowBox[{"n", ",", 
           SuperscriptBox[
            RowBox[{"Abs", "[", "z", "]"}], "2"]}], "]"}], "/", 
         SqrtBox["\[Pi]"]}]}], " ", ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"m", ">", "0"}], "\[And]", 
        RowBox[{"z", "\[NotEqual]", "0.0"}]}], ",", 
       RowBox[{
        SuperscriptBox["z", "m"], 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          SuperscriptBox[
           RowBox[{"Abs", "[", "z", "]"}], "2"]}]], "  ", 
        FractionBox[
         RowBox[{"LaguerreL", "[", 
          RowBox[{"n", ",", "m", ",", 
           SuperscriptBox[
            RowBox[{"Abs", "[", "z", "]"}], "2"]}], "]"}], 
         RowBox[{
          SqrtBox[
           RowBox[{
            RowBox[{"Pochhammer", "[", 
             RowBox[{
              RowBox[{"n", "+", "1."}], ",", "m"}], "]"}], " ", "\[Pi]"}]], 
          " "}]]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"m", "<", "0"}], "\[And]", 
        RowBox[{"z", "\[NotEqual]", "0.0"}]}], ",", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"Conjugate", "[", "z", "]"}], 
         RowBox[{"-", "m"}]], 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          SuperscriptBox[
           RowBox[{"Abs", "[", "z", "]"}], "2"]}]], "  ", 
        FractionBox[
         RowBox[{"LaguerreL", "[", 
          RowBox[{"n", ",", 
           RowBox[{"-", "m"}], ",", 
           SuperscriptBox[
            RowBox[{"Abs", "[", "z", "]"}], "2"]}], "]"}], 
         RowBox[{
          SqrtBox[
           RowBox[{
            RowBox[{"Pochhammer", "[", 
             RowBox[{
              RowBox[{"n", "+", "1."}], ",", 
              RowBox[{"-", "m"}]}], "]"}], " ", "\[Pi]"}]], " "}]]}], ",", 
       "\[IndentingNewLine]", "True", ",", "0"}], "]"}], " ", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Which", "[", "__", "]"}], ",", "_Complex"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"LaguerreL", "[", 
          RowBox[{"_", ",", "_", ",", "_"}], "]"}], ",", "_Real"}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Pochhammer", "[", 
          RowBox[{"_", ",", "_"}], "]"}], ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Abs", "[", "z", "]"}], ",", "_Real"}], "}"}]}], "}"}]}], 
    "]"}]}], ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Numerical Hankel Basis 3D", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NHankelBasis3D", "[", 
    RowBox[{"n_", ",", "l_", ",", "m_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"NHankelBasis3D", "[", 
     RowBox[{"n", ",", "l", ",", "m"}], "]"}], "=", "\[IndentingNewLine]", 
    RowBox[{"Compile", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"r", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Phi]", ",", "_Real"}], "}"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Evaluate", "[", "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"l", "==", "0"}], "&&", 
          RowBox[{"r", "==", "0"}]}], ",", 
         FractionBox[
          RowBox[{
           RowBox[{"Binomial", "[", 
            RowBox[{
             RowBox[{"n", "+", 
              FractionBox["1", "2"]}], ",", 
             FractionBox["1", "2"]}], "]"}], " ", 
           SqrtBox[
            FractionBox[
             RowBox[{"n", "!"}], 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                FractionBox["1", "2"], "+", "n"}], ")"}], "!"}]]]}], 
          SqrtBox[
           RowBox[{"2", " ", "\[Pi]"}]]], ",", "\[IndentingNewLine]", "True", 
         ",", 
         RowBox[{
          SqrtBox[
           FractionBox[
            RowBox[{"2", 
             RowBox[{"(", 
              RowBox[{"n", "!"}], ")"}]}], 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"n", "+", "l", "+", 
               FractionBox["1", "2"]}], ")"}], "!"}]]], 
          SuperscriptBox["r", "l"], 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"-", 
            FractionBox[
             SuperscriptBox["r", "2"], "2"]}]], 
          RowBox[{"LaguerreL", "[", 
           RowBox[{"n", ",", 
            RowBox[{"l", "+", 
             FractionBox["1", "2"]}], ",", 
            SuperscriptBox["r", "2"]}], "]"}], 
          RowBox[{"SphericalHarmonicY", "[", 
           RowBox[{"l", ",", "m", ",", "\[Theta]", ",", "\[Phi]"}], "]"}]}]}],
         "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Which", "[", "__", "]"}], ",", "_Complex"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"SphericalHarmonicY", "[", 
           RowBox[{"_", ",", "_", ",", "_", ",", "_"}], "]"}], ",", 
          "_Complex"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"LaguerreL", "[", 
           RowBox[{"_", ",", "_", ",", "_"}], "]"}], ",", "_Real"}], "}"}]}], 
       "}"}]}], "\[IndentingNewLine]", "]"}]}]}], ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Hankel Basis n List", "Subsection"],

Cell[TextData[{
 "Utilize recursion in ",
 Cell[BoxData["n"]],
 " and ",
 Cell[BoxData["m"]]
}], "Text"],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    SubsuperscriptBox["h", "n", 
     RowBox[{"\[LeftBracketingBar]", "m", "\[RightBracketingBar]"}]], "(", 
    "z", ")"}], " ", "\[Equal]", 
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "n"}], "+", 
        RowBox[{"\[LeftBracketingBar]", "m", "\[RightBracketingBar]"}], "-", 
        "1", "-", 
        SuperscriptBox[
         RowBox[{"\[LeftBracketingBar]", "z", "\[RightBracketingBar]"}], 
         "2"]}], ")"}], " ", 
      RowBox[{
       SubsuperscriptBox["h", 
        RowBox[{"n", "-", "1"}], 
        RowBox[{"\[LeftBracketingBar]", "m", "\[RightBracketingBar]"}]], "(", 
       "z", ")"}]}], "-", 
     RowBox[{
      SqrtBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{"n", "-", "1"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"n", "+", 
          RowBox[{"\[LeftBracketingBar]", "m", "\[RightBracketingBar]"}], "-",
           "1"}], ")"}]}]], " ", 
      RowBox[{
       SubsuperscriptBox["h", 
        RowBox[{"n", "-", "2"}], 
        RowBox[{"\[LeftBracketingBar]", "m", "\[RightBracketingBar]"}]], "(", 
       "z", ")"}]}]}], 
    SqrtBox[
     RowBox[{"n", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[LeftBracketingBar]", "m", "\[RightBracketingBar]"}], "+", 
        "n"}], ")"}]}]]]}], TraditionalForm]], "Output"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HankelBasisNList", "[", 
     RowBox[{"nmax_", ",", "z_"}], "]"}], ":=", 
    RowBox[{"HankelBasisNList", "[", 
     RowBox[{"nmax", ",", "0", ",", "z"}], "]"}]}], ";"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HankelBasisNList", "[", 
     RowBox[{"nmax_", ",", "0", ",", "z_"}], "]"}], " ", ":=", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"r", " ", "=", " ", 
        SuperscriptBox[
         RowBox[{"Abs", "[", "z", "]"}], "2"]}], "}"}], ",", " ", 
      RowBox[{"Rest", "[", 
       RowBox[{"Fold", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Append", "[", 
           RowBox[{"#", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"1", "-", " ", "#2"}], ",", 
                RowBox[{
                 RowBox[{"2", " ", "#2"}], "-", "1", "-", "r"}]}], "}"}], ".", 
              RowBox[{"Take", "[", 
               RowBox[{"#1", ",", 
                RowBox[{"-", "2"}]}], "]"}]}], "/", "#2"}]}], "]"}], "&"}], 
         ",", " ", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           FractionBox["1", 
            SqrtBox[
             RowBox[{"\[Pi]", " ", 
              SuperscriptBox["\[ExponentialE]", "z2"]}]]]}], "}"}], ",", 
         RowBox[{"Range", "[", "nmax", "]"}]}], "]"}], "]"}]}], "]"}]}], 
   ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HankelBasisNList", "[", 
     RowBox[{"nmax_", ",", 
      RowBox[{"m_", "?", "Positive"}], ",", "z_"}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"With", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"r", " ", "=", " ", 
        SuperscriptBox[
         RowBox[{"Abs", "[", "z", "]"}], "2"]}], "}"}], ",", 
      RowBox[{
       FractionBox[
        SuperscriptBox["z", "m"], 
        SqrtBox[
         RowBox[{"\[Pi]", " ", 
          SuperscriptBox["\[ExponentialE]", "r"]}]]], "*", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Rest", "[", 
         RowBox[{"Fold", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Append", "[", 
             RowBox[{"#", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"1", "-", " ", "#2", "-", "m"}], ",", 
                  RowBox[{
                   RowBox[{"2", " ", "#2"}], "+", "m", "-", "1", "-", "r"}]}],
                  "}"}], ".", 
                RowBox[{"Take", "[", 
                 RowBox[{"#1", ",", 
                  RowBox[{"-", "2"}]}], "]"}]}], "/", "#2"}]}], "]"}], "&"}], 
           ",", " ", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1"}], "}"}], ",", 
           RowBox[{"Range", "[", "nmax", "]"}]}], "]"}], "]"}], "/", 
        "\[IndentingNewLine]", 
        SqrtBox[
         RowBox[{"FoldList", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"#1", " ", 
              RowBox[{"(", 
               RowBox[{
                FractionBox["m", "#2"], "+", "1"}], ")"}]}], ")"}], "&"}], 
           ",", 
           RowBox[{"Factorial", "[", "m", "]"}], ",", 
           RowBox[{"Range", "[", "nmax", "]"}]}], "]"}]]}]}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HankelBasisNList", "[", 
    RowBox[{"nmax_", ",", 
     RowBox[{"m_", "?", "Negative"}], ",", "z_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", " ", "=", " ", 
       SuperscriptBox[
        RowBox[{"Abs", "[", "z", "]"}], "2"]}], "}"}], ",", 
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"Conjugate", "[", "z", "]"}], 
        RowBox[{"-", "m"}]], 
       SqrtBox[
        RowBox[{"\[Pi]", " ", 
         SuperscriptBox["\[ExponentialE]", "r"]}]]], "*", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Rest", "[", 
        RowBox[{"Fold", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Append", "[", 
            RowBox[{"#", ",", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"1", "-", " ", "#2", "+", "m"}], ",", 
                 RowBox[{
                  RowBox[{"2", " ", "#2"}], "-", "m", "-", "1", "-", "r"}]}], 
                "}"}], ".", 
               RowBox[{"Take", "[", 
                RowBox[{"#1", ",", 
                 RowBox[{"-", "2"}]}], "]"}]}], "/", "#2"}]}], "]"}], "&"}], 
          ",", " ", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", 
          RowBox[{"Range", "[", "nmax", "]"}]}], "]"}], "]"}], "/", 
       "\[IndentingNewLine]", 
       SqrtBox[
        RowBox[{"FoldList", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"-", "m"}], "#2"], "+", "1"}], ")"}]}], ")"}], "&"}], 
          ",", 
          RowBox[{"Factorial", "[", 
           RowBox[{"-", "m"}], "]"}], ",", 
          RowBox[{"Range", "[", "nmax", "]"}]}], "]"}]]}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "PackageInput",
 CellChangeTimes->{{3.4622957227249403`*^9, 3.462295729092989*^9}, {
  3.463852402992442*^9, 3.463852438595533*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Numerical Hankel Basis n List", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NHankelBasisNList", " ", "=", " ", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"nmax", ",", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "_Complex"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r", " ", "=", " ", 
         SuperscriptBox[
          RowBox[{"Abs", "[", "z", "]"}], "2"]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"r", ">", "708."}], ",", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{"0.", ",", 
           RowBox[{"{", 
            RowBox[{"nmax", "+", "1"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Which", "[", 
          RowBox[{
           RowBox[{"m", "===", "0"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"Fold", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Append", "[", 
                 RowBox[{"#", ",", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "#2"}], "-", "1.", "-", "r"}], ")"}], 
                    RowBox[{"#1", "\[LeftDoubleBracket]", 
                    RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]}], " ", "-",
                     " ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"#2", "-", "1."}], ")"}], 
                    RowBox[{"#1", "\[LeftDoubleBracket]", 
                    RowBox[{"-", "2"}], "\[RightDoubleBracket]"}]}]}], 
                   "#2"]}], "]"}], "&"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{"0", ",", 
                 SuperscriptBox["\[ExponentialE]", 
                  RowBox[{
                   RowBox[{"-", "r"}], "/", "2"}]]}], "}"}], ",", 
               RowBox[{"Range", "[", "nmax", "]"}]}], "]"}], "]"}], "/", 
            SqrtBox["\[Pi]"]}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"m", ">", "0"}], "\[And]", 
            RowBox[{"z", "\[NotEqual]", "0.0"}]}], ",", 
           RowBox[{
            SuperscriptBox["z", "m"], "*", 
            RowBox[{
             RowBox[{"Rest", "[", 
              RowBox[{"Fold", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Append", "[", 
                  RowBox[{"#", ",", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "#2"}], "+", "m", "-", "1.", "-", "r"}],
                     ")"}], 
                    RowBox[{"#1", "\[LeftDoubleBracket]", 
                    RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]}], " ", "+",
                     " ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1.", "-", "#2", "-", "m"}], ")"}], 
                    RowBox[{"#1", "\[LeftDoubleBracket]", 
                    RowBox[{"-", "2"}], "\[RightDoubleBracket]"}]}]}], 
                    "#2"]}], "]"}], "&"}], ",", " ", 
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  SuperscriptBox["\[ExponentialE]", 
                   RowBox[{
                    RowBox[{"-", "r"}], "/", "2"}]]}], "}"}], ",", 
                RowBox[{"Range", "[", "nmax", "]"}]}], "]"}], "]"}], "/", 
             "\[IndentingNewLine]", 
             SqrtBox[
              RowBox[{"\[Pi]", " ", 
               RowBox[{"FoldList", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"#1", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    FractionBox["m", "#2"], "+", "1."}], ")"}]}], ")"}], 
                  "&"}], ",", 
                 RowBox[{"Factorial", "[", "m", "]"}], ",", 
                 RowBox[{"Range", "[", "nmax", "]"}]}], "]"}]}]]}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"m", "<", "0"}], "\[And]", 
            RowBox[{"z", "\[NotEqual]", "0.0"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"Conjugate", "[", "z", "]"}], 
             RowBox[{"-", "m"}]], "*", " ", 
            RowBox[{
             RowBox[{"Rest", "[", 
              RowBox[{"Fold", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Append", "[", 
                  RowBox[{"#", ",", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "#2"}], "-", "m", "-", "1.", "-", "r"}],
                     ")"}], 
                    RowBox[{"#1", "\[LeftDoubleBracket]", 
                    RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]}], " ", "+",
                     " ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"1.", "-", "#2", "+", "m"}], ")"}], 
                    RowBox[{"#1", "\[LeftDoubleBracket]", 
                    RowBox[{"-", "2"}], "\[RightDoubleBracket]"}]}]}], 
                    "#2"]}], "]"}], "&"}], ",", " ", 
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  SuperscriptBox["\[ExponentialE]", 
                   RowBox[{
                    RowBox[{"-", "r"}], "/", "2"}]]}], "}"}], ",", 
                RowBox[{"Range", "[", "nmax", "]"}]}], "]"}], "]"}], "/", 
             "\[IndentingNewLine]", 
             SqrtBox[
              RowBox[{"\[Pi]", " ", 
               RowBox[{"FoldList", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"#1", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    FractionBox[
                    RowBox[{"-", "m"}], "#2"], "+", "1."}], ")"}]}], ")"}], 
                  "&"}], ",", 
                 RowBox[{"Factorial", "[", 
                  RowBox[{"-", "m"}], "]"}], ",", 
                 RowBox[{"Range", "[", "nmax", "]"}]}], "]"}]}]]}]}], ",", 
           "\[IndentingNewLine]", "True", ",", 
           RowBox[{"Table", "[", 
            RowBox[{"0.", ",", 
             RowBox[{"{", 
              RowBox[{"nmax", "+", "1"}], "}"}]}], "]"}]}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Which", "[", "__", "]"}], ",", "_Complex", ",", "1"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Append", "[", 
          RowBox[{"_", ",", "_"}], "]"}], ",", "_Real", ",", "1"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Factorial", "[", "_", "]"}], ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Range", "[", "_", "]"}], ",", "_Real", ",", "1"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Fold", "[", 
          RowBox[{"_", ",", "_", ",", "_"}], "]"}], ",", "_Real", ",", "1"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FoldList", "[", 
          RowBox[{"_", ",", "_", ",", "_"}], "]"}], ",", "_Real", ",", "1"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"r", ",", "_Real"}], "}"}]}], "}"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "PackageInput"],

Cell["Old version", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NHankelHnList", " ", "=", " ", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"nmax", ",", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"m", ",", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "_Complex"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r", " ", "=", " ", 
         SuperscriptBox[
          RowBox[{"Abs", "[", "z", "]"}], "2"]}], "}"}], ",", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"m", "===", "0"}], ",", "1", ",", 
          SuperscriptBox["z", "m"]}], "]"}], " ", 
        RowBox[{"Rest", "[", 
         RowBox[{"Fold", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Append", "[", 
             RowBox[{"#", ",", 
              FractionBox[
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", "#2"}], "+", 
                   RowBox[{"Abs", "[", "m", "]"}], "-", "1.", "-", "r"}], 
                  ")"}], 
                 RowBox[{"#1", "\[LeftDoubleBracket]", 
                  RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]}], " ", "-", 
                " ", 
                RowBox[{
                 SqrtBox[
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"#2", "-", "1."}], ")"}], 
                   RowBox[{"(", 
                    RowBox[{"#2", "+", 
                    RowBox[{"Abs", "[", "m", "]"}], "-", "1."}], ")"}]}]], 
                 RowBox[{"#1", "\[LeftDoubleBracket]", 
                  RowBox[{"-", "2"}], "\[RightDoubleBracket]"}]}]}], 
               SqrtBox[
                RowBox[{"#2", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Abs", "[", "m", "]"}], "+", "#2"}], ")"}]}]]]}], 
             "]"}], "&"}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"0", ",", 
             FractionBox["1.", 
              SqrtBox[
               RowBox[{"\[Pi]", " ", 
                SuperscriptBox["\[ExponentialE]", "r"], " ", 
                RowBox[{"Factorial", "[", 
                 RowBox[{"Abs", "[", "m", "]"}], "]"}]}]]]}], "}"}], ",", 
           RowBox[{"Range", "[", "nmax", "]"}]}], "]"}], "]"}]}]}], "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Fold", "[", 
          RowBox[{"_", ",", "_", ",", "_"}], "]"}], ",", "_Real", ",", "1"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FoldList", "[", 
          RowBox[{"_", ",", "_", ",", "_"}], "]"}], ",", "_Real", ",", "1"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"r", ",", "_Real"}], "}"}]}], "}"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["Hankel Basis (n,m) List", "Subsection"],

Cell[TextData[{
 "Utilize recursion in ",
 Cell[BoxData["n"]],
 " and ",
 Cell[BoxData["m"]]
}], "Text"],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    SubsuperscriptBox["h", "n", 
     RowBox[{"\[LeftBracketingBar]", "m", "\[RightBracketingBar]"}]], "(", 
    "z", ")"}], "  ", "\[Equal]", 
   FractionBox[
    RowBox[{
     RowBox[{
      SuperscriptBox["z", 
       RowBox[{"sgn", "(", "m", ")"}]], " ", 
      FormBox[
       RowBox[{
        SubsuperscriptBox["h", "n", 
         RowBox[{
          RowBox[{"\[LeftBracketingBar]", "m", "\[RightBracketingBar]"}], "-", 
          RowBox[{"sgn", "(", "m", ")"}]}]], "(", "z", ")"}],
       TraditionalForm]}], " ", "+", 
     RowBox[{
      SqrtBox["n"], " ", 
      FormBox[
       RowBox[{
        SubsuperscriptBox["h", 
         RowBox[{"n", "-", "1"}], 
         RowBox[{"\[LeftBracketingBar]", "m", "\[RightBracketingBar]"}]], "(",
         "z", ")"}],
       TraditionalForm]}]}], 
    SqrtBox[
     RowBox[{"n", "+", 
      RowBox[{"\[LeftBracketingBar]", "m", "\[RightBracketingBar]"}]}]]]}], 
  TraditionalForm]], "Output"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HankelBasisNMList", "[", 
    RowBox[{"nmax_", ",", "mmax_", ",", "z_"}], "]"}], ":=", " ", 
   "\[IndentingNewLine]", 
   RowBox[{"With", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", " ", "=", " ", 
       SuperscriptBox[
        RowBox[{"Abs", "[", "z", "]"}], "2"]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"NestList", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"z", "*", "#"}], ")"}], "&"}], ",", 
        FractionBox["1", 
         SqrtBox[
          RowBox[{"\[Pi]", " ", 
           SuperscriptBox["\[ExponentialE]", "r"]}]]], ",", "mmax"}], "]"}], 
      " ", "*", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"NestList", "[", "\[IndentingNewLine]", 
        RowBox[{"Accumulate", ",", "\[IndentingNewLine]", 
         RowBox[{"Rest", "[", 
          RowBox[{"Fold", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Append", "[", 
              RowBox[{"#", ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"1", "-", " ", "#2"}], ",", 
                   RowBox[{
                    RowBox[{"2", " ", "#2"}], "-", "1", "-", "r"}]}], "}"}], 
                 ".", 
                 RowBox[{"Take", "[", 
                  RowBox[{"#1", ",", 
                   RowBox[{"-", "2"}]}], "]"}]}], "/", "#2"}]}], "]"}], "&"}],
             ",", " ", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}], ",", 
            RowBox[{"Range", "[", "nmax", "]"}]}], "]"}], "]"}], ",", 
         "\[IndentingNewLine]", "mmax"}], "\[IndentingNewLine]", "]"}], "/", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{"Times", ",", "1", ",", 
              RowBox[{"Range", "[", 
               RowBox[{"nmax", "+", "mmax"}], "]"}]}], "]"}], ",", 
            RowBox[{"mmax", "+", "1"}], ",", "1"}], "]"}], "/", 
          RowBox[{"FoldList", "[", 
           RowBox[{"Times", ",", "1", ",", 
            RowBox[{"Range", "[", "nmax", "]"}]}], "]"}]}], "]"}], 
        "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput",
 CellChangeTimes->{
  3.462293349815805*^9, {3.4637552906295567`*^9, 3.463755293413957*^9}, {
   3.463839076646256*^9, 3.463839080128047*^9}, {3.4638399734305363`*^9, 
   3.463839982525985*^9}, {3.4638420156279087`*^9, 3.46384201842854*^9}, {
   3.463852136434308*^9, 3.463852141192082*^9}, {3.463852317056355*^9, 
   3.46385235430179*^9}}],

Cell["Old version:", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HankelHnmList", "[", 
   RowBox[{"nmax_", ",", "mmax_", ",", "z_"}], "]"}], ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{"With", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"r", " ", "=", " ", 
      SuperscriptBox[
       RowBox[{"Abs", "[", "z", "]"}], "2"]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"NestList", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"z", "*", "#"}], ")"}], "&"}], ",", 
       FractionBox["1", 
        SqrtBox[
         RowBox[{"\[Pi]", " ", 
          SuperscriptBox["\[ExponentialE]", "r"]}]]], ",", "mmax"}], "]"}], 
     " ", "*", "\[IndentingNewLine]", 
     RowBox[{"FoldList", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"m", "=", "#2"}], "}"}], ",", 
          RowBox[{"Fold", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Append", "[", 
              RowBox[{"#1", ",", 
               FractionBox[
                RowBox[{
                 RowBox[{
                  SqrtBox[
                   RowBox[{"Last", "[", "#2", "]"}]], 
                  RowBox[{"Last", "[", "#1", "]"}]}], " ", "+", "  ", 
                 RowBox[{"First", "[", "#2", "]"}]}], 
                SqrtBox[
                 RowBox[{
                  RowBox[{"Last", "[", "#2", "]"}], "+", "m"}]]]}], "]"}], 
             "&"}], ",", 
            RowBox[{"{", 
             FractionBox[
              RowBox[{"First", "[", "#1", "]"}], 
              SqrtBox["m"]], "}"}], ",", 
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Rest", "[", "#1", "]"}], ",", 
               RowBox[{"Range", "[", "nmax", "]"}]}], "}"}], "]"}]}], "]"}]}],
          "]"}], "&"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Rest", "[", 
        RowBox[{"Fold", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Append", "[", 
            RowBox[{"#", ",", 
             FractionBox[
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"2", " ", "#2"}], "-", "1", "-", "r"}], ")"}], 
                RowBox[{"Last", "[", "#1", "]"}]}], " ", "-", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"#2", "-", "1"}], ")"}], 
                RowBox[{"#1", "\[LeftDoubleBracket]", 
                 RowBox[{"-", "2"}], "\[RightDoubleBracket]"}]}]}], "#2"]}], 
            "]"}], "&"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}], ",", 
          RowBox[{"Range", "[", "nmax", "]"}]}], "]"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Range", "[", "mmax", "]"}]}], "\[IndentingNewLine]", 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["Numerical Hankel Basis (n,m) List", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NHankelBasisNMList", " ", "=", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"nmax", ",", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"mmax", ",", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "_Complex"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"With", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r", " ", "=", " ", 
         SuperscriptBox[
          RowBox[{"Abs", "[", "z", "]"}], "2"]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"r", ">", "708."}], ",", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{"0.", ",", 
           RowBox[{"{", 
            RowBox[{"mmax", "+", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"nmax", "+", "1"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"NestList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"z", "*", "#"}], ")"}], "&"}], ",", "1", ",", "mmax"}], 
           "]"}], " ", "*", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"FoldList", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"With", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"m", "=", "#2"}], "}"}], ",", 
                RowBox[{"Fold", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Append", "[", 
                    RowBox[{"#1", ",", 
                    RowBox[{
                    RowBox[{"Last", "[", "#1", "]"}], " ", "+", "  ", 
                    "#2"}]}], "]"}], "&"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"First", "[", "#", "]"}], "}"}], ",", 
                  RowBox[{"Rest", "[", "#", "]"}]}], "]"}]}], "]"}], "&"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"Rest", "[", 
              RowBox[{"Fold", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Append", "[", 
                  RowBox[{"#", ",", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "#2"}], "-", "1", "-", "r"}], ")"}], 
                    RowBox[{"Last", "[", "#1", "]"}]}], " ", "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"#2", "-", "1"}], ")"}], " ", 
                    RowBox[{"#1", "\[LeftDoubleBracket]", 
                    RowBox[{"-", "2"}], "\[RightDoubleBracket]"}]}]}], 
                    "#2"]}], "]"}], "&"}], ",", " ", 
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  SuperscriptBox["\[ExponentialE]", 
                   RowBox[{
                    RowBox[{"-", "r"}], "/", "2"}]]}], "}"}], ",", 
                RowBox[{"Range", "[", "nmax", "]"}]}], "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Range", "[", "mmax", "]"}]}], "\[IndentingNewLine]", 
            "]"}], "/", 
           RowBox[{"\[Sqrt]", 
            RowBox[{"(", 
             RowBox[{"\[Pi]", " ", 
              RowBox[{"Transpose", "[", 
               RowBox[{
                RowBox[{"Partition", "[", 
                 RowBox[{
                  RowBox[{"FoldList", "[", 
                   RowBox[{"Times", ",", "1.", ",", 
                    RowBox[{"Range", "[", 
                    RowBox[{"nmax", "+", "mmax"}], "]"}]}], "]"}], ",", 
                  RowBox[{"mmax", "+", "1"}], ",", "1"}], "]"}], "/", 
                RowBox[{"FoldList", "[", 
                 RowBox[{"Times", ",", "1.", ",", 
                  RowBox[{"Range", "[", "nmax", "]"}]}], "]"}]}], "]"}]}], 
             ")"}]}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{"_", ",", "_", ",", "_"}], "]"}], ",", "_Complex", ",", 
         "2"}], "}"}]}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"],

Cell["Old version:", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NHankelHnmList", "=", " ", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"nmax", ",", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"mmax", ",", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", "_Complex"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"With", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r", " ", "=", " ", 
         SuperscriptBox[
          RowBox[{"Abs", "[", "z", "]"}], "2"]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"MapIndexed", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["z", 
             RowBox[{
              RowBox[{"First", "[", "#2", "]"}], "-", "1"}]], " ", "#1"}], 
           ")"}], "&"}], ",", "\[IndentingNewLine]", 
         RowBox[{"FoldList", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"With", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"m", "=", "#2"}], "}"}], ",", 
              RowBox[{"Fold", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Append", "[", 
                  RowBox[{"#1", ",", 
                   FractionBox[
                    RowBox[{
                    RowBox[{
                    SqrtBox[
                    RowBox[{"Last", "[", "#2", "]"}]], 
                    RowBox[{"Last", "[", "#1", "]"}]}], " ", "+", "  ", 
                    RowBox[{"First", "[", "#2", "]"}]}], 
                    SqrtBox[
                    RowBox[{
                    RowBox[{"Last", "[", "#2", "]"}], "+", "m"}]]]}], "]"}], 
                 "&"}], ",", 
                RowBox[{"{", 
                 FractionBox[
                  RowBox[{"First", "[", "#1", "]"}], 
                  SqrtBox["m"]], "}"}], ",", 
                RowBox[{"Transpose", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Rest", "[", "#1", "]"}], ",", 
                   RowBox[{"Range", "[", "nmax", "]"}]}], "}"}], "]"}]}], 
               "]"}]}], "]"}], "&"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Rest", "[", 
            RowBox[{"Fold", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Append", "[", 
                RowBox[{"#", ",", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", " ", "#2"}], "-", "1.", "-", "r"}], ")"}], 
                    RowBox[{"#1", "\[LeftDoubleBracket]", 
                    RowBox[{"-", "1"}], "\[RightDoubleBracket]"}]}], " ", "-",
                    " ", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"#2", "-", "1."}], ")"}], 
                    RowBox[{"#1", "\[LeftDoubleBracket]", 
                    RowBox[{"-", "2"}], "\[RightDoubleBracket]"}]}]}], 
                  "#2"]}], "]"}], "&"}], ",", " ", 
              RowBox[{"{", 
               RowBox[{"0", ",", 
                FractionBox["1", 
                 SqrtBox[
                  RowBox[{"\[Pi]", " ", 
                   SuperscriptBox["\[ExponentialE]", "r"]}]]]}], "}"}], ",", 
              RowBox[{"Range", "[", "nmax", "]"}]}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Range", "[", "mmax", "]"}]}], "\[IndentingNewLine]", 
          "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Fold", "[", 
          RowBox[{"_", ",", "_", ",", "_"}], "]"}], ",", "_Real", ",", "1"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FoldList", "[", 
          RowBox[{"_", ",", "_", ",", "_"}], "]"}], ",", "_Real", ",", "2"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"r", ",", "_Real"}], "}"}]}], "}"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["Hankel Basis Radius", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HankelBasisRadius", "[", 
    RowBox[{"n_", ",", 
     RowBox[{"m_:", "0"}], ",", 
     RowBox[{"t_:", "DefaultScaleParameter"}]}], "]"}], " ", "=", 
   SqrtBox[
    RowBox[{"4", "t", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", "n"}], "+", "m", "+", "1"}], ")"}]}]]}], 
  ";"}]], "PackageInput",
 CellChangeTimes->{3.462295747388691*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Polar Fourier Scale", "Subsection"],

Cell["For explanation, see Polar Fourier.", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PolarFourierScale", "[", 
    RowBox[{"dims", ":", 
     RowBox[{"{", 
      RowBox[{"_Integer", ",", "_Integer"}], "}"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", " ", "=", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Min", "[", "dims", "]"}], "-", "1"}], ")"}], "/", "2"}]}], 
      "}"}], ",", "\[IndentingNewLine]", 
     FractionBox[
      SuperscriptBox["r", "2"], 
      RowBox[{"4", 
       RowBox[{"(", " ", 
        RowBox[{
         RowBox[{
          SqrtBox["2"], " ", "r"}], "-", "1"}], ")"}]}]]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput",
 CellChangeTimes->{3.462295753332316*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Polar Fourier n-Maximum", "Subsection"],

Cell["For explanation, see Polar Fourier.", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PolarFourierNMax", "[", 
    RowBox[{
     RowBox[{"t", ":", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "Positive"}], "|", "Automatic"}], ")"}], ":", 
       "Automatic"}]}], ",", 
     RowBox[{"dims", ":", 
      RowBox[{"{", 
       RowBox[{"_Integer", ",", "_Integer"}], "}"}]}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", " ", "=", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Min", "[", "dims", "]"}], "-", "1"}], ")"}], "/", "2"}]}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Round", "[", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"t", "===", "Automatic"}], ",", 
        RowBox[{
         FractionBox["r", 
          SqrtBox["2"]], "-", "1"}], ",", 
        FractionBox[
         RowBox[{
          SuperscriptBox["r", "2"], "-", 
          RowBox[{"4", " ", "t"}]}], 
         RowBox[{"8", " ", "t"}]]}], "]"}], "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "PackageInput",
 CellChangeTimes->{3.462295759389291*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Polar Fourier", "Subsection"],

Cell[TextData[{
 "For the polar Fourier transformation we have to observe two boundary \
conditions. First, the domain of the Hankel basis function should stay within \
the support of the data or image, hence HankelBasisRadius[n,0,t]\[Equal]r. \
Second, the Nyquist frequency in the radial direction is roughly ",
 Cell[BoxData[
  FractionBox[
   RowBox[{"n", "+", "1"}], "r"]]],
 "and should stay \[GreaterEqual] ",
 Cell[BoxData[
  RowBox[{"1", "/", 
   SqrtBox["2"]}]]],
 ". Last but not least, for an even sampling density in angular and radial \
direction we set  ",
 Cell[BoxData[
  RowBox[{"m", "=", 
   RowBox[{
    SqrtBox["2"], "\[Pi]", " ", "n"}]}]]],
 "."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"HankelBasisRadius", "[", 
        RowBox[{"n", ",", "0", ",", "t"}], "]"}], "\[Equal]", "r"}], ",", " ", 
      RowBox[{
       FractionBox[
        RowBox[{"n", "+", "1"}], "r"], "==", 
       FractionBox["1", 
        SqrtBox["2"]]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "r"}], "}"}]}], "]"}], "//", "Simplify"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"t", "\[Rule]", 
     FractionBox[
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "+", "n"}], ")"}], "2"], 
      RowBox[{"2", "+", 
       RowBox[{"4", " ", "n"}]}]]}], ",", 
    RowBox[{"r", "\[Rule]", 
     RowBox[{
      SqrtBox["2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "n"}], ")"}]}]}]}], "}"}], "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"HankelBasisRadius", "[", 
        RowBox[{"n", ",", "0", ",", "t"}], "]"}], "\[Equal]", "r"}], ",", " ", 
      RowBox[{
       FractionBox[
        RowBox[{"n", "+", "1"}], "r"], "==", 
       FractionBox["1", 
        SqrtBox["2"]]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "n"}], "}"}]}], "]"}], "//", "Simplify"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"t", "\[Rule]", 
     FractionBox[
      SuperscriptBox["r", "2"], 
      RowBox[{
       RowBox[{"-", "4"}], "+", 
       RowBox[{"4", " ", 
        SqrtBox["2"], " ", "r"}]}]]}], ",", 
    RowBox[{"n", "\[Rule]", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      FractionBox["r", 
       SqrtBox["2"]]}]}]}], "}"}], "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"PolarFourier", "::", "scalefail"}], " ", "=", " ", 
  "\"\<Scale `1` too small to support Hankel basis function for n up to \
`2`.\>\""}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PolarFourier", "::", "scalechoice"}], " ", "=", " ", 
  "\"\<Choosing scale `1` for the Hankel basis.\>\""}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Off", "[", 
   RowBox[{"PolarFourier", "::", "scalechoice"}], "]"}], 
  ";"}]}], "PackageInput"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PolarFourier", "[", 
     RowBox[{"img_List", ",", 
      RowBox[{"nmax", ":", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"_Integer", "?", "NonNegative"}], "|", "Automatic"}], ")"}],
         ":", "Automatic"}]}], ",", 
      RowBox[{"mmax", ":", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"_Integer", "?", "NonNegative"}], "|", "Automatic"}], ")"}],
         ":", "Automatic"}]}]}], "]"}], " ", ":=", 
    RowBox[{
     RowBox[{"PolarFourier", "[", 
      RowBox[{"DefaultScaleParameter", ",", 
       RowBox[{"\[Pi]", "/", "2"}]}], "]"}], "[", 
     RowBox[{"img", ",", "nmax", ",", "mmax"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PolarFourier", "[", 
     RowBox[{
      RowBox[{"t_:", "DefaultScaleParameter"}], ",", 
      RowBox[{"\[Alpha]_:", 
       RowBox[{"\[Pi]", "/", "2"}]}]}], "]"}], "[", 
    RowBox[{"img_List", ",", 
     RowBox[{"nmax", ":", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_Integer", "?", "NonNegative"}], "|", "Automatic"}], ")"}], 
       ":", "Automatic"}]}], ",", 
     RowBox[{"mmax", ":", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_Integer", "?", "NonNegative"}], "|", "Automatic"}], ")"}], 
       ":", "Automatic"}]}]}], "]"}], " ", ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"xmax", ",", "ymax", ",", " ", "filter", ",", 
       RowBox[{"r", " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Min", "[", 
            RowBox[{"Dimensions", "[", "img", "]"}], "]"}], "-", "1"}], ")"}],
          "/", "2."}]}], ",", "tt", ",", "nn", ",", "mm"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"nmax", "===", "Automatic"}], ",", 
        RowBox[{"nn", " ", "=", 
         RowBox[{"PolarFourierNMax", "[", 
          RowBox[{"t", ",", 
           RowBox[{"Dimensions", "[", "img", "]"}]}], "]"}]}], ",", 
        RowBox[{"nn", "=", "nmax"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"mmax", "===", "Automatic"}], ",", 
        RowBox[{"mm", " ", "=", 
         RowBox[{"Round", "[", 
          RowBox[{
           FractionBox["\[Pi]", 
            SqrtBox["2"]], " ", "nn"}], "]"}]}], ",", 
        RowBox[{"mm", "=", "mmax"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"t", "===", "Automatic"}], ",", 
        RowBox[{
         RowBox[{"tt", " ", "=", " ", 
          RowBox[{"N", "[", 
           RowBox[{"PolarFourierScale", "[", 
            RowBox[{"Dimensions", "[", "img", "]"}], "]"}], "]"}]}], ";", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"PolarFourier", "::", "scalechoice"}], ",", "tt"}], 
          "]"}]}], ",", 
        RowBox[{"tt", "=", 
         RowBox[{"N", "[", "t", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      
      RowBox[{
       RowBox[{"{", 
        RowBox[{"xmax", ",", "ymax"}], "}"}], " ", "=", " ", 
       FractionBox[
        RowBox[{
         RowBox[{"Dimensions", "[", "img", "]"}], "-", "1"}], 
        RowBox[{"2", 
         SqrtBox[
          RowBox[{"2", "tt"}]]}]]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox[
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"nn", "+", "1"}], ")"}], "2"], 
           RowBox[{
            RowBox[{"4", " ", "nn"}], "+", "2"}]], "-", 
          FractionBox["1", "8"]}], ">", " ", "tt"}], ",", " ", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"PolarFourier", "::", "scalefail"}], ",", "tt", ",", "nn"}],
          "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"filter", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"NHankelBasisNMList", "[", 
          RowBox[{"nn", ",", "mm", ",", 
           RowBox[{"x", "+", 
            RowBox[{"\[ImaginaryI]", " ", "y"}]}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", 
           RowBox[{"-", "xmax"}], ",", "xmax", ",", 
           RowBox[{"1", "/", 
            SqrtBox[
             RowBox[{"2", "tt"}]]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"y", ",", 
           RowBox[{"-", "ymax"}], ",", "ymax", ",", 
           RowBox[{"1", "/", 
            SqrtBox[
             RowBox[{"2", "tt"}]]}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"\[Alpha]", "\[NotEqual]", "0"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"\[ImaginaryI]", " ", "\[Alpha]", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", "n"}], "+", 
               RowBox[{"Abs", "[", "m", "]"}]}], ")"}]}]], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", "0", ",", "nn"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"m", ",", 
             RowBox[{"-", "mm"}], ",", "mm"}], "}"}]}], "]"}], ",", "1"}], 
        "]"}], " ", "*", " ", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"Chop", "[", 
          RowBox[{"If", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"FreeQ", "[", 
             RowBox[{"img", ",", "Complex"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"Conjugate", "[", 
                 RowBox[{"Reverse", "[", 
                  RowBox[{"Rest", "[", "#", "]"}], "]"}], "]"}], ",", "#"}], 
               "]"}], "&"}], "[", 
             RowBox[{
              RowBox[{"Flatten", "[", "img", "]"}], ".", 
              RowBox[{"Flatten", "[", 
               RowBox[{"filter", ",", "1"}], "]"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Flatten", "[", "img", "]"}], ".", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Join", "[", 
                 RowBox[{
                  RowBox[{"Conjugate", "[", 
                   RowBox[{"Reverse", "[", 
                    RowBox[{"Rest", "[", "#", "]"}], "]"}], "]"}], ",", "#"}],
                  "]"}], "&"}], ",", 
               RowBox[{"Flatten", "[", 
                RowBox[{"filter", ",", "1"}], "]"}], ",", 
               RowBox[{"{", "1", "}"}]}], "]"}]}]}], "\[IndentingNewLine]", 
           "]"}], "]"}], "]"}], "/", 
        SqrtBox[
         RowBox[{"2", "tt"}]]}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Inverse Polar Fourier", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"InversePolarFourier", "::", "scalefail"}], " ", "=", " ", 
  "\"\<Scale `1` too small to support Hankel basis function for n up to \
`2`.\>\""}]], "PackageInput"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"InversePolarFourier", "[", 
     RowBox[{"coeff_List", ",", 
      RowBox[{"dims", ":", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "Automatic"}], "}"}]}]}], "]"}], " ", ":=", 
    
    RowBox[{
     RowBox[{"InversePolarFourier", "[", 
      RowBox[{"DefaultScaleParameter", ",", 
       RowBox[{"\[Pi]", "/", "2"}]}], "]"}], "[", 
     RowBox[{"coeff", ",", "dims"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"InversePolarFourier", "[", 
     RowBox[{
      RowBox[{"t_:", "DefaultScaleParameter"}], ",", 
      RowBox[{"\[Alpha]_:", "-", 
       RowBox[{"\[Pi]", "/", "2"}]}]}], "]"}], "[", 
    RowBox[{"coeff_List", ",", "\[IndentingNewLine]", 
     RowBox[{"dims", ":", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"_Integer", "?", "Positive"}], "|", "Automatic"}], ",", 
         RowBox[{
          RowBox[{"_Integer", "?", "Positive"}], "|", "Automatic"}]}], "}"}], 
       ":", 
       RowBox[{"{", 
        RowBox[{"Automatic", ",", "Automatic"}], "}"}]}]}]}], "]"}], " ", ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "conjfilter", ",", "fourierCoeff", ",", "xn", ",", "yn", ",", "nmax", 
       ",", "mmax", ",", "xmax", ",", " ", "ymax", ",", "r", ",", "tt"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"xn", ",", "yn"}], "}"}], "=", "dims"}], ";", 
      RowBox[{"r", " ", "=", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Min", "[", 
           RowBox[{"{", 
            RowBox[{"xn", ",", "yn"}], "}"}], "]"}], "-", "1"}], ")"}], "/", 
        "2"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"nmax", ",", "mmax"}], "}"}], " ", "=", " ", 
       RowBox[{
        RowBox[{"Dimensions", "[", "coeff", "]"}], "-", "1"}]}], ";", 
      RowBox[{"mmax", " ", "/=", "2"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Not", "[", 
         RowBox[{"FreeQ", "[", 
          RowBox[{"r", ",", "Automatic"}], "]"}], "]"}], ",", 
        RowBox[{"r", " ", "=", " ", 
         RowBox[{
          SqrtBox["2"], 
          RowBox[{"(", 
           RowBox[{"nmax", "+", "1"}], ")"}]}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"t", "===", "Automatic"}], ",", 
        RowBox[{"tt", " ", "=", " ", 
         RowBox[{"N", "[", 
          FractionBox[
           SuperscriptBox["r", "2"], 
           RowBox[{"4", 
            RowBox[{"(", " ", 
             RowBox[{
              RowBox[{
               SqrtBox["2"], " ", "r"}], "-", "1"}], ")"}]}]], "]"}]}], ",", 
        RowBox[{"tt", "=", 
         RowBox[{"N", "[", "t", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"xn", "===", "Automatic"}], ",", 
        RowBox[{"xmax", "=", 
         FractionBox[
          RowBox[{"Round", "[", 
           RowBox[{"2", "r"}], "]"}], 
          RowBox[{"2", 
           SqrtBox[
            RowBox[{"2", "tt"}]]}]]}], ",", 
        RowBox[{"xmax", "=", 
         FractionBox[
          RowBox[{"xn", "-", "1"}], 
          RowBox[{"2", 
           SqrtBox[
            RowBox[{"2", "tt"}]]}]]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"yn", "===", "Automatic"}], ",", 
        RowBox[{"ymax", "=", 
         FractionBox[
          RowBox[{"Round", "[", 
           RowBox[{"2", "r"}], "]"}], 
          RowBox[{"2", 
           SqrtBox[
            RowBox[{"2", "tt"}]]}]]}], ",", 
        RowBox[{"ymax", "=", 
         FractionBox[
          RowBox[{"yn", "-", "1"}], 
          RowBox[{"2", 
           SqrtBox[
            RowBox[{"2", "tt"}]]}]]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox[
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"nmax", "+", "1"}], ")"}], "2"], 
           RowBox[{
            RowBox[{"4", " ", "nmax"}], "+", "2"}]], "-", 
          FractionBox["1", "8"]}], ">", " ", "tt"}], ",", " ", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"InversePolarFourier", "::", "scalefail"}], ",", "tt", ",", 
          "nmax"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"conjfilter", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"NHankelBasisNMList", "[", 
          RowBox[{"nmax", ",", "mmax", ",", 
           RowBox[{"x", "-", 
            RowBox[{"\[ImaginaryI]", " ", "y"}]}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", 
           RowBox[{"-", "xmax"}], ",", "xmax", ",", 
           FractionBox["1", 
            SqrtBox[
             RowBox[{"2", "tt"}]]]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"y", ",", 
           RowBox[{"-", "ymax"}], ",", "ymax", ",", 
           FractionBox["1", 
            SqrtBox[
             RowBox[{"2", "tt"}]]]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"fourierCoeff", "=", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"\[Alpha]", "\[NotEqual]", "0"}], ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"\[ImaginaryI]", " ", "\[Alpha]", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", "n"}], "+", 
                RowBox[{"Abs", "[", "m", "]"}]}], ")"}]}]], ",", 
            RowBox[{"{", 
             RowBox[{"m", ",", 
              RowBox[{"-", "mmax"}], ",", "mmax"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", "0", ",", "nmax"}], "}"}]}], "]"}], ",", "1"}],
          "]"}], "*", 
        RowBox[{"Transpose", "[", "coeff", "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Chop", "[", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Conjugate", "[", 
             RowBox[{"Reverse", "[", 
              RowBox[{"Take", "[", 
               RowBox[{"fourierCoeff", ",", "mmax"}], "]"}], "]"}], "]"}], "===", 
            RowBox[{"Take", "[", 
             RowBox[{"fourierCoeff", ",", 
              RowBox[{"-", "mmax"}]}], "]"}]}], ";", "False"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Re", "[", 
           RowBox[{
            RowBox[{"Map", "[", 
             RowBox[{"Flatten", ",", "conjfilter", ",", 
              RowBox[{"{", "2", "}"}]}], "]"}], ".", 
            RowBox[{"Flatten", "[", 
             RowBox[{
              RowBox[{"Prepend", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{"2", ",", 
                  RowBox[{"{", "mmax", "}"}]}], "]"}], ",", "1"}], "]"}], " ", 
              RowBox[{"Take", "[", 
               RowBox[{"fourierCoeff", ",", 
                RowBox[{
                 RowBox[{"-", "mmax"}], "-", "1"}]}], "]"}]}], "]"}]}], "]"}],
           ",", "\[IndentingNewLine]", " ", 
          RowBox[{
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Flatten", "[", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"Conjugate", "[", 
                  RowBox[{"Reverse", "[", 
                   RowBox[{"Rest", "[", "#", "]"}], "]"}], "]"}], ",", "#"}], 
                "]"}], "]"}], "&"}], ",", "conjfilter", ",", 
             RowBox[{"{", "2", "}"}]}], "]"}], ".", 
           RowBox[{"Flatten", "[", "fourierCoeff", "]"}]}]}], 
         "\[IndentingNewLine]", "]"}], "]"}], "/", 
       SqrtBox[
        RowBox[{"2", "tt"}]]}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Rotate Polar Fourier Phase", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RotatePolarFourierPhase", "[", 
    RowBox[{"coeff_List", ",", 
     RowBox[{"\[Alpha]_:", 
      RowBox[{"\[Pi]", "/", "2"}]}]}], "]"}], " ", ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"nmax", " ", ",", "mmax"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"mmax", ",", "nmax"}], "}"}], " ", "=", " ", 
       RowBox[{
        RowBox[{"Dimensions", "[", "coeff", "]"}], "-", "1"}]}], ";", 
      RowBox[{"mmax", " ", "/=", "2"}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "n"}], "+", 
             RowBox[{"Abs", "[", "m", "]"}]}], ")"}], "\[Alpha]"}]], ",", 
         RowBox[{"{", 
          RowBox[{"m", ",", 
           RowBox[{"-", "mmax"}], ",", "mmax"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", "0", ",", "nmax"}], "}"}]}], "]"}], " ", "*", " ",
        "coeff"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput",\

 CellChangeTimes->{3.4622957921415987`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Centered Fourier", "Subsection"],

Cell["There is a bug here!", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CenteredFourier", "[", 
    RowBox[{"img_", "?", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"ArrayQ", "[", 
        RowBox[{"#", ",", "_", ",", "NumericQ"}], "]"}], "&"}], ")"}]}], 
    "]"}], ":=", " ", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"dims", "=", 
        RowBox[{"Dimensions", "[", "img", "]"}]}], ",", " ", 
       RowBox[{"shifts", " ", "=", " ", 
        RowBox[{"Floor", "[", 
         RowBox[{
          RowBox[{"Dimensions", "[", "img", "]"}], "/", "2"}], "]"}]}]}], 
      "}"}], ",", "\[IndentingNewLine]", " ", 
     RowBox[{"RotateRight", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Array", "[", 
         RowBox[{
          RowBox[{
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]", "  ", 
               RowBox[{"shifts", "/", "dims"}]}], ")"}], ".", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"{", "##", "}"}], "-", "1"}], ")"}]}]], "&"}], ",", 
          "dims"}], "]"}], " ", 
        RowBox[{"Fourier", "[", "img", "]"}]}], ",", "shifts"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Inverse Centered Fourier", "Subsection"],

Cell["There is a bug here!", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InverseCenteredFourier", "[", 
    RowBox[{"img_", "?", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"ArrayQ", "[", 
        RowBox[{"#", ",", "_", ",", "NumericQ"}], "]"}], "&"}], ")"}]}], 
    "]"}], " ", ":=", " ", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"dims", "=", 
        RowBox[{"Dimensions", "[", "img", "]"}]}], ",", 
       RowBox[{"shifts", " ", "=", " ", 
        RowBox[{"Floor", "[", 
         RowBox[{
          RowBox[{"Dimensions", "[", "img", "]"}], "/", "2"}], "]"}]}]}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"InverseFourier", "[", 
      RowBox[{
       RowBox[{"Array", "[", 
        RowBox[{
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"shifts", "/", "dims"}], ")"}], ".", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"{", "##", "}"}], "-", "1"}], ")"}]}]}]], "&"}], ",", 
         "dims"}], "]"}], " ", 
       RowBox[{"RotateLeft", "[", 
        RowBox[{"img", ",", "shifts"}], "]"}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "HankelTransform", ",", "\[IndentingNewLine]", "InverseHankelTransform",
        ",", "\[IndentingNewLine]", "GaussHankelCoefficient", ",", 
       "\[IndentingNewLine]", "HalfGaussHankelCoefficient", ",", 
       "\[IndentingNewLine]", "HankelBasis", ",", "\[IndentingNewLine]", 
       "NHankelBasis", ",", "\[IndentingNewLine]", "HankelBasisEigenvalue", 
       ",", "\[IndentingNewLine]", "HankelBasisNList", ",", 
       "\[IndentingNewLine]", "NHankelBasisNList", ",", "\[IndentingNewLine]",
        "HankelBasisNMList", ",", "\[IndentingNewLine]", "NHankelBasisNMList",
        ",", "\[IndentingNewLine]", "HankelBasisRadius", ",", 
       "\[IndentingNewLine]", "PolarFourierScale", ",", "\[IndentingNewLine]",
        "PolarFourierNMax", ",", "\[IndentingNewLine]", "PolarFourier", ",", 
       "\[IndentingNewLine]", "InversePolarFourier", ",", 
       "\[IndentingNewLine]", "RotatePolarFourierPhase", ",", 
       "\[IndentingNewLine]", "CenteredFourier", ",", "\[IndentingNewLine]", 
       "InverseCenteredFourier"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", "Protected", "}"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.4622940292236443`*^9, 3.462294029954545*^9}, {
  3.46339318184687*^9, 3.463393183029153*^9}, {3.464082975259639*^9, 
  3.464082976544733*^9}}]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1280, 976},
WindowMargins->{{5, Automatic}, {Automatic, 0}},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (November 10, 2008)",
StyleDefinitions->"PackageNotebook.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 40, 0, 144, "Title"],
Cell[610, 24, 216, 6, 118, "Subsubtitle"],
Cell[CellGroupData[{
Cell[851, 34, 25, 0, 72, "Section"],
Cell[879, 36, 1023, 26, 3309, "PackageInput"],
Cell[1905, 64, 128, 3, 438, "Text"],
Cell[2036, 69, 3242, 89, 8811, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5315, 163, 32, 0, 40, "Section"],
Cell[5350, 165, 92, 2, 130, "Text"],
Cell[5445, 169, 952, 18, 670, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[6434, 192, 42, 0, 40, "Section"],
Cell[6479, 194, 10067, 198, 4152, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[16583, 397, 31, 0, 40, "Section"],
Cell[16617, 399, 60, 0, 39, "Text"],
Cell[16680, 401, 108, 2, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[16813, 407, 38, 0, 63, "Subsection"],
Cell[16854, 409, 155, 7, 195, "Text"],
Cell[17012, 418, 1583, 45, 810, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[18632, 468, 46, 0, 37, "Subsection"],
Cell[18681, 470, 1671, 47, 924, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[20389, 522, 45, 0, 37, "Subsection"],
Cell[20437, 524, 491, 15, 256, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[20965, 544, 112, 1, 37, "Subsection"],
Cell[21080, 547, 5076, 126, 3606, "PackageInput"],
Cell[26159, 675, 4247, 116, 5409, "PackageInput"],
Cell[30409, 793, 6237, 147, 5649, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[36683, 945, 167, 2, 37, "Subsection"],
Cell[36853, 949, 3477, 80, 195, "PackageInput"],
Cell[40333, 1031, 4390, 110, 288, "PackageInput"],
Cell[44726, 1143, 3977, 112, 513, "PackageInput"],
Cell[48706, 1257, 4042, 117, 540, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[52785, 1379, 34, 0, 37, "Subsection"],
Cell[52822, 1381, 4166, 126, 450, "PackageInput"],
Cell[56991, 1509, 28, 0, 39, "Text"],
Cell[57022, 1511, 683, 23, 74, "Input",
 Evaluatable->False],
Cell[57708, 1536, 262, 8, 42, "Input",
 Evaluatable->False],
Cell[57973, 1546, 564, 20, 75, "Input",
 Evaluatable->False]
}, Closed]],
Cell[CellGroupData[{
Cell[58574, 1571, 37, 0, 37, "Subsection"],
Cell[58614, 1573, 1768, 57, 4828, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[60419, 1635, 44, 0, 37, "Subsection"],
Cell[60466, 1637, 3400, 98, 2058, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[63903, 1740, 47, 0, 37, "Subsection"],
Cell[63953, 1742, 2896, 80, 2857, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[66886, 1827, 41, 0, 37, "Subsection"],
Cell[66930, 1829, 104, 5, 130, "Text"],
Cell[67037, 1836, 1386, 42, 249, "Output"],
Cell[68426, 1880, 5512, 162, 2539, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[73975, 2047, 51, 0, 37, "Subsection"],
Cell[74029, 2049, 7961, 199, 17362, "PackageInput"],
Cell[81993, 2250, 27, 0, 657, "Text"],
Cell[82023, 2252, 3050, 83, 6468, "Input",
 Evaluatable->False]
}, Closed]],
Cell[CellGroupData[{
Cell[85110, 2340, 45, 0, 37, "Subsection"],
Cell[85158, 2342, 104, 5, 130, "Text"],
Cell[85265, 2349, 985, 31, 252, "Output"],
Cell[86253, 2382, 2707, 68, 1248, "PackageInput"],
Cell[88963, 2452, 28, 0, 130, "Text"],
Cell[88994, 2454, 2952, 81, 1593, "Input",
 Evaluatable->False]
}, Closed]],
Cell[CellGroupData[{
Cell[91983, 2540, 55, 0, 37, "Subsection"],
Cell[92041, 2542, 4502, 112, 3496, "PackageInput"],
Cell[96546, 2656, 28, 0, 195, "Text"],
Cell[96577, 2658, 4265, 110, 3516, "Input",
 Evaluatable->False]
}, Closed]],
Cell[CellGroupData[{
Cell[100879, 2773, 41, 0, 37, "Subsection"],
Cell[100923, 2775, 395, 13, 1167, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[101355, 2793, 41, 0, 37, "Subsection"],
Cell[101399, 2795, 51, 0, 657, "Text"],
Cell[101453, 2797, 801, 25, 4104, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[102291, 2827, 45, 0, 37, "Subsection"],
Cell[102339, 2829, 51, 0, 657, "Text"],
Cell[102393, 2831, 1185, 37, 3921, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[103615, 2873, 35, 0, 37, "Subsection"],
Cell[103653, 2875, 679, 19, 1822, "Text"],
Cell[CellGroupData[{
Cell[104357, 2898, 469, 15, 1203, "Input"],
Cell[104829, 2915, 420, 15, 1066, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[105286, 2935, 469, 15, 1203, "Input"],
Cell[105758, 2952, 407, 15, 1167, "Output"]
}, Open  ]],
Cell[106180, 2970, 471, 11, 2215, "PackageInput"],
Cell[106654, 2983, 6972, 190, 13185, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[113663, 3178, 43, 0, 37, "Subsection"],
Cell[113709, 3180, 197, 4, 1431, "PackageInput"],
Cell[113909, 3186, 8063, 223, 16749, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[122009, 3414, 48, 0, 37, "Subsection"],
Cell[122060, 3416, 1259, 34, 2571, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[123356, 3455, 38, 0, 37, "Subsection"],
Cell[123397, 3457, 36, 0, 657, "Text"],
Cell[123436, 3459, 1361, 38, 2979, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[124834, 3502, 46, 0, 37, "Subsection"],
Cell[124883, 3504, 36, 0, 657, "Text"],
Cell[124922, 3506, 1328, 37, 2979, "PackageInput"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[126299, 3549, 34, 0, 40, "Section"],
Cell[126336, 3551, 64, 0, 130, "Text"],
Cell[126403, 3553, 1658, 30, 2146, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
