(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    355071,       9797]
NotebookOptionsPosition[    346369,       9570]
NotebookOutlinePosition[    346966,       9593]
CellTagsIndexPosition[    346923,       9590]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Image Interpolation Package", "Title"],

Cell["\<\
Markus van Almsick
Technische Universiteit Eindhoven
\[Copyright]2009\
\>", "Subsubtitle"],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
    "TimeStamp", "[", "\"\<MathVisionTools`ImageInterpolation`\>\"", "]"}], 
    "=", 
    RowBox[{"{", 
     RowBox[{"2010", ",", "8", ",", "26", ",", "10", ",", "22", ",", "0"}], 
     "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput",
 CellChangeTimes->{{3.491799764759226*^9, 3.4917997770053253`*^9}}],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", "MathVisionTools`ImageInterpolation`"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Author", ":", 
     RowBox[{"Markus", " ", "van", " ", "Almsick"}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", 
      RowBox[{"M", ".", "v", ".", 
       RowBox[{"Almsick", "@", "tue"}], ".", "nl"}]}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", "MathVisionTools`ImageInterpolation`"}]}], "*)"}],
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", "2.2"}]}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", "7"}]}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", 
      RowBox[{"Copyright", " ", "2009"}]}]}], ",", 
    RowBox[{"Technische", " ", "Universiteit", " ", "Eindhoven"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Title", ":", 
     RowBox[{"Image", " ", "Transformation"}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", 
     RowBox[{
     "This", " ", "package", " ", "implements", " ", "linear", " ", "and", 
      " ", "cubic", " ", "interpolation", " ", "schemes"}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", "Interpolation"}]}], ",", "BSpline"}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", "None"}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":", "None"}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"September", " ", "2008"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", 
      RowBox[{
      "Version", " ", "2.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"November", " ", "2008"}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":"}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], "*)"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{3.491799780047378*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<MathVisionTools`ImageInterpolation`\>\"", ",", " ", 
    RowBox[{
    "{", "\"\<MathVisionTools`Common`MathVisionToolsCommon`\>\"", "}"}]}], 
   "]"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"Unprotect", "[", "\[IndentingNewLine]", 
  RowBox[{
  "ImageInterpolation", ",", "\[IndentingNewLine]", "InterpolatingImage", ",",
    "\[IndentingNewLine]", "NBSplineInterpolationFilter1D", ",", 
   "\[IndentingNewLine]", "BSplineInterpolationFilter1D", ",", 
   "\[IndentingNewLine]", "BSplineInterpolationFilter"}], 
  "\[IndentingNewLine]", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ImageInterpolation", "::", "usage"}], "=", 
    "\[IndentingNewLine]", 
    "\"\<ImageInterpolation[array] constructs an InterpolatingImage object, \
which represents a function that interpolates the 1-, 2-, or 3-dimensional \
image array with B-splines of \
1\!\(TraditionalForm\`\*SuperscriptBox[\(\[Null]\), \(st\)]\), \
3\!\(TraditionalForm\`\*SuperscriptBox[\(\[Null]\), \(rd\)]\), \
5\!\(TraditionalForm\`\*SuperscriptBox[\(\[Null]\), \(th\)]\), \
7\!\(TraditionalForm\`\*SuperscriptBox[\(\[Null]\), \(th\)]\), or \
9\!\(TraditionalForm\`\*SuperscriptBox[\(\[Null]\), \(th\)]\) order. The \
variables of the interpolating function are in the order x, y, and z. The \
default is set to InterpolationOrder \[Rule] 3. The option ImageBoundary is \
also supported.\nImageInterpolation[array, off] constructs an \
InterpolatingImage function that returns off  if sampled outside the image \
domain. The default off-value is 0.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"InterpolatingImage", "::", "usage"}], "=", " ", 
    "\"\<InterpolatingImage[domain, order, boundary, table] represents a 1-, \
2-, or 3-dimensional image function whose values are found by interpolation \
with B-spline of 1\!\(TraditionalForm\`\*SuperscriptBox[\(\[Null]\), \
\(st\)]\), 3\!\(TraditionalForm\`\*SuperscriptBox[\(\[Null]\), \(rd\)]\), 5\!\
\(TraditionalForm\`\*SuperscriptBox[\(\[Null]\), \(th\)]\), \
7\!\(TraditionalForm\`\*SuperscriptBox[\(\[Null]\), \(th\)]\), or \
9\!\(TraditionalForm\`\*SuperscriptBox[\(\[Null]\), \(th\)]\) order.\>\""}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NBSplineInterpolationFilter1D", "::", "usage"}], "=", 
    "\"\<For internal use only.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BSplineInterpolationFilter1D", "::", "usage"}], "=", 
    "\"\<For internal use only.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter", "::", "usage"}], "=", 
   "\"\<BSplineInterpolationFilter[rank,{orders},{boundaries}][data] performs \
a B-spline preprocessing filter on image data. Parameter rank determines the \
number of dimensions that will be filter with the respective B-spline orders \
and boundary conditions.\>\""}], ";"}]}], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.4917978580951157`*^9, 3.491797898109498*^9}, {
   3.491799675281252*^9, 3.491799698912322*^9}, 3.4917997465993547`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["NBSplineInterpolationFilter1D", "Subsection"],

Cell[BoxData[
 RowBox[{"NBSplineInterpolationFilter1D", "[", 
  RowBox[{"{", 
   RowBox[{"bsplineOrder", ",", "boundaryType", ",", "boundaryWidth"}], "}"}],
   "]"}]], "Input"],

Cell[CellGroupData[{

Cell["Monic", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Reflective", ",", 
      RowBox[{"w_Integer:", "1"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ArrayPad", "[", 
     RowBox[{"#", ",", "w", ",", "\"\<Reversed\>\""}], "]"}], "&"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Cyclic", ",", 
      RowBox[{"w_Integer:", "1"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ArrayPad", "[", 
     RowBox[{"#", ",", "w", ",", "\"\<Cyclic\>\""}], "]"}], "&"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Constant", ",", 
      RowBox[{"w_Integer:", "1"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ArrayPad", "[", 
     RowBox[{"#", ",", "w", ",", "\"\<Fixed\>\""}], "]"}], "&"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"c_", "?", "NumberQ"}], ",", 
      RowBox[{"w_Integer:", "1"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ArrayPad", "[", 
     RowBox[{"#", ",", "w", ",", "c"}], "]"}], "&"}]}], ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Cubic", "Subsubsection"],

Cell["Root of the filter:", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Alpha]", "=", 
   RowBox[{
    RowBox[{"-", "2"}], "+", 
    SqrtBox["3"]}]}], ";"}]], "Input"],

Cell["Merging function:", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    FractionBox["\[Alpha]", 
     RowBox[{
      SuperscriptBox["\[Alpha]", "2"], "-", "1"}]], "*", 
    RowBox[{"(", 
     RowBox[{"#1", "+", 
      RowBox[{"Reverse", "[", "#2", "]"}], "-", "img"}], ")"}]}], ")"}], 
  "&"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"3", ",", "Reflective", ",", 
      RowBox[{"w_Integer:", "2"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Alpha]", "=", 
          RowBox[{"-", "0.2679491924311228`"}]}], ",", 
         RowBox[{"nmax", "=", "12"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"ArrayPad", "[", 
          RowBox[{"#", ",", "w", ",", "\"\<Reversed\>\""}], "]"}], "&"}], "[",
         "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"0.28867513459481303`", "*", 
              RowBox[{"(", 
               RowBox[{"#1", "+", 
                RowBox[{"Reverse", "[", "#2", "]"}], "-", "img"}], ")"}]}], 
             ")"}], "&"}], "[", "\[IndentingNewLine]", 
           RowBox[{"#", ",", "\[IndentingNewLine]", 
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
               ",", 
               RowBox[{"Last", "[", "#", "]"}], ",", 
               RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}]}], 
           "\[IndentingNewLine]", "]"}], "&"}], "[", 
         RowBox[{"Drop", "[", 
          RowBox[{
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", "0", ",", 
             RowBox[{"ArrayPad", "[", 
              RowBox[{"img", ",", 
               RowBox[{"{", 
                RowBox[{"nmax", ",", "0"}], "}"}], ",", "\"\<Reversed\>\""}], 
              "]"}]}], "]"}], ",", 
           RowBox[{"nmax", "+", "1"}]}], "]"}], "]"}], "\[IndentingNewLine]", 
        "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"3", ",", "Cyclic", ",", 
      RowBox[{"w_Integer:", "2"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Alpha]", "=", 
          RowBox[{"-", "0.2679491924311228`"}]}], ",", 
         RowBox[{"nmax", "=", "12"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"ArrayPad", "[", 
          RowBox[{"#", ",", "w", ",", "\"\<Cyclic\>\""}], "]"}], "&"}], "[", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"0.28867513459481303`", "*", 
            RowBox[{"(", 
             RowBox[{"#1", "+", 
              RowBox[{"Reverse", "[", "#2", "]"}], "-", "img"}], ")"}]}], 
           ")"}], "&"}], "[", 
         RowBox[{
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{"img", ",", 
                RowBox[{"{", 
                 RowBox[{"nmax", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}], 
               "]"}]}], "]"}], ",", 
            RowBox[{"nmax", "+", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{
                RowBox[{"Reverse", "[", "img", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"nmax", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}], 
               "]"}]}], "]"}], ",", 
            RowBox[{"nmax", "+", "1"}]}], "]"}]}], "]"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"3", ",", "Constant", ",", 
      RowBox[{"w_Integer:", "2"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Alpha]", "=", 
         RowBox[{"-", "0.2679491924311228`"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"0.28867513459481303`", "*", 
             RowBox[{"(", 
              RowBox[{"#2", "+", 
               RowBox[{"Reverse", "[", "#3", "]"}], "-", "#1"}], ")"}]}], 
            ")"}], "&"}], "[", "\[IndentingNewLine]", 
          RowBox[{"#", ",", "\[IndentingNewLine]", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{
               RowBox[{"First", "[", "#", "]"}], "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]"}], ")"}]}], ",", "#"}], "]"}], 
            "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{
               RowBox[{"Last", "[", "#", "]"}], "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}]}], 
          "\[IndentingNewLine]", "]"}], "&"}], "[", 
        RowBox[{"ArrayPad", "[", 
         RowBox[{"img", ",", "w", ",", "\"\<Fixed\>\""}], "]"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"3", ",", 
      RowBox[{"c_", "?", "NumberQ"}], ",", 
      RowBox[{"w_Integer:", "2"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Alpha]", "=", 
         RowBox[{"-", "0.2679491924311228`"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"0.28867513459481303`", "*", 
             RowBox[{"(", 
              RowBox[{"#2", "+", 
               RowBox[{"Reverse", "[", "#3", "]"}], "-", "#1"}], ")"}]}], 
            ")"}], "&"}], "[", "\[IndentingNewLine]", 
          RowBox[{"#", ",", "\[IndentingNewLine]", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{"c", "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]"}], ")"}]}], ",", "#"}], "]"}], 
            "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{"c", "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}]}], 
          "\[IndentingNewLine]", "]"}], "&"}], "[", 
        RowBox[{"ArrayPad", "[", 
         RowBox[{"img", ",", "w", ",", "c"}], "]"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Quintic", "Subsubsection"],

Cell["Roots of the filter:", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Alpha]1", "=", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "13"}], "-", 
      SqrtBox["105"], "+", 
      SqrtBox[
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"135", "+", 
          RowBox[{"13", " ", 
           SqrtBox["105"]}]}], ")"}]}]]}], ")"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"\[Alpha]2", " ", "=", " ", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["13", "2"]}], "+", 
    FractionBox[
     SqrtBox["105"], "2"], "+", 
    SqrtBox[
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"135", "-", 
        RowBox[{"13", " ", 
         SqrtBox["105"]}]}], ")"}]}]]}]}], ";"}]}], "Input",
 MathVisionTools`MathVisionToolsCopyRight -> {
  "{2009, 12, 5, 21, 53}: version 3.0 (December 6th, 2009) loaded by markus \
on 5102-91456-83330."}],

Cell["Merging function:", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox[
    RowBox[{"\[Alpha]1", " ", "\[Alpha]2"}], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"\[Alpha]1", "-", "\[Alpha]2"}], ")"}], 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["\[Alpha]1", "2"], "-", "1"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"\[Alpha]1", " ", "\[Alpha]2"}], "-", "1"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["\[Alpha]2", "2"], "-", "1"}], ")"}]}]], "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"\[Alpha]1", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[Alpha]2", "2"], "-", "1"}], ")"}], "#2"}], "+", 
     RowBox[{"\[Alpha]2", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        SuperscriptBox["\[Alpha]1", "2"]}], ")"}], " ", "#3"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]2"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"\[Alpha]1", " ", "\[Alpha]2"}]}], ")"}], "#1"}]}], ")"}]}], 
  "&"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"5", ",", "Reflective", ",", 
      RowBox[{"w_Integer:", "3"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Alpha]1", "=", 
          RowBox[{"-", "0.04309628820326239`"}]}], ",", 
         RowBox[{"n1max", "=", "5"}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]2", "=", 
          RowBox[{"-", "0.43057534709997025`"}]}], ",", 
         RowBox[{"n2max", "=", "19"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"ArrayPad", "[", 
          RowBox[{"#", ",", "w", ",", "\"\<Reversed\>\""}], "]"}], "&"}], "[",
         "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "0.023684757703449577`"}], " ", "img"}], "-", 
              RowBox[{"0.002106796542648226`", " ", "#1"}], "+", 
              RowBox[{"0.025791554151510354`", " ", "#2"}]}], ")"}], "&"}], 
           "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"#1", "+", 
             RowBox[{"Reverse", "[", 
              RowBox[{"Rest", "[", 
               RowBox[{"FoldList", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], 
                  "&"}], ",", 
                 RowBox[{"Last", "[", "#1", "]"}], ",", 
                 RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], 
              "]"}]}], ",", 
            RowBox[{"#2", "+", 
             RowBox[{"Reverse", "[", 
              RowBox[{"Rest", "[", 
               RowBox[{"FoldList", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], 
                  "&"}], ",", 
                 RowBox[{"Last", "[", "#2", "]"}], ",", 
                 RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], 
              "]"}]}]}], "\[IndentingNewLine]", "]"}], "&"}], "[", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{"img", ",", 
                RowBox[{"{", 
                 RowBox[{"n1max", ",", "0"}], "}"}], ",", 
                "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
            RowBox[{"n1max", "+", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
          
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{"img", ",", 
                RowBox[{"{", 
                 RowBox[{"n2max", ",", "0"}], "}"}], ",", 
                "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
            RowBox[{"n2max", "+", "1"}]}], "]"}]}], "]"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"5", ",", "Cyclic", ",", 
      RowBox[{"w_Integer:", "3"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Alpha]1", "=", 
          RowBox[{"-", "0.04309628820326239`"}]}], ",", 
         RowBox[{"n1max", "=", "5"}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]2", "=", 
          RowBox[{"-", "0.43057534709997025`"}]}], ",", 
         RowBox[{"n2max", "=", "19"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"ArrayPad", "[", 
          RowBox[{"#", ",", "w", ",", "\"\<Cyclic\>\""}], "]"}], "&"}], "[", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "0.023684757703449577`"}], " ", "img"}], "-", 
            RowBox[{"0.002106796542648226`", " ", "#1"}], "+", 
            RowBox[{"0.025791554151510354`", " ", "#2"}]}], ")"}], "&"}], "[",
          "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Drop", "[", 
            RowBox[{
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", "0", ",", 
               RowBox[{"ArrayPad", "[", 
                RowBox[{"img", ",", 
                 RowBox[{"{", 
                  RowBox[{"n1max", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}],
                 "]"}]}], "]"}], ",", 
             RowBox[{"n1max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Drop", "[", 
             RowBox[{
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", "0", ",", 
                RowBox[{"ArrayPad", "[", 
                 RowBox[{
                  RowBox[{"Reverse", "[", "img", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n1max", ",", "0"}], "}"}], ",", 
                  "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
              RowBox[{"n1max", "+", "1"}]}], "]"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Drop", "[", 
            RowBox[{
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", "0", ",", 
               RowBox[{"ArrayPad", "[", 
                RowBox[{"img", ",", 
                 RowBox[{"{", 
                  RowBox[{"n2max", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}],
                 "]"}]}], "]"}], ",", 
             RowBox[{"n2max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Drop", "[", 
             RowBox[{
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", "0", ",", 
                RowBox[{"ArrayPad", "[", 
                 RowBox[{
                  RowBox[{"Reverse", "[", "img", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n2max", ",", "0"}], "}"}], ",", 
                  "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
              RowBox[{"n2max", "+", "1"}]}], "]"}], "]"}]}]}], "]"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"5", ",", "Constant", ",", 
      RowBox[{"w_Integer:", "3"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Alpha]1", "=", 
          RowBox[{"-", "0.04309628820326239`"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]2", "=", 
          RowBox[{"-", "0.43057534709997025`"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "0.023684757703449577`"}], " ", "#1"}], "-", 
             RowBox[{"0.002106796542648226`", " ", "#2"}], "+", 
             RowBox[{"0.025791554151510354`", " ", "#3"}]}], ")"}], "&"}], 
          "[", "\[IndentingNewLine]", 
          RowBox[{"#", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{
                RowBox[{"First", "[", "#", "]"}], "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{
                 RowBox[{"Last", "[", "#", "]"}], "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{
                RowBox[{"First", "[", "#", "]"}], "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{
                 RowBox[{"Last", "[", "#", "]"}], "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}]}],
           "\[IndentingNewLine]", "]"}], "&"}], "[", 
        RowBox[{"ArrayPad", "[", 
         RowBox[{"img", ",", "w", ",", "\"\<Fixed\>\""}], "]"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"5", ",", 
      RowBox[{"c_", "?", "NumberQ"}], ",", 
      RowBox[{"w_Integer:", "3"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Alpha]1", "=", 
          RowBox[{"-", "0.04309628820326239`"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]2", "=", 
          RowBox[{"-", "0.43057534709997025`"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "0.023684757703449577`"}], " ", "#1"}], "-", 
             RowBox[{"0.002106796542648226`", " ", "#2"}], "+", 
             RowBox[{"0.025791554151510354`", " ", "#3"}]}], ")"}], "&"}], 
          "[", "\[IndentingNewLine]", 
          RowBox[{"#", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"c", "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{"c", "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"c", "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{"c", "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}]}],
           "\[IndentingNewLine]", "]"}], "&"}], "[", 
        RowBox[{"ArrayPad", "[", 
         RowBox[{"img", ",", "w", ",", "c"}], "]"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Septic", "Subsubsection"],

Cell["Roots of the filter :", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Alpha]1", " ", "=", " ", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"120", " ", "#1"}], "+", 
       RowBox[{"1191", " ", 
        SuperscriptBox["#1", "2"]}], "+", 
       RowBox[{"2416", " ", 
        SuperscriptBox["#1", "3"]}], "+", 
       RowBox[{"1191", " ", 
        SuperscriptBox["#1", "4"]}], "+", 
       RowBox[{"120", " ", 
        SuperscriptBox["#1", "5"]}], "+", 
       SuperscriptBox["#1", "6"]}], "&"}], ",", "6"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"\[Alpha]2", " ", "=", " ", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"120", " ", "#1"}], "+", 
       RowBox[{"1191", " ", 
        SuperscriptBox["#1", "2"]}], "+", 
       RowBox[{"2416", " ", 
        SuperscriptBox["#1", "3"]}], "+", 
       RowBox[{"1191", " ", 
        SuperscriptBox["#1", "4"]}], "+", 
       RowBox[{"120", " ", 
        SuperscriptBox["#1", "5"]}], "+", 
       SuperscriptBox["#1", "6"]}], "&"}], ",", "5"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"\[Alpha]3", " ", "=", " ", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"120", " ", "#1"}], "+", 
       RowBox[{"1191", " ", 
        SuperscriptBox["#1", "2"]}], "+", 
       RowBox[{"2416", " ", 
        SuperscriptBox["#1", "3"]}], "+", 
       RowBox[{"1191", " ", 
        SuperscriptBox["#1", "4"]}], "+", 
       RowBox[{"120", " ", 
        SuperscriptBox["#1", "5"]}], "+", 
       SuperscriptBox["#1", "6"]}], "&"}], ",", "4"}], "]"}]}], 
  ";"}]}], "Input"],

Cell["Merging function:", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"\[Alpha]1", " ", "\[Alpha]2", " ", "\[Alpha]3"}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[Alpha]1", "2"], "-", "1"}], ")"}], "  ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[Alpha]2", "2"], "-", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[Alpha]3", "2"], "-", "1"}], ")"}], 
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]3"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]3", "-", "\[Alpha]2"}], ")"}], 
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]2"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Alpha]1", " ", "\[Alpha]2"}], "-", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Alpha]1", " ", "\[Alpha]3"}], "-", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Alpha]2", " ", "\[Alpha]3"}], "-", "1"}], ")"}]}], " ", 
     ")"}]}], "*", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["\[Alpha]1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[Alpha]2", "2"], "-", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]3", "-", "\[Alpha]2"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Alpha]2", " ", "\[Alpha]3"}], "-", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[Alpha]3", "2"], "-", "1"}], ")"}], "#2"}], "+", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[Alpha]1", "2"], "-", "1"}], ")"}], " ", 
      SuperscriptBox["\[Alpha]2", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]3"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Alpha]1", " ", "\[Alpha]3"}], "-", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[Alpha]3", "2"], "-", "1"}], ")"}], " ", "#3"}], "+",
      "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[Alpha]1", "2"], "-", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]2", "-", "\[Alpha]1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Alpha]1", " ", "\[Alpha]2"}], "-", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[Alpha]2", "2"], "-", "1"}], ")"}], " ", 
      SuperscriptBox["\[Alpha]3", "2"], " ", "#4"}], "+", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]2"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]3"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]2", "-", "\[Alpha]3"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Alpha]1", " ", 
         RowBox[{"(", 
          RowBox[{"\[Alpha]2", "+", "\[Alpha]3"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Alpha]2", " ", "\[Alpha]3"}], "-", "1"}], ")"}]}], "+", 
        
        RowBox[{
         SuperscriptBox["\[Alpha]1", "2"], " ", "\[Alpha]2", " ", "\[Alpha]3",
          " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Alpha]2", " ", "\[Alpha]3"}], "+", "1"}], ")"}]}], "-", 
        
        RowBox[{"\[Alpha]2", " ", "\[Alpha]3"}], "-", "1"}], ")"}], "#1"}]}], 
    ")"}]}], "&"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"7", ",", "Reflective", ",", 
      RowBox[{"w_Integer:", "4"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Alpha]1", "=", 
          RowBox[{"-", "0.009148694809608277`"}]}], ",", 
         RowBox[{"n1max", "=", "4"}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]2", "=", 
          RowBox[{"-", "0.12255461519232669`"}]}], ",", 
         RowBox[{"n2max", "=", "8"}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]3", "=", 
          RowBox[{"-", "0.5352804307964383`"}]}], ",", 
         RowBox[{"n3max", "=", "26"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"ArrayPad", "[", 
          RowBox[{"#", ",", "w", ",", "\"\<Reversed\>\""}], "]"}], "&"}], "[",
         "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "0.000985066048869381`"}], " ", "img"}], "+", 
              RowBox[{"8.470592879244762`*^-7", " ", "#1"}], "-", 
              RowBox[{"0.00020948815361334196`", " ", "#2"}], "+", 
              RowBox[{"0.0011937071431947985`", " ", "#3"}]}], ")"}], "&"}], 
           "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"#1", "+", 
             RowBox[{"Reverse", "[", 
              RowBox[{"Rest", "[", 
               RowBox[{"FoldList", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], 
                  "&"}], ",", 
                 RowBox[{"Last", "[", "#1", "]"}], ",", 
                 RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], 
              "]"}]}], ",", 
            RowBox[{"#2", "+", 
             RowBox[{"Reverse", "[", 
              RowBox[{"Rest", "[", 
               RowBox[{"FoldList", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], 
                  "&"}], ",", 
                 RowBox[{"Last", "[", "#2", "]"}], ",", 
                 RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], 
              "]"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"#3", "+", 
             RowBox[{"Reverse", "[", 
              RowBox[{"Rest", "[", 
               RowBox[{"FoldList", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], 
                  "&"}], ",", 
                 RowBox[{"Last", "[", "#3", "]"}], ",", 
                 RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], 
              "]"}]}]}], "\[IndentingNewLine]", "]"}], "&"}], "[", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{"img", ",", 
                RowBox[{"{", 
                 RowBox[{"n1max", ",", "0"}], "}"}], ",", 
                "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
            RowBox[{"n1max", "+", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
          
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{"img", ",", 
                RowBox[{"{", 
                 RowBox[{"n2max", ",", "0"}], "}"}], ",", 
                "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
            RowBox[{"n2max", "+", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
          
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{"img", ",", 
                RowBox[{"{", 
                 RowBox[{"n3max", ",", "0"}], "}"}], ",", 
                "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
            RowBox[{"n3max", "+", "1"}]}], "]"}]}], "]"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"7", ",", "Cyclic", ",", 
      RowBox[{"w_Integer:", "4"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Alpha]1", "=", 
          RowBox[{"-", "0.009148694809608277`"}]}], ",", 
         RowBox[{"n1max", "=", "4"}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]2", "=", 
          RowBox[{"-", "0.12255461519232669`"}]}], ",", 
         RowBox[{"n2max", "=", "8"}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]3", "=", 
          RowBox[{"-", "0.5352804307964383`"}]}], ",", 
         RowBox[{"n3max", "=", "26"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"ArrayPad", "[", 
          RowBox[{"#", ",", "w", ",", "\"\<Cyclic\>\""}], "]"}], "&"}], "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "0.000985066048869381`"}], " ", "img"}], "+", 
            RowBox[{"8.470592879244762`*^-7", " ", "#1"}], "-", 
            RowBox[{"0.00020948815361334196`", " ", "#2"}], "+", 
            RowBox[{"0.0011937071431947985`", " ", "#3"}]}], ")"}], "&"}], 
         "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Drop", "[", 
            RowBox[{
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", "0", ",", 
               RowBox[{"ArrayPad", "[", 
                RowBox[{"img", ",", 
                 RowBox[{"{", 
                  RowBox[{"n1max", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}],
                 "]"}]}], "]"}], ",", 
             RowBox[{"n1max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Drop", "[", 
             RowBox[{
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", "0", ",", 
                RowBox[{"ArrayPad", "[", 
                 RowBox[{
                  RowBox[{"Reverse", "[", "img", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n1max", ",", "0"}], "}"}], ",", 
                  "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
              RowBox[{"n1max", "+", "1"}]}], "]"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Drop", "[", 
            RowBox[{
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", "0", ",", 
               RowBox[{"ArrayPad", "[", 
                RowBox[{"img", ",", 
                 RowBox[{"{", 
                  RowBox[{"n2max", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}],
                 "]"}]}], "]"}], ",", 
             RowBox[{"n2max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Drop", "[", 
             RowBox[{
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", "0", ",", 
                RowBox[{"ArrayPad", "[", 
                 RowBox[{
                  RowBox[{"Reverse", "[", "img", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n2max", ",", "0"}], "}"}], ",", 
                  "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
              RowBox[{"n2max", "+", "1"}]}], "]"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Drop", "[", 
            RowBox[{
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", "0", ",", 
               RowBox[{"ArrayPad", "[", 
                RowBox[{"img", ",", 
                 RowBox[{"{", 
                  RowBox[{"n3max", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}],
                 "]"}]}], "]"}], ",", 
             RowBox[{"n3max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Drop", "[", 
             RowBox[{
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", "0", ",", 
                RowBox[{"ArrayPad", "[", 
                 RowBox[{
                  RowBox[{"Reverse", "[", "img", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n3max", ",", "0"}], "}"}], ",", 
                  "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
              RowBox[{"n3max", "+", "1"}]}], "]"}], "]"}]}]}], "]"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"7", ",", "Constant", ",", 
      RowBox[{"w_Integer:", "4"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Alpha]1", "=", 
          RowBox[{"-", "0.009148694809608277`"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]2", "=", 
          RowBox[{"-", "0.12255461519232669`"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]3", "=", 
          RowBox[{"-", "0.5352804307964383`"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "0.000985066048869381`"}], " ", "#1"}], "+", 
             RowBox[{"8.470592879244762`*^-7", " ", "#2"}], "-", 
             RowBox[{"0.00020948815361334196`", " ", "#3"}], "+", 
             RowBox[{"0.0011937071431947985`", " ", "#4"}]}], ")"}], "&"}], 
          "[", "\[IndentingNewLine]", 
          RowBox[{"#", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{
                RowBox[{"First", "[", "#", "]"}], "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{
                 RowBox[{"Last", "[", "#", "]"}], "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{
                RowBox[{"First", "[", "#", "]"}], "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{
                 RowBox[{"Last", "[", "#", "]"}], "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{
                RowBox[{"First", "[", "#", "]"}], "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]3"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{
                 RowBox[{"Last", "[", "#", "]"}], "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]3"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}]}],
           "\[IndentingNewLine]", "]"}], "&"}], "[", 
        RowBox[{"ArrayPad", "[", 
         RowBox[{"img", ",", "w", ",", "\"\<Fixed\>\""}], "]"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"7", ",", 
      RowBox[{"c_", "?", "NumberQ"}], ",", 
      RowBox[{"w_Integer:", "4"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Alpha]1", "=", 
          RowBox[{"-", "0.009148694809608277`"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]2", "=", 
          RowBox[{"-", "0.12255461519232669`"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]3", "=", 
          RowBox[{"-", "0.5352804307964383`"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "0.000985066048869381`"}], " ", "#1"}], "+", 
             RowBox[{"8.470592879244762`*^-7", " ", "#2"}], "-", 
             RowBox[{"0.00020948815361334196`", " ", "#3"}], "+", 
             RowBox[{"0.0011937071431947985`", " ", "#4"}]}], ")"}], "&"}], 
          "[", "\[IndentingNewLine]", 
          RowBox[{"#", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"c", "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{"c", "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"c", "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{"c", "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
           ",", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"c", "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]3"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{"c", "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]3"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}]}],
           "\[IndentingNewLine]", "]"}], "&"}], "[", 
        RowBox[{"ArrayPad", "[", 
         RowBox[{"img", ",", "w", ",", "c"}], "]"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Nonic", "Subsubsection"],

Cell["Roots of the filter :", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Alpha]1", " ", "=", " ", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"502", " ", "#1"}], "+", 
       RowBox[{"14608", " ", 
        SuperscriptBox["#1", "2"]}], "+", 
       RowBox[{"88234", " ", 
        SuperscriptBox["#1", "3"]}], "+", 
       RowBox[{"156190", " ", 
        SuperscriptBox["#1", "4"]}], "+", 
       RowBox[{"88234", " ", 
        SuperscriptBox["#1", "5"]}], "+", 
       RowBox[{"14608", " ", 
        SuperscriptBox["#1", "6"]}], "+", 
       RowBox[{"502", " ", 
        SuperscriptBox["#1", "7"]}], "+", 
       SuperscriptBox["#1", "8"]}], "&"}], ",", "8"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"\[Alpha]2", " ", "=", " ", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"502", " ", "#1"}], "+", 
       RowBox[{"14608", " ", 
        SuperscriptBox["#1", "2"]}], "+", 
       RowBox[{"88234", " ", 
        SuperscriptBox["#1", "3"]}], "+", 
       RowBox[{"156190", " ", 
        SuperscriptBox["#1", "4"]}], "+", 
       RowBox[{"88234", " ", 
        SuperscriptBox["#1", "5"]}], "+", 
       RowBox[{"14608", " ", 
        SuperscriptBox["#1", "6"]}], "+", 
       RowBox[{"502", " ", 
        SuperscriptBox["#1", "7"]}], "+", 
       SuperscriptBox["#1", "8"]}], "&"}], ",", "7"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"\[Alpha]3", " ", "=", " ", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"502", " ", "#1"}], "+", 
       RowBox[{"14608", " ", 
        SuperscriptBox["#1", "2"]}], "+", 
       RowBox[{"88234", " ", 
        SuperscriptBox["#1", "3"]}], "+", 
       RowBox[{"156190", " ", 
        SuperscriptBox["#1", "4"]}], "+", 
       RowBox[{"88234", " ", 
        SuperscriptBox["#1", "5"]}], "+", 
       RowBox[{"14608", " ", 
        SuperscriptBox["#1", "6"]}], "+", 
       RowBox[{"502", " ", 
        SuperscriptBox["#1", "7"]}], "+", 
       SuperscriptBox["#1", "8"]}], "&"}], ",", "6"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"\[Alpha]4", " ", "=", " ", 
   RowBox[{"Root", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"502", " ", "#1"}], "+", 
       RowBox[{"14608", " ", 
        SuperscriptBox["#1", "2"]}], "+", 
       RowBox[{"88234", " ", 
        SuperscriptBox["#1", "3"]}], "+", 
       RowBox[{"156190", " ", 
        SuperscriptBox["#1", "4"]}], "+", 
       RowBox[{"88234", " ", 
        SuperscriptBox["#1", "5"]}], "+", 
       RowBox[{"14608", " ", 
        SuperscriptBox["#1", "6"]}], "+", 
       RowBox[{"502", " ", 
        SuperscriptBox["#1", "7"]}], "+", 
       SuperscriptBox["#1", "8"]}], "&"}], ",", "5"}], "]"}]}], 
  ";"}]}], "Input"],

Cell["Merging function :", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
     "\[Alpha]1", " ", "\[Alpha]2", " ", "\[Alpha]3", " ", "\[Alpha]4"}], 
     ")"}], "/", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[Alpha]1", "2"], "-", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[Alpha]2", "2"], "-", "1"}], ")"}], 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[Alpha]3", "2"], "-", "1"}], ")"}], 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[Alpha]4", "2"], "-", "1"}], ")"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Alpha]1", " ", "\[Alpha]2"}], "-", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Alpha]1", " ", "\[Alpha]3"}], "-", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Alpha]2", " ", "\[Alpha]3"}], "-", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Alpha]1", " ", "\[Alpha]4"}], "-", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Alpha]2", " ", "\[Alpha]4"}], "-", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Alpha]3", " ", "\[Alpha]4"}], "-", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]2"}], ")"}], 
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]3"}], ")"}], 
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]4"}], ")"}], 
      RowBox[{"(", 
       RowBox[{"\[Alpha]2", "-", "\[Alpha]3"}], ")"}], 
      RowBox[{"(", 
       RowBox[{"\[Alpha]2", "-", "\[Alpha]4"}], ")"}], 
      RowBox[{"(", 
       RowBox[{"\[Alpha]3", "-", "\[Alpha]4"}], ")"}]}], ")"}]}], "*", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["\[Alpha]1", "3"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["\[Alpha]2", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]2", "-", "\[Alpha]3"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"\[Alpha]2", " ", "\[Alpha]3"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["\[Alpha]3", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]2", "-", "\[Alpha]4"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]3", "-", "\[Alpha]4"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"\[Alpha]2", " ", "\[Alpha]4"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"\[Alpha]3", " ", "\[Alpha]4"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["\[Alpha]4", "2"]}], ")"}], "#2"}], "-", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["\[Alpha]1", "2"]}], ")"}], " ", 
      SuperscriptBox["\[Alpha]2", "3"], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]3"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"\[Alpha]1", " ", "\[Alpha]3"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["\[Alpha]3", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]4"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]3", "-", "\[Alpha]4"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"\[Alpha]1", " ", "\[Alpha]4"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"\[Alpha]3", " ", "\[Alpha]4"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["\[Alpha]4", "2"]}], ")"}], " ", "#3"}], "+", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["\[Alpha]1", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]2"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"\[Alpha]1", " ", "\[Alpha]2"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["\[Alpha]2", "2"]}], ")"}], " ", 
      SuperscriptBox["\[Alpha]3", "3"], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]4"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]2", "-", "\[Alpha]4"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"\[Alpha]1", " ", "\[Alpha]4"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"\[Alpha]2", " ", "\[Alpha]4"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["\[Alpha]4", "2"]}], ")"}], " ", "#4"}], "-", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["\[Alpha]1", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]2"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"\[Alpha]1", " ", "\[Alpha]2"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["\[Alpha]2", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]3"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]2", "-", "\[Alpha]3"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"\[Alpha]1", " ", "\[Alpha]3"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"\[Alpha]2", " ", "\[Alpha]3"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["\[Alpha]3", "2"]}], ")"}], " ", 
      SuperscriptBox["\[Alpha]4", "3"], " ", "#5"}], "-", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]2"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]3"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]2", "-", "\[Alpha]3"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]1", "-", "\[Alpha]4"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]2", "-", "\[Alpha]4"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]3", "-", "\[Alpha]4"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"\[Alpha]3", " ", "\[Alpha]4"}], "-", 
        RowBox[{"\[Alpha]2", " ", 
         RowBox[{"(", 
          RowBox[{"\[Alpha]3", "+", "\[Alpha]4"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"\[Alpha]3", " ", "\[Alpha]4"}]}], ")"}]}], "-", 
        RowBox[{
         SuperscriptBox["\[Alpha]2", "2"], " ", "\[Alpha]3", " ", "\[Alpha]4",
          " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"\[Alpha]3", " ", "\[Alpha]4"}]}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[Alpha]1", "3"], " ", "\[Alpha]2", " ", "\[Alpha]3",
          " ", "\[Alpha]4", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"\[Alpha]3", " ", "\[Alpha]4"}], "-", 
           RowBox[{"\[Alpha]2", " ", 
            RowBox[{"(", 
             RowBox[{"\[Alpha]3", "+", "\[Alpha]4"}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"\[Alpha]3", " ", "\[Alpha]4"}]}], ")"}]}], "-", 
           RowBox[{
            SuperscriptBox["\[Alpha]2", "2"], " ", "\[Alpha]3", " ", 
            "\[Alpha]4", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"\[Alpha]3", " ", "\[Alpha]4"}]}], ")"}]}]}], ")"}]}], 
        "+", 
        RowBox[{"\[Alpha]1", " ", 
         RowBox[{"(", 
          RowBox[{"\[Alpha]3", "+", "\[Alpha]4", "-", 
           RowBox[{"\[Alpha]3", " ", "\[Alpha]4", " ", 
            RowBox[{"(", 
             RowBox[{"\[Alpha]3", "+", "\[Alpha]4"}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["\[Alpha]2", "3"], " ", "\[Alpha]3", " ", 
            "\[Alpha]4", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"\[Alpha]3", " ", "\[Alpha]4"}]}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["\[Alpha]2", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"\[Alpha]3", "+", "\[Alpha]4"}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"\[Alpha]3", " ", "\[Alpha]4"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"\[Alpha]3", " ", "\[Alpha]4"}]}], ")"}]}], "+", 
           RowBox[{"\[Alpha]2", " ", 
            RowBox[{"(", 
             RowBox[{"1", "-", 
              SuperscriptBox["\[Alpha]3", "2"], "+", 
              RowBox[{
               SuperscriptBox["\[Alpha]3", "3"], " ", "\[Alpha]4"}], "-", 
              SuperscriptBox["\[Alpha]4", "2"], "+", 
              RowBox[{"\[Alpha]3", " ", "\[Alpha]4", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "3"}], "+", 
                 SuperscriptBox["\[Alpha]4", "2"]}], ")"}]}]}], ")"}]}]}], 
          ")"}]}], "-", 
        RowBox[{
         SuperscriptBox["\[Alpha]1", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SuperscriptBox["\[Alpha]2", "3"], " ", "\[Alpha]3", " ", 
            "\[Alpha]4", " ", 
            RowBox[{"(", 
             RowBox[{"\[Alpha]3", "+", "\[Alpha]4"}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"\[Alpha]3", " ", "\[Alpha]4"}]}], ")"}]}], "+", 
           RowBox[{"\[Alpha]3", " ", "\[Alpha]4", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"\[Alpha]3", " ", "\[Alpha]4"}]}], ")"}]}], "-", 
           RowBox[{"\[Alpha]2", " ", 
            RowBox[{"(", 
             RowBox[{"\[Alpha]3", "+", "\[Alpha]4"}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"\[Alpha]3", " ", "\[Alpha]4"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"\[Alpha]3", " ", "\[Alpha]4"}]}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["\[Alpha]2", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Alpha]4", "2"], "-", 
              RowBox[{"\[Alpha]3", " ", 
               SuperscriptBox["\[Alpha]4", "3"]}], "+", 
              RowBox[{
               SuperscriptBox["\[Alpha]3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"3", " ", 
                  SuperscriptBox["\[Alpha]4", "2"]}]}], ")"}]}], "+", 
              RowBox[{
               SuperscriptBox["\[Alpha]3", "3"], " ", "\[Alpha]4", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "1"}], "+", 
                 SuperscriptBox["\[Alpha]4", "2"]}], ")"}]}]}], ")"}]}]}], 
          ")"}]}]}], ")"}], "#1"}]}], ")"}]}], "&"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"9", ",", "Reflective", ",", 
      RowBox[{"w_Integer:", "5"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Alpha]1", "=", 
          RowBox[{"-", "0.002121306903180818`"}]}], ",", 
         RowBox[{"n1max", "=", "3"}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]2", "=", 
          RowBox[{"-", "0.04322260854048175`"}]}], ",", 
         RowBox[{"n2max", "=", "5"}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]3", "=", 
          RowBox[{"-", "0.2017505201931532`"}]}], ",", 
         RowBox[{"n3max", "=", "10"}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]4", "=", 
          RowBox[{"-", "0.6079973891686256`"}]}], ",", 
         RowBox[{"n4max", "=", "32"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"ArrayPad", "[", 
          RowBox[{"#", ",", "w", ",", "\"\<Reversed\>\""}], "]"}], "&"}], "[",
         "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "0.000025453882305777692`"}], " ", "img"}], "-", 
              RowBox[{"2.163545673286295`*^-11", " ", "#1"}], "+", 
              RowBox[{"2.561818738752173`*^-7", " ", "#2"}], "-", 
              RowBox[{"8.614411452377346`*^-6", " ", "#3"}], "+", 
              RowBox[{"0.00003381213351973659`", " ", "#4"}]}], ")"}], "&"}], 
           "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"#1", "+", 
             RowBox[{"Reverse", "[", 
              RowBox[{"Rest", "[", 
               RowBox[{"FoldList", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], 
                  "&"}], ",", 
                 RowBox[{"Last", "[", "#1", "]"}], ",", 
                 RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], 
              "]"}]}], ",", 
            RowBox[{"#2", "+", 
             RowBox[{"Reverse", "[", 
              RowBox[{"Rest", "[", 
               RowBox[{"FoldList", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], 
                  "&"}], ",", 
                 RowBox[{"Last", "[", "#2", "]"}], ",", 
                 RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], 
              "]"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"#3", "+", 
             RowBox[{"Reverse", "[", 
              RowBox[{"Rest", "[", 
               RowBox[{"FoldList", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], 
                  "&"}], ",", 
                 RowBox[{"Last", "[", "#3", "]"}], ",", 
                 RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], 
              "]"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"#4", "+", 
             RowBox[{"Reverse", "[", 
              RowBox[{"Rest", "[", 
               RowBox[{"FoldList", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"\[Alpha]4", " ", "#1"}], "+", "#2"}], ")"}], 
                  "&"}], ",", 
                 RowBox[{"Last", "[", "#4", "]"}], ",", 
                 RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], 
              "]"}]}]}], "\[IndentingNewLine]", "]"}], "&"}], "[", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{"img", ",", 
                RowBox[{"{", 
                 RowBox[{"n1max", ",", "0"}], "}"}], ",", 
                "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
            RowBox[{"n1max", "+", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
          
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{"img", ",", 
                RowBox[{"{", 
                 RowBox[{"n2max", ",", "0"}], "}"}], ",", 
                "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
            RowBox[{"n2max", "+", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
          
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{"img", ",", 
                RowBox[{"{", 
                 RowBox[{"n3max", ",", "0"}], "}"}], ",", 
                "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
            RowBox[{"n3max", "+", "1"}]}], "]"}], ",", 
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]4", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{"img", ",", 
                RowBox[{"{", 
                 RowBox[{"n4max", ",", "0"}], "}"}], ",", 
                "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
            RowBox[{"n4max", "+", "1"}]}], "]"}]}], "]"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"9", ",", "Cyclic", ",", 
      RowBox[{"w_Integer:", "5"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Alpha]1", "=", 
          RowBox[{"-", "0.002121306903180818`"}]}], ",", 
         RowBox[{"n1max", "=", "3"}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]2", "=", 
          RowBox[{"-", "0.04322260854048175`"}]}], ",", 
         RowBox[{"n2max", "=", "5"}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]3", "=", 
          RowBox[{"-", "0.2017505201931532`"}]}], ",", 
         RowBox[{"n3max", "=", "10"}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]4", "=", 
          RowBox[{"-", "0.6079973891686256`"}]}], ",", 
         RowBox[{"n4max", "=", "32"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"ArrayPad", "[", 
          RowBox[{"#", ",", "w", ",", "\"\<Cyclic\>\""}], "]"}], "&"}], "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "0.000025453882305777692`"}], " ", "img"}], "-", 
            RowBox[{"2.163545673286295`*^-11", " ", "#1"}], "+", 
            RowBox[{"2.561818738752173`*^-7", " ", "#2"}], "-", 
            RowBox[{"8.614411452377346`*^-6", " ", "#3"}], "+", 
            RowBox[{"0.00003381213351973659`", " ", "#4"}]}], ")"}], "&"}], 
         "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Drop", "[", 
            RowBox[{
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", "0", ",", 
               RowBox[{"ArrayPad", "[", 
                RowBox[{"img", ",", 
                 RowBox[{"{", 
                  RowBox[{"n1max", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}],
                 "]"}]}], "]"}], ",", 
             RowBox[{"n1max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Drop", "[", 
             RowBox[{
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", "0", ",", 
                RowBox[{"ArrayPad", "[", 
                 RowBox[{
                  RowBox[{"Reverse", "[", "img", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n1max", ",", "0"}], "}"}], ",", 
                  "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
              RowBox[{"n1max", "+", "1"}]}], "]"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Drop", "[", 
            RowBox[{
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", "0", ",", 
               RowBox[{"ArrayPad", "[", 
                RowBox[{"img", ",", 
                 RowBox[{"{", 
                  RowBox[{"n2max", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}],
                 "]"}]}], "]"}], ",", 
             RowBox[{"n2max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Drop", "[", 
             RowBox[{
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", "0", ",", 
                RowBox[{"ArrayPad", "[", 
                 RowBox[{
                  RowBox[{"Reverse", "[", "img", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n2max", ",", "0"}], "}"}], ",", 
                  "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
              RowBox[{"n2max", "+", "1"}]}], "]"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Drop", "[", 
            RowBox[{
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", "0", ",", 
               RowBox[{"ArrayPad", "[", 
                RowBox[{"img", ",", 
                 RowBox[{"{", 
                  RowBox[{"n3max", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}],
                 "]"}]}], "]"}], ",", 
             RowBox[{"n3max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Drop", "[", 
             RowBox[{
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", "0", ",", 
                RowBox[{"ArrayPad", "[", 
                 RowBox[{
                  RowBox[{"Reverse", "[", "img", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n3max", ",", "0"}], "}"}], ",", 
                  "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
              RowBox[{"n3max", "+", "1"}]}], "]"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Drop", "[", 
            RowBox[{
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]4", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", "0", ",", 
               RowBox[{"ArrayPad", "[", 
                RowBox[{"img", ",", 
                 RowBox[{"{", 
                  RowBox[{"n4max", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}],
                 "]"}]}], "]"}], ",", 
             RowBox[{"n4max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Drop", "[", 
             RowBox[{
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]4", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", "0", ",", 
                RowBox[{"ArrayPad", "[", 
                 RowBox[{
                  RowBox[{"Reverse", "[", "img", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n4max", ",", "0"}], "}"}], ",", 
                  "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
              RowBox[{"n4max", "+", "1"}]}], "]"}], "]"}]}]}], "]"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"9", ",", "Constant", ",", 
      RowBox[{"w_Integer:", "5"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Alpha]1", "=", 
          RowBox[{"-", "0.002121306903180818`"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]2", "=", 
          RowBox[{"-", "0.04322260854048175`"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]3", "=", 
          RowBox[{"-", "0.2017505201931532`"}]}], ",", "\[IndentingNewLine]", 
         
         RowBox[{"\[Alpha]4", "=", 
          RowBox[{"-", "0.6079973891686256`"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "0.000025453882305777692`"}], " ", "#1"}], "-", 
             RowBox[{"2.163545673286295`*^-11", " ", "#2"}], "+", 
             RowBox[{"2.561818738752173`*^-7", " ", "#3"}], "-", 
             RowBox[{"8.614411452377346`*^-6", " ", "#4"}], "+", 
             RowBox[{"0.00003381213351973659`", " ", "#5"}]}], ")"}], "&"}], 
          "[", "\[IndentingNewLine]", 
          RowBox[{"#", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{
                RowBox[{"First", "[", "#", "]"}], "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{
                 RowBox[{"Last", "[", "#", "]"}], "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{
                RowBox[{"First", "[", "#", "]"}], "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{
                 RowBox[{"Last", "[", "#", "]"}], "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{
                RowBox[{"First", "[", "#", "]"}], "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]3"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{
                 RowBox[{"Last", "[", "#", "]"}], "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]3"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
           ",", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]4", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{
                RowBox[{"First", "[", "#", "]"}], "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]4"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]4", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{
                 RowBox[{"Last", "[", "#", "]"}], "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]4"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}]}],
           "\[IndentingNewLine]", "]"}], "&"}], "[", 
        RowBox[{"ArrayPad", "[", 
         RowBox[{"img", ",", "w", ",", "\"\<Fixed\>\""}], "]"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NBSplineInterpolationFilter1D", "[", 
    RowBox[{"{", 
     RowBox[{"9", ",", 
      RowBox[{"c_", "?", "NumberQ"}], ",", 
      RowBox[{"w_Integer:", "5"}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Block", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Alpha]1", "=", 
          RowBox[{"-", "0.002121306903180818`"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]2", "=", 
          RowBox[{"-", "0.04322260854048175`"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"\[Alpha]3", "=", 
          RowBox[{"-", "0.2017505201931532`"}]}], ",", "\[IndentingNewLine]", 
         
         RowBox[{"\[Alpha]4", "=", 
          RowBox[{"-", "0.6079973891686256`"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "0.000025453882305777692`"}], " ", "#1"}], "-", 
             RowBox[{"2.163545673286295`*^-11", " ", "#2"}], "+", 
             RowBox[{"2.561818738752173`*^-7", " ", "#3"}], "-", 
             RowBox[{"8.614411452377346`*^-6", " ", "#4"}], "+", 
             RowBox[{"0.00003381213351973659`", " ", "#5"}]}], ")"}], "&"}], 
          "[", "\[IndentingNewLine]", 
          RowBox[{"#", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"c", "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{"c", "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"c", "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{"c", "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
           ",", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"c", "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]3"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{"c", "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]3"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]4", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"c", "/", 
                RowBox[{"(", 
                 RowBox[{"1", "-", "\[Alpha]4"}], ")"}]}], ",", "#"}], "]"}], 
             "]"}], "+", "\[IndentingNewLine]", 
            RowBox[{"Reverse", "[", 
             RowBox[{"Rest", "[", 
              RowBox[{"FoldList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[Alpha]4", " ", "#1"}], "+", "#2"}], ")"}], 
                 "&"}], ",", 
                RowBox[{"c", "/", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", "\[Alpha]4"}], ")"}]}], ",", 
                RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}]}],
           "\[IndentingNewLine]", "]"}], "&"}], "[", 
        RowBox[{"ArrayPad", "[", 
         RowBox[{"img", ",", "w", ",", "c"}], "]"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["BSplineInterpolationFilter1D", "Subsection"],

Cell[CellGroupData[{

Cell["Linear", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "Reflective", ",", 
       RowBox[{"w_Integer:", "1"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"ArrayPad", "[", 
    RowBox[{"img", ",", 
     RowBox[{"{", "w", "}"}], ",", "\"\<Reversed\>\""}], "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "Cyclic", ",", 
       RowBox[{"w_Integer:", "1"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"ArrayPad", "[", 
    RowBox[{"img", ",", 
     RowBox[{"{", "w", "}"}], ",", "\"\<Cyclic\>\""}], "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "Constant", ",", 
       RowBox[{"w_Integer:", "1"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"ArrayPad", "[", 
    RowBox[{"img", ",", 
     RowBox[{"{", "w", "}"}], ",", "\"\<Fixed\>\""}], "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"c_", "?", "NumberQ"}], ",", 
       RowBox[{"w_Integer:", "1"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"ArrayPad", "[", 
    RowBox[{"img", ",", 
     RowBox[{"{", "w", "}"}], ",", "c"}], "]"}]}], ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Cubic", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "Reflective", ",", 
       RowBox[{"w_Integer:", "2"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Alpha]", "=", 
        RowBox[{"-", "0.2679491924311228`"}]}], ",", 
       RowBox[{"nmax", "=", "12"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"ArrayPad", "[", 
        RowBox[{"#", ",", 
         RowBox[{"{", "w", "}"}], ",", "\"\<Reversed\>\""}], "]"}], "&"}], 
      "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"0.28867513459481303`", "*", 
            RowBox[{"(", 
             RowBox[{"#1", "+", 
              RowBox[{"Reverse", "[", "#2", "]"}], "-", "img"}], ")"}]}], 
           ")"}], "&"}], "[", "\[IndentingNewLine]", 
         RowBox[{"#", ",", "\[IndentingNewLine]", 
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{"Last", "[", "#", "]"}], ",", 
             RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], "&"}], "[", 
       RowBox[{"Drop", "[", 
        RowBox[{
         RowBox[{"FoldList", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"\[Alpha]", " ", "#1"}], "+", "#2"}], ")"}], "&"}], ",",
            "0", ",", 
           RowBox[{"ArrayPad", "[", 
            RowBox[{"img", ",", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"nmax", ",", "0"}], "}"}], "}"}], ",", 
             "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
         RowBox[{"nmax", "+", "1"}]}], "]"}], "]"}], "\[IndentingNewLine]", 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "Cyclic", ",", 
       RowBox[{"w_Integer:", "2"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Alpha]", "=", 
        RowBox[{"-", "0.2679491924311228`"}]}], ",", 
       RowBox[{"nmax", "=", "12"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"ArrayPad", "[", 
        RowBox[{"#", ",", 
         RowBox[{"{", "w", "}"}], ",", "\"\<Cyclic\>\""}], "]"}], "&"}], "[", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"0.28867513459481303`", "*", 
          RowBox[{"(", 
           RowBox[{"#1", "+", 
            RowBox[{"Reverse", "[", "#2", "]"}], "-", "img"}], ")"}]}], ")"}],
         "&"}], "[", 
       RowBox[{
        RowBox[{"Drop", "[", 
         RowBox[{
          RowBox[{"FoldList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Alpha]", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
            ",", "0", ",", 
            RowBox[{"ArrayPad", "[", 
             RowBox[{"img", ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"nmax", ",", "0"}], "}"}], "}"}], ",", 
              "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
          RowBox[{"nmax", "+", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Drop", "[", 
         RowBox[{
          RowBox[{"FoldList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Alpha]", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
            ",", "0", ",", 
            RowBox[{"ArrayPad", "[", 
             RowBox[{
              RowBox[{"Reverse", "[", "img", "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"nmax", ",", "0"}], "}"}], "}"}], ",", 
              "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
          RowBox[{"nmax", "+", "1"}]}], "]"}]}], "]"}], "\[IndentingNewLine]",
       "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "Constant", ",", 
       RowBox[{"w_Integer:", "2"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Alpha]", "=", 
       RowBox[{"-", "0.2679491924311228`"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.28867513459481303`", "*", 
           RowBox[{"(", 
            RowBox[{"#2", "+", 
             RowBox[{"Reverse", "[", "#3", "]"}], "-", "#1"}], ")"}]}], ")"}],
          "&"}], "[", "\[IndentingNewLine]", 
        RowBox[{"#", ",", "\[IndentingNewLine]", 
         RowBox[{"Rest", "[", 
          RowBox[{"FoldList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Alpha]", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
            ",", 
            RowBox[{
             RowBox[{"First", "[", "#", "]"}], "/", 
             RowBox[{"(", 
              RowBox[{"1", "-", "\[Alpha]"}], ")"}]}], ",", "#"}], "]"}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Rest", "[", 
          RowBox[{"FoldList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Alpha]", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
            ",", 
            RowBox[{
             RowBox[{"Last", "[", "#", "]"}], "/", 
             RowBox[{"(", 
              RowBox[{"1", "-", "\[Alpha]"}], ")"}]}], ",", 
            RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], "&"}], "[", 
      RowBox[{"ArrayPad", "[", 
       RowBox[{"img", ",", 
        RowBox[{"{", "w", "}"}], ",", "\"\<Fixed\>\""}], "]"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{"c_", "?", "NumberQ"}], ",", 
       RowBox[{"w_Integer:", "2"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Alpha]", "=", 
       RowBox[{"-", "0.2679491924311228`"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.28867513459481303`", "*", 
           RowBox[{"(", 
            RowBox[{"#2", "+", 
             RowBox[{"Reverse", "[", "#3", "]"}], "-", "#1"}], ")"}]}], ")"}],
          "&"}], "[", "\[IndentingNewLine]", 
        RowBox[{"#", ",", "\[IndentingNewLine]", 
         RowBox[{"Rest", "[", 
          RowBox[{"FoldList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Alpha]", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
            ",", 
            RowBox[{"c", "/", 
             RowBox[{"(", 
              RowBox[{"1", "-", "\[Alpha]"}], ")"}]}], ",", "#"}], "]"}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Rest", "[", 
          RowBox[{"FoldList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Alpha]", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
            ",", 
            RowBox[{"c", "/", 
             RowBox[{"(", 
              RowBox[{"1", "-", "\[Alpha]"}], ")"}]}], ",", 
            RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], "&"}], "[", 
      RowBox[{"ArrayPad", "[", 
       RowBox[{"img", ",", 
        RowBox[{"{", "w", "}"}], ",", "c"}], "]"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Quintic", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"5", ",", "Reflective", ",", 
       RowBox[{"w_Integer:", "3"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Alpha]1", "=", 
        RowBox[{"-", "0.04309628820326239`"}]}], ",", 
       RowBox[{"n1max", "=", "5"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]2", "=", 
        RowBox[{"-", "0.43057534709997025`"}]}], ",", 
       RowBox[{"n2max", "=", "19"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"ArrayPad", "[", 
        RowBox[{"#", ",", 
         RowBox[{"{", "w", "}"}], ",", "\"\<Reversed\>\""}], "]"}], "&"}], 
      "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "0.023684757703449577`"}], " ", "img"}], "-", 
            RowBox[{"0.002106796542648226`", " ", "#1"}], "+", 
            RowBox[{"0.025791554151510354`", " ", "#2"}]}], ")"}], "&"}], "[",
          "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"#1", "+", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"Last", "[", "#1", "]"}], ",", 
               RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], "]"}]}], 
          ",", 
          RowBox[{"#2", "+", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"Last", "[", "#2", "]"}], ",", 
               RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], 
            "]"}]}]}], "\[IndentingNewLine]", "]"}], "&"}], "[", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Drop", "[", 
         RowBox[{
          RowBox[{"FoldList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
            ",", "0", ",", 
            RowBox[{"ArrayPad", "[", 
             RowBox[{"img", ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"n1max", ",", "0"}], "}"}], "}"}], ",", 
              "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
          RowBox[{"n1max", "+", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Drop", "[", 
         RowBox[{
          RowBox[{"FoldList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
            ",", "0", ",", 
            RowBox[{"ArrayPad", "[", 
             RowBox[{"img", ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"n2max", ",", "0"}], "}"}], "}"}], ",", 
              "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
          RowBox[{"n2max", "+", "1"}]}], "]"}]}], "]"}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"5", ",", "Cyclic", ",", 
       RowBox[{"w_Integer:", "3"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Alpha]1", "=", 
        RowBox[{"-", "0.04309628820326239`"}]}], ",", 
       RowBox[{"n1max", "=", "5"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]2", "=", 
        RowBox[{"-", "0.43057534709997025`"}]}], ",", 
       RowBox[{"n2max", "=", "19"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"ArrayPad", "[", 
        RowBox[{"#", ",", 
         RowBox[{"{", "w", "}"}], ",", "\"\<Cyclic\>\""}], "]"}], "&"}], "[", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "0.023684757703449577`"}], " ", "img"}], "-", 
          RowBox[{"0.002106796542648226`", " ", "#1"}], "+", 
          RowBox[{"0.025791554151510354`", " ", "#2"}]}], ")"}], "&"}], "[", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Drop", "[", 
          RowBox[{
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", "0", ",", 
             RowBox[{"ArrayPad", "[", 
              RowBox[{"img", ",", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{"n1max", ",", "0"}], "}"}], "}"}], ",", 
               "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
           RowBox[{"n1max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
         RowBox[{"Reverse", "[", 
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{
                RowBox[{"Reverse", "[", "img", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"{", 
                  RowBox[{"n1max", ",", "0"}], "}"}], "}"}], ",", 
                "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
            RowBox[{"n1max", "+", "1"}]}], "]"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Drop", "[", 
          RowBox[{
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", "0", ",", 
             RowBox[{"ArrayPad", "[", 
              RowBox[{"img", ",", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{"n2max", ",", "0"}], "}"}], "}"}], ",", 
               "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
           RowBox[{"n2max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
         RowBox[{"Reverse", "[", 
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{
                RowBox[{"Reverse", "[", "img", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"{", 
                  RowBox[{"n2max", ",", "0"}], "}"}], "}"}], ",", 
                "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
            RowBox[{"n2max", "+", "1"}]}], "]"}], "]"}]}]}], "]"}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"5", ",", "Constant", ",", 
       RowBox[{"w_Integer:", "3"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Alpha]1", "=", 
        RowBox[{"-", "0.04309628820326239`"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]2", "=", 
        RowBox[{"-", "0.43057534709997025`"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "0.023684757703449577`"}], " ", "#1"}], "-", 
           RowBox[{"0.002106796542648226`", " ", "#2"}], "+", 
           RowBox[{"0.025791554151510354`", " ", "#3"}]}], ")"}], "&"}], "[", 
        "\[IndentingNewLine]", 
        RowBox[{"#", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{
              RowBox[{"First", "[", "#", "]"}], "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{
               RowBox[{"Last", "[", "#", "]"}], "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{
              RowBox[{"First", "[", "#", "]"}], "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{
               RowBox[{"Last", "[", "#", "]"}], "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], "&"}], "[", 
      RowBox[{"ArrayPad", "[", 
       RowBox[{"img", ",", 
        RowBox[{"{", "w", "}"}], ",", "\"\<Fixed\>\""}], "]"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"5", ",", 
       RowBox[{"c_", "?", "NumberQ"}], ",", 
       RowBox[{"w_Integer:", "3"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Alpha]1", "=", 
        RowBox[{"-", "0.04309628820326239`"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]2", "=", 
        RowBox[{"-", "0.43057534709997025`"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "0.023684757703449577`"}], " ", "#1"}], "-", 
           RowBox[{"0.002106796542648226`", " ", "#2"}], "+", 
           RowBox[{"0.025791554151510354`", " ", "#3"}]}], ")"}], "&"}], "[", 
        "\[IndentingNewLine]", 
        RowBox[{"#", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{"c", "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{"c", "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{"c", "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{"c", "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], "&"}], "[", 
      RowBox[{"ArrayPad", "[", 
       RowBox[{"img", ",", 
        RowBox[{"{", "w", "}"}], ",", "c"}], "]"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Septic", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"7", ",", "Reflective", ",", 
       RowBox[{"w_Integer:", "4"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Alpha]1", "=", 
        RowBox[{"-", "0.009148694809608277`"}]}], ",", 
       RowBox[{"n1max", "=", "4"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]2", "=", 
        RowBox[{"-", "0.12255461519232669`"}]}], ",", 
       RowBox[{"n2max", "=", "8"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]3", "=", 
        RowBox[{"-", "0.5352804307964383`"}]}], ",", 
       RowBox[{"n3max", "=", "26"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"ArrayPad", "[", 
        RowBox[{"#", ",", 
         RowBox[{"{", "w", "}"}], ",", "\"\<Reversed\>\""}], "]"}], "&"}], 
      "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "0.000985066048869381`"}], " ", "img"}], "+", 
            RowBox[{"8.470592879244762`*^-7", " ", "#1"}], "-", 
            RowBox[{"0.00020948815361334196`", " ", "#2"}], "+", 
            RowBox[{"0.0011937071431947985`", " ", "#3"}]}], ")"}], "&"}], 
         "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"#1", "+", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"Last", "[", "#1", "]"}], ",", 
               RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], "]"}]}], 
          ",", 
          RowBox[{"#2", "+", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"Last", "[", "#2", "]"}], ",", 
               RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], "]"}]}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"#3", "+", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"Last", "[", "#3", "]"}], ",", 
               RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], 
            "]"}]}]}], "\[IndentingNewLine]", "]"}], "&"}], "[", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Drop", "[", 
         RowBox[{
          RowBox[{"FoldList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
            ",", "0", ",", 
            RowBox[{"ArrayPad", "[", 
             RowBox[{"img", ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"n1max", ",", "0"}], "}"}], "}"}], ",", 
              "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
          RowBox[{"n1max", "+", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Drop", "[", 
         RowBox[{
          RowBox[{"FoldList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
            ",", "0", ",", 
            RowBox[{"ArrayPad", "[", 
             RowBox[{"img", ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"n2max", ",", "0"}], "}"}], "}"}], ",", 
              "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
          RowBox[{"n2max", "+", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Drop", "[", 
         RowBox[{
          RowBox[{"FoldList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
            ",", "0", ",", 
            RowBox[{"ArrayPad", "[", 
             RowBox[{"img", ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"n3max", ",", "0"}], "}"}], "}"}], ",", 
              "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
          RowBox[{"n3max", "+", "1"}]}], "]"}]}], "]"}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"7", ",", "Cyclic", ",", 
       RowBox[{"w_Integer:", "4"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Alpha]1", "=", 
        RowBox[{"-", "0.009148694809608277`"}]}], ",", 
       RowBox[{"n1max", "=", "4"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]2", "=", 
        RowBox[{"-", "0.12255461519232669`"}]}], ",", 
       RowBox[{"n2max", "=", "8"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]3", "=", 
        RowBox[{"-", "0.5352804307964383`"}]}], ",", 
       RowBox[{"n3max", "=", "26"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"ArrayPad", "[", 
        RowBox[{"#", ",", 
         RowBox[{"{", "w", "}"}], ",", "\"\<Cyclic\>\""}], "]"}], "&"}], "[", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "0.000985066048869381`"}], " ", "img"}], "+", 
          RowBox[{"8.470592879244762`*^-7", " ", "#1"}], "-", 
          RowBox[{"0.00020948815361334196`", " ", "#2"}], "+", 
          RowBox[{"0.0011937071431947985`", " ", "#3"}]}], ")"}], "&"}], "[", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Drop", "[", 
          RowBox[{
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", "0", ",", 
             RowBox[{"ArrayPad", "[", 
              RowBox[{"img", ",", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{"n1max", ",", "0"}], "}"}], "}"}], ",", 
               "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
           RowBox[{"n1max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
         RowBox[{"Reverse", "[", 
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{
                RowBox[{"Reverse", "[", "img", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"{", 
                  RowBox[{"n1max", ",", "0"}], "}"}], "}"}], ",", 
                "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
            RowBox[{"n1max", "+", "1"}]}], "]"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Drop", "[", 
          RowBox[{
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", "0", ",", 
             RowBox[{"ArrayPad", "[", 
              RowBox[{"img", ",", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{"n2max", ",", "0"}], "}"}], "}"}], ",", 
               "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
           RowBox[{"n2max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
         RowBox[{"Reverse", "[", 
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{
                RowBox[{"Reverse", "[", "img", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"{", 
                  RowBox[{"n2max", ",", "0"}], "}"}], "}"}], ",", 
                "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
            RowBox[{"n2max", "+", "1"}]}], "]"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Drop", "[", 
          RowBox[{
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", "0", ",", 
             RowBox[{"ArrayPad", "[", 
              RowBox[{"img", ",", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{"n3max", ",", "0"}], "}"}], "}"}], ",", 
               "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
           RowBox[{"n3max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
         RowBox[{"Reverse", "[", 
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{
                RowBox[{"Reverse", "[", "img", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"{", 
                  RowBox[{"n3max", ",", "0"}], "}"}], "}"}], ",", 
                "\"\<Cyclic\>\""}], "]"}]}], "]"}], ",", 
            RowBox[{"n3max", "+", "1"}]}], "]"}], "]"}]}]}], "]"}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"7", ",", "Constant", ",", 
       RowBox[{"w_Integer:", "4"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Alpha]1", "=", 
        RowBox[{"-", "0.009148694809608277`"}]}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"\[Alpha]2", "=", 
        RowBox[{"-", "0.12255461519232669`"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]3", "=", 
        RowBox[{"-", "0.5352804307964383`"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "0.000985066048869381`"}], " ", "#1"}], "+", 
           RowBox[{"8.470592879244762`*^-7", " ", "#2"}], "-", 
           RowBox[{"0.00020948815361334196`", " ", "#3"}], "+", 
           RowBox[{"0.0011937071431947985`", " ", "#4"}]}], ")"}], "&"}], "[",
         "\[IndentingNewLine]", 
        RowBox[{"#", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{
              RowBox[{"First", "[", "#", "]"}], "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{
               RowBox[{"Last", "[", "#", "]"}], "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{
              RowBox[{"First", "[", "#", "]"}], "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{
               RowBox[{"Last", "[", "#", "]"}], "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{
              RowBox[{"First", "[", "#", "]"}], "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]3"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{
               RowBox[{"Last", "[", "#", "]"}], "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]3"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], "&"}], "[", 
      RowBox[{"ArrayPad", "[", 
       RowBox[{"img", ",", 
        RowBox[{"{", "w", "}"}], ",", "\"\<Fixed\>\""}], "]"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"7", ",", 
       RowBox[{"c_", "?", "NumberQ"}], ",", 
       RowBox[{"w_Integer:", "4"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Alpha]1", "=", 
        RowBox[{"-", "0.009148694809608277`"}]}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"\[Alpha]2", "=", 
        RowBox[{"-", "0.12255461519232669`"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]3", "=", 
        RowBox[{"-", "0.5352804307964383`"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "0.000985066048869381`"}], " ", "#1"}], "+", 
           RowBox[{"8.470592879244762`*^-7", " ", "#2"}], "-", 
           RowBox[{"0.00020948815361334196`", " ", "#3"}], "+", 
           RowBox[{"0.0011937071431947985`", " ", "#4"}]}], ")"}], "&"}], "[",
         "\[IndentingNewLine]", 
        RowBox[{"#", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{"c", "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{"c", "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{"c", "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{"c", "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{"c", "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]3"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{"c", "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]3"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], "&"}], "[", 
      RowBox[{"ArrayPad", "[", 
       RowBox[{"img", ",", 
        RowBox[{"{", "w", "}"}], ",", "c"}], "]"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Nonic", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"9", ",", "Reflective", ",", 
       RowBox[{"w_Integer:", "5"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Alpha]1", "=", 
        RowBox[{"-", "0.002121306903180818`"}]}], ",", 
       RowBox[{"n1max", "=", "3"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]2", "=", 
        RowBox[{"-", "0.04322260854048175`"}]}], ",", 
       RowBox[{"n2max", "=", "5"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]3", "=", 
        RowBox[{"-", "0.2017505201931532`"}]}], ",", 
       RowBox[{"n3max", "=", "10"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]4", "=", 
        RowBox[{"-", "0.6079973891686256`"}]}], ",", 
       RowBox[{"n4max", "=", "32"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"ArrayPad", "[", 
        RowBox[{"#", ",", 
         RowBox[{"{", "w", "}"}], ",", "\"\<Reversed\>\""}], "]"}], "&"}], 
      "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "0.000025453882305777692`"}], " ", "img"}], "-", 
            RowBox[{"2.163545673286295`*^-11", "  ", "#1"}], "+", 
            RowBox[{"2.561818738752173`*^-7", "  ", "#2"}], "-", 
            RowBox[{"8.614411452377346`*^-6", " ", "#3"}], "+", 
            RowBox[{"0.00003381213351973659`", " ", "#4"}]}], ")"}], "&"}], 
         "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"#1", "+", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"Last", "[", "#1", "]"}], ",", 
               RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], "]"}]}], 
          ",", 
          RowBox[{"#2", "+", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"Last", "[", "#2", "]"}], ",", 
               RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], "]"}]}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"#3", "+", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"Last", "[", "#3", "]"}], ",", 
               RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], "]"}]}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"#4", "+", 
           RowBox[{"Reverse", "[", 
            RowBox[{"Rest", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Alpha]4", " ", "#1"}], "+", "#2"}], ")"}], "&"}],
                ",", 
               RowBox[{"Last", "[", "#4", "]"}], ",", 
               RowBox[{"Reverse", "[", "img", "]"}]}], "]"}], "]"}], 
            "]"}]}]}], "\[IndentingNewLine]", "]"}], "&"}], "[", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Drop", "[", 
         RowBox[{
          RowBox[{"FoldList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
            ",", "0", ",", 
            RowBox[{"ArrayPad", "[", 
             RowBox[{"img", ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"n1max", ",", "0"}], "}"}], "}"}], ",", 
              "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
          RowBox[{"n1max", "+", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Drop", "[", 
         RowBox[{
          RowBox[{"FoldList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
            ",", "0", ",", 
            RowBox[{"ArrayPad", "[", 
             RowBox[{"img", ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"n2max", ",", "0"}], "}"}], "}"}], ",", 
              "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
          RowBox[{"n2max", "+", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Drop", "[", 
         RowBox[{
          RowBox[{"FoldList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
            ",", "0", ",", 
            RowBox[{"ArrayPad", "[", 
             RowBox[{"img", ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"n3max", ",", "0"}], "}"}], "}"}], ",", 
              "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
          RowBox[{"n3max", "+", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Drop", "[", 
         RowBox[{
          RowBox[{"FoldList", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Alpha]4", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
            ",", "0", ",", 
            RowBox[{"ArrayPad", "[", 
             RowBox[{"img", ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"n4max", ",", "0"}], "}"}], "}"}], ",", 
              "\"\<Reversed\>\""}], "]"}]}], "]"}], ",", 
          RowBox[{"n4max", "+", "1"}]}], "]"}]}], "]"}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"9", ",", "Cyclic", ",", 
       RowBox[{"w_Integer:", "5"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Alpha]1", "=", 
        RowBox[{"-", "0.002121306903180818`"}]}], ",", 
       RowBox[{"n1max", "=", "3"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]2", "=", 
        RowBox[{"-", "0.04322260854048175`"}]}], ",", 
       RowBox[{"n2max", "=", "5"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]3", "=", 
        RowBox[{"-", "0.2017505201931532`"}]}], ",", 
       RowBox[{"n3max", "=", "10"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]4", "=", 
        RowBox[{"-", "0.6079973891686256`"}]}], ",", 
       RowBox[{"n4max", "=", "32"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"ArrayPad", "[", 
        RowBox[{"#", ",", 
         RowBox[{"{", "w", "}"}], ",", "\"\<Cyclic\>\""}], "]"}], "&"}], "[", 
      
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "0.000025453882305777692`"}], " ", "img"}], "-", 
          RowBox[{"2.163545673286295`*^-11", " ", "#1"}], "+", 
          RowBox[{"2.561818738752173`*^-7", " ", "#2"}], "-", 
          RowBox[{"8.614411452377346`*^-6", " ", "#3"}], "+", 
          RowBox[{"0.00003381213351973659`", " ", "#4"}]}], ")"}], "&"}], "[",
        "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Drop", "[", 
          RowBox[{
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", "0", ",", 
             RowBox[{"ArrayPad", "[", 
              RowBox[{"img", ",", 
               RowBox[{"{", 
                RowBox[{"n1max", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}], 
              "]"}]}], "]"}], ",", 
           RowBox[{"n1max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
         RowBox[{"Reverse", "[", 
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{
                RowBox[{"Reverse", "[", "img", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"n1max", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}], 
               "]"}]}], "]"}], ",", 
            RowBox[{"n1max", "+", "1"}]}], "]"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Drop", "[", 
          RowBox[{
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", "0", ",", 
             RowBox[{"ArrayPad", "[", 
              RowBox[{"img", ",", 
               RowBox[{"{", 
                RowBox[{"n2max", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}], 
              "]"}]}], "]"}], ",", 
           RowBox[{"n2max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
         RowBox[{"Reverse", "[", 
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{
                RowBox[{"Reverse", "[", "img", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"n2max", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}], 
               "]"}]}], "]"}], ",", 
            RowBox[{"n2max", "+", "1"}]}], "]"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Drop", "[", 
          RowBox[{
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", "0", ",", 
             RowBox[{"ArrayPad", "[", 
              RowBox[{"img", ",", 
               RowBox[{"{", 
                RowBox[{"n3max", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}], 
              "]"}]}], "]"}], ",", 
           RowBox[{"n3max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
         RowBox[{"Reverse", "[", 
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{
                RowBox[{"Reverse", "[", "img", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"n3max", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}], 
               "]"}]}], "]"}], ",", 
            RowBox[{"n3max", "+", "1"}]}], "]"}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Drop", "[", 
          RowBox[{
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]4", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", "0", ",", 
             RowBox[{"ArrayPad", "[", 
              RowBox[{"img", ",", 
               RowBox[{"{", 
                RowBox[{"n4max", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}], 
              "]"}]}], "]"}], ",", 
           RowBox[{"n4max", "+", "1"}]}], "]"}], "+", "\[IndentingNewLine]", 
         RowBox[{"Reverse", "[", 
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]4", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", "0", ",", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{
                RowBox[{"Reverse", "[", "img", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"n4max", ",", "0"}], "}"}], ",", "\"\<Cyclic\>\""}], 
               "]"}]}], "]"}], ",", 
            RowBox[{"n4max", "+", "1"}]}], "]"}], "]"}]}]}], "]"}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"9", ",", "Constant", ",", 
       RowBox[{"w_Integer:", "5"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Alpha]1", "=", 
        RowBox[{"-", "0.002121306903180818`"}]}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"\[Alpha]2", "=", 
        RowBox[{"-", "0.04322260854048175`"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]3", "=", 
        RowBox[{"-", "0.2017505201931532`"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]4", "=", 
        RowBox[{"-", "0.6079973891686256`"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "0.000025453882305777692`"}], " ", "#1"}], "-", 
           RowBox[{"2.163545673286295`*^-11", " ", "#2"}], "+", 
           RowBox[{"2.561818738752173`*^-7", " ", "#3"}], "-", 
           RowBox[{"8.614411452377346`*^-6", " ", "#4"}], "+", 
           RowBox[{"0.00003381213351973659`", " ", "#5"}]}], ")"}], "&"}], 
        "[", "\[IndentingNewLine]", 
        RowBox[{"#", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{
              RowBox[{"First", "[", "#", "]"}], "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{
               RowBox[{"Last", "[", "#", "]"}], "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{
              RowBox[{"First", "[", "#", "]"}], "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{
               RowBox[{"Last", "[", "#", "]"}], "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{
              RowBox[{"First", "[", "#", "]"}], "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]3"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{
               RowBox[{"Last", "[", "#", "]"}], "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]3"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
         ",", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]4", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{
              RowBox[{"First", "[", "#", "]"}], "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]4"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]4", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{
               RowBox[{"Last", "[", "#", "]"}], "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]4"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], "&"}], "[", 
      RowBox[{"ArrayPad", "[", 
       RowBox[{"img", ",", 
        RowBox[{"{", "w", "}"}], ",", "\"\<Fixed\>\""}], "]"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"9", ",", 
       RowBox[{"c_", "?", "NumberQ"}], ",", 
       RowBox[{"w_Integer:", "5"}]}], "}"}], ",", "img_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Alpha]1", "=", 
        RowBox[{"-", "0.002121306903180818`"}]}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"\[Alpha]2", "=", 
        RowBox[{"-", "0.04322260854048175`"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]3", "=", 
        RowBox[{"-", "0.2017505201931532`"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"\[Alpha]4", "=", 
        RowBox[{"-", "0.6079973891686256`"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "0.000025453882305777692`"}], " ", "#1"}], "-", 
           RowBox[{"2.163545673286295`*^-11", " ", "#2"}], "+", 
           RowBox[{"2.561818738752173`*^-7", " ", "#3"}], "-", 
           RowBox[{"8.614411452377346`*^-6", " ", "#4"}], "+", 
           RowBox[{"0.00003381213351973659`", " ", "#5"}]}], ")"}], "&"}], 
        "[", "\[IndentingNewLine]", 
        RowBox[{"#", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{"c", "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]1", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{"c", "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]1"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{"c", "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]2", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{"c", "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]2"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
         ",", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{"c", "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]3"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]3", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{"c", "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]3"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Rest", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Alpha]4", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
             ",", 
             RowBox[{"c", "/", 
              RowBox[{"(", 
               RowBox[{"1", "-", "\[Alpha]4"}], ")"}]}], ",", "#"}], "]"}], 
           "]"}], "+", "\[IndentingNewLine]", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Rest", "[", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[Alpha]4", " ", "#1"}], "+", "#2"}], ")"}], "&"}], 
              ",", 
              RowBox[{"c", "/", 
               RowBox[{"(", 
                RowBox[{"1", "-", "\[Alpha]4"}], ")"}]}], ",", 
              RowBox[{"Reverse", "[", "#", "]"}]}], "]"}], "]"}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], "&"}], "[", 
      RowBox[{"ArrayPad", "[", 
       RowBox[{"img", ",", 
        RowBox[{"{", "w", "}"}], ",", "c"}], "]"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["BSplineInterpolationFilter", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineInterpolationFilter", "[", 
    RowBox[{"nn_Integer", ",", 
     RowBox[{"orders", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "|", "3", "|", "5", "|", "7", "|", "9"}], ")"}], ".."}],
        "}"}]}], ",", 
     RowBox[{"boundaries", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Reflective", "|", "Cyclic", "|", "Constant", "|", 
          RowBox[{"_", "?", "NumberQ"}]}], ")"}], ".."}], "}"}]}]}], "]"}], 
   "[", "img_List", "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", " ", "=", " ", 
       RowBox[{"Min", "[", 
        RowBox[{"nn", ",", 
         RowBox[{"ArrayDepth", "[", "img", "]"}]}], "]"}]}], ",", "shift", 
      ",", 
      RowBox[{"tmp", "=", "img"}], ",", "boundaryList", ",", "orderList", ",",
       "j"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"boundaryList", "=", 
      RowBox[{"PadRight", "[", 
       RowBox[{"boundaries", ",", "n", ",", 
        RowBox[{"Last", "[", "boundaries", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"orderList", "=", 
      RowBox[{"PadRight", "[", 
       RowBox[{"orders", ",", "n", ",", 
        RowBox[{"Last", "[", "orders", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"shift", "=", 
      RowBox[{"RotateRight", "[", 
       RowBox[{"Range", "[", "n", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     
     RowBox[{"Do", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"tmp", "=", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"BSplineInterpolationFilter1D", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
              "orderList", "\[LeftDoubleBracket]", "j", 
               "\[RightDoubleBracket]"}], ",", 
              RowBox[{
              "boundaryList", "\[LeftDoubleBracket]", "j", 
               "\[RightDoubleBracket]"}]}], "}"}], ",", "tmp"}], "]"}], ",", 
          "shift"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"j", ",", "n"}], "}"}]}], "\[IndentingNewLine]", "]"}], ";", 
     "\[IndentingNewLine]", "tmp"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "PackageInput",
 CellChangeTimes->{{3.4917975481971073`*^9, 3.491797549735779*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Image Interpolation", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ImageInterpolation", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ImageBoundary", "->", "Reflective"}], ",", 
     RowBox[{"InterpolationOrder", " ", "->", "3"}]}], "}"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImageInterpolation", "::", "notimpl"}], "=", " ", 
  "\"\<ImageInterpolation is not implemented for these parameters.\>\""}]], \
"PackageInput"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ImageInterpolation", "[", 
     RowBox[{"img_", ",", 
      RowBox[{"opts___", "?", "OptionQ"}]}], "]"}], ":=", 
    RowBox[{"ImageInterpolation", "[", 
     RowBox[{"img", ",", "0", ",", "opts"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ImageInterpolation", "[", 
   RowBox[{"img_", ",", 
    RowBox[{"offValue_", "?", "NumberQ"}], ",", 
    RowBox[{"opts___", "?", "OptionQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"rank", "=", 
       RowBox[{"ArrayDepth", "[", "img", "]"}]}], ",", 
      RowBox[{"dims", "=", " ", 
       RowBox[{"Reverse", "[", 
        RowBox[{"Dimensions", "[", "img", "]"}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"boundary", "=", 
       RowBox[{
        RowBox[{"ImageBoundary", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "ImageInterpolation", "]"}]}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"order", "=", 
       RowBox[{
        RowBox[{"InterpolationOrder", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "ImageInterpolation", "]"}]}]}]}], "}"}], ",",
     "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Head", "[", "order", "]"}], "===", "List"}], ",", 
       RowBox[{"order", "=", 
        RowBox[{"Max", "[", "order", "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"MatchQ", "[", 
        RowBox[{"boundary", ",", 
         RowBox[{
         "None", "|", "Cyclic", "|", "Reflective", "|", "Constant", "|", 
          RowBox[{"_", "?", "NumberQ"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"boundary", "=", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{"boundary", ",", 
           RowBox[{"{", "rank", "}"}]}], "]"}], "/.", " ", 
         RowBox[{"Truncate", "->", " ", "0"}]}]}]}], "\[IndentingNewLine]", 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Switch", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"rank", ",", "order", ",", "boundary"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"1", "|", "3", "|", "5", "|", "7", "|", "9"}], ",", 
         RowBox[{"{", 
          RowBox[{"Reflective", "|", "Cyclic", "|", "Constant", "|", 
           RowBox[{"_", "?", "NumberQ"}]}], "}"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"InterpolatingImage", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "#"}], "}"}], "&"}], ",", "dims"}], "]"}], ",",
          "boundary", ",", "offValue", ",", "order", ",", 
         RowBox[{"{", "0", "}"}], ",", "rank", ",", "dims", ",", 
         RowBox[{
          RowBox[{"NBSplineInterpolationFilter1D", "[", 
           RowBox[{"Prepend", "[", 
            RowBox[{"boundary", ",", "order"}], "]"}], "]"}], "[", "img", 
          "]"}]}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_Integer", "?", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"0", "<", "#", "<", "4"}], "&"}], ")"}]}], ",", 
         RowBox[{"(", 
          RowBox[{"1", "|", "3", "|", "5", "|", "7", "|", "9"}], ")"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"Reflective", "|", "Cyclic", "|", "Constant", "|", 
             RowBox[{"_", "?", "NumberQ"}]}], ")"}], ".."}], "}"}]}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"InterpolatingImage", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "#"}], "}"}], "&"}], ",", "dims"}], "]"}], ",",
          "boundary", ",", "offValue", ",", "order", ",", 
         RowBox[{"Table", "[", 
          RowBox[{"0", ",", 
           RowBox[{"{", "rank", "}"}]}], "]"}], ",", "rank", ",", "dims", ",", 
         RowBox[{
          RowBox[{"BSplineInterpolationFilter", "[", 
           RowBox[{"rank", ",", 
            RowBox[{"{", "order", "}"}], ",", 
            RowBox[{"Reverse", "[", "boundary", "]"}]}], "]"}], "[", "img", 
          "]"}]}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", "_"}], "}"}], ",", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{"ImageInterpolation", "::", "notimpl"}], "]"}], ";", 
        RowBox[{"Return", "[", "$Failed", "]"}]}]}], "\[IndentingNewLine]", 
      "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}], "\[IndentingNewLine]"}], "PackageInput",
 CellChangeTimes->{{3.4917986938326883`*^9, 3.491798697600648*^9}, {
   3.49179912655357*^9, 3.491799130369458*^9}, 3.491799322434681*^9, {
   3.491799369497319*^9, 3.491799379356868*^9}, 3.4917994332455397`*^9, 
   3.4917994696216593`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["InterpolatingImage", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Format", "[", "\[IndentingNewLine]", 
   RowBox[{"InterpolatingImage", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"domain", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"boundary", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
         "None", "|", "Cyclic", "|", "Reflective", "|", "Constant", "|", 
          RowBox[{"_", "?", "NumberQ"}]}], ")"}], ".."}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"offcolor_", "?", "NumberQ"}], ",", "\[IndentingNewLine]", 
     RowBox[{"order", ":", 
      RowBox[{"_Integer", "?", "NonNegative"}]}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"derivorders", ":", 
      RowBox[{"{", 
       RowBox[{"__Integer", "?", "NonNegative"}], "}"}]}], ",", " ", 
     "\[IndentingNewLine]", 
     RowBox[{"rank_Integer", "?", "Positive"}], ",", "\[IndentingNewLine]", 
     RowBox[{"dims", ":", 
      RowBox[{"{", 
       RowBox[{"__Integer", "?", "Positive"}], "}"}]}], ",", 
     "\[IndentingNewLine]", "data_List"}], "]"}], "]"}], ":=", 
  RowBox[{"Row", "[", 
   RowBox[{"{", 
    RowBox[{
    "\"\<InterpolatingImage\>\"", ",", "\"\<[\>\"", ",", "domain", ",", 
     "\"\<, \>\"", ",", 
     RowBox[{"Switch", "[", 
      RowBox[{
      "order", ",", "0", ",", "\"\<Nearest Neighbor\>\"", ",", "1", ",", 
       "\"\<Linear\>\"", ",", " ", "2", ",", "\"\<Quadratic\>\"", ",", "3", 
       ",", "\"\<Cubic\>\"", ",", "4", ",", "\"\<Quartic\>\"", ",", "5", ",", 
       "\"\<Quintic\>\"", ",", "5", ",", "\"\<Sextic\>\"", ",", "7", ",", 
       "\"\<Septic\>\"", ",", "8", ",", "\"\<Octic\>\"", ",", "9", ",", 
       "\"\<Nonic\>\""}], "]"}], ",", "\"\<, \>\"", ",", "derivorders", ",", 
     "\"\<, \>\"", ",", "boundary", ",", "\"\<, \>\"", ",", "\"\<<>\>\"", 
     ",", "\"\<]\>\""}], "}"}], "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InterpolatingImage", "/:", " ", "\[IndentingNewLine]", 
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      RowBox[{"Derivative", "[", 
       RowBox[{"ds__Integer", "?", "NonNegative"}], "]"}], "[", 
      RowBox[{"InterpolatingImage", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"domain", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"boundary", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
            "None", "|", "Cyclic", "|", "Reflective", "|", "Constant", "|", 
             RowBox[{"_", "?", "NumberQ"}]}], ")"}], ".."}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"offcolor_", "?", "NumberQ"}], ",", "\[IndentingNewLine]", 
        RowBox[{"order", ":", 
         RowBox[{"_Integer", "?", "NonNegative"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"derivorders", ":", 
         RowBox[{"{", 
          RowBox[{"__Integer", "?", "NonNegative"}], "}"}]}], ",", " ", 
        "\[IndentingNewLine]", 
        RowBox[{"rank_Integer", "?", "Positive"}], ",", "\[IndentingNewLine]", 
        RowBox[{"dims", ":", 
         RowBox[{"{", 
          RowBox[{"__Integer", "?", "Positive"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "data_List"}], "]"}], "]"}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"InterpolatingImage", "[", 
      RowBox[{"domain", ",", "boundary", ",", "offcolor", ",", "order", ",", 
       RowBox[{"derivorders", "+", 
        RowBox[{"{", "ds", "}"}]}], ",", "rank", ",", "dims", ",", "data"}], 
      "]"}], "/;", 
     RowBox[{
      RowBox[{"Length", "[", "derivorders", "]"}], " ", "===", " ", 
      RowBox[{"Length", "[", 
       RowBox[{"{", "ds", "}"}], "]"}]}]}]}], ";"}], " "}]], "PackageInput"],

Cell[CellGroupData[{

Cell["Monic", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineFilter", "[", 
    RowBox[{"1", ",", "d_"}], "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "-", "d"}], ",", "d"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MonicInterpolation", "[", 
    RowBox[{"1", ",", 
     RowBox[{
      RowBox[{"{", "kx_Integer", "}"}], "/;", 
      RowBox[{"0", "\[LessEqual]", "kx", "\[LessEqual]", "1"}]}]}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MonicInterpolation", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", "kx", "}"}]}], "]"}], "=", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Compile", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Block", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x0", " ", "=", " ", 
             RowBox[{"Floor", "[", "x", "]"}]}], ",", " ", "dx"}], "}"}], ",",
           "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dx", " ", "=", " ", 
            RowBox[{"x", " ", "-", " ", "x0"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"0.5", "<=", "x", "<=", 
              RowBox[{"nx", "+", "0.5"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Take", "[", 
               RowBox[{"img", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x0", "+", "1"}], ",", 
                  RowBox[{"x0", "+", "2"}]}], "}"}]}], "]"}], ".", "#1"}], 
             ",", "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", 
            "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
       "]"}], "&"}], "[", 
     RowBox[{
      RowBox[{"BSplineFilter", "[", 
       RowBox[{"1", ",", "dx"}], "]"}], "\[LeftDoubleBracket]", 
      RowBox[{"kx", "+", "1"}], "\[RightDoubleBracket]"}], "]"}]}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MonicInterpolation", "[", 
    RowBox[{"1", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"ks_Integer", "?", "NonNegative"}], "}"}], "/;", " ", 
      RowBox[{"ks", ">=", "2"}]}]}], "]"}], "=", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"0.5", "<=", "x", "<=", 
        RowBox[{"nx", "+", "0.5"}]}], ",", "\[IndentingNewLine]", "0.0", ",", 
       "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MonicInterpolation", "[", 
    RowBox[{"2", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"kx_Integer", ",", "ky_Integer"}], "}"}], "/;", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"0", "\[LessEqual]", "kx", "\[LessEqual]", "1"}], " ", 
        "\[And]", " ", 
        RowBox[{"0", "\[LessEqual]", "ky", "\[LessEqual]", "1"}]}], ")"}]}]}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MonicInterpolation", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"kx", ",", "ky"}], "}"}]}], "]"}], "=", "\[IndentingNewLine]", 
    
    RowBox[{
     RowBox[{
      RowBox[{"Compile", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"img", ",", "_Real", ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Block", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x0", " ", "=", " ", 
             RowBox[{"Floor", "[", "x", "]"}]}], ",", " ", "dx", " ", ",", 
            RowBox[{"y0", " ", "=", " ", 
             RowBox[{"Floor", "[", "y", "]"}]}], ",", " ", "dy"}], " ", "}"}],
           ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dx", " ", "=", " ", 
            RowBox[{"x", " ", "-", " ", "x0"}]}], ";", 
           RowBox[{"dy", " ", "=", " ", 
            RowBox[{"y", " ", "-", " ", "y0"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"0.5", "<=", "x", "<=", 
               RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
              RowBox[{"0.5", "<=", "y", "<=", 
               RowBox[{"ny", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"#2", ".", 
              RowBox[{"Take", "[", 
               RowBox[{"img", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"y0", "+", "1"}], ",", 
                  RowBox[{"y0", "+", "2"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"x0", "+", "1"}], ",", 
                  RowBox[{"x0", "+", "2"}]}], "}"}]}], "]"}], ".", "#1"}], 
             ",", "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", 
            "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
       "]"}], "&"}], "[", 
     RowBox[{
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"1", ",", "dx"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kx", "+", "1"}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"1", ",", "dy"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"ky", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MonicInterpolation", "[", 
    RowBox[{"2", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"ks__Integer", "?", "NonNegative"}], "}"}], "/;", " ", 
      RowBox[{
       RowBox[{"Max", "[", "ks", "]"}], ">=", "2"}]}]}], "]"}], "=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"0.5", "<=", "x", "<=", 
         RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
        RowBox[{"0.5", "<=", "y", "<=", 
         RowBox[{"ny", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", "0.0", 
       ",", "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MonicInterpolation", "[", 
    RowBox[{"3", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"kx_Integer", ",", "ky_Integer", ",", "kz_Integer"}], "}"}], "/;", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"0", "\[LessEqual]", "kx", "\[LessEqual]", "1"}], " ", 
        "\[And]", " ", 
        RowBox[{"0", "\[LessEqual]", "ky", "\[LessEqual]", "1"}], " ", 
        "\[And]", " ", 
        RowBox[{"0", "\[LessEqual]", "kz", "\[LessEqual]", "1"}]}], ")"}]}]}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MonicInterpolation", "[", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{"kx", ",", "ky", ",", "kz"}], "}"}]}], "]"}], "=", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Compile", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"img", ",", "_Real", ",", "3"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nz", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"z", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Block", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x0", " ", "=", " ", 
             RowBox[{"Floor", "[", "x", "]"}]}], ",", " ", "dx", " ", ",", 
            RowBox[{"y0", " ", "=", " ", 
             RowBox[{"Floor", "[", "y", "]"}]}], ",", " ", "dy", ",", 
            RowBox[{"z0", " ", "=", " ", 
             RowBox[{"Floor", "[", "z", "]"}]}], ",", " ", "dz"}], " ", "}"}],
           ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dx", " ", "=", " ", 
            RowBox[{"x", " ", "-", " ", "x0"}]}], ";", 
           RowBox[{"dy", " ", "=", " ", 
            RowBox[{"y", " ", "-", " ", "y0"}]}], ";", 
           RowBox[{"dz", " ", "=", " ", 
            RowBox[{"z", " ", "-", " ", "z0"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"0.5", "<=", "x", "<=", 
               RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
              RowBox[{"0.5", "<=", "y", "<=", 
               RowBox[{"ny", "+", "0.5"}]}], " ", "\[And]", " ", 
              RowBox[{"0.5", "<=", "z", "<=", 
               RowBox[{"nz", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Take", "[", 
                   RowBox[{"img", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"z0", "+", "1"}], ",", 
                    RowBox[{"z0", "+", "2"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"y0", "+", "1"}], ",", 
                    RowBox[{"y0", "+", "2"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"x0", "+", "1"}], ",", 
                    RowBox[{"x0", "+", "2"}]}], "}"}]}], "]"}], ".", "#1"}], 
                 ")"}], ".", "#2"}], ")"}], ".", "#3"}], ",", 
             "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}]}],
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], "&"}],
      "[", 
     RowBox[{
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"1", ",", "dx"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kx", "+", "1"}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"1", ",", "dy"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"ky", "+", "1"}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"1", ",", "dz"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kz", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MonicInterpolation", "[", 
    RowBox[{"3", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"ks__Integer", "?", "NonNegative"}], "}"}], "/;", " ", 
      RowBox[{
       RowBox[{"Max", "[", "ks", "]"}], ">=", "2"}]}]}], "]"}], "=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nz", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"0.5", "<=", "x", "<=", 
         RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
        RowBox[{"0.5", "<=", "y", "<=", 
         RowBox[{"ny", "+", "0.5"}]}], " ", "\[And]", " ", 
        RowBox[{"0.5", "<=", "z", "<=", 
         RowBox[{"nz", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", "0.0", 
       ",", "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InterpolatingImage", "[", 
    RowBox[{"_", ",", "_", ",", "off_", ",", 
     RowBox[{"{", "1", "}"}], ",", "ds_List", ",", "1", ",", 
     RowBox[{"{", "xn_", "}"}], ",", "data_"}], "]"}], "[", 
   RowBox[{"x_", "?", "NumberQ"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"MonicInterpolation", "[", 
    RowBox[{"1", ",", "ds"}], "]"}], "[", 
   RowBox[{"data", ",", "off", ",", "xn", ",", "x"}], "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InterpolatingImage", "[", 
    RowBox[{"_", ",", "_", ",", "off_", ",", 
     RowBox[{"{", "1", "}"}], ",", "ds_List", ",", "2", ",", 
     RowBox[{"{", 
      RowBox[{"xn_", ",", "yn_"}], "}"}], ",", "data_"}], "]"}], "[", 
   RowBox[{
    RowBox[{"x_", "?", "NumberQ"}], ",", 
    RowBox[{"y_", "?", "NumberQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"MonicInterpolation", "[", 
    RowBox[{"2", ",", "ds"}], "]"}], "[", 
   RowBox[{"data", ",", "off", ",", "xn", ",", "yn", ",", "x", ",", "y"}], 
   "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InterpolatingImage", "[", 
    RowBox[{"_", ",", "_", ",", "off_", ",", 
     RowBox[{"{", "1", "}"}], ",", "ds_List", ",", "3", ",", 
     RowBox[{"{", 
      RowBox[{"xn_", ",", "yn_", ",", "zn_"}], "}"}], ",", "data_"}], "]"}], 
   "[", 
   RowBox[{
    RowBox[{"x_", "?", "NumberQ"}], ",", 
    RowBox[{"y_", "?", "NumberQ"}], ",", 
    RowBox[{"z_", "?", "NumberQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"MonicInterpolation", "[", 
    RowBox[{"3", ",", "ds"}], "]"}], "[", 
   RowBox[{
   "data", ",", "off", ",", "xn", ",", "yn", ",", "zn", ",", "x", ",", "y", 
    ",", "z"}], "]"}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Cubic", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineFilter", "[", 
    RowBox[{"3", ",", "d_"}], "]"}], " ", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "-", "d"}], ")"}], "3"], ",", 
       RowBox[{"4", "+", 
        RowBox[{"3", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", "d"}], ")"}], " ", 
         SuperscriptBox["d", "2"]}]}], ",", 
       RowBox[{"1", "+", 
        RowBox[{"3", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", "d", "-", 
           SuperscriptBox["d", "2"]}], ")"}]}]}], ",", 
       SuperscriptBox["d", "3"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "d"}], ")"}], "2"]}], ",", 
       RowBox[{"d", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", 
          RowBox[{"3", " ", "d"}]}], ")"}]}], ",", 
       RowBox[{"1", "+", 
        RowBox[{"2", " ", "d"}], "-", 
        RowBox[{"3", " ", 
         SuperscriptBox["d", "2"]}]}], ",", 
       SuperscriptBox["d", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "-", "d"}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], "+", 
        RowBox[{"3", " ", "d"}]}], ",", 
       RowBox[{"1", "-", 
        RowBox[{"3", " ", "d"}]}], ",", "d"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "3", ",", 
       RowBox[{"-", "3"}], ",", "1"}], "}"}]}], "}"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CubicInterpolation", "[", 
    RowBox[{"1", ",", 
     RowBox[{
      RowBox[{"{", "kx_Integer", "}"}], "/;", 
      RowBox[{"0", "\[LessEqual]", "kx", "\[LessEqual]", "3"}]}]}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"CubicInterpolation", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", "kx", "}"}]}], "]"}], "=", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Compile", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Block", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x0", " ", "=", " ", 
             RowBox[{"Floor", "[", "x", "]"}]}], ",", " ", "dx"}], " ", "}"}],
           ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dx", " ", "=", " ", 
            RowBox[{"x", " ", "-", " ", "x0"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"0.5", "<=", "x", "<=", 
              RowBox[{"nx", "+", "0.5"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"#1", "*", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Take", "[", 
                 RowBox[{"img", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"x0", "+", "1"}], ",", 
                    RowBox[{"x0", "+", "4"}]}], "}"}]}], "]"}], ".", "#2"}], 
               ")"}]}], ",", "\[IndentingNewLine]", "off"}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "]"}], "&"}], "[", 
     RowBox[{
      FractionBox[
       RowBox[{"3", "!"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"3", "-", "kx"}], ")"}], "!"}]], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"3", ",", "dx"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kx", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CubicInterpolation", "[", 
    RowBox[{"1", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"ks_Integer", "?", "NonNegative"}], "}"}], "/;", " ", 
      RowBox[{"ks", "\[GreaterEqual]", "4"}]}]}], "]"}], "=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"0.5", "<=", "x", "<=", 
        RowBox[{"nx", "+", "0.5"}]}], ",", "\[IndentingNewLine]", "0.0", ",", 
       "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CubicInterpolation", "[", 
    RowBox[{"2", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"kx_Integer", ",", "ky_Integer"}], "}"}], "/;", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"0", "\[LessEqual]", "kx", "\[LessEqual]", "3"}], " ", 
        "\[And]", " ", 
        RowBox[{"0", "\[LessEqual]", "ky", "\[LessEqual]", "3"}]}], ")"}]}]}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"CubicInterpolation", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"kx", ",", "ky"}], "}"}]}], "]"}], "=", "\[IndentingNewLine]", 
    
    RowBox[{
     RowBox[{
      RowBox[{"Compile", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"img", ",", "_Real", ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Block", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x0", " ", "=", " ", 
             RowBox[{"Floor", "[", "x", "]"}]}], ",", " ", "dx", " ", ",", 
            RowBox[{"y0", " ", "=", " ", 
             RowBox[{"Floor", "[", "y", "]"}]}], ",", " ", "dy"}], " ", "}"}],
           ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dx", " ", "=", " ", 
            RowBox[{"x", " ", "-", " ", "x0"}]}], ";", 
           RowBox[{"dy", " ", "=", " ", 
            RowBox[{"y", " ", "-", " ", "y0"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"0.5", "<=", "x", "<=", 
               RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
              RowBox[{"0.5", "<=", "y", "<=", 
               RowBox[{"ny", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"#1", "*", 
              RowBox[{"(", 
               RowBox[{"#3", ".", 
                RowBox[{"Take", "[", 
                 RowBox[{"img", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"y0", "+", "1"}], ",", 
                    RowBox[{"y0", "+", "4"}]}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"x0", "+", "1"}], ",", 
                    RowBox[{"x0", "+", "4"}]}], "}"}]}], "]"}], ".", "#2"}], 
               ")"}]}], ",", "\[IndentingNewLine]", "off"}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "]"}], "&"}], "[", 
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"3", "!"}], ")"}], "2"], 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"3", "-", "kx"}], ")"}], "!"}], " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"3", "-", "ky"}], ")"}], "!"}]}]], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"3", ",", "dx"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kx", "+", "1"}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"3", ",", "dy"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"ky", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CubicInterpolation", "[", 
    RowBox[{"2", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"ks__Integer", "?", "NonNegative"}], "}"}], "/;", " ", 
      RowBox[{
       RowBox[{"Max", "[", "ks", "]"}], "\[GreaterEqual]", "4"}]}]}], "]"}], 
   "=", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"0.5", "<=", "x", "<=", 
         RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
        RowBox[{"0.5", "<=", "y", "<=", 
         RowBox[{"ny", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", "0.0", 
       ",", "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CubicInterpolation", "[", 
    RowBox[{"3", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"kx_Integer", ",", "ky_Integer", ",", "kz_Integer"}], "}"}], "/;", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"0", "\[LessEqual]", "kx", "\[LessEqual]", "3"}], " ", 
        "\[And]", " ", 
        RowBox[{"0", "\[LessEqual]", "ky", "\[LessEqual]", "3"}], " ", 
        "\[And]", " ", 
        RowBox[{"0", "\[LessEqual]", "kz", "\[LessEqual]", "3"}]}], ")"}]}]}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"CubicInterpolation", "[", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{"kx", ",", "ky", ",", "kz"}], "}"}]}], "]"}], "=", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Compile", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"img", ",", "_Real", ",", "3"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nz", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"z", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Block", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x0", " ", "=", " ", 
             RowBox[{"Floor", "[", "x", "]"}]}], ",", " ", "dx", " ", ",", 
            RowBox[{"y0", " ", "=", " ", 
             RowBox[{"Floor", "[", "y", "]"}]}], ",", " ", "dy", ",", 
            RowBox[{"z0", " ", "=", " ", 
             RowBox[{"Floor", "[", "z", "]"}]}], ",", " ", "dz"}], " ", "}"}],
           ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dx", " ", "=", " ", 
            RowBox[{"x", " ", "-", " ", "x0"}]}], ";", 
           RowBox[{"dy", " ", "=", " ", 
            RowBox[{"y", " ", "-", " ", "y0"}]}], ";", 
           RowBox[{"dz", " ", "=", " ", 
            RowBox[{"z", " ", "-", " ", "z0"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"0.5", "<=", "x", "<=", 
               RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
              RowBox[{"0.5", "<=", "y", "<=", 
               RowBox[{"ny", "+", "0.5"}]}], " ", "\[And]", " ", 
              RowBox[{"0.5", "<=", "z", "<=", 
               RowBox[{"nz", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"#1", "*", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Take", "[", 
                    RowBox[{"img", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"z0", "+", "1"}], ",", 
                    RowBox[{"z0", "+", "4"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"y0", "+", "1"}], ",", 
                    RowBox[{"y0", "+", "4"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"x0", "+", "1"}], ",", 
                    RowBox[{"x0", "+", "4"}]}], "}"}]}], "]"}], ".", "#2"}], 
                   ")"}], ".", "#3"}], ")"}], ".", "#4"}], ")"}]}], ",", 
             "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}]}],
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], "&"}],
      "[", 
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"3", "!"}], ")"}], "3"], 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"3", "-", "kx"}], ")"}], "!"}], " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"3", "-", "ky"}], ")"}], "!"}], " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"3", "-", "kz"}], ")"}], "!"}]}]], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"3", ",", "dx"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kx", "+", "1"}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"3", ",", "dy"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"ky", "+", "1"}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"3", ",", "dz"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kz", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
  ";"}]], "PackageInput",
 CellChangeTimes->{{3.4916186808653307`*^9, 3.4916186892000303`*^9}, {
  3.491711727064129*^9, 3.491711739489951*^9}, {3.491716342617086*^9, 
  3.4917164028871603`*^9}, {3.491799582169751*^9, 3.4917995972884293`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CubicInterpolation", "[", 
    RowBox[{"3", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"ks__Integer", "?", "NonNegative"}], "}"}], "/;", " ", 
      RowBox[{
       RowBox[{"Max", "[", "ks", "]"}], "\[GreaterEqual]", "4"}]}]}], "]"}], 
   "=", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nz", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"0.5", "<=", "x", "<=", 
         RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
        RowBox[{"0.5", "<=", "y", "<=", 
         RowBox[{"ny", "+", "0.5"}]}], " ", "\[And]", " ", 
        RowBox[{"0.5", "<=", "z", "<=", 
         RowBox[{"nz", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", "0.0", 
       ",", "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InterpolatingImage", "[", 
    RowBox[{
    "_", ",", "_", ",", "off_", ",", "3", ",", "ds_List", ",", "1", ",", 
     RowBox[{"{", "xn_", "}"}], ",", "data_"}], "]"}], "[", 
   RowBox[{"x_", "?", "NumberQ"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"CubicInterpolation", "[", 
    RowBox[{"1", ",", "ds"}], "]"}], "[", 
   RowBox[{"data", ",", "off", ",", "xn", ",", "x"}], "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InterpolatingImage", "[", 
    RowBox[{
    "_", ",", "_", ",", "off_", ",", "3", ",", "ds_List", ",", "2", ",", 
     RowBox[{"{", 
      RowBox[{"xn_", ",", "yn_"}], "}"}], ",", "data_"}], "]"}], "[", 
   RowBox[{
    RowBox[{"x_", "?", "NumberQ"}], ",", 
    RowBox[{"y_", "?", "NumberQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"CubicInterpolation", "[", 
    RowBox[{"2", ",", "ds"}], "]"}], "[", 
   RowBox[{"data", ",", "off", ",", "xn", ",", "yn", ",", "x", ",", "y"}], 
   "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InterpolatingImage", "[", 
    RowBox[{
    "_", ",", "_", ",", "off_", ",", "3", ",", "ds_List", ",", "3", ",", 
     RowBox[{"{", 
      RowBox[{"xn_", ",", "yn_", ",", "zn_"}], "}"}], ",", "data_"}], "]"}], 
   "[", 
   RowBox[{
    RowBox[{"x_", "?", "NumberQ"}], ",", 
    RowBox[{"y_", "?", "NumberQ"}], ",", 
    RowBox[{"z_", "?", "NumberQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"CubicInterpolation", "[", 
    RowBox[{"3", ",", "ds"}], "]"}], "[", 
   RowBox[{
   "data", ",", "off", ",", "xn", ",", "yn", ",", "zn", ",", "x", ",", "y", 
    ",", "z"}], "]"}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Quintic", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineFilter", "[", 
    RowBox[{"5", ",", "d_"}], "]"}], " ", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "-", "d"}], ")"}], "5"], ",", 
       RowBox[{"26", "+", 
        RowBox[{"5", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "10"}], "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"4", "+", 
              RowBox[{
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "2"}], "+", "d"}], ")"}], "2"], " ", "d"}]}], 
             ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{"66", "-", 
        RowBox[{"10", " ", 
         SuperscriptBox["d", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"6", "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "3"}], "+", "d"}], ")"}], " ", 
            SuperscriptBox["d", "2"]}]}], ")"}]}]}], ",", 
       RowBox[{"26", "+", 
        RowBox[{"10", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{"5", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"2", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "2"}], "+", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "2"}], "+", "d"}], ")"}], " ", "d"}]}], 
                ")"}]}]}], ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{"1", "+", 
        RowBox[{"5", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"2", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{"2", "+", "d", "-", 
                 SuperscriptBox["d", "2"]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
       ",", 
       SuperscriptBox["d", "5"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "d"}], ")"}], "4"]}], ",", 
       RowBox[{
        RowBox[{"-", "10"}], "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{"8", "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "2"}], "+", "d"}], ")"}], " ", "d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "6"}], "+", 
              RowBox[{"5", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", "d", " ", 
        RowBox[{"(", 
         RowBox[{"12", "+", 
          RowBox[{
           SuperscriptBox["d", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "12"}], "+", 
             RowBox[{"5", " ", "d"}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"5", "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "2"}], "+", "d"}], ")"}], " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "2"}], "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{"2", "+", 
                RowBox[{"5", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"1", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{"4", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"6", "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", "-", 
                 RowBox[{"5", " ", "d"}]}], ")"}], " ", "d"}]}], ")"}]}]}], 
          ")"}]}]}], ",", 
       SuperscriptBox["d", "4"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "-", "d"}], ")"}], "3"], ",", 
       RowBox[{"2", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{"6", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "12"}], "+", 
              RowBox[{"5", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{"3", "+", 
          RowBox[{
           SuperscriptBox["d", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "9"}], "+", 
             RowBox[{"5", " ", "d"}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "3"}], "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "6"}], "+", 
                RowBox[{"5", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"1", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{"3", "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"3", "-", 
              RowBox[{"5", " ", "d"}]}], ")"}], " ", "d"}]}], ")"}]}]}], ",", 
       
       SuperscriptBox["d", "3"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "d"}], ")"}], "2"]}], ",", 
       RowBox[{"2", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "8"}], "+", 
           RowBox[{"5", " ", "d"}]}], ")"}]}]}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"6", "-", 
          RowBox[{"5", " ", "d"}]}], ")"}], " ", "d"}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"5", " ", "d"}]}], ")"}]}], ",", 
       RowBox[{"1", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", "-", 
           RowBox[{"5", " ", "d"}]}], ")"}], " ", "d"}]}], ",", 
       SuperscriptBox["d", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "-", "d"}], ",", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{"5", " ", "d"}]}], ",", 
       RowBox[{"6", "-", 
        RowBox[{"10", " ", "d"}]}], ",", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{"10", " ", "d"}]}], ",", 
       RowBox[{"1", "-", 
        RowBox[{"5", " ", "d"}]}], ",", "d"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "5", ",", 
       RowBox[{"-", "10"}], ",", "10", ",", 
       RowBox[{"-", "5"}], ",", "1"}], "}"}]}], "}"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"QuinticInterpolation", "[", 
    RowBox[{"1", ",", 
     RowBox[{
      RowBox[{"{", "kx_Integer", "}"}], "/;", 
      RowBox[{"0", "\[LessEqual]", "kx", "\[LessEqual]", "5"}]}]}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QuinticInterpolation", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", "kx", "}"}]}], "]"}], "=", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Compile", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Block", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x0", " ", "=", " ", 
             RowBox[{"Floor", "[", "x", "]"}]}], ",", " ", "dx"}], "}"}], ",",
           "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dx", " ", "=", " ", 
            RowBox[{"x", " ", "-", " ", "x0"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"0.5", "<=", "x", "<=", 
              RowBox[{"nx", "+", "0.5"}]}], " ", ",", "\[IndentingNewLine]", 
             RowBox[{"#1", "*", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Take", "[", 
                 RowBox[{"img", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"x0", "+", "1"}], ",", 
                    RowBox[{"x0", "+", "6"}]}], "}"}]}], "]"}], ".", "#2"}], 
               ")"}]}], ",", "\[IndentingNewLine]", "off"}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "]"}], "&"}], "[", 
     RowBox[{
      FractionBox[
       RowBox[{"5", "!"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"5", "-", "kx"}], ")"}], "!"}]], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"5", ",", "dx"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kx", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"QuinticInterpolation", "[", 
    RowBox[{"1", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"kx_Integer", "?", "NonNegative"}], "}"}], "/;", " ", 
      RowBox[{"kx", "\[GreaterEqual]", "6"}]}]}], "]"}], "=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"0.5", "<=", "x", "<=", 
        RowBox[{"nx", "+", "0.5"}]}], ",", "\[IndentingNewLine]", "0.0", ",", 
       "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"QuinticInterpolation", "[", 
    RowBox[{"2", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"kx_Integer", ",", "ky_Integer"}], "}"}], "/;", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"0", "\[LessEqual]", "kx", "\[LessEqual]", "5"}], " ", 
        "\[And]", " ", 
        RowBox[{"0", "\[LessEqual]", "ky", "\[LessEqual]", "5"}]}], ")"}]}]}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QuinticInterpolation", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"kx", ",", "ky"}], "}"}]}], "]"}], "=", "\[IndentingNewLine]", 
    
    RowBox[{
     RowBox[{
      RowBox[{"Compile", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"img", ",", "_Real", ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Block", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x0", " ", "=", " ", 
             RowBox[{"Floor", "[", "x", "]"}]}], ",", " ", "dx", " ", ",", 
            RowBox[{"y0", " ", "=", " ", 
             RowBox[{"Floor", "[", "y", "]"}]}], ",", " ", "dy"}], " ", "}"}],
           ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dx", " ", "=", " ", 
            RowBox[{"x", " ", "-", " ", "x0"}]}], ";", 
           RowBox[{"dy", " ", "=", " ", 
            RowBox[{"y", " ", "-", " ", "y0"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"0.5", "<=", "x", "<=", 
               RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
              RowBox[{"0.5", "<=", "y", "<=", 
               RowBox[{"ny", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"#1", "*", 
              RowBox[{"(", 
               RowBox[{"#3", ".", 
                RowBox[{"Take", "[", 
                 RowBox[{"img", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"y0", "+", "1"}], ",", 
                    RowBox[{"y0", "+", "6"}]}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"x0", "+", "1"}], ",", 
                    RowBox[{"x0", "+", "6"}]}], "}"}]}], "]"}], ".", "#2"}], 
               ")"}]}], ",", "\[IndentingNewLine]", "off"}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "]"}], "&"}], "[", 
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"5", "!"}], ")"}], "2"], 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"5", "-", "kx"}], ")"}], "!"}], " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"5", "-", "ky"}], ")"}], "!"}]}]], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"5", ",", "dx"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kx", "+", "1"}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"5", ",", "dy"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"ky", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"QuinticInterpolation", "[", 
    RowBox[{"2", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"ks__Integer", "?", "NonNegative"}], "}"}], "/;", " ", 
      RowBox[{
       RowBox[{"Max", "[", "ks", "]"}], "\[GreaterEqual]", "6"}]}]}], "]"}], 
   "=", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"0.5", "<=", "x", "<=", 
         RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
        RowBox[{"0.5", "<=", "y", "<=", 
         RowBox[{"ny", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", "0.0", 
       ",", "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"QuinticInterpolation", "[", 
    RowBox[{"3", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"kx_Integer", ",", "ky_Integer", ",", "kz_Integer"}], "}"}], "/;", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"0", "\[LessEqual]", "kx", "\[LessEqual]", "5"}], " ", 
        "\[And]", " ", 
        RowBox[{"0", "\[LessEqual]", "ky", "\[LessEqual]", "5"}], " ", 
        "\[And]", " ", 
        RowBox[{"0", "\[LessEqual]", "kz", "\[LessEqual]", "5"}]}], ")"}]}]}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"QuinticInterpolation", "[", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{"kx", ",", "ky", ",", "kz"}], "}"}]}], "]"}], "=", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Compile", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"img", ",", "_Real", ",", "3"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nz", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"z", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Block", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x0", " ", "=", " ", 
             RowBox[{"Floor", "[", "x", "]"}]}], ",", " ", "dx", " ", ",", 
            RowBox[{"y0", " ", "=", " ", 
             RowBox[{"Floor", "[", "y", "]"}]}], ",", " ", "dy", "  ", ",", 
            RowBox[{"z0", " ", "=", " ", 
             RowBox[{"Floor", "[", "z", "]"}]}], ",", " ", "dz"}], "}"}], ",",
           "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dx", " ", "=", " ", 
            RowBox[{"x", " ", "-", " ", "x0"}]}], ";", 
           RowBox[{"dy", " ", "=", " ", 
            RowBox[{"y", " ", "-", " ", "y0"}]}], ";", 
           RowBox[{"dz", " ", "=", " ", 
            RowBox[{"z", " ", "-", " ", "z0"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"0.5", "<=", "x", "<=", 
               RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
              RowBox[{"0.5", "<=", "y", "<=", 
               RowBox[{"ny", "+", "0.5"}]}], " ", "\[And]", " ", 
              RowBox[{"0.5", "<=", "z", "<=", 
               RowBox[{"nz", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"#1", "*", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Take", "[", 
                    RowBox[{"img", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"z0", "+", "1"}], ",", 
                    RowBox[{"z0", "+", "6"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"y0", "+", "1"}], ",", 
                    RowBox[{"y0", "+", "6"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"x0", "+", "1"}], ",", 
                    RowBox[{"x0", "+", "6"}]}], "}"}]}], "]"}], ".", "#2"}], 
                   ")"}], ".", "#3"}], ")"}], ".", "#4"}], ")"}]}], ",", 
             "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}]}],
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], "&"}],
      "[", 
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"5", "!"}], ")"}], "3"], 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"5", "-", "kx"}], ")"}], "!"}], " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"5", "-", "ky"}], ")"}], "!"}], " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"5", "-", "kz"}], ")"}], "!"}]}]], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"5", ",", "dx"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kx", "+", "1"}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"5", ",", "dy"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"ky", "+", "1"}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"5", ",", "dz"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kz", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"QuinticInterpolation", "[", 
    RowBox[{"3", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"ks__Integer", "?", "NonNegative"}], "}"}], "/;", " ", 
      RowBox[{
       RowBox[{"Max", "[", "ks", "]"}], "\[GreaterEqual]", "6"}]}]}], "]"}], 
   "=", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nz", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"0.5", "<=", "x", "<=", 
         RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
        RowBox[{"0.5", "<=", "y", "<=", 
         RowBox[{"ny", "+", "0.5"}]}], " ", "\[And]", " ", 
        RowBox[{"0.5", "<=", "z", "<=", 
         RowBox[{"nz", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", "0.0", 
       ",", "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InterpolatingImage", "[", 
    RowBox[{
    "_", ",", "_", ",", "off_", ",", "5", ",", "ds_List", ",", "1", ",", 
     RowBox[{"{", "xn_", "}"}], ",", "data_"}], "]"}], "[", 
   RowBox[{"x_", "?", "NumberQ"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"QuinticInterpolation", "[", 
    RowBox[{"1", ",", "ds"}], "]"}], "[", 
   RowBox[{"data", ",", "off", ",", "xn", ",", "x"}], "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InterpolatingImage", "[", 
    RowBox[{
    "_", ",", "_", ",", "off_", ",", "5", ",", "ds_List", ",", "2", ",", 
     RowBox[{"{", 
      RowBox[{"xn_", ",", "yn_"}], "}"}], ",", "data_"}], "]"}], "[", 
   RowBox[{
    RowBox[{"x_", "?", "NumberQ"}], ",", 
    RowBox[{"y_", "?", "NumberQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"QuinticInterpolation", "[", 
    RowBox[{"2", ",", "ds"}], "]"}], "[", 
   RowBox[{"data", ",", "off", ",", "xn", ",", "yn", ",", "x", ",", "y"}], 
   "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InterpolatingImage", "[", 
    RowBox[{
    "_", ",", "_", ",", "off_", ",", "5", ",", "ds_List", ",", "3", ",", 
     RowBox[{"{", 
      RowBox[{"xn_", ",", "yn_", ",", "zn_"}], "}"}], ",", "data_"}], "]"}], 
   "[", 
   RowBox[{
    RowBox[{"x_", "?", "NumberQ"}], ",", 
    RowBox[{"y_", "?", "NumberQ"}], ",", 
    RowBox[{"z_", "?", "NumberQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"QuinticInterpolation", "[", 
    RowBox[{"3", ",", "ds"}], "]"}], "[", 
   RowBox[{
   "data", ",", "off", ",", "xn", ",", "yn", ",", "yn", ",", "x", ",", "y", 
    ",", "z"}], "]"}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Septic", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineFilter", "[", 
    RowBox[{"7", ",", "d_"}], "]"}], " ", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "-", "d"}], ")"}], "7"], ",", 
       RowBox[{"120", "+", 
        RowBox[{"7", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "56"}], "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"72", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "40"}], "+", 
                 RowBox[{
                  SuperscriptBox["d", "2"], " ", 
                  RowBox[{"(", 
                   RowBox[{"12", "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "6"}], "+", "d"}], ")"}], " ", "d"}]}], 
                   ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{"1191", "-", 
        RowBox[{"7", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{"245", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "45"}], "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "95"}], "+", 
                 RowBox[{"3", " ", "d", " ", 
                  RowBox[{"(", 
                   RowBox[{"15", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"5", "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "5"}], "+", "d"}], ")"}], " ", "d"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
       ",", 
       RowBox[{"2416", "+", 
        RowBox[{"35", " ", 
         SuperscriptBox["d", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "48"}], "+", 
           RowBox[{"16", " ", 
            SuperscriptBox["d", "2"]}], "-", 
           RowBox[{"4", " ", 
            SuperscriptBox["d", "4"]}], "+", 
           SuperscriptBox["d", "5"]}], ")"}]}]}], ",", 
       RowBox[{"1191", "-", 
        RowBox[{"35", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "49"}], "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "9"}], "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{"19", "+", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "3"}], "+", "d"}], ")"}], " ", "d", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "3"}], "+", 
                    SuperscriptBox["d", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{"120", "+", 
        RowBox[{"7", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{"56", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"72", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{"40", "+", 
                 RowBox[{"3", " ", 
                  SuperscriptBox["d", "2"], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "4"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "2"}], "+", "d"}], ")"}], " ", "d"}]}], 
                   ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{"1", "+", 
        RowBox[{"7", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"3", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{"5", "+", 
                 RowBox[{"d", " ", 
                  RowBox[{"(", 
                   RowBox[{"5", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"3", "+", "d", "-", 
                    SuperscriptBox["d", "2"]}], ")"}]}]}], ")"}]}]}], 
                ")"}]}]}], ")"}]}]}], ")"}]}]}], ",", 
       SuperscriptBox["d", "7"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "d"}], ")"}], "6"]}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", 
          SuperscriptBox["d", "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"28", "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "72"}], "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{"74", "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "36"}], "+", 
                   RowBox[{"7", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}],
          ")"}]}], ",", 
       RowBox[{
        RowBox[{"-", "245"}], "+", 
        RowBox[{"3", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{"30", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"95", "-", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{"60", "+", 
                 RowBox[{"d", " ", 
                  RowBox[{"(", 
                   RowBox[{"25", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "30"}], "+", 
                    RowBox[{"7", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
                ")"}]}]}], ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{"5", " ", "d", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "96"}], "+", 
          RowBox[{"64", " ", 
           SuperscriptBox["d", "2"]}], "-", 
          RowBox[{"24", " ", 
           SuperscriptBox["d", "4"]}], "+", 
          RowBox[{"7", " ", 
           SuperscriptBox["d", "5"]}]}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"-", "5"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", "d"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"49", "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{"18", "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "8"}], "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "18"}], "+", 
                   RowBox[{"7", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}],
          ")"}]}], ",", 
       RowBox[{"56", "+", 
        RowBox[{"3", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{"48", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"40", "+", 
              RowBox[{
               SuperscriptBox["d", "2"], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "20"}], "+", 
                 RowBox[{"d", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "12"}], "+", 
                    RowBox[{"7", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "2"}], "+", "d"}], ")"}], " ", "d"}]}], ")"}], " ", 
        
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{"4", "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{"8", "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{"8", "+", 
                   RowBox[{"7", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}],
          ")"}]}], ",", 
       SuperscriptBox["d", "6"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "-", "d"}], ")"}], "5"], ",", 
       RowBox[{"24", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "40"}], "+", 
           RowBox[{
            SuperscriptBox["d", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"40", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "30"}], "+", 
                 RowBox[{"7", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
       ",", 
       RowBox[{"15", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{"95", "-", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"90", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{"50", "+", 
                 RowBox[{"3", " ", "d", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "25"}], "+", 
                    RowBox[{"7", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{"5", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "16"}], "+", 
          RowBox[{"32", " ", 
           SuperscriptBox["d", "2"]}], "-", 
          RowBox[{"20", " ", 
           SuperscriptBox["d", "4"]}], "+", 
          RowBox[{"7", " ", 
           SuperscriptBox["d", "5"]}]}], ")"}]}], ",", 
       RowBox[{"15", "-", 
        RowBox[{"5", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{"19", "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", "d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "18"}], "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "8"}], "+", 
                 RowBox[{"7", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
       ",", 
       RowBox[{"24", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{"40", "+", 
           RowBox[{
            SuperscriptBox["d", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "40"}], "+", 
              RowBox[{"3", " ", "d", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "10"}], "+", 
                 RowBox[{"7", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
       ",", 
       RowBox[{"1", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{"5", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"10", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{"10", "+", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"5", "-", 
                    RowBox[{"7", " ", "d"}]}], ")"}], " ", "d"}]}], ")"}]}]}],
              ")"}]}]}], ")"}]}]}], ",", 
       SuperscriptBox["d", "5"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "d"}], ")"}], "4"]}], ",", 
       RowBox[{
        RowBox[{"-", "8"}], "+", 
        RowBox[{
         SuperscriptBox["d", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"24", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "24"}], "+", 
              RowBox[{"7", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{"19", "-", 
        RowBox[{"3", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{"12", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"10", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "20"}], "+", 
                 RowBox[{"7", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
       ",", 
       RowBox[{"d", " ", 
        RowBox[{"(", 
         RowBox[{"64", "+", 
          RowBox[{"5", " ", 
           SuperscriptBox["d", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "16"}], "+", 
             RowBox[{"7", " ", "d"}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"-", "19"}], "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "36"}], "+", 
           RowBox[{"5", " ", "d", " ", 
            RowBox[{"(", 
             RowBox[{"6", "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"12", "-", 
                 RowBox[{"7", " ", "d"}]}], ")"}], " ", "d"}]}], ")"}]}]}], 
          ")"}]}]}], ",", 
       RowBox[{"8", "+", 
        RowBox[{"3", " ", 
         SuperscriptBox["d", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "8"}], "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "8"}], "+", 
              RowBox[{"7", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{"1", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{"4", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"6", "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", "-", 
                 RowBox[{"7", " ", "d"}]}], ")"}], " ", "d"}]}], ")"}]}]}], 
          ")"}]}]}], ",", 
       SuperscriptBox["d", "4"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "-", "d"}], ")"}], "3"], ",", 
       RowBox[{"d", " ", 
        RowBox[{"(", 
         RowBox[{"12", "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "18"}], "+", 
             RowBox[{"7", " ", "d"}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"-", "3"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "3"}], "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "8"}], "+", 
             RowBox[{"7", " ", "d"}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"16", "+", 
        RowBox[{"5", " ", 
         SuperscriptBox["d", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "12"}], "+", 
           RowBox[{"7", " ", "d"}]}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", "9"}], "+", 
        RowBox[{"5", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{"3", "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"9", "-", 
              RowBox[{"7", " ", "d"}]}], ")"}], " ", "d"}]}], ")"}]}]}], ",", 
       
       RowBox[{"3", " ", "d", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "6"}], "+", 
             RowBox[{"7", " ", "d"}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"1", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{"3", "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"3", "-", 
              RowBox[{"7", " ", "d"}]}], ")"}], " ", "d"}]}], ")"}]}]}], ",", 
       
       SuperscriptBox["d", "3"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "d"}], ")"}], "2"]}], ",", 
       RowBox[{"4", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "12"}], "+", 
           RowBox[{"7", " ", "d"}]}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", "5"}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"(", 
          RowBox[{"10", "-", 
           RowBox[{"7", " ", "d"}]}], ")"}], " ", "d"}]}], ",", 
       RowBox[{"5", " ", "d", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "8"}], "+", 
          RowBox[{"7", " ", "d"}]}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"-", "5"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"7", " ", "d"}]}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"-", "4"}], "+", 
        RowBox[{"3", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", 
           RowBox[{"7", " ", "d"}]}], ")"}]}]}], ",", 
       RowBox[{"1", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", "-", 
           RowBox[{"7", " ", "d"}]}], ")"}], " ", "d"}]}], ",", 
       SuperscriptBox["d", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "-", "d"}], ",", 
       RowBox[{
        RowBox[{"-", "6"}], "+", 
        RowBox[{"7", " ", "d"}]}], ",", 
       RowBox[{"15", "-", 
        RowBox[{"21", " ", "d"}]}], ",", 
       RowBox[{"5", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", 
          RowBox[{"7", " ", "d"}]}], ")"}]}], ",", 
       RowBox[{"15", "-", 
        RowBox[{"35", " ", "d"}]}], ",", 
       RowBox[{
        RowBox[{"-", "6"}], "+", 
        RowBox[{"21", " ", "d"}]}], ",", 
       RowBox[{"1", "-", 
        RowBox[{"7", " ", "d"}]}], ",", "d"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "7", ",", 
       RowBox[{"-", "21"}], ",", "35", ",", 
       RowBox[{"-", "35"}], ",", "21", ",", 
       RowBox[{"-", "7"}], ",", "1"}], "}"}]}], "}"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SepticInterpolation", "[", 
    RowBox[{"1", ",", 
     RowBox[{
      RowBox[{"{", "kx_Integer", "}"}], "/;", 
      RowBox[{"0", "\[LessEqual]", "kx", "\[LessEqual]", "7"}]}]}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SepticInterpolation", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", "kx", "}"}]}], "]"}], "=", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Compile", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Block", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x0", " ", "=", " ", 
             RowBox[{"Floor", "[", "x", "]"}]}], ",", " ", "dx"}], "}"}], ",",
           "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dx", " ", "=", " ", 
            RowBox[{"x", " ", "-", " ", "x0"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"0.5", "<=", "x", "<=", 
              RowBox[{"nx", "+", "0.5"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"#1", "*", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Take", "[", 
                 RowBox[{"img", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"x0", "+", "1"}], ",", 
                    RowBox[{"x0", "+", "8"}]}], "}"}]}], "]"}], ".", "#2"}], 
               ")"}]}], ",", "\[IndentingNewLine]", "off"}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "]"}], "&"}], "[", 
     RowBox[{
      FractionBox[
       RowBox[{"7", "!"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"7", "-", "kx"}], ")"}], "!"}]], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"7", ",", "dx"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kx", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SepticInterpolation", "[", 
    RowBox[{"1", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"kx_Integer", "?", "NonNegative"}], "}"}], "/;", " ", 
      RowBox[{"kx", ">=", "8"}]}]}], "]"}], "=", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"0.5", "<=", "x", "<=", 
        RowBox[{"nx", "+", "0.5"}]}], ",", "\[IndentingNewLine]", "0.0", ",", 
       "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SepticInterpolation", "[", 
    RowBox[{"2", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"kx_Integer", ",", "ky_Integer"}], "}"}], "/;", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"0", "\[LessEqual]", "kx", "\[LessEqual]", "7"}], " ", 
        "\[And]", " ", 
        RowBox[{"0", "\[LessEqual]", "ky", "\[LessEqual]", "7"}]}], ")"}]}]}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SepticInterpolation", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"kx", ",", "ky"}], "}"}]}], "]"}], "=", "\[IndentingNewLine]", 
    
    RowBox[{
     RowBox[{
      RowBox[{"Compile", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"img", ",", "_Real", ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Block", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x0", " ", "=", " ", 
             RowBox[{"Floor", "[", "x", "]"}]}], ",", " ", "dx", " ", ",", 
            RowBox[{"y0", " ", "=", " ", 
             RowBox[{"Floor", "[", "y", "]"}]}], ",", " ", "dy"}], " ", "}"}],
           ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dx", " ", "=", " ", 
            RowBox[{"x", " ", "-", " ", "x0"}]}], ";", 
           RowBox[{"dy", " ", "=", " ", 
            RowBox[{"y", " ", "-", " ", "y0"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"0.5", "<=", "x", "<=", 
               RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
              RowBox[{"0.5", "<=", "y", "<=", 
               RowBox[{"ny", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"#1", "*", 
              RowBox[{"(", 
               RowBox[{"#3", ".", 
                RowBox[{"Take", "[", 
                 RowBox[{"img", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"y0", "+", "1"}], ",", 
                    RowBox[{"y0", "+", "8"}]}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"x0", "+", "1"}], ",", 
                    RowBox[{"x0", "+", "8"}]}], "}"}]}], "]"}], ".", "#2"}], 
               ")"}]}], ",", "\[IndentingNewLine]", "off"}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "]"}], "&"}], "[", 
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"7", "!"}], ")"}], "2"], 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"7", "-", "kx"}], ")"}], "!"}], " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"7", "-", "ky"}], ")"}], "!"}]}]], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"7", ",", "dx"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kx", "+", "1"}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"7", ",", "dy"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"ky", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SepticInterpolation", "[", 
    RowBox[{"2", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"ks__Integer", "?", "NonNegative"}], "}"}], "/;", " ", 
      RowBox[{
       RowBox[{"Max", "[", "ks", "]"}], ">=", "8"}]}]}], "]"}], "=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"0.5", "<=", "x", "<=", 
         RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
        RowBox[{"0.5", "<=", "y", "<=", 
         RowBox[{"ny", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", "0.0", 
       ",", "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SepticInterpolation", "[", 
    RowBox[{"3", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"kx_Integer", ",", "ky_Integer", ",", "kz_Integer"}], "}"}], "/;", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"0", "\[LessEqual]", "kx", "\[LessEqual]", "7"}], " ", 
        "\[And]", " ", 
        RowBox[{"0", "\[LessEqual]", "ky", "\[LessEqual]", "7"}], " ", 
        "\[And]", " ", 
        RowBox[{"0", "\[LessEqual]", "kz", "\[LessEqual]", "7"}]}], ")"}]}]}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SepticInterpolation", "[", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{"kx", ",", "ky", ",", "kz"}], "}"}]}], "]"}], "=", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Compile", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"img", ",", "_Real", ",", "3"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nz", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"z", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Block", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x0", " ", "=", " ", 
             RowBox[{"Floor", "[", "x", "]"}]}], ",", " ", "dx", " ", ",", 
            RowBox[{"y0", " ", "=", " ", 
             RowBox[{"Floor", "[", "y", "]"}]}], ",", " ", "dy", "  ", ",", 
            RowBox[{"z0", " ", "=", " ", 
             RowBox[{"Floor", "[", "z", "]"}]}], ",", " ", "dz"}], "}"}], ",",
           "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dx", " ", "=", " ", 
            RowBox[{"x", " ", "-", " ", "x0"}]}], ";", 
           RowBox[{"dy", " ", "=", " ", 
            RowBox[{"y", " ", "-", " ", "y0"}]}], ";", 
           RowBox[{"dz", " ", "=", " ", 
            RowBox[{"z", " ", "-", " ", "z0"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"0.5", "<=", "x", "<=", 
               RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
              RowBox[{"0.5", "<=", "y", "<=", 
               RowBox[{"ny", "+", "0.5"}]}], " ", "\[And]", " ", 
              RowBox[{"0.5", "<=", "z", "<=", 
               RowBox[{"nz", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"#1", "*", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Take", "[", 
                    RowBox[{"img", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"z0", "+", "1"}], ",", 
                    RowBox[{"z0", "+", "8"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"y0", "+", "1"}], ",", 
                    RowBox[{"y0", "+", "8"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"x0", "+", "1"}], ",", 
                    RowBox[{"x0", "+", "8"}]}], "}"}]}], "]"}], ".", "#2"}], 
                   ")"}], ".", "#3"}], ")"}], ".", "#4"}], ")"}]}], ",", 
             "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}]}],
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], "&"}],
      "[", 
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"7", "!"}], ")"}], "3"], 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"7", "-", "kx"}], ")"}], "!"}], " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"7", "-", "ky"}], ")"}], "!"}], " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"7", "-", "kz"}], ")"}], "!"}]}]], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"7", ",", "dx"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kx", "+", "1"}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"7", ",", "dy"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"ky", "+", "1"}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"7", ",", "dz"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kz", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SepticInterpolation", "[", 
    RowBox[{"3", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"ks__Integer", "?", "NonNegative"}], "}"}], "/;", " ", 
      RowBox[{
       RowBox[{"Max", "[", "ks", "]"}], "\[GreaterEqual]", "8"}]}]}], "]"}], 
   "=", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nz", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"0.5", "<=", "x", "<=", 
         RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
        RowBox[{"0.5", "<=", "y", "<=", 
         RowBox[{"ny", "+", "0.5"}]}], " ", "\[And]", " ", 
        RowBox[{"0.5", "<=", "z", "<=", 
         RowBox[{"nz", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", "0.0", 
       ",", "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InterpolatingImage", "[", 
    RowBox[{
    "_", ",", "_", ",", "off_", ",", "7", ",", "ds_List", ",", "1", ",", 
     RowBox[{"{", "xn_", "}"}], ",", "data_"}], "]"}], "[", 
   RowBox[{"x_", "?", "NumberQ"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"SepticInterpolation", "[", 
    RowBox[{"1", ",", "ds"}], "]"}], "[", 
   RowBox[{"data", ",", "off", ",", "xn", ",", "x"}], "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InterpolatingImage", "[", 
    RowBox[{
    "_", ",", "_", ",", "off_", ",", "7", ",", "ds_List", ",", "2", ",", 
     RowBox[{"{", 
      RowBox[{"xn_", ",", "yn_"}], "}"}], ",", "data_"}], "]"}], "[", 
   RowBox[{
    RowBox[{"x_", "?", "NumberQ"}], ",", 
    RowBox[{"y_", "?", "NumberQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"SepticInterpolation", "[", 
    RowBox[{"2", ",", "ds"}], "]"}], "[", 
   RowBox[{"data", ",", "off", ",", "xn", ",", "yn", ",", "x", ",", "y"}], 
   "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InterpolatingImage", "[", 
    RowBox[{
    "_", ",", "_", ",", "off_", ",", "7", ",", "ds_List", ",", "3", ",", 
     RowBox[{"{", 
      RowBox[{"xn_", ",", "yn_", ",", "zn_"}], "}"}], ",", "data_"}], "]"}], 
   "[", 
   RowBox[{
    RowBox[{"x_", "?", "NumberQ"}], ",", 
    RowBox[{"y_", "?", "NumberQ"}], ",", 
    RowBox[{"z_", "?", "NumberQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"SepticInterpolation", "[", 
    RowBox[{"3", ",", "ds"}], "]"}], "[", 
   RowBox[{
   "data", ",", "off", ",", "xn", ",", "yn", ",", "yn", ",", "x", ",", "y", 
    ",", "z"}], "]"}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Nonic", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BSplineFilter", "[", 
    RowBox[{"9", ",", "d_"}], "]"}], " ", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "-", "d"}], ")"}], "9"], ",", 
       RowBox[{"502", "+", 
        RowBox[{"3", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "738"}], "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"1416", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "1512"}], "+", 
                 RowBox[{"d", " ", 
                  RowBox[{"(", 
                   RowBox[{"924", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "252"}], "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "56"}], "+", 
                    RowBox[{"3", " ", "d", " ", 
                    RowBox[{"(", 
                    RowBox[{"24", "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "8"}], "+", "d"}], ")"}], " ", "d"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "7304"}], "+", 
          RowBox[{"3", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{"6069", "+", 
             RowBox[{"2", " ", "d", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "2856"}], "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{"938", "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"336", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "357"}], "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"56", "+", 
                    RowBox[{"3", " ", "d", " ", 
                    RowBox[{"(", 
                    RowBox[{"14", "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "7"}], "+", "d"}], ")"}], " ", "d"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
               ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"44117", "+", 
          RowBox[{"21", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "2427"}], "+", 
             RowBox[{"2", " ", "d", " ", 
              RowBox[{"(", 
               RowBox[{"66", "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{"434", "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "129"}], "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "69"}], "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"34", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"6", "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "6"}], "+", "d"}], ")"}], " ", "d"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
               ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"156190", "-", 
        RowBox[{"42", " ", 
         SuperscriptBox["d", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"2100", "+", 
           RowBox[{
            SuperscriptBox["d", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "570"}], "+", 
              RowBox[{
               SuperscriptBox["d", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"100", "+", 
                 RowBox[{"3", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "5"}], "+", "d"}], ")"}], " ", 
                  SuperscriptBox["d", "2"]}]}], ")"}]}]}], ")"}]}]}], 
          ")"}]}]}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"44117", "+", 
          RowBox[{"21", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{"2427", "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{"132", "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "868"}], "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "258"}], "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"138", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"68", "+", 
                    RowBox[{"3", " ", "d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "4"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "4"}], "+", "d"}], ")"}], " ", "d"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
               ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"14608", "-", 
        RowBox[{"42", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "867"}], "+", 
           RowBox[{"2", " ", "d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "408"}], "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "134"}], "+", 
                 RowBox[{"d", " ", 
                  RowBox[{"(", 
                   RowBox[{"48", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"51", "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "4"}], "+", "d"}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", "d", " ", 
                    RowBox[{"(", 
                    RowBox[{"2", "+", "d"}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
                ")"}]}]}], ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{"502", "+", 
        RowBox[{"6", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{"369", "+", 
           RowBox[{"2", " ", "d", " ", 
            RowBox[{"(", 
             RowBox[{"354", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{"378", "+", 
                 RowBox[{"d", " ", 
                  RowBox[{"(", 
                   RowBox[{"231", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"63", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "14"}], "+", 
                    RowBox[{"3", " ", "d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "6"}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "2"}], "+", "d"}], ")"}], " ", "d"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{"1", "+", 
        RowBox[{"3", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{"3", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"12", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{"28", "+", 
                 RowBox[{"d", " ", 
                  RowBox[{"(", 
                   RowBox[{"42", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"42", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"28", "+", 
                    RowBox[{"3", " ", "d", " ", 
                    RowBox[{"(", 
                    RowBox[{"4", "+", "d", "-", 
                    SuperscriptBox["d", "2"]}], ")"}]}]}], ")"}]}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
       ",", 
       SuperscriptBox["d", "9"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "d"}], ")"}], "8"]}], ",", 
       RowBox[{
        RowBox[{"-", "246"}], "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{"944", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1512"}], "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{"1232", "+", 
                 RowBox[{"d", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "420"}], "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "112"}], "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"168", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "64"}], "+", 
                    RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
       ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{"2023", "+", 
          RowBox[{"2", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1904"}], "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{"938", "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{"448", "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "595"}], "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"112", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"98", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "56"}], "+", 
                    RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
         ")"}]}], ",", 
       RowBox[{"14", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "809"}], "+", 
          RowBox[{"2", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{"44", "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{"434", "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "172"}], "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "115"}], "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"68", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"14", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "16"}], "+", 
                    RowBox[{"3", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
         ")"}]}], ",", 
       RowBox[{
        RowBox[{"-", "14"}], " ", "d", " ", 
        RowBox[{"(", 
         RowBox[{"1400", "-", 
          RowBox[{"760", " ", 
           SuperscriptBox["d", "2"]}], "+", 
          RowBox[{"200", " ", 
           SuperscriptBox["d", "4"]}], "-", 
          RowBox[{"40", " ", 
           SuperscriptBox["d", "6"]}], "+", 
          RowBox[{"9", " ", 
           SuperscriptBox["d", "7"]}]}], ")"}]}], ",", 
       RowBox[{"14", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "809"}], "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "897"}], "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "29"}], "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{"315", "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"85", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "51"}], "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "23"}], "+", 
                    RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       
       RowBox[{
        RowBox[{"-", "14"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "289"}], "+", 
          RowBox[{"2", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "272"}], "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "134"}], "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{"64", "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"85", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"16", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "14"}], "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "8"}], "+", 
                    RowBox[{"3", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
         ")"}]}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"123", "+", 
          RowBox[{"2", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{"236", "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{"378", "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{"308", "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"105", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "28"}], "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "42"}], "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "16"}], "+", 
                    RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
         ")"}]}], ",", 
       RowBox[{"1", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{"8", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"28", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{"56", "+", 
                 RowBox[{"d", " ", 
                  RowBox[{"(", 
                   RowBox[{"70", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"56", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"28", "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"8", "-", 
                    RowBox[{"9", " ", "d"}]}], ")"}], " ", "d"}]}], ")"}]}]}],
                     ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
       ",", 
       SuperscriptBox["d", "8"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "d"}], ")"}], "7"]}], ",", 
       RowBox[{"118", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "378"}], "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"462", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "210"}], "+", 
                 RowBox[{"d", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "70"}], "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"126", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "56"}], "+", 
                    RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
                   ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "476"}], "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{"469", "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{"336", "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "595"}], "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"140", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"147", "+", 
                    RowBox[{"2", " ", "d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "49"}], "+", 
                    RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       
       RowBox[{"14", " ", 
        RowBox[{"(", 
         RowBox[{"11", "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{"217", "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "129"}], "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "115"}], "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"85", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"21", "-", 
                    RowBox[{"28", " ", "d"}], "+", 
                    RowBox[{"6", " ", 
                    SuperscriptBox["d", "2"]}]}], ")"}]}]}], ")"}]}]}], 
                  ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"-", "14"}], " ", 
        RowBox[{"(", 
         RowBox[{"175", "-", 
          RowBox[{"285", " ", 
           SuperscriptBox["d", "2"]}], "+", 
          RowBox[{"125", " ", 
           SuperscriptBox["d", "4"]}], "-", 
          RowBox[{"35", " ", 
           SuperscriptBox["d", "6"]}], "+", 
          RowBox[{"9", " ", 
           SuperscriptBox["d", "7"]}]}], ")"}]}], ",", 
       RowBox[{"14", " ", 
        RowBox[{"(", 
         RowBox[{"11", "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "217"}], "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "129"}], "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{"115", "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"85", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "21"}], "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "28"}], "+", 
                    RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       
       RowBox[{
        RowBox[{"-", "14"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "68"}], "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "67"}], "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{"48", "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{"85", "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"20", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "21"}], "+", 
                    RowBox[{"2", " ", "d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "7"}], "+", 
                    RowBox[{"3", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"59", "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{"189", "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{"231", "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{"105", "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "35"}], "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "63"}], "+", 
                    RowBox[{"2", " ", "d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "14"}], "+", 
                    RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       
       RowBox[{"1", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{"7", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"21", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{"35", "+", 
                 RowBox[{"d", " ", 
                  RowBox[{"(", 
                   RowBox[{"35", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{"21", "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"7", "-", 
                    RowBox[{"9", " ", "d"}]}], ")"}], " ", "d"}]}], ")"}]}]}],
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ",", 
       SuperscriptBox["d", "7"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "d"}], ")"}], "6"]}], ",", 
       RowBox[{
        RowBox[{"-", "54"}], "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{"132", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "90"}], "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "40"}], "+", 
                 RowBox[{"3", " ", "d", " ", 
                  RowBox[{"(", 
                   RowBox[{"30", "+", 
                    RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "16"}], "+", 
                    RowBox[{"3", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
                ")"}]}]}], ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{"67", "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{"96", "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "255"}], "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{"80", "+", 
                   RowBox[{"3", " ", "d", " ", 
                    RowBox[{"(", 
                    RowBox[{"35", "-", 
                    RowBox[{"28", " ", "d"}], "+", 
                    RowBox[{"6", " ", 
                    SuperscriptBox["d", "2"]}]}], ")"}]}]}], ")"}]}]}], 
               ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"217", "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "258"}], "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "345"}], "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{"340", "+", 
                   RowBox[{"21", " ", "d", " ", 
                    RowBox[{"(", 
                    RowBox[{"5", "+", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "4"}], "+", "d"}], ")"}], " ", "d"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       
       RowBox[{"2", " ", "d", " ", 
        RowBox[{"(", 
         RowBox[{"570", "-", 
          RowBox[{"500", " ", 
           SuperscriptBox["d", "2"]}], "+", 
          RowBox[{"210", " ", 
           SuperscriptBox["d", "4"]}], "-", 
          RowBox[{"63", " ", 
           SuperscriptBox["d", "5"]}]}], ")"}]}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"217", "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{"475", "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{"130", "+", 
                RowBox[{"21", " ", "d", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "10"}], "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "5"}], "+", 
                    RowBox[{"3", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
               ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "67"}], "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{"96", "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{"255", "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{"80", "+", 
                   RowBox[{"21", " ", "d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "5"}], "+", 
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "2"}], "+", "d"}], ")"}], " ", "d"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"27", "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{"66", "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{"45", "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "20"}], "+", 
                   RowBox[{"3", " ", "d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "15"}], "-", 
                    RowBox[{"8", " ", "d"}], "+", 
                    RowBox[{"6", " ", 
                    SuperscriptBox["d", "2"]}]}], ")"}]}]}], ")"}]}]}], 
               ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"1", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{"6", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"15", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{"20", "+", 
                 RowBox[{"3", " ", "d", " ", 
                  RowBox[{"(", 
                   RowBox[{"5", "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", "-", 
                    RowBox[{"3", " ", "d"}]}], ")"}], " ", "d"}]}], ")"}]}]}],
                 ")"}]}]}], ")"}]}]}], ")"}]}]}], ",", 
       SuperscriptBox["d", "6"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "d"}], ")"}], "5"]}], ",", 
       RowBox[{"22", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "30"}], "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "20"}], "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{"60", "+", 
                 RowBox[{"d", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "40"}], "+", 
                    RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{"16", "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "85"}], "+", 
             RowBox[{"2", " ", "d", " ", 
              RowBox[{"(", 
               RowBox[{"20", "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{"35", "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "35"}], "+", 
                    RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
               ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "43"}], "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "115"}], "+", 
             RowBox[{"2", " ", "d", " ", 
              RowBox[{"(", 
               RowBox[{"85", "+", 
                RowBox[{"7", " ", "d", " ", 
                 RowBox[{"(", 
                  RowBox[{"5", "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"3", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
               ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "95"}], "+", 
          RowBox[{
           SuperscriptBox["d", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"250", "+", 
             RowBox[{"7", " ", 
              SuperscriptBox["d", "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "25"}], "+", 
                RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "43"}], "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{"115", "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{"170", "+", 
                RowBox[{"7", " ", "d", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "10"}], "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "20"}], "+", 
                    RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
               ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{"16", "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{"85", "+", 
             RowBox[{"2", " ", "d", " ", 
              RowBox[{"(", 
               RowBox[{"20", "+", 
                RowBox[{"7", " ", "d", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "5"}], "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "5"}], "+", 
                    RowBox[{"3", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
               ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"11", "+", 
          RowBox[{"d", " ", 
           RowBox[{"(", 
            RowBox[{"15", "+", 
             RowBox[{"2", " ", "d", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "5"}], "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "15"}], "+", 
                   RowBox[{"d", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "10"}], "+", 
                    RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}]}], 
               ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"1", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{"5", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"10", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{"10", "+", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"5", "-", 
                    RowBox[{"9", " ", "d"}]}], ")"}], " ", "d"}]}], ")"}]}]}],
              ")"}]}]}], ")"}]}]}], ",", 
       SuperscriptBox["d", "5"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "d"}], ")"}], "4"]}], ",", 
       RowBox[{
        RowBox[{"-", "6"}], "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "8"}], "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"36", "+", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "32"}], "+", 
                 RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
       ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "17"}], "+", 
          RowBox[{"2", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{"8", "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{"21", "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "28"}], "+", 
                   RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}],
          ")"}]}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "23"}], "+", 
          RowBox[{"2", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{"34", "+", 
             RowBox[{"7", " ", "d", " ", 
              RowBox[{"(", 
               RowBox[{"3", "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "8"}], "+", 
                   RowBox[{"3", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}],
          ")"}]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", "d", " ", 
        RowBox[{"(", 
         RowBox[{"100", "+", 
          RowBox[{"7", " ", 
           SuperscriptBox["d", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "20"}], "+", 
             RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "23"}], "+", 
          RowBox[{"7", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "13"}], "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "7"}], "+", 
                RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{"17", "+", 
          RowBox[{"2", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{"8", "+", 
             RowBox[{"7", " ", "d", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "3"}], "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "4"}], "+", 
                   RowBox[{"3", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}],
          ")"}]}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"3", "+", 
          RowBox[{"2", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "2"}], "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "9"}], "+", 
                RowBox[{"d", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "8"}], "+", 
                   RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ")"}]}]}],
          ")"}]}], ",", 
       RowBox[{"1", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{"4", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"6", "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", "-", 
                 RowBox[{"9", " ", "d"}]}], ")"}], " ", "d"}]}], ")"}]}]}], 
          ")"}]}]}], ",", 
       SuperscriptBox["d", "4"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "d"}], ")"}], "3"]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], "+", 
        RowBox[{"3", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{"6", "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "8"}], "+", 
              RowBox[{"3", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", 
          RowBox[{"3", " ", "d"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{"6", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", "d"}]}], ")"}]}], 
       ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"17", "+", 
          RowBox[{"21", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "2"}], "+", "d"}], ")"}], " ", "d"}]}], 
            ")"}]}]}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{"25", "+", 
          RowBox[{"21", " ", 
           SuperscriptBox["d", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "5"}], "+", 
             RowBox[{"3", " ", "d"}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"17", "+", 
          RowBox[{"21", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "4"}], "+", 
                RowBox[{"3", " ", "d"}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{"4", "+", 
          RowBox[{"21", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", "d"}]}], 
            ")"}]}]}], ")"}]}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"3", " ", "d"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{"6", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", "d"}]}], ")"}]}], 
       ",", 
       RowBox[{"1", "+", 
        RowBox[{"3", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", "d", "-", 
           RowBox[{"3", " ", 
            SuperscriptBox["d", "2"]}]}], ")"}]}]}], ",", 
       SuperscriptBox["d", "3"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "d"}], ")"}], "2"]}], ",", 
       RowBox[{"6", "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "16"}], "+", 
           RowBox[{"9", " ", "d"}]}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{"7", "+", 
          RowBox[{"2", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "14"}], "+", 
             RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"14", " ", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"8", " ", "d"}], "+", 
          RowBox[{"6", " ", 
           SuperscriptBox["d", "2"]}]}], ")"}]}], ",", 
       RowBox[{"14", " ", 
        RowBox[{"(", 
         RowBox[{"10", "-", 
          RowBox[{"9", " ", "d"}]}], ")"}], " ", "d"}], ",", 
       RowBox[{"14", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"9", " ", "d"}]}], ")"}]}], ",", 
       RowBox[{"14", "+", 
        RowBox[{"28", " ", 
         RowBox[{"(", 
          RowBox[{"2", "-", 
           RowBox[{"3", " ", "d"}]}], ")"}], " ", "d"}]}], ",", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "3"}], "+", 
          RowBox[{"2", " ", "d", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "4"}], "+", 
             RowBox[{"9", " ", "d"}]}], ")"}]}]}], ")"}]}], ",", 
       RowBox[{"1", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", "-", 
           RowBox[{"9", " ", "d"}]}], ")"}], " ", "d"}]}], ",", 
       SuperscriptBox["d", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "-", "d"}], ",", 
       RowBox[{
        RowBox[{"-", "8"}], "+", 
        RowBox[{"9", " ", "d"}]}], ",", 
       RowBox[{"28", "-", 
        RowBox[{"36", " ", "d"}]}], ",", 
       RowBox[{
        RowBox[{"-", "56"}], "+", 
        RowBox[{"84", " ", "d"}]}], ",", 
       RowBox[{"70", "-", 
        RowBox[{"126", " ", "d"}]}], ",", 
       RowBox[{"14", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4"}], "+", 
          RowBox[{"9", " ", "d"}]}], ")"}]}], ",", 
       RowBox[{"28", "-", 
        RowBox[{"84", " ", "d"}]}], ",", 
       RowBox[{
        RowBox[{"-", "8"}], "+", 
        RowBox[{"36", " ", "d"}]}], ",", 
       RowBox[{"1", "-", 
        RowBox[{"9", " ", "d"}]}], ",", "d"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "9", ",", 
       RowBox[{"-", "36"}], ",", "84", ",", 
       RowBox[{"-", "126"}], ",", "126", ",", 
       RowBox[{"-", "84"}], ",", "36", ",", 
       RowBox[{"-", "9"}], ",", "1"}], "}"}]}], "}"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NonicInterpolation", "[", 
    RowBox[{"1", ",", 
     RowBox[{
      RowBox[{"{", "kx_Integer", "}"}], "/;", 
      RowBox[{"0", "\[LessEqual]", "kx", "\[LessEqual]", "9"}]}]}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"NonicInterpolation", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", "kx", "}"}]}], "]"}], "=", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Compile", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Block", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x0", " ", "=", " ", 
             RowBox[{"Floor", "[", "x", "]"}]}], ",", " ", "dx"}], "}"}], ",",
           "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dx", " ", "=", " ", 
            RowBox[{"x", " ", "-", " ", "x0"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"0.5", "<=", "x", "<=", 
              RowBox[{"nx", "+", "0.5"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"#1", "*", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Take", "[", 
                 RowBox[{"img", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"x0", "+", "1"}], ",", 
                    RowBox[{"x0", "+", "10"}]}], "}"}]}], "]"}], ".", "#2"}], 
               ")"}]}], ",", "\[IndentingNewLine]", "off"}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "]"}], "&"}], "[", 
     RowBox[{
      FractionBox[
       RowBox[{"9", "!"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"9", "-", "kx"}], ")"}], "!"}]], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"9", ",", "dx"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kx", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NonicInterpolation", "[", 
    RowBox[{"1", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"kx_Integer", "?", "NonNegative"}], "}"}], "/;", " ", 
      RowBox[{"kx", ">=", "10"}]}]}], "]"}], "=", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"0.5", "<=", "x", "<=", 
        RowBox[{"nx", "+", "0.5"}]}], ",", "\[IndentingNewLine]", "0.0", ",", 
       "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NonicInterpolation", "[", 
    RowBox[{"2", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"kx_Integer", ",", "ky_Integer"}], "}"}], "/;", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"0", "\[LessEqual]", "kx", "\[LessEqual]", "9"}], " ", 
        "\[And]", " ", 
        RowBox[{"0", "\[LessEqual]", "ky", "\[LessEqual]", "9"}]}], ")"}]}]}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"NonicInterpolation", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"kx", ",", "ky"}], "}"}]}], "]"}], "=", "\[IndentingNewLine]", 
    
    RowBox[{
     RowBox[{
      RowBox[{"Compile", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"img", ",", "_Real", ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Block", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x0", " ", "=", " ", 
             RowBox[{"Floor", "[", "x", "]"}]}], ",", " ", "dx", " ", ",", 
            RowBox[{"y0", " ", "=", " ", 
             RowBox[{"Floor", "[", "y", "]"}]}], ",", " ", "dy"}], " ", "}"}],
           ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dx", " ", "=", " ", 
            RowBox[{"x", " ", "-", " ", "x0"}]}], ";", 
           RowBox[{"dy", " ", "=", " ", 
            RowBox[{"y", " ", "-", " ", "y0"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"0.5", "<=", "x", "<=", 
               RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
              RowBox[{"0.5", "<=", "y", "<=", 
               RowBox[{"ny", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"#1", "*", 
              RowBox[{"(", 
               RowBox[{"#3", ".", 
                RowBox[{"Take", "[", 
                 RowBox[{"img", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"y0", "+", "1"}], ",", 
                    RowBox[{"y0", "+", "10"}]}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"x0", "+", "1"}], ",", 
                    RowBox[{"x0", "+", "10"}]}], "}"}]}], "]"}], ".", "#2"}], 
               ")"}]}], ",", "\[IndentingNewLine]", "off"}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "]"}], "&"}], "[", 
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"9", "!"}], ")"}], "2"], 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"9", "-", "kx"}], ")"}], "!"}], " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"9", "-", "ky"}], ")"}], "!"}]}]], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"9", ",", "dx"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kx", "+", "1"}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"9", ",", "dy"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"ky", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NonicInterpolation", "[", 
    RowBox[{"2", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"ks__Integer", "?", "NonNegative"}], "}"}], "/;", " ", 
      RowBox[{
       RowBox[{"Max", "[", "ks", "]"}], ">=", "10"}]}]}], "]"}], "=", 
   "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"0.5", "<=", "x", "<=", 
         RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
        RowBox[{"0.5", "<=", "y", "<=", 
         RowBox[{"ny", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", "0.0", 
       ",", "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NonicInterpolation", "[", 
    RowBox[{"3", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"kx_Integer", ",", "ky_Integer", ",", "kz_Integer"}], "}"}], "/;", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"0", "\[LessEqual]", "kx", "\[LessEqual]", "9"}], " ", 
        "\[And]", " ", 
        RowBox[{"0", "\[LessEqual]", "ky", "\[LessEqual]", "9"}], " ", 
        "\[And]", " ", 
        RowBox[{"0", "\[LessEqual]", "kz", "\[LessEqual]", "9"}]}], ")"}]}]}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"NonicInterpolation", "[", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{"kx", ",", "ky", ",", "kz"}], "}"}]}], "]"}], "=", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Compile", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"img", ",", "_Real", ",", "3"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"nz", ",", " ", "_Integer"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", " ", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"z", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Block", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x0", " ", "=", " ", 
             RowBox[{"Floor", "[", "x", "]"}]}], ",", " ", "dx", " ", ",", 
            RowBox[{"y0", " ", "=", " ", 
             RowBox[{"Floor", "[", "y", "]"}]}], ",", " ", "dy", "  ", ",", 
            RowBox[{"z0", " ", "=", " ", 
             RowBox[{"Floor", "[", "z", "]"}]}], ",", " ", "dz"}], "}"}], ",",
           "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"dx", " ", "=", " ", 
            RowBox[{"x", " ", "-", " ", "x0"}]}], ";", 
           RowBox[{"dy", " ", "=", " ", 
            RowBox[{"y", " ", "-", " ", "y0"}]}], ";", 
           RowBox[{"dz", " ", "=", " ", 
            RowBox[{"z", " ", "-", " ", "z0"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"0.5", "<=", "x", "<=", 
               RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
              RowBox[{"0.5", "<=", "y", "<=", 
               RowBox[{"ny", "+", "0.5"}]}], " ", "\[And]", " ", 
              RowBox[{"0.5", "<=", "z", "<=", 
               RowBox[{"nz", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"#1", "*", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Take", "[", 
                    RowBox[{"img", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"z0", "+", "1"}], ",", 
                    RowBox[{"z0", "+", "10"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"y0", "+", "1"}], ",", 
                    RowBox[{"y0", "+", "10"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"x0", "+", "1"}], ",", 
                    RowBox[{"x0", "+", "10"}]}], "}"}]}], "]"}], ".", "#2"}], 
                   ")"}], ".", "#3"}], ")"}], ".", "#4"}], ")"}]}], ",", 
             "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}]}],
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], "&"}],
      "[", 
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"9", "!"}], ")"}], "3"], 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"9", "-", "kx"}], ")"}], "!"}], " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"9", "-", "ky"}], ")"}], "!"}], " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"9", "-", "kz"}], ")"}], "!"}]}]], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"9", ",", "dx"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kx", "+", "1"}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"9", ",", "dy"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"ky", "+", "1"}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"BSplineFilter", "[", 
        RowBox[{"9", ",", "dz"}], "]"}], "\[LeftDoubleBracket]", 
       RowBox[{"kz", "+", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NonicInterpolation", "[", 
    RowBox[{"3", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"ks__Integer", "?", "NonNegative"}], "}"}], "/;", " ", 
      RowBox[{
       RowBox[{"Max", "[", "ks", "]"}], "\[GreaterEqual]", "10"}]}]}], "]"}], 
   "=", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"off", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nx", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"ny", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nz", ",", " ", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", " ", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", " ", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"0.5", "<=", "x", "<=", 
         RowBox[{"nx", "+", "0.5"}]}], " ", "\[And]", " ", 
        RowBox[{"0.5", "<=", "y", "<=", 
         RowBox[{"ny", "+", "0.5"}]}], " ", "\[And]", " ", 
        RowBox[{"0.5", "<=", "z", "<=", 
         RowBox[{"nz", "+", "0.5"}]}]}], ",", "\[IndentingNewLine]", "0.0", 
       ",", "\[IndentingNewLine]", "off"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InterpolatingImage", "[", 
    RowBox[{
    "_", ",", "_", ",", "off_", ",", "9", ",", "ds_List", ",", "1", ",", 
     RowBox[{"{", "xn_", "}"}], ",", "data_"}], "]"}], "[", 
   RowBox[{"x_", "?", "NumberQ"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"NonicInterpolation", "[", 
    RowBox[{"1", ",", "ds"}], "]"}], "[", 
   RowBox[{"data", ",", "off", ",", "xn", ",", "x"}], "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InterpolatingImage", "[", 
    RowBox[{
    "_", ",", "_", ",", "off_", ",", "9", ",", "ds_List", ",", "2", ",", 
     RowBox[{"{", 
      RowBox[{"xn_", ",", "yn_"}], "}"}], ",", "data_"}], "]"}], "[", 
   RowBox[{
    RowBox[{"x_", "?", "NumberQ"}], ",", 
    RowBox[{"y_", "?", "NumberQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"NonicInterpolation", "[", 
    RowBox[{"2", ",", "ds"}], "]"}], "[", 
   RowBox[{"data", ",", "off", ",", "xn", ",", "yn", ",", "x", ",", "y"}], 
   "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InterpolatingImage", "[", 
    RowBox[{
    "_", ",", "_", ",", "off_", ",", "9", ",", "ds_List", ",", "3", ",", 
     RowBox[{"{", 
      RowBox[{"xn_", ",", "yn_", ",", "zn_"}], "}"}], ",", "data_"}], "]"}], 
   "[", 
   RowBox[{
    RowBox[{"x_", "?", "NumberQ"}], ",", 
    RowBox[{"y_", "?", "NumberQ"}], ",", 
    RowBox[{"z_", "?", "NumberQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"NonicInterpolation", "[", 
    RowBox[{"3", ",", "ds"}], "]"}], "[", 
   RowBox[{
   "data", ",", "off", ",", "xn", ",", "yn", ",", "yn", ",", "x", ",", "y", 
    ",", "z"}], "]"}]}]], "PackageInput"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ImageInterpolation", ",", "\[IndentingNewLine]", "InterpolatingImage", 
       ",", "\[IndentingNewLine]", "NBSplineInterpolationFilter1D", ",", 
       "\[IndentingNewLine]", "BSplineInterpolationFilter1D", ",", 
       "\[IndentingNewLine]", "BSplineInterpolationFilter"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Protected", ",", "ReadProtected"}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1226, 971},
WindowMargins->{{142, Automatic}, {Automatic, 0}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
PrivateNotebookOptions->{"NotebookAuthor"->""},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (August 23, \
2010)",
StyleDefinitions->"PackageNotebook.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 44, 0, 144, "Title"],
Cell[614, 24, 100, 4, 118, "Subsubtitle"],
Cell[CellGroupData[{
Cell[739, 32, 25, 0, 72, "Section"],
Cell[767, 34, 991, 25, 291, "PackageInput"],
Cell[1761, 61, 128, 3, 39, "Text"],
Cell[1892, 66, 3251, 94, 774, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[5180, 165, 32, 0, 72, "Section"],
Cell[5215, 167, 92, 2, 39, "Text"],
Cell[5310, 171, 663, 14, 268, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6010, 190, 42, 0, 40, "Section"],
Cell[6055, 192, 2656, 53, 573, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[8748, 250, 31, 0, 40, "Section"],
Cell[8782, 252, 60, 0, 39, "Text"],
Cell[8845, 254, 108, 2, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[8978, 260, 51, 0, 63, "Subsection"],
Cell[9032, 262, 176, 4, 36, "Input"],
Cell[CellGroupData[{
Cell[9233, 270, 30, 0, 57, "Subsubsection"],
Cell[9266, 272, 370, 11, 640, "PackageInput"],
Cell[9639, 285, 364, 11, 640, "PackageInput"],
Cell[10006, 298, 365, 11, 640, "PackageInput"],
Cell[10374, 311, 377, 11, 640, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[10788, 327, 30, 0, 34, "Subsubsection"],
Cell[10821, 329, 35, 0, 292, "Text"],
Cell[10859, 331, 132, 5, 324, "Input"],
Cell[10994, 338, 33, 0, 292, "Text"],
Cell[11030, 340, 288, 10, 486, "Input"],
Cell[11321, 352, 2432, 64, 2571, "PackageInput"],
Cell[13756, 418, 2520, 67, 2398, "PackageInput"],
Cell[16279, 487, 2295, 61, 2398, "PackageInput"],
Cell[18577, 550, 2221, 60, 2398, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[20835, 615, 32, 0, 34, "Subsubsection"],
Cell[20870, 617, 36, 0, 292, "Text"],
Cell[20909, 619, 896, 31, 1113, "Input"],
Cell[21808, 652, 33, 0, 292, "Text"],
Cell[21844, 654, 1047, 33, 546, "Input"],
Cell[22894, 689, 3930, 101, 3097, "PackageInput"],
Cell[26827, 792, 4249, 107, 3268, "PackageInput"],
Cell[31079, 901, 3753, 96, 2917, "PackageInput"],
Cell[34835, 999, 3553, 92, 2917, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[38425, 1096, 31, 0, 34, "Subsubsection"],
Cell[38459, 1098, 37, 0, 292, "Text"],
Cell[38499, 1100, 1617, 49, 810, "Input"],
Cell[40119, 1151, 33, 0, 292, "Text"],
Cell[40155, 1153, 3509, 101, 1278, "Input"],
Cell[43667, 1256, 5318, 134, 3795, "PackageInput"],
Cell[48988, 1392, 5815, 144, 4144, "PackageInput"],
Cell[54806, 1538, 5102, 129, 3618, "PackageInput"],
Cell[59911, 1669, 4818, 124, 3618, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[64766, 1798, 30, 0, 34, "Subsubsection"],
Cell[64799, 1800, 37, 0, 292, "Text"],
Cell[64839, 1802, 2749, 81, 1045, "Input"],
Cell[67591, 1885, 34, 0, 292, "Text"],
Cell[67628, 1887, 11670, 318, 3087, "Input"],
Cell[79301, 2207, 6673, 166, 4315, "PackageInput"],
Cell[85977, 2375, 7414, 182, 4842, "PackageInput"],
Cell[93394, 2559, 6428, 162, 4144, "PackageInput"],
Cell[99825, 2723, 6075, 155, 4144, "PackageInput"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[105949, 2884, 50, 0, 37, "Subsection"],
Cell[CellGroupData[{
Cell[106024, 2888, 31, 0, 190, "Subsubsection"],
Cell[106058, 2890, 407, 12, 285, "PackageInput"],
Cell[106468, 2904, 401, 12, 285, "PackageInput"],
Cell[106872, 2918, 402, 12, 285, "PackageInput"],
Cell[107277, 2932, 415, 12, 285, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[107729, 2949, 30, 0, 114, "Subsubsection"],
Cell[107762, 2951, 2193, 60, 2038, "PackageInput"],
Cell[109958, 3013, 2313, 64, 1864, "PackageInput"],
Cell[112274, 3079, 2025, 56, 1864, "PackageInput"],
Cell[114302, 3137, 1956, 55, 1864, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[116295, 3197, 32, 0, 114, "Subsubsection"],
Cell[116330, 3199, 3621, 98, 2565, "PackageInput"],
Cell[119954, 3299, 4044, 107, 2736, "PackageInput"],
Cell[124001, 3408, 3412, 91, 2389, "PackageInput"],
Cell[127416, 3501, 3252, 88, 2389, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[130705, 3594, 31, 0, 114, "Subsubsection"],
Cell[130739, 3596, 4968, 131, 1450, "PackageInput"],
Cell[135710, 3729, 5643, 147, 1606, "PackageInput"],
Cell[141356, 3878, 4694, 124, 1372, "PackageInput"],
Cell[146053, 4004, 4446, 119, 1372, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[150536, 4128, 30, 0, 114, "Subsubsection"],
Cell[150569, 4130, 6318, 164, 1683, "PackageInput"],
Cell[156890, 4296, 6904, 179, 1917, "PackageInput"],
Cell[163797, 4477, 5945, 156, 1606, "PackageInput"],
Cell[169745, 4635, 5609, 149, 1606, "PackageInput"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[175403, 4790, 48, 0, 37, "Subsection"],
Cell[175454, 4792, 2438, 64, 341, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[177929, 4861, 41, 0, 37, "Subsection"],
Cell[177973, 4863, 275, 8, 60, "PackageInput"],
Cell[178251, 4873, 179, 4, 60, "PackageInput"],
Cell[178433, 4879, 5262, 128, 691, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[183732, 5012, 40, 0, 37, "Subsection"],
Cell[183775, 5014, 1983, 46, 369, "PackageInput"],
Cell[185761, 5062, 1953, 47, 324, "PackageInput"],
Cell[CellGroupData[{
Cell[187739, 5113, 30, 0, 57, "Subsubsection"],
Cell[187772, 5115, 350, 13, 208, "PackageInput"],
Cell[188125, 5130, 2217, 57, 1221, "PackageInput"],
Cell[190345, 5189, 1040, 27, 832, "PackageInput"],
Cell[191388, 5218, 3340, 84, 814, "PackageInput"],
Cell[194731, 5304, 1357, 36, 555, "PackageInput"],
Cell[196091, 5342, 4498, 109, 868, "PackageInput"],
Cell[200592, 5453, 1614, 42, 609, "PackageInput"],
Cell[202209, 5497, 487, 11, 190, "PackageInput"],
Cell[202699, 5510, 598, 15, 190, "PackageInput"],
Cell[203300, 5527, 682, 18, 244, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[204019, 5550, 30, 0, 34, "Subsubsection"],
Cell[204052, 5552, 1637, 53, 100, "PackageInput"],
Cell[205692, 5607, 2469, 65, 392, "PackageInput"],
Cell[208164, 5674, 1057, 28, 247, "PackageInput"],
Cell[209224, 5704, 3752, 97, 398, "PackageInput"],
Cell[212979, 5803, 1370, 36, 247, "PackageInput"],
Cell[214352, 5841, 5215, 128, 463, "PackageInput"],
Cell[219570, 5971, 1627, 42, 271, "PackageInput"],
Cell[221200, 6015, 466, 11, 85, "PackageInput"],
Cell[221669, 6028, 577, 15, 85, "PackageInput"],
Cell[222249, 6045, 661, 18, 109, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[222947, 6068, 32, 0, 34, "Subsubsection"],
Cell[222982, 6070, 6915, 216, 279, "PackageInput"],
Cell[229900, 6288, 2473, 65, 391, "PackageInput"],
Cell[232376, 6355, 1059, 28, 247, "PackageInput"],
Cell[233438, 6385, 3756, 97, 398, "PackageInput"],
Cell[237197, 6484, 1372, 36, 247, "PackageInput"],
Cell[238572, 6522, 5002, 125, 486, "PackageInput"],
Cell[243577, 6649, 1629, 42, 271, "PackageInput"],
Cell[245209, 6693, 468, 11, 85, "PackageInput"],
Cell[245680, 6706, 579, 15, 85, "PackageInput"],
Cell[246262, 6723, 663, 18, 109, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[246962, 6746, 31, 0, 34, "Subsubsection"],
Cell[246996, 6748, 18233, 552, 4690, "PackageInput"],
Cell[265232, 7302, 2466, 65, 2976, "PackageInput"],
Cell[267701, 7369, 1041, 27, 1872, "PackageInput"],
Cell[268745, 7398, 3754, 97, 3019, "PackageInput"],
Cell[272502, 7497, 1358, 36, 1872, "PackageInput"],
Cell[273863, 7535, 5000, 125, 3511, "PackageInput"],
Cell[278866, 7662, 1628, 42, 2053, "PackageInput"],
Cell[280497, 7706, 467, 11, 640, "PackageInput"],
Cell[280967, 7719, 578, 15, 640, "PackageInput"],
Cell[281548, 7736, 662, 18, 823, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[282247, 7759, 30, 0, 34, "Subsubsection"],
Cell[282280, 7761, 46133, 1322, 10066, "PackageInput"],
Cell[328416, 9085, 2465, 65, 2976, "PackageInput"],
Cell[330884, 9152, 1041, 27, 1872, "PackageInput"],
Cell[331928, 9181, 3754, 97, 3019, "PackageInput"],
Cell[335685, 9280, 1358, 36, 1872, "PackageInput"],
Cell[337046, 9318, 5001, 125, 3511, "PackageInput"],
Cell[342050, 9445, 1628, 42, 2053, "PackageInput"],
Cell[343681, 9489, 466, 11, 640, "PackageInput"],
Cell[344150, 9502, 577, 15, 640, "PackageInput"],
Cell[344730, 9519, 661, 18, 823, "PackageInput"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[345452, 9544, 34, 0, 40, "Section"],
Cell[345489, 9546, 64, 0, 292, "Text"],
Cell[345556, 9548, 785, 18, 2382, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
