(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     33463,       1012]
NotebookOptionsPosition[     29464,        886]
NotebookOutlinePosition[     30064,        909]
CellTagsIndexPosition[     30021,        906]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Image Vector Calculus", "Title"],

Cell["\<\
Markus van Almsick
Technische Universiteit Eindhoven
\[Copyright]2009\
\>", "Subsubtitle"],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
     "TimeStamp", "[", "\"\<MathVisionTools`ImageVectorCalculus`\>\"", "]"}], 
     " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"2010", ",", "9", ",", "7", ",", "17", ",", "40", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput",
 CellChangeTimes->{{3.492862827236123*^9, 3.492862834396998*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`ImageVectorCalculus`"}]}], " ",
    "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Author", ":", " ", 
     RowBox[{"Markus", " ", "van", " ", "Almsick"}]}]}], "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"M", ".", "v", ".", 
       RowBox[{"Almsick", "@", "tue"}], ".", "nl"}]}]}]}], "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`ImageVectorCalculus`"}]}], 
   "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "1.0"}]}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "7.0"}]}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2009"}]}]}], ",", " ", 
    RowBox[{"Technische", " ", "Universiteit", " ", "Eindhoven"}]}], "*)"}], 
  "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "ImageVectorCalculus"}]}], " ", "*)"}], "\n", 
  "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "implements", " ", "vector", " ", 
      "calculus", " ", "operators", " ", "with", " ", "Image", " ", 
      "derivatives"}]}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", "Grad"}]}], ",", " ", "Curl", ",", " ", 
    "Div", ",", " ", "gauge", ",", " ", "invariant", ",", " ", 
    RowBox[{"B", "-", "spline"}]}], "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", 
     RowBox[{"Mathematica", " ", "7", " ", "or", " ", "higher"}]}]}], " ", 
   "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", "  ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"December", " ", "2009"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{
   "\"\<MathVisionTools`ImageVectorCalculus`\>\"", ",", 
    "\[IndentingNewLine]", "\"\<MathVisionTools`ImageDerivative`\>\"", ",", 
    "\[IndentingNewLine]", 
    "\"\<MathVisionTools`Common`MathVisionToolsCommon`\>\""}], "]"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{"Unprotect", "[", "\n", "  ", 
  RowBox[{
  "ImageGrad", ",", "\[IndentingNewLine]", "ImageCurl", ",", 
   "\[IndentingNewLine]", "ImageDiv", ",", "\[IndentingNewLine]", 
   "ImageLaplacian", ",", "\[IndentingNewLine]", "ImageStructureTensor", ",", 
   "\[IndentingNewLine]", "ImageHessian", ",", "\[IndentingNewLine]", 
   "ImageGaugeDerivative"}], "\n", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ImageGrad", "::", "usage"}], " ", "=", " ", 
   "\"\<\\!\\(\\*\\nStyleBox[\\\"ImageGrad\\\", \
\\\"MR\\\"]\\)[\\!\\(\\*\\nStyleBox[\\\"img\\\", \\\"IT\\\"]\\)] gives the \
gradient of the image array \\!\\(\\*\\nStyleBox[\\\"img\\\",\\nFontSlant->\\\
\"Italic\\\"]\\) in the Cartesian coordinate system obtained via \
\\!\\(\\*\\nStyleBox[\\\"ImageDerivatives\\\", \\\"MR\\\"]\\).\>\""}], 
  ";"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ImageCurl", "::", "usage"}], " ", "=", " ", 
   "\"\<\\!\\(\\*\\nStyleBox[\\\"ImageCurl\\\", \
\\\"MR\\\"]\\)[\\!\\(\\*\\nStyleBox[\\\"img\\\", \\\"IT\\\"]\\)] gives the \
curl of the vector-valued image array \
\\!\\(\\*\\nStyleBox[\\\"img\\\",\\nFontSlant->\\\"Italic\\\"]\\) in the \
Cartesian coordinate system obtained via \
\\!\\(\\*\\nStyleBox[\\\"ImageDerivatives\\\", \\\"MR\\\"]\\)\>\""}], 
  ";"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ImageDiv", "::", "usage"}], " ", "=", " ", 
   "\"\<\\!\\(\\*\\nStyleBox[\\\"ImageDiv\\\", \
\\\"MR\\\"]\\)[\\!\\(\\*\\nStyleBox[\\\"img\\\", \\\"IT\\\"]\\)] gives the \
divergence of the vector-valued image array \\!\\(\\*\\nStyleBox[\\\"img\\\",\
\\nFontSlant->\\\"Italic\\\"]\\) in the Cartesian coordinate system obtained \
via \\!\\(\\*\\nStyleBox[\\\"ImageDerivatives\\\", \\\"MR\\\"]\\).\>\""}], 
  ";"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ImageLaplacian", "::", "usage"}], " ", "=", " ", 
   "\"\<\\!\\(\\*\\nStyleBox[\\\"ImageLaplacian\\\", \\\"MR\\\"]\\)[\\!\\(\\*\
\\nStyleBox[\\\"img\\\", \\\"IT\\\"]\\)] gives the Laplacian of the scalar or \
vector-valued image array \
\\!\\(\\*\\nStyleBox[\\\"img\\\",\\nFontSlant->\\\"Italic\\\"]\\) in the \
Cartesian coordinate system obtained via \
\\!\\(\\*\\nStyleBox[\\\"ImageDerivatives\\\", \\\"MR\\\"]\\).\>\""}], 
  ";"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ImageStructureTensor", "::", "usage"}], " ", "=", " ", 
   "\"\<\\!\\(\\*\\nStyleBox[\\\"ImageStructureTensor\\\", \\\"MR\\\"]\\)[\\!\
\\(\\*\\nStyleBox[\\\"img\\\", \\\"IT\\\"]\\)] gives the structure tensor of \
the scalar- or tensor-valued image array \\!\\(\\*\\nStyleBox[\\\"img\\\", \\\
\"IT\\\"]\\) in the Cartesian coordinate system obtained via Image \
derivatives.\>\""}], ";"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ImageHessian", "::", "usage"}], " ", "=", " ", 
   "\"\<\\!\\(\\*\\nStyleBox[\\\"ImageHessian\\\", \
\\\"MR\\\"]\\)[\\!\\(\\*\\nStyleBox[\\\"img\\\", \\\"IT\\\"]\\)] renders the \
hessian matrix of Image derivatives.\>\""}], ";"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ImageGaugeDerivative", "::", "usage"}], " ", "=", " ", 
   "\"\<\\!\\(\\*\\nStyleBox[\\\"ImageGaugeDerivative\\\", \\\"MR\\\"]\\)[\\!\
\\(\\*\\nStyleBox[\\\"nv\\\", \\\"IT\\\"]\\), \
\\!\\(\\*\\nStyleBox[\\\"nw\\\", \\\"IT\\\"]\\)][\\!\\(\\*\\nStyleBox[\\\"img\
\\\", \\\"IT\\\"]\\)] renders the Image derivative of a 2-dimensional image \
or luminosity function \\!\\(\\*\\nStyleBox[\\\"img\\\", \\\"IT\\\"]\\) in \
the gauge coordinates \\!\\(\\*\\nStyleBox[\\\"v\\\", \\\"IT\\\"]\\) and \
\\!\\(\\*\\nStyleBox[\\\"w\\\", \\\"IT\\\"]\\)\\!\\(\\*\\nStyleBox[\\\".\\\", \
\\\"IT\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"  \\\", \
\\\"IT\\\"]\\)\\!\\(\\*\\nStyleBox[\\\"w\\\", \\\"IT\\\"]\\) is the gauge \
coordinate in the direction of the gradient and \
\\!\\(\\*\\nStyleBox[\\\"v\\\", \\\"IT\\\"]\\) is the gauge coordinate along \
the isophote tangent.  \\!\\(\\*\\nStyleBox[\\\"nv\\\", \\\"IT\\\"]\\) \
denotes the derivative order in \\!\\(\\*\\nStyleBox[\\\"v\\\", \
\\\"IT\\\"]\\) and \\!\\(\\*\\nStyleBox[\\\"nw\\\", \\\"IT\\\"]\\) the \
derivative order in \\!\\(\\*\\nStyleBox[\\\"w\\\", \\\"IT\\\"]\\).\>\""}], 
  ";"}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Image Grad", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImageGrad", "[", 
   RowBox[{"img_", "?", "ImageQ"}], "]"}], ":=", 
  RowBox[{"Image", "[", 
   RowBox[{
    RowBox[{"ImageGrad", "[", "2", "]"}], "[", 
    RowBox[{"ImageData", "[", 
     RowBox[{"img", ",", 
      RowBox[{"Interleaving", "\[Rule]", " ", "True"}]}], "]"}], "]"}], 
   "]"}]}]], "PackageInput",
 CellChangeTimes->{3.4928627679982862`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ImageGrad", "[", 
    RowBox[{"r_Integer", "?", "Positive"}], "]"}], "[", "img_", "]"}], " ", ":=",
   " ", 
  RowBox[{
   RowBox[{"Transpose", "[", 
    RowBox[{
     RowBox[{"Apply", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"ImageDerivative", "[", "##", "]"}], "[", "img", "]"}], 
        "&"}], ",", 
       RowBox[{"IdentityMatrix", "[", "r", "]"}], ",", 
       RowBox[{"{", "1", "}"}]}], "]"}], ",", 
     RowBox[{"RotateRight", "[", 
      RowBox[{"Range", "[", 
       RowBox[{"r", "+", "1"}], "]"}], "]"}]}], "]"}], "/;", " ", 
   RowBox[{"r", " ", "\[LessEqual]", " ", 
    RowBox[{"ArrayDepth", "[", "img", "]"}]}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImageGrad", "[", 
   RowBox[{"img_", "?", "ArrayQ"}], "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"ImageGrad", "[", 
    RowBox[{"ArrayDepth", "[", "img", "]"}], "]"}], "[", "img", 
   "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Image Curl", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImageCurl", "[", 
   RowBox[{"img_", "?", "ImageQ"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Image", "[", 
    RowBox[{"ImageCurl", "[", 
     RowBox[{"ImageData", "[", 
      RowBox[{"img", ",", 
       RowBox[{"Interleaving", "\[Rule]", " ", "True"}]}], "]"}], "]"}], 
    "]"}], "/;", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"ImageDimensions", "[", "img", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "2"}], "}"}]}], "]"}]}]}]], "PackageInput",
 CellChangeTimes->{{3.492862781671568*^9, 3.4928627839108543`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImageCurl", "[", "img_", "]"}], " ", ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ImageDerivative", "[", 
      RowBox[{"1", ",", "0"}], "]"}], "[", 
     RowBox[{"img", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "All", ",", "2"}], "\[RightDoubleBracket]"}], "]"}],
     "-", 
    RowBox[{
     RowBox[{"ImageDerivative", "[", 
      RowBox[{"0", ",", "1"}], "]"}], "[", 
     RowBox[{"img", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "All", ",", "1"}], "\[RightDoubleBracket]"}], 
     "]"}]}], "/;", " ", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"Dimensions", "[", "img", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "2"}], "}"}]}], "]"}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImageCurl", "[", "img_", "]"}], " ", ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Transpose", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"ImageDerivative", "[", 
          RowBox[{"0", ",", "1", ",", "0"}], "]"}], "[", 
         RowBox[{"img", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "All", ",", "3"}], "\[RightDoubleBracket]"}], 
         "]"}], "-", 
        RowBox[{
         RowBox[{"ImageDerivative", "[", 
          RowBox[{"0", ",", "0", ",", "1"}], "]"}], "[", 
         RowBox[{"img", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "All", ",", "2"}], "\[RightDoubleBracket]"}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"ImageDerivative", "[", 
          RowBox[{"0", ",", "0", ",", "1"}], "]"}], "[", 
         RowBox[{"img", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "All", ",", "1"}], "\[RightDoubleBracket]"}], 
         "]"}], "-", 
        RowBox[{
         RowBox[{"ImageDerivative", "[", 
          RowBox[{"1", ",", "0", ",", "0"}], "]"}], "[", 
         RowBox[{"img", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "All", ",", "3"}], "\[RightDoubleBracket]"}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"ImageDerivative", "[", 
          RowBox[{"1", ",", "0", ",", "0"}], "]"}], "[", 
         RowBox[{"img", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "All", ",", "2"}], "\[RightDoubleBracket]"}], 
         "]"}], "-", 
        RowBox[{
         RowBox[{"ImageDerivative", "[", 
          RowBox[{"0", ",", "1", ",", "0"}], "]"}], "[", 
         RowBox[{"img", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "All", ",", "1"}], "\[RightDoubleBracket]"}], 
         "]"}]}]}], "\[IndentingNewLine]", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}], "/;", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"Dimensions", "[", "img", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "_", ",", "3"}], "}"}]}], 
    "]"}]}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Image Div", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImageDiv", "[", "img_", "]"}], " ", ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Image", "[", 
    RowBox[{"ImageDiv", "[", 
     RowBox[{"ImageData", "[", 
      RowBox[{"img", ",", 
       RowBox[{"Interleaving", "\[Rule]", " ", "True"}]}], "]"}], "]"}], 
    "]"}], "/;", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"ImageDimensions", "[", "img", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "2"}], "}"}]}], "]"}]}]}]], "PackageInput",
 CellChangeTimes->{{3.492862789138187*^9, 3.492862791543981*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImageDiv", "[", "img_", "]"}], " ", ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ImageDerivative", "[", "1", "]"}], "[", 
    RowBox[{"img", "\[LeftDoubleBracket]", 
     RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], "/;", " ", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"Dimensions", "[", "img", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"_", ",", "1"}], "}"}]}], "]"}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImageDiv", "[", "img_", "]"}], " ", ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ImageDerivative", "[", 
      RowBox[{"1", ",", "0"}], "]"}], "[", 
     RowBox[{"img", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "All", ",", "1"}], "\[RightDoubleBracket]"}], "]"}],
     "+", 
    RowBox[{
     RowBox[{"ImageDerivative", "[", 
      RowBox[{"0", ",", "1"}], "]"}], "[", 
     RowBox[{"img", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "All", ",", "2"}], "\[RightDoubleBracket]"}], 
     "]"}]}], "/;", " ", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"Dimensions", "[", "img", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "2"}], "}"}]}], "]"}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImageDiv", "[", "img_", "]"}], " ", ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ImageDerivative", "[", 
      RowBox[{"1", ",", "0", ",", "0"}], "]"}], "[", 
     RowBox[{"img", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "All", ",", "All", ",", "1"}], 
      "\[RightDoubleBracket]"}], "]"}], "+", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ImageDerivative", "[", 
      RowBox[{"0", ",", "1", ",", "0"}], "]"}], "[", 
     RowBox[{"img", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "All", ",", "All", ",", "2"}], 
      "\[RightDoubleBracket]"}], "]"}], "+", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ImageDerivative", "[", 
      RowBox[{"0", ",", "0", ",", "1"}], "]"}], "[", 
     RowBox[{"img", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "All", ",", "All", ",", "3"}], 
      "\[RightDoubleBracket]"}], "]"}]}], "/;", " ", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"Dimensions", "[", "img", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "_", ",", "3"}], "}"}]}], 
    "]"}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImageDiv", "[", "img_", "]"}], " ", ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ImageDerivative", "[", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "]"}], "[", 
     RowBox[{"img", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "All", ",", "All", ",", "All", ",", "1"}], 
      "\[RightDoubleBracket]"}], "]"}], "+", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ImageDerivative", "[", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "]"}], "[", 
     RowBox[{"img", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "All", ",", "All", ",", "All", ",", "2"}], 
      "\[RightDoubleBracket]"}], "]"}], "+", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ImageDerivative", "[", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "]"}], "[", 
     RowBox[{"img", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "All", ",", "All", ",", "All", ",", "3"}], 
      "\[RightDoubleBracket]"}], "]"}], "+", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ImageDerivative", "[", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "]"}], "[", 
     RowBox[{"img", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "All", ",", "All", ",", "All", ",", "4"}], 
      "\[RightDoubleBracket]"}], "]"}]}], "/;", " ", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"Dimensions", "[", "img", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"_", ",", "_", ",", "_", ",", "_", ",", "4"}], "}"}]}], 
    "]"}]}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Image Laplacian", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImageLaplacian", "[", 
   RowBox[{"img_", "?", "ImageQ"}], "]"}], ":=", 
  RowBox[{"Image", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"ImageLaplacian", "[", "2", "]"}], "[", 
     RowBox[{"ImageData", "[", 
      RowBox[{"img", ",", 
       RowBox[{"Interleaving", "\[Rule]", " ", "True"}]}], "]"}], "]"}], ",", 
    
    RowBox[{"Sequence", "@@", 
     RowBox[{"Options", "[", "img", "]"}]}]}], "]"}]}]], "PackageInput",
 CellChangeTimes->{{3.4928627964163303`*^9, 3.492862798295031*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ImageLaplacian", "[", 
    RowBox[{"r_Integer", "?", "Positive"}], "]"}], "[", "img_", "]"}], " ", ":=",
   " ", 
  RowBox[{
   RowBox[{"Total", "[", 
    RowBox[{"Apply", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"ImageDerivative", "[", "##", "]"}], "[", "img", "]"}], "&"}],
       ",", 
      RowBox[{"2", " ", 
       RowBox[{"IdentityMatrix", "[", "r", "]"}]}], ",", 
      RowBox[{"{", "1", "}"}]}], "]"}], "]"}], "/;", " ", 
   RowBox[{"r", " ", "\[LessEqual]", " ", 
    RowBox[{"ArrayDepth", "[", "img", "]"}]}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImageLaplacian", "[", 
   RowBox[{"img_", "?", "ArrayQ"}], "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"ImageLaplacian", "[", 
    RowBox[{"ArrayDepth", "[", "img", "]"}], "]"}], "[", "img", 
   "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Image Structure Tensor", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImageStructureTensor", "[", 
   RowBox[{"img_", "?", "ImageQ"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"ImageStructureTensor", "[", "2", "]"}], "[", 
   RowBox[{"ImageData", "[", 
    RowBox[{"img", ",", 
     RowBox[{"Interleaving", "\[Rule]", " ", "True"}]}], "]"}], 
   "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ImageStructureTensor", "[", 
    RowBox[{"r_Integer", "?", "Positive"}], "]"}], "[", "img_", "]"}], " ", ":=",
   " ", 
  RowBox[{
   RowBox[{"MapThread", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Outer", "[", 
       RowBox[{"Times", ",", "#1", ",", "#2", ",", "1"}], "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"ImageGrad", "[", "r", "]"}], "[", "img", "]"}], ",", 
       RowBox[{
        RowBox[{"ImageGrad", "[", "r", "]"}], "[", "img", "]"}]}], "}"}], ",",
      "r"}], "]"}], "/;", " ", 
   RowBox[{"r", " ", "\[LessEqual]", " ", 
    RowBox[{"ArrayDepth", "[", "img", "]"}]}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImageStructureTensor", "[", 
   RowBox[{"img_", "?", "ArrayQ"}], "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"ImageStructureTensor", "[", 
    RowBox[{"ArrayDepth", "[", "img", "]"}], "]"}], "[", "img", 
   "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Image Hessian", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImageHessian", "[", 
   RowBox[{"img_", "?", "ImageQ"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"ImageHessian", "[", "2", "]"}], "[", 
   RowBox[{"ImageData", "[", 
    RowBox[{"img", ",", 
     RowBox[{"Interleaving", "\[Rule]", " ", "True"}]}], "]"}], 
   "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ImageHessian", "[", 
    RowBox[{"r_Integer", "?", "Positive"}], "]"}], "[", "img_", "]"}], " ", ":=",
   " ", 
  RowBox[{
   RowBox[{"Transpose", "[", 
    RowBox[{
     RowBox[{"Apply", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"ImageDerivative", "[", "##", "]"}], "[", "img", "]"}], 
        "&"}], ",", 
       RowBox[{"Outer", "[", 
        RowBox[{"Plus", ",", 
         RowBox[{"IdentityMatrix", "[", "r", "]"}], ",", 
         RowBox[{"IdentityMatrix", "[", "r", "]"}], ",", "1"}], "]"}], ",", 
       RowBox[{"{", "2", "}"}]}], "]"}], ",", 
     RowBox[{"RotateRight", "[", 
      RowBox[{
       RowBox[{"Range", "[", 
        RowBox[{"r", "+", "2"}], "]"}], ",", "2"}], "]"}]}], "]"}], "/;", " ", 
   RowBox[{"r", " ", "\[LessEqual]", " ", 
    RowBox[{"ArrayDepth", "[", "img", "]"}]}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImageHessian", "[", 
   RowBox[{"img_", "?", "ArrayQ"}], "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"ImageHessian", "[", 
    RowBox[{"ArrayDepth", "[", "img", "]"}], "]"}], "[", "img", 
   "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Image Gauge Derivative", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ImageGaugeDerivative", "[", 
    RowBox[{
     RowBox[{"Nv_Integer", "?", "NonNegative"}], ",", 
     RowBox[{"Nw_Integer", "?", "NonNegative"}]}], "]"}], "[", 
   RowBox[{"img_", "?", "ImageQ"}], "]"}], ":=", 
  RowBox[{"Image", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"ImageGaugeDerivative", "[", 
      RowBox[{"Nv", ",", "Nw"}], "]"}], "[", 
     RowBox[{"ImageData", "[", 
      RowBox[{"img", ",", 
       RowBox[{"Interleaving", "\[Rule]", " ", "True"}]}], "]"}], "]"}], ",", 
    
    RowBox[{"Sequence", "@@", 
     RowBox[{"Options", "[", "img", "]"}]}]}], "]"}]}]], "PackageInput",
 CellChangeTimes->{{3.492862802545363*^9, 3.4928628039214067`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ImageGaugeDerivative", "[", 
     RowBox[{"1", ",", "0"}], "]"}], "[", 
    RowBox[{"img_", "?", "ArrayQ"}], "]"}], ":=", " ", 
   RowBox[{"Array", "[", 
    RowBox[{
     RowBox[{"0.0", "&"}], ",", 
     RowBox[{"Dimensions", "[", "img", "]"}]}], "]"}]}], 
  ";"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ImageGaugeDerivative", "[", 
    RowBox[{
     RowBox[{"Nv_Integer", "?", "NonNegative"}], ",", 
     RowBox[{"Nw_Integer", "?", "NonNegative"}]}], "]"}], "[", 
   RowBox[{"img_", "?", "ArrayQ"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Lx", " ", "=", " ", 
       RowBox[{
        RowBox[{"ImageDerivative", "[", 
         RowBox[{"1", ",", "0"}], "]"}], "[", "img", "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Ly", " ", "=", " ", 
       RowBox[{
        RowBox[{"ImageDerivative", "[", 
         RowBox[{"0", ",", "1"}], "]"}], "[", "img", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Total", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"-", "1"}], ")"}], "nv"], " ", 
              RowBox[{"Binomial", "[", 
               RowBox[{"Nv", ",", "nv"}], "]"}], " ", 
              RowBox[{"Binomial", "[", 
               RowBox[{"Nw", ",", 
                RowBox[{"nv", "+", "q"}]}], "]"}]}], ")"}], " ", 
            SuperscriptBox["Lx", 
             RowBox[{
              RowBox[{"2", " ", "nv"}], "+", "q"}]], " ", 
            SuperscriptBox["Ly", 
             RowBox[{"Nv", "+", "Nw", "-", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", "nv"}], "+", "q"}], ")"}]}]]}], " ", ",", 
           " ", 
           RowBox[{"{", 
            RowBox[{"nv", ",", 
             RowBox[{"Max", "[", 
              RowBox[{
               RowBox[{"-", "q"}], ",", "0"}], "]"}], ",", 
             RowBox[{"Min", "[", 
              RowBox[{"Nv", ",", 
               RowBox[{"Nw", "-", "q"}]}], "]"}]}], "}"}]}], 
          "\[IndentingNewLine]", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"q", ",", 
           RowBox[{"-", "Nv"}], ",", "Nw"}], "}"}]}], "]"}], "*", 
       RowBox[{"Apply", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"ImageDerivative", "[", "##", "]"}], "[", "img", "]"}], 
          "&"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Nv", "+", "q"}], ",", 
             RowBox[{"Nw", "-", "q"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"q", ",", 
             RowBox[{"-", "Nv"}], ",", "Nw"}], "}"}]}], "]"}]}], "]"}]}], " ",
       "]"}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["Lx", "2"], " ", "+", 
        SuperscriptBox["Ly", "2"]}], ")"}], 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{"Nv", "+", "Nw"}], ")"}]}], "/", "2"}]]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ImageGrad", ",", "ImageCurl", ",", "ImageDiv", ",", "ImageLaplacian", 
       ",", "ImageStructureTensor", ",", "ImageHessian", ",", 
       "ImageGaugeDerivative"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Protected", ",", " ", "ReadProtected", ",", " ", "Locked"}], 
      "}"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1199, 697},
WindowMargins->{{119, Automatic}, {Automatic, 86}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
PrivateNotebookOptions->{"NotebookAuthor"->""},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (September 2, \
2010)",
StyleDefinitions->"PackageNotebook.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 38, 0, 144, "Title"],
Cell[608, 24, 100, 4, 118, "Subsubtitle"],
Cell[CellGroupData[{
Cell[733, 32, 25, 0, 72, "Section"],
Cell[761, 34, 128, 3, 39, "Text"],
Cell[892, 39, 1025, 26, 291, "PackageInput"],
Cell[1920, 67, 2676, 78, 751, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[4633, 150, 32, 0, 40, "Section"],
Cell[4668, 152, 92, 2, 39, "Text"],
Cell[4763, 156, 752, 16, 337, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5552, 177, 42, 0, 40, "Section"],
Cell[5597, 179, 489, 10, 771, "PackageInput",
 InitializationCell->True],
Cell[6089, 191, 500, 11, 771, "PackageInput",
 InitializationCell->True],
Cell[6592, 204, 503, 10, 771, "PackageInput",
 InitializationCell->True],
Cell[7098, 216, 526, 11, 771, "PackageInput",
 InitializationCell->True],
Cell[7627, 229, 480, 9, 771, "PackageInput",
 InitializationCell->True],
Cell[8110, 240, 322, 7, 540, "PackageInput",
 InitializationCell->True],
Cell[8435, 249, 1214, 20, 1702, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[9686, 274, 31, 0, 40, "Section"],
Cell[9720, 276, 60, 0, 39, "Text"],
Cell[9783, 278, 108, 2, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[9916, 284, 32, 0, 63, "Subsection"],
Cell[9951, 286, 390, 11, 62, "PackageInput"],
Cell[10344, 299, 751, 22, 108, "PackageInput",
 InitializationCell->True],
Cell[11098, 323, 274, 8, 62, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[11409, 336, 32, 0, 37, "Subsection"],
Cell[11444, 338, 583, 16, 86, "PackageInput"],
Cell[12030, 356, 817, 23, 109, "PackageInput",
 InitializationCell->True],
Cell[12850, 381, 2256, 56, 178, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[15143, 442, 31, 0, 37, "Subsection"],
Cell[15177, 444, 586, 16, 86, "PackageInput"],
Cell[15766, 462, 513, 14, 86, "PackageInput",
 InitializationCell->True],
Cell[16282, 478, 816, 23, 109, "PackageInput",
 InitializationCell->True],
Cell[17101, 503, 1178, 30, 132, "PackageInput",
 InitializationCell->True],
Cell[18282, 535, 1553, 36, 178, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[19872, 576, 37, 0, 37, "Subsection"],
Cell[19912, 578, 526, 14, 85, "PackageInput"],
Cell[20441, 594, 641, 19, 85, "PackageInput",
 InitializationCell->True],
Cell[21085, 615, 284, 8, 62, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[21406, 628, 44, 0, 37, "Subsection"],
Cell[21453, 630, 331, 9, 62, "PackageInput"],
Cell[21787, 641, 727, 21, 108, "PackageInput",
 InitializationCell->True],
Cell[22517, 664, 296, 8, 62, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[22850, 677, 35, 0, 37, "Subsection"],
Cell[22888, 679, 315, 9, 62, "PackageInput"],
Cell[23206, 690, 922, 26, 108, "PackageInput",
 InitializationCell->True],
Cell[24131, 718, 280, 8, 62, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[24448, 731, 44, 0, 37, "Subsection"],
Cell[24495, 733, 711, 19, 108, "PackageInput"],
Cell[25209, 754, 370, 12, 62, "PackageInput",
 InitializationCell->True],
Cell[25582, 768, 3018, 87, 311, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[28649, 861, 34, 0, 40, "Section"],
Cell[28686, 863, 64, 0, 195, "Text"],
Cell[28753, 865, 683, 17, 1237, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
