(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    119817,       3012]
NotebookOptionsPosition[     65237,       1771]
NotebookOutlinePosition[    112160,       2762]
CellTagsIndexPosition[    112117,       2759]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Math Vision Tools", "Title"],

Cell["Initialization File", "Subtitle"],

Cell["\<\
Markus van Almsick
Technische Universiteit Eindhoven
\[Copyright]2010\
\>", "Subsubtitle",
 CellChangeTimes->{{3.44441367678401*^9, 3.444413677158574*^9}, {
  3.4643703731271133`*^9, 3.464370377833894*^9}, {3.4740981481354103`*^9, 
  3.474098148691259*^9}}],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "[", "\"\<MathVisionTools`\>\"", "]"}], " ", "=", 
     " ", 
     RowBox[{"{", 
      RowBox[{"2010", ",", "11", ",", "14", ",", "16", ",", "06", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput",
 CellChangeTimes->{{3.430050744627511*^9, 3.430050752738933*^9}, {
  3.4347075806797743`*^9, 3.434707586091432*^9}, {3.435650342836323*^9, 
  3.435650348815613*^9}, {3.444413529797286*^9, 3.444413548612064*^9}, {
  3.469022978467215*^9, 3.469022980670743*^9}, {3.474098153507629*^9, 
  3.4740981604755373`*^9}, {3.488871968615712*^9, 3.488871977047049*^9}, {
  3.4987353281609907`*^9, 3.498735333315792*^9}}],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`Kernel`init"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Authors", ":", " ", 
      RowBox[{"BMIA", " ", "at", " ", "TU", " ", "Eindhoven"}]}]}], ",", " ", 
    
    RowBox[{
    "edited", " ", "by", " ", "Markus", " ", "van", " ", "Almsick"}]}], 
   StyleBox[" ",
    FontColor->RGBColor[1, 0, 1]], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"m", ".", "v", ".", 
       RowBox[{"almsick", "@", "tue"}], ".", "nl"}]}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "3.2"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "7.0"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2010"}]}]}], ",", " ", 
    RowBox[{"Technische", " ", "Universiteit", " ", "Eindhoven"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", 
     RowBox[{"Math", " ", "Vision", " ", "Tools"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{"Addon", " ", "initialization", " ", "file"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", "init"}]}], ",", " ", "path", ",", " ", 
    "stub", ",", " ", "MathVisionTools"}], " ", "*)"}], "\[IndentingNewLine]",
   "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"May", " ", "2003"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "2.4", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"March", " ", "2005"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "2.8", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"December", " ", "2005"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "2.9", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"May", " ", "2006"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "2.12", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"July", " ", "2007"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "2.15", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"September", " ", "2008"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "2.21", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"February", " ", "2009"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "3.0", "  ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"December", " ", "2009"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "3.1", "  ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"February", " ", "2010"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "3.2", "  ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"November", " ", "2010"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.43005075641763*^9, 3.430050757441984*^9}, {
  3.435650352930122*^9, 3.435650353165359*^9}, {3.444413554415523*^9, 
  3.444413572369918*^9}, {3.4690229868736897`*^9, 3.469023019346665*^9}, {
  3.474098163805482*^9, 3.474098187670776*^9}, {3.488871980647223*^9, 
  3.488871980859618*^9}, {3.498735340167931*^9, 3.498735353503488*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[
 RowBox[{"BeginPackage", "[", "\"\<MathVisionTools`\>\"", 
  "]"}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Version ID", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "$MathVisionToolsVersion", "=", "\"\<3.2 (November 14th, 2010)\>\""}], 
  ";"}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.430050735629315*^9, 3.430050737624548*^9}, {
   3.430461894571773*^9, 3.4304618984500628`*^9}, {3.4325293893367443`*^9, 
   3.432529404394258*^9}, {3.434707567892496*^9, 3.434707572282332*^9}, {
   3.4356503303792877`*^9, 3.4356503331180563`*^9}, {3.444413504979453*^9, 
   3.444413518271044*^9}, {3.4633932707237387`*^9, 3.4633932847950163`*^9}, {
   3.464024270323127*^9, 3.4640242735525312`*^9}, {3.464370357592559*^9, 
   3.4643703599198313`*^9}, {3.465821900583706*^9, 3.465821903588107*^9}, {
   3.469022955101913*^9, 3.469022967977027*^9}, {3.4740981966862*^9, 
   3.474098206599019*^9}, {3.476787192211563*^9, 3.4767871967083263`*^9}, 
   3.476798559873128*^9, {3.4888717508379507`*^9, 3.4888717571926126`*^9}, 
   3.488871956344907*^9, {3.498735366927692*^9, 3.4987353746553297`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Server Specification", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$RemoteOperation", "=", 
   RowBox[{"Not", "[", 
    RowBox[{"StringFreeQ", "[", 
     RowBox[{
      RowBox[{"First", "[", "$ParentLink", "]"}], ",", "\"\<@\>\""}], "]"}], 
    "]"}]}], ";"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"$ParallelOperation", "=", 
   RowBox[{"Not", "[", 
    RowBox[{"StringFreeQ", "[", 
     RowBox[{
      RowBox[{"First", "[", "$ParentLink", "]"}], ",", "\"\<ParentLink\>\""}],
      "]"}], "]"}]}], ";"}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell[CellGroupData[{

Cell["Copyright Notice", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InsertCopyrightNote", "[", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"nb", " ", "=", " ", 
       RowBox[{"InputNotebook", "[", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"delete", " ", "old", " ", "copyright", " ", "note"}], " ", 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "NotebookLocate", "[", "\"\<MathVisionToolsCopyrightNote\>\"", "]"}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"NotebookRead", "[", "nb", "]"}], "=!=", 
         RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SetOptions", "[", 
          RowBox[{
           RowBox[{"NotebookSelection", "[", "nb", "]"}], ",", 
           RowBox[{"Editable", "\[Rule]", "True"}], ",", 
           RowBox[{"Deletable", "\[Rule]", "True"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"NotebookDelete", "[", "nb", "]"}]}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"move", " ", "to", " ", "insertion", " ", "point"}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"NotebookFind", "[", 
       RowBox[{
       "nb", ",", "\"\<MathVisionTools`\>\"", ",", "Previous", ",", 
        "CellContents", ",", " ", 
        RowBox[{"AutoScroll", "\[Rule]", " ", "False"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"SelectionMove", "[", 
       RowBox[{"nb", ",", "All", ",", "Cell", ",", " ", 
        RowBox[{"AutoScroll", "\[Rule]", " ", "False"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"SetOptions", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"NotebookSelection", "[", "nb", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MathVisionToolsCopyRight", "\[Rule]", "\[IndentingNewLine]", 
          RowBox[{"PadRight", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", " ", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"StringJoin", "[", 
                RowBox[{
                 RowBox[{"ToString", "[", 
                  RowBox[{"Take", "[", 
                   RowBox[{
                    RowBox[{"Date", "[", "]"}], ",", "5"}], "]"}], "]"}], 
                 ",", "\"\<: version \>\"", ",", "$MathVisionToolsVersion", 
                 ",", "\"\< loaded by \>\"", ",", 
                 RowBox[{"ToString", "[", "$UserName", "]"}], ",", 
                 "\"\< on \>\"", ",", 
                 RowBox[{"ToString", "[", "$MachineID", "]"}], ",", 
                 "\"\<.\>\""}], "]"}], "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"MathVisionToolsCopyRight", "/.", 
                 RowBox[{"Options", "[", 
                  RowBox[{"NotebookSelection", "[", "nb", "]"}], "]"}]}], 
                ")"}], "/.", 
               RowBox[{"MathVisionToolsCopyRight", "->", " ", 
                RowBox[{"{", "}"}]}]}]}], "\[IndentingNewLine]", "]"}], ",", 
            "\[IndentingNewLine]", "6", ",", "\[IndentingNewLine]", "Null"}], 
           "\[IndentingNewLine]", "]"}]}], "/.", " ", 
         RowBox[{"Null", "\[Rule]", " ", 
          RowBox[{"Sequence", "[", "]"}]}]}]}], "\[IndentingNewLine]", "]"}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"SelectionMove", "[", 
       RowBox[{"nb", ",", "After", ",", "Cell", ",", 
        RowBox[{"AutoScroll", "\[Rule]", " ", "False"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"insert", " ", "copyright", " ", "note"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"NotebookWrite", "[", "\[IndentingNewLine]", 
       RowBox[{"nb", ",", "\[IndentingNewLine]", 
        RowBox[{"Cell", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"TextData", "[", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"ButtonBox", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"StyleBox", "[", 
                RowBox[{"\"\<MathVisionTools\>\"", ",", 
                 RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}]}], "]"}], 
               ",", 
               RowBox[{"ButtonData", "\[RuleDelayed]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                  "URL", "[", "\"\<http://www.mathvisiontools.net/\>\"", 
                   "]"}], ",", "None"}], "}"}]}], ",", 
               RowBox[{"ButtonStyle", "\[Rule]", "\"\<Hyperlink\>\""}]}], 
              "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
             "\"\<\\n\[Copyright]2008 Biomedical Image-Analysis, Technische \
Universiteit Eindhoven, the Netherlands\\nThis \>\"", ",", 
             RowBox[{"StyleBox", "[", 
              RowBox[{"\"\<Mathematica\>\"", ",", 
               RowBox[{"FontSlant", "\[Rule]", "\"\<Italic\>\""}]}], "]"}], 
             ",", 
             RowBox[{
             "\"\< add-on, version \>\"", "<>", "$MathVisionToolsVersion", 
              "<>", "\"\< is for \>\""}], ",", "\[IndentingNewLine]", 
             RowBox[{"StyleBox", "[", 
              RowBox[{"\"\<academic use only\>\"", ",", 
               RowBox[{"FontVariations", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"\"\<Underline\>\"", "\[Rule]", "True"}], "}"}]}]}], 
              "]"}], ",", "\[IndentingNewLine]", 
             "\"\<.\\nPlease, contact \>\"", ",", "\[IndentingNewLine]", 
             RowBox[{"ButtonBox", "[", "\[IndentingNewLine]", 
              RowBox[{"\"\<Dr. Markus van Almsick\>\"", ",", 
               RowBox[{"ButtonData", "\[RuleDelayed]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                  "URL", "[", "\"\<mailto:m.v.almsick@tue.nl\>\"", "]"}], ",",
                   "None"}], "}"}]}], ",", 
               RowBox[{"ButtonStyle", "\[Rule]", "\"\<Hyperlink\>\""}]}], 
              "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
             "\"\< or \>\"", ",", "\[IndentingNewLine]", 
             RowBox[{"ButtonBox", "[", "\[IndentingNewLine]", 
              RowBox[{"\"\<Prof. Bart ter Haar Romeny\>\"", ",", 
               RowBox[{"ButtonData", "\[RuleDelayed]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                  "URL", "[", "\"\<mailto:B.M.terhaarRomeny@tue.nl\>\"", 
                   "]"}], ",", "None"}], "}"}]}], ",", 
               RowBox[{"ButtonStyle", "\[Rule]", "\"\<Hyperlink\>\""}]}], 
              "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
             "\"\< for bug reports and commercial use.\>\""}], "}"}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
          "\"\<Text\>\"", ",", "\[IndentingNewLine]", 
          RowBox[{"Editable", "\[Rule]", "False"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Deletable", "\[Rule]", "True"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"CellFrame", "\[Rule]", "True"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ShowCellBracket", "\[Rule]", "False"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ShowSelection", "\[Rule]", "False"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"1", ",", "0.4", ",", "0.4"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
          "CellTags", "\[Rule]", "\"\<MathVisionToolsCopyrightNote\>\""}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{
  3.430245211432148*^9, {3.436254780296433*^9, 3.436254780835637*^9}}],

Cell[BoxData[
 RowBox[{"If", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Not", "[", "$ParallelOperation", "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"If", "[", "\[IndentingNewLine]", 
    RowBox[{"$RemoteOperation", ",", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", "\[IndentingNewLine]", 
      RowBox[{
      "\"\<MathVisionTools \[Copyright]2008 Biomedical Image-Analysis, \
Technische Universiteit Eindhoven, the Netherlands\\n\>\"", ",", 
       "\[IndentingNewLine]", "\"\<This Mathematica package, version \>\"", 
       ",", "$MathVisionToolsVersion", ",", 
       "\"\< is for academic use only.\\n\>\"", ",", "\[IndentingNewLine]", 
       "\"\<Please, contact Markus van Almsick, m.v.almsick@tue.nl, for bug \
reports and commercial use.\>\""}], "\[IndentingNewLine]", "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"InsertCopyrightNote", "[", "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], "\[IndentingNewLine]", "]"}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["File Path Management", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"AppendTo", "[", 
   RowBox[{"$Path", ",", 
    RowBox[{"ToFileName", "[", 
     RowBox[{"{", 
      RowBox[{
      "$UserAddOnsDirectory", ",", "\"\<Applications\>\"", ",", 
       "\"\<MathVisionTools\>\"", ",", "\"\<Data\>\""}], "}"}], "]"}]}], 
   "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"AppendTo", "[", 
   RowBox[{"$Path", ",", 
    RowBox[{"ToFileName", "[", 
     RowBox[{"{", 
      RowBox[{
      "$AddOnsDirectory", ",", "\"\<Applications\>\"", ",", 
       "\"\<MathVisionTools\>\"", ",", "\"\<Data\>\""}], "}"}], "]"}]}], 
   "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"AppendTo", "[", 
   RowBox[{"$Path", ",", 
    RowBox[{"ToFileName", "[", 
     RowBox[{"{", 
      RowBox[{
      "$InstallationDirectory", ",", "\"\<AddOns\>\"", ",", 
       "\"\<Applications\>\"", ",", "\"\<MathVisionTools\>\"", ",", 
       "\"\<Data\>\""}], "}"}], "]"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"$SystemID", "===", "\"\<Windows\>\""}], ",", 
    RowBox[{"AppendTo", "[", 
     RowBox[{"$Path", ",", 
      RowBox[{"ToFileName", "[", 
       RowBox[{"{", 
        RowBox[{
        "$TopDirectory", ",", "\"\<AddOns\>\"", ",", "\"\<Applications\>\"", 
         ",", "\"\<MathVisionTools\>\"", ",", "\"\<Data\>\""}], "}"}], 
       "]"}]}], "]"}]}], "]"}], ";"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell[BoxData[
 RowBox[{"EndPackage", "[", "]"}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Package Declarations", "Section"],

Cell[CellGroupData[{

Cell["Version Compatibility", "Subsection"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<MathVisionTools`VersionCompatibility`\>\"", 
  "]"}]], "PackageInput",
 CellChangeTimes->{{3.445084623892212*^9, 3.445084626527896*^9}, {
  3.4450846704297657`*^9, 3.445084672736907*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["MathVisionToolsCommon", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`Common`MathVisionToolsCommon`"}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`Common`MathVisionToolsCommon`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<ImageBoundary\>\"", ",", "\"\<Cyclic\>\"", ",", 
      "\"\<Reflective\>\"", ",", "\"\<Truncate\>\""}], "}"}]}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["ActiveContours", "Subsection",
 CellChangeTimes->{{3.435650272949758*^9, 3.435650275218678*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`ActiveContours`"}], "*)"}], "\[IndentingNewLine]", "\n", 
  
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`ActiveContour`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<ActiveContour\>\"", ",", "\"\<ActiveContourStep\>\"", ",", 
      "\"\<ActiveContourPlot\>\"", ",", "\"\<CubicLoop\>\"", ",", 
      "\"\<SplineLength\>\"", ",", "\"\<ApproximationOrder\>\""}], "}"}]}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.435650282084908*^9, 3.435650315077667*^9}, 
   3.435761945809819*^9, {3.4359953506277733`*^9, 3.435995357901557*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ImageFrame", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`ImageFrame`"}], "*)"}], "\[IndentingNewLine]", "\n", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`ImageFrame`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<RemoveImageFrame\>\"", ",", "\"\<ImageFrame\>\"", ",", 
      "\"\<ImageFrame1D\>\""}], "}"}]}], "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Convolve", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`Convolve`"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"Not", "[", 
     RowBox[{"$VersionNumber", ">=", "7"}], "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{"DeclarePackage", "[", 
     RowBox[{"\"\<MathVisionTools`Convolve`\>\"", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<Convolve\>\"", ",", "\"\<Convolute\>\""}], "}"}]}], 
     "]"}]}], "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.469178919571239*^9, 3.4691789201583853`*^9}, {
  3.469178964123931*^9, 3.469178977287077*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ImageDerivative", "Subsection",
 CellChangeTimes->{{3.469120757537408*^9, 3.4691207580129223`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`ImageDerivative`"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{
   "\"\<MathVisionTools`ImageDerivative`\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\"\<ImageDerivative\>\"", "}"}]}], "]"}]}]], "PackageInput",\

 InitializationCell->True,
 CellChangeTimes->{{3.4691207632882547`*^9, 3.469120776267448*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ImageVectorCalculus", "Subsection",
 CellChangeTimes->{{3.469188061096394*^9, 3.469188062444642*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`ImageVectorCalculus`"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{
   "\"\<MathVisionTools`ImageVectorCalculus`\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<ImageGrad\>\"", ",", "\"\<ImageCurl\>\"", ",", "\"\<ImageDiv\>\"", 
      ",", "\"\<ImageLaplacian\>\"", ",", "\"\<ImageStructureTensor\>\"", 
      ",", "\"\<ImageHessian\>\"", ",", "\"\<ImageGaugeDerivative\>\""}], 
     "}"}]}], "]"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.469188066092412*^9, 3.469188093743244*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["GaussianDerivative", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`GaussianDerivative`"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{
   "\"\<MathVisionTools`GaussianDerivative`\>\"", ",", "\[IndentingNewLine]", 
    
    RowBox[{"{", 
     RowBox[{
     "\"\<DefaultScaleParameter\>\"", ",", "\"\<G\>\"", ",", 
      "\"\<SigmaToScaleT\>\"", ",", "\[IndentingNewLine]", 
      "\"\<ScaleTToSigma\>\"", ",", "\"\<NGaussianKernel\>\"", ",", 
      "\"\<GaussianKernel\>\"", ",", "\"\<AngularGaussianKernel\>\"", ",", 
      "\"\<NGaussianDKernel\>\"", ",", "\"\<GaussianDKernel\>\"", ",", 
      "\"\<GaussianD\>\"", ",", "\"\<GaussianBlur\>\"", ",", 
      "\"\<GaussianDerivative\>\"", ",", "\"\<GaussianDerivativeJet\>\"", 
      ",", "\"\<GaussianDerivativeAt\>\"", ",", "\"\<LocalMinimumMask\>\"", 
      ",", "\"\<LocalMaximumMask\>\"", ",", "\"\<ThresholdFilter\>\"", ",", 
      "\"\<KernelRange\>\""}], "}"}]}], "]"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.4741065426255083`*^9, 3.474106551832054*^9}, {
  3.498735302819682*^9, 3.498735303583251*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["GaussianVectorCalculus", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`GaussianVectorCalculus`"}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{
   "\"\<MathVisionTools`GaussianVectorCalculus`\>\"", ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<GaussianGrad\>\"", ",", "\"\<GaussianCurl\>\"", ",", 
      "\"\<GaussianDiv\>\"", ",", "\"\<GaussianLaplacian\>\"", ",", 
      "\"\<GaussianStructureTensor\>\"", ",", "\"\<GaussianHessian\>\"", ",", 
      "\"\<GaussianGaugeDerivative\>\""}], "}"}]}], "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Histogram", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`Histogram`"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"If", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$VersionNumber", "<", "8"}], ",", "\[IndentingNewLine]", 
    RowBox[{"DeclarePackage", "[", 
     RowBox[{"\"\<MathVisionTools`Histogram7`\>\"", ",", 
      RowBox[{"{", 
       RowBox[{
       "\"\<HistogramList\>\"", ",", "\"\<HistogramListEntropy\>\"", ",", 
        "\"\<HistogramListRange\>\"", ",", "\"\<HistogramListBinRange\>\"", 
        ",", "\"\<HistogramListRangeSpecified\>\"", ",", 
        "\"\<HistogramListNormalized\>\"", ",", 
        "\"\<HistogramListBinFunction\>\""}], "}"}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"DeclarePackage", "[", 
     RowBox[{"\"\<MathVisionTools`Histogram`\>\"", ",", 
      RowBox[{"{", 
       RowBox[{
       "\"\<mvtHistogramList\>\"", ",", "\"\<HistogramListEntropy\>\"", ",", 
        "\"\<HistogramListRange\>\"", ",", "\"\<HistogramListBinRange\>\"", 
        ",", "\"\<HistogramListRangeSpecified\>\"", ",", 
        "\"\<HistogramListNormalized\>\"", ",", 
        "\"\<HistogramListBinFunction\>\""}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{
  3.488887772309883*^9, {3.498736676559691*^9, 3.498736686756044*^9}, {
   3.498737033526717*^9, 3.498737046576077*^9}, {3.498737220114036*^9, 
   3.4987372205528593`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["OrientationBundle", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`OrientationBundle`"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`OrientationBundle`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<OrientationTransform\>\"", ",", 
      "\"\<OrientationBundleTransform\>\"", ",", 
      "\"\<InverseOrientationBundleTransform\>\"", ",", 
      "\"\<DirectionalFourierFilter\>\"", ",", 
      "\"\<FourierOrientationBundleTransform\>\"", ",", 
      "\"\<InverseFourierOrientationBundleTransform\>\""}], "}"}]}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.464370339359659*^9, 3.464370340451922*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["HankelTransform", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`HankelTransform`"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`HankelTransform`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<HankelTransform\>\"", ",", "\"\<InverseHankelTransform\>\"", ",", 
      "\"\<HalfGaussHankelCoefficient\>\"", ",", 
      "\"\<GaussHankelCoefficient\>\"", ",", "\"\<HankelBasis\>\"", ",", 
      "\"\<NHankelBasis\>\"", ",", "\"\<HankelBasisEigenvalue\>\"", ",", 
      "\"\<HankelBasisNList\>\"", ",", "\"\<NHankelBasisNList\>\"", ",", 
      "\"\<HankelBasisRadius\>\"", ",", "\"\<HankelBasisNMList\>\"", ",", 
      "\"\<NHankelBasisNMList\>\"", ",", "\"\<HankelBasis\>\"", ",", 
      "\"\<PolarFourierScale\>\"", ",", "\"\<PolarFourierNMax\>\"", ",", 
      "\"\<PolarFourier\>\"", ",", "\"\<InversePolarFourier\>\"", ",", 
      "\"\<RotatePolarFourierPhase\>\"", ",", "\"\<CenteredFourier\>\"", ",", 
      "\"\<InverseCenteredFourier\>\""}], "}"}]}], "]"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.4633932587865868`*^9, 3.463393260957941*^9}, {
  3.464083221638298*^9, 3.464083222852578*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["GeometryDrivenDiffusion", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`GeometryDrivenDiffusion`"}], "*)"}], 
  "\[IndentingNewLine]", "\n", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`GeometryDrivenDiffusion`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<GeometryDrivenDiffusion\>\"", ",", "\"\<DiffusionEquation\>\"", 
      ",", "\"\<EuclideanShorten\>\"", ",", "\"\<PeronaMalik1\>\"", ",", 
      "\"\<PeronaMalik2\>\"", ",", "\"\<ForwardEuler\>\"", ",", 
      "\"\<RungeKutta\>\""}], "}"}]}], "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["BilateralFilter", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`BilateralFilter`"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"If", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$VersionNumber", "<", "8"}], ",", "\[IndentingNewLine]", 
    RowBox[{"DeclarePackage", "[", 
     RowBox[{"\"\<MathVisionTools`BilateralFilter7`\>\"", ",", 
      RowBox[{"{", 
       RowBox[{
       "\"\<BilateralFilter\>\"", ",", "\"\<BilateralColorFilter\>\""}], 
       "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{"DeclarePackage", "[", 
     RowBox[{"\"\<MathVisionTools`BilateralFilter7`\>\"", ",", 
      RowBox[{"{", 
       RowBox[{
       "\"\<BilateralGrayscaleFilter\>\"", ",", 
        "\"\<BilateralColorFilter\>\""}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.498737211397779*^9, 3.498737225040015*^9}, {
  3.498737398474031*^9, 3.498737403007833*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["RegionGrowing", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`RegionGrowing`"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`RegionGrowing`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<RegionGrowing\>\"", ",", "\"\<AdjacencyNumbers\>\""}], 
     "}"}]}], "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["ImageInterpolation", "Subsection",
 CellChangeTimes->{{3.430461818141774*^9, 3.430461819794512*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`ImageTransformation`"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`ImageInterpolation`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<ImageInterpolation\>\"", ",", "\[IndentingNewLine]", 
      "\"\<InterpolatingImage\>\"", ",", 
      "\"\<NBSplineInterpolationFilter1D\>\"", ",", 
      "\"\<BSplineInterpolationFilter\>\"", ",", 
      "\"\<BSplineInterpolationFilter1D\>\""}], "}"}]}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.430461855022225*^9, 3.430461878654828*^9}, {
  3.469022921118091*^9, 3.469022943827112*^9}, {3.469034018689884*^9, 
  3.469034022893305*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ImageTransformation", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`ImageTransformation`"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`ImageTransformation`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<NConstantImageInterpolation\>\"", ",", 
      "\"\<NConstantImageInterpolation3D\>\"", ",", 
      "\"\<NConstant2DImageInterpolation3D\>\"", ",", 
      "\"\<NLinearImageInterpolation\>\"", ",", 
      "\"\<NLinearImageInterpolation3D\>\"", ",", 
      "\"\<NLinear2DImageInterpolation3D\>\"", ",", 
      "\"\<NCubicBSplineImageInterpolation\>\"", ",", 
      "\"\<NCubicBSplineImageInterpolation3D\>\"", ",", 
      "\"\<NCubicBSpline2DImageInterpolation3D\>\"", ",", 
      "\"\<CubicBSplineImageInterpolationFilter\>\"", ",", 
      "\"\<TranslateArray\>\"", ",", "\"\<RotateArray\>\"", ",", 
      "\"\<ScaleArray\>\"", ",", "\"\<NLinearAffineTransform\>\"", ",", 
      "\"\<NLinearAffineTransform3D\>\"", ",", 
      "\"\<NLinearAffine2DTransform3D\>\"", ",", 
      "\"\<NConstantAffineTransform\>\"", ",", 
      "\"\<NConstantAffineTransform3D\>\"", ",", 
      "\"\<NConstantAffine2DTransform3D\>\"", ",", 
      "\"\<NCubicBSplineAffineTransform\>\"", ",", 
      "\"\<NCubicBSplineAffineTransform3D\>\"", ",", 
      "\"\<NCubicBSplineAffine2DTransform3D\>\"", ",", 
      "\"\<PerspectiveTransformArray\>\"", ",", "\"\<ArrayInterpolation\>\"", 
      ",", "\[IndentingNewLine]", "\"\<ConstantInterpolation\>\"", ",", " ", 
      "\"\<LinearInterpolation\>\"", ",", 
      "\"\<CubicBSplineInterpolation\>\""}], "}"}]}], "]"}]}]], "PackageInput",\

 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Radial Basis Interpolation", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`RadialBasisInterpolation`"}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`RadialBasisInterpolation`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<ThinPlateSplineNorm\>\"", ",", "\"\<GaussianNorm\>\"", ",", 
      "\"\<RadialBasisInterpolation\>\"", ",", "\[IndentingNewLine]", 
      "\"\<RadialBasisNorm\>\"", ",", "\"\<Smoothness\>\""}], "}"}]}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Logic-Linear Operators", "Subsection",
 CellChangeTimes->{3.464024196215012*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`RadialBasisInterpolation`"}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`LogicLinearOperators`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<LinearAnd\>\"", ",", "\"\<LinearOr\>\"", ",", "\"\<LinearTrue\>\"", 
      ",", "\"\<LinearSigma\>\"", ",", "\"\<LinearTrue\>\""}], "}"}]}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.464024207774778*^9, 3.464024227856586*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["VolumeRendering", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`VolumeRendering`"}], "*)"}], "\[IndentingNewLine]", "\n", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`VolumeRendering`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<IntensityProjection\>\"", ",", 
      "\"\<MaximumIntensityProjection\>\""}], "}"}]}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["VolumeRenderer", "Subsection",
 CellChangeTimes->{{3.434707514713297*^9, 3.434707514757369*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`VolumeRenderer`"}], "*)"}], "\[IndentingNewLine]", "\n", 
  
  RowBox[{"(*", " ", 
   RowBox[{"DeclarePackage", "[", 
    RowBox[{
    "\"\<MathVisionTools`VolumeRenderer`\>\"", ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<ListDensityPlot3D\>\"", ",", "\"\<TransferFunction\>\"", ",", " ", 
       "\"\<CUDADevices\>\""}], "}"}]}], "]"}], " ", "*)"}]}]], "PackageInput",\

 InitializationCell->True,
 CellChangeTimes->{{3.4347075187897577`*^9, 3.4347075587915373`*^9}, {
  3.498733209928832*^9, 3.4987332129684277`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Spherical Tesselation", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`SphericalTesselation`"}], "*)"}], "\[IndentingNewLine]", 
  "\n", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{
   "\"\<MathVisionTools`SphericalTesselation`\>\"", ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<IcosahedralComplex\>\"", ",", "\"\<OctahedralComplex\>\"", ",", 
      "\"\<TetrahedralComplex\>\"", ",", "\"\<DualTesselate\>\"", ",", 
      "\"\<DualComplex\>\"", ",", "\"\<VertexAreas\>\"", ",", 
      "\"\<TriangularTesselate\>\"", ",", 
      "\"\<BalancedTriangularTesselate\>\"", ",", "\"\<Triangulate\>\"", ",", 
      "\"\<SphericalAngels\>\""}], "}"}]}], "]"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.4347075187897577`*^9, 3.4347075587915373`*^9}, {
   3.476787140187622*^9, 3.476787148485608*^9}, 3.4767871821624928`*^9, {
   3.476789781178193*^9, 3.47678978233244*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["GConvolution", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`GConvolution`"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`GConvolution`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<GConjugateKernel\>\"", ",", "\"\<GListConvolve\>\"", ",", 
      "\"\<GListCorrelate\>\""}], "}"}]}], "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["CompletionField", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`CompletionField`"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`CompletionField`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<CompletionKernelAlongX\>\"", ",", "\"\<NCompletionKernelAlongX\>\"",
       ",", "\"\<NCompletionKernelxyMarginalAlongX\>\"", ",", 
      "\"\<CompletionKernel\>\"", ",", "\"\<NCompletionKernel\>\"", ",", 
      "\"\<NCompletionKernelxyMarginal\>\"", ",", 
      "\"\<PolarCompletionKernel\>\"", ",", "\"\<NPolarCompletionKernel\>\"", 
      ",", "\"\<NPolarCompletionKernelr\[Theta]Marginal\>\"", ",", 
      "\"\<PolarCompletionKernelM\>\"", ",", 
      "\"\<NPolarCompletionKernelM\>\"", ",", 
      "\"\<NPolarCompletionKernelMr\[Theta]Marginal\>\"", ",", 
      "\"\<CompletionField\>\"", ",", "\"\<CompletionMode\>\"", ",", 
      "\"\<CompletionModeAlongX\>\"", ",", "\"\<CompletionSpline\>\"", ",", 
      "\"\<TensorVotingKernel\>\"", ",", "\"\<TensorVotingKernelM\>\"", ",", 
      "\"\<MedioniTensorVotingKernel\>\""}], "}"}]}], "]"}]}]], "PackageInput",\

 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["LineKernel", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`LineKernel`"}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`LineKernel`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<LineKernel\>\"", ",", "\"\<FourierInfiniteLineKernel\>\"", ",", 
      "\"\<FourierInfiniteLineDiffusionKernel\>\"", ",", 
      "\"\<FourierInfiniteLineKernelPolar\>\"", ",", 
      "\"\<FourierLineKernel\>\"", ",", "\"\<FourierLineKernelPolar\>\"", 
      ",", "\"\<FourierCyclicLineKernel\>\"", ",", 
      "\"\<FourierCyclicLineKernelPolar\>\"", ",", 
      "\"\<FourierLineKernelApproximation\>\"", ",", 
      "\"\<LineKernelApproximation\>\"", ",", 
      "\"\<NLineKernelApproximation\>\"", ",", 
      "\"\<NLineKernelApproximationList\>\"", ",", 
      "\"\<NLineKernelApproximationMarginal\>\"", ",", 
      "\"\<LineKernelDensityApproximation\>\"", ",", 
      "\"\<NLineKernelDensityApproximation\>\"", ",", 
      "\"\<NLineKernelDensityApproximationList\>\"", ",", 
      "\"\<LineKernelMean\>\"", ",", "\"\<LineKernelMeanAngle\>\"", ",", 
      "\"\<LineKernelMeanRadius\>\"", ",", 
      "\"\<NLineKernelDensityApproximationMarginal\>\""}], "}"}]}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.444413623109498*^9, 3.4444136254709263`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ListFourierTransform", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`ListFourierTransform`"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`ListFourierTransform`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<ListFourierTransform\>\"", ",", 
      "\"\<ListInverseFourierTransform\>\"", ",", "\"\<ArrayTimes\>\"", ",", 
      "\"\<ListFourierPositions\>\"", ",", "\"\<ListFourierFrequencies\>\""}],
      "}"}]}], "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["BSpline", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`BSpline`"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"If", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$VersionNumber", "<", "6"}], ",", "\[IndentingNewLine]", 
    RowBox[{"DeclarePackage", "[", 
     RowBox[{"\"\<MathVisionTools`BSplineV5`\>\"", ",", 
      RowBox[{"{", "\"\<BSplineDistribution\>\"", "}"}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"DeclarePackage", "[", 
     RowBox[{"\"\<MathVisionTools`BSpline`\>\"", ",", 
      RowBox[{"{", "\"\<BSplineDistribution\>\"", "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["DisplayFunctions", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`DisplayFunctions`"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`DisplayFunctions`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<ListLuminocityPlot\>\"", ",", " ", "\"\<RasterPlot\>\"", ",", " ", 
      "\"\<PixelLabeling\>\"", ",", "\"\<ListEllipsePlot\>\"", ",", " ", 
      "\"\<ListEllipsoidPlot3D\>\""}], "}"}]}], "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["SelectFunctions", "Subsection",
 CellChangeTimes->{{3.4300495201693068`*^9, 3.430049527766283*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`DisplayFunctions`"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"If", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"$VersionNumber", " ", "\[GreaterEqual]", " ", "6."}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"DeclarePackage", "[", 
     RowBox[{"\"\<MathVisionTools`SelectFunctions`\>\"", ",", 
      RowBox[{"{", 
       RowBox[{
       "\"\<SelectSubimageDialog\>\"", ",", " ", "\"\<SelectPathDialog\>\"", 
        ",", "\"\<ExtractCrossSection\>\""}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.430049534590719*^9, 3.430049554930118*^9}, {
  3.4300496583260612`*^9, 3.4300496727703257`*^9}, {3.4300499267376347`*^9, 
  3.430049946774691*^9}, {3.430049978055534*^9, 3.430049978751108*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Ellipse Fit", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`EllipseFit`"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`EllipseFit`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<ListEllipseFit\>\"", ",", "\"\<EllipseProperties\>\"", ",", 
      "\"\<EllipseOrigin\>\"", ",", "\"\<EllipseRadii\>\"", ",", 
      "\"\<EllipseOrientation\>\"", ",", "\"\<QuadraticCurve\>\""}], "}"}]}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["FrontEndVision", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`FrontEndVision`"}], " ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{"If", "[", "\n", " ", 
    RowBox[{
     RowBox[{"$VersionNumber", " ", "<", " ", "6"}], ",", "\n", " ", 
     RowBox[{"DeclarePackage", "[", 
      RowBox[{"\"\<MathVisionTools`FrontEndVision`FEV`\>\"", ",", " ", 
       RowBox[{"{", 
        RowBox[{
        "\"\<arrow3D\>\"", ",", " ", "\"\<binarydilate\>\"", ",", " ", 
         "\"\<binaryerode\>\"", ",", " ", "\"\<bundle\>\"", ",", " ", 
         "\"\<colorToBW\>\"", ",", " ", "\"\<deform2D\>\"", ",", " ", 
         "\"\<dilate\>\"", ",", " ", "\"\<displayNewNotebook\>\"", ",", " ", 
         "\"\<erode\>\"", ",", " ", "\"\<gauge2D\>\"", ",", " ", 
         "\"\<gauge2DN\>\"", ",", " ", "\"\<gauss\>\"", ",", " ", 
         "\"\<gaussc\>\"", ",", " ", "\"\<gD\>\"", ",", " ", "\"\<gD1D\>\"", 
         ",", " ", "\"\<gDc\>\"", ",", " ", "\"\<gDf\>\"", ",", " ", 
         "\"\<gDf1D\>\"", ",", " ", "\"\<gDn\>\"", ",", " ", 
         "\"\<gD\[Phi]\>\"", ",", " ", "\"\<gD\[Phi]N\>\"", ",", " ", 
         "\"\<g\[ScriptCapitalG]\>\"", ",", " ", "\"\<g\[ScriptCapitalN]\>\"",
          ",", " ", "\"\<g\[ScriptCapitalW]\>\"", ",", " ", "\"\<heq\>\"", 
         ",", " ", "\"\<invertbundle\>\"", ",", " ", "\"\<laplaceG\>\"", ",", 
         " ", "\"\<liveForm\>\"", ",", " ", "\"\<liveAnimationForm\>\"", ",", 
         " ", "\"\<liveFormWrite\>\"", ",", " ", 
         "\"\<liveAnimationFormWrite\>\"", ",", " ", "\"\<rasterpixels\>\"", 
         ",", " ", "\"\<RDSPlot\>\"", ",", " ", "\"\<shortnotation\>\"", ",", 
         " ", "\"\<showarray\>\"", ",", " ", "\"\<sortrefs\>\"", ",", " ", 
         "\"\<writeimage\>\""}], "}"}]}], "]"}], ",", "\n", " ", 
     RowBox[{"DeclarePackage", "[", 
      RowBox[{"\"\<MathVisionTools`FrontEndVision`FEV6`\>\"", ",", " ", 
       RowBox[{"{", 
        RowBox[{
        "\"\<arrow3D\>\"", ",", " ", "\"\<binarydilate\>\"", ",", " ", 
         "\"\<binaryerode\>\"", ",", " ", "\"\<bundle\>\"", ",", " ", 
         "\"\<colorToBW\>\"", ",", " ", "\"\<deform2D\>\"", ",", " ", 
         "\"\<dilate\>\"", ",", " ", "\"\<displayNewNotebook\>\"", ",", " ", 
         "\"\<erode\>\"", ",", " ", "\"\<gauge2D\>\"", ",", " ", 
         "\"\<gauge2DN\>\"", ",", " ", "\"\<gauss\>\"", ",", " ", 
         "\"\<gaussc\>\"", ",", " ", "\"\<gD\>\"", ",", " ", "\"\<gD1D\>\"", 
         ",", " ", "\"\<gDc\>\"", ",", " ", "\"\<gDf\>\"", ",", " ", 
         "\"\<gDf1D\>\"", ",", " ", "\"\<gDn\>\"", ",", " ", 
         "\"\<gD\[Phi]\>\"", ",", " ", "\"\<gD\[Phi]N\>\"", ",", " ", 
         "\"\<g\[ScriptCapitalG]\>\"", ",", " ", "\"\<g\[ScriptCapitalN]\>\"",
          ",", " ", "\"\<g\[ScriptCapitalW]\>\"", ",", " ", "\"\<heq\>\"", 
         ",", " ", "\"\<invertbundle\>\"", ",", " ", "\"\<laplaceG\>\"", ",", 
         " ", "\"\<liveForm\>\"", ",", " ", "\"\<liveAnimationForm\>\"", ",", 
         " ", "\"\<liveFormWrite\>\"", ",", " ", 
         "\"\<liveAnimationFormWrite\>\"", ",", " ", "\"\<rasterpixels\>\"", 
         ",", " ", "\"\<RDSPlot\>\"", ",", " ", "\"\<shortnotation\>\"", ",", 
         " ", "\"\<showarray\>\"", ",", " ", "\"\<sortrefs\>\"", ",", " ", 
         "\"\<writeimage\>\""}], "}"}]}], "]"}]}], "\n", " ", "]"}], " ", 
   "*)"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.498733249785721*^9, 3.49873325310216*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["NAlgebra", "Subsection",
 CellChangeTimes->{{3.474130048888062*^9, 3.474130051084532*^9}, {
  3.474803314975354*^9, 3.474803316958947*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`NAlgebra`"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`NAlgebra`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<NQuadraticRootsReal\>\"", ",", "\"\<NCubicRootsReal\>\"", ",", 
      "\"\<NQuarticRootsReal\>\"", ",", "\"\<NQuadraticRootsComplex\>\"", 
      ",", "\"\<NCubicRootsComplex\>\"", ",", "\"\<NQuarticRootsComplex\>\"", 
      ",", "\"\<NQuadraticUnitRootsComplex\>\"", ",", 
      "\"\<NCubicUnitRootsComplex\>\"", ",", 
      "\"\<NQuarticUnitRootsComplex\>\""}], "}"}]}], "]"}]}]], "PackageInput",\

 InitializationCell->True,
 CellChangeTimes->{{3.4741300695808697`*^9, 3.474130139458899*^9}, {
  3.474195366783659*^9, 3.4741953676544657`*^9}, {3.474628504768559*^9, 
  3.474628513353548*^9}, {3.4746309138206377`*^9, 3.474630930379539*^9}, {
  3.474803327395688*^9, 3.47480338000605*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["MRITagging", "Subsection",
 CellChangeTimes->{{3.474130048888062*^9, 3.474130051084532*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`MRITagging`"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`MRITagging`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<SO2ReductionMatrix\>\"", ",", "\"\<CartesianToSO2Irreducible\>\"", 
      ",", "\"\<SO2IrreducibleNorm\>\"", ",", "\"\<SO2UnitJet\>\"", ",", 
      "\"\<SO2SpectrumToMaxAngle\>\"", ",", 
      "\"\<SO2SpectrumToExtremaAngles\>\"", ",", 
      "\"\<SO2SpectrumOfTaggingWave\>\"", ",", "\"\<ComplexTaggingWave\>\"", 
      ",", "\"\<DirectionOfTaggingWave\>\""}], "}"}]}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.4741300695808697`*^9, 3.474130139458899*^9}, {
  3.474195366783659*^9, 3.4741953676544657`*^9}, {3.474628504768559*^9, 
  3.474628513353548*^9}, {3.4746309138206377`*^9, 3.474630930379539*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Dicom (& DicomExport)", "Subsection",
 CellChangeTimes->{{3.43252954524481*^9, 3.432529548609898*^9}}],

Cell[BoxData[
 RowBox[{"Off", "[", 
  RowBox[{"Experimental`RegisterConverter", "::", "\"\<obsalt\>\""}], 
  "]"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Loading", " ", "package", " ", "MathVisionTools`Converters`Dicom`", " ", 
    "to", " ", "register", " ", "Import"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`Converters`Dicom`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Dicom\>\"", ",", "\"\<DicomImport\>\"", ",", 
      "\"\<DicomDictionary\>\"", ",", "\"\<DicomTags\>\"", ",", 
      "\"\<DicomExport\>\"", ",", "\"\<$DicomTags\>\""}], "}"}]}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{
  3.432528932412839*^9, {3.432529501685959*^9, 3.432529536528337*^9}, {
   3.432530080740597*^9, 3.432530093836499*^9}, {3.498737653842394*^9, 
   3.4987376632651052`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Use", " ", "built"}], "-", 
    RowBox[{"in", " ", "version", " ", "of", " ", "DICOM", " ", 
     RowBox[{"I", "/", "O"}]}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"MathVisionTools`Converters`DicomImportDummy", ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"Symbol", "[", "\"\<DicomImport\>\"", "]"}], "[", 
      RowBox[{"#1", ",", 
       RowBox[{
        RowBox[{"\"\<ImageIndex\>\"", "/.", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"ConversionOptions", "/.", 
            RowBox[{"Rest", "[", 
             RowBox[{"{", "##", "}"}], "]"}]}], "/.", 
           RowBox[{"ConversionOptions", "\[Rule]", 
            RowBox[{"{", "}"}]}]}], ")"}]}], "/.", 
        RowBox[{"\"\<ImageIndex\>\"", "\[Rule]", "All"}]}], ",", 
       RowBox[{"Apply", "[", 
        RowBox[{"Sequence", ",", 
         RowBox[{
          RowBox[{"ConversionOptions", "/.", 
           RowBox[{"Rest", "[", 
            RowBox[{"{", "##", "}"}], "]"}]}], "/.", 
          RowBox[{"ConversionOptions", "\[Rule]", 
           RowBox[{"{", "}"}]}]}]}], "]"}]}], "]"}], "&"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"Experimental`RegisterConverter", "[", 
    RowBox[{"Import", ",", "\"\<DICOM\>\"", ",", 
     RowBox[{"{", 
      RowBox[{
      "\"\<*.dcm\>\"", ",", "\"\<*.DCM\>\"", ",", "\"\<*.dicom\>\"", ",", 
       "\"\<*.DICOM\>\"", ",", "\"\<*.ani\>\"", ",", "\"\<*.ANI\>\"", ",", 
       "\"\<*.spi\>\"", ",", "\"\<*.SPI\>\""}], "}"}], ",", "None", ",", 
     "MathVisionTools`Converters`DicomImportDummy", ",", 
     RowBox[{"\"\<TextFormat\>\"", "\[Rule]", "False"}]}], "]"}], "*)"}], 
  "\n", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`Converters`DicomExport`"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"NOTE", ":", " ", 
    RowBox[{
    "DicomExport", " ", "has", " ", "been", " ", "merged", " ", "with", " ", 
     RowBox[{"Dicom", "!"}], " ", "MvA", " ", "2007"}]}], "*)"}], 
  "\[IndentingNewLine]", "\n", 
  RowBox[{"(*", " ", 
   RowBox[{"DeclarePackage", "[", 
    RowBox[{"\"\<MathVisionTools`Converters`DicomExport`\>\"", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<DicomExport\>\"", ",", "\"\<$DicomTags\>\""}], "}"}]}], 
    "]"}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{
  3.432528932412839*^9, {3.432529501685959*^9, 3.4325295385404787`*^9}, 
   3.4325299321974583`*^9, {3.4325299905970507`*^9, 3.4325299968402233`*^9}, {
   3.4325300728049307`*^9, 3.43253007571351*^9}, {3.43253011155973*^9, 
   3.432530136028048*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Raw3D", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Loading", " ", "package", " ", "MathVisionTools`Converters`Raw3D`", " ", 
    "to", " ", "register", " ", "Import", " ", "and", " ", "Export"}], "*)"}],
   "\n", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"DeclarePackage", "[", 
    RowBox[{"\"\<MathVisionTools`Converters`Raw3D`\>\"", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<Raw3DImport\>\"", ",", "\"\<Raw3DExport\>\""}], "}"}]}], 
    "]"}], "\[IndentingNewLine]", "\n", 
   RowBox[{"MathVisionTools`Converters`Raw3DImport", ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"Symbol", "[", "\"\<Raw3DImport\>\"", "]"}], "[", 
      RowBox[{"#1", ",", 
       RowBox[{"Apply", "[", 
        RowBox[{"Sequence", ",", 
         RowBox[{
          RowBox[{"ConversionOptions", "/.", 
           RowBox[{"Rest", "[", 
            RowBox[{"{", "##", "}"}], "]"}]}], "/.", 
          RowBox[{"ConversionOptions", "\[Rule]", 
           RowBox[{"{", "}"}]}]}]}], "]"}]}], "]"}], "&"}]}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{"Experimental`RegisterConverter", "[", 
    RowBox[{"Import", ",", "\"\<Raw3D\>\"", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<*.dat\>\"", ",", "\"\<*.DAT\>\""}], "}"}], ",", "None", 
     ",", "MathVisionTools`Converters`Raw3DImport", ",", 
     RowBox[{"\"\<TextFormat\>\"", "\[Rule]", "False"}]}], "]"}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{"MathVisionTools`Converters`Raw3DExport", ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"Symbol", "[", "\"\<Raw3DExport\>\"", "]"}], "[", 
      RowBox[{"#1", ",", "#2", ",", 
       RowBox[{"Apply", "[", 
        RowBox[{"Sequence", ",", 
         RowBox[{
          RowBox[{"ConversionOptions", "/.", 
           RowBox[{"Drop", "[", 
            RowBox[{
             RowBox[{"{", "##", "}"}], ",", "2"}], "]"}]}], "/.", 
          RowBox[{"ConversionOptions", "\[Rule]", 
           RowBox[{"{", "}"}]}]}]}], "]"}]}], "]"}], "&"}]}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{"Experimental`RegisterConverter", "[", 
    RowBox[{"Export", ",", "\"\<Raw3D\>\"", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<*.dat\>\"", ",", "\"\<*.DAT\>\""}], "}"}], ",", "None", 
     ",", "MathVisionTools`Converters`Raw3DExport", ",", 
     RowBox[{"\"\<TextFormat\>\"", "\[Rule]", "False"}]}], 
    "]"}]}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["KretzVolume", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Loading", " ", "package", " ", "MathVisionTools`Converters`KretzVolume`", 
    " ", "to", " ", "register", " ", "Import"}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"DeclarePackage", "[", 
    RowBox[{"\"\<MathVisionTools`Converters`KretzVolume`\>\"", ",", 
     RowBox[{"{", 
      RowBox[{
      "\"\<KretzVolumeImport\>\"", ",", "\"\<KretzVolume\>\"", ",", 
       "\"\<KretzHeader\>\""}], "}"}]}], "]"}], "\n", "\[IndentingNewLine]", 
   RowBox[{"MathVisionTools`Converters`KretzVolumeImportDummy", ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"Symbol", "[", "\"\<KretzVolumeImport\>\"", "]"}], "[", 
      RowBox[{"#1", ",", 
       RowBox[{"Apply", "[", 
        RowBox[{"Sequence", ",", 
         RowBox[{
          RowBox[{"ConversionOptions", "/.", 
           RowBox[{"Rest", "[", 
            RowBox[{"{", "##", "}"}], "]"}]}], "/.", 
          RowBox[{"ConversionOptions", "\[Rule]", 
           RowBox[{"{", "}"}]}]}]}], "]"}]}], "]"}], "&"}]}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{"Experimental`RegisterConverter", "[", 
    RowBox[{"Import", ",", "\"\<KretzVolume\>\"", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<*.v@\>\"", ",", "\"\<*.V@\>\""}], "}"}], ",", "None", ",", 
     "MathVisionTools`Converters`KretzVolumeImportDummy", ",", 
     RowBox[{"\"\<TextFormat\>\"", "\[Rule]", "False"}]}], 
    "]"}]}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["FDF", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Loading", " ", "package", " ", "MathVisionTools`Converters`FDF`", " ", 
    "to", " ", "register", " ", "Import"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"DeclarePackage", "[", 
    RowBox[{"\"\<MathVisionTools`Converters`FDF`\>\"", ",", 
     RowBox[{"{", 
      RowBox[{
      "\"\<FDFImport\>\"", ",", "\"\<FDFHeaderImport\>\"", ",", "\"\<FDF\>\"",
        ",", "\"\<FDFHeader\>\"", ",", "\"\<FDFSelection\>\"", ",", 
       "\"\<FDFHeaderParsing\>\""}], "}"}]}], "]"}], "\[IndentingNewLine]", 
   "\n", 
   RowBox[{"MathVisionTools`Converters`FDFImportDummy", ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"Symbol", "[", "\"\<FDFImport\>\"", "]"}], "[", 
      RowBox[{"#1", ",", 
       RowBox[{"Apply", "[", 
        RowBox[{"Sequence", ",", 
         RowBox[{
          RowBox[{"ConversionOptions", "/.", 
           RowBox[{"Rest", "[", 
            RowBox[{"{", "##", "}"}], "]"}]}], "/.", 
          RowBox[{"ConversionOptions", "\[Rule]", 
           RowBox[{"{", "}"}]}]}]}], "]"}]}], "]"}], "&"}]}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{"Experimental`RegisterConverter", "[", 
    RowBox[{"Import", ",", "\"\<FDF\>\"", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<*.fdf\>\"", ",", "\"\<*.FDF\>\""}], "}"}], ",", "None", 
     ",", "MathVisionTools`Converters`FDFImportDummy", ",", 
     RowBox[{"\"\<TextFormat\>\"", "\[Rule]", "False"}]}], 
    "]"}]}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["BioRad", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`Converters`BioRad`"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`Converters`BioRad`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<BioRadImport\>\"", ",", "\"\<BioRad\>\""}], "}"}]}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["BinaryArray", "Subsection",
 CellChangeTimes->{{3.474098004452489*^9, 3.474098008744454*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Declarations", " ", "for", " ", "package", " ", 
    "MathVisionTools`Converters`BinaryArray`"}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"DeclarePackage", "[", 
   RowBox[{"\"\<MathVisionTools`Converters`BinaryArray`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<BinaryArrayDimensions\>\"", ",", "\"\<BinaryArrayDataType\>\"", 
      ",", "\"\<BinaryArrayImport\>\"", ",", "\"\<BinaryArrayExport\>\""}], 
     "}"}]}], "]"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.4740980154737597`*^9, 3.474098019698573*^9}, {
  3.474098076616415*^9, 3.474098118207119*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"End", " ", "of", " ", "Master", " ", "package"}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "Null"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"On", "[", 
  RowBox[{"Experimental`RegisterConverter", "::", "\"\<obsalt\>\""}], 
  "]"}]], "PackageInput"]
}, Closed]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1076, 940},
WindowMargins->{{Automatic, 207}, {Automatic, 6}},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 7, \
2010)",
StyleDefinitions->Notebook[{
   Cell[
    CellGroupData[{
      Cell["Style Definitions", "Subtitle"], 
      Cell[
      "Modify the definitions below to change the default appearance of all \
cells in a given style.  Make modifications to any definition using commands \
in the Format menu.", "Text"], 
      Cell[
       CellGroupData[{
         Cell["Style Environment Names", "Section"], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{12, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 9], 
         Cell[
          StyleData[All, "Presentation"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 12], 
         Cell[
          StyleData[All, "Condensed"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{8, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 8], 
         Cell[
          StyleData[All, "Printout"], PageWidth -> PaperWidth, 
          CellLabelMargins -> {{2, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 5, 
          PrivateFontOptions -> {"FontType" -> "Outline"}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Notebook Options", "Section"], 
         Cell[
         "The options defined for the style below will be used at the \
Notebook level.", "Text"], 
         Cell[
          StyleData["Notebook"], PageHeaders -> {{
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"], None, 
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"]}, {
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"], None, 
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"]}}, CellFrameLabelMargins -> 
          6, StyleMenuListing -> None]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headings", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Title"], CellMargins -> {{12, Inherited}, {20, 40}}, 
             CellGroupingRules -> {"TitleGrouping", 0}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LineSpacing -> {1, 11}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "Title", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subtitle", 0}, {"Subsubtitle", 0}}, FontFamily -> 
             "Helvetica", FontSize -> 36, FontWeight -> "Bold"], 
            Cell[
             StyleData["Title", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 40}}, LineSpacing -> {1, 0}, 
             FontSize -> 44], 
            Cell[
             StyleData["Title", "Condensed"], 
             CellMargins -> {{8, 10}, {4, 8}}, FontSize -> 20], 
            Cell[
             StyleData["Title", "Printout"], 
             CellMargins -> {{2, 10}, {12, 30}}, FontSize -> 24]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subtitle"], 
             CellMargins -> {{12, Inherited}, {20, 15}}, 
             CellGroupingRules -> {"TitleGrouping", 10}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subtitle", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subsubtitle", 0}}, FontFamily -> "Helvetica", 
             FontSize -> 24], 
            Cell[
             StyleData["Subtitle", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 20}}, LineSpacing -> {1, 0}, 
             FontSize -> 36], 
            Cell[
             StyleData["Subtitle", "Condensed"], 
             CellMargins -> {{8, 10}, {4, 4}}, FontSize -> 14], 
            Cell[
             StyleData["Subtitle", "Printout"], 
             CellMargins -> {{2, 10}, {12, 8}}, FontSize -> 18]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubtitle"], 
             CellMargins -> {{12, Inherited}, {20, 15}}, 
             CellGroupingRules -> {"TitleGrouping", 20}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsubtitle", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}}, FontFamily -> "Helvetica", FontSize -> 14, 
             FontSlant -> "Italic"], 
            Cell[
             StyleData["Subsubtitle", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 20}}, LineSpacing -> {1, 0}, 
             FontSize -> 24], 
            Cell[
             StyleData["Subsubtitle", "Condensed"], 
             CellMargins -> {{8, 10}, {8, 8}}, FontSize -> 12], 
            Cell[
             StyleData["Subsubtitle", "Printout"], 
             CellMargins -> {{2, 10}, {12, 8}}, FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellDingbat -> "\[FilledSquare]", 
             CellMargins -> {{25, Inherited}, {8, 24}}, 
             CellGroupingRules -> {"SectionGrouping", 30}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LineSpacing -> {1, 7}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "Section", 
             CounterAssignments -> {{"Subsection", 0}, {"Subsubsection", 0}}, 
             FontFamily -> "Helvetica", FontSize -> 16, FontWeight -> "Bold"], 
            Cell[
             StyleData["Section", "Presentation"], 
             CellMargins -> {{40, 10}, {11, 32}}, LineSpacing -> {1, 0}, 
             FontSize -> 24], 
            Cell[
             StyleData["Section", "Condensed"], 
             CellMargins -> {{18, Inherited}, {6, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Section", "Printout"], 
             CellMargins -> {{13, 0}, {7, 22}}, FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> "\[FilledSmallSquare]", 
             CellMargins -> {{22, Inherited}, {8, 20}}, 
             CellGroupingRules -> {"SectionGrouping", 40}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsection", CounterAssignments -> {{"Subsubsection", 0}}, 
             FontFamily -> "Times", FontSize -> 14, FontWeight -> "Bold"], 
            Cell[
             StyleData["Subsection", "Presentation"], 
             CellMargins -> {{36, 10}, {11, 32}}, LineSpacing -> {1, 0}, 
             FontSize -> 22], 
            Cell[
             StyleData["Subsection", "Condensed"], 
             CellMargins -> {{16, Inherited}, {6, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Subsection", "Printout"], 
             CellMargins -> {{9, 0}, {7, 22}}, FontSize -> 12]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsection"], CellDingbat -> 
             "\[FilledSmallSquare]", 
             CellMargins -> {{22, Inherited}, {8, 18}}, 
             CellGroupingRules -> {"SectionGrouping", 50}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsubsection", FontFamily -> "Times", FontWeight -> "Bold"], 
            Cell[
             StyleData["Subsubsection", "Presentation"], 
             CellMargins -> {{34, 10}, {11, 26}}, LineSpacing -> {1, 0}, 
             FontSize -> 18], 
            Cell[
             StyleData["Subsubsection", "Condensed"], 
             CellMargins -> {{17, Inherited}, {6, 12}}, FontSize -> 10], 
            Cell[
             StyleData["Subsubsection", "Printout"], 
             CellMargins -> {{9, 0}, {7, 14}}, FontSize -> 11]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Body Text", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Text"], CellMargins -> {{12, 10}, {7, 7}}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             Hyphenation -> True, LineSpacing -> {1, 3}, CounterIncrements -> 
             "Text"], 
            Cell[
             StyleData["Text", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["Text", "Condensed"], CellMargins -> {{8, 10}, {6, 6}},
              LineSpacing -> {1, 1}, FontSize -> 11], 
            Cell[
             StyleData["Text", "Printout"], CellMargins -> {{2, 2}, {6, 6}}, 
             TextJustification -> 0.5, FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SmallText"], CellMargins -> {{12, 10}, {6, 6}}, 
             DefaultNewInlineCellStyle -> "None", Hyphenation -> True, 
             LineSpacing -> {1, 3}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "SmallText", FontFamily -> "Helvetica", 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Presentation"], 
             CellMargins -> {{24, 10}, {8, 8}}, LineSpacing -> {1, 5}, 
             FontSize -> 12], 
            Cell[
             StyleData["SmallText", "Condensed"], 
             CellMargins -> {{8, 10}, {5, 5}}, LineSpacing -> {1, 2}, 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Printout"], 
             CellMargins -> {{2, 2}, {5, 5}}, TextJustification -> 0.5, 
             FontSize -> 7]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Input/Output", "Section"], 
         Cell[
         "The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names. Some attributes for these styles are actually set in FormatType Styles \
(in the last section of this stylesheet). ", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Input"], CellMargins -> {{45, 10}, {5, 7}}, 
             Evaluatable -> True, CellGroupingRules -> "InputGrouping", 
             CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, DefaultFormatType -> 
             DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
             FormatType -> InputForm, ShowStringCharacters -> True, 
             NumberMarks -> True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1},
              CounterIncrements -> "Input", FontWeight -> "Bold"], 
            Cell[
             StyleData["Input", "Presentation"], 
             CellMargins -> {{72, Inherited}, {8, 10}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["Input", "Condensed"], 
             CellMargins -> {{40, 10}, {2, 3}}, FontSize -> 11], 
            Cell[
             StyleData["Input", "Printout"], CellMargins -> {{39, 0}, {4, 6}},
              LinebreakAdjustments -> {0.85, 2, 10, 1, 1}, FontSize -> 9]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PackageInput"], CellMargins -> {{45, 10}, {5, 7}}, 
             Evaluatable -> True, CellGroupingRules -> "InputGrouping", 
             CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, InitializationCell -> True, 
             DefaultFormatType -> DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
             FormatType -> InputForm, ShowStringCharacters -> True, 
             NumberMarks -> True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1},
              CounterIncrements -> "Input", FontWeight -> "Bold", Background -> 
             RGBColor[0.500008, 1, 0.566644]], 
            Cell[
             StyleData["PackageInput", "Presentation"], 
             CellMargins -> {{72, Inherited}, {8, 10}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["PackageInput", "Condensed"], 
             CellMargins -> {{40, 10}, {2, 3}}, FontSize -> 11], 
            Cell[
             StyleData["PackageInput", "Printout"], 
             CellMargins -> {{39, 0}, {4, 6}}, 
             LinebreakAdjustments -> {0.85, 2, 10, 1, 1}, FontSize -> 9, 
             Background -> GrayLevel[1]]}, Closed]], 
         Cell[
          StyleData["InputOnly"], Evaluatable -> True, CellGroupingRules -> 
          "InputGrouping", CellHorizontalScrolling -> True, DefaultFormatType -> 
          DefaultInputFormatType, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
          FormatType -> InputForm, ShowStringCharacters -> True, NumberMarks -> 
          True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, 
          CounterIncrements -> "Input", StyleMenuListing -> None, FontWeight -> 
          "Bold"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Output"], CellMargins -> {{47, 10}, {7, 5}}, 
             CellEditDuplicate -> True, CellGroupingRules -> "OutputGrouping",
              CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, DefaultFormatType -> 
             DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Output"], 
            Cell[
             StyleData["Output", "Presentation"], 
             CellMargins -> {{72, Inherited}, {10, 8}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["Output", "Condensed"], 
             CellMargins -> {{41, Inherited}, {3, 2}}, FontSize -> 11], 
            Cell[
             StyleData["Output", "Printout"], 
             CellMargins -> {{39, 0}, {6, 4}}, FontSize -> 9]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Message"], 
             CellMargins -> {{45, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Message", StyleMenuListing -> 
             None, FontSize -> 11, FontColor -> RGBColor[0, 0, 1]], 
            Cell[
             StyleData["Message", "Presentation"], 
             CellMargins -> {{72, Inherited}, {Inherited, Inherited}}, 
             LineSpacing -> {1, 0}, FontSize -> 16], 
            Cell[
             StyleData["Message", "Condensed"], 
             CellMargins -> {{41, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 11], 
            Cell[
             StyleData["Message", "Printout"], 
             CellMargins -> {{39, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 7, FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Print"], 
             CellMargins -> {{45, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, ShowCellLabel -> 
             False, DefaultFormatType -> DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Print", StyleMenuListing -> 
             None], 
            Cell[
             StyleData["Print", "Presentation"], 
             CellMargins -> {{72, Inherited}, {Inherited, Inherited}}, 
             LineSpacing -> {1, 0}, FontSize -> 16], 
            Cell[
             StyleData["Print", "Condensed"], 
             CellMargins -> {{41, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 11], 
            Cell[
             StyleData["Print", "Printout"], 
             CellMargins -> {{39, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 8]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Graphics"], 
             CellMargins -> {{4, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "GraphicsGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, LanguageCategory -> 
             None, FormatType -> InputForm, CounterIncrements -> "Graphics", 
             ImageMargins -> {{43, Inherited}, {Inherited, 0}}, 
             StyleMenuListing -> None, FontFamily -> "Courier", FontSize -> 
             10], 
            Cell[
             StyleData["Graphics", "Presentation"], 
             ImageMargins -> {{62, Inherited}, {Inherited, 0}}], 
            Cell[
             StyleData["Graphics", "Condensed"], 
             ImageMargins -> {{38, Inherited}, {Inherited, 0}}, Magnification -> 
             0.6], 
            Cell[
             StyleData["Graphics", "Printout"], 
             ImageMargins -> {{30, Inherited}, {Inherited, 0}}, Magnification -> 
             0.8]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["CellLabel"], LanguageCategory -> None, 
             StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 
             9, FontColor -> RGBColor[0, 0, 1]], 
            Cell[
             StyleData["CellLabel", "Presentation"], FontSize -> 12], 
            Cell[
             StyleData["CellLabel", "Condensed"], FontSize -> 9], 
            Cell[
             StyleData["CellLabel", "Printout"], FontFamily -> "Courier", 
             FontSize -> 8, FontSlant -> "Italic", FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Inline Formatting", "Section"], 
         Cell[
         "These styles are for modifying individual words or letters in a \
cell exclusive of the cell tag.", "Text"], 
         Cell[
          StyleData["RM"], StyleMenuListing -> None, FontWeight -> "Plain", 
          FontSlant -> "Plain"], 
         Cell[
          StyleData["BF"], StyleMenuListing -> None, FontWeight -> "Bold"], 
         Cell[
          StyleData["IT"], StyleMenuListing -> None, FontSlant -> "Italic"], 
         Cell[
          StyleData["TR"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["TI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["TB"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["TBI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["MR"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["MO"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["MB"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["MBO"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["SR"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["SO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["SB"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["SBO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SO10"], StyleMenuListing -> None, FontFamily -> 
             "Helvetica", FontSize -> 10, FontWeight -> "Plain", FontSlant -> 
             "Italic"], 
            Cell[
             StyleData["SO10", "Printout"], StyleMenuListing -> None, 
             FontFamily -> "Helvetica", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"], 
            Cell[
             StyleData["SO10", "EnhancedPrintout"], StyleMenuListing -> None, 
             FontFamily -> "Futura", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Formulas and Programming", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["InlineFormula"], CellMargins -> {{10, 4}, {0, 8}}, 
             CellHorizontalScrolling -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", ScriptLevel -> 1, SingleLetterItalics -> True], 
            Cell[
             StyleData["InlineFormula", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["InlineFormula", "Condensed"], 
             CellMargins -> {{8, 10}, {6, 6}}, LineSpacing -> {1, 1}, 
             FontSize -> 11], 
            Cell[
             StyleData["InlineFormula", "Printout"], 
             CellMargins -> {{2, 0}, {6, 6}}, FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["DisplayFormula"], 
             CellMargins -> {{42, Inherited}, {Inherited, Inherited}}, 
             CellHorizontalScrolling -> True, DefaultFormatType -> 
             DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", ScriptLevel -> 0, SingleLetterItalics -> True, 
             UnderoverscriptBoxOptions -> {LimitsPositioning -> True}], 
            Cell[
             StyleData["DisplayFormula", "Presentation"], 
             LineSpacing -> {1, 5}, FontSize -> 16], 
            Cell[
             StyleData["DisplayFormula", "Condensed"], LineSpacing -> {1, 1}, 
             FontSize -> 11], 
            Cell[
             StyleData["DisplayFormula", "Printout"], FontSize -> 10]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Program"], CellFrame -> {{0, 0}, {0.5, 0.5}}, 
             CellMargins -> {{10, 4}, {0, 8}}, CellHorizontalScrolling -> 
             True, Hyphenation -> False, LanguageCategory -> "Formula", 
             ScriptLevel -> 1, FontFamily -> "Courier"], 
            Cell[
             StyleData["Program", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["Program", "Condensed"], 
             CellMargins -> {{8, 10}, {6, 6}}, LineSpacing -> {1, 1}, 
             FontSize -> 11], 
            Cell[
             StyleData["Program", "Printout"], 
             CellMargins -> {{2, 0}, {6, 6}}, FontSize -> 9]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Outline Styles", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline1"], CellMargins -> {{12, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 50}, 
             ParagraphIndent -> -38, CounterIncrements -> "Outline1", 
             FontSize -> 18, FontWeight -> "Bold", 
             CounterBoxOptions -> {CounterFunction :> CapitalRomanNumeral}], 
            Cell[
             StyleData["Outline1", "Printout"], 
             CounterBoxOptions -> {CounterFunction :> CapitalRomanNumeral}]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline2"], CellMargins -> {{59, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 60}, 
             ParagraphIndent -> -27, CounterIncrements -> "Outline2", 
             FontSize -> 15, FontWeight -> "Bold", 
             CounterBoxOptions -> {CounterFunction :> (Part[
                 CharacterRange["A", "Z"], #]& )}], 
            Cell[
             StyleData["Outline2", "Printout"], 
             CounterBoxOptions -> {CounterFunction :> (Part[
                 CharacterRange["A", "Z"], #]& )}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline3"], CellMargins -> {{108, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 70}, 
             ParagraphIndent -> -21, CounterIncrements -> "Outline3", 
             FontSize -> 12, 
             CounterBoxOptions -> {CounterFunction :> Identity}], 
            Cell[
             StyleData["Outline3", "Printout"], 
             CounterBoxOptions -> {CounterFunction :> Identity}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline4"], CellMargins -> {{158, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 80}, 
             ParagraphIndent -> -18, CounterIncrements -> "Outline4", 
             FontSize -> 10, CounterBoxOptions -> {CounterFunction :> (Part[
                 CharacterRange["a", "z"], #]& )}], 
            Cell[
             StyleData["Outline4", "Printout"]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Hyperlink Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same Notebook, \
or between Notebooks.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Hyperlink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonNote -> 
               ButtonData}], 
            Cell[
             StyleData["Hyperlink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["Hyperlink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["Hyperlink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
         "The following styles are for linking automatically to the on-line \
help system.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["MainBookLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["MainBook", #]}]& )}], 
            Cell[
             StyleData["MainBookLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["MainBookLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["MainBookLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["AddOnsLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["AddOns", #]}]& )}], 
            Cell[
             StyleData["AddOnsLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["AddOnsLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["AddOnsLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["RefGuideLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["RefGuide", #]}]& )}], 
            Cell[
             StyleData["RefGuideLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["RefGuideLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["RefGuideLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["GettingStartedLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["GettingStarted", #]}]& )}], 
            Cell[
             StyleData["GettingStartedLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["GettingStartedLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["GettingStartedLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["OtherInformationLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["OtherInformation", #]}]& )}], 
            Cell[
             StyleData["OtherInformationLink", "Presentation"], FontSize -> 
             16], 
            Cell[
             StyleData["OtherInformationLink", "Condensed"], FontSize -> 11], 
            
            Cell[
             StyleData["OtherInformationLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headers and Footers", "Section"], 
         Cell[
          StyleData["Header"], CellMargins -> {{0, 0}, {4, 1}}, 
          DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
          "NaturalLanguage", StyleMenuListing -> None, FontSize -> 10, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["Footer"], CellMargins -> {{0, 0}, {0, 4}}, 
          DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
          "NaturalLanguage", StyleMenuListing -> None, FontSize -> 9, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["PageNumber"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Times", FontSize -> 10]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Palette Styles", "Section"], 
         Cell[
         "The cells below define styles that define standard ButtonFunctions, \
for use in palette buttons.", "Text"], 
         Cell[
          StyleData["Paste"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, After]}]& )}], 
         Cell[
          StyleData["Evaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["EvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionMove[
                FrontEnd`InputNotebook[], All, Cell, 1], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Placeholder Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making placeholder objects \
in palette templates.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Placeholder"], Placeholder -> True, StyleMenuListing -> 
             None, FontSlant -> "Italic", FontColor -> 
             RGBColor[0.890623, 0.864698, 0.384756], 
             TagBoxOptions -> {
              Editable -> False, Selectable -> False, StripWrapperBoxes -> 
               False}], 
            Cell[
             StyleData["Placeholder", "Presentation"]], 
            Cell[
             StyleData["Placeholder", "Condensed"]], 
            Cell[
             StyleData["Placeholder", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PrimaryPlaceholder"], StyleMenuListing -> None, 
             DrawHighlighted -> True, FontSlant -> "Italic", Background -> 
             RGBColor[0.912505, 0.891798, 0.507774], 
             TagBoxOptions -> {
              Editable -> False, Selectable -> False, StripWrapperBoxes -> 
               False}], 
            Cell[
             StyleData["PrimaryPlaceholder", "Presentation"]], 
            Cell[
             StyleData["PrimaryPlaceholder", "Condensed"]], 
            Cell[
             StyleData["PrimaryPlaceholder", "Printout"]]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["FormatType Styles", "Section"], 
         Cell[
         "The cells below define styles that are mixed in with the styles of \
most cells.  If a cell's FormatType matches the name of one of the styles \
defined below, then that style is applied between the cell's style and its \
own options. This is particularly true of Input and Output.", "Text"], 
         Cell[
          StyleData["CellExpression"], PageWidth -> Infinity, 
          CellMargins -> {{6, Inherited}, {Inherited, Inherited}}, 
          ShowCellLabel -> False, ShowSpecialCharacters -> False, 
          AllowInlineCells -> False, Hyphenation -> False, 
          AutoItalicWords -> {}, StyleMenuListing -> None, FontFamily -> 
          "Courier", FontSize -> 12, Background -> GrayLevel[1]], 
         Cell[
          StyleData["InputForm"], InputAutoReplacements -> {}, 
          AllowInlineCells -> False, Hyphenation -> False, StyleMenuListing -> 
          None, FontFamily -> "Courier"], 
         Cell[
          StyleData["OutputForm"], PageWidth -> Infinity, TextAlignment -> 
          Left, LineSpacing -> {0.6, 1}, StyleMenuListing -> None, FontFamily -> 
          "Courier"], 
         Cell[
          StyleData["StandardForm"], 
          InputAutoReplacements -> {
           "->" -> "\[Rule]", ":>" -> "\[RuleDelayed]", "<=" -> 
            "\[LessEqual]", ">=" -> "\[GreaterEqual]", "!=" -> "\[NotEqual]", 
            "==" -> "\[Equal]", Inherited}, LineSpacing -> {1.25, 0}, 
          StyleMenuListing -> None, FontFamily -> "Courier"], 
         Cell[
          StyleData["TraditionalForm"], 
          InputAutoReplacements -> {
           "->" -> "\[Rule]", ":>" -> "\[RuleDelayed]", "<=" -> 
            "\[LessEqual]", ">=" -> "\[GreaterEqual]", "!=" -> "\[NotEqual]", 
            "==" -> "\[Equal]", Inherited}, LineSpacing -> {1.25, 0}, 
          SingleLetterItalics -> True, TraditionalFunctionNotation -> True, 
          DelimiterMatching -> None, StyleMenuListing -> None], 
         Cell[
         "The style defined below is mixed in to any cell that is in an \
inline cell within another.", "Text"], 
         Cell[
          StyleData["InlineCell"], LanguageCategory -> "Formula", ScriptLevel -> 
          1, StyleMenuListing -> None], 
         Cell[
          StyleData["InlineCellEditing"], StyleMenuListing -> None, 
          Background -> RGBColor[1, 0.749996, 0.8]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Automatic Styles", "Section"], 
         Cell[
         "The cells below define styles that are used to affect the display \
of certain types of objects in typeset expressions.  For example, \
\"UnmatchedBracket\" style defines how unmatched bracket, curly bracket, and \
parenthesis characters are displayed (typically by coloring them to make them \
stand out).", "Text"], 
         Cell[
          StyleData["UnmatchedBracket"], StyleMenuListing -> None, FontColor -> 
          RGBColor[0.760006, 0.330007, 0.8]]}, Closed]]}, Open]]}, Visible -> 
  False, FrontEndVersion -> 
  "8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 34, 0, 144, "Title"],
Cell[604, 24, 39, 0, 88, "Subtitle"],
Cell[646, 26, 267, 7, 118, "Subsubtitle"],
Cell[CellGroupData[{
Cell[938, 37, 25, 0, 72, "Section"],
Cell[966, 39, 1344, 30, 654, "PackageInput"],
Cell[2313, 71, 128, 3, 87, "Text"],
Cell[2444, 76, 6091, 168, 2155, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[8572, 249, 32, 0, 40, "Section"],
Cell[8607, 251, 92, 2, 646461, "Text"],
Cell[8702, 255, 125, 3, 1005310, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[8864, 263, 29, 0, 40, "Section"],
Cell[8896, 265, 977, 16, 135, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[9910, 286, 39, 0, 40, "Section"],
Cell[9952, 288, 272, 8, 135, "PackageInput",
 InitializationCell->True],
Cell[10227, 298, 284, 8, 135, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[10548, 311, 31, 0, 40, "Section"],
Cell[CellGroupData[{
Cell[10604, 315, 38, 0, 141, "Subsection"],
Cell[10645, 317, 8083, 168, 7992, "PackageInput",
 InitializationCell->True],
Cell[18731, 487, 1004, 19, 1936, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[19772, 511, 42, 0, 82, "Subsection"],
Cell[19817, 513, 1385, 40, 1356, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[21251, 559, 34, 0, 40, "Section"],
Cell[21288, 561, 92, 2, 303, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[21417, 568, 39, 0, 40, "Section"],
Cell[CellGroupData[{
Cell[21481, 572, 43, 0, 63, "Subsection"],
Cell[21527, 574, 229, 4, 303, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[21793, 583, 43, 0, 37, "Subsection"],
Cell[21839, 585, 538, 14, 4909059, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[22414, 604, 102, 1, 37, "Subsection"],
Cell[22519, 607, 722, 17, 343, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[23278, 629, 32, 0, 37, "Subsection"],
Cell[23313, 631, 462, 12, 292, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[23812, 648, 30, 0, 37, "Subsection"],
Cell[23845, 650, 703, 17, 292, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[24585, 672, 105, 1, 37, "Subsection"],
Cell[24693, 675, 503, 13, 292, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[25233, 693, 107, 1, 37, "Subsection"],
Cell[25343, 696, 728, 17, 343, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[26108, 718, 40, 0, 37, "Subsection"],
Cell[26151, 720, 1210, 25, 499, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[27398, 750, 44, 0, 37, "Subsection"],
Cell[27445, 752, 695, 17, 343, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[28177, 774, 31, 0, 37, "Subsection"],
Cell[28211, 776, 1540, 34, 337, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[29788, 815, 39, 0, 63, "Subsection"],
Cell[29830, 817, 783, 19, 396, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[30650, 841, 37, 0, 37, "Subsection"],
Cell[30690, 843, 1272, 24, 550, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[31999, 872, 45, 0, 37, "Subsection"],
Cell[32047, 874, 637, 15, 343, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[32721, 894, 37, 0, 37, "Subsection"],
Cell[32761, 896, 1035, 25, 245, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[33833, 926, 35, 0, 63, "Subsection"],
Cell[33871, 928, 455, 12, 292, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[34363, 945, 106, 1, 37, "Subsection"],
Cell[34472, 948, 826, 20, 343, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[35335, 973, 41, 0, 37, "Subsection"],
Cell[35379, 975, 1740, 36, 861, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[37156, 1016, 48, 0, 37, "Subsection"],
Cell[37207, 1018, 620, 15, 343, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[37864, 1038, 86, 1, 37, "Subsection"],
Cell[37953, 1041, 620, 15, 292, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[38610, 1061, 37, 0, 37, "Subsection"],
Cell[38650, 1063, 466, 13, 292, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[39153, 1081, 102, 1, 37, "Subsection"],
Cell[39258, 1084, 676, 18, 292, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[39971, 1107, 43, 0, 37, "Subsection"],
Cell[40017, 1109, 979, 22, 396, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[41033, 1136, 34, 0, 37, "Subsection"],
Cell[41070, 1138, 491, 13, 292, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[41598, 1156, 37, 0, 37, "Subsection"],
Cell[41638, 1158, 1237, 25, 603, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[42912, 1188, 32, 0, 37, "Subsection"],
Cell[42947, 1190, 1429, 30, 706, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[44413, 1225, 42, 0, 37, "Subsection"],
Cell[44458, 1227, 615, 15, 343, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[45110, 1247, 29, 0, 37, "Subsection"],
Cell[45142, 1249, 736, 17, 264, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[45915, 1271, 38, 0, 37, "Subsection"],
Cell[45956, 1273, 587, 14, 343, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[46580, 1292, 105, 1, 37, "Subsection"],
Cell[46688, 1295, 911, 20, 396, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[47636, 1320, 33, 0, 37, "Subsection"],
Cell[47672, 1322, 594, 15, 343, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[48303, 1342, 36, 0, 37, "Subsection"],
Cell[48342, 1344, 3467, 58, 1120, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[51846, 1407, 145, 2, 37, "Subsection"],
Cell[51994, 1411, 1019, 22, 447, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[53050, 1438, 98, 1, 37, "Subsection"],
Cell[53151, 1441, 976, 21, 396, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[54164, 1467, 108, 1, 37, "Subsection"],
Cell[54275, 1470, 132, 3, 60, "PackageInput"],
Cell[54410, 1475, 798, 19, 153, "PackageInput",
 InitializationCell->True],
Cell[55211, 1496, 2752, 66, 429, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[58000, 1567, 27, 0, 63, "Subsection"],
Cell[58030, 1569, 2340, 56, 429, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[60407, 1630, 33, 0, 37, "Subsection"],
Cell[60443, 1632, 1479, 35, 291, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[61959, 1672, 25, 0, 37, "Subsection"],
Cell[61987, 1674, 1521, 37, 314, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[63545, 1716, 28, 0, 37, "Subsection"],
Cell[63576, 1718, 450, 12, 107, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[64063, 1735, 99, 1, 37, "Subsection"],
Cell[64165, 1738, 682, 16, 153, "PackageInput",
 InitializationCell->True],
Cell[64850, 1756, 213, 5, 107, "PackageInput",
 InitializationCell->True],
Cell[65066, 1763, 131, 3, 60, "PackageInput"]
}, Closed]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
