(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    466825,      12677]
NotebookOptionsPosition[    449263,      12165]
NotebookOutlinePosition[    449684,      12183]
CellTagsIndexPosition[    449641,      12180]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Line Kernel Package", "Title"],

Cell["\<\
Markus van Almsick
Technische Universiteit Eindhoven
\[Copyright]2007\
\>", "Subsubtitle"],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "[", "\"\<MathVisionTools`LineKernel`\>\"", "]"}], 
     " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"2009", ",", "2", ",", "23", ",", "22", ",", "23", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput"],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`LineKernel`"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Author", ":", " ", 
     RowBox[{"Markus", " ", "van", " ", "Almsick"}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"M", ".", "v", ".", 
       RowBox[{"Almsick", "@", "tue"}], ".", "nl"}]}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`LineKernel`"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "2.1"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "5.2"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2009"}]}]}], ",", " ", 
    RowBox[{"Technische", " ", "Universiteit", " ", "Eindhoven"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Title", ":", " ", 
      RowBox[{"Stochastic", " ", "Completion", " ", "Field"}]}]}], ",", " ", 
    RowBox[{"Line", " ", "and", " ", "Contour", " ", "Propagation"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "implements", " ", "routines", " ", "for", 
      " ", "line", " ", "and", " ", "edge", " ", "propagation"}]}]}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", 
      RowBox[{"Stochastic", " ", "Completion", " ", "Field"}]}]}], ",", " ", 
    RowBox[{"Tensor", " ", "Voting"}], ",", " ", 
    RowBox[{"Line", " ", "and", " ", "Contour", " ", "Propagation"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"December", " ", "2005"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "2.1", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"Febraury", " ", "2009"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "BeginPackage", "[", "\[IndentingNewLine]", 
   "\"\<MathVisionTools`LineKernel`\>\"", "\[IndentingNewLine]", "]"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{"Unprotect", "[", "\[IndentingNewLine]", 
  RowBox[{
  "LineKernel", ",", "\[IndentingNewLine]", "LineKernelMean", ",", 
   "\[IndentingNewLine]", "FourierLineKernel", ",", "\[IndentingNewLine]", 
   "FourierInfiniteLineKernel", ",", "\[IndentingNewLine]", 
   "FourierInfiniteLineDiffusionKernel", ",", "\[IndentingNewLine]", 
   "FourierLineKernelPolar", ",", "\[IndentingNewLine]", 
   "FourierInfiniteLineKernelPolar", ",", "\[IndentingNewLine]", 
   "FourierCyclicLineKernel", ",", "\[IndentingNewLine]", 
   "FourierCyclicLineKernelPolar", ",", "\[IndentingNewLine]", 
   "FourierLineKernelApproximation", ",", "\[IndentingNewLine]", 
   "LineKernelApproximation", ",", "\[IndentingNewLine]", 
   "NLineKernelApproximation", ",", "\[IndentingNewLine]", 
   "NLineKernelApproximationList", ",", "\[IndentingNewLine]", 
   "NLineKernelApproximationMarginal", ",", "\[IndentingNewLine]", 
   "LineKernelDensityApproximation", ",", "\[IndentingNewLine]", 
   "NLineKernelDensityApproximation", ",", "\[IndentingNewLine]", 
   "NLineKernelDensityApproximationList", ",", "\[IndentingNewLine]", 
   "NLineKernelDensityApproximationMarginal", ",", "\[IndentingNewLine]", 
   "FloquetSign", ",", "\[IndentingNewLine]", "FloquetExponent"}], 
  "\[IndentingNewLine]", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"LineKernel", "::", "usage"}], " ", "=", " ", 
   "\"\<LineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Alpha]] renders \
the \[Alpha]-marginal of the exact kernel of the stochastic line propagation \
with periodic boundaries for \[Alpha] at \[PlusMinus]\[Pi]. \[Sigma] is the \
angular diffusion constant randomizing the direction of line propagation. \
\[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \
\[Kappa] the constant curvature of line propagation. The LineKernel for x, y, \
and \[Alpha] has to be generated via the FourierLineKernel command and a \
subsequent inverse Fourier transformation.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelMean", "::", "usage"}], "=", 
   "\"\<LineKernelMean[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Alpha]] \
renders the average {x,y} position with final direction \[Alpha] for the \
exact stochastic line propagation kernel with periodic boundaries for \
\[Alpha] at \[PlusMinus]\[Pi]. \[Sigma] is the angular diffusion constant \
randomizing the direction of line propagation. \[Lambda] is the line decay \
constant. \[Alpha]0 is the initial direction and \[Kappa] the constant \
curvature of line propagation.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelMeanAngle", "::", "usage"}], "=", 
   "\"\<LineKernelMeanAngle[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Alpha]] \
renders the average polar angle with final direction \[Alpha] for the exact \
stochastic line propagation kernel with periodic boundaries for \[Alpha] at \
\[PlusMinus]\[Pi]. \[Sigma] is the angular diffusion constant randomizing the \
direction of line propagation. \[Lambda] is the line decay constant. \
\[Alpha]0 is the initial direction and \[Kappa] the constant curvature of \
line propagation.\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelMeanRadius", "::", "usage"}], "=", 
   "\"\<LineKernelMeanRadius[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Alpha]] \
renders the average polar radius with final direction \[Alpha] for the exact \
stochastic line propagation kernel with periodic boundaries for \[Alpha] at \
\[PlusMinus]\[Pi]. \[Sigma] is the angular diffusion constant randomizing the \
direction of line propagation. \[Lambda] is the line decay constant. \
\[Alpha]0 is the initial direction and \[Kappa] the constant curvature of \
line propagation.\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FourierInfiniteLineKernel", "::", "usage"}], " ", "=", " ", 
   "\"\<FourierInfiniteLineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\
\[Omega]x,\[Omega]y,\[Alpha]] renders a spatially Fourier-transformed, exact \
kernel of the stochastic line propagation with absorbing, non-periodic \
boundaries for \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the angular \
diffusion constant randomizing the direction of line propagation. \[Lambda] \
is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] \
the constant curvature of line propagation. \[Omega]x and \[Omega]y are the \
Cartesian variables of Fourier space and \[Alpha] is the line direction, that \
is not Fourier-transformed. FourierLineKernel[\[Sigma],\[Lambda],\[Alpha]0,\
\[Kappa]][\[Omega]x,\[Omega]y,{min\[Alpha],max\[Alpha],d\[Alpha]}] renders a \
range of kernel values for \[Alpha]=min\[Alpha], min\[Alpha]+d\[Alpha],... \
max\[Alpha]. \
FourierLineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]x,\[Omega]y,{\
n\[Alpha]}] renders the range of n\[Alpha] kernel values for \
\[Alpha]=-\[Pi]+2\[Pi]/n\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \[Pi].\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FourierInfiniteLineDiffusionKernel", "::", "usage"}], " ", "=", 
   " ", "\"\<FourierInfiniteLineDiffusionKernel[\[Sigma],\[Sigma]\[Alpha],\
\[Lambda],\[Alpha]0][\[Omega]x,\[Omega]y,\[Alpha]] renders a spatially \
Fourier-transformed, exact kernel of the stochastic line diffusion with \
absorbing, non-periodic boundaries for \[Alpha] at \[PlusMinus]\[Infinity]. \
\[Sigma] is the spatial diffusion constant in \[Alpha]-direction. \[Sigma]\
\[Alpha] is the angular diffusion constant randomizing the direction of line \
propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial \
direction of line propagation. \[Omega]x and \[Omega]y are the Cartesian \
variables of Fourier space and \[Alpha] is the line direction, that is not \
Fourier-transformed. FourierInfiniteLineDiffusionKernel[\[Sigma],\[Sigma]\
\[Alpha],\[Lambda],\[Alpha]0][\[Omega]x,\[Omega]y,{min\[Alpha],max\[Alpha],d\
\[Alpha]}] renders a range of kernel values for \[Alpha]=min\[Alpha], min\
\[Alpha]+d\[Alpha],... max\[Alpha]. FourierInfiniteLineDiffusionKernel[\
\[Sigma],\[Sigma]\[Alpha],\[Lambda],\[Alpha]0][\[Omega]x,\[Omega]y,{n\[Alpha]}\
] renders the range of n\[Alpha] kernel values for \[Alpha]=-\[Pi]+2\[Pi]/n\
\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \[Pi].\>\""}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FourierLineKernel", "::", "usage"}], " ", "=", " ", 
   "\"\<FourierLineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]x,\
\[Omega]y,\[Alpha]] renders a spatially Fourier-transformed, exact kernel of \
the stochastic line propagation with periodic boundaries for \[Alpha] at \
\[PlusMinus]\[Pi]. \[Sigma] is the angular diffusion constant randomizing the \
direction of line propagation. \[Lambda] is the line decay constant. \
\[Alpha]0 is the initial direction and \[Kappa] the constant curvature of \
line propagation. \[Omega]x and \[Omega]y are the Cartesian variables of \
Fourier space and \[Alpha] is the line direction, that is not \
Fourier-transformed. \
FourierLineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]x,\[Omega]y,{\
min\[Alpha],max\[Alpha],d\[Alpha]}] renders a range of kernel values for \
\[Alpha]=min\[Alpha], min\[Alpha]+d\[Alpha],... max\[Alpha]. \
FourierLineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]x,\[Omega]y,{\
n\[Alpha]}] renders the range of n\[Alpha] kernel values for \
\[Alpha]=-\[Pi]+2\[Pi]/n\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \[Pi].\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FourierInfiniteLineKernelPolar", "::", "usage"}], " ", "=", " ", 
   "\"\<FourierLineKernelPolar[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]\
r,\[Omega]\[CurlyPhi],\[Alpha]] renders a spatially Fourier-transformed, \
exact kernel of the stochastic line propagation with absorbing, non-periodic \
boundaries for \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the angular \
diffusion constant randomizing the direction of line propagation. \[Lambda] \
is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] \
the constant curvature of line propagation. \[Omega]r and \[Omega]\[CurlyPhi] \
are the polar variables of Fourier space and \[Alpha] is the line direction, \
that is not Fourier-transformed. FourierLineKernelPolar[\[Sigma],\[Lambda],\
\[Alpha]0,\[Kappa]][\[Omega]r,\[Omega]\[CurlyPhi],{min\[Alpha],max\[Alpha],d\
\[Alpha]}] renders a range of kernel values for \[Alpha]=min\[Alpha], min\
\[Alpha]+d\[Alpha],... max\[Alpha]. \
FourierLineKernelPolar[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]r,\
\[Omega]\[CurlyPhi],{n\[Alpha]}] renders the range of n\[Alpha] kernel values \
for \[Alpha]=-\[Pi]+2\[Pi]/n\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \
\[Pi].\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FourierLineKernelPolar", "::", "usage"}], " ", "=", " ", 
   "\"\<FourierLineKernelPolar[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]\
r,\[Omega]\[CurlyPhi],\[Alpha]] renders a spatially Fourier-transformed, \
exact kernel of the stochastic line propagation with periodic boundaries for \
\[Alpha] at \[PlusMinus]\[Pi]. \[Sigma] is the angular diffusion constant \
randomizing the direction of line propagation. \[Lambda] is the line decay \
constant. \[Alpha]0 is the initial direction and \[Kappa] the constant \
curvature of line propagation. \[Omega]r and \[Omega]\[CurlyPhi] are the \
polar variables of Fourier space and \[Alpha] is the line direction, that is \
not Fourier-transformed. FourierLineKernelPolar[\[Sigma],\[Lambda],\[Alpha]0,\
\[Kappa]][\[Omega]r,\[Omega]\[CurlyPhi],{min\[Alpha],max\[Alpha],d\[Alpha]}] \
renders a range of kernel values for \[Alpha]=min\[Alpha], min\[Alpha]+d\
\[Alpha],... max\[Alpha]. \
FourierLineKernelPolar[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\[Omega]r,\
\[Omega]\[CurlyPhi],{n\[Alpha]}] renders the range of n\[Alpha] kernel values \
for \[Alpha]=-\[Pi]+2\[Pi]/n\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \
\[Pi].\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FourierCyclicLineKernel", "::", "usage"}], " ", "=", " ", 
   "\"\<FourierCyclicLineKernel[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],n][\
\[Omega]x,\[Omega]y,\[Alpha]] renders a spatially Fourier-transformed, exact \
kernel of the stochastic line propagation with periodic boundaries for \
\[Alpha] at \[PlusMinus]\[Pi]. \[Sigma] is the angular diffusion constant \
randomizing the direction of line propagation. \[Lambda] is the line decay \
constant. \[Alpha]0 is the initial direction and \[Kappa] the constant \
curvature of line propagation. n denotes the number of 2\[Pi] intervals to \
the left and the right of [-\[Pi],\[Pi]], from which nonperiodic kernel \
values are mapped into [-\[Pi],\[Pi]] to achieve periodicity. \[Omega]x and \
\[Omega]y are the Cartesian variables of Fourier space and \[Alpha] is the \
line direction, that is not Fourier-transformed. FourierCyclicLineKernel[\
\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],n][\[Omega]x,\[Omega]y,{n\[Alpha]}] \
renders the range of n\[Alpha] kernel values for \[Alpha]=-\[Pi]+2\[Pi]/n\
\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \[Pi].\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FourierCyclicLineKernelPolar", "::", "usage"}], " ", "=", " ", 
   "\"\<FourierCyclicLineKernelPolar[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],n][\
\[Omega]r,\[Omega]\[CurlyPhi],\[Alpha]] renders a spatially \
Fourier-transformed, exact kernel of the stochastic line propagation with \
periodic boundaries for \[Alpha] at \[PlusMinus]\[Pi]. \[Sigma] is the \
angular diffusion constant randomizing the direction of line propagation. \
\[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \
\[Kappa] the constant curvature of line propagation. n denotes the number of \
2\[Pi] intervals to the left and the right of [-\[Pi],\[Pi]], from which \
nonperiodic kernel values are mapped into [-\[Pi],\[Pi]] to achieve \
periodicity. \[Omega]r and \[Omega]\[CurlyPhi] are the polar variables of \
Fourier space and \[Alpha] is the line direction, that is not \
Fourier-transformed. \
FourierCyclicLineKernelPolar[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],n][\[Omega]\
r,\[Omega]\[CurlyPhi],{n\[Alpha]}] renders the range of n\[Alpha] kernel \
values for \[Alpha]=-\[Pi]+2\[Pi]/n\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \
\[Pi].\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FourierLineKernelApproximation", "::", "usage"}], " ", "=", " ", 
   "\"\<FourierLineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\
\[Omega]x,\[Omega]y,\[Alpha]] renders a spatially \
Fourier-transformed,approximate kernel of the stochastic line propagation \
with absorbing, non-periodic boundaries for \[Alpha] at \[PlusMinus]\
\[Infinity]. \[Sigma] is the angular diffusion constant randomizing the \
direction of line propagation. \[Lambda] is the line decay constant. \
\[Alpha]0 is the initial direction and \[Kappa] the constant curvature of \
line propagation. \[Omega]x and \[Omega]y are the Cartesian variables of \
Fourier space and \[Alpha] is the line direction, that is not \
Fourier-transformed. FourierLineKernelApproximation[\[Sigma],\[Lambda],\
\[Alpha]0,\[Kappa]][\[Omega]x,\[Omega]y,{min\[Alpha],max\[Alpha],d\[Alpha]}] \
renders a range of kernel values for \[Alpha]=min\[Alpha], min\[Alpha]+d\
\[Alpha],... max\[Alpha]. FourierLineKernelApproximation[\[Sigma],\[Lambda],\
\[Alpha]0,\[Kappa]][\[Omega]x,\[Omega]y,{n\[Alpha]}] renders the range of n\
\[Alpha] kernel values for \[Alpha]=-\[Pi]+2\[Pi]/n\[Alpha], -\[Pi]+4\[Pi]/n\
\[Alpha],..., \[Pi].\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelApproximation", "::", "usage"}], " ", "=", " ", 
   "\"\<LineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,y,\
\[Alpha]] renders the approximate kernel of the stochastic line propagation \
with absorbing, non-periodic boundaries for \[Alpha] at \[PlusMinus]\
\[Infinity]. \[Sigma] is the angular diffusion constant randomizing the \
direction of line propagation. \[Lambda] is the line decay constant. \
\[Alpha]0 is the initial direction and \[Kappa] the constant curvature of \
line propagation. x and y are the Cartesian spatial variables and \[Alpha] is \
the line direction. LineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\
\[Kappa]][x,y,{min\[Alpha],max\[Alpha],d\[Alpha]}] renders a range of kernel \
values for \[Alpha]=min\[Alpha], min\[Alpha]+d\[Alpha],... max\[Alpha]. \
LineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,y,{n\[Alpha]}\
] renders the range of n\[Alpha] kernel values for \[Alpha]=-\[Pi]+2\[Pi]/n\
\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \[Pi]. \
LineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,y] returns \
the values of the xy-marginal.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NLineKernelApproximation", "::", "usage"}], " ", "=", " ", 
   "\"\<NLineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y,\
\[Alpha]] calculates numerically the approximate kernel of the stochastic \
line propagation with absorbing, non-periodic boundaries for \[Alpha] at \
\[PlusMinus]\[Infinity]. \[Sigma] is the angular diffusion constant \
randomizing the direction of line propagation. \[Lambda] is the line decay \
constant. \[Alpha]0 is the initial direction and \[Kappa] the constant \
curvature of line propagation. x and y are the Cartesian spatial variables \
and \[Alpha] is the line direction.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NLineKernelApproximationList", "::", "usage"}], " ", "=", " ", 
   "\"\<NLineKernelApproximationList[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,\
y,min\[Alpha],max\[Alpha],d\[Alpha]] calculates numerically a range of  \
approximate kernel values of the stochastic line propagation with absorbing, \
non-periodic boundaries for \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is \
the angular diffusion constant randomizing the direction of line propagation. \
\[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \
\[Kappa] the constant curvature of line propagation. x and y are the \
Cartesian spatial variables and \[Alpha] is the line direction. \
NLineKernelApproximationList[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,y,min\
\[Alpha],max\[Alpha],d\[Alpha]] renders the range of kernel values for \
\[Alpha]=min\[Alpha], min\[Alpha]+d\[Alpha],... max\[Alpha].\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NLineKernelApproximationMarginal", "::", "usage"}], " ", "=", 
   " ", "\"\<NLineKernelApproximationMarginal[\[Sigma],\[Lambda],\[Alpha]0,\
\[Kappa],x,y] calculates numerically the marginal kernel values of the \
stochastic line propagation with absorbing, non-periodic boundaries for the \
line direction \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the angular \
diffusion constant randomizing the direction of line propagation. \[Lambda] \
is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] \
the constant curvature of line propagation. x and y are the Cartesian spatial \
variables.\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelDensityApproximation", "::", "usage"}], " ", "=", " ", 
   "\"\<LineKernelDensityApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][\
x,dx,y,dy,\[Alpha],d\[Alpha]] renders the approximate kernel density of the \
stochastic line propagation with absorbing, non-periodic boundaries for \
\[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the angular diffusion \
constant randomizing the direction of line propagation. \[Lambda] is the line \
decay constant. \[Alpha]0 is the initial direction and \[Kappa] the constant \
curvature of line propagation. x and y are the Cartesian spatial variables \
and \[Alpha] is the line direction. dx, dy, and d\[Alpha] are the sampling \
step sizes. \
LineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,dx,y,dy,{min\
\[Alpha],max\[Alpha],d\[Alpha]}] renders a range of kernel density values for \
\[Alpha]=min\[Alpha], min\[Alpha]+d\[Alpha],... max\[Alpha]. \
LineKernelApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,dx,y,dy,{n\
\[Alpha]}] renders the range of n\[Alpha] kernel density values for \
\[Alpha]=-\[Pi]+2\[Pi]/n\[Alpha], -\[Pi]+4\[Pi]/n\[Alpha],..., \[Pi]. \
LineKernelDensityApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa]][x,dx,y,\
dy] returns the density values of the xy-marginal.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NLineKernelDensityApproximation", "::", "usage"}], " ", "=", " ", 
   "\"\<NLineKernelDensityApproximation[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],\
x,dx,y,dy,\[Alpha],d\[Alpha]] calculates numerically the approximate kernel \
density of the stochastic line propagation with absorbing, non-periodic \
boundaries for \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the angular \
diffusion constant randomizing the direction of line propagation. \[Lambda] \
is the line decay constant. \[Alpha]0 is the initial direction and \[Kappa] \
the constant curvature of line propagation. x and y are the Cartesian spatial \
variables and \[Alpha] is the line direction. dx, dy, and d\[Alpha] are the \
the sampling step sizes.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NLineKernelDensityApproximationList", "::", "usage"}], " ", "=", 
   " ", "\"\<NLineKernelDensityApproximationList[\[Sigma],\[Lambda],\[Alpha]0,\
\[Kappa],x,dx,y,dy,min\[Alpha],max\[Alpha],d\[Alpha]] calculates numerically \
a range of  approximate kernel values of the stochastic line propagation with \
absorbing, non-periodic boundaries for \[Alpha] at \[PlusMinus]\[Infinity]. \
\[Sigma] is the angular diffusion constant randomizing the direction of line \
propagation. \[Lambda] is the line decay constant. \[Alpha]0 is the initial \
direction and \[Kappa] the constant curvature of line propagation. x and y \
are the Cartesian spatial variables and \[Alpha] is the line direction. dx, \
dy, and d\[Alpha] are the the sampling step sizes. \
NLineKernelDensityApproximationList[\[Sigma],\[Lambda],\[Alpha]0,\[Kappa],x,\
dx,y,dy,min\[Alpha],max\[Alpha],d\[Alpha]] renders the range of kernel values \
for \[Alpha]=min\[Alpha], min\[Alpha]+d\[Alpha],... max\[Alpha].\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NLineKernelDensityApproximationMarginal", "::", "usage"}], " ", 
   "=", " ", 
   "\"\<NLineKernelDensityApproximationMarginal[\[Sigma],\[Lambda],\[Alpha]0,\
\[Kappa],x,dx,y,dy] calculates numerically the marginal kernel density values \
of the stochastic line propagation with absorbing, non-periodic boundaries \
for the line direction \[Alpha] at \[PlusMinus]\[Infinity]. \[Sigma] is the \
angular diffusion constant randomizing the direction of line propagation. \
\[Lambda] is the line decay constant. \[Alpha]0 is the initial direction and \
\[Kappa] the constant curvature of line propagation. x and y are the \
Cartesian spatial variables. dx and dy are the the sampling step \
sizes.\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FloquetSign", "::", "usage"}], "=", " ", 
   "\"\<FloquetSign[a,q] provides the sign \[Chi] of the Floquet function \
FloquetF[a,q,z] = MathieuC[a,q,z]+ \[Chi] MathieuS[a,q,z].\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FloquetExponent", "::", "usage"}], "=", 
   "\"\<FloquetExponent[a,q] provides the Floquet exponent.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Angle", "::", "usage"}], "=", 
   "\"\<Angle[x,y] renders like ArcTan the angle between -\[Pi] and \[Pi] \
between the vector {x,y} and the x-axis. Angle[0,0] renders 0 without a \
warning.\>\""}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Radius", "::", "usage"}], "=", 
  "\"\<Radius[x,y] renders the length of vector {x,y}.\>\""}]}], \
"PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Derivation", "Section"],

Cell[CellGroupData[{

Cell["\<\
Fourier-Transformed, Exact Kernel with Boundaries at \[Alpha]  = \[PlusMinus]\
\[Infinity]\
\>", "Subsection"],

Cell["\<\
Notational substitutions \[Alpha] \[Rule] \[Beta], e\[Rule] R, d\[Rule] \
\[Gamma] with respect to Remco Duits.\
\>", "Text"],

Cell["\<\
Mumfolrd Fokker-Planck equation for the propagation of a line or contour is\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
     RowBox[{
      SubscriptBox["\[PartialD]", "x"], "#"}]}], " ", "+", " ", 
    RowBox[{
     RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
     RowBox[{
      SubscriptBox["\[PartialD]", "y"], "#"}]}], " ", "+", 
    RowBox[{"\[Kappa]", " ", 
     RowBox[{
      SubscriptBox["\[PartialD]", "\[Alpha]"], "#"}]}], "-", " ", 
    RowBox[{
     FractionBox[
      SuperscriptBox["\[Sigma]", "2"], "2"], 
     RowBox[{
      SubscriptBox["\[PartialD]", 
       RowBox[{"\[Alpha]", ",", "\[Alpha]"}]], "#"}]}], " ", "+", " ", 
    RowBox[{"\[Lambda]", "#"}]}], ")"}], " ", "\[Equal]", " ", 
  RowBox[{"DiracDelta", "[", 
   RowBox[{"x", ",", "y", ",", 
    RowBox[{"\[Alpha]", "-", "\[Alpha]0"}]}], "]"}]}]], "Input"],

Cell["After Fourier transformation in x and y, we obtain", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]x"}], ")"}], "#"}], " ", 
    "+", " ", 
    RowBox[{
     RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]y"}], ")"}], " ", "#"}], 
    " ", "+", 
    RowBox[{"\[Kappa]", " ", 
     RowBox[{
      SubscriptBox["\[PartialD]", "\[Alpha]"], "#"}]}], "-", " ", 
    RowBox[{
     FractionBox[
      SuperscriptBox["\[Sigma]", "2"], "2"], 
     RowBox[{
      SubscriptBox["\[PartialD]", 
       RowBox[{"\[Alpha]", ",", "\[Alpha]"}]], "#"}]}], " ", "+", " ", 
    RowBox[{"\[Lambda]", "#"}]}], ")"}], " ", "\[Equal]", " ", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[Pi]"}]], 
   RowBox[{"DiracDelta", "[", 
    RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}]}]}]], "Input"],

Cell[TextData[{
 "Polar coordinates in Fouier space: ",
 Cell[BoxData[
  RowBox[{"\[Omega]R", " ", "=", " ", 
   RowBox[{
    RowBox[{
     SqrtBox[
      RowBox[{
       SuperscriptBox["\[Omega]x", "2"], "+", 
       SuperscriptBox["\[Omega]y", "2"]}]], " ", "and", "  ", 
     "\[Omega]\[CurlyPhi]"}], " ", "=", " ", 
    RowBox[{
     RowBox[{"ArcTan", "[", 
      RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], "."}]}]}]]],
 " So that \[Omega]x= \[Omega]R Cos[\[Omega]\[CurlyPhi]] and \[Omega]y= \
\[Omega]R Sin[\[Omega]\[CurlyPhi]]."
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]R", " ", 
       RowBox[{"Cos", "[", "\[Omega]\[CurlyPhi]", "]"}]}], ")"}], "#"}], " ", 
    "+", " ", 
    RowBox[{
     RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]R", " ", 
       RowBox[{"Sin", "[", "\[Omega]\[CurlyPhi]", "]"}]}], ")"}], " ", "#"}], 
    " ", "+", 
    RowBox[{"\[Kappa]", " ", 
     RowBox[{
      SubscriptBox["\[PartialD]", "\[Alpha]"], "#"}]}], "-", " ", 
    RowBox[{
     FractionBox[
      SuperscriptBox["\[Sigma]", "2"], "2"], 
     RowBox[{
      SubscriptBox["\[PartialD]", 
       RowBox[{"\[Alpha]", ",", "\[Alpha]"}]], "#"}]}], " ", "+", " ", 
    RowBox[{"\[Lambda]", "#"}]}], ")"}], " ", "\[Equal]", " ", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[Pi]"}]], 
   RowBox[{"DiracDelta", "[", 
    RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]R", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
        RowBox[{"Cos", "[", "\[Omega]\[CurlyPhi]", "]"}]}], "+", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
        RowBox[{"Sin", "[", "\[Omega]\[CurlyPhi]", "]"}]}]}], ")"}], "#"}], 
    " ", "+", 
    RowBox[{"\[Kappa]", " ", 
     RowBox[{
      SubscriptBox["\[PartialD]", "\[Alpha]"], "#"}]}], "-", " ", 
    RowBox[{
     FractionBox[
      SuperscriptBox["\[Sigma]", "2"], "2"], 
     RowBox[{
      SubscriptBox["\[PartialD]", 
       RowBox[{"\[Alpha]", ",", "\[Alpha]"}]], "#"}]}], " ", "+", " ", 
    RowBox[{"\[Lambda]", "#"}]}], ")"}], " ", "\[Equal]", " ", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[Pi]"}]], 
   RowBox[{"DiracDelta", "[", 
    RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}]}]}]], "Input"],

Cell["\<\
Here we use the trigonometric identity Cos[\[Alpha] - \[Beta]] = \
Cos[\[Alpha]] Cos[\[Beta]]+Sin[\[Alpha]] Sin[\[Beta]].\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]R", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"\[Alpha]", "-", "\[Omega]\[CurlyPhi]"}], "]"}], "#"}], " ", 
    "+", 
    RowBox[{"\[Kappa]", " ", 
     RowBox[{
      SubscriptBox["\[PartialD]", "\[Alpha]"], "#"}]}], "-", " ", 
    RowBox[{
     FractionBox[
      SuperscriptBox["\[Sigma]", "2"], "2"], 
     RowBox[{
      SubscriptBox["\[PartialD]", 
       RowBox[{"\[Alpha]", ",", "\[Alpha]"}]], "#"}]}], " ", "+", " ", 
    RowBox[{"\[Lambda]", "#"}]}], ")"}], " ", "\[Equal]", " ", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[Pi]"}]], 
   RowBox[{"DiracDelta", "[", 
    RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}]}]}]], "Input"],

Cell[TextData[{
 "Divide both sides by -",
 Cell[BoxData[
  RowBox[{"2", "/", 
   SuperscriptBox["\[Sigma]", "2"]}]]],
 "."
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[PartialD]", 
      RowBox[{"\[Alpha]", ",", "\[Alpha]"}]], "#"}], " ", "+", " ", 
    RowBox[{
     FractionBox[
      RowBox[{"2", "\[ImaginaryI]"}], 
      SuperscriptBox["\[Sigma]", "2"]], " ", "\[Omega]R", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"\[Alpha]", "-", "\[Omega]\[CurlyPhi]"}], "]"}], "#"}], "  ", 
    "-", " ", 
    RowBox[{
     FractionBox[
      RowBox[{"2", " ", "\[Kappa]"}], 
      SuperscriptBox["\[Sigma]", "2"]], " ", 
     RowBox[{
      SubscriptBox["\[PartialD]", "\[Alpha]"], "#"}]}], "-", " ", 
    RowBox[{
     FractionBox[
      RowBox[{"2", "\[Lambda]"}], 
      SuperscriptBox["\[Sigma]", "2"]], "#"}]}], ")"}], " ", "\[Equal]", " ", 
  
  RowBox[{
   FractionBox[
    RowBox[{"-", "1"}], 
    RowBox[{"\[Pi]", " ", 
     SuperscriptBox["\[Sigma]", "2"]}]], " ", 
   RowBox[{"DiracDelta", "[", 
    RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}]}]}]], "Input"],

Cell["This ODE is solved by a Mathieu functions.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DSolve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["\[PartialD]", 
       RowBox[{"\[Alpha]", ",", "\[Alpha]"}]], 
      RowBox[{"f", "[", "\[Alpha]", "]"}]}], " ", "+", " ", 
     RowBox[{
      FractionBox[
       RowBox[{"2", "\[ImaginaryI]"}], 
       SuperscriptBox["\[Sigma]", "2"]], " ", "\[Omega]R", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{"\[Alpha]", "-", "\[Omega]\[CurlyPhi]"}], "]"}], 
      RowBox[{"f", "[", "\[Alpha]", "]"}]}], "   ", "-", " ", 
     RowBox[{
      FractionBox[
       RowBox[{"2", " ", "\[Kappa]"}], 
       SuperscriptBox["\[Sigma]", "2"]], " ", 
      RowBox[{
       SubscriptBox["\[PartialD]", "\[Alpha]"], 
       RowBox[{"f", "[", "\[Alpha]", "]"}]}]}], "-", 
     RowBox[{
      FractionBox[
       RowBox[{"2", "\[Lambda]"}], 
       SuperscriptBox["\[Sigma]", "2"]], 
      RowBox[{"f", "[", "\[Alpha]", "]"}]}]}], "\[Equal]", "0"}], ",", 
   RowBox[{"f", "[", "\[Alpha]", "]"}], ",", "\[Alpha]"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"f", "[", "\[Alpha]", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       FractionBox[
        RowBox[{"\[Alpha]", " ", "\[Kappa]"}], 
        SuperscriptBox["\[Sigma]", "2"]]], " ", 
      RowBox[{"C", "[", "1", "]"}], " ", 
      RowBox[{"MathieuC", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Kappa]", "2"], "+", 
             RowBox[{"2", " ", "\[Lambda]", " ", 
              SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
          SuperscriptBox["\[Sigma]", "4"]]}], ",", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
          SuperscriptBox["\[Sigma]", "2"]]}], ",", 
        FractionBox[
         RowBox[{"\[Alpha]", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}]}], 
     "+", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       FractionBox[
        RowBox[{"\[Alpha]", " ", "\[Kappa]"}], 
        SuperscriptBox["\[Sigma]", "2"]]], " ", 
      RowBox[{"C", "[", "2", "]"}], " ", 
      RowBox[{"MathieuS", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Kappa]", "2"], "+", 
             RowBox[{"2", " ", "\[Lambda]", " ", 
              SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
          SuperscriptBox["\[Sigma]", "4"]]}], ",", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
          SuperscriptBox["\[Sigma]", "2"]]}], ",", 
        FractionBox[
         RowBox[{"\[Alpha]", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
       "]"}]}]}]}], "}"}], "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"C", "[", "1", "]"}], " ", 
   SuperscriptBox["\[ExponentialE]", 
    FractionBox[
     RowBox[{"\[Alpha]", " ", "\[Kappa]"}], 
     SuperscriptBox["\[Sigma]", "2"]]], " ", 
   RowBox[{"MathieuC", "[", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["\[Kappa]", "2"], "+", 
          RowBox[{"2", " ", "\[Lambda]", " ", 
           SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
       SuperscriptBox["\[Sigma]", "4"]]}], ",", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
       SuperscriptBox["\[Sigma]", "2"]]}], ",", 
     FractionBox[
      RowBox[{"\[Alpha]", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}]}], "+", 
  
  RowBox[{
   RowBox[{"C", "[", "2", "]"}], "  ", 
   SuperscriptBox["\[ExponentialE]", 
    FractionBox[
     RowBox[{"\[Alpha]", " ", "\[Kappa]"}], 
     SuperscriptBox["\[Sigma]", "2"]]], " ", 
   RowBox[{"MathieuS", "[", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["\[Kappa]", "2"], "+", 
          RowBox[{"2", " ", "\[Lambda]", " ", 
           SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
       SuperscriptBox["\[Sigma]", "4"]]}], ",", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
       SuperscriptBox["\[Sigma]", "2"]]}], ",", 
     FractionBox[
      RowBox[{"\[Alpha]", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
    "]"}]}]}]], "Input"],

Cell[TextData[{
 "The solution that vanishes for ",
 Cell[BoxData[
  UnderscriptBox["lim", 
   RowBox[{"\[Alpha]", "\[Rule]", "\[Infinity]"}]]]],
 " |\[Alpha]| \[Rule] 0 is for \[Alpha]>0 (c>0)"
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MathieuPositive", "[", 
    RowBox[{"a_", ",", "b_", ",", "c_"}], "]"}], " ", "=", " ", 
   RowBox[{
    RowBox[{"MathieuC", "[", 
     RowBox[{"a", ",", "b", ",", "c"}], "]"}], "+", 
    RowBox[{"\[Chi]", " ", 
     RowBox[{"MathieuS", "[", 
      RowBox[{"a", ",", "b", ",", "c"}], "]"}]}]}]}], ";"}]], "Input"],

Cell["and for \[Alpha] < 0 (c<0) it's", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MathieuNegative", "[", 
    RowBox[{"a_", ",", "b_", ",", "c_"}], "]"}], " ", "=", " ", 
   RowBox[{
    RowBox[{"MathieuC", "[", 
     RowBox[{"a", ",", "b", ",", "c"}], "]"}], "-", 
    RowBox[{"\[Chi]", " ", 
     RowBox[{"MathieuS", "[", 
      RowBox[{"a", ",", "b", ",", "c"}], "]"}]}]}]}], ";"}]], "Input"],

Cell["\<\
Merging the solution to the left and the right side of the \[Delta]-function. \
Continuity at \[Alpha]=\[Alpha]0 and \"active\" kinck in the first derivative:\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"solm", " ", "=", " ", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{"\[Alpha]", " ", "\[Kappa]"}], 
      SuperscriptBox["\[Sigma]", "2"]]], " ", 
    RowBox[{"MathieuNegative", "[", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["\[Kappa]", "2"], "+", 
           RowBox[{"2", " ", "\[Lambda]", " ", 
            SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
        SuperscriptBox["\[Sigma]", "4"]]}], ",", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
        SuperscriptBox["\[Sigma]", "2"]]}], ",", 
      FractionBox[
       RowBox[{"\[Alpha]", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}]}]}], 
  ";", 
  RowBox[{"solp", " ", "=", " ", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{"\[Alpha]", " ", "\[Kappa]"}], 
      SuperscriptBox["\[Sigma]", "2"]]], " ", 
    RowBox[{"MathieuPositive", "[", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["\[Kappa]", "2"], "+", 
           RowBox[{"2", " ", "\[Lambda]", " ", 
            SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
        SuperscriptBox["\[Sigma]", "4"]]}], ",", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
        SuperscriptBox["\[Sigma]", "2"]]}], ",", 
      FractionBox[
       RowBox[{"\[Alpha]", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}]}]}], 
  ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol", " ", "=", " ", 
  RowBox[{
   RowBox[{"Solve", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Cm", " ", 
         RowBox[{"(", 
          RowBox[{"solm", " ", "/.", " ", 
           RowBox[{"\[Alpha]", "\[Rule]", "\[Alpha]0"}]}], ")"}]}], "  ", 
        "\[Equal]", " ", 
        RowBox[{"Cp", " ", 
         RowBox[{"(", 
          RowBox[{"solp", " ", "/.", " ", 
           RowBox[{"\[Alpha]", "\[Rule]", "\[Alpha]0"}]}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{"Cp", " ", "solp"}], ",", "\[Alpha]"}], "]"}], "/.", " ", 
           RowBox[{"\[Alpha]", "\[Rule]", " ", "\[Alpha]0"}]}], ")"}], " ", 
         "-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{"Cm", " ", "solm"}], ",", "\[Alpha]"}], "]"}], "/.", " ", 
           RowBox[{"\[Alpha]", "\[Rule]", " ", "\[Alpha]0"}]}], ")"}]}], " ", 
        "\[Equal]", " ", 
        FractionBox[
         RowBox[{"-", "1"}], 
         RowBox[{"\[Pi]", " ", 
          SuperscriptBox["\[Sigma]", "2"]}]]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Cp", ",", "Cm"}], "}"}]}], "\[IndentingNewLine]", "]"}], "//", 
   "Simplify"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Cp", "\[Rule]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"\[Alpha]0", " ", "\[Kappa]"}], 
           SuperscriptBox["\[Sigma]", "2"]]}]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"MathieuC", "[", 
            RowBox[{
             RowBox[{"-", 
              FractionBox[
               RowBox[{"4", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["\[Kappa]", "2"], "+", 
                  RowBox[{"2", " ", "\[Lambda]", " ", 
                   SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
               SuperscriptBox["\[Sigma]", "4"]]}], ",", 
             RowBox[{"-", 
              FractionBox[
               RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
               SuperscriptBox["\[Sigma]", "2"]]}], ",", 
             FractionBox[
              RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
            "]"}]}], "+", 
          RowBox[{"\[Chi]", " ", 
           RowBox[{"MathieuS", "[", 
            RowBox[{
             RowBox[{"-", 
              FractionBox[
               RowBox[{"4", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["\[Kappa]", "2"], "+", 
                  RowBox[{"2", " ", "\[Lambda]", " ", 
                   SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
               SuperscriptBox["\[Sigma]", "4"]]}], ",", 
             RowBox[{"-", 
              FractionBox[
               RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
               SuperscriptBox["\[Sigma]", "2"]]}], ",", 
             FractionBox[
              RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
            "]"}]}]}], ")"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"\[Pi]", " ", 
        SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"MathieuCPrime", "[", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["\[Kappa]", "2"], "+", 
                   RowBox[{"2", " ", "\[Lambda]", " ", 
                    SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
                SuperscriptBox["\[Sigma]", "4"]]}], ",", 
              RowBox[{"-", 
               FractionBox[
                RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
                SuperscriptBox["\[Sigma]", "2"]]}], ",", 
              FractionBox[
               RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
             "]"}]}], " ", 
           RowBox[{"MathieuS", "[", 
            RowBox[{
             RowBox[{"-", 
              FractionBox[
               RowBox[{"4", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["\[Kappa]", "2"], "+", 
                  RowBox[{"2", " ", "\[Lambda]", " ", 
                   SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
               SuperscriptBox["\[Sigma]", "4"]]}], ",", 
             RowBox[{"-", 
              FractionBox[
               RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
               SuperscriptBox["\[Sigma]", "2"]]}], ",", 
             FractionBox[
              RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
            "]"}]}], "+", 
          RowBox[{
           RowBox[{"MathieuC", "[", 
            RowBox[{
             RowBox[{"-", 
              FractionBox[
               RowBox[{"4", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["\[Kappa]", "2"], "+", 
                  RowBox[{"2", " ", "\[Lambda]", " ", 
                   SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
               SuperscriptBox["\[Sigma]", "4"]]}], ",", 
             RowBox[{"-", 
              FractionBox[
               RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
               SuperscriptBox["\[Sigma]", "2"]]}], ",", 
             FractionBox[
              RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
            "]"}], " ", 
           RowBox[{"MathieuSPrime", "[", 
            RowBox[{
             RowBox[{"-", 
              FractionBox[
               RowBox[{"4", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["\[Kappa]", "2"], "+", 
                  RowBox[{"2", " ", "\[Lambda]", " ", 
                   SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
               SuperscriptBox["\[Sigma]", "4"]]}], ",", 
             RowBox[{"-", 
              FractionBox[
               RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
               SuperscriptBox["\[Sigma]", "2"]]}], ",", 
             FractionBox[
              RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
            "]"}]}]}], ")"}]}], ")"}]}]}], ",", 
    RowBox[{"Cm", "\[Rule]", 
     RowBox[{"-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"\[Alpha]0", " ", "\[Kappa]"}], 
            SuperscriptBox["\[Sigma]", "2"]]}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"MathieuC", "[", 
            RowBox[{
             RowBox[{"-", 
              FractionBox[
               RowBox[{"4", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["\[Kappa]", "2"], "+", 
                  RowBox[{"2", " ", "\[Lambda]", " ", 
                   SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
               SuperscriptBox["\[Sigma]", "4"]]}], ",", 
             RowBox[{"-", 
              FractionBox[
               RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
               SuperscriptBox["\[Sigma]", "2"]]}], ",", 
             FractionBox[
              RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
            "]"}], "+", 
           RowBox[{"\[Chi]", " ", 
            RowBox[{"MathieuS", "[", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["\[Kappa]", "2"], "+", 
                   RowBox[{"2", " ", "\[Lambda]", " ", 
                    SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
                SuperscriptBox["\[Sigma]", "4"]]}], ",", 
              RowBox[{"-", 
               FractionBox[
                RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
                SuperscriptBox["\[Sigma]", "2"]]}], ",", 
              FractionBox[
               RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
             "]"}]}]}], ")"}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{"\[Pi]", " ", 
         SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", 
             RowBox[{"MathieuCPrime", "[", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["\[Kappa]", "2"], "+", 
                    RowBox[{"2", " ", "\[Lambda]", " ", 
                    SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
                 SuperscriptBox["\[Sigma]", "4"]]}], ",", 
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
                 SuperscriptBox["\[Sigma]", "2"]]}], ",", 
               FractionBox[
                RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
              "]"}]}], " ", 
            RowBox[{"MathieuS", "[", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["\[Kappa]", "2"], "+", 
                   RowBox[{"2", " ", "\[Lambda]", " ", 
                    SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
                SuperscriptBox["\[Sigma]", "4"]]}], ",", 
              RowBox[{"-", 
               FractionBox[
                RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
                SuperscriptBox["\[Sigma]", "2"]]}], ",", 
              FractionBox[
               RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
             "]"}]}], "+", 
           RowBox[{
            RowBox[{"MathieuC", "[", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["\[Kappa]", "2"], "+", 
                   RowBox[{"2", " ", "\[Lambda]", " ", 
                    SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
                SuperscriptBox["\[Sigma]", "4"]]}], ",", 
              RowBox[{"-", 
               FractionBox[
                RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
                SuperscriptBox["\[Sigma]", "2"]]}], ",", 
              FractionBox[
               RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
             "]"}], " ", 
            RowBox[{"MathieuSPrime", "[", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["\[Kappa]", "2"], "+", 
                   RowBox[{"2", " ", "\[Lambda]", " ", 
                    SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
                SuperscriptBox["\[Sigma]", "4"]]}], ",", 
              RowBox[{"-", 
               FractionBox[
                RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
                SuperscriptBox["\[Sigma]", "2"]]}], ",", 
              FractionBox[
               RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
             "]"}]}]}], ")"}]}], ")"}]}]}]}]}], "}"}], "}"}]], "Output"]
}, Open  ]],

Cell["\<\
The solution for the left side with \[Alpha]<\[Alpha]0 is:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Cm", " ", "solm"}], " ", "/.", " ", 
    RowBox[{"First", "[", "sol", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Re", "[", "a", "]"}], "\[Equal]", "0"}], ",", 
     RowBox[{"d", "\[Element]", "Reals"}], ",", 
     RowBox[{"\[Alpha]", " ", "\[Element]", " ", "Reals"}]}], "}"}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}], " ", "\[Kappa]"}], 
      SuperscriptBox["\[Sigma]", "2"]]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"MathieuC", "[", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Kappa]", "2"], "+", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
           SuperscriptBox["\[Sigma]", "4"]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
           SuperscriptBox["\[Sigma]", "2"]]}], ",", 
         FractionBox[
          RowBox[{"\[Alpha]", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}]}], 
      "+", 
      RowBox[{"\[Chi]", " ", 
       RowBox[{"MathieuS", "[", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Kappa]", "2"], "+", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
           SuperscriptBox["\[Sigma]", "4"]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
           SuperscriptBox["\[Sigma]", "2"]]}], ",", 
         FractionBox[
          RowBox[{"\[Alpha]", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}]}]}],
      ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"MathieuC", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Kappa]", "2"], "+", 
             RowBox[{"2", " ", "\[Lambda]", " ", 
              SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
          SuperscriptBox["\[Sigma]", "4"]]}], ",", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
          SuperscriptBox["\[Sigma]", "2"]]}], ",", 
        FractionBox[
         RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}], 
      "+", 
      RowBox[{"\[Chi]", " ", 
       RowBox[{"MathieuS", "[", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Kappa]", "2"], "+", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
           SuperscriptBox["\[Sigma]", "4"]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
           SuperscriptBox["\[Sigma]", "2"]]}], ",", 
         FractionBox[
          RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
        "]"}]}]}], ")"}]}], ")"}], "/", 
  RowBox[{"(", 
   RowBox[{"\[Pi]", " ", 
    SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"MathieuCPrime", "[", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"4", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["\[Kappa]", "2"], "+", 
               RowBox[{"2", " ", "\[Lambda]", " ", 
                SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
            SuperscriptBox["\[Sigma]", "4"]]}], ",", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
            SuperscriptBox["\[Sigma]", "2"]]}], ",", 
          FractionBox[
           RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}]}],
        " ", 
       RowBox[{"MathieuS", "[", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Kappa]", "2"], "+", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
           SuperscriptBox["\[Sigma]", "4"]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
           SuperscriptBox["\[Sigma]", "2"]]}], ",", 
         FractionBox[
          RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}]}], 
      "+", 
      RowBox[{
       RowBox[{"MathieuC", "[", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Kappa]", "2"], "+", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
           SuperscriptBox["\[Sigma]", "4"]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
           SuperscriptBox["\[Sigma]", "2"]]}], ",", 
         FractionBox[
          RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}], 
       " ", 
       RowBox[{"MathieuSPrime", "[", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Kappa]", "2"], "+", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
           SuperscriptBox["\[Sigma]", "4"]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
           SuperscriptBox["\[Sigma]", "2"]]}], ",", 
         FractionBox[
          RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
        "]"}]}]}], ")"}]}], ")"}]}]], "Output"]
}, Open  ]],

Cell["\<\
The solution for the left side with \[Alpha]>\[Alpha]0 is:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Cp", " ", "solp"}], " ", "/.", " ", 
    RowBox[{"First", "[", "sol", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Re", "[", "a", "]"}], "\[Equal]", "0"}], ",", 
     RowBox[{"d", "\[Element]", "Reals"}], ",", 
     RowBox[{"\[Alpha]", " ", "\[Element]", " ", "Reals"}]}], "}"}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}], " ", "\[Kappa]"}], 
      SuperscriptBox["\[Sigma]", "2"]]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"MathieuC", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Kappa]", "2"], "+", 
             RowBox[{"2", " ", "\[Lambda]", " ", 
              SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
          SuperscriptBox["\[Sigma]", "4"]]}], ",", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
          SuperscriptBox["\[Sigma]", "2"]]}], ",", 
        FractionBox[
         RowBox[{"\[Alpha]", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}], "+", 
      RowBox[{"\[Chi]", " ", 
       RowBox[{"MathieuS", "[", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Kappa]", "2"], "+", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
           SuperscriptBox["\[Sigma]", "4"]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
           SuperscriptBox["\[Sigma]", "2"]]}], ",", 
         FractionBox[
          RowBox[{"\[Alpha]", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}]}]}],
      ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"MathieuC", "[", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Kappa]", "2"], "+", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
           SuperscriptBox["\[Sigma]", "4"]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
           SuperscriptBox["\[Sigma]", "2"]]}], ",", 
         FractionBox[
          RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}]}], 
      "+", 
      RowBox[{"\[Chi]", " ", 
       RowBox[{"MathieuS", "[", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Kappa]", "2"], "+", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
           SuperscriptBox["\[Sigma]", "4"]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
           SuperscriptBox["\[Sigma]", "2"]]}], ",", 
         FractionBox[
          RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
        "]"}]}]}], ")"}]}], ")"}], "/", 
  RowBox[{"(", 
   RowBox[{"\[Pi]", " ", 
    SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"MathieuCPrime", "[", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"4", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["\[Kappa]", "2"], "+", 
               RowBox[{"2", " ", "\[Lambda]", " ", 
                SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
            SuperscriptBox["\[Sigma]", "4"]]}], ",", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
            SuperscriptBox["\[Sigma]", "2"]]}], ",", 
          FractionBox[
           RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}]}],
        " ", 
       RowBox[{"MathieuS", "[", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Kappa]", "2"], "+", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
           SuperscriptBox["\[Sigma]", "4"]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
           SuperscriptBox["\[Sigma]", "2"]]}], ",", 
         FractionBox[
          RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}]}], 
      "+", 
      RowBox[{
       RowBox[{"MathieuC", "[", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Kappa]", "2"], "+", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
           SuperscriptBox["\[Sigma]", "4"]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
           SuperscriptBox["\[Sigma]", "2"]]}], ",", 
         FractionBox[
          RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}], 
       " ", 
       RowBox[{"MathieuSPrime", "[", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Kappa]", "2"], "+", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
           SuperscriptBox["\[Sigma]", "4"]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
           SuperscriptBox["\[Sigma]", "2"]]}], ",", 
         FractionBox[
          RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
        "]"}]}]}], ")"}]}], ")"}]}]], "Output"]
}, Open  ]],

Cell["The solution for   \[Alpha]==\[Alpha]0 is:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "/.", " ", 
   RowBox[{"\[Alpha]", "\[Rule]", " ", "\[Alpha]0"}]}], "//", 
  "Simplify"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"MathieuC", "[", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[Kappa]", "2"], "+", 
            RowBox[{"2", " ", "\[Lambda]", " ", 
             SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
         SuperscriptBox["\[Sigma]", "4"]]}], ",", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
         SuperscriptBox["\[Sigma]", "2"]]}], ",", 
       FractionBox[
        RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}], 
     "2"], "-", 
    RowBox[{
     SuperscriptBox["\[Chi]", "2"], " ", 
     SuperscriptBox[
      RowBox[{"MathieuS", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Kappa]", "2"], "+", 
             RowBox[{"2", " ", "\[Lambda]", " ", 
              SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
          SuperscriptBox["\[Sigma]", "4"]]}], ",", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
          SuperscriptBox["\[Sigma]", "2"]]}], ",", 
        FractionBox[
         RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}], 
      "2"]}]}], ")"}], "/", 
  RowBox[{"(", 
   RowBox[{"\[Pi]", " ", 
    SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"MathieuCPrime", "[", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Kappa]", "2"], "+", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
           SuperscriptBox["\[Sigma]", "4"]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
           SuperscriptBox["\[Sigma]", "2"]]}], ",", 
         FractionBox[
          RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}], 
       " ", 
       RowBox[{"MathieuS", "[", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Kappa]", "2"], "+", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
           SuperscriptBox["\[Sigma]", "4"]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
           SuperscriptBox["\[Sigma]", "2"]]}], ",", 
         FractionBox[
          RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}]}], 
      "-", 
      RowBox[{
       RowBox[{"MathieuC", "[", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Kappa]", "2"], "+", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
           SuperscriptBox["\[Sigma]", "4"]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
           SuperscriptBox["\[Sigma]", "2"]]}], ",", 
         FractionBox[
          RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}], 
       " ", 
       RowBox[{"MathieuSPrime", "[", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Kappa]", "2"], "+", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
           SuperscriptBox["\[Sigma]", "4"]]}], ",", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
           SuperscriptBox["\[Sigma]", "2"]]}], ",", 
         FractionBox[
          RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], 
        "]"}]}]}], ")"}]}], ")"}]}]], "Output"]
}, Open  ]],

Cell["\<\
Note, that the Wronskian of Mathieu functions is a constant, since its \
derivative is 0. Hence,\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MathieuCPrime", "[", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["\[Kappa]", "2"], "+", 
           RowBox[{"2", " ", "\[Lambda]", " ", 
            SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
        SuperscriptBox["\[Sigma]", "4"]]}], ",", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
        SuperscriptBox["\[Sigma]", "2"]]}], ",", 
      FractionBox[
       RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}], " ", 
    
    RowBox[{"MathieuS", "[", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["\[Kappa]", "2"], "+", 
           RowBox[{"2", " ", "\[Lambda]", " ", 
            SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
        SuperscriptBox["\[Sigma]", "4"]]}], ",", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
        SuperscriptBox["\[Sigma]", "2"]]}], ",", 
      FractionBox[
       RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}]}], 
   "-", 
   RowBox[{
    RowBox[{"MathieuC", "[", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["\[Kappa]", "2"], "+", 
           RowBox[{"2", " ", "\[Lambda]", " ", 
            SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
        SuperscriptBox["\[Sigma]", "4"]]}], ",", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
        SuperscriptBox["\[Sigma]", "2"]]}], ",", 
      FractionBox[
       RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}], " ", 
    
    RowBox[{"MathieuSPrime", "[", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["\[Kappa]", "2"], "+", 
           RowBox[{"2", " ", "\[Lambda]", " ", 
            SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
        SuperscriptBox["\[Sigma]", "4"]]}], ",", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
        SuperscriptBox["\[Sigma]", "2"]]}], ",", 
      FractionBox[
       RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], "2"]}], "]"}]}]}], 
  "\[Equal]", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"MathieuC", "[", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["\[Kappa]", "2"], "+", 
           RowBox[{"2", " ", "\[Lambda]", " ", 
            SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
        SuperscriptBox["\[Sigma]", "4"]]}], ",", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
        SuperscriptBox["\[Sigma]", "2"]]}], ",", "0"}], "]"}]}], " ", 
   RowBox[{"MathieuSPrime", "[", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["\[Kappa]", "2"], "+", 
          RowBox[{"2", " ", "\[Lambda]", " ", 
           SuperscriptBox["\[Sigma]", "2"]}]}], ")"}]}], 
       SuperscriptBox["\[Sigma]", "4"]]}], ",", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", "\[ImaginaryI]", " ", "\[Omega]R"}], 
       SuperscriptBox["\[Sigma]", "2"]]}], ",", "0"}], "]"}]}]}]], "Input",
 Evaluatable->False]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Fourier-Transformed, Exact Kernel with Boundaries at \[Alpha]  = \[PlusMinus]\
\[Pi]\
\>", "Subsection"],

Cell["Ansatz", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"G\[Infinity]", "[", 
   RowBox[{"a_", ",", "q_", ",", "z_"}], "]"}], " ", ":=", " ", 
  RowBox[{"\[Piecewise]", GridBox[{
     {
      RowBox[{"cp", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "q", ",", "z"}], "]"}], "+", " ", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "q", ",", "z"}], "]"}]}]}], " ", ")"}]}], 
      RowBox[{"z", "\[GreaterEqual]", "z0"}]},
     {
      RowBox[{"cm", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "q", ",", "z"}], "]"}], "-", " ", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "q", ",", "z"}], "]"}]}]}], " ", ")"}]}], 
      RowBox[{"z", "<", "z0"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.84]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}]}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"cp", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"MathieuC", "[", 
             RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "+", " ", 
            RowBox[{"\[Chi]", " ", 
             RowBox[{"MathieuS", "[", 
              RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], " ", ")"}]}], 
         " ", "-", " ", 
         RowBox[{"cm", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"MathieuC", "[", 
             RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "-", " ", 
            RowBox[{"\[Chi]", " ", 
             RowBox[{"MathieuS", "[", 
              RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], " ", ")"}]}]}], 
        " ", "\[Equal]", " ", "0"}], " ", ",", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"cp", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"MathieuCPrime", "[", 
             RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "+", " ", 
            RowBox[{"\[Chi]", " ", 
             RowBox[{"MathieuSPrime", "[", 
              RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], " ", ")"}]}], 
         " ", "-", 
         RowBox[{"cm", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"MathieuCPrime", "[", 
             RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "-", " ", 
            RowBox[{"\[Chi]", " ", 
             RowBox[{"MathieuSPrime", "[", 
              RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], " ", ")"}]}]}], 
        " ", "\[Equal]", " ", 
        FractionBox[
         RowBox[{"-", "2"}], 
         RowBox[{"\[Pi]", " ", 
          SuperscriptBox["\[Sigma]", "2"]}]]}]}], " ", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cm", ",", "cp"}], "}"}]}], "]"}], "//", 
   "Simplify"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"cm", "\[Rule]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"MathieuC", "[", 
         RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "+", 
        RowBox[{"\[Chi]", " ", 
         RowBox[{"MathieuS", "[", 
          RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Pi]", " ", 
         SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
         RowBox[{"MathieuCPrime", "[", 
          RowBox[{"a", ",", "q", ",", "z0"}], "]"}], " ", 
         RowBox[{"MathieuS", "[", 
          RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}], "-", 
        RowBox[{"\[Pi]", " ", 
         SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "q", ",", "z0"}], "]"}], " ", 
         RowBox[{"MathieuSPrime", "[", 
          RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}]}], ",", 
    RowBox[{"cp", "\[Rule]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"MathieuC", "[", 
         RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "-", 
        RowBox[{"\[Chi]", " ", 
         RowBox[{"MathieuS", "[", 
          RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Pi]", " ", 
         SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
         RowBox[{"MathieuCPrime", "[", 
          RowBox[{"a", ",", "q", ",", "z0"}], "]"}], " ", 
         RowBox[{"MathieuS", "[", 
          RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}], "-", 
        RowBox[{"\[Pi]", " ", 
         SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "q", ",", "z0"}], "]"}], " ", 
         RowBox[{"MathieuSPrime", "[", 
          RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}]}]}], "}"}], 
  "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"MathieuCPrime", "[", 
      RowBox[{"a", ",", "q", ",", "z"}], "]"}], " ", 
     RowBox[{"MathieuS", "[", 
      RowBox[{"a", ",", "q", ",", "z"}], "]"}]}], "-", 
    RowBox[{
     RowBox[{"MathieuC", "[", 
      RowBox[{"a", ",", "q", ",", "z"}], "]"}], " ", 
     RowBox[{"MathieuSPrime", "[", 
      RowBox[{"a", ",", "q", ",", "z"}], "]"}]}]}], ",", "z"}], 
  "]"}]], "Input"],

Cell[BoxData["0"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"newres", "=", 
  RowBox[{"res", "/.", 
   RowBox[{
    RowBox[{
     RowBox[{"t_.", 
      RowBox[{"MathieuCPrime", "[", 
       RowBox[{"a", ",", "q", ",", "z_"}], "]"}], " ", 
      RowBox[{"MathieuS", "[", 
       RowBox[{"a", ",", "q", ",", "z_"}], "]"}]}], "-", 
     RowBox[{"t_.", 
      RowBox[{"MathieuC", "[", 
       RowBox[{"a", ",", "q", ",", "z_"}], "]"}], " ", 
      RowBox[{"MathieuSPrime", "[", 
       RowBox[{"a", ",", "q", ",", "z_"}], "]"}]}]}], "\[Rule]", 
    RowBox[{"t", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"MathieuCPrime", "[", 
         RowBox[{"a", ",", "q", ",", "0"}], "]"}], " ", 
        RowBox[{"MathieuS", "[", 
         RowBox[{"a", ",", "q", ",", "0"}], "]"}]}], "-", 
       RowBox[{
        RowBox[{"MathieuC", "[", 
         RowBox[{"a", ",", "q", ",", "0"}], "]"}], " ", 
        RowBox[{"MathieuSPrime", "[", 
         RowBox[{"a", ",", "q", ",", "0"}], "]"}]}]}], ")"}]}]}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"cm", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"MathieuC", "[", 
        RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "+", 
       RowBox[{"\[Chi]", " ", 
        RowBox[{"MathieuS", "[", 
         RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], 
      RowBox[{"\[Pi]", " ", 
       SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"MathieuCPrime", "[", 
           RowBox[{"a", ",", "q", ",", "0"}], "]"}], " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "q", ",", "0"}], "]"}]}], "-", 
         RowBox[{
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "q", ",", "0"}], "]"}], " ", 
          RowBox[{"MathieuSPrime", "[", 
           RowBox[{"a", ",", "q", ",", "0"}], "]"}]}]}], ")"}]}]]}], ",", 
    RowBox[{"cp", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"MathieuC", "[", 
        RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "-", 
       RowBox[{"\[Chi]", " ", 
        RowBox[{"MathieuS", "[", 
         RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], 
      RowBox[{"\[Pi]", " ", 
       SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"MathieuCPrime", "[", 
           RowBox[{"a", ",", "q", ",", "0"}], "]"}], " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "q", ",", "0"}], "]"}]}], "-", 
         RowBox[{
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "q", ",", "0"}], "]"}], " ", 
          RowBox[{"MathieuSPrime", "[", 
           RowBox[{"a", ",", "q", ",", "0"}], "]"}]}]}], ")"}]}]]}]}], "}"}], 
  "}"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Piecewise]", GridBox[{
     {
      RowBox[{"cp", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "q", ",", "z"}], "]"}], "+", " ", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "q", ",", "z"}], "]"}]}]}], " ", ")"}]}], 
      RowBox[{"z", "\[GreaterEqual]", "z0"}]},
     {
      RowBox[{"cm", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "q", ",", "z"}], "]"}], "-", " ", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "q", ",", "z"}], "]"}]}]}], " ", ")"}]}], 
      RowBox[{"z", "<", "z0"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.84]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}]}], "/.", 
  RowBox[{
  "newres", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"\[Piecewise]", GridBox[{
    {
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "q", ",", "z"}], "]"}], "+", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "q", ",", "z"}], "]"}]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "-", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}], 
      RowBox[{"\[Pi]", " ", 
       SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"MathieuCPrime", "[", 
           RowBox[{"a", ",", "q", ",", "0"}], "]"}], " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "q", ",", "0"}], "]"}]}], "-", 
         RowBox[{
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "q", ",", "0"}], "]"}], " ", 
          RowBox[{"MathieuSPrime", "[", 
           RowBox[{"a", ",", "q", ",", "0"}], "]"}]}]}], ")"}]}]], 
     RowBox[{"z", "\[GreaterEqual]", "z0"}]},
    {
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "q", ",", "z"}], "]"}], "-", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "q", ",", "z"}], "]"}]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "+", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}], 
      RowBox[{"\[Pi]", " ", 
       SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"MathieuCPrime", "[", 
           RowBox[{"a", ",", "q", ",", "0"}], "]"}], " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "q", ",", "0"}], "]"}]}], "-", 
         RowBox[{
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "q", ",", "0"}], "]"}], " ", 
          RowBox[{"MathieuSPrime", "[", 
           RowBox[{"a", ",", "q", ",", "0"}], "]"}]}]}], ")"}]}]], 
     RowBox[{"z", "<", "z0"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.84]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}]}]], "Output"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"-", "1"}], 
   RowBox[{"\[Pi]", " ", 
    SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
    RowBox[{"MathieuC", "[", 
     RowBox[{"a", ",", "q", ",", "0"}], "]"}], " ", 
    RowBox[{"MathieuSPrime", "[", 
     RowBox[{"a", ",", "q", ",", "0"}], "]"}]}]], 
  RowBox[{"\[Piecewise]", GridBox[{
     {
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "q", ",", "z"}], "]"}], "+", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "q", ",", "z"}], "]"}]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "-", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}], 
      RowBox[{"z", ">", "z0"}]},
     {
      RowBox[{
       SuperscriptBox[
        RowBox[{"MathieuC", "[", 
         RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "2"], "-", 
       RowBox[{
        SuperscriptBox["\[Chi]", "2"], " ", 
        SuperscriptBox[
         RowBox[{"MathieuS", "[", 
          RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "2"]}]}], 
      RowBox[{"z", "\[Equal]", "z0"}]},
     {
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "q", ",", "z"}], "]"}], "-", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "q", ",", "z"}], "]"}]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "+", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}], 
      RowBox[{"z", "<", "z0"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.84]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"-", "1"}], 
   RowBox[{"\[Pi]", " ", 
    SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
    RowBox[{"MathieuC", "[", 
     RowBox[{"a", ",", "q", ",", "0"}], "]"}], " ", 
    RowBox[{"MathieuSPrime", "[", 
     RowBox[{"a", ",", "q", ",", "0"}], "]"}]}]], 
  RowBox[{"\[Piecewise]", GridBox[{
     {
      RowBox[{
       RowBox[{
        RowBox[{"MathieuC", "[", 
         RowBox[{"a", ",", "q", ",", "z"}], "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Coth", "[", 
             FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", "\[Nu]"}], "2"], 
             "]"}]}], " ", 
           RowBox[{"MathieuC", "[", 
            RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}], "-", " ", 
          RowBox[{"\[Chi]", " ", 
           RowBox[{"MathieuS", "[", 
            RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}], "+", 
       RowBox[{"\[Chi]", " ", 
        RowBox[{"MathieuS", "[", 
         RowBox[{"a", ",", "q", ",", "z"}], "]"}], " ", 
        RowBox[{"(", " ", 
         RowBox[{
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "+", 
          RowBox[{
           RowBox[{"Coth", "[", 
            FractionBox[
             RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", "\[Nu]"}], "2"], 
            "]"}], " ", "\[Chi]", " ", 
           RowBox[{"MathieuS", "[", 
            RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}]}], 
      RowBox[{"z", ">", "z0"}]},
     {
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Coth", "[", 
         FractionBox[
          RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", "\[Nu]"}], "2"], 
         "]"}]}], 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "2"], "-", 
         RowBox[{
          SuperscriptBox["\[Chi]", "2"], " ", 
          SuperscriptBox[
           RowBox[{"MathieuS", "[", 
            RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "2"]}]}], ")"}]}], 
      RowBox[{"z", "\[Equal]", "z0"}]},
     {
      RowBox[{
       RowBox[{
        RowBox[{"MathieuC", "[", 
         RowBox[{"a", ",", "q", ",", "z"}], "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Coth", "[", 
             FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", "\[Nu]"}], "2"], 
             "]"}]}], " ", 
           RowBox[{"MathieuC", "[", 
            RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}], "+", " ", 
          RowBox[{"\[Chi]", " ", 
           RowBox[{"MathieuS", "[", 
            RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}], "-", 
       RowBox[{"\[Chi]", " ", 
        RowBox[{"MathieuS", "[", 
         RowBox[{"a", ",", "q", ",", "z"}], "]"}], " ", 
        RowBox[{"(", " ", 
         RowBox[{
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "-", 
          RowBox[{
           RowBox[{"Coth", "[", 
            FractionBox[
             RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", "\[Nu]"}], "2"], 
            "]"}], " ", "\[Chi]", " ", 
           RowBox[{"MathieuS", "[", 
            RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}]}], 
      RowBox[{"z", "<", "z0"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.84]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[Chi]", "[", 
    RowBox[{"a_", ",", "q_"}], "]"}], " ", "=", " ", 
   RowBox[{
    RowBox[{"Sign", "[", 
     RowBox[{"Im", "[", 
      RowBox[{"MathieuCharacteristicExponent", "[", 
       RowBox[{"a", ",", "q"}], "]"}], "]"}], "]"}], " ", 
    RowBox[{"Tanh", "[", 
     RowBox[{"\[ImaginaryI]", 
      FractionBox["\[Pi]", "2"], 
      RowBox[{"MathieuCharacteristicExponent", "[", 
       RowBox[{"a", ",", "q"}], "]"}]}], "]"}], 
    FractionBox[
     RowBox[{"MathieuC", "[", 
      RowBox[{"a", ",", "q", ",", 
       FractionBox["\[Pi]", "2"]}], "]"}], 
     RowBox[{"MathieuS", "[", 
      RowBox[{"a", ",", "q", ",", 
       FractionBox["\[Pi]", "2"]}], "]"}]]}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell["Result", "Subsubsection"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"a", ",", "q"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[Chi]func", "[", 
    RowBox[{"a_", ",", "q_"}], "]"}], " ", "=", " ", 
   RowBox[{"\[ImaginaryI]", " ", 
    RowBox[{"Sign", "[", 
     RowBox[{"Im", "[", 
      RowBox[{"MathieuCharacteristicExponent", "[", 
       RowBox[{"a", ",", "q"}], "]"}], "]"}], "]"}], " ", 
    RowBox[{"Tan", "[", 
     RowBox[{
      FractionBox["1", "2"], " ", "\[Pi]", " ", 
      RowBox[{"MathieuCharacteristicExponent", "[", 
       RowBox[{"a", ",", "q"}], "]"}]}], "]"}], " ", 
    FractionBox[
     RowBox[{"MathieuC", "[", 
      RowBox[{"a", ",", "q", ",", 
       FractionBox["\[Pi]", "2"]}], "]"}], 
     RowBox[{"MathieuS", "[", 
      RowBox[{"a", ",", "q", ",", 
       FractionBox["\[Pi]", "2"]}], "]"}]]}]}], ";"}]], "Input"],

Cell["Version according to phase convention in PhD thesis.", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Nu]func", "[", 
   RowBox[{"a_", ",", "q_"}], "]"}], " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"Re", "[", "#", "]"}], ",", "2"}], "]"}], "+", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"Im", "[", "#", "]"}]}]}], ")"}], "&"}], "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Sign", "[", 
        RowBox[{"Im", "[", "#", "]"}], "]"}], " ", "#"}], ")"}], "&"}], "[", 
    RowBox[{"MathieuCharacteristicExponent", "[", 
     RowBox[{"a", ",", "q"}], "]"}], "]"}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"G\[Infinity]", "[", 
   RowBox[{"a_", ",", "q_", ",", "z_", ",", 
    RowBox[{"z0_:", "0"}]}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[Chi]", " ", "=", " ", 
      RowBox[{"\[Chi]func", "[", 
       RowBox[{"a", ",", "q"}], "]"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", 
       RowBox[{"\[Pi]", " ", 
        SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
        RowBox[{"MathieuC", "[", 
         RowBox[{"a", ",", "q", ",", "0"}], "]"}], " ", 
        RowBox[{"MathieuSPrime", "[", 
         RowBox[{"a", ",", "q", ",", "0"}], "]"}]}]]}], 
     RowBox[{"\[Piecewise]", GridBox[{
        {
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"MathieuC", "[", 
             RowBox[{"a", ",", "q", ",", "z"}], "]"}], "+", 
            RowBox[{"\[Chi]", " ", 
             RowBox[{"MathieuS", "[", 
              RowBox[{"a", ",", "q", ",", "z"}], "]"}]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"MathieuC", "[", 
             RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "-", 
            RowBox[{"\[Chi]", " ", 
             RowBox[{"MathieuS", "[", 
              RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}], 
         RowBox[{"z", ">", "z0"}]},
        {
         RowBox[{
          SuperscriptBox[
           RowBox[{"MathieuC", "[", 
            RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "2"], "-", 
          RowBox[{
           SuperscriptBox["\[Chi]", "2"], " ", 
           SuperscriptBox[
            RowBox[{"MathieuS", "[", 
             RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "2"]}]}], 
         RowBox[{"z", "\[Equal]", "z0"}]},
        {
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"MathieuC", "[", 
             RowBox[{"a", ",", "q", ",", "z"}], "]"}], "-", 
            RowBox[{"\[Chi]", " ", 
             RowBox[{"MathieuS", "[", 
              RowBox[{"a", ",", "q", ",", "z"}], "]"}]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"MathieuC", "[", 
             RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "+", 
            RowBox[{"\[Chi]", " ", 
             RowBox[{"MathieuS", "[", 
              RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}], 
         RowBox[{"z", "<", "z0"}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"G", "[", 
   RowBox[{"a_", ",", "q_", ",", "z_", ",", 
    RowBox[{"z0_:", "0"}]}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[Chi]", " ", "=", " ", 
       RowBox[{"\[Chi]func", "[", 
        RowBox[{"a", ",", "q"}], "]"}]}], ",", 
      RowBox[{"\[Nu]", " ", "=", " ", 
       RowBox[{"\[Nu]func", "[", 
        RowBox[{"a", ",", "q"}], "]"}]}]}], "}"}], ",", 
    RowBox[{
     FractionBox[
      RowBox[{"-", "1"}], 
      RowBox[{"\[Pi]", " ", 
       SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
       RowBox[{"MathieuC", "[", 
        RowBox[{"a", ",", "q", ",", "0"}], "]"}], " ", 
       RowBox[{"MathieuSPrime", "[", 
        RowBox[{"a", ",", "q", ",", "0"}], "]"}]}]], 
     RowBox[{"\[Piecewise]", GridBox[{
        {
         RowBox[{
          RowBox[{
           RowBox[{"MathieuC", "[", 
            RowBox[{"a", ",", "q", ",", "z"}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               RowBox[{"Coth", "[", 
                FractionBox[
                 RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", "\[Nu]"}], "2"], 
                "]"}]}], " ", 
              RowBox[{"MathieuC", "[", 
               RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}], "-", " ", 
             RowBox[{"\[Chi]", " ", 
              RowBox[{"MathieuS", "[", 
               RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}], "+", 
          RowBox[{"\[Chi]", " ", 
           RowBox[{"MathieuS", "[", 
            RowBox[{"a", ",", "q", ",", "z"}], "]"}], " ", 
           RowBox[{"(", " ", 
            RowBox[{
             RowBox[{"MathieuC", "[", 
              RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "+", 
             RowBox[{
              RowBox[{"Coth", "[", 
               FractionBox[
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", "\[Nu]"}], "2"], 
               "]"}], " ", "\[Chi]", " ", 
              RowBox[{"MathieuS", "[", 
               RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}]}], 
         RowBox[{"z", ">", "z0"}]},
        {
         RowBox[{
          RowBox[{"-", 
           RowBox[{"Coth", "[", 
            FractionBox[
             RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", "\[Nu]"}], "2"], 
            "]"}]}], 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"MathieuC", "[", 
              RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "2"], "-", 
            RowBox[{
             SuperscriptBox["\[Chi]", "2"], " ", 
             SuperscriptBox[
              RowBox[{"MathieuS", "[", 
               RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "2"]}]}], ")"}]}], 
         RowBox[{"z", "\[Equal]", "z0"}]},
        {
         RowBox[{
          RowBox[{
           RowBox[{"MathieuC", "[", 
            RowBox[{"a", ",", "q", ",", "z"}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               RowBox[{"Coth", "[", 
                FractionBox[
                 RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", "\[Nu]"}], "2"], 
                "]"}]}], " ", 
              RowBox[{"MathieuC", "[", 
               RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}], "+", " ", 
             RowBox[{"\[Chi]", " ", 
              RowBox[{"MathieuS", "[", 
               RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}], "-", 
          RowBox[{"\[Chi]", " ", 
           RowBox[{"MathieuS", "[", 
            RowBox[{"a", ",", "q", ",", "z"}], "]"}], " ", 
           RowBox[{"(", " ", 
            RowBox[{
             RowBox[{"MathieuC", "[", 
              RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "-", 
             RowBox[{
              RowBox[{"Coth", "[", 
               FractionBox[
                RowBox[{"\[ImaginaryI]", " ", "\[Pi]", " ", "\[Nu]"}], "2"], 
               "]"}], " ", "\[Chi]", " ", 
              RowBox[{"MathieuS", "[", 
               RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}]}], 
         RowBox[{"z", "<", "z0"}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]}]}]}], "]"}]}]], "Input"],

Cell["as printed in PhD thesis:", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TestFunc", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", "\[Alpha]0_", ",", 
     RowBox[{"0", "|", "0."}]}], "]"}], "[", 
   RowBox[{"x_", ",", "y_", ",", "\[Alpha]_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", " ", "=", " ", 
       RowBox[{
        FractionBox[
         RowBox[{"-", "8"}], 
         SuperscriptBox["\[Sigma]", "2"]], "\[Lambda]"}]}], " ", ",", " ", 
      RowBox[{"q", " ", "=", " ", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", 
        FractionBox["4", 
         SuperscriptBox["\[Sigma]", "2"]], 
        RowBox[{"Radius", "[", 
         RowBox[{"x", ",", "y"}], "]"}]}]}], ",", " ", 
      RowBox[{"z0", "=", 
       FractionBox[
        RowBox[{"\[Alpha]0", "-", 
         RowBox[{"Angle", "[", 
          RowBox[{"x", ",", "y"}], "]"}]}], "2"]}], ",", " ", 
      RowBox[{"z", "=", 
       FractionBox[
        RowBox[{"\[Alpha]", "-", 
         RowBox[{"Angle", "[", 
          RowBox[{"x", ",", "y"}], "]"}]}], "2"]}], ",", "\[Chi]", ",", 
      "i\[Nu]"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Chi]", " ", "=", " ", 
      RowBox[{"FloquetSign", "[", 
       RowBox[{"a", ",", "q"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"i\[Nu]", "=", 
      RowBox[{"-", 
       RowBox[{"Abs", "[", 
        RowBox[{"Im", "[", 
         RowBox[{"MathieuCharacteristicExponent", "[", 
          RowBox[{"a", ",", "q"}], "]"}], "]"}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{"\[Pi]", " ", 
         SuperscriptBox["\[Sigma]", "2"], " ", "\[Chi]", " ", 
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "q", ",", "0"}], "]"}], " ", 
         RowBox[{"MathieuSPrime", "[", 
          RowBox[{"a", ",", "q", ",", "0"}], "]"}]}], ")"}]}], "*", 
      "\[IndentingNewLine]", 
      RowBox[{"\[Piecewise]", GridBox[{
         {
          RowBox[{
           RowBox[{
            RowBox[{"MathieuC", "[", 
             RowBox[{"a", ",", "q", ",", "z"}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"Coth", "[", 
                FractionBox[
                 RowBox[{"i\[Nu]", " ", "\[Pi]"}], "2"], "]"}], " ", 
               RowBox[{"MathieuC", "[", 
                RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}], "-", 
              RowBox[{"\[Chi]", " ", 
               RowBox[{"MathieuS", "[", 
                RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}], "+", 
           "\[IndentingNewLine]", 
           RowBox[{"\[Chi]", " ", 
            RowBox[{"MathieuS", "[", 
             RowBox[{"a", ",", "q", ",", "z"}], "]"}], " ", 
            RowBox[{"(", " ", 
             RowBox[{
              RowBox[{"MathieuC", "[", 
               RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "-", 
              RowBox[{"\[Chi]", " ", 
               RowBox[{"Coth", "[", 
                FractionBox[
                 RowBox[{"i\[Nu]", " ", "\[Pi]"}], "2"], "]"}], " ", 
               RowBox[{"MathieuS", "[", 
                RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}]}], 
          RowBox[{"z", "<", "z0"}]},
         {
          RowBox[{
           RowBox[{"Coth", "[", 
            FractionBox[
             RowBox[{"i\[Nu]", " ", "\[Pi]"}], "2"], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"MathieuC", "[", 
               RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "2"], "-", 
             RowBox[{
              SuperscriptBox["\[Chi]", "2"], " ", 
              SuperscriptBox[
               RowBox[{"MathieuS", "[", 
                RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "2"]}]}], ")"}]}], 
          
          RowBox[{"z", "\[Equal]", "z0"}]},
         {
          RowBox[{
           RowBox[{
            RowBox[{"MathieuC", "[", 
             RowBox[{"a", ",", "q", ",", "z"}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"Coth", "[", 
                FractionBox[
                 RowBox[{"i\[Nu]", " ", "\[Pi]"}], "2"], "]"}], " ", 
               RowBox[{"MathieuC", "[", 
                RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}], "+", 
              RowBox[{"\[Chi]", " ", 
               RowBox[{"MathieuS", "[", 
                RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}], "-", 
           "\[IndentingNewLine]", 
           RowBox[{"\[Chi]", " ", 
            RowBox[{"MathieuS", "[", 
             RowBox[{"a", ",", "q", ",", "z"}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"MathieuC", "[", 
               RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "+", 
              RowBox[{"\[Chi]", " ", 
               RowBox[{"Coth", "[", 
                FractionBox[
                 RowBox[{"i\[Nu]", " ", "\[Pi]"}], "2"], "]"}], " ", 
               RowBox[{"MathieuS", "[", 
                RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}]}], 
          RowBox[{"z", ">", "z0"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}]}]}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TestFunc", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", "\[Alpha]0_", ",", 
      RowBox[{"0", "|", "0."}]}], "]"}], "[", 
    RowBox[{"x_", ",", "y_", ",", "\[Alpha]_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", " ", "=", " ", 
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{"-", "8"}], 
           SuperscriptBox["\[Sigma]", "2"]], "\[Lambda]"}], " ", "-", " ", 
         RowBox[{
          FractionBox["4", 
           SuperscriptBox["\[Sigma]", "4"]], 
          SuperscriptBox["\[Kappa]", "2"]}]}]}], ",", " ", 
       RowBox[{"q", " ", "=", " ", 
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", 
         FractionBox["4", 
          SuperscriptBox["\[Sigma]", "2"]], 
         RowBox[{"Radius", "[", 
          RowBox[{"x", ",", "y"}], "]"}]}]}], ",", " ", 
       RowBox[{"z0", "=", 
        FractionBox[
         RowBox[{"\[Alpha]0", "-", 
          RowBox[{"Angle", "[", 
           RowBox[{"x", ",", "y"}], "]"}]}], "2"]}], ",", " ", 
       RowBox[{"z", "=", 
        FractionBox[
         RowBox[{"\[Alpha]", "-", 
          RowBox[{"Angle", "[", 
           RowBox[{"x", ",", "y"}], "]"}]}], "2"]}], ",", "\[Chi]", ",", 
       "i\[Nu]"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"\[Chi]", " ", "=", " ", 
       RowBox[{"FloquetSign", "[", 
        RowBox[{"a", ",", "q"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"i\[Nu]", "=", 
       RowBox[{"-", 
        RowBox[{"Abs", "[", 
         RowBox[{"Im", "[", 
          RowBox[{"MathieuCharacteristicExponent", "[", 
           RowBox[{"a", ",", "q"}], "]"}], "]"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       FractionBox[
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"2", "\[Kappa]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"z", "-", "z0"}], ")"}], "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]], 
        RowBox[{"\[Pi]", " ", 
         SuperscriptBox["\[Sigma]", "2"], "\[Chi]", " ", 
         RowBox[{"MathieuSPrime", "[", 
          RowBox[{"a", ",", "q", ",", "0"}], "]"}], " ", 
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "q", ",", "0"}], "]"}]}]], "*", 
       RowBox[{"\[Piecewise]", GridBox[{
          {
           RowBox[{
            RowBox[{
             FractionBox["1", 
              RowBox[{"1", "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"\[Pi]", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "i\[Nu]"}], "-", 
                   FractionBox[
                    RowBox[{"2", " ", "\[Kappa]"}], 
                    SuperscriptBox["\[Sigma]", "2"]]}], ")"}]}]]}]], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"MathieuC", "[", 
                RowBox[{"a", ",", "q", ",", "z"}], "]"}], "+", 
               RowBox[{"\[Chi]", " ", 
                RowBox[{"MathieuS", "[", 
                 RowBox[{"a", ",", "q", ",", "z"}], "]"}]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"MathieuC", "[", 
                RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "-", 
               RowBox[{"\[Chi]", " ", 
                RowBox[{"MathieuS", "[", 
                 RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}], "-", 
            "\[IndentingNewLine]", 
            RowBox[{
             FractionBox["1", 
              RowBox[{"1", "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"\[Pi]", " ", 
                 RowBox[{"(", 
                  RowBox[{"i\[Nu]", "-", 
                   FractionBox[
                    RowBox[{"2", " ", "\[Kappa]"}], 
                    SuperscriptBox["\[Sigma]", "2"]]}], ")"}]}]]}]], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"MathieuC", "[", 
                RowBox[{"a", ",", "q", ",", "z"}], "]"}], "-", 
               RowBox[{"\[Chi]", " ", 
                RowBox[{"MathieuS", "[", 
                 RowBox[{"a", ",", "q", ",", "z"}], "]"}]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"MathieuC", "[", 
                RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "+", 
               RowBox[{"\[Chi]", " ", 
                RowBox[{"MathieuS", "[", 
                 RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}]}], 
           RowBox[{"z", "<", "z0"}]},
          {
           RowBox[{
            FractionBox[
             RowBox[{"Sinh", "[", 
              RowBox[{"i\[Nu]", " ", "\[Pi]"}], "]"}], 
             RowBox[{
              RowBox[{"Cosh", "[", 
               RowBox[{"i\[Nu]", " ", "\[Pi]"}], "]"}], "-", 
              RowBox[{"Cosh", "[", 
               FractionBox[
                RowBox[{"2", " ", "\[Pi]", " ", "\[Kappa]"}], 
                SuperscriptBox["\[Sigma]", "2"]], "]"}]}]], " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"MathieuC", "[", 
                RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "2"], "-", 
              RowBox[{
               SuperscriptBox["\[Chi]", "2"], " ", 
               SuperscriptBox[
                RowBox[{"MathieuS", "[", 
                 RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "2"]}]}], ")"}]}], 
           RowBox[{"z", "\[Equal]", "z0"}]},
          {
           RowBox[{
            RowBox[{
             FractionBox["1", 
              RowBox[{"1", "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"\[Pi]", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "i\[Nu]"}], "+", 
                   FractionBox[
                    RowBox[{"2", " ", "\[Kappa]"}], 
                    SuperscriptBox["\[Sigma]", "2"]]}], ")"}]}]]}]], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"MathieuC", "[", 
                RowBox[{"a", ",", "q", ",", "z"}], "]"}], "-", 
               RowBox[{"\[Chi]", " ", 
                RowBox[{"MathieuS", "[", 
                 RowBox[{"a", ",", "q", ",", "z"}], "]"}]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"MathieuC", "[", 
                RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "+", 
               RowBox[{"\[Chi]", " ", 
                RowBox[{"MathieuS", "[", 
                 RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}], "-", 
            "\[IndentingNewLine]", 
            RowBox[{
             FractionBox["1", 
              RowBox[{"1", "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"\[Pi]", " ", 
                 RowBox[{"(", 
                  RowBox[{"i\[Nu]", "+", 
                   FractionBox[
                    RowBox[{"2", " ", "\[Kappa]"}], 
                    SuperscriptBox["\[Sigma]", "2"]]}], ")"}]}]]}]], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"MathieuC", "[", 
                RowBox[{"a", ",", "q", ",", "z"}], "]"}], "+", 
               RowBox[{"\[Chi]", " ", 
                RowBox[{"MathieuS", "[", 
                 RowBox[{"a", ",", "q", ",", "z"}], "]"}]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"MathieuC", "[", 
                RowBox[{"a", ",", "q", ",", "z0"}], "]"}], "-", 
               RowBox[{"\[Chi]", " ", 
                RowBox[{"MathieuS", "[", 
                 RowBox[{"a", ",", "q", ",", "z0"}], "]"}]}]}], ")"}]}]}], 
           RowBox[{"z", ">", "z0"}]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.84]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}]}]}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Fourier-Transformed, Approximate  Kernel with Boundaries at \[Alpha]  = \
\[PlusMinus]\[Infinity]\
\>", "Subsection"],

Cell["\<\
An approximation for small \[Alpha] is Cos[\[Alpha]] \[TildeTilde] 1 and Sin[\
\[Alpha]] \[TildeTilde] \[Alpha]. In this approximation the Fokker-Planck \
equation is\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[PartialD]", "x"], "#"}], " ", "+", " ", 
    RowBox[{"\[Alpha]", " ", 
     RowBox[{
      SubscriptBox["\[PartialD]", "y"], "#"}]}], " ", "+", 
    RowBox[{"\[Kappa]", " ", 
     RowBox[{
      SubscriptBox["\[PartialD]", "\[Alpha]"], "#"}]}], "-", " ", 
    RowBox[{
     FractionBox[
      SuperscriptBox["\[Sigma]", "2"], "2"], 
     RowBox[{
      SubscriptBox["\[PartialD]", 
       RowBox[{"\[Alpha]", ",", "\[Alpha]"}]], "#"}]}], " ", "+", " ", 
    RowBox[{"\[Lambda]", "#"}]}], ")"}], " ", "\[Equal]", " ", 
  RowBox[{"DiracDelta", "[", 
   RowBox[{"x", ",", "y", ",", 
    RowBox[{"\[Alpha]", "-", "\[Alpha]0"}]}], "]"}]}]], "Input",
 Evaluatable->False],

Cell["After Fourier transformation in x and y, we obtain", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]x"}], ")"}], "#"}], " ", 
    "+", " ", 
    RowBox[{"\[Alpha]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]y"}], ")"}], " ", "#"}], 
    " ", "+", 
    RowBox[{"\[Kappa]", " ", 
     RowBox[{
      SubscriptBox["\[PartialD]", "\[Alpha]"], "#"}]}], "-", " ", 
    RowBox[{
     FractionBox[
      SuperscriptBox["\[Sigma]", "2"], "2"], 
     RowBox[{
      SubscriptBox["\[PartialD]", 
       RowBox[{"\[Alpha]", ",", "\[Alpha]"}]], "#"}]}], " ", "+", " ", 
    RowBox[{"\[Lambda]", "#"}]}], ")"}], " ", "\[Equal]", " ", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[Pi]"}]], 
   RowBox[{"DiracDelta", "[", 
    RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}]}]}]], "Input",
 Evaluatable->False],

Cell[TextData[{
 "Divide both sides by -",
 Cell[BoxData[
  RowBox[{"2", "/", 
   SuperscriptBox["\[Sigma]", "2"]}]]],
 "."
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[PartialD]", 
      RowBox[{"\[Alpha]", ",", "\[Alpha]"}]], "#"}], " ", "+", 
    RowBox[{
     FractionBox[
      RowBox[{"2", "\[ImaginaryI]"}], 
      SuperscriptBox["\[Sigma]", "2"]], " ", "\[Alpha]", "  ", "\[Omega]y", 
     " ", "#"}], " ", "-", 
    RowBox[{
     FractionBox[
      RowBox[{"2", "\[Kappa]"}], 
      SuperscriptBox["\[Sigma]", "2"]], " ", 
     RowBox[{
      SubscriptBox["\[PartialD]", "\[Alpha]"], "#"}]}], "+", 
    RowBox[{
     FractionBox["2", 
      SuperscriptBox["\[Sigma]", "2"]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}], "-", "\[Lambda]"}], ")"}],
      " ", "#"}]}], " ", ")"}], " ", "\[Equal]", " ", 
  RowBox[{
   FractionBox[
    RowBox[{"-", "1"}], 
    RowBox[{"\[Pi]", " ", 
     SuperscriptBox["\[Sigma]", "2"]}]], " ", 
   RowBox[{"DiracDelta", "[", 
    RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}]}]}]], "Input",
 Evaluatable->False],

Cell["We introduce the following substitutions.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"a", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"2", "\[ImaginaryI]"}], 
       SuperscriptBox["\[Sigma]", "2"]]}], " ", "\[Omega]y"}]}], ",", " ", 
   RowBox[{"d", "\[Rule]", " ", 
    FractionBox["\[Kappa]", 
     SuperscriptBox["\[Sigma]", "2"]]}], ",", " ", 
   RowBox[{"c", "\[Rule]", " ", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["2", 
       SuperscriptBox["\[Sigma]", "2"]]}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}], "-", "\[Lambda]"}], 
      ")"}]}]}]}], "}"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"spell1\"\>"}], ":", 
  " ", "\<\"Possible spelling error: new symbol name \\\"\\!\\(\[Omega]x\\)\\\
\" is similar to existing symbol \\\"\\!\\(\[Omega]y\\)\\\". \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"a", "\[Rule]", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{"2", " ", "\[ImaginaryI]", " ", "\[Omega]y"}], 
      SuperscriptBox["\[Sigma]", "2"]]}]}], ",", 
   RowBox[{"d", "\[Rule]", 
    FractionBox["\[Kappa]", 
     SuperscriptBox["\[Sigma]", "2"]]}], ",", 
   RowBox[{"c", "\[Rule]", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "\[Lambda]"}], "+", 
         RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], ")"}]}], 
      SuperscriptBox["\[Sigma]", "2"]]}]}]}], "}"}]], "Output"]
}, Open  ]],

Cell[TextData[{
 "This ODE is solved by an AiryAI function for ",
 Cell[BoxData[
  UnderscriptBox["lim", 
   RowBox[{"\[Alpha]", "\[Rule]", "\[Infinity]"}]]]],
 " |\[Alpha]| \[Rule] 0. Note, that we have to consider the different complex \
branches of ",
 Cell[BoxData[
  SuperscriptBox["a", 
   RowBox[{"2", "/", "3"}]]]],
 "."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DSolve", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{
       SubscriptBox["\[PartialD]", 
        RowBox[{"\[Alpha]", ",", "\[Alpha]"}]], 
       RowBox[{"f", "[", "\[Alpha]", "]"}]}], " ", "-", 
      RowBox[{"a", " ", "\[Alpha]", " ", 
       RowBox[{"f", "[", "\[Alpha]", "]"}]}], "-", 
      RowBox[{"2", " ", "d", " ", 
       RowBox[{
        SubscriptBox["\[PartialD]", "\[Alpha]"], 
        RowBox[{"f", "[", "\[Alpha]", "]"}]}]}], "-", 
      RowBox[{"c", " ", 
       RowBox[{"f", "[", "\[Alpha]", "]"}]}]}], "\[Equal]", "0"}], " ", ")"}],
    ",", 
   RowBox[{"f", "[", "\[Alpha]", "]"}], ",", "\[Alpha]"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"f", "[", "\[Alpha]", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"d", " ", "\[Alpha]"}]], " ", 
      RowBox[{"AiryAi", "[", 
       FractionBox[
        RowBox[{"c", "+", 
         SuperscriptBox["d", "2"], "+", 
         RowBox[{"a", " ", "\[Alpha]"}]}], 
        SuperscriptBox["a", 
         RowBox[{"2", "/", "3"}]]], "]"}], " ", 
      RowBox[{"C", "[", "1", "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"d", " ", "\[Alpha]"}]], " ", 
      RowBox[{"AiryBi", "[", 
       FractionBox[
        RowBox[{"c", "+", 
         SuperscriptBox["d", "2"], "+", 
         RowBox[{"a", " ", "\[Alpha]"}]}], 
        SuperscriptBox["a", 
         RowBox[{"2", "/", "3"}]]], "]"}], " ", 
      RowBox[{"C", "[", "2", "]"}]}]}]}], "}"}], "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"solm", " ", "=", " ", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"d", " ", "\[Alpha]"}]], " ", 
    RowBox[{"AiryAi", "[", 
     FractionBox[
      RowBox[{"c", "+", 
       SuperscriptBox["d", "2"], "+", 
       RowBox[{"a", " ", "\[Alpha]"}]}], 
      RowBox[{"Conjugate", "[", " ", 
       SuperscriptBox["a", 
        RowBox[{"2", "/", "3"}]], "]"}]], "]"}]}]}], ";", " ", 
  RowBox[{"solp", " ", "=", " ", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"d", " ", "\[Alpha]"}]], " ", 
    RowBox[{"AiryAi", "[", 
     FractionBox[
      RowBox[{"c", "+", 
       SuperscriptBox["d", "2"], "+", 
       RowBox[{"a", " ", "\[Alpha]"}]}], 
      RowBox[{" ", 
       SuperscriptBox["a", 
        RowBox[{"2", "/", "3"}]]}]], "]"}]}]}], ";"}]], "Input"],

Cell["\<\
Merging the solution to the left and the right side of the \[Delta]-function. \
Continuity at \[Alpha]=\[Alpha]0 and \"active\" kinck in the first derivative:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol", " ", "=", " ", 
  RowBox[{
   RowBox[{"Solve", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Cm", " ", 
         RowBox[{"(", 
          RowBox[{"solm", " ", "/.", " ", 
           RowBox[{"\[Alpha]", "\[Rule]", "\[Alpha]0"}]}], ")"}]}], "  ", 
        "\[Equal]", " ", 
        RowBox[{"Cp", " ", 
         RowBox[{"(", 
          RowBox[{"solp", " ", "/.", " ", 
           RowBox[{"\[Alpha]", "\[Rule]", "\[Alpha]0"}]}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{"Cp", " ", "solp"}], ",", "\[Alpha]"}], "]"}], "/.", " ", 
           RowBox[{"\[Alpha]", "\[Rule]", " ", "\[Alpha]0"}]}], ")"}], " ", 
         "-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{"Cm", " ", "solm"}], ",", "\[Alpha]"}], "]"}], "/.", " ", 
           RowBox[{"\[Alpha]", "\[Rule]", " ", "\[Alpha]0"}]}], ")"}]}], " ", 
        "\[Equal]", " ", 
        FractionBox[
         RowBox[{"-", "1"}], 
         RowBox[{"\[Pi]", " ", 
          SuperscriptBox["\[Sigma]", "2"]}]]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Cp", ",", "Cm"}], "}"}]}], "\[IndentingNewLine]", "]"}], "//", 
   "Simplify"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Cp", "\[Rule]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "d"}], " ", "\[Alpha]0"}]], " ", 
        RowBox[{"AiryAi", "[", 
         FractionBox[
          RowBox[{"c", "+", 
           SuperscriptBox["d", "2"], "+", 
           RowBox[{"a", " ", "\[Alpha]0"}]}], 
          RowBox[{"Conjugate", "[", 
           SuperscriptBox["a", 
            RowBox[{"2", "/", "3"}]], "]"}]], "]"}], " ", 
        RowBox[{"Conjugate", "[", 
         SuperscriptBox["a", 
          RowBox[{"2", "/", "3"}]], "]"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["a", 
         RowBox[{"1", "/", "3"}]], " ", "\[Pi]", " ", 
        SuperscriptBox["\[Sigma]", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox["a", 
            RowBox[{"2", "/", "3"}]], " ", 
           RowBox[{"AiryAi", "[", 
            FractionBox[
             RowBox[{"c", "+", 
              SuperscriptBox["d", "2"], "+", 
              RowBox[{"a", " ", "\[Alpha]0"}]}], 
             SuperscriptBox["a", 
              RowBox[{"2", "/", "3"}]]], "]"}], " ", 
           RowBox[{"AiryAiPrime", "[", 
            FractionBox[
             RowBox[{"c", "+", 
              SuperscriptBox["d", "2"], "+", 
              RowBox[{"a", " ", "\[Alpha]0"}]}], 
             RowBox[{"Conjugate", "[", 
              SuperscriptBox["a", 
               RowBox[{"2", "/", "3"}]], "]"}]], "]"}]}], "-", 
          RowBox[{
           RowBox[{"AiryAi", "[", 
            FractionBox[
             RowBox[{"c", "+", 
              SuperscriptBox["d", "2"], "+", 
              RowBox[{"a", " ", "\[Alpha]0"}]}], 
             RowBox[{"Conjugate", "[", 
              SuperscriptBox["a", 
               RowBox[{"2", "/", "3"}]], "]"}]], "]"}], " ", 
           RowBox[{"AiryAiPrime", "[", 
            FractionBox[
             RowBox[{"c", "+", 
              SuperscriptBox["d", "2"], "+", 
              RowBox[{"a", " ", "\[Alpha]0"}]}], 
             SuperscriptBox["a", 
              RowBox[{"2", "/", "3"}]]], "]"}], " ", 
           RowBox[{"Conjugate", "[", 
            SuperscriptBox["a", 
             RowBox[{"2", "/", "3"}]], "]"}]}]}], ")"}]}], ")"}]}]}], ",", 
    RowBox[{"Cm", "\[Rule]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          RowBox[{"-", "d"}], " ", "\[Alpha]0"}]], " ", 
        RowBox[{"AiryAi", "[", 
         FractionBox[
          RowBox[{"c", "+", 
           SuperscriptBox["d", "2"], "+", 
           RowBox[{"a", " ", "\[Alpha]0"}]}], 
          SuperscriptBox["a", 
           RowBox[{"2", "/", "3"}]]], "]"}], " ", 
        RowBox[{"Conjugate", "[", 
         SuperscriptBox["a", 
          RowBox[{"2", "/", "3"}]], "]"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["a", 
         RowBox[{"1", "/", "3"}]], " ", "\[Pi]", " ", 
        SuperscriptBox["\[Sigma]", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox["a", 
            RowBox[{"2", "/", "3"}]], " ", 
           RowBox[{"AiryAi", "[", 
            FractionBox[
             RowBox[{"c", "+", 
              SuperscriptBox["d", "2"], "+", 
              RowBox[{"a", " ", "\[Alpha]0"}]}], 
             SuperscriptBox["a", 
              RowBox[{"2", "/", "3"}]]], "]"}], " ", 
           RowBox[{"AiryAiPrime", "[", 
            FractionBox[
             RowBox[{"c", "+", 
              SuperscriptBox["d", "2"], "+", 
              RowBox[{"a", " ", "\[Alpha]0"}]}], 
             RowBox[{"Conjugate", "[", 
              SuperscriptBox["a", 
               RowBox[{"2", "/", "3"}]], "]"}]], "]"}]}], "-", 
          RowBox[{
           RowBox[{"AiryAi", "[", 
            FractionBox[
             RowBox[{"c", "+", 
              SuperscriptBox["d", "2"], "+", 
              RowBox[{"a", " ", "\[Alpha]0"}]}], 
             RowBox[{"Conjugate", "[", 
              SuperscriptBox["a", 
               RowBox[{"2", "/", "3"}]], "]"}]], "]"}], " ", 
           RowBox[{"AiryAiPrime", "[", 
            FractionBox[
             RowBox[{"c", "+", 
              SuperscriptBox["d", "2"], "+", 
              RowBox[{"a", " ", "\[Alpha]0"}]}], 
             SuperscriptBox["a", 
              RowBox[{"2", "/", "3"}]]], "]"}], " ", 
           RowBox[{"Conjugate", "[", 
            SuperscriptBox["a", 
             RowBox[{"2", "/", "3"}]], "]"}]}]}], ")"}]}], ")"}]}]}]}], "}"}],
   "}"}]], "Output"]
}, Open  ]],

Cell["Consider the constant Wronskian with the following identity.", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"WronskianRule", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"a", " ", "\[Pi]", " ", 
       SuperscriptBox["\[Sigma]", "2"], " ", 
       RowBox[{"AiryAi", "[", 
        FractionBox[
         RowBox[{"c", "+", 
          SuperscriptBox["d", "2"], "+", 
          RowBox[{"a", " ", "\[Alpha]0"}]}], 
         SuperscriptBox["a", 
          RowBox[{"2", "/", "3"}]]], "]"}], " ", 
       RowBox[{"AiryAiPrime", "[", 
        FractionBox[
         RowBox[{"c", "+", 
          SuperscriptBox["d", "2"], "+", 
          RowBox[{"a", " ", "\[Alpha]0"}]}], 
         RowBox[{"Conjugate", "[", 
          SuperscriptBox["a", 
           RowBox[{"2", "/", "3"}]], "]"}]], "]"}]}], "-", 
      RowBox[{
       SuperscriptBox["a", 
        RowBox[{"1", "/", "3"}]], " ", "\[Pi]", " ", 
       SuperscriptBox["\[Sigma]", "2"], " ", 
       RowBox[{"AiryAi", "[", 
        FractionBox[
         RowBox[{"c", "+", 
          SuperscriptBox["d", "2"], "+", 
          RowBox[{"a", " ", "\[Alpha]0"}]}], 
         RowBox[{"Conjugate", "[", 
          SuperscriptBox["a", 
           RowBox[{"2", "/", "3"}]], "]"}]], "]"}], " ", 
       RowBox[{"AiryAiPrime", "[", 
        FractionBox[
         RowBox[{"c", "+", 
          SuperscriptBox["d", "2"], "+", 
          RowBox[{"a", " ", "\[Alpha]0"}]}], 
         SuperscriptBox["a", 
          RowBox[{"2", "/", "3"}]]], "]"}], " ", 
       RowBox[{"Conjugate", "[", 
        SuperscriptBox["a", 
         RowBox[{"2", "/", "3"}]], "]"}]}]}], ")"}], "\[Rule]", " ", 
    RowBox[{
     FractionBox[
      RowBox[{"1", " "}], "2"], " ", 
     RowBox[{"Conjugate", "[", 
      SuperscriptBox["a", 
       RowBox[{"2", "/", "3"}]], "]"}], " ", 
     SuperscriptBox[
      RowBox[{"Abs", "[", "a", "]"}], 
      RowBox[{"1", "/", "3"}]], "  ", 
     SuperscriptBox["\[Sigma]", "2"]}]}]}], ";"}]], "Input"],

Cell["\<\
The solution for the left side with \[Alpha]<\[Alpha]0 is:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Cm", " ", "solm"}], " ", "/.", " ", 
     RowBox[{"First", "[", "sol", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Re", "[", "a", "]"}], "\[Equal]", "0"}], ",", 
      RowBox[{"d", "\[Element]", "Reals"}], ",", 
      RowBox[{"\[Alpha]", " ", "\[Element]", " ", "Reals"}]}], "}"}]}], "]"}],
   "/.", "WronskianRule"}]], "Input"],

Cell[BoxData[
 FractionBox[
  RowBox[{"2", " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"d", " ", 
     RowBox[{"(", 
      RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}]}]], " ", 
   RowBox[{"AiryAi", "[", 
    FractionBox[
     RowBox[{"c", "+", 
      SuperscriptBox["d", "2"], "+", 
      RowBox[{"a", " ", "\[Alpha]0"}]}], 
     SuperscriptBox["a", 
      RowBox[{"2", "/", "3"}]]], "]"}], " ", 
   RowBox[{"AiryAi", "[", 
    FractionBox[
     RowBox[{"c", "+", 
      SuperscriptBox["d", "2"], "+", 
      RowBox[{"a", " ", "\[Alpha]"}]}], 
     RowBox[{"Conjugate", "[", 
      SuperscriptBox["a", 
       RowBox[{"2", "/", "3"}]], "]"}]], "]"}]}], 
  RowBox[{
   SuperscriptBox["\[Sigma]", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Abs", "[", "a", "]"}], 
    RowBox[{"1", "/", "3"}]]}]]], "Output"]
}, Open  ]],

Cell["\<\
The solution for the left side with \[Alpha]>\[Alpha]0 is:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Cp", " ", "solp"}], " ", "/.", " ", 
     RowBox[{"First", "[", "sol", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Re", "[", "a", "]"}], "\[Equal]", "0"}], ",", 
      RowBox[{"d", "\[Element]", "Reals"}], ",", 
      RowBox[{"\[Alpha]", " ", "\[Element]", " ", "Reals"}]}], "}"}]}], "]"}],
   "/.", "WronskianRule"}]], "Input"],

Cell[BoxData[
 FractionBox[
  RowBox[{"2", " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"d", " ", 
     RowBox[{"(", 
      RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}]}]], " ", 
   RowBox[{"AiryAi", "[", 
    FractionBox[
     RowBox[{"c", "+", 
      SuperscriptBox["d", "2"], "+", 
      RowBox[{"a", " ", "\[Alpha]"}]}], 
     SuperscriptBox["a", 
      RowBox[{"2", "/", "3"}]]], "]"}], " ", 
   RowBox[{"AiryAi", "[", 
    FractionBox[
     RowBox[{"c", "+", 
      SuperscriptBox["d", "2"], "+", 
      RowBox[{"a", " ", "\[Alpha]0"}]}], 
     RowBox[{"Conjugate", "[", 
      SuperscriptBox["a", 
       RowBox[{"2", "/", "3"}]], "]"}]], "]"}]}], 
  RowBox[{
   SuperscriptBox["\[Sigma]", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Abs", "[", "a", "]"}], 
    RowBox[{"1", "/", "3"}]]}]]], "Output"]
}, Open  ]],

Cell["The solution for   \[Alpha]==\[Alpha]0 is:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"(", 
  RowBox[{
   RowBox[{"%", "/.", " ", 
    RowBox[{"\[Alpha]", "\[Rule]", " ", "\[Alpha]0"}]}], "//", "Simplify"}], 
  ")"}]], "Input"],

Cell[BoxData[
 FractionBox[
  RowBox[{"2", " ", 
   RowBox[{"AiryAi", "[", 
    FractionBox[
     RowBox[{"c", "+", 
      SuperscriptBox["d", "2"], "+", 
      RowBox[{"a", " ", "\[Alpha]0"}]}], 
     SuperscriptBox["a", 
      RowBox[{"2", "/", "3"}]]], "]"}], " ", 
   RowBox[{"AiryAi", "[", 
    FractionBox[
     RowBox[{"c", "+", 
      SuperscriptBox["d", "2"], "+", 
      RowBox[{"a", " ", "\[Alpha]0"}]}], 
     RowBox[{"Conjugate", "[", 
      SuperscriptBox["a", 
       RowBox[{"2", "/", "3"}]], "]"}]], "]"}]}], 
  RowBox[{
   SuperscriptBox["\[Sigma]", "2"], " ", 
   SuperscriptBox[
    RowBox[{"Abs", "[", "a", "]"}], 
    RowBox[{"1", "/", "3"}]]}]]], "Output"]
}, Open  ]],

Cell["\<\
Note, that the solution is only well defined for a \[NotEqual] 0. For a=0 we \
have to solve the ODE once again.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DSolve", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        SubscriptBox["\[PartialD]", 
         RowBox[{"\[Alpha]", ",", "\[Alpha]"}]], 
        RowBox[{"f", "[", "\[Alpha]", "]"}]}], " ", "-", 
       RowBox[{"2", " ", "d", " ", 
        RowBox[{
         SubscriptBox["\[PartialD]", "\[Alpha]"], 
         RowBox[{"f", "[", "\[Alpha]", "]"}]}]}], "-", 
       RowBox[{"c", " ", 
        RowBox[{"f", "[", "\[Alpha]", "]"}]}]}], "\[Equal]", "0"}], " ", 
     ")"}], ",", 
    RowBox[{"f", "[", "\[Alpha]", "]"}], ",", "\[Alpha]"}], "]"}], 
  " "}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"f", "[", "\[Alpha]", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"d", "-", 
          SqrtBox[
           RowBox[{"c", "+", 
            SuperscriptBox["d", "2"]}]]}], ")"}], " ", "\[Alpha]"}]], " ", 
      RowBox[{"C", "[", "1", "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"d", "+", 
          SqrtBox[
           RowBox[{"c", "+", 
            SuperscriptBox["d", "2"]}]]}], ")"}], " ", "\[Alpha]"}]], " ", 
      RowBox[{"C", "[", "2", "]"}]}]}]}], "}"}], "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"solm", " ", "=", " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"d", "+", 
       SqrtBox[
        RowBox[{"c", "+", 
         SuperscriptBox["d", "2"]}]]}], ")"}], " ", "\[Alpha]"}]]}], ";", 
  RowBox[{"solp", " ", "=", " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"d", "-", 
       SqrtBox[
        RowBox[{"c", "+", 
         SuperscriptBox["d", "2"]}]]}], ")"}], " ", "\[Alpha]"}]]}], 
  ";"}]], "Input"],

Cell["\<\
Merging the solution to the left and the right side of the \[Delta]-function. \
Continuity at \[Alpha]=\[Alpha]0 and \"active\" kinck in the first derivative:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol", " ", "=", " ", 
  RowBox[{
   RowBox[{"Solve", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Cm", " ", 
         RowBox[{"(", 
          RowBox[{"solm", " ", "/.", " ", 
           RowBox[{"\[Alpha]", "\[Rule]", "\[Alpha]0"}]}], ")"}]}], "  ", 
        "\[Equal]", " ", 
        RowBox[{"Cp", " ", 
         RowBox[{"(", 
          RowBox[{"solp", " ", "/.", " ", 
           RowBox[{"\[Alpha]", "\[Rule]", "\[Alpha]0"}]}], ")"}]}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{"Cp", " ", "solp"}], ",", "\[Alpha]"}], "]"}], "/.", " ", 
           RowBox[{"\[Alpha]", "\[Rule]", " ", "\[Alpha]0"}]}], ")"}], " ", 
         "-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"D", "[", 
            RowBox[{
             RowBox[{"Cm", " ", "solm"}], ",", "\[Alpha]"}], "]"}], "/.", " ", 
           RowBox[{"\[Alpha]", "\[Rule]", " ", "\[Alpha]0"}]}], ")"}]}], " ", 
        "\[Equal]", " ", 
        FractionBox[
         RowBox[{"-", "1"}], 
         RowBox[{"\[Pi]", " ", 
          SuperscriptBox["\[Sigma]", "2"]}]]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Cp", ",", "Cm"}], "}"}]}], "\[IndentingNewLine]", "]"}], "//", 
   "Simplify"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Cp", "\[Rule]", 
     FractionBox[
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "d"}], "+", 
          SqrtBox[
           RowBox[{"c", "+", 
            SuperscriptBox["d", "2"]}]]}], ")"}], " ", "\[Alpha]0"}]], 
      RowBox[{"2", " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         SuperscriptBox["d", "2"]}]], " ", "\[Pi]", " ", 
       SuperscriptBox["\[Sigma]", "2"]}]]}], ",", 
    RowBox[{"Cm", "\[Rule]", 
     FractionBox[
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{"d", "+", 
           SqrtBox[
            RowBox[{"c", "+", 
             SuperscriptBox["d", "2"]}]]}], ")"}]}], " ", "\[Alpha]0"}]], 
      RowBox[{"2", " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         SuperscriptBox["d", "2"]}]], " ", "\[Pi]", " ", 
       SuperscriptBox["\[Sigma]", "2"]}]]}]}], "}"}], "}"}]], "Output"]
}, Open  ]],

Cell["\<\
The solution for the left side with \[Alpha]<\[Alpha]0 is:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Cm", " ", "solm"}], " ", "/.", " ", 
    RowBox[{"First", "[", "sol", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Re", "[", "a", "]"}], "\[Equal]", "0"}], ",", 
     RowBox[{"d", "\[Element]", "Reals"}], ",", 
     RowBox[{"\[Alpha]", " ", "\[Element]", " ", "Reals"}]}], "}"}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 FractionBox[
  SuperscriptBox["\[ExponentialE]", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"d", "+", 
      SqrtBox[
       RowBox[{"c", "+", 
        SuperscriptBox["d", "2"]}]]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}]}]], 
  RowBox[{"2", " ", 
   SqrtBox[
    RowBox[{"c", "+", 
     SuperscriptBox["d", "2"]}]], " ", "\[Pi]", " ", 
   SuperscriptBox["\[Sigma]", "2"]}]]], "Output"]
}, Open  ]],

Cell["\<\
The solution for the left side with \[Alpha]>\[Alpha]0 is:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Cp", " ", "solp"}], " ", "/.", " ", 
    RowBox[{"First", "[", "sol", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Re", "[", "a", "]"}], "\[Equal]", "0"}], ",", 
     RowBox[{"d", "\[Element]", "Reals"}], ",", 
     RowBox[{"\[Alpha]", " ", "\[Element]", " ", "Reals"}]}], "}"}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 FractionBox[
  SuperscriptBox["\[ExponentialE]", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "d"}], "+", 
       SqrtBox[
        RowBox[{"c", "+", 
         SuperscriptBox["d", "2"]}]]}], ")"}]}], " ", 
    RowBox[{"(", 
     RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}]}]], 
  RowBox[{"2", " ", 
   SqrtBox[
    RowBox[{"c", "+", 
     SuperscriptBox["d", "2"]}]], " ", "\[Pi]", " ", 
   SuperscriptBox["\[Sigma]", "2"]}]]], "Output"]
}, Open  ]],

Cell["The solution for   \[Alpha]==\[Alpha]0 is:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "/.", " ", 
   RowBox[{"\[Alpha]", "\[Rule]", " ", "\[Alpha]0"}]}], "//", 
  "Simplify"}]], "Input"],

Cell[BoxData[
 FractionBox["1", 
  RowBox[{"2", " ", 
   SqrtBox[
    RowBox[{"c", "+", 
     SuperscriptBox["d", "2"]}]], " ", "\[Pi]", " ", 
   SuperscriptBox["\[Sigma]", "2"]}]]], "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Utility Functions", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Utility", " ", "Functions"}], " ", "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Adjusting Values to a Sequence", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PreviousTick", "::", "usage"}], "=", 
   "\"\<PreviousTick[offset,step][val] finds with in the sequence ..., \
offset-step,offset,offset+step,... the largest element smaller than \
val.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PreviousTick", "[", 
     RowBox[{"min_", ",", 
      RowBox[{"d_:", "1"}]}], "]"}], "[", "val_", "]"}], ":=", " ", 
   RowBox[{"val", "+", 
    RowBox[{"Mod", "[", 
     RowBox[{
      RowBox[{"min", "-", "val"}], ",", "d", ",", 
      RowBox[{"-", "d"}]}], "]"}]}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NextTick", "::", "usage"}], "=", 
   "\"\<NextTick[offset,step][val] finds with in the sequence ..., \
offset-step,offset,offset+step,... the smallest element greater than \
val.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NextTick", "[", 
     RowBox[{"min_", ",", 
      RowBox[{"d_:", "1"}]}], "]"}], "[", "val_", "]"}], ":=", " ", 
   RowBox[{"val", "-", 
    RowBox[{"Mod", "[", 
     RowBox[{
      RowBox[{"val", "-", "min"}], ",", "d"}], "]"}], "+", "d"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OnTick", "::", "usage"}], "=", 
   "\"\<OnTick[offset,step][val] finds with in the sequence ..., \
offset-step,offset,offset+step,... the element closest to val.\>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OnTick", "[", 
     RowBox[{"min_", ",", 
      RowBox[{"d_:", "1"}]}], "]"}], "[", "val_", "]"}], ":=", " ", 
   RowBox[{"val", "-", 
    RowBox[{"Mod", "[", 
     RowBox[{
      RowBox[{"val", "-", "min"}], ",", "d", ",", 
      RowBox[{
       RowBox[{"-", "d"}], "/", "2"}]}], "]"}]}]}], ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Polar Coordinate Transformations", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Angle", "::", "usage"}], "=", 
   "\"\<Angle[x,y] renders like ArcTan the angle between -\[Pi] and \[Pi] \
between the vector {x,y} and the x-axis. Angle[0,0] renders 0 without a \
warning.\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Angle", "=", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Chop", "[", "x", "]"}], "===", "0."}], " ", "\[And]", " ", 
        RowBox[{
         RowBox[{"Chop", "[", "y", "]"}], "===", "0."}]}], ",", "0", ",", 
       RowBox[{"ArcTan", "[", 
        RowBox[{"x", ",", "y"}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ArcTan", "[", 
         RowBox[{"_", ",", "_"}], "]"}], ",", "_Real"}], "}"}], "}"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Radius", "::", "usage"}], "=", 
   "\"\<Radius[x,y] renders the length of vector {x,y}.\>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Radius", "=", " ", 
   RowBox[{
    SqrtBox[
     RowBox[{
      SuperscriptBox["#1", "2"], "+", " ", 
      SuperscriptBox["#2", "2"]}]], "&"}]}], ";"}]], "PackageInput"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Mathieu Functions Utilties", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FloquetCutoff", "::", "usage"}], "=", " ", 
   "\"\<FloquetCutoff[a,b] provides a c-value, for which MathieuC[a,\
\[ImaginaryI] b,c] \[PlusMinus] \[ImaginaryI] MathieuS[a,\[ImaginaryI] b,c] \
approaches 0. See MathieuSSign[a,b] concerning the choice of the correct sign \
of MathieuS[a,\[ImaginaryI] b,c].\>\""}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FloquetCutoff", "=", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"b", ",", "_Real"}], "}"}]}], "}"}], ",", 
     RowBox[{"24", "/", 
      SqrtBox[
       RowBox[{
        RowBox[{"-", "a"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"b", "+", "1"}], ")"}], "/", "2"}]}]]}]}], "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FloquetSign", "::", "usage"}], "=", " ", 
   "\"\<FloquetSign[a,q] provides the sign \[Chi] of the Floquet function \
FloquetF[a,q,z] = MathieuC[a,q,z]+ \[Chi] MathieuS[a,q,z].\>\""}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FloquetSign", "=", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a", ",", "_Complex"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"q", ",", "_Complex"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"Tan", "[", 
           RowBox[{"\[Pi]", " ", 
            RowBox[{"Sign", "[", 
             RowBox[{"Im", "[", "#", "]"}], "]"}], " ", 
            RowBox[{"#", "/", "2"}]}], "]"}]}], "&"}], "[", 
        RowBox[{"MathieuCharacteristicExponent", "[", 
         RowBox[{"a", ",", "q"}], "]"}], "]"}], " ", 
       RowBox[{
        RowBox[{"MathieuC", "[", 
         RowBox[{"a", ",", "q", ",", 
          RowBox[{"\[Pi]", "/", "2"}]}], "]"}], "/", 
        RowBox[{"MathieuS", "[", 
         RowBox[{"a", ",", "q", ",", 
          RowBox[{"\[Pi]", "/", "2"}]}], "]"}]}]}], "//", "Chop"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Tanh", "[", "_", "]"}], ",", "_Complex"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"MathieuCharacteristicExponent", "[", 
          RowBox[{"_", ",", "_"}], "]"}], ",", "_Complex"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"_", ",", "_", ",", "_"}], "]"}], ",", "_Complex"}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"MathieuS", "[", 
          RowBox[{"_", ",", "_", ",", "_"}], "]"}], ",", "_Complex"}], 
        "}"}]}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FloquetExponent", "::", "usage"}], "=", 
  "\"\<FloquetExponent[a,q] provides the Floquet exponent.\>\""}]], "Input"],

Cell[BoxData[
 RowBox[{"FloquetExponent", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"Re", "[", "#", "]"}], ",", "2"}], "]"}], "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"Im", "[", "#", "]"}]}]}], ")"}], "&"}], "[", 
      RowBox[{
       RowBox[{"Sign", "[", 
        RowBox[{"Im", "[", "#", "]"}], "]"}], " ", "#"}], "]"}], "&"}], "[", 
    RowBox[{"MathieuCharacteristicExponent", "[", 
     RowBox[{"#1", ",", "#2"}], "]"}], "]"}], "&"}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["AiryAi Function Fix", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "AiryAi", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AiryAi", "[", "z_", "]"}], " ", ":=", " ", 
  RowBox[{
   FractionBox[
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"2", " ", 
         SuperscriptBox["z", 
          RowBox[{"3", "/", "2"}]]}], "3"]}]], " ", 
     RowBox[{"(", 
      RowBox[{"385", "-", 
       RowBox[{"480", " ", 
        SuperscriptBox["z", 
         RowBox[{"3", "/", "2"}]]}], "+", 
       RowBox[{"4608", " ", 
        SuperscriptBox["z", "3"]}]}], ")"}]}], 
    RowBox[{"9216", " ", 
     SqrtBox["\[Pi]"], " ", 
     SuperscriptBox["z", 
      RowBox[{"13", "/", "4"}]]}]], "/;", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Re", "[", "z", "]"}], ">", "5"}], "\[And]", 
    RowBox[{
     RowBox[{"Re", "[", "z", "]"}], ">", 
     RowBox[{"Abs", "[", 
      RowBox[{"Im", "[", "z", "]"}], "]"}]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "AiryAi", "]"}], ";"}]}], "PackageInput"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Fourier Line Kernel", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Fourier", " ", "Line", " ", "Kernel"}], " ", 
  "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Numeric Implementation", "Subsubsection"],

Cell["\<\
Implementing a compiled version of the Fourier-transformed line kernel..\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Numeric", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"no", " ", "speed", " ", "gain"}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Symbolic Implementation", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FourierLineKernel", "[", 
      RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", " ", "\[Alpha]_"}], "]"}], 
    ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", " ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Kappa]", "2"], "+", 
             RowBox[{"2", " ", "\[Lambda]", " ", 
              SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
           SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[IndentingNewLine]", 
        
        RowBox[{"b", " ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", "\[ImaginaryI]", " ", 
          RowBox[{
           RowBox[{"Radius", "[", 
            RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", " ", 
        "\[IndentingNewLine]", 
        RowBox[{"z\[Omega]", "=", 
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{
            RowBox[{"Angle", "[", 
             RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], "-", 
            "\[Alpha]0"}], "]"}], "/", "2"}]}], ",", "\[Zeta]\[Omega]", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"z\[Alpha]", "=", 
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}], "/", "2"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"z\[Delta]", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Alpha]", "-", 
            RowBox[{"Angle", "[", 
             RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}]}], ")"}], "/", 
          "2"}]}], ",", "\[Zeta]\[Delta]", ",", "\[IndentingNewLine]", 
        RowBox[{"\[Kappa]\[Sigma]", " ", "=", 
         RowBox[{"2", 
          RowBox[{"\[Kappa]", "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", "\[Chi]", ",", 
        "i\[Nu]", ",", "\[IndentingNewLine]", "mp\[Omega]", ",", 
        "mm\[Omega]"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Chi]", "   ", "=", " ", 
        RowBox[{"FloquetSign", "[", 
         RowBox[{"a", ",", "b"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"i\[Nu]", " ", "=", " ", 
        RowBox[{"-", 
         RowBox[{"Abs", "[", 
          RowBox[{"Im", "[", 
           RowBox[{"MathieuCharacteristicExponent", "[", 
            RowBox[{"a", ",", "b"}], "]"}], "]"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Zeta]\[Omega]", " ", "=", " ", 
        RowBox[{"Mod", "[", 
         RowBox[{"z\[Omega]", ",", "\[Pi]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Zeta]\[Delta]", " ", "=", " ", 
        RowBox[{"Mod", "[", 
         RowBox[{"z\[Delta]", ",", "\[Pi]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"mp\[Omega]", " ", "=", " ", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "b", ",", 
           RowBox[{"\[Zeta]\[Omega]", "-", "\[Pi]"}]}], "]"}], "+", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "b", ",", 
            RowBox[{"\[Zeta]\[Omega]", "-", "\[Pi]"}]}], "]"}]}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"mm\[Omega]", " ", "=", " ", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "b", ",", "\[Zeta]\[Omega]"}], "]"}], "-", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "b", ",", "\[Zeta]\[Omega]"}], "]"}]}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{"\[Chi]", " ", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"\[Kappa]\[Sigma]", " ", "z\[Alpha]"}]]}], 
           RowBox[{"\[Pi]", " ", 
            SuperscriptBox["\[Sigma]", 
             RowBox[{"2", " "}]], 
            RowBox[{"MathieuSPrime", "[", 
             RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
            RowBox[{"MathieuC", "[", 
             RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]], "*", 
          RowBox[{"Piecewise", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", "*", "i\[Nu]", "*", "Pi"}], " ", "-", " ", 
                    "#1"}], ")"}]}], "*", "mp\[Omega]", "*", "#2"}], ")"}], 
                  "/", 
                  RowBox[{"(", 
                   RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "+", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}], " ", "+", " ", "\n", "    ", 
                 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "-", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], " ", "+", " ", "#1"}], ")"}]}], "*", 
                    "mm\[Omega]", "*", "#3"}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "-", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}]}], ",", " ", "\n", "   ", 
                RowBox[{"Positive", "[", "z\[Alpha]", "]"}]}], "}"}], ",", 
              " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"3", "*", "i\[Nu]"}], " ", "+", " ", 
                    "\[Kappa]\[Sigma]"}], ")"}]}], " ", "-", " ", "#1"}], 
                    ")"}]}], "*", "mp\[Omega]", "*", "#2"}], ")"}], "/", "\n",
                   "     ", 
                  RowBox[{"(", 
                   RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "+", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}], " ", "+", " ", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"E", "^", "#1"}], "*", "mm\[Omega]", "*", "#3"}], 
                   ")"}], "/", "\n", "     ", 
                  RowBox[{"(", 
                   RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "-", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}]}], ",", " ", 
                RowBox[{"Negative", "[", "z\[Alpha]", "]"}]}], "}"}]}], "}"}],
             ",", " ", "\n", " ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"E", "^", 
                RowBox[{"(", 
                 RowBox[{"i\[Nu]", "*", "Pi"}], ")"}]}], "*", 
               RowBox[{"(", 
                RowBox[{"1", " ", "-", " ", 
                 RowBox[{"E", "^", 
                  RowBox[{"(", 
                   RowBox[{"2", "*", "i\[Nu]", "*", "Pi"}], ")"}]}]}], ")"}], 
               "*", "mm\[Omega]", "*", "mp\[Omega]"}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"1", " ", "-", " ", 
                 RowBox[{"E", "^", 
                  RowBox[{"(", 
                   RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "-", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}], "*", "\n", "   ", 
               RowBox[{"(", 
                RowBox[{"1", " ", "-", " ", 
                 RowBox[{"E", "^", 
                  RowBox[{"(", 
                   RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "+", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}], ")"}]}]}], "]"}]}], "&"}], 
        "[", 
        RowBox[{
         RowBox[{"i\[Nu]", " ", 
          RowBox[{"(", 
           RowBox[{
           "\[Zeta]\[Delta]", "-", "z\[Delta]", "+", "\[Zeta]\[Omega]", "-", 
            "z\[Omega]"}], ")"}]}], ",", 
         RowBox[{
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "b", ",", 
            RowBox[{"\[Zeta]\[Delta]", "-", "\[Pi]"}]}], "]"}], "+", 
          RowBox[{"\[Chi]", " ", 
           RowBox[{"MathieuS", "[", 
            RowBox[{"a", ",", "b", ",", 
             RowBox[{"\[Zeta]\[Delta]", "-", "\[Pi]"}]}], "]"}]}]}], ",", 
         RowBox[{
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "b", ",", "\[Zeta]\[Delta]"}], "]"}], "-", 
          RowBox[{"\[Chi]", " ", 
           RowBox[{"MathieuS", "[", 
            RowBox[{"a", ",", "b", ",", "\[Zeta]\[Delta]"}], "]"}]}]}]}], 
        "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FourierLineKernel", "[", 
      RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", 
      RowBox[{"{", 
       RowBox[{"n\[Alpha]_Integer", "?", "Positive"}], "}"}]}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "  ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Kappa]", "2"], "+", 
             RowBox[{"2", " ", "\[Lambda]", " ", 
              SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
           SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[IndentingNewLine]", 
        
        RowBox[{"b", "  ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", "\[ImaginaryI]", " ", 
          RowBox[{
           RowBox[{"Radius", "[", 
            RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", " ", 
        "\[IndentingNewLine]", 
        RowBox[{"z\[Omega]", "=", 
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{
            RowBox[{"Angle", "[", 
             RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], "-", 
            "\[Alpha]0"}], "]"}], "/", "2"}]}], ",", "\[Zeta]\[Omega]", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Alpha]", "  ", "=", " ", 
         RowBox[{"Range", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[Pi]"}], "+", 
            RowBox[{"2", 
             RowBox[{"\[Pi]", "/", "n\[Alpha]"}]}]}], ",", "\[Pi]", ",", 
           RowBox[{"2", 
            RowBox[{"\[Pi]", "/", "n\[Alpha]"}]}]}], "]"}]}], ",", 
        "z\[Delta]", ",", "\[Zeta]\[Delta]", ",", "\[IndentingNewLine]", 
        RowBox[{"\[Kappa]\[Sigma]", "=", 
         RowBox[{"2", 
          RowBox[{"\[Kappa]", "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", "\[Chi]", ",", 
        "i\[Nu]", ",", "\[IndentingNewLine]", "mp\[Omega]", ",", 
        "mm\[Omega]"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Chi]", "   ", "=", 
        RowBox[{"FloquetSign", "[", 
         RowBox[{"a", ",", "b"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"i\[Nu]", " ", "=", 
        RowBox[{"-", 
         RowBox[{"Abs", "[", 
          RowBox[{"Im", "[", 
           RowBox[{"MathieuCharacteristicExponent", "[", 
            RowBox[{"a", ",", "b"}], "]"}], "]"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Zeta]\[Omega]", " ", "=", " ", 
        RowBox[{"Mod", "[", 
         RowBox[{"z\[Omega]", ",", "\[Pi]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"z\[Delta]", " ", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[Alpha]", "-", 
           RowBox[{"Angle", "[", 
            RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}]}], ")"}], "/", 
         "2"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Zeta]\[Delta]", " ", "=", " ", 
        RowBox[{"Mod", "[", 
         RowBox[{"z\[Delta]", ",", "\[Pi]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"mp\[Omega]", " ", "=", " ", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "b", ",", 
           RowBox[{"\[Zeta]\[Omega]", "-", "\[Pi]"}]}], "]"}], "+", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "b", ",", 
            RowBox[{"\[Zeta]\[Omega]", "-", "\[Pi]"}]}], "]"}]}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"mm\[Omega]", " ", "=", " ", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "b", ",", "\[Zeta]\[Omega]"}], "]"}], "-", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "b", ",", "\[Zeta]\[Omega]"}], "]"}]}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        FractionBox["\[Chi]", 
         RowBox[{"\[Pi]", " ", 
          SuperscriptBox["\[Sigma]", 
           RowBox[{"2", " "}]], 
          RowBox[{"MathieuSPrime", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]], "*", 
        "\[IndentingNewLine]", 
        RowBox[{"MapThread", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Piecewise", "[", "\n", " ", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"E", "^", 
                   RowBox[{"(", 
                    RowBox[{"\[Kappa]\[Sigma]", "*", "#1"}], ")"}]}], "*", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", "*", "i\[Nu]", "*", "Pi"}], " ", "-", " ", 
                    "#2"}], ")"}]}], "*", "mp\[Omega]", "*", "#3"}], ")"}], 
                    "/", 
                    RowBox[{"(", 
                    RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "+", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}], " ", "+", " ", "\n", "     ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "-", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], " ", "+", " ", "#2"}], ")"}]}], "*", 
                    "mm\[Omega]", "*", "#4"}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "-", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", " ", "\n", 
                 "   ", 
                 RowBox[{"Positive", "[", "#1", "]"}]}], "}"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"E", "^", 
                   RowBox[{"(", 
                    RowBox[{"\[Kappa]\[Sigma]", "*", "#1"}], ")"}]}], "*", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"3", "*", "i\[Nu]"}], " ", "+", " ", 
                    "\[Kappa]\[Sigma]"}], ")"}]}], " ", "-", " ", "#2"}], 
                    ")"}]}], "*", "mp\[Omega]", "*", "#3"}], ")"}], "/", "\n",
                     "      ", 
                    RowBox[{"(", 
                    RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "+", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}], " ", "+", " ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"E", "^", "#2"}], "*", "mm\[Omega]", "*", "#4"}], 
                    ")"}], "/", "\n", "      ", 
                    RowBox[{"(", 
                    RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "-", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", " ", 
                 RowBox[{"Negative", "[", "#1", "]"}]}], "}"}]}], "}"}], ",", 
             " ", "\n", " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"E", "^", 
                 RowBox[{"(", 
                  RowBox[{"i\[Nu]", "*", "Pi"}], ")"}]}], "*", 
                RowBox[{"(", 
                 RowBox[{"1", " ", "-", " ", 
                  RowBox[{"E", "^", 
                   RowBox[{"(", 
                    RowBox[{"2", "*", "i\[Nu]", "*", "Pi"}], ")"}]}]}], ")"}],
                 "*", "mm\[Omega]", "*", "mp\[Omega]"}], ")"}], "/", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", " ", "-", " ", 
                  RowBox[{"E", "^", 
                   RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "-", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}], "*", "\n", "   ", 
                RowBox[{"(", 
                 RowBox[{"1", " ", "-", " ", 
                  RowBox[{"E", "^", 
                   RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "+", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}], ")"}]}]}], "]"}], "&"}], ",",
           "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"N", "[", 
              RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}], "/", "2"}], ",", 
            
            RowBox[{"i\[Nu]", 
             RowBox[{"(", 
              RowBox[{
              "\[Zeta]\[Delta]", "-", "z\[Delta]", "+", "\[Zeta]\[Omega]", 
               "-", "z\[Omega]"}], ")"}]}], ",", 
            RowBox[{
             RowBox[{"MathieuC", "[", 
              RowBox[{"a", ",", "b", ",", 
               RowBox[{"\[Zeta]\[Delta]", "-", "\[Pi]"}]}], "]"}], "+", 
             RowBox[{"\[Chi]", " ", 
              RowBox[{"MathieuS", "[", 
               RowBox[{"a", ",", "b", ",", 
                RowBox[{"\[Zeta]\[Delta]", "-", "\[Pi]"}]}], "]"}]}]}], ",", 
            RowBox[{
             RowBox[{"MathieuC", "[", 
              RowBox[{"a", ",", "b", ",", "\[Zeta]\[Delta]"}], "]"}], "-", 
             RowBox[{"\[Chi]", " ", 
              RowBox[{"MathieuS", "[", 
               RowBox[{"a", ",", "b", ",", "\[Zeta]\[Delta]"}], "]"}]}]}]}], 
           "}"}]}], "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FourierLineKernel", "[", 
      RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", 
      RowBox[{"{", 
       RowBox[{"min\[Alpha]_", ",", "max\[Alpha]_", ",", "d\[Alpha]_"}], 
       "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "  ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Kappa]", "2"], "+", 
             RowBox[{"2", " ", "\[Lambda]", " ", 
              SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
           SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[IndentingNewLine]", 
        
        RowBox[{"b", "  ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", "\[ImaginaryI]", " ", 
          RowBox[{
           RowBox[{"Radius", "[", 
            RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", " ", 
        "\[IndentingNewLine]", 
        RowBox[{"z\[Omega]", "=", 
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{
            RowBox[{"Angle", "[", 
             RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], "-", 
            "\[Alpha]0"}], "]"}], "/", "2"}]}], ",", "\[Zeta]\[Omega]", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Alpha]", "  ", "=", " ", 
         RowBox[{"Range", "[", 
          RowBox[{"min\[Alpha]", ",", "max\[Alpha]", ",", "d\[Alpha]"}], 
          "]"}]}], ",", "z\[Delta]", ",", "\[Zeta]\[Delta]", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Kappa]\[Sigma]", "=", 
         RowBox[{"2", 
          RowBox[{"\[Kappa]", "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", "\[Chi]", ",", 
        "i\[Nu]", ",", "\[IndentingNewLine]", "mp\[Omega]", ",", 
        "mm\[Omega]"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Chi]", "   ", "=", 
        RowBox[{"FloquetSign", "[", 
         RowBox[{"a", ",", "b"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"i\[Nu]", " ", "=", 
        RowBox[{"-", 
         RowBox[{"Abs", "[", 
          RowBox[{"Im", "[", 
           RowBox[{"MathieuCharacteristicExponent", "[", 
            RowBox[{"a", ",", "b"}], "]"}], "]"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"z\[Delta]", " ", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[Alpha]", "-", 
           RowBox[{"Angle", "[", 
            RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}]}], ")"}], "/", 
         "2"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Zeta]\[Omega]", " ", "=", " ", 
        RowBox[{"Mod", "[", 
         RowBox[{"z\[Omega]", ",", "\[Pi]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Zeta]\[Delta]", " ", "=", " ", 
        RowBox[{"Mod", "[", 
         RowBox[{"z\[Delta]", ",", "\[Pi]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"mp\[Omega]", " ", "=", " ", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "b", ",", 
           RowBox[{"\[Zeta]\[Omega]", "-", "\[Pi]"}]}], "]"}], "+", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "b", ",", 
            RowBox[{"\[Zeta]\[Omega]", "-", "\[Pi]"}]}], "]"}]}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"mm\[Omega]", " ", "=", " ", 
        RowBox[{
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "b", ",", "\[Zeta]\[Omega]"}], "]"}], "-", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "b", ",", "\[Zeta]\[Omega]"}], "]"}]}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        FractionBox["\[Chi]", 
         RowBox[{"\[Pi]", " ", 
          SuperscriptBox["\[Sigma]", 
           RowBox[{"2", " "}]], 
          RowBox[{"MathieuSPrime", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]], "*", 
        "\[IndentingNewLine]", 
        RowBox[{"MapThread", "[", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"Piecewise", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"E", "^", 
                   RowBox[{"(", 
                    RowBox[{"\[Kappa]\[Sigma]", "*", "#1"}], ")"}]}], "*", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"2", "*", "i\[Nu]", "*", "Pi"}], "-", "#2"}], 
                    ")"}]}], "*", "mp\[Omega]", "*", "#3"}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "+", "\[Kappa]\[Sigma]"}], ")"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "-", "\[Kappa]\[Sigma]"}], ")"}]}], "+",
                     "#2"}], ")"}]}], "*", "mm\[Omega]", "*", "#4"}], ")"}], 
                    "/", 
                    RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "-", "\[Kappa]\[Sigma]"}], ")"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
                 RowBox[{"Positive", "[", "#1", "]"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"E", "^", 
                   RowBox[{"(", 
                    RowBox[{"\[Kappa]\[Sigma]", "*", "#1"}], ")"}]}], "*", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"3", "*", "i\[Nu]"}], "+", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], "-", "#2"}], ")"}]}], "*", "mp\[Omega]", "*", 
                    "#3"}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "+", "\[Kappa]\[Sigma]"}], ")"}]}], 
                    ")"}]}]}], ")"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"E", "^", "#2"}], "*", "mm\[Omega]", "*", "#4"}], 
                    ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "-", "\[Kappa]\[Sigma]"}], ")"}]}], 
                    ")"}]}]}], ")"}]}]}], ")"}]}], ",", 
                 RowBox[{"Negative", "[", "#1", "]"}]}], "}"}]}], "}"}], ",", 
             
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"E", "^", 
                 RowBox[{"(", 
                  RowBox[{"i\[Nu]", "*", "Pi"}], ")"}]}], "*", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"E", "^", 
                   RowBox[{"(", 
                    RowBox[{"2", "*", "i\[Nu]", "*", "Pi"}], ")"}]}]}], ")"}],
                 "*", "mm\[Omega]", "*", "mp\[Omega]"}], ")"}], "/", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"E", "^", 
                   RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "-", "\[Kappa]\[Sigma]"}], ")"}]}], 
                    ")"}]}]}], ")"}], "*", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"E", "^", 
                   RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "+", "\[Kappa]\[Sigma]"}], ")"}]}], 
                    ")"}]}]}], ")"}]}], ")"}]}]}], "]"}], "&"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"N", "[", 
              RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}], "/", "2"}], ",", 
            
            RowBox[{"i\[Nu]", 
             RowBox[{"(", 
              RowBox[{
              "\[Zeta]\[Delta]", "-", "z\[Delta]", "+", "\[Zeta]\[Omega]", 
               "-", "z\[Omega]"}], ")"}]}], ",", 
            RowBox[{
             RowBox[{"MathieuC", "[", 
              RowBox[{"a", ",", "b", ",", 
               RowBox[{"\[Zeta]\[Delta]", "-", "\[Pi]"}]}], "]"}], "+", 
             RowBox[{"\[Chi]", " ", 
              RowBox[{"MathieuS", "[", 
               RowBox[{"a", ",", "b", ",", 
                RowBox[{"\[Zeta]\[Delta]", "-", "\[Pi]"}]}], "]"}]}]}], ",", 
            RowBox[{
             RowBox[{"MathieuC", "[", 
              RowBox[{"a", ",", "b", ",", "\[Zeta]\[Delta]"}], "]"}], "-", 
             RowBox[{"\[Chi]", " ", 
              RowBox[{"MathieuS", "[", 
               RowBox[{"a", ",", "b", ",", "\[Zeta]\[Delta]"}], "]"}]}]}]}], 
           "}"}]}], "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Symbolic Implementation (backup: faster but numerically unstable)\
\>", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FourierLineKernel", "[", 
      RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", " ", "\[Alpha]_"}], "]"}], 
    ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", " ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Kappa]", "2"], "+", 
             RowBox[{"2", " ", "\[Lambda]", " ", 
              SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
           SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[IndentingNewLine]", 
        
        RowBox[{"b", " ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", "\[ImaginaryI]", " ", 
          RowBox[{
           RowBox[{"Radius", "[", 
            RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", " ", 
        "\[IndentingNewLine]", 
        RowBox[{"z\[Omega]", "=", 
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{
            RowBox[{"Angle", "[", 
             RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], "-", 
            "\[Alpha]0"}], "]"}], "/", "2"}]}], ",", "\[Zeta]\[Omega]", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"z\[Alpha]", "=", 
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}], "/", "2"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"z\[Delta]", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Alpha]", "-", 
            RowBox[{"Angle", "[", 
             RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}]}], ")"}], "/", 
          "2"}]}], ",", "\[Zeta]\[Delta]", ",", "\[IndentingNewLine]", 
        RowBox[{"\[Kappa]\[Sigma]", " ", "=", 
         RowBox[{"2", 
          RowBox[{"\[Kappa]", "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", "\[Chi]", ",", 
        "i\[Nu]", ",", "\[IndentingNewLine]", "mc\[Omega]", ",", 
        "ms\[Omega]"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Chi]", "   ", "=", " ", 
        RowBox[{"FloquetSign", "[", 
         RowBox[{"a", ",", "b"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"i\[Nu]", " ", "=", " ", 
        RowBox[{"-", 
         RowBox[{"Abs", "[", 
          RowBox[{"Im", "[", 
           RowBox[{"MathieuCharacteristicExponent", "[", 
            RowBox[{"a", ",", "b"}], "]"}], "]"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Zeta]\[Omega]", " ", "=", " ", 
        RowBox[{"Mod", "[", 
         RowBox[{"z\[Omega]", ",", "\[Pi]", ",", 
          RowBox[{
           RowBox[{"-", "\[Pi]"}], "/", "2"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Zeta]\[Delta]", " ", "=", " ", 
        RowBox[{"Mod", "[", 
         RowBox[{"z\[Delta]", ",", "\[Pi]", ",", 
          RowBox[{
           RowBox[{"-", "\[Pi]"}], "/", "2"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"mc\[Omega]", " ", "=", " ", 
        RowBox[{"MathieuC", "[", 
         RowBox[{"a", ",", "b", ",", "\[Zeta]\[Omega]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ms\[Omega]", " ", "=", " ", 
        RowBox[{"\[Chi]", " ", 
         RowBox[{"MathieuS", "[", 
          RowBox[{"a", ",", "b", ",", "\[Zeta]\[Omega]"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{"\[Chi]", " ", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"\[Kappa]\[Sigma]", " ", "z\[Alpha]"}]]}], 
           RowBox[{"\[Pi]", " ", 
            SuperscriptBox["\[Sigma]", 
             RowBox[{"2", " "}]], 
            RowBox[{"MathieuSPrime", "[", 
             RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
            RowBox[{"MathieuC", "[", 
             RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]], "*", 
          RowBox[{"(", 
           RowBox[{"\[Piecewise]", GridBox[{
              {
               RowBox[{
                FractionBox[
                 RowBox[{
                  SuperscriptBox["\[ExponentialE]", 
                   RowBox[{"-", "#1"}]], 
                  RowBox[{"(", 
                   RowBox[{"#2", "+", "#3"}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{"mc\[Omega]", "+", "ms\[Omega]"}], ")"}]}], 
                 RowBox[{"1", "-", 
                  SuperscriptBox["\[ExponentialE]", 
                   RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "+", "\[Kappa]\[Sigma]"}], ")"}]}]]}]], 
                "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["\[ExponentialE]", "#1"], " ", 
                  RowBox[{"(", 
                   RowBox[{"#2", "-", "#3"}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{"mc\[Omega]", "-", "ms\[Omega]"}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["\[ExponentialE]", 
                   RowBox[{
                    RowBox[{"-", "\[Pi]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "-", "\[Kappa]\[Sigma]"}], ")"}]}]], 
                  "-", "1"}]]}], 
               RowBox[{"Positive", "[", "z\[Alpha]", "]"}]},
              {
               RowBox[{
                FractionBox[
                 RowBox[{
                  SuperscriptBox["\[ExponentialE]", 
                   RowBox[{"-", "#1"}]], " ", 
                  RowBox[{"(", 
                   RowBox[{"#2", "+", "#3"}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{"mc\[Omega]", "+", "ms\[Omega]"}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["\[ExponentialE]", 
                   RowBox[{
                    RowBox[{"-", "\[Pi]"}], " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "+", "\[Kappa]\[Sigma]"}], ")"}]}]], 
                  "-", "1"}]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["\[ExponentialE]", "#1"], 
                  RowBox[{"(", 
                   RowBox[{"#2", "-", "#3"}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{"mc\[Omega]", "-", "ms\[Omega]"}], ")"}]}], 
                 RowBox[{"1", "-", 
                  SuperscriptBox["\[ExponentialE]", 
                   RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "-", "\[Kappa]\[Sigma]"}], 
                    ")"}]}]]}]]}], 
               RowBox[{"Negative", "[", "z\[Alpha]", "]"}]},
              {
               FractionBox[
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"2", "\[Pi]", " ", "i\[Nu]"}]]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["mc\[Omega]", "2"], "-", 
                   SuperscriptBox["ms\[Omega]", "2"]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "-", "\[Kappa]\[Sigma]"}], ")"}]}]]}], 
                  ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "+", "\[Kappa]\[Sigma]"}], ")"}]}]]}], 
                  ")"}]}]], 
               TagBox["True",
                "PiecewiseDefault",
                AutoDelete->False,
                DeletionWarning->True]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.84]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}]}], ")"}]}], "&"}], "[", 
        RowBox[{
         RowBox[{"i\[Nu]", " ", 
          RowBox[{"(", 
           RowBox[{
           "\[Zeta]\[Delta]", "-", "z\[Delta]", "+", "\[Zeta]\[Omega]", "-", 
            "z\[Omega]"}], ")"}]}], ",", 
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "b", ",", "\[Zeta]\[Delta]"}], "]"}], ",", 
         RowBox[{"\[Chi]", " ", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "b", ",", "\[Zeta]\[Delta]"}], "]"}]}]}], 
        "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FourierLineKernel", "[", 
      RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", 
      RowBox[{"{", 
       RowBox[{"n\[Alpha]_Integer", "?", "Positive"}], "}"}]}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "  ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Kappa]", "2"], "+", 
             RowBox[{"2", " ", "\[Lambda]", " ", 
              SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
           SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[IndentingNewLine]", 
        
        RowBox[{"b", "  ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", "\[ImaginaryI]", " ", 
          RowBox[{
           RowBox[{"Radius", "[", 
            RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", " ", 
        "\[IndentingNewLine]", 
        RowBox[{"z\[Omega]", "=", 
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{
            RowBox[{"Angle", "[", 
             RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], "-", 
            "\[Alpha]0"}], "]"}], "/", "2"}]}], ",", "\[Zeta]\[Omega]", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Alpha]", "  ", "=", " ", 
         RowBox[{"Range", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[Pi]"}], "+", 
            RowBox[{"2", 
             RowBox[{"\[Pi]", "/", "n\[Alpha]"}]}]}], ",", "\[Pi]", ",", 
           RowBox[{"2", 
            RowBox[{"\[Pi]", "/", "n\[Alpha]"}]}]}], "]"}]}], ",", 
        "z\[Delta]", ",", "\[Zeta]\[Delta]", ",", "\[IndentingNewLine]", 
        RowBox[{"\[Kappa]\[Sigma]", "=", 
         RowBox[{"2", 
          RowBox[{"\[Kappa]", "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", "\[Chi]", ",", 
        "i\[Nu]", ",", "\[IndentingNewLine]", "mc\[Omega]", ",", 
        "ms\[Omega]"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Chi]", "   ", "=", 
        RowBox[{"FloquetSign", "[", 
         RowBox[{"a", ",", "b"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"i\[Nu]", " ", "=", 
        RowBox[{"-", 
         RowBox[{"Abs", "[", 
          RowBox[{"Im", "[", 
           RowBox[{"MathieuCharacteristicExponent", "[", 
            RowBox[{"a", ",", "b"}], "]"}], "]"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Zeta]\[Omega]", " ", "=", " ", 
        RowBox[{"Mod", "[", 
         RowBox[{"z\[Omega]", ",", "\[Pi]", ",", 
          RowBox[{
           RowBox[{"-", "\[Pi]"}], "/", "2"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"z\[Delta]", " ", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[Alpha]", "-", 
           RowBox[{"Angle", "[", 
            RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}]}], ")"}], "/", 
         "2"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Zeta]\[Delta]", " ", "=", " ", 
        RowBox[{"Mod", "[", 
         RowBox[{"z\[Delta]", ",", "\[Pi]", ",", 
          RowBox[{
           RowBox[{"-", "\[Pi]"}], "/", "2"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"mc\[Omega]", " ", "=", " ", 
        RowBox[{"MathieuC", "[", 
         RowBox[{"a", ",", "b", ",", "\[Zeta]\[Omega]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ms\[Omega]", " ", "=", " ", 
        RowBox[{"\[Chi]", " ", 
         RowBox[{"MathieuS", "[", 
          RowBox[{"a", ",", "b", ",", "\[Zeta]\[Omega]"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        FractionBox["\[Chi]", 
         RowBox[{"\[Pi]", " ", 
          SuperscriptBox["\[Sigma]", 
           RowBox[{"2", " "}]], 
          RowBox[{"MathieuSPrime", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]], "*", 
        "\[IndentingNewLine]", 
        RowBox[{"MapThread", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Piecewise]", GridBox[{
              {
               RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                 RowBox[{"\[Kappa]\[Sigma]", " ", "#1"}]], 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   RowBox[{
                    SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"-", "#2"}]], 
                    RowBox[{"(", 
                    RowBox[{"#3", "+", "#4"}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{"mc\[Omega]", "+", "ms\[Omega]"}], ")"}]}], 
                   RowBox[{"1", "-", 
                    SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "+", "\[Kappa]\[Sigma]"}], ")"}]}]]}]], 
                  "+", 
                  FractionBox[
                   RowBox[{
                    SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "-", "\[Kappa]\[Sigma]"}], ")"}]}], "+",
                     "#2"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{"#3", "-", "#4"}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{"mc\[Omega]", "-", "ms\[Omega]"}], ")"}]}], 
                   RowBox[{"1", "-", 
                    SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "-", "\[Kappa]\[Sigma]"}], 
                    ")"}]}]]}]]}], ")"}]}], 
               RowBox[{"Positive", "[", "#1", "]"}]},
              {
               RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                 RowBox[{"\[Kappa]\[Sigma]", " ", "#1"}]], 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   RowBox[{
                    SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "+", "\[Kappa]\[Sigma]"}], ")"}]}], "-",
                     "#2"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{"#3", "+", "#4"}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{"mc\[Omega]", "+", "ms\[Omega]"}], ")"}]}], 
                   RowBox[{"1", "-", 
                    SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "+", "\[Kappa]\[Sigma]"}], ")"}]}]]}]], 
                  "+", 
                  FractionBox[
                   RowBox[{
                    SuperscriptBox["\[ExponentialE]", "#2"], 
                    RowBox[{"(", 
                    RowBox[{"#3", "-", "#4"}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{"mc\[Omega]", "-", "ms\[Omega]"}], ")"}]}], 
                   RowBox[{"1", "-", 
                    SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "-", "\[Kappa]\[Sigma]"}], 
                    ")"}]}]]}]]}], ")"}]}], 
               RowBox[{"Negative", "[", "#1", "]"}]},
              {
               FractionBox[
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"2", "\[Pi]", " ", "i\[Nu]"}]]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["mc\[Omega]", "2"], "-", 
                   SuperscriptBox["ms\[Omega]", "2"]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "-", "\[Kappa]\[Sigma]"}], ")"}]}]]}], 
                  ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "+", "\[Kappa]\[Sigma]"}], ")"}]}]]}], 
                  ")"}]}]], 
               TagBox["True",
                "PiecewiseDefault",
                AutoDelete->False,
                DeletionWarning->True]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.84]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}]}], "&"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"z\[Alpha]", " ", "=", 
             RowBox[{
              RowBox[{"N", "[", 
               RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}], "/", "2"}]}], 
            ",", 
            RowBox[{"i\[Nu]", 
             RowBox[{"(", 
              RowBox[{
              "\[Zeta]\[Delta]", "-", "z\[Delta]", "+", "\[Zeta]\[Omega]", 
               "-", "z\[Omega]"}], ")"}]}], ",", 
            RowBox[{"MathieuC", "[", 
             RowBox[{"a", ",", "b", ",", "\[Zeta]\[Delta]"}], "]"}], ",", 
            RowBox[{"\[Chi]", " ", 
             RowBox[{"MathieuS", "[", 
              RowBox[{"a", ",", "b", ",", "\[Zeta]\[Delta]"}], "]"}]}]}], 
           "}"}]}], "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FourierLineKernel", "[", 
      RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", 
      RowBox[{"{", 
       RowBox[{"min\[Alpha]_", ",", "max\[Alpha]_", ",", "d\[Alpha]_"}], 
       "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "  ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Kappa]", "2"], "+", 
             RowBox[{"2", " ", "\[Lambda]", " ", 
              SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
           SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[IndentingNewLine]", 
        
        RowBox[{"b", "  ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", "\[ImaginaryI]", " ", 
          RowBox[{
           RowBox[{"Radius", "[", 
            RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", " ", 
        "\[IndentingNewLine]", 
        RowBox[{"z\[Omega]", "=", 
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{
            RowBox[{"Angle", "[", 
             RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], "-", 
            "\[Alpha]0"}], "]"}], "/", "2"}]}], ",", "\[Zeta]\[Omega]", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Alpha]", "  ", "=", " ", 
         RowBox[{"Range", "[", 
          RowBox[{"min\[Alpha]", ",", "max\[Alpha]", ",", "d\[Alpha]"}], 
          "]"}]}], ",", "z\[Delta]", ",", "\[Zeta]\[Delta]", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Kappa]\[Sigma]", "=", 
         RowBox[{"2", 
          RowBox[{"\[Kappa]", "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", "\[Chi]", ",", 
        "i\[Nu]", ",", "\[IndentingNewLine]", "mc\[Omega]", ",", 
        "ms\[Omega]"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Chi]", "   ", "=", 
        RowBox[{"FloquetSign", "[", 
         RowBox[{"a", ",", "b"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"i\[Nu]", " ", "=", 
        RowBox[{"-", 
         RowBox[{"Abs", "[", 
          RowBox[{"Im", "[", 
           RowBox[{"MathieuCharacteristicExponent", "[", 
            RowBox[{"a", ",", "b"}], "]"}], "]"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"z\[Delta]", " ", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[Alpha]", "-", 
           RowBox[{"Angle", "[", 
            RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}]}], ")"}], "/", 
         "2"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Zeta]\[Omega]", " ", "=", " ", 
        RowBox[{"Mod", "[", 
         RowBox[{"z\[Omega]", ",", "\[Pi]", ",", 
          RowBox[{
           RowBox[{"-", "\[Pi]"}], "/", "2"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Zeta]\[Delta]", " ", "=", " ", 
        RowBox[{"Mod", "[", 
         RowBox[{"z\[Delta]", ",", "\[Pi]", ",", 
          RowBox[{
           RowBox[{"-", "\[Pi]"}], "/", "2"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"mc\[Omega]", " ", "=", " ", 
        RowBox[{"MathieuC", "[", 
         RowBox[{"a", ",", "b", ",", "\[Zeta]\[Omega]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ms\[Omega]", " ", "=", " ", 
        RowBox[{"\[Chi]", " ", 
         RowBox[{"MathieuS", "[", 
          RowBox[{"a", ",", "b", ",", "\[Zeta]\[Omega]"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        FractionBox["\[Chi]", 
         RowBox[{"\[Pi]", " ", 
          SuperscriptBox["\[Sigma]", 
           RowBox[{"2", " "}]], 
          RowBox[{"MathieuSPrime", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]], "*", 
        "\[IndentingNewLine]", 
        RowBox[{"MapThread", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Piecewise]", GridBox[{
              {
               RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                 RowBox[{"\[Kappa]\[Sigma]", " ", "#1"}]], 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   RowBox[{
                    SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"-", "#2"}]], 
                    RowBox[{"(", 
                    RowBox[{"#3", "+", "#4"}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{"mc\[Omega]", "+", "ms\[Omega]"}], ")"}]}], 
                   RowBox[{"1", "-", 
                    SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "+", "\[Kappa]\[Sigma]"}], ")"}]}]]}]], 
                  "+", 
                  FractionBox[
                   RowBox[{
                    SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "-", "\[Kappa]\[Sigma]"}], ")"}]}], "+",
                     "#2"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{"#3", "-", "#4"}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{"mc\[Omega]", "-", "ms\[Omega]"}], ")"}]}], 
                   RowBox[{"1", "-", 
                    SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "-", "\[Kappa]\[Sigma]"}], 
                    ")"}]}]]}]]}], ")"}]}], 
               RowBox[{"Positive", "[", "#1", "]"}]},
              {
               RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                 RowBox[{"\[Kappa]\[Sigma]", " ", "#1"}]], 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   RowBox[{
                    SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "+", "\[Kappa]\[Sigma]"}], ")"}]}], "-",
                     "#2"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{"#3", "+", "#4"}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{"mc\[Omega]", "+", "ms\[Omega]"}], ")"}]}], 
                   RowBox[{"1", "-", 
                    SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "+", "\[Kappa]\[Sigma]"}], ")"}]}]]}]], 
                  "+", 
                  FractionBox[
                   RowBox[{
                    SuperscriptBox["\[ExponentialE]", "#2"], 
                    RowBox[{"(", 
                    RowBox[{"#3", "-", "#4"}], ")"}], " ", 
                    RowBox[{"(", 
                    RowBox[{"mc\[Omega]", "-", "ms\[Omega]"}], ")"}]}], 
                   RowBox[{"1", "-", 
                    SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "-", "\[Kappa]\[Sigma]"}], 
                    ")"}]}]]}]]}], ")"}]}], 
               RowBox[{"Negative", "[", "#1", "]"}]},
              {
               FractionBox[
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"2", "\[Pi]", " ", "i\[Nu]"}]]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["mc\[Omega]", "2"], "-", 
                   SuperscriptBox["ms\[Omega]", "2"]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "-", "\[Kappa]\[Sigma]"}], ")"}]}]]}], 
                  ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{"\[Pi]", " ", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", "+", "\[Kappa]\[Sigma]"}], ")"}]}]]}], 
                  ")"}]}]], 
               TagBox["True",
                "PiecewiseDefault",
                AutoDelete->False,
                DeletionWarning->True]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.84]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.4]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}]}], "&"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"z\[Alpha]", " ", "=", 
             RowBox[{
              RowBox[{"N", "[", 
               RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}], "/", "2"}]}], 
            ",", 
            RowBox[{"i\[Nu]", 
             RowBox[{"(", 
              RowBox[{
              "\[Zeta]\[Delta]", "-", "z\[Delta]", "+", "\[Zeta]\[Omega]", 
               "-", "z\[Omega]"}], ")"}]}], ",", 
            RowBox[{"MathieuC", "[", 
             RowBox[{"a", ",", "b", ",", "\[Zeta]\[Delta]"}], "]"}], ",", 
            RowBox[{"\[Chi]", " ", 
             RowBox[{"MathieuS", "[", 
              RowBox[{"a", ",", "b", ",", "\[Zeta]\[Delta]"}], "]"}]}]}], 
           "}"}]}], "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}]}]], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Fourier Line Kernel Polar", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Fourier", " ", "Line", " ", "Kernel", " ", "Polar"}], " ", 
  "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Numeric Implementation", "Subsubsection"],

Cell["\<\
Implementing a compiled version of the Fourier-transformed line kernel..\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Numeric", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"no", " ", "speed", " ", "gain"}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Symbolic Implementation", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FourierLineKernelPolar", "[", 
      RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{
     "\[Omega]r_", ",", "\[Omega]\[CurlyPhi]_", ",", " ", "\[Alpha]_"}], 
     "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", " ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Kappa]", "2"], "+", 
             RowBox[{"2", " ", "\[Lambda]", " ", 
              SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
           SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[IndentingNewLine]", 
        
        RowBox[{"b", " ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", "\[ImaginaryI]", " ", 
          RowBox[{"\[Omega]r", "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", " ", 
        "\[IndentingNewLine]", 
        RowBox[{"c", " ", "=", " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"\[Alpha]0", ",", 
              RowBox[{"2", "\[Pi]"}], ",", 
              RowBox[{"-", "\[Pi]"}]}], "]"}], "-", 
            RowBox[{"Mod", "[", 
             RowBox[{"\[Omega]\[CurlyPhi]", ",", 
              RowBox[{"2", "\[Pi]"}], ",", 
              RowBox[{"-", "\[Pi]"}]}], "]"}]}], ")"}], "/", "2"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"d", " ", "=", " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"\[Alpha]", ",", 
              RowBox[{"2", "\[Pi]"}], ",", 
              RowBox[{"-", "\[Pi]"}]}], "]"}], "-", 
            RowBox[{"Mod", "[", 
             RowBox[{"\[Alpha]0", ",", 
              RowBox[{"2", "\[Pi]"}], ",", 
              RowBox[{"-", "\[Pi]"}]}], "]"}]}], ")"}], "/", "2"}]}], ",", 
        "\[IndentingNewLine]", "mc0", ",", "ms0", ",", "wdet", ",", 
        "\[Chi]"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"mc0", " ", "=", " ", 
        RowBox[{"MathieuC", "[", 
         RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ms0", " ", "=", " ", 
        RowBox[{"MathieuS", "[", 
         RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"wdet", " ", "=", " ", 
        FractionBox["1", 
         RowBox[{"\[Pi]", " ", 
          SuperscriptBox["\[Sigma]", 
           RowBox[{"2", " "}]], 
          RowBox[{"MathieuSPrime", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Chi]", "   ", "=", " ", 
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", 
         RowBox[{"Sign", "[", 
          RowBox[{"Im", "[", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["mc0", "2"], "+", 
              SuperscriptBox["ms0", "2"]}], ")"}], "wdet"}], "]"}], "]"}]}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"\[Chi]", "  ", "wdet", " ", "*", 
           RowBox[{"Piecewise", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", " ", 
                 RowBox[{
                  RowBox[{"Abs", "[", 
                   RowBox[{"c", " ", "+", " ", "d"}], "]"}], " ", ">", " ", 
                  RowBox[{"FloquetCutoff", "[", 
                   RowBox[{"a", ",", " ", 
                    RowBox[{"Im", "[", "b", "]"}]}], "]"}]}]}], "}"}], ",", 
               " ", "\n", "  ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"E", "^", 
                   RowBox[{"(", 
                    RowBox[{"d", "*", "#4"}], ")"}]}], "*", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"#3", " ", "-", " ", "#4"}], ")"}]}], ")"}]}], 
                    "*", 
                    RowBox[{"(", 
                    RowBox[{"mc0", " ", "+", " ", 
                    RowBox[{"ms0", "*", "\[Chi]"}]}], ")"}], "*", 
                    RowBox[{"(", 
                    RowBox[{"#1", " ", "-", " ", 
                    RowBox[{"\[Chi]", "*", "#2"}]}], ")"}]}], ")"}], "/", 
                    "\n", "      ", 
                    RowBox[{"(", 
                    RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"#3", " ", "-", " ", "#4"}], ")"}]}], ")"}]}]}], 
                    ")"}]}], " ", "+", " ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"mc0", " ", "-", " ", 
                    RowBox[{"ms0", "*", "\[Chi]"}]}], ")"}], "*", 
                    RowBox[{"(", 
                    RowBox[{"#1", " ", "+", " ", 
                    RowBox[{"\[Chi]", "*", "#2"}]}], ")"}]}], ")"}], "/", 
                    "\n", "      ", 
                    RowBox[{"(", 
                    RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"#3", " ", "+", " ", "#4"}], ")"}]}], ")"}]}]}], 
                    ")"}]}]}], ")"}]}], ",", " ", 
                 RowBox[{"Positive", "[", "d", "]"}]}], "}"}], ",", " ", "\n",
                "  ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"E", "^", 
                   RowBox[{"(", 
                    RowBox[{"d", "*", "#4"}], ")"}]}], "*", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"mc0", " ", "+", " ", 
                    RowBox[{"ms0", "*", "\[Chi]"}]}], ")"}], "*", 
                    RowBox[{"(", 
                    RowBox[{"#1", " ", "-", " ", 
                    RowBox[{"\[Chi]", "*", "#2"}]}], ")"}]}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"#3", " ", "-", " ", "#4"}], ")"}]}], ")"}]}]}], 
                    ")"}]}], " ", "+", " ", "\n", "     ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"#3", " ", "+", " ", "#4"}], ")"}]}], ")"}]}], 
                    "*", 
                    RowBox[{"(", 
                    RowBox[{"mc0", " ", "-", " ", 
                    RowBox[{"ms0", "*", "\[Chi]"}]}], ")"}], "*", 
                    RowBox[{"(", 
                    RowBox[{"#1", " ", "+", " ", 
                    RowBox[{"\[Chi]", "*", "#2"}]}], ")"}]}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"#3", " ", "+", " ", "#4"}], ")"}]}], ")"}]}]}], 
                    ")"}]}]}], ")"}]}], ",", " ", "\n", "   ", 
                 RowBox[{"Negative", "[", "d", "]"}]}], "}"}]}], "}"}], ",", 
             " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", " ", "-", " ", 
                  RowBox[{"E", "^", 
                   RowBox[{"(", 
                    RowBox[{"2", "*", "Pi", "*", "#3"}], ")"}]}]}], ")"}], 
                "*", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"mc0", "^", "2"}], " ", "+", " ", 
                  RowBox[{"ms0", "^", "2"}]}], ")"}]}], ")"}], "/", "\n", 
              "  ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", " ", "-", " ", 
                  RowBox[{"E", "^", 
                   RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"#3", " ", "-", " ", "#4"}], ")"}]}], ")"}]}]}], 
                 ")"}], "*", 
                RowBox[{"(", 
                 RowBox[{"1", " ", "-", " ", 
                  RowBox[{"E", "^", 
                   RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"#3", " ", "+", " ", "#4"}], ")"}]}], ")"}]}]}], 
                 ")"}]}], ")"}]}]}], "]"}]}], "&"}], "[", 
         RowBox[{
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "b", ",", 
            RowBox[{"c", "+", "d"}]}], "]"}], ",", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "b", ",", 
            RowBox[{"c", "+", "d"}]}], "]"}], ",", 
          RowBox[{"\[ImaginaryI]", " ", 
           RowBox[{"FloquetExponent", "[", 
            RowBox[{"a", ",", "b"}], "]"}]}], ",", 
          RowBox[{"2", 
           RowBox[{"\[Kappa]", "/", 
            SuperscriptBox["\[Sigma]", "2"]}]}]}], "]"}], "//", "Chop"}]}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FourierLineKernelPolar", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{"\[Omega]r_", ",", "\[Omega]\[CurlyPhi]_", ",", " ", 
     RowBox[{"{", 
      RowBox[{"n\[Alpha]_Integer", "?", "Positive"}], "}"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", " ", "=", " ", 
        RowBox[{
         RowBox[{"-", "4"}], " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[Kappa]", "2"], "+", 
            RowBox[{"2", " ", "\[Lambda]", " ", 
             SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
          SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"b", " ", "=", " ", 
        RowBox[{
         RowBox[{"-", "4"}], " ", "\[ImaginaryI]", " ", 
         RowBox[{"\[Omega]r", "/", 
          SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"c", " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Mod", "[", 
            RowBox[{"\[Alpha]0", ",", 
             RowBox[{"2", "\[Pi]"}], ",", 
             RowBox[{"-", "\[Pi]"}]}], "]"}], "-", 
           RowBox[{"Mod", "[", 
            RowBox[{"\[Omega]\[CurlyPhi]", ",", 
             RowBox[{"2", "\[Pi]"}], ",", 
             RowBox[{"-", "\[Pi]"}]}], "]"}]}], ")"}], "/", "2"}]}], ",", " ",
        "\[IndentingNewLine]", 
       RowBox[{"dmin", " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", 
            RowBox[{"\[Pi]", "/", "n\[Alpha]"}]}], "-", 
           RowBox[{"Mod", "[", 
            RowBox[{"\[Alpha]0", ",", 
             RowBox[{"2", "\[Pi]"}], ",", 
             RowBox[{"-", "\[Pi]"}]}], "]"}], "-", "\[Pi]"}], ")"}], "/", 
         "2"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"dmax", " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[Pi]", "-", 
           RowBox[{"Mod", "[", 
            RowBox[{"\[Alpha]0", ",", 
             RowBox[{"2", "\[Pi]"}], ",", 
             RowBox[{"-", "\[Pi]"}]}], "]"}]}], ")"}], "/", "2"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"dd", " ", "=", " ", 
        RowBox[{"\[Pi]", "/", "n\[Alpha]"}]}], ",", "\[IndentingNewLine]", 
       "cc", ",", "wdet", ",", "mc0", ",", "ms0", ",", "\[Chi]", ",", 
       "i\[Nu]", ",", "\[Kappa]\[Sigma]", ",", "f"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"cc", "   ", "=", " ", 
       RowBox[{"FloquetCutoff", "[", 
        RowBox[{"a", ",", 
         RowBox[{"Im", "[", "b", "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"mc0", " ", "=", " ", 
       RowBox[{"MathieuC", "[", 
        RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ms0", " ", "=", " ", 
       RowBox[{"MathieuS", "[", 
        RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"wdet", "=", " ", 
       FractionBox["1", 
        RowBox[{"\[Pi]", " ", 
         SuperscriptBox["\[Sigma]", 
          RowBox[{"2", " "}]], 
         RowBox[{"MathieuSPrime", "[", 
          RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[Chi]", "   ", "=", " ", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", 
        RowBox[{"Sign", "[", 
         RowBox[{"Im", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["mc0", "2"], "+", 
             SuperscriptBox["ms0", "2"]}], ")"}], "wdet"}], "]"}], "]"}]}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"i\[Nu]", " ", "=", " ", 
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"FloquetExponent", "[", 
         RowBox[{"a", ",", "b"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Kappa]\[Sigma]", " ", "=", " ", 
       RowBox[{"2", 
        RowBox[{"\[Kappa]", "/", 
         SuperscriptBox["\[Sigma]", "2"]}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"f", "   ", "=", " ", 
       RowBox[{"Compile", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"mc", ",", "_Complex"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"ms", ",", "_Complex"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"d", ",", "_Real"}], "}"}]}], "}"}], ",", 
         RowBox[{"Evaluate", "[", 
          RowBox[{"Chop", "[", 
           RowBox[{"\[Chi]", " ", "wdet", "*", 
            RowBox[{"Piecewise", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", " ", 
                  RowBox[{
                   RowBox[{"Abs", "[", 
                    RowBox[{"c", " ", "+", " ", "d"}], "]"}], " ", ">", " ", 
                   "cc"}]}], "}"}], ",", " ", "\n", "  ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"d", "*", "\[Kappa]\[Sigma]"}], ")"}]}], "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"mc", " ", "+", " ", 
                    RowBox[{"ms", "*", "\[Chi]"}]}], ")"}], "*", 
                    RowBox[{"(", 
                    RowBox[{"mc0", " ", "-", " ", 
                    RowBox[{"ms0", "*", "\[Chi]"}]}], ")"}]}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "+", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}], " ", "+", " ", "\n", "     ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "-", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}], "*", 
                    RowBox[{"(", 
                    RowBox[{"mc", " ", "-", " ", 
                    RowBox[{"ms", "*", "\[Chi]"}]}], ")"}], "*", 
                    RowBox[{"(", 
                    RowBox[{"mc0", " ", "+", " ", 
                    RowBox[{"ms0", "*", "\[Chi]"}]}], ")"}]}], ")"}], "/", 
                    "\n", "      ", 
                    RowBox[{"(", 
                    RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "-", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", " ", 
                  RowBox[{"Positive", "[", "d", "]"}]}], "}"}], ",", " ", 
                "\n", "  ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"d", "*", "\[Kappa]\[Sigma]"}], ")"}]}], "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "+", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}], "*", 
                    RowBox[{"(", 
                    RowBox[{"mc", " ", "+", " ", 
                    RowBox[{"ms", "*", "\[Chi]"}]}], ")"}], "*", 
                    RowBox[{"(", 
                    RowBox[{"mc0", " ", "-", " ", 
                    RowBox[{"ms0", "*", "\[Chi]"}]}], ")"}]}], ")"}], "/", 
                    "\n", "      ", 
                    RowBox[{"(", 
                    RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "+", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}], " ", "+", " ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"mc", " ", "-", " ", 
                    RowBox[{"ms", "*", "\[Chi]"}]}], ")"}], "*", 
                    RowBox[{"(", 
                    RowBox[{"mc0", " ", "+", " ", 
                    RowBox[{"ms0", "*", "\[Chi]"}]}], ")"}]}], ")"}], "/", 
                    "\n", "      ", 
                    RowBox[{"(", 
                    RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "-", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", " ", 
                  RowBox[{"Negative", "[", "d", "]"}]}], "}"}]}], "}"}], ",", 
              " ", "\n", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"1", " ", "-", " ", 
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"2", "*", "i\[Nu]", "*", "Pi"}], ")"}]}]}], ")"}],
                  "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"mc0", "^", "2"}], " ", "+", " ", 
                   RowBox[{"ms0", "^", "2"}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"1", " ", "-", " ", 
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "-", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}], "*", "\n", "   ", 
                 RowBox[{"(", 
                  RowBox[{"1", " ", "-", " ", 
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "+", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}], ")"}]}]}], "]"}]}], "]"}], 
          "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"f", "[", 
         RowBox[{
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "b", ",", 
            RowBox[{"c", "+", "d"}]}], "]"}], ",", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "b", ",", 
            RowBox[{"c", "+", "d"}]}], "]"}], ",", "d"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"d", ",", "dmin", ",", "dmax", ",", "dd"}], "}"}]}], 
       "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FourierLineKernelPolar", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{"\[Omega]r_", ",", "\[Omega]\[CurlyPhi]_", ",", " ", 
     RowBox[{"{", 
      RowBox[{"min\[Alpha]_", ",", "max\[Alpha]_", ",", "d\[Alpha]_"}], 
      "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", " ", "=", " ", 
        RowBox[{
         RowBox[{"-", "4"}], " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[Kappa]", "2"], "+", 
            RowBox[{"2", " ", "\[Lambda]", " ", 
             SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
          SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"b", " ", "=", " ", 
        RowBox[{
         RowBox[{"-", "4"}], " ", "\[ImaginaryI]", " ", 
         RowBox[{"\[Omega]r", "/", 
          SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"c", " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], ")"}], "/", 
         "2"}]}], ",", " ", "\[IndentingNewLine]", 
       RowBox[{"dmin", " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"min\[Alpha]", "-", "\[Alpha]0"}], ")"}], "/", "2"}]}], ",", 
       RowBox[{"dmax", " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"max\[Alpha]", "-", "\[Alpha]0"}], ")"}], "/", "2"}]}], ",", 
       RowBox[{"dd", " ", "=", " ", 
        RowBox[{"d\[Alpha]", "/", "2"}]}], ",", "\[IndentingNewLine]", "cc", 
       ",", "wdet", ",", "mc0", ",", "ms0", ",", "\[Chi]", ",", "i\[Nu]", ",",
        "\[Kappa]\[Sigma]", ",", "f"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"cc", "   ", "=", " ", 
       RowBox[{"FloquetCutoff", "[", 
        RowBox[{"a", ",", 
         RowBox[{"Im", "[", "b", "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"mc0", " ", "=", " ", 
       RowBox[{"MathieuC", "[", 
        RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ms0", " ", "=", " ", 
       RowBox[{"MathieuS", "[", 
        RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"wdet", "=", " ", 
       FractionBox["1", 
        RowBox[{"\[Pi]", " ", 
         SuperscriptBox["\[Sigma]", 
          RowBox[{"2", " "}]], 
         RowBox[{"MathieuSPrime", "[", 
          RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[Chi]", "   ", "=", " ", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", 
        RowBox[{"Sign", "[", 
         RowBox[{"Im", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["mc0", "2"], "+", 
             SuperscriptBox["ms0", "2"]}], ")"}], "wdet"}], "]"}], "]"}]}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"i\[Nu]", " ", "=", " ", 
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"FloquetExponent", "[", 
         RowBox[{"a", ",", "b"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Kappa]\[Sigma]", " ", "=", " ", 
       RowBox[{"2", 
        RowBox[{"\[Kappa]", "/", 
         SuperscriptBox["\[Sigma]", "2"]}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"f", "   ", "=", " ", 
       RowBox[{"Compile", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"mc", ",", "_Complex"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"ms", ",", "_Complex"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"d", ",", "_Real"}], "}"}]}], "}"}], ",", 
         RowBox[{"Evaluate", "[", 
          RowBox[{"Chop", "[", 
           RowBox[{"\[Chi]", " ", "wdet", "*", 
            RowBox[{"Piecewise", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", " ", 
                  RowBox[{
                   RowBox[{"Abs", "[", 
                    RowBox[{"c", " ", "+", " ", "d"}], "]"}], " ", ">", " ", 
                   "cc"}]}], "}"}], ",", " ", "\n", "  ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"d", "*", "\[Kappa]\[Sigma]"}], ")"}]}], "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"mc", " ", "+", " ", 
                    RowBox[{"ms", "*", "\[Chi]"}]}], ")"}], "*", 
                    RowBox[{"(", 
                    RowBox[{"mc0", " ", "-", " ", 
                    RowBox[{"ms0", "*", "\[Chi]"}]}], ")"}]}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "+", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}], " ", "+", " ", "\n", "     ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "-", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}], "*", 
                    RowBox[{"(", 
                    RowBox[{"mc", " ", "-", " ", 
                    RowBox[{"ms", "*", "\[Chi]"}]}], ")"}], "*", 
                    RowBox[{"(", 
                    RowBox[{"mc0", " ", "+", " ", 
                    RowBox[{"ms0", "*", "\[Chi]"}]}], ")"}]}], ")"}], "/", 
                    "\n", "      ", 
                    RowBox[{"(", 
                    RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "-", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", " ", 
                  RowBox[{"Positive", "[", "d", "]"}]}], "}"}], ",", " ", 
                "\n", "  ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"d", "*", "\[Kappa]\[Sigma]"}], ")"}]}], "*", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "+", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}], "*", 
                    RowBox[{"(", 
                    RowBox[{"mc", " ", "+", " ", 
                    RowBox[{"ms", "*", "\[Chi]"}]}], ")"}], "*", 
                    RowBox[{"(", 
                    RowBox[{"mc0", " ", "-", " ", 
                    RowBox[{"ms0", "*", "\[Chi]"}]}], ")"}]}], ")"}], "/", 
                    "\n", "      ", 
                    RowBox[{"(", 
                    RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "+", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}], " ", "+", " ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"mc", " ", "-", " ", 
                    RowBox[{"ms", "*", "\[Chi]"}]}], ")"}], "*", 
                    RowBox[{"(", 
                    RowBox[{"mc0", " ", "+", " ", 
                    RowBox[{"ms0", "*", "\[Chi]"}]}], ")"}]}], ")"}], "/", 
                    "\n", "      ", 
                    RowBox[{"(", 
                    RowBox[{"1", " ", "-", " ", 
                    RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "-", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}]}], ")"}]}], ",", " ", 
                  RowBox[{"Negative", "[", "d", "]"}]}], "}"}]}], "}"}], ",", 
              " ", "\n", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"1", " ", "-", " ", 
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"2", "*", "i\[Nu]", "*", "Pi"}], ")"}]}]}], ")"}],
                  "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"mc0", "^", "2"}], " ", "+", " ", 
                   RowBox[{"ms0", "^", "2"}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"1", " ", "-", " ", 
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "-", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}], "*", "\n", "   ", 
                 RowBox[{"(", 
                  RowBox[{"1", " ", "-", " ", 
                   RowBox[{"E", "^", 
                    RowBox[{"(", 
                    RowBox[{"Pi", "*", 
                    RowBox[{"(", 
                    RowBox[{"i\[Nu]", " ", "+", " ", "\[Kappa]\[Sigma]"}], 
                    ")"}]}], ")"}]}]}], ")"}]}], ")"}]}]}], "]"}]}], "]"}], 
          "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"f", "[", 
         RowBox[{
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "b", ",", 
            RowBox[{"c", "+", "d"}]}], "]"}], ",", 
          RowBox[{"MathieuS", "[", 
           RowBox[{"a", ",", "b", ",", 
            RowBox[{"c", "+", "d"}]}], "]"}], ",", "d"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"d", ",", "dmin", ",", "dmax", ",", "dd"}], "}"}]}], 
       "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Fourier Infinite Line Kernel", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Fourier", " ", "Infinite", " ", "Line", " ", "Kernel"}], " ", 
  "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Numeric Implementation", "Subsubsection"],

Cell["\<\
Implementing a compiled version of the Fourier-transformed line kernel..\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Numeric", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"no", " ", "speed", " ", "gain"}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Symbolic Implementation", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"FourierInfiniteLineKernel", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", " ", 
     RowBox[{"{", 
      RowBox[{"n\[Alpha]_Integer", "?", "Positive"}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"FourierInfiniteLineKernel", "[", 
     RowBox[{
     "\[Sigma]", ",", "\[Lambda]", ",", "\[Alpha]0", ",", "\[Kappa]"}], "]"}],
     "[", 
    RowBox[{"\[Omega]x", ",", "\[Omega]y", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "\[Pi]"}], "+", 
        FractionBox[
         RowBox[{"2", "\[Pi]"}], "n\[Alpha]"]}], ",", " ", "\[Pi]", ",", 
       FractionBox[
        RowBox[{"2", "\[Pi]"}], "n\[Alpha]"]}], "}"}]}], 
    "]"}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FourierInfiniteLineKernel", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", " ", 
     RowBox[{"{", 
      RowBox[{"min\[Alpha]_", ",", "max\[Alpha]_", ",", "d\[Alpha]_"}], 
      "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", " ", "=", " ", 
        RowBox[{
         RowBox[{"-", "4"}], " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[Kappa]", "2"], "+", 
            RowBox[{"2", " ", "\[Lambda]", " ", 
             SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
          SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"b", " ", "=", " ", 
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{
          RowBox[{"Radius", "[", 
           RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], "/", 
          SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"c", " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[Alpha]0", "-", 
           RowBox[{"Angle", "[", 
            RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}]}], ")"}], "/", 
         "2"}]}], ",", " ", "\[IndentingNewLine]", 
       RowBox[{"dmin", " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"min\[Alpha]", "-", "\[Alpha]0"}], ")"}], "/", "2"}]}], ",", 
       RowBox[{"dmax", " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"max\[Alpha]", "-", "\[Alpha]0"}], ")"}], "/", "2"}]}], ",", 
       RowBox[{"dd", " ", "=", " ", 
        RowBox[{"d\[Alpha]", "/", "2"}]}], ",", "\[IndentingNewLine]", "cc", 
       ",", "wdet", ",", "mc", ",", "ms", ",", "s"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"cc", " ", "=", " ", 
       RowBox[{"FloquetCutoff", "[", 
        RowBox[{"a", ",", 
         RowBox[{"Im", "[", "b", "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"mc", " ", "=", " ", 
       RowBox[{"MathieuC", "[", 
        RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ms", " ", "=", " ", 
       RowBox[{"MathieuS", "[", 
        RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"wdet", " ", "=", " ", 
       FractionBox["1", 
        RowBox[{"\[Pi]", " ", 
         SuperscriptBox["\[Sigma]", 
          RowBox[{"2", " "}]], 
         RowBox[{"MathieuSPrime", "[", 
          RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[Chi]", " ", "=", " ", 
       RowBox[{"Sign", "[", 
        RowBox[{"Im", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["mc", "2"], "+", 
            SuperscriptBox["ms", "2"]}], ")"}], "wdet"}], "]"}], "]"}]}], ";",
       "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"-", "\[Chi]"}], " ", "wdet", "*", " ", 
       RowBox[{"Table", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\[Piecewise]", GridBox[{
            {"0", 
             RowBox[{
              RowBox[{"Abs", "[", 
               RowBox[{"c", "+", "d"}], "]"}], ">", "cc"}]},
            {
             RowBox[{
              SuperscriptBox["\[ExponentialE]", 
               FractionBox[
                RowBox[{"2", " ", "d", " ", "\[Kappa]"}], 
                SuperscriptBox["\[Sigma]", "2"]]], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[ImaginaryI]", " ", "mc"}], "+", 
                RowBox[{"\[Chi]", " ", "ms"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"MathieuC", "[", 
                 RowBox[{"a", ",", "b", ",", 
                  RowBox[{"c", "+", "d"}]}], "]"}], "+", 
                RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", 
                 RowBox[{"MathieuS", "[", 
                  RowBox[{"a", ",", "b", ",", 
                   RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], 
             RowBox[{"Negative", "[", "d", "]"}]},
            {
             RowBox[{
              SuperscriptBox["\[ExponentialE]", 
               FractionBox[
                RowBox[{"2", " ", "d", " ", "\[Kappa]"}], 
                SuperscriptBox["\[Sigma]", "2"]]], " ", 
              RowBox[{"(", 
               RowBox[{"mc", "+", 
                RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", "ms"}]}], ")"}], 
              " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[ImaginaryI]", " ", 
                 RowBox[{"MathieuC", "[", 
                  RowBox[{"a", ",", "b", ",", 
                   RowBox[{"c", "+", "d"}]}], "]"}]}], "+", 
                RowBox[{"\[Chi]", " ", 
                 RowBox[{"MathieuS", "[", 
                  RowBox[{"a", ",", "b", ",", 
                   RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], 
             RowBox[{"Positive", "[", "d", "]"}]},
            {
             RowBox[{"\[ImaginaryI]", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["mc", "2"], "+", 
                SuperscriptBox["ms", "2"]}], ")"}]}], "True"}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.84]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"d", ",", "dmin", ",", "dmax", ",", "dd"}], "}"}]}], 
        "\[IndentingNewLine]", "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FourierInfiniteLineKernel", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", " ", "\[Alpha]_"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", " ", "=", " ", 
        RowBox[{
         RowBox[{"-", "4"}], " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[Kappa]", "2"], "+", 
            RowBox[{"2", " ", "\[Lambda]", " ", 
             SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
          SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"b", " ", "=", " ", 
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{
          RowBox[{"Radius", "[", 
           RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], "/", 
          SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"c", " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[Alpha]0", "-", 
           RowBox[{"Angle", "[", 
            RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}]}], ")"}], "/", 
         "2"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"d", " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}], "/", "2"}]}], ",", 
       "\[IndentingNewLine]", "cc", ",", "mc", ",", "ms", ",", "wdet", ",", 
       "s"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"cc", " ", "=", " ", 
       RowBox[{"FloquetCutoff", "[", 
        RowBox[{"a", ",", 
         RowBox[{"Im", "[", "b", "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"mc", " ", "=", " ", 
       RowBox[{"MathieuC", "[", 
        RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ms", " ", "=", " ", 
       RowBox[{"MathieuS", "[", 
        RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"wdet", " ", "=", " ", 
       FractionBox["1", 
        RowBox[{"\[Pi]", " ", 
         SuperscriptBox["\[Sigma]", 
          RowBox[{"2", " "}]], 
         RowBox[{"MathieuSPrime", "[", 
          RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[Chi]", " ", "=", " ", 
       RowBox[{"Sign", "[", 
        RowBox[{"Im", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["mc", "2"], "+", 
            SuperscriptBox["ms", "2"]}], ")"}], "wdet"}], "]"}], "]"}]}], ";",
       "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"-", "\[Chi]"}], " ", "wdet", "*", 
       RowBox[{"\[Piecewise]", GridBox[{
          {"0", 
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{"c", "+", "d"}], "]"}], ">", "cc"}]},
          {
           RowBox[{
            SuperscriptBox["\[ExponentialE]", 
             FractionBox[
              RowBox[{"2", " ", "d", " ", "\[Kappa]"}], 
              SuperscriptBox["\[Sigma]", "2"]]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"\[ImaginaryI]", " ", "mc"}], "+", 
              RowBox[{"\[Chi]", " ", "ms"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"MathieuC", "[", 
               RowBox[{"a", ",", "b", ",", 
                RowBox[{"c", "+", "d"}]}], "]"}], "+", 
              RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", 
               RowBox[{"MathieuS", "[", 
                RowBox[{"a", ",", "b", ",", 
                 RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], 
           RowBox[{"Negative", "[", "d", "]"}]},
          {
           RowBox[{
            SuperscriptBox["\[ExponentialE]", 
             FractionBox[
              RowBox[{"2", " ", "d", " ", "\[Kappa]"}], 
              SuperscriptBox["\[Sigma]", "2"]]], " ", 
            RowBox[{"(", 
             RowBox[{"mc", "+", 
              RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", "ms"}]}], ")"}], 
            " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"\[ImaginaryI]", " ", 
               RowBox[{"MathieuC", "[", 
                RowBox[{"a", ",", "b", ",", 
                 RowBox[{"c", "+", "d"}]}], "]"}]}], "+", 
              RowBox[{"\[Chi]", " ", 
               RowBox[{"MathieuS", "[", 
                RowBox[{"a", ",", "b", ",", 
                 RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], 
           RowBox[{"Positive", "[", "d", "]"}]},
          {
           RowBox[{"\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["mc", "2"], "+", 
              SuperscriptBox["ms", "2"]}], ")"}]}], "True"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.84]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}]}]}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Fourier Infinite Line Diffusion Kernel", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Fourier", " ", "Infinite", " ", "Line", " ", "Diffusion", " ", "Kernel"}], 
  " ", "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Numeric Implementation", "Subsubsection"],

Cell["\<\
Implementing a compiled version of the Fourier-transformed line kernel..\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Numeric", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"no", " ", "speed", " ", "gain"}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Symbolic Implementation", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"FourierInfiniteLineDiffusionKernel", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Sigma]\[Alpha]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}]}], "]"}], "[", 
    RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", " ", 
     RowBox[{"{", 
      RowBox[{"n\[Alpha]_Integer", "?", "Positive"}], "}"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"FourierInfiniteLineDiffusionKernel", "[", 
     RowBox[{
     "\[Sigma]", ",", "\[Sigma]\[Alpha]", ",", "\[Lambda]", ",", 
      "\[Alpha]0"}], "]"}], "[", 
    RowBox[{"\[Omega]x", ",", "\[Omega]y", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "\[Pi]"}], "+", 
        FractionBox[
         RowBox[{"2", "\[Pi]"}], "n\[Alpha]"]}], ",", " ", "\[Pi]", ",", 
       FractionBox[
        RowBox[{"2", "\[Pi]"}], "n\[Alpha]"]}], "}"}]}], 
    "]"}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FourierInfiniteLineDiffusionKernel", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Sigma]\[Alpha]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}]}], "]"}], "[", 
    RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", " ", 
     RowBox[{"{", 
      RowBox[{"min\[Alpha]_", ",", "max\[Alpha]_", ",", "d\[Alpha]_"}], 
      "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", " ", "=", " ", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"4", " ", "\[Lambda]"}], "+", 
           RowBox[{
            SuperscriptBox["\[Sigma]", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["\[Omega]x", "2"], "+", 
              SuperscriptBox["\[Omega]y", "2"]}], ")"}]}]}], 
          RowBox[{"2", " ", 
           SuperscriptBox["\[Sigma]\[Alpha]", "2"]}]]}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"b", " ", "=", " ", 
        FractionBox[
         RowBox[{
          SuperscriptBox["\[Sigma]", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[Omega]x", "2"], "+", 
            SuperscriptBox["\[Omega]y", "2"]}], ")"}]}], 
         RowBox[{"4", " ", 
          SuperscriptBox["\[Sigma]\[Alpha]", "2"]}]]}], ",", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"c", " ", "=", " ", 
        RowBox[{"\[Alpha]", "-", 
         RowBox[{"Angle", "[", 
          RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}]}]}], ",", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"dmin", " ", "=", " ", 
        RowBox[{"(", 
         RowBox[{"min\[Alpha]", "-", "\[Alpha]0"}], ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"dmax", " ", "=", " ", 
        RowBox[{"(", 
         RowBox[{"max\[Alpha]", "-", "\[Alpha]0"}], ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"dd", " ", "=", " ", "d\[Alpha]"}], ",", "\[IndentingNewLine]",
        "cc", ",", "wdet", ",", "mc", ",", "ms", ",", "s"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"mc", " ", "=", " ", 
       RowBox[{"MathieuC", "[", 
        RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ms", " ", "=", " ", 
       RowBox[{"MathieuS", "[", 
        RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"wdet", " ", "=", " ", 
       FractionBox["1", 
        RowBox[{"2", " ", "\[Pi]", " ", 
         SuperscriptBox["\[Sigma]\[Alpha]", 
          RowBox[{"2", " "}]], 
         RowBox[{"MathieuSPrime", "[", 
          RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[Chi]", " ", "=", " ", 
       RowBox[{"Sign", "[", 
        RowBox[{"Im", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["mc", "2"], "+", 
            SuperscriptBox["ms", "2"]}], ")"}], "wdet"}], "]"}], "]"}]}], ";",
       "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"-", "\[Chi]"}], " ", "wdet", "*", " ", 
       RowBox[{"Table", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\[Piecewise]", GridBox[{
            {
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[ImaginaryI]", " ", "mc"}], "+", 
                RowBox[{"\[Chi]", " ", "ms"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"MathieuC", "[", 
                 RowBox[{"a", ",", "b", ",", 
                  RowBox[{"c", "+", "d"}]}], "]"}], "+", 
                RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", 
                 RowBox[{"MathieuS", "[", 
                  RowBox[{"a", ",", "b", ",", 
                   RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], 
             RowBox[{"Negative", "[", "d", "]"}]},
            {
             RowBox[{
              RowBox[{"(", 
               RowBox[{"mc", "+", 
                RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", "ms"}]}], ")"}], 
              " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[ImaginaryI]", " ", 
                 RowBox[{"MathieuC", "[", 
                  RowBox[{"a", ",", "b", ",", 
                   RowBox[{"c", "+", "d"}]}], "]"}]}], "+", 
                RowBox[{"\[Chi]", " ", 
                 RowBox[{"MathieuS", "[", 
                  RowBox[{"a", ",", "b", ",", 
                   RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], 
             RowBox[{"Positive", "[", "d", "]"}]},
            {
             RowBox[{"\[ImaginaryI]", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["mc", "2"], "+", 
                SuperscriptBox["ms", "2"]}], ")"}]}], "True"}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.84]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"d", ",", "dmin", ",", "dmax", ",", "dd"}], "}"}]}], 
        "\[IndentingNewLine]", "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FourierInfiniteLineDiffusionKernel", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Sigma]\[Alpha]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}]}], "]"}], "[", 
    RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", " ", "\[Alpha]_"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", " ", "=", " ", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"2", " ", "\[Lambda]"}], 
           SuperscriptBox["\[Sigma]", "2"]]}], "+", 
         FractionBox[
          RowBox[{
           SuperscriptBox["\[Sigma]", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Omega]x", "2"], "+", 
             SuperscriptBox["\[Omega]y", "2"]}], ")"}]}], 
          RowBox[{"2", " ", 
           SuperscriptBox["\[Sigma]\[Alpha]", "2"]}]]}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"b", " ", "=", " ", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["\[Sigma]", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Omega]x", "2"], "+", 
             SuperscriptBox["\[Omega]y", "2"]}], ")"}]}], 
          RowBox[{"4", " ", 
           SuperscriptBox["\[Sigma]\[Alpha]", "2"]}]]}]}], ",", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"c", " ", "=", " ", 
        RowBox[{"\[Alpha]", "-", 
         RowBox[{"Angle", "[", 
          RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}]}]}], ",", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"d", " ", "=", " ", 
        RowBox[{"(", 
         RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}]}], ",", 
       "\[IndentingNewLine]", "cc", ",", "mc", ",", "ms", ",", "wdet", ",", 
       "s"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"mc", " ", "=", " ", 
       RowBox[{"MathieuC", "[", 
        RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ms", " ", "=", " ", 
       RowBox[{"MathieuS", "[", 
        RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"wdet", " ", "=", " ", 
       FractionBox["1", 
        RowBox[{"2", " ", "\[Pi]", " ", 
         SuperscriptBox["\[Sigma]\[Alpha]", 
          RowBox[{"2", " "}]], 
         RowBox[{"MathieuSPrime", "[", 
          RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[Chi]", " ", "=", " ", 
       RowBox[{"Sign", "[", 
        RowBox[{"Im", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["mc", "2"], "+", 
            SuperscriptBox["ms", "2"]}], ")"}], "wdet"}], "]"}], "]"}]}], ";",
       "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"-", "\[Chi]"}], " ", "wdet", "*", 
       RowBox[{"\[Piecewise]", GridBox[{
          {
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"\[ImaginaryI]", " ", "mc"}], "+", 
              RowBox[{"\[Chi]", " ", "ms"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"MathieuC", "[", 
               RowBox[{"a", ",", "b", ",", 
                RowBox[{"c", "+", "d"}]}], "]"}], "+", 
              RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", 
               RowBox[{"MathieuS", "[", 
                RowBox[{"a", ",", "b", ",", 
                 RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], 
           RowBox[{"Negative", "[", "d", "]"}]},
          {
           RowBox[{
            RowBox[{"(", 
             RowBox[{"mc", "+", 
              RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", "ms"}]}], ")"}], 
            " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"\[ImaginaryI]", " ", 
               RowBox[{"MathieuC", "[", 
                RowBox[{"a", ",", "b", ",", 
                 RowBox[{"c", "+", "d"}]}], "]"}]}], "+", 
              RowBox[{"\[Chi]", " ", 
               RowBox[{"MathieuS", "[", 
                RowBox[{"a", ",", "b", ",", 
                 RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], 
           RowBox[{"Positive", "[", "d", "]"}]},
          {
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["mc", "2"], "+", 
             SuperscriptBox["ms", "2"]}], ")"}], "True"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.84]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}]}]}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Fourier Infinite Line Kernel Polar", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Fourier", " ", "Infinite", " ", "Line", " ", "Kernel", " ", "Polar"}], " ",
   "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Numeric Implementation", "Subsubsection"],

Cell["\<\
Implementing a compiled version of the Fourier-transformed line kernel..\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Numeric", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"no", " ", "speed", " ", "gain"}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Symbolic Implementation", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"FourierInfiniteLineKernelPolar", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{"\[Omega]r_", ",", "\[Omega]\[CurlyPhi]_", ",", " ", 
     RowBox[{"{", 
      RowBox[{"n\[Alpha]_Integer", "?", "Positive"}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"FourierInfiniteLineKernelPolar", "[", 
     RowBox[{
     "\[Sigma]", ",", "\[Lambda]", ",", "\[Alpha]0", ",", "\[Kappa]"}], "]"}],
     "[", 
    RowBox[{"\[Omega]r", ",", "\[Omega]\[CurlyPhi]", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "\[Pi]"}], "+", 
        FractionBox[
         RowBox[{"2", "\[Pi]"}], "n\[Alpha]"]}], ",", " ", "\[Pi]", ",", 
       FractionBox[
        RowBox[{"2", "\[Pi]"}], "n\[Alpha]"]}], "}"}]}], 
    "]"}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FourierInfiniteLineKernelPolar", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{"\[Omega]r_", ",", "\[Omega]\[CurlyPhi]_", ",", " ", 
     RowBox[{"{", 
      RowBox[{"min\[Alpha]_", ",", "max\[Alpha]_", ",", "d\[Alpha]_"}], 
      "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", " ", "=", " ", 
        RowBox[{
         RowBox[{"-", "4"}], " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[Kappa]", "2"], "+", 
            RowBox[{"2", " ", "\[Lambda]", " ", 
             SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
          SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"b", " ", "=", " ", 
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"\[Omega]r", "/", 
          SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"c", " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], ")"}], "/", 
         "2"}]}], ",", " ", "\[IndentingNewLine]", 
       RowBox[{"dmin", " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"min\[Alpha]", "-", "\[Alpha]0"}], ")"}], "/", "2"}]}], ",", 
       RowBox[{"dmax", " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"max\[Alpha]", "-", "\[Alpha]0"}], ")"}], "/", "2"}]}], ",", 
       RowBox[{"dd", " ", "=", " ", 
        RowBox[{"d\[Alpha]", "/", "2"}]}], ",", "\[IndentingNewLine]", "cc", 
       ",", "wdet", ",", "mc", ",", "ms", ",", "s"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"cc", " ", "=", " ", 
       RowBox[{"FloquetCutoff", "[", 
        RowBox[{"a", ",", 
         RowBox[{"Im", "[", "b", "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"mc", " ", "=", " ", 
       RowBox[{"MathieuC", "[", 
        RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ms", " ", "=", " ", 
       RowBox[{"MathieuS", "[", 
        RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"wdet", " ", "=", " ", 
       FractionBox["1", 
        RowBox[{"\[Pi]", " ", 
         SuperscriptBox["\[Sigma]", 
          RowBox[{"2", " "}]], 
         RowBox[{"MathieuSPrime", "[", 
          RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[Chi]", " ", "=", " ", 
       RowBox[{"Sign", "[", 
        RowBox[{"Im", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["mc", "2"], "+", 
            SuperscriptBox["ms", "2"]}], ")"}], "wdet"}], "]"}], "]"}]}], ";",
       "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"-", "\[Chi]"}], " ", "wdet", "*", " ", 
       RowBox[{"Table", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\[Piecewise]", GridBox[{
            {"0", 
             RowBox[{
              RowBox[{"Abs", "[", 
               RowBox[{"c", "+", "d"}], "]"}], ">", "cc"}]},
            {
             RowBox[{
              SuperscriptBox["\[ExponentialE]", 
               FractionBox[
                RowBox[{"2", " ", "d", " ", "\[Kappa]"}], 
                SuperscriptBox["\[Sigma]", "2"]]], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[ImaginaryI]", " ", "mc"}], "+", 
                RowBox[{"\[Chi]", " ", "ms"}]}], ")"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"MathieuC", "[", 
                 RowBox[{"a", ",", "b", ",", 
                  RowBox[{"c", "+", "d"}]}], "]"}], "+", 
                RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", 
                 RowBox[{"MathieuS", "[", 
                  RowBox[{"a", ",", "b", ",", 
                   RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], 
             RowBox[{"Negative", "[", "d", "]"}]},
            {
             RowBox[{
              SuperscriptBox["\[ExponentialE]", 
               FractionBox[
                RowBox[{"2", " ", "d", " ", "\[Kappa]"}], 
                SuperscriptBox["\[Sigma]", "2"]]], " ", 
              RowBox[{"(", 
               RowBox[{"mc", "+", 
                RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", "ms"}]}], ")"}], 
              " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[ImaginaryI]", " ", 
                 RowBox[{"MathieuC", "[", 
                  RowBox[{"a", ",", "b", ",", 
                   RowBox[{"c", "+", "d"}]}], "]"}]}], "+", 
                RowBox[{"\[Chi]", " ", 
                 RowBox[{"MathieuS", "[", 
                  RowBox[{"a", ",", "b", ",", 
                   RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], 
             RowBox[{"Positive", "[", "d", "]"}]},
            {
             RowBox[{"\[ImaginaryI]", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["mc", "2"], "+", 
                SuperscriptBox["ms", "2"]}], ")"}]}], "True"}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.84]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"d", ",", "dmin", ",", "dmax", ",", "dd"}], "}"}]}], 
        "\[IndentingNewLine]", "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FourierInfiniteLineKernelPolar", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{
    "\[Omega]r_", ",", "\[Omega]\[CurlyPhi]_", ",", " ", "\[Alpha]_"}], "]"}],
    ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", " ", "=", " ", 
        RowBox[{
         RowBox[{"-", "4"}], " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[Kappa]", "2"], "+", 
            RowBox[{"2", " ", "\[Lambda]", " ", 
             SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
          SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"b", " ", "=", " ", 
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"\[Omega]r", "/", 
          SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", " ", 
       "\[IndentingNewLine]", 
       RowBox[{"c", " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[Alpha]0", "-", "\[Omega]\[CurlyPhi]"}], ")"}], "/", 
         "2"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"d", " ", "=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}], "/", "2"}]}], ",", 
       "\[IndentingNewLine]", "cc", ",", "wdet", ",", "mc", ",", "ms", ",", 
       "s"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"cc", " ", "=", " ", 
       RowBox[{"FloquetCutoff", "[", 
        RowBox[{"a", ",", 
         RowBox[{"Im", "[", "b", "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"mc", " ", "=", " ", 
       RowBox[{"MathieuC", "[", 
        RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ms", " ", "=", " ", 
       RowBox[{"MathieuS", "[", 
        RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"wdet", " ", "=", " ", 
       FractionBox["1", 
        RowBox[{"\[Pi]", " ", 
         SuperscriptBox["\[Sigma]", 
          RowBox[{"2", " "}]], 
         RowBox[{"MathieuSPrime", "[", 
          RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
         RowBox[{"MathieuC", "[", 
          RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[Chi]", " ", "=", " ", 
       RowBox[{"Sign", "[", 
        RowBox[{"Im", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["mc", "2"], "+", 
            SuperscriptBox["ms", "2"]}], ")"}], "wdet"}], "]"}], "]"}]}], ";",
       "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"-", "\[Chi]"}], " ", "wdet", "*", 
       RowBox[{"\[Piecewise]", GridBox[{
          {"0", 
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{"c", "+", "d"}], "]"}], ">", "cc"}]},
          {
           RowBox[{
            SuperscriptBox["\[ExponentialE]", 
             FractionBox[
              RowBox[{"2", " ", "d", " ", "\[Kappa]"}], 
              SuperscriptBox["\[Sigma]", "2"]]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"\[ImaginaryI]", " ", "mc"}], "+", 
              RowBox[{"\[Chi]", " ", "ms"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"MathieuC", "[", 
               RowBox[{"a", ",", "b", ",", 
                RowBox[{"c", "+", "d"}]}], "]"}], "+", 
              RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", 
               RowBox[{"MathieuS", "[", 
                RowBox[{"a", ",", "b", ",", 
                 RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], 
           RowBox[{"Negative", "[", "d", "]"}]},
          {
           RowBox[{
            SuperscriptBox["\[ExponentialE]", 
             FractionBox[
              RowBox[{"2", " ", "d", " ", "\[Kappa]"}], 
              SuperscriptBox["\[Sigma]", "2"]]], " ", 
            RowBox[{"(", 
             RowBox[{"mc", "+", 
              RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", "ms"}]}], ")"}], 
            " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"\[ImaginaryI]", " ", 
               RowBox[{"MathieuC", "[", 
                RowBox[{"a", ",", "b", ",", 
                 RowBox[{"c", "+", "d"}]}], "]"}]}], "+", 
              RowBox[{"\[Chi]", " ", 
               RowBox[{"MathieuS", "[", 
                RowBox[{"a", ",", "b", ",", 
                 RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], 
           RowBox[{"Positive", "[", "d", "]"}]},
          {
           RowBox[{"\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["mc", "2"], "+", 
              SuperscriptBox["ms", "2"]}], ")"}]}], "True"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.84]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}]}]}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Fourier Cyclic Line Kernel", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Fourier", " ", "Cyclic", " ", "Line", " ", "Kernel"}], " ", 
  "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Numeric Implementation", "Subsubsection"],

Cell["\<\
Implementing a compiled version of the Fourier-transformed line kernel..\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Numeric", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"no", " ", "speed", " ", "gain"}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Symbolic Implementation", "Subsubsection"],

Cell["\<\
Check  the flip at \[Pi] in mapping back\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FourierCyclicLineKernel", "[", 
      RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}], ",", 
       RowBox[{"n_Integer:", "1"}]}], "]"}], "[", 
     RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", " ", 
      RowBox[{"{", 
       RowBox[{"n\[Alpha]_Integer", "?", "Positive"}], "}"}]}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", " ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Kappa]", "2"], "+", 
             RowBox[{"2", " ", "\[Lambda]", " ", 
              SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
           SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[IndentingNewLine]", 
        
        RowBox[{"b", " ", "=", " ", 
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          RowBox[{
           RowBox[{"Radius", "[", 
            RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", " ", 
        "\[IndentingNewLine]", 
        RowBox[{"c", " ", "=", " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Alpha]0", "-", 
            RowBox[{"Mod", "[", 
             RowBox[{
              RowBox[{"Angle", "[", 
               RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], ",", "\[Pi]", 
              ",", 
              RowBox[{
               RowBox[{"-", "\[Pi]"}], "/", "2"}]}], "]"}]}], ")"}], "/", 
          "2"}]}], ",", " ", "\[IndentingNewLine]", 
        RowBox[{"dmin", " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[Pi]"}], 
           RowBox[{"(", 
            RowBox[{"n", "+", 
             FractionBox["1", "2"]}], ")"}]}], "-", 
          FractionBox["\[Alpha]0", "2"]}]}], ",", 
        RowBox[{"dmax", " ", "=", " ", 
         RowBox[{
          RowBox[{"\[Pi]", 
           RowBox[{"(", 
            RowBox[{"n", "+", 
             FractionBox["1", "2"], "-", 
             FractionBox["1", "n\[Alpha]"]}], ")"}]}], "-", 
          FractionBox["\[Alpha]0", "2"]}]}], ",", 
        RowBox[{"dd", " ", "=", " ", 
         FractionBox["\[Pi]", "n\[Alpha]"]}], ",", "\[IndentingNewLine]", 
        "cc", ",", "wdet", ",", "mc", ",", "ms", ",", "s", ",", "dbot", ",", 
        "dtop"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"cc", " ", "=", " ", 
        RowBox[{"FloquetCutoff", "[", 
         RowBox[{"a", ",", 
          RowBox[{"Im", "[", "b", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"mc", " ", "=", " ", 
        RowBox[{"MathieuC", "[", 
         RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ms", " ", "=", " ", 
        RowBox[{"MathieuS", "[", 
         RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"wdet", " ", "=", " ", 
        FractionBox["1", 
         RowBox[{"\[Pi]", " ", 
          SuperscriptBox["\[Sigma]", 
           RowBox[{"2", " "}]], 
          RowBox[{"MathieuSPrime", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Chi]", "=", " ", 
        RowBox[{"Sign", "[", 
         RowBox[{"Im", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["mc", "2"], "+", 
             SuperscriptBox["ms", "2"]}], ")"}], "wdet"}], "]"}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"dbot", " ", "=", " ", 
        RowBox[{
         RowBox[{"Round", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"OnTick", "[", 
             RowBox[{"dmin", ",", "dd"}], "]"}], "[", 
            RowBox[{
             RowBox[{"-", "cc"}], "-", "c"}], "]"}], "/", "dd"}], "]"}], " ", 
         "dd"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"dtop", " ", "=", " ", 
        RowBox[{
         RowBox[{"Round", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"OnTick", "[", 
             RowBox[{"dmin", ",", "dd"}], "]"}], "[", 
            RowBox[{"cc", "-", "c"}], "]"}], "/", "dd"}], "]"}], " ", 
         "dd"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"-", "\[Chi]"}], " ", "wdet", "*", "\[IndentingNewLine]", 
        RowBox[{"Total", "[", "\[IndentingNewLine]", 
         RowBox[{"Partition", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Join", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{"0", ",", 
               RowBox[{"{", 
                RowBox[{"d", ",", "dmin", ",", 
                 RowBox[{"dbot", "-", "dd"}], ",", "dd"}], "}"}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[ImaginaryI]", " ", "mc"}], "+", 
                RowBox[{"\[Chi]", " ", "ms"}]}], ")"}], " ", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 SuperscriptBox["\[ExponentialE]", 
                  FractionBox[
                   RowBox[{"2", "d", " ", "\[Kappa]"}], 
                   SuperscriptBox["\[Sigma]", "2"]]], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"MathieuC", "[", 
                    RowBox[{"a", ",", "b", ",", 
                    RowBox[{"c", "+", "d"}]}], "]"}], "+", 
                   RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", 
                    RowBox[{"MathieuS", "[", 
                    RowBox[{"a", ",", "b", ",", 
                    RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"d", ",", 
                  RowBox[{"Max", "[", 
                   RowBox[{"dmin", ",", "dbot"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"PreviousTick", "[", 
                    RowBox[{"dmin", ",", "dd"}], "]"}], "[", "0", "]"}], ",", 
                  "dd"}], "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"EvenQ", "[", "n\[Alpha]", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"\[ImaginaryI]", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["mc", "2"], "+", 
                   SuperscriptBox["ms", "2"]}], ")"}]}], "}"}], ",", 
               RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"mc", "+", 
                RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", "ms"}]}], ")"}], 
              " ", 
              RowBox[{"Table", "[", " ", 
               RowBox[{
                RowBox[{
                 SuperscriptBox["\[ExponentialE]", 
                  FractionBox[
                   RowBox[{"2", "d", " ", "\[Kappa]"}], 
                   SuperscriptBox["\[Sigma]", "2"]]], 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"MathieuC", "[", 
                    RowBox[{"a", ",", "b", ",", 
                    RowBox[{"c", "+", "d"}]}], "]"}]}], "+", 
                   RowBox[{"\[Chi]", " ", 
                    RowBox[{"MathieuS", "[", 
                    RowBox[{"a", ",", "b", ",", 
                    RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"d", ",", 
                  RowBox[{
                   RowBox[{"NextTick", "[", 
                    RowBox[{"dmin", ",", "dd"}], "]"}], "[", "0", "]"}], ",", 
                  
                  RowBox[{"Min", "[", 
                   RowBox[{"dmax", ",", "dtop"}], "]"}], ",", "dd"}], "}"}]}],
                "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{"0", ",", 
               RowBox[{"{", 
                RowBox[{"d", ",", 
                 RowBox[{"dtop", "+", "dd"}], ",", "dmax", ",", "dd"}], 
                "}"}]}], "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
           "\[IndentingNewLine]", "n\[Alpha]"}], "\[IndentingNewLine]", "]"}],
          "\[IndentingNewLine]", "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FourierCyclicLineKernel", "::", "notimpl"}], " ", "=", " ", 
    "\"\<This function call is not implemented, since the \[Alpha]-sequence \
should always match the cyclic boundary. Just specify the number of \
\[Alpha]-values between -\[Pi] and \[Pi] instead.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FourierCyclicLineKernel", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}], ",", 
      RowBox[{"n_Integer:", "1"}]}], "]"}], "[", 
    RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", " ", 
     RowBox[{"{", 
      RowBox[{"min\[Alpha]_", ",", "max\[Alpha]_", ",", "d\[Alpha]_"}], 
      "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Message", "[", 
    RowBox[{"FourierCyclicLineKernel", "::", "notimpl"}], "]"}]}], 
  ";"}]}], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Note", " ", "order", " ", "of", " ", 
    RowBox[{"implementation", ".", " ", "Do"}], " ", "not", " ", "move", " ", 
    "this", " ", "function", " ", 
    RowBox[{"up", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FourierCyclicLineKernel", "[", 
      RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}], ",", 
       RowBox[{"n_Integer:", "1"}]}], "]"}], "[", 
     RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", " ", "\[Alpha]_"}], "]"}], 
    ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", " ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Kappa]", "2"], "+", 
             RowBox[{"2", " ", "\[Lambda]", " ", 
              SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
           SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[IndentingNewLine]", 
        
        RowBox[{"b", " ", "=", " ", 
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          RowBox[{
           RowBox[{"Radius", "[", 
            RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", " ", 
        "\[IndentingNewLine]", 
        RowBox[{"c", " ", "=", " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Alpha]0", "-", 
            RowBox[{"Mod", "[", 
             RowBox[{
              RowBox[{"Angle", "[", 
               RowBox[{"\[Omega]x", ",", "\[Omega]y"}], "]"}], ",", "\[Pi]", 
              ",", 
              RowBox[{
               RowBox[{"-", "\[Pi]"}], "/", "2"}]}], "]"}]}], ")"}], "/", 
          "2"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"dmod", " ", "=", " ", 
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}], "/", "2"}], ",", 
           "\[Pi]", ",", 
           RowBox[{
            RowBox[{"-", "\[Pi]"}], "/", "2"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", "cc", ",", "wdet", ",", "mc0", ",", "ms0", ",",
         "s"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"cc", " ", "=", " ", 
        RowBox[{"FloquetCutoff", "[", 
         RowBox[{"a", ",", 
          RowBox[{"Im", "[", "b", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"mc", " ", "=", " ", 
        RowBox[{"MathieuC", "[", 
         RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ms", " ", "=", " ", 
        RowBox[{"MathieuS", "[", 
         RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"wdet", " ", "=", " ", 
        FractionBox["1", 
         RowBox[{"\[Pi]", " ", 
          SuperscriptBox["\[Sigma]", 
           RowBox[{"2", " "}]], 
          RowBox[{"MathieuSPrime", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Chi]", " ", "=", " ", 
        RowBox[{"Sign", "[", 
         RowBox[{"Im", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["mc", "2"], "+", 
             SuperscriptBox["ms", "2"]}], ")"}], "wdet"}], "]"}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"-", "\[Chi]"}], " ", "wdet", "*", " ", 
        RowBox[{"Sum", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\[Piecewise]", GridBox[{
             {"0", 
              RowBox[{
               RowBox[{"Abs", "[", 
                RowBox[{"c", "+", "d"}], "]"}], ">", "cc"}]},
             {
              RowBox[{
               SuperscriptBox["\[ExponentialE]", 
                FractionBox[
                 RowBox[{"2", " ", "d", " ", "\[Kappa]"}], 
                 SuperscriptBox["\[Sigma]", "2"]]], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[ImaginaryI]", " ", "mc"}], "+", 
                 RowBox[{"\[Chi]", " ", "ms"}]}], ")"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"MathieuC", "[", 
                  RowBox[{"a", ",", "b", ",", 
                   RowBox[{"c", "+", "d"}]}], "]"}], "+", 
                 RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", 
                  RowBox[{"MathieuS", "[", 
                   RowBox[{"a", ",", "b", ",", 
                    RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], 
              RowBox[{"Negative", "[", "d", "]"}]},
             {
              RowBox[{
               SuperscriptBox["\[ExponentialE]", 
                FractionBox[
                 RowBox[{"2", " ", "d", " ", "\[Kappa]"}], 
                 SuperscriptBox["\[Sigma]", "2"]]], " ", 
               RowBox[{"(", 
                RowBox[{"mc", "+", 
                 RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", "ms"}]}], ")"}],
                " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"MathieuC", "[", 
                   RowBox[{"a", ",", "b", ",", 
                    RowBox[{"c", "+", "d"}]}], "]"}]}], "+", 
                 RowBox[{"\[Chi]", " ", 
                  RowBox[{"MathieuS", "[", 
                   RowBox[{"a", ",", "b", ",", 
                    RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], 
              RowBox[{"Positive", "[", "d", "]"}]},
             {
              RowBox[{"\[ImaginaryI]", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["mc", "2"], "+", 
                 SuperscriptBox["ms", "2"]}], ")"}]}], "True"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.84]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"d", ",", 
            RowBox[{"dmod", "-", 
             RowBox[{"n", " ", "\[Pi]"}]}], ",", 
            RowBox[{"dmod", "+", 
             RowBox[{"n", " ", "\[Pi]"}]}], ",", "\[Pi]"}], "}"}]}], 
         "\[IndentingNewLine]", "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Fourier Cyclic Line Kernel Polar", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Fourier", " ", "Cyclic", " ", "Line", " ", "Kernel", " ", "Polar"}], " ", 
  "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Numeric Implementation", "Subsubsection"],

Cell["\<\
Implementing a compiled version of the Fourier-transformed line kernel..\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Numeric", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"no", " ", "speed", " ", "gain"}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Symbolic Implementation", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FourierCyclicLineKernelPolar", "[", 
      RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}], ",", 
       RowBox[{"n_Integer:", "1"}]}], "]"}], "[", 
     RowBox[{"\[Omega]r_", ",", "\[Omega]\[CurlyPhi]_", ",", " ", 
      RowBox[{"{", 
       RowBox[{"n\[Alpha]_Integer", "?", "Positive"}], "}"}]}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", " ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Kappa]", "2"], "+", 
             RowBox[{"2", " ", "\[Lambda]", " ", 
              SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
           SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[IndentingNewLine]", 
        
        RowBox[{"b", " ", "=", " ", 
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          RowBox[{"\[Omega]r", "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", " ", 
        "\[IndentingNewLine]", 
        RowBox[{"c", " ", "=", " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"\[Alpha]0", ",", 
              RowBox[{"2", "\[Pi]"}], ",", 
              RowBox[{"-", "\[Pi]"}]}], "]"}], "-", "\[Omega]\[CurlyPhi]"}], 
           ")"}], "/", "2"}]}], ",", " ", "\[IndentingNewLine]", 
        RowBox[{"dmin", " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[Pi]"}], 
           RowBox[{"(", 
            RowBox[{"n", "+", 
             FractionBox["1", "2"]}], ")"}]}], "-", 
          RowBox[{
           RowBox[{"Mod", "[", 
            RowBox[{"\[Alpha]0", ",", 
             RowBox[{"2", "\[Pi]"}], ",", 
             RowBox[{"-", "\[Pi]"}]}], "]"}], "/", "2"}]}]}], ",", 
        RowBox[{"dmax", " ", "=", " ", 
         RowBox[{
          RowBox[{"\[Pi]", 
           RowBox[{"(", 
            RowBox[{"n", "+", 
             FractionBox["1", "2"], "-", 
             FractionBox["1", "n\[Alpha]"]}], ")"}]}], "-", 
          RowBox[{
           RowBox[{"Mod", "[", 
            RowBox[{"\[Alpha]0", ",", 
             RowBox[{"2", "\[Pi]"}], ",", 
             RowBox[{"-", "\[Pi]"}]}], "]"}], "/", "2"}]}]}], ",", 
        RowBox[{"dd", " ", "=", " ", 
         FractionBox["\[Pi]", "n\[Alpha]"]}], ",", "\[IndentingNewLine]", 
        "cc", ",", "wdet", ",", "mc", ",", "ms", ",", "s", ",", "dbot", ",", 
        "dtop"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"cc", " ", "=", " ", 
        RowBox[{"FloquetCutoff", "[", 
         RowBox[{"a", ",", 
          RowBox[{"Im", "[", "b", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"mc", " ", "=", " ", 
        RowBox[{"MathieuC", "[", 
         RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"mmma", "=", " ", 
        RowBox[{"MathieuS", "[", 
         RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"wdet", " ", "=", " ", 
        FractionBox["1", 
         RowBox[{"\[Pi]", " ", 
          SuperscriptBox["\[Sigma]", 
           RowBox[{"2", " "}]], 
          RowBox[{"MathieuSPrime", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Chi]", " ", "=", " ", 
        RowBox[{"Sign", "[", 
         RowBox[{"Im", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["mc", "2"], "+", 
             SuperscriptBox["ms", "2"]}], ")"}], "wdet"}], "]"}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"dbot", " ", "=", " ", 
        RowBox[{
         RowBox[{"Round", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"OnTick", "[", 
             RowBox[{"dmin", ",", "dd"}], "]"}], "[", 
            RowBox[{
             RowBox[{"-", "cc"}], "-", "c"}], "]"}], "/", "dd"}], "]"}], " ", 
         "dd"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"dtop", " ", "=", " ", 
        RowBox[{
         RowBox[{"Round", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"OnTick", "[", 
             RowBox[{"dmin", ",", "dd"}], "]"}], "[", 
            RowBox[{"cc", "-", "c"}], "]"}], "/", "dd"}], "]"}], " ", 
         "dd"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"-", "\[Chi]"}], " ", "wdet", "*", "\[IndentingNewLine]", 
        RowBox[{"Total", "[", "\[IndentingNewLine]", 
         RowBox[{"Partition", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Join", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{"0", ",", 
               RowBox[{"{", 
                RowBox[{"d", ",", "dmin", ",", 
                 RowBox[{"dbot", "-", "dd"}], ",", "dd"}], "}"}]}], "]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[ImaginaryI]", " ", "mc"}], "+", 
                RowBox[{"\[Chi]", " ", "ms"}]}], ")"}], " ", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 SuperscriptBox["\[ExponentialE]", 
                  FractionBox[
                   RowBox[{"2", "d", " ", "\[Kappa]"}], 
                   SuperscriptBox["\[Sigma]", "2"]]], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"MathieuC", "[", 
                    RowBox[{"a", ",", "b", ",", 
                    RowBox[{"c", "+", "d"}]}], "]"}], "+", 
                   RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", 
                    RowBox[{"MathieuS", "[", 
                    RowBox[{"a", ",", "b", ",", 
                    RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"d", ",", 
                  RowBox[{"Max", "[", 
                   RowBox[{"dmin", ",", "dbot"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"PreviousTick", "[", 
                    RowBox[{"dmin", ",", "dd"}], "]"}], "[", "0", "]"}], ",", 
                  "dd"}], "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"EvenQ", "[", "n\[Alpha]", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"\[ImaginaryI]", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["mc", "2"], "+", 
                   SuperscriptBox["ms", "2"]}], ")"}]}], "}"}], ",", 
               RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"mc", "+", 
                RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", "ms"}]}], ")"}], 
              " ", 
              RowBox[{"Table", "[", " ", 
               RowBox[{
                RowBox[{
                 SuperscriptBox["\[ExponentialE]", 
                  FractionBox[
                   RowBox[{"2", "d", " ", "\[Kappa]"}], 
                   SuperscriptBox["\[Sigma]", "2"]]], 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"MathieuC", "[", 
                    RowBox[{"a", ",", "b", ",", 
                    RowBox[{"c", "+", "d"}]}], "]"}]}], "+", 
                   RowBox[{"\[Chi]", " ", 
                    RowBox[{"MathieuS", "[", 
                    RowBox[{"a", ",", "b", ",", 
                    RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"d", ",", 
                  RowBox[{
                   RowBox[{"NextTick", "[", 
                    RowBox[{"dmin", ",", "dd"}], "]"}], "[", "0", "]"}], ",", 
                  
                  RowBox[{"Min", "[", 
                   RowBox[{"dmax", ",", "dtop"}], "]"}], ",", "dd"}], "}"}]}],
                "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"Table", "[", 
              RowBox[{"0", ",", 
               RowBox[{"{", 
                RowBox[{"d", ",", 
                 RowBox[{"dtop", "+", "dd"}], ",", "dmax", ",", "dd"}], 
                "}"}]}], "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
           "\[IndentingNewLine]", "n\[Alpha]"}], "\[IndentingNewLine]", "]"}],
          "\[IndentingNewLine]", "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FourierCyclicLineKernelPolar", "::", "notimpl"}], " ", "=", " ", 
    "\"\<This function call is not implemented, since the \[Alpha]-sequence \
should always match the cyclic boundary. Just specify the number of \
\[Alpha]-values between -\[Pi] and \[Pi] instead.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FourierCyclicLineKernelPolar", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}], ",", 
      RowBox[{"n_Integer:", "1"}]}], "]"}], "[", 
    RowBox[{"\[Omega]r_", ",", "\[Omega]\[CurlyPhi]_", ",", " ", 
     RowBox[{"{", 
      RowBox[{"min\[Alpha]_", ",", "max\[Alpha]_", ",", "d\[Alpha]_"}], 
      "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Message", "[", 
    RowBox[{"FourierCyclicLineKernelPolar", "::", "notimpl"}], "]"}]}], 
  ";"}]}], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Note", " ", "order", " ", "of", " ", 
    RowBox[{"implementation", ".", " ", "Do"}], " ", "not", " ", "move", " ", 
    "this", " ", "function", " ", 
    RowBox[{"up", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FourierCyclicLineKernelPolar", "[", 
      RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}], ",", 
       RowBox[{"n_Integer:", "1"}]}], "]"}], "[", 
     RowBox[{
     "\[Omega]r_", ",", "\[Omega]\[CurlyPhi]_", ",", " ", "\[Alpha]_"}], 
     "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", " ", "=", " ", 
         RowBox[{
          RowBox[{"-", "4"}], " ", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[Kappa]", "2"], "+", 
             RowBox[{"2", " ", "\[Lambda]", " ", 
              SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
           SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[IndentingNewLine]", 
        
        RowBox[{"b", " ", "=", " ", 
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          RowBox[{"\[Omega]r", "/", 
           SuperscriptBox["\[Sigma]", "2"]}]}]}], ",", " ", 
        "\[IndentingNewLine]", 
        RowBox[{"c", " ", "=", " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{"\[Alpha]0", ",", 
              RowBox[{"2", "\[Pi]"}], ",", 
              RowBox[{"-", "\[Pi]"}]}], "]"}], "-", "\[Omega]\[CurlyPhi]"}], 
           ")"}], "/", "2"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"dmod", " ", "=", " ", 
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{
            RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ",", 
            RowBox[{"2", "\[Pi]"}], ",", 
            RowBox[{"-", "\[Pi]"}]}], "]"}], "/", "2"}]}], ",", 
        "\[IndentingNewLine]", "cc", ",", "wdet", ",", "mc", ",", "ms", ",", 
        "s"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"cc", " ", "=", " ", 
        RowBox[{"FloquetCutoff", "[", 
         RowBox[{"a", ",", 
          RowBox[{"Im", "[", "b", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"mc", " ", "=", " ", 
        RowBox[{"MathieuC", "[", 
         RowBox[{"a", ",", "b", ",", 
          RowBox[{"c", "+", "d0"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"ms", " ", "=", " ", 
        RowBox[{"MathieuS", "[", 
         RowBox[{"a", ",", "b", ",", 
          RowBox[{"c", "+", "d0"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"wdet", " ", "=", " ", 
        FractionBox["1", 
         RowBox[{"\[Pi]", " ", 
          SuperscriptBox["\[Sigma]", 
           RowBox[{"2", " "}]], 
          RowBox[{"MathieuSPrime", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}], " ", 
          RowBox[{"MathieuC", "[", 
           RowBox[{"a", ",", "b", ",", "0"}], "]"}]}]]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Chi]", " ", "=", " ", 
        RowBox[{"Sign", "[", 
         RowBox[{"Im", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["mc", "2"], "+", 
             SuperscriptBox["ms", "2"]}], ")"}], "wdet"}], "]"}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"-", "\[Chi]"}], " ", "wdet", "*", " ", 
        RowBox[{"Sum", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\[Piecewise]", GridBox[{
             {"0", 
              RowBox[{
               RowBox[{"Abs", "[", 
                RowBox[{"c", "+", "d"}], "]"}], ">", "cc"}]},
             {
              RowBox[{
               SuperscriptBox["\[ExponentialE]", 
                FractionBox[
                 RowBox[{"2", " ", "d", " ", "\[Kappa]"}], 
                 SuperscriptBox["\[Sigma]", "2"]]], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[ImaginaryI]", " ", "mc"}], "+", 
                 RowBox[{"\[Chi]", " ", "ms"}]}], ")"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"MathieuC", "[", 
                  RowBox[{"a", ",", "b", ",", 
                   RowBox[{"c", "+", "d"}]}], "]"}], "+", 
                 RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", 
                  RowBox[{"MathieuS", "[", 
                   RowBox[{"a", ",", "b", ",", 
                    RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], 
              RowBox[{"Negative", "[", "d", "]"}]},
             {
              RowBox[{
               SuperscriptBox["\[ExponentialE]", 
                FractionBox[
                 RowBox[{"2", " ", "d", " ", "\[Kappa]"}], 
                 SuperscriptBox["\[Sigma]", "2"]]], " ", 
               RowBox[{"(", 
                RowBox[{"mc", "+", 
                 RowBox[{"\[ImaginaryI]", " ", "\[Chi]", " ", "ms"}]}], ")"}],
                " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"\[ImaginaryI]", " ", 
                  RowBox[{"MathieuC", "[", 
                   RowBox[{"a", ",", "b", ",", 
                    RowBox[{"c", "+", "d"}]}], "]"}]}], "+", 
                 RowBox[{"\[Chi]", " ", 
                  RowBox[{"MathieuS", "[", 
                   RowBox[{"a", ",", "b", ",", 
                    RowBox[{"c", "+", "d"}]}], "]"}]}]}], ")"}]}], 
              RowBox[{"Positive", "[", "d", "]"}]},
             {
              RowBox[{"\[ImaginaryI]", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["mc", "2"], "+", 
                 SuperscriptBox["ms", "2"]}], ")"}]}], "True"}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.84]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"d", ",", 
            RowBox[{"dmod", "-", 
             RowBox[{"n", " ", "\[Pi]"}]}], ",", 
            RowBox[{"dmod", "+", 
             RowBox[{"n", " ", "\[Pi]"}]}], ",", "\[Pi]"}], "}"}]}], 
         "\[IndentingNewLine]", "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}]}]], "PackageInput",
 InitializationCell->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Fourier Line Kernel Approximation", "Subsection"],

Cell["\<\
Same as completion kernel along x but with the \"x-axis\" aligned along \
\[Alpha]0.\
\>", "Text"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Fourier", " ", "Line", " ", "Kernel", " ", "Approximation"}], " ", 
  "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Numeric Implementation", "Subsubsection"],

Cell["Implementing a compiled version of the completion kernel.", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Numeric", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"no", " ", "speed", " ", "gain"}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Symbolic Implementation", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"FourierLineKernelApproximation", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_"}], "]"}], "[", 
    RowBox[{"\[Omega]x_", ",", 
     RowBox[{"0", "|", "0."}], ",", 
     RowBox[{"{", 
      RowBox[{"min\[Alpha]_", ",", "max\[Alpha]_", ",", "d\[Alpha]_"}], 
      "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", "\[Pi]", " ", 
      SqrtBox[
       RowBox[{"2", 
        SuperscriptBox["\[Sigma]", "2"], 
        RowBox[{"(", 
         RowBox[{"\[Lambda]", "-", 
          RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], ")"}]}]]}]], 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"-", 
         SqrtBox[
          RowBox[{"2", 
           RowBox[{"(", 
            RowBox[{"\[Lambda]", "-", 
             RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], ")"}]}]]}], " ", 
        RowBox[{
         RowBox[{"Abs", "[", "\[Alpha]", "]"}], "/", "\[Sigma]"}]}], "]"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
       "\[Alpha]", ",", "min\[Alpha]", ",", "max\[Alpha]", ",", "d\[Alpha]"}],
        "}"}]}], "]"}]}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FourierLineKernelApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
     RowBox[{"0", "|", "0."}], ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{"\[Omega]x_", ",", 
    RowBox[{"0", "|", "0."}], ",", 
    RowBox[{"{", 
     RowBox[{"min\[Alpha]_", ",", "max\[Alpha]_", ",", "d\[Alpha]_"}], 
     "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[Pi]", " ", 
     SqrtBox[
      RowBox[{
       SuperscriptBox["\[Kappa]", "2"], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox["\[Sigma]", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"\[Lambda]", "-", 
          RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], ")"}]}]}]]}]], 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[Kappa]", " ", "\[Alpha]"}], "-", 
         RowBox[{
          SqrtBox[
           RowBox[{
            SuperscriptBox["\[Kappa]", "2"], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["\[Sigma]", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"\[Lambda]", "-", 
               RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], ")"}]}]}]], 
          RowBox[{"Abs", "[", "\[Alpha]", "]"}]}]}], ")"}], "/", 
       SuperscriptBox["\[Sigma]", "2"]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "\[Alpha]", ",", "min\[Alpha]", ",", "max\[Alpha]", ",", "d\[Alpha]"}], 
      "}"}]}], "]"}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FourierLineKernelApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_"}], "]"}], "[", 
   RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", 
    RowBox[{"{", 
     RowBox[{"min\[Alpha]_", ",", "max\[Alpha]_", ",", "d\[Alpha]_"}], 
     "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", " ", "=", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", "\[ImaginaryI]", " "}], 
          RowBox[{" ", 
           SuperscriptBox["\[Sigma]", "2"]}]]}], "\[Omega]y"}]}], ",", " ", 
      RowBox[{"c", " ", "=", 
       RowBox[{
        FractionBox["2", 
         SuperscriptBox["\[Sigma]", "2"]], " ", 
        RowBox[{"(", 
         RowBox[{"\[Lambda]", "-", 
          RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], ")"}]}]}]}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     FractionBox["2", 
      RowBox[{
       SuperscriptBox["\[Sigma]", "2"], 
       SuperscriptBox[
        RowBox[{"Abs", "[", "a", "]"}], 
        RowBox[{"1", "/", "3"}]]}]], "*", "\[IndentingNewLine]", 
     RowBox[{"Join", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"AiryAi", "[", 
         FractionBox["c", 
          SuperscriptBox["a", 
           RowBox[{"2", "/", "3"}]]], "]"}], " ", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"AiryAi", "[", 
           FractionBox[
            RowBox[{"c", "+", 
             RowBox[{"a", " ", "\[Alpha]"}]}], 
            RowBox[{"Conjugate", "[", 
             SuperscriptBox["a", 
              RowBox[{"2", "/", "3"}]], "]"}]], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Alpha]", ",", "min\[Alpha]", ",", 
            RowBox[{
             RowBox[{"PreviousTick", "[", 
              RowBox[{"min\[Alpha]", ",", "d\[Alpha]"}], "]"}], "[", "0", 
             "]"}], ",", "d\[Alpha]"}], "}"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Mod", "[", 
            RowBox[{"min\[Alpha]", ",", "d\[Alpha]"}], "]"}], "\[Equal]", 
           "0"}], " ", "\[And]", " ", 
          RowBox[{
          "min\[Alpha]", " ", "\[LessEqual]", " ", "0", " ", "\[LessEqual]", 
           " ", "max\[Alpha]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"AiryAi", "[", 
            FractionBox["c", 
             SuperscriptBox["a", 
              RowBox[{"2", "/", "3"}]]], "]"}], " ", 
           RowBox[{"AiryAi", "[", 
            FractionBox["c", 
             RowBox[{"Conjugate", "[", 
              SuperscriptBox["a", 
               RowBox[{"2", "/", "3"}]], "]"}]], "]"}]}], "}"}], ",", 
         RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"AiryAi", "[", 
         FractionBox["c", 
          RowBox[{"Conjugate", "[", 
           SuperscriptBox["a", 
            RowBox[{"2", "/", "3"}]], "]"}]], "]"}], "  ", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"AiryAi", "[", 
           FractionBox[
            RowBox[{"c", "+", 
             RowBox[{"a", " ", "\[Alpha]"}]}], 
            SuperscriptBox["a", 
             RowBox[{"2", "/", "3"}]]], "]"}], " ", ",", 
          RowBox[{"{", 
           RowBox[{"\[Alpha]", ",", 
            RowBox[{
             RowBox[{"NextTick", "[", 
              RowBox[{"min\[Alpha]", ",", "d\[Alpha]"}], "]"}], "[", "0", 
             "]"}], ",", "max\[Alpha]", ",", "d\[Alpha]"}], "}"}]}], 
         "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FourierLineKernelApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
     RowBox[{"0", "|", "0."}], ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", 
    RowBox[{"{", 
     RowBox[{"min\[Alpha]_", ",", "max\[Alpha]_", ",", "d\[Alpha]_"}], 
     "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", " ", "=", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", "\[ImaginaryI]", " "}], 
          SuperscriptBox["\[Sigma]", "2"]]}], "\[Omega]y"}]}], ",", " ", 
      RowBox[{"c", " ", "=", 
       RowBox[{
        FractionBox["2", 
         SuperscriptBox["\[Sigma]", "2"]], " ", 
        RowBox[{"(", 
         RowBox[{"\[Lambda]", "-", 
          RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], ")"}]}]}], ",", 
      RowBox[{"d", " ", "=", " ", 
       FractionBox[
        RowBox[{"\[Kappa]", " "}], 
        SuperscriptBox["\[Sigma]", "2"]]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     FractionBox["2", 
      RowBox[{
       SuperscriptBox["\[Sigma]", "2"], 
       SuperscriptBox[
        RowBox[{"Abs", "[", "a", "]"}], 
        RowBox[{"1", "/", "3"}]]}]], "*", "\[IndentingNewLine]", 
     RowBox[{"Join", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"AiryAi", "[", 
         FractionBox[
          RowBox[{"c", "+", 
           SuperscriptBox["d", "2"]}], 
          SuperscriptBox["a", 
           RowBox[{"2", "/", "3"}]]], "]"}], " ", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"d", " ", "\[Alpha]"}]], " ", 
           RowBox[{"AiryAi", "[", 
            FractionBox[
             RowBox[{"c", "+", 
              SuperscriptBox["d", "2"], "+", 
              RowBox[{"a", " ", "\[Alpha]"}]}], 
             RowBox[{"Conjugate", "[", 
              SuperscriptBox["a", 
               RowBox[{"2", "/", "3"}]], "]"}]], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Alpha]", ",", "min\[Alpha]", ",", 
            RowBox[{
             RowBox[{"PreviousTick", "[", 
              RowBox[{"min\[Alpha]", ",", "d\[Alpha]"}], "]"}], "[", "0", 
             "]"}], ",", "d\[Alpha]"}], "}"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Mod", "[", 
            RowBox[{"min\[Alpha]", ",", "d\[Alpha]"}], "]"}], "\[Equal]", 
           "0"}], " ", "\[And]", " ", 
          RowBox[{
          "min\[Alpha]", " ", "\[LessEqual]", " ", "0", " ", "\[LessEqual]", 
           " ", "max\[Alpha]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"AiryAi", "[", 
            FractionBox[
             RowBox[{"c", "+", 
              SuperscriptBox["d", "2"]}], 
             SuperscriptBox["a", 
              RowBox[{"2", "/", "3"}]]], "]"}], " ", 
           RowBox[{"AiryAi", "[", 
            FractionBox[
             RowBox[{"c", "+", 
              SuperscriptBox["d", "2"]}], 
             RowBox[{"Conjugate", "[", 
              SuperscriptBox["a", 
               RowBox[{"2", "/", "3"}]], "]"}]], "]"}]}], "}"}], ",", 
         RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"AiryAi", "[", 
         FractionBox[
          RowBox[{"c", "+", 
           SuperscriptBox["d", "2"]}], 
          RowBox[{"Conjugate", "[", 
           SuperscriptBox["a", 
            RowBox[{"2", "/", "3"}]], "]"}]], "]"}], "  ", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"d", " ", "\[Alpha]"}]], " ", 
           RowBox[{"AiryAi", "[", 
            FractionBox[
             RowBox[{"c", "+", 
              SuperscriptBox["d", "2"], "+", 
              RowBox[{"a", " ", "\[Alpha]"}]}], 
             SuperscriptBox["a", 
              RowBox[{"2", "/", "3"}]]], "]"}]}], " ", ",", 
          RowBox[{"{", 
           RowBox[{"\[Alpha]", ",", 
            RowBox[{
             RowBox[{"NextTick", "[", 
              RowBox[{"min\[Alpha]", ",", "d\[Alpha]"}], "]"}], "[", "0", 
             "]"}], ",", "max\[Alpha]", ",", "d\[Alpha]"}], "}"}]}], 
         "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FourierLineKernelApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", "\[Alpha]0_", ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", 
    RowBox[{"{", 
     RowBox[{"min\[Alpha]_", ",", "max\[Alpha]_", ",", "d\[Alpha]_"}], 
     "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", " ", "=", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", "\[ImaginaryI]", " "}], 
          RowBox[{" ", 
           SuperscriptBox["\[Sigma]", "2"]}]]}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "\[Omega]x"}], " ",
           "+", " ", 
          RowBox[{
           RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "\[Omega]y"}]}], 
         ")"}]}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"c", " ", "=", 
       RowBox[{
        FractionBox["2", 
         SuperscriptBox["\[Sigma]", "2"]], " ", 
        RowBox[{"(", 
         RowBox[{"\[Lambda]", "-", 
          RowBox[{"\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "\[Omega]x"}], " ",
              "+", " ", 
             RowBox[{
              RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "\[Omega]y"}]}], 
            ")"}]}]}], ")"}]}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"d", " ", "=", " ", 
       FractionBox[
        RowBox[{"\[Kappa]", " "}], 
        SuperscriptBox["\[Sigma]", "2"]]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"a", "==", "0"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"2", " ", "\[Pi]", " ", 
         SuperscriptBox["\[Sigma]", "2"], 
         SqrtBox[
          RowBox[{"c", "+", 
           SuperscriptBox["d", "2"]}]]}]], 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Exp", "[", 
          RowBox[{
           RowBox[{"d", " ", "\[Alpha]"}], "-", 
           RowBox[{
            SqrtBox[
             RowBox[{"c", "+", 
              SuperscriptBox["d", "2"]}]], " ", 
            RowBox[{"Abs", "[", "\[Alpha]", "]"}]}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
          "\[Alpha]", ",", "min\[Alpha]", ",", "max\[Alpha]", ",", 
           "d\[Alpha]"}], "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
       FractionBox["2", 
        RowBox[{
         SuperscriptBox["\[Sigma]", "2"], 
         SuperscriptBox[
          RowBox[{"Abs", "[", "a", "]"}], 
          RowBox[{"1", "/", "3"}]]}]], "*", 
       RowBox[{"Join", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"AiryAi", "[", 
           FractionBox[
            RowBox[{"c", "+", 
             SuperscriptBox["d", "2"]}], 
            SuperscriptBox["a", 
             RowBox[{"2", "/", "3"}]]], "]"}], " ", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"d", " ", "\[Alpha]"}]], " ", 
             RowBox[{"AiryAi", "[", 
              FractionBox[
               RowBox[{"c", "+", 
                SuperscriptBox["d", "2"], "+", 
                RowBox[{"a", " ", "\[Alpha]"}]}], 
               RowBox[{"Conjugate", "[", 
                SuperscriptBox["a", 
                 RowBox[{"2", "/", "3"}]], "]"}]], "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Alpha]", ",", "min\[Alpha]", ",", 
              RowBox[{
               RowBox[{"PreviousTick", "[", 
                RowBox[{"min\[Alpha]", ",", "d\[Alpha]"}], "]"}], "[", "0", 
               "]"}], ",", "d\[Alpha]"}], "}"}]}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Mod", "[", 
              RowBox[{"min\[Alpha]", ",", "d\[Alpha]"}], "]"}], "\[Equal]", 
             "0"}], " ", "\[And]", " ", 
            RowBox[{
            "min\[Alpha]", " ", "\[LessEqual]", " ", "0", " ", "\[LessEqual]",
              " ", "max\[Alpha]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"AiryAi", "[", 
              FractionBox[
               RowBox[{"c", "+", 
                SuperscriptBox["d", "2"]}], 
               SuperscriptBox["a", 
                RowBox[{"2", "/", "3"}]]], "]"}], " ", 
             RowBox[{"AiryAi", "[", 
              FractionBox[
               RowBox[{"c", "+", 
                SuperscriptBox["d", "2"]}], 
               RowBox[{"Conjugate", "[", 
                SuperscriptBox["a", 
                 RowBox[{"2", "/", "3"}]], "]"}]], "]"}]}], "}"}], ",", 
           RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"AiryAi", "[", 
           FractionBox[
            RowBox[{"c", "+", 
             SuperscriptBox["d", "2"]}], 
            RowBox[{"Conjugate", "[", 
             SuperscriptBox["a", 
              RowBox[{"2", "/", "3"}]], "]"}]], "]"}], "  ", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"d", " ", "\[Alpha]"}]], " ", 
             RowBox[{"AiryAi", "[", 
              FractionBox[
               RowBox[{"c", "+", 
                SuperscriptBox["d", "2"], "+", 
                RowBox[{"a", " ", "\[Alpha]"}]}], 
               SuperscriptBox["a", 
                RowBox[{"2", "/", "3"}]]], "]"}]}], " ", ",", 
            RowBox[{"{", 
             RowBox[{"\[Alpha]", ",", 
              RowBox[{
               RowBox[{"NextTick", "[", 
                RowBox[{"min\[Alpha]", ",", "d\[Alpha]"}], "]"}], "[", "0", 
               "]"}], ",", "max\[Alpha]", ",", "d\[Alpha]"}], "}"}]}], 
           "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]",
      "]"}]}], "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FourierLineKernelApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
     RowBox[{"\[Alpha]0_:", "0"}], ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", 
    RowBox[{"{", "n\[Alpha]_", "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"FourierLineKernelApproximation", "[", 
    RowBox[{"\[Sigma]", ",", "\[Lambda]", ",", "\[Alpha]0", ",", "\[Kappa]"}],
     "]"}], "[", 
   RowBox[{"\[Omega]x", ",", "\[Omega]y", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "\[Pi]"}], "+", 
       RowBox[{"2", 
        RowBox[{"\[Pi]", "/", "n\[Alpha]"}]}]}], ",", "\[Pi]", ",", 
      RowBox[{"2", 
       RowBox[{"\[Pi]", "/", "n\[Alpha]"}]}]}], "}"}]}], 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Note", " ", "the", " ", "order", " ", "of", " ", 
    RowBox[{"implemtation", ".", " ", "Do"}], " ", "not", " ", "move", " ", 
    "the", " ", "following", " ", "code", " ", "up"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FourierLineKernelApproximation", "[", 
      RowBox[{"\[Sigma]_", ",", "\[Lambda]_"}], "]"}], "[", 
     RowBox[{"\[Omega]x_", ",", 
      RowBox[{"0", "|", "0."}], ",", "\[Alpha]_"}], "]"}], "=", 
    "\[IndentingNewLine]", 
    FractionBox[
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox[
         RowBox[{"2", 
          RowBox[{"(", 
           RowBox[{"\[Lambda]", "-", 
            RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], ")"}]}]]}], " ", 
       RowBox[{
        RowBox[{"Abs", "[", "\[Alpha]", "]"}], "/", "\[Sigma]"}]}], "]"}], 
     RowBox[{"2", "\[Pi]", " ", 
      SqrtBox[
       RowBox[{"2", 
        SuperscriptBox["\[Sigma]", "2"], 
        RowBox[{"(", 
         RowBox[{"\[Lambda]", "-", 
          RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], ")"}]}]]}]]}], 
   ";"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FourierLineKernelApproximation", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
      RowBox[{"0", "|", "0."}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{"\[Omega]x_", ",", 
     RowBox[{"0", "|", "0."}], ",", "\[Alpha]_"}], "]"}], "=", 
   "\[IndentingNewLine]", 
   FractionBox[
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Kappa]", " ", "\[Alpha]"}], "-", 
        RowBox[{
         SqrtBox[
          RowBox[{
           SuperscriptBox["\[Kappa]", "2"], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["\[Sigma]", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"\[Lambda]", "-", 
              RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], ")"}]}]}]], 
         RowBox[{"Abs", "[", "\[Alpha]", "]"}]}]}], ")"}], "/", 
      SuperscriptBox["\[Sigma]", "2"]}], "]"}], 
    RowBox[{"2", "\[Pi]", " ", 
     SqrtBox[
      RowBox[{
       SuperscriptBox["\[Kappa]", "2"], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox["\[Sigma]", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"\[Lambda]", "-", 
          RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], ")"}]}]}]]}]]}], 
  ";"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FourierLineKernelApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_"}], "]"}], "[", 
   RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", "\[Alpha]_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", " ", "=", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", "\[ImaginaryI]", " "}], 
          RowBox[{" ", 
           SuperscriptBox["\[Sigma]", "2"]}]]}], "\[Omega]y"}]}], ",", " ", 
      RowBox[{"c", " ", "=", 
       RowBox[{
        FractionBox["2", 
         SuperscriptBox["\[Sigma]", "2"]], " ", 
        RowBox[{"(", 
         RowBox[{"\[Lambda]", "-", 
          RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], ")"}]}]}]}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     FractionBox["2", 
      RowBox[{
       SuperscriptBox["\[Sigma]", "2"], 
       SuperscriptBox[
        RowBox[{"Abs", "[", "a", "]"}], 
        RowBox[{"1", "/", "3"}]]}]], 
     RowBox[{"\[Piecewise]", GridBox[{
        {
         RowBox[{
          RowBox[{"AiryAi", "[", 
           FractionBox["c", 
            SuperscriptBox["a", 
             RowBox[{"2", "/", "3"}]]], "]"}], " ", 
          RowBox[{"AiryAi", "[", 
           FractionBox[
            RowBox[{"c", "+", 
             RowBox[{"a", " ", "\[Alpha]"}]}], 
            RowBox[{"Conjugate", "[", 
             SuperscriptBox["a", 
              RowBox[{"2", "/", "3"}]], "]"}]], "]"}], " "}], 
         RowBox[{"\[Alpha]", "<", "0"}]},
        {
         RowBox[{
          RowBox[{"AiryAi", "[", 
           FractionBox[
            RowBox[{"c", "+", 
             RowBox[{"a", " ", "\[Alpha]"}]}], 
            SuperscriptBox["a", 
             RowBox[{"2", "/", "3"}]]], "]"}], " ", 
          RowBox[{"AiryAi", "[", 
           FractionBox["c", 
            RowBox[{"Conjugate", "[", 
             SuperscriptBox["a", 
              RowBox[{"2", "/", "3"}]], "]"}]], "]"}], " "}], 
         RowBox[{"\[Alpha]", ">", "0"}]},
        {
         RowBox[{
          RowBox[{"AiryAi", "[", 
           FractionBox["c", 
            SuperscriptBox["a", 
             RowBox[{"2", "/", "3"}]]], "]"}], " ", 
          RowBox[{"AiryAi", "[", 
           FractionBox["c", 
            RowBox[{"Conjugate", "[", 
             SuperscriptBox["a", 
              RowBox[{"2", "/", "3"}]], "]"}]], "]"}], " "}], 
         RowBox[{"\[Alpha]", "\[Equal]", "0"}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FourierLineKernelApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
     RowBox[{"0", "|", "0."}], ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", "\[Alpha]_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", " ", "=", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", "\[ImaginaryI]", " "}], 
          RowBox[{" ", 
           SuperscriptBox["\[Sigma]", "2"]}]]}], "\[Omega]y"}]}], ",", " ", 
      RowBox[{"c", " ", "=", 
       RowBox[{
        FractionBox["2", 
         SuperscriptBox["\[Sigma]", "2"]], " ", 
        RowBox[{"(", 
         RowBox[{"\[Lambda]", "-", 
          RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], ")"}]}]}], ",", 
      RowBox[{"d", " ", "=", " ", 
       FractionBox[
        RowBox[{"\[Kappa]", " "}], 
        SuperscriptBox["\[Sigma]", "2"]]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     FractionBox["2", 
      RowBox[{
       SuperscriptBox["\[Sigma]", "2"], 
       SuperscriptBox[
        RowBox[{"Abs", "[", "a", "]"}], 
        RowBox[{"1", "/", "3"}]]}]], 
     RowBox[{"\[Piecewise]", GridBox[{
        {
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"d", " ", "\[Alpha]"}]], " ", 
          RowBox[{"AiryAi", "[", 
           FractionBox[
            RowBox[{"c", "+", 
             SuperscriptBox["d", "2"]}], 
            SuperscriptBox["a", 
             RowBox[{"2", "/", "3"}]]], "]"}], " ", 
          RowBox[{"AiryAi", "[", 
           FractionBox[
            RowBox[{"c", "+", 
             SuperscriptBox["d", "2"], "+", 
             RowBox[{"a", " ", "\[Alpha]"}]}], 
            RowBox[{"Conjugate", "[", 
             SuperscriptBox["a", 
              RowBox[{"2", "/", "3"}]], "]"}]], "]"}], " "}], 
         RowBox[{"\[Alpha]", "<", "0"}]},
        {
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"d", " ", "\[Alpha]"}]], " ", 
          RowBox[{"AiryAi", "[", 
           FractionBox[
            RowBox[{"c", "+", 
             SuperscriptBox["d", "2"], "+", 
             RowBox[{"a", " ", "\[Alpha]"}]}], 
            SuperscriptBox["a", 
             RowBox[{"2", "/", "3"}]]], "]"}], " ", 
          RowBox[{"AiryAi", "[", 
           FractionBox[
            RowBox[{"c", "+", 
             SuperscriptBox["d", "2"]}], 
            RowBox[{"Conjugate", "[", 
             SuperscriptBox["a", 
              RowBox[{"2", "/", "3"}]], "]"}]], "]"}], " "}], 
         RowBox[{"\[Alpha]", ">", "0"}]},
        {
         RowBox[{
          RowBox[{"AiryAi", "[", 
           FractionBox[
            RowBox[{"c", "+", 
             SuperscriptBox["d", "2"]}], 
            SuperscriptBox["a", 
             RowBox[{"2", "/", "3"}]]], "]"}], " ", 
          RowBox[{"AiryAi", "[", 
           FractionBox[
            RowBox[{"c", "+", 
             SuperscriptBox["d", "2"]}], 
            RowBox[{"Conjugate", "[", 
             SuperscriptBox["a", 
              RowBox[{"2", "/", "3"}]], "]"}]], "]"}], " "}], 
         RowBox[{"\[Alpha]", "\[Equal]", "0"}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FourierLineKernelApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", "\[Alpha]0_", ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{"\[Omega]x_", ",", "\[Omega]y_", ",", "\[Alpha]_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", " ", "=", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", "\[ImaginaryI]", " "}], 
          RowBox[{" ", 
           SuperscriptBox["\[Sigma]", "2"]}]]}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "\[Omega]x"}], " ",
           "+", " ", 
          RowBox[{
           RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "\[Omega]y"}]}], 
         ")"}]}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"c", " ", "=", 
       RowBox[{
        FractionBox["2", 
         SuperscriptBox["\[Sigma]", "2"]], " ", 
        RowBox[{"(", 
         RowBox[{"\[Lambda]", "-", 
          RowBox[{"\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "\[Omega]x"}], " ",
              "+", " ", 
             RowBox[{
              RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "\[Omega]y"}]}], 
            ")"}]}]}], ")"}]}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"d", " ", "=", " ", 
       FractionBox[
        RowBox[{"\[Kappa]", " "}], 
        SuperscriptBox["\[Sigma]", "2"]]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"a", "==", "0"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"2", " ", "\[Pi]", " ", 
         SuperscriptBox["\[Sigma]", "2"], 
         SqrtBox[
          RowBox[{"c", "+", 
           SuperscriptBox["d", "2"]}]]}]], 
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"d", " ", "\[Alpha]"}], "-", 
         RowBox[{
          SqrtBox[
           RowBox[{"c", "+", 
            SuperscriptBox["d", "2"]}]], " ", 
          RowBox[{"Abs", "[", "\[Alpha]", "]"}]}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       FractionBox["2", 
        RowBox[{
         SuperscriptBox["\[Sigma]", "2"], 
         SuperscriptBox[
          RowBox[{"Abs", "[", "a", "]"}], 
          RowBox[{"1", "/", "3"}]]}]], 
       RowBox[{"\[Piecewise]", GridBox[{
          {
           RowBox[{
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"d", " ", "\[Alpha]"}]], " ", 
            RowBox[{"AiryAi", "[", 
             FractionBox[
              RowBox[{"c", "+", 
               SuperscriptBox["d", "2"]}], 
              SuperscriptBox["a", 
               RowBox[{"2", "/", "3"}]]], "]"}], " ", 
            RowBox[{"AiryAi", "[", 
             FractionBox[
              RowBox[{"c", "+", 
               SuperscriptBox["d", "2"], "+", 
               RowBox[{"a", " ", "\[Alpha]"}]}], 
              RowBox[{"Conjugate", "[", 
               SuperscriptBox["a", 
                RowBox[{"2", "/", "3"}]], "]"}]], "]"}], " "}], 
           RowBox[{"\[Alpha]", "<", "0"}]},
          {
           RowBox[{
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"d", " ", "\[Alpha]"}]], " ", 
            RowBox[{"AiryAi", "[", 
             FractionBox[
              RowBox[{"c", "+", 
               SuperscriptBox["d", "2"], "+", 
               RowBox[{"a", " ", "\[Alpha]"}]}], 
              SuperscriptBox["a", 
               RowBox[{"2", "/", "3"}]]], "]"}], " ", 
            RowBox[{"AiryAi", "[", 
             FractionBox[
              RowBox[{"c", "+", 
               SuperscriptBox["d", "2"]}], 
              RowBox[{"Conjugate", "[", 
               SuperscriptBox["a", 
                RowBox[{"2", "/", "3"}]], "]"}]], "]"}], " "}], 
           RowBox[{"\[Alpha]", ">", "0"}]},
          {
           RowBox[{
            RowBox[{"AiryAi", "[", 
             FractionBox[
              RowBox[{"c", "+", 
               SuperscriptBox["d", "2"]}], 
              SuperscriptBox["a", 
               RowBox[{"2", "/", "3"}]]], "]"}], " ", 
            RowBox[{"AiryAi", "[", 
             FractionBox[
              RowBox[{"c", "+", 
               SuperscriptBox["d", "2"]}], 
              RowBox[{"Conjugate", "[", 
               SuperscriptBox["a", 
                RowBox[{"2", "/", "3"}]], "]"}]], "]"}], " "}], 
           RowBox[{"\[Alpha]", "\[Equal]", "0"}]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.84]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}]}]}]}], "\[IndentingNewLine]",
      "]"}]}], "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Line Kernel (\[Alpha]-Marginal)", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Line", " ", "Kernel", " ", "\[Alpha]"}], "-", "Marginal"}], " ", 
  "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Symbolic Implementation", "Subsubsection"],

Cell["\[Alpha]-marginal:", "Text"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"LineKernel", "[", 
      RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", "\[Alpha]0_"}], "]"}], "[",
      "\[Alpha]_", "]"}], "=", 
    FractionBox[
     RowBox[{
      RowBox[{"Cosh", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          SqrtBox[
           RowBox[{"2", "\[Lambda]"}]], " "}], "\[Sigma]"], 
        RowBox[{"(", 
         RowBox[{"\[Pi]", "-", 
          RowBox[{"Abs", "[", 
           RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}]}], ")"}]}], "]"}], 
      " "}], 
     RowBox[{
      SqrtBox[
       RowBox[{"2", "\[Lambda]"}]], "  ", "\[Sigma]", " ", 
      RowBox[{"Sinh", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          SqrtBox[
           RowBox[{"2", "\[Lambda]"}]], " "}], "\[Sigma]"], "\[Pi]"}], 
       "]"}]}]]}], ";"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"LineKernel", "[", 
      RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", "\[Alpha]0_", ",", "0"}], 
      "]"}], "[", "\[Alpha]_", "]"}], "=", 
    FractionBox[
     RowBox[{
      RowBox[{"Cosh", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          SqrtBox[
           RowBox[{"2", "\[Lambda]"}]], " "}], "\[Sigma]"], 
        RowBox[{"(", 
         RowBox[{"\[Pi]", "-", 
          RowBox[{"Abs", "[", 
           RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "]"}]}], ")"}]}], "]"}], 
      " "}], 
     RowBox[{
      SqrtBox[
       RowBox[{"2", "\[Lambda]"}]], "  ", "\[Sigma]", " ", 
      RowBox[{"Sinh", "[", 
       RowBox[{
        FractionBox[
         RowBox[{
          SqrtBox[
           RowBox[{"2", "\[Lambda]"}]], " "}], "\[Sigma]"], "\[Pi]"}], 
       "]"}]}]]}], ";"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernel", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", "\[Alpha]0_", ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", "\[Alpha]_", "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"sa", " ", "=", " ", 
      RowBox[{"2", " ", 
       RowBox[{
        SqrtBox[
         RowBox[{
          SuperscriptBox["\[Kappa]", "2"], "+", 
          RowBox[{"2", " ", "\[Lambda]", " ", 
           SuperscriptBox["\[Sigma]", "2"]}]}]], "/", 
        SuperscriptBox["\[Sigma]", "2"]}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     FractionBox["2", 
      RowBox[{"sa", " ", 
       SuperscriptBox["\[Sigma]", "2"]}]], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}], " ", 
       RowBox[{"\[Kappa]", "/", 
        SuperscriptBox["\[Sigma]", "2"]}]}]], "  ", 
     RowBox[{"\[Piecewise]", GridBox[{
        {
         RowBox[{
          FractionBox[
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             RowBox[{"-", "sa"}], " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}], "/", "2"}]}]], 
           RowBox[{"1", "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "sa"}], " ", "\[Pi]"}], "+", 
              RowBox[{"2", " ", "\[Pi]", " ", 
               RowBox[{"\[Kappa]", "/", 
                SuperscriptBox["\[Sigma]", "2"]}]}]}]]}]], "-", 
          FractionBox[
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"sa", " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}], "/", "2"}]}]], 
           RowBox[{"1", "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{
              RowBox[{"sa", " ", "\[Pi]"}], "+", 
              RowBox[{"2", " ", "\[Pi]", " ", 
               RowBox[{"\[Kappa]", "/", 
                SuperscriptBox["\[Sigma]", "2"]}]}]}]]}]]}], 
         RowBox[{"\[Alpha]", ">", "\[Alpha]0"}]},
        {
         FractionBox[
          RowBox[{"Sinh", "[", 
           RowBox[{"sa", " ", "\[Pi]"}], "]"}], 
          RowBox[{
           RowBox[{"Cosh", "[", 
            RowBox[{"sa", " ", "\[Pi]"}], "]"}], "-", 
           RowBox[{"Cosh", "[", 
            FractionBox[
             RowBox[{"2", " ", "\[Pi]", " ", "\[Kappa]"}], 
             SuperscriptBox["\[Sigma]", "2"]], "]"}]}]], 
         RowBox[{"\[Alpha]", "\[Equal]", "\[Alpha]0"}]},
        {
         RowBox[{
          FractionBox[
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"sa", " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}], "/", "2"}]}]], 
           RowBox[{"1", "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "sa"}], " ", "\[Pi]"}], "-", 
              RowBox[{"2", " ", "\[Pi]", " ", 
               RowBox[{"\[Kappa]", "/", 
                SuperscriptBox["\[Sigma]", "2"]}]}]}]]}]], "-", 
          FractionBox[
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             RowBox[{"-", "sa"}], " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}], "/", "2"}]}]], 
           RowBox[{"1", "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{
              RowBox[{"sa", " ", "\[Pi]"}], "-", 
              RowBox[{"2", " ", "\[Pi]", " ", 
               RowBox[{"\[Kappa]", "/", 
                SuperscriptBox["\[Sigma]", "2"]}]}]}]]}]]}], 
         RowBox[{"\[Alpha]", "<", "\[Alpha]0"}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}]}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "PackageInput"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Line Kernel Mean", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelMean", "[", 
    RowBox[{
    "\[Sigma]_", ",", "\[Lambda]_", ",", "\[Alpha]0_", ",", "\[Kappa]_"}], 
    "]"}], "[", "\[Alpha]_", "]"}], " ", ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", " ", "=", " ", 
       RowBox[{
        RowBox[{"-", "4"}], " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["\[Kappa]", "2"], "+", 
           RowBox[{"2", " ", "\[Lambda]", " ", 
            SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
         SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[Mu]p", ",", 
      "\[Mu]m"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Mu]p", " ", "=", " ", 
      RowBox[{
       FractionBox["\[Kappa]", 
        SuperscriptBox["\[Sigma]", "2"]], "+", 
       FractionBox[
        SqrtBox[
         RowBox[{"-", "a"}]], "2"]}]}], ";", 
     RowBox[{"\[Mu]m", "=", " ", 
      RowBox[{
       FractionBox["\[Kappa]", 
        SuperscriptBox["\[Sigma]", "2"]], "-", 
       FractionBox[
        SqrtBox[
         RowBox[{"-", "a"}]], "2"]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      FractionBox["2", 
       RowBox[{
        RowBox[{
         RowBox[{"LineKernel", "[", 
          RowBox[{
          "\[Sigma]", ",", "\[Lambda]", ",", "\[Alpha]0", ",", "\[Kappa]"}], 
          "]"}], "[", "\[Alpha]", "]"}], 
        RowBox[{"(", 
         RowBox[{"a", "-", "1"}], ")"}], " ", 
        SuperscriptBox["\[Sigma]", "4"], " ", 
        SqrtBox[
         RowBox[{"-", "a"}]]}]], " ", "*", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}], " ", "\[Mu]m"}]], 
         "*", 
         RowBox[{"\[Piecewise]", GridBox[{
            {
             RowBox[{" ", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Coth", "[", 
                   RowBox[{"\[Pi]", " ", "\[Mu]m"}], "]"}], "-", "1", "-", 
                  RowBox[{
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                    SqrtBox[
                    RowBox[{"-", "a"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}]}]], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Coth", "[", 
                    RowBox[{"\[Pi]", " ", "\[Mu]p"}], "]"}], "-", "1"}], 
                    ")"}]}]}], ")"}], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Cos", "[", "\[Alpha]", "]"}], "+", 
                  RowBox[{"Cos", "[", "\[Alpha]0", "]"}]}], ")"}]}], "+", 
               "\[IndentingNewLine]", 
               RowBox[{
                SqrtBox[
                 RowBox[{"-", "a"}]], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Coth", "[", 
                   RowBox[{"\[Pi]", " ", "\[Mu]m"}], "]"}], "-", "1", "+", 
                  RowBox[{
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                    SqrtBox[
                    RowBox[{"-", "a"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}]}]], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Coth", "[", 
                    RowBox[{"\[Pi]", " ", "\[Mu]p"}], "]"}], "-", "1"}], 
                    ")"}]}]}], ")"}], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Sin", "[", "\[Alpha]", "]"}], "-", 
                  RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], ")"}]}]}]}], 
             RowBox[{"\[Alpha]", ">", "\[Alpha]0"}]},
            {
             RowBox[{"  ", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Coth", "[", 
                   RowBox[{"\[Pi]", " ", "\[Mu]m"}], "]"}], "+", "1", "-", 
                  RowBox[{
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                    SqrtBox[
                    RowBox[{"-", "a"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}]}]], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Coth", "[", 
                    RowBox[{"\[Pi]", " ", "\[Mu]p"}], "]"}], "+", "1"}], 
                    ")"}]}]}], ")"}], 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Cos", "[", "\[Alpha]", "]"}], "+", 
                  RowBox[{"Cos", "[", "\[Alpha]0", "]"}]}], ")"}]}], "+", 
               "\[IndentingNewLine]", 
               RowBox[{
                SqrtBox[
                 RowBox[{"-", "a"}]], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Coth", "[", 
                   RowBox[{"\[Pi]", " ", "\[Mu]m"}], "]"}], "+", "1", "+", 
                  RowBox[{
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                    SqrtBox[
                    RowBox[{"-", "a"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}]}]], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Coth", "[", 
                    RowBox[{"\[Pi]", " ", "\[Mu]p"}], "]"}], "+", "1"}], 
                    ")"}]}]}], ")"}], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Sin", "[", "\[Alpha]", "]"}], "-", 
                  RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], ")"}]}]}]}], 
             RowBox[{"\[Alpha]", "<", "\[Alpha]0"}]},
            {
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"4", "  ", 
                 RowBox[{"Sinh", "[", 
                  RowBox[{
                   SqrtBox[
                    RowBox[{"-", "a"}]], " ", "\[Pi]"}], "]"}]}], 
                RowBox[{
                 RowBox[{"Cosh", "[", 
                  RowBox[{
                   SqrtBox[
                    RowBox[{"-", "a"}]], " ", "\[Pi]"}], "]"}], "-", 
                 RowBox[{"Cosh", "[", 
                  FractionBox[
                   RowBox[{"2", " ", "\[Pi]", " ", "\[Kappa]"}], 
                   SuperscriptBox["\[Sigma]", "2"]], "]"}]}]]}], 
              RowBox[{"Cos", "[", "\[Alpha]0", "]"}]}], 
             RowBox[{"\[Alpha]", "\[Equal]", "\[Alpha]0"}]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.84]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}]}]}], ",", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}], " ", "\[Mu]p"}]], 
         "*", 
         RowBox[{"\[Piecewise]", GridBox[{
            {
             RowBox[{" ", 
              RowBox[{
               RowBox[{
                SqrtBox[
                 RowBox[{"-", "a"}]], "  ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                    SqrtBox[
                    RowBox[{"-", "a"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "\[Alpha]"}], "+", "\[Alpha]0"}], ")"}]}]], 
                   " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Coth", "[", 
                    RowBox[{"\[Pi]", " ", "\[Mu]m"}], "]"}]}], ")"}]}], "-", 
                  RowBox[{"Coth", "[", 
                   RowBox[{"\[Pi]", " ", "\[Mu]p"}], "]"}], "+", "1"}], ")"}], 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Cos", "[", "\[Alpha]", "]"}], "-", 
                  RowBox[{"Cos", "[", "\[Alpha]0", "]"}]}], ")"}]}], "-", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                    SqrtBox[
                    RowBox[{"-", "a"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "\[Alpha]"}], "+", "\[Alpha]0"}], ")"}]}]], 
                   " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Coth", "[", 
                    RowBox[{"\[Pi]", " ", "\[Mu]m"}], "]"}]}], ")"}]}], "+", 
                  RowBox[{"Coth", "[", 
                   RowBox[{"\[Pi]", " ", "\[Mu]p"}], "]"}], "-", "1"}], ")"}],
                 " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Sin", "[", "\[Alpha]", "]"}], "+", 
                  RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], ")"}]}]}]}], 
             RowBox[{"\[Alpha]", ">", "\[Alpha]0"}]},
            {
             RowBox[{" ", 
              RowBox[{
               RowBox[{
                SqrtBox[
                 RowBox[{"-", "a"}]], "  ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                    SqrtBox[
                    RowBox[{"-", "a"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "\[Alpha]"}], "+", "\[Alpha]0"}], ")"}]}]]}],
                    " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "+", 
                    RowBox[{"Coth", "[", 
                    RowBox[{"\[Pi]", " ", "\[Mu]m"}], "]"}]}], ")"}]}], "-", 
                  RowBox[{"Coth", "[", 
                   RowBox[{"\[Pi]", " ", "\[Mu]p"}], "]"}], "-", "1"}], ")"}], 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Cos", "[", "\[Alpha]", "]"}], "-", 
                  RowBox[{"Cos", "[", "\[Alpha]0", "]"}]}], ")"}]}], "-", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["\[ExponentialE]", 
                    RowBox[{
                    SqrtBox[
                    RowBox[{"-", "a"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "\[Alpha]"}], "+", "\[Alpha]0"}], ")"}]}]]}],
                    " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "+", 
                    RowBox[{"Coth", "[", " ", 
                    RowBox[{"\[Pi]", " ", "\[Mu]m"}], "]"}]}], ")"}]}], "+", 
                  RowBox[{"Coth", "[", 
                   RowBox[{"\[Pi]", " ", "\[Mu]p"}], "]"}], "+", "1"}], ")"}],
                 " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Sin", "[", "\[Alpha]", "]"}], "+", 
                  RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], ")"}]}]}]}], 
             RowBox[{"\[Alpha]", "<", "\[Alpha]0"}]},
            {
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"4", "  ", 
                 RowBox[{"Sinh", "[", 
                  RowBox[{
                   SqrtBox[
                    RowBox[{"-", "a"}]], " ", "\[Pi]"}], "]"}]}], 
                RowBox[{
                 RowBox[{"Cosh", "[", 
                  RowBox[{
                   SqrtBox[
                    RowBox[{"-", "a"}]], " ", "\[Pi]"}], "]"}], "-", 
                 RowBox[{"Cosh", "[", 
                  FractionBox[
                   RowBox[{"2", " ", "\[Pi]", " ", "\[Kappa]"}], 
                   SuperscriptBox["\[Sigma]", "2"]], "]"}]}]]}], 
              RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], 
             RowBox[{"\[Alpha]", "\[Equal]", "\[Alpha]0"}]}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.84]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}]}]}]}], "}"}]}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LineKernelMeanAngle", "[", 
     RowBox[{
     "\[Sigma]_", ",", "\[Lambda]_", ",", "\[Alpha]0_", ",", "\[Kappa]_"}], 
     "]"}], "[", "\[Alpha]_", "]"}], " ", "=", 
   FractionBox[
    RowBox[{"\[Alpha]", "+", "\[Alpha]0"}], "2"]}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelMeanRadius", "[", 
    RowBox[{
    "\[Sigma]_", ",", "\[Lambda]_", ",", "\[Alpha]0_", ",", "\[Kappa]_"}], 
    "]"}], "[", "\[Alpha]_", "]"}], " ", ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", " ", "=", " ", 
       RowBox[{
        RowBox[{"-", "4"}], " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["\[Kappa]", "2"], "+", 
           RowBox[{"2", " ", "\[Lambda]", " ", 
            SuperscriptBox["\[Sigma]", "2"]}]}], ")"}], "/", 
         SuperscriptBox["\[Sigma]", "4"]}]}]}], ",", "\[Mu]p", ",", 
      "\[Mu]m"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Mu]p", " ", "=", " ", 
      RowBox[{
       FractionBox["\[Kappa]", 
        SuperscriptBox["\[Sigma]", "2"]], "+", 
       FractionBox[
        SqrtBox[
         RowBox[{"-", "a"}]], "2"]}]}], ";", 
     RowBox[{"\[Mu]m", "=", " ", 
      RowBox[{
       FractionBox["\[Kappa]", 
        SuperscriptBox["\[Sigma]", "2"]], "-", 
       FractionBox[
        SqrtBox[
         RowBox[{"-", "a"}]], "2"]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{"1", " "}], 
        RowBox[{
         RowBox[{"LineKernel", "[", 
          RowBox[{
          "\[Sigma]", ",", "\[Lambda]", ",", "\[Alpha]0", ",", "\[Kappa]"}], 
          "]"}], "[", "\[Alpha]", "]"}]], " ", "*", 
       FractionBox[
        RowBox[{"8", " ", 
         SuperscriptBox["\[ExponentialE]", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}], " ", "\[Kappa]"}], 
           SuperscriptBox["\[Sigma]", "2"]]]}], 
        RowBox[{
         SqrtBox[
          RowBox[{"-", "a"}]], " ", 
         SuperscriptBox["\[Sigma]", "4"], 
         RowBox[{"(", 
          RowBox[{"a", "-", "1"}], ")"}]}]], "  ", "*", 
       RowBox[{"\[Piecewise]", GridBox[{
          {
           RowBox[{" ", 
            RowBox[{
             RowBox[{
              FractionBox[
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{
                 FractionBox["1", "2"], " ", 
                 SqrtBox[
                  RowBox[{"-", "a"}]], " ", 
                 RowBox[{"(", 
                  RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}]}]], 
               RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                 RowBox[{"2", "\[Pi]", " ", "\[Mu]p"}]], "-", "1"}]], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 RowBox[{"Cos", "[", 
                  FractionBox[
                   RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "2"], "]"}]}], "+", 
                RowBox[{
                 SqrtBox[
                  RowBox[{"-", "a"}]], " ", 
                 RowBox[{"Sin", "[", 
                  FractionBox[
                   RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "2"], "]"}]}]}], 
               ")"}]}], "+", 
             RowBox[{
              FractionBox[
               RowBox[{" ", 
                SuperscriptBox["\[ExponentialE]", 
                 RowBox[{
                  RowBox[{"-", 
                   FractionBox["1", "2"]}], " ", 
                  SqrtBox[
                   RowBox[{"-", "a"}]], " ", 
                  RowBox[{"(", 
                   RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}]}]]}], 
               RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                 RowBox[{"2", "\[Pi]", " ", "\[Mu]m"}]], "-", "1"}]], 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Cos", "[", 
                 FractionBox[
                  RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "2"], "]"}], "+", 
                RowBox[{
                 SqrtBox[
                  RowBox[{"-", "a"}]], " ", 
                 RowBox[{"Sin", "[", 
                  FractionBox[
                   RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "2"], "]"}]}]}], 
               ")"}]}]}]}], 
           RowBox[{"\[Alpha]", ">", "\[Alpha]0"}]},
          {
           RowBox[{"  ", 
            RowBox[{
             RowBox[{
              FractionBox[
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{
                 FractionBox["1", "2"], " ", 
                 SqrtBox[
                  RowBox[{"-", "a"}]], " ", 
                 RowBox[{"(", 
                  RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}]}]], 
               RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                 RowBox[{
                  RowBox[{"-", "2"}], "\[Pi]", " ", "\[Mu]p"}]], "-", "1"}]], 
              " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Cos", "[", 
                 FractionBox[
                  RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "2"], "]"}], "-", 
                RowBox[{
                 SqrtBox[
                  RowBox[{"-", "a"}]], " ", 
                 RowBox[{"Sin", "[", 
                  FractionBox[
                   RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "2"], "]"}]}]}], 
               ")"}]}], "-", 
             RowBox[{
              FractionBox[
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["1", "2"]}], " ", 
                 SqrtBox[
                  RowBox[{"-", "a"}]], " ", 
                 RowBox[{"(", 
                  RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], ")"}]}]], 
               RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                 RowBox[{
                  RowBox[{"-", "2"}], "\[Pi]", " ", "\[Mu]m"}]], "-", "1"}]], 
              
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Cos", "[", 
                 FractionBox[
                  RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "2"], "]"}], "+", 
                RowBox[{
                 SqrtBox[
                  RowBox[{"-", "a"}]], " ", 
                 RowBox[{"Sin", "[", 
                  FractionBox[
                   RowBox[{"\[Alpha]", "-", "\[Alpha]0"}], "2"], "]"}]}]}], 
               ")"}]}]}]}], 
           RowBox[{"\[Alpha]", "<", "\[Alpha]0"}]},
          {
           RowBox[{
            FractionBox["1", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Coth", "[", 
               RowBox[{"\[Pi]", " ", "\[Mu]m"}], "]"}], "-", 
              RowBox[{"Coth", "[", 
               RowBox[{"\[Pi]", " ", "\[Mu]p"}], "]"}]}], ")"}]}], 
           TagBox[
            RowBox[{"\[Alpha]", "\[Equal]", "\[Alpha]0"}],
            "PiecewiseDefault",
            AutoDelete->False,
            DeletionWarning->True]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.84]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}]}]}], "//", "Chop"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Line Kernel Approximation", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Line", " ", "Kernel", " ", "Approximation"}], " ", 
  "*)"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Numeric Implementation", "Subsubsection"],

Cell["function", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Numeric", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"NLineKernelApproximation", "=", 
    RowBox[{"Compile", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Sigma]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Lambda]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Alpha]0", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Kappa]", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"y", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Alpha]", ",", "_Real"}], "}"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Module", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"xr", " ", "=", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "x"}], " ", "+", 
            " ", 
            RowBox[{
             RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"yr", " ", "=", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"-", 
              RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "x"}], " ", "+", 
            " ", 
            RowBox[{
             RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}]}], "}"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"Piecewise", "[", 
         RowBox[{
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Chop", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    FractionBox[
                    SqrtBox["3"], 
                    RowBox[{"\[Pi]", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"xr", " ", "\[Sigma]"}], ")"}], "2"]}]], 
                    RowBox[{"Exp", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "xr"}], " ", "\[Lambda]"}], "-", 
                    FractionBox[
                    RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"3", " ", 
                    SuperscriptBox["#1", "2"]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"#2", "-", 
                    RowBox[{"3", " ", "#1"}]}], ")"}], " ", "#2"}]}], ")"}]}], 
                    RowBox[{
                    SuperscriptBox["xr", "3"], " ", 
                    SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], ")"}], 
                  "&"}], "[", 
                 RowBox[{
                  RowBox[{"yr", "-", 
                   RowBox[{
                    FractionBox["\[Kappa]", "2"], " ", 
                    SuperscriptBox["xr", "2"]}]}], ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"\[Alpha]", "-", 
                    RowBox[{"\[Kappa]", " ", "xr"}]}], ")"}], "xr"}]}], "]"}],
                 ",", "$MachineEpsilon"}], "]"}], ",", 
              RowBox[{"xr", ">", "0"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"xr", "<", "0"}]}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"$MaxMachineNumber", ",", 
              RowBox[{
               RowBox[{"yr", "\[Equal]", "0"}], "\[And]", 
               RowBox[{"\[Alpha]", "\[Equal]", "0"}]}]}], "}"}]}], "}"}], ",",
           "\[IndentingNewLine]", "0"}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"NLineKernelApproximationList", "=", 
  RowBox[{"Compile", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Sigma]", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Lambda]", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Alpha]0", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Kappa]", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"min\[Alpha]", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"max\[Alpha]", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"d\[Alpha]", ",", "_Real"}], "}"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"xr", " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "x"}], " ", "+", " ", 
          
          RowBox[{
           RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"yr", " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "x"}], " ", "+", 
          " ", 
          RowBox[{
           RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}]}], "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"Piecewise", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Chop", "[", 
             RowBox[{
              RowBox[{
               FractionBox[
                SqrtBox["3"], 
                RowBox[{"\[Pi]", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{"xr", " ", "\[Sigma]"}], ")"}], "2"]}]], 
               RowBox[{"Exp", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "xr"}], " ", "\[Lambda]"}], "-", 
                 RowBox[{
                  FractionBox["2", 
                   RowBox[{
                    SuperscriptBox["xr", "3"], " ", 
                    SuperscriptBox["\[Sigma]", "2"]}]], 
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"3", " ", 
                    SuperscriptBox["#1", "2"]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"xr", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Alpha]", "-", 
                    RowBox[{"\[Kappa]", " ", "xr"}]}], ")"}]}], "-", 
                    RowBox[{"3", " ", "#1"}]}], ")"}], " ", "xr", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Alpha]", "-", 
                    RowBox[{"\[Kappa]", " ", "xr"}]}], ")"}]}]}], ")"}], 
                    "&"}], "[", 
                    RowBox[{"yr", "-", 
                    RowBox[{
                    FractionBox["\[Kappa]", "2"], " ", 
                    SuperscriptBox["xr", "2"]}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    "\[Alpha]", ",", "min\[Alpha]", ",", "max\[Alpha]", ",", 
                    "d\[Alpha]"}], "}"}]}], "]"}]}]}], "]"}]}], ",", 
              "$MachineEpsilon"}], "]"}], ",", 
            RowBox[{"xr", ">", "0"}]}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{
               "\[Alpha]", ",", "min\[Alpha]", ",", "max\[Alpha]", ",", 
                "d\[Alpha]"}], "}"}]}], "]"}], ",", 
            RowBox[{"xr", "<", "0"}]}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"\[Alpha]", "===", "0"}], ",", "$MaxMachineNumber", 
                ",", "0"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
               "\[Alpha]", ",", "min\[Alpha]", ",", "max\[Alpha]", ",", 
                "d\[Alpha]"}], "}"}]}], "]"}], ",", 
            RowBox[{"yr", "\[Equal]", "0"}]}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{
           "\[Alpha]", ",", "min\[Alpha]", ",", "max\[Alpha]", ",", 
            "d\[Alpha]"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"NLineKernelApproximationMarginal", "=", 
  RowBox[{"Compile", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Sigma]", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Lambda]", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Alpha]0", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Kappa]", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", "_Real"}], "}"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"xr", " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "x"}], " ", "+", " ", 
          
          RowBox[{
           RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"yr", " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "x"}], " ", "+", 
          " ", 
          RowBox[{
           RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}]}], "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"Piecewise", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Chop", "[", 
             RowBox[{
              RowBox[{
               FractionBox["1", "\[Sigma]"], 
               SqrtBox[
                FractionBox["3", 
                 RowBox[{"2", " ", "\[Pi]", " ", 
                  SuperscriptBox["xr", "3"]}]]], 
               RowBox[{"Exp", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "xr"}], " ", "\[Lambda]"}], "-", 
                 FractionBox[
                  RowBox[{"3", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "2"}], " ", "yr"}], "+", 
                    RowBox[{
                    SuperscriptBox["xr", "2"], " ", "\[Kappa]"}]}], ")"}], 
                    "2"]}], 
                  RowBox[{"8", " ", 
                   SuperscriptBox["xr", "3"], " ", 
                   SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], ",", 
              "$MachineEpsilon"}], "]"}], ",", 
            RowBox[{"xr", ">", "0"}]}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"xr", "<", "0"}]}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"$MaxMachineNumber", ",", 
            RowBox[{"yr", "\[Equal]", "0"}]}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", "0"}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell["density", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NLineKernelDensityApproximation", "=", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Sigma]", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Lambda]", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Alpha]0", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Kappa]", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"dx", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"dy", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Alpha]", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"d\[Alpha]", ",", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"xr", " ", "=", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "x"}], " ", "+", " ", 
           RowBox[{
            RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"yr", " ", "=", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"-", 
             RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "x"}], " ", "+", 
           " ", 
           RowBox[{
            RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"dyr", " ", "=", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"-", 
             RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "dx"}], " ", "+", 
           " ", 
           RowBox[{
            RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "dy"}]}]}]}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"Piecewise", "[", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Chop", "[", 
              RowBox[{
               RowBox[{
                FractionBox[
                 RowBox[{"Exp", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "xr"}], " ", "\[Lambda]"}], "-", 
                   FractionBox[
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"\[Alpha]", "-", 
                    RowBox[{"xr", " ", "\[Kappa]"}]}], ")"}], "2"], 
                    RowBox[{"2", " ", "xr", " ", 
                    SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}], 
                 RowBox[{"2", " ", "dyr", " ", 
                  SqrtBox[
                   RowBox[{"2", " ", "\[Pi]", " ", "xr"}]], " ", 
                  "\[Sigma]"}]], 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Erf", "[", 
                   RowBox[{
                    SqrtBox[
                    FractionBox["3", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["xr", "3"]}]]], 
                    FractionBox[
                    RowBox[{"dyr", "+", 
                    RowBox[{"2", " ", "yr"}], "-", 
                    RowBox[{"xr", " ", "\[Alpha]"}]}], "\[Sigma]"]}], "]"}], 
                  "+", 
                  RowBox[{"Erf", "[", 
                   RowBox[{
                    SqrtBox[
                    FractionBox["3", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["xr", "3"]}]]], 
                    FractionBox[
                    RowBox[{"dyr", "-", 
                    RowBox[{"2", " ", "yr"}], "+", 
                    RowBox[{"xr", " ", "\[Alpha]"}]}], "\[Sigma]"]}], "]"}]}],
                  ")"}]}], ",", "$MachineEpsilon"}], "]"}], ",", 
             RowBox[{"xr", ">", "0"}]}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{"xr", "<", "0"}]}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             FractionBox[
              RowBox[{"1", "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{
                 RowBox[{"-", "\[Lambda]"}], " ", 
                 RowBox[{
                  RowBox[{"Abs", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "dx"}], " ", 
                    "+", " ", 
                    RowBox[{
                    RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "dy"}]}], 
                   "]"}], "/", "2"}]}]]}], 
              RowBox[{"\[Lambda]", " ", 
               RowBox[{"Abs", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "dx"}], " ", 
                 "+", " ", 
                 RowBox[{
                  RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "dy"}]}], 
                "]"}]}]], ",", 
             RowBox[{
              RowBox[{"yr", "\[Equal]", "0"}], "\[And]", 
              RowBox[{"\[Alpha]", "\[Equal]", "0"}]}]}], "}"}]}], "}"}], ",", 
         "\[IndentingNewLine]", "0"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"NLineKernelDensityApproximationList", "=", 
  RowBox[{"Compile", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Sigma]", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Lambda]", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Alpha]0", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Kappa]", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"dx", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"dy", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"min\[Alpha]", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"max\[Alpha]", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"d\[Alpha]", ",", "_Real"}], "}"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"xr", " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "x"}], " ", "+", " ", 
          
          RowBox[{
           RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"yr", " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "x"}], " ", "+", 
          " ", 
          RowBox[{
           RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"dyr", " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "dx"}], " ", "+", 
          " ", 
          RowBox[{
           RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "dy"}]}]}]}], "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"Piecewise", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Chop", "[", 
             RowBox[{
              RowBox[{
               FractionBox[
                RowBox[{"Exp", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "xr"}], " ", "\[Lambda]"}], "-", 
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"\[Alpha]", "-", 
                    RowBox[{"xr", " ", "\[Kappa]"}]}], ")"}], "2"], 
                   RowBox[{"2", " ", "xr", " ", 
                    SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}], 
                RowBox[{"2", " ", "dyr", " ", 
                 SqrtBox[
                  RowBox[{"2", " ", "\[Pi]", " ", "xr"}]], " ", "\[Sigma]"}]], 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Erf", "[", 
                   RowBox[{
                    SqrtBox[
                    FractionBox["3", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["xr", "3"]}]]], 
                    FractionBox[
                    RowBox[{"dyr", "+", 
                    RowBox[{"2", " ", "yr"}], "-", 
                    RowBox[{"xr", " ", "\[Alpha]"}]}], "\[Sigma]"]}], "]"}], 
                  "+", 
                  RowBox[{"Erf", "[", 
                   RowBox[{
                    SqrtBox[
                    FractionBox["3", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["xr", "3"]}]]], 
                    FractionBox[
                    RowBox[{"dyr", "-", 
                    RowBox[{"2", " ", "yr"}], "+", 
                    RowBox[{"xr", " ", "\[Alpha]"}]}], "\[Sigma]"]}], "]"}]}],
                  ",", 
                 RowBox[{"{", 
                  RowBox[{
                  "\[Alpha]", ",", "min\[Alpha]", ",", "max\[Alpha]", ",", 
                   "d\[Alpha]"}], "}"}]}], "]"}]}], ",", "$MachineEpsilon"}], 
             "]"}], ",", 
            RowBox[{"xr", ">", "0"}]}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{
               "\[Alpha]", ",", "min\[Alpha]", ",", "max\[Alpha]", ",", 
                "d\[Alpha]"}], "}"}]}], "]"}], ",", 
            RowBox[{"xr", "<", "0"}]}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"\[Alpha]", "===", "0"}], ",", 
                FractionBox[
                 RowBox[{"1", "-", 
                  SuperscriptBox["\[ExponentialE]", 
                   RowBox[{
                    RowBox[{"-", "\[Lambda]"}], " ", 
                    RowBox[{
                    RowBox[{"Abs", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "dx"}], " ", 
                    "+", " ", 
                    RowBox[{
                    RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "dy"}]}], 
                    "]"}], "/", "2"}]}]]}], 
                 RowBox[{"\[Lambda]", " ", 
                  RowBox[{"Abs", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "dx"}], " ", 
                    "+", " ", 
                    RowBox[{
                    RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "dy"}]}], 
                   "]"}]}]], ",", "0"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
               "\[Alpha]", ",", "min\[Alpha]", ",", "max\[Alpha]", ",", 
                "d\[Alpha]"}], "}"}]}], "]"}], ",", 
            RowBox[{"yr", "\[Equal]", "0"}]}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{
           "\[Alpha]", ",", "min\[Alpha]", ",", "max\[Alpha]", ",", 
            "d\[Alpha]"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"NLineKernelDensityApproximationMarginal", "=", 
  RowBox[{"Compile", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Sigma]", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Lambda]", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Alpha]0", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Kappa]", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"dx", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", "_Real"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"dy", ",", "_Real"}], "}"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"xr", " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "x"}], " ", "+", " ", 
          
          RowBox[{
           RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"yr", " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "x"}], " ", "+", 
          " ", 
          RowBox[{
           RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"dyr", " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "dx"}], " ", "+", 
          " ", 
          RowBox[{
           RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "dy"}]}]}]}], "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"Piecewise", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Chop", "[", 
             RowBox[{
              RowBox[{
               FractionBox[
                RowBox[{"Exp", "[", 
                 RowBox[{
                  RowBox[{"-", "xr"}], " ", "\[Lambda]"}], "]"}], 
                RowBox[{"2", " ", "dyr"}]], 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Erf", "[", 
                  RowBox[{
                   SqrtBox[
                    FractionBox["3", 
                    RowBox[{"8", 
                    SuperscriptBox["xr", "3"]}]]], 
                   FractionBox[
                    RowBox[{"dyr", "+", 
                    RowBox[{"2", " ", "yr"}], "-", 
                    RowBox[{
                    SuperscriptBox["xr", "2"], " ", "\[Kappa]"}]}], 
                    "\[Sigma]"]}], "]"}], "+", 
                 RowBox[{"Erf", "[", 
                  RowBox[{
                   SqrtBox[
                    FractionBox["3", 
                    RowBox[{"8", 
                    SuperscriptBox["xr", "3"]}]]], 
                   FractionBox[
                    RowBox[{"dyr", "-", 
                    RowBox[{"2", " ", "yr"}], "+", 
                    RowBox[{
                    SuperscriptBox["xr", "2"], " ", "\[Kappa]"}]}], 
                    "\[Sigma]"]}], "]"}]}], ")"}]}], ",", "$MachineEpsilon"}],
              "]"}], ",", 
            RowBox[{"xr", ">", "0"}]}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"xr", "<", "0"}]}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            FractionBox[
             RowBox[{"1", "-", 
              SuperscriptBox["\[ExponentialE]", 
               RowBox[{
                RowBox[{"-", "\[Lambda]"}], " ", 
                RowBox[{
                 RowBox[{"Abs", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "dx"}], " ", 
                   "+", " ", 
                   RowBox[{
                    RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "dy"}]}], 
                  "]"}], "/", "2"}]}]]}], 
             RowBox[{"\[Lambda]", " ", 
              RowBox[{"Abs", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "dx"}], " ", 
                "+", " ", 
                RowBox[{
                 RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "dy"}]}], 
               "]"}]}]], ",", 
            RowBox[{"yr", "\[Equal]", "0"}]}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", "0"}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Symbolic Implementation", "Subsubsection"],

Cell["Function:", "Text"],

Cell["Orientation column", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Symbolic", " ", "Implementation"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"LineKernelApproximation", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{"x_", ",", "y_", ",", 
     RowBox[{"{", 
      RowBox[{"min\[Alpha]_", ",", "max\[Alpha]_", ",", "d\[Alpha]_"}], 
      "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NLineKernelApproximationList", "[", 
    RowBox[{
    "\[Sigma]", ",", "\[Lambda]", ",", "\[Alpha]0", ",", "\[Kappa]", ",", "x",
      ",", "y", ",", "min\[Alpha]", ",", "max\[Alpha]", ",", "d\[Alpha]"}], 
    "]"}]}]}]], "PackageInput",
 InitializationCell->True],

Cell["\<\
The kernel for \[Alpha] = -\[Pi] and +\[Pi] are added together to maintain \
the symmetry.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
     RowBox[{"\[Alpha]0_:", "0"}], ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{"x_", ",", "y_", ",", 
    RowBox[{"{", "n\[Alpha]_", "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"kernel", "=", 
      RowBox[{"NLineKernelApproximationList", "[", 
       RowBox[{
       "\[Sigma]", ",", "\[Lambda]", ",", "\[Alpha]0", ",", "\[Kappa]", ",", 
        "x", ",", "y", ",", 
        RowBox[{"-", "\[Pi]"}], ",", "\[Pi]", ",", 
        RowBox[{"2", 
         RowBox[{"\[Pi]", "/", "n\[Alpha]"}]}]}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"MapAt", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"#", "+", 
         RowBox[{"First", "[", "kernel", "]"}]}], ")"}], "&"}], ",", 
      RowBox[{"Rest", "[", "kernel", "]"}], ",", 
      RowBox[{"-", "1"}]}], "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell["Symbolic expressions", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Note", " ", "the", " ", "order", " ", "of", " ", 
    RowBox[{"implementation", ".", " ", "Do"}], " ", "not", " ", "move", " ", 
    "the", " ", "following", " ", "code", " ", 
    RowBox[{"up", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"LineKernelApproximation", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{
     RowBox[{"0", "|", "0."}], ",", "y_", ",", "\[Alpha]_"}], "]"}], "=", 
   RowBox[{"DiracDelta", "[", "y", "]"}], " "}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_"}], "]"}], "[", 
   RowBox[{"x_", ",", "y_", ",", "\[Alpha]_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"UnitStep", "[", "x", "]"}], " ", 
   RowBox[{"Chop", "[", 
    RowBox[{
     RowBox[{
      FractionBox[
       SqrtBox["3"], 
       RowBox[{"\[Pi]", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"x", " ", "\[Sigma]"}], ")"}], "2"]}]], 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "x"}], " ", "\[Lambda]"}], "-", 
        FractionBox[
         RowBox[{"2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"3", " ", 
             SuperscriptBox["y", "2"]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"x", " ", "\[Alpha]"}], "-", 
               RowBox[{"3", " ", "y"}]}], ")"}], " ", "x", " ", 
             "\[Alpha]"}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["x", "3"], " ", 
          SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], ",", 
     "$MachineEpsilon"}], "]"}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
     RowBox[{"0", "|", "0."}], ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{"x_", ",", "y_", ",", "\[Alpha]_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"UnitStep", "[", "x", "]"}], " ", 
     RowBox[{"Chop", "[", 
      RowBox[{
       RowBox[{
        FractionBox[
         SqrtBox["3"], 
         RowBox[{"\[Pi]", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"x", " ", "\[Sigma]"}], ")"}], "2"]}]], 
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "x"}], " ", "\[Lambda]"}], "-", 
          FractionBox[
           RowBox[{"2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"3", " ", 
               SuperscriptBox["#1", "2"]}], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"#2", "-", 
                 RowBox[{"3", " ", "#1"}]}], ")"}], " ", "#2"}]}], ")"}]}], 
           RowBox[{
            SuperscriptBox["x", "3"], " ", 
            SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], ",", 
       "$MachineEpsilon"}], "]"}]}], "&"}], "[", 
   RowBox[{
    RowBox[{"y", "-", 
     RowBox[{
      FractionBox["\[Kappa]", "2"], " ", 
      SuperscriptBox["x", "2"]}]}], ",", 
    RowBox[{"x", 
     RowBox[{"(", 
      RowBox[{"\[Alpha]", "-", 
       RowBox[{"\[Kappa]", " ", "x"}]}], ")"}]}]}], "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", "\[Alpha]0_", ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{"x_", ",", "y_", ",", "\[Alpha]_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"xr", " ", "=", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "x"}], " ", "+", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"yr", " ", "=", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "x"}], " ", "+", " ", 
        RowBox[{
         RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}]}], "}"}], ",",
     "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"UnitStep", "[", "xr", "]"}], " ", 
       RowBox[{"Chop", "[", 
        RowBox[{
         RowBox[{
          FractionBox[
           SqrtBox["3"], 
           RowBox[{"\[Pi]", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"xr", " ", "\[Sigma]"}], ")"}], "2"]}]], 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "xr"}], " ", "\[Lambda]"}], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"3", " ", 
                 SuperscriptBox["#1", "2"]}], "+", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"#2", "-", 
                   RowBox[{"3", " ", "#1"}]}], ")"}], " ", "#2"}]}], ")"}]}], 
             
             RowBox[{
              SuperscriptBox["xr", "3"], " ", 
              SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], ",", 
         "$MachineEpsilon"}], "]"}]}], "&"}], "[", 
     RowBox[{
      RowBox[{"yr", "-", 
       RowBox[{
        FractionBox["\[Kappa]", "2"], " ", 
        SuperscriptBox["xr", "2"]}]}], ",", 
      RowBox[{"xr", 
       RowBox[{"(", 
        RowBox[{"\[Alpha]", "-", 
         RowBox[{"\[Kappa]", " ", "xr"}]}], ")"}]}]}], "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell["xy-marginal", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
     RowBox[{"\[Alpha]0_:", "0"}], ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"0", "|", "0."}], ",", "y_"}], "]"}], "=", 
  RowBox[{"DiracDelta", "[", "y", "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_"}], "]"}], "[", 
   RowBox[{"x_", ",", "y_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"UnitStep", "[", "x", "]"}], " ", 
   FractionBox["1", "\[Sigma]"], 
   SqrtBox[
    FractionBox["3", 
     RowBox[{"2", " ", "\[Pi]", " ", 
      SuperscriptBox["x", "3"]}]]], 
   RowBox[{"Chop", "[", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "x"}], " ", "\[Lambda]"}], "-", 
       FractionBox[
        RowBox[{"3", " ", 
         SuperscriptBox["y", "2"]}], 
        RowBox[{"2", " ", 
         SuperscriptBox["x", "3"], " ", 
         SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}], ",", 
     "$MachineEpsilon"}], "]"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
     RowBox[{"0", "|", "0."}], ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{"x_", ",", "y_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"UnitStep", "[", "x", "]"}], " ", 
   FractionBox["1", "\[Sigma]"], 
   SqrtBox[
    FractionBox["3", 
     RowBox[{"2", " ", "\[Pi]", " ", 
      SuperscriptBox["x", "3"]}]]], 
   RowBox[{"Chop", "[", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "x"}], " ", "\[Lambda]"}], "-", 
       FractionBox[
        RowBox[{"3", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "2"}], " ", "y"}], "+", 
            RowBox[{
             SuperscriptBox["x", "2"], " ", "\[Kappa]"}]}], ")"}], "2"]}], 
        RowBox[{"8", " ", 
         SuperscriptBox["x", "3"], " ", 
         SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}], ",", 
     "$MachineEpsilon"}], "]"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", "\[Alpha]0_", ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{"x_", ",", "y_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"xr", " ", "=", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "x"}], " ", "+", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"yr", " ", "=", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "x"}], " ", "+", " ", 
        RowBox[{
         RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}]}], "}"}], ",",
     "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"UnitStep", "[", "xr", "]"}], "  ", 
     RowBox[{"Chop", "[", 
      RowBox[{
       RowBox[{
        FractionBox["1", "\[Sigma]"], 
        SqrtBox[
         FractionBox["3", 
          RowBox[{"2", " ", "\[Pi]", " ", 
           SuperscriptBox["xr", "3"]}]]], 
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "xr"}], " ", "\[Lambda]"}], "-", 
          FractionBox[
           RowBox[{"3", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "2"}], " ", "yr"}], "+", 
               RowBox[{
                SuperscriptBox["xr", "2"], " ", "\[Kappa]"}]}], ")"}], "2"]}], 
           RowBox[{"8", " ", 
            SuperscriptBox["xr", "3"], " ", 
            SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}]}], ",", 
       "$MachineEpsilon"}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "PackageInput"],

Cell["Density:", "Text"],

Cell["Orientation column", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelDensityApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
     RowBox[{"\[Alpha]0_:", "0"}], ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{"x_", ",", "dx_", ",", "y_", ",", "dy_", ",", 
    RowBox[{"{", 
     RowBox[{"min\[Alpha]_", ",", "max\[Alpha]_", ",", "d\[Alpha]_"}], 
     "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"NLineKernelDensityApproximationList", "[", 
   RowBox[{
   "\[Sigma]", ",", "\[Lambda]", ",", "\[Alpha]0", ",", "\[Kappa]", ",", "x", 
    ",", "dx", ",", "y", ",", "dy", ",", "min\[Alpha]", ",", "max\[Alpha]", 
    ",", "d\[Alpha]"}], "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelDensityApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
     RowBox[{"\[Alpha]0_:", "0"}], ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{"x_", ",", "dx_", ",", "y_", ",", "dy_", ",", 
    RowBox[{"{", "n\[Alpha]_", "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"NLineKernelDensityApproximationList", "[", 
   RowBox[{
   "\[Sigma]", ",", "\[Lambda]", ",", "\[Alpha]0", ",", "\[Kappa]", ",", "x", 
    ",", "dx", ",", "y", ",", "dy", ",", 
    RowBox[{
     RowBox[{"-", "\[Pi]"}], "+", 
     RowBox[{"2", 
      RowBox[{"\[Pi]", "/", "n\[Alpha]"}]}]}], ",", "\[Pi]", ",", 
    RowBox[{"2", 
     RowBox[{"\[Pi]", "/", "n\[Alpha]"}]}]}], "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell["Symbolic expressions", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Note", " ", "the", " ", "order", " ", "of", " ", 
    RowBox[{"implementation", ".", " ", "Do"}], " ", "not", " ", "move", " ", 
    "the", " ", "following", " ", "code", " ", 
    RowBox[{"up", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"LineKernelDensityApproximation", "[", 
      RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
       RowBox[{"\[Alpha]0_:", "0"}], ",", 
       RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
     RowBox[{
      RowBox[{"0", "|", "0."}], ",", "dx_", ",", 
      RowBox[{"0", "|", "0."}], ",", "dy_", ",", 
      RowBox[{"0", "|", "0."}], ",", 
      RowBox[{"d\[Alpha]_:", "0"}]}], "]"}], "=", 
    FractionBox[
     RowBox[{"1", "-", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[Lambda]"}], " ", 
        RowBox[{
         RowBox[{"Abs", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "dx"}], " ", "+", 
           " ", 
           RowBox[{
            RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "dy"}]}], "]"}], "/",
          "2"}]}]]}], 
     RowBox[{"\[Lambda]", " ", 
      RowBox[{"Abs", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "dx"}], " ", "+", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "dy"}]}], "]"}]}]]}], 
   ";"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LineKernelDensityApproximation", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{
     RowBox[{"0", "|", "0."}], ",", "dx_", ",", "y_", ",", "dy_", ",", 
     "\[Alpha]_", ",", 
     RowBox[{"d\[Alpha]_:", "0"}]}], "]"}], "=", "0"}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelDensityApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_"}], "]"}], "[", 
   RowBox[{
   "x_", ",", "dx_", ",", "y_", ",", "dy_", ",", "\[Alpha]_", ",", 
    "d\[Alpha]_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"UnitStep", "[", "x", "]"}], 
   RowBox[{"Chop", "[", 
    RowBox[{
     RowBox[{
      FractionBox[
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "x"}], " ", "\[Lambda]"}], "-", 
         FractionBox[
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[Alpha]", "/", "\[Sigma]"}], ")"}], "2"], 
          RowBox[{"2", " ", "x"}]]}], "]"}], 
       RowBox[{"2", " ", "dy", " ", 
        SqrtBox[
         RowBox[{"2", " ", "\[Pi]", " ", "x"}]], " ", "\[Sigma]"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Erf", "[", 
         RowBox[{
          SqrtBox[
           FractionBox["3", 
            RowBox[{"2", " ", 
             SuperscriptBox["x", "3"]}]]], 
          FractionBox[
           RowBox[{"dy", "+", 
            RowBox[{"2", " ", "y"}], "-", 
            RowBox[{"x", " ", "\[Alpha]"}]}], "\[Sigma]"]}], "]"}], "+", 
        RowBox[{"Erf", "[", 
         RowBox[{
          SqrtBox[
           FractionBox["3", 
            RowBox[{"2", " ", 
             SuperscriptBox["x", "3"]}]]], 
          FractionBox[
           RowBox[{"dy", "-", 
            RowBox[{"2", " ", "y"}], "+", 
            RowBox[{"x", " ", "\[Alpha]"}]}], "\[Sigma]"]}], "]"}]}], ")"}]}],
      ",", "$MachineEpsilon"}], "]"}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelDensityApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
     RowBox[{"0", "|", "0."}], ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{"x_", ",", "dx_", ",", "y_", ",", "dy_", ",", "\[Alpha]_", ",", 
    RowBox[{"d\[Alpha]_:", "0"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"UnitStep", "[", "x", "]"}], 
   RowBox[{"Chop", "[", 
    RowBox[{
     RowBox[{
      FractionBox[
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "x"}], " ", "\[Lambda]"}], "-", 
         FractionBox[
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[Alpha]", "-", 
             RowBox[{"x", " ", "\[Kappa]"}]}], ")"}], "2"], 
          RowBox[{"2", " ", "x", " ", 
           SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}], 
       RowBox[{"2", " ", "dy", " ", 
        SqrtBox[
         RowBox[{"2", " ", "\[Pi]", " ", "x"}]], " ", "\[Sigma]"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Erf", "[", 
         RowBox[{
          SqrtBox[
           FractionBox["3", 
            RowBox[{"2", " ", 
             SuperscriptBox["x", "3"]}]]], 
          FractionBox[
           RowBox[{"dy", "+", 
            RowBox[{"2", " ", "y"}], "-", 
            RowBox[{"x", " ", "\[Alpha]"}]}], "\[Sigma]"]}], "]"}], "+", 
        RowBox[{"Erf", "[", 
         RowBox[{
          SqrtBox[
           FractionBox["3", 
            RowBox[{"2", " ", 
             SuperscriptBox["x", "3"]}]]], 
          FractionBox[
           RowBox[{"dy", "-", 
            RowBox[{"2", " ", "y"}], "+", 
            RowBox[{"x", " ", "\[Alpha]"}]}], "\[Sigma]"]}], "]"}]}], ")"}]}],
      ",", "$MachineEpsilon"}], "]"}]}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelDensityApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", "\[Alpha]0_", ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{"x_", ",", "dx_", ",", "y_", ",", "dy_", ",", "\[Alpha]_", ",", 
    RowBox[{"d\[Alpha]_:", "0"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"xr", "   ", "=", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "x"}], " ", "+", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"yr", "   ", "=", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "x"}], " ", "+", " ", 
        RowBox[{
         RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"dyr", " ", "=", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "dx"}], " ", "+", 
        " ", 
        RowBox[{
         RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "dy"}]}]}]}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"UnitStep", "[", "xr", "]"}], 
     RowBox[{"Chop", "[", 
      RowBox[{
       RowBox[{
        FractionBox[
         RowBox[{"Exp", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "xr"}], " ", "\[Lambda]"}], "-", 
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"\[Alpha]", "-", 
               RowBox[{"xr", " ", "\[Kappa]"}]}], ")"}], "2"], 
            RowBox[{"2", " ", "xr", " ", 
             SuperscriptBox["\[Sigma]", "2"]}]]}], "]"}], 
         RowBox[{"2", " ", "dyr", " ", 
          SqrtBox[
           RowBox[{"2", " ", "\[Pi]", " ", "xr"}]], " ", "\[Sigma]"}]], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Erf", "[", 
           RowBox[{
            SqrtBox[
             FractionBox["3", 
              RowBox[{"2", " ", 
               SuperscriptBox["xr", "3"]}]]], 
            FractionBox[
             RowBox[{"dyr", "+", 
              RowBox[{"2", " ", "yr"}], "-", 
              RowBox[{"xr", " ", "\[Alpha]"}]}], "\[Sigma]"]}], "]"}], "+", 
          RowBox[{"Erf", "[", 
           RowBox[{
            SqrtBox[
             FractionBox["3", 
              RowBox[{"2", " ", 
               SuperscriptBox["xr", "3"]}]]], 
            FractionBox[
             RowBox[{"dyr", "-", 
              RowBox[{"2", " ", "yr"}], "+", 
              RowBox[{"xr", " ", "\[Alpha]"}]}], "\[Sigma]"]}], "]"}]}], 
         ")"}]}], ",", "$MachineEpsilon"}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell["xy-marginal", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LineKernelDensityApproximation", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{
     RowBox[{"0", "|", "0."}], ",", "dx_", ",", 
     RowBox[{"0", "|", "0."}], ",", "dy_"}], "]"}], "=", 
   FractionBox[
    RowBox[{"1", "-", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "\[Lambda]"}], " ", 
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "dx"}], " ", "+", " ", 
          RowBox[{
           RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "dy"}]}], "]"}], "/", 
        "2"}]}]]}], 
    RowBox[{"\[Lambda]", " ", 
     RowBox[{"Abs", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "dx"}], " ", "+", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "dy"}]}], "]"}]}]]}], 
  ";"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LineKernelDensityApproximation", "[", 
     RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
      RowBox[{"\[Alpha]0_:", "0"}], ",", 
      RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
    RowBox[{
     RowBox[{"0", "|", "0."}], ",", "dx_", ",", "y_", ",", "dy_"}], "]"}], 
   "=", "0"}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelDensityApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_"}], "]"}], "[", 
   RowBox[{"x_", ",", "dx_", ",", "y_", ",", "dy_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"UnitStep", "[", "x", "]"}], " ", 
   RowBox[{"Chop", "[", 
    RowBox[{
     RowBox[{
      FractionBox[
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"-", "x"}], " ", "\[Lambda]"}], "]"}], 
       RowBox[{"2", " ", "dy"}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Erf", "[", 
         RowBox[{
          SqrtBox[
           FractionBox["3", 
            RowBox[{"8", " ", 
             SuperscriptBox["x", "3"]}]]], 
          FractionBox[
           RowBox[{"dy", "-", 
            RowBox[{"2", " ", "y"}]}], "\[Sigma]"]}], "]"}], "+", 
        RowBox[{"Erf", "[", 
         RowBox[{
          SqrtBox[
           FractionBox["3", 
            RowBox[{"8", " ", 
             SuperscriptBox["x", "3"]}]]], 
          FractionBox[
           RowBox[{"dy", "+", 
            RowBox[{"2", " ", "y"}]}], "\[Sigma]"]}], "]"}]}], ")"}]}], ",", 
     "$MachineEpsilon"}], "]"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelDensityApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", 
     RowBox[{"0", "|", "0."}], ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{"x_", ",", "dx_", ",", "y_", ",", "dy_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"UnitStep", "[", "x", "]"}], 
   RowBox[{"Chop", "[", 
    RowBox[{
     RowBox[{
      FractionBox[
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"-", "x"}], " ", "\[Lambda]"}], "]"}], 
       RowBox[{"2", " ", "dy"}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Erf", "[", 
         RowBox[{
          SqrtBox[
           FractionBox["3", 
            RowBox[{"8", " ", 
             SuperscriptBox["x", "3"]}]]], 
          FractionBox[
           RowBox[{"dy", "+", 
            RowBox[{"2", " ", "y"}], "-", 
            RowBox[{
             SuperscriptBox["x", "2"], " ", "\[Kappa]"}]}], "\[Sigma]"]}], 
         "]"}], "+", 
        RowBox[{"Erf", "[", 
         RowBox[{
          SqrtBox[
           FractionBox["3", 
            RowBox[{"8", " ", 
             SuperscriptBox["x", "3"]}]]], 
          FractionBox[
           RowBox[{"dy", "-", 
            RowBox[{"2", " ", "y"}], "+", 
            RowBox[{
             SuperscriptBox["x", "2"], " ", "\[Kappa]"}]}], "\[Sigma]"]}], 
         "]"}]}], ")"}]}], ",", "$MachineEpsilon"}], 
    "]"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LineKernelDensityApproximation", "[", 
    RowBox[{"\[Sigma]_", ",", "\[Lambda]_", ",", "\[Alpha]0_", ",", 
     RowBox[{"\[Kappa]_:", "0"}]}], "]"}], "[", 
   RowBox[{"x_", ",", "dx_", ",", "y_", ",", "dy_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"xr", " ", "=", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "x"}], " ", "+", " ", 
        RowBox[{
         RowBox[{"Sin", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"yr", " ", "=", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "x"}], " ", "+", " ", 
        RowBox[{
         RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "y"}]}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"dyr", " ", "=", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Sin", "[", "\[Alpha]0", "]"}]}], " ", "dx"}], " ", "+", 
        " ", 
        RowBox[{
         RowBox[{"Cos", "[", "\[Alpha]0", "]"}], " ", "dy"}]}]}]}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"Chop", "[", 
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"-", "xr"}], " ", "\[Lambda]"}], "]"}], 
        RowBox[{"2", " ", "dx", " ", "dy"}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox[
            FractionBox["3", 
             RowBox[{"8", 
              SuperscriptBox["xr", "3"]}]]], 
           FractionBox[
            RowBox[{"dyr", "+", 
             RowBox[{"2", " ", "yr"}], "-", 
             RowBox[{
              SuperscriptBox["xr", "2"], " ", "\[Kappa]"}]}], "\[Sigma]"]}], 
          "]"}], "+", 
         RowBox[{"Erf", "[", 
          RowBox[{
           SqrtBox[
            FractionBox["3", 
             RowBox[{"8", 
              SuperscriptBox["xr", "3"]}]]], 
           FractionBox[
            RowBox[{"dyr", "-", 
             RowBox[{"2", " ", "yr"}], "+", 
             RowBox[{
              SuperscriptBox["xr", "2"], " ", "\[Kappa]"}]}], "\[Sigma]"]}], 
          "]"}]}], ")"}]}], ",", "$MachineEpsilon"}], "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "LineKernel", ",", "\[IndentingNewLine]", "LineKernelMean", ",", 
       "\[IndentingNewLine]", "FourierLineKernel", ",", "\[IndentingNewLine]",
        "FourierInfiniteLineKernel", ",", "\[IndentingNewLine]", 
       "FourierInfiniteLineDiffusionKernel", ",", "\[IndentingNewLine]", 
       "FourierLineKernelPolar", ",", "\[IndentingNewLine]", 
       "FourierInfiniteLineKernelPolar", ",", "\[IndentingNewLine]", 
       "FourierCyclicLineKernel", ",", "\[IndentingNewLine]", 
       "FourierCyclicLineKernelPolar", ",", "\[IndentingNewLine]", 
       "FourierLineKernelApproximation", ",", "\[IndentingNewLine]", 
       "LineKernelApproximation", ",", "\[IndentingNewLine]", 
       "NLineKernelApproximation", ",", "\[IndentingNewLine]", 
       "NLineKernelApproximationList", ",", "\[IndentingNewLine]", 
       "NLineKernelApproximationMarginal", ",", "\[IndentingNewLine]", 
       "LineKernelDensityApproximation", ",", "\[IndentingNewLine]", 
       "NLineKernelDensityApproximation", ",", "\[IndentingNewLine]", 
       "NLineKernelDensityApproximationList", ",", "\[IndentingNewLine]", 
       "NLineKernelDensityApproximationMarginal", ",", "\[IndentingNewLine]", 
       "FloquetSign", ",", "\[IndentingNewLine]", "FloquetExponent"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Protected", ",", " ", "ReadProtected"}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1280, 976},
WindowMargins->{{4, Automatic}, {Automatic, 0}},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (November 10, 2008)",
StyleDefinitions->"PackageNotebook.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 36, 0, 144, "Title"],
Cell[606, 24, 100, 4, 118, "Subsubtitle"],
Cell[CellGroupData[{
Cell[731, 32, 25, 0, 72, "Section"],
Cell[759, 34, 945, 24, 436, "PackageInput"],
Cell[1707, 60, 128, 3, 58, "Text"],
Cell[1838, 65, 3620, 98, 1161, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5495, 168, 32, 0, 40, "Section"],
Cell[5530, 170, 92, 2, 39, "Text"],
Cell[5625, 174, 1514, 27, 636, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[7176, 206, 42, 0, 40, "Section"],
Cell[7221, 208, 21141, 337, 4730, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[28399, 550, 29, 0, 40, "Section"],
Cell[CellGroupData[{
Cell[28453, 554, 120, 3, 94, "Subsection"],
Cell[28576, 559, 135, 3, 58, "Text"],
Cell[28714, 564, 99, 2, 58, "Text"],
Cell[28816, 568, 830, 24, 108, "Input"],
Cell[29649, 594, 66, 0, 58, "Text"],
Cell[29718, 596, 964, 30, 108, "Input"],
Cell[30685, 628, 551, 16, 81, "Text"],
Cell[31239, 646, 1090, 32, 108, "Input"],
Cell[32332, 680, 986, 29, 108, "Input"],
Cell[33321, 711, 145, 3, 58, "Text"],
Cell[33469, 716, 768, 23, 108, "Input"],
Cell[34240, 741, 135, 6, 69, "Text"],
Cell[34378, 749, 986, 31, 99, "Input"],
Cell[35367, 782, 58, 0, 58, "Text"],
Cell[CellGroupData[{
Cell[35450, 786, 1022, 28, 99, "Input"],
Cell[36475, 816, 1881, 53, 163, "Output"]
}, Open  ]],
Cell[38371, 872, 1622, 49, 108, "Input"],
Cell[39996, 923, 206, 6, 61, "Text"],
Cell[40205, 931, 360, 10, 57, "Input"],
Cell[40568, 943, 47, 0, 58, "Text"],
Cell[40618, 945, 360, 10, 57, "Input"],
Cell[40981, 957, 182, 3, 58, "Text"],
Cell[41166, 962, 1676, 49, 205, "Input"],
Cell[CellGroupData[{
Cell[42867, 1015, 1411, 40, 255, "Input"],
Cell[44281, 1057, 10440, 261, 600, "Output"]
}, Open  ]],
Cell[54736, 1321, 82, 2, 58, "Text"],
Cell[CellGroupData[{
Cell[54843, 1327, 407, 12, 54, "Input"],
Cell[55253, 1341, 6030, 168, 403, "Output"]
}, Open  ]],
Cell[61298, 1512, 82, 2, 58, "Text"],
Cell[CellGroupData[{
Cell[61405, 1518, 411, 12, 54, "Input"],
Cell[61819, 1532, 6023, 167, 403, "Output"]
}, Open  ]],
Cell[67857, 1702, 58, 0, 58, "Text"],
Cell[CellGroupData[{
Cell[67940, 1706, 139, 4, 54, "Input"],
Cell[68082, 1712, 4343, 122, 307, "Output"]
}, Open  ]],
Cell[72440, 1837, 120, 3, 58, "Text"],
Cell[72563, 1842, 3661, 109, 303, "Input",
 Evaluatable->False]
}, Open  ]],
Cell[CellGroupData[{
Cell[76261, 1956, 114, 3, 94, "Subsection"],
Cell[76378, 1961, 22, 0, 58, "Text"],
Cell[76403, 1963, 1274, 35, 93, "Input"],
Cell[CellGroupData[{
Cell[77702, 2002, 1909, 53, 228, "Input"],
Cell[79614, 2057, 1952, 50, 202, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[81603, 2112, 464, 14, 54, "Input"],
Cell[82070, 2128, 28, 0, 54, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[82135, 2133, 986, 27, 91, "Input"],
Cell[83124, 2162, 1774, 48, 183, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[84935, 2215, 1263, 35, 93, "Input"],
Cell[86201, 2252, 2818, 76, 144, "Output"]
}, Open  ]],
Cell[89034, 2331, 2324, 66, 226, "Input"],
Cell[91361, 2399, 3809, 105, 294, "Input"],
Cell[95173, 2506, 741, 21, 216, "Input"],
Cell[CellGroupData[{
Cell[95939, 2531, 31, 0, 85, "Subsubsection"],
Cell[95973, 2533, 81, 2, 54, "Input"],
Cell[96057, 2537, 769, 21, 183, "Input"],
Cell[96829, 2560, 68, 0, 58, "Text"],
Cell[96900, 2562, 646, 20, 57, "Input"],
Cell[97549, 2584, 2862, 76, 267, "Input"],
Cell[100414, 2662, 4587, 119, 426, "Input"],
Cell[105004, 2783, 41, 0, 58, "Text"],
Cell[105048, 2785, 5718, 148, 688, "Input"],
Cell[110769, 2935, 8268, 207, 907, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[119086, 3148, 127, 3, 94, "Subsection"],
Cell[119216, 3153, 190, 4, 58, "Text"],
Cell[119409, 3159, 751, 22, 108, "Input",
 Evaluatable->False],
Cell[120163, 3183, 66, 0, 58, "Text"],
Cell[120232, 3185, 902, 29, 108, "Input",
 Evaluatable->False],
Cell[121137, 3216, 135, 6, 69, "Text"],
Cell[121275, 3224, 1017, 32, 99, "Input",
 Evaluatable->False],
Cell[122295, 3258, 57, 0, 58, "Text"],
Cell[CellGroupData[{
Cell[122377, 3262, 634, 20, 99, "Input"],
Cell[123014, 3284, 384, 7, 42, "Message"],
Cell[123401, 3293, 619, 19, 93, "Output"]
}, Open  ]],
Cell[124035, 3315, 340, 11, 66, "Text"],
Cell[CellGroupData[{
Cell[124400, 3330, 690, 19, 66, "Input"],
Cell[125093, 3351, 915, 27, 99, "Output"]
}, Open  ]],
Cell[126023, 3381, 828, 25, 114, "Input"],
Cell[126854, 3408, 182, 3, 58, "Text"],
Cell[CellGroupData[{
Cell[127061, 3415, 1411, 40, 255, "Input"],
Cell[128475, 3457, 4642, 127, 489, "Output"]
}, Open  ]],
Cell[133132, 3587, 76, 0, 58, "Text"],
Cell[133211, 3589, 1889, 54, 339, "Input"],
Cell[135103, 3645, 82, 2, 58, "Text"],
Cell[CellGroupData[{
Cell[135210, 3651, 453, 13, 54, "Input"],
Cell[135666, 3666, 820, 26, 129, "Output"]
}, Open  ]],
Cell[136501, 3695, 82, 2, 58, "Text"],
Cell[CellGroupData[{
Cell[136608, 3701, 453, 13, 54, "Input"],
Cell[137064, 3716, 820, 26, 129, "Output"]
}, Open  ]],
Cell[137899, 3745, 58, 0, 58, "Text"],
Cell[CellGroupData[{
Cell[137982, 3749, 164, 5, 54, "Input"],
Cell[138149, 3756, 679, 22, 129, "Output"]
}, Open  ]],
Cell[138843, 3781, 136, 3, 58, "Text"],
Cell[CellGroupData[{
Cell[139004, 3788, 634, 19, 66, "Input"],
Cell[139641, 3809, 725, 23, 99, "Output"]
}, Open  ]],
Cell[140381, 3835, 531, 18, 87, "Input"],
Cell[140915, 3855, 182, 3, 58, "Text"],
Cell[CellGroupData[{
Cell[141122, 3862, 1411, 40, 255, "Input"],
Cell[142536, 3904, 1038, 33, 145, "Output"]
}, Open  ]],
Cell[143589, 3940, 82, 2, 58, "Text"],
Cell[CellGroupData[{
Cell[143696, 3946, 407, 12, 54, "Input"],
Cell[144106, 3960, 445, 15, 145, "Output"]
}, Open  ]],
Cell[144566, 3978, 82, 2, 58, "Text"],
Cell[CellGroupData[{
Cell[144673, 3984, 407, 12, 54, "Input"],
Cell[145083, 3998, 493, 17, 145, "Output"]
}, Open  ]],
Cell[145591, 4018, 58, 0, 58, "Text"],
Cell[CellGroupData[{
Cell[145674, 4022, 139, 4, 54, "Input"],
Cell[145816, 4028, 192, 6, 112, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[146069, 4041, 31, 0, 40, "Section"],
Cell[146103, 4043, 60, 0, 39, "Text"],
Cell[146166, 4045, 108, 2, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[146299, 4051, 39, 0, 63, "Subsection"],
Cell[146341, 4053, 132, 3, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[146498, 4060, 55, 0, 57, "Subsubsection"],
Cell[146556, 4062, 257, 6, 186, "Input"],
Cell[146816, 4070, 353, 11, 139, "PackageInput"],
Cell[147172, 4083, 250, 6, 186, "Input"],
Cell[147425, 4091, 330, 11, 139, "PackageInput"],
Cell[147758, 4104, 236, 6, 135, "Input"],
Cell[147997, 4112, 375, 12, 139, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[148409, 4129, 57, 0, 34, "Subsubsection"],
Cell[148469, 4131, 261, 6, 83, "Input"],
Cell[148733, 4139, 899, 26, 155, "PackageInput"],
Cell[149635, 4167, 162, 5, 36, "Input"],
Cell[149800, 4174, 206, 7, 77, "PackageInput"]
}, Open  ]],
Cell[CellGroupData[{
Cell[150043, 4186, 51, 0, 57, "Subsubsection"],
Cell[150097, 4188, 377, 7, 159, "Input"],
Cell[150477, 4197, 509, 18, 114, "PackageInput"],
Cell[150989, 4217, 251, 6, 124, "Input"],
Cell[151243, 4225, 1815, 51, 337, "PackageInput"],
Cell[153061, 4278, 152, 3, 54, "Input"],
Cell[153216, 4283, 626, 18, 90, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[153879, 4306, 44, 0, 34, "Subsubsection"],
Cell[153926, 4308, 1066, 33, 441, "PackageInput"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[155041, 4347, 41, 0, 37, "Subsection"],
Cell[155085, 4349, 145, 4, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[155255, 4357, 47, 0, 57, "Subsubsection"],
Cell[155305, 4359, 96, 2, 87, "Text"],
Cell[155404, 4363, 282, 7, 240, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[155723, 4375, 48, 0, 34, "Subsubsection"],
Cell[155774, 4377, 10309, 251, 1642, "PackageInput",
 InitializationCell->True],
Cell[166086, 4630, 11242, 272, 1779, "PackageInput",
 InitializationCell->True],
Cell[177331, 4904, 10718, 264, 1624, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[188086, 5173, 98, 2, 34, "Subsubsection"],
Cell[188187, 5177, 9354, 227, 1504, "Input"],
Cell[197544, 5406, 10516, 255, 1662, "Input"],
Cell[208063, 5663, 10362, 250, 1662, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[218474, 5919, 47, 0, 37, "Subsection"],
Cell[218524, 5921, 159, 4, 135, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[218708, 5929, 47, 0, 127, "Subsubsection"],
Cell[218758, 5931, 96, 2, 87, "Text"],
Cell[218857, 5935, 282, 7, 240, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[219176, 5947, 48, 0, 76, "Subsubsection"],
Cell[219227, 5949, 10407, 258, 1513, "PackageInput",
 InitializationCell->True],
Cell[229637, 6209, 11797, 286, 1864, "PackageInput",
 InitializationCell->True],
Cell[241437, 6497, 11084, 265, 1761, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[252570, 6768, 50, 0, 37, "Subsection"],
Cell[252623, 6770, 162, 4, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[252810, 6778, 47, 0, 57, "Subsubsection"],
Cell[252860, 6780, 96, 2, 58, "Text"],
Cell[252959, 6784, 282, 7, 160, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[253278, 6796, 48, 0, 34, "Subsubsection"],
Cell[253329, 6798, 1053, 29, 238, "PackageInput",
 InitializationCell->True],
Cell[254385, 6829, 6294, 157, 1038, "PackageInput",
 InitializationCell->True],
Cell[260682, 6988, 5568, 142, 886, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[266299, 7136, 60, 0, 37, "Subsection"],
Cell[266362, 7138, 183, 5, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[266570, 7147, 47, 0, 57, "Subsubsection"],
Cell[266620, 7149, 96, 2, 58, "Text"],
Cell[266719, 7153, 282, 7, 160, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[267038, 7165, 48, 0, 34, "Subsubsection"],
Cell[267089, 7167, 1093, 29, 159, "PackageInput",
 InitializationCell->True],
Cell[268185, 7198, 5734, 145, 728, "PackageInput",
 InitializationCell->True],
Cell[273922, 7345, 5082, 132, 581, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[279053, 7483, 56, 0, 37, "Subsection"],
Cell[279112, 7485, 179, 5, 141, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[279316, 7494, 47, 0, 139, "Subsubsection"],
Cell[279366, 7496, 96, 2, 105, "Text"],
Cell[279465, 7500, 282, 7, 244, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[279784, 7512, 48, 0, 87, "Subsubsection"],
Cell[279835, 7514, 1083, 29, 357, "PackageInput",
 InitializationCell->True],
Cell[280921, 7545, 6156, 153, 1390, "PackageInput",
 InitializationCell->True],
Cell[287080, 7700, 5435, 139, 1215, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[292564, 7845, 48, 0, 37, "Subsection"],
Cell[292615, 7847, 160, 4, 135, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[292800, 7855, 47, 0, 127, "Subsubsection"],
Cell[292850, 7857, 96, 2, 105, "Text"],
Cell[292949, 7861, 282, 7, 244, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[293268, 7873, 48, 0, 76, "Subsubsection"],
Cell[293319, 7875, 64, 2, 105, "Text"],
Cell[293386, 7879, 8821, 215, 2125, "PackageInput",
 InitializationCell->True],
Cell[302210, 8096, 971, 23, 400, "PackageInput"],
Cell[303184, 8121, 6933, 173, 1494, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[310166, 8300, 54, 0, 37, "Subsection"],
Cell[310223, 8302, 177, 5, 141, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[310425, 8311, 47, 0, 132, "Subsubsection"],
Cell[310475, 8313, 96, 2, 100, "Text"],
Cell[310574, 8317, 282, 7, 244, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[310893, 8329, 48, 0, 132, "Subsubsection"],
Cell[310944, 8331, 8957, 218, 2400, "PackageInput",
 InitializationCell->True],
Cell[319904, 8551, 996, 23, 559, "PackageInput"],
Cell[320903, 8576, 6770, 167, 1653, "PackageInput",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[327722, 8749, 55, 0, 37, "Subsection"],
Cell[327780, 8751, 108, 3, 87, "Text"],
Cell[327891, 8756, 167, 4, 135, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[328083, 8764, 47, 0, 127, "Subsubsection"],
Cell[328133, 8766, 73, 0, 105, "Text"],
Cell[328209, 8768, 282, 7, 244, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[328528, 8780, 48, 0, 76, "Subsubsection"],
Cell[328579, 8782, 1363, 40, 387, "PackageInput",
 InitializationCell->True],
Cell[329945, 8824, 1582, 45, 283, "PackageInput",
 InitializationCell->True],
Cell[331530, 8871, 3755, 102, 999, "PackageInput",
 InitializationCell->True],
Cell[335288, 8975, 4555, 123, 1063, "PackageInput",
 InitializationCell->True],
Cell[339846, 9100, 6209, 164, 1554, "PackageInput",
 InitializationCell->True],
Cell[346058, 9266, 867, 23, 193, "PackageInput",
 InitializationCell->True],
Cell[346928, 9291, 1226, 34, 418, "PackageInput",
 InitializationCell->True],
Cell[348157, 9327, 1309, 38, 328, "PackageInput",
 InitializationCell->True],
Cell[349469, 9367, 3035, 86, 693, "PackageInput",
 InitializationCell->True],
Cell[352507, 9455, 3805, 106, 760, "PackageInput",
 InitializationCell->True],
Cell[356315, 9563, 5209, 141, 1314, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[361573, 9710, 53, 0, 37, "Subsection"],
Cell[361629, 9712, 177, 5, 141, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[361831, 9721, 48, 0, 139, "Subsubsection"],
Cell[361882, 9723, 34, 0, 105, "Text"],
Cell[361919, 9725, 886, 30, 298, "PackageInput"],
Cell[362808, 9757, 897, 30, 298, "PackageInput"],
Cell[363708, 9789, 4380, 116, 792, "PackageInput"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[368137, 9911, 38, 0, 37, "Subsection"],
Cell[368178, 9913, 13228, 334, 1741, "PackageInput"],
Cell[381409, 10249, 318, 9, 190, "PackageInput"],
Cell[381730, 10260, 7353, 198, 1120, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[389120, 10463, 47, 0, 37, "Subsection"],
Cell[389170, 10465, 151, 4, 141, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[389346, 10473, 47, 0, 139, "Subsubsection"],
Cell[389396, 10475, 24, 0, 105, "Text"],
Cell[389423, 10477, 4109, 105, 1111, "PackageInput",
 InitializationCell->True],
Cell[393535, 10584, 5040, 131, 1230, "PackageInput",
 InitializationCell->True],
Cell[398578, 10717, 3073, 82, 928, "PackageInput",
 InitializationCell->True],
Cell[401654, 10801, 23, 0, 105, "Text"],
Cell[401680, 10803, 5507, 141, 1230, "PackageInput",
 InitializationCell->True],
Cell[407190, 10946, 6487, 167, 1230, "PackageInput",
 InitializationCell->True],
Cell[413680, 11115, 4763, 127, 1192, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[418480, 11247, 48, 0, 87, "Subsubsection"],
Cell[418531, 11249, 25, 0, 105, "Text"],
Cell[418559, 11251, 34, 0, 105, "Text"],
Cell[418596, 11253, 823, 20, 297, "PackageInput",
 InitializationCell->True],
Cell[419422, 11275, 114, 3, 105, "Text"],
Cell[419539, 11280, 1127, 30, 348, "PackageInput",
 InitializationCell->True],
Cell[420669, 11312, 36, 0, 105, "Text"],
Cell[420708, 11314, 718, 17, 244, "PackageInput",
 InitializationCell->True],
Cell[421429, 11333, 1229, 38, 285, "PackageInput",
 InitializationCell->True],
Cell[422661, 11373, 1591, 49, 400, "PackageInput",
 InitializationCell->True],
Cell[424255, 11424, 2365, 69, 630, "PackageInput",
 InitializationCell->True],
Cell[426623, 11495, 27, 0, 105, "Text"],
Cell[426653, 11497, 346, 9, 141, "PackageInput"],
Cell[427002, 11508, 820, 25, 285, "PackageInput"],
Cell[427825, 11535, 1097, 33, 285, "PackageInput"],
Cell[428925, 11570, 1877, 53, 519, "PackageInput"],
Cell[430805, 11625, 24, 0, 105, "Text"],
Cell[430832, 11627, 34, 0, 105, "Text"],
Cell[430869, 11629, 724, 16, 193, "PackageInput",
 InitializationCell->True],
Cell[431596, 11647, 799, 19, 193, "PackageInput",
 InitializationCell->True],
Cell[432398, 11668, 36, 0, 105, "Text"],
Cell[432437, 11670, 1523, 42, 378, "PackageInput",
 InitializationCell->True],
Cell[433963, 11714, 430, 11, 141, "PackageInput"],
Cell[434396, 11727, 1641, 49, 409, "PackageInput",
 InitializationCell->True],
Cell[436040, 11778, 1814, 52, 409, "PackageInput",
 InitializationCell->True],
Cell[437857, 11832, 2899, 80, 739, "PackageInput",
 InitializationCell->True],
Cell[440759, 11914, 27, 0, 105, "Text"],
Cell[440789, 11916, 1087, 32, 274, "PackageInput",
 InitializationCell->True],
Cell[441879, 11950, 369, 10, 141, "PackageInput"],
Cell[442251, 11962, 1191, 37, 298, "PackageInput"],
Cell[443445, 12001, 1452, 45, 370, "PackageInput"],
Cell[444900, 12048, 2406, 70, 649, "PackageInput"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[447367, 12125, 34, 0, 40, "Section"],
Cell[447404, 12127, 64, 0, 58, "Text"],
Cell[447471, 12129, 1764, 32, 988, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
