(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     58790,       1735]
NotebookOptionsPosition[     55820,       1641]
NotebookOutlinePosition[     56240,       1659]
CellTagsIndexPosition[     56197,       1656]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["ListFourierTransform Package", "Title",
 CellChangeTimes->{{3.488887935837162*^9, 3.48888793614124*^9}}],

Cell["\<\
Markus van Almsick
Technische Universiteit Eindhoven
\[Copyright]2006\
\>", "Subsubtitle"],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "[", "\"\<MathVisionTools`\>\"", "]"}], " ", "=", 
     " ", 
     RowBox[{"{", 
      RowBox[{"2007", ",", "6", ",", "25", ",", "11", ",", "38", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput"],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contemns, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`ListFourierTransform`"}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Authors", ":", " ", 
     RowBox[{"Markus", " ", "van", " ", "Almsick"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"M", ".", "v", ".", 
       RowBox[{"Almsick", "@", "tue"}], ".", "nl"}]}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`ListFourierTransform`"}]}], 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "1.1"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "5.0"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2006"}]}]}], ",", " ", 
    RowBox[{"Technische", " ", "Universiteit", " ", "Eindhoven"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "ListFourierTransform"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "implements", " ", 
      "ListFourierTransform"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", "Fourier"}]}], ",", " ", "FFT", ",", " ", 
    "FouierTransform", ",", " ", "ListFourierTransform"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"April", " ", "2006"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "BeginPackage", "[", "\"\<MathVisionTools`ListFourierTransform`\>\"", "]"}],
   "\[IndentingNewLine]"}], "\n", 
 RowBox[{"Unprotect", "[", "\[IndentingNewLine]", 
  RowBox[{
  "ListFourierTransform", ",", "ListInverseFourierTransform", ",", 
   "ArrayTimes", ",", "ListFourierPositions", ",", "ListFourierFrequencies", 
   ",", "ListFourierFilter"}], "\[IndentingNewLine]", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ListFourierTransform", "::", "usage"}], "=", 
    "\"\<ListFourierTransform[list,{xmin,xmax}] finds the Fourier transform \
of a list of complex numbers that represents the discrete sampling of a \
function f[x] in an interval [xmin,xmax]. One can generate the n sampling \
positions \!\(\*SubscriptBox[\(x\), \(r\)]\) with \
ListFourierPositions[n,{xmin,xmax}]. The result of ListFourierTransform is \
equivalent to the sampling of the FourierTransform[f,x,\[Omega]]-function at \
the appropriate frequencies \!\(\*SubscriptBox[\(\[Omega]\), \(s\)]\) given \
by ListFourierFrequencies[n,{xmin,xmax}]. Higher-dimensional function calls \
like ListFourierTransform[array, {min1,max1}, {min2,max2},...] are \
implemented aswell.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Options", "[", "ListFourierTransform", "]"}], " ", "=", " ", 
    RowBox[{"{", 
     RowBox[{"ListFourierFilter", "\[Rule]", " ", "False"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ListInverseFourierTransform", "::", "usage"}], "=", 
    "\"\<ListInverseFourierTransform[list,{xmin,xmax}] finds the inverse \
Fourier transform of a list of complex numbers that represents the discrete \
sampling of a Fourier transformed function \!\(\*OverscriptBox[\(f\), \
\(^\)]\)[\[Omega]] originally defined in position space in an interval \
[xmin,xmax]. One can generate the n sampling positions \!\(\*SubscriptBox[\(\
\[Omega]\), \(s\)]\) with ListFourierFrequencies[n,{xmin,xmax}]. The result \
of ListInverseFourierTransform is equivalent to the sampling of the \
InverseFourierTransform[\!\(\*OverscriptBox[\(f\), \
\(^\)]\),\[Omega],x]-function at the appropriate positions \
\!\(\*SubscriptBox[\(x\), \(r\)]\) given by \
ListFourierPositions[n,{xmin,xmax}]. Higher-dimensional function calls like \
ListInverseFourierTransform[array, {min1,max1}, {min2,max2},...] are \
implemented aswell.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Options", "[", "ListInverseFourierTransform", "]"}], " ", "=", 
    " ", 
    RowBox[{"{", 
     RowBox[{"ListFourierFilter", "\[Rule]", " ", "False"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ListFourierFilter", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<ListFourierFilter is an option of ListFourierTransform and \
ListInverseFourierTransform. If set to True the discrete data entering the \
Fourier transformation is multiplied with a Gaussian kernel with a standard \
deviation of \[Sigma] equal 1/6th of the Fourier domain interval. This filter \
dampens sync-effects, but also blurs the resulting data by \[Pi]/3 grid units \
(or pixels). For data arrays ListFourierFilter can take a List of Boolean \
values, one for each dimension.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ArrayTimes", "::", "usage"}], "=", 
    "\"\<ArrayTimes[{list1, list2, ...}, array] threads Times over list1 and \
the first dimension of array, then threads Times over list2 and the second \
dimension of array, and so on. It is a fast alternative for \
Outer[Times,list1, list2, ...] * array.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ListFourierPositions", "::", "usage"}], "=", 
    "\"\<ListFourierPositions[n,{xmin,xmax}] generates all positions that \
ListFourierTransform[list,{xmin,xmax}] takes into account. The positions are \
\!\(\*SubscriptBox[\(x\), \(\(r\)\(\\\ \)\)]\)= r*\[CapitalDelta]x+xmin, with \
\[CapitalDelta]x = (xmax-xmin)/n and r = 1,2,...,n. Note, that \
ListFourierTransform assumes cylic boundary condition \
f[\!\(\*SubscriptBox[\(x\), \(0\)]\)] = f[\!\(\*SubscriptBox[\(x\), \
\(n\)]\)].\>\""}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ListFourierFrequencies", "::", "usage"}], "=", 
   "\"\<ListFourierFrequencies[n,{xmin,xmax}] generates all frequencies \
\!\(\*SubscriptBox[\(\[Omega]\), \(s\)]\), for which \
ListFourierTransform[list,{xmin,xmax}] generates the Fourier coefficients \
\!\(\*OverscriptBox[\(f\), \(^\)]\)[\!\(\*SubscriptBox[\(\[Omega]\), \
\(s\)]\)]. The frequencies are \!\(\*SubscriptBox[\(\[Omega]\), \(s\)]\)= 2\
\[Pi] (s-Ceiling[\!\(\*FractionBox[\(n\), \(2\)]\)])/(xmax-xmin), with s = \
1,2,...,n.\>\""}], ";"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Derivation", "Section"],

Cell[TextData[{
 "The objective is to find and install the discrete analog to the ",
 Cell[BoxData["FourierTransform"]],
 " function in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ". The sampling space of the Fourier-function is limited to the natural \
numbers 1, 2, 3, ..., n.\nHere we consider an arbitrary sampling interval \
with an arbitrary sampling step size. "
}], "Text"],

Cell[TextData[{
 "We sample a function ",
 Cell[BoxData[
  RowBox[{"f", "[", "x", "]"}]]],
 " on an interval ",
 Cell[BoxData[
  RowBox[{"[", 
   RowBox[{
    SubscriptBox["x", "min"], ",", " ", 
    SubscriptBox["x", "max"]}], "]"}]]],
 Cell[BoxData[Cell["n"]]],
 "-times at ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["f", "r"], ":=", 
   RowBox[{"f", "[", 
    RowBox[{
     SubscriptBox["x", "min"], "+", 
     RowBox[{"r", " ", "\[CapitalDelta]x"}]}], "]"}]}]]],
 "for ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"r", "=", "1"}], ",", "2", ",", "...", ",", "n"}]]],
 ". The sampling step size is ",
 Cell[BoxData[
  RowBox[{"\[CapitalDelta]x", "=", 
   FractionBox[
    RowBox[{
     SubscriptBox["x", "max"], "-", 
     SubscriptBox["x", "min"]}], "n"]}]]],
 "."
}], "Text"],

Cell[TextData[{
 "Note, that ",
 Cell[BoxData[
  RowBox[{"f", "[", 
   SubscriptBox["x", "max"], "]"}]]],
 " but not ",
 Cell[BoxData[
  RowBox[{"f", "[", 
   SubscriptBox["x", "min"], "]"}]]],
 "is sampled, since ",
 Cell[BoxData["r"]],
 " starts with ",
 Cell[BoxData["1"]],
 " and not with ",
 Cell[BoxData["0"]],
 ". However, in Fourier analysis one assumes ",
 Cell[BoxData[
  RowBox[{"f", "[", "x", "]"}]]],
 " to fulfill cyclic boundary conditions at ",
 Cell[BoxData[
  SubscriptBox["x", "min"]]],
 " and ",
 Cell[BoxData[
  SubscriptBox["x", "max"]]],
 ". Hence, ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"f", "[", 
    SubscriptBox["x", "min"], "]"}], " ", "=", " ", 
   RowBox[{"f", "[", 
    SubscriptBox["x", "max"], "]"}]}]]],
 ". If that is not the case, one should sample for ",
 Cell[BoxData[
  RowBox[{"r", "=", "n"}]]],
 " ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["f", "n"], ":=", 
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"f", "[", 
       SubscriptBox["x", "min"], "]"}], "+", 
      RowBox[{"f", "[", 
       SubscriptBox["x", "max"], "]"}]}], ")"}]}]}]]],
 "."
}], "Text"],

Cell[TextData[{
 "Basis function for intervals ",
 Cell[BoxData[
  RowBox[{"x", "\[Element]", 
   RowBox[{"[", 
    RowBox[{
     SubscriptBox["x", "min"], ",", " ", 
     SubscriptBox["x", "max"]}], "]"}]}]]],
 "."
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["\[Phi]", "\[Omega]"], "[", "x", "]"}], " ", "=", " ", 
  RowBox[{
   FractionBox["1", 
    SqrtBox[
     RowBox[{"\[CapitalDelta]x", " ", "n"}]]], 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"\[ImaginaryI]", "  ", "\[Omega]", " ", "x"}]]}]}]], "Input"],

Cell[TextData[{
 "with ",
 Cell[BoxData[
  RowBox[{"\[CapitalDelta]x", "  ", "=", " ", 
   FractionBox[
    RowBox[{
     SubscriptBox["x", "max"], "-", 
     SubscriptBox["x", "min"]}], "n"]}]]],
 "."
}], "Text"],

Cell[TextData[{
 "Discrete basis function, because \[Omega] is discrete when requesting \
periodicity on ",
 Cell[BoxData[
  RowBox[{"[", 
   RowBox[{
    SubscriptBox["x", "min"], ",", " ", 
    SubscriptBox["x", "max"]}], "]"}]]],
 ", and because of discrete sampling in position space ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox["x", "r"], "=", " ", 
    RowBox[{
     SubscriptBox["x", "min"], "+", 
     RowBox[{"r", " ", "\[CapitalDelta]x"}]}]}], ",", 
   RowBox[{"r", "=", "1"}], ",", "2", ",", "...", ",", "n"}]]],
 ". "
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["\[Phi]", "s"], "[", 
   RowBox[{
    SubscriptBox["x", "xmin"], "+", 
    RowBox[{"r", " ", "\[CapitalDelta]x"}]}], "]"}], " ", "=", " ", 
  RowBox[{
   FractionBox["1", 
    SqrtBox[
     RowBox[{"n", " ", "\[CapitalDelta]x"}]]], 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"2", " ", "\[Pi]", " ", "\[ImaginaryI]", "  ", 
     FractionBox[
      RowBox[{"s", " ", "-", 
       RowBox[{"Ceiling", "[", 
        RowBox[{"n", "/", "2"}], "]"}]}], 
      RowBox[{"n", " ", "\[CapitalDelta]x"}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"r", " ", "\[CapitalDelta]x"}], "+", 
       SubscriptBox["x", "min"]}], ")"}]}]]}]}]], "Input"],

Cell[TextData[{
 "with ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox["\[Omega]", "s"], " ", "=", " ", 
    RowBox[{"2", "\[Pi]", 
     FractionBox[
      RowBox[{"s", " ", "-", 
       RowBox[{"Ceiling", "[", 
        RowBox[{"n", "/", "2"}], "]"}]}], 
      RowBox[{"n", " ", "\[CapitalDelta]x"}]]}]}], ",", 
   RowBox[{"s", "=", "1"}], ",", "2", ",", "...", ",", "N"}]]],
 ". The offset ",
 Cell[BoxData[
  RowBox[{"Ceiling", "[", 
   RowBox[{"N", "/", "2"}], "]"}]]],
 " is necessary to maintain a symmetric sampling of \[Omega] around 0 for \
derivatives  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox["\[Phi]", "s"], "'"}], "[", 
   RowBox[{
    RowBox[{"\[CapitalDelta]", " ", "r"}], " ", "+", " ", 
    SubscriptBox["x", "xmin"]}], "]"}]]],
 " and real-valued reconstruction."
}], "Text"],

Cell[TextData[{
 "Transcription of the inner product ",
 Cell[BoxData[
  RowBox[{
   SubsuperscriptBox["\[Integral]", 
    SubscriptBox["x", "min"], 
    SubscriptBox["x", "max"]], 
   RowBox[{
    OverscriptBox[
     RowBox[{"p", "[", "x", "]"}], "_"], " ", 
    RowBox[{
     SubscriptBox["\[Phi]", "\[Omega]"], "[", "x", "]"}], 
    RowBox[{"\[DifferentialD]", "x"}]}]}]]],
 " into a ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Fourier transformation."
}], "Text"],

Cell["Discrete version of the inner product.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    OverscriptBox["f", "^"], "[", "\[Omega]", "]"}], "==", 
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     SubscriptBox["x", "min"], 
     SubscriptBox["x", "max"]], 
    RowBox[{
     RowBox[{"Conjugate", "[", 
      RowBox[{"f", "[", "x", "]"}], "]"}], " ", 
     RowBox[{
      SubscriptBox["\[Phi]", "\[Omega]"], "[", "x", "]"}], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}], " "}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox[
   OverscriptBox["f", "^"], "s"], "==", " ", 
  RowBox[{"\[CapitalDelta]x", 
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"r", "=", "1"}], "N"], 
    RowBox[{
     RowBox[{"Conjugate", "[", 
      RowBox[{"f", "[", 
       RowBox[{
        RowBox[{"r", " ", "\[CapitalDelta]x"}], " ", "+", " ", 
        SubscriptBox["x", "xmin"]}], "]"}], "]"}], " ", 
     RowBox[{
      SubscriptBox["\[Phi]", "s"], "[", 
      RowBox[{
       RowBox[{"r", " ", "\[CapitalDelta]x"}], " ", "+", " ", 
       SubscriptBox["x", "xmin"]}], "]"}]}]}]}]}]}], "Input"],

Cell[TextData[{
 "with ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["f", "r"], "="}]]],
 Cell[BoxData[
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{
     RowBox[{"r", " ", "\[CapitalDelta]x"}], " ", "+", " ", 
     SubscriptBox["x", "xmin"]}], "]"}], ",", 
   RowBox[{"r", "=", "1"}], ",", "2", ",", "...", ",", "N"}]]],
 "."
}], "Text"],

Cell["\<\
The exponent of the discrete basis function can be expanded as follows.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"2", " ", "\[Pi]", " ", "\[ImaginaryI]", "  ", 
    FractionBox[
     RowBox[{"s", "-", 
      RowBox[{"Ceiling", "[", 
       RowBox[{"n", "/", "2"}], "]"}]}], 
     RowBox[{"n", " ", "\[CapitalDelta]x"}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"r", " ", "\[CapitalDelta]x"}], "+", "xmin"}], ")"}]}], "==", 
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}], "n"], 
     RowBox[{"(", 
      RowBox[{"s", "-", "1"}], ")"}], 
     RowBox[{"(", 
      RowBox[{"r", "-", "1"}], ")"}]}], "+", 
    RowBox[{"s", " ", 
     RowBox[{"(", 
      FractionBox[
       RowBox[{"2", " ", "\[ImaginaryI]", " ", "\[Pi]", " ", 
        RowBox[{"(", 
         RowBox[{"xmin", "+", "\[CapitalDelta]x"}], ")"}]}], 
       RowBox[{"n", " ", "\[CapitalDelta]x"}]], ")"}]}], "-", 
    RowBox[{"r", " ", 
     RowBox[{"(", 
      FractionBox[
       RowBox[{"2", " ", "\[ImaginaryI]", " ", "\[Pi]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{"Ceiling", "[", 
           FractionBox["n", "2"], "]"}]}], ")"}]}], "n"], ")"}]}], "-", 
    FractionBox[
     RowBox[{"2", " ", "\[ImaginaryI]", " ", "\[Pi]", " ", 
      RowBox[{"(", 
       RowBox[{"\[CapitalDelta]x", "+", 
        RowBox[{"xmin", " ", 
         RowBox[{"Ceiling", "[", 
          FractionBox["n", "2"], "]"}]}]}], ")"}]}], 
     RowBox[{"n", " ", "\[CapitalDelta]x"}]]}]}], "\[IndentingNewLine]", 
  "]"}]], "Input"],

Cell[BoxData["True"], "Output"]
}, Open  ]],

Cell[TextData[{
 "Inserting this expanded exponent, one can obtain the expression for the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Fourier transformation ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"Fourier", "[", 
    SubscriptBox["f", "r"], "]"}], " ", "=", " ", 
   RowBox[{
    FractionBox["1", 
     SqrtBox["n"]], 
    RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"r", "=", "1"}], "N"], 
     RowBox[{
      SubscriptBox["f", "r"], " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        FractionBox[
         RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}], "n"], " ", 
        RowBox[{"(", 
         RowBox[{"s", "-", "1"}], ")"}], 
        RowBox[{"(", 
         RowBox[{"r", "-", "1"}], ")"}]}]]}]}]}]}]]],
 "."
}], "Text"],

Cell[BoxData[{
 SubscriptBox[
  OverscriptBox["f", "^"], "s"], "\[IndentingNewLine]", 
 RowBox[{"==", 
  RowBox[{"\[CapitalDelta]x", 
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"r", "=", "1"}], "N"], 
    RowBox[{
     RowBox[{"Conjugate", "[", 
      RowBox[{"f", "[", 
       RowBox[{
        RowBox[{"r", " ", "\[CapitalDelta]x"}], " ", "+", " ", 
        SubscriptBox["x", "min"]}], "]"}], "]"}], " ", 
     RowBox[{
      SubscriptBox["\[Phi]", "s"], "[", 
      RowBox[{
       RowBox[{"r", " ", "\[CapitalDelta]x"}], " ", "+", " ", 
       SubscriptBox["x", "min"]}], "]"}]}]}]}]}], "\n", 
 RowBox[{"\[Equal]", " ", 
  RowBox[{"\[CapitalDelta]x", 
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"r", "=", "1"}], "N"], 
    RowBox[{
     RowBox[{"Conjugate", "[", 
      SubscriptBox["f", "r"], "]"}], " ", 
     FractionBox["1", 
      SqrtBox[
       RowBox[{"n", " ", "\[CapitalDelta]x"}]]], 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"2", " ", "\[Pi]", " ", "\[ImaginaryI]", "  ", 
       FractionBox[
        RowBox[{"s", " ", "-", 
         RowBox[{"Ceiling", "[", 
          RowBox[{"n", "/", "2"}], "]"}]}], 
        RowBox[{"n", " ", "\[CapitalDelta]x"}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"r", " ", "\[CapitalDelta]x"}], "+", 
         SubscriptBox["x", "min"]}], ")"}]}]]}]}]}]}], "\n", 
 RowBox[{"\[Equal]", " ", 
  RowBox[{"\[CapitalDelta]x", 
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"r", "=", "1"}], "N"], 
    RowBox[{
     RowBox[{"Conjugate", "[", 
      SubscriptBox["f", "r"], "]"}], " ", 
     FractionBox["1", 
      SqrtBox[
       RowBox[{"n", " ", "\[CapitalDelta]x"}]]], 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{
        FractionBox[
         RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}], "n"], 
        RowBox[{"(", 
         RowBox[{"s", "-", "1"}], ")"}], 
        RowBox[{"(", 
         RowBox[{"r", "-", "1"}], ")"}]}], "+", 
       RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]", " ", "s", " ", 
        FractionBox[
         RowBox[{
          SubscriptBox["x", "min"], "+", "\[CapitalDelta]x"}], 
         RowBox[{"n", " ", "\[CapitalDelta]x"}]]}], "+", 
       RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]", " ", "r", " ", 
        FractionBox[
         RowBox[{"1", "-", 
          RowBox[{"Ceiling", "[", 
           FractionBox["n", "2"], "]"}]}], "n"]}], "-", 
       RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]", 
        FractionBox[
         RowBox[{"\[CapitalDelta]x", "+", 
          RowBox[{
           SubscriptBox["x", "min"], " ", 
           RowBox[{"Ceiling", "[", 
            FractionBox["n", "2"], "]"}]}]}], 
         RowBox[{"n", " ", "\[CapitalDelta]x"}]]}]}]]}]}]}]}], "\n", 
 RowBox[{"\[Equal]", " ", 
  RowBox[{"\[CapitalDelta]x", 
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"r", "=", "1"}], "N"], 
    RowBox[{
     RowBox[{"Conjugate", "[", 
      SubscriptBox["f", "r"], "]"}], " ", 
     FractionBox["1", 
      SqrtBox[
       RowBox[{"n", " ", "\[CapitalDelta]x"}]]], 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       FractionBox[
        RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}], "n"], 
       RowBox[{"(", 
        RowBox[{"s", "-", "1"}], ")"}], 
       RowBox[{"(", 
        RowBox[{"r", "-", "1"}], ")"}]}]], 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]", " ", "s", " ", 
       FractionBox[
        RowBox[{
         SubscriptBox["x", "min"], "+", "\[CapitalDelta]x"}], 
        RowBox[{"n", " ", "\[CapitalDelta]x"}]]}]], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]", " ", "r", " ", 
       FractionBox[
        RowBox[{"1", "-", 
         RowBox[{"Ceiling", "[", 
          FractionBox["n", "2"], "]"}]}], "n"]}]], 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]", 
       FractionBox[
        RowBox[{"\[CapitalDelta]x", "+", 
         RowBox[{
          SubscriptBox["x", "min"], " ", 
          RowBox[{"Ceiling", "[", 
           FractionBox["n", "2"], "]"}]}]}], 
        RowBox[{"n", " ", "\[CapitalDelta]x"}]]}]]}]}]}]}], "\n", 
 RowBox[{
  RowBox[{"\[Equal]", " ", 
   RowBox[{
    SqrtBox["\[CapitalDelta]x"], 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]", 
      FractionBox[
       RowBox[{"\[CapitalDelta]x", "+", 
        RowBox[{
         SubscriptBox["x", "min"], " ", 
         RowBox[{"Ceiling", "[", 
          FractionBox["n", "2"], "]"}]}]}], 
       RowBox[{"n", " ", "\[CapitalDelta]x"}]]}]], 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]", " ", "s", " ", 
      FractionBox[
       RowBox[{
        SubscriptBox["x", "min"], "+", "\[CapitalDelta]x"}], 
       RowBox[{"n", " ", "\[CapitalDelta]x"}]]}]], 
    FractionBox["1", 
     SqrtBox["n"]], 
    RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"r", "=", "1"}], "N"], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]", " ", "r", " ", 
          FractionBox[
           RowBox[{"1", "-", 
            RowBox[{"Ceiling", "[", 
             FractionBox["n", "2"], "]"}]}], "n"]}]], 
        RowBox[{"Conjugate", "[", 
         SubscriptBox["f", "r"], "]"}]}], ")"}], " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        FractionBox[
         RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}], "n"], 
        RowBox[{"(", 
         RowBox[{"s", "-", "1"}], ")"}], 
        RowBox[{"(", 
         RowBox[{"r", "-", "1"}], ")"}]}]]}]}]}]}], " "}], "\n", 
 RowBox[{"\[Equal]", 
  RowBox[{
   SqrtBox["\[CapitalDelta]x"], 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]", " ", 
     FractionBox[
      RowBox[{
       RowBox[{"s", " ", 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["x", "min"], "+", "\[CapitalDelta]x"}], ")"}]}], "-", 
       "\[CapitalDelta]x", "-", 
       RowBox[{
        SubscriptBox["x", "min"], " ", 
        RowBox[{"Ceiling", "[", 
         FractionBox["n", "2"], "]"}]}]}], 
      RowBox[{"n", " ", "\[CapitalDelta]x"}]]}]], 
   RowBox[{"Fourier", "[", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]", " ", "r", " ", 
       FractionBox[
        RowBox[{"1", "-", 
         RowBox[{"Ceiling", "[", 
          FractionBox["n", "2"], "]"}]}], "n"]}]], 
     RowBox[{"Conjugate", "[", 
      SubscriptBox["f", "r"], "]"}]}], "]"}]}]}]}], "Input",
 Evaluatable->False],

Cell["\<\
The phase factors within the Fourier-command lead to and a cyclic shift and a \
constant phase factor in the result.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Fourier", "[", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]", " ", "r", " ", 
      FractionBox[
       RowBox[{"1", "-", 
        RowBox[{"Ceiling", "[", 
         FractionBox["n", "2"], "]"}]}], "n"]}]], 
    RowBox[{"Conjugate", "[", 
     SubscriptBox["f", "r"], "]"}]}], "]"}], "==", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"2", " ", "\[ImaginaryI]", " ", "\[Pi]", " ", 
     FractionBox[
      RowBox[{"1", "-", 
       RowBox[{"Ceiling", "[", 
        FractionBox["n", "2"], "]"}]}], "n"]}]], " ", 
   RowBox[{"RotateLeft", "[", 
    RowBox[{
     RowBox[{"Fourier", "[", 
      RowBox[{"Conjugate", "[", 
       SubscriptBox["f", "r"], "]"}], "]"}], ",", " ", 
     RowBox[{"1", "-", 
      RowBox[{"Ceiling", "[", 
       FractionBox["n", "2"], "]"}]}]}], "]"}]}]}]], "Input",
 Evaluatable->False],

Cell["\<\
Hence, one can simplify the Fourier transformation even further to\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   OverscriptBox["p", "^"], "s"], "==", 
  RowBox[{
   SqrtBox["\[CapitalDelta]x"], 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]", " ", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["x", "min"], "+", "\[CapitalDelta]x"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"s", "-", 
         RowBox[{"Ceiling", "[", 
          FractionBox["n", "2"], "]"}]}], ")"}]}], 
      RowBox[{"n", " ", "\[CapitalDelta]x"}]]}]], " ", 
   RowBox[{"RotateLeft", "[", 
    RowBox[{
     RowBox[{"Fourier", "[", 
      RowBox[{"Conjugate", "[", 
       SubscriptBox["f", "r"], "]"}], "]"}], ",", " ", 
     RowBox[{"1", "-", 
      RowBox[{"Ceiling", "[", 
       FractionBox["n", "2"], "]"}]}]}], "]"}]}]}]], "Input",
 Evaluatable->False],

Cell[TextData[{
 "Inserting the conversion factor  ",
 Cell[BoxData[
  SqrtBox[
   FractionBox[
    RowBox[{
     RowBox[{"Abs", "[", "b", "]"}], "\[CapitalDelta]x", " ", "nx"}], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"2", "\[Pi]"}], ")"}], 
     RowBox[{"1", "-", "a"}]]]]]],
 " that takes the normalization for the interval ",
 Cell[BoxData[
  RowBox[{"[", 
   RowBox[{
    SubscriptBox["x", "min"], ",", " ", 
    SubscriptBox["x", "max"]}], "]"}]]],
 " to the infinite normalization ",
 Cell[BoxData[
  SqrtBox[
   FractionBox[
    RowBox[{"Abs", "[", "b", "]"}], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"2", "\[Pi]"}], ")"}], 
     RowBox[{"1", "-", "a"}]]]]]],
 ", with ",
 Cell[BoxData[
  RowBox[{"FourierParameters", " ", "->", " ", 
   RowBox[{"{", 
    RowBox[{"a", ",", " ", "b"}], "}"}]}]]],
 "."
}], "Text"],

Cell[TextData[{
 "The above FFT in ",
 StyleBox["Mathematica ",
  FontSlant->"Italic"],
 "assuming real-valued ",
 Cell[BoxData[
  SubscriptBox["p", "r"]]],
 " is in one- and multi-dimensions:"
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ListFourierPositions", "[", 
    RowBox[{"n_", ",", 
     RowBox[{"{", 
      RowBox[{"xmin_", ",", "xmax_"}], "}"}]}], "]"}], ":=", " ", 
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"xmax", "-", "xmin"}], "n"], 
     RowBox[{"Range", "[", "n", "]"}]}], "+", "xmin"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListFourierPositions", "[", 
   RowBox[{"n_List", ",", 
    RowBox[{"domains", ":", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "_"}], "}"}], ".."}]}]}], "]"}], ":=", " ", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{"-", 
      RowBox[{"Apply", "[", 
       RowBox[{"Subtract", ",", 
        RowBox[{"{", "domains", "}"}], ",", 
        RowBox[{"{", "1", "}"}]}], "]"}]}], "n"], 
    RowBox[{"Range", "[", "n", "]"}]}], "+", 
   RowBox[{"Map", "[", 
    RowBox[{"First", ",", 
     RowBox[{"{", "domains", "}"}]}], "]"}]}]}]}], "PackageInput"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ListFourierFrequencies", "[", 
    RowBox[{"n_", ",", 
     RowBox[{"{", 
      RowBox[{"xmin_", ",", "xmax_"}], "}"}]}], "]"}], ":=", " ", 
   RowBox[{
    FractionBox[
     RowBox[{"2", "\[Pi]"}], 
     RowBox[{"xmax", "-", "xmin"}]], 
    RowBox[{"Range", "[", 
     RowBox[{
      RowBox[{"1", "-", 
       RowBox[{"Ceiling", "[", 
        FractionBox["n", "2"], "]"}]}], ",", 
      RowBox[{"n", "-", 
       RowBox[{"Ceiling", "[", 
        FractionBox["n", "2"], "]"}]}]}], "]"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListFourierFrequencies", "[", 
   RowBox[{"n_List", ",", 
    RowBox[{"domains", ":", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "_"}], "}"}], ".."}]}]}], "]"}], ":=", " ", 
  RowBox[{
   FractionBox[
    RowBox[{"2", "\[Pi]"}], 
    RowBox[{"-", 
     RowBox[{"Apply", "[", 
      RowBox[{"Subtract", ",", 
       RowBox[{"{", "domains", "}"}], ",", 
       RowBox[{"{", "1", "}"}]}], "]"}]}]], 
   RowBox[{"Range", "[", 
    RowBox[{
     RowBox[{"1", "-", 
      RowBox[{"Ceiling", "[", 
       FractionBox["n", "2"], "]"}]}], ",", 
     RowBox[{"n", "-", 
      RowBox[{"Ceiling", "[", 
       FractionBox["n", "2"], "]"}]}]}], "]"}]}]}]}], "PackageInput"],

Cell[TextData[{
 StyleBox["nDimensionalFourier [array,d]", "MR"],
 " performs an FFT on only the first ",
 StyleBox["d", "MR"],
 " dimensions of an array. ",
 StyleBox["Fourier", "MR"],
 " always transforms the complete array."
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"nDimensionalFourier", "[", 
   RowBox[{"f_List", ",", "d_Integer"}], "]"}], ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Transpose", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Map", "[", "\[IndentingNewLine]", 
       RowBox[{"Fourier", ",", "\[IndentingNewLine]", 
        RowBox[{"Transpose", "[", "\[IndentingNewLine]", 
         RowBox[{"f", ",", "\[IndentingNewLine]", 
          RowBox[{"RotateRight", "[", 
           RowBox[{"#", ",", "d"}], "]"}]}], "\[IndentingNewLine]", "]"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Length", "[", "#", "]"}], "-", "d"}], "}"}]}], 
       "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"RotateLeft", "[", 
       RowBox[{"#", ",", "d"}], "]"}]}], "\[IndentingNewLine]", "]"}], "&"}], 
   "[", 
   RowBox[{"Range", "[", 
    RowBox[{"ArrayDepth", "[", "f", "]"}], "]"}], "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[TextData[{
 StyleBox["nDimensionalInverseFourier[array,d]", "MR"],
 " performs an inverse FFT on only the first d dimensions of an array.",
 StyleBox["InverseFourier", "MR"],
 " always transforms the complete array."
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"nDimensionalInverseFourier", "[", 
    RowBox[{"f_List", ",", "d_Integer"}], "]"}], ":=", " ", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Transpose", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Map", "[", "\[IndentingNewLine]", 
        RowBox[{"InverseFourier", ",", "\[IndentingNewLine]", 
         RowBox[{"Transpose", "[", "\[IndentingNewLine]", 
          RowBox[{"f", ",", "\[IndentingNewLine]", 
           RowBox[{"RotateRight", "[", 
            RowBox[{"#", ",", "d"}], "]"}]}], "\[IndentingNewLine]", "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Length", "[", "#", "]"}], "-", "d"}], "}"}]}], 
        "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"RotateLeft", "[", 
        RowBox[{"#", ",", "d"}], "]"}]}], "\[IndentingNewLine]", "]"}], "&"}],
     "[", 
    RowBox[{"Range", "[", 
     RowBox[{"ArrayDepth", "[", "f", "]"}], "]"}], "]"}]}], 
  ";"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ArrayTimes", "[", 
     RowBox[{
      RowBox[{"1", "|", 
       RowBox[{"{", 
        RowBox[{"1.", "."}], "}"}]}], ",", "tensor_"}], "]"}], "=", " ", 
    "tensor"}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ArrayTimes", "[", 
   RowBox[{
    RowBox[{"{", "vecs__", "}"}], ",", "tensor_"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"transpositions", "=", 
       RowBox[{"RotateRight", "[", 
        RowBox[{"Range", "[", 
         RowBox[{"ArrayDepth", "[", "tensor", "]"}], "]"}], "]"}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"Transpose", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Fold", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{
            RowBox[{"#2", " ", "#1"}], ",", "transpositions"}], "]"}], "&"}], 
         ",", "tensor", ",", 
         RowBox[{"{", "vecs", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"RotateRight", "[", 
        RowBox[{"transpositions", ",", 
         RowBox[{
          RowBox[{"ArrayDepth", "[", "tensor", "]"}], "-", 
          RowBox[{"Length", "[", 
           RowBox[{"{", "vecs", "}"}], "]"}], "-", "1"}]}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], "/;", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"Map", "[", 
      RowBox[{"Length", ",", 
       RowBox[{"{", "vecs", "}"}]}], "]"}], ",", 
     RowBox[{"Thread", "[", 
      RowBox[{
       RowBox[{"Take", "[", 
        RowBox[{
         RowBox[{"Dimensions", "[", "tensor", "]"}], ",", 
         RowBox[{"Length", "[", 
          RowBox[{"{", "vecs", "}"}], "]"}]}], "]"}], "|", "0"}], "]"}]}], 
    "]"}]}]}]}], "PackageInput"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ListFourierTransform", "[", 
     RowBox[{"f_List", ",", 
      RowBox[{"{", 
       RowBox[{"xmin_", ",", "xmax_"}], "}"}], ",", " ", "opts___Rule"}], 
     "]"}], " ", ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[CapitalDelta]x", " ", ",", 
        RowBox[{"n", " ", "=", " ", 
         RowBox[{"Length", "[", "f", "]"}]}], ",", 
        RowBox[{"r", " ", "=", " ", 
         RowBox[{"ArrayDepth", "[", "f", "]"}]}], ",", "a", ",", "b", ",", 
        " ", 
        RowBox[{"filter", "=", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"a", ",", "b"}], "}"}], "=", " ", 
        RowBox[{
         RowBox[{"FourierParameters", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "FourierTransform", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[CapitalDelta]x", " ", "=", " ", 
        FractionBox[
         RowBox[{"xmax", "-", "xmin"}], "n"]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ListFourierFilter", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "ListFourierTransform", "]"}]}], ",", 
           RowBox[{"True", "|", 
            RowBox[{"{", 
             RowBox[{"True", ",", "___"}], "}"}]}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"filter", " ", "=", " ", 
          RowBox[{"N", "[", 
           RowBox[{"Exp", "[", 
            RowBox[{"-", 
             FractionBox[
              RowBox[{"18", " ", 
               SuperscriptBox[
                RowBox[{"ListFourierPositions", "[", 
                 RowBox[{"n", ",", 
                  RowBox[{"{", 
                   RowBox[{"xmin", ",", "xmax"}], "}"}]}], "]"}], "2"]}], 
              SuperscriptBox[
               RowBox[{"Abs", "[", 
                RowBox[{"xmax", "-", "xmin"}], "]"}], "2"]]}], "]"}], 
           "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        SqrtBox[
         FractionBox[
          RowBox[{
           RowBox[{"Abs", "[", "b", "]"}], "n"}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"2", "\[Pi]"}], ")"}], 
           RowBox[{"1", "-", "a"}]]]], " ", "\[CapitalDelta]x", " ", 
        RowBox[{"Chop", "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"N", "[", 
             RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]", " ", 
              FractionBox[
               RowBox[{"xmin", "+", "\[CapitalDelta]x"}], 
               RowBox[{"n", " ", "\[CapitalDelta]x"}]]}], "]"}], " ", 
            RowBox[{"Range", "[", 
             RowBox[{
              RowBox[{"1", "-", 
               RowBox[{"Ceiling", "[", 
                FractionBox["n", "2"], "]"}]}], ",", 
              RowBox[{"n", "-", 
               RowBox[{"Ceiling", "[", 
                FractionBox["n", "2"], "]"}]}]}], "]"}]}], "]"}], ",", 
          "$MachineEpsilon"}], "]"}], "*", "\[IndentingNewLine]", 
        RowBox[{"RotateLeft", "[", 
         RowBox[{
          RowBox[{"nDimensionalFourier", "[", 
           RowBox[{
            RowBox[{"filter", " ", "f"}], ",", "1"}], "]"}], ",", 
          RowBox[{"1", "-", 
           RowBox[{"Ceiling", "[", 
            FractionBox["n", "2"], "]"}]}]}], "]"}]}]}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListFourierTransform", "[", 
   RowBox[{
    RowBox[{"f_", "?", "ArrayQ"}], ",", 
    RowBox[{"domains", ":", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "_"}], "}"}], ".."}]}], ",", " ", "opts___Rule"}], 
   "]"}], " ", ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[CapitalDelta]", " ", ",", 
       RowBox[{"n", "=", " ", 
        RowBox[{"Take", "[", 
         RowBox[{
          RowBox[{"Dimensions", "[", "f", "]"}], ",", 
          RowBox[{"Length", "[", 
           RowBox[{"{", "domains", "}"}], "]"}]}], "]"}]}], ",", "a", ",", 
       "b", ",", " ", "filter", ",", "filterBooleans"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}], "=", " ", 
       RowBox[{
        RowBox[{"FourierParameters", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "FourierTransform", "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[CapitalDelta]", " ", "=", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Apply", "[", 
          RowBox[{"Subtract", ",", 
           RowBox[{"{", "domains", "}"}], ",", 
           RowBox[{"{", "1", "}"}]}], "]"}]}], "/", "n"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"filterBooleans", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"PadRight", "[", 
          RowBox[{"#", ",", 
           RowBox[{"Length", "[", 
            RowBox[{"{", "domains", "}"}], "]"}], ",", "#"}], "]"}], "&"}], 
        "[", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Head", "[", "#", "]"}], "===", "List"}], ",", "#", ",", 
            RowBox[{"{", "#", "}"}]}], "]"}], "&"}], "[", 
         RowBox[{
          RowBox[{"ListFourierFilter", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "ListFourierTransform", "]"}]}], "]"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"filter", "=", 
       RowBox[{"MapThread", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{"#1", ",", "#2", ",", "1", ",", "1"}], "]"}], "&"}], ",", 
         RowBox[{"{", 
          RowBox[{"filterBooleans", ",", 
           RowBox[{"N", "[", 
            RowBox[{"Exp", "[", 
             RowBox[{"-", 
              FractionBox[
               RowBox[{"18", " ", 
                SuperscriptBox[
                 RowBox[{"ListFourierPositions", "[", 
                  RowBox[{"n", ",", "domains"}], "]"}], "2"]}], 
               SuperscriptBox[
                RowBox[{"Abs", "[", 
                 RowBox[{"Apply", "[", 
                  RowBox[{"Subtract", ",", 
                   RowBox[{"{", "domains", "}"}], ",", 
                   RowBox[{"{", "1", "}"}]}], "]"}], "]"}], "2"]]}], "]"}], 
            "]"}]}], "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ArrayTimes", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         SqrtBox[
          FractionBox[
           RowBox[{
            RowBox[{"Abs", "[", "b", "]"}], "n"}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"2", "\[Pi]"}], ")"}], 
            RowBox[{"(", 
             RowBox[{"1", "-", "a"}], ")"}]]]], " ", "\[CapitalDelta]", " ", 
         RowBox[{"Chop", "[", 
          RowBox[{
           RowBox[{"Exp", "[", 
            RowBox[{
             RowBox[{"N", "[", 
              RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]", " ", 
               FractionBox[
                RowBox[{
                 RowBox[{"Map", "[", 
                  RowBox[{"First", ",", 
                   RowBox[{"{", "domains", "}"}]}], "]"}], "+", 
                 "\[CapitalDelta]"}], 
                RowBox[{"n", " ", "\[CapitalDelta]"}]]}], "]"}], 
             RowBox[{"Range", "[", 
              RowBox[{
               RowBox[{"1", "-", 
                RowBox[{"Ceiling", "[", 
                 FractionBox["n", "2"], "]"}]}], ",", 
               RowBox[{"n", "-", 
                RowBox[{"Ceiling", "[", 
                 FractionBox["n", "2"], "]"}]}]}], "]"}]}], "]"}], ",", 
           "$MachineEpsilon"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"RotateLeft", "[", 
         RowBox[{
          RowBox[{"nDimensionalFourier", "[", 
           RowBox[{
            RowBox[{"ArrayTimes", "[", 
             RowBox[{"filter", ",", "f"}], "]"}], ",", 
            RowBox[{"Length", "[", 
             RowBox[{"{", "domains", "}"}], "]"}]}], "]"}], ",", " ", 
          RowBox[{"1", "-", 
           RowBox[{"Ceiling", "[", 
            FractionBox["n", "2"], "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
       "]"}]}]}], "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{
    RowBox[{"ArrayDepth", "[", "f", "]"}], "\[GreaterEqual]", 
    RowBox[{"Length", "[", 
     RowBox[{"{", "domains", "}"}], "]"}]}]}]}]}], "PackageInput",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ListInverseFourierTransform", "[", 
    RowBox[{"f_List", ",", 
     RowBox[{"{", 
      RowBox[{"xmin_", ",", "xmax_"}], "}"}], ",", "opts___Rule"}], "]"}], 
   " ", ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[CapitalDelta]x", " ", ",", 
       RowBox[{"n", " ", "=", " ", 
        RowBox[{"Length", "[", "f", "]"}]}], ",", "a", ",", "b", ",", " ", 
       RowBox[{"filter", "=", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}], "=", " ", 
       RowBox[{
        RowBox[{"FourierParameters", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "InverseFourierTransform", "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[CapitalDelta]x", " ", "=", " ", 
       FractionBox[
        RowBox[{"xmax", "-", "xmin"}], "n"]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MatchQ", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ListFourierFilter", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "ListInverseFourierTransform", "]"}]}], 
          ",", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ",", "___"}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"filter", " ", "=", " ", 
         RowBox[{"N", "[", 
          RowBox[{"Exp", "[", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"9", " ", 
              SuperscriptBox[
               RowBox[{"Abs", "[", 
                RowBox[{"xmax", "-", "xmin"}], "]"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{"ListFourierFrequencies", "[", 
                RowBox[{"n", ",", 
                 RowBox[{"{", 
                  RowBox[{"xmin", ",", "xmax"}], "}"}]}], "]"}], "2"]}], 
             RowBox[{"2", " ", 
              SuperscriptBox["\[Pi]", "2"], " ", 
              SuperscriptBox["n", "2"]}]]}], "]"}], "]"}]}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"nDimensionalInverseFourier", "[", 
       RowBox[{
        RowBox[{"RotateRight", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           SqrtBox[
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"2", "\[Pi]"}], ")"}], 
              RowBox[{"1", "-", "a"}]], 
             RowBox[{
              RowBox[{"Abs", "[", "b", "]"}], "n"}]]], 
           FractionBox["1", "\[CapitalDelta]x"], 
           RowBox[{"Chop", "[", 
            RowBox[{
             RowBox[{"filter", " ", 
              RowBox[{"Exp", "[", 
               RowBox[{
                RowBox[{"N", "[", 
                 RowBox[{
                  RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]", " ", 
                  FractionBox[
                   RowBox[{"xmin", "+", "\[CapitalDelta]x"}], 
                   RowBox[{"n", " ", "\[CapitalDelta]x"}]]}], "]"}], " ", 
                RowBox[{"Range", "[", 
                 RowBox[{
                  RowBox[{"1", "-", 
                   RowBox[{"Ceiling", "[", 
                    FractionBox["n", "2"], "]"}]}], ",", 
                  RowBox[{"n", "-", 
                   RowBox[{"Ceiling", "[", 
                    FractionBox["n", "2"], "]"}]}]}], "]"}]}], "]"}]}], ",", 
             "$MachineEpsilon"}], "]"}], " ", "*", " ", "f"}], " ", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"1", "-", 
           RowBox[{"Ceiling", "[", 
            FractionBox["n", "2"], "]"}]}]}], "\[IndentingNewLine]", "]"}], 
        ",", "\[IndentingNewLine]", "1"}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ListInverseFourierTransform", "[", 
   RowBox[{
    RowBox[{"f_", "?", "ArrayQ"}], ",", 
    RowBox[{"domains", ":", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "_"}], "}"}], ".."}]}], ",", " ", "opts___Rule"}], 
   "]"}], " ", ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[CapitalDelta]", " ", ",", 
       RowBox[{"n", "=", " ", 
        RowBox[{"Take", "[", 
         RowBox[{
          RowBox[{"Dimensions", "[", "f", "]"}], ",", 
          RowBox[{"Length", "[", 
           RowBox[{"{", "domains", "}"}], "]"}]}], "]"}]}], ",", "a", ",", 
       "b", ",", "filter", ",", "filterBooleans"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}], "=", " ", 
       RowBox[{
        RowBox[{"FourierParameters", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "InverseFourierTransform", "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[CapitalDelta]", " ", "=", " ", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Apply", "[", 
          RowBox[{"Subtract", ",", 
           RowBox[{"{", "domains", "}"}], ",", 
           RowBox[{"{", "1", "}"}]}], "]"}]}], "/", "n"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"filterBooleans", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"PadRight", "[", 
          RowBox[{"#", ",", 
           RowBox[{"Length", "[", 
            RowBox[{"{", "domains", "}"}], "]"}], ",", "#"}], "]"}], "&"}], 
        "[", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Head", "[", "#", "]"}], "===", "List"}], ",", "#", ",", 
            RowBox[{"{", "#", "}"}]}], "]"}], "&"}], "[", 
         RowBox[{
          RowBox[{"ListFourierFilter", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "ListFourierTransform", "]"}]}], "]"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"filter", "=", 
       RowBox[{"MapThread", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{"#1", ",", "#2", ",", "1", ",", "1"}], "]"}], "&"}], ",", 
         RowBox[{"{", 
          RowBox[{"filterBooleans", ",", 
           RowBox[{"N", "[", 
            RowBox[{"Exp", "[", 
             RowBox[{"-", 
              FractionBox[
               RowBox[{"9", " ", 
                SuperscriptBox[
                 RowBox[{"Abs", "[", 
                  RowBox[{"Apply", "[", 
                   RowBox[{"Subtract", ",", 
                    RowBox[{"{", "domains", "}"}], ",", 
                    RowBox[{"{", "1", "}"}]}], "]"}], "]"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"ListFourierFrequencies", "[", 
                  RowBox[{"n", ",", "domains"}], "]"}], "2"]}], 
               RowBox[{"2", " ", 
                SuperscriptBox["\[Pi]", "2"], " ", 
                SuperscriptBox["n", "2"]}]]}], "]"}], "]"}]}], "}"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"nDimensionalInverseFourier", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"RotateRight", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ArrayTimes", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             SqrtBox[
              FractionBox[
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"2", "\[Pi]"}], ")"}], 
                RowBox[{"(", 
                 RowBox[{"1", "-", "a"}], ")"}]], 
               RowBox[{
                RowBox[{"Abs", "[", "b", "]"}], "n"}]]], " ", 
             FractionBox["1", "\[CapitalDelta]"], 
             RowBox[{"Chop", "[", 
              RowBox[{
               RowBox[{"filter", " ", 
                RowBox[{"Exp", "[", 
                 RowBox[{
                  RowBox[{"N", "[", 
                   RowBox[{
                    RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]", " ", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"Map", "[", 
                    RowBox[{"First", ",", 
                    RowBox[{"{", "domains", "}"}]}], "]"}], "+", 
                    "\[CapitalDelta]"}], 
                    RowBox[{"n", " ", "\[CapitalDelta]"}]]}], "]"}], 
                  RowBox[{"Range", "[", 
                   RowBox[{
                    RowBox[{"1", "-", 
                    RowBox[{"Ceiling", "[", 
                    FractionBox["n", "2"], "]"}]}], ",", 
                    RowBox[{"n", "-", 
                    RowBox[{"Ceiling", "[", 
                    FractionBox["n", "2"], "]"}]}]}], "]"}]}], "]"}]}], ",", 
               "$MachineEpsilon"}], "]"}]}], ",", "\[IndentingNewLine]", 
            "f"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"1", "-", 
           RowBox[{"Ceiling", "[", 
            FractionBox["n", "2"], "]"}]}]}], "\[IndentingNewLine]", "]"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"Length", "[", 
         RowBox[{"{", "domains", "}"}], "]"}]}], "\[IndentingNewLine]", 
       "]"}]}]}], "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{
    RowBox[{"ArrayDepth", "[", "f", "]"}], "\[GreaterEqual]", 
    RowBox[{"Length", "[", 
     RowBox[{"{", "domains", "}"}], "]"}]}]}]}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ListFourierTransform", ",", "ListInverseFourierTransform", ",", 
       "ArrayTimes", ",", "ListFourierPositions", ",", 
       "ListFourierFrequencies"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Protected", ",", " ", "ReadProtected"}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1021, 921},
WindowMargins->{{92, Automatic}, {Automatic, 6}},
ShowSelection->True,
Magnification->1,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (November 10, 2008)",
StyleDefinitions->"PackageNotebook.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 110, 1, 96, "Title"],
Cell[680, 25, 100, 4, 79, "Subsubtitle"],
Cell[CellGroupData[{
Cell[805, 33, 25, 0, 48, "Section"],
Cell[833, 35, 934, 24, 161, "PackageInput"],
Cell[1770, 61, 128, 3, 26, "Text"],
Cell[1901, 66, 3070, 85, 491, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5008, 156, 32, 0, 28, "Section"],
Cell[5043, 158, 92, 2, 32, "Text"],
Cell[5138, 162, 463, 10, 123, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5638, 177, 42, 0, 28, "Section"],
Cell[5683, 179, 4628, 90, 725, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[10348, 274, 29, 0, 28, "Section"],
Cell[10380, 276, 390, 9, 56, "Text"],
Cell[10773, 287, 777, 31, 37, "Text"],
Cell[11553, 320, 1142, 47, 51, "Text"],
Cell[12698, 369, 227, 9, 26, "Text"],
Cell[12928, 380, 311, 9, 48, "Input"],
Cell[13242, 391, 213, 9, 37, "Text"],
Cell[13458, 402, 554, 18, 26, "Text"],
Cell[14015, 422, 698, 21, 50, "Input"],
Cell[14716, 445, 819, 27, 52, "Text"],
Cell[15538, 474, 478, 17, 36, "Text"],
Cell[16019, 493, 54, 0, 26, "Text"],
Cell[16076, 495, 1055, 32, 92, "Input"],
Cell[17134, 529, 337, 13, 26, "Text"],
Cell[17474, 544, 95, 2, 26, "Text"],
Cell[CellGroupData[{
Cell[17594, 550, 1554, 44, 154, "Input"],
Cell[19151, 596, 31, 0, 24, "Output"]
}, Open  ]],
Cell[19197, 599, 768, 26, 44, "Text"],
Cell[19968, 627, 6668, 191, 321, "Input",
 Evaluatable->False],
Cell[26639, 820, 140, 3, 26, "Text"],
Cell[26782, 825, 917, 27, 51, "Input",
 Evaluatable->False],
Cell[27702, 854, 90, 2, 26, "Text"],
Cell[27795, 858, 853, 26, 51, "Input",
 Evaluatable->False],
Cell[28651, 886, 849, 32, 52, "Text"],
Cell[29503, 920, 205, 8, 26, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[29745, 933, 31, 0, 28, "Section"],
Cell[29779, 935, 60, 0, 32, "Text"],
Cell[29842, 937, 108, 2, 43, "PackageInput",
 InitializationCell->True],
Cell[29953, 941, 974, 31, 109, "PackageInput"],
Cell[30930, 974, 1290, 42, 127, "PackageInput"],
Cell[32223, 1018, 239, 7, 32, "Text"],
Cell[32465, 1027, 1029, 25, 219, "PackageInput",
 InitializationCell->True],
Cell[33497, 1054, 233, 5, 32, "Text"],
Cell[33733, 1061, 1087, 27, 219, "PackageInput",
 InitializationCell->True],
Cell[34823, 1090, 1883, 53, 187, "PackageInput"],
Cell[36709, 1145, 8786, 228, 625, "PackageInput",
 InitializationCell->True],
Cell[45498, 1375, 9489, 237, 841, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[55024, 1617, 34, 0, 28, "Section"],
Cell[55061, 1619, 64, 0, 32, "Text"],
Cell[55128, 1621, 664, 16, 155, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
