(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     99754,       2541]
NotebookOptionsPosition[     50283,       1471]
NotebookOutlinePosition[     97175,       2461]
CellTagsIndexPosition[     97132,       2458]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
 "MRI Tagging",
 StyleBox[" ",
  FontColor->RGBColor[1, 0, 1]],
 "Package"
}], "Title"],

Cell["\<\
Markus van Almsick, TU Eindhoven
\[Copyright]2010\
\>", "Subsubtitle"],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "[", "\"\<MathVisionTools`MRITagging`\>\"", "]"}], 
     " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"2010", ",", "2", ",", "2", ",", "10", ",", "0", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput"],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`MRITagging`"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Author", ":", " ", 
     RowBox[{"Markus", " ", "van", " ", "Almsick"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"m", ".", "v", ".", 
       RowBox[{"almsick", "@", "tue"}], ".", "nl"}]}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`BSpline`"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "1.0"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "7.0"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2010"}]}]}], ",", " ", 
    RowBox[{"Markus", " ", "van", " ", "Almsick"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "MRITagging"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "provides", " ", "functions", " ", "needed",
       " ", "in", " ", "the", " ", "processing", " ", "to", " ", "MRI", " ", 
      RowBox[{"tagging", "."}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", "MRI"}]}], ",", " ", "tagging"}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Warning", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"February", " ", "2010"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":", " ", 
     RowBox[{
     "Works", " ", "only", " ", "for", " ", "Mathematica", " ", "7.0", " ", 
      "or", " ", 
      RowBox[{"later", "."}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.
\"Statistics`Common`DistributionsCommon`\"\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeginPackage", "[", "\[IndentingNewLine]", 
   RowBox[{
   "\"\<MathVisionTools`MRITagging`\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<MathVisionTools`GaussianDerivative`\>\"", ",", 
      "\"\<MathVisionTools`NAlgebra`\>\""}], "}"}]}], "\[IndentingNewLine]", 
   "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Unprotect", "[", 
  RowBox[{
  "SO2ReductionMatrix", ",", "CartesianToSO2Irreducible", ",", 
   "SO2IrreducibleNorm", ",", "SO2UnitJet", ",", "SO2SpectrumToMaxAngle", ",",
    "SO2SpectrumToExtremaAngles", ",", "SO2SpectrumOfTaggingWave", ",", 
   "\[IndentingNewLine]", "ComplexTaggingWave", ",", 
   "DirectionOfTaggingWave"}], "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SO2ReductionMatrix", "::", "usage"}], " ", "=", " ", 
    "\"\<For internal use only.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianToSO2Irreducible", "::", "usage"}], " ", "=", " ", 
    "\"\<CartesianToSO2Irreducible[jet] converts a Cartesian jet into a jet \
of irreducible SO(2)-invariant subspaces.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SO2IrreducibleNorm", "::", "usage"}], " ", "=", " ", 
    "\"\<SO2IrreducibleNorm[jet] renders the Norm of a SO(2)-jet.\>\""}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SO2UnitJet", "::", "usage"}], " ", "=", " ", 
    "\"\<SO2UnitJet[n,\[CurlyPhi]] is an n-th order SO(2)-jet of unit norm.\>\
\""}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SO2SpectrumToMaxAngle", "::", "usage"}], " ", "=", " ", 
    "\"\<SO2SpectrumToMaxAngle[spectrum] renders the angle of the ...\>\""}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SO2SpectrumToExtremaAngles", "::", "usage"}], " ", "=", " ", 
    "\"\<SO2SpectrumToExtremaAngles[\[Kappa]min,amin][spectrum] ...\>\""}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SO2SpectrumOfTaggingWave", "::", "usage"}], " ", "=", " ", 
    "\"\<SO2SpectrumOfTaggingWave[\[Omega]0,n][img] ...\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ComplexTaggingWave", "::", "usage"}], " ", "=", " ", 
    "\"\<ComplexTaggingWave[\[Omega]0,\[CurlyPhi]0,n][img] ...\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DirectionOfTaggingWave", "::", "usage"}], " ", "=", " ", 
   "\"\<DirectionOfTaggingWave[\[Omega]0,\[CurlyPhi]0,n][img] ...\>\""}], 
  ";"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["SO(2) ReductionMatrix", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"SO", 
    RowBox[{"(", "2", ")"}], " ", "ReductionMatrix"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Clear", "[", "SO2ReductionMatrixInternal", "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SO2ReductionMatrix", "[", "n_Integer", "]"}], " ", "=", " ", 
     RowBox[{"SO2ReductionMatrixInternal", "[", "n", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SO2ReductionMatrixInternal", "[", "n_Integer", "]"}], ":=", 
    RowBox[{
     RowBox[{"SO2ReductionMatrixInternal", "[", "n", "]"}], "=", 
     "\[IndentingNewLine]", 
     RowBox[{"Transpose", "[", 
      RowBox[{"CoefficientList", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"-", "\[ImaginaryI]"}], ")"}], "k"], 
            SuperscriptBox["2", "n"]], " ", 
           RowBox[{"Binomial", "[", 
            RowBox[{"n", ",", "k"}], "]"}], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "-", "Q"}], ")"}], "k"], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", "Q"}], ")"}], 
            RowBox[{"n", "-", "k"}]]}], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", "0", ",", "n"}], "}"}]}], "]"}], ",", "Q"}], 
       "]"}], "]"}]}]}]}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Cartesian to SO(2) Irreducible", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Cartesian", " ", "to", " ", "SO", 
    RowBox[{"(", "2", ")"}], " ", "Irreducible"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"CartesianToSO2Irreducible", "[", "jet_List", "]"}], ":=", 
   RowBox[{
    RowBox[{"SO2ReductionMatrixInternal", "[", 
     RowBox[{
      RowBox[{"Length", "[", "jet", "]"}], "-", "1"}], "]"}], ".", 
    "jet"}]}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["SO(2) Irreducible Norm", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"SO", 
    RowBox[{"(", "2", ")"}], " ", "Irreducible", " ", "Norm"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"SO2IrreducibleNorm", "[", "jet_List", "]"}], ":=", 
   RowBox[{
    RowBox[{"Reverse", "[", "jet", "]"}], ".", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"Binomial", "[", 
          RowBox[{"#", ",", 
           RowBox[{"Range", "[", 
            RowBox[{"0", ",", "#"}], "]"}]}], "]"}], "&"}], "[", 
        RowBox[{
         RowBox[{"Length", "[", "jet", "]"}], "-", "1"}], "]"}], ")"}], 
      "jet"}], ")"}]}]}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["SO(2) Unit Jet", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"SO", 
    RowBox[{"(", "2", ")"}], " ", "ReductionMatrix"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"SO2UnitJet", "[", 
      RowBox[{"0", ",", "\[CurlyPhi]_"}], "]"}], "=", " ", 
     RowBox[{"{", "1", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SO2UnitJet", "[", 
      RowBox[{"1", ",", "\[CurlyPhi]_"}], "]"}], "=", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Cos", "[", "\[CurlyPhi]", "]"}], ",", 
       RowBox[{"-", 
        RowBox[{"Sin", "[", "\[CurlyPhi]", "]"}]}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SO2UnitJet", "[", 
      RowBox[{
       RowBox[{"n_Integer", "?", "Positive"}], ",", " ", "\[CurlyPhi]_"}], 
      "]"}], ":=", "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"s", " ", "=", " ", 
          RowBox[{"Sin", "[", "\[CurlyPhi]", "]"}]}], ",", 
         RowBox[{"c", "=", 
          RowBox[{"Cos", "[", "\[CurlyPhi]", "]"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Binomial", "[", 
         RowBox[{"n", ",", 
          RowBox[{"Range", "[", 
           RowBox[{"0", ",", "n"}], "]"}]}], "]"}], " ", 
        RowBox[{"NestList", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"s", "#"}], ")"}], "&"}], ",", "1", ",", "n"}], "]"}], 
        " ", 
        RowBox[{"Reverse", "[", 
         RowBox[{"NestList", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"c", "#"}], ")"}], "&"}], ",", "1", ",", "n"}], "]"}], 
         "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}]}]], "PackageInput",\

 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["SO(2) Spectrum Of Tagging Wave", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SO2SpectrumOfTaggingWave", "[", 
    RowBox[{
     RowBox[{"\[Omega]0_", "?", "NumericQ"}], ",", "n_Integer"}], "]"}], "[", 
   "img_List", "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{"jet1", "=", 
        RowBox[{
         RowBox[{"GaussianDerivativeJet", "[", 
          RowBox[{
           FractionBox[
            RowBox[{"n", "-", "1"}], 
            RowBox[{"2", " ", 
             SuperscriptBox["\[Omega]0", "2"]}]], ",", 
           RowBox[{"n", "-", "1"}]}], "]"}], "[", 
         RowBox[{
          FractionBox[
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             FractionBox[
              RowBox[{"n", "-", "1"}], "2"], " "}]], 
           RowBox[{" ", 
            SuperscriptBox["\[Omega]0", 
             RowBox[{"n", "-", "1"}]]}]], "img"}], "]"}]}], ",", "spectrum1", 
       ",", "amplitude1", ",", "\[IndentingNewLine]", 
       RowBox[{"jet2", "=", 
        RowBox[{
         RowBox[{"GaussianDerivativeJet", "[", 
          RowBox[{
           FractionBox["n", 
            RowBox[{"2", " ", 
             SuperscriptBox["\[Omega]0", "2"]}]], ",", "n"}], "]"}], "[", 
         RowBox[{
          FractionBox[
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             FractionBox["n", "2"], " "}]], 
           RowBox[{" ", 
            SuperscriptBox["\[Omega]0", "n"]}]], "img"}], "]"}]}], ",", 
       "spectrum2", ",", "amplitude2"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"spectrum1", " ", "=", " ", 
       RowBox[{
        RowBox[{"SO2ReductionMatrix", "[", 
         RowBox[{"n", "-", "1"}], "]"}], ".", "jet1"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"spectrum2", " ", "=", " ", 
       RowBox[{
        RowBox[{"SO2ReductionMatrix", "[", "n", "]"}], ".", "jet2"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"amplitude1", "=", 
       RowBox[{
        RowBox[{"Binomial", "[", 
         RowBox[{
          RowBox[{"n", "-", "1"}], ",", 
          RowBox[{"Range", "[", 
           RowBox[{"0", ",", 
            RowBox[{"n", "-", "1"}]}], "]"}]}], "]"}], ".", 
        SuperscriptBox["jet1", "2"]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"amplitude2", "=", 
       RowBox[{
        RowBox[{"Binomial", "[", 
         RowBox[{"n", ",", 
          RowBox[{"Range", "[", 
           RowBox[{"0", ",", "n"}], "]"}]}], "]"}], ".", 
        SuperscriptBox["jet2", "2"]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Riffle", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"amplitude2", " ", 
           RowBox[{"Transpose", "[", 
            RowBox[{"spectrum2", ",", 
             RowBox[{"{", 
              RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "3", ",", "1"}], "}"}]}], "]"}], ",", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"amplitude1", " ", 
           RowBox[{"Transpose", "[", 
            RowBox[{"spectrum1", ",", 
             RowBox[{"{", 
              RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "3", ",", "1"}], "}"}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}], "/;", 
   " ", 
   RowBox[{
    RowBox[{
     RowBox[{"ArrayDepth", "[", "img", "]"}], "===", "2"}], " ", "\[And]", 
    " ", 
    RowBox[{
    "2", "\[LessEqual]", "n", "\[LessEqual]", "20"}]}]}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Complex Tagging Wave", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ComplexTaggingWave", "[", 
    RowBox[{
     RowBox[{"\[Omega]0_", "?", "NumericQ"}], ",", "\[CurlyPhi]0_", ",", 
     "n_Integer"}], "]"}], "[", "img_List", "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{"jet1", "=", 
        RowBox[{
         RowBox[{"GaussianDerivativeJet", "[", 
          RowBox[{
           FractionBox[
            RowBox[{"n", "-", "1"}], 
            RowBox[{"2", " ", 
             SuperscriptBox["\[Omega]0", "2"]}]], ",", 
           RowBox[{"n", "-", "1"}]}], "]"}], "[", 
         RowBox[{
          FractionBox[
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             FractionBox[
              RowBox[{"n", "-", "1"}], "2"], " "}]], 
           RowBox[{" ", 
            SuperscriptBox["\[Omega]0", 
             RowBox[{"n", "-", "1"}]]}]], "img"}], "]"}]}], ",", "spectrum1", 
       ",", "amplitude1", ",", "\[IndentingNewLine]", 
       RowBox[{"jet2", "=", 
        RowBox[{
         RowBox[{"GaussianDerivativeJet", "[", 
          RowBox[{
           FractionBox["n", 
            RowBox[{"2", " ", 
             SuperscriptBox["\[Omega]0", "2"]}]], ",", "n"}], "]"}], "[", 
         RowBox[{
          FractionBox[
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             FractionBox["n", "2"], " "}]], 
           RowBox[{" ", 
            SuperscriptBox["\[Omega]0", "n"]}]], "img"}], "]"}]}], ",", 
       "spectrum2", ",", "amplitude2", ",", "angles"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"spectrum1", " ", "=", " ", 
       RowBox[{
        RowBox[{"SO2ReductionMatrix", "[", 
         RowBox[{"n", "-", "1"}], "]"}], ".", "jet1"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"spectrum2", " ", "=", " ", 
       RowBox[{
        RowBox[{"SO2ReductionMatrix", "[", "n", "]"}], ".", "jet2"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"amplitude1", "=", 
       RowBox[{
        RowBox[{"Binomial", "[", 
         RowBox[{
          RowBox[{"n", "-", "1"}], ",", 
          RowBox[{"Range", "[", 
           RowBox[{"0", ",", 
            RowBox[{"n", "-", "1"}]}], "]"}]}], "]"}], ".", 
        SuperscriptBox["jet1", "2"]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"amplitude2", "=", 
       RowBox[{
        RowBox[{"Binomial", "[", 
         RowBox[{"n", ",", 
          RowBox[{"Range", "[", 
           RowBox[{"0", ",", "n"}], "]"}]}], "]"}], ".", 
        SuperscriptBox["jet2", "2"]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"angles", "=", 
       RowBox[{
        RowBox[{"Mod", "[", 
         RowBox[{
          RowBox[{"SO2SpectrumToMaxAngle", "[", 
           RowBox[{"Riffle", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{
               RowBox[{"amplitude2", " ", 
                RowBox[{"Transpose", "[", 
                 RowBox[{"spectrum2", ",", 
                  RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "3", ",", "1"}], "}"}]}], "]"}], ",", 
             RowBox[{"Transpose", "[", 
              RowBox[{
               RowBox[{"amplitude1", " ", 
                RowBox[{"Transpose", "[", 
                 RowBox[{"spectrum1", ",", 
                  RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "3", ",", "1"}], "}"}]}], "]"}]}], 
            "\[IndentingNewLine]", "]"}], "]"}], ",", "\[Pi]", ",", 
          RowBox[{"\[CurlyPhi]0", "-", 
           RowBox[{"\[Pi]", "/", "2"}]}]}], "]"}], "/.", 
        RowBox[{"Indeterminate", "->", " ", "\[CurlyPhi]0"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"SO2UnitJet", "[", 
          RowBox[{
           RowBox[{"n", "-", "1"}], ",", "angles"}], "]"}], " ", "jet1"}], 
        "]"}], " ", "+", " ", 
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"Total", "[", 
         RowBox[{
          RowBox[{"SO2UnitJet", "[", 
           RowBox[{"n", ",", "angles"}], "]"}], "jet2"}], "]"}]}]}]}]}], 
    "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"ArrayDepth", "[", "img", "]"}], "===", "2"}], " ", "\[And]", 
    " ", 
    RowBox[{
    "2", "\[LessEqual]", "n", "\[LessEqual]", "20"}]}]}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Direction of Tagging Wave", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DirectionOfTaggingWave", "[", 
    RowBox[{
     RowBox[{"\[Omega]0_", "?", "NumericQ"}], ",", "\[CurlyPhi]0_", ",", 
     "n_Integer"}], "]"}], "[", "img_List", "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{"jet1", "=", 
        RowBox[{
         RowBox[{"GaussianDerivativeJet", "[", 
          RowBox[{
           FractionBox[
            RowBox[{"n", "-", "1"}], 
            RowBox[{"2", " ", 
             SuperscriptBox["\[Omega]0", "2"]}]], ",", 
           RowBox[{"n", "-", "1"}]}], "]"}], "[", 
         RowBox[{
          FractionBox[
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             FractionBox[
              RowBox[{"n", "-", "1"}], "2"], " "}]], 
           RowBox[{" ", 
            SuperscriptBox["\[Omega]0", 
             RowBox[{"n", "-", "1"}]]}]], "img"}], "]"}]}], ",", "spectrum1", 
       ",", "amplitude1", ",", "\[IndentingNewLine]", 
       RowBox[{"jet2", "=", 
        RowBox[{
         RowBox[{"GaussianDerivativeJet", "[", 
          RowBox[{
           FractionBox["n", 
            RowBox[{"2", " ", 
             SuperscriptBox["\[Omega]0", "2"]}]], ",", "n"}], "]"}], "[", 
         RowBox[{
          FractionBox[
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             FractionBox["n", "2"], " "}]], 
           RowBox[{" ", 
            SuperscriptBox["\[Omega]0", "n"]}]], "img"}], "]"}]}], ",", 
       "spectrum2", ",", "amplitude2", ",", "angles"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"spectrum1", " ", "=", " ", 
       RowBox[{
        RowBox[{"SO2ReductionMatrix", "[", 
         RowBox[{"n", "-", "1"}], "]"}], ".", "jet1"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"spectrum2", " ", "=", " ", 
       RowBox[{
        RowBox[{"SO2ReductionMatrix", "[", "n", "]"}], ".", "jet2"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"amplitude1", "=", 
       RowBox[{
        RowBox[{"Binomial", "[", 
         RowBox[{
          RowBox[{"n", "-", "1"}], ",", 
          RowBox[{"Range", "[", 
           RowBox[{"0", ",", 
            RowBox[{"n", "-", "1"}]}], "]"}]}], "]"}], ".", 
        SuperscriptBox["jet1", "2"]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"amplitude2", "=", 
       RowBox[{
        RowBox[{"Binomial", "[", 
         RowBox[{"n", ",", 
          RowBox[{"Range", "[", 
           RowBox[{"0", ",", "n"}], "]"}]}], "]"}], ".", 
        SuperscriptBox["jet2", "2"]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"angles", "=", 
       RowBox[{
        RowBox[{"Mod", "[", 
         RowBox[{
          RowBox[{"SO2SpectrumToMaxAngle", "[", 
           RowBox[{"Riffle", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{
               RowBox[{"amplitude2", " ", 
                RowBox[{"Transpose", "[", 
                 RowBox[{"spectrum2", ",", 
                  RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "3", ",", "1"}], "}"}]}], "]"}], ",", 
             RowBox[{"Transpose", "[", 
              RowBox[{
               RowBox[{"amplitude1", " ", 
                RowBox[{"Transpose", "[", 
                 RowBox[{"spectrum1", ",", 
                  RowBox[{"{", 
                   RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "3", ",", "1"}], "}"}]}], "]"}]}], 
            "\[IndentingNewLine]", "]"}], "]"}], ",", "\[Pi]", ",", 
          RowBox[{"\[CurlyPhi]0", "-", 
           RowBox[{"\[Pi]", "/", "2"}]}]}], "]"}], "/.", 
        RowBox[{"Indeterminate", "->", " ", "\[CurlyPhi]0"}]}]}]}]}], 
    "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"ArrayDepth", "[", "img", "]"}], "===", "2"}], " ", "\[And]", 
    " ", 
    RowBox[{
    "2", "\[LessEqual]", "n", "\[LessEqual]", "20"}]}]}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["SO(2) Spectrum To Maximal Angle", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"SO", 
   RowBox[{"(", "2", ")"}], " ", "Spectrum", " ", "To", " ", "Max", " ", 
   "Angle"}], " ", "*)"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ComplexUnitQ", " ", "=", " ", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"z", ",", "_Complex"}], "}"}], "}"}], ",", 
     RowBox[{
      RowBox[{"Abs", "[", "z", "]"}], "==", "1."}]}], "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SO2SpectrumToMaxAngle", "[", "phases_List", "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Length", "[", "phases", "]"}], "-", "1"}], ")"}], "/", 
         "2"}]}], ",", "angles", ",", "amplitudes", ",", "z"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"angles", " ", "=", " ", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Select", "[", 
           RowBox[{
            RowBox[{"List", "@@", 
             RowBox[{
              RowBox[{"NRoots", "[", 
               RowBox[{
                RowBox[{"#", "\[Equal]", "0"}], ",", "z"}], "]"}], 
              "\[LeftDoubleBracket]", 
              RowBox[{"All", ",", 
               RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}]}], ",", 
            "ComplexUnitQ"}], "]"}], "&"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Range", "[", 
             RowBox[{
              RowBox[{"-", "n"}], ",", "n"}], "]"}], 
            SuperscriptBox["z", 
             RowBox[{"Range", "[", 
              RowBox[{"0", ",", 
               RowBox[{"2", "n"}]}], "]"}]]}], ")"}], ".", "phases"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ";", " ", "\[IndentingNewLine]", 
      
      RowBox[{"amplitudes", "=", 
       RowBox[{"Abs", "[", 
        RowBox[{"Total", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            SuperscriptBox["angles", "k"], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", 
              RowBox[{"-", "n"}], ",", "n"}], "}"}]}], "]"}], " ", "phases"}],
          "]"}], "]"}]}], ";", " ", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"MapThread", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Arg", "[", 
           RowBox[{"Conjugate", "[", 
            RowBox[{"Extract", "[", 
             RowBox[{"#1", ",", 
              RowBox[{"Ordering", "[", 
               RowBox[{"#2", ",", 
                RowBox[{"-", "1"}]}], "]"}]}], "]"}], "]"}], "]"}], "&"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"angles", ",", "amplitudes"}], "}"}], ",", "2"}], "]"}], 
       " ", "/.", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Arg", "[", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Extract", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"Ordering", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", 
              RowBox[{"-", "1"}]}], "]"}]}], "]"}], "]"}], "]"}], "\[Rule]", 
        " ", "Indeterminate"}]}]}]}], "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"Dimensions", "[", "phases", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"_", "?", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"OddQ", "[", "#", "]"}], "\[And]", " ", 
            RowBox[{"#", ">", "5"}]}], ")"}], "&"}], ")"}]}], ",", "_", ",", 
       "_"}], "}"}]}], "]"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SO2SpectrumToMaxAngle", "[", "phases_List", "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"angles", ",", "amplitudes", ",", "z"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"angles", " ", "=", " ", 
       RowBox[{"MapThread", "[", 
        RowBox[{"NQuadraticUnitRootsComplex", ",", 
         RowBox[{"Reverse", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "0", ",", "1"}], "}"}], "phases"}], 
          "]"}], ",", "2"}], "]"}]}], ";", " ", "\[IndentingNewLine]", 
      RowBox[{"amplitudes", "=", 
       RowBox[{"Abs", "[", 
        RowBox[{"Total", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            SuperscriptBox["angles", "k"], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", 
              RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}], " ", "phases"}],
          "]"}], "]"}]}], ";", " ", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"MapThread", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Arg", "[", 
           RowBox[{"Conjugate", "[", 
            RowBox[{"Extract", "[", 
             RowBox[{"#1", ",", 
              RowBox[{"Ordering", "[", 
               RowBox[{"#2", ",", 
                RowBox[{"-", "1"}]}], "]"}]}], "]"}], "]"}], "]"}], "&"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"angles", ",", "amplitudes"}], "}"}], ",", "2"}], "]"}], 
       " ", "/.", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Arg", "[", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Extract", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"Ordering", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", 
              RowBox[{"-", "1"}]}], "]"}]}], "]"}], "]"}], "]"}], "\[Rule]", 
        " ", "Indeterminate"}]}]}]}], "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"Dimensions", "[", "phases", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "_", ",", "_"}], "}"}]}], "]"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SO2SpectrumToMaxAngle", "[", "phases_List", "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"angles", ",", "amplitudes", ",", "z"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"angles", " ", "=", " ", 
       RowBox[{"MapThread", "[", 
        RowBox[{"NQuarticUnitRootsComplex", ",", 
         RowBox[{"Reverse", "[", 
          RowBox[{
           RowBox[{"Range", "[", 
            RowBox[{
             RowBox[{"-", "2"}], ",", "2"}], "]"}], "phases"}], "]"}], ",", 
         "2"}], "]"}]}], ";", " ", "\[IndentingNewLine]", 
      RowBox[{"amplitudes", "=", 
       RowBox[{"Abs", "[", 
        RowBox[{"Total", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            SuperscriptBox["angles", "k"], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", 
              RowBox[{"-", "2"}], ",", "2"}], "}"}]}], "]"}], " ", "phases"}],
          "]"}], "]"}]}], ";", " ", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"MapThread", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Arg", "[", 
           RowBox[{"Conjugate", "[", 
            RowBox[{"Extract", "[", 
             RowBox[{"#1", ",", 
              RowBox[{"Ordering", "[", 
               RowBox[{"#2", ",", 
                RowBox[{"-", "1"}]}], "]"}]}], "]"}], "]"}], "]"}], "&"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"angles", ",", "amplitudes"}], "}"}], ",", "2"}], "]"}], 
       " ", "/.", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Arg", "[", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Extract", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"Ordering", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", 
              RowBox[{"-", "1"}]}], "]"}]}], "]"}], "]"}], "]"}], "\[Rule]", 
        " ", "Indeterminate"}]}]}]}], "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"Dimensions", "[", "phases", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "_", ",", "_"}], "}"}]}], "]"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SO2SpectrumToMaxAngle", "[", "phases_List", "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Length", "[", "phases", "]"}], "-", "1"}], ")"}], "/", 
         "2"}]}], ",", "angles", ",", "amplitudes", ",", "z"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"angles", " ", "=", " ", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"List", "@@", 
          RowBox[{
           RowBox[{"NRoots", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Range", "[", 
                  RowBox[{
                   RowBox[{"-", "n"}], ",", "n"}], "]"}], 
                 SuperscriptBox["z", 
                  RowBox[{"Range", "[", 
                   RowBox[{"0", ",", 
                    RowBox[{"2", "n"}]}], "]"}]]}], ")"}], ".", "phases"}], 
              "\[Equal]", "0"}], ",", "z"}], "]"}], "\[LeftDoubleBracket]", 
           RowBox[{"All", ",", 
            RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}]}], ",", 
         "ComplexUnitQ"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"amplitudes", "=", 
       RowBox[{"Abs", "[", 
        RowBox[{"Total", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            SuperscriptBox["angles", "k"], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", 
              RowBox[{"-", "n"}], ",", "n"}], "}"}]}], "]"}], " ", "phases"}],
          "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Arg", "[", 
        RowBox[{"Conjugate", "[", 
         RowBox[{"Extract", "[", 
          RowBox[{"angles", ",", 
           RowBox[{"Ordering", "[", 
            RowBox[{"amplitudes", ",", 
             RowBox[{"-", "1"}]}], "]"}]}], "]"}], "]"}], "]"}], "/.", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Arg", "[", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Extract", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"Ordering", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", 
              RowBox[{"-", "1"}]}], "]"}]}], "]"}], "]"}], "]"}], "\[Rule]", 
        " ", "Indeterminate"}]}]}]}], "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"Dimensions", "[", "phases", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"_", "?", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"OddQ", "[", "#", "]"}], "\[And]", " ", 
           RowBox[{"#", ">", "5"}]}], ")"}], "&"}], ")"}]}], "}"}]}], 
    "]"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SO2SpectrumToMaxAngle", "[", "phases_List", "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"angles", ",", "amplitudes", ",", "z"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"angles", " ", "=", " ", 
       RowBox[{"NQuadraticUnitRootsComplex", "@@", 
        RowBox[{"Reverse", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "0", ",", "1"}], "}"}], "phases"}], 
         "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"amplitudes", "=", 
       RowBox[{"Abs", "[", 
        RowBox[{"Total", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            SuperscriptBox["angles", "k"], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", 
              RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}], " ", "phases"}],
          "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Arg", "[", 
        RowBox[{"Conjugate", "[", 
         RowBox[{"Extract", "[", 
          RowBox[{"angles", ",", 
           RowBox[{"Ordering", "[", 
            RowBox[{"amplitudes", ",", 
             RowBox[{"-", "1"}]}], "]"}]}], "]"}], "]"}], "]"}], "/.", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Arg", "[", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Extract", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"Ordering", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", 
              RowBox[{"-", "1"}]}], "]"}]}], "]"}], "]"}], "]"}], "\[Rule]", 
        " ", "Indeterminate"}]}]}]}], "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"Dimensions", "[", "phases", "]"}], ",", 
     RowBox[{"{", "3", "}"}]}], "]"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SO2SpectrumToMaxAngle", "[", "phases_List", "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"angles", ",", "amplitudes", ",", "z"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"angles", " ", "=", " ", 
       RowBox[{"NQuarticUnitRootsComplex", "@@", 
        RowBox[{"Reverse", "[", 
         RowBox[{
          RowBox[{"Range", "[", 
           RowBox[{
            RowBox[{"-", "2"}], ",", "2"}], "]"}], "phases"}], "]"}]}]}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"amplitudes", "=", 
       RowBox[{"Abs", "[", 
        RowBox[{"Total", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            SuperscriptBox["angles", "k"], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", 
              RowBox[{"-", "2"}], ",", "2"}], "}"}]}], "]"}], " ", "phases"}],
          "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Arg", "[", 
        RowBox[{"Conjugate", "[", 
         RowBox[{"Extract", "[", 
          RowBox[{"angles", ",", 
           RowBox[{"Ordering", "[", 
            RowBox[{"amplitudes", ",", 
             RowBox[{"-", "1"}]}], "]"}]}], "]"}], "]"}], "]"}], "/.", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Arg", "[", 
         RowBox[{"Conjugate", "[", 
          RowBox[{"Extract", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"Ordering", "[", 
             RowBox[{
              RowBox[{"{", "}"}], ",", 
              RowBox[{"-", "1"}]}], "]"}]}], "]"}], "]"}], "]"}], "\[Rule]", 
        " ", "Indeterminate"}]}]}]}], "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"Dimensions", "[", "phases", "]"}], ",", 
     RowBox[{"{", "5", "}"}]}], "]"}]}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["SO(2) Spectrum To Extremal Angles", "Subsection"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"SO", 
   RowBox[{"(", "2", ")"}], " ", "Spectrum", " ", "To", " ", "Extremal", " ", 
   "Angles"}], " ", "*)"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SO2SpectrumToExtremaAngles", "[", 
    RowBox[{"\[Kappa]min_", ",", "amin_"}], "]"}], "[", "phases_List", "]"}], 
  ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Length", "[", "phases", "]"}], "-", "1"}], ")"}], "/", 
         "2"}]}], ",", "angles", ",", "pos", ",", "z", ",", 
       RowBox[{"famin", "=", 
        RowBox[{
         SqrtBox[
          RowBox[{"2", "\[Pi]"}]], "amin"}]}], ",", 
       RowBox[{"f\[Kappa]min", "=", 
        RowBox[{
         RowBox[{"-", 
          SqrtBox[
           RowBox[{"2", "\[Pi]"}]]}], "\[Kappa]min"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"angles", " ", "=", " ", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Select", "[", 
           RowBox[{
            RowBox[{"List", "@@", 
             RowBox[{
              RowBox[{"NRoots", "[", 
               RowBox[{
                RowBox[{"#", "\[Equal]", "0"}], ",", "z"}], "]"}], 
              "\[LeftDoubleBracket]", 
              RowBox[{"All", ",", 
               RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}]}], ",", 
            "ComplexUnitQ"}], "]"}], "&"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Range", "[", 
             RowBox[{
              RowBox[{"-", "n"}], ",", "n"}], "]"}], 
            SuperscriptBox["z", 
             RowBox[{"Range", "[", 
              RowBox[{"0", ",", 
               RowBox[{"2", "n"}]}], "]"}]]}], ")"}], ".", "phases"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"pos", "=", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Re", "[", 
                RowBox[{
                 RowBox[{"(", 
                  SuperscriptBox[
                   RowBox[{"Range", "[", 
                    RowBox[{
                    RowBox[{"-", "n"}], ",", "n"}], "]"}], "2"], ")"}], ".", 
                 "#"}], "]"}], ",", 
               RowBox[{"Abs", "[", 
                RowBox[{"Total", "[", "#", "]"}], "]"}]}], "}"}], "]"}], ",", 
            
            RowBox[{"{", 
             RowBox[{
              RowBox[{"_", "?", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"#", ">", "f\[Kappa]min"}], "&"}], ")"}]}], ",", 
              RowBox[{"_", "?", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"#", ">", "famin"}], "&"}], ")"}]}]}], "}"}], ",", 
            RowBox[{"{", "1", "}"}]}], "]"}], "&"}], ",", 
         RowBox[{"Transpose", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              SuperscriptBox["angles", "k"], ",", 
              RowBox[{"{", 
               RowBox[{"k", ",", 
                RowBox[{"-", "n"}], ",", "n"}], "}"}]}], "]"}], " ", 
            "phases"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Arg", "[", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"MapThread", "[", 
         RowBox[{"Extract", ",", 
          RowBox[{"{", 
           RowBox[{"angles", ",", "pos"}], "}"}], ",", "2"}], "]"}], "]"}], 
       "]"}]}]}], "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"Dimensions", "[", "phases", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"_", "?", "OddQ"}], ",", "_", ",", "_"}], "}"}]}], 
    "]"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SO2SpectrumToExtremaAngles", "[", 
    RowBox[{"\[Kappa]min_", ",", "amin_"}], "]"}], "[", "phases_List", "]"}], 
  ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Length", "[", "phases", "]"}], "-", "1"}], ")"}], "/", 
         "2"}]}], ",", "angles", ",", "pos", ",", "z", ",", 
       RowBox[{"famin", "=", 
        RowBox[{
         SqrtBox[
          RowBox[{"2", "\[Pi]"}]], "amin"}]}], ",", 
       RowBox[{"f\[Kappa]min", "=", 
        RowBox[{
         RowBox[{"-", 
          SqrtBox[
           RowBox[{"2", "\[Pi]"}]]}], "\[Kappa]min"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"angles", " ", "=", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"List", "@@", 
            RowBox[{
             RowBox[{"NRoots", "[", 
              RowBox[{
               RowBox[{"#", "\[Equal]", "0"}], ",", "z"}], "]"}], 
             "\[LeftDoubleBracket]", 
             RowBox[{"All", ",", 
              RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}]}], ",", 
           "ComplexUnitQ"}], "]"}], "&"}], "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Range", "[", 
            RowBox[{
             RowBox[{"-", "n"}], ",", "n"}], "]"}], 
           SuperscriptBox["z", 
            RowBox[{"Range", "[", 
             RowBox[{"0", ",", 
              RowBox[{"2", "n"}]}], "]"}]]}], ")"}], ".", "phases"}], "]"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"pos", "=", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Re", "[", 
               RowBox[{
                RowBox[{"(", 
                 SuperscriptBox[
                  RowBox[{"Range", "[", 
                   RowBox[{
                    RowBox[{"-", "n"}], ",", "n"}], "]"}], "2"], ")"}], ".", 
                "#"}], "]"}], ",", 
              RowBox[{"Abs", "[", 
               RowBox[{"Total", "[", "#", "]"}], "]"}]}], "}"}], "]"}], "&"}],
           "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             SuperscriptBox["angles", "k"], ",", 
             RowBox[{"{", 
              RowBox[{"k", ",", 
               RowBox[{"-", "n"}], ",", "n"}], "}"}]}], "]"}], " ", 
           "phases"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"#", ">", "f\[Kappa]min"}], "&"}], ")"}]}], ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"#", ">", "famin"}], "&"}], ")"}]}]}], "}"}], ",", 
         RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Arg", "[", 
       RowBox[{"Conjugate", "[", 
        RowBox[{"Extract", "[", 
         RowBox[{"angles", ",", "pos"}], "]"}], "]"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}], "/;", " ", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"Dimensions", "[", "phases", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"_", "?", "OddQ"}], "}"}]}], "]"}]}]}]], "PackageInput"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "SO2ReductionMatrix", ",", "CartesianToSO2Irreducible", ",", 
       "SO2IrreducibleNorm", ",", "SO2UnitJet", ",", "SO2SpectrumToMaxAngle", 
       ",", "SO2SpectrumToExtremaAngles", ",", "SO2SpectrumOfTaggingWave", 
       ",", "\[IndentingNewLine]", "ComplexTaggingWave", ",", 
       "DirectionOfTaggingWave"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Protected", ",", " ", "ReadProtected"}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1240, 754},
WindowMargins->{{12, Automatic}, {Automatic, 0}},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (November 10, 2008)",
StyleDefinitions->Notebook[{
   Cell[
    CellGroupData[{
      Cell["Style Definitions", "Subtitle"], 
      Cell[
      "Modify the definitions below to change the default appearance of all \
cells in a given style.  Make modifications to any definition using commands \
in the Format menu.", "Text"], 
      Cell[
       CellGroupData[{
         Cell["Style Environment Names", "Section"], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{12, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 9], 
         Cell[
          StyleData[All, "Presentation"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 12], 
         Cell[
          StyleData[All, "Condensed"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{8, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 8], 
         Cell[
          StyleData[All, "Printout"], PageWidth -> PaperWidth, 
          CellLabelMargins -> {{2, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 5, 
          PrivateFontOptions -> {"FontType" -> "Outline"}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Notebook Options", "Section"], 
         Cell[
         "The options defined for the style below will be used at the \
Notebook level.", "Text"], 
         Cell[
          StyleData["Notebook"], PageHeaders -> {{
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"], None, 
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"]}, {
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"], None, 
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"]}}, CellFrameLabelMargins -> 
          6, StyleMenuListing -> None]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headings", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Title"], CellMargins -> {{12, Inherited}, {20, 40}}, 
             CellGroupingRules -> {"TitleGrouping", 0}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LineSpacing -> {1, 11}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "Title", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subtitle", 0}, {"Subsubtitle", 0}}, FontFamily -> 
             "Helvetica", FontSize -> 36, FontWeight -> "Bold"], 
            Cell[
             StyleData["Title", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 40}}, LineSpacing -> {1, 0}, 
             FontSize -> 44], 
            Cell[
             StyleData["Title", "Condensed"], 
             CellMargins -> {{8, 10}, {4, 8}}, FontSize -> 20], 
            Cell[
             StyleData["Title", "Printout"], 
             CellMargins -> {{2, 10}, {12, 30}}, FontSize -> 24]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subtitle"], 
             CellMargins -> {{12, Inherited}, {20, 15}}, 
             CellGroupingRules -> {"TitleGrouping", 10}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subtitle", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subsubtitle", 0}}, FontFamily -> "Helvetica", 
             FontSize -> 24], 
            Cell[
             StyleData["Subtitle", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 20}}, LineSpacing -> {1, 0}, 
             FontSize -> 36], 
            Cell[
             StyleData["Subtitle", "Condensed"], 
             CellMargins -> {{8, 10}, {4, 4}}, FontSize -> 14], 
            Cell[
             StyleData["Subtitle", "Printout"], 
             CellMargins -> {{2, 10}, {12, 8}}, FontSize -> 18]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubtitle"], 
             CellMargins -> {{12, Inherited}, {20, 15}}, 
             CellGroupingRules -> {"TitleGrouping", 20}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsubtitle", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}}, FontFamily -> "Helvetica", FontSize -> 14, 
             FontSlant -> "Italic"], 
            Cell[
             StyleData["Subsubtitle", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 20}}, LineSpacing -> {1, 0}, 
             FontSize -> 24], 
            Cell[
             StyleData["Subsubtitle", "Condensed"], 
             CellMargins -> {{8, 10}, {8, 8}}, FontSize -> 12], 
            Cell[
             StyleData["Subsubtitle", "Printout"], 
             CellMargins -> {{2, 10}, {12, 8}}, FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellDingbat -> "\[FilledSquare]", 
             CellMargins -> {{25, Inherited}, {8, 24}}, 
             CellGroupingRules -> {"SectionGrouping", 30}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LineSpacing -> {1, 7}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "Section", 
             CounterAssignments -> {{"Subsection", 0}, {"Subsubsection", 0}}, 
             FontFamily -> "Helvetica", FontSize -> 16, FontWeight -> "Bold"], 
            Cell[
             StyleData["Section", "Presentation"], 
             CellMargins -> {{40, 10}, {11, 32}}, LineSpacing -> {1, 0}, 
             FontSize -> 24], 
            Cell[
             StyleData["Section", "Condensed"], 
             CellMargins -> {{18, Inherited}, {6, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Section", "Printout"], 
             CellMargins -> {{13, 0}, {7, 22}}, FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> "\[FilledSmallSquare]", 
             CellMargins -> {{22, Inherited}, {8, 20}}, 
             CellGroupingRules -> {"SectionGrouping", 40}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsection", CounterAssignments -> {{"Subsubsection", 0}}, 
             FontFamily -> "Times", FontSize -> 14, FontWeight -> "Bold"], 
            Cell[
             StyleData["Subsection", "Presentation"], 
             CellMargins -> {{36, 10}, {11, 32}}, LineSpacing -> {1, 0}, 
             FontSize -> 22], 
            Cell[
             StyleData["Subsection", "Condensed"], 
             CellMargins -> {{16, Inherited}, {6, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Subsection", "Printout"], 
             CellMargins -> {{9, 0}, {7, 22}}, FontSize -> 12]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsection"], CellDingbat -> 
             "\[FilledSmallSquare]", 
             CellMargins -> {{22, Inherited}, {8, 18}}, 
             CellGroupingRules -> {"SectionGrouping", 50}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsubsection", FontFamily -> "Times", FontWeight -> "Bold"], 
            Cell[
             StyleData["Subsubsection", "Presentation"], 
             CellMargins -> {{34, 10}, {11, 26}}, LineSpacing -> {1, 0}, 
             FontSize -> 18], 
            Cell[
             StyleData["Subsubsection", "Condensed"], 
             CellMargins -> {{17, Inherited}, {6, 12}}, FontSize -> 10], 
            Cell[
             StyleData["Subsubsection", "Printout"], 
             CellMargins -> {{9, 0}, {7, 14}}, FontSize -> 11]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Body Text", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Text"], CellMargins -> {{12, 10}, {7, 7}}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             Hyphenation -> True, LineSpacing -> {1, 3}, CounterIncrements -> 
             "Text"], 
            Cell[
             StyleData["Text", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["Text", "Condensed"], CellMargins -> {{8, 10}, {6, 6}},
              LineSpacing -> {1, 1}, FontSize -> 11], 
            Cell[
             StyleData["Text", "Printout"], CellMargins -> {{2, 2}, {6, 6}}, 
             TextJustification -> 0.5, FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SmallText"], CellMargins -> {{12, 10}, {6, 6}}, 
             DefaultNewInlineCellStyle -> "None", Hyphenation -> True, 
             LineSpacing -> {1, 3}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "SmallText", FontFamily -> "Helvetica", 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Presentation"], 
             CellMargins -> {{24, 10}, {8, 8}}, LineSpacing -> {1, 5}, 
             FontSize -> 12], 
            Cell[
             StyleData["SmallText", "Condensed"], 
             CellMargins -> {{8, 10}, {5, 5}}, LineSpacing -> {1, 2}, 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Printout"], 
             CellMargins -> {{2, 2}, {5, 5}}, TextJustification -> 0.5, 
             FontSize -> 7]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Input/Output", "Section"], 
         Cell[
         "The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names. Some attributes for these styles are actually set in FormatType Styles \
(in the last section of this stylesheet). ", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Input"], CellMargins -> {{45, 10}, {5, 7}}, 
             Evaluatable -> True, CellGroupingRules -> "InputGrouping", 
             CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, DefaultFormatType -> 
             DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
             FormatType -> InputForm, ShowStringCharacters -> True, 
             NumberMarks -> True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1},
              CounterIncrements -> "Input", FontWeight -> "Bold"], 
            Cell[
             StyleData["Input", "Presentation"], 
             CellMargins -> {{72, Inherited}, {8, 10}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["Input", "Condensed"], 
             CellMargins -> {{40, 10}, {2, 3}}, FontSize -> 11], 
            Cell[
             StyleData["Input", "Printout"], CellMargins -> {{39, 0}, {4, 6}},
              LinebreakAdjustments -> {0.85, 2, 10, 1, 1}, FontSize -> 9]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PackageInput"], CellMargins -> {{45, 10}, {5, 7}}, 
             Evaluatable -> True, CellGroupingRules -> "InputGrouping", 
             CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, InitializationCell -> True, 
             DefaultFormatType -> DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
             FormatType -> InputForm, ShowStringCharacters -> True, 
             NumberMarks -> True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1},
              CounterIncrements -> "Input", FontWeight -> "Bold", Background -> 
             RGBColor[0.500008, 1, 0.566644]], 
            Cell[
             StyleData["PackageInput", "Presentation"], 
             CellMargins -> {{72, Inherited}, {8, 10}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["PackageInput", "Condensed"], 
             CellMargins -> {{40, 10}, {2, 3}}, FontSize -> 11], 
            Cell[
             StyleData["PackageInput", "Printout"], 
             CellMargins -> {{39, 0}, {4, 6}}, 
             LinebreakAdjustments -> {0.85, 2, 10, 1, 1}, FontSize -> 9, 
             Background -> GrayLevel[1]]}, Closed]], 
         Cell[
          StyleData["InputOnly"], Evaluatable -> True, CellGroupingRules -> 
          "InputGrouping", CellHorizontalScrolling -> True, DefaultFormatType -> 
          DefaultInputFormatType, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
          FormatType -> InputForm, ShowStringCharacters -> True, NumberMarks -> 
          True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, 
          CounterIncrements -> "Input", StyleMenuListing -> None, FontWeight -> 
          "Bold"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Output"], CellMargins -> {{47, 10}, {7, 5}}, 
             CellEditDuplicate -> True, CellGroupingRules -> "OutputGrouping",
              CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, DefaultFormatType -> 
             DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Output"], 
            Cell[
             StyleData["Output", "Presentation"], 
             CellMargins -> {{72, Inherited}, {10, 8}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["Output", "Condensed"], 
             CellMargins -> {{41, Inherited}, {3, 2}}, FontSize -> 11], 
            Cell[
             StyleData["Output", "Printout"], 
             CellMargins -> {{39, 0}, {6, 4}}, FontSize -> 9]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Message"], 
             CellMargins -> {{45, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Message", StyleMenuListing -> 
             None, FontSize -> 11, FontColor -> RGBColor[0, 0, 1]], 
            Cell[
             StyleData["Message", "Presentation"], 
             CellMargins -> {{72, Inherited}, {Inherited, Inherited}}, 
             LineSpacing -> {1, 0}, FontSize -> 16], 
            Cell[
             StyleData["Message", "Condensed"], 
             CellMargins -> {{41, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 11], 
            Cell[
             StyleData["Message", "Printout"], 
             CellMargins -> {{39, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 7, FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Print"], 
             CellMargins -> {{45, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, ShowCellLabel -> 
             False, DefaultFormatType -> DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Print", StyleMenuListing -> 
             None], 
            Cell[
             StyleData["Print", "Presentation"], 
             CellMargins -> {{72, Inherited}, {Inherited, Inherited}}, 
             LineSpacing -> {1, 0}, FontSize -> 16], 
            Cell[
             StyleData["Print", "Condensed"], 
             CellMargins -> {{41, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 11], 
            Cell[
             StyleData["Print", "Printout"], 
             CellMargins -> {{39, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 8]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Graphics"], 
             CellMargins -> {{4, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "GraphicsGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, LanguageCategory -> 
             None, FormatType -> InputForm, CounterIncrements -> "Graphics", 
             ImageMargins -> {{43, Inherited}, {Inherited, 0}}, 
             StyleMenuListing -> None, FontFamily -> "Courier", FontSize -> 
             10], 
            Cell[
             StyleData["Graphics", "Presentation"], 
             ImageMargins -> {{62, Inherited}, {Inherited, 0}}], 
            Cell[
             StyleData["Graphics", "Condensed"], 
             ImageMargins -> {{38, Inherited}, {Inherited, 0}}, Magnification -> 
             0.6], 
            Cell[
             StyleData["Graphics", "Printout"], 
             ImageMargins -> {{30, Inherited}, {Inherited, 0}}, Magnification -> 
             0.8]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["CellLabel"], LanguageCategory -> None, 
             StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 
             9, FontColor -> RGBColor[0, 0, 1]], 
            Cell[
             StyleData["CellLabel", "Presentation"], FontSize -> 12], 
            Cell[
             StyleData["CellLabel", "Condensed"], FontSize -> 9], 
            Cell[
             StyleData["CellLabel", "Printout"], FontFamily -> "Courier", 
             FontSize -> 8, FontSlant -> "Italic", FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Inline Formatting", "Section"], 
         Cell[
         "These styles are for modifying individual words or letters in a \
cell exclusive of the cell tag.", "Text"], 
         Cell[
          StyleData["RM"], StyleMenuListing -> None, FontWeight -> "Plain", 
          FontSlant -> "Plain"], 
         Cell[
          StyleData["BF"], StyleMenuListing -> None, FontWeight -> "Bold"], 
         Cell[
          StyleData["IT"], StyleMenuListing -> None, FontSlant -> "Italic"], 
         Cell[
          StyleData["TR"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["TI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["TB"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["TBI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["MR"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["MO"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["MB"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["MBO"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["SR"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["SO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["SB"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["SBO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SO10"], StyleMenuListing -> None, FontFamily -> 
             "Helvetica", FontSize -> 10, FontWeight -> "Plain", FontSlant -> 
             "Italic"], 
            Cell[
             StyleData["SO10", "Printout"], StyleMenuListing -> None, 
             FontFamily -> "Helvetica", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"], 
            Cell[
             StyleData["SO10", "EnhancedPrintout"], StyleMenuListing -> None, 
             FontFamily -> "Futura", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Formulas and Programming", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["InlineFormula"], CellMargins -> {{10, 4}, {0, 8}}, 
             CellHorizontalScrolling -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", ScriptLevel -> 1, SingleLetterItalics -> True], 
            Cell[
             StyleData["InlineFormula", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["InlineFormula", "Condensed"], 
             CellMargins -> {{8, 10}, {6, 6}}, LineSpacing -> {1, 1}, 
             FontSize -> 11], 
            Cell[
             StyleData["InlineFormula", "Printout"], 
             CellMargins -> {{2, 0}, {6, 6}}, FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["DisplayFormula"], 
             CellMargins -> {{42, Inherited}, {Inherited, Inherited}}, 
             CellHorizontalScrolling -> True, DefaultFormatType -> 
             DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", ScriptLevel -> 0, SingleLetterItalics -> True, 
             UnderoverscriptBoxOptions -> {LimitsPositioning -> True}], 
            Cell[
             StyleData["DisplayFormula", "Presentation"], 
             LineSpacing -> {1, 5}, FontSize -> 16], 
            Cell[
             StyleData["DisplayFormula", "Condensed"], LineSpacing -> {1, 1}, 
             FontSize -> 11], 
            Cell[
             StyleData["DisplayFormula", "Printout"], FontSize -> 10]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Program"], CellFrame -> {{0, 0}, {0.5, 0.5}}, 
             CellMargins -> {{10, 4}, {0, 8}}, CellHorizontalScrolling -> 
             True, Hyphenation -> False, LanguageCategory -> "Formula", 
             ScriptLevel -> 1, FontFamily -> "Courier"], 
            Cell[
             StyleData["Program", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["Program", "Condensed"], 
             CellMargins -> {{8, 10}, {6, 6}}, LineSpacing -> {1, 1}, 
             FontSize -> 11], 
            Cell[
             StyleData["Program", "Printout"], 
             CellMargins -> {{2, 0}, {6, 6}}, FontSize -> 9]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Outline Styles", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline1"], CellMargins -> {{12, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 50}, 
             ParagraphIndent -> -38, CounterIncrements -> "Outline1", 
             FontSize -> 18, FontWeight -> "Bold", 
             CounterBoxOptions -> {CounterFunction :> CapitalRomanNumeral}], 
            Cell[
             StyleData["Outline1", "Printout"], 
             CounterBoxOptions -> {CounterFunction :> CapitalRomanNumeral}]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline2"], CellMargins -> {{59, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 60}, 
             ParagraphIndent -> -27, CounterIncrements -> "Outline2", 
             FontSize -> 15, FontWeight -> "Bold", 
             CounterBoxOptions -> {CounterFunction :> (Part[
                 CharacterRange["A", "Z"], #]& )}], 
            Cell[
             StyleData["Outline2", "Printout"], 
             CounterBoxOptions -> {CounterFunction :> (Part[
                 CharacterRange["A", "Z"], #]& )}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline3"], CellMargins -> {{108, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 70}, 
             ParagraphIndent -> -21, CounterIncrements -> "Outline3", 
             FontSize -> 12, 
             CounterBoxOptions -> {CounterFunction :> Identity}], 
            Cell[
             StyleData["Outline3", "Printout"], 
             CounterBoxOptions -> {CounterFunction :> Identity}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline4"], CellMargins -> {{158, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 80}, 
             ParagraphIndent -> -18, CounterIncrements -> "Outline4", 
             FontSize -> 10, CounterBoxOptions -> {CounterFunction :> (Part[
                 CharacterRange["a", "z"], #]& )}], 
            Cell[
             StyleData["Outline4", "Printout"]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Hyperlink Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same Notebook, \
or between Notebooks.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Hyperlink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonNote -> 
               ButtonData}], 
            Cell[
             StyleData["Hyperlink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["Hyperlink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["Hyperlink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
         "The following styles are for linking automatically to the on-line \
help system.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["MainBookLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["MainBook", #]}]& )}], 
            Cell[
             StyleData["MainBookLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["MainBookLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["MainBookLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["AddOnsLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["AddOns", #]}]& )}], 
            Cell[
             StyleData["AddOnsLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["AddOnsLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["AddOnsLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["RefGuideLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["RefGuide", #]}]& )}], 
            Cell[
             StyleData["RefGuideLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["RefGuideLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["RefGuideLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["GettingStartedLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["GettingStarted", #]}]& )}], 
            Cell[
             StyleData["GettingStartedLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["GettingStartedLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["GettingStartedLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["OtherInformationLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["OtherInformation", #]}]& )}], 
            Cell[
             StyleData["OtherInformationLink", "Presentation"], FontSize -> 
             16], 
            Cell[
             StyleData["OtherInformationLink", "Condensed"], FontSize -> 11], 
            
            Cell[
             StyleData["OtherInformationLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headers and Footers", "Section"], 
         Cell[
          StyleData["Header"], CellMargins -> {{0, 0}, {4, 1}}, 
          DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
          "NaturalLanguage", StyleMenuListing -> None, FontSize -> 10, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["Footer"], CellMargins -> {{0, 0}, {0, 4}}, 
          DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
          "NaturalLanguage", StyleMenuListing -> None, FontSize -> 9, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["PageNumber"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Times", FontSize -> 10]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Palette Styles", "Section"], 
         Cell[
         "The cells below define styles that define standard ButtonFunctions, \
for use in palette buttons.", "Text"], 
         Cell[
          StyleData["Paste"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, After]}]& )}], 
         Cell[
          StyleData["Evaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["EvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionMove[
                FrontEnd`InputNotebook[], All, Cell, 1], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Placeholder Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making placeholder objects \
in palette templates.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Placeholder"], Placeholder -> True, StyleMenuListing -> 
             None, FontSlant -> "Italic", FontColor -> 
             RGBColor[0.890623, 0.864698, 0.384756], 
             TagBoxOptions -> {
              Editable -> False, Selectable -> False, StripWrapperBoxes -> 
               False}], 
            Cell[
             StyleData["Placeholder", "Presentation"]], 
            Cell[
             StyleData["Placeholder", "Condensed"]], 
            Cell[
             StyleData["Placeholder", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PrimaryPlaceholder"], StyleMenuListing -> None, 
             DrawHighlighted -> True, FontSlant -> "Italic", Background -> 
             RGBColor[0.912505, 0.891798, 0.507774], 
             TagBoxOptions -> {
              Editable -> False, Selectable -> False, StripWrapperBoxes -> 
               False}], 
            Cell[
             StyleData["PrimaryPlaceholder", "Presentation"]], 
            Cell[
             StyleData["PrimaryPlaceholder", "Condensed"]], 
            Cell[
             StyleData["PrimaryPlaceholder", "Printout"]]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["FormatType Styles", "Section"], 
         Cell[
         "The cells below define styles that are mixed in with the styles of \
most cells.  If a cell's FormatType matches the name of one of the styles \
defined below, then that style is applied between the cell's style and its \
own options. This is particularly true of Input and Output.", "Text"], 
         Cell[
          StyleData["CellExpression"], PageWidth -> Infinity, 
          CellMargins -> {{6, Inherited}, {Inherited, Inherited}}, 
          ShowCellLabel -> False, ShowSpecialCharacters -> False, 
          AllowInlineCells -> False, Hyphenation -> False, 
          AutoItalicWords -> {}, StyleMenuListing -> None, FontFamily -> 
          "Courier", FontSize -> 12, Background -> GrayLevel[1]], 
         Cell[
          StyleData["InputForm"], InputAutoReplacements -> {}, 
          AllowInlineCells -> False, Hyphenation -> False, StyleMenuListing -> 
          None, FontFamily -> "Courier"], 
         Cell[
          StyleData["OutputForm"], PageWidth -> Infinity, TextAlignment -> 
          Left, LineSpacing -> {0.6, 1}, StyleMenuListing -> None, FontFamily -> 
          "Courier"], 
         Cell[
          StyleData["StandardForm"], 
          InputAutoReplacements -> {
           "->" -> "\[Rule]", ":>" -> "\[RuleDelayed]", "<=" -> 
            "\[LessEqual]", ">=" -> "\[GreaterEqual]", "!=" -> "\[NotEqual]", 
            "==" -> "\[Equal]", Inherited}, LineSpacing -> {1.25, 0}, 
          StyleMenuListing -> None, FontFamily -> "Courier"], 
         Cell[
          StyleData["TraditionalForm"], 
          InputAutoReplacements -> {
           "->" -> "\[Rule]", ":>" -> "\[RuleDelayed]", "<=" -> 
            "\[LessEqual]", ">=" -> "\[GreaterEqual]", "!=" -> "\[NotEqual]", 
            "==" -> "\[Equal]", Inherited}, LineSpacing -> {1.25, 0}, 
          SingleLetterItalics -> True, TraditionalFunctionNotation -> True, 
          DelimiterMatching -> None, StyleMenuListing -> None], 
         Cell[
         "The style defined below is mixed in to any cell that is in an \
inline cell within another.", "Text"], 
         Cell[
          StyleData["InlineCell"], LanguageCategory -> "Formula", ScriptLevel -> 
          1, StyleMenuListing -> None], 
         Cell[
          StyleData["InlineCellEditing"], StyleMenuListing -> None, 
          Background -> RGBColor[1, 0.749996, 0.8]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Automatic Styles", "Section"], 
         Cell[
         "The cells below define styles that are used to affect the display \
of certain types of objects in typeset expressions.  For example, \
\"UnmatchedBracket\" style defines how unmatched bracket, curly bracket, and \
parenthesis characters are displayed (typically by coloring them to make them \
stand out).", "Text"], 
         Cell[
          StyleData["UnmatchedBracket"], StyleMenuListing -> None, FontColor -> 
          RGBColor[0.760006, 0.330007, 0.8]]}, Closed]]}, Open]]}, Visible -> 
  False, FrontEndVersion -> 
  "7.0 for Mac OS X x86 (32-bit) (November 10, 2008)", StyleDefinitions -> 
  "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 103, 5, 144, "Title"],
Cell[673, 29, 80, 3, 96, "Subsubtitle"],
Cell[CellGroupData[{
Cell[778, 36, 25, 0, 72, "Section"],
Cell[806, 38, 943, 24, 291, "PackageInput"],
Cell[1752, 64, 128, 3, 39, "Text"],
Cell[1883, 69, 3359, 93, 797, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5279, 167, 32, 0, 40, "Section"],
Cell[5314, 169, 135, 3, 62, "Text"],
Cell[5452, 174, 781, 17, 222, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6270, 196, 42, 0, 40, "Section"],
Cell[6315, 198, 2139, 55, 475, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[8491, 258, 31, 0, 40, "Section"],
Cell[8525, 260, 60, 0, 39, "Text"],
Cell[8588, 262, 108, 2, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[8721, 268, 43, 0, 63, "Subsection"],
Cell[8767, 270, 1542, 43, 210, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[10346, 318, 52, 0, 37, "Subsection"],
Cell[10401, 320, 491, 13, 108, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[10929, 338, 44, 0, 37, "Subsection"],
Cell[10976, 340, 736, 22, 108, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[11749, 367, 36, 0, 37, "Subsection"],
Cell[11788, 369, 1896, 56, 248, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[13721, 430, 52, 0, 37, "Subsection"],
Cell[13776, 432, 3675, 99, 474, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[17488, 536, 42, 0, 37, "Subsection"],
Cell[17533, 538, 4611, 122, 497, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[22181, 665, 47, 0, 37, "Subsection"],
Cell[22231, 667, 4160, 109, 474, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[26428, 781, 53, 0, 37, "Subsection"],
Cell[26484, 783, 169, 4, 90, "PackageInput"],
Cell[26656, 789, 308, 10, 93, "PackageInput"],
Cell[26967, 801, 3286, 93, 420, "PackageInput"],
Cell[30256, 896, 2258, 61, 243, "PackageInput"],
Cell[32517, 959, 2254, 61, 243, "PackageInput"],
Cell[34774, 1022, 2909, 81, 251, "PackageInput"],
Cell[37686, 1105, 1950, 53, 243, "PackageInput"],
Cell[39639, 1160, 1944, 53, 243, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[41620, 1218, 55, 0, 37, "Subsection"],
Cell[41678, 1220, 175, 4, 60, "PackageInput"],
Cell[41856, 1226, 3956, 111, 375, "PackageInput"],
Cell[45815, 1339, 3465, 100, 323, "PackageInput"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[49329, 1445, 34, 0, 40, "Section"],
Cell[49366, 1447, 64, 0, 39, "Text"],
Cell[49433, 1449, 822, 18, 268, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
