(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     66206,       1680]
NotebookOptionsPosition[     64404,       1616]
NotebookOutlinePosition[     64826,       1634]
CellTagsIndexPosition[     64783,       1631]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["NAlgebra Package", "Title",
 CellChangeTimes->{{3.474084518955797*^9, 3.474084521022291*^9}, {
  3.474786592742001*^9, 3.474786595220525*^9}}],

Cell["\<\
Markus van Almsick
Technische Universiteit Eindhoven
\[Copyright]2010\
\>", "Subsubtitle",
 CellChangeTimes->{{3.474084522934184*^9, 3.474084523317668*^9}}],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\[IndentingNewLine]", 
   "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "[", "\"\<MathVisionTools`NAlgebra`\>\"", "]"}], 
     " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"2010", ",", "2", ",", "10", ",", "10", ",", "0", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput",
 CellChangeTimes->{{3.474084527829178*^9, 3.474084541496231*^9}, {
  3.474786604254691*^9, 3.474786607228919*^9}}],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`NAlgebra`"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Author", ":", " ", 
     RowBox[{"Markus", " ", "van", " ", "Almsick"}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"M", ".", "v", ".", 
       RowBox[{"Almsick", "@", "tue"}], ".", "nl"}]}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`NAlgebra`"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "1.0"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "7.0"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2010"}]}]}], ",", " ", 
    RowBox[{"Technische", " ", "Universiteit", " ", "Eindhoven"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "NAlgebra"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "implements", " ", "fast", " ", "routines", 
      " ", "to", " ", "solve", " ", 
      RowBox[{"polynomials", "."}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", "quartic"}]}], ",", " ", "cubic", ",", " ",
     "quadratic", ",", " ", "polynomial", ",", " ", "algebra"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"February", " ", "2010"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":", " ", "none"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.4740845471708117`*^9, 3.474084595994582*^9}, 
   3.474097969558043*^9, {3.474786612850473*^9, 3.474786676712714*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeginPackage", "[", "\"\<MathVisionTools`NAlgebra`\>\"", "]"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{"Unprotect", "[", "\[IndentingNewLine]", 
  RowBox[{
  "NQuadraticRootsReal", ",", "NCubicRootsReal", ",", "NQuarticRootsReal", 
   ",", "NQuadraticRootsComplex", ",", "NCubicRootsComplex", ",", 
   "NQuarticRootsComplex", ",", "NQuadraticUnitRootsComplex", ",", 
   "NCubicUnitRootsComplex", ",", "NQuarticUnitRootsComplex"}], 
  "\[IndentingNewLine]", "]"}]}], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.474084606139537*^9, 3.474084621505604*^9}, 
   3.474095644858821*^9, {3.474097269077238*^9, 3.474097270508334*^9}, {
   3.474786681716853*^9, 3.474786693091259*^9}, {3.474787141144257*^9, 
   3.4747871445907784`*^9}, {3.474787242498556*^9, 3.47478724462894*^9}, {
   3.474794324038603*^9, 3.4747943595842457`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NQuadraticRootsReal", "::", "usage"}], "=", 
    "\"\<NQuadraticRootsReal[a,b,c] caluclates the roots of the polynomial a*\
\!\(\*SuperscriptBox[\(z\), \(2\)]\)+b*z+c==0 for real-valued coefficients a, \
b, and c.\>\""}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NCubicRootsReal", "::", "usage"}], "=", 
    "\"\<NCubicRootsReal[a,b,c,d] caluclates the roots of the polynomial a*\!\
\(\*SuperscriptBox[\(z\), \(3\)]\)+b*\!\(\*SuperscriptBox[\(z\), \
\(2\)]\)+c*z+d==0 for real-valued coefficients a, b, c, and d.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NQuarticRootsReal", "::", "usage"}], "=", 
    "\"\<NQuarticRootsReal[a,b,c,d,e] caluclates the roots of the polynomial \
a*\!\(\*SuperscriptBox[\(z\), \(4\)]\)+b*\!\(\*SuperscriptBox[\(z\), \
\(3\)]\)+c*\!\(\*SuperscriptBox[\(z\), \(2\)]\)+d*z+e==0 for real-valued \
coefficients a, b, c, d, and e.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NQuadraticRootsComplex", "::", "usage"}], "=", 
    "\"\<NQuadraticRootsComplex[a,b,c] caluclates the roots of the polynomial \
a*\!\(\*SuperscriptBox[\(z\), \(2\)]\)+b*z+c==0 for complex-valued \
coefficients a, b, and c.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NCubicRootsComplex", "::", "usage"}], "=", 
    "\"\<NCubicRootsComplex[a,b,c,d] caluclates the roots of the polynomial \
a*\!\(\*SuperscriptBox[\(z\), \(3\)]\)+b*\!\(\*SuperscriptBox[\(z\), \
\(2\)]\)+c*z+d==0 for complex-valued coefficients a, b, c, and d.\>\""}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NQuarticRootsComplex", "::", "usage"}], "=", 
    "\"\<NQuarticRootsComplex[a,b,c,d,e] caluclates the roots of the \
polynomial a*\!\(\*SuperscriptBox[\(z\), \
\(4\)]\)+b*\!\(\*SuperscriptBox[\(z\), \(3\)]\)+c*\!\(\*SuperscriptBox[\(z\), \
\(2\)]\)+d*z+e==0 for complex-valued coefficients a, b, c, d, and e.\>\""}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NQuadraticUnitRootsComplex", "::", "usage"}], "=", 
    "\"\<NQuadraticUnitRootsComplex[a,b,c] renders the List of roots with \
norm 1 of the polynomial a*\!\(\*SuperscriptBox[\(z\), \(2\)]\)+b*z+c==0 for \
complex-valued coefficients a, b, and c.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NCubicUnitRootsComplex", "::", "usage"}], "=", 
    "\"\<NCubicUnitRootsComplex[a,b,c,d] renders the List of roots with norm \
1 of the polynomial a*\!\(\*SuperscriptBox[\(z\), \
\(3\)]\)+b*\!\(\*SuperscriptBox[\(z\), \(2\)]\)+c*z+d==0 for complex-valued \
coefficients a, b, c, and d.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NQuarticUnitRootsComplex", "::", "usage"}], "=", 
   "\"\<NQuarticUnitRootsComplex[a,b,c,d,e] renders the List of roots with \
norm 1 of the polynomial a*\!\(\*SuperscriptBox[\(z\), \
\(4\)]\)+b*\!\(\*SuperscriptBox[\(z\), \(3\)]\)+c*\!\(\*SuperscriptBox[\(z\), \
\(2\)]\)+d*z+e==0 for complex-valued coefficients a, b, c, d, and e.\>\""}], 
  ";"}]}], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.474092772433627*^9, 3.474092850809124*^9}, {
  3.474095185370227*^9, 3.474095198032914*^9}, {3.4740960259271793`*^9, 
  3.474096094191236*^9}, {3.474096142911748*^9, 3.4740965282587967`*^9}, {
  3.474096576570375*^9, 3.474096773005929*^9}, {3.47409691582626*^9, 
  3.4740969817528677`*^9}, {3.474097262616395*^9, 3.4740972946835213`*^9}, {
  3.474786696821889*^9, 3.474786709768022*^9}, {3.474786762153598*^9, 
  3.474786897240162*^9}, {3.474787049855152*^9, 3.474787121809969*^9}, {
  3.474787247662179*^9, 3.474787274878214*^9}, {3.474794026312869*^9, 
  3.474794130527005*^9}, {3.474794171660911*^9, 3.474794294424423*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["NQuadratic", "Subsection",
 CellChangeTimes->{{3.474096013536991*^9, 3.474096015601246*^9}, {
   3.474096804539312*^9, 3.474096807011284*^9}, 3.474786718038619*^9, {
   3.474786929538397*^9, 3.4747869303467712`*^9}, {3.47478699911423*^9, 
   3.474787001011284*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "NQuadratic", " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"NQuadraticRootsReal", "=", "\[IndentingNewLine]", 
     RowBox[{"Compile", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"c", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"d", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"e", ",", "_Real"}], "}"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"c", "\[Equal]", " ", "0"}], ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"d", "\[Equal]", " ", "0"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"-", 
             FractionBox["e", "d"]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "1"}], "}"}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["#", "2"], "-", 
                FractionBox["e", "c"]}]]}], " ", "-", " ", "#"}], ")"}], 
           "&"}], "[", 
          FractionBox["d", 
           RowBox[{"2", " ", "c"}]], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"NQuadraticRootsComplex", "=", "\[IndentingNewLine]", 
     RowBox[{"Compile", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"c", ",", "_Complex"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"d", ",", "_Complex"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"e", ",", "_Complex"}], "}"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"c", "\[Equal]", " ", "0"}], ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"d", "\[Equal]", " ", "0"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"-", 
             FractionBox["e", "d"]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", "1"}], "}"}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["#", "2"], "-", 
                FractionBox["e", "c"]}]]}], " ", "-", " ", "#"}], ")"}], 
           "&"}], "[", 
          FractionBox["d", 
           RowBox[{"2", " ", "c"}]], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"NQuadraticUnitRootsComplex", "=", "\[IndentingNewLine]", 
    RowBox[{"Compile", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"c", ",", "_Complex"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"d", ",", "_Complex"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"e", ",", "_Complex"}], "}"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Select", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"c", "\[Equal]", " ", "0"}], ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"d", "\[Equal]", " ", "0"}], ",", 
            RowBox[{"{", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"-", 
              FractionBox["e", "d"]}], "}"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", "1"}], "}"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["#", "2"], "-", 
                 FractionBox["e", "c"]}]]}], " ", "-", " ", "#"}], ")"}], 
            "&"}], "[", 
           FractionBox["d", 
            RowBox[{"2", " ", "c"}]], "]"}]}], "\[IndentingNewLine]", "]"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Round", "[", 
            RowBox[{
             RowBox[{"Abs", "[", "#", "]"}], ",", "0.00000001`"}], "]"}], "===",
            "1.`"}], ")"}], "&"}]}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}]}]}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.474084654367385*^9, 3.4740847818687897`*^9}, {
   3.474084878807519*^9, 3.4740849648690977`*^9}, {3.474085008333084*^9, 
   3.4740850430747347`*^9}, {3.474085736946537*^9, 3.4740858002300587`*^9}, {
   3.4740858657843437`*^9, 3.4740859043003683`*^9}, {3.474092646103478*^9, 
   3.474092733142741*^9}, 3.474092770573106*^9, {3.4740929297133217`*^9, 
   3.4740930356600933`*^9}, 3.4740930695470123`*^9, {3.474093104584824*^9, 
   3.47409320035819*^9}, 3.474093274233268*^9, {3.474093419031234*^9, 
   3.474093419179723*^9}, 3.474095170515188*^9, {3.4740956720465727`*^9, 
   3.474095676333323*^9}, {3.474096801434593*^9, 3.47409689963868*^9}, {
   3.474097009275313*^9, 3.47409706626554*^9}, {3.474097165750875*^9, 
   3.4740971667094316`*^9}, 3.474786727297843*^9, {3.474786944570949*^9, 
   3.4747869696193666`*^9}, {3.474787005551045*^9, 3.474787024834919*^9}, 
   3.474787064585688*^9, {3.474787207850506*^9, 3.4747872089203053`*^9}, {
   3.4747872842124033`*^9, 3.4747872992280893`*^9}, 3.474792634543807*^9, {
   3.474793974116933*^9, 3.4747940141265*^9}, {3.4748060462914667`*^9, 
   3.474806068082878*^9}, 3.474808502418188*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["NCubic", "Subsection",
 CellChangeTimes->{{3.474096013536991*^9, 3.474096015601246*^9}, {
   3.474096804539312*^9, 3.474096807011284*^9}, 3.474786718038619*^9, {
   3.474786929538397*^9, 3.4747869303467712`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "NCubic", " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"NCubicRootsReal", "=", "\[IndentingNewLine]", 
    RowBox[{"Compile", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"b", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"c", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"d", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"e", ",", "_Real"}], "}"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Block", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"mc", ",", "md", ",", "P", ",", "Q"}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"b", "\[Equal]", " ", "0"}], ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"c", "\[Equal]", " ", "0"}], ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"d", "\[Equal]", " ", "0"}], ",", 
              RowBox[{"{", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"-", 
                FractionBox["e", "d"]}], "}"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"-", "1"}], ",", "1"}], "}"}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["#", "2"], "-", 
                   FractionBox["e", "c"]}]]}], " ", "-", " ", "#"}], ")"}], 
              "&"}], "[", 
             FractionBox["d", 
              RowBox[{"2", " ", "c"}]], "]"}]}], "\[IndentingNewLine]", "]"}],
           ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"mc", "=", 
            FractionBox["c", 
             RowBox[{"3", "b"}]]}], ";", 
           RowBox[{"md", "=", 
            FractionBox["d", "b"]}], ";", "\[IndentingNewLine]", 
           RowBox[{"P", " ", "=", " ", 
            RowBox[{
             FractionBox["md", "3"], " ", "-", " ", 
             SuperscriptBox["mc", "2"]}]}], ";", " ", 
           RowBox[{"Q", " ", "=", " ", 
            RowBox[{
             FractionBox["e", 
              RowBox[{"2", "b"}]], " ", "+", " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["mc", "2"], "-", 
                FractionBox["md", "2"]}], ")"}], "mc"}]}]}], ";", " ", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"#", "-", 
               FractionBox["P", "#"], "-", "mc"}], ")"}], "&"}], "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", 
               FractionBox[
                RowBox[{
                 RowBox[{"-", "1"}], "+", 
                 RowBox[{"\[ImaginaryI]", 
                  SqrtBox["3"]}]}], "2"], ",", 
               FractionBox[
                RowBox[{
                 RowBox[{"-", "1"}], "-", 
                 RowBox[{"\[ImaginaryI]", 
                  SqrtBox["3"]}]}], "2"]}], "}"}], " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "Q"}], "+", " ", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["Q", "2"], "+", 
                  SuperscriptBox["P", "3"]}]]}], ")"}], 
              RowBox[{"1", "/", "3"}]]}], "]"}]}]}], "\[IndentingNewLine]", 
         "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"NCubicRootsComplex", "=", "\[IndentingNewLine]", 
     RowBox[{"Compile", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"b", ",", "_Complex"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"c", ",", "_Complex"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"d", ",", "_Complex"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"e", ",", "_Complex"}], "}"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Block", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"mc", ",", "md", ",", "P", ",", "Q"}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"b", "\[Equal]", " ", "0"}], ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"c", "\[Equal]", " ", "0"}], ",", "\[IndentingNewLine]", 
             
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"d", "\[Equal]", " ", "0"}], ",", 
               RowBox[{"{", "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"-", 
                 FractionBox["e", "d"]}], "}"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}], 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["#", "2"], "-", 
                    FractionBox["e", "c"]}]]}], " ", "-", " ", "#"}], ")"}], 
               "&"}], "[", 
              FractionBox["d", 
               RowBox[{"2", " ", "c"}]], "]"}]}], "\[IndentingNewLine]", 
            "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"mc", "=", 
             FractionBox["c", 
              RowBox[{"3", "b"}]]}], ";", 
            RowBox[{"md", "=", 
             FractionBox["d", "b"]}], ";", "\[IndentingNewLine]", 
            RowBox[{"P", " ", "=", " ", 
             RowBox[{
              FractionBox["md", "3"], " ", "-", " ", 
              SuperscriptBox["mc", "2"]}]}], ";", " ", 
            RowBox[{"Q", " ", "=", " ", 
             RowBox[{
              FractionBox["e", 
               RowBox[{"2", "b"}]], " ", "+", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["mc", "2"], "-", 
                 FractionBox["md", "2"]}], ")"}], "mc"}]}]}], ";", " ", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "-", 
                FractionBox["P", "#"], "-", "mc"}], ")"}], "&"}], "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", 
                FractionBox[
                 RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"\[ImaginaryI]", 
                   SqrtBox["3"]}]}], "2"], ",", 
                FractionBox[
                 RowBox[{
                  RowBox[{"-", "1"}], "-", 
                  RowBox[{"\[ImaginaryI]", 
                   SqrtBox["3"]}]}], "2"]}], "}"}], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "Q"}], "+", " ", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["Q", "2"], "+", 
                   SuperscriptBox["P", "3"]}]]}], ")"}], 
               RowBox[{"1", "/", "3"}]]}], "]"}]}]}], "\[IndentingNewLine]", 
          "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"NCubicUnitRootsComplex", "=", "\[IndentingNewLine]", 
    RowBox[{"Compile", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"b", ",", "_Complex"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"c", ",", "_Complex"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"d", ",", "_Complex"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"e", ",", "_Complex"}], "}"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Block", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"mc", ",", "md", ",", "P", ",", "Q"}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Select", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"b", "\[Equal]", " ", "0"}], ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"c", "\[Equal]", " ", "0"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"d", "\[Equal]", " ", "0"}], ",", 
                RowBox[{"{", "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"-", 
                  FractionBox["e", "d"]}], "}"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}], 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["#", "2"], "-", 
                    FractionBox["e", "c"]}]]}], " ", "-", " ", "#"}], ")"}], 
                "&"}], "[", 
               FractionBox["d", 
                RowBox[{"2", " ", "c"}]], "]"}]}], "\[IndentingNewLine]", 
             "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"mc", "=", 
              FractionBox["c", 
               RowBox[{"3", "b"}]]}], ";", 
             RowBox[{"md", "=", 
              FractionBox["d", "b"]}], ";", "\[IndentingNewLine]", 
             RowBox[{"P", " ", "=", " ", 
              RowBox[{
               FractionBox["md", "3"], " ", "-", " ", 
               SuperscriptBox["mc", "2"]}]}], ";", " ", 
             RowBox[{"Q", " ", "=", " ", 
              RowBox[{
               FractionBox["e", 
                RowBox[{"2", "b"}]], " ", "+", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["mc", "2"], "-", 
                  FractionBox["md", "2"]}], ")"}], "mc"}]}]}], ";", " ", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"#", "-", 
                 FractionBox["P", "#"], "-", "mc"}], ")"}], "&"}], "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"1", ",", 
                 FractionBox[
                  RowBox[{
                   RowBox[{"-", "1"}], "+", 
                   RowBox[{"\[ImaginaryI]", 
                    SqrtBox["3"]}]}], "2"], ",", 
                 FractionBox[
                  RowBox[{
                   RowBox[{"-", "1"}], "-", 
                   RowBox[{"\[ImaginaryI]", 
                    SqrtBox["3"]}]}], "2"]}], "}"}], " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "Q"}], "+", " ", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["Q", "2"], "+", 
                    SuperscriptBox["P", "3"]}]]}], ")"}], 
                RowBox[{"1", "/", "3"}]]}], "]"}]}]}], "\[IndentingNewLine]", 
           "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Round", "[", 
              RowBox[{
               RowBox[{"Abs", "[", "#", "]"}], ",", "0.00000001`"}], "]"}], "===",
              "1.`"}], ")"}], "&"}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
     "]"}]}]}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.474084654367385*^9, 3.4740847818687897`*^9}, {
   3.474084878807519*^9, 3.4740849648690977`*^9}, {3.474085008333084*^9, 
   3.4740850430747347`*^9}, {3.474085736946537*^9, 3.4740858002300587`*^9}, {
   3.4740858657843437`*^9, 3.4740859043003683`*^9}, {3.474092646103478*^9, 
   3.474092733142741*^9}, 3.474092770573106*^9, {3.4740929297133217`*^9, 
   3.4740930356600933`*^9}, 3.4740930695470123`*^9, {3.474093104584824*^9, 
   3.47409320035819*^9}, 3.474093274233268*^9, {3.474093419031234*^9, 
   3.474093419179723*^9}, 3.474095170515188*^9, {3.4740956720465727`*^9, 
   3.474095676333323*^9}, {3.474096801434593*^9, 3.47409689963868*^9}, {
   3.474097009275313*^9, 3.47409706626554*^9}, {3.474097165750875*^9, 
   3.4740971667094316`*^9}, 3.474786727297843*^9, {3.474786944570949*^9, 
   3.4747869696193666`*^9}, 3.474787068196336*^9, {3.474787213433442*^9, 
   3.474787214236681*^9}, {3.474787314460396*^9, 3.474787327643313*^9}, {
   3.474792638802493*^9, 3.474792653069111*^9}, {3.474793922835659*^9, 
   3.474793950557482*^9}, {3.474794429079669*^9, 3.474794431486045*^9}, {
   3.474806072283827*^9, 3.474806084605712*^9}, 3.474808498581143*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["NQuartic", "Subsection",
 CellChangeTimes->{{3.474096013536991*^9, 3.474096015601246*^9}, {
   3.474096804539312*^9, 3.474096807011284*^9}, 3.474786718038619*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "NQuartic", " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"NQuarticRootsReal", "=", "\[IndentingNewLine]", 
    RowBox[{"Compile", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"a", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"b", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"c", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"d", ",", "_Real"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"e", ",", "_Real"}], "}"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Block", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "mb", ",", "mc", ",", "md", ",", "P", ",", "Q", ",", "R", ",", "S", 
          ",", "\[Alpha]", ",", "\[Beta]", ",", "\[Gamma]"}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"a", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"b", "\[Equal]", " ", "0"}], ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"c", "\[Equal]", " ", "0"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"d", "\[Equal]", " ", "0"}], ",", 
                RowBox[{"{", "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"-", 
                  FractionBox["e", "d"]}], "}"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}], 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["#", "2"], "-", 
                    FractionBox["e", "c"]}]]}], " ", "-", " ", "#"}], ")"}], 
                "&"}], "[", 
               FractionBox["d", 
                RowBox[{"2", " ", "c"}]], "]"}]}], "\[IndentingNewLine]", 
             "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"mc", "=", 
              FractionBox["c", 
               RowBox[{"3", "b"}]]}], ";", 
             RowBox[{"md", "=", 
              FractionBox["d", "b"]}], ";", "\[IndentingNewLine]", 
             RowBox[{"P", " ", "=", " ", 
              RowBox[{
               FractionBox["md", "3"], " ", "-", " ", 
               SuperscriptBox["mc", "2"]}]}], ";", " ", 
             RowBox[{"Q", " ", "=", " ", 
              RowBox[{
               FractionBox["e", 
                RowBox[{"2", "b"}]], " ", "+", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["mc", "2"], "-", 
                  FractionBox["md", "2"]}], ")"}], "mc"}]}]}], ";", " ", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"#", "-", 
                 FractionBox["P", "#"], "-", "mc"}], ")"}], "&"}], "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"1", ",", 
                 FractionBox[
                  RowBox[{
                   RowBox[{"-", "1"}], "+", 
                   RowBox[{"\[ImaginaryI]", 
                    SqrtBox["3"]}]}], "2"], ",", 
                 FractionBox[
                  RowBox[{
                   RowBox[{"-", "1"}], "-", 
                   RowBox[{"\[ImaginaryI]", 
                    SqrtBox["3"]}]}], "2"]}], "}"}], " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "Q"}], "+", " ", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["Q", "2"], "+", 
                    SuperscriptBox["P", "3"]}]]}], ")"}], 
                RowBox[{"1", "/", "3"}]]}], "]"}]}]}], "\[IndentingNewLine]", 
           "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"mb", "=", 
            FractionBox["b", 
             RowBox[{"4", "a"}]]}], ";", 
           RowBox[{"mc", "=", 
            FractionBox["c", "a"]}], ";", 
           RowBox[{"md", "=", 
            FractionBox["d", "a"]}], ";", "\[IndentingNewLine]", 
           RowBox[{"\[Alpha]", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "6"}], 
              SuperscriptBox["mb", "2"]}], "+", "mc"}]}], ";", 
           RowBox[{"\[Beta]", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"8", 
                 SuperscriptBox["mb", "2"]}], "-", 
                RowBox[{"2", "mc"}]}], " ", ")"}], "mb"}], "+", "md"}]}], ";", 
           RowBox[{"\[Gamma]", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "3"}], 
                    SuperscriptBox["mb", "2"]}], "+", "mc"}], ")"}], " ", 
                 "mb"}], "-", " ", "md"}], ")"}], " ", "mb"}], "+", 
             FractionBox["e", "a"]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"\[Beta]", "===", "0"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Q", "=", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["\[Alpha]", "2"], "-", 
                 RowBox[{"4", "\[Gamma]"}]}]]}], ";", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"-", "#1"}], ",", 
                   RowBox[{"-", "#2"}], ",", "#1", ",", "#2"}], "}"}], "&"}], 
                "[", 
                RowBox[{
                 SqrtBox[
                  FractionBox[
                   RowBox[{
                    RowBox[{"-", "\[Alpha]"}], "-", "Q"}], "2"]], ",", 
                 SqrtBox[
                  FractionBox[
                   RowBox[{
                    RowBox[{"-", "\[Alpha]"}], "+", "Q"}], "2"]]}], "]"}], 
               "-", "mb"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"P", "=", 
               RowBox[{"-", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["\[Alpha]", "2"], "+", 
                  RowBox[{"12", "\[Gamma]"}]}], "36"]}]}], ";", 
              RowBox[{"Q", " ", "=", " ", 
               RowBox[{
                FractionBox[
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"36", "\[Gamma]"}], "-", 
                    SuperscriptBox["\[Alpha]", "2"]}], ")"}], "\[Alpha]"}], 
                 "216"], "-", " ", 
                FractionBox[
                 SuperscriptBox["\[Beta]", "2"], "16"]}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"R", " ", "=", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["5", "6"]}], "\[Alpha]"}], "-", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"#", "==", "0"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", " ", "Q"}], ")"}], "^", 
                    RowBox[{"(", 
                    RowBox[{"1", "/", "3"}], ")"}]}], ",", " ", 
                    RowBox[{
                    FractionBox["P", "#"], "-", "#"}]}], "]"}], "&"}], "[", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "Q"}], "+", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["Q", "2"], "+", 
                    SuperscriptBox["P", "3"]}]]}], ")"}], "^", 
                   RowBox[{"(", 
                    RowBox[{"1", "/", "3"}], ")"}]}], "]"}], ")"}]}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"S", " ", "=", " ", 
               FractionBox[
                SqrtBox[
                 RowBox[{"\[Alpha]", " ", "+", " ", 
                  RowBox[{"2", "R"}]}]], "2"]}], ";", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "#1"}], "-", "S"}], ",", 
                    RowBox[{"#1", "-", "S"}], ",", 
                    RowBox[{
                    RowBox[{"-", "#2"}], "+", "S"}], ",", 
                    RowBox[{"#2", "+", "S"}]}], "}"}], "&"}], "[", 
                   RowBox[{
                    FractionBox[
                    SqrtBox[
                    RowBox[{"#1", "+", "#2"}]], "2"], ",", 
                    FractionBox[
                    SqrtBox[
                    RowBox[{"#1", "-", "#2"}]], "2"]}], "]"}], ")"}], "&"}], 
                "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "3"}], "\[Alpha]"}], " ", "-", 
                  RowBox[{"2", " ", "R"}]}], ",", 
                 FractionBox["\[Beta]", "S"]}], "]"}], "-", "mb"}]}]}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"NQuarticRootsComplex", "=", "\[IndentingNewLine]", 
     RowBox[{"Compile", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"a", ",", "_Complex"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"b", ",", "_Complex"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"c", ",", "_Complex"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"d", ",", "_Complex"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"e", ",", "_Complex"}], "}"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Block", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "mb", ",", "mc", ",", "md", ",", "P", ",", "Q", ",", "R", ",", "S", 
           ",", "\[Alpha]", ",", "\[Beta]", ",", "\[Gamma]"}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"a", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"b", "\[Equal]", " ", "0"}], ",", "\[IndentingNewLine]", 
             
             RowBox[{"If", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"c", "\[Equal]", " ", "0"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"d", "\[Equal]", " ", "0"}], ",", 
                 RowBox[{"{", "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"-", 
                   FractionBox["e", "d"]}], "}"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}], 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["#", "2"], "-", 
                    FractionBox["e", "c"]}]]}], " ", "-", " ", "#"}], ")"}], 
                 "&"}], "[", 
                FractionBox["d", 
                 RowBox[{"2", " ", "c"}]], "]"}]}], "\[IndentingNewLine]", 
              "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"mc", "=", 
               FractionBox["c", 
                RowBox[{"3", "b"}]]}], ";", 
              RowBox[{"md", "=", 
               FractionBox["d", "b"]}], ";", "\[IndentingNewLine]", 
              RowBox[{"P", " ", "=", " ", 
               RowBox[{
                FractionBox["md", "3"], " ", "-", " ", 
                SuperscriptBox["mc", "2"]}]}], ";", " ", 
              RowBox[{"Q", " ", "=", " ", 
               RowBox[{
                FractionBox["e", 
                 RowBox[{"2", "b"}]], " ", "+", " ", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["mc", "2"], "-", 
                   FractionBox["md", "2"]}], ")"}], "mc"}]}]}], ";", " ", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"#", "-", 
                  FractionBox["P", "#"], "-", "mc"}], ")"}], "&"}], "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", 
                  FractionBox[
                   RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    RowBox[{"\[ImaginaryI]", 
                    SqrtBox["3"]}]}], "2"], ",", 
                  FractionBox[
                   RowBox[{
                    RowBox[{"-", "1"}], "-", 
                    RowBox[{"\[ImaginaryI]", 
                    SqrtBox["3"]}]}], "2"]}], "}"}], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "Q"}], "+", " ", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["Q", "2"], "+", 
                    SuperscriptBox["P", "3"]}]]}], ")"}], 
                 RowBox[{"1", "/", "3"}]]}], "]"}]}]}], "\[IndentingNewLine]",
             "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"mb", "=", 
             FractionBox["b", 
              RowBox[{"4", "a"}]]}], ";", 
            RowBox[{"mc", "=", 
             FractionBox["c", "a"]}], ";", 
            RowBox[{"md", "=", 
             FractionBox["d", "a"]}], ";", "\[IndentingNewLine]", 
            RowBox[{"\[Alpha]", "=", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "6"}], 
               SuperscriptBox["mb", "2"]}], "+", "mc"}]}], ";", 
            RowBox[{"\[Beta]", "=", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"8", 
                  SuperscriptBox["mb", "2"]}], "-", 
                 RowBox[{"2", "mc"}]}], " ", ")"}], "mb"}], "+", "md"}]}], 
            ";", 
            RowBox[{"\[Gamma]", "=", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", "3"}], 
                    SuperscriptBox["mb", "2"]}], "+", "mc"}], ")"}], " ", 
                  "mb"}], "-", " ", "md"}], ")"}], " ", "mb"}], "+", 
              FractionBox["e", "a"]}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"If", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"\[Beta]", "===", "0"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Q", "=", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["\[Alpha]", "2"], "-", 
                  RowBox[{"4", "\[Gamma]"}]}]]}], ";", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "#1"}], ",", 
                    RowBox[{"-", "#2"}], ",", "#1", ",", "#2"}], "}"}], "&"}],
                  "[", 
                 RowBox[{
                  SqrtBox[
                   FractionBox[
                    RowBox[{
                    RowBox[{"-", "\[Alpha]"}], "-", "Q"}], "2"]], ",", 
                  SqrtBox[
                   FractionBox[
                    RowBox[{
                    RowBox[{"-", "\[Alpha]"}], "+", "Q"}], "2"]]}], "]"}], 
                "-", "mb"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"P", "=", 
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{
                   SuperscriptBox["\[Alpha]", "2"], "+", 
                   RowBox[{"12", "\[Gamma]"}]}], "36"]}]}], ";", 
               RowBox[{"Q", " ", "=", " ", 
                RowBox[{
                 FractionBox[
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"36", "\[Gamma]"}], "-", 
                    SuperscriptBox["\[Alpha]", "2"]}], ")"}], "\[Alpha]"}], 
                  "216"], "-", " ", 
                 FractionBox[
                  SuperscriptBox["\[Beta]", "2"], "16"]}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"R", " ", "=", " ", 
                RowBox[{
                 RowBox[{
                  RowBox[{"-", 
                   FractionBox["5", "6"]}], "\[Alpha]"}], "-", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"#", "==", "0"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", " ", "Q"}], ")"}], "^", 
                    RowBox[{"(", 
                    RowBox[{"1", "/", "3"}], ")"}]}], ",", " ", 
                    RowBox[{
                    FractionBox["P", "#"], "-", "#"}]}], "]"}], "&"}], "[", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "Q"}], "+", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["Q", "2"], "+", 
                    SuperscriptBox["P", "3"]}]]}], ")"}], "^", 
                    RowBox[{"(", 
                    RowBox[{"1", "/", "3"}], ")"}]}], "]"}], ")"}]}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"S", " ", "=", " ", 
                FractionBox[
                 SqrtBox[
                  RowBox[{"\[Alpha]", " ", "+", " ", 
                   RowBox[{"2", "R"}]}]], "2"]}], ";", "\[IndentingNewLine]", 
               
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "#1"}], "-", "S"}], ",", 
                    RowBox[{"#1", "-", "S"}], ",", 
                    RowBox[{
                    RowBox[{"-", "#2"}], "+", "S"}], ",", 
                    RowBox[{"#2", "+", "S"}]}], "}"}], "&"}], "[", 
                    RowBox[{
                    FractionBox[
                    SqrtBox[
                    RowBox[{"#1", "+", "#2"}]], "2"], ",", 
                    FractionBox[
                    SqrtBox[
                    RowBox[{"#1", "-", "#2"}]], "2"]}], "]"}], ")"}], "&"}], 
                 "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "3"}], "\[Alpha]"}], " ", "-", 
                   RowBox[{"2", " ", "R"}]}], ",", 
                  FractionBox["\[Beta]", "S"]}], "]"}], "-", "mb"}]}]}], 
             "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}],
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"NQuarticUnitRootsComplex", "=", "\[IndentingNewLine]", 
    RowBox[{"Compile", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"a", ",", "_Complex"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"b", ",", "_Complex"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"c", ",", "_Complex"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"d", ",", "_Complex"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"e", ",", "_Complex"}], "}"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Block", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "mb", ",", "mc", ",", "md", ",", "P", ",", "Q", ",", "R", ",", "S", 
          ",", "\[Alpha]", ",", "\[Beta]", ",", "\[Gamma]"}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Select", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"a", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"b", "\[Equal]", " ", "0"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"c", "\[Equal]", " ", "0"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"d", "\[Equal]", " ", "0"}], ",", 
                  RowBox[{"{", "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"-", 
                    FractionBox["e", "d"]}], "}"}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}], 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["#", "2"], "-", 
                    FractionBox["e", "c"]}]]}], " ", "-", " ", "#"}], ")"}], 
                  "&"}], "[", 
                 FractionBox["d", 
                  RowBox[{"2", " ", "c"}]], "]"}]}], "\[IndentingNewLine]", 
               "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"mc", "=", 
                FractionBox["c", 
                 RowBox[{"3", "b"}]]}], ";", 
               RowBox[{"md", "=", 
                FractionBox["d", "b"]}], ";", "\[IndentingNewLine]", 
               RowBox[{"P", " ", "=", " ", 
                RowBox[{
                 FractionBox["md", "3"], " ", "-", " ", 
                 SuperscriptBox["mc", "2"]}]}], ";", " ", 
               RowBox[{"Q", " ", "=", " ", 
                RowBox[{
                 FractionBox["e", 
                  RowBox[{"2", "b"}]], " ", "+", " ", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["mc", "2"], "-", 
                    FractionBox["md", "2"]}], ")"}], "mc"}]}]}], ";", " ", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"#", "-", 
                   FractionBox["P", "#"], "-", "mc"}], ")"}], "&"}], "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"1", ",", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    RowBox[{"\[ImaginaryI]", 
                    SqrtBox["3"]}]}], "2"], ",", 
                   FractionBox[
                    RowBox[{
                    RowBox[{"-", "1"}], "-", 
                    RowBox[{"\[ImaginaryI]", 
                    SqrtBox["3"]}]}], "2"]}], "}"}], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", "Q"}], "+", " ", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["Q", "2"], "+", 
                    SuperscriptBox["P", "3"]}]]}], ")"}], 
                  RowBox[{"1", "/", "3"}]]}], "]"}]}]}], 
             "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"mb", "=", 
              FractionBox["b", 
               RowBox[{"4", "a"}]]}], ";", 
             RowBox[{"mc", "=", 
              FractionBox["c", "a"]}], ";", 
             RowBox[{"md", "=", 
              FractionBox["d", "a"]}], ";", "\[IndentingNewLine]", 
             RowBox[{"\[Alpha]", "=", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "6"}], 
                SuperscriptBox["mb", "2"]}], "+", "mc"}]}], ";", 
             RowBox[{"\[Beta]", "=", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"8", 
                   SuperscriptBox["mb", "2"]}], "-", 
                  RowBox[{"2", "mc"}]}], " ", ")"}], "mb"}], "+", "md"}]}], 
             ";", 
             RowBox[{"\[Gamma]", "=", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "3"}], 
                    SuperscriptBox["mb", "2"]}], "+", "mc"}], ")"}], " ", 
                   "mb"}], "-", " ", "md"}], ")"}], " ", "mb"}], "+", 
               FractionBox["e", "a"]}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"\[Beta]", "===", "0"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Q", "=", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["\[Alpha]", "2"], "-", 
                   RowBox[{"4", "\[Gamma]"}]}]]}], ";", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "#1"}], ",", 
                    RowBox[{"-", "#2"}], ",", "#1", ",", "#2"}], "}"}], "&"}],
                   "[", 
                  RowBox[{
                   SqrtBox[
                    FractionBox[
                    RowBox[{
                    RowBox[{"-", "\[Alpha]"}], "-", "Q"}], "2"]], ",", 
                   SqrtBox[
                    FractionBox[
                    RowBox[{
                    RowBox[{"-", "\[Alpha]"}], "+", "Q"}], "2"]]}], "]"}], 
                 "-", "mb"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"P", "=", 
                 RowBox[{"-", 
                  FractionBox[
                   RowBox[{
                    SuperscriptBox["\[Alpha]", "2"], "+", 
                    RowBox[{"12", "\[Gamma]"}]}], "36"]}]}], ";", 
                RowBox[{"Q", " ", "=", " ", 
                 RowBox[{
                  FractionBox[
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"36", "\[Gamma]"}], "-", 
                    SuperscriptBox["\[Alpha]", "2"]}], ")"}], "\[Alpha]"}], 
                   "216"], "-", " ", 
                  FractionBox[
                   SuperscriptBox["\[Beta]", "2"], "16"]}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"R", " ", "=", " ", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", 
                    FractionBox["5", "6"]}], "\[Alpha]"}], "-", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"#", "==", "0"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"2", " ", "Q"}], ")"}], "^", 
                    RowBox[{"(", 
                    RowBox[{"1", "/", "3"}], ")"}]}], ",", " ", 
                    RowBox[{
                    FractionBox["P", "#"], "-", "#"}]}], "]"}], "&"}], "[", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "Q"}], "+", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["Q", "2"], "+", 
                    SuperscriptBox["P", "3"]}]]}], ")"}], "^", 
                    RowBox[{"(", 
                    RowBox[{"1", "/", "3"}], ")"}]}], "]"}], ")"}]}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"S", " ", "=", " ", 
                 FractionBox[
                  SqrtBox[
                   RowBox[{"\[Alpha]", " ", "+", " ", 
                    RowBox[{"2", "R"}]}]], "2"]}], ";", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "#1"}], "-", "S"}], ",", 
                    RowBox[{"#1", "-", "S"}], ",", 
                    RowBox[{
                    RowBox[{"-", "#2"}], "+", "S"}], ",", 
                    RowBox[{"#2", "+", "S"}]}], "}"}], "&"}], "[", 
                    RowBox[{
                    FractionBox[
                    SqrtBox[
                    RowBox[{"#1", "+", "#2"}]], "2"], ",", 
                    FractionBox[
                    SqrtBox[
                    RowBox[{"#1", "-", "#2"}]], "2"]}], "]"}], ")"}], "&"}], 
                  "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", "3"}], "\[Alpha]"}], " ", "-", 
                    RowBox[{"2", " ", "R"}]}], ",", 
                   FractionBox["\[Beta]", "S"]}], "]"}], "-", "mb"}]}]}], 
              "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Round", "[", 
              RowBox[{
               RowBox[{"Abs", "[", "#", "]"}], ",", "0.00000001`"}], "]"}], "===",
              "1.`"}], ")"}], "&"}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
     "]"}]}]}]}]], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.474084654367385*^9, 3.4740847818687897`*^9}, {
   3.474084878807519*^9, 3.4740849648690977`*^9}, {3.474085008333084*^9, 
   3.4740850430747347`*^9}, {3.474085736946537*^9, 3.4740858002300587`*^9}, {
   3.4740858657843437`*^9, 3.4740859043003683`*^9}, {3.474092646103478*^9, 
   3.474092733142741*^9}, 3.474092770573106*^9, {3.4740929297133217`*^9, 
   3.4740930356600933`*^9}, 3.4740930695470123`*^9, {3.474093104584824*^9, 
   3.47409320035819*^9}, 3.474093274233268*^9, {3.474093419031234*^9, 
   3.474093419179723*^9}, 3.474095170515188*^9, {3.4740956720465727`*^9, 
   3.474095676333323*^9}, {3.474096801434593*^9, 3.47409689963868*^9}, {
   3.474097009275313*^9, 3.47409706626554*^9}, {3.474097165750875*^9, 
   3.4740971667094316`*^9}, 3.474786727297843*^9, {3.474787218476289*^9, 
   3.4747872191377077`*^9}, {3.474792591275714*^9, 3.474792608106441*^9}, {
   3.474792646478753*^9, 3.47479264862208*^9}, {3.474793747932065*^9, 
   3.4747938001759853`*^9}, {3.474793841780437*^9, 3.474793855904509*^9}, 
   3.4747939561352777`*^9, {3.474806088670848*^9, 3.474806101338435*^9}, {
   3.474806221871522*^9, 3.474806222328199*^9}, 3.474808489254944*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "NQuadraticRootsReal", ",", "NCubicRootsReal", ",", "NQuarticRootsReal",
        ",", "NQuadraticRootsComplex", ",", "NCubicRootsComplex", ",", 
       "NQuarticRootsComplex", ",", "NQuadraticUnitRootsComplex", ",", 
       "NCubicUnitRootsComplex", ",", "NQuarticUnitRootsComplex"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Protected", ",", " ", "ReadProtected"}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True,
 CellChangeTimes->{{3.474095626690797*^9, 3.474095630637424*^9}, {
   3.474097234712188*^9, 3.4740972462724667`*^9}, {3.47478674275355*^9, 
   3.474786749349059*^9}, 3.474787150292974*^9, {3.474787226244658*^9, 
   3.474787237682205*^9}, 3.4747943692301826`*^9}]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{897, 853},
WindowMargins->{{Automatic, 168}, {55, Automatic}},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit) (October 19, 2009)",
StyleDefinitions->"PackageNotebook.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 148, 2, 144, "Title"],
Cell[718, 26, 166, 5, 118, "Subsubtitle"],
Cell[CellGroupData[{
Cell[909, 35, 25, 0, 72, "Section"],
Cell[937, 37, 1057, 26, 291, "PackageInput"],
Cell[1997, 65, 128, 3, 39, "Text"],
Cell[2128, 70, 3252, 88, 774, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[5417, 163, 32, 0, 72, "Section"],
Cell[5452, 165, 92, 2, 39, "Text"],
Cell[5547, 169, 886, 16, 222, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[6470, 190, 42, 0, 72, "Section"],
Cell[6515, 192, 4084, 84, 1077, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[10636, 281, 31, 0, 72, "Section"],
Cell[10670, 283, 60, 0, 39, "Text"],
Cell[10733, 285, 108, 2, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[10866, 291, 271, 4, 63, "Subsection"],
Cell[11140, 297, 6120, 152, 1271, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[17297, 454, 218, 3, 63, "Subsection"],
Cell[17518, 459, 13338, 327, 2387, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[30893, 791, 168, 2, 63, "Subsection"],
Cell[31064, 795, 32098, 785, 4778, "PackageInput",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[63211, 1586, 34, 0, 72, "Section"],
Cell[63248, 1588, 64, 0, 39, "Text"],
Cell[63315, 1590, 1061, 22, 291, "PackageInput",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
