(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     73176,       2009]
NotebookOptionsPosition[     70101,       1912]
NotebookOutlinePosition[     70522,       1930]
CellTagsIndexPosition[     70479,       1927]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Orientation Bundle Package", "Title"],

Cell["\<\
Markus van Almsick
Technische Universiteit Eindhoven
\[Copyright]2008\
\>", "Subsubtitle"],

Cell["todo: implement routines with modified orientation kernels.", "Text"],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\[IndentingNewLine]", 
   "\n", 
   RowBox[{
    RowBox[{
     RowBox[{
     "TimeStamp", "[", "\"\<MathVisionTools`OrientationBundle`\>\"", "]"}], 
     " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"2009", ",", "10", ",", "12", ",", "23", ",", "0", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput"],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`OrientationBundle`"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Author", ":", " ", 
     RowBox[{"Markus", " ", "van", " ", "Almsick"}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"M", ".", "v", ".", 
       RowBox[{"Almsick", "@", "tue"}], ".", "nl"}]}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`OrientationBundle`"}]}], 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "2.0"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "6.0"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2009"}]}]}], ",", " ", 
    RowBox[{"Technische", " ", "Universiteit", " ", "Eindhoven"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Title", ":", " ", "Histogram"}]}], ",", " ", "Entropy"}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "implements", " ", "the", " ", 
      "Orientation", " ", "Bundle", " ", "transformation", " ", "according", 
      " ", "to", " ", "Kalitzin"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", "Orientation"}]}], ",", " ", 
    "Transformation", ",", " ", "Wavelet"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{
    "June", " ", "2004", "\[IndentingNewLine]", "\t\t  ", "Version", " ", 
     "1.1", " ", "by", " ", "Markus", " ", "van", " ", "Almsick"}], ",", " ", 
    
    RowBox[{"April", " ", "2005"}], ",", "\[IndentingNewLine]", 
    "\t\t\t\t\t\t\t", 
    RowBox[{"\[Alpha]", "=", 
     RowBox[{
      RowBox[{"0", " ", "now", " ", "corresponds", " ", "to", " ", "x"}], "-", 
      RowBox[{
      "Direction", " ", "\[IndentingNewLine]", "\t\t", "Version", " ", "1.3", 
       " ", "by", " ", "Markus", " ", "van", " ", "Almsick"}]}]}], ",", " ", 
    RowBox[{"August", " ", "2008"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "BeginPackage", "[", "\"\<MathVisionTools`OrientationBundle`\>\"", "]"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{"Unprotect", "[", "\[IndentingNewLine]", 
  RowBox[{
  "OrientationTransform", ",", "\[IndentingNewLine]", 
   "OrientationBundleTransform", ",", "\[IndentingNewLine]", 
   "InverseOrientationBundleTransform", ",", "\[IndentingNewLine]", 
   "DirectionalFourierFilter", ",", "\[IndentingNewLine]", 
   "FourierOrientationBundleTransform", ",", "\[IndentingNewLine]", 
   "InverseFourierOrientationBundleTransform"}], "\[IndentingNewLine]", 
  "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"OrientationTransform", "::", "usage"}], "=", 
   "\"\<OrientationTransform[img,filter,t] generates an orientation bundle of \
image img with filter of scale t. The filter must be given by a n\[Times]m \
table of Hankel-coefficients. The number of m-Hankel-coefficients determines \
the number of resulting orientations.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"OrientationBundleTransform", "::", "usage"}], "=", 
   "\"\<OrientationBundleTransform[img,t,\[Xi],n] generates an orientation \
bundle of image img with a \[Xi]-Kalitzin kernel of scale t with n \
orientations. \[Xi] is the ratio between angular and radial units.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"InverseOrientationBundleTransform", "::", "usage"}], "=", 
   "\"\<InverseOrientationBundleTransform[bndl,t,\[Xi]] reconstructs an image \
from an orientation bundle bndl with a \[Xi]-Kalitzin kernel of scale t and a \
angular versus radial ratio \[Xi].\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DirectionalFourierFilter", "::", "usage"}], "=", 
   "\"\<DirectionalFourierFilter is an option of the \
OrientationBundleTransform function. One can assign a List of weighting \
coefficients {w0,w1,w2,...} to DirectionalFourierFilter. In this way, one can \
reduce or emphasize m-components in the construction of the orientation \
bundle. The default is {1,1,1,....}.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Options", "[", "OrientationBundleTransform", "]"}], "=", 
    RowBox[{"{", 
     RowBox[{"DirectionalFourierFilter", " ", "\[Rule]", " ", 
      RowBox[{"{", "1", "}"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FourierOrientationBundleTransform", "::", "usage"}], "=", 
   "\"\<FourierOrientationBundleTransform[img,t,\[Xi],n] generates a Fourier \
orientation bundle of image img with a \[Xi]-Kalitzin kernel of scale t with \
n orientations. \[Xi] is the ratio between angular and radial units.\>\""}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"InverseFourierOrientationBundleTransform", "::", "usage"}], "=", 
  "\"\<InverseFourierOrientationBundleTransform[bndl,t,\[Xi]] reconstructs an \
image from a Fourier orientation bundle bndl with a \[Xi]-Kalitzin kernel of \
scale t and a angular versus radial ratio \[Xi].\>\""}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Utility Functions", "Subsection"],

Cell[TextData[{
 StyleBox["FourierRange[n]", "Input"],
 " generates the discrete \[Omega] values that one obtains when performing a \
Fourier transformation on a function with the domain ",
 StyleBox["Range[n]", "Input"],
 "."
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Utility", " ", "Functions"}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"SetAttributes", "[", 
     RowBox[{"FourierRange", ",", " ", "Listable"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FourierRange", "[", "dim_Integer", "]"}], " ", ":=", " ", 
     RowBox[{
      FractionBox[
       RowBox[{"2", "\[Pi]"}], "dim"], " ", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"Range", "[", 
         RowBox[{"0", ",", 
          RowBox[{"Quotient", "[", 
           RowBox[{"dim", ",", "2"}], "]"}]}], "]"}], ",", 
        RowBox[{"Range", "[", 
         RowBox[{
          RowBox[{"1", "+", 
           RowBox[{"Quotient", "[", 
            RowBox[{
             RowBox[{"-", "dim"}], ",", "2"}], "]"}]}], ",", 
          RowBox[{"-", "1"}]}], "]"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetAttributes", "[", 
     RowBox[{"ComplexPhase", ",", " ", "Listable"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ComplexPhase", "[", 
      RowBox[{"0", "|", "0."}], "]"}], " ", "=", " ", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ComplexPhase", "[", "z_", "]"}], " ", "=", " ", 
     RowBox[{"Sign", "[", "z", "]"}]}], ";"}]}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["OrientationTransform", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OrientationTransform", "[", 
   RowBox[{
    RowBox[{"img_", "?", "MatrixQ"}], ",", 
    RowBox[{"filter_", "?", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"ArrayQ", "[", 
        RowBox[{"#", ",", "2"}], "]"}], "&"}], ")"}]}], ",", 
    RowBox[{"t_", "?", "NumericQ"}], ",", "opts___Rule"}], "]"}], " ", ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "mmax", ",", "nmax", ",", "mmin", ",", "mlen", ",", "coeff", ",", 
      "\[Omega]$sqr", ",", "polys"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"mlen", ",", "nmax"}], "}"}], "=", 
      RowBox[{
       RowBox[{"Dimensions", "[", "filter", "]"}], "-", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"mmax", "=", 
      RowBox[{"Quotient", "[", 
       RowBox[{"mlen", ",", "2"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"mmin", "=", 
      RowBox[{"Quotient", "[", 
       RowBox[{
        RowBox[{"mlen", "-", "1"}], ",", "2"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"polys", "=", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"NestList", "[", "\[IndentingNewLine]", 
        RowBox[{"Accumulate", ",", "\[IndentingNewLine]", 
         RowBox[{"Rest", "[", 
          RowBox[{"Fold", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Append", "[", 
              RowBox[{"#", ",", 
               RowBox[{"Expand", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"1", "-", " ", "#2"}], ",", 
                    RowBox[{
                    RowBox[{"2", " ", "#2"}], "-", "1", "-", 
                    "\[Omega]$sqr"}]}], "}"}], ".", 
                  RowBox[{"Take", "[", 
                   RowBox[{"#1", ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], "/", "#2"}], "]"}]}], 
              "]"}], "&"}], ",", " ", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}], ",", 
            RowBox[{"Range", "[", "nmax", "]"}]}], "]"}], "]"}], ",", 
         "\[IndentingNewLine]", "mmax"}], "\[IndentingNewLine]", "]"}], "/", 
       RowBox[{"Transpose", "[", 
        RowBox[{
         RowBox[{"NestList", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "#"}], "&"}], ",", "1", ",", "nmax"}], "]"}], 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Sqrt", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{"Times", ",", "1", ",", 
               RowBox[{"Range", "[", 
                RowBox[{"nmax", "+", "mmax"}], "]"}]}], "]"}], "]"}], ",", 
            RowBox[{"mmax", "+", "1"}], ",", "1"}], "]"}], "/", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{"Times", ",", "1", ",", 
             RowBox[{"Range", "[", "nmax", "]"}]}], "]"}], "]"}]}]}], 
        "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"coeff", "=", 
      RowBox[{"CoefficientList", "[", 
       RowBox[{
        RowBox[{"Total", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"RotateLeft", "[", 
            RowBox[{
             RowBox[{"N", "[", "filter", "]"}], ",", "mmin"}], "]"}], "*", 
           RowBox[{"Join", "[", 
            RowBox[{"polys", ",", 
             RowBox[{"Take", "[", 
              RowBox[{"polys", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"mmin", "+", "1"}], ",", "2", ",", 
                 RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], "]"}]}], ",", 
          RowBox[{"{", "2", "}"}]}], "]"}], ",", "\[Omega]$sqr"}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Last", "[", 
         RowBox[{"Dimensions", "[", "coeff", "]"}], "]"}], "===", "1"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"InternalOrientationBundleM", "[", 
        RowBox[{
         RowBox[{"Normal", "[", "img", "]"}], ",", 
         RowBox[{"coeff", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], ",", "t", ",",
          "mmin", ",", "mmax"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"InternalOrientationBundleNM", "[", 
        RowBox[{
         RowBox[{"Normal", "[", "img", "]"}], ",", "coeff", ",", "t", ",", 
         "nmax", ",", "mmin", ",", "mmax"}], "]"}]}], "\[IndentingNewLine]", 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"InternalOrientationBundleM", " ", "=", "  ", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"coeff", ",", "_Complex", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"mmin", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"mmax", ",", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "\[Omega]x", ",", "\[Omega]y", ",", "\[ImaginaryI]\[Omega]", ",", 
         "\[ImaginaryI]\[Omega]c", ",", "\[Omega]exp"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\[Omega]x", " ", "=", " ", 
         RowBox[{
          RowBox[{"Sqrt", "[", "t", "]"}], " ", 
          RowBox[{"FourierRange", "[", 
           RowBox[{
            RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
            "2", "\[RightDoubleBracket]"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Omega]y", " ", "=", " ", 
         RowBox[{
          RowBox[{"Sqrt", "[", "t", "]"}], " ", 
          RowBox[{"FourierRange", "[", 
           RowBox[{
            RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
            "1", "\[RightDoubleBracket]"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[ImaginaryI]\[Omega]", "=", " ", 
         RowBox[{"Outer", "[", 
          RowBox[{"Plus", ",", 
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]y"}], ",", 
           RowBox[{"-", "\[Omega]x"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"\[ImaginaryI]\[Omega]c", "=", 
         RowBox[{"Outer", "[", 
          RowBox[{"Plus", ",", 
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]y"}], ",", 
           "\[Omega]x"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Omega]exp", "=", 
         RowBox[{"Outer", "[", 
          RowBox[{"Times", ",", 
           RowBox[{"Exp", "[", 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[Omega]y", "2"]}], "/", "2"}], "]"}], ",", 
           RowBox[{"Exp", "[", 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[Omega]x", "2"]}], "/", "2"}], "]"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"InverseFourier", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"NestList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"\[ImaginaryI]\[Omega]", "*", "#"}], ")"}], "&"}], 
                ",", "#", ",", "mmax"}], "]"}], ",", 
              RowBox[{"Reverse", "[", 
               RowBox[{"NestList", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"\[ImaginaryI]\[Omega]c", "*", "#"}], ")"}], "&"}],
                  ",", 
                 RowBox[{"\[ImaginaryI]\[Omega]c", "*", "#"}], ",", 
                 RowBox[{"mmin", "-", "1"}]}], "]"}], "]"}]}], "]"}], "&"}], 
           "[", 
           RowBox[{
            RowBox[{"Fourier", "[", "img", "]"}], "\[Omega]exp"}], "]"}], "*",
           " ", "coeff"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FourierRange", "[", "_", "]"}], ",", "_Real", ",", "1"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Fourier", "[", "_", "]"}], ",", "_Complex", ",", "2"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"InverseFourier", "[", "_", "]"}], ",", "_Complex", ",", 
         "3"}], "}"}]}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "InternalOrientationBundleNM", " ", "=", "  ", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"coeff", ",", "_Complex", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nmax", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"mmin", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"mmax", ",", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "\[Omega]x", ",", "\[Omega]y", ",", "\[ImaginaryI]\[Omega]", ",", 
         "\[ImaginaryI]\[Omega]c", ",", "\[Omega]sqr", ",", "\[Omega]exp"}], 
        "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\[Omega]x", " ", "=", " ", 
         RowBox[{
          RowBox[{"Sqrt", "[", "t", "]"}], " ", 
          RowBox[{"FourierRange", "[", 
           RowBox[{
            RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
            "2", "\[RightDoubleBracket]"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Omega]y", " ", "=", " ", 
         RowBox[{
          RowBox[{"Sqrt", "[", "t", "]"}], " ", 
          RowBox[{"FourierRange", "[", 
           RowBox[{
            RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
            "1", "\[RightDoubleBracket]"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[ImaginaryI]\[Omega]", " ", "=", " ", 
         RowBox[{"Outer", "[", 
          RowBox[{"Plus", ",", "\[Omega]y", ",", 
           RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[ImaginaryI]\[Omega]c", " ", "=", " ", 
         RowBox[{"Outer", "[", 
          RowBox[{"Plus", ",", 
           RowBox[{"-", "\[Omega]y"}], ",", " ", 
           RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Omega]sqr", "=", 
         RowBox[{"Outer", "[", 
          RowBox[{"Plus", ",", 
           SuperscriptBox["\[Omega]y", "2"], ",", 
           SuperscriptBox["\[Omega]x", "2"]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Omega]exp", "=", 
         RowBox[{"Outer", "[", 
          RowBox[{"Times", ",", 
           RowBox[{"Exp", "[", 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[Omega]y", "2"]}], "/", "2"}], "]"}], ",", 
           RowBox[{"Exp", "[", 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[Omega]x", "2"]}], "/", "2"}], "]"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"InverseFourier", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"NestList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"\[ImaginaryI]\[Omega]", "*", "#"}], ")"}], "&"}], 
                ",", "#", ",", "mmax"}], "]"}], ",", 
              RowBox[{"Reverse", "[", 
               RowBox[{"NestList", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"\[ImaginaryI]\[Omega]c", "*", "#"}], ")"}], "&"}],
                  ",", 
                 RowBox[{"\[ImaginaryI]\[Omega]c", "*", "#"}], ",", 
                 RowBox[{"mmin", "-", "1"}]}], "]"}], "]"}]}], "]"}], "&"}], 
           "[", 
           RowBox[{"Fourier", "[", "img", "]"}], "]"}], "*", " ", 
          RowBox[{"(", 
           RowBox[{"coeff", ".", 
            RowBox[{"NestList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"\[Omega]sqr", "*", "#"}], ")"}], "&"}], ",", 
              "\[Omega]exp", ",", "nmax"}], "]"}]}], ")"}]}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FourierRange", "[", "_", "]"}], ",", "_Real", ",", "1"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Fourier", "[", "_", "]"}], ",", "_Complex", ",", "2"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"InverseFourier", "[", "_", "]"}], ",", "_Complex", ",", 
         "3"}], "}"}]}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OrientationTransform", "[", 
   RowBox[{
    RowBox[{"img_", "?", "MatrixQ"}], ",", 
    RowBox[{"filter_", "?", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"ArrayQ", "[", 
        RowBox[{"#", ",", "3"}], "]"}], "&"}], ")"}]}], ",", 
    RowBox[{"t_", "?", "NumericQ"}], ",", "opts___Rule"}], "]"}], " ", ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "mmax", ",", "nmax", ",", "mmin", ",", "mlen", ",", "coeff", ",", 
      "\[Omega]$sqr", ",", "polys"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"mlen", ",", "nmax"}], "}"}], "=", 
      RowBox[{
       RowBox[{"Rest", "[", 
        RowBox[{"Dimensions", "[", "filter", "]"}], "]"}], "-", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"mmax", "=", 
      RowBox[{"Quotient", "[", 
       RowBox[{"mlen", ",", "2"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"mmin", "=", 
      RowBox[{"Quotient", "[", 
       RowBox[{
        RowBox[{"mlen", "-", "1"}], ",", "2"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"polys", "=", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"NestList", "[", "\[IndentingNewLine]", 
        RowBox[{"Accumulate", ",", "\[IndentingNewLine]", 
         RowBox[{"Rest", "[", 
          RowBox[{"Fold", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Append", "[", 
              RowBox[{"#", ",", 
               RowBox[{"Expand", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"1", "-", " ", "#2"}], ",", 
                    RowBox[{
                    RowBox[{"2", " ", "#2"}], "-", "1", "-", 
                    "\[Omega]$sqr"}]}], "}"}], ".", 
                  RowBox[{"Take", "[", 
                   RowBox[{"#1", ",", 
                    RowBox[{"-", "2"}]}], "]"}]}], "/", "#2"}], "]"}]}], 
              "]"}], "&"}], ",", " ", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}], ",", 
            RowBox[{"Range", "[", "nmax", "]"}]}], "]"}], "]"}], ",", 
         "\[IndentingNewLine]", "mmax"}], "\[IndentingNewLine]", "]"}], "/", 
       RowBox[{"Transpose", "[", 
        RowBox[{
         RowBox[{"NestList", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "#"}], "&"}], ",", "1", ",", "nmax"}], "]"}], 
         RowBox[{
          RowBox[{"Partition", "[", 
           RowBox[{
            RowBox[{"Sqrt", "[", 
             RowBox[{"FoldList", "[", 
              RowBox[{"Times", ",", "1", ",", 
               RowBox[{"Range", "[", 
                RowBox[{"nmax", "+", "mmax"}], "]"}]}], "]"}], "]"}], ",", 
            RowBox[{"mmax", "+", "1"}], ",", "1"}], "]"}], "/", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"FoldList", "[", 
            RowBox[{"Times", ",", "1", ",", 
             RowBox[{"Range", "[", "nmax", "]"}]}], "]"}], "]"}]}]}], 
        "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"coeff", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"PadRight", "[", 
          RowBox[{
           RowBox[{"CoefficientList", "[", 
            RowBox[{
             RowBox[{"Total", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{"#", ",", "mmin"}], "]"}], "*", 
                RowBox[{"Join", "[", 
                 RowBox[{"polys", ",", 
                  RowBox[{"Take", "[", 
                   RowBox[{"polys", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"mmin", "+", "1"}], ",", "2", ",", 
                    RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], "]"}]}], ",", 
               RowBox[{"{", "2", "}"}]}], "]"}], ",", "\[Omega]$sqr"}], "]"}],
            ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"mmin", "+", "mmax", "+", "1"}], ",", 
             RowBox[{"nmax", "+", "1"}]}], "}"}]}], "]"}], "&"}], ",", 
        RowBox[{"N", "[", "filter", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Last", "[", 
         RowBox[{"Dimensions", "[", "coeff", "]"}], "]"}], "===", "1"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"ListInternalOrientationBundleM", "[", 
        RowBox[{
         RowBox[{"Normal", "[", "img", "]"}], ",", 
         RowBox[{"coeff", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "All", ",", "1"}], "\[RightDoubleBracket]"}], 
         ",", "t", ",", "mmin", ",", "mmax"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"ListInternalOrientationBundleNM", "[", 
        RowBox[{
         RowBox[{"Normal", "[", "img", "]"}], ",", "coeff", ",", "t", ",", 
         "nmax", ",", "mmin", ",", "mmax"}], "]"}]}], "\[IndentingNewLine]", 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "ListInternalOrientationBundleM", " ", "=", "  ", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"coeff", ",", "_Complex", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"mmin", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"mmax", ",", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "\[Omega]x", ",", "\[Omega]y", ",", "\[ImaginaryI]\[Omega]", ",", 
         "\[ImaginaryI]\[Omega]c", ",", "\[Omega]exp"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\[Omega]x", " ", "=", " ", 
         RowBox[{
          RowBox[{"Sqrt", "[", "t", "]"}], " ", 
          RowBox[{"FourierRange", "[", 
           RowBox[{
            RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
            "2", "\[RightDoubleBracket]"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Omega]y", " ", "=", " ", 
         RowBox[{
          RowBox[{"Sqrt", "[", "t", "]"}], " ", 
          RowBox[{"FourierRange", "[", 
           RowBox[{
            RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
            "1", "\[RightDoubleBracket]"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[ImaginaryI]\[Omega]", "=", " ", 
         RowBox[{"Outer", "[", 
          RowBox[{"Plus", ",", 
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]y"}], ",", 
           RowBox[{"-", "\[Omega]x"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"\[ImaginaryI]\[Omega]c", "=", 
         RowBox[{"Outer", "[", 
          RowBox[{"Plus", ",", 
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]y"}], ",", 
           "\[Omega]x"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Omega]exp", "=", 
         RowBox[{"Outer", "[", 
          RowBox[{"Times", ",", 
           RowBox[{"Exp", "[", 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[Omega]y", "2"]}], "/", "2"}], "]"}], ",", 
           RowBox[{"Exp", "[", 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[Omega]x", "2"]}], "/", "2"}], "]"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"InverseFourier", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"NestList", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"\[ImaginaryI]\[Omega]", "*", "#"}], ")"}], "&"}],
                    ",", "#", ",", "mmax"}], "]"}], ",", 
                 RowBox[{"Reverse", "[", 
                  RowBox[{"NestList", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"\[ImaginaryI]\[Omega]c", "*", "#"}], ")"}], 
                    "&"}], ",", 
                    RowBox[{"\[ImaginaryI]\[Omega]c", "*", "#"}], ",", 
                    RowBox[{"mmin", "-", "1"}]}], "]"}], "]"}]}], "]"}], 
               "&"}], "[", 
              RowBox[{
               RowBox[{"Fourier", "[", "img", "]"}], "\[Omega]exp"}], "]"}], 
             "*", " ", "#"}], "]"}], "&"}], ",", "coeff"}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FourierRange", "[", "_", "]"}], ",", "_Real", ",", "1"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Fourier", "[", "_", "]"}], ",", "_Complex", ",", "2"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"InverseFourier", "[", "_", "]"}], ",", "_Complex", ",", 
         "3"}], "}"}]}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "ListInternalOrientationBundleNM", " ", "=", "  ", "\[IndentingNewLine]", 
   RowBox[{"Compile", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"img", ",", "_Real", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"coeff", ",", "_Complex", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"nmax", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"mmin", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"mmax", ",", "_Real"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "\[Omega]x", ",", "\[Omega]y", ",", "\[ImaginaryI]\[Omega]", ",", 
         "\[ImaginaryI]\[Omega]c", ",", "\[Omega]sqr", ",", "\[Omega]exp", 
         ",", "Q1", ",", "Q2"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\[Omega]x", " ", "=", " ", 
         RowBox[{
          RowBox[{"Sqrt", "[", "t", "]"}], " ", 
          RowBox[{"FourierRange", "[", 
           RowBox[{
            RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
            "2", "\[RightDoubleBracket]"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Omega]y", " ", "=", " ", 
         RowBox[{
          RowBox[{"Sqrt", "[", "t", "]"}], " ", 
          RowBox[{"FourierRange", "[", 
           RowBox[{
            RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
            "1", "\[RightDoubleBracket]"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[ImaginaryI]\[Omega]", " ", "=", " ", 
         RowBox[{"Outer", "[", 
          RowBox[{"Plus", ",", "\[Omega]y", ",", 
           RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[ImaginaryI]\[Omega]c", " ", "=", " ", 
         RowBox[{"Outer", "[", 
          RowBox[{"Plus", ",", 
           RowBox[{"-", "\[Omega]y"}], ",", " ", 
           RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Omega]sqr", "=", 
         RowBox[{"Outer", "[", 
          RowBox[{"Plus", ",", 
           SuperscriptBox["\[Omega]y", "2"], ",", 
           SuperscriptBox["\[Omega]x", "2"]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Omega]exp", "=", 
         RowBox[{"Outer", "[", 
          RowBox[{"Times", ",", 
           RowBox[{"Exp", "[", 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[Omega]y", "2"]}], "/", "2"}], "]"}], ",", 
           RowBox[{"Exp", "[", 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[Omega]x", "2"]}], "/", "2"}], "]"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Q1", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"NestList", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"\[ImaginaryI]\[Omega]", "*", "#"}], ")"}], "&"}], 
               ",", "#", ",", "mmax"}], "]"}], ",", 
             RowBox[{"Reverse", "[", 
              RowBox[{"NestList", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"\[ImaginaryI]\[Omega]c", "*", "#"}], ")"}], "&"}], 
                ",", 
                RowBox[{"\[ImaginaryI]\[Omega]c", "*", "#"}], ",", 
                RowBox[{"mmin", "-", "1"}]}], "]"}], "]"}]}], "]"}], "&"}], 
          "[", 
          RowBox[{"Fourier", "[", "img", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Q2", "=", 
         RowBox[{"NestList", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"\[Omega]sqr", "*", "#"}], ")"}], "&"}], ",", 
           "\[Omega]exp", ",", "nmax"}], "]"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"InverseFourier", "[", 
            RowBox[{"Q1", "*", 
             RowBox[{"(", 
              RowBox[{"#", ".", "Q2"}], ")"}]}], "]"}], "&"}], ",", "coeff"}],
          "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FourierRange", "[", "_", "]"}], ",", "_Real", ",", "1"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Fourier", "[", "_", "]"}], ",", "_Complex", ",", "2"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"InverseFourier", "[", "_", "]"}], ",", "_Complex", ",", 
         "3"}], "}"}]}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Orientation Bundle Transform", "Subsection"],

Cell[TextData[{
 "Orientation kernel in Fourier space is (see base-independent approach with \
seed f[\[Nu]] = ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"t", " ", "\[Nu]"}]], TraditionalForm]]],
 "):"
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[ScriptCapitalF]", "[", 
    RowBox[{"\[Psi]", "[", 
     RowBox[{"r", ",", "\[CurlyPhi]"}], "]"}], "]"}], "[", "\[Omega]", "]"}], 
  " ", "=", " ", 
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"m", "=", "0"}], "\[Infinity]"], 
   RowBox[{
    SubscriptBox["w", "m"], 
    SqrtBox[
     FractionBox[
      SuperscriptBox["t", "m"], 
      RowBox[{"m", "!"}]]], 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", "m", " ", 
      SubscriptBox["\[Omega]", "\[CurlyPhi]"]}]], " ", 
    SuperscriptBox[
     SubscriptBox["\[Omega]", "r"], 
     RowBox[{" ", 
      RowBox[{"\[Xi]", " ", "m"}]}]], " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "t"}], " ", 
      FractionBox[
       SuperscriptBox[
        SubscriptBox["\[Omega]", "r"], 
        RowBox[{"2", "\[Xi]"}]], "2"]}]]}]}]}]], "Input",
 Evaluatable->False],

Cell["with", "Text"],

Cell[BoxData[
 RowBox[{"\[Omega]", " ", ":=", " ", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Omega]", "r"], " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"\[ImaginaryI]", " ", 
      SubscriptBox["\[Omega]", "\[CurlyPhi]"]}]]}], " ", "=", " ", 
   RowBox[{
    SubscriptBox["\[Omega]", "x"], "+", " ", 
    RowBox[{"\[ImaginaryI]", " ", 
     SubscriptBox["\[Omega]", "y"]}]}]}]}]], "Input",
 Evaluatable->False],

Cell[TextData[{
 "and ",
 Cell[BoxData[
  SubscriptBox["w", "m"]],
  Evaluatable->False],
 " are the weights introduced via the ",
 "DirectionalFourierFilter option.",
 " "
}], "Text"],

Cell["\<\
The convolution of the image with the orienation kernel is done via \
multiplication in Fouier space.\
\>", "Text"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"\[ScriptCapitalF]", "[", 
      RowBox[{"\[Psi]", "[", 
       RowBox[{"r", ",", "\[CurlyPhi]"}], "]"}], "]"}], "[", "\[Omega]", 
     "]"}], " ", "*", " ", 
    RowBox[{
     RowBox[{"\[ScriptCapitalF]", "[", "image", "]"}], "[", "\[Omega]", 
     "]"}]}], "=", 
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"m", "=", "0"}], "\[Infinity]"], 
    RowBox[{
     SqrtBox[
      FractionBox[
       SuperscriptBox["t", "m"], 
       RowBox[{"m", "!"}]]], 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"\[ImaginaryI]", " ", "m", " ", 
       SubscriptBox["\[Omega]", "\[CurlyPhi]"]}]], " ", 
     SuperscriptBox[
      SubscriptBox["\[Omega]", "r"], 
      RowBox[{" ", 
       RowBox[{"\[Xi]", " ", "m"}]}]], " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "t"}], " ", 
         FractionBox[
          SuperscriptBox[
           SubscriptBox["\[Omega]", "r"], 
           RowBox[{"2", "\[Xi]"}]], "2"]}]], " ", "*", " ", 
       RowBox[{
        RowBox[{"\[ScriptCapitalF]", "[", "image", "]"}], "[", "\[Omega]", 
        "]"}]}], ")"}]}]}]}]}]], "Input",
 Evaluatable->False],

Cell[TextData[{
 "The ",
 StyleBox["m", "Input"],
 "-dependent terms of the summation are created iteratively with the ",
 StyleBox["FoldList", "Input"],
 " command.\nFinally, the summation in ",
 StyleBox["m", "Input"],
 "  is performed via an inverse Fourier transformation to convert the ",
 StyleBox["m", "Input"],
 "-slices of the bundle into ",
 StyleBox["\[CurlyPhi]", "Input"],
 "-slices. \nThe concurrent inverse Fourier transformation in ",
 StyleBox["\[Omega]", "Input"],
 "-space brings the product of \[ScriptCapitalF][image] and the kernel back \
to position space."
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "OrientationBundle", " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"OrientationBundleTransform", "[", 
      RowBox[{
       RowBox[{"img_", "?", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"MatrixQ", "[", 
           RowBox[{"#", ",", "NumericQ"}], "]"}], "&"}], ")"}]}], ",", 
       RowBox[{"t_", "?", "NumericQ"}], ",", 
       RowBox[{"\[Xi]_:", "1"}], ",", 
       RowBox[{"n_Integer", "?", "Positive"}], ",", "opts___Rule"}], "]"}], 
     " ", ":=", " ", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"InternalOrientationBundle", "[", 
       RowBox[{
        RowBox[{"Normal", "[", "img", "]"}], ",", "t", ",", "\[Xi]", ",", "n",
         ",", "\[IndentingNewLine]", 
        RowBox[{"Re", "[", 
         RowBox[{"PadRight", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"DirectionalFourierFilter", " ", "/.", " ", 
             RowBox[{"{", "opts", "}"}]}], " ", "/.", " ", 
            RowBox[{"Options", "[", "OrientationBundleTransform", "]"}]}], 
           ",", "n", ",", "1"}], "]"}], "]"}]}], "]"}], "/;", 
      RowBox[{"\[Xi]", ">", "0"}]}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"InternalOrientationBundle", " ", "=", " ", 
     RowBox[{"Compile", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"img", ",", "_Real", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Xi]", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", "_Integer"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"w", ",", "_Real", ",", "1"}], "}"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Module", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "\[Omega]x", ",", "\[Omega]y", ",", "\[Omega]", ",", " ", 
           "m0Bundle"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\[Omega]x", " ", "=", "  ", 
           RowBox[{"FourierRange", "[", 
            RowBox[{
             RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
             "2", "\[RightDoubleBracket]"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"\[Omega]y", " ", "=", "  ", 
           RowBox[{"FourierRange", "[", 
            RowBox[{
             RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
             "1", "\[RightDoubleBracket]"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"\[Omega]", " ", "=", " ", 
           RowBox[{"Outer", "[", 
            RowBox[{"Plus", ",", 
             RowBox[{"-", "\[Omega]y"}], ",", 
             RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"\[Xi]", ">", "1"}], ",", 
            RowBox[{"\[Omega]", " ", "=", " ", 
             RowBox[{"\[Omega]", " ", 
              SuperscriptBox[
               RowBox[{"Abs", "[", "\[Omega]", "]"}], 
               RowBox[{"\[Xi]", "-", "1"}]]}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"1", ">", "\[Xi]", ">", "0"}], ",", 
            RowBox[{"\[Omega]", " ", "=", " ", 
             RowBox[{
              RowBox[{"ComplexPhase", "[", "\[Omega]", "]"}], " ", 
              SuperscriptBox[
               RowBox[{"Abs", "[", "\[Omega]", "]"}], "\[Xi]"]}]}]}], "]"}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"m0Bundle", "=", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             RowBox[{"-", "t"}], " ", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"Abs", "[", "\[Omega]", "]"}], "2"], "/", "2"}]}]]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"InverseFourier", "[", 
           RowBox[{"w", " ", "*", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SqrtBox[
                  FractionBox["t", "#2"]], "  ", "\[Omega]", " ", "*", " ", 
                 "#1"}], ")"}], "&"}], ",", 
              RowBox[{
               RowBox[{"Fourier", "[", "img", "]"}], "*", " ", "m0Bundle"}], 
              ",", 
              RowBox[{"Range", "[", " ", 
               RowBox[{"n", "-", "1"}], "]"}]}], "]"}]}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ComplexPhase", "[", "_", "]"}], ",", "_Complex", ",", 
           "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Abs", "[", "_", "]"}], ",", "_Real", ",", "2"}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"FourierRange", "[", "_", "]"}], ",", "_Real", ",", "1"}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Fourier", "[", "_", "]"}], ",", "_Complex", ",", "2"}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InverseFourier", "[", "_", "]"}], ",", "_Complex", ",", 
           "3"}], "}"}]}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
    ";"}]}]}]], "PackageInput"],

Cell["\<\
The same as above, but omitting the angular Fourier transformation at the \
end. \
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "FourierOrientationBundle", " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"FourierOrientationBundleTransform", "[", 
      RowBox[{
       RowBox[{"img_", "?", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"MatrixQ", "[", 
           RowBox[{"#", ",", "NumericQ"}], "]"}], "&"}], ")"}]}], ",", 
       RowBox[{"t_", "?", "NumericQ"}], ",", 
       RowBox[{"\[Xi]_:", "1"}], ",", 
       RowBox[{"n_Integer", "?", "Positive"}]}], "]"}], " ", ":=", " ", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"InternalFourierOrientationBundle", "[", 
       RowBox[{
        RowBox[{"Normal", "[", "img", "]"}], ",", "t", ",", "\[Xi]", ",", 
        "n"}], "]"}], "/;", 
      RowBox[{"\[Xi]", ">", "0"}]}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"InternalFourierOrientationBundle", " ", "=", " ", 
     RowBox[{"Compile", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"img", ",", "_Real", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Xi]", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", "_Integer"}], "}"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Module", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "\[Omega]x", ",", "\[Omega]y", ",", "\[Omega]", ",", " ", 
           "m0Bundle"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\[Omega]x", " ", "=", "  ", 
           RowBox[{"FourierRange", "[", 
            RowBox[{
             RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
             "2", "\[RightDoubleBracket]"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"\[Omega]y", " ", "=", "  ", 
           RowBox[{"FourierRange", "[", 
            RowBox[{
             RowBox[{"Dimensions", "[", "img", "]"}], "\[LeftDoubleBracket]", 
             "1", "\[RightDoubleBracket]"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"\[Omega]", " ", "=", " ", 
           RowBox[{"Outer", "[", 
            RowBox[{"Plus", ",", 
             RowBox[{"-", "\[Omega]y"}], ",", 
             RowBox[{"\[ImaginaryI]", " ", "\[Omega]x"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"\[Xi]", ">", "1"}], ",", 
            RowBox[{"\[Omega]", " ", "=", " ", 
             RowBox[{"\[Omega]", " ", 
              SuperscriptBox[
               RowBox[{"Abs", "[", "\[Omega]", "]"}], 
               RowBox[{"\[Xi]", "-", "1"}]]}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"1", ">", "\[Xi]", ">", "0"}], ",", 
            RowBox[{"\[Omega]", " ", "=", " ", 
             RowBox[{
              RowBox[{"ComplexPhase", "[", "\[Omega]", "]"}], " ", 
              SuperscriptBox[
               RowBox[{"Abs", "[", "\[Omega]", "]"}], "\[Xi]"]}]}]}], "]"}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"m0Bundle", "=", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             RowBox[{"-", "t"}], " ", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"Abs", "[", "\[Omega]", "]"}], "2"], "/", "2"}]}]]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"Map", "[", 
           RowBox[{"InverseFourier", ",", 
            RowBox[{"FoldList", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SqrtBox[
                  FractionBox["t", "#2"]], "  ", "\[Omega]", " ", "*", " ", 
                 "#1"}], ")"}], "&"}], ",", 
              RowBox[{
               RowBox[{"Fourier", "[", "img", "]"}], "*", " ", "m0Bundle"}], 
              ",", 
              RowBox[{"Range", "[", " ", 
               RowBox[{"n", "-", "1"}], "]"}]}], "]"}]}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ComplexPhase", "[", "_", "]"}], ",", "_Complex", ",", 
           "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Abs", "[", "_", "]"}], ",", "_Real", ",", "2"}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"FourierRange", "[", "_", "]"}], ",", "_Real", ",", "1"}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Fourier", "[", "_", "]"}], ",", "_Complex", ",", "2"}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InverseFourier", "[", "_", "]"}], ",", "_Complex", ",", 
           "2"}], "}"}]}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
    ";"}]}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Inverse Orientation Bundle Transform", "Subsection"],

Cell[TextData[{
 "The conjugate orientation kernel in Fourier space is (see base-independent \
approach with seed f[\[Nu]] = ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"t", " ", "\[Nu]"}]], TraditionalForm]]],
 "):"
}], "Text"],

Cell[BoxData[
 RowBox[{"  ", 
  RowBox[{
   OverscriptBox[
    RowBox[{
     RowBox[{"\[ScriptCapitalF]", "[", 
      RowBox[{"\[Psi]", "[", 
       RowBox[{"r", ",", "\[CurlyPhi]"}], "]"}], "]"}], "[", "\[Omega]", 
     "]"}], "_"], " ", "=", " ", 
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"m", "=", "0"}], "\[Infinity]"], 
    RowBox[{
     SqrtBox[
      FractionBox[
       SuperscriptBox["t", "m"], 
       RowBox[{"m", "!"}]]], 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", "m", " ", 
       SubscriptBox["\[Omega]", "\[CurlyPhi]"]}]], " ", 
     SuperscriptBox[
      SubscriptBox["\[Omega]", "r"], 
      RowBox[{" ", 
       RowBox[{"\[Xi]", " ", "m"}]}]], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "t"}], " ", 
       FractionBox[
        SuperscriptBox[
         SubscriptBox["\[Omega]", "r"], 
         RowBox[{"2", "\[Xi]"}]], "2"]}]]}]}]}]}]], "Input",
 Evaluatable->False],

Cell["with", "Text"],

Cell[BoxData[
 RowBox[{
  OverscriptBox["\[Omega]", "_"], " ", ":=", " ", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Omega]", "r"], " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", 
      SubscriptBox["\[Omega]", "\[CurlyPhi]"]}]]}], " ", "=", " ", 
   RowBox[{
    SubscriptBox["\[Omega]", "x"], "-", " ", 
    RowBox[{"\[ImaginaryI]", " ", 
     SubscriptBox["\[Omega]", "y"]}]}]}]}]], "Input",
 Evaluatable->False],

Cell[TextData[{
 "The convolution of the bundle with the conjugate orienation kernel is done \
via multiplication in Fouier space.\nNote, that the Fourier transformation of \
the bundle is performed in space and orientation! Thus, the ",
 StyleBox["\[CurlyPhi]", "Input"],
 "-slices of the bundle become ",
 StyleBox["m", "Input"],
 "-slices.\n"
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"m", "=", "0"}], "\[Infinity]"], " ", 
   RowBox[{
    OverscriptBox[
     RowBox[{
      RowBox[{"\[ScriptCapitalF]", "[", 
       RowBox[{"\[Psi]", "[", 
        RowBox[{"r", ",", "\[CurlyPhi]"}], "]"}], "]"}], "[", "\[Omega]", 
      "]"}], "_"], " ", "*", " ", 
    RowBox[{
     RowBox[{"\[ScriptCapitalF]", "[", "bundle", "]"}], "[", 
     RowBox[{"m", ",", "\[Omega]"}], "]"}]}]}], "=", 
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"m", "=", "0"}], "\[Infinity]"], 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      SqrtBox[
       FractionBox[
        SuperscriptBox["t", "m"], 
        RowBox[{"m", "!"}]]], 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "m", " ", 
        SubscriptBox["\[Omega]", "\[CurlyPhi]"]}]], " ", 
      SuperscriptBox[
       SubscriptBox["\[Omega]", "r"], 
       RowBox[{" ", 
        RowBox[{"\[Xi]", " ", "m"}]}]], " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "t"}], " ", 
        FractionBox[
         SuperscriptBox[
          SubscriptBox["\[Omega]", "r"], 
          RowBox[{"2", "\[Xi]"}]], "2"]}]]}], ")"}], " ", "*", " ", 
    RowBox[{
     RowBox[{"\[ScriptCapitalF]", "[", "bundle", "]"}], "[", 
     RowBox[{"m", ",", "\[Omega]"}], "]"}]}]}]}]], "Input",
 Evaluatable->False],

Cell[TextData[{
 "The ",
 StyleBox["m", "Input"],
 "-dependent terms of the summation are created iteratively with the ",
 StyleBox["FoldList", "Input"],
 " command. Each ",
 StyleBox["m", "Input"],
 "-slice of the Fourier transformed bundle is multiplied (and thus convolved) \
with the repsective ",
 StyleBox["m", "Input"],
 "-compenent of the kernel. The summation in ",
 StyleBox["m", "Input"],
 "  is performed via ",
 StyleBox["Apply[Plus,#]", "Input"],
 ".  Finally, the inverse Fourier transformation in ",
 StyleBox["\[Omega]", "Input"],
 "-space brings the reconstructed image back to position space."
}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "InverseOrientationBundle", " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"InverseOrientationBundleTransform", "[", 
      RowBox[{
       RowBox[{"bundle_", "?", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"ArrayQ", "[", 
           RowBox[{"#", ",", "3", ",", "NumericQ"}], "]"}], "&"}], ")"}]}], 
       ",", 
       RowBox[{"t_", "?", "NumericQ"}], ",", 
       RowBox[{"\[Xi]_:", "1"}]}], "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"InternalInverseOrientationBundle", "[", 
       RowBox[{"bundle", ",", "t", ",", "\[Xi]"}], "]"}], "/;", 
      RowBox[{"\[Xi]", ">", "0"}]}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
    "InternalInverseOrientationBundle", " ", "=", " ", "\[IndentingNewLine]", 
     
     RowBox[{"Compile", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"bundle", ",", "_Complex", ",", "3"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Xi]", ",", "_Real"}], "}"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Module", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"n", "=", 
            RowBox[{"Length", "[", "bundle", "]"}]}], ",", " ", "\[Omega]x", 
           ",", " ", "\[Omega]y", ",", "\[Omega]c", ",", "m0Bundle"}], "}"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\[Omega]x", " ", "=", "  ", 
           RowBox[{"FourierRange", "[", 
            RowBox[{
             RowBox[{"Dimensions", "[", "bundle", "]"}], 
             "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], "]"}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"\[Omega]y", " ", "=", "  ", 
           RowBox[{"FourierRange", "[", 
            RowBox[{
             RowBox[{"Dimensions", "[", "bundle", "]"}], 
             "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "]"}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"\[Omega]c", " ", "=", " ", 
           RowBox[{"Outer", "[", 
            RowBox[{"Plus", ",", " ", 
             RowBox[{"-", "\[Omega]y"}], ",", 
             RowBox[{
              RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]x"}]}], "]"}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"\[Xi]", ">", "1"}], ",", 
            RowBox[{"\[Omega]c", " ", "=", " ", 
             RowBox[{"\[Omega]c", " ", 
              SuperscriptBox[
               RowBox[{"Abs", "[", "\[Omega]c", "]"}], 
               RowBox[{"\[Xi]", "-", "1"}]]}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"1", ">", "\[Xi]", ">", "0"}], ",", 
            RowBox[{"\[Omega]c", " ", "=", " ", 
             RowBox[{
              RowBox[{"ComplexPhase", "[", "\[Omega]c", "]"}], " ", 
              SuperscriptBox[
               RowBox[{"Abs", "[", "\[Omega]c", "]"}], "\[Xi]"]}]}]}], "]"}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"m0Bundle", "=", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             RowBox[{"-", "t"}], " ", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"Abs", "[", "\[Omega]c", "]"}], "2"], "/", "2"}]}]]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"Chop", "[", 
           RowBox[{"InverseFourier", "[", "\[IndentingNewLine]", 
            RowBox[{"Apply", "[", 
             RowBox[{"Plus", ",", 
              RowBox[{
               RowBox[{"FoldList", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    SqrtBox[
                    FractionBox["t", "#2"]], " ", "\[Omega]c", " ", "*", " ", 
                    "#1"}], ")"}], "&"}], ",", "m0Bundle", ",", 
                 RowBox[{"Range", "[", 
                  RowBox[{"n", "-", "1"}], "]"}]}], "]"}], " ", "*", " ", 
               RowBox[{"Fourier", "[", "bundle", "]"}]}]}], "]"}], 
            "\[IndentingNewLine]", "]"}], "]"}]}]}], "\[IndentingNewLine]", 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ComplexPhase", "[", "_", "]"}], ",", "_Complex", ",", 
           "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Abs", "[", "_", "]"}], ",", "_Real", ",", "2"}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"FourierRange", "[", "_", "]"}], ",", "_Real", ",", "1"}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"FoldList", "[", 
            RowBox[{"_", ",", "_", ",", "_"}], "]"}], ",", "_Complex", ",", 
           "3"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Fourier", "[", "_", "]"}], ",", "_Complex", ",", "3"}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InverseFourier", "[", "_", "]"}], ",", "_Complex", ",", 
           "2"}], "}"}]}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
    ";"}]}]}]], "PackageInput"],

Cell["\<\
The same as above, but omitting the inverse angular Fourier transformation at \
the beginning.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "InverseFourierOrientationBundle", " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"InverseFourierOrientationBundle", "[", 
      RowBox[{
       RowBox[{"bundle_", "?", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"ArrayQ", "[", 
           RowBox[{"#", ",", "3", ",", "NumericQ"}], "]"}], "&"}], ")"}]}], 
       ",", 
       RowBox[{"t_", "?", "NumericQ"}], ",", 
       RowBox[{"\[Xi]_:", "1"}]}], "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"InternalInverseOrientationBundle", "[", 
       RowBox[{"bundle", ",", "t", ",", "\[Xi]"}], "]"}], "/;", 
      RowBox[{"\[Xi]", ">", "0"}]}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
    "InverseFourierOrientationBundle", " ", "=", " ", "\[IndentingNewLine]", 
     RowBox[{"Compile", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"bundle", ",", "_Complex", ",", "3"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", "_Real"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Xi]", ",", "_Real"}], "}"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Module", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"n", "=", 
            RowBox[{"Length", "[", "bundle", "]"}]}], ",", " ", "\[Omega]x", 
           ",", " ", "\[Omega]y", ",", "\[Omega]c", ",", "m0Bundle"}], "}"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\[Omega]x", " ", "=", "  ", 
           RowBox[{"FourierRange", "[", 
            RowBox[{
             RowBox[{"Dimensions", "[", "bundle", "]"}], 
             "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], "]"}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"\[Omega]y", " ", "=", "  ", 
           RowBox[{"FourierRange", "[", 
            RowBox[{
             RowBox[{"Dimensions", "[", "bundle", "]"}], 
             "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "]"}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"\[Omega]c", " ", "=", " ", 
           RowBox[{"Outer", "[", 
            RowBox[{"Plus", ",", " ", 
             RowBox[{"-", "\[Omega]y"}], ",", 
             RowBox[{
              RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Omega]x"}]}], "]"}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"\[Xi]", ">", "1"}], ",", 
            RowBox[{"\[Omega]c", " ", "=", " ", 
             RowBox[{"\[Omega]c", " ", 
              SuperscriptBox[
               RowBox[{"Abs", "[", "\[Omega]c", "]"}], 
               RowBox[{"\[Xi]", "-", "1"}]]}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"1", ">", "\[Xi]", ">", "0"}], ",", 
            RowBox[{"\[Omega]c", " ", "=", " ", 
             RowBox[{
              RowBox[{"ComplexPhase", "[", "\[Omega]c", "]"}], " ", 
              SuperscriptBox[
               RowBox[{"Abs", "[", "\[Omega]c", "]"}], "\[Xi]"]}]}]}], "]"}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"m0Bundle", "=", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             RowBox[{"-", "t"}], " ", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"Abs", "[", "\[Omega]c", "]"}], "2"], "/", "2"}]}]]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"Chop", "[", 
           RowBox[{"InverseFourier", "[", "\[IndentingNewLine]", 
            RowBox[{"Apply", "[", 
             RowBox[{"Plus", ",", 
              RowBox[{
               RowBox[{"FoldList", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    SqrtBox[
                    FractionBox["t", "#2"]], " ", "\[Omega]c", " ", "*", " ", 
                    "#1"}], ")"}], "&"}], ",", "m0Bundle", ",", 
                 RowBox[{"Range", "[", 
                  RowBox[{"n", "-", "1"}], "]"}]}], "]"}], " ", "*", " ", 
               RowBox[{"Map", "[", 
                RowBox[{"Fourier", ",", "bundle"}], "]"}]}]}], "]"}], 
            "\[IndentingNewLine]", "]"}], "]"}]}]}], "\[IndentingNewLine]", 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ComplexPhase", "[", "_", "]"}], ",", "_Complex", ",", 
           "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Abs", "[", "_", "]"}], ",", "_Real", ",", "2"}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"FourierRange", "[", "_", "]"}], ",", "_Real", ",", "1"}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"FoldList", "[", 
            RowBox[{"_", ",", "_", ",", "_"}], "]"}], ",", "_Complex", ",", 
           "3"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Fourier", "[", "_", "]"}], ",", "_Complex", ",", "2"}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"InverseFourier", "[", "_", "]"}], ",", "_Complex", ",", 
           "2"}], "}"}]}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
    ";"}]}]}]], "PackageInput"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "OrientationTransform", ",", "\[IndentingNewLine]", 
       "OrientationBundleTransform", ",", "\[IndentingNewLine]", 
       "InverseOrientationBundleTransform", ",", "\[IndentingNewLine]", 
       "FourierOrientationBundleTransform", ",", "\[IndentingNewLine]", 
       "InverseFourierOrientationBundleTransform", ",", "\[IndentingNewLine]",
        "DirectionalFourierFilter"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Protected", ",", " ", "ReadProtected"}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1014, 736},
WindowMargins->{{2, Automatic}, {Automatic, 0}},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (November 10, 2008)",
StyleDefinitions->"PackageNotebook.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 43, 0, 144, "Title"],
Cell[613, 24, 100, 4, 118, "Subsubtitle"],
Cell[716, 30, 75, 0, 39, "Text"],
Cell[CellGroupData[{
Cell[816, 34, 25, 0, 72, "Section"],
Cell[844, 36, 958, 25, 436, "PackageInput"],
Cell[1805, 63, 128, 3, 58, "Text"],
Cell[1936, 68, 3704, 99, 1264, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5677, 172, 32, 0, 40, "Section"],
Cell[5712, 174, 92, 2, 58, "Text"],
Cell[5807, 178, 650, 14, 402, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6494, 197, 42, 0, 40, "Section"],
Cell[6539, 199, 2608, 52, 1230, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[9184, 256, 31, 0, 40, "Section"],
Cell[9218, 258, 60, 0, 39, "Text"],
Cell[9281, 260, 108, 2, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[9414, 266, 39, 0, 63, "Subsection"],
Cell[9456, 268, 238, 6, 93, "Text"],
Cell[9697, 276, 1440, 42, 418, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[11174, 323, 42, 0, 37, "Subsection"],
Cell[11219, 325, 4638, 116, 888, "PackageInput"],
Cell[15860, 443, 4176, 107, 766, "PackageInput"],
Cell[20039, 552, 4727, 120, 813, "PackageInput"],
Cell[24769, 674, 5096, 128, 991, "PackageInput"],
Cell[29868, 804, 4348, 111, 801, "PackageInput"],
Cell[34219, 917, 4963, 127, 847, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[39219, 1049, 50, 0, 37, "Subsection"],
Cell[39272, 1051, 249, 8, 61, "Text"],
Cell[39524, 1061, 928, 30, 124, "Input",
 Evaluatable->False],
Cell[40455, 1093, 20, 0, 58, "Text"],
Cell[40478, 1095, 426, 12, 67, "Input",
 Evaluatable->False],
Cell[40907, 1109, 184, 8, 58, "Text"],
Cell[41094, 1119, 125, 3, 58, "Text"],
Cell[41222, 1124, 1248, 39, 124, "Input",
 Evaluatable->False],
Cell[42473, 1165, 592, 15, 160, "Text"],
Cell[43068, 1182, 5544, 139, 1162, "PackageInput"],
Cell[48615, 1323, 105, 3, 58, "Text"],
Cell[48723, 1328, 5085, 129, 1093, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[53845, 1462, 58, 0, 37, "Subsection"],
Cell[53906, 1464, 263, 8, 136, "Text"],
Cell[54172, 1474, 998, 32, 271, "Input",
 Evaluatable->False],
Cell[55173, 1508, 20, 0, 130, "Text"],
Cell[55196, 1510, 471, 14, 144, "Input",
 Evaluatable->False],
Cell[55670, 1526, 357, 8, 360, "Text"],
Cell[56030, 1536, 1412, 43, 271, "Input",
 Evaluatable->False],
Cell[57445, 1581, 624, 17, 360, "Text"],
Cell[58072, 1600, 5399, 136, 2632, "PackageInput"],
Cell[63474, 1738, 118, 3, 130, "Text"],
Cell[63595, 1743, 5436, 136, 2632, "PackageInput"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[69080, 1885, 34, 0, 40, "Section"],
Cell[69117, 1887, 64, 0, 58, "Text"],
Cell[69184, 1889, 889, 19, 505, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
