(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     17442,        505]
NotebookOptionsPosition[     16054,        455]
NotebookOutlinePosition[     16473,        473]
CellTagsIndexPosition[     16430,        470]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["RegionGrowing Package", "Title"],

Cell["\<\
Edwin Bennink, Markus van Almsick
Technische Universiteit Eindhoven
\[Copyright]2005 - \[Copyright]2008\
\>", "Subsubtitle"],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\[IndentingNewLine]", 
   "\n", 
   RowBox[{
    RowBox[{
     RowBox[{
     "TimeStamp", "[", "\"\<MathVisionTools`RegionGrowing`\>\"", "]"}], " ", 
     "=", " ", 
     RowBox[{"{", 
      RowBox[{"2008", ",", "8", ",", "13", ",", "11", ",", "43", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput"],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contemns, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`RegionGrowing`"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Authors", ":", " ", 
      RowBox[{"Edwin", " ", "Bennink"}]}]}], ",", " ", 
    RowBox[{"Markus", " ", "van", " ", "Almsick"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Email", " ", 
      RowBox[{"address", ":", " ", 
       RowBox[{"H", ".", "E", ".", 
        RowBox[{"Bennink", "@", "student"}], ".", "tue", ".", "nl"}]}]}]}], 
    ",", " ", 
    RowBox[{"M", ".", "v", ".", 
     RowBox[{"Almsick", "@", "tue"}], ".", "nl"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`RegionGrowing`"}]}], "*)"}],
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "1.2"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "5.0"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2005"}]}]}], ",", " ", 
    RowBox[{"Technische", " ", "Universiteit", " ", "Eindhoven"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "RegionGrowing"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "implements", " ", "Region", " ", 
      "Growing"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", "Region"}]}], ",", " ", "Growing", ",", 
    " ", "Segmentation"}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Edwin", " ", "Bennink"}]}]}], 
    ",", " ", 
    RowBox[{
    "February", " ", "2005", "\[IndentingNewLine]", "         ", "Version", 
     " ", "1.1", " ", "by", " ", "Markus", " ", "van", " ", "Almsick"}], ",", 
    " ", 
    RowBox[{
    "March", " ", "2005", "\[IndentingNewLine]", "         ", "Version", " ", 
     "1.2", " ", "by", " ", "Markus", " ", "van", " ", "Almsick"}], ",", " ", 
    RowBox[{"August", " ", "2008"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":", " ", 
      RowBox[{
      "try", " ", "to", " ", "speed", " ", "up", " ", "the", " ", "procedure",
        " ", "with", " ", "Sow", " ", "and", " ", "Reap"}]}]}]}], " ", 
   "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "BeginPackage", "[", "\"\<MathVisionTools`RegionGrowing`\>\"", "]"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{"Unprotect", "[", "\[IndentingNewLine]", 
  RowBox[{"RegionGrowing", ",", "AdjacencyNumbers"}], "\[IndentingNewLine]", 
  "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"RegionGrowing", "::", "usage"}], "=", 
    "\"\<RegionGrowing[{img1, img2, ... }, pos, adjacency, costfunc] grows a \
binary region by sequentially adding adjacent pixels or voxels that match the \
criterium defined by the boolean cost function costfunc. The cost function \
must accept two arguments,the first being the List of img-values at the \
position of a region seed,the second being the List of img values at the \
position of a neighbor, for which the membership to the region is under \
investigation. The costfunction must be a boolean function that renders True \
or False. The seed point of the region is given by pos. adjacency specifies \
the neigborhod of points that is considered in the regiong rowing process. \
adjacency=1 accounts for immediate neighbors. adjacency=2 accounts for \
immediate and diagonal neighbors in a plane. adjacency=3 adds neighbors along \
the diagonals in a volumen, and so on. The result is a binary image, in which \
the region and background have the values 1 and 0 respectively. \
\\nRegionGrowing[{img1, img2, ... }, {pos1, pos2, ... }, adjacency, costfunc] \
applies region growing to multiple seed points.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"AdjacencyNumbers", "::", "usage"}], "=", 
    "\"\<AdjacencyNumbers[n] render the possible adjacency numbers for an \
array of rank or depth n. The adjacency numbers are the number of immediate \
and diagonal neighbors in a plane, volume, etc. into account.\>\""}], ";"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "RegionGrowing", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"MaxIterations", "\[Rule]", "\[Infinity]"}], "}"}]}], 
  ";"}]}], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"AdjacencyNumbers", "[", "n_Integer", "]"}], " ", ":=", " ", 
  RowBox[{"Rest", "[", 
   RowBox[{"FoldList", "[", 
    RowBox[{"Plus", ",", "0", ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Binomial", "[", 
         RowBox[{"n", ",", "k"}], "]"}], " ", 
        SuperscriptBox["2", "k"]}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", "1", ",", "n"}], "}"}]}], "]"}]}], "]"}], 
   "]"}]}]], "PackageInput"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RegionGrowing", "[", 
    RowBox[{
     RowBox[{"data_", "?", "ArrayQ"}], ",", 
     RowBox[{"seed", ":", 
      RowBox[{"{", "__Integer", "}"}]}], ",", "adjR2_Integer", ",", 
     "costFunction_", ",", 
     RowBox[{
      RowBox[{"(", "opts___", ")"}], "?", "OptionQ"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"RegionGrowing", "[", 
     RowBox[{"data", ",", 
      RowBox[{"{", "seed", "}"}], ",", "adjR2", ",", "costFunction", ",", 
      "opts"}], "]"}], " ", "/;", " ", 
    RowBox[{
     RowBox[{"ArrayDepth", "[", "data", "]"}], " ", "===", " ", 
     RowBox[{
      RowBox[{"Last", "[", 
       RowBox[{"Dimensions", "[", "seed", "]"}], "]"}], "+", "1"}]}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RegionGrowing", "[", 
   RowBox[{
    RowBox[{"data_", "?", "ArrayQ"}], ",", 
    RowBox[{"seeds", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "__Integer", "}"}], ".."}], "}"}]}], ",", "adjR2_Integer",
     ",", "costFunction_", ",", 
    RowBox[{
     RowBox[{"(", "opts___", ")"}], "?", "OptionQ"}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "region", ",", "neighbor", ",", "neighborhood", ",", "candidates", ",", 
       RowBox[{"seedStorage", " ", "=", " ", "seeds"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"dims", " ", "=", " ", 
        RowBox[{"Rest", "[", 
         RowBox[{"Dimensions", "[", "data", "]"}], "]"}]}], ",", 
       RowBox[{"rank", "=", 
        RowBox[{
         RowBox[{"ArrayDepth", "[", "data", "]"}], "-", "1"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"maxIterator", "=", 
        RowBox[{
         RowBox[{"MaxIterations", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "RegionGrowing", "]"}]}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"iterator", "=", "1"}], ",", " ", "source"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"neighborhood", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Outer", "[", 
            RowBox[{"List", ",", 
             RowBox[{"Sequence", "@@", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "1"}], ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", "rank", "}"}]}], "]"}]}]}], "]"}], ",", 
           RowBox[{"rank", "-", "1"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "\[LessEqual]", " ", 
            RowBox[{"Norm", "[", "#", "]"}], "\[LessEqual]", 
            SqrtBox["adjR2"]}], ")"}], "&"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"region", "=", 
       RowBox[{"PadRight", "[", 
        RowBox[{
         RowBox[{"PadLeft", "[", 
          RowBox[{
           RowBox[{"ReplacePart", "[", 
            RowBox[{
             RowBox[{"Array", "[", 
              RowBox[{
               RowBox[{"0", "&"}], ",", "dims"}], "]"}], ",", "1", ",", 
             "seedStorage"}], "]"}], ",", 
           RowBox[{"dims", "+", "1"}], ",", "1"}], "]"}], ",", 
         RowBox[{"dims", "+", "2"}], ",", "1"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"While", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"iterator", "<", "maxIterator"}], " ", "\[And]", " ", 
         RowBox[{"seedStorage", "\[NotEqual]", 
          RowBox[{"{", "}"}]}]}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"iterator", "++"}], ";", " ", "\[IndentingNewLine]", 
         RowBox[{"source", " ", "=", " ", 
          RowBox[{"First", "[", "seedStorage", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"candidates", " ", "=", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"Pick", "[", 
             RowBox[{"#", ",", 
              RowBox[{"Extract", "[", 
               RowBox[{"region", ",", 
                RowBox[{"#", "+", "1"}]}], "]"}], ",", "0"}], "]"}], "&"}], 
           "[", 
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"source", "+", "#"}], ")"}], "&"}], ",", 
             "neighborhood"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"Scan", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"region", "=", 
               RowBox[{"ReplacePart", "[", 
                RowBox[{"region", ",", "1", ",", 
                 RowBox[{"#", "+", "1"}]}], "]"}]}], ";", 
              RowBox[{"AppendTo", "[", 
               RowBox[{"seedStorage", ",", "#"}], "]"}]}], ")"}], "&"}], ",", 
           RowBox[{"Pick", "[", 
            RowBox[{"candidates", ",", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"costFunction", "[", 
                 RowBox[{
                  RowBox[{"Map", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Extract", "[", 
                    RowBox[{"#", ",", "source"}], "]"}], "&"}], ",", "data"}],
                    "]"}], ",", "#"}], "]"}], "&"}], ",", 
               RowBox[{"Transpose", "[", 
                RowBox[{"Map", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Extract", "[", 
                    RowBox[{"#", ",", "candidates"}], "]"}], "&"}], ",", 
                  "data"}], "]"}], "]"}]}], "]"}]}], "]"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"seedStorage", " ", "=", " ", 
          RowBox[{"Rest", "[", "seedStorage", "]"}]}]}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Take", "[", 
       RowBox[{"region", ",", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{"2", ",", 
              RowBox[{"{", "rank", "}"}]}], "]"}], ",", 
            RowBox[{"dims", " ", "+", " ", "1"}]}], "}"}], "]"}]}]}], 
       "]"}]}]}], "\[IndentingNewLine]", "]"}], "/;", 
   RowBox[{
    RowBox[{"ArrayDepth", "[", "data", "]"}], " ", "===", " ", 
    RowBox[{
     RowBox[{"Last", "[", 
      RowBox[{"Dimensions", "[", "seeds", "]"}], "]"}], "+", 
     "1"}]}]}]}]}], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"RegionGrowing", ",", "AdjacencyNumbers"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Protected", ",", " ", "ReadProtected"}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1112, 954},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
Magnification->1,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (November 10, 2008)",
StyleDefinitions->"PackageNotebook.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 38, 0, 96, "Title"],
Cell[608, 24, 134, 4, 79, "Subsubtitle"],
Cell[CellGroupData[{
Cell[767, 32, 25, 0, 48, "Section"],
Cell[795, 34, 954, 25, 161, "PackageInput"],
Cell[1752, 61, 128, 3, 26, "Text"],
Cell[1883, 66, 3717, 102, 521, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5637, 173, 32, 0, 28, "Section"],
Cell[5672, 175, 92, 2, 32, "Text"],
Cell[5767, 179, 325, 8, 107, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6129, 192, 42, 0, 28, "Section"],
Cell[6174, 194, 1812, 34, 281, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[8023, 233, 31, 0, 28, "Section"],
Cell[8057, 235, 60, 0, 26, "Text"],
Cell[8120, 237, 108, 2, 40, "PackageInput",
 InitializationCell->True],
Cell[8231, 241, 485, 14, 46, "PackageInput"],
Cell[8719, 257, 6616, 171, 410, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[15372, 433, 34, 0, 28, "Section"],
Cell[15409, 435, 64, 0, 32, "Text"],
Cell[15476, 437, 550, 14, 155, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
