(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     22416,        656]
NotebookOptionsPosition[     20261,        582]
NotebookOutlinePosition[     20794,        603]
CellTagsIndexPosition[     20751,        600]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Select Functions", "Title"],

Cell["\<\
Markus van Almsick
Technische Universiteit Eindhoven
\[Copyright]2008\
\>", "Subsubtitle"],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
     "TimeStamp", "[", "\"\<MathVisionTools`SelectFunctions`\>\"", "]"}], " ",
      "=", " ", 
     RowBox[{"{", 
      RowBox[{"2010", ",", "4", ",", "14", ",", "12", ",", "10", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`SelectFunctions`"}]}], " ", 
   "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Author", ":", " ", 
     RowBox[{"Markus", " ", "van", " ", "Almsick"}]}]}], "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"M", ".", "v", ".", 
       RowBox[{"Almsick", "@", "tue"}], ".", "nl"}]}]}]}], "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`SelectFunctions`"}]}], 
   "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "1.0"}]}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "6"}]}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2008"}]}]}], ",", " ", 
    RowBox[{"Technische", " ", "Universiteit", " ", "Eindhoven"}]}], "*)"}], 
  "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "SelectFunctions"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "implements", " ", "several", " ", 
      "functions", " ", "to", " ", "display", " ", "image", " ", "data"}]}]}],
    " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", "plot"}]}], ",", " ", "display"}], " ", 
   "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", "  ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"Septmeber", " ", "2008"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":", " ", 
     RowBox[{
     "needs", " ", "Mathematica", " ", "6", " ", "or", " ", "later"}]}]}], 
   " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\n", "\n", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<MathVisionTools`SelectFunctions`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<MathVisionTools`DisplayFunctions`\>\"", ",", 
      "\"\<MathVisionTools`ImageTransformation`\>\""}], "}"}]}], "]"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{"Unprotect", "[", "\n", "  ", 
  RowBox[{
  "SelectSubimageDialog", ",", " ", "SelectPathDialog", ",", 
   "ExtractCrossSection"}], " ", "\n", "  ", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SelectSubimageDialog", "::", "usage"}], " ", "=", " ", 
  "\"\<SelectSubimageDialog[img] puts up a dialog notebook that displays the \
image. Two movable locators determine the rectangle that defines the \
subimage. To select the choosen subimage, hit the proceed button or \
\[ReturnKey]. The dialog will disapear and SelectSubimageDialog will return \
the subimage array.\>\""}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SelectPathDialog", "::", "usage"}], " ", "=", " ", 
  "\"\<SelectPathDialog[img] puts up a dialog notebook that displays the \
image. Initially two locators determine the end points of a linear path. \
Click the locators to move these end points around. Additional points can be \
added to or deleted from the path by \[CommandKey]+click or \[AltKey]+click. \
To select the choosen path, hit the proceed button or \[ReturnKey]. The \
dialog will disapear and SelectPathDialog will return the two Lists of points \
that define the path. The first List is given in Image-coordinates, the \
second in matrix-indices.\>\""}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ExtractCrossSection", "::", "usage"}], " ", "=", " ", 
  "\"\<ExtractCrossSection[img, {p0, p1,\[Ellipsis]} ds:1] renders the List \
of pixel values along the path given by {p0,p1,\[Ellipsis]} in steps of ds. \
Cubic B-spline interpolation is used.\>\""}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["SelectSubimageDialog", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SelectSubimageDialog", "[", "img_", "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"dims", " ", "=", " ", 
       RowBox[{"Reverse", "[", 
        RowBox[{"Dimensions", "[", "img", "]"}], "]"}]}], ",", "p"}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"p", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"dims", "/", "3"}], ",", 
        RowBox[{"2", 
         RowBox[{"dims", "/", "3"}]}]}], "}"}]}], ";", "\[IndentingNewLine]", 
     
     RowBox[{"DialogInput", "[", "\[IndentingNewLine]", 
      RowBox[{"DialogNotebook", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"RasterPlot", "[", 
            RowBox[{"img", ",", 
             RowBox[{"Epilog", "\[Rule]", " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"EdgeForm", "[", "Orange", "]"}], ",", 
                RowBox[{"FaceForm", "[", 
                 RowBox[{"{", 
                  RowBox[{"Green", ",", 
                   RowBox[{"Opacity", "[", 
                    RowBox[{"1", "/", "8"}], "]"}]}], "}"}], "]"}], ",", 
                RowBox[{"Rectangle", "@@", "p"}]}], "}"}]}], ",", " ", 
             RowBox[{"Frame", "\[Rule]", " ", "False"}], ",", 
             RowBox[{"ImageSize", "\[Rule]", "Large"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"p", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}], ",", "dims", ",", "Locator"}], 
            "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Deployed", "\[Rule]", "True"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Paneled", "\[Rule]", " ", "False"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"LocalizeVariables", "\[Rule]", " ", "False"}]}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Button", "[", 
          RowBox[{"\"\<Proceed\>\"", ",", 
           RowBox[{"DialogReturn", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Take", "[", 
               RowBox[{"img", ",", "##"}], "]"}], "&"}], "@@", 
             RowBox[{"Map", "[", 
              RowBox[{"Sort", ",", 
               RowBox[{"Reverse", "[", 
                RowBox[{"Transpose", "[", 
                 RowBox[{"Round", "[", "p", "]"}], "]"}], "]"}]}], "]"}]}], 
            "]"}]}], "]"}]}], "\[IndentingNewLine]", "}"}], "]"}], 
      "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["SelectPathDialog", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SelectPathDialog", "[", "img_", "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"dims", " ", "=", " ", 
       RowBox[{"Reverse", "[", 
        RowBox[{"Dimensions", "[", "img", "]"}], "]"}]}], ",", "p"}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"p", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"dims", "/", "3"}], ",", 
        RowBox[{"2", 
         RowBox[{"dims", "/", "3"}]}]}], "}"}]}], ";", "\[IndentingNewLine]", 
     
     RowBox[{"DialogInput", "[", "\[IndentingNewLine]", 
      RowBox[{"DialogNotebook", "[", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"RasterPlot", "[", 
            RowBox[{"img", ",", 
             RowBox[{"Epilog", "\[Rule]", " ", 
              RowBox[{"{", 
               RowBox[{"Orange", ",", 
                RowBox[{"Line", "[", "p", "]"}]}], "}"}]}], ",", " ", 
             RowBox[{"Frame", "\[Rule]", " ", "False"}], ",", 
             RowBox[{"ImageSize", "\[Rule]", "Large"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"p", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}], ",", "dims", ",", "Locator", 
             ",", 
             RowBox[{"LocatorAutoCreate", "\[Rule]", "True"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Deployed", "\[Rule]", "True"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Paneled", "\[Rule]", " ", "False"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"LocalizeVariables", "\[Rule]", " ", "False"}]}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Button", "[", 
          RowBox[{"\"\<Proceed\>\"", ",", 
           RowBox[{"DialogReturn", "[", 
            RowBox[{"{", 
             RowBox[{"p", ",", 
              RowBox[{"Round", "[", 
               RowBox[{"Map", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", 
                    RowBox[{"Length", "[", "img", "]"}]}], "}"}], "+", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1", ",", 
                    RowBox[{"-", "1"}]}], "}"}], "#"}]}], ")"}], "&"}], ",", 
                 "p"}], "]"}], "]"}]}], "}"}], "]"}]}], "]"}]}], 
        "\[IndentingNewLine]", "}"}], "]"}], "\[IndentingNewLine]", "]"}]}]}],
    "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["ExtractCrossSection", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtractCrossSection", "::", "off"}], "=", 
   "\"\<One or both end-points of the cross-section are outside the \
image.\>\""}], ";"}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ExtractCrossSection", "[", 
   RowBox[{"img_", ",", 
    RowBox[{"{", 
     RowBox[{"pt1_List", ",", "pt2_List"}], "}"}], ",", 
    RowBox[{"ds_:", "1"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"dims", " ", "=", " ", 
       RowBox[{"Reverse", "[", 
        RowBox[{"Dimensions", "[", "img", "]"}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"tmp", "=", 
       RowBox[{"CubicBSplineImageInterpolationFilter", "[", "img", "]"}]}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"len", "=", 
       RowBox[{"Norm", "[", 
        RowBox[{"pt2", "-", "pt1"}], "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"Not", "[", 
        RowBox[{
         RowBox[{"And", "@@", 
          RowBox[{"Thread", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], "\[LessEqual]", "pt1", 
            "\[LessEqual]", "dims"}], "]"}]}], " ", "\[And]", " ", 
         RowBox[{"And", "@@", 
          RowBox[{"Thread", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], "\[LessEqual]", "pt2", 
            "\[LessEqual]", " ", "dims"}], "]"}]}]}], "]"}], ",", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{"ExtractCrossSection", "::", "off"}], "]"}], ";", " ", 
        RowBox[{"Return", "[", "$Failed", "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Apply", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"NCubicBSplineImageInterpolation", "[", 
           RowBox[{"tmp", ",", "#1", ",", 
            RowBox[{
             RowBox[{
             "dims", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
             "-", "#2", "+", "1"}], ",", 
            RowBox[{
            "dims", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
            ",", 
            RowBox[{
            "dims", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
            ",", "0"}], "]"}], "&"}], ",", " ", 
         RowBox[{"pt1", "+", 
          RowBox[{"s", "*", 
           FractionBox[
            RowBox[{"pt2", "-", "pt1"}], "len"]}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"s", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"len", "-", 
            RowBox[{
             RowBox[{"Floor", "[", 
              RowBox[{"len", "/", "ds"}], "]"}], "ds"}]}], ")"}], "/", "2"}], 
         ",", "len", ",", "ds"}], "}"}]}], "\[IndentingNewLine]", "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ExtractCrossSection", "[", 
   RowBox[{"img_", ",", 
    RowBox[{"pts", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
    RowBox[{"ds_:", "1"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"dims", " ", "=", " ", 
       RowBox[{"Reverse", "[", 
        RowBox[{"Dimensions", "[", "img", "]"}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"tmp", "=", 
       RowBox[{"CubicBSplineImageInterpolationFilter", "[", "img", "]"}]}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"lens", "=", 
       RowBox[{"FoldList", "[", 
        RowBox[{"Plus", ",", "0", ",", 
         RowBox[{"Apply", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Norm", "[", 
             RowBox[{"#2", "-", "#1"}], "]"}], "&"}], ",", 
           RowBox[{"Partition", "[", 
            RowBox[{"pts", ",", "2", ",", "1"}], "]"}], ",", 
           RowBox[{"{", "1", "}"}]}], "]"}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", "len", ",", "path"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"len", "=", 
      RowBox[{"Last", "[", "lens", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Not", "[", 
        RowBox[{"And", "@@", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"And", "@@", 
             RowBox[{"Thread", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], "\[LessEqual]", "#", 
               "\[LessEqual]", "dims"}], "]"}]}], "&"}], ",", "pts"}], 
          "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{"ExtractCrossSection", "::", "off"}], "]"}], ";", " ", 
        RowBox[{"Return", "[", "$Failed", "]"}]}]}], "\[IndentingNewLine]", 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"path", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Interpolation", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"lens", ",", "#"}], "}"}], "]"}], ",", 
           RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}], "&"}], 
        ",", 
        RowBox[{"Transpose", "[", "pts", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"NCubicBSplineImageInterpolation", "[", 
        RowBox[{"tmp", ",", 
         RowBox[{
          RowBox[{
          "path", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], "[",
           "s", "]"}], ",", 
         RowBox[{
          RowBox[{
          "dims", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "-", 
          RowBox[{
           RowBox[{
           "path", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
           "[", "s", "]"}], "+", "1"}], ",", 
         RowBox[{
         "dims", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
         
         RowBox[{
         "dims", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], ",", 
         "0"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"s", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"len", "-", 
            RowBox[{
             RowBox[{"Floor", "[", 
              RowBox[{"len", "/", "ds"}], "]"}], "ds"}]}], ")"}], "/", "2"}], 
         ",", "len", ",", "ds"}], "}"}]}], "\[IndentingNewLine]", "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "SelectSubimageDialog", ",", " ", "SelectPathDialog", ",", 
       "ExtractCrossSection"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", "Protected", "}"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1200, 771},
WindowMargins->{{10, Automatic}, {Automatic, 0}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (November 10, 2008)",
StyleDefinitions->"PackageNotebook.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 33, 0, 144, "Title"],
Cell[603, 24, 100, 4, 118, "Subsubtitle"],
Cell[CellGroupData[{
Cell[728, 32, 25, 0, 72, "Section"],
Cell[756, 34, 128, 3, 39, "Text"],
Cell[887, 39, 956, 25, 291, "PackageInput"],
Cell[1846, 66, 2583, 77, 751, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[4466, 148, 32, 0, 40, "Section"],
Cell[4501, 150, 92, 2, 39, "Text"],
Cell[4596, 154, 522, 13, 176, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5155, 172, 42, 0, 40, "Section"],
Cell[5200, 174, 460, 8, 153, "PackageInput",
 InitializationCell->True],
Cell[5663, 184, 700, 11, 222, "PackageInput",
 InitializationCell->True],
Cell[6366, 197, 335, 6, 107, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6738, 208, 31, 0, 40, "Section"],
Cell[6772, 210, 60, 0, 39, "Text"],
Cell[6835, 212, 108, 2, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[6968, 218, 42, 0, 63, "Subsection"],
Cell[7013, 220, 2767, 67, 453, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[9817, 292, 38, 0, 37, "Subsection"],
Cell[9858, 294, 2791, 68, 430, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[12686, 367, 41, 0, 37, "Subsection"],
Cell[12730, 369, 198, 5, 60, "PackageInput"],
Cell[12931, 376, 2835, 76, 447, "PackageInput",
 InitializationCell->True],
Cell[15769, 454, 3775, 100, 430, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[19593, 560, 34, 0, 40, "Section"],
Cell[19630, 562, 64, 0, 39, "Text"],
Cell[19697, 564, 536, 14, 222, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
