(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    102719,       2589]
NotebookOptionsPosition[     53449,       1527]
NotebookOutlinePosition[    100370,       2518]
CellTagsIndexPosition[    100327,       2515]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Spherical Tesselation", "Title"],

Cell["\<\
Markus van Almsick, TU Eindhoven
\[Copyright]2010\
\>", "Subsubtitle"],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\[IndentingNewLine]", 
   "\n", 
   RowBox[{
    RowBox[{
     RowBox[{
     "TimeStamp", "[", "\"\<MathVisionTools`SphericalTesselation`\>\"", "]"}],
      " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"2010", ",", "3", ",", "4", ",", "11", ",", "0", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput"],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`SphericalTesselation`"}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Author", ":", " ", 
     RowBox[{"Markus", " ", "van", " ", "Almsick"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"m", ".", "v", ".", 
       RowBox[{"almsick", "@", "tue"}], ".", "nl"}]}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`SphericalTesselation`"}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "1.0"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "2.0"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2010"}]}]}], ",", " ", 
    RowBox[{"Markus", " ", "van", " ", "Almsick"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "SphericalTesselation"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "provides", " ", "a", " ", "discrete", " ", 
      "grid", " ", "for", " ", "numerical", " ", "calculations", " ", "on", 
      " ", "a", " ", 
      RowBox[{"sphere", "."}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", "tesselation"}]}], ",", " ", "spherical"}],
    " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Warning", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"March", " ", "2010"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":", " ", 
     RowBox[{
     "Works", " ", "for", " ", "Mathematica", " ", "7.0", " ", "or", " ", 
      RowBox[{"later", "."}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.
\"Statistics`Common`DistributionsCommon`\"\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "BeginPackage", "[", "\[IndentingNewLine]", 
   "\"\<MathVisionTools`SphericalTesselation`\>\"", "\[IndentingNewLine]", 
   "]"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{"{", 
    RowBox[{
    "IcosahedralComplex", ",", "OctahedralComplex", ",", "TetrahedralComplex",
      ",", "DualTesselate", ",", "DualComplex", ",", "VertexAreas", ",", 
     "TriangularTesselate", ",", "BalancedTriangularTesselate", ",", 
     "Triangulate", ",", "SphericalAngels"}], "}"}], "]"}], 
  ";"}]}], "PackageInput",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IcosahedralComplex", "::", "usage"}], "=", 
    "\"\<IcosahedralComplex render a GraphicsComplex of an icosahedron with \
unit radius.\>\""}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OctahedralComplex", "::", "usage"}], "=", 
    "\"\<OctahedralComplex render a GraphicsComplex of an octahedron with \
unit radius.\>\""}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TetrahedralComplex", "::", "usage"}], "=", 
    "\"\<TetrahedralComplex render a GraphicsComplex of an tetrahedron with \
unit radius.\>\""}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DualTesselate", "::", "usage"}], "=", 
    "\"\<DualTesselate[gc]...\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DualComplex", "::", "usage"}], "=", 
    "\"\<DualComplex[gc]...\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"VertexAreas", "::", "usage"}], "=", 
    "\"\<VertexAreas[gc]...\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TriangularTesselate", "::", "usage"}], "=", 
    "\"\<TriangularTesselate[gc,n]...\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BalancedTriangularTesselate", "::", "usage"}], "=", 
    "\"\<BalancedTriangularTesselate[gc,n]...\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Triangulate", "::", "usage"}], "=", 
    "\"\<Triangulate[gc]...\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SphericalAngels", "::", "usage"}], "=", 
   "\"\<SphericalAngels[gc]...\>\""}], ";"}]}], "PackageInput",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["SphericalTesselation", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"IcosahedralComplex", "=", "\[IndentingNewLine]", 
    RowBox[{"GraphicsComplex", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"#1", ",", "#2", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "#1"}], ",", "#2", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "#1"}], ",", 
            RowBox[{"-", "#2"}], ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"#1", ",", 
            RowBox[{"-", "#2"}], ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"#2", ",", "0", ",", "#1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"#2", ",", "0", ",", 
            RowBox[{"-", "#1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "#2"}], ",", "0", ",", 
            RowBox[{"-", "#1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "#2"}], ",", "0", ",", "#1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "#1", ",", "#2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"-", "#1"}], ",", "#2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"-", "#1"}], ",", 
            RowBox[{"-", "#2"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "#1", ",", 
            RowBox[{"-", "#2"}]}], "}"}]}], "}"}], "&"}], "[", 
       RowBox[{
        SqrtBox[
         RowBox[{"0.1`", " ", 
          RowBox[{"(", 
           RowBox[{"5", "+", 
            SqrtBox["5"]}], ")"}]}]], ",", 
        SqrtBox[
         RowBox[{"0.1`", " ", 
          RowBox[{"(", 
           RowBox[{"5", "-", 
            SqrtBox["5"]}], ")"}]}]]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5", ",", "9", ",", "8"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"5", ",", "8", ",", "10"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"6", ",", "7", ",", "12"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"6", ",", "11", ",", "7"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "5", ",", "4"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "4", ",", "6"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "8", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "2", ",", "7"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"9", ",", "1", ",", "12"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"9", ",", "12", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "11", ",", "4"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "3", ",", "11"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"9", ",", "5", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"12", ",", "1", ",", "6"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"5", ",", "10", ",", "4"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"6", ",", "4", ",", "11"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"8", ",", "9", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"7", ",", "2", ",", "12"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"8", ",", "3", ",", "10"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"7", ",", "11", ",", "3"}], "}"}]}], "}"}], "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"OctahedralComplex", " ", "=", " ", "\[IndentingNewLine]", 
    RowBox[{"GraphicsComplex", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "5", ",", "3"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "5", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "5", ",", "4"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "5", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "3", ",", "6"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "2", ",", "6"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "4", ",", "6"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "1", ",", "6"}], "}"}]}], "}"}], "]"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TetrahedralComplex", " ", "=", " ", "\[IndentingNewLine]", 
   RowBox[{"GraphicsComplex", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"#", ",", "#", ",", "#"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "#"}], ",", 
           RowBox[{"-", "#"}], ",", "#"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "#"}], ",", "#", ",", 
           RowBox[{"-", "#"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"#", ",", 
           RowBox[{"-", "#"}], ",", 
           RowBox[{"-", "#"}]}], "}"}]}], "}"}], "&"}], "[", 
      RowBox[{"N", "[", 
       RowBox[{"1", "/", 
        SqrtBox["3"]}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "4", ",", "2"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", "2", ",", "4"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "3", ",", "4"}], "}"}]}], "}"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell[" Dual Tesselate", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriangularNeighborhoods", "[", 
   RowBox[{"triangles", ":", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", "_"}], "}"}], ".."}], "}"}]}], "]"}], ":=",
   "\[IndentingNewLine]", 
  RowBox[{"Flatten", "[", 
   RowBox[{
    RowBox[{"Last", "[", 
     RowBox[{"Reap", "[", 
      RowBox[{
       RowBox[{"Scan", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Sow", "[", 
           RowBox[{"#", ",", "#"}], "]"}], "&"}], ",", "triangles"}], "]"}], 
       ",", "_", ",", "TriangularNeighbors"}], "]"}], "]"}], ",", "1"}], 
   "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriangularNeighbors", "[", 
   RowBox[{"a_", ",", 
    RowBox[{"triangles", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", "_"}], "}"}], ".."}], "}"}]}]}], "]"}], ":=",
   "\[IndentingNewLine]", 
  RowBox[{"Last", "[", 
   RowBox[{"Reap", "[", 
    RowBox[{
     RowBox[{"Scan", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Sow", "[", 
         RowBox[{"#", ",", "#"}], "]"}], "&"}], ",", "triangles"}], "]"}], 
     ",", 
     RowBox[{"Except", "[", "a", "]"}], ",", 
     RowBox[{
      RowBox[{"SortTriangularNeighbors", "[", 
       RowBox[{"a", ",", "##"}], "]"}], "&"}]}], "]"}], 
   "]"}]}]], "PackageInput"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SortTriangularNeighbors", "[", 
   RowBox[{"a_", ",", "b_", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"t1", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"a_", ",", "b_", ",", "_"}], "}"}], "|", 
         RowBox[{"{", 
          RowBox[{"_", ",", "a_", ",", "b_"}], "}"}], "|", 
         RowBox[{"{", 
          RowBox[{"b_", ",", "_", ",", "a_"}], "}"}]}], ")"}]}], ",", "t2_"}],
      "}"}]}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"a", ",", "t1", ",", "t2"}], "}"}]}], "\n", 
 RowBox[{
  RowBox[{"SortTriangularNeighbors", "[", 
   RowBox[{"a_", ",", "b_", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"t1", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"b_", ",", "a_", ",", "_"}], "}"}], "|", 
         RowBox[{"{", 
          RowBox[{"_", ",", "b_", ",", "a_"}], "}"}], "|", 
         RowBox[{"{", 
          RowBox[{"a_", ",", "_", ",", "b_"}], "}"}]}], ")"}]}], ",", "t2_"}],
      "}"}]}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"a", ",", "t2", ",", "t1"}], "}"}]}]}], "PackageInput"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"DualTesselate", "[", "\[IndentingNewLine]", 
    RowBox[{"GraphicsComplex", "[", 
     RowBox[{"vectors_List", ",", 
      RowBox[{"Polygon", "[", 
       RowBox[{"triangles", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_Integer", ",", "_Integer", ",", "_Integer"}], "}"}], 
          ".."}], "}"}]}], "]"}], ",", 
      RowBox[{"opts", ":", 
       RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], "\[IndentingNewLine]",
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"n", " ", "=", " ", 
        RowBox[{"Length", "[", "vectors", "]"}]}], ",", "dualVectorRules"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"dualVectorRules", "=", 
       RowBox[{"Dispatch", "[", 
        RowBox[{"MapIndexed", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", "\[Rule]", " ", 
             RowBox[{
              RowBox[{"First", "[", "#2", "]"}], "+", "n"}]}], ")"}], "&"}], 
          ",", "triangles"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"GraphicsComplex", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{"vectors", ",", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Normalize", "[", 
              RowBox[{"Plus", "@@", 
               RowBox[{
               "vectors", "\[LeftDoubleBracket]", "#", 
                "\[RightDoubleBracket]"}]}], "]"}], "&"}], ",", "triangles"}],
            "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Polygon", "[", 
         RowBox[{"Replace", "[", 
          RowBox[{
           RowBox[{"TriangularNeighborhoods", "[", "triangles", "]"}], ",", 
           "dualVectorRules", ",", 
           RowBox[{"{", "2", "}"}]}], "]"}], "]"}], ",", 
        "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell[" Dual Complex", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"VertexCycles", "[", "faces_List", "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Last", "[", 
   RowBox[{"Reap", "[", 
    RowBox[{
     RowBox[{"Scan", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Sow", "[", 
         RowBox[{"#", ",", "#"}], "]"}], "&"}], ",", "faces"}], "]"}], ",", 
     "_", ",", "VertexCycle"}], "]"}], "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"VertexCycle", "[", 
   RowBox[{"a_", ",", "faces_List"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"segmentRules", "=", 
      RowBox[{"Last", "[", 
       RowBox[{"Reap", "[", 
        RowBox[{
         RowBox[{"Scan", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Sow", "[", 
             RowBox[{"#", ",", "#"}], "]"}], "&"}], ",", "faces"}], "]"}], 
         ",", 
         RowBox[{"Except", "[", "a", "]"}], ",", 
         RowBox[{
          RowBox[{"VertexCycleSegment", "[", 
           RowBox[{"a", ",", "##"}], "]"}], "&"}]}], "]"}], "]"}]}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"NestList", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"#", "/.", "segmentRules"}], ")"}], "&"}], ",", 
      RowBox[{"segmentRules", "\[LeftDoubleBracket]", 
       RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"Length", "[", "segmentRules", "]"}], "-", "1"}]}], "]"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"VertexCycleSegment", "[", 
   RowBox[{"a_", ",", "b_", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"t1", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"___", ",", "a_", ",", "b_", ",", "___"}], "}"}], "|", 
         RowBox[{"{", 
          RowBox[{"b_", ",", "__", ",", "a_"}], "}"}]}], ")"}]}], ",", 
      "t2_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Rule", "[", 
   RowBox[{"t1", ",", "t2"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"VertexCycleSegment", "[", 
   RowBox[{"a_", ",", "b_", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"t1", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"___", ",", "b_", ",", "a_", ",", "___"}], "}"}], "|", 
         RowBox[{"{", 
          RowBox[{"a_", ",", "__", ",", "b_"}], "}"}]}], ")"}]}], ",", 
      "t2_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Rule", "[", 
   RowBox[{"t2", ",", "t1"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"VertexCycleSegment", "[", 
    RowBox[{"a_", ",", "b_", ",", 
     RowBox[{"{", 
      RowBox[{"{", "__", "}"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Sequence", "[", "]"}]}], ";"}]}], "PackageInput"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"DualComplex", "[", "\[IndentingNewLine]", 
    RowBox[{"GraphicsComplex", "[", 
     RowBox[{"vectors_List", ",", 
      RowBox[{"Polygon", "[", 
       RowBox[{"faces", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "__Integer", "}"}], ".."}], "}"}]}], "]"}], ",", 
      RowBox[{"opts", ":", 
       RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], "\[IndentingNewLine]",
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"n", " ", "=", " ", 
        RowBox[{"Length", "[", "vectors", "]"}]}], ",", "dualVectorRules"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"dualVectorRules", "=", 
       RowBox[{"Dispatch", "[", 
        RowBox[{"MapIndexed", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", "\[Rule]", " ", 
             RowBox[{"First", "[", "#2", "]"}]}], ")"}], "&"}], ",", 
          "faces"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"GraphicsComplex", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Normalize", "[", 
            RowBox[{"Plus", "@@", 
             RowBox[{
             "vectors", "\[LeftDoubleBracket]", "#", 
              "\[RightDoubleBracket]"}]}], "]"}], "&"}], ",", "faces"}], 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Polygon", "[", 
         RowBox[{"Replace", "[", 
          RowBox[{
           RowBox[{"VertexCycles", "[", "faces", "]"}], ",", 
           "dualVectorRules", ",", 
           RowBox[{"{", "2", "}"}]}], "]"}], "]"}], ",", 
        "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell[" Vertex Areas", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PolygonArea", "[", "vertices_List", "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"segements", "=", 
       RowBox[{"Partition", "[", 
        RowBox[{"vertices", ",", "2", ",", "1", ",", "1"}], "]"}]}], ",", 
      RowBox[{"center", " ", "=", " ", 
       RowBox[{"Normalize", "[", 
        RowBox[{"Total", "[", "vertices", "]"}], "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Total", "[", 
      RowBox[{"Map", "[", 
       RowBox[{"Norm", ",", 
        RowBox[{"Apply", "[", 
         RowBox[{"Cross", ",", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"#", "-", "center"}], ")"}], "&"}], ",", "segements", 
            ",", 
            RowBox[{"{", "2", "}"}]}], "]"}], ",", 
          RowBox[{"{", "1", "}"}]}], "]"}]}], "]"}], "]"}], "/", "2"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"VertexAreas", "[", "\[IndentingNewLine]", 
    RowBox[{"GraphicsComplex", "[", 
     RowBox[{"vectors_List", ",", 
      RowBox[{"Polygon", "[", 
       RowBox[{"faces", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "__Integer", "}"}], ".."}], "}"}]}], "]"}], ",", 
      RowBox[{"opts", ":", 
       RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], "\[IndentingNewLine]",
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"n", " ", "=", " ", 
        RowBox[{"Length", "[", "vectors", "]"}]}], ",", "dualVectorRules"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"dualVectorRules", "=", 
       RowBox[{"Dispatch", "[", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", "\[Rule]", " ", 
             RowBox[{"Normalize", "[", 
              RowBox[{"Total", "[", 
               RowBox[{
               "vectors", "\[LeftDoubleBracket]", "#", 
                "\[RightDoubleBracket]"}], "]"}], "]"}]}], ")"}], "&"}], ",", 
          "faces"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Map", "[", 
       RowBox[{"PolygonArea", ",", 
        RowBox[{"Replace", "[", 
         RowBox[{
          RowBox[{"VertexCycles", "[", "faces", "]"}], ",", "dualVectorRules",
           ",", 
          RowBox[{"{", "2", "}"}]}], "]"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Spherical Angels", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SphericalAngels", "[", 
   RowBox[{"GraphicsComplex", "[", 
    RowBox[{"vectors_List", ",", 
     RowBox[{"Polygon", "[", "triangels_List", "]"}], ",", 
     RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Arg", "[", 
      RowBox[{
       RowBox[{"vectors", "\[LeftDoubleBracket]", 
        RowBox[{"All", ",", "3"}], "\[RightDoubleBracket]"}], "+", 
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"Map", "[", 
         RowBox[{"Norm", ",", 
          RowBox[{"vectors", "\[LeftDoubleBracket]", 
           RowBox[{"All", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "2"}], "}"}]}], "\[RightDoubleBracket]"}]}], 
         "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Arg", "[", 
      RowBox[{
       RowBox[{"vectors", "\[LeftDoubleBracket]", 
        RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "+", 
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"vectors", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}]}]}], "]"}]}], 
    "\[IndentingNewLine]", "}"}], "]"}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Triangular Tesselate", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TriangularTesselateFunction", "[", "0", "]"}], " ", "=", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Vertex$", "[", "#1", "]"}], ",", 
      RowBox[{"Vertex$", "[", "#2", "]"}], ",", 
      RowBox[{"Vertex$", "[", "#3", "]"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TriangularTesselateFunction", "[", 
   RowBox[{"ord_Integer", "?", "Positive"}], "]"}], ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"TriangularTesselateFunction", "[", "ord", "]"}], "=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"indices", " ", "=", " ", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"i", ",", "j", ",", 
            RowBox[{"ord", "-", "i", "-", "j"}]}], "}"}], ".", 
          RowBox[{"TriangularTesselateFunction", "[", "0", "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "ord"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "0", ",", 
           RowBox[{"ord", "-", "i"}]}], "}"}]}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Join", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Outer", "[", 
        RowBox[{"Plus", ",", 
         RowBox[{"indices", "//", "Flatten"}], ",", 
         RowBox[{"TriangularTesselateFunction", "[", "0", "]"}], ",", "1"}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Outer", "[", 
        RowBox[{"Plus", ",", 
         RowBox[{
          RowBox[{"Rest", "[", "indices", "]"}], "//", "Flatten"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Vertex$", "[", "#3", "]"}], ",", 
           RowBox[{"Vertex$", "[", "#2", "]"}], ",", 
           RowBox[{
            RowBox[{"Vertex$", "[", "#2", "]"}], "+", 
            RowBox[{"Vertex$", "[", "#3", "]"}], "-", 
            RowBox[{"Vertex$", "[", "#1", "]"}]}]}], "}"}], ",", "1"}], 
        "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
    "]"}]}]}]}], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriangularTesselate", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"GraphicsComplex", "[", 
     RowBox[{"vectors_List", ",", 
      RowBox[{"Polygon", "[", "triangels_List", "]"}], ",", 
      RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"ord_Integer", "?", "Positive"}]}], "\[IndentingNewLine]", "]"}], 
  ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"newIndexPairs", ",", 
      RowBox[{"n", " ", "=", " ", 
       RowBox[{"Length", "[", "vectors", "]"}]}], ",", 
      RowBox[{"tesselate", "=", 
       RowBox[{
        RowBox[{"Evaluate", "[", 
         RowBox[{"TriangularTesselateFunction", "[", "ord", "]"}], "]"}], 
        "&"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"newTriangels", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{"Apply", "[", 
         RowBox[{"tesselate", ",", "triangels", ",", 
          RowBox[{"{", "1", "}"}]}], "]"}], ",", "1"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"newVertices", "=", 
      RowBox[{"Union", "[", 
       RowBox[{"Flatten", "[", "newTriangels", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"GraphicsComplex", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{"Normalize", ",", 
         RowBox[{"newVertices", "/.", " ", 
          RowBox[{
           RowBox[{"Vertex$", "[", "n_", "]"}], "\[RuleDelayed]", " ", 
           RowBox[{
           "vectors", "\[LeftDoubleBracket]", "n", 
            "\[RightDoubleBracket]"}]}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Polygon", "[", 
        RowBox[{"newTriangels", "/.", 
         RowBox[{"Dispatch", "[", 
          RowBox[{"MapIndexed", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"#1", "\[Rule]", " ", 
               RowBox[{"First", "[", "#2", "]"}]}], ")"}], "&"}], ",", 
            "newVertices"}], "]"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "PackageInput"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BalancingRules", "[", "1", "]"}], "=", 
    RowBox[{"{", "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BalancingRules", "[", "2", "]"}], "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Vertex$", "[", "b_", "]"}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
      RowBox[{
       RowBox[{"1.0858615683827177`", " ", 
        RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BalancingRules", "[", "3", "]"}], "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Vertex$", "[", "b_", "]"}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"1.1312435506880292`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Vertex$", "[", "a_", "]"}], "+", 
        RowBox[{"Vertex$", "[", "b_", "]"}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"1.0679419913043333`", " ", 
         RowBox[{"Vertex$", "[", "a", "]"}]}], "+", 
        RowBox[{"1.0679419913043333`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BalancingRules", "[", "4", "]"}], "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Vertex$", "[", "b_", "]"}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"1.159612058563206`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "b_", "]"}]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"2", " ", "1.0500456653876376`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Vertex$", "[", "a_", "]"}], "+", 
        RowBox[{"Vertex$", "[", "b_", "]"}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"1.1092032654023123`", " ", 
         RowBox[{"Vertex$", "[", "a", "]"}]}], "+", 
        RowBox[{"1.1092032654023123`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Vertex$", "[", "a_", "]"}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "b_", "]"}]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"1.0569979621981365`", " ", 
         RowBox[{"Vertex$", "[", "a", "]"}]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BalancingRules", "[", "5", "]"}], "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Vertex$", "[", "b_", "]"}], "+", 
        RowBox[{"5", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"1.1790886969862926`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"5", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "b_", "]"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"2", " ", "1.0848630641601036`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Vertex$", "[", "a_", "]"}], "+", 
        RowBox[{"Vertex$", "[", "b_", "]"}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"1.1371039124915192`", " ", 
         RowBox[{"Vertex$", "[", "a", "]"}]}], "+", 
        RowBox[{"1.1371039124915192`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Vertex$", "[", "a_", "]"}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "b_", "]"}]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"1.0945559999639352`", " ", 
         RowBox[{"Vertex$", "[", "a", "]"}]}], "+", 
        RowBox[{"2", " ", "1.0433273564827867`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BalancingRules", "[", "6", "]"}], "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Vertex$", "[", "b_", "]"}], "+", 
        RowBox[{"6", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"1.193307628481359`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"6", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "b_", "]"}]}], "+", 
        RowBox[{"5", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"2", " ", "1.1105774350715019`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"5", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "b_", "]"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"3", " ", "1.035382890602149`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Vertex$", "[", "a_", "]"}], "+", 
        RowBox[{"Vertex$", "[", "b_", "]"}], "+", 
        RowBox[{"5", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"1.1572858923237752`", " ", 
         RowBox[{"Vertex$", "[", "a", "]"}]}], "+", 
        RowBox[{"1.1572858923237752`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"5", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Vertex$", "[", "a_", "]"}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "b_", "]"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"1.121275988251519`", " ", 
         RowBox[{"Vertex$", "[", "a", "]"}]}], "+", 
        RowBox[{"2", " ", "1.0749655628681625`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Vertex$", "[", "a_", "]"}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "b_", "]"}]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"1.0834737406672839`", " ", 
         RowBox[{"Vertex$", "[", "a", "]"}]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "a_", "]"}]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "b_", "]"}]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"2", " ", "1.0385576766414544`", " ", 
         RowBox[{"Vertex$", "[", "a", "]"}]}], "+", 
        RowBox[{"2", " ", "1.0385576766414544`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BalancingRules", "[", "7", "]"}], "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Vertex$", "[", "b_", "]"}], "+", 
        RowBox[{"7", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"1.2041522924759`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"7", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "b_", "]"}]}], "+", 
        RowBox[{"6", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"2", " ", "1.1303817950664596`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"6", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "b_", "]"}]}], "+", 
        RowBox[{"5", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"3", " ", "1.0627900356246538`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"5", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Vertex$", "[", "a_", "]"}], "+", 
        RowBox[{"Vertex$", "[", "b_", "]"}], "+", 
        RowBox[{"6", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"1.1725851519248613`", " ", 
         RowBox[{"Vertex$", "[", "a", "]"}]}], "+", 
        RowBox[{"1.1725851519248613`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"6", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Vertex$", "[", "a_", "]"}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "b_", "]"}]}], "+", 
        RowBox[{"5", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"1.1413056150541134`", " ", 
         RowBox[{"Vertex$", "[", "a", "]"}]}], "+", 
        RowBox[{"2", " ", "1.0991641548014388`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"5", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Vertex$", "[", "a_", "]"}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "b_", "]"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"1.1089131007193087`", " ", 
         RowBox[{"Vertex$", "[", "a", "]"}]}], "+", 
        RowBox[{"3", " ", "1.031854526113556`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "a_", "]"}]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "b_", "]"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"2", " ", "1.067665644162049`", " ", 
         RowBox[{"Vertex$", "[", "a", "]"}]}], "+", 
        RowBox[{"2", " ", "1.067665644162049`", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Vertex$", "[", "a_", "]"}]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "b_", "]"}]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "c_", "]"}]}]}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"2", " ", "1.0347993783289484`", " ", 
         RowBox[{"Vertex$", "[", "a", "]"}]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "b", "]"}]}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"Vertex$", "[", "c", "]"}]}]}]}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BalancingRules", "[", "_", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}]}], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BalancedTriangularTesselate", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"GraphicsComplex", "[", 
     RowBox[{"vectors_List", ",", 
      RowBox[{"Polygon", "[", "triangels_List", "]"}], ",", 
      RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"ord_Integer", "?", "Positive"}]}], "\[IndentingNewLine]", "]"}], 
  ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"newIndexPairs", ",", 
      RowBox[{"n", " ", "=", " ", 
       RowBox[{"Length", "[", "vectors", "]"}]}], ",", 
      RowBox[{"tesselate", "=", 
       RowBox[{
        RowBox[{"Evaluate", "[", 
         RowBox[{"TriangularTesselateFunction", "[", "ord", "]"}], "]"}], 
        "&"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"newTriangels", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{"Apply", "[", 
         RowBox[{"tesselate", ",", "triangels", ",", 
          RowBox[{"{", "1", "}"}]}], "]"}], ",", "1"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"newVertices", "=", 
      RowBox[{"Union", "[", 
       RowBox[{"Flatten", "[", "newTriangels", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"GraphicsComplex", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{"Normalize", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"newVertices", "/.", 
            RowBox[{"BalancingRules", "[", "ord", "]"}]}], ")"}], "/.", " ", 
          RowBox[{
           RowBox[{"Vertex$", "[", "n_", "]"}], "\[RuleDelayed]", " ", 
           RowBox[{
           "vectors", "\[LeftDoubleBracket]", "n", 
            "\[RightDoubleBracket]"}]}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Polygon", "[", 
        RowBox[{"newTriangels", "/.", 
         RowBox[{"Dispatch", "[", 
          RowBox[{"MapIndexed", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"#1", "\[Rule]", " ", 
               RowBox[{"First", "[", "#2", "]"}]}], ")"}], "&"}], ",", 
            "newVertices"}], "]"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "PackageInput"]
}, Closed]],

Cell[CellGroupData[{

Cell["Triangulate", "Subsection"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"TriangulateFace", "[", 
    RowBox[{"face", ":", 
     RowBox[{"{", "__Integer", "}"}]}], "]"}], ":=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Prepend", "[", 
       RowBox[{"#", ",", "face"}], "]"}], "&"}], ",", 
     RowBox[{"Partition", "[", 
      RowBox[{"face", ",", "2", ",", "1", ",", "1"}], "]"}]}], 
    "]"}]}]}]], "PackageInput"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Triangulate", "[", "\[IndentingNewLine]", 
   RowBox[{"GraphicsComplex", "[", 
    RowBox[{"vectors_List", ",", 
     RowBox[{"Polygon", "[", 
      RowBox[{"faces", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "__Integer", "}"}], ".."}], "}"}]}], "]"}], ",", 
     RowBox[{"opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], "\[IndentingNewLine]", 
   "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"n", "=", 
       RowBox[{"Length", "[", "vectors", "]"}]}], ",", "centerVectorRules", 
      ",", 
      RowBox[{"polyangles", "=", 
       RowBox[{"DeleteCases", "[", 
        RowBox[{"faces", ",", 
         RowBox[{"{", 
          RowBox[{"_", ",", "_", ",", "_"}], "}"}]}], "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"centerVectorRules", "=", 
      RowBox[{"Dispatch", "[", 
       RowBox[{"MapIndexed", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"#1", "\[Rule]", " ", 
            RowBox[{
             RowBox[{"First", "[", "#2", "]"}], "+", "n"}]}], ")"}], "&"}], 
         ",", "polyangles"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"GraphicsComplex", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Join", "[", 
        RowBox[{"vectors", ",", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Normalize", "[", 
             RowBox[{"Plus", "@@", 
              RowBox[{
              "vectors", "\[LeftDoubleBracket]", "#", 
               "\[RightDoubleBracket]"}]}], "]"}], "&"}], ",", "polyangles"}],
           "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
        RowBox[{"Join", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Cases", "[", 
           RowBox[{"faces", ",", 
            RowBox[{"{", 
             RowBox[{"_", ",", "_", ",", "_"}], "}"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Replace", "[", 
           RowBox[{
            RowBox[{"Flatten", "[", 
             RowBox[{
              RowBox[{"Map", "[", 
               RowBox[{"TriangulateFace", ",", "polyangles"}], "]"}], ",", 
              "1"}], "]"}], ",", "centerVectorRules", ",", 
            RowBox[{"{", "2", "}"}]}], "]"}]}], "\[IndentingNewLine]", "]"}], 
        "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "opts"}], 
      "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "PackageInput"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "IcosahedralComplex", ",", "OctahedralComplex", ",", 
       "TetrahedralComplex", ",", "DualTesselate", ",", "DualComplex", ",", 
       "VertexAreas", ",", "TriangularTesselate", ",", 
       "BalancedTriangularTesselate", ",", "Triangulate", ",", 
       "SphericalAngels"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Protected", ",", " ", "ReadProtected"}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1267, 823},
WindowMargins->{{7, Automatic}, {Automatic, 0}},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 7, \
2010)",
StyleDefinitions->Notebook[{
   Cell[
    CellGroupData[{
      Cell["Style Definitions", "Subtitle"], 
      Cell[
      "Modify the definitions below to change the default appearance of all \
cells in a given style.  Make modifications to any definition using commands \
in the Format menu.", "Text"], 
      Cell[
       CellGroupData[{
         Cell["Style Environment Names", "Section"], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{12, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 9], 
         Cell[
          StyleData[All, "Presentation"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{24, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 12], 
         Cell[
          StyleData[All, "Condensed"], PageWidth -> WindowWidth, 
          CellLabelMargins -> {{8, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 8], 
         Cell[
          StyleData[All, "Printout"], PageWidth -> PaperWidth, 
          CellLabelMargins -> {{2, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 5, 
          PrivateFontOptions -> {"FontType" -> "Outline"}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Notebook Options", "Section"], 
         Cell[
         "The options defined for the style below will be used at the \
Notebook level.", "Text"], 
         Cell[
          StyleData["Notebook"], PageHeaders -> {{
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"], None, 
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"]}, {
             Cell[
              TextData[{
                ValueBox["FileName"]}], "Header"], None, 
             Cell[
              TextData[{
                CounterBox["Page"]}], "PageNumber"]}}, CellFrameLabelMargins -> 
          6, StyleMenuListing -> None]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headings", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Title"], CellMargins -> {{12, Inherited}, {20, 40}}, 
             CellGroupingRules -> {"TitleGrouping", 0}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LineSpacing -> {1, 11}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "Title", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subtitle", 0}, {"Subsubtitle", 0}}, FontFamily -> 
             "Helvetica", FontSize -> 36, FontWeight -> "Bold"], 
            Cell[
             StyleData["Title", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 40}}, LineSpacing -> {1, 0}, 
             FontSize -> 44], 
            Cell[
             StyleData["Title", "Condensed"], 
             CellMargins -> {{8, 10}, {4, 8}}, FontSize -> 20], 
            Cell[
             StyleData["Title", "Printout"], 
             CellMargins -> {{2, 10}, {12, 30}}, FontSize -> 24]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subtitle"], 
             CellMargins -> {{12, Inherited}, {20, 15}}, 
             CellGroupingRules -> {"TitleGrouping", 10}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subtitle", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}, {"Subsubtitle", 0}}, FontFamily -> "Helvetica", 
             FontSize -> 24], 
            Cell[
             StyleData["Subtitle", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 20}}, LineSpacing -> {1, 0}, 
             FontSize -> 36], 
            Cell[
             StyleData["Subtitle", "Condensed"], 
             CellMargins -> {{8, 10}, {4, 4}}, FontSize -> 14], 
            Cell[
             StyleData["Subtitle", "Printout"], 
             CellMargins -> {{2, 10}, {12, 8}}, FontSize -> 18]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubtitle"], 
             CellMargins -> {{12, Inherited}, {20, 15}}, 
             CellGroupingRules -> {"TitleGrouping", 20}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsubtitle", 
             CounterAssignments -> {{"Section", 0}, {"Equation", 0}, {
               "Figure", 0}}, FontFamily -> "Helvetica", FontSize -> 14, 
             FontSlant -> "Italic"], 
            Cell[
             StyleData["Subsubtitle", "Presentation"], 
             CellMargins -> {{24, 10}, {20, 20}}, LineSpacing -> {1, 0}, 
             FontSize -> 24], 
            Cell[
             StyleData["Subsubtitle", "Condensed"], 
             CellMargins -> {{8, 10}, {8, 8}}, FontSize -> 12], 
            Cell[
             StyleData["Subsubtitle", "Printout"], 
             CellMargins -> {{2, 10}, {12, 8}}, FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellDingbat -> "\[FilledSquare]", 
             CellMargins -> {{25, Inherited}, {8, 24}}, 
             CellGroupingRules -> {"SectionGrouping", 30}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LineSpacing -> {1, 7}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "Section", 
             CounterAssignments -> {{"Subsection", 0}, {"Subsubsection", 0}}, 
             FontFamily -> "Helvetica", FontSize -> 16, FontWeight -> "Bold"], 
            Cell[
             StyleData["Section", "Presentation"], 
             CellMargins -> {{40, 10}, {11, 32}}, LineSpacing -> {1, 0}, 
             FontSize -> 24], 
            Cell[
             StyleData["Section", "Condensed"], 
             CellMargins -> {{18, Inherited}, {6, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Section", "Printout"], 
             CellMargins -> {{13, 0}, {7, 22}}, FontSize -> 14]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> "\[FilledSmallSquare]", 
             CellMargins -> {{22, Inherited}, {8, 20}}, 
             CellGroupingRules -> {"SectionGrouping", 40}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsection", CounterAssignments -> {{"Subsubsection", 0}}, 
             FontFamily -> "Times", FontSize -> 14, FontWeight -> "Bold"], 
            Cell[
             StyleData["Subsection", "Presentation"], 
             CellMargins -> {{36, 10}, {11, 32}}, LineSpacing -> {1, 0}, 
             FontSize -> 22], 
            Cell[
             StyleData["Subsection", "Condensed"], 
             CellMargins -> {{16, Inherited}, {6, 12}}, FontSize -> 12], 
            Cell[
             StyleData["Subsection", "Printout"], 
             CellMargins -> {{9, 0}, {7, 22}}, FontSize -> 12]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsubsection"], CellDingbat -> 
             "\[FilledSmallSquare]", 
             CellMargins -> {{22, Inherited}, {8, 18}}, 
             CellGroupingRules -> {"SectionGrouping", 50}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             LanguageCategory -> "NaturalLanguage", CounterIncrements -> 
             "Subsubsection", FontFamily -> "Times", FontWeight -> "Bold"], 
            Cell[
             StyleData["Subsubsection", "Presentation"], 
             CellMargins -> {{34, 10}, {11, 26}}, LineSpacing -> {1, 0}, 
             FontSize -> 18], 
            Cell[
             StyleData["Subsubsection", "Condensed"], 
             CellMargins -> {{17, Inherited}, {6, 12}}, FontSize -> 10], 
            Cell[
             StyleData["Subsubsection", "Printout"], 
             CellMargins -> {{9, 0}, {7, 14}}, FontSize -> 11]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Body Text", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Text"], CellMargins -> {{12, 10}, {7, 7}}, 
             InputAutoReplacements -> {"TeX" -> StyleBox[
                 RowBox[{"T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "LaTeX" -> StyleBox[
                 RowBox[{"L", 
                   StyleBox[
                    AdjustmentBox[
                    "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                    BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
                   AdjustmentBox[
                   "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, 
                    BoxBaselineShift -> 0.5], "X"}]], "mma" -> "Mathematica", 
               "Mma" -> "Mathematica", "MMA" -> "Mathematica", Inherited}, 
             Hyphenation -> True, LineSpacing -> {1, 3}, CounterIncrements -> 
             "Text"], 
            Cell[
             StyleData["Text", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["Text", "Condensed"], CellMargins -> {{8, 10}, {6, 6}},
              LineSpacing -> {1, 1}, FontSize -> 11], 
            Cell[
             StyleData["Text", "Printout"], CellMargins -> {{2, 2}, {6, 6}}, 
             TextJustification -> 0.5, FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SmallText"], CellMargins -> {{12, 10}, {6, 6}}, 
             DefaultNewInlineCellStyle -> "None", Hyphenation -> True, 
             LineSpacing -> {1, 3}, LanguageCategory -> "NaturalLanguage", 
             CounterIncrements -> "SmallText", FontFamily -> "Helvetica", 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Presentation"], 
             CellMargins -> {{24, 10}, {8, 8}}, LineSpacing -> {1, 5}, 
             FontSize -> 12], 
            Cell[
             StyleData["SmallText", "Condensed"], 
             CellMargins -> {{8, 10}, {5, 5}}, LineSpacing -> {1, 2}, 
             FontSize -> 9], 
            Cell[
             StyleData["SmallText", "Printout"], 
             CellMargins -> {{2, 2}, {5, 5}}, TextJustification -> 0.5, 
             FontSize -> 7]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Input/Output", "Section"], 
         Cell[
         "The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names. Some attributes for these styles are actually set in FormatType Styles \
(in the last section of this stylesheet). ", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Input"], CellMargins -> {{45, 10}, {5, 7}}, 
             Evaluatable -> True, CellGroupingRules -> "InputGrouping", 
             CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, DefaultFormatType -> 
             DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
             FormatType -> InputForm, ShowStringCharacters -> True, 
             NumberMarks -> True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1},
              CounterIncrements -> "Input", FontWeight -> "Bold"], 
            Cell[
             StyleData["Input", "Presentation"], 
             CellMargins -> {{72, Inherited}, {8, 10}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["Input", "Condensed"], 
             CellMargins -> {{40, 10}, {2, 3}}, FontSize -> 11], 
            Cell[
             StyleData["Input", "Printout"], CellMargins -> {{39, 0}, {4, 6}},
              LinebreakAdjustments -> {0.85, 2, 10, 1, 1}, FontSize -> 9]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PackageInput"], CellMargins -> {{45, 10}, {5, 7}}, 
             Evaluatable -> True, CellGroupingRules -> "InputGrouping", 
             CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, InitializationCell -> True, 
             DefaultFormatType -> DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
             FormatType -> InputForm, ShowStringCharacters -> True, 
             NumberMarks -> True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1},
              CounterIncrements -> "Input", FontWeight -> "Bold", Background -> 
             RGBColor[0.500008, 1, 0.566644]], 
            Cell[
             StyleData["PackageInput", "Presentation"], 
             CellMargins -> {{72, Inherited}, {8, 10}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["PackageInput", "Condensed"], 
             CellMargins -> {{40, 10}, {2, 3}}, FontSize -> 11], 
            Cell[
             StyleData["PackageInput", "Printout"], 
             CellMargins -> {{39, 0}, {4, 6}}, 
             LinebreakAdjustments -> {0.85, 2, 10, 1, 1}, FontSize -> 9, 
             Background -> GrayLevel[1]]}, Closed]], 
         Cell[
          StyleData["InputOnly"], Evaluatable -> True, CellGroupingRules -> 
          "InputGrouping", CellHorizontalScrolling -> True, DefaultFormatType -> 
          DefaultInputFormatType, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
          FormatType -> InputForm, ShowStringCharacters -> True, NumberMarks -> 
          True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, 
          CounterIncrements -> "Input", StyleMenuListing -> None, FontWeight -> 
          "Bold"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Output"], CellMargins -> {{47, 10}, {7, 5}}, 
             CellEditDuplicate -> True, CellGroupingRules -> "OutputGrouping",
              CellHorizontalScrolling -> True, PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, DefaultFormatType -> 
             DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Output"], 
            Cell[
             StyleData["Output", "Presentation"], 
             CellMargins -> {{72, Inherited}, {10, 8}}, LineSpacing -> {1, 0},
              FontSize -> 16], 
            Cell[
             StyleData["Output", "Condensed"], 
             CellMargins -> {{41, Inherited}, {3, 2}}, FontSize -> 11], 
            Cell[
             StyleData["Output", "Printout"], 
             CellMargins -> {{39, 0}, {6, 4}}, FontSize -> 9]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Message"], 
             CellMargins -> {{45, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", PageBreakWithin -> False, 
             GroupPageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Message", StyleMenuListing -> 
             None, FontSize -> 11, FontColor -> RGBColor[0, 0, 1]], 
            Cell[
             StyleData["Message", "Presentation"], 
             CellMargins -> {{72, Inherited}, {Inherited, Inherited}}, 
             LineSpacing -> {1, 0}, FontSize -> 16], 
            Cell[
             StyleData["Message", "Condensed"], 
             CellMargins -> {{41, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 11], 
            Cell[
             StyleData["Message", "Printout"], 
             CellMargins -> {{39, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 7, FontColor -> GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Print"], 
             CellMargins -> {{45, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "OutputGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
             GeneratedCell -> True, CellAutoOverwrite -> True, ShowCellLabel -> 
             False, DefaultFormatType -> DefaultOutputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, 
             AutoItalicWords -> {}, LanguageCategory -> None, FormatType -> 
             InputForm, CounterIncrements -> "Print", StyleMenuListing -> 
             None], 
            Cell[
             StyleData["Print", "Presentation"], 
             CellMargins -> {{72, Inherited}, {Inherited, Inherited}}, 
             LineSpacing -> {1, 0}, FontSize -> 16], 
            Cell[
             StyleData["Print", "Condensed"], 
             CellMargins -> {{41, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 11], 
            Cell[
             StyleData["Print", "Printout"], 
             CellMargins -> {{39, Inherited}, {Inherited, Inherited}}, 
             FontSize -> 8]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Graphics"], 
             CellMargins -> {{4, Inherited}, {Inherited, Inherited}}, 
             CellGroupingRules -> "GraphicsGrouping", CellHorizontalScrolling -> 
             True, PageBreakWithin -> False, GeneratedCell -> True, 
             CellAutoOverwrite -> True, ShowCellLabel -> False, 
             DefaultFormatType -> DefaultOutputFormatType, LanguageCategory -> 
             None, FormatType -> InputForm, CounterIncrements -> "Graphics", 
             ImageMargins -> {{43, Inherited}, {Inherited, 0}}, 
             StyleMenuListing -> None, FontFamily -> "Courier", FontSize -> 
             10], 
            Cell[
             StyleData["Graphics", "Presentation"], 
             ImageMargins -> {{62, Inherited}, {Inherited, 0}}], 
            Cell[
             StyleData["Graphics", "Condensed"], 
             ImageMargins -> {{38, Inherited}, {Inherited, 0}}, Magnification -> 
             0.6], 
            Cell[
             StyleData["Graphics", "Printout"], 
             ImageMargins -> {{30, Inherited}, {Inherited, 0}}, Magnification -> 
             0.8]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["CellLabel"], LanguageCategory -> None, 
             StyleMenuListing -> None, FontFamily -> "Helvetica", FontSize -> 
             9, FontColor -> RGBColor[0, 0, 1]], 
            Cell[
             StyleData["CellLabel", "Presentation"], FontSize -> 12], 
            Cell[
             StyleData["CellLabel", "Condensed"], FontSize -> 9], 
            Cell[
             StyleData["CellLabel", "Printout"], FontFamily -> "Courier", 
             FontSize -> 8, FontSlant -> "Italic", FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Inline Formatting", "Section"], 
         Cell[
         "These styles are for modifying individual words or letters in a \
cell exclusive of the cell tag.", "Text"], 
         Cell[
          StyleData["RM"], StyleMenuListing -> None, FontWeight -> "Plain", 
          FontSlant -> "Plain"], 
         Cell[
          StyleData["BF"], StyleMenuListing -> None, FontWeight -> "Bold"], 
         Cell[
          StyleData["IT"], StyleMenuListing -> None, FontSlant -> "Italic"], 
         Cell[
          StyleData["TR"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["TI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["TB"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["TBI"], StyleMenuListing -> None, FontFamily -> "Times", 
          FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["MR"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["MO"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["MB"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["MBO"], 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           StyleMenuListing -> None, FontFamily -> "Courier", FontWeight -> 
          "Bold", FontSlant -> "Italic"], 
         Cell[
          StyleData["SR"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Plain"], 
         Cell[
          StyleData["SO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Plain", FontSlant -> "Italic"], 
         Cell[
          StyleData["SB"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Plain"], 
         Cell[
          StyleData["SBO"], StyleMenuListing -> None, FontFamily -> 
          "Helvetica", FontWeight -> "Bold", FontSlant -> "Italic"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["SO10"], StyleMenuListing -> None, FontFamily -> 
             "Helvetica", FontSize -> 10, FontWeight -> "Plain", FontSlant -> 
             "Italic"], 
            Cell[
             StyleData["SO10", "Printout"], StyleMenuListing -> None, 
             FontFamily -> "Helvetica", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"], 
            Cell[
             StyleData["SO10", "EnhancedPrintout"], StyleMenuListing -> None, 
             FontFamily -> "Futura", FontSize -> 7, FontWeight -> "Plain", 
             FontSlant -> "Italic"]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Formulas and Programming", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["InlineFormula"], CellMargins -> {{10, 4}, {0, 8}}, 
             CellHorizontalScrolling -> True, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", ScriptLevel -> 1, SingleLetterItalics -> True], 
            Cell[
             StyleData["InlineFormula", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["InlineFormula", "Condensed"], 
             CellMargins -> {{8, 10}, {6, 6}}, LineSpacing -> {1, 1}, 
             FontSize -> 11], 
            Cell[
             StyleData["InlineFormula", "Printout"], 
             CellMargins -> {{2, 0}, {6, 6}}, FontSize -> 10]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["DisplayFormula"], 
             CellMargins -> {{42, Inherited}, {Inherited, Inherited}}, 
             CellHorizontalScrolling -> True, DefaultFormatType -> 
             DefaultInputFormatType, 
             HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Continuation]"}, LanguageCategory -> 
             "Formula", ScriptLevel -> 0, SingleLetterItalics -> True, 
             UnderoverscriptBoxOptions -> {LimitsPositioning -> True}], 
            Cell[
             StyleData["DisplayFormula", "Presentation"], 
             LineSpacing -> {1, 5}, FontSize -> 16], 
            Cell[
             StyleData["DisplayFormula", "Condensed"], LineSpacing -> {1, 1}, 
             FontSize -> 11], 
            Cell[
             StyleData["DisplayFormula", "Printout"], FontSize -> 10]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Program"], CellFrame -> {{0, 0}, {0.5, 0.5}}, 
             CellMargins -> {{10, 4}, {0, 8}}, CellHorizontalScrolling -> 
             True, Hyphenation -> False, LanguageCategory -> "Formula", 
             ScriptLevel -> 1, FontFamily -> "Courier"], 
            Cell[
             StyleData["Program", "Presentation"], 
             CellMargins -> {{24, 10}, {10, 10}}, LineSpacing -> {1, 5}, 
             FontSize -> 16], 
            Cell[
             StyleData["Program", "Condensed"], 
             CellMargins -> {{8, 10}, {6, 6}}, LineSpacing -> {1, 1}, 
             FontSize -> 11], 
            Cell[
             StyleData["Program", "Printout"], 
             CellMargins -> {{2, 0}, {6, 6}}, FontSize -> 9]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Outline Styles", "Section"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline1"], CellMargins -> {{12, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 50}, 
             ParagraphIndent -> -38, CounterIncrements -> "Outline1", 
             FontSize -> 18, FontWeight -> "Bold", 
             CounterBoxOptions -> {CounterFunction :> CapitalRomanNumeral}], 
            Cell[
             StyleData["Outline1", "Printout"], 
             CounterBoxOptions -> {CounterFunction :> CapitalRomanNumeral}]}, 
           Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline2"], CellMargins -> {{59, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 60}, 
             ParagraphIndent -> -27, CounterIncrements -> "Outline2", 
             FontSize -> 15, FontWeight -> "Bold", 
             CounterBoxOptions -> {CounterFunction :> (Part[
                 CharacterRange["A", "Z"], #]& )}], 
            Cell[
             StyleData["Outline2", "Printout"], 
             CounterBoxOptions -> {CounterFunction :> (Part[
                 CharacterRange["A", "Z"], #]& )}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline3"], CellMargins -> {{108, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 70}, 
             ParagraphIndent -> -21, CounterIncrements -> "Outline3", 
             FontSize -> 12, 
             CounterBoxOptions -> {CounterFunction :> Identity}], 
            Cell[
             StyleData["Outline3", "Printout"], 
             CounterBoxOptions -> {CounterFunction :> Identity}]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Outline4"], CellMargins -> {{158, 10}, {7, 7}}, 
             CellGroupingRules -> {"SectionGrouping", 80}, 
             ParagraphIndent -> -18, CounterIncrements -> "Outline4", 
             FontSize -> 10, CounterBoxOptions -> {CounterFunction :> (Part[
                 CharacterRange["a", "z"], #]& )}], 
            Cell[
             StyleData["Outline4", "Printout"]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Hyperlink Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same Notebook, \
or between Notebooks.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Hyperlink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`NotebookLocate[#2]}]& ), ButtonNote -> 
               ButtonData}], 
            Cell[
             StyleData["Hyperlink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["Hyperlink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["Hyperlink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
         "The following styles are for linking automatically to the on-line \
help system.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["MainBookLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["MainBook", #]}]& )}], 
            Cell[
             StyleData["MainBookLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["MainBookLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["MainBookLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["AddOnsLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["AddOns", #]}]& )}], 
            Cell[
             StyleData["AddOnsLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["AddOnsLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["AddOnsLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["RefGuideLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, FontFamily -> "Courier", 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["RefGuide", #]}]& )}], 
            Cell[
             StyleData["RefGuideLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["RefGuideLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["RefGuideLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["GettingStartedLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["GettingStarted", #]}]& )}], 
            Cell[
             StyleData["GettingStartedLink", "Presentation"], FontSize -> 16], 
            Cell[
             StyleData["GettingStartedLink", "Condensed"], FontSize -> 11], 
            Cell[
             StyleData["GettingStartedLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["OtherInformationLink"], StyleMenuListing -> None, 
             ButtonStyleMenuListing -> Automatic, 
             FontVariations -> {"Underline" -> True}, FontColor -> 
             RGBColor[0, 0, 1], 
             ButtonBoxOptions -> {
              Active -> True, Appearance -> {Automatic, None}, 
               ButtonFunction :> (FrontEndExecute[{
                  FrontEnd`HelpBrowserLookup["OtherInformation", #]}]& )}], 
            Cell[
             StyleData["OtherInformationLink", "Presentation"], FontSize -> 
             16], 
            Cell[
             StyleData["OtherInformationLink", "Condensed"], FontSize -> 11], 
            
            Cell[
             StyleData["OtherInformationLink", "Printout"], FontSize -> 10, 
             FontVariations -> {"Underline" -> False}, FontColor -> 
             GrayLevel[0]]}, Closed]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Styles for Headers and Footers", "Section"], 
         Cell[
          StyleData["Header"], CellMargins -> {{0, 0}, {4, 1}}, 
          DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
          "NaturalLanguage", StyleMenuListing -> None, FontSize -> 10, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["Footer"], CellMargins -> {{0, 0}, {0, 4}}, 
          DefaultNewInlineCellStyle -> "None", LanguageCategory -> 
          "NaturalLanguage", StyleMenuListing -> None, FontSize -> 9, 
          FontSlant -> "Italic"], 
         Cell[
          StyleData["PageNumber"], CellMargins -> {{0, 0}, {4, 1}}, 
          StyleMenuListing -> None, FontFamily -> "Times", FontSize -> 10]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["Palette Styles", "Section"], 
         Cell[
         "The cells below define styles that define standard ButtonFunctions, \
for use in palette buttons.", "Text"], 
         Cell[
          StyleData["Paste"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, After]}]& )}], 
         Cell[
          StyleData["Evaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["EvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionMove[
                FrontEnd`InputNotebook[], All, Cell, 1], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluate"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluate[
                FrontEnd`InputNotebook[], All]}]& )}], 
         Cell[
          StyleData["CopyEvaluateCell"], StyleMenuListing -> None, 
          ButtonStyleMenuListing -> Automatic, 
          ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
               FrontEnd`SelectionCreateCell[
                FrontEnd`InputNotebook[], All], 
               FrontEnd`NotebookApply[
                FrontEnd`InputNotebook[], #, All], 
               FrontEnd`SelectionEvaluateCreateCell[
                FrontEnd`InputNotebook[], All]}]& )}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Placeholder Styles", "Section"], 
         Cell[
         "The cells below define styles useful for making placeholder objects \
in palette templates.", "Text"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Placeholder"], Placeholder -> True, StyleMenuListing -> 
             None, FontSlant -> "Italic", FontColor -> 
             RGBColor[0.890623, 0.864698, 0.384756], 
             TagBoxOptions -> {
              Editable -> False, Selectable -> False, StripWrapperBoxes -> 
               False}], 
            Cell[
             StyleData["Placeholder", "Presentation"]], 
            Cell[
             StyleData["Placeholder", "Condensed"]], 
            Cell[
             StyleData["Placeholder", "Printout"]]}, Closed]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["PrimaryPlaceholder"], StyleMenuListing -> None, 
             DrawHighlighted -> True, FontSlant -> "Italic", Background -> 
             RGBColor[0.912505, 0.891798, 0.507774], 
             TagBoxOptions -> {
              Editable -> False, Selectable -> False, StripWrapperBoxes -> 
               False}], 
            Cell[
             StyleData["PrimaryPlaceholder", "Presentation"]], 
            Cell[
             StyleData["PrimaryPlaceholder", "Condensed"]], 
            Cell[
             StyleData["PrimaryPlaceholder", "Printout"]]}, Closed]]}, 
        Closed]], 
      Cell[
       CellGroupData[{
         Cell["FormatType Styles", "Section"], 
         Cell[
         "The cells below define styles that are mixed in with the styles of \
most cells.  If a cell's FormatType matches the name of one of the styles \
defined below, then that style is applied between the cell's style and its \
own options. This is particularly true of Input and Output.", "Text"], 
         Cell[
          StyleData["CellExpression"], PageWidth -> Infinity, 
          CellMargins -> {{6, Inherited}, {Inherited, Inherited}}, 
          ShowCellLabel -> False, ShowSpecialCharacters -> False, 
          AllowInlineCells -> False, Hyphenation -> False, 
          AutoItalicWords -> {}, StyleMenuListing -> None, FontFamily -> 
          "Courier", FontSize -> 12, Background -> GrayLevel[1]], 
         Cell[
          StyleData["InputForm"], InputAutoReplacements -> {}, 
          AllowInlineCells -> False, Hyphenation -> False, StyleMenuListing -> 
          None, FontFamily -> "Courier"], 
         Cell[
          StyleData["OutputForm"], PageWidth -> Infinity, TextAlignment -> 
          Left, LineSpacing -> {0.6, 1}, StyleMenuListing -> None, FontFamily -> 
          "Courier"], 
         Cell[
          StyleData["StandardForm"], 
          InputAutoReplacements -> {
           "->" -> "\[Rule]", ":>" -> "\[RuleDelayed]", "<=" -> 
            "\[LessEqual]", ">=" -> "\[GreaterEqual]", "!=" -> "\[NotEqual]", 
            "==" -> "\[Equal]", Inherited}, LineSpacing -> {1.25, 0}, 
          StyleMenuListing -> None, FontFamily -> "Courier"], 
         Cell[
          StyleData["TraditionalForm"], 
          InputAutoReplacements -> {
           "->" -> "\[Rule]", ":>" -> "\[RuleDelayed]", "<=" -> 
            "\[LessEqual]", ">=" -> "\[GreaterEqual]", "!=" -> "\[NotEqual]", 
            "==" -> "\[Equal]", Inherited}, LineSpacing -> {1.25, 0}, 
          SingleLetterItalics -> True, TraditionalFunctionNotation -> True, 
          DelimiterMatching -> None, StyleMenuListing -> None], 
         Cell[
         "The style defined below is mixed in to any cell that is in an \
inline cell within another.", "Text"], 
         Cell[
          StyleData["InlineCell"], LanguageCategory -> "Formula", ScriptLevel -> 
          1, StyleMenuListing -> None], 
         Cell[
          StyleData["InlineCellEditing"], StyleMenuListing -> None, 
          Background -> RGBColor[1, 0.749996, 0.8]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell["Automatic Styles", "Section"], 
         Cell[
         "The cells below define styles that are used to affect the display \
of certain types of objects in typeset expressions.  For example, \
\"UnmatchedBracket\" style defines how unmatched bracket, curly bracket, and \
parenthesis characters are displayed (typically by coloring them to make them \
stand out).", "Text"], 
         Cell[
          StyleData["UnmatchedBracket"], StyleMenuListing -> None, FontColor -> 
          RGBColor[0.760006, 0.330007, 0.8]]}, Closed]]}, Open]]}, Visible -> 
  False, FrontEndVersion -> 
  "8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 38, 0, 144, "Title"],
Cell[608, 24, 80, 3, 96, "Subsubtitle"],
Cell[CellGroupData[{
Cell[713, 31, 25, 0, 72, "Section"],
Cell[741, 33, 959, 25, 436, "PackageInput"],
Cell[1703, 60, 128, 3, 58, "Text"],
Cell[1834, 65, 3401, 93, 1195, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5272, 163, 32, 0, 40, "Section"],
Cell[5307, 165, 135, 3, 62, "Text"],
Cell[5445, 170, 607, 15, 199, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[6089, 190, 42, 0, 72, "Section"],
Cell[6134, 192, 2035, 59, 544, "PackageInput",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[8206, 256, 31, 0, 72, "Section"],
Cell[8240, 258, 60, 0, 58, "Text"],
Cell[8303, 260, 108, 2, 90, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[8436, 266, 42, 0, 94, "Subsection"],
Cell[8481, 268, 6771, 182, 1705, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[15289, 455, 37, 0, 55, "Subsection"],
Cell[15329, 457, 637, 20, 193, "PackageInput"],
Cell[15969, 479, 709, 23, 190, "PackageInput"],
Cell[16681, 504, 1129, 34, 198, "PackageInput"],
Cell[17813, 540, 2111, 54, 760, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[19961, 599, 35, 0, 55, "Subsection"],
Cell[19999, 601, 399, 12, 193, "PackageInput"],
Cell[20401, 615, 1144, 31, 346, "PackageInput"],
Cell[21548, 648, 1218, 37, 252, "PackageInput"],
Cell[22769, 687, 1890, 49, 708, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[24696, 741, 35, 0, 55, "Subsection"],
Cell[24734, 743, 1053, 29, 231, "PackageInput"],
Cell[25790, 774, 1587, 42, 334, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[27414, 821, 38, 0, 55, "Subsection"],
Cell[27455, 823, 1252, 30, 231, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[28744, 858, 42, 0, 55, "Subsection"],
Cell[28789, 860, 2164, 55, 708, "PackageInput"],
Cell[30956, 917, 2196, 55, 765, "PackageInput"],
Cell[33155, 974, 13862, 371, 1753, "PackageInput"],
Cell[47020, 1347, 2321, 58, 510, "PackageInput"]
}, Closed]],
Cell[CellGroupData[{
Cell[49378, 1410, 33, 0, 55, "Subsection"],
Cell[49414, 1412, 420, 13, 93, "PackageInput"],
Cell[49837, 1427, 2645, 68, 648, "PackageInput"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[52531, 1501, 34, 0, 40, "Section"],
Cell[52568, 1503, 64, 0, 58, "Text"],
Cell[52635, 1505, 786, 18, 367, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
