(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     15526,        484]
NotebookOptionsPosition[     13811,        423]
NotebookOutlinePosition[     14232,        441]
CellTagsIndexPosition[     14189,        438]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Volume Rendering Package", "Title",
 CellChangeTimes->{{3.4888883669261436`*^9, 3.488888368185748*^9}}],

Cell["\<\
Markus van Almsick
Technische Universiteit Eindhoven
\[Copyright]2005\
\>", "Subsubtitle"],

Cell[CellGroupData[{

Cell["Prefix", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "TimeSamp", " ", "for", " ", "Package", " ", "Version", " ", "Control"}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Unprotect", "[", "TimeStamp", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TimeStamp", "::", "usage"}], "=", 
     "\"\<TimeStamp[context] should be set to a Date[]-List indicating the \
version of the corresponding package.\>\""}], ";"}], "\[IndentingNewLine]", 
   "\n", 
   RowBox[{
    RowBox[{
     RowBox[{
     "TimeStamp", "[", "\"\<MathVisionTools`VolumeRendering`\>\"", "]"}], " ",
      "=", " ", 
     RowBox[{"{", 
      RowBox[{"2005", ",", "3", ",", "25", ",", "23", ",", "30", ",", "0"}], 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Protect", "[", "TimeStamp", "]"}], ";"}]}]}]], "PackageInput"],

Cell["\<\
The preamble of the package containing all kinds of remarks about authorship, \
contence, and copyright.\
\>", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Name", ":", " ", "MathVisionTools`VolumeRendering`"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Author", ":", " ", 
     RowBox[{"Markus", " ", "van", " ", "Almsick"}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Email", " ", 
     RowBox[{"address", ":", " ", 
      RowBox[{"M", ".", "v", ".", 
       RowBox[{"Almsick", "@", "tue"}], ".", "nl"}]}]}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "MathVisionTools`VolumeRendering`"}]}], 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "1.1"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "5.1"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2005"}]}]}], ",", " ", 
    RowBox[{"Technische", " ", "Universiteit", " ", "Eindhoven"}]}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Title", ":", " ", "Padding"}]}], ",", " ", "Frame", ",", " ", 
    "Boundary"}], " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "This", " ", "package", " ", "implements", " ", "the", " ", "Maximum", 
      " ", "Intensity", " ", "Projection", " ", "for", " ", "3", "D", " ", 
      "data", " ", "sets"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Keywords", ":", " ", "MIP"}]}], ",", " ", 
    RowBox[{"Volume", " ", "Rendering"}], ",", " ", 
    RowBox[{"Maximum", " ", "Intensity", " ", "Projection"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Requirements", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Source", ":", " ", "None"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"History", ":", " ", 
      RowBox[{
      "Version", " ", "1.0", " ", "by", " ", "Markus", " ", "van", " ", 
       "Almsick"}]}]}], ",", " ", 
    RowBox[{"March", " ", "2005"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Limitations", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"Discussion", ":"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{":", 
    RowBox[{"To", " ", 
     RowBox[{"do", ":"}]}]}], " ", "*)"}]}]], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell["\<\
Declaring the package and unlocking all symbols defined in the code.\
\>", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeginPackage", "[", "\[IndentingNewLine]", 
   RowBox[{
   "\"\<MathVisionTools`VolumeRendering`\>\"", ",", 
    "\"\<MathVisionTools`ImageTransformation`\>\""}], "\[IndentingNewLine]", 
   "]"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{"Unprotect", "[", "\[IndentingNewLine]", 
  RowBox[{
  "IntensityProjection", ",", "\[IndentingNewLine]", 
   "MaximumIntensityProjection"}], "\[IndentingNewLine]", 
  "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Online Help and Options", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IntensityProjection", "::", "usage"}], "=", 
    "\"\<IntensityProjection[image,a] performs an intensity projection of a \
3D image dataset with a focal length of 1/a in units of dataset thickness in \
z-direction. The projection is a simple summation over the \
z-dimension.\>\""}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MaximumIntensityProjection", "::", "usage"}], "=", 
   "\"\<MaximumIntensityProjection[image,a] performs a maximum intensity \
projection of a 3D image dataset with a focal length of 1/a in units of \
dataset thickness in z-direction.\>\""}], ";"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Package Code", "Section"],

Cell["Starting the private context of the package.", "Text"],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "PackageInput",
 InitializationCell->True],

Cell[CellGroupData[{

Cell["Intensity Projection", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "IntensityProjection", "]"}], " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"ArrayInterpolation", "->", " ", "LinearInterpolation"}], "}"}]}],
   ";"}]], "PackageInput"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"IntensityProjection", "[", 
    RowBox[{
     RowBox[{"img_", "?", "ArrayQ"}], ",", 
     RowBox[{"opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Total", "[", "img", "]"}], "/;", " ", 
    RowBox[{
     RowBox[{"ArrayDepth", "[", "img", "]"}], " ", "===", "3"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"IntensityProjection", "[", 
    RowBox[{
     RowBox[{"img_", "?", "ArrayQ"}], ",", 
     RowBox[{"0", "|", "0.0"}], ",", 
     RowBox[{"opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Total", "[", "img", "]"}], "/;", " ", 
    RowBox[{
     RowBox[{"ArrayDepth", "[", "img", "]"}], " ", "===", "3"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IntensityProjection", "[", 
   RowBox[{
    RowBox[{"img_", "?", "ArrayQ"}], ",", 
    RowBox[{"a_", "?", "NumberQ"}], ",", 
    RowBox[{"opts___", "?", "OptionQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"y0", ",", "x0"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y0", ",", "x0"}], "}"}], "=", 
       RowBox[{"Floor", "[", 
        RowBox[{
         RowBox[{"Rest", "[", 
          RowBox[{"Dimensions", "[", "img", "]"}], "]"}], "/", "2"}], "]"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"Total", "[", 
       RowBox[{"PerspectiveTransformArray", "[", 
        RowBox[{"img", ",", 
         RowBox[{"{", 
          RowBox[{"x0", ",", 
           RowBox[{"1", "-", "a"}], ",", 
           RowBox[{"1", "+", "a"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"y0", ",", 
           RowBox[{"1", "-", "a"}], ",", 
           RowBox[{"1", "+", "a"}]}], "}"}], ",", "0", ",", 
         RowBox[{"ArrayInterpolation", "->", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"ArrayInterpolation", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "MaximumIntensityProjection", "]"}]}], 
           ")"}]}]}], "]"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], "/;", 
   " ", 
   RowBox[{
    RowBox[{"ArrayDepth", "[", "img", "]"}], " ", "===", 
    "3"}]}]}]}], "PackageInput",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Maximum Intensity Projection", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "MaximumIntensityProjection", "]"}], " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"ArrayInterpolation", "->", " ", "LinearInterpolation"}], "}"}]}],
   ";"}]], "PackageInput"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MaximumIntensityProjection", "[", 
    RowBox[{
     RowBox[{"img_", "?", "ArrayQ"}], ",", 
     RowBox[{"opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Map", "[", 
     RowBox[{"Max", ",", 
      RowBox[{"Transpose", "[", 
       RowBox[{"img", ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}], ",", 
      RowBox[{"{", "2", "}"}]}], "]"}], "/;", " ", 
    RowBox[{
     RowBox[{"ArrayDepth", "[", "img", "]"}], " ", "===", "3"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MaximumIntensityProjection", "[", 
    RowBox[{
     RowBox[{"img_", "?", "ArrayQ"}], ",", 
     RowBox[{"0", "|", "0.0"}], ",", 
     RowBox[{"opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Map", "[", 
     RowBox[{"Max", ",", 
      RowBox[{"Transpose", "[", 
       RowBox[{"img", ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}], ",", 
      RowBox[{"{", "2", "}"}]}], "]"}], "/;", " ", 
    RowBox[{
     RowBox[{"ArrayDepth", "[", "img", "]"}], " ", "===", "3"}]}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MaximumIntensityProjection", "[", 
   RowBox[{
    RowBox[{"img_", "?", "ArrayQ"}], ",", 
    RowBox[{"a_", "?", "NumberQ"}], ",", 
    RowBox[{"opts___", "?", "OptionQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"y0", ",", "x0"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"y0", ",", "x0"}], "}"}], "=", 
       RowBox[{"Floor", "[", 
        RowBox[{
         RowBox[{"Rest", "[", 
          RowBox[{"Dimensions", "[", "img", "]"}], "]"}], "/", "2"}], "]"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"Map", "[", 
       RowBox[{"Max", ",", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"PerspectiveTransformArray", "[", 
           RowBox[{"img", ",", 
            RowBox[{"{", 
             RowBox[{"x0", ",", 
              RowBox[{"1", "-", "a"}], ",", 
              RowBox[{"1", "+", "a"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"y0", ",", 
              RowBox[{"1", "-", "a"}], ",", 
              RowBox[{"1", "+", "a"}]}], "}"}], ",", "0", ",", 
            "\[IndentingNewLine]", 
            RowBox[{"ArrayInterpolation", "->", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"ArrayInterpolation", "/.", 
                RowBox[{"{", "opts", "}"}]}], "/.", 
               RowBox[{"Options", "[", "MaximumIntensityProjection", "]"}]}], 
              ")"}]}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", "2", "}"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}], "/;",
    " ", 
   RowBox[{
    RowBox[{"ArrayDepth", "[", "img", "]"}], " ", "===", 
    "3"}]}]}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Closing Package", "Section"],

Cell["Closing the package and locking all the symbols.", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"IntensityProjection", ",", "MaximumIntensityProjection"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Protected", ",", " ", "ReadProtected"}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"EndPackage", "[", "]"}]}], "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1172, 744},
WindowMargins->{{0, Automatic}, {Automatic, 5}},
ShowSelection->True,
Magnification->1.5,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (November 10, 2008)",
StyleDefinitions->"PackageNotebook.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 109, 1, 144, "Title"],
Cell[679, 25, 100, 4, 118, "Subsubtitle"],
Cell[CellGroupData[{
Cell[804, 33, 25, 0, 72, "Section"],
Cell[832, 35, 956, 25, 436, "PackageInput"],
Cell[1791, 62, 128, 3, 58, "Text"],
Cell[1922, 67, 3228, 88, 1126, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5187, 160, 32, 0, 40, "Section"],
Cell[5222, 162, 92, 2, 70, "Text"],
Cell[5317, 166, 493, 12, 336, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5847, 183, 42, 0, 40, "Section"],
Cell[5892, 185, 728, 15, 370, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6657, 205, 31, 0, 40, "Section"],
Cell[6691, 207, 60, 0, 39, "Text"],
Cell[6754, 209, 108, 2, 60, "PackageInput",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[6887, 215, 42, 0, 63, "Subsection"],
Cell[6932, 217, 230, 6, 60, "PackageInput"],
Cell[7165, 225, 2424, 68, 364, "PackageInput",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[9626, 298, 50, 0, 37, "Subsection"],
Cell[9679, 300, 237, 6, 60, "PackageInput"],
Cell[9919, 308, 3144, 87, 364, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[13112, 401, 34, 0, 40, "Section"],
Cell[13149, 403, 64, 0, 70, "Text"],
Cell[13216, 405, 567, 14, 336, "PackageInput",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
