(* Content-type: application/vnd.wolfram.cdf.text *)

(*** Wolfram CDF File ***)
(* http://www.wolfram.com/cdf *)

(* CreatedBy='Mathematica 9.0' *)

(*************************************************************************)
(*                                                                       *)
(*  The Mathematica License under which this file was created prohibits  *)
(*  restricting third parties in receipt of this file from republishing  *)
(*  or redistributing it by any means, including but not limited to      *)
(*  rights management or terms of use, without the express consent of    *)
(*  Wolfram Research, Inc. For additional information concerning CDF     *)
(*  licensing and redistribution see:                                    *)
(*                                                                       *)
(*        www.wolfram.com/cdf/adopting-cdf/licensing-options.html        *)
(*                                                                       *)
(*************************************************************************)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[      1063,         20]
NotebookDataLength[    256743,       6890]
NotebookOptionsPosition[    253418,       6777]
NotebookOutlinePosition[    253760,       6792]
CellTagsIndexPosition[    253717,       6789]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Init", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<Retina`\>\"", ",", 
    RowBox[{"{", "\"\<MathVisionTools`GaussianDerivative`\>\"", "}"}], ",", 
    RowBox[{"{", "\"\<MathVisionTools`DisplayFunctions`\>\"", "}"}]}], "]"}], 
  "\n", 
  RowBox[{"(*", 
   RowBox[{"BeginPackage", "[", 
    RowBox[{"\"\<Retina`\>\"", ",", 
     RowBox[{"{", "\"\<MathVisionTools`GaussianDerivative`\>\"", "}"}], ",", 
     RowBox[{"{", "\"\<MathVisionTools`DisplayFunctions`\>\"", "}"}], ",", 
     RowBox[{"{", "\"\<MathVisionCpp`\>\"", "}"}]}], "]"}], "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "@@", 
   RowBox[{"Names", "[", "\"\<Retina`*\>\"", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ClearAll", " ", "@@", 
   RowBox[{"Names", "[", "\"\<Retina`*\>\"", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"$HistoryLength", " ", "=", " ", "1"}], ";"}]}], "Code"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ClosingIm", "::", "usage"}], "=", 
   "\"\<ClosingIm[list, r] = Closing for matrices.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"CreateGMM", "::", "usage"}], "=", 
   "\"\<CreateGMM[k,data,i,(savename)] creates a Gaussian Mixture Model for \
the data with k gaussians and max i iterations.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"CreateMask", "::", "usage"}], "=", 
   "\"\<CCreateMask[im,(pt),(r)] creates a mask of the aperture.\\nUse an \
inverted colored retina image as input.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"CreateSamplematrix", "::", "usage"}], "=", 
   "\"\<CreateSamplematrix[im,classifier,mask] creates samplematrix used for \
segmenting images.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"CreateTrainingSamplematrix", "::", "usage"}], "=", 
   "\"\<Create samplematrix used for training.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"DeleteNoiseandElongation", "::", "usage"}], "=", 
   "\"\<DeleteNoiseandElongation[image,\[Sigma],compsize,elongation,cl] \
deletes noise and elongation in \\!\\(\\*\n\t\
StyleBox[\\\"image\\\",\\nFontSlant->\\\"Italic\\\"]\\). Noise is deleted \
using closing (scale \\!\\(\\*\n\t\
StyleBox[\\\"\[Sigma]\\\",\\nFontSlant->\\\"Italic\\\"]\\)) and the fraction \
(needs to be larger than \\!\\(\\*\n\t\
StyleBox[\\\"cl\\\",\\nFontSlant->\\\"Italic\\\"]\\) to be included) of \
pixelincrease. Structures smaller than \\!\\(\\*\n\t\
StyleBox[\\\"compsize\\\",\\nFontSlant->\\\"Italic\\\"]\\) need to be more \
elongated than \\!\\(\\*\n\t\
StyleBox[\\\"elongation\\\",\\nFontSlant->\\\"Italic\\\"]\\).\>\""}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"DeleteSmallStructures", "::", "usage"}], "=", 
   "\"\<DeleteSmallStructures[list,size] deletes small structures in \
\\!\\(\\*\n\tStyleBox[\\\"list\\\",\\nFontSlant->\\\"Italic\\\"]\\) smaller \
than \\!\\(\\*\n\t\
StyleBox[\\\"size\\\",\\nFontSlant->\\\"Italic\\\"]\\).\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Dilate", "::", "usage"}], "=", 
   "\"\<Dilate[list, r] = Dilation for matrices.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Erode", "::", "usage"}], "=", 
   "\"\<Erode[list, r] = Erosion for lists.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"FractalDimensionBoxcounting", "::", "usage"}], "=", 
   "\"\<FractalDimensionBoxcounting[list,point (opt.) ,radius \
(opt.),diskradius (opt.) ,extrainfo (opt.)] calculates the fractal dimension \
for \\!\\(\\*\n\tStyleBox[\\\"list\\\",\\nFontSlant->\\\"Italic\\\"]\\)\\!\\(\
\\* StyleBox[\\\" \\\",\\nFontSlant->\\\"Italic\\\"]\\)using the box-counting \
method and can also return the FD of a disk image centered on the center \
point \\!\\(\\*\nStyleBox[\\\"point\\\",\\nFontSlant->\\\"Italic\\\"]\\) with \
radius \\!\\(\\*\nStyleBox[\\\"radius\\\",\\nFontSlant->\\\"Italic\\\"]\\) \
and optionally discarding the optic disk with radius\\!\\(\\*\nStyleBox[\\\" \
\\\",\\nFontSlant->\\\"Italic\\\"]\\)\\!\\(\\*\n\
StyleBox[\\\"diskradius\\\",\\nFontSlant->\\\"Italic\\\"]\\). \\!\\(\\*\n\
StyleBox[\\\"Extrainfo\\\",\\nFontSlant->\\\"Italic\\\"]\\) is a boolean for \
additional information. \>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"FractalDimensionMass", "::", "usage"}], "=", 
   "\"\<FractalDimensionMass[\\!\\(\\*\n\t\
StyleBox[\\\"list\\\",\\nFontSlant->\\\"Italic\\\"]\\), \\!\\(\\*\n\t\
StyleBox[\\\"point\\\",\\nFontSlant->\\\"Italic\\\"]\\)] calculates the \
fractal dimension and image using the mass-radius method centered on \
\\!\\(\\*\n\tStyleBox[\\\"point\\\",\\nFontSlant->\\\"Italic\\\"]\\).\>\""}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"FractalDimensionMass2", "::", "usage"}], "=", "\"\<\>\""}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"FractalDimensionDilation", "::", "usage"}], "=", 
   "\"\<FractalDimensionDilation[list,r (=40: opt.),point (opt.) ,radius \
(opt.),diskradius (opt.) ,extrainfo (opt.)] calculates the fractal dimension \
for \\!\\(\\*\n\tStyleBox[\\\"list\\\",\\nFontSlant->\\\"Italic\\\"]\\)\\!\\(\
\\* StyleBox[\\\" \\\",\\nFontSlant->\\\"Italic\\\"]\\)using the dilation \
method with a maximum dilation of \\!\\(\\*\n\
StyleBox[\\\"r\\\",\\nFontSlant->\\\"Italic\\\"]\\) and can also return the \
FD of a disk image centered on the center point \\!\\(\\*\nStyleBox[\\\"point\
\\\",\\nFontSlant->\\\"Italic\\\"]\\) with radius \\!\\(\\*\n\
StyleBox[\\\"radius\\\",\\nFontSlant->\\\"Italic\\\"]\\) and optionally \
discarding the optic disk with radius\\!\\(\\*\nStyleBox[\\\" \
\\\",\\nFontSlant->\\\"Italic\\\"]\\)\\!\\(\\*\n\
StyleBox[\\\"diskradius\\\",\\nFontSlant->\\\"Italic\\\"]\\). \\!\\(\\*\n\
StyleBox[\\\"Extrainfo\\\",\\nFontSlant->\\\"Italic\\\"]\\) is a boolean for \
additional information. \>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"FractalDimensionCorrelation", "::", "usage"}], "=", 
   "\"\<FractalDimensionDilation[list,r (=40: opt.),point (opt.) ,radius \
(opt.),diskradius (opt.) ,extrainfo (opt.)] calculates the fractal dimension \
for \\!\\(\\*\n\tStyleBox[\\\"list\\\",\\nFontSlant->\\\"Italic\\\"]\\)\\!\\(\
\\* StyleBox[\\\" \\\",\\nFontSlant->\\\"Italic\\\"]\\)using the correlation \
method with a maximum dilation of \\!\\(\\*\n\
StyleBox[\\\"r\\\",\\nFontSlant->\\\"Italic\\\"]\\) and can also return the \
FD of a disk image centered on the center point \\!\\(\\*\nStyleBox[\\\"point\
\\\",\\nFontSlant->\\\"Italic\\\"]\\) with radius \\!\\(\\*\n\
StyleBox[\\\"radius\\\",\\nFontSlant->\\\"Italic\\\"]\\) and optionally \
discarding the optic disk with radius\\!\\(\\*\nStyleBox[\\\" \
\\\",\\nFontSlant->\\\"Italic\\\"]\\)\\!\\(\\*\n\
StyleBox[\\\"diskradius\\\",\\nFontSlant->\\\"Italic\\\"]\\). \\!\\(\\*\n\
StyleBox[\\\"Extrainfo\\\",\\nFontSlant->\\\"Italic\\\"]\\) is a boolean for \
additional information. \>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"FrangiVesselnessFilter", "::", "usage"}], "=", 
   "\"\<FrangiVesselnessFilter[data,\[Beta],\[Epsilon],\[Sigma]] calculates \
the vesselness with given parameters.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"FrangiVesselnessFilterMask", "::", "usage"}], "=", 
   "\"\<FrangiVesselnessFilter[data,\[Beta],\[Epsilon],\[Sigma]] calculates \
the vesselness with given parameters.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"FrangiVesselnessFilterS", "::", "usage"}], "=", 
   "\"\<FrangiVesselnessFilterS[data,\[Beta],\[Epsilon],\[Sigma],mask,size] \
calculates the vesselness with given parameters and adapting parameter \
S.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"VesselnessFilterCrossing", "::", "usage"}], "=", 
   "\"\<FrangiVesselnessFilter[data,\[Beta],\[Epsilon],\[Sigma]] calculates \
the vesselness with given parameters.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"GaborResponse", "::", "usage"}], "=", 
   "\"\<GaborResponse[list,a_Integer,\[Epsilon]_Integer,k_List,mask_List] \
calculates the gaborreponse for im and mask with the choosen \
parameters.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"GaborFilter", "::", "usage"}], "=", 
   "\"\<GaborFilter[a,\[Epsilon],k] calculates the filters that are used for \
the GaborResponse function.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"GaborFilterTranslated", "::", "usageTranslated"}], "=", 
   "\"\<GaborFilterTranslated[a,\[Epsilon],k] calculates the filters that are \
used for the GaborResponse function.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"H", "::", "usage"}], "=", 
   "\"\<H[\[Sigma]][im] calculates the Hessian matrix at scale \
\[Sigma]\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ImagePlot", "::", "usage"}], "=", 
   "\"\<ImagePlot[im] = RasterPlot with rescaled Epilog.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Initialize", "::", "usage"}], " ", "=", " ", 
   "\"\<Initialize[name] loads the green channel of a colored retina image, \
invert it and rescale it between 0 and 1.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"InitializeReference", "::", "usage"}], " ", "=", " ", 
   "\"\<InitializeReference[name] loads the image as a binary reference \
image.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"InitializeMask", "::", "usage"}], " ", "=", " ", 
   "\"\<InitializeMask[name] load a mask of the image.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ListToMatrix", "::", "usage"}], "=", 
   "\"\<ListToMatrix[list_,x_,y_] creates a x*y matrix from list.\>\""}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Load", "::", "usage"}], "=", 
   "\"\<Load[] loads an image using an open dialog window.\>\""}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"LoadMask", "::", "usage"}], "=", 
   "\"\<LoadMask[] loads a mask image using an open dialog window.\>\""}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"LoadReference", "::", "usage"}], "=", 
   "\"\<LoadReference[name] loads a reference image using an open dialog \
window.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"LoadTrainingSet", "::", "usage"}], "=", 
   "\"\<LoadTrainingSet[start,end,{gray,\[Sigma],lum,type}] loads the \
trainingset in range start:end, Gray = True/False, \[Sigma] = scales (List), \
lum is a boolean for luminance correction and type = Gabor/Vesselness.\>\""}],
   ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"LoadTrainingSetLarge", "::", "usage"}], "=", 
   "\"\<LoadTrainingSet[start,end,{gray,\[Sigma],lum,type}] loads the \
trainingset in range start:end, Gray = True/False, \[Sigma] = scales (List), \
lum is a boolean for luminance correction and type = Gabor/Vesselness.\>\""}],
   ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"LocalThresholding", "::", "usage"}], "=", 
   "\"\<LocalThresholding[im,\[Sigma],mask] thresholds im at scale \[Sigma] \
and multiplies with mask.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"LuminanceCorrection", "::", "usage"}], " ", "=", " ", 
   "\"\<LuminanceCoreection[im,\[Sigma]] corrects the image for uneven \
luminance. \[Sigma] represents the scale for the median filter.\>\""}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"MethodAccuracy", "::", "usage"}], "=", 
   "\"\<MethodAccuracy[image,mask,reference] calculates the [SPEC,SENS and \
ACC].\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpeningIm", "::", "usage"}], "=", 
   "\"\<OpeningIm[im,r] = Opening[im,DiskMatrix@r] for matrices.\>\""}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpticDisk", "::", "usage"}], "=", 
   "\"\<OpticDisk[\\!\\(\\*\n\
StyleBox[\\\"image\\\",\\nFontSlant->\\\"Italic\\\"]\\)\\!\\(\\*\nStyleBox[\\\
\",\\\",\\nFontSlant->\\\"Italic\\\"]\\)\\!\\(\\*\n\
StyleBox[\\\"Opt\\\",\\nFontSlant->\\\"Italic\\\"]\\)\\!\\(\\*\n\
StyleBox[\\\":\\\",\\nFontSlant->\\\"Italic\\\"]\\)\\!\\(\\*\n\
StyleBox[\\\"ImageSize\\\",\\nFontSlant->\\\"Italic\\\"]\\)] gives a \
locatorpane to determine size and position of the optic disk.\>\""}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"PadImage", "::", "usage"}], "=", 
   "\"\<PadImage[im_,nrofit_,mask_,es_,ps_] pads image (ps px) after eroding \
(es px) the original image and then enlarges the image (nrofit px).\>\""}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"PadImageOld", "::", "usage"}], "=", "\"\<\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"SegmentImage", "::", "usage"}], "=", 
   "\"\<SegmentImage[image,classifier,mask] segments an image using \
classifier and mask\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ShoujunVesselnessFilter", "::", "usage"}], "=", 
   "\"\<ShoujunVesselnessFilter[data,\[Sigma]] calculates the vesselness at \
scale \[Sigma].\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"UpdateStatus", "::", "usage"}], "=", 
   "\"\<updates the status of a calculation and stores it in variable \
message.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"V", "::", "usage"}], "=", 
   "\"\<V[\[Beta],\[Epsilon],\[Sigma]][im] calculates the vesselness with \
given parameters.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"VFast", "::", "usage"}], "=", 
   "\"\<Vesselness[\[Beta],\[Epsilon],\[Sigma]][im] calculates the vesselness \
with given parameters.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"VVFast", "::", "usage"}], "=", 
   "\"\<Vesselness[\[Beta],\[Epsilon],\[Sigma]][im] calculates the vesselness \
with given parameters.\>\""}], ";"}], "\n"}], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Code"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Load functions", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Initialize", "[", "name_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "Ifg", "}"}], ",", " ", 
     RowBox[{"(*", 
      RowBox[{"Load", ",", " ", 
       RowBox[{
       "rescale", " ", "and", " ", "invert", " ", "an", " ", "image"}]}], 
      "*)"}], "\n", "\t", 
     RowBox[{
      RowBox[{"Ifg", " ", "=", " ", 
       RowBox[{"Rescale", "[", 
        RowBox[{"1", "-", 
         RowBox[{"ImageData", "[", 
          RowBox[{"Import", "[", "name", "]"}], "]"}]}], "]"}]}], ";", "\n", 
      "\t", 
      RowBox[{"Rescale", "[", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "@", 
           RowBox[{"Dimensions", "[", "Ifg", "]"}]}], "==", "3"}], ",", 
         RowBox[{"Ifg", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}], ",", "Ifg"}], 
        "]"}], "]"}]}]}], "\n", "\t", "\n", "\t", 
    RowBox[{"(*", 
     RowBox[{"Rescale", "[", 
      RowBox[{"-", 
       RowBox[{
        RowBox[{"ImageData", "[", 
         RowBox[{"Import", "[", "name", "]"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}]}], "]"}], "*)"}],
     "\n", "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"InitializeMask", "[", "name_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", "\n", "\t", 
    RowBox[{"ImageData", "@", 
     RowBox[{"Binarize", "[", 
      RowBox[{"Import", "[", "name", "]"}], "]"}]}]}], "\n", "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"InitializeReference", "[", "name_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", "\n", "\t", 
    RowBox[{"ImageData", "@", 
     RowBox[{"Binarize", "[", 
      RowBox[{"Import", "[", "name", "]"}], "]"}]}]}], "\n", "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Load", ":=", 
   RowBox[{"Initialize", "[", 
    RowBox[{"SystemDialogInput", "[", 
     RowBox[{"\"\<FileOpen\>\"", ",", 
      RowBox[{"WindowTitle", "->", "\"\<Select an image to open\>\""}]}], 
     "]"}], "]"}]}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{
   "Load", " ", "an", " ", "image", " ", "with", " ", "a", " ", "windows", 
    " ", "open", " ", "folder"}], "*)"}], "\n", 
  RowBox[{"LoadMask", ":=", 
   RowBox[{"InitializeMask", "[", 
    RowBox[{"SystemDialogInput", "[", 
     RowBox[{"\"\<FileOpen\>\"", ",", 
      RowBox[{"WindowTitle", "->", "\"\<Select an image to open\>\""}]}], 
     "]"}], "]"}]}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{
   "Load", " ", "an", " ", "image", " ", "with", " ", "a", " ", "windows", 
    " ", "open", " ", "folder"}], "*)"}], "\n", 
  RowBox[{"LoadReference", ":=", 
   RowBox[{"InitializeReference", "[", 
    RowBox[{"SystemDialogInput", "[", 
     RowBox[{"\"\<FileOpen\>\"", ",", 
      RowBox[{"WindowTitle", "->", "\"\<Select an image to open\>\""}]}], 
     "]"}], "]"}]}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{
   "Load", " ", "an", " ", "image", " ", "with", " ", "a", " ", "windows", 
    " ", "open", " ", "folder"}], "*)"}]}]], "Code"]
}, Closed]],

Cell[CellGroupData[{

Cell["Create Mask", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CreateMask", "[", 
    RowBox[{"im_", ",", 
     RowBox[{"pt_:", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}], ",", 
     RowBox[{"r_:", "0"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", "y", ",", 
       RowBox[{"maskOD", "=", 
        RowBox[{"ConstantArray", "[", 
         RowBox[{"0", ",", 
          RowBox[{"Dimensions", "[", "im", "]"}]}], "]"}]}], ",", "im1", ",", 
       "coord", ",", "\[Theta]"}], "}"}], ",", "\n", "\t", 
     RowBox[{
      RowBox[{"UpdateStatus", "[", "\"\<Creating mask...\>\"", "]"}], ";", 
      "\n", "\t", 
      RowBox[{"(*", 
       RowBox[{
       "Binarize", " ", "an", " ", "image", " ", "using", " ", 
        "regionbinarize", " ", 
        RowBox[{"(", 
         RowBox[{
         "pad", " ", "image", " ", "to", " ", "make", " ", "sure", " ", 
          "both", " ", "left", " ", "and", " ", "right", " ", "background", 
          " ", "are", " ", "connected"}], " "}]}], "*)"}], "\n", "\t", 
      RowBox[{"mask", " ", "=", " ", 
       RowBox[{"Erode", "[", 
        RowBox[{
         RowBox[{"Rescale", "@", 
          RowBox[{"ArrayPad", "[", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"ImageData", "@", 
              RowBox[{"RegionBinarize", "[", 
               RowBox[{
                RowBox[{"Image", "@", 
                 RowBox[{"ArrayPad", "[", 
                  RowBox[{"im", ",", "4", ",", "1"}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"{", 
                  RowBox[{"50", ",", "50"}], "}"}], "}"}], ",", "0.05"}], 
               "]"}]}]}], ",", 
            RowBox[{"-", "4"}]}], "]"}]}], ",", "0"}], "]"}]}], ";", "\n", 
      "\t", "\n", "\t", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"r", ">", "0"}], ",", " ", 
        RowBox[{"(*", 
         RowBox[{
         "Make", " ", "a", " ", "correction", " ", "for", " ", "the", " ", 
          "optic", " ", "disk", " ", "by", " ", "creating", " ", "a", " ", 
          "diskmatrix", " ", "and", " ", "pad", " ", "it", " ", "to", " ", 
          "the", " ", "right", " ", 
          RowBox[{"position", "."}]}], "*)"}], "\n", "\t\t", 
        RowBox[{
         RowBox[{"maskOD", " ", "=", " ", 
          RowBox[{"ArrayPad", "[", 
           RowBox[{
            RowBox[{"RotateLeft", "[", 
             RowBox[{
              RowBox[{"DiskMatrix", "[", 
               RowBox[{"r", ",", 
                RowBox[{
                 RowBox[{"Dimensions", "[", "im", "]"}], "+", 
                 RowBox[{"2", "r"}]}]}], "]"}], ",", 
              RowBox[{"Round", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Dimensions", "[", "im", "]"}], "/", "2"}], "-", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"pt", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{"pt", "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}]}], "]"}], 
            ",", 
            RowBox[{"-", "r"}]}], "]"}]}], ";"}]}], "\n", "\t", "]"}], ";", 
      "\n", "\t", 
      RowBox[{"Round", "[", 
       RowBox[{"mask", "-", 
        RowBox[{"mask", "*", "maskOD"}]}], "]"}]}]}], " ", 
    RowBox[{"(*", 
     RowBox[{"mask", "*", "maskOD"}], " ", "*)"}], "\n", "]"}]}], 
  ";"}]], "Code"]
}, Closed]],

Cell[CellGroupData[{

Cell["Padding", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PadImageNew", "[", 
    RowBox[{
    "im_", ",", "nrofit_", ",", "maskim_", ",", "erodesize_", ",", 
     "paddingsize_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "kernel", ",", "d", ",", "impaddedflat", ",", "oldmask", ",", "dilmask",
        ",", "border", ",", "pos", ",", "replval", ",", "impadded"}], "}"}], 
     ",", "\n", "\t", 
     RowBox[{
      RowBox[{"UpdateStatus", "[", "\"\<Padding image...\>\"", "]"}], ";", 
      "\n", "\t", 
      RowBox[{"(*", 
       RowBox[{
       "Pad", " ", "image", " ", "by", " ", "calculating", " ", "the", " ", 
        "positions", " ", "just", " ", "around", " ", "the", " ", 
        RowBox[{"aperture", ".", " ", "Replace"}], " ", "these", " ", 
        "pixelvalues", " ", "by", " ", "the", " ", "average", " ", "of", " ", 
        "the", " ", "pixels", " ", "around", " ", "it", " ", "without", " ", 
        "taking", " ", "zeros", " ", "into", " ", 
        RowBox[{"account", "."}]}], "*)"}], "\n", "\t", 
      RowBox[{"d", " ", "=", " ", 
       RowBox[{
        RowBox[{"Dimensions", "[", "im", "]"}], "+", 
        RowBox[{"2", "*", "paddingsize"}]}]}], ";", "\n", "\t", 
      RowBox[{"kernel", " ", "=", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"d", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "-", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"-", 
           RowBox[{"d", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"d", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "+", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"-", "1"}], "}"}], ",", 
         RowBox[{"{", "0", "}"}], ",", 
         RowBox[{"{", "1", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"d", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "-", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"d", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"d", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "+", "1"}], "}"}]}], "}"}]}], ";",
       " ", 
      RowBox[{"(*", 
       RowBox[{"Surrounding", " ", "pixel", " ", "positions"}], "*)"}], "\n", 
      "\t", 
      RowBox[{"oldmask", " ", "=", " ", 
       RowBox[{"Erode", "[", 
        RowBox[{"maskim", ",", "erodesize"}], "]"}]}], ";", " ", 
      RowBox[{"(*", 
       RowBox[{"Old", " ", "mask"}], "*)"}], "\n", "\t", 
      RowBox[{"impadded", " ", "=", " ", 
       RowBox[{"Flatten", "@", 
        RowBox[{"ArrayPad", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"oldmask", "*", "im"}], ")"}], ",", "paddingsize"}], 
         "]"}]}]}], ";", " ", "\n", "\t", 
      RowBox[{"oldmask", "=", 
       RowBox[{"ArrayPad", "[", 
        RowBox[{"oldmask", ",", "paddingsize"}], "]"}]}], ";", "\n", "\n", 
      "\t", 
      RowBox[{"Table", "[", "\n", "\t\t", 
       RowBox[{
        RowBox[{
         RowBox[{"UpdateStatus", "[", 
          RowBox[{"\"\<Padding image...\>\"", "<>", 
           RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\< of \>\"", "<>", 
           " ", 
           RowBox[{"ToString", "[", "nrofit", "]"}]}], "]"}], ";", "\t", "\n",
          "\t\t", 
         RowBox[{"dilmask", " ", "=", 
          RowBox[{"Dilate", "[", 
           RowBox[{"oldmask", ",", "1"}], "]"}]}], ";", "\n", "\t\t", 
         RowBox[{"border", "=", " ", 
          RowBox[{"dilmask", " ", "-", " ", "oldmask"}]}], ";", " ", 
         RowBox[{"(*", 
          RowBox[{"Border", " ", "=", " ", 
           RowBox[{
            RowBox[{"dilated", " ", "mask"}], " ", "-", " ", 
            RowBox[{"old", " ", "mask"}]}]}], "*)"}], "\n", "\t\t", 
         RowBox[{"oldmask", " ", "=", " ", "dilmask"}], ";", "\n", "\t\t", 
         RowBox[{"pos", " ", "=", " ", 
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"Flatten", "@", "border"}], ",", "1."}], "]"}]}], ";", 
         " ", 
         RowBox[{"(*", 
          RowBox[{
          "Positions", " ", "of", " ", "the", " ", "border", " ", "around", 
           " ", "the", " ", 
           RowBox[{"aperture", "."}]}], "*)"}], "\n", "\t\t", 
         RowBox[{"replval", " ", "=", " ", 
          RowBox[{"Mean", "/@", 
           RowBox[{"DeleteCases", "[", 
            RowBox[{
             RowBox[{"Partition", "[", 
              RowBox[{
               RowBox[{"Chop", "[", 
                RowBox[{"Extract", "[", 
                 RowBox[{"impadded", ",", " ", 
                  RowBox[{"Flatten", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"kernel", "+", "#"}], "&"}], "/@", 
                    RowBox[{"pos", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ",", "1"}], 
                   "]"}]}], "]"}], "]"}], ",", "9"}], "]"}], ",", "0", ",", 
             RowBox[{"{", "2", "}"}]}], "]"}]}]}], ";", " ", 
         RowBox[{"(*", 
          RowBox[{
          "Replacement", " ", "values", " ", "for", " ", "every", " ", 
           "pixel", " ", "on", " ", "the", " ", "border"}], "*)"}], "\n", 
         "\t\t", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"impadded", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"pos", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}], "=", 
             RowBox[{"replval", "[", 
              RowBox[{"[", "i", "]"}], "]"}]}], ";"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "[", "pos", "]"}]}], "}"}]}], "]"}], ";"}], 
        "\n", "\t", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "nrofit"}], "}"}]}], "]"}], ";", "\n", 
      "\t", 
      RowBox[{"ListToMatrix", "[", 
       RowBox[{"impadded", ",", 
        RowBox[{"Dimensions", "[", "impadded", "]"}]}], "]"}]}]}], "\n", 
    "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PointAverage", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a_", ",", "b_"}], "}"}], ",", "kernel_", ",", "im_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"values", ",", "p"}], "}"}], ",", " ", 
     RowBox[{"(*", 
      RowBox[{
      "Calculate", " ", "the", " ", "average", " ", "of", " ", "the", " ", 
       "surrounding", " ", 
       RowBox[{"pixels", "."}]}], "*)"}], "\n", "\t", 
     RowBox[{
      RowBox[{"values", "=", 
       RowBox[{"Chop", "@", 
        RowBox[{"Extract", "[", 
         RowBox[{"im", ",", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"#", "+", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b"}], "}"}]}], "&"}], ",", "kernel", ",", 
            RowBox[{"{", "1", "}"}]}], "]"}]}], "]"}]}]}], ";", " ", 
      RowBox[{"(*", 
       RowBox[{
       "Extract", " ", "values", " ", "of", " ", "surrounding", " ", 
        "pixels"}], "*)"}], "\n", "\t", 
      RowBox[{"Mean", "[", 
       RowBox[{"DeleteCases", "[", 
        RowBox[{"values", ",", "0"}], "]"}], "]"}]}]}], " ", 
    RowBox[{"(*", 
     RowBox[{"Delete", " ", "zeros", " ", "and", " ", "take", " ", "mean"}], 
     "*)"}], "\n", "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PadImage2", "[", 
    RowBox[{
    "im_", ",", "nrofit_", ",", "maskim_", ",", "erodesize_", ",", 
     "paddingsize_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "kernel", ",", "oldmask", ",", "dilmask", ",", "border", ",", "pos", 
       ",", "replval", ",", "impadded"}], "}"}], ",", "\n", "\t", "\n", " ", 
     RowBox[{
      RowBox[{"UpdateStatus", "[", "\"\<Padding image...\>\"", "]"}], ";", 
      "\n", "  ", 
      RowBox[{"(*", 
       RowBox[{
       "Pad", " ", "image", " ", "by", " ", "calculating", " ", "the", " ", 
        "positions", " ", "just", " ", "around", " ", "the", " ", 
        RowBox[{"aperture", ".", " ", "Replace"}], " ", "these", " ", 
        "pixelvalues", " ", "by", " ", "the", " ", "average", " ", "of", " ", 
        "the", " ", "pixels", " ", "around", " ", "it", " ", "without", " ", 
        "taking", " ", "zeros", " ", "into", " ", 
        RowBox[{"account", "."}]}], "*)"}], "\n", "  \t", 
      RowBox[{"kernel", " ", "=", " ", 
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"x", ",", "y"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"x", ",", 
             RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"y", ",", 
             RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}], ",", "1"}], 
        "]"}]}], ";", " ", 
      RowBox[{"(*", 
       RowBox[{"Surrounding", " ", "pixel", " ", "positions"}], "*)"}], "\n", 
      "  \t", 
      RowBox[{"oldmask", " ", "=", " ", 
       RowBox[{"Erode", "[", 
        RowBox[{"maskim", ",", "erodesize"}], "]"}]}], ";", " ", 
      RowBox[{"(*", 
       RowBox[{"Old", " ", "mask"}], "*)"}], "\n", "  \t", 
      RowBox[{"impadded", " ", "=", " ", 
       RowBox[{"ArrayPad", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"oldmask", "*", "im"}], ")"}], ",", "paddingsize"}], 
        "]"}]}], ";", "\n", "  \t", 
      RowBox[{"oldmask", "=", 
       RowBox[{"ArrayPad", "[", 
        RowBox[{"oldmask", ",", "paddingsize"}], "]"}]}], ";", "\n", "  \t", 
      RowBox[{"Table", "[", "\n", "  \t\t", 
       RowBox[{
        RowBox[{
         RowBox[{"dilmask", " ", "=", 
          RowBox[{"Dilate", "[", 
           RowBox[{"oldmask", ",", "1"}], "]"}]}], ";", "\n", "  \t\t", 
         RowBox[{"border", " ", "=", " ", 
          RowBox[{"dilmask", " ", "-", " ", "oldmask"}]}], ";", " ", 
         RowBox[{"(*", 
          RowBox[{"Border", " ", "=", " ", 
           RowBox[{
            RowBox[{"dilated", " ", "mask"}], " ", "-", " ", 
            RowBox[{"old", " ", "mask"}]}]}], "*)"}], "\n", "  \t\t", 
         RowBox[{"oldmask", " ", "=", " ", "dilmask"}], ";", "\n", "  \t\t", 
         RowBox[{"pos", " ", "=", " ", 
          RowBox[{"Position", "[", 
           RowBox[{"border", ",", "1."}], "]"}]}], ";", " ", 
         RowBox[{"(*", 
          RowBox[{
          "Positions", " ", "of", " ", "the", " ", "border", " ", "around", 
           " ", "the", " ", 
           RowBox[{"aperture", "."}]}], "*)"}], "\n", "  \t\t", 
         RowBox[{"replval", " ", "=", " ", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"PointAverage", "[", 
              RowBox[{"#", ",", "kernel", ",", "impadded"}], "]"}], "&"}], 
            ",", "pos", ",", 
            RowBox[{"{", "1", "}"}]}], "]"}]}], ";", " ", 
         RowBox[{"(*", 
          RowBox[{
          "Replacement", " ", "values", " ", "for", " ", "every", " ", 
           "pixel", " ", "on", " ", "the", " ", "border"}], "*)"}], "\n", 
         "  \t\t", 
         RowBox[{"Table", "[", "\n", "  \t\t\t", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"impadded", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"pos", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"pos", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}], "=", 
             RowBox[{"replval", "[", 
              RowBox[{"[", "i", "]"}], "]"}]}], ";"}], " ", 
           RowBox[{"(*", 
            RowBox[{
            "Replace", " ", "values", " ", "for", " ", "pixels", " ", "on", 
             " ", "the", " ", "border"}], "*)"}], "\n", "  \t\t", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "[", "pos", "]"}]}], "}"}]}], "]"}], ";"}], 
        "\n", "  \t", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "nrofit"}], "}"}]}], "]"}], ";", "\n", 
      "  \t", "impadded"}]}], "\n", "\n", "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PadImage", "[", 
    RowBox[{
    "im_", ",", "nrofit_", ",", "maskim_", ",", "erodesize_", ",", 
     "paddingsize_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "kernel", ",", "oldmask", ",", "dilmask", ",", "border", ",", "pos", 
       ",", "replval", ",", "impadded"}], "}"}], ",", "\n", "\t", "\n", " ", 
     RowBox[{
      RowBox[{"UpdateStatus", "[", "\"\<Padding image...\>\"", "]"}], ";", 
      "\n", "  ", 
      RowBox[{"(*", 
       RowBox[{
       "Pad", " ", "image", " ", "by", " ", "calculating", " ", "the", " ", 
        "positions", " ", "just", " ", "around", " ", "the", " ", 
        RowBox[{"aperture", ".", " ", "Replace"}], " ", "these", " ", 
        "pixelvalues", " ", "by", " ", "the", " ", "average", " ", "of", " ", 
        "the", " ", "pixels", " ", "around", " ", "it", " ", "without", " ", 
        "taking", " ", "zeros", " ", "into", " ", 
        RowBox[{"account", "."}]}], "*)"}], "\n", "  \t", 
      RowBox[{"kernel", " ", "=", " ", 
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"x", ",", "y"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"x", ",", 
             RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"y", ",", 
             RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}], ",", "1"}], 
        "]"}]}], ";", " ", 
      RowBox[{"(*", 
       RowBox[{"Surrounding", " ", "pixel", " ", "positions"}], "*)"}], "\n", 
      "  \t", 
      RowBox[{"oldmask", " ", "=", " ", 
       RowBox[{"Erode", "[", 
        RowBox[{"maskim", ",", "erodesize"}], "]"}]}], ";", " ", 
      RowBox[{"(*", 
       RowBox[{"Old", " ", "mask"}], "*)"}], "\n", "  \t", 
      RowBox[{"impadded", " ", "=", " ", 
       RowBox[{"ArrayPad", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"oldmask", "*", "im"}], ")"}], ",", "paddingsize"}], 
        "]"}]}], ";", "\n", "  \t", 
      RowBox[{"oldmask", "=", 
       RowBox[{"ArrayPad", "[", 
        RowBox[{"oldmask", ",", "paddingsize"}], "]"}]}], ";", "\n", "  \t", 
      RowBox[{"Table", "[", "\n", "\t\t  ", 
       RowBox[{
        RowBox[{
         RowBox[{"UpdateStatus", "[", 
          RowBox[{"\"\<Padding image...\>\"", "<>", 
           RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\< of \>\"", "<>", 
           " ", 
           RowBox[{"ToString", "[", "nrofit", "]"}]}], "]"}], ";", "\t", "\n",
          "  \t\t", 
         RowBox[{"dilmask", " ", "=", 
          RowBox[{"Dilate", "[", 
           RowBox[{"oldmask", ",", "1"}], "]"}]}], ";", "\n", "  \t\t", 
         RowBox[{"border", " ", "=", " ", 
          RowBox[{"dilmask", " ", "-", " ", "oldmask"}]}], ";", " ", 
         RowBox[{"(*", 
          RowBox[{"Border", " ", "=", " ", 
           RowBox[{
            RowBox[{"dilated", " ", "mask"}], " ", "-", " ", 
            RowBox[{"old", " ", "mask"}]}]}], "*)"}], "\n", "  \t\t", 
         RowBox[{"oldmask", " ", "=", " ", "dilmask"}], ";", "\n", "  \t\t", 
         RowBox[{"pos", " ", "=", " ", 
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"Round", "@", "border"}], ",", "1"}], "]"}]}], ";", " ", 
         RowBox[{"(*", 
          RowBox[{
          "Positions", " ", "of", " ", "the", " ", "border", " ", "around", 
           " ", "the", " ", 
           RowBox[{"aperture", "."}]}], "*)"}], "\n", "  \t\t", 
         RowBox[{"replval", " ", "=", " ", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"PointAverage", "[", 
              RowBox[{"#", ",", "kernel", ",", "impadded"}], "]"}], "&"}], 
            ",", "pos", ",", 
            RowBox[{"{", "1", "}"}]}], "]"}]}], ";", " ", 
         RowBox[{"(*", 
          RowBox[{
          "Replacement", " ", "values", " ", "for", " ", "every", " ", 
           "pixel", " ", "on", " ", "the", " ", "border"}], "*)"}], "\n", 
         "  \t\t", 
         RowBox[{"Table", "[", "\n", "  \t\t\t", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"impadded", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{
                 RowBox[{"pos", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"pos", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}], "=", 
             RowBox[{"replval", "[", 
              RowBox[{"[", "i", "]"}], "]"}]}], ";"}], " ", 
           RowBox[{"(*", 
            RowBox[{
            "Replace", " ", "values", " ", "for", " ", "pixels", " ", "on", 
             " ", "the", " ", "border"}], "*)"}], "\n", "  \t\t", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "[", "pos", "]"}]}], "}"}]}], "]"}], ";"}], 
        "\n", "  \t", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "nrofit"}], "}"}]}], "]"}], ";", "\n", 
      "  \t", "impadded"}]}], "\n", "\n", "]"}]}], ";"}]], "Code"]
}, Closed]],

Cell[CellGroupData[{

Cell["Gabor-wavelet", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GaborResponse", "[", 
   RowBox[{
   "im_List", ",", "a_", ",", "\[Epsilon]_Integer", ",", "k_List", ",", 
    "mask_List"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"wvltsize", "=", 
       RowBox[{"Round", "[", 
        RowBox[{"10", "a"}], "]"}]}], ",", 
      RowBox[{"A", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Epsilon]", "^", 
          RowBox[{"-", "0.5"}]}], ",", "1"}], "}"}]}], ",", 
      RowBox[{"dim", "=", 
       RowBox[{
        RowBox[{"Dimensions", "[", "im", "]"}], "/", "2"}]}], ",", "padding", 
      ",", "x", ",", "x1", ",", "y", ",", "y1", ",", "wvlt", ",", "cwvlt", 
      ",", "fimg", ",", "fwvlt", ",", "fimgwv", ",", "imgwv", ",", "wvlts", 
      ",", "resp", ",", "gabor", ",", "xx", ",", "yy"}], "}"}], ",", "\n", 
    "\t", 
    RowBox[{
     RowBox[{"UpdateStatus", "[", 
      RowBox[{"\"\<Calculating Gabor response at scale \>\"", "<>", 
       RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<...\>\""}], "]"}], ";",
      "\n", "\t", 
     RowBox[{"padding", "=", " ", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Ceiling", "@", 
            RowBox[{"dim", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ",", 
           RowBox[{"Floor", "@", 
            RowBox[{"dim", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Ceiling", "@", 
            RowBox[{"dim", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ",", 
           RowBox[{"Floor", "@", 
            RowBox[{"dim", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}]}], "}"}]}], "}"}], "-", 
       "wvltsize"}]}], ";", "\n", "\t", 
     RowBox[{"x", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"N", "@", 
          RowBox[{"Range", "[", 
           RowBox[{
            RowBox[{"-", "wvltsize"}], ",", 
            RowBox[{"wvltsize", "-", "1"}]}], "]"}]}], "/", "a"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", "wvltsize"}], "}"}]}], "]"}]}], ";", "\n", "\t", 
     RowBox[{"y", "=", 
      RowBox[{"Transpose", "[", "x", "]"}]}], ";", "\n", "\t", 
     RowBox[{"fimg", " ", "=", " ", 
      RowBox[{"Fourier", "[", 
       RowBox[{"im", ",", 
        RowBox[{"FourierParameters", "->", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]}], "]"}]}], ";", "\n", "\t", 
     RowBox[{"gabor", " ", "=", " ", 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"I", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"k", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "xx"}], "+", 
           RowBox[{
            RowBox[{"k", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "yy"}]}], ")"}]}], "-", 
        RowBox[{"0.5", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"A", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "xx"}], ")"}], "^", "2"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"A", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "yy"}], ")"}], "^", "2"}]}], 
          ")"}]}]}], "]"}]}], ";", "\n", "\t", "\n", "\t", 
     RowBox[{"wvlts", " ", "=", " ", "\n", "\t\t", 
      RowBox[{"Table", "[", "\n", "\t\t\t", 
       RowBox[{
        RowBox[{
         RowBox[{"UpdateStatus", "[", 
          RowBox[{"\"\<Calculating Gabor response at scale \>\"", "<>", 
           RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\< - \>\"", "<>", 
           " ", 
           RowBox[{"ToString", "[", "\[Theta]", "]"}], "<>", 
           "\"\< Degree ...\>\""}], "]"}], ";", "\n", "\t\t\t", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x1", ",", "y1"}], "}"}], " ", "=", 
          RowBox[{"Apply", "[", 
           RowBox[{"Plus", ",", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"x", ",", 
                  RowBox[{"-", "y"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"x", ",", 
                  RowBox[{"-", "y"}]}], "}"}]}], "}"}], 
              RowBox[{"Transpose", "@", 
               RowBox[{"N", "@", 
                RowBox[{"RotationMatrix", "[", 
                 RowBox[{
                  RowBox[{"-", "\[Theta]"}], " ", "Degree"}], "]"}]}]}]}], 
             ")"}], ",", "1"}], "]"}]}], ";", "\n", "\t\t\t", 
         RowBox[{"wvlt", "=", 
          RowBox[{"gabor", "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xx", "->", "x1"}], ",", 
             RowBox[{"yy", "->", "y1"}]}], "}"}]}]}], ";", "\n", "\t\t\t", 
         RowBox[{"cwvlt", " ", "=", " ", 
          RowBox[{"ArrayPad", "[", 
           RowBox[{
            RowBox[{"Conjugate", "@", "wvlt"}], ",", "padding"}], "]"}]}], 
         ";", "\n", "\t\t\t", 
         RowBox[{"fwvlt", " ", "=", " ", 
          RowBox[{"Fourier", "[", 
           RowBox[{
            RowBox[{"RotateLeft", "[", 
             RowBox[{"cwvlt", ",", 
              RowBox[{"Ceiling", "[", 
               RowBox[{
                RowBox[{"Dimensions", "[", "cwvlt", "]"}], "/", "2"}], 
               "]"}]}], "]"}], ",", 
            RowBox[{"FourierParameters", "->", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}]}]}], "]"}]}], ";", "\n", 
         "\t\t\t", 
         RowBox[{"fimgwv", " ", "=", " ", 
          RowBox[{"fimg", " ", "*", " ", 
           RowBox[{"Conjugate", "[", "fwvlt", "]"}]}]}], ";", "\n", "\t\t\t", 
         RowBox[{"imgwv", " ", "=", " ", 
          RowBox[{"Abs", "[", 
           RowBox[{"InverseFourier", "[", 
            RowBox[{"fimgwv", ",", 
             RowBox[{"FourierParameters", "->", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1"}], "}"}]}]}], "]"}], "]"}]}]}], "\n", 
        "\t\t", ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "0", ",", "170", ",", "10"}], "}"}]}], 
       "]"}]}], ";", "\n", "\n", "\t", 
     RowBox[{
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{"Max", ",", 
         RowBox[{"Transpose", "[", 
          RowBox[{"wvlts", ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}], ",", 
         RowBox[{"{", "2", "}"}]}], "]"}], "/", "a"}], "*", "mask"}]}]}], 
   "\n", "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GaborFilter", "[", 
   RowBox[{"a_Integer", ",", "\[Epsilon]_Integer", ",", "k_List"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"wvltsize", "=", 
       RowBox[{"5", "a"}]}], ",", 
      RowBox[{"A", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Epsilon]", "^", 
          RowBox[{"-", "0.5"}]}], ",", "1"}], "}"}]}], ",", "x", ",", "x1", 
      ",", "y", ",", "y1", ",", "wvlt", ",", "cwvlt", ",", "fimg", ",", 
      "fwvlt", ",", "fimgwv", ",", "imgwv", ",", "wvlts", ",", "resp", ",", 
      "gabor", ",", "xx", ",", "yy"}], "}"}], ",", "\n", "\t", 
    RowBox[{
     RowBox[{"UpdateStatus", "[", 
      RowBox[{"\"\<Calculating Gabor response at scale \>\"", "<>", 
       RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<...\>\""}], "]"}], ";",
      "\n", "\t", 
     RowBox[{"x", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"N", "@", 
          RowBox[{"Range", "[", 
           RowBox[{
            RowBox[{"-", "wvltsize"}], ",", 
            RowBox[{"wvltsize", "-", "1"}]}], "]"}]}], "/", "a"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", "wvltsize"}], "}"}]}], "]"}]}], ";", "\n", "\t", 
     RowBox[{"y", "=", 
      RowBox[{"Transpose", "[", "x", "]"}]}], ";", "\n", "\t", "\n", "\t", 
     RowBox[{"gabor", " ", "=", " ", 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"I", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"k", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "xx"}], "+", 
           RowBox[{
            RowBox[{"k", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "yy"}]}], ")"}]}], "-", 
        RowBox[{"0.5", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"A", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "xx"}], ")"}], "^", "2"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"A", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "yy"}], ")"}], "^", "2"}]}], 
          ")"}]}]}], "]"}]}], ";", "\n", "\t", "\n", "\t", 
     RowBox[{"wvlts", " ", "=", " ", "\n", "\t\t", 
      RowBox[{"Table", "[", "\n", "\t\t\t", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x1", ",", "y1"}], "}"}], " ", "=", 
          RowBox[{"Apply", "[", 
           RowBox[{"Plus", ",", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"x", ",", 
                  RowBox[{"-", "y"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"x", ",", 
                  RowBox[{"-", "y"}]}], "}"}]}], "}"}], 
              RowBox[{"Transpose", "@", 
               RowBox[{"N", "@", 
                RowBox[{"RotationMatrix", "[", 
                 RowBox[{
                  RowBox[{"-", "\[Theta]"}], " ", "Degree"}], "]"}]}]}]}], 
             ")"}], ",", "1"}], "]"}]}], ";", "\n", "\t\t\t", 
         RowBox[{"wvlt", "=", 
          RowBox[{"gabor", "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"xx", "->", "x1"}], ",", 
             RowBox[{"yy", "->", "y1"}]}], "}"}]}]}], ";", "\n", "\t\t\t", 
         RowBox[{"Conjugate", "@", "wvlt"}]}], "\n", "\t\t", ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "0", ",", "170", ",", "10"}], "}"}]}], 
       "]"}]}], ";", "\n", "\t", "wvlts"}]}], "\n", "\t", "\n", 
   "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GaborFilterTranslated", "[", 
   RowBox[{
   "im_List", ",", "a_Integer", ",", "\[Epsilon]_Integer", ",", "k_List", ",", 
    RowBox[{"filter_:", "False"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"wvltsize", "=", 
       RowBox[{"5", "a"}]}], ",", 
      RowBox[{"A", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Epsilon]", "^", 
          RowBox[{"-", "0.5"}]}], ",", "1"}], "}"}]}], ",", "wvltpad", ",", 
      RowBox[{"dim", "=", 
       RowBox[{
        RowBox[{"Dimensions", "[", "im", "]"}], "/", "2"}]}], ",", "padding", 
      ",", "x", ",", "x1", ",", "y", ",", "y1", ",", "wvlt", ",", "cwvlt", 
      ",", "fimg", ",", "fwvlt", ",", "fimgwv", ",", "imgwv", ",", "wvlts", 
      ",", "resp", ",", "gabor", ",", "xx", ",", "yy", ",", "real", ",", 
      "imaginary", ",", "wvltsout"}], "}"}], ",", "\n", "\t", 
    RowBox[{
     RowBox[{"UpdateStatus", "[", 
      RowBox[{"\"\<Calculating Gabor translated response at scale \>\"", "<>", 
       RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\<...\>\""}], "]"}], ";",
      "\n", "\t", "\n", "\t", 
     RowBox[{"x", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"N", "@", 
          RowBox[{"Range", "[", 
           RowBox[{
            RowBox[{"-", "wvltsize"}], ",", 
            RowBox[{"wvltsize", "-", "1"}]}], "]"}]}], "/", "a"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", "wvltsize"}], "}"}]}], "]"}]}], ";", "\n", "\t", 
     RowBox[{"y", "=", 
      RowBox[{"Transpose", "[", "x", "]"}]}], ";", "\n", "\t", "\n", "\t", 
     RowBox[{"gabor", " ", "=", " ", 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"I", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"k", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "xx"}], "+", 
           RowBox[{
            RowBox[{"k", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "yy"}]}], ")"}]}], "-", 
        RowBox[{"0.5", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"A", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "xx"}], ")"}], "^", "2"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"A", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "yy"}], ")"}], "^", "2"}]}], 
          ")"}]}]}], "]"}]}], ";", "\n", "\t", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x1", ",", "y1"}], "}"}], " ", "=", 
      RowBox[{"Apply", "[", 
       RowBox[{"Plus", ",", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"x", ",", 
              RowBox[{"-", "y"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"x", ",", 
              RowBox[{"-", "y"}]}], "}"}]}], "}"}], 
          RowBox[{"Transpose", "@", 
           RowBox[{"N", "@", 
            RowBox[{"RotationMatrix", "[", 
             RowBox[{"0", " ", "Degree"}], "]"}]}]}]}], ")"}], ",", "1"}], 
       "]"}]}], ";", "\n", "\t", 
     RowBox[{"wvlt", "=", 
      RowBox[{"gabor", "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"xx", "->", "x1"}], ",", 
         RowBox[{"yy", "->", "y1"}]}], "}"}]}]}], ";", "\n", "\t", 
     RowBox[{"wvlt", " ", "=", " ", 
      RowBox[{"Conjugate", "@", "wvlt"}]}], ";", "\n", "\t", "\n", "\t", 
     RowBox[{"dim", " ", "=", " ", 
      RowBox[{"Dimensions", "[", "wvlt", "]"}]}], ";", "\n", "\t", 
     RowBox[{"wvlts", " ", "=", " ", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"real", " ", "=", " ", 
          RowBox[{
           RowBox[{"ImageRotate", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"ArrayPad", "[", 
                RowBox[{"wvlt", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Round", "[", 
                    RowBox[{"0.5", 
                    RowBox[{"First", "@", "dim"}]}], "]"}], ",", "0"}], 
                    "}"}]}], "}"}]}], "]"}], "//", "Re"}], "//", "Image"}], 
             ",", 
             RowBox[{"\[Theta]", " ", "Degree"}], ",", 
             RowBox[{"2", "dim"}]}], "]"}], "//", "ImageData"}]}], ";", "\n", 
         "\t", 
         RowBox[{"imaginary", " ", "=", " ", 
          RowBox[{
           RowBox[{"ImageRotate", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"ArrayPad", "[", 
                RowBox[{"wvlt", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Round", "[", 
                    RowBox[{"0.5", 
                    RowBox[{"First", "@", "dim"}]}], "]"}], ",", "0"}], 
                    "}"}]}], "}"}]}], "]"}], "//", "Im"}], "//", "Image"}], 
             ",", 
             RowBox[{"\[Theta]", " ", "Degree"}], ",", 
             RowBox[{"2", "dim"}]}], "]"}], "//", "ImageData"}]}], ";", "\n", 
         "\t", 
         RowBox[{"real", "+", "imaginary"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]", ",", "0", ",", "355", ",", "5"}], "}"}]}], 
       "]"}]}], ";", "\n", "\n", "\t", 
     RowBox[{"dim", "=", 
      RowBox[{
       RowBox[{"Dimensions", "[", "im", "]"}], "/", "2"}]}], ";", "\n", "\t", 
     RowBox[{"padding", "=", " ", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Ceiling", "@", 
            RowBox[{"dim", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ",", 
           RowBox[{"Floor", "@", 
            RowBox[{"dim", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Ceiling", "@", 
            RowBox[{"dim", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ",", 
           RowBox[{"Floor", "@", 
            RowBox[{"dim", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}]}], "}"}]}], "}"}], "-", 
       RowBox[{
        RowBox[{"Dimensions", "[", "wvlt", "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}]}]}], ";", "\t", "\n", "\t", 
     RowBox[{"fimg", " ", "=", " ", 
      RowBox[{"Fourier", "[", 
       RowBox[{"im", ",", 
        RowBox[{"FourierParameters", "->", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]}], "]"}]}], ";", "\n", "\n", "\t", 
     "\n", "\t", 
     RowBox[{"wvltsout", " ", "=", " ", "\n", "\t\t", 
      RowBox[{"Table", "[", "\n", "\t\t\t", 
       RowBox[{
        RowBox[{
         RowBox[{"UpdateStatus", "[", 
          RowBox[{"\"\<Calculating Gabor response at scale \>\"", "<>", 
           RowBox[{"ToString", "[", "a", "]"}], "<>", "\"\< - \>\"", "<>", 
           " ", 
           RowBox[{"ToString", "[", "\[Theta]", "]"}], "<>", 
           "\"\< Degree ...\>\""}], "]"}], ";", "\n", "\t\t\t", 
         RowBox[{"wvltpad", "=", 
          RowBox[{"ArrayPad", "[", 
           RowBox[{
            RowBox[{"Conjugate", "[", 
             RowBox[{"wvlts", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", "padding"}], 
           "]"}]}], ";", "\n", "\t\t\t", 
         RowBox[{"fwvlt", " ", "=", " ", 
          RowBox[{"Fourier", "[", 
           RowBox[{
            RowBox[{"RotateLeft", "[", 
             RowBox[{"wvltpad", ",", 
              RowBox[{"Ceiling", "[", 
               RowBox[{
                RowBox[{"Dimensions", "[", "wvltpad", "]"}], "/", "2"}], 
               "]"}]}], "]"}], ",", 
            RowBox[{"FourierParameters", "->", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}]}]}], "]"}]}], ";", "\n", 
         "\t\t\t", 
         RowBox[{"fimgwv", " ", "=", " ", 
          RowBox[{"fimg", " ", "*", " ", 
           RowBox[{"Conjugate", "[", "fwvlt", "]"}]}]}], ";", "\n", "\t\t\t", 
         RowBox[{"imgwv", " ", "=", " ", 
          RowBox[{
           RowBox[{"Abs", "[", 
            RowBox[{"InverseFourier", "[", 
             RowBox[{"fimgwv", ",", 
              RowBox[{"FourierParameters", "->", 
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}]}]}], "]"}], "]"}], "/", 
           "a"}]}]}], "\n", "\t\t", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "wvlts", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\n", "\t", "\n", 
     RowBox[{"If", "[", 
      RowBox[{"filter", ",", 
       RowBox[{"{", 
        RowBox[{"wvltsout", ",", "wvlts"}], "}"}], ",", "wvltsout"}], 
      "]"}]}]}], "\n", "\t", "\n", "]"}]}]], "Code"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Vesselness Filter", "Section"],

Cell[CellGroupData[{

Cell["Old", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"H", "[", "\[Sigma]_", "]"}], "[", "L_", "]"}], ":=", 
   RowBox[{"Transpose", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"GaussianDerivative", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"\[Sigma]", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Sigma]", ",", "0"}], "}"}]}], "]"}], "[", "L", "]"}], 
         ",", 
         RowBox[{"H12", "=", 
          RowBox[{
           RowBox[{"GaussianDerivative", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"\[Sigma]", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"\[Sigma]", ",", "1"}], "}"}]}], "]"}], "[", "L", 
           "]"}]}]}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"H12", ",", 
         RowBox[{
          RowBox[{"GaussianDerivative", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"\[Sigma]", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Sigma]", ",", "2"}], "}"}]}], "]"}], "[", "L", 
          "]"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "1", ",", "2"}], "}"}]}], "]"}]}], 
  ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Rb", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[Lambda]1", ",", "\[Lambda]2"}], "}"}], "\[Function]", 
    RowBox[{
     RowBox[{"Abs", "@", "\[Lambda]2"}], "/", 
     RowBox[{"Abs", "@", "\[Lambda]1"}]}]}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"S", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[Lambda]1", ",", "\[Lambda]2"}], "}"}], "\[Function]", 
    RowBox[{"Sqrt", "[", 
     RowBox[{
      RowBox[{"\[Lambda]1", "^", "2"}], "+", 
      RowBox[{"\[Lambda]2", "^", "2"}]}], "]"}]}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"V", "[", 
      RowBox[{"\[Beta]_", ",", "\[Epsilon]_", ",", "\[Sigma]_"}], "]"}], "[", 
     "im_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Lambda]1", ",", "\[Lambda]2", ",", "c"}], "}"}], ",", "\n", 
      "\t", 
      RowBox[{
       RowBox[{"UpdateStatus", "[", 
        RowBox[{"\"\<Calculating vesselness at scale \>\"", "<>", 
         RowBox[{"ToString", "[", "\[Sigma]", "]"}]}], "]"}], ";", "\n", "\t", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Lambda]1", ",", "\[Lambda]2"}], "}"}], "=", 
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"Map", "[", 
           RowBox[{"Eigenvalues", ",", 
            RowBox[{
             RowBox[{"H", "[", "\[Sigma]", "]"}], "[", "im", "]"}], ",", 
            RowBox[{"{", "2", "}"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "3", ",", "1"}], "}"}]}], "]"}]}], ";", "\n", 
       "\t", 
       RowBox[{"c", "=", 
        RowBox[{"\[Epsilon]", " ", 
         RowBox[{"Max", "@", 
          RowBox[{"S", "[", 
           RowBox[{"\[Lambda]1", ",", "\[Lambda]2"}], "]"}]}]}]}], ";", "\n", 
       "\t", 
       RowBox[{"MapThread", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"#1", ">=", "0"}], ",", "0", ",", 
            RowBox[{
             RowBox[{"Exp", "[", 
              RowBox[{"-", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Rb", "[", 
                   RowBox[{"#1", ",", "#2"}], "]"}], "^", "2"}], "/", 
                 RowBox[{"(", 
                  RowBox[{"2", 
                   RowBox[{"\[Beta]", "^", "2"}]}], ")"}]}], ")"}]}], "]"}], 
             "*", 
             RowBox[{"(", 
              RowBox[{"1", "-", 
               RowBox[{"Exp", "[", 
                RowBox[{"-", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"S", "[", 
                    RowBox[{"#1", ",", "#2"}], "]"}], "^", "2"}], "/", 
                   RowBox[{"(", 
                    RowBox[{"2", 
                    RowBox[{"c", "^", "2"}]}], ")"}]}], ")"}]}], "]"}]}], 
              ")"}]}]}], "]"}], "&"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Lambda]1", ",", "\[Lambda]2"}], "}"}], ",", "2"}], 
        "]"}]}]}], "\n", "]"}]}], ";"}], "\n"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"VFast", "[", 
     RowBox[{"\[Beta]_", ",", "\[Epsilon]_", ",", "\[Sigma]_"}], "]"}], "[", 
    "im_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "gd", ",", "evgd", ",", "x", ",", "evsort", ",", "evgdt", ",", "S", ",",
        "VV"}], "}"}], ",", "\n", "\t", 
     RowBox[{
      RowBox[{"UpdateStatus", "[", 
       RowBox[{"\"\<Calculating vesselness at \[Beta]= \>\"", "<>", 
        RowBox[{"ToString", "[", "\[Beta]", "]"}], "<>", 
        "\"\<, \[Epsilon]=\>\"", "<>", 
        RowBox[{"ToString", "[", "\[Epsilon]", "]"}], "<>", 
        "\"\< and \[Sigma]=\>\"", "<>", 
        RowBox[{"ToString", "[", "\[Sigma]", "]"}]}], "]"}], ";", "\n", "\t", 
      RowBox[{"gd", " ", "=", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Flatten", "@", 
          RowBox[{
           RowBox[{"GaussianDerivative", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"\[Sigma]", ",", "2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"\[Sigma]", ",", "0"}], "}"}]}], "]"}], "[", "im", 
           "]"}]}], ",", 
         RowBox[{"Flatten", "@", 
          RowBox[{
           RowBox[{"GaussianDerivative", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"\[Sigma]", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"\[Sigma]", ",", "1"}], "}"}]}], "]"}], "[", "im", 
           "]"}]}], ",", 
         RowBox[{"Flatten", "@", 
          RowBox[{
           RowBox[{"GaussianDerivative", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"\[Sigma]", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"\[Sigma]", ",", "2"}], "}"}]}], "]"}], "[", "im", 
           "]"}]}]}], "}"}]}], ";", "\n", "\t", 
      RowBox[{"Block", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"root", " ", "=", " ", 
           RowBox[{".5", 
            RowBox[{"Sqrt", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"gd", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "^", "2"}], "+", 
              RowBox[{"4", 
               RowBox[{
                RowBox[{"gd", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "^", "2"}]}], "-", 
              RowBox[{"2", 
               RowBox[{"gd", "[", 
                RowBox[{"[", "1", "]"}], "]"}], 
               RowBox[{"gd", "[", 
                RowBox[{"[", "3", "]"}], "]"}]}], "+", 
              RowBox[{
               RowBox[{"gd", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "^", "2"}]}], "]"}]}]}], ",", 
          RowBox[{"tmp", " ", "=", " ", 
           RowBox[{".5", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"gd", "[", 
               RowBox[{"[", "1", "]"}], "]"}], " ", "+", " ", 
              RowBox[{"gd", "[", 
               RowBox[{"[", "3", "]"}], "]"}]}], ")"}]}]}]}], "}"}], ",", 
        RowBox[{"evgd", " ", "=", " ", 
         RowBox[{"Re", "@", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"tmp", "-", "root"}], ")"}], ",", 
            RowBox[{"(", 
             RowBox[{"tmp", "+", "root"}], ")"}]}], "}"}]}]}]}], "]"}], ";", 
      "\n", "\t", 
      RowBox[{"x", "=", 
       RowBox[{
        RowBox[{"Positive", "[", 
         RowBox[{
          RowBox[{"Abs", "[", 
           RowBox[{"evgd", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "]"}], "-", 
          RowBox[{"Abs", "[", 
           RowBox[{"evgd", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"False", "->", 
           RowBox[{"-", "1"}]}], ",", 
          RowBox[{"True", "->", "1"}]}], "}"}]}]}], ";", "\n", "\t", 
      RowBox[{"evsort", " ", "=", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Extract", "[", 
          RowBox[{
           RowBox[{"evgdt", " ", "=", " ", 
            RowBox[{"Transpose", "@", "evgd"}]}], ",", " ", 
           RowBox[{"Transpose", "@", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Range", "@", 
               RowBox[{"Length", "[", "x", "]"}]}], ",", "x"}], "}"}]}]}], 
          "]"}], ",", 
         RowBox[{"Extract", "[", 
          RowBox[{"evgdt", ",", " ", 
           RowBox[{"Transpose", "@", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Range", "@", 
               RowBox[{"Length", "[", "x", "]"}]}], ",", 
              RowBox[{"-", "x"}]}], "}"}]}]}], "]"}]}], "}"}]}], ";", "\n", 
      "\t", 
      RowBox[{"Remove", "[", 
       RowBox[{"evgd", ",", "x", ",", "gd", ",", "evgdt"}], "]"}], ";", "\n", 
      "\t", 
      RowBox[{"S", " ", "=", " ", 
       RowBox[{"Sqrt", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"evsort", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "^", "2"}], "+", 
         RowBox[{
          RowBox[{"evsort", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "^", "2"}]}], "]"}]}], ";", "\n", 
      "\t", 
      RowBox[{"VV", " ", "=", " ", 
       RowBox[{"ListToMatrix", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Positive", "[", 
             RowBox[{"evsort", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "/.", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"True", "->", "0"}], ",", 
              RowBox[{"False", "->", "1"}]}], "}"}]}], ")"}], "*", 
          RowBox[{"Exp", "[", 
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"evsort", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "/", 
                 RowBox[{"evsort", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], ")"}], "^", "2"}], "/", 
              RowBox[{"(", 
               RowBox[{"2", 
                RowBox[{
                 RowBox[{"(", "\[Beta]", ")"}], "^", "2"}]}], ")"}]}], 
             ")"}]}], "]"}], 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"Exp", "[", 
             RowBox[{"-", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"S", "^", "2"}], "/", 
                RowBox[{"(", 
                 RowBox[{"2", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"\[Epsilon]", " ", "*", 
                    RowBox[{"Max", "@", "S"}]}], ")"}], "^", "2"}]}], ")"}]}],
                ")"}]}], "]"}]}], ")"}]}], ",", 
         RowBox[{"Dimensions", "[", "im", "]"}]}], "]"}]}]}]}], "\n", "]"}]}],
   ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VVFast", "[", 
    RowBox[{"\[Beta]_", ",", "\[Epsilon]_", ",", "\[Sigma]_"}], "]"}], "[", 
   "im_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "Lxx", ",", "Lxy", ",", "Lyy", ",", "ev", ",", "x", ",", "evgdt", ",", 
      "S", ",", "Lcomp", ",", "Vcomp"}], "}"}], ",", "\n", "\t", "\n", 
    RowBox[{"(*", 
     RowBox[{"Calculate", " ", "eigenvalues"}], "*)"}], "\n", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"\[Sigma]", ">", "2"}], ",", " ", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Lxx", ",", "Lxy", ",", "Lyy"}], "}"}], " ", "=", " ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Flatten", "@", 
           RowBox[{"GaussianFilter", "[", 
            RowBox[{"im", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "2"}], "}"}]}], "]"}]}], ",", 
          RowBox[{"Flatten", "@", 
           RowBox[{"GaussianFilter", "[", 
            RowBox[{"im", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}]}], "]"}]}], ",", 
          RowBox[{"Flatten", "@", 
           RowBox[{"GaussianFilter", "[", 
            RowBox[{"im", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}]}], "]"}]}]}], "}"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Lxx", ",", "Lxy", ",", "Lyy"}], "}"}], "=", " ", 
        RowBox[{"DerivativeFilter", "[", 
         RowBox[{"im", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}]}], "}"}], ",", "\[Sigma]"}], 
         "]"}]}]}], "]"}], ";", "\n", "\t", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"root", " ", "=", 
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"Lxx", "-", "Lyy"}], ")"}], "^", "2"}], "+", 
            RowBox[{"4", 
             RowBox[{"Lxy", "^", "2"}]}]}], "]"}]}], ",", 
         RowBox[{"tmp", " ", "=", " ", 
          RowBox[{"Lxx", " ", "+", " ", "Lyy"}]}]}], "}"}], ",", 
       RowBox[{"ev", " ", "=", " ", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"tmp", "-", "root"}], ")"}], ",", 
           RowBox[{"(", 
            RowBox[{"tmp", "+", "root"}], ")"}]}], "}"}], "/", "2"}]}]}], 
      "]"}], ";", "\n", "\n", 
     RowBox[{"(*", 
      RowBox[{"Sort", " ", "eigenvalues"}], "*)"}], "\n", "\t", 
     RowBox[{"x", "=", 
      RowBox[{"Sign", "[", 
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{"ev", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "]"}], "-", 
        RowBox[{"Abs", "[", 
         RowBox[{"ev", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}]}], " ", ";", "\n", 
     "\t", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Lambda]1", ",", "\[Lambda]2"}], "}"}], " ", "=", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Extract", "[", 
         RowBox[{
          RowBox[{"ev", " ", "=", " ", 
           RowBox[{"Transpose", "@", "ev"}]}], ",", " ", 
          RowBox[{"Transpose", "@", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Range", "@", 
              RowBox[{"Length", "[", "x", "]"}]}], ",", "x"}], "}"}]}]}], 
         "]"}], ",", 
        RowBox[{"Extract", "[", 
         RowBox[{"ev", ",", " ", 
          RowBox[{"Transpose", "@", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Range", "@", 
              RowBox[{"Length", "[", "x", "]"}]}], ",", 
             RowBox[{"-", "x"}]}], "}"}]}]}], "]"}]}], "}"}]}], ";", "\n", 
     "\n", 
     RowBox[{"(*", 
      RowBox[{"Calculate", " ", "vesselness"}], "*)"}], "\n", 
     RowBox[{"Vcomp", " ", "=", " ", 
      RowBox[{"Compile", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"ev1", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"ev2", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Beta]2", ",", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"S2", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"m", ",", "_Real"}], "}"}]}], "}"}], ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"Exp", "[", 
            RowBox[{"-", 
             RowBox[{"(", 
              RowBox[{"S2", "/", 
               RowBox[{"(", 
                RowBox[{"2", "m"}], ")"}]}], ")"}]}], "]"}]}], ")"}], 
         RowBox[{"Exp", "[", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"ev1", "/", "ev2"}], ")"}], "^", "2"}]}], "/", 
           RowBox[{"(", 
            RowBox[{"2", 
             RowBox[{
              RowBox[{"(", "\[Beta]2", ")"}], "^", "2"}]}], ")"}]}], 
          "]"}]}]}], "]"}]}], ";", "\n", "\t", 
     RowBox[{"S", " ", "=", " ", 
      RowBox[{
       RowBox[{"\[Lambda]1", "^", "2"}], "+", 
       RowBox[{"\[Lambda]2", "^", "2"}]}]}], ";", "\n", "\t", 
     RowBox[{
      RowBox[{"ListToMatrix", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"UnitStep", "[", 
          RowBox[{"-", "\[Lambda]2"}], "]"}], "*", 
         RowBox[{"Vcomp", "[", 
          RowBox[{
          "\[Lambda]1", ",", "\[Lambda]2", ",", "\[Beta]", ",", "S", ",", 
           RowBox[{"\[Epsilon]", " ", 
            RowBox[{"Max", "@", "S"}]}]}], "]"}]}], ",", 
        RowBox[{"Dimensions", "[", "im", "]"}]}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}]}]}], "\n", "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VVFastOld", "[", 
    RowBox[{"\[Beta]_", ",", "\[Epsilon]_", ",", "\[Sigma]_"}], "]"}], "[", 
   "im_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "L", ",", "evgd", ",", "x", ",", "evsort", ",", "evgdt", ",", "S", ",", 
      "Lcomp", ",", "Vcomp"}], "}"}], ",", "\n", "\t", 
    RowBox[{
     RowBox[{"UpdateStatus", "[", 
      RowBox[{"\"\<Calculating vesselness at \[Beta]= \>\"", "<>", 
       RowBox[{"ToString", "[", "\[Beta]", "]"}], "<>", 
       "\"\<, \[Epsilon]=\>\"", "<>", 
       RowBox[{"ToString", "[", "\[Epsilon]", "]"}], "<>", 
       "\"\< and \[Sigma]=\>\"", "<>", 
       RowBox[{"ToString", "[", "\[Sigma]", "]"}]}], "]"}], ";", "\n", "\n", 
     "\t", 
     RowBox[{"Lcomp", " ", "=", " ", 
      RowBox[{"Compile", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Lxx", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Lxy", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Lyy", ",", "_Real", ",", "1"}], "}"}]}], "}"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Lxx", "-", "Lyy"}], ")"}], "^", "2"}], "+", 
         RowBox[{"4", 
          RowBox[{"Lxy", "^", "2"}]}]}]}], "]"}]}], ";", "\t", "\n", "\t", 
     RowBox[{"Vcomp", " ", "=", " ", 
      RowBox[{"Compile", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"ev1", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"ev2", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Beta]2", ",", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"S2", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"m", ",", "_Real"}], "}"}]}], "}"}], ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"Exp", "[", 
            RowBox[{"-", 
             RowBox[{"(", 
              RowBox[{"S2", "/", 
               RowBox[{"(", 
                RowBox[{"2", "m"}], ")"}]}], ")"}]}], "]"}]}], ")"}], 
         RowBox[{"Exp", "[", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"ev1", "/", "ev2"}], ")"}], "^", "2"}]}], "/", 
           RowBox[{"(", 
            RowBox[{"2", 
             RowBox[{
              RowBox[{"(", "\[Beta]2", ")"}], "^", "2"}]}], ")"}]}], 
          "]"}]}]}], "]"}]}], ";", "\n", "\n", 
     RowBox[{"(*", 
      RowBox[{"Calculate", " ", "eigenvalues"}], "*)"}], "\n", "\t", 
     RowBox[{"L", " ", "=", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Flatten", "@", 
         RowBox[{"GaussianFilter", "[", 
          RowBox[{"im", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "2"}], "}"}]}], "]"}]}], ",", 
        RowBox[{"Flatten", "@", 
         RowBox[{"GaussianFilter", "[", 
          RowBox[{"im", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}]}], "]"}]}], ",", 
        RowBox[{"Flatten", "@", 
         RowBox[{"GaussianFilter", "[", 
          RowBox[{"im", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "0"}], "}"}]}], "]"}]}]}], "}"}]}], ";", "\n", 
     "\t", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"root", " ", "=", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"Lcomp", "[", 
            RowBox[{
             RowBox[{"L", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"L", "[", 
              RowBox[{"[", "2", "]"}], "]"}], ",", 
             RowBox[{"L", "[", 
              RowBox[{"[", "3", "]"}], "]"}]}], "]"}], "]"}]}], ",", 
         RowBox[{"tmp", " ", "=", " ", 
          RowBox[{
           RowBox[{"L", "[", 
            RowBox[{"[", "1", "]"}], "]"}], " ", "+", " ", 
           RowBox[{"L", "[", 
            RowBox[{"[", "3", "]"}], "]"}]}]}]}], "}"}], ",", 
       RowBox[{"evgd", " ", "=", " ", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"tmp", "-", "root"}], ")"}], ",", 
           RowBox[{"(", 
            RowBox[{"tmp", "+", "root"}], ")"}]}], "}"}], "/", "2"}]}]}], 
      "]"}], ";", "\n", "\n", 
     RowBox[{"(*", 
      RowBox[{"Sort", " ", "eigenvalues"}], "*)"}], "\n", "\t", 
     RowBox[{"x", "=", 
      RowBox[{"Sign", "[", 
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{"evgd", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "]"}], "-", 
        RowBox[{"Abs", "[", 
         RowBox[{"evgd", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}]}], " ", ";", "\n", 
     "\t", 
     RowBox[{"evsort", " ", "=", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Extract", "[", 
         RowBox[{
          RowBox[{"evgdt", " ", "=", " ", 
           RowBox[{"Transpose", "@", "evgd"}]}], ",", " ", 
          RowBox[{"Transpose", "@", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Range", "@", 
              RowBox[{"Length", "[", "x", "]"}]}], ",", "x"}], "}"}]}]}], 
         "]"}], ",", 
        RowBox[{"Extract", "[", 
         RowBox[{"evgdt", ",", " ", 
          RowBox[{"Transpose", "@", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Range", "@", 
              RowBox[{"Length", "[", "x", "]"}]}], ",", 
             RowBox[{"-", "x"}]}], "}"}]}]}], "]"}]}], "}"}]}], ";", "\n", 
     "\n", "\n", "\t", 
     RowBox[{"S", " ", "=", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"evsort", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "^", "2"}], "+", 
       RowBox[{
        RowBox[{"evsort", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "^", "2"}]}]}], ";", "\n", "\t", 
     RowBox[{"ListToMatrix", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"UnitStep", "[", 
         RowBox[{"-", 
          RowBox[{"evsort", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "*", 
        RowBox[{"Vcomp", "[", 
         RowBox[{
          RowBox[{"evsort", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"evsort", "[", 
           RowBox[{"[", "2", "]"}], "]"}], ",", "\[Beta]", ",", "S", ",", 
          RowBox[{"\[Epsilon]", " ", 
           RowBox[{"Max", "@", "S"}]}]}], "]"}]}], ",", 
       RowBox[{"Dimensions", "[", "im", "]"}]}], "]"}]}]}], "\n", 
   "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VVVVVFast", "[", 
    RowBox[{"\[Beta]_", ",", "\[Epsilon]_", ",", "\[Sigma]_"}], "]"}], "[", 
   "im_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "gd", ",", "evgd", ",", "x", ",", "evsort", ",", "evgdt", ",", "S", ",", 
      "comp1", ",", "comp2"}], "}"}], ",", "\n", "\t", 
    RowBox[{
     RowBox[{"UpdateStatus", "[", 
      RowBox[{"\"\<Calculating vesselness at \[Beta]= \>\"", "<>", 
       RowBox[{"ToString", "[", "\[Beta]", "]"}], "<>", 
       "\"\<, \[Epsilon]=\>\"", "<>", 
       RowBox[{"ToString", "[", "\[Epsilon]", "]"}], "<>", 
       "\"\< and \[Sigma]=\>\"", "<>", 
       RowBox[{"ToString", "[", "\[Sigma]", "]"}]}], "]"}], ";", "\n", "\n", 
     "\t", 
     RowBox[{"comp1", " ", "=", " ", 
      RowBox[{"Compile", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"gd1", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"gd2", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"gd3", ",", "_Real", ",", "1"}], "}"}]}], "}"}], ",", 
        RowBox[{
         RowBox[{"gd1", "^", "2"}], "+", 
         RowBox[{"4", 
          RowBox[{"gd2", "^", "2"}]}], "-", 
         RowBox[{"2", "gd1", "*", "gd3"}], "+", 
         RowBox[{"gd3", "^", "2"}]}]}], "]"}]}], ";", "\t", "\n", "\t", 
     RowBox[{"comp2", " ", "=", " ", 
      RowBox[{"Compile", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"ev1", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"ev2", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"\[Beta]2", ",", "_Real"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"S2", ",", "_Real", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"m", ",", "_Real"}], "}"}]}], "}"}], ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"Exp", "[", 
            RowBox[{"-", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"S2", "^", "2"}], "/", 
               RowBox[{"(", 
                RowBox[{"2", 
                 RowBox[{"m", "^", "2"}]}], ")"}]}], ")"}]}], "]"}]}], ")"}], 
         RowBox[{"Exp", "[", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"ev1", "/", "ev2"}], ")"}], "^", "2"}]}], "/", 
           RowBox[{"(", 
            RowBox[{"2", 
             RowBox[{
              RowBox[{"(", "\[Beta]2", ")"}], "^", "2"}]}], ")"}]}], 
          "]"}]}]}], "]"}]}], ";", "\n", "\n", "\t", 
     RowBox[{"gd", " ", "=", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Flatten", "@", 
         RowBox[{
          RowBox[{"GaussianDerivative", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"\[Sigma]", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Sigma]", ",", "0"}], "}"}]}], "]"}], "[", "im", 
          "]"}]}], ",", 
        RowBox[{"Flatten", "@", 
         RowBox[{
          RowBox[{"GaussianDerivative", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"\[Sigma]", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Sigma]", ",", "1"}], "}"}]}], "]"}], "[", "im", 
          "]"}]}], ",", 
        RowBox[{"Flatten", "@", 
         RowBox[{
          RowBox[{"GaussianDerivative", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"\[Sigma]", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Sigma]", ",", "2"}], "}"}]}], "]"}], "[", "im", 
          "]"}]}]}], "}"}]}], ";", "\n", "\t", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"gd", " ", "=", " ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Flatten", "@", 
           RowBox[{"GaussianFilter", "[", 
            RowBox[{"im", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "2"}], "}"}]}], "]"}]}], ",", 
          RowBox[{"Flatten", "@", 
           RowBox[{"GaussianFilter", "[", 
            RowBox[{"im", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}]}], "]"}]}], ",", 
          RowBox[{"Flatten", "@", 
           RowBox[{"GaussianFilter", "[", 
            RowBox[{"im", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", "0"}], "}"}]}], "]"}]}]}], "}"}]}], ";"}], 
      "*)"}], "\n", "\t", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"root", " ", "=", 
          RowBox[{
           RowBox[{"Sqrt", "[", 
            RowBox[{"comp1", "[", 
             RowBox[{
              RowBox[{"gd", "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{"gd", "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", 
              RowBox[{"gd", "[", 
               RowBox[{"[", "3", "]"}], "]"}]}], "]"}], "]"}], "/", "2"}]}], 
         ",", 
         RowBox[{"tmp", " ", "=", " ", 
          RowBox[{".5", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"gd", "[", 
              RowBox[{"[", "1", "]"}], "]"}], " ", "+", " ", 
             RowBox[{"gd", "[", 
              RowBox[{"[", "3", "]"}], "]"}]}], ")"}]}]}]}], "}"}], ",", 
       RowBox[{"evgd", " ", "=", " ", 
        RowBox[{"Re", "@", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"tmp", "-", "root"}], ")"}], ",", 
           RowBox[{"(", 
            RowBox[{"tmp", "+", "root"}], ")"}]}], "}"}]}]}]}], "]"}], ";", 
     "\n", "\t", 
     RowBox[{"x", "=", 
      RowBox[{"Sign", "[", 
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{"evgd", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "]"}], "-", 
        RowBox[{"Abs", "[", 
         RowBox[{"evgd", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}]}], " ", ";", "\n", 
     "\t", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Count", "[", 
         RowBox[{"x", ",", "0"}], "]"}], "!=", "0"}], ",", 
       RowBox[{"x", " ", "=", " ", 
        RowBox[{"x", " ", "/.", " ", 
         RowBox[{"0", "->", "1"}]}]}]}], "]"}], ";", "\n", "\t", 
     RowBox[{"evsort", " ", "=", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Extract", "[", 
         RowBox[{
          RowBox[{"evgdt", " ", "=", " ", 
           RowBox[{"Transpose", "@", "evgd"}]}], ",", " ", 
          RowBox[{"Transpose", "@", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Range", "@", 
              RowBox[{"Length", "[", "x", "]"}]}], ",", "x"}], "}"}]}]}], 
         "]"}], ",", 
        RowBox[{"Extract", "[", 
         RowBox[{"evgdt", ",", " ", 
          RowBox[{"Transpose", "@", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Range", "@", 
              RowBox[{"Length", "[", "x", "]"}]}], ",", 
             RowBox[{"-", "x"}]}], "}"}]}]}], "]"}]}], "}"}]}], ";", "\n", 
     "\t", 
     RowBox[{"Remove", "[", 
      RowBox[{"x", ",", "gd", ",", "evgdt"}], "]"}], ";", "\n", "\t", 
     RowBox[{"S", " ", "=", " ", 
      RowBox[{"Sqrt", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"evsort", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "^", "2"}], "+", 
        RowBox[{
         RowBox[{"evsort", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "^", "2"}]}], "]"}]}], ";", "\n", 
     "\t", 
     RowBox[{"ListToMatrix", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"UnitStep", "[", 
         RowBox[{"-", 
          RowBox[{"evsort", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "*", 
        RowBox[{"comp2", "[", 
         RowBox[{
          RowBox[{"evsort", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"evsort", "[", 
           RowBox[{"[", "2", "]"}], "]"}], ",", "\[Beta]", ",", "S", ",", 
          RowBox[{"\[Epsilon]", " ", 
           RowBox[{"Max", "@", "S"}]}]}], "]"}]}], ",", 
       RowBox[{"Dimensions", "[", "im", "]"}]}], "]"}]}]}], "\n", 
   "]"}]}]], "Code"]
}, Closed]],

Cell[CellGroupData[{

Cell["New and Fast", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FrangiVesselnessFilter", "=", "\n", 
   RowBox[{"Compile", "[", "\n", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"data", ",", "_Real", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Beta]", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Epsilon]", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Sigma]", ",", "_Real"}], "}"}]}], "}"}], ",", "\n", 
     RowBox[{"Module", "[", "\n", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "Lxx", ",", "Lxy", ",", "Lyy", ",", "\[Lambda]", ",", 
         "\[Lambda]\[Delta]", ",", "\[Lambda]1", ",", "\[Lambda]2", ",", "R2",
          ",", "nR2", ",", "S2", ",", "nS2", ",", 
         RowBox[{"\[Gamma]", " ", "=", " ", 
          RowBox[{"3", "/", "4"}]}], ",", "mf"}], "}"}], ",", "\n", 
       RowBox[{
        RowBox[{"UpdateStatus", "[", 
         RowBox[{"\"\<Calculating vesselness at \[Beta]= \>\"", "<>", 
          RowBox[{"ToString", "[", "\[Beta]", "]"}], "<>", 
          "\"\<, \[Epsilon]=\>\"", "<>", 
          RowBox[{"ToString", "[", "\[Epsilon]", "]"}], "<>", 
          "\"\< and \[Sigma]=\>\"", "<>", 
          RowBox[{"ToString", "[", "\[Sigma]", "]"}]}], "]"}], ";", "\n", 
        "\n", 
        RowBox[{"(*", " ", 
         RowBox[{"Calculate", " ", "Hessian", " ", "derivatives"}], " ", 
         "*)"}], "\n", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Lxx", ",", "Lxy", ",", "Lyy"}], "}"}], "=", 
         RowBox[{"If", "[", "\n", 
          RowBox[{
           RowBox[{"\[Sigma]", ">", "2"}], ",", "\n", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"GaussianFilter", "[", 
              RowBox[{"data", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "2"}], "}"}]}], "]"}], ",", "\n", 
             RowBox[{"GaussianFilter", "[", 
              RowBox[{"data", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}]}], "]"}], ",", "\n", 
             RowBox[{"GaussianFilter", "[", 
              RowBox[{"data", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "0"}], "}"}]}], "]"}]}], "}"}], ",", "\n", 
           RowBox[{"DerivativeFilter", "[", 
            RowBox[{"data", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", "2"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "0"}], "}"}]}], "}"}], ",", "\[Sigma]"}], 
            "]"}]}], "\n", "]"}]}], ";", "\n", "\n", 
        RowBox[{"(*", " ", 
         RowBox[{"Calculate", " ", "eigenvalues"}], " ", "*)"}], "\n", 
        RowBox[{"\[Lambda]", " ", "=", " ", 
         RowBox[{"Lxx", "+", "Lyy"}]}], ";", "\n", 
        RowBox[{"\[Lambda]\[Delta]", " ", "=", " ", 
         RowBox[{
          RowBox[{"Sign", "[", "\[Lambda]", "]"}], 
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"2", " ", "Lxy"}], ")"}], "^", "2"}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"Lxx", "-", "Lyy"}], ")"}], "^", "2"}]}], "]"}]}]}], 
        ";", "\n", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\[Lambda]1", ",", "\[Lambda]2"}], "}"}], "=", 
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{
            RowBox[{"\[Sigma]", "^", "\[Gamma]"}], "/", "2"}], "]"}], 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"\[Lambda]", "+", "\[Lambda]\[Delta]"}], ",", 
            RowBox[{"\[Lambda]", "-", "\[Lambda]\[Delta]"}]}], "}"}]}]}], ";",
         "\n", "\n", 
        RowBox[{"(*", " ", 
         RowBox[{"Calculate", " ", "vesselness"}], " ", "*)"}], "\n", 
        RowBox[{"R2", " ", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Lambda]2", "/", 
            RowBox[{"(", 
             RowBox[{"\[Lambda]1", " ", "+", " ", "$MachineEpsilon"}], 
             ")"}]}], ")"}], "^", "2"}]}], ";", "\n", "\n", 
        RowBox[{"nR2", "=", 
         RowBox[{
          RowBox[{"-", "1"}], "/", 
          RowBox[{"(", 
           RowBox[{"2", 
            RowBox[{"\[Beta]", "^", "2"}]}], ")"}]}]}], ";", "\n", 
        RowBox[{"S2", " ", "=", " ", 
         RowBox[{
          RowBox[{"\[Lambda]1", "^", "2"}], "+", 
          RowBox[{"\[Lambda]2", "^", "2"}]}]}], ";", "\n", 
        RowBox[{"nS2", " ", "=", " ", 
         RowBox[{
          RowBox[{"-", "1"}], "/", 
          RowBox[{"(", 
           RowBox[{"2", " ", 
            RowBox[{"\[Epsilon]", "^", "2"}], " ", 
            RowBox[{"Max", "[", "S2", "]"}]}], ")"}]}]}], ";", "\n", "\n", 
        RowBox[{
         RowBox[{"Exp", "[", 
          RowBox[{"nR2", " ", 
           RowBox[{"R2", "^", "2"}]}], "]"}], 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"Exp", "[", 
            RowBox[{"nS2", " ", "S2"}], "]"}]}], ")"}], 
         RowBox[{"UnitStep", "[", 
          RowBox[{"-", "\[Lambda]1"}], "]"}]}]}]}], "\n", "]"}], ",", "\n", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"GaussianFilter", "[", "__", "]"}], ",", "_Real", ",", "2"}],
         "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"DerivativeFilter", "[", "__", "]"}], ",", "_Real", ",", 
         "3"}], "}"}]}], "}"}]}], "\n", "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FrangiVesselnessFilterMask", "=", "\n", 
   RowBox[{"Compile", "[", "\n", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"data", ",", "_Real", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Beta]", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Epsilon]", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Sigma]", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"mask", ",", "_Real", ",", "2"}], "}"}]}], "}"}], ",", "\n", 
     RowBox[{"Module", "[", "\n", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "Lxx", ",", "Lxy", ",", "Lyy", ",", "\[Lambda]", ",", 
         "\[Lambda]\[Delta]", ",", "\[Lambda]1", ",", "\[Lambda]2", ",", "R2",
          ",", "nR2", ",", "S2", ",", "nS2", ",", 
         RowBox[{"\[Gamma]", " ", "=", " ", 
          RowBox[{"3", "/", "4"}]}], ",", "mf"}], "}"}], ",", "\n", 
       RowBox[{
        RowBox[{"UpdateStatus", "[", 
         RowBox[{"\"\<Calculating vesselness at \[Beta]= \>\"", "<>", 
          RowBox[{"ToString", "[", "\[Beta]", "]"}], "<>", 
          "\"\<, \[Epsilon]=\>\"", "<>", 
          RowBox[{"ToString", "[", "\[Epsilon]", "]"}], "<>", 
          "\"\< and \[Sigma]=\>\"", "<>", 
          RowBox[{"ToString", "[", "\[Sigma]", "]"}]}], "]"}], ";", "\n", 
        "\n", 
        RowBox[{"(*", " ", 
         RowBox[{"Calculate", " ", "Hessian", " ", "derivatives"}], " ", 
         "*)"}], "\n", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Lxx", ",", "Lxy", ",", "Lyy"}], "}"}], "=", 
         RowBox[{"If", "[", "\n", 
          RowBox[{
           RowBox[{"\[Sigma]", ">", "2"}], ",", "\n", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"GaussianFilter", "[", 
              RowBox[{"data", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "2"}], "}"}]}], "]"}], ",", "\n", 
             RowBox[{"GaussianFilter", "[", 
              RowBox[{"data", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}]}], "]"}], ",", "\n", 
             RowBox[{"GaussianFilter", "[", 
              RowBox[{"data", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "0"}], "}"}]}], "]"}]}], "}"}], ",", "\n", 
           RowBox[{"DerivativeFilter", "[", 
            RowBox[{"data", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", "2"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "0"}], "}"}]}], "}"}], ",", "\[Sigma]"}], 
            "]"}]}], "\n", "]"}]}], ";", "\n", "\n", 
        RowBox[{"(*", " ", 
         RowBox[{"Calculate", " ", "eigenvalues"}], " ", "*)"}], "\n", 
        RowBox[{"\[Lambda]", " ", "=", " ", 
         RowBox[{"Lxx", "+", "Lyy"}]}], ";", "\n", 
        RowBox[{"\[Lambda]\[Delta]", " ", "=", " ", 
         RowBox[{
          RowBox[{"Sign", "[", "\[Lambda]", "]"}], 
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"2", " ", "Lxy"}], ")"}], "^", "2"}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"Lxx", "-", "Lyy"}], ")"}], "^", "2"}]}], "]"}]}]}], 
        ";", "\n", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\[Lambda]1", ",", "\[Lambda]2"}], "}"}], "=", 
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{
            RowBox[{"\[Sigma]", "^", "\[Gamma]"}], "/", "2"}], "]"}], 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"\[Lambda]", "+", "\[Lambda]\[Delta]"}], ",", 
            RowBox[{"\[Lambda]", "-", "\[Lambda]\[Delta]"}]}], "}"}]}]}], ";",
         "\n", "\n", 
        RowBox[{"(*", " ", 
         RowBox[{"Calculate", " ", "vesselness"}], " ", "*)"}], "\n", 
        RowBox[{"R2", " ", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Lambda]2", "/", 
            RowBox[{"(", 
             RowBox[{"\[Lambda]1", " ", "+", " ", "$MachineEpsilon"}], 
             ")"}]}], ")"}], "^", "2"}]}], ";", "\n", "\n", 
        RowBox[{"nR2", "=", 
         RowBox[{
          RowBox[{"-", "1"}], "/", 
          RowBox[{"(", 
           RowBox[{"2", 
            RowBox[{"\[Beta]", "^", "2"}]}], ")"}]}]}], ";", "\n", 
        RowBox[{"S2", " ", "=", " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Lambda]1", "^", "2"}], "+", 
            RowBox[{"\[Lambda]2", "^", "2"}]}], ")"}], "*", "mask"}]}], ";", 
        "\n", 
        RowBox[{"nS2", " ", "=", " ", 
         RowBox[{
          RowBox[{"-", "1"}], "/", 
          RowBox[{"(", 
           RowBox[{"2", " ", 
            RowBox[{"\[Epsilon]", "^", "2"}], " ", 
            RowBox[{"Max", "[", "S2", "]"}]}], ")"}]}]}], ";", "\n", "\n", 
        RowBox[{
         RowBox[{"Exp", "[", 
          RowBox[{"nR2", " ", 
           RowBox[{"R2", "^", "2"}]}], "]"}], 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"Exp", "[", 
            RowBox[{"nS2", " ", "S2"}], "]"}]}], ")"}], 
         RowBox[{"UnitStep", "[", 
          RowBox[{"-", "\[Lambda]1"}], "]"}]}]}]}], "\n", "]"}], ",", "\n", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"GaussianFilter", "[", "__", "]"}], ",", "_Real", ",", "2"}],
         "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"DerivativeFilter", "[", "__", "]"}], ",", "_Real", ",", 
         "3"}], "}"}]}], "}"}]}], "\n", "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FrangiVesselnessFilterS", "[", 
   RowBox[{
   "data_", ",", "\[Beta]_", ",", "\[Epsilon]_", ",", "\[Sigma]_", ",", 
    "mask_", ",", "size_", ",", "blur_"}], "]"}], ":=", "\n", 
  RowBox[{"Module", "[", "\n", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "Lxx", ",", "Lxy", ",", "Lyy", ",", "\[Lambda]", ",", 
      "\[Lambda]\[Delta]", ",", "\[Lambda]1", ",", "\[Lambda]2", ",", "R2", 
      ",", "nR2", ",", "S2", ",", "nS2", ",", 
      RowBox[{"\[Gamma]", " ", "=", " ", 
       RowBox[{"3", "/", "4"}]}], ",", "mf", ",", "maximage", ",", "maxs"}], 
     "}"}], ",", "\n", 
    RowBox[{
     RowBox[{"UpdateStatus", "[", 
      RowBox[{"\"\<Calculating vesselness at \[Beta]= \>\"", "<>", 
       RowBox[{"ToString", "[", "\[Beta]", "]"}], "<>", 
       "\"\<, \[Epsilon]=\>\"", "<>", 
       RowBox[{"ToString", "[", "\[Epsilon]", "]"}], "<>", 
       "\"\< and \[Sigma]=\>\"", "<>", 
       RowBox[{"ToString", "[", "\[Sigma]", "]"}]}], "]"}], ";", "\n", "\n", 
     RowBox[{"(*", " ", 
      RowBox[{"Calculate", " ", "Hessian", " ", "derivatives"}], " ", "*)"}], 
     "\n", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Lxx", ",", "Lxy", ",", "Lyy"}], "}"}], "=", 
      RowBox[{"If", "[", "\n", 
       RowBox[{
        RowBox[{"\[Sigma]", ">", "2"}], ",", "\n", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"GaussianFilter", "[", 
           RowBox[{"data", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "2"}], "}"}]}], "]"}], ",", "\n", 
          RowBox[{"GaussianFilter", "[", 
           RowBox[{"data", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}]}], "]"}], ",", "\n", 
          RowBox[{"GaussianFilter", "[", 
           RowBox[{"data", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}]}], "]"}]}], "}"}], ",", "\n", 
        RowBox[{"DerivativeFilter", "[", 
         RowBox[{"data", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}]}], "}"}], ",", "\[Sigma]"}], 
         "]"}]}], "\n", "]"}]}], ";", "\n", 
     RowBox[{"(*", " ", 
      RowBox[{"Calculate", " ", "eigenvalues"}], " ", "*)"}], "\n", 
     RowBox[{"\[Lambda]", " ", "=", " ", 
      RowBox[{"Lxx", "+", "Lyy"}]}], ";", "\n", 
     RowBox[{"\[Lambda]\[Delta]", " ", "=", " ", 
      RowBox[{
       RowBox[{"Sign", "[", "\[Lambda]", "]"}], 
       RowBox[{"Sqrt", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"2", " ", "Lxy"}], ")"}], "^", "2"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Lxx", "-", "Lyy"}], ")"}], "^", "2"}]}], "]"}]}]}], ";", 
     "\n", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Lambda]1", ",", "\[Lambda]2"}], "}"}], "=", 
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{
         RowBox[{"\[Sigma]", "^", "\[Gamma]"}], "/", "2"}], "]"}], 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Lambda]", "+", "\[Lambda]\[Delta]"}], ",", 
         RowBox[{"\[Lambda]", "-", "\[Lambda]\[Delta]"}]}], "}"}]}]}], ";", 
     "\n", 
     RowBox[{"(*", " ", 
      RowBox[{"Calculate", " ", "vesselness"}], " ", "*)"}], "\n", 
     RowBox[{"R2", " ", "=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"\[Lambda]2", "/", 
         RowBox[{"(", 
          RowBox[{"\[Lambda]1", " ", "+", " ", "$MachineEpsilon"}], ")"}]}], 
        ")"}], "^", "2"}]}], ";", "\n", "\n", 
     RowBox[{"nR2", "=", 
      RowBox[{
       RowBox[{"-", "1"}], "/", 
       RowBox[{"(", 
        RowBox[{"2", 
         RowBox[{"\[Beta]", "^", "2"}]}], ")"}]}]}], ";", "\n", 
     RowBox[{"S2", " ", "=", " ", 
      RowBox[{
       RowBox[{"\[Lambda]1", "^", "2"}], "+", 
       RowBox[{"\[Lambda]2", "^", "2"}]}]}], ";", "\n", "\n", 
     RowBox[{"nS2", " ", "=", " ", 
      RowBox[{
       RowBox[{"-", "1"}], "/", 
       RowBox[{"(", 
        RowBox[{"2", " ", 
         RowBox[{"\[Epsilon]", "^", "2"}], " ", 
         RowBox[{"Max", "[", 
          RowBox[{"Erode", "[", 
           RowBox[{"S2", ",", "20"}], "]"}], "]"}]}], ")"}]}]}], ";", "\n", 
     "\n", 
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{"nR2", " ", 
        RowBox[{"R2", "^", "2"}]}], "]"}], 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"Exp", "[", 
         RowBox[{"nS2", " ", "S2"}], "]"}]}], ")"}], 
      RowBox[{"UnitStep", "[", 
       RowBox[{"-", "\[Lambda]1"}], "]"}]}]}]}], "\n", "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FrangiVesselnessFilterS2", "[", 
   RowBox[{
   "data_", ",", "\[Beta]_", ",", "\[Epsilon]_", ",", "\[Sigma]_", ",", 
    "mask_", ",", "size_", ",", "blur_"}], "]"}], ":=", "\n", 
  RowBox[{"Module", "[", "\n", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "Lxx", ",", "Lxy", ",", "Lyy", ",", "\[Lambda]", ",", 
      "\[Lambda]\[Delta]", ",", "\[Lambda]1", ",", "\[Lambda]2", ",", "R2", 
      ",", "nR2", ",", "S2", ",", "nS2", ",", 
      RowBox[{"\[Gamma]", " ", "=", " ", 
       RowBox[{"3", "/", "4"}]}], ",", "mf", ",", "maximage", ",", "maxs"}], 
     "}"}], ",", "\n", 
    RowBox[{
     RowBox[{"UpdateStatus", "[", 
      RowBox[{"\"\<Calculating vesselness at \[Beta]= \>\"", "<>", 
       RowBox[{"ToString", "[", "\[Beta]", "]"}], "<>", 
       "\"\<, \[Epsilon]=\>\"", "<>", 
       RowBox[{"ToString", "[", "\[Epsilon]", "]"}], "<>", 
       "\"\< and \[Sigma]=\>\"", "<>", 
       RowBox[{"ToString", "[", "\[Sigma]", "]"}]}], "]"}], ";", "\n", "\n", 
     RowBox[{"(*", " ", 
      RowBox[{"Calculate", " ", "Hessian", " ", "derivatives"}], " ", "*)"}], 
     "\n", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Lxx", ",", "Lxy", ",", "Lyy"}], "}"}], "=", 
      RowBox[{"If", "[", "\n", 
       RowBox[{
        RowBox[{"\[Sigma]", ">", "2"}], ",", "\n", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"GaussianFilter", "[", 
           RowBox[{"data", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "2"}], "}"}]}], "]"}], ",", "\n", 
          RowBox[{"GaussianFilter", "[", 
           RowBox[{"data", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}]}], "]"}], ",", "\n", 
          RowBox[{"GaussianFilter", "[", 
           RowBox[{"data", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}]}], "]"}]}], "}"}], ",", "\n", 
        RowBox[{"DerivativeFilter", "[", 
         RowBox[{"data", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "0"}], "}"}]}], "}"}], ",", "\[Sigma]"}], 
         "]"}]}], "\n", "]"}]}], ";", "\n", 
     RowBox[{"(*", " ", 
      RowBox[{"Calculate", " ", "eigenvalues"}], " ", "*)"}], "\n", 
     RowBox[{"\[Lambda]", " ", "=", " ", 
      RowBox[{"Lxx", "+", "Lyy"}]}], ";", "\n", 
     RowBox[{"\[Lambda]\[Delta]", " ", "=", " ", 
      RowBox[{
       RowBox[{"Sign", "[", "\[Lambda]", "]"}], 
       RowBox[{"Sqrt", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"2", " ", "Lxy"}], ")"}], "^", "2"}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Lxx", "-", "Lyy"}], ")"}], "^", "2"}]}], "]"}]}]}], ";", 
     "\n", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Lambda]1", ",", "\[Lambda]2"}], "}"}], "=", 
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{
         RowBox[{"\[Sigma]", "^", "\[Gamma]"}], "/", "2"}], "]"}], 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Lambda]", "+", "\[Lambda]\[Delta]"}], ",", 
         RowBox[{"\[Lambda]", "-", "\[Lambda]\[Delta]"}]}], "}"}]}]}], ";", 
     "\n", 
     RowBox[{"(*", " ", 
      RowBox[{"Calculate", " ", "vesselness"}], " ", "*)"}], "\n", 
     RowBox[{"R2", " ", "=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"\[Lambda]2", "/", 
         RowBox[{"(", 
          RowBox[{"\[Lambda]1", " ", "+", " ", "$MachineEpsilon"}], ")"}]}], 
        ")"}], "^", "2"}]}], ";", "\n", "\n", 
     RowBox[{"nR2", "=", 
      RowBox[{
       RowBox[{"-", "1"}], "/", 
       RowBox[{"(", 
        RowBox[{"2", 
         RowBox[{"\[Beta]", "^", "2"}]}], ")"}]}]}], ";", "\n", 
     RowBox[{"S2", " ", "=", " ", 
      RowBox[{
       RowBox[{"\[Lambda]1", "^", "2"}], "+", 
       RowBox[{"\[Lambda]2", "^", "2"}]}]}]}]}], 
   RowBox[{"(*", 
    RowBox[{";", "\n", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"nS2", " ", "=", " ", 
        RowBox[{
         RowBox[{"-", "1"}], "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", 
            RowBox[{"\[Epsilon]", "^", "2"}], " ", 
            RowBox[{"ImageData", "[", 
             RowBox[{"Blur", "[", 
              RowBox[{
               RowBox[{"Image", "[", 
                RowBox[{"MaxFilter", "[", 
                 RowBox[{
                  RowBox[{"Erode", "[", 
                   RowBox[{"mask", ",", "10"}], "]"}], ",", "200"}], "]"}], 
                "]"}], ",", "300"}], "]"}], "]"}]}], "+", "$MachineEpsilon"}],
           ")"}]}]}], ";"}], "*)"}], "\n", 
     RowBox[{"(*", 
      RowBox[{"Print", "@", 
       RowBox[{"AbsoluteTiming", "[", 
        RowBox[{
         RowBox[{"maximage", " ", "=", " ", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"ConstantArray", "[", 
              RowBox[{
               RowBox[{"Max", "[", "#", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"size", ",", "size"}], "}"}]}], "]"}], "&"}], ",", 
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Erode", "[", 
                RowBox[{"mask", ",", "10"}], "]"}], "*", "S2"}], ",", 
              RowBox[{"{", 
               RowBox[{"size", ",", "size"}], "}"}], ",", "size", ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1"}], "}"}]}], "]"}], ",", 
            RowBox[{"{", "2", "}"}]}], "]"}]}], ";"}], "]"}]}], "*)"}], "\n", 
     RowBox[{"maximage", " ", "=", " ", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ConstantArray", "[", 
          RowBox[{
           RowBox[{"Max", "[", "#", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"size", ",", "size"}], "}"}]}], "]"}], "&"}], ",", 
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"ImageData", "[", 
           RowBox[{"ImageMultiply", "[", 
            RowBox[{
             RowBox[{"Erosion", "[", 
              RowBox[{
               RowBox[{"Image", "[", "mask", "]"}], ",", "10"}], "]"}], ",", 
             RowBox[{"Image", "[", "S2", "]"}]}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"size", ",", "size"}], "}"}], ",", "size", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{"(*", 
      RowBox[{"Partition", "[", 
       RowBox[{
        RowBox[{"ImageData", "[", 
         RowBox[{"ImageMultiply", "[", 
          RowBox[{
           RowBox[{"Erosion", "[", 
            RowBox[{
             RowBox[{"Image", "[", "mask", "]"}], ",", "10"}], "]"}], ",", 
           RowBox[{"Image", "[", "im", "]"}]}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"size", "=", "100"}], ",", "size"}], "}"}], ",", "size", 
        ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}]}], "]"}], "*)"}], "\n", 
     RowBox[{"maxs", " ", "=", " ", 
      RowBox[{"Take", "[", 
       RowBox[{
        RowBox[{"ArrayFlatten", "[", "maximage", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{
           RowBox[{"Dimensions", "[", "data", "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{
           RowBox[{"Dimensions", "[", "data", "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}]}], ";", "\n", 
     RowBox[{"nS2", " ", "=", " ", 
      RowBox[{
       RowBox[{"-", "1"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", 
          RowBox[{"\[Epsilon]", "^", "2"}], " ", 
          RowBox[{"ImageData", "[", 
           RowBox[{"Blur", "[", 
            RowBox[{
             RowBox[{"Image", "@", "maxs"}], ",", "blur"}], "]"}], "]"}]}], 
         " ", "+", " ", "$MachineEpsilon"}], ")"}]}]}], ";", "\n", 
     RowBox[{"nS2", " ", "=", " ", 
      RowBox[{"Chop", "[", "nS2", "]"}]}], ";", "\n", 
     RowBox[{"Print", "@", 
      RowBox[{"AbsoluteTiming", "[", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{"nR2", " ", 
          RowBox[{"R2", "^", "2"}]}], "]"}], 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{"Exp", "[", 
           RowBox[{"nS2", " ", "S2"}], "]"}]}], ")"}], 
        RowBox[{"UnitStep", "[", 
         RowBox[{"-", "\[Lambda]1"}], "]"}]}], "]"}]}]}], "*)"}], "\n", 
   "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"VesselnessFilterCrossing", "=", " ", "\n", 
   RowBox[{"Compile", "[", "\n", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"data", ",", "_Real", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Beta]", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Epsilon]", ",", "_Real"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Sigma]", ",", "_Real"}], "}"}]}], "}"}], ",", "\n", 
     RowBox[{"Module", "[", "\n", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "Lxx", ",", "Lxy", ",", "Lyy", ",", "\[Lambda]", ",", 
         "\[Lambda]\[Delta]", ",", "\[Lambda]1", ",", "\[Lambda]2", ",", "R2",
          ",", "nR2", ",", "S2", ",", "nS2", ",", "cros", ",", 
         RowBox[{"\[Gamma]", " ", "=", " ", 
          RowBox[{"3", "/", "4"}]}], ",", "mf", ",", "\[Lambda]3"}], "}"}], 
       ",", "\n", 
       RowBox[{
        RowBox[{"UpdateStatus", "[", 
         RowBox[{"\"\<Calculating vesselness at \[Beta]= \>\"", "<>", 
          RowBox[{"ToString", "[", "\[Beta]", "]"}], "<>", 
          "\"\<, \[Epsilon]=\>\"", "<>", 
          RowBox[{"ToString", "[", "\[Epsilon]", "]"}], "<>", 
          "\"\< and \[Sigma]=\>\"", "<>", 
          RowBox[{"ToString", "[", "\[Sigma]", "]"}]}], "]"}], ";", "\n", 
        "\n", 
        RowBox[{"(*", " ", 
         RowBox[{"Calculate", " ", "Hessian", " ", "derivatives"}], " ", 
         "*)"}], "\n", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Lxx", ",", "Lxy", ",", "Lyy"}], "}"}], "=", 
         RowBox[{"If", "[", "\n", 
          RowBox[{
           RowBox[{"\[Sigma]", ">", "2"}], ",", "\n", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"GaussianFilter", "[", 
              RowBox[{"data", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "2"}], "}"}]}], "]"}], ",", "\n", 
             RowBox[{"GaussianFilter", "[", 
              RowBox[{"data", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}]}], "]"}], ",", "\n", 
             RowBox[{"GaussianFilter", "[", 
              RowBox[{"data", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "0"}], "}"}]}], "]"}]}], "}"}], ",", "\n", 
           RowBox[{"DerivativeFilter", "[", 
            RowBox[{"data", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", "2"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "0"}], "}"}]}], "}"}], ",", "\[Sigma]"}], 
            "]"}]}], "\n", "]"}]}], ";", "\n", "\n", 
        RowBox[{"(*", " ", 
         RowBox[{"Calculate", " ", "eigenvalues"}], " ", "*)"}], "\n", 
        RowBox[{"\[Lambda]", " ", "=", " ", 
         RowBox[{"Lxx", "+", "Lyy"}]}], ";", "\n", 
        RowBox[{"\[Lambda]\[Delta]", " ", "=", " ", 
         RowBox[{
          RowBox[{"Sign", "[", "\[Lambda]", "]"}], 
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"2", " ", "Lxy"}], ")"}], "^", "2"}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"Lxx", "-", "Lyy"}], ")"}], "^", "2"}]}], "]"}]}]}], 
        ";", "\n", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\[Lambda]1", ",", "\[Lambda]2"}], "}"}], "=", 
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{
            RowBox[{"\[Sigma]", "^", "\[Gamma]"}], "/", "2"}], "]"}], 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"\[Lambda]", "+", "\[Lambda]\[Delta]"}], ",", 
            RowBox[{"\[Lambda]", "-", "\[Lambda]\[Delta]"}]}], "}"}]}]}], ";",
         "\n", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"\[Lambda]3", "=", 
           RowBox[{
            RowBox[{"N", "[", 
             RowBox[{
              RowBox[{"\[Sigma]", "^", "\[Gamma]"}], "/", "2"}], "]"}], 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"\[Lambda]", "+", "\[Lambda]\[Delta]"}], ",", 
              RowBox[{"\[Lambda]", "-", "\[Lambda]\[Delta]"}]}], "}"}]}]}], 
          ";"}], "*)"}], "\n", "\n", "\n", 
        RowBox[{"(*", " ", 
         RowBox[{"Calculate", " ", "vesselness"}], " ", "*)"}], "\n", 
        RowBox[{"R2", " ", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Lambda]2", "/", 
            RowBox[{"(", 
             RowBox[{"\[Lambda]1", " ", "+", " ", "$MachineEpsilon"}], 
             ")"}]}], ")"}], "^", "2"}]}], ";", "\n", 
        RowBox[{"nR2", "=", 
         RowBox[{
          RowBox[{"-", "1"}], "/", 
          RowBox[{"(", 
           RowBox[{"2", 
            RowBox[{"\[Beta]", "^", "2"}]}], ")"}]}]}], ";", "\n", 
        RowBox[{"S2", " ", "=", " ", 
         RowBox[{
          RowBox[{"\[Lambda]1", "^", "2"}], "+", 
          RowBox[{"\[Lambda]2", "^", "2"}]}]}], ";", "\n", 
        RowBox[{"nS2", " ", "=", " ", 
         RowBox[{
          RowBox[{"-", "1"}], "/", 
          RowBox[{"(", 
           RowBox[{"2", " ", 
            RowBox[{"\[Epsilon]", "^", "2"}], " ", 
            RowBox[{"Max", "[", "S2", "]"}]}], ")"}]}]}], ";", "\n", 
        RowBox[{"cros", " ", "=", " ", 
         RowBox[{"Abs", "[", 
          RowBox[{
           RowBox[{"UnitStep", "[", 
            RowBox[{
             RowBox[{"-", "\[Lambda]1"}], "*", "\[Lambda]2"}], "]"}], "*", 
           "\[Lambda]1", "*", "\[Lambda]2"}], "]"}]}], ";", "\n", "\n", "\n", 
        RowBox[{
         RowBox[{"Exp", "[", 
          RowBox[{"nR2", " ", 
           RowBox[{"R2", "^", "2"}]}], "]"}], 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"Exp", "[", 
            RowBox[{"nS2", " ", "S2"}], "]"}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"UnitStep", "[", 
            RowBox[{"-", "\[Lambda]1"}], "]"}], "+", 
           RowBox[{"UnitStep", "[", 
            RowBox[{"cros", "-", "0.000005"}], "]"}]}], ")"}]}]}]}], "\n", 
      "\n", "]"}], ",", "\n", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"GaussianFilter", "[", "__", "]"}], ",", "_Real", ",", "2"}],
         "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"DerivativeFilter", "[", "__", "]"}], ",", "_Real", ",", 
         "3"}], "}"}]}], "}"}]}], "\n", "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ShoujunVesselnessFilter", "=", "\n", 
   RowBox[{"Compile", "[", "\n", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"data", ",", "_Real", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Sigma]", ",", "_Real"}], "}"}]}], "}"}], ",", "\n", 
     RowBox[{"Module", "[", "\n", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "Lxx", ",", "Lxy", ",", "Lyy", ",", "\[Lambda]", ",", 
         "\[Lambda]\[Delta]", ",", "\[Lambda]1", ",", "\[Lambda]2", ",", "R2",
          ",", "nR2", ",", "S2", ",", "nS2", ",", 
         RowBox[{"\[Gamma]", " ", "=", " ", 
          RowBox[{"3", "/", "4"}]}], ",", "r\[Lambda]"}], "}"}], ",", "\n", 
       "\n", "\n", 
       RowBox[{"(*", " ", 
        RowBox[{"Calculate", " ", "Hessian", " ", "derivatives"}], " ", 
        "*)"}], "\n", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Lxx", ",", "Lxy", ",", "Lyy"}], "}"}], "=", 
         RowBox[{"If", "[", "\n", 
          RowBox[{
           RowBox[{"\[Sigma]", ">", "2"}], ",", "\n", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"GaussianFilter", "[", 
              RowBox[{"data", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "2"}], "}"}]}], "]"}], ",", "\n", 
             RowBox[{"GaussianFilter", "[", 
              RowBox[{"data", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}]}], "]"}], ",", "\n", 
             RowBox[{"GaussianFilter", "[", 
              RowBox[{"data", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"3", "\[Sigma]"}], ",", "\[Sigma]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "0"}], "}"}]}], "]"}]}], "}"}], ",", "\n", 
           RowBox[{"DerivativeFilter", "[", 
            RowBox[{"data", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", "2"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "0"}], "}"}]}], "}"}], ",", "\[Sigma]"}], 
            "]"}]}], "\n", "]"}]}], ";", "\n", "\n", 
        RowBox[{"(*", " ", 
         RowBox[{"Calculate", " ", "eigenvalues"}], " ", "*)"}], "\n", 
        RowBox[{"\[Lambda]", " ", "=", " ", 
         RowBox[{"Lxx", "+", "Lyy"}]}], ";", "\n", 
        RowBox[{"\[Lambda]\[Delta]", " ", "=", " ", 
         RowBox[{
          RowBox[{"Sign", "[", "\[Lambda]", "]"}], 
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"2", " ", "Lxy"}], ")"}], "^", "2"}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"Lxx", "-", "Lyy"}], ")"}], "^", "2"}]}], "]"}]}]}], 
        ";", "\n", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\[Lambda]1", ",", "\[Lambda]2"}], "}"}], "=", 
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{
            RowBox[{"\[Sigma]", "^", "2"}], "/", "2"}], "]"}], 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"\[Lambda]", "+", "\[Lambda]\[Delta]"}], ",", 
            RowBox[{"\[Lambda]", "-", "\[Lambda]\[Delta]"}]}], "}"}]}]}], ";",
         "\n", "\n", 
        RowBox[{"r\[Lambda]", " ", "=", " ", 
         RowBox[{"-", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"2", "\[Pi]", " ", "\[Sigma]"}], "]"}]}]}], ";", "\n", 
        "\n", 
        RowBox[{
         RowBox[{"UnitStep", "[", 
          RowBox[{
           RowBox[{"-", "\[Lambda]1"}], "+", "r\[Lambda]"}], "]"}], "*", 
         RowBox[{"Log", "[", 
          RowBox[{"Abs", "[", "\[Lambda]1", "]"}], "]"}]}]}]}], "\n", "\n", 
      "\n", "]"}], ",", "\n", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"GaussianFilter", "[", "__", "]"}], ",", "_Real", ",", "2"}],
         "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"DerivativeFilter", "[", "__", "]"}], ",", "_Real", ",", 
         "3"}], "}"}]}], "}"}]}], "\n", "]"}]}], ";"}]], "Code"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Postprocessing", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LocalThresholding", "[", 
    RowBox[{"im_", ",", "\[Sigma]_", ",", "mask_"}], "]"}], ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"blur", ",", "us", ",", "mc"}], "}"}], ",", " ", 
     RowBox[{"(*", 
      RowBox[{
      "Local", " ", "thresholding", " ", "by", " ", "comparing", " ", "with", 
       " ", "the", " ", "gaussian", " ", "blurred", " ", "image"}], "*)"}], 
     "\n", "\t", 
     RowBox[{
      RowBox[{
      "UpdateStatus", "[", "\"\<Applying local threshold...\>\"", "]"}], ";", 
      "\n", "\t", 
      RowBox[{"blur", " ", "=", " ", 
       RowBox[{"GaussianFilter", "[", 
        RowBox[{
         RowBox[{"im", "*", "mask"}], ",", "\[Sigma]", ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}], "]"}]}], ";", "\n", "\t", 
      RowBox[{"us", " ", "=", " ", 
       RowBox[{
        RowBox[{"UnitStep", "[", 
         RowBox[{"im", "-", 
          RowBox[{"2", "*", "blur"}]}], "]"}], "*", "mask"}]}]}]}], 
    RowBox[{"(*", 
     RowBox[{
     "Volgende", " ", "berekening", " ", "is", " ", "een", " ", "test"}], 
     "*)"}], "\n", "\t", 
    RowBox[{"(*", 
     RowBox[{"us", " ", "=", " ", 
      RowBox[{
       RowBox[{"UnitStep", "[", 
        RowBox[{"im", "-", "blur", "-", "0.1"}], "]"}], "*", "mask"}]}], 
     "*)"}], "\n", "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DeleteSmallStructures", "[", 
    RowBox[{"im_", ",", "size_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", " ", 
     RowBox[{"(*", 
      RowBox[{
      "Delete", " ", "structues", " ", "that", " ", "are", " ", "smaller", 
       " ", "in", " ", "size", " ", "than", " ", "a", " ", "certain", " ", 
       "threshold"}], "*)"}], "\n", "\t", 
     RowBox[{
      RowBox[{
      "UpdateStatus", "[", "\"\<Deleting small components...\>\"", "]"}], ";",
       "\n", "\t", 
      RowBox[{"MorphologicalComponents", "[", 
       RowBox[{"DeleteSmallComponents", "[", 
        RowBox[{
         RowBox[{"Image", "@", "im"}], ",", "size"}], "]"}], "]"}]}]}], "\n", 
    "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeleteNoiseandElongationWerkend", "[", 
   RowBox[{
   "im_", ",", "\[Sigma]_", ",", "compsize_", ",", "elongation_", ",", 
    "cl_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "cmp", ",", "cmpcount", ",", "cmpelongation", ",", "ruleset", ",", 
      "small", ",", "small2", ",", "c", ",", "meas", ",", "elongated"}], 
     "}"}], ",", "\n", "\t", 
    RowBox[{
     RowBox[{
     "UpdateStatus", "[", 
      "\"\<Deleting noisy and non-elongated structures...\>\"", "]"}], ";", 
     "\n", "\t", 
     RowBox[{"cmp", " ", "=", " ", 
      RowBox[{"ComponentMeasurements", "[", 
       RowBox[{"im", " ", ",", "\"\<BoundingBox\>\""}], "]"}]}], ";", " ", 
     RowBox[{"(*", 
      RowBox[{
      "Calculate", " ", "boundingbox", " ", "to", " ", "take", " ", "out", 
       " ", "seperate", " ", "components"}], "*)"}], "\n", "\t", 
     RowBox[{"cmpcount", " ", "=", " ", 
      RowBox[{"ComponentMeasurements", "[", 
       RowBox[{"im", " ", ",", "\"\<Count\>\""}], "]"}]}], ";", " ", "\n", 
     "\t", 
     RowBox[{"cmpelongation", " ", "=", " ", 
      RowBox[{"ComponentMeasurements", "[", 
       RowBox[{"im", " ", ",", "\"\<Elongation\>\""}], "]"}]}], ";", "\n", 
     "\t", 
     RowBox[{"ruleset", " ", "=", " ", 
      RowBox[{"Table", "[", "\n", "\t\t", 
       RowBox[{
        RowBox[{
         RowBox[{"small", "  ", "=", 
          RowBox[{
           RowBox[{"(", "im", ")"}], "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{
              RowBox[{"Round", "@", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Dimensions", "[", "im", "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "-", 
                 RowBox[{"cmp", "[", 
                  RowBox[{"[", 
                   RowBox[{"x", ",", "2", ",", "2", ",", "2"}], "]"}], "]"}], 
                 "+", "1"}], ")"}]}], ";;", 
              RowBox[{"Round", "@", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Dimensions", "[", "im", "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "-", 
                 RowBox[{"cmp", "[", 
                  RowBox[{"[", 
                   RowBox[{"x", ",", "2", ",", "1", ",", "2"}], "]"}], 
                  "]"}]}], ")"}]}]}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"Round", "@", 
                RowBox[{"cmp", "[", 
                 RowBox[{"[", 
                  RowBox[{"x", ",", "2", ",", "1", ",", "1"}], "]"}], "]"}]}],
                "+", "1"}], ";;", 
              RowBox[{"Round", "@", 
               RowBox[{"cmp", "[", 
                RowBox[{"[", 
                 RowBox[{"x", ",", "2", ",", "2", ",", "1"}], "]"}], 
                "]"}]}]}]}], "]"}], "]"}]}], ";", "\n", "\t\t", 
         RowBox[{"small2", " ", "=", " ", 
          RowBox[{"ArrayPad", "[", 
           RowBox[{
            RowBox[{"ImageData", "@", 
             RowBox[{"Binarize", "[", 
              RowBox[{
               RowBox[{"small", "//", "Image"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"cmp", "[", 
                  RowBox[{"[", 
                   RowBox[{"x", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"cmp", "[", 
                  RowBox[{"[", 
                   RowBox[{"x", ",", "1"}], "]"}], "]"}]}], "}"}]}], "]"}]}], 
            ",", "20"}], "]"}]}], ";", "\n", "\t\t", 
         RowBox[{"c", " ", "=", " ", 
          RowBox[{"Closing", "[", 
           RowBox[{
            RowBox[{"Image", "@", "small2"}], ",", "\[Sigma]"}], "]"}]}], ";",
          "\n", "\t\t", 
         RowBox[{"meas", " ", "=", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"c", "//", "ImageData"}], "//", "Flatten"}], "//", 
              "Total"}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"small2", "//", "Flatten"}], "//", "Total"}], ")"}]}], "//",
            "N"}]}], ";", "\n", "\t\t", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"cmpcount", "[", 
             RowBox[{"[", 
              RowBox[{"x", ",", "2"}], "]"}], "]"}], "<", "compsize"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"cmpelongation", "[", 
               RowBox[{"[", 
                RowBox[{"x", ",", "2"}], "]"}], "]"}], ">", "elongation"}], 
             ",", 
             RowBox[{"elongated", "=", "True"}], ",", 
             RowBox[{"elongated", "=", "False"}]}], "]"}], ",", 
           RowBox[{"elongated", " ", "=", " ", "True"}]}], "]"}], ";", "\n", 
         "\t\t", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"meas", "<", "cl"}], "&&", "elongated"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"cmp", "[", 
              RowBox[{"[", 
               RowBox[{"x", ",", "1"}], "]"}], "]"}], ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"cmp", "[", 
              RowBox[{"[", 
               RowBox[{"x", ",", "1"}], "]"}], "]"}], ",", "0"}], "}"}]}], 
          "]"}]}], "\n", "\t", ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "1", ",", 
          RowBox[{"Length", "[", "cmp", "]"}], ",", "1"}], "}"}]}], "]"}]}], 
     ";", "\n", "\n", "\t", 
     RowBox[{"im", "/.", 
      RowBox[{"Dispatch", "[", 
       RowBox[{"Apply", "[", 
        RowBox[{"Rule", ",", "ruleset", ",", 
         RowBox[{"{", "1", "}"}]}], "]"}], "]"}]}]}]}], "\n", "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeleteNoiseandElongation", "[", 
   RowBox[{
   "im_", ",", "\[Sigma]_", ",", "compsize_", ",", "elongation_", ",", 
    "cl_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "cmp", ",", "cmpcount", ",", "cmpelongation", ",", "ruleset", ",", 
      "small", ",", "small2", ",", "c", ",", "meas", ",", "elongated"}], 
     "}"}], ",", "\n", "\t", 
    RowBox[{
     RowBox[{
     "UpdateStatus", "[", 
      "\"\<Deleting noisy and non-elongated structures...\>\"", "]"}], ";", 
     "\n", "\t", 
     RowBox[{"cmp", " ", "=", " ", 
      RowBox[{"ComponentMeasurements", "[", 
       RowBox[{"im", " ", ",", "\"\<BoundingBox\>\""}], "]"}]}], ";", " ", 
     RowBox[{"(*", 
      RowBox[{
      "Calculate", " ", "boundingbox", " ", "to", " ", "take", " ", "out", 
       " ", "seperate", " ", "components"}], "*)"}], "\n", "\t", 
     RowBox[{"cmpcount", " ", "=", " ", 
      RowBox[{"ComponentMeasurements", "[", 
       RowBox[{"im", " ", ",", "\"\<Count\>\""}], "]"}]}], ";", " ", "\n", 
     "\t", 
     RowBox[{"cmpelongation", " ", "=", " ", 
      RowBox[{"ComponentMeasurements", "[", 
       RowBox[{"im", " ", ",", "\"\<Elongation\>\""}], "]"}]}], ";", "\n", 
     "\t", 
     RowBox[{"ruleset", " ", "=", " ", 
      RowBox[{"Table", "[", "\n", "\t\t", 
       RowBox[{
        RowBox[{
         RowBox[{"small", "  ", "=", 
          RowBox[{
           RowBox[{"(", "im", ")"}], "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{
              RowBox[{"Round", "@", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Dimensions", "[", "im", "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "-", 
                 RowBox[{"cmp", "[", 
                  RowBox[{"[", 
                   RowBox[{"x", ",", "2", ",", "2", ",", "2"}], "]"}], "]"}], 
                 "+", "1"}], ")"}]}], ";;", 
              RowBox[{"Round", "@", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Dimensions", "[", "im", "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "-", 
                 RowBox[{"cmp", "[", 
                  RowBox[{"[", 
                   RowBox[{"x", ",", "2", ",", "1", ",", "2"}], "]"}], 
                  "]"}]}], ")"}]}]}], ",", 
             RowBox[{
              RowBox[{"Round", "@", 
               RowBox[{"cmp", "[", 
                RowBox[{"[", 
                 RowBox[{"x", ",", "2", ",", "1", ",", "1"}], "]"}], "]"}]}], 
              ";;", 
              RowBox[{"Round", "@", 
               RowBox[{"cmp", "[", 
                RowBox[{"[", 
                 RowBox[{"x", ",", "2", ",", "2", ",", "1"}], "]"}], 
                "]"}]}]}]}], "]"}], "]"}]}], ";", "\n", "\t\t", 
         RowBox[{"small2", " ", "=", " ", 
          RowBox[{"ArrayPad", "[", 
           RowBox[{
            RowBox[{"ImageData", "@", 
             RowBox[{"Binarize", "[", 
              RowBox[{
               RowBox[{"small", "//", "Image"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"cmp", "[", 
                  RowBox[{"[", 
                   RowBox[{"x", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"cmp", "[", 
                  RowBox[{"[", 
                   RowBox[{"x", ",", "1"}], "]"}], "]"}]}], "}"}]}], "]"}]}], 
            ",", "20"}], "]"}]}], ";", "\n", "\t\t", 
         RowBox[{"c", " ", "=", " ", 
          RowBox[{"Closing", "[", 
           RowBox[{
            RowBox[{"Image", "@", "small2"}], ",", "\[Sigma]"}], "]"}]}], ";",
          "\n", "\t\t", 
         RowBox[{"meas", " ", "=", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"c", "//", "ImageData"}], "//", "Flatten"}], "//", 
              "Total"}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"small2", "//", "Flatten"}], "//", "Total"}], ")"}]}], "//",
            "N"}]}], ";", "\n", "\t\t", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"cmpcount", "[", 
             RowBox[{"[", 
              RowBox[{"x", ",", "2"}], "]"}], "]"}], "<", "compsize"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"cmpelongation", "[", 
               RowBox[{"[", 
                RowBox[{"x", ",", "2"}], "]"}], "]"}], ">", "elongation"}], 
             ",", 
             RowBox[{"elongated", "=", "True"}], ",", 
             RowBox[{"elongated", "=", "False"}]}], "]"}], ",", 
           RowBox[{"elongated", " ", "=", " ", "True"}]}], "]"}], ";", "\n", 
         "\t\t", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"meas", "<", "cl"}], "&&", "elongated"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"cmp", "[", 
              RowBox[{"[", 
               RowBox[{"x", ",", "1"}], "]"}], "]"}], ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"cmp", "[", 
              RowBox[{"[", 
               RowBox[{"x", ",", "1"}], "]"}], "]"}], ",", "0"}], "}"}]}], 
          "]"}]}], "\n", "\t", ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "1", ",", 
          RowBox[{"Length", "[", "cmp", "]"}], ",", "1"}], "}"}]}], "]"}]}], 
     ";", "\n", "\n", "\t", 
     RowBox[{"im", "/.", 
      RowBox[{"Dispatch", "[", 
       RowBox[{"Apply", "[", 
        RowBox[{"Rule", ",", "ruleset", ",", 
         RowBox[{"{", "1", "}"}]}], "]"}], "]"}]}]}]}], "\n", "]"}]}]], "Code"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Training", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LoadTrainingImages", "[", 
   RowBox[{"folder_", ",", "name_", ",", "lum_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"LTIim", ",", "LTIref", ",", "LTImask"}], "}"}], ",", "\n", "\t", 
    RowBox[{
     RowBox[{"LTIim", "=", 
      RowBox[{"Initialize", "[", 
       RowBox[{"StringJoin", "[", 
        RowBox[{
        "folder", ",", "\"\<images/\>\"", ",", "name", ",", 
         "\"\<_training.tif\>\""}], "]"}], "]"}]}], ";", "\n", "\t", 
     RowBox[{"If", "[", 
      RowBox[{"lum", ",", 
       RowBox[{"LTIim", " ", "=", " ", 
        RowBox[{"LuminanceCorrection", "[", 
         RowBox[{"LTIim", ",", "20"}], "]"}]}]}], "]"}], ";", "\n", "\t", 
     RowBox[{"LTIref", "=", 
      RowBox[{"Rescale", "[", 
       RowBox[{
        RowBox[{"ImageData", "[", 
         RowBox[{"Import", "[", 
          RowBox[{"StringJoin", "[", 
           RowBox[{"folder", ",", "\"\<1st_manual/\>\"", ",", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"name", "<", "10"}], ",", "\"\<0\>\"", ",", 
               "\"\<\>\""}], "]"}], "<>", 
             RowBox[{"ToString", "@", "name"}]}], ",", 
            "\"\<_manual1.gif\>\""}], "]"}], "]"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}], "]"}]}], ";", 
     "\n", "\t", 
     RowBox[{"LTImask", "=", 
      RowBox[{"Chop", "@", 
       RowBox[{"Rescale", "[", 
        RowBox[{
         RowBox[{"ImageData", "[", 
          RowBox[{"Import", "[", 
           RowBox[{"StringJoin", "[", 
            RowBox[{"folder", ",", "\"\<mask/\>\"", ",", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"name", "<", "10"}], ",", "\"\<0\>\"", ",", 
                "\"\<\>\""}], "]"}], "<>", 
              RowBox[{"ToString", "@", "name"}]}], ",", 
             "\"\<_training_mask.gif\>\""}], "]"}], "]"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}], "]"}]}]}], ";",
      "\n", "\t", 
     RowBox[{"{", 
      RowBox[{"LTIim", ",", "LTIref", ",", "LTImask"}], "}"}]}]}], "\n", 
   "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LoadTrainingImagesLarge", "[", 
   RowBox[{"fname_", ",", "refname_", ",", "lum_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"LTIim", ",", "LTIref", ",", "LTImask"}], "}"}], ",", "\n", "\t", 
    RowBox[{
     RowBox[{"LTIim", "=", 
      RowBox[{"Initialize", "[", "fname", "]"}]}], ";", "\n", "\t", 
     RowBox[{"If", "[", 
      RowBox[{"lum", ",", 
       RowBox[{"LTIim", " ", "=", " ", 
        RowBox[{"LuminanceCorrection", "[", 
         RowBox[{"LTIim", ",", "20"}], "]"}]}]}], "]"}], ";", "\n", "\t", 
     RowBox[{"LTIref", "=", 
      RowBox[{"Initialize", "[", "refname", "]"}]}], ";", "\n", "\t", 
     RowBox[{"LTImask", "=", 
      RowBox[{"CreateMask", "[", "LTIim", "]"}]}], ";", "\n", "\t", 
     RowBox[{"{", 
      RowBox[{"LTIim", ",", "LTIref", ",", "LTImask"}], "}"}]}]}], "\n", 
   "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LoadTrainingImagesLargesubimage", "[", 
   RowBox[{"fname_", ",", "refname_", ",", "lum_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"LTIim", ",", "LTIref", ",", "LTImask"}], "}"}], ",", "\n", "\t", 
    RowBox[{
     RowBox[{"LTIim", "=", 
      RowBox[{
       RowBox[{"Initialize", "[", "fname", "]"}], "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"500", ";;", "2000"}], ",", 
         RowBox[{"500", ";;", "2000"}]}], "]"}], "]"}]}], ";", 
     RowBox[{"(*", 
      RowBox[{"!!", 
       RowBox[{"!!", 
        RowBox[{"!", 
         RowBox[{"TERUG", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"AANPASSEN", "!!"}], "!!"}], "!"}]}]}]}]}], "*)"}], "\n", 
     "\t", 
     RowBox[{"If", "[", 
      RowBox[{"lum", ",", 
       RowBox[{"LTIim", " ", "=", " ", 
        RowBox[{"LuminanceCorrection", "[", 
         RowBox[{"LTIim", ",", "20"}], "]"}]}]}], "]"}], ";", "\n", "\t", 
     RowBox[{"LTIref", "=", 
      RowBox[{
       RowBox[{"Initialize", "[", "refname", "]"}], "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"500", ";;", "2000"}], ",", 
         RowBox[{"500", ";;", "2000"}]}], "]"}], "]"}]}], ";", 
     RowBox[{"(*", 
      RowBox[{"!!", 
       RowBox[{"!!", 
        RowBox[{"!", 
         RowBox[{"TERUG", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"AANPASSEN", "!!"}], "!!"}], "!"}]}]}]}]}], "*)"}], "\n", 
     "\t", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"LTImask", "=", 
        RowBox[{"CreateMask", "[", "LTIim", "]"}]}], ";"}], "*)"}], 
     RowBox[{"(*", 
      RowBox[{"!!", 
       RowBox[{"!!", 
        RowBox[{"!", 
         RowBox[{"TERUG", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"AANPASSEN", "!!"}], "!!"}], "!"}]}]}]}]}], "*)"}], "\n", 
     "\t", 
     RowBox[{"LTImask", " ", "=", " ", 
      RowBox[{"ConstantArray", "[", 
       RowBox[{"1", ",", 
        RowBox[{"Dimensions", "[", "LTIim", "]"}]}], "]"}]}], ";", 
     RowBox[{"(*", 
      RowBox[{"!!", 
       RowBox[{"!!", 
        RowBox[{"!", 
         RowBox[{"TERUG", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"AANPASSEN", "!!"}], "!!"}], "!"}]}]}]}]}], "*)"}], "\n", 
     "\t", 
     RowBox[{"{", 
      RowBox[{"LTIim", ",", "LTIref", ",", "LTImask"}], "}"}]}]}], "\n", 
   "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CreateTrainingSamplematrix", "[", 
   RowBox[{
   "CTSim_", ",", "CTSref_", ",", "CTSmask_", ",", "CTSGray_", ",", 
    "CTS\[Sigma]_List", ",", "CTStype_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "pos", ",", "vesselpos", ",", "nonvesselpos", ",", "mask", ",", "im", 
      ",", 
      RowBox[{"size", "=", "50"}], ",", "imgs", ",", "vessel", ",", 
      "nonvessel"}], "}"}], ",", "\n", "\t", 
    RowBox[{
     RowBox[{"mask", " ", "=", " ", "CTSmask"}], ";", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"mask", " ", "=", " ", 
        RowBox[{"CreateMask", "[", "CTSim", "]"}]}], ";"}], "*)"}], " ", 
     RowBox[{"(*", 
      RowBox[{"!!", 
       RowBox[{"!!", 
        RowBox[{"!", 
         RowBox[{"TERUG", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"AANPASSEN", "!!"}], "!!"}], "!"}]}]}]}]}], "*)"}], "\n", 
     "\t", 
     RowBox[{"pos", " ", "=", " ", 
      RowBox[{
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"Flatten", "@", "CTSmask"}], ",", 
         RowBox[{"_", "?", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"#", ">", "0"}], "&"}], ")"}]}]}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", "\n", "\t", 
     RowBox[{"vesselpos", "=", " ", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Flatten", "[", " ", "CTSref", "]"}], "[", 
          RowBox[{"[", "pos", "]"}], "]"}], ",", 
         RowBox[{"_", "?", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"#", ">", "0"}], "&"}], ")"}]}]}], "]"}], "]"}]}], ";", 
     "\n", "\t", 
     RowBox[{"nonvesselpos", "=", " ", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Flatten", "[", 
            RowBox[{"(", 
             RowBox[{"1", "-", "CTSref"}], ")"}], "]"}], "[", 
           RowBox[{"[", "pos", "]"}], "]"}], "*", 
          RowBox[{
           RowBox[{"Flatten", "[", "CTSmask", "]"}], "[", 
           RowBox[{"[", "pos", "]"}], "]"}]}], ",", 
         RowBox[{"_", "?", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"#", ">", "0"}], "&"}], ")"}]}]}], "]"}], "]"}]}], ";", 
     "\n", "\n", "\t", 
     RowBox[{"im", "=", 
      RowBox[{"PadImage", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"mask", "*", "CTSim"}], ")"}], ",", "20", ",", "mask", ",", 
        "5", ",", "size"}], "]"}]}], ";", "\n", "\t", 
     RowBox[{"im", "=", 
      RowBox[{"im", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"Range", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"size", "+", "1"}], ")"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"Dimensions", "[", "im", "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "-", "size"}]}], "]"}], ",", 
         RowBox[{"Range", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"size", "+", "1"}], ")"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"Dimensions", "[", "im", "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "-", "size"}]}], "]"}]}], "]"}], 
       "]"}]}], ";", "\n", "\n", 
     RowBox[{"(*", "\t", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"CTStype", "==", "\"\<Gabor\>\""}], ","}]}], "*)"}], "\n", 
     "\t\t", 
     RowBox[{"imgs", " ", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Flatten", "[", 
           RowBox[{"GaborResponse", "[", 
            RowBox[{"im", ",", "#", ",", "4", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "3"}], "}"}], ",", "CTSmask"}], "]"}], "]"}], 
          "[", 
          RowBox[{"[", "pos", "]"}], "]"}], "&"}], ",", "CTS\[Sigma]"}], 
       "]"}]}], ";", "\n", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{",", "\n", "\t\t", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"CTStype", "==", "\"\<Vesselness\>\""}], ",", 
           RowBox[{
            RowBox[{"imgs", " ", "=", " ", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"Flatten", "[", 
                  RowBox[{
                   RowBox[{"V", "[", 
                    RowBox[{"0.5", ",", "0.05", ",", "mask", ",", "#"}], 
                    "]"}], "[", 
                   RowBox[{"CTSim", "+", "1", "-", "mask"}], "]"}], "]"}], 
                 "[", 
                 RowBox[{"[", "pos", "]"}], "]"}], "&"}], ",", 
               "CTS\[Sigma]"}], "]"}]}], ";"}], "\n", "\t", ",", 
           RowBox[{"Print", "@", "\"\<Unknown type\>\""}]}], "]"}]}], "]"}], 
       ";"}], "*)"}], "\n", "\t", 
     RowBox[{"If", "[", 
      RowBox[{"CTSGray", ",", 
       RowBox[{"imgs", " ", "=", " ", 
        RowBox[{"Prepend", "[", 
         RowBox[{"imgs", ",", 
          RowBox[{
           RowBox[{"Flatten", "[", "im", "]"}], "[", 
           RowBox[{"[", "pos", "]"}], "]"}]}], "]"}]}]}], "]"}], ";", "\n", 
     "\t", 
     RowBox[{"imgs", " ", "=", 
      RowBox[{"NormalizeFeatures", "[", 
       RowBox[{"imgs", ",", "imgs"}], "]"}]}], ";", "\n", "\t", 
     RowBox[{"vessel", " ", "=", " ", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"imgs", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "[", 
          RowBox[{"[", "vesselpos", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "imgs", "]"}]}], "}"}]}], "]"}], "]"}]}], 
     ";", "\n", "\t", 
     RowBox[{"nonvessel", " ", "=", "  ", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"imgs", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "[", 
          RowBox[{"[", "nonvesselpos", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "imgs", "]"}]}], "}"}]}], "]"}], "]"}]}], 
     ";", "\n", "\t", 
     RowBox[{"{", 
      RowBox[{"vessel", ",", "nonvessel"}], "}"}]}]}], "\n", "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CreateTrainingSamplematrixsubimage", "[", 
   RowBox[{
   "CTSim_", ",", "CTSref_", ",", "CTSmask_", ",", "CTSGray_", ",", 
    "CTS\[Sigma]_List", ",", "CTStype_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "pos", ",", "vesselpos", ",", "nonvesselpos", ",", "mask", ",", "im", 
      ",", 
      RowBox[{"size", "=", "50"}], ",", "imgs", ",", "vessel", ",", 
      "nonvessel"}], "}"}], ",", "\n", "\t", 
    RowBox[{
     RowBox[{"mask", " ", "=", " ", "CTSmask"}], ";", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"mask", " ", "=", " ", 
        RowBox[{"CreateMask", "[", "CTSim", "]"}]}], ";"}], "*)"}], " ", 
     RowBox[{"(*", 
      RowBox[{"!!", 
       RowBox[{"!!", 
        RowBox[{"!", 
         RowBox[{"TERUG", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"AANPASSEN", "!!"}], "!!"}], "!"}]}]}]}]}], "*)"}], "\n", 
     "\t", 
     RowBox[{"pos", " ", "=", " ", 
      RowBox[{
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"Flatten", "@", "CTSmask"}], ",", 
         RowBox[{"_", "?", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"#", ">", "0"}], "&"}], ")"}]}]}], "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", "\n", "\t", 
     RowBox[{"vesselpos", "=", " ", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Flatten", "[", " ", "CTSref", "]"}], "[", 
          RowBox[{"[", "pos", "]"}], "]"}], ",", 
         RowBox[{"_", "?", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"#", ">", "0"}], "&"}], ")"}]}]}], "]"}], "]"}]}], ";", 
     "\n", "\t", 
     RowBox[{"nonvesselpos", "=", " ", 
      RowBox[{"Flatten", "[", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Flatten", "[", 
            RowBox[{"(", 
             RowBox[{"1", "-", "CTSref"}], ")"}], "]"}], "[", 
           RowBox[{"[", "pos", "]"}], "]"}], "*", 
          RowBox[{
           RowBox[{"Flatten", "[", "CTSmask", "]"}], "[", 
           RowBox[{"[", "pos", "]"}], "]"}]}], ",", 
         RowBox[{"_", "?", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"#", ">", "0"}], "&"}], ")"}]}]}], "]"}], "]"}]}], ";", 
     "\n", "\t", 
     RowBox[{"im", " ", "=", " ", "CTSim"}], ";", "  ", 
     RowBox[{"(*", 
      RowBox[{"!!", 
       RowBox[{"!!", 
        RowBox[{"!", 
         RowBox[{"TERUG", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"AANPASSEN", "!!"}], "!!"}], "!"}]}]}]}]}], "*)"}], "\n", 
     RowBox[{"(*", "\t", 
      RowBox[{
       RowBox[{"im", "=", 
        RowBox[{"PadImage", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"mask", "*", "CTSim"}], ")"}], ",", "20", ",", "mask", ",",
           "5", ",", "size"}], "]"}]}], ";", "\n", "\t", 
       RowBox[{"im", "=", 
        RowBox[{"im", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"Range", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"size", "+", "1"}], ")"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"Dimensions", "[", "im", "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "-", "size"}]}], "]"}], ",", 
           RowBox[{"Range", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"size", "+", "1"}], ")"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"Dimensions", "[", "im", "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "-", "size"}]}], "]"}]}], 
          "]"}], "]"}]}], ";"}], "*)"}], " ", 
     RowBox[{"(*", 
      RowBox[{"!!", 
       RowBox[{"!!", 
        RowBox[{"!", 
         RowBox[{"TERUG", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"AANPASSEN", "!!"}], "!!"}], "!"}]}]}]}]}], "*)"}], "\n", 
     "\n", 
     RowBox[{"(*", "\t", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"CTStype", "==", "\"\<Gabor\>\""}], ","}]}], "*)"}], "\n", 
     "\t\t", 
     RowBox[{"imgs", " ", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Flatten", "[", 
           RowBox[{"GaborResponse", "[", 
            RowBox[{"im", ",", "#", ",", "4", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "3"}], "}"}], ",", "CTSmask"}], "]"}], "]"}], 
          "[", 
          RowBox[{"[", "pos", "]"}], "]"}], "&"}], ",", "CTS\[Sigma]"}], 
       "]"}]}], ";", "\n", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{",", "\n", "\t\t", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"CTStype", "==", "\"\<Vesselness\>\""}], ",", 
           RowBox[{
            RowBox[{"imgs", " ", "=", " ", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"Flatten", "[", 
                  RowBox[{
                   RowBox[{"V", "[", 
                    RowBox[{"0.5", ",", "0.05", ",", "mask", ",", "#"}], 
                    "]"}], "[", 
                   RowBox[{"CTSim", "+", "1", "-", "mask"}], "]"}], "]"}], 
                 "[", 
                 RowBox[{"[", "pos", "]"}], "]"}], "&"}], ",", 
               "CTS\[Sigma]"}], "]"}]}], ";"}], "\n", "\t", ",", 
           RowBox[{"Print", "@", "\"\<Unknown type\>\""}]}], "]"}]}], "]"}], 
       ";"}], "*)"}], "\n", "\t", 
     RowBox[{"If", "[", 
      RowBox[{"CTSGray", ",", 
       RowBox[{"imgs", " ", "=", " ", 
        RowBox[{"Prepend", "[", 
         RowBox[{"imgs", ",", 
          RowBox[{
           RowBox[{"Flatten", "[", "im", "]"}], "[", 
           RowBox[{"[", "pos", "]"}], "]"}]}], "]"}]}]}], "]"}], ";", "\n", 
     "\t", 
     RowBox[{"imgs", " ", "=", 
      RowBox[{"NormalizeFeatures", "[", 
       RowBox[{"imgs", ",", "imgs"}], "]"}]}], ";", "\n", "\t", 
     RowBox[{"vessel", " ", "=", " ", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"imgs", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "[", 
          RowBox[{"[", "vesselpos", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "imgs", "]"}]}], "}"}]}], "]"}], "]"}]}], 
     ";", "\n", "\t", 
     RowBox[{"nonvessel", " ", "=", "  ", 
      RowBox[{"Transpose", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"imgs", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "[", 
          RowBox[{"[", "nonvesselpos", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "imgs", "]"}]}], "}"}]}], "]"}], "]"}]}], 
     ";", "\n", "\t", 
     RowBox[{"{", 
      RowBox[{"vessel", ",", "nonvessel"}], "}"}]}]}], "\n", "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NormalizeFeatures", "[", 
    RowBox[{"feat_", ",", "flatfeat_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Tflatfeat", " ", "=", " ", 
        RowBox[{"Transpose", "@", "flatfeat"}]}], ",", "\[Mu]", ",", 
       "\[Sigma]"}], "}"}], ",", "\n", "\t", 
     RowBox[{
      RowBox[{"\[Mu]", " ", "=", "  ", 
       RowBox[{"Mean", "[", "Tflatfeat", "]"}]}], ";", "\n", "\t", 
      RowBox[{"\[Sigma]", " ", "=", " ", 
       RowBox[{"StandardDeviation", "[", "Tflatfeat", "]"}]}], ";", "\n", 
      "\t", 
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"#", "-", "\[Mu]"}], ")"}], "/", "\[Sigma]"}], "&"}], "/@", 
        RowBox[{"Transpose", "[", "feat", "]"}]}], "]"}]}]}], "\n", "]"}]}], 
  ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LoadTrainingSet", "[", 
   RowBox[{"start_", ",", "end_", ",", 
    RowBox[{"{", 
     RowBox[{"gray_", ",", "\[Sigma]_List", ",", "lum_", ",", "type_String"}],
      "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"vessel", " ", "=", " ", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"rest", " ", "=", " ", 
       RowBox[{"{", "}"}]}], ",", "trainim", ",", "trainref", ",", 
      "trainmask", ",", "v", ",", "r", ",", "randindex", ",", "priors"}], 
     "}"}], ",", "\n", "\t", 
    RowBox[{
     RowBox[{"PrintTemporary", "[", 
      RowBox[{"Framed", "[", 
       RowBox[{"Row", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ProgressIndicator", "[", 
           RowBox[{
            RowBox[{"Dynamic", "@", "LTS"}], ",", 
            RowBox[{"{", 
             RowBox[{"start", ",", "end"}], "}"}]}], "]"}], ",", 
          RowBox[{
           RowBox[{"LTS", "=", "start"}], ";", 
           RowBox[{"(", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"\"\< \>\"", "<>", 
              RowBox[{"ToString", "[", 
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"LTS", "-", "start"}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{"end", "-", "start", "+", "1"}], ")"}]}], "*", 
                 "100"}], "]"}], "]"}], "<>", "\"\<%\>\""}], "]"}], ")"}]}]}],
          "}"}], "]"}], "]"}], "]"}], ";", "\n", "\t", 
     RowBox[{"Table", "[", "\n", "\t\t", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"trainim", ",", "trainref", ",", "trainmask"}], "}"}], " ", 
         "=", " ", 
         RowBox[{"LoadTrainingImages", "[", 
          RowBox[{
          "\"\<D:/Documents/Dropbox/Mathematica/DRIVE/training/\>\"", ",", 
           "LTS", ",", "lum"}], "]"}]}], ";", "\n", "\t\t", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"v", ",", "r"}], "}"}], " ", "=", " ", 
         RowBox[{"CreateTrainingSamplematrix", "[", 
          RowBox[{
          "trainim", ",", "trainref", ",", "trainmask", ",", "gray", ",", 
           "\[Sigma]", ",", "type"}], "]"}]}], ";", "\n", "\t\t", 
        RowBox[{"vessel", " ", "=", " ", 
         RowBox[{"Join", "[", 
          RowBox[{"vessel", ",", "v"}], "]"}]}], ";", "\n", "\t\t", 
        RowBox[{"rest", " ", "=", " ", 
         RowBox[{"Join", "[", 
          RowBox[{"rest", ",", "r"}], "]"}]}], ";", "\n", "\t\t", 
        RowBox[{"Print", "[", "LTS", "]"}], ";"}], "\n", "\t", ",", 
       RowBox[{"{", 
        RowBox[{"LTS", ",", "start", ",", "end"}], "}"}]}], "]"}], ";", "\n", 
     "\t", 
     RowBox[{"priors", " ", "=", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Length", "[", "vessel", "]"}], ",", 
          RowBox[{"Length", "[", "rest", "]"}]}], "}"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Length", "[", "vessel", "]"}], "+", 
          RowBox[{"Length", "[", "rest", "]"}]}], ")"}]}], "//", "N"}]}], ";",
      "\n", "\n", "\t", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "rest", "]"}], " ", ">", "5000000"}], ",", 
       "\n", "\t\t", 
       RowBox[{
        RowBox[{"randindex", "=", " ", 
         RowBox[{"RandomSample", "[", 
          RowBox[{
           RowBox[{"Range", "[", 
            RowBox[{"Length", "[", "rest", "]"}], "]"}], ",", "5000000"}], 
          "]"}]}], ";", "\n", "\t\t", 
        RowBox[{"rest", " ", "=", " ", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"rest", "[", 
            RowBox[{"[", 
             RowBox[{"randindex", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "5000000"}], "}"}]}], "]"}]}], 
        ";"}]}], "\n", "\t", "]"}], ";", "\n", "\t", "\n", "\t", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "vessel", "]"}], " ", ">", "5000000"}], ",", 
       "\n", "\t\t", 
       RowBox[{
        RowBox[{"randindex", "=", " ", 
         RowBox[{"RandomSample", "[", 
          RowBox[{
           RowBox[{"Range", "[", 
            RowBox[{"Length", "[", "vessel", "]"}], "]"}], ",", "5000000"}], 
          "]"}]}], ";", "\n", "\t\t", 
        RowBox[{"vessel", " ", "=", " ", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"vessel", "[", 
            RowBox[{"[", 
             RowBox[{"randindex", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "5000000"}], "}"}]}], "]"}]}], 
        ";"}]}], "\n", "\t", "]"}], ";", "\n", "\t", "\n", "\t", 
     RowBox[{"{", 
      RowBox[{"vessel", ",", "rest", ",", "priors"}], "}"}]}]}], "\n", 
   "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LoadTrainingSetLarge", "[", 
   RowBox[{"fnames_", ",", "refnames_", ",", 
    RowBox[{"{", 
     RowBox[{"gray_", ",", "\[Sigma]_List", ",", "lum_", ",", "type_String"}],
      "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"vessel", " ", "=", " ", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"rest", " ", "=", " ", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"vessellength", "=", "0"}], ",", 
      RowBox[{"restlength", "=", "0"}], ",", "trainim", ",", "trainref", ",", 
      "trainmask", ",", "v", ",", "r", ",", "randindex", ",", "priors"}], 
     "}"}], ",", "\n", "\t", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"PrintTemporary", "[", 
       RowBox[{"Framed", "[", 
        RowBox[{"Row", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ProgressIndicator", "[", 
            RowBox[{
             RowBox[{"Dynamic", "@", "LTS"}], ",", 
             RowBox[{"{", 
              RowBox[{"start", ",", "end"}], "}"}]}], "]"}], ",", 
           RowBox[{
            RowBox[{"LTS", "=", "start"}], ";", 
            RowBox[{"(", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"\"\< \>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Round", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"LTS", "-", "start"}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{"end", "-", "start", "+", "1"}], ")"}]}], "*", 
                  "100"}], "]"}], "]"}], "<>", "\"\<%\>\""}], "]"}], 
             ")"}]}]}], "}"}], "]"}], "]"}], "]"}], ";"}], "*)"}], "\n", 
    RowBox[{
     RowBox[{"Table", "[", "\n", "\t\t", 
      RowBox[{
       RowBox[{
        RowBox[{"UpdateStatus", "[", 
         RowBox[{"fnames", "[", 
          RowBox[{"[", "LTS", "]"}], "]"}], "]"}], ";", "\n", "\t\t", 
        RowBox[{"Print", "@", 
         RowBox[{"fnames", "[", 
          RowBox[{"[", "LTS", "]"}], "]"}]}], ";", "\n", "\t\t", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"trainim", ",", "trainref", ",", "trainmask"}], "}"}], " ", 
         "=", " ", 
         RowBox[{"LoadTrainingImagesLarge", "[", 
          RowBox[{
           RowBox[{"fnames", "[", 
            RowBox[{"[", "LTS", "]"}], "]"}], ",", 
           RowBox[{"refnames", "[", 
            RowBox[{"[", "LTS", "]"}], "]"}], ",", "lum"}], "]"}]}], ";", 
        "\n", "\t\t", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"v", ",", "r"}], "}"}], " ", "=", " ", 
         RowBox[{"CreateTrainingSamplematrix", "[", 
          RowBox[{
          "trainim", ",", "trainref", ",", "trainmask", ",", "gray", ",", 
           "\[Sigma]", ",", "type"}], "]"}]}], ";", "\n", "\t\t", 
        RowBox[{"vessellength", " ", "+=", 
         RowBox[{"Length", "[", "v", "]"}]}], ";", "\n", "\t\t", 
        RowBox[{"restlength", " ", "+=", " ", 
         RowBox[{"Length", "[", "r", "]"}]}], ";", " ", "\n", "\t\t", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "r", "]"}], " ", ">", "1000000"}], ",", 
          "\n", "\t\t\t", 
          RowBox[{
           RowBox[{"randindex", "=", " ", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"Range", "[", 
               RowBox[{"Length", "[", "r", "]"}], "]"}], ",", "1000000"}], 
             "]"}]}], ";", "\n", "\t\t\t", 
           RowBox[{"r", " ", "=", " ", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"r", "[", 
               RowBox[{"[", 
                RowBox[{"randindex", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", "1000000"}], "}"}]}], "]"}]}], 
           ";"}]}], "\n", "\t\t", "]"}], ";", "\n", "\n", "\t\t", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "v", "]"}], " ", ">", " ", "1000000"}], ",",
           "\n", "\t\t\t", 
          RowBox[{
           RowBox[{"randindex", "=", " ", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"Range", "[", 
               RowBox[{"Length", "[", "v", "]"}], "]"}], ",", "1000000"}], 
             "]"}]}], ";", "\n", "\t\t\t", 
           RowBox[{"v", " ", "=", " ", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"v", "[", 
               RowBox[{"[", 
                RowBox[{"randindex", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", "1000000"}], "}"}]}], "]"}]}], 
           ";"}]}], "\n", "\t\t", "]"}], ";", "\n", "\n", "\t\t", 
        RowBox[{"Print", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"MemoryInUse", "[", "]"}], "/", "1000000"}], "//", "N"}], 
         "]"}], ";", "\n", "\t\t", 
        RowBox[{"vessel", " ", "=", " ", 
         RowBox[{"Join", "[", 
          RowBox[{"vessel", ",", "v"}], "]"}]}], ";", "\n", "\t\t", 
        RowBox[{"rest", " ", "=", " ", 
         RowBox[{"Join", "[", 
          RowBox[{"rest", ",", "r"}], "]"}]}], ";", "\n", "\t\t", 
        RowBox[{"Export", "[", 
         RowBox[{
          RowBox[{"\"\<temp_15images_\>\"", "<>", 
           RowBox[{"ToString", "@", 
            RowBox[{"{", 
             RowBox[{"gray", ",", "\[Sigma]", ",", "lum", ",", "type"}], 
             "}"}]}], "<>", "\"\<_\>\"", "<>", 
           RowBox[{"ToString", "[", "LTS", "]"}], "<>", "\"\<.h5\>\""}], ",", 
          RowBox[{"{", 
           RowBox[{"vessel", ",", "rest", ",", 
            RowBox[{"{", 
             RowBox[{"vessellength", ",", "restlength"}], "}"}], ",", 
            "\[Sigma]"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"\"\<Datasets\>\"", ",", 
            RowBox[{"{", 
             RowBox[{
             "\"\<vessel\>\"", ",", "\"\<rest\>\"", ",", "\"\<priors\>\"", 
              ",", "\"\<feat\>\""}], "}"}]}], "}"}]}], "]"}], ";"}], "\n", 
       "\t", ",", 
       RowBox[{"{", 
        RowBox[{"LTS", ",", "1", ",", 
         RowBox[{"Length", "[", "fnames", "]"}]}], "}"}]}], "]"}], ";", "\n", 
     "\t", 
     RowBox[{"priors", " ", "=", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"vessellength", ",", "restlength"}], "}"}], "/", 
        RowBox[{"(", 
         RowBox[{"vessellength", "+", "restlength"}], ")"}]}], "//", "N"}]}], 
     ";", "\n", "\n", "\t", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "rest", "]"}], " ", ">", "15000000"}], ",", 
       "\n", "\t\t", 
       RowBox[{
        RowBox[{"randindex", "=", " ", 
         RowBox[{"RandomSample", "[", 
          RowBox[{
           RowBox[{"Range", "[", 
            RowBox[{"Length", "[", "rest", "]"}], "]"}], ",", "15000000"}], 
          "]"}]}], ";", "\n", "\t\t", 
        RowBox[{"rest", " ", "=", " ", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"rest", "[", 
            RowBox[{"[", 
             RowBox[{"randindex", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "15000000"}], "}"}]}], "]"}]}], 
        ";"}]}], "\n", "\t", "]"}], ";", "\n", "\n", "\t", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "vessel", "]"}], " ", ">", " ", "15000000"}], 
       ",", "\n", "\t\t", 
       RowBox[{
        RowBox[{"randindex", "=", " ", 
         RowBox[{"RandomSample", "[", 
          RowBox[{
           RowBox[{"Range", "[", 
            RowBox[{"Length", "[", "vessel", "]"}], "]"}], ",", "15000000"}], 
          "]"}]}], ";", "\n", "\t\t", 
        RowBox[{"vessel", " ", "=", " ", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"vessel", "[", 
            RowBox[{"[", 
             RowBox[{"randindex", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "15000000"}], "}"}]}], "]"}]}], 
        ";"}]}], "\n", "\t", "]"}], ";", "\n", "\t", "\n", "\t", 
     RowBox[{"{", 
      RowBox[{"vessel", ",", "rest", ",", "priors"}], "}"}]}]}], "\n", 
   "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LoadTrainingSetLarge2", "[", 
   RowBox[{"fnames_", ",", "refnames_", ",", 
    RowBox[{"{", 
     RowBox[{"gray_", ",", "\[Sigma]_List", ",", "lum_", ",", "type_String"}],
      "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"vessel", " ", "=", " ", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"rest", " ", "=", " ", 
       RowBox[{"{", "}"}]}], ",", "trainim", ",", "trainref", ",", 
      "trainmask", ",", "v", ",", "r", ",", "randindex", ",", "priors"}], 
     "}"}], ",", "\n", "\t", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"PrintTemporary", "[", 
       RowBox[{"Framed", "[", 
        RowBox[{"Row", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ProgressIndicator", "[", 
            RowBox[{
             RowBox[{"Dynamic", "@", "LTS"}], ",", 
             RowBox[{"{", 
              RowBox[{"start", ",", "end"}], "}"}]}], "]"}], ",", 
           RowBox[{
            RowBox[{"LTS", "=", "start"}], ";", 
            RowBox[{"(", 
             RowBox[{"Dynamic", "[", 
              RowBox[{"\"\< \>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{"Round", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"LTS", "-", "start"}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{"end", "-", "start", "+", "1"}], ")"}]}], "*", 
                  "100"}], "]"}], "]"}], "<>", "\"\<%\>\""}], "]"}], 
             ")"}]}]}], "}"}], "]"}], "]"}], "]"}], ";"}], "*)"}], "\n", 
    RowBox[{
     RowBox[{"Table", "[", "\n", "\t\t", 
      RowBox[{
       RowBox[{
        RowBox[{"UpdateStatus", "[", 
         RowBox[{"fnames", "[", 
          RowBox[{"[", "LTS", "]"}], "]"}], "]"}], ";", "\n", "\t\t", 
        RowBox[{"Print", "@", 
         RowBox[{"fnames", "[", 
          RowBox[{"[", "LTS", "]"}], "]"}]}], ";", "\n", "\t\t", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"trainim", ",", "trainref", ",", "trainmask"}], "}"}], " ", 
         "=", " ", 
         RowBox[{"LoadTrainingImagesLarge", "[", 
          RowBox[{
           RowBox[{"fnames", "[", 
            RowBox[{"[", "LTS", "]"}], "]"}], ",", 
           RowBox[{"refnames", "[", 
            RowBox[{"[", "LTS", "]"}], "]"}], ",", "lum"}], "]"}]}], ";", 
        "\n", "\t\t", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"v", ",", "r"}], "}"}], " ", "=", " ", 
         RowBox[{"CreateTrainingSamplematrix", "[", 
          RowBox[{
          "trainim", ",", "trainref", ",", "trainmask", ",", "gray", ",", 
           "\[Sigma]", ",", "type"}], "]"}]}], ";", "\n", "\t\t", 
        RowBox[{"vessel", " ", "=", " ", 
         RowBox[{"Join", "[", 
          RowBox[{"vessel", ",", "v"}], "]"}]}], ";", "\n", "\t\t", 
        RowBox[{"rest", " ", "=", " ", 
         RowBox[{"Join", "[", 
          RowBox[{"rest", ",", "r"}], "]"}]}], ";"}], "\n", "\t", ",", 
       RowBox[{"{", 
        RowBox[{"LTS", ",", "1", ",", 
         RowBox[{"Length", "[", "fnames", "]"}]}], "}"}]}], "]"}], ";", "\n", 
     "\t", 
     RowBox[{"priors", " ", "=", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Length", "[", "vessel", "]"}], ",", 
          RowBox[{"Length", "[", "rest", "]"}]}], "}"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Length", "[", "vessel", "]"}], "+", 
          RowBox[{"Length", "[", "rest", "]"}]}], ")"}]}], "//", "N"}]}], ";",
      "\n", "\n", "\t", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "rest", "]"}], " ", ">", "5000000"}], ",", 
       "\n", "\t\t", 
       RowBox[{
        RowBox[{"randindex", "=", " ", 
         RowBox[{"RandomSample", "[", 
          RowBox[{
           RowBox[{"Range", "[", 
            RowBox[{"Length", "[", "rest", "]"}], "]"}], ",", "2000000"}], 
          "]"}]}], ";", "\n", "\t\t", 
        RowBox[{"rest", " ", "=", " ", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"rest", "[", 
            RowBox[{"[", 
             RowBox[{"randindex", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "2000000"}], "}"}]}], "]"}]}], 
        ";"}]}], "\n", "\t", "]"}], ";", "\n", "\n", "\t", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "vessel", "]"}], " ", ">", " ", "5000000"}], 
       ",", "\n", "\t\t", 
       RowBox[{
        RowBox[{"randindex", "=", " ", 
         RowBox[{"RandomSample", "[", 
          RowBox[{
           RowBox[{"Range", "[", 
            RowBox[{"Length", "[", "vessel", "]"}], "]"}], ",", "2000000"}], 
          "]"}]}], ";", "\n", "\t\t", 
        RowBox[{"vessel", " ", "=", " ", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"vessel", "[", 
            RowBox[{"[", 
             RowBox[{"randindex", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "2000000"}], "}"}]}], "]"}]}], 
        ";"}]}], "\n", "\t", "]"}], ";", "\n", "\t", "\n", "\t", 
     RowBox[{"{", 
      RowBox[{"vessel", ",", "rest", ",", "priors"}], "}"}]}]}], "\n", 
   "]"}]}]], "Code"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create GMM", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CreateGMM", "[", 
    RowBox[{
    "k_", ",", "samplematrix_", ",", "maxiterations_", ",", "savename_", ",", 
     "loadname_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"tmp", "=", "0"}], ",", "nsamples", ",", "nfeatures", ",", 
       "randindex", ",", 
       RowBox[{"scale", "=", "1000"}], ",", "gaussians", ",", 
       RowBox[{"\[Epsilon]", "=", "0.0001"}], ",", "T", ",", 
       RowBox[{"iterations", "=", "0"}], ",", 
       RowBox[{"minvar", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "/", 
           RowBox[{"(", 
            RowBox[{"10", "*", "k"}], ")"}]}], ")"}], "^", "2"}]}], ",", 
       RowBox[{"Q", "=", 
        RowBox[{
         RowBox[{"-", "1"}], "*", 
         RowBox[{"10", "^", "10"}]}]}], ",", "difference", ",", 
       RowBox[{"condlimit", "=", 
        RowBox[{"10", "^", "7"}]}]}], "}"}], ",", "\n", "\t", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"nsamples", ",", "nfeatures"}], "}"}], "=", 
       RowBox[{"Dimensions", "[", "samplematrix", "]"}]}], ";", "\n", "\t", 
      RowBox[{"randindex", "=", " ", 
       RowBox[{"RandomSample", "[", 
        RowBox[{
         RowBox[{"Range", "[", "nsamples", "]"}], ",", "k"}], "]"}]}], ";", 
      "\n", "\t", 
      RowBox[{"gaussians", " ", "=", " ", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"samplematrix", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"randindex", "[", 
                RowBox[{"[", "i", "]"}], "]"}], ",", "All"}], "]"}], "]"}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", "k"}], "}"}]}], "]"}], ",", 
          RowBox[{"ConstantArray", "[", 
           RowBox[{
            RowBox[{"1", "/", "k"}], ",", 
            RowBox[{"{", "k", "}"}]}], "]"}], ",", " ", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"IdentityMatrix", "[", "nfeatures", "]"}], "*", 
             "scale"}], ",", 
            RowBox[{"{", "k", "}"}]}], "]"}]}], "}"}], "]"}]}], ";", "\n", 
      "\t", 
      RowBox[{"T", "=", 
       RowBox[{"\[Epsilon]", "*", "nsamples"}]}], ";", "\n", "\t", 
      RowBox[{"difference", " ", "=", " ", 
       RowBox[{"T", "+", "1"}]}], ";", "\n", "\t", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"loadname", "!=", "\"\<\>\""}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "iterations", ",", "difference", ",", "gaussians", ",", "Q"}], 
          "}"}], " ", "=", " ", 
         RowBox[{"ToExpression", "@", 
          RowBox[{"Import", "[", 
           RowBox[{
            RowBox[{"NotebookDirectory", "[", "]"}], "<>", "loadname"}], 
           "]"}]}]}]}], "]"}], ";", "\n", "\t", 
      RowBox[{"PrintTemporary", "[", 
       RowBox[{"Framed", "[", 
        RowBox[{"Row", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ProgressIndicator", "[", 
            RowBox[{
             RowBox[{"Dynamic", "@", "iterations"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "maxiterations"}], "}"}]}], "]"}], ",", 
           RowBox[{"Dynamic", "[", 
            RowBox[{"\"\< \>\"", "<>", 
             RowBox[{"ToString", "[", 
              RowBox[{"Round", "[", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", "iterations", ")"}], "/", 
                  RowBox[{"(", "maxiterations", ")"}]}], "*", "100"}], ")"}], 
               "]"}], "]"}], "<>", "\"\<%\>\""}], "]"}]}], "}"}], "]"}], 
        "]"}], "]"}], ";", "\n", "\n", "\t", 
      RowBox[{"While", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"tmp", "<", "2"}], "\[Or]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"difference", ">", "T"}], "\[And]", 
           RowBox[{"iterations", "<", "maxiterations"}]}], ")"}]}], ",", "\n",
         "\t\t", 
        RowBox[{
         RowBox[{"Print", "@", "\"\<Hij doet het\>\""}], ";", "\n", "\t\t", 
         RowBox[{"tmp", "+=", "1"}], ";", "\n", "\t\t", 
         RowBox[{"iterations", " ", "+=", "1"}], ";", "\n", "\t\t", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"difference", ",", "gaussians", ",", "Q"}], "}"}], " ", 
          "=", " ", 
          RowBox[{"CalculateNewParameters", "[", 
           RowBox[{
           "gaussians", ",", "nsamples", ",", "nfeatures", ",", 
            "samplematrix", ",", "Q", ",", "condlimit"}], "]"}]}], ";", "\n", 
         "\t\t", 
         RowBox[{"PrintTemporary", "[", "iterations", "]"}], ";", "\n", 
         "\t\t", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"savename", "!=", "\"\<\>\""}], ",", 
           RowBox[{"Export", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"NotebookDirectory", "[", "]"}], "<>", "savename"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{
              "iterations", ",", "difference", ",", "gaussians", ",", "Q"}], 
              "}"}], ",", "\"\<String\>\""}], "]"}]}], "]"}], ";"}]}], "\n", 
       "\t", "]"}], ";", "\n", "\n", "\t", 
      RowBox[{"Print", "[", 
       RowBox[{"StringJoin", "[", 
        RowBox[{"\"\<Iterations used: \>\"", ",", 
         RowBox[{"ToString", "[", "iterations", "]"}]}], "]"}], "]"}], ";", 
      "\n", "\t", "gaussians"}]}], "\n", "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"pdf", "[", 
    RowBox[{"g_", ",", "nfeatures_", ",", "samplematrix_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"func", ",", "z"}], "}"}], ",", "\n", "\t", 
     RowBox[{
      RowBox[{"func", " ", "=", 
       RowBox[{
        RowBox[{"PDF", "[", 
         RowBox[{
          RowBox[{"MultinormalDistribution", "[", 
           RowBox[{
            RowBox[{"g", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"g", "[", 
             RowBox[{"[", "3", "]"}], "]"}]}], "]"}], ",", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"z", "[", "#", "]"}], "&"}], ",", 
            RowBox[{"Range", "@", "nfeatures"}]}], "]"}]}], "]"}], "*", 
        RowBox[{"g", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}]}], ";", "\n", "\t", 
      RowBox[{"func", "/.", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Rule", "[", 
           RowBox[{
            RowBox[{"z", "[", "#", "]"}], ",", 
            RowBox[{"samplematrix", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "#"}], "]"}], "]"}]}], "]"}], "&"}], ",", 
         RowBox[{"Range", "@", "nfeatures"}]}], "]"}]}]}]}], "\n", "]"}]}], 
  ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExpectedLogLikelihood", "[", 
    RowBox[{"p_", ",", "g_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "llh", "}"}], ",", "\n", "\t", 
     RowBox[{"llh", "=", 
      RowBox[{"Dot", "[", 
       RowBox[{"p", ",", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"#", ">", "0"}], ",", 
             RowBox[{"Log", "[", "#", "]"}], ",", "0"}], "]"}], "&"}], ",", 
          "p"}], "]"}]}], "]"}]}]}], "\n", "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CalculateNewParameters", "[", 
    RowBox[{
    "gaussians_", ",", "nsamples_", ",", "nfeatures_", ",", "samplematrix_", 
     ",", "Q_", ",", "condlimit_"}], "]"}], " ", ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "difference", ",", "gaussiansold", ",", "p", ",", 
       "expectedloglikelihood", ",", "tot", ",", "sampleprob", ",", 
       "somaprob", ",", "a"}], "}"}], ",", "\n", "\t", 
     RowBox[{
      RowBox[{"gaussiansold", " ", "=", " ", "gaussians"}], ";", "\n", "\t", 
      RowBox[{"p", "=", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"pdf", "[", 
           RowBox[{"#", ",", "nfeatures", ",", "samplematrix"}], "]"}], "&"}],
          ",", "gaussians", ",", 
         RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\n", "\t", 
      RowBox[{"expectedloglikelihood", "=", 
       RowBox[{"Total", "[", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"ExpectedLogLikelihood", "[", 
            RowBox[{"#", ",", "gaussians"}], "]"}], "&"}], ",", 
          RowBox[{"Transpose", "@", "p"}], ",", 
          RowBox[{"{", "1", "}"}]}], "]"}], "]"}]}], ";", "\n", "\n", "\t", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"p", " ", "=", " ", 
         RowBox[{"Transpose", "@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"#", " ", "/", 
              RowBox[{"Total", "[", "#", "]"}]}], "&"}], ",", 
            RowBox[{"Transpose", "@", "p"}]}], "]"}]}]}], ";"}], "*)"}], "\n",
       "\t", 
      RowBox[{"p", " ", "=", " ", 
       RowBox[{"Transpose", "@", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"tot", " ", "=", 
              RowBox[{"Total", "[", "#", "]"}]}], ";", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"tot", "!=", "0"}], ",", " ", 
               RowBox[{"#", " ", "/", "tot"}], ",", 
               RowBox[{"ConstantArray", "[", 
                RowBox[{
                 RowBox[{"1", "/", 
                  RowBox[{
                   RowBox[{"Dimensions", "[", "gaussiansold", "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Dimensions", "[", "gaussiansold", "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "}"}]}], "]"}]}], "]"}]}], 
            ")"}], "&"}], ",", 
          RowBox[{"Transpose", "@", "p"}]}], "]"}]}]}], ";", "\n", "\n", "\t", 
      RowBox[{"Table", "[", "\n", "\t\t", 
       RowBox[{
        RowBox[{
         RowBox[{"UpdateStatus", "[", 
          RowBox[{"\"\<Currently at:\>\"", "<>", 
           RowBox[{"ToString", "[", "i", "]"}]}], "]"}], ";", "\n", "\t\t", 
         RowBox[{"somaprob", " ", "=", " ", 
          RowBox[{"Total", "[", 
           RowBox[{"p", "[", 
            RowBox[{"[", 
             RowBox[{"i", ",", "All"}], "]"}], "]"}], "]"}]}], ";", "\n", 
         "\t\t", 
         RowBox[{
          RowBox[{"gaussiansold", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "3"}], "]"}], "]"}], " ", "=", 
          RowBox[{
           RowBox[{
            RowBox[{"Total", "[", 
             RowBox[{"MapIndexed", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"a", "=", 
                   RowBox[{"#1", "-", 
                    RowBox[{"gaussiansold", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", "1"}], "]"}], "]"}]}]}], ",", 
                  RowBox[{
                   RowBox[{"p", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", ",", 
                    RowBox[{"#2", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}], 
                   RowBox[{"KroneckerProduct", "[", 
                    RowBox[{"a", ",", "a"}], "]"}]}]}], "}"}], "&"}], ",", 
               "samplematrix"}], "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], "/", "somaprob"}]}], ";", "\n", 
         "\t\t", 
         RowBox[{
          RowBox[{"gaussiansold", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "1"}], "]"}], "]"}], "=", " ", 
          RowBox[{
           RowBox[{"Dot", "[", 
            RowBox[{
             RowBox[{"p", "[", 
              RowBox[{"[", 
               RowBox[{"i", ",", "All"}], "]"}], "]"}], ",", "samplematrix"}],
             "]"}], "/", "somaprob"}]}], ";", "\n", "\t\t", 
         RowBox[{
          RowBox[{"gaussiansold", "[", 
           RowBox[{"[", 
            RowBox[{"i", ",", "2"}], "]"}], "]"}], "=", 
          RowBox[{"somaprob", "/", "nsamples"}]}], ";"}], "\n", "\t", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{
           RowBox[{"Dimensions", "[", "gaussiansold", "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "]"}], ";", "\n", "\t", 
      "\n", "\t", 
      RowBox[{"difference", " ", "=", " ", 
       RowBox[{"Abs", "[", 
        RowBox[{"expectedloglikelihood", "-", "Q"}], "]"}]}], ";", "\n", "\t", 
      RowBox[{"gaussiansold", "=", 
       RowBox[{"Delete", "[", 
        RowBox[{"gaussiansold", ",", 
         RowBox[{"Position", "[", 
          RowBox[{
           RowBox[{"gaussiansold", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "3"}], "]"}], "]"}], ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"LinearAlgebra`MatrixConditionNumber", "@", "#"}], ">",
                "condlimit"}], "&"}], ")"}]}], ",", "3"}], "]"}]}], "]"}]}], 
      ";", "\n", "\t", 
      RowBox[{"{", 
       RowBox[{
       "difference", ",", "gaussiansold", ",", "expectedloglikelihood"}], 
       "}"}]}]}], "\n", "]"}]}], ";"}]], "Code"]
}, Closed]],

Cell[CellGroupData[{

Cell["Segment Image", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CreateSamplematrix", "[", 
   RowBox[{"CSim_", ",", 
    RowBox[{"{", 
     RowBox[{
     "CSGray_", ",", "CS\[Sigma]_List", ",", "CSlum_", ",", "CStype_"}], 
     "}"}], ",", "mask_"}], "]"}], ":=", "\n", "\t", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"im", ",", "pos", ",", "imgspos", ",", 
      RowBox[{"size", "=", "50"}], ",", "lim", ",", "imgs", ",", "vessel", 
      ",", "nonvessel"}], "}"}], ",", "\n", "\t\t", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{"CSlum", ",", 
       RowBox[{"lim", " ", "=", " ", 
        RowBox[{"LuminanceCorrection", "[", 
         RowBox[{"CSim", ",", "20"}], "]"}]}], ",", 
       RowBox[{"lim", "=", "CSim"}]}], "]"}], ";", " ", 
     RowBox[{"(*", 
      RowBox[{
      "Correct", " ", "for", " ", "luminance", " ", "if", " ", "needed"}], 
      "*)"}], "\n", "\t\t", 
     RowBox[{"pim", "=", 
      RowBox[{"PadImage", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"mask", "*", "lim"}], ")"}], ",", "20", ",", "mask", ",", 
        "5", ",", "size"}], "]"}]}], ";", " ", 
     RowBox[{"(*", 
      RowBox[{"Pad", " ", "image"}], "*)"}], "\n", "\t\t", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"NumericQ", "[", 
        RowBox[{"Max", "@", "pim"}], "]"}], ",", 
       RowBox[{"im", "=", 
        RowBox[{"pim", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"Range", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"size", "+", "1"}], ")"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"Dimensions", "[", "pim", "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "-", "size"}]}], "]"}], ",", 
           RowBox[{"Range", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"size", "+", "1"}], ")"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"Dimensions", "[", "pim", "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "-", "size"}]}], "]"}]}], 
          "]"}], "]"}]}], ",", 
       RowBox[{"im", "=", "lim"}]}], "]"}], ";", " ", 
     RowBox[{"(*", 
      RowBox[{
      "Delete", " ", "padding", " ", "but", " ", "containing", " ", "the", 
       " ", "padded", " ", "part"}], "*)"}], "\n", "\t\t", 
     RowBox[{"pos", " ", "=", " ", 
      RowBox[{"Flatten", "@", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"Flatten", "@", 
          RowBox[{"Round", "@", "mask"}]}], ",", "1"}], "]"}]}]}], ";", " ", 
     RowBox[{"(*", 
      RowBox[{"Positions", " ", "of", " ", "the", " ", "mask"}], "*)"}], "\n",
      "\n", "\t\t", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"CStype", "==", "\"\<Gabor\>\""}], ",", 
         RowBox[{"Print", "@", "\"\<gyes\>\""}], ",", 
         RowBox[{"Print", "@", "\"\<gno\>\""}]}], "]"}], ";"}], "*)"}], "\n", 
     "\n", "\t\t", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"CStype", "==", "\"\<Gabor\>\""}], ",", " ", 
         RowBox[{"(*", 
          RowBox[{"Calculate", " ", "the", " ", "image", " ", "features"}], 
          "*)"}], "\n", "\t\t\t", 
         RowBox[{
          RowBox[{"imgs", " ", "=", 
           RowBox[{"Map", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Flatten", "[", 
               RowBox[{"GaborResponse", "[", 
                RowBox[{"im", ",", "#", ",", "4", ",", 
                 RowBox[{"{", 
                  RowBox[{"0", ",", "3"}], "}"}], ",", "mask"}], "]"}], "]"}],
               "&"}], ",", "CS\[Sigma]"}], "]"}]}], ";", 
          RowBox[{"Print", "@", "\"\<po\>\""}], ";"}], ",", " ", "\n", 
         "\t\t\t", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"CStype", "==", "\"\<Vesselness\>\""}], ",", 
           RowBox[{
            RowBox[{"imgs", " ", "=", " ", 
             RowBox[{"Map", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Flatten", "[", 
                 RowBox[{
                  RowBox[{"V", "[", 
                   RowBox[{"0.5", ",", "0.2", ",", "mask", ",", "#"}], "]"}], 
                  "[", "im", "]"}], "]"}], "&"}], ",", "CS\[Sigma]"}], 
              "]"}]}], ";"}], "\n", "\t\t", ",", 
           RowBox[{"Print", "@", "\"\<Unknown type\>\""}]}], "]"}]}], "]"}], 
       ";"}], "*)"}], "\n", "\t\t", "\n", "\t\t", 
     RowBox[{"imgs", " ", "=", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Flatten", "[", 
          RowBox[{"GaborResponse", "[", 
           RowBox[{"im", ",", "#", ",", "4", ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "3"}], "}"}], ",", "mask"}], "]"}], "]"}], 
         "&"}], ",", "CS\[Sigma]"}], "]"}]}], ";", "\n", "\n", "\t\t", 
     RowBox[{"If", "[", 
      RowBox[{"CSGray", ",", 
       RowBox[{"imgs", " ", "=", " ", 
        RowBox[{"Prepend", "[", 
         RowBox[{"imgs", ",", 
          RowBox[{"Flatten", "@", 
           RowBox[{"(", 
            RowBox[{"im", "*", "mask"}], ")"}]}]}], "]"}]}]}], "]"}], ";", 
     " ", 
     RowBox[{"(*", 
      RowBox[{
      "Append", " ", "the", " ", "grey", " ", "values", " ", "if", " ", 
       "desired"}], "*)"}], "\n", "\n", "\t\t", 
     RowBox[{"imgspos", " ", "=", " ", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "pos", "]"}], "]"}], "&"}], ",", "imgs"}], "]"}]}], 
     ";", " ", "\n", "\n", "\t\t", 
     RowBox[{"imgs", " ", "=", " ", 
      RowBox[{"NormalizeFeatures", "[", 
       RowBox[{"imgs", ",", "imgspos"}], "]"}]}], ";", " ", 
     RowBox[{"(*", 
      RowBox[{
      "Normalize", " ", "features", " ", "at", " ", "the", " ", "positions"}],
       "*)"}], "\n", "\n", "\t\t", 
     RowBox[{"imgs", " ", "=", " ", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ListToMatrix", "[", 
          RowBox[{"#", ",", 
           RowBox[{
            RowBox[{"Dimensions", "[", "CSim", "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{
            RowBox[{"Dimensions", "[", "CSim", "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "&"}], ",", "imgs"}], 
       "]"}]}]}]}], "\n", "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"ClassImage", "[", 
    RowBox[{"gaussians_", ",", "samplematrix_", ",", "prior_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"class", " ", ",", "z", ",", 
       RowBox[{"nfeat", "=", 
        RowBox[{
         RowBox[{"Dimensions", "[", 
          RowBox[{"gaussians", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}]}]}], "}"}], ",", "\n", "\t", 
     RowBox[{
      RowBox[{"class", " ", "=", " ", 
       RowBox[{"Total", "[", " ", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "*", 
            RowBox[{"PDF", "[", 
             RowBox[{
              RowBox[{"MultinormalDistribution", "[", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "3", "]"}], "]"}]}], "]"}], ",", 
              RowBox[{"Map", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"z", "[", "#", "]"}], "&"}], ",", 
                RowBox[{"Range", "[", "nfeat", "]"}]}], "]"}]}], "]"}]}], 
           "&"}], ",", "gaussians"}], "]"}], "]"}]}], ";", "\n", "\t", 
      RowBox[{"class", " ", "=", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"class", "/.", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Rule", "[", 
              RowBox[{
               RowBox[{"z", "[", "#", "]"}], ",", 
               RowBox[{"samplematrix", "[", 
                RowBox[{"[", "#", "]"}], "]"}]}], "]"}], "&"}], ",", 
            RowBox[{"Range", "[", "nfeat", "]"}]}], "]"}]}], ")"}], "*", 
        "prior"}]}]}]}], " ", 
    RowBox[{"(*", "*)"}], "\n", "]"}]}], "*)"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ClassImage", " ", "=", " ", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"samplematrix", ",", "_Real", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"gaussian", ",", "_Real", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"cov", ",", "_Real", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"weight", ",", "_Real", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"prior", ",", "_Real"}], "}"}]}], "}"}], ",", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"xminmu", ",", "constant", ",", "inv"}], "}"}], ",", "\n", 
       "\t", 
       RowBox[{"Plus", "@@", 
        RowBox[{"Table", "[", "\n", "\t\t", 
         RowBox[{
          RowBox[{
           RowBox[{"inv", " ", "=", " ", 
            RowBox[{"Inverse", "[", 
             RowBox[{"cov", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ";", "\n", "\t\t", 
           RowBox[{"xminmu", "=", 
            RowBox[{"Transpose", "[", " ", 
             RowBox[{
              RowBox[{"samplematrix", "-", 
               RowBox[{"gaussian", "[", 
                RowBox[{"[", "i", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}]}], ";", "\n",
            "\t\t", 
           RowBox[{"constant", " ", "=", " ", 
            RowBox[{"prior", "*", 
             RowBox[{"weight", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "*", 
             RowBox[{"1", "/", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"2", "\[Pi]"}], ")"}], "^", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Length", "[", 
                    RowBox[{"gaussian", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], "/", "2"}], 
                  ")"}]}], "*", 
                RowBox[{
                 RowBox[{"Det", "[", 
                  RowBox[{"cov", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "]"}], "^", 
                 RowBox[{"(", 
                  RowBox[{"1", "/", "2"}], ")"}]}]}], ")"}]}]}]}], ";", "\n", 
           "\t\t", 
           RowBox[{"constant", "*", 
            RowBox[{"Exp", "[", 
             RowBox[{
              RowBox[{"-", "0.5"}], 
              RowBox[{"Map", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"#", ".", "inv", ".", "#"}], "&"}], ",", "xminmu", 
                ",", 
                RowBox[{"{", "2", "}"}]}], "]"}]}], " ", "]"}]}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "gaussian", "]"}]}], "}"}]}], "]"}]}]}], 
      "\n", "]"}]}], "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SegmentImage", "[", 
    RowBox[{"SIim_", ",", 
     RowBox[{"{", 
      RowBox[{"SIgvessel_", ",", "SIgrest_", ",", "SIprior_", ",", 
       RowBox[{"{", 
        RowBox[{
        "SIgray_", ",", "SI\[Sigma]_", ",", "SIlum_", ",", "SItype_"}], 
        "}"}]}], "}"}], ",", "mask_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"grest", "=", 
        RowBox[{"Transpose", "[", "SIgrest", "]"}]}], ",", 
       RowBox[{"gvessel", "=", 
        RowBox[{"Transpose", "[", "SIgvessel", "]"}]}], ",", "samplematrix", 
       ",", "vesselclass", ",", "restclass", ",", "imsegm", ",", "postprob"}],
       "}"}], ",", "\n", "\n", "\t", 
     RowBox[{
      RowBox[{
      "UpdateStatus", "[", "\"\<Calculating SampleMatrix...\>\"", "]"}], ";", 
      "\n", "\t", 
      RowBox[{"samplematrix", " ", "=", " ", 
       RowBox[{"CreateSamplematrix", "[", 
        RowBox[{"SIim", ",", 
         RowBox[{"{", 
          RowBox[{"SIgray", ",", "SI\[Sigma]", ",", "SIlum", ",", "SItype"}], 
          "}"}], ",", "mask"}], "]"}]}], ";", "\n", "\t", 
      RowBox[{
      "UpdateStatus", "[", 
       "\"\<Calculating vessel class probabilities...\>\"", "]"}], ";", "\n", 
      "\t", 
      RowBox[{"vesselclass", " ", "=", " ", 
       RowBox[{"ClassImage", "[", 
        RowBox[{"samplematrix", ",", 
         RowBox[{"gvessel", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"gvessel", "[", 
          RowBox[{"[", "3", "]"}], "]"}], ",", 
         RowBox[{"gvessel", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{"SIprior", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], ";", "\n", "\t", 
      RowBox[{
      "UpdateStatus", "[", "\"\<Calculating rest class probabilities...\>\"", 
       "]"}], ";", "\n", "\t", 
      RowBox[{"restclass", " ", "=", " ", 
       RowBox[{"ClassImage", "[", 
        RowBox[{"samplematrix", ",", 
         RowBox[{"grest", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"grest", "[", 
          RowBox[{"[", "3", "]"}], "]"}], ",", 
         RowBox[{"grest", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{"SIprior", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], ";", "\n", "\t", 
      RowBox[{"UpdateStatus", "[", "\"\<Segmenting image...\>\"", "]"}], ";", 
      "\n", "\t", 
      RowBox[{"imsegm", " ", "=", " ", 
       RowBox[{"UnitStep", "[", 
        RowBox[{"vesselclass", "-", "restclass"}], "]"}]}], ";", "\n", "\t", 
      RowBox[{"UpdateStatus", "[", "\"\<Done...\>\"", "]"}], ";", "\n", "\t", 
      "imsegm"}]}], "\n", "\t", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"postprob", " ", "=", " ", 
       RowBox[{"vesselclass", "/", 
        RowBox[{"(", 
         RowBox[{"vesselclass", "+", "restclass"}], ")"}]}]}], ";"}], "*)"}], 
    "\n", "\t", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"UpdateStatus", "[", "\"\<Done...\>\"", "]"}], ";", "\n", "\t", 
      RowBox[{"{", 
       RowBox[{"imsegm", ",", "postprob"}], "}"}]}], "*)"}], "\n", "]"}]}], 
  ";"}]], "Code"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Features", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FractalDimensionBoxcounting", "[", 
    RowBox[{"FDBim_", ",", 
     RowBox[{"FDBdiskcenter_:", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}], ",", 
     RowBox[{"FDBr_:", "0"}], ",", 
     RowBox[{"FDBdisk_:", "0"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "data", ",", "fit", ",", "maxR", ",", "disk", ",", "disk2", ",", "x", 
       ",", 
       RowBox[{"im", "=", "FDBim"}]}], "}"}], ",", "\t", "\n", "\t", 
     RowBox[{
      RowBox[{
      "UpdateStatus", "[", 
       "\"\<Calculating fractal dimension - Box-counting...\>\"", "]"}], ";", 
      "\n", "\t", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"FDBr", ">", "0"}], ",", "\n", "\t\t", 
        RowBox[{
         RowBox[{"maxR", "=", 
          RowBox[{"Min", "@", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Round", "[", "FDBr", "]"}], ",", 
             RowBox[{"Round", "@", "FDBdiskcenter"}], ",", 
             RowBox[{
              RowBox[{"Dimensions", "[", "FDBim", "]"}], "-", 
              "FDBdiskcenter"}]}], "}"}]}]}], ";", "\n", "\t\t", 
         RowBox[{"disk", "=", 
          RowBox[{"ArrayPad", "[", 
           RowBox[{
            RowBox[{"RotateLeft", "[", 
             RowBox[{
              RowBox[{"DiskMatrix", "[", 
               RowBox[{"maxR", ",", 
                RowBox[{
                 RowBox[{"Dimensions", "[", "FDBim", "]"}], "+", 
                 RowBox[{"2", "maxR"}]}]}], "]"}], ",", 
              RowBox[{"Round", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Dimensions", "[", "FDBim", "]"}], "/", "2"}], "-", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"FDBdiskcenter", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{"FDBdiskcenter", "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}]}], "]"}], 
            ",", 
            RowBox[{"-", "maxR"}]}], "]"}]}], ";", "\n", "\t\t", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"FDBdisk", ">", "0"}], ",", 
           RowBox[{"disk2", "=", 
            RowBox[{"ArrayPad", "[", 
             RowBox[{
              RowBox[{"RotateLeft", "[", 
               RowBox[{
                RowBox[{"DiskMatrix", "[", 
                 RowBox[{"FDBdisk", ",", 
                  RowBox[{
                   RowBox[{"Dimensions", "[", "FDBim", "]"}], "+", 
                   RowBox[{"2", "maxR"}]}]}], "]"}], ",", 
                RowBox[{"Round", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Dimensions", "[", "FDBim", "]"}], "/", "2"}], "-", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"FDBdiskcenter", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"FDBdiskcenter", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}]}], "]"}],
               ",", 
              RowBox[{"-", "maxR"}]}], "]"}]}], ",", 
           RowBox[{"disk2", "=", 
            RowBox[{"ConstantArray", "[", 
             RowBox[{"0", ",", 
              RowBox[{"Dimensions", "[", "FDBim", "]"}]}], "]"}]}]}], "]"}], 
         ";", "\n", "\t\t", 
         RowBox[{"im", "=", 
          RowBox[{"UnitStep", "[", 
           RowBox[{
            RowBox[{"ImageData", "[", 
             RowBox[{"ImageCrop", "[", 
              RowBox[{"Image", "[", 
               RowBox[{
                RowBox[{"FDBim", "*", "disk"}], "+", "disk", "-", "disk2"}], 
               "]"}], "]"}], "]"}], "-", "1.1"}], "]"}]}], ";"}]}], "\n", 
       "\t", "]"}], ";", "\n", "\n", "\t\t", 
      RowBox[{"data", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Log", "[", 
            RowBox[{"1", "/", "x"}], "]"}], ",", 
           RowBox[{"Log", "[", 
            RowBox[{"Total", "@", 
             RowBox[{"UnitStep", "[", 
              RowBox[{
               RowBox[{"Map", "[", 
                RowBox[{"Total", ",", 
                 RowBox[{"Flatten", "[", 
                  RowBox[{
                   RowBox[{"Partition", "[", 
                    RowBox[{"im", ",", 
                    RowBox[{"{", 
                    RowBox[{"x", ",", "x"}], "}"}]}], "]"}], ",", "1"}], 
                  "]"}], ",", "2"}], "]"}], "-", "0.1"}], "]"}]}], "]"}]}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", 
           RowBox[{"NestWhileList", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "*", "2"}], "&"}], ",", "1", ",", 
             RowBox[{
              RowBox[{"#", "<", 
               RowBox[{
                RowBox[{"Min", "@", 
                 RowBox[{"Dimensions", "[", "im", "]"}]}], "/", "2"}]}], 
              "&"}]}], "]"}]}], "}"}]}], "]"}]}], ";", "\n", "\t\t", 
      RowBox[{"fit", "=", 
       RowBox[{"LinearModelFit", "[", 
        RowBox[{"data", ",", "x", ",", "x"}], "]"}]}], ";", "\n", "\t\t", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"fit", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "2", ",", "2"}], "]"}], "]"}], ",", "fit", ",", 
        RowBox[{"fit", "[", "\"\<RSquared\>\"", "]"}], ",", "data"}], 
       "}"}]}]}], "\n", "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FractalDimensionDilation", "[", 
    RowBox[{"FDDim_", ",", 
     RowBox[{"FDDmaxdilation_:", "40"}], ",", 
     RowBox[{"FDDdiskcenter_:", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}], ",", 
     RowBox[{"FDDr_:", "0"}], ",", 
     RowBox[{"FDDdisk_:", "0"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "data", ",", "fit", ",", "maxR", ",", "disk", ",", "disk2", ",", "x", 
       ",", 
       RowBox[{"im", "=", "FDDim"}]}], "}"}], ",", "\n", "\t", 
     RowBox[{
      RowBox[{
      "UpdateStatus", "[", 
       "\"\<Calculating fractal dimension - Dilation...\>\"", "]"}], ";", 
      "\n", "\t", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"FDDr", ">", "0"}], ",", "\n", "\t\t", 
        RowBox[{
         RowBox[{"maxR", "=", 
          RowBox[{"Min", "@", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Round", "[", "FDDr", "]"}], ",", 
             RowBox[{"Round", "@", "FDDdiskcenter"}], ",", 
             RowBox[{
              RowBox[{"Dimensions", "[", "FDDim", "]"}], "-", 
              "FDDdiskcenter"}]}], "}"}]}]}], ";", "\n", "\t\t", 
         RowBox[{"disk", "=", 
          RowBox[{"ArrayPad", "[", 
           RowBox[{
            RowBox[{"RotateLeft", "[", 
             RowBox[{
              RowBox[{"DiskMatrix", "[", 
               RowBox[{"maxR", ",", 
                RowBox[{
                 RowBox[{"Dimensions", "[", "FDDim", "]"}], "+", 
                 RowBox[{"2", "maxR"}]}]}], "]"}], ",", 
              RowBox[{"Round", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Dimensions", "[", "FDDim", "]"}], "/", "2"}], "-", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"FDDdiskcenter", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{"FDDdiskcenter", "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}]}], "]"}], 
            ",", 
            RowBox[{"-", "maxR"}]}], "]"}]}], ";", "\n", "\t\t", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"FDDdisk", ">", "0"}], ",", 
           RowBox[{"disk2", "=", 
            RowBox[{"ArrayPad", "[", 
             RowBox[{
              RowBox[{"RotateLeft", "[", 
               RowBox[{
                RowBox[{"DiskMatrix", "[", 
                 RowBox[{"FDDdisk", ",", 
                  RowBox[{
                   RowBox[{"Dimensions", "[", "FDDim", "]"}], "+", 
                   RowBox[{"2", "maxR"}]}]}], "]"}], ",", 
                RowBox[{"Round", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Dimensions", "[", "FDDim", "]"}], "/", "2"}], "-", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"FDDdiskcenter", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"FDDdiskcenter", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}]}], "]"}],
               ",", 
              RowBox[{"-", "maxR"}]}], "]"}]}], ",", 
           RowBox[{"disk2", "=", 
            RowBox[{"ConstantArray", "[", 
             RowBox[{"0", ",", 
              RowBox[{"Dimensions", "[", "FDDim", "]"}]}], "]"}]}]}], "]"}], 
         ";", "\n", "\t\t", 
         RowBox[{"im", "=", 
          RowBox[{"UnitStep", "[", 
           RowBox[{
            RowBox[{"ImageData", "[", 
             RowBox[{"ImageCrop", "[", 
              RowBox[{"Image", "[", 
               RowBox[{
                RowBox[{"FDDim", "*", "disk"}], "+", "disk", "-", "disk2"}], 
               "]"}], "]"}], "]"}], "-", "1.1"}], "]"}]}], ";"}]}], "\n", 
       "\t", "]"}], ";", "\n", "\t", "\n", "\t", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"data", " ", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Log", "@", "r"}], ",", 
             RowBox[{"Log", "@", 
              RowBox[{"Count", "[", 
               RowBox[{
                RowBox[{"Flatten", "@", 
                 RowBox[{"Dilate", "[", 
                  RowBox[{"im", ",", 
                   RowBox[{"DiskMatrix", "[", "r", "]"}]}], "]"}]}], ",", 
                "1."}], "]"}]}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"r", ",", "5", ",", "FDDmaxdilation", ",", "5"}], "}"}]}],
           "]"}]}], ";"}], 
       RowBox[{"(*", 
        RowBox[{
        "Dilate", " ", "images", " ", "and", " ", "count", " ", "nr", " ", 
         "of", " ", 
         RowBox[{"pixels", "."}]}], "*)"}], "*)"}], " ", 
      RowBox[{"(*", 
       RowBox[{"Slow", " ", "version"}], "*)"}], "\n", "\t", 
      RowBox[{"data", " ", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Log", "@", "r"}], ",", 
           RowBox[{"Log", "@", 
            RowBox[{"Count", "[", 
             RowBox[{
              RowBox[{"UnitStep", "[", 
               RowBox[{
                RowBox[{"ListConvolve", "[", 
                 RowBox[{
                  RowBox[{"DiskMatrix", "[", "r", "]"}], ",", "im", ",", 
                  RowBox[{"Round", "[", 
                   RowBox[{
                    RowBox[{"Dimensions", "[", 
                    RowBox[{"DiskMatrix", "[", "r", "]"}], "]"}], "/", "2"}], 
                   "]"}]}], "]"}], "-", "0.1"}], "]"}], ",", "1", ",", 
              RowBox[{"{", "2", "}"}]}], "]"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"r", ",", "5", ",", "FDDmaxdilation", ",", "5"}], "}"}]}], 
        "]"}]}], ";", "\n", "\t", 
      RowBox[{"fit", " ", "=", " ", 
       RowBox[{"LinearModelFit", "[", 
        RowBox[{"data", ",", "x", ",", "x"}], "]"}]}], ";", 
      RowBox[{"(*", 
       RowBox[{"Fit", " ", "parameters"}], "*)"}], "\n", "\t", "\n", "\t", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"2", "-", 
         RowBox[{"fit", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "2", ",", "2"}], "]"}], "]"}]}], ",", "fit", ",", 
        RowBox[{"fit", "[", "\"\<RSquared\>\"", "]"}], ",", "data"}], 
       "}"}]}]}], 
    RowBox[{"(*", 
     RowBox[{"Gives", " ", "the", " ", "fractal", " ", "dimension"}], "*)"}], 
    "\n", "\t", "\n", "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FractalDimensionMass", "[", 
    RowBox[{"FDMim_", ",", "FDMpoint_", ",", 
     RowBox[{"FDMextrainf_:", "False"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"data", ",", "fit", ",", 
       RowBox[{"im", "=", "FDMim"}], ",", "maxR", ",", "x"}], "}"}], ",", 
     "\n", "\t", 
     RowBox[{
      RowBox[{
      "UpdateStatus", "[", 
       "\"\<Calculating fractal dimension - Mass-radius...\>\"", "]"}], ";", 
      "\n", "\t", 
      RowBox[{"maxR", " ", "=", " ", 
       RowBox[{"Min", "@", 
        RowBox[{"{", 
         RowBox[{"FDMpoint", ",", 
          RowBox[{
           RowBox[{"Dimensions", "[", "FDMim", "]"}], "-", "FDMpoint"}]}], 
         "}"}]}]}], ";", " ", 
      RowBox[{"(*", 
       RowBox[{
       "Maximum", " ", "radius", " ", "that", " ", "can", " ", "be", " ", 
        "used", " ", "without", " ", "falling", " ", "out", " ", "of", " ", 
        "the", " ", "image"}], "*)"}], "\n", "\t", 
      RowBox[{"data", " ", "=", " ", 
       RowBox[{"Table", "[", "\n", "\t\t", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"r", ",", 
           RowBox[{"Total", "[", 
            RowBox[{"Flatten", "[", 
             RowBox[{"im", "*", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{
                  RowBox[{"DiskMatrix", "[", 
                   RowBox[{"r", ",", 
                    RowBox[{
                    RowBox[{"Dimensions", "[", "im", "]"}], "+", 
                    RowBox[{"2", "r"}]}]}], "]"}], ",", 
                  RowBox[{"Round", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Dimensions", "[", "im", "]"}], "/", "2"}], "-", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"FDMpoint", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"FDMpoint", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}]}], "]"}],
                 ",", 
                RowBox[{"-", "r"}]}], "]"}]}], "]"}], "]"}]}], "}"}], "\n", 
         "\t\t\t", ",", 
         RowBox[{"{", 
          RowBox[{"r", ",", "200", ",", "maxR", ",", "100"}], "}"}]}], 
        "]"}]}], ";", " ", 
      RowBox[{"(*", 
       RowBox[{"Number", " ", "of", " ", "pixels", " ", "within", " ", 
        RowBox[{"circles", "."}]}], "*)"}], "\n", "\t", 
      RowBox[{"data", " ", "=", " ", 
       RowBox[{"Log", "@", 
        RowBox[{"DeleteCases", "[", 
         RowBox[{"data", ",", 
          RowBox[{"_", "?", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"MemberQ", "[", 
              RowBox[{"#", ",", "0"}], "]"}], "&"}], ")"}]}], ",", 
          RowBox[{"{", "1", "}"}]}], "]"}]}]}], ";", " ", 
      RowBox[{"(*", 
       RowBox[{"Delete", " ", "radii", " ", 
        RowBox[{"(", "circles", ")"}], " ", "containing", " ", "zero", " ", 
        "pixels"}], "*)"}], "\n", "\t", 
      RowBox[{"fit", " ", "=", " ", 
       RowBox[{"LinearModelFit", "[", 
        RowBox[{"data", ",", "x", ",", "x"}], "]"}]}], ";", 
      RowBox[{"(*", 
       RowBox[{"Fit", " ", "parameters"}], "*)"}], "\n", "\t", 
      RowBox[{"(*", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"fit", "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"fit", "[", 
            RowBox[{"[", 
             RowBox[{"2", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"Log", "@", "data"}], ",", 
         RowBox[{"ImagePlot", "[", 
          RowBox[{"FDMim", ",", 
           RowBox[{"Epilog", "->", 
            RowBox[{"{", 
             RowBox[{"Thick", " ", ",", "Red", ",", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"Circle", "[", 
                 RowBox[{"FDMpoint", ",", "r"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"r", ",", "50", ",", "maxR", ",", "100"}], "}"}]}], 
               "]"}]}], "}"}]}]}], "]"}]}], "}"}], "*)"}], 
      RowBox[{"(*", 
       RowBox[{"Gives", " ", "all", " ", "output"}], "*)"}], "\n", "\t", 
      RowBox[{"(*", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"fit", "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "1"}], "]"}], "]"}], ",", 
         RowBox[{"ImagePlot", "[", 
          RowBox[{"FDMim", ",", 
           RowBox[{"Epilog", "->", 
            RowBox[{"{", 
             RowBox[{"Thick", " ", ",", "Red", ",", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"Circle", "[", 
                 RowBox[{"FDMpoint", ",", "r"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"r", ",", "50", ",", "maxR", ",", "100"}], "}"}]}], 
               "]"}]}], "}"}]}]}], "]"}]}], "}"}], 
       RowBox[{"(*", 
        RowBox[{
        "Gives", " ", "the", " ", "fractal", " ", "dimension", " ", "and", 
         " ", "image", " ", "back"}], "*)"}], "*)"}], "\n", 
      RowBox[{"(*", "\t", 
       RowBox[{"If", "[", 
        RowBox[{"FDMextrainf", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"fit", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "2", ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"fit", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "2", ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"Log", "@", "data"}], ",", 
           RowBox[{
           "\"\<\\!\\(\\*SuperscriptBox[\\(R\\), \\(2\\)]\\) = \>\"", "<>", 
            RowBox[{"ToString", "@", 
             RowBox[{"fit", "[", "\"\<RSquared\>\"", "]"}]}]}], ",", 
           RowBox[{"ImagePlot", "[", 
            RowBox[{"FDMim", ",", 
             RowBox[{"Epilog", "->", 
              RowBox[{"{", 
               RowBox[{"Thick", " ", ",", "Red", ",", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"Circle", "[", 
                   RowBox[{"FDMpoint", ",", "r"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"r", ",", "50", ",", "maxR", ",", "100"}], "}"}]}],
                  "]"}]}], "}"}]}]}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"fit", "[", 
            RowBox[{"[", 
             RowBox[{"1", ",", "2", ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{
           "\"\<\\!\\(\\*SuperscriptBox[\\(R\\), \\(2\\)]\\) = \>\"", "<>", 
            RowBox[{"ToString", "@", 
             RowBox[{"fit", "[", "\"\<RSquared\>\"", "]"}]}]}]}], "}"}]}], 
        "]"}], "*)"}], "\n", "\t", 
      RowBox[{"If", "[", 
       RowBox[{"FDMextrainf", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"fit", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "2", ",", "2"}], "]"}], "]"}], ",", "fit", ",", 
          RowBox[{"fit", "[", "\"\<RSquared\>\"", "]"}], ",", "data", ",", 
          RowBox[{"ImagePlot", "[", 
           RowBox[{"FDMim", ",", 
            RowBox[{"Epilog", "->", 
             RowBox[{"{", 
              RowBox[{"Thick", " ", ",", "Red", ",", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"Circle", "[", 
                  RowBox[{"FDMpoint", ",", "r"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"r", ",", "50", ",", "maxR", ",", "100"}], "}"}]}], 
                "]"}]}], "}"}]}]}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"fit", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "2", ",", "2"}], "]"}], "]"}], ",", "fit", ",", 
          RowBox[{"fit", "[", "\"\<RSquared\>\"", "]"}], ",", "data"}], 
         "}"}]}], "]"}]}]}], "\n", "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FractalDimensionMass2", "[", 
    RowBox[{"FDMim_", ",", "FDMpoint_", ",", "FDMr_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"data", ",", "fit", ",", 
       RowBox[{"im", "=", "FDMim"}], ",", "maxR", ",", "x"}], "}"}], ",", 
     "\n", "\t", 
     RowBox[{
      RowBox[{
      "UpdateStatus", "[", 
       "\"\<Calculating fractal dimension - Mass-radius...\>\"", "]"}], ";", 
      "\n", "\t", 
      RowBox[{"maxR", " ", "=", " ", 
       RowBox[{"Min", "@", 
        RowBox[{"{", 
         RowBox[{"FDMpoint", ",", 
          RowBox[{"Round", "@", "FDMr"}], ",", 
          RowBox[{
           RowBox[{"Dimensions", "[", "FDMim", "]"}], "-", "FDMpoint"}]}], 
         "}"}]}]}], ";", " ", 
      RowBox[{"(*", 
       RowBox[{
       "Maximum", " ", "radius", " ", "that", " ", "can", " ", "be", " ", 
        "used", " ", "without", " ", "falling", " ", "out", " ", "of", " ", 
        "the", " ", "image"}], "*)"}], "\n", "\t", "\n", "\t", 
      RowBox[{"data", " ", "=", " ", 
       RowBox[{"Table", "[", "\n", "\t\t", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"r", ",", 
           RowBox[{"Total", "[", 
            RowBox[{"Flatten", "[", 
             RowBox[{"im", "*", 
              RowBox[{"ArrayPad", "[", 
               RowBox[{
                RowBox[{"RotateLeft", "[", 
                 RowBox[{
                  RowBox[{"DiskMatrix", "[", 
                   RowBox[{"r", ",", 
                    RowBox[{
                    RowBox[{"Dimensions", "[", "im", "]"}], "+", 
                    RowBox[{"2", "r"}]}]}], "]"}], ",", 
                  RowBox[{"Round", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Dimensions", "[", "im", "]"}], "/", "2"}], "-", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"FDMpoint", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"FDMpoint", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}]}], "]"}],
                 ",", 
                RowBox[{"-", "r"}]}], "]"}]}], "]"}], "]"}]}], "}"}], "\n", 
         "\t\t\t", ",", 
         RowBox[{"{", 
          RowBox[{"r", ",", "200", ",", "maxR", ",", "100"}], "}"}]}], 
        "]"}]}], ";", " ", 
      RowBox[{"(*", 
       RowBox[{"Number", " ", "of", " ", "pixels", " ", "within", " ", 
        RowBox[{"circles", "."}]}], "*)"}], "\n", "\t", 
      RowBox[{"data", " ", "=", " ", 
       RowBox[{"Log", "@", 
        RowBox[{"DeleteCases", "[", 
         RowBox[{"data", ",", 
          RowBox[{"_", "?", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"MemberQ", "[", 
              RowBox[{"#", ",", "0"}], "]"}], "&"}], ")"}]}], ",", 
          RowBox[{"{", "1", "}"}]}], "]"}]}]}], ";", " ", 
      RowBox[{"(*", 
       RowBox[{"Delete", " ", "radii", " ", 
        RowBox[{"(", "circles", ")"}], " ", "containing", " ", "zero", " ", 
        "pixels"}], "*)"}], "\n", "\t", 
      RowBox[{"fit", " ", "=", " ", 
       RowBox[{"LinearModelFit", "[", 
        RowBox[{"data", ",", "x", ",", "x"}], "]"}]}], ";", 
      RowBox[{"(*", 
       RowBox[{"Fit", " ", "parameters"}], "*)"}], "\n", "\t", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"fit", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "2", ",", "2"}], "]"}], "]"}], ",", "fit", ",", 
        RowBox[{"fit", "[", "\"\<RSquared\>\"", "]"}], ",", "data", ",", 
        RowBox[{"ImagePlot", "[", 
         RowBox[{"FDMim", ",", 
          RowBox[{"Epilog", "->", 
           RowBox[{"{", 
            RowBox[{"Thick", " ", ",", "Red", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Circle", "[", 
                RowBox[{"FDMpoint", ",", "r"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"r", ",", "50", ",", "maxR", ",", "100"}], "}"}]}], 
              "]"}]}], "}"}]}]}], "]"}]}], "}"}]}]}], "\n", "]"}]}], 
  ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FractalDimensionCorrelation", "[", 
    RowBox[{"FDCim_", ",", 
     RowBox[{"FDCdiskcenter_:", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}], ",", 
     RowBox[{"FDCr_:", "0"}], ",", 
     RowBox[{"FDCdisk_:", "0"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "data", ",", "fit", ",", "maxR", ",", "disk", ",", "disk2", ",", "x", 
       ",", 
       RowBox[{"im", "=", "FDCim"}], ",", " ", 
       RowBox[{"dim", " ", "=", " ", 
        RowBox[{"Dimensions", "[", "FDCim", "]"}]}], ",", "nr"}], "}"}], ",", 
     "\n", "\t", 
     RowBox[{
      RowBox[{
      "UpdateStatus", "[", 
       "\"\<Calculating fractal dimension - Correlation...\>\"", "]"}], ";", 
      "\n", "\t", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"FDCr", ">", "0"}], ",", "\n", "\t\t", 
        RowBox[{
         RowBox[{"maxR", "=", 
          RowBox[{"Min", "@", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Round", "[", "FDCr", "]"}], ",", 
             RowBox[{"Round", "@", "FDCdiskcenter"}], ",", 
             RowBox[{"dim", "-", "FDCdiskcenter"}]}], "}"}]}]}], ";", "\n", 
         "\t\t", 
         RowBox[{"disk", "=", 
          RowBox[{"ArrayPad", "[", 
           RowBox[{
            RowBox[{"RotateLeft", "[", 
             RowBox[{
              RowBox[{"DiskMatrix", "[", 
               RowBox[{"maxR", ",", 
                RowBox[{"dim", "+", 
                 RowBox[{"2", "maxR"}]}]}], "]"}], ",", 
              RowBox[{"Round", "[", 
               RowBox[{
                RowBox[{"dim", "/", "2"}], "-", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"FDCdiskcenter", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{"FDCdiskcenter", "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}]}], "]"}], 
            ",", 
            RowBox[{"-", "maxR"}]}], "]"}]}], ";", "\n", "\t\t", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"FDCdisk", ">", "0"}], ",", 
           RowBox[{"disk2", "=", 
            RowBox[{"ArrayPad", "[", 
             RowBox[{
              RowBox[{"RotateLeft", "[", 
               RowBox[{
                RowBox[{"DiskMatrix", "[", 
                 RowBox[{"FDCdisk", ",", 
                  RowBox[{
                   RowBox[{"Dimensions", "[", "FDCim", "]"}], "+", 
                   RowBox[{"2", "maxR"}]}]}], "]"}], ",", 
                RowBox[{"Round", "[", 
                 RowBox[{
                  RowBox[{"dim", "/", "2"}], "-", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"FDCdiskcenter", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"FDCdiskcenter", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}]}], "]"}],
               ",", 
              RowBox[{"-", "maxR"}]}], "]"}]}], ",", 
           RowBox[{"disk2", "=", 
            RowBox[{"ConstantArray", "[", 
             RowBox[{"0", ",", "dim"}], "]"}]}]}], "]"}], ";", "\n", "\t\t", 
         RowBox[{"im", "=", 
          RowBox[{"UnitStep", "[", 
           RowBox[{
            RowBox[{"ImageData", "[", 
             RowBox[{"ImageCrop", "[", 
              RowBox[{"Image", "[", 
               RowBox[{
                RowBox[{"FDCim", "*", "disk"}], "+", "disk", "-", "disk2"}], 
               "]"}], "]"}], "]"}], "-", "1.1"}], "]"}]}], ";"}]}], "\n", 
       "\t", "]"}], ";", "\n", "\t", "\n", "\t", 
      RowBox[{"nr", " ", "=", " ", 
       RowBox[{"Times", "@@", "dim"}]}], ";", "\n", "\t", 
      RowBox[{"data", " ", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Log", "@", "r"}], ",", 
           RowBox[{"Log", "@", 
            RowBox[{"N", "[", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Total", "[", " ", 
                RowBox[{
                 RowBox[{
                  RowBox[{"ListConvolve", "[", 
                   RowBox[{
                    RowBox[{"DiskMatrix", "[", "r", "]"}], ",", "FDCim", ",", 
                    RowBox[{"{", 
                    RowBox[{"r", ",", "r"}], "}"}]}], "]"}], "*", "FDCim"}], 
                 ",", "2"}], "]"}], "/", "2"}], ")"}], "]"}]}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"r", ",", 
           RowBox[{"{", 
            RowBox[{
            "1", ",", "2", ",", "4", ",", "8", ",", "16", ",", "32", ",", 
             "64", ",", "128", ",", "256"}], "}"}]}], "}"}]}], "]"}]}], ";", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Exclude", " ", "i"}], "=", 
        RowBox[{"j", ":", " ", 
         RowBox[{"-", " ", 
          RowBox[{"Times", "@@", "dim"}]}]}]}], "*)"}], "\n", "\t", 
      RowBox[{"fit", " ", "=", " ", 
       RowBox[{"LinearModelFit", "[", 
        RowBox[{"data", ",", "x", ",", "x"}], "]"}]}], ";", 
      RowBox[{"(*", 
       RowBox[{"Fit", " ", "parameters"}], "*)"}], "\n", "\t", "\n", "\t", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"fit", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "2", ",", "2"}], "]"}], "]"}], ",", "fit", ",", 
        RowBox[{"fit", "[", "\"\<RSquared\>\"", "]"}], ",", "data"}], 
       "}"}]}]}], 
    RowBox[{"(*", 
     RowBox[{"Gives", " ", "the", " ", "fractal", " ", "dimension"}], "*)"}], 
    "\n", "\t", "\n", "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MethodAccuracy", "[", 
    RowBox[{"im_", ",", "mask_", ",", "ref_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tmp", ",", 
       RowBox[{"TP", "=", "0"}], ",", 
       RowBox[{"TN", "=", "0"}], ",", 
       RowBox[{"FP", "=", "0"}], ",", 
       RowBox[{"FN", "=", "0"}]}], "}"}], ",", " ", 
     RowBox[{"(*", 
      RowBox[{"Calculate", " ", "accuracy", " ", "parameters"}], "*)"}], "\n",
      "\t", 
     RowBox[{
      RowBox[{"tmp", " ", "=", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Round", "@", "ref"}], "+", "1"}], ")"}]}], "-", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Round", "@", "im"}], "+", "1"}], ")"}]}], ")"}], "*", 
        "mask"}]}], ";", " ", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{
         "Gives", " ", "every", " ", "pixel", " ", "a", " ", "different", " ",
           "number", " ", "representing", " ", "4"}], "=", "TP"}], ",", " ", 
        RowBox[{"5", "=", "FN"}], ",", 
        RowBox[{"1", "=", "FP"}], ",", 
        RowBox[{"2", "=", "TN"}]}], "*)"}], "\n", "\t", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"FP", ",", "TN", ",", "TP", ",", "FN"}], "}"}], "=", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"Sort", "[", 
          RowBox[{"Tally", "[", 
           RowBox[{"Flatten", "@", 
            RowBox[{"Join", "@", 
             RowBox[{"{", 
              RowBox[{"tmp", ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "1", ",", "2", ",", "4", ",", "5"}], 
                "}"}]}], "}"}]}]}], "]"}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;", "5"}], ",", "2"}], "]"}], "]"}], "-", "1"}]}], 
      ";", " ", 
      RowBox[{"(*", 
       RowBox[{
       "Ad", " ", "additional", " ", "numbers", " ", "to", " ", "make", " ", 
        "sure", " ", "every", " ", "number", " ", "is", " ", "present", " ", 
        "to", " ", "prevent", " ", "errors", " ", "and", " ", "subtract", " ",
         "in", " ", "the", " ", "end"}], "*)"}], "\n", "\t", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "-", 
          RowBox[{"FP", "/", 
           RowBox[{"(", 
            RowBox[{"TN", "+", "FP"}], ")"}]}]}], ",", " ", 
         RowBox[{"TP", "/", 
          RowBox[{"(", 
           RowBox[{"TP", "+", "FN", "+", "$MachineEpsilon"}], ")"}]}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"TN", "+", "TP"}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"TP", "+", "TN", "+", "FP", "+", "FN"}], ")"}]}]}], "}"}], 
       "//", "N"}]}]}], " ", 
    RowBox[{"(*", 
     RowBox[{"Specificity", ",", "Sensitivity", ",", " ", "Accuracy"}], 
     "*)"}], "\n", "]"}]}], ";"}]], "Code"]
}, Closed]],

Cell[CellGroupData[{

Cell["Other", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LuminanceCorrection", "[", 
    RowBox[{"im_", ",", "\[Sigma]_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"filt", ",", "m", ",", "coco"}], "}"}], ",", " ", 
     RowBox[{"(*", 
      RowBox[{"Correct", " ", "for", " ", "the", " ", "luminance"}], " ", 
      "*)"}], "\n", "\t", 
     RowBox[{
      RowBox[{"UpdateStatus", "[", "\"\<Correcting luminance...\>\"", "]"}], 
      ";", "\n", "\t", 
      RowBox[{"filt", " ", "=", " ", 
       RowBox[{
        RowBox[{"ImageData", "[", 
         RowBox[{"MedianFilter", "[", 
          RowBox[{
           RowBox[{"Image", "@", "im"}], ",", "\[Sigma]"}], "]"}], "]"}], "*", 
        RowBox[{"Erode", "[", 
         RowBox[{
          RowBox[{"CreateMask", "[", "im", "]"}], ",", "7"}], "]"}]}]}], ";", 
      "\n", "\t", 
      RowBox[{"(*", 
       RowBox[{
       "Derive", " ", "lumination", " ", "by", " ", "blurring", " ", "at", 
        " ", "a", " ", "large", " ", "scale", " ", "and", " ", "correcting", 
        " ", "every", " ", "pixel", " ", "to", " ", "the", " ", "max", " ", 
        "of", " ", "this", " ", "luminance", " ", "map"}], "*)"}], "\n", "\t", 
      RowBox[{"coco", " ", "=", " ", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"m", " ", "=", " ", 
           RowBox[{"Max", "@", "filt"}]}], ";", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"#", ">", "0"}], ",", 
             RowBox[{"m", "/", "#"}], ",", "0"}], "]"}], "&"}]}], ",", "filt",
          ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\n", "\t", 
      RowBox[{"Rescale", "@", 
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{"im", " ", "*", " ", "coco"}], ")"}]}]}]}]}], "\n", "]"}]}], 
  ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ListToMatrix", "[", 
    RowBox[{"im_", ",", "x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"Partition", "[", 
       RowBox[{"im", ",", "y"}], "]"}], ",", "x"}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", 
  RowBox[{"(*", 
   RowBox[{
   "Transform", " ", "a", " ", "list", " ", "to", " ", "a", " ", "matrix"}], 
   "*)"}], "\n", 
  RowBox[{
   RowBox[{"ListToMatrix", "[", 
    RowBox[{"im_", ",", 
     RowBox[{"{", 
      RowBox[{"x_", ",", "y_"}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Partition", "[", 
     RowBox[{
      RowBox[{"Partition", "[", 
       RowBox[{"im", ",", "y"}], "]"}], ",", "x"}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{
   "Transform", " ", "a", " ", "list", " ", "to", " ", "a", " ", "matrix"}], 
   "*)"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OpticDisk", "[", 
   RowBox[{"ODim_", ",", 
    RowBox[{"VisSize_:", "500"}]}], "]"}], " ", ":=", 
  RowBox[{"DynamicModule", "[", 
   RowBox[{
    RowBox[{"{", " ", 
     RowBox[{"ODpt", ",", "ODr", ",", "pt"}], "}"}], ",", " ", 
    RowBox[{"(*", 
     RowBox[{
     "Show", " ", "the", " ", "optic", " ", "disk", " ", "selector", " ", 
      "using", " ", "a", " ", "locatorpane"}], "*)"}], "\n", "\t", 
    RowBox[{
     RowBox[{"ODpt", " ", "=", " ", 
      RowBox[{"Dynamic", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Dimensions", "[", "ODim", "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "-", 
          RowBox[{"pt", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ",", 
         RowBox[{"pt", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "]"}]}], ";", " ", 
     RowBox[{"(*", 
      RowBox[{"Center", " ", "of", " ", "optic", " ", "disk"}], "*)"}], "\n", 
     "\t", 
     RowBox[{"ODr", " ", "=", " ", 
      RowBox[{"Round", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Dimensions", "[", "ODim", "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}], "/", "20"}], "]"}]}], ";", " ", 
     RowBox[{"(*", 
      RowBox[{"Radius", " ", "of", " ", "optic", " ", "disk"}], "*)"}], "\n", 
     "\t", 
     RowBox[{"Panel", "@", 
      RowBox[{"Column", "@", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"LocatorPane", "[", 
          RowBox[{
           RowBox[{"Dynamic", "[", "pt", "]"}], ",", 
           RowBox[{"Show", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"RasterPlot", "[", 
                RowBox[{"ODim", ",", 
                 RowBox[{"Frame", "->", "False"}]}], "]"}], ",", 
               RowBox[{"Graphics", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Opacity", "[", "0.4", "]"}], ",", "Green", ",", 
                  RowBox[{"Disk", "[", 
                   RowBox[{
                    RowBox[{"Dynamic", "@", "pt"}], ",", 
                    RowBox[{"Dynamic", "[", "ODr", "]"}]}], "]"}]}], "}"}], 
                "]"}]}], "}"}], ",", 
             RowBox[{"ImageSize", "->", 
              RowBox[{"{", "VisSize", "}"}]}]}], "]"}], ",", 
           RowBox[{"Appearance", "->", 
            RowBox[{"Graphics", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"Red", ",", 
                RowBox[{"Disk", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"200", ",", "200"}], "}"}], ",", "1"}], "]"}]}], 
               "}"}], ",", 
              RowBox[{"ImageSize", "->", "1"}]}], "]"}]}]}], "]"}], ",", 
         RowBox[{"Panel", "[", 
          RowBox[{"Row", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Slider", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", "ODr", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"10", ",", 
                  RowBox[{"Round", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Dimensions", "[", "ODim", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "/", "2"}], "]"}], ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"ImageSize", "->", 
                 RowBox[{"VisSize", "-", "120"}]}]}], "]"}], ",", 
              RowBox[{"Dynamic", "@", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Round", "@", 
                  RowBox[{"ODpt", "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], ",", "ODr"}], "}"}]}]}], 
             "}"}], ",", 
            RowBox[{"ImageSize", "->", "VisSize"}]}], "]"}], "]"}]}], 
        "}"}]}]}]}]}], " ", 
   RowBox[{"(*", 
    RowBox[{"Locatorpane", " ", "with", " ", "optic", " ", "disk"}], "*)"}], 
   "\n", "]"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ImagePlot", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"PlotRange", "->", "Automatic"}], ",", 
     RowBox[{"ImageSize", "->", "Large"}], ",", 
     RowBox[{"Epilog", "->", 
      RowBox[{"{", "}"}]}]}], "}"}]}], ";", "  ", 
  RowBox[{"(*", 
   RowBox[{
   "Plot", " ", "an", " ", "image", " ", "with", " ", "epilog", " ", 
    "working", " ", "as", " ", "expected"}], "*)"}], "\n", 
  RowBox[{
   RowBox[{"ImagePlot", "[", 
    RowBox[{"image_", ",", 
     RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
   RowBox[{"Show", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Image", "[", 
       RowBox[{
        RowBox[{"Rescale", "[", 
         RowBox[{"image", ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"OptionValue", "[", "PlotRange", "]"}], "===", 
             "Automatic"}], ",", 
            RowBox[{"Through", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"Min", ",", "Max"}], "}"}], "@", "image"}], "]"}], ",", 
            RowBox[{"OptionValue", "@", "PlotRange"}]}], "]"}]}], "]"}], ",", 
        RowBox[{"ImageSize", "->", 
         RowBox[{"OptionValue", "@", "ImageSize"}]}]}], "]"}], ",", 
      RowBox[{"Graphics", "[", 
       RowBox[{"GeometricTransformation", "[", 
        RowBox[{
         RowBox[{"OptionValue", "@", "Epilog"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", ".5"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"Dimensions", "[", "image", "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "+", ".5"}]}], "}"}]}], 
          "}"}]}], "]"}], "]"}]}], "}"}], "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Erode", "[", 
    RowBox[{"im_List", ",", "p_"}], "]"}], ":=", 
   RowBox[{"ImageData", "@", 
    RowBox[{"Erosion", "[", 
     RowBox[{
      RowBox[{"Image", "@", "im"}], ",", 
      RowBox[{"DiskMatrix", "@", "p"}]}], "]"}]}]}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{"Erosion", " ", "for", " ", "lists"}], "*)"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Dilate", "[", 
    RowBox[{"im_List", ",", "p_"}], "]"}], ":=", 
   RowBox[{"ImageData", "@", 
    RowBox[{"Dilation", "[", 
     RowBox[{
      RowBox[{"Image", "@", "im"}], ",", "p"}], "]"}]}]}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{"Dilation", " ", "for", " ", "lists"}], "*)"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ClosingIm", "[", 
    RowBox[{"im_List", ",", "p_"}], "]"}], ":=", 
   RowBox[{"ImageData", "@", 
    RowBox[{"Closing", "[", 
     RowBox[{
      RowBox[{"Image", "@", "im"}], ",", 
      RowBox[{"DiskMatrix", "@", "p"}]}], "]"}]}]}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{"Closing", " ", "for", " ", "lists"}], "*)"}]}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OpeningIm", "[", 
    RowBox[{"im_List", ",", "p_"}], "]"}], ":=", 
   RowBox[{"ImageData", "@", 
    RowBox[{"Opening", "[", 
     RowBox[{
      RowBox[{"Image", "@", "im"}], ",", 
      RowBox[{"DiskMatrix", "@", "p"}]}], "]"}]}]}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{"Opening", " ", "for", " ", "lists"}], "*)"}]}]], "Code"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Rest", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Code"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UpdateStatus", "[", "mes_", "]"}], ":=", 
   RowBox[{"message", "=", "mes"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"blauw", " ", "=", " ", 
   RowBox[{"RGBColor", "[", 
    RowBox[{
     RowBox[{"50", "/", "255"}], ",", 
     RowBox[{"125", "/", "255"}], ",", 
     RowBox[{"200", "/", "255"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"donkerblauw", " ", "=", " ", 
   RowBox[{"RGBColor", "[", 
    RowBox[{
     RowBox[{"30", "/", "255"}], ",", 
     RowBox[{"80", "/", "255"}], ",", 
     RowBox[{"130", "/", "255"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"kleur2", " ", "=", " ", 
   RowBox[{"RGBColor", "[", 
    RowBox[{
     RowBox[{"55", "/", "255"}], ",", 
     RowBox[{"128", "/", "255"}], ",", 
     RowBox[{"200", "/", "255"}]}], "]"}]}], ";"}]}], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Protect", "@@", 
   RowBox[{"Names", "[", "\"\<Retina`*\>\"", "]"}]}], ";"}]], "Code"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "message", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "[", "kleur", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "[", "ODr", "]"}], ";"}]}], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EndPackage", "[", " ", "]"}], "\n", "\n", "\n"}]], "Code"]
}, Closed]]
},
WindowSize->{707, 867},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"9.0 for Microsoft Windows (32-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[1485, 35, 23, 0, 86, "Section"],
Cell[1511, 37, 872, 20, 128, "Code"],
Cell[2386, 59, 12398, 280, 1572, "Code"],
Cell[14787, 341, 91, 2, 52, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14915, 348, 33, 0, 31, "Section"],
Cell[14951, 350, 1279, 37, 153, "Code"],
Cell[16233, 389, 300, 8, 93, "Code"],
Cell[16536, 399, 305, 8, 93, "Code"],
Cell[16844, 409, 1238, 31, 93, "Code"]
}, Closed]],
Cell[CellGroupData[{
Cell[18119, 445, 30, 0, 31, "Section"],
Cell[18152, 447, 3403, 88, 233, "Code"]
}, Closed]],
Cell[CellGroupData[{
Cell[21592, 540, 26, 0, 31, "Section"],
Cell[21621, 542, 6313, 158, 433, "Code"],
Cell[27937, 702, 1319, 37, 113, "Code"],
Cell[29259, 741, 4942, 118, 453, "Code"],
Cell[34204, 861, 5263, 125, 473, "Code"]
}, Closed]],
Cell[CellGroupData[{
Cell[39504, 991, 32, 0, 31, "Section"],
Cell[39539, 993, 6574, 174, 453, "Code"],
Cell[46116, 1169, 3641, 97, 353, "Code"],
Cell[49760, 1268, 8956, 233, 693, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[58753, 1506, 36, 0, 31, "Section"],
Cell[CellGroupData[{
Cell[58814, 1510, 25, 0, 31, "Subsection"],
Cell[58842, 1512, 1323, 40, 52, "Code"],
Cell[60168, 1554, 269, 8, 52, "Code"],
Cell[60440, 1564, 300, 9, 52, "Code"],
Cell[60743, 1575, 2513, 69, 173, "Code"],
Cell[63259, 1646, 6769, 185, 233, "Code"],
Cell[70031, 1833, 6251, 173, 333, "Code"],
Cell[76285, 2008, 6891, 190, 393, "Code"],
Cell[83179, 2200, 8540, 236, 353, "Code"]
}, Closed]],
Cell[CellGroupData[{
Cell[91756, 2441, 34, 0, 31, "Subsection"],
Cell[91793, 2443, 5908, 149, 673, "Code"],
Cell[97704, 2594, 6075, 154, 673, "Code"],
Cell[103782, 2750, 5009, 133, 573, "Code"],
Cell[108794, 2885, 8952, 237, 653, "Code"],
Cell[117749, 3124, 6867, 174, 753, "Code"],
Cell[124619, 3300, 4446, 114, 613, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[129102, 3419, 36, 0, 31, "Subsection"],
Cell[129141, 3421, 1390, 38, 153, "Code"],
Cell[130534, 3461, 787, 21, 113, "Code"],
Cell[131324, 3484, 5784, 148, 353, "Code"],
Cell[137111, 3634, 5737, 147, 353, "Code"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[142897, 3787, 27, 0, 31, "Section"],
Cell[142927, 3789, 2234, 57, 173, "Code"],
Cell[145164, 3848, 904, 22, 173, "Code"],
Cell[146071, 3872, 2408, 74, 193, "Code"],
Cell[148482, 3948, 6326, 176, 433, "Code"],
Cell[154811, 4126, 6966, 196, 433, "Code"],
Cell[161780, 4324, 897, 25, 133, "Code"],
Cell[162680, 4351, 4977, 129, 493, "Code"],
Cell[167660, 4482, 8402, 211, 793, "Code"],
Cell[176065, 4695, 5390, 140, 513, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[181492, 4840, 29, 0, 31, "Section"],
Cell[181524, 4842, 5564, 142, 453, "Code"],
Cell[187091, 4986, 1329, 38, 113, "Code"],
Cell[188423, 5026, 597, 18, 93, "Code"],
Cell[189023, 5046, 5997, 152, 433, "Code"]
}, Closed]],
Cell[CellGroupData[{
Cell[195057, 5203, 32, 0, 31, "Section"],
Cell[195092, 5205, 6321, 166, 513, "Code"],
Cell[201416, 5373, 1972, 53, 113, "Code"],
Cell[203391, 5428, 2883, 75, 173, "Code"],
Cell[206277, 5505, 3152, 79, 353, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[209466, 5589, 27, 0, 31, "Section"],
Cell[209496, 5591, 5421, 139, 293, "Code"],
Cell[214920, 5732, 6370, 162, 353, "Code"],
Cell[221293, 5896, 7833, 195, 293, "Code"],
Cell[229129, 6093, 4084, 102, 253, "Code"],
Cell[233216, 6197, 5515, 141, 353, "Code"],
Cell[238734, 6340, 2921, 80, 133, "Code"]
}, Closed]],
Cell[CellGroupData[{
Cell[241692, 6425, 24, 0, 31, "Section"],
Cell[241719, 6427, 1844, 48, 173, "Code"],
Cell[243566, 6477, 925, 29, 73, "Code"],
Cell[244494, 6508, 3964, 103, 133, "Code"],
Cell[248461, 6613, 2051, 57, 73, "Code"],
Cell[250515, 6672, 375, 11, 52, "Code"],
Cell[250893, 6685, 342, 10, 52, "Code"],
Cell[251238, 6697, 379, 11, 52, "Code"],
Cell[251620, 6710, 379, 11, 52, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[252036, 6726, 23, 0, 31, "Section"],
Cell[252062, 6728, 68, 2, 52, "Code"],
Cell[252133, 6732, 825, 25, 113, "Code"],
Cell[252961, 6759, 121, 3, 52, "Code"],
Cell[253085, 6764, 221, 6, 93, "Code"],
Cell[253309, 6772, 93, 2, 113, "Code"]
}, Closed]]
}
]
*)

(* End of internal cache information *)

(* NotebookSignature XxTs8QfyM68r8CKefb2aKQmR *)
