(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     48115,        949]
NotebookOptionsPosition[     46791,        901]
NotebookOutlinePosition[     47135,        916]
CellTagsIndexPosition[     47092,        913]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["File Tools", "Title",
 CellChangeTimes->{{3.577183162574053*^9, 3.577183165045806*^9}, {
  3.57718810405285*^9, 3.57718810630685*^9}, {3.57718847990985*^9, 
  3.57718849528785*^9}, {3.577454896446121*^9, 3.5774548984122334`*^9}, {
  3.5774578672700424`*^9, 3.5774578697801857`*^9}}],

Cell[BoxData[
 FrameBox[
  TagBox[GridBox[{
     {
      TemplateBox[{
       StyleBox[
        "\"File tools\"", StripOnInput -> False, FontFamily -> "Arial", 
         FontSize -> 14, FontWeight -> Bold],TagBox[
         TooltipBox[
          ButtonBox[
           GraphicsBox[
            TagBox[
             RasterBox[CompressedData["
1:eJxTTMoPSmNiYGAo5gASQYnljkVFiZXBLECOU2VJahIzkMEDxSDBYxD8n0hM
ilqs+OPFi/9h4Mvdu//POTnhVPtozpz/P16+/H9KTQ2MQerfHj1KtF0gtS93
7CDaXSDzQfYQUovsLmLMBrmBWHeQg6lsPknpAQC1+iQd
              "], {{0, 12}, {12, 0}}, {0, 255}, ColorFunction -> RGBColor], 
             BoxForm`ImageTag[
             "Byte", ColorSpace -> "RGB", Interleaving -> True], Selectable -> 
             False], BaseStyle -> "ImageGraphics", ImageSizeRaw -> {12, 12}, 
            PlotRange -> {{0, 12}, {0, 12}}], Appearance -> "Frameless", 
           ButtonFunction :> $CellContext`OpenHelp["FileHelp"], Evaluator -> 
           Automatic, ImageMargins -> {{5, 10}, {0, 0}}, 
           ImageSize -> {12, 14}, Method -> "Preemptive"], 
          "\"Need help with the file functions? Click here!\"", TooltipDelay -> 
          0.5, TooltipStyle -> "TextStyling"], 
         Annotation[#, "Need help with the file functions? Click here!", 
          "Tooltip"]& ]},
       "RowDefault"]},
     {
      TemplateBox[{TagBox[
         TooltipBox[
          ButtonBox[
           GraphicsBox[
            TagBox[
             RasterBox[CompressedData["
1:eJzt1kEOwUAUgOGiwSFY2LkGR+AEmrCVQSJuILFgYWEhErERidiQuAs9y5jX
aFK0M1N9byzM4m/avpn2W07N67d6ecdxhmVxaXXGjcGgM2m74qE5GXW9grip
P4OXnHMbYYwxVVySdK/1WZ+Gr0zkKyH5LqIisg++d0bywX9OEmNanys6whzR
Bx1EhYw+2L8P58g+aBdj1PXBvm10TuCDNqJcSh+sX7/PiXzQKmJU+WDdMm5O
6IMWmr550pzYB80U86lsbsCXKSTfjcjnI/kqBEZfVEXyYRsDG8M/v2AY76GN
wJfV+GIj8n1r/LAR+tIaY23EPl1jos2AT2WU2gz5koxKm0Hfu1HLZtgXGq+6
th/4UofkozgbBFmf9Vnff/tsNsoeNWqDOQ==
              "], {{0, 40}, {40, 0}}, {0, 255}, ColorFunction -> RGBColor], 
             BoxForm`ImageTag[
             "Byte", ColorSpace -> ColorProfileData[CompressedData["
1:eJydlndUVNcWxs+9d3qhzTAUKUPvXWAA6b1Jr6IyzAwwlAGGGRDEhogKRBQR
aYoiUQEDRkORWBHFQkCw14AEETUGo4iK5d2RtaIrL++9vHx/nPW75+x97jnf
3netq5GQEZoIAwCyCegQys51FQrZeWEY9MEtT8RLgFDwoaADoPgE8AUZsAwA
6QKRMNTbjRkdE8vEDwIYEAEOWADA5mRnBoZ5hUuifT3dmdloEPgidKvXNyQj
AFdNfIKZTPD/SZaTKRSh2wSjbMXlZXNQLkI5LVeUKZmfRpmekCphWHJ+uhA9
IMqKEk6aZ+PPMfPsImFuuoCLsuTMmdx0roT7UN6UI+ahjASgXJzD5+WifA1l
7TRxOh/lN5LcdB47GwCMxB1tEY+TjLK5xChheKg7yosAIFCSvuKEr1jEWyGS
XMo9IzNPyE9KFjH1OQZMCzs7FtOHl5vGE4lMgtmcVLaQy3TPSM9kC/IAmL/z
Z8lJvGWiJttY2NnYmFiaWnxl1H9d/JuS1HaeXoZ8rhnEGPgy91dxGY0AsGZQ
b7Z+mUuoAaBrAwCKd77Mae8BQBqtW+fQV/dhSPolWSTKtDczy83NNeXzOKYS
Q//Q/wz4G/rqfaaS7f6wh+nBS2SL00RMiW+cjLQMsZCZncnm8Jgmf27if5z4
1+cwDuUl8oQ8AZoRiXYZX5CEllvA5Yv4GQImX/CfivgP0/6k+b5GRWv6COjL
TYHMEB0gvw4ADI0MkLjd6Ar0R90CiJFA8uVFqU/O9/1nQf++K1wuGbL5SZ/z
3EPDmRyxMGd+TfJZAiwgAWlAB0pADWgBfWACLIEtcAAuwBP4gSAQDmLAMsAB
ySAdCEEuKADrQDEoBVvBDlALGkATaAZt4AjoAsfBGXAeXAZXwHVwF4yCCfAU
TIPXYA6CIDxEhWiQEqQO6UBGkCXEgpwgTygACoVioHgoCRJAYqgAWg+VQhVQ
LbQXaoa+h45BZ6CL0DB0GxqDpqDfoXcwAlNgOqwK68JmMAt2hf3hcHgpnARn
wflwEbwFroYb4UNwJ3wGvgxfh0fhp/AMAhAywkA0EBOEhbgjQUgskogIkdVI
CVKFNCJtSA/Sj1xFRpFnyFsMDkPDMDEmGAeMDyYCw8FkYVZjyjC1mIOYTkwf
5ipmDDON+YilYlWwRlh7rC82GpuEzcUWY6uw+7Ed2HPY69gJ7GscDsfA6eFs
cT64GFwKbiWuDLcL1447jRvGjeNm8Hi8Et4I74gPwrPxInwxvgZ/CH8KP4Kf
wL8hkAnqBEuCFyGWICAUEqoILYSThBHCJGGOKEPUIdoTg4hcYh6xnNhE7CEO
ESeIcyRZkh7JkRROSiGtI1WT2kjnSPdIL8lksibZjhxC5pPXkqvJh8kXyGPk
txQ5iiHFnRJHEVO2UA5QTlNuU15SqVRdqgs1liqibqE2U89SH1DfSNGkTKV8
pbhSa6TqpDqlRqSeSxOldaRdpZdJ50tXSR+VHpJ+JkOU0ZVxl2HLrJapkzkm
c1NmRpYmayEbJJsuWybbIntR9rEcXk5XzlOOK1ckt0/urNw4DaFp0dxpHNp6
WhPtHG2CjqPr0X3pKfRS+nf0Qfq0vJz8QvlI+RXydfIn5EcZCEOX4ctIY5Qz
jjBuMN4pqCq4KvAUNiu0KYwozCouUHRR5CmWKLYrXld8p8RU8lRKVdqm1KV0
XxmjbKgcopyrvFv5nPKzBfQFDgs4C0oWHFlwRwVWMVQJVVmpsk9lQGVGVU3V
WzVTtUb1rOozNYaai1qKWqXaSbUpdZq6kzpfvVL9lPoTpjzTlZnGrGb2Mac1
VDR8NMQaezUGNeY09TQjNAs12zXva5G0WFqJWpVavVrT2uragdoF2q3ad3SI
OiydZJ2dOv06s7p6ulG6G3W7dB/rKer56uXrterd06fqO+tn6TfqXzPAGbAM
Ug12GVwxhA2tDZMN6wyHjGAjGyO+0S6jYWOssZ2xwLjR+KYJxcTVJMek1WTM
lGEaYFpo2mX63EzbLNZsm1m/2Udza/M08ybzuxZyFn4WhRY9Fr9bGlpyLOss
r1lRrbys1lh1W71YaLSQt3D3wlvWNOtA643WvdYfbGxthDZtNlO22rbxtvW2
N1l0VjCrjHXBDmvnZrfG7rjdW3sbe5H9EfvfHEwcUh1aHB4v0lvEW9S0aNxR
05HtuNdx1InpFO+0x2nUWcOZ7dzo/NBFy4Xrst9l0tXANcX1kOtzN3M3oVuH
26y7vfsq99MeiIe3R4nHoKecZ4RnrecDL02vJK9Wr2lva++V3qd9sD7+Ptt8
bvqq+nJ8m32n/Wz9Vvn1+VP8w/xr/R8GGAYIA3oC4UC/wO2B9xbrLBYs7goC
Qb5B24PuB+sFZwX/GIILCQ6pC3kUahFaENofRgtbHtYS9jrcLbw8/G6EfoQ4
ojdSOjIusjlyNsojqiJqNNoselX05RjlGH5Mdyw+NjJ2f+zMEs8lO5ZMxFnH
FcfdWKq3dMXSi8uUl6UtO7Fcejl7+dF4bHxUfEv8e3YQu5E9k+CbUJ8wzXHn
7OQ85bpwK7lTPEdeBW8y0TGxIvFxkmPS9qSpZOfkquRnfHd+Lf9Fik9KQ8ps
alDqgdRPaVFp7emE9Pj0YwI5QaqgL0MtY0XGcKZRZnHmaJZ91o6saaG/cH82
lL00u1tER3+mBsT64g3isRynnLqcN7mRuUdXyK4QrBjIM8zbnDeZ75X/7UrM
Ss7K3gKNgnUFY6tcV+1dDa1OWN27RmtN0ZqJtd5rD64jrUtd91OheWFF4av1
Uet7ilSL1haNb/De0FosVSwsvrnRYWPDJswm/qbBzVabazZ/LOGWXCo1L60q
fV/GKbv0jcU31d982pK4ZbDcpnz3VtxWwdYb25y3HayQrcivGN8euL2zkllZ
Uvlqx/IdF6sWVjXsJO0U7xytDqjurtGu2Vrzvja59nqdW117vUr95vrZXdxd
I7tddrc1qDaUNrzbw99za6/33s5G3caqfbh9OfseNUU29X/L+rZ5v/L+0v0f
DggOjB4MPdjXbNvc3KLSUt4Kt4pbpw7FHbryncd33W0mbXvbGe2lh8Fh8eEn
38d/f+OI/5Heo6yjbT/o/FDfQeso6YQ68zqnu5K7RrtjuoeP+R3r7XHo6fjR
9McDxzWO152QP1F+knSy6OSnU/mnZk5nnn52JunMeO/y3rtno89e6wvpGzzn
f+7Cea/zZ/td+09dcLxw/KL9xWOXWJe6Lttc7hywHuj4yfqnjkGbwc4h26Hu
K3ZXeoYXDZ8ccR45c9Xj6vlrvtcuX198ffhGxI1bN+Nujt7i3np8O+32izs5
d+burr2HvVdyX+Z+1QOVB40/G/zcPmozemLMY2zgYdjDu+Oc8ae/ZP/yfqLo
EfVR1aT6ZPNjy8fHp7ymrjxZ8mTiaebTuWfFv8r+Wv9c//kPv7n8NjAdPT3x
Qvji0+9lL5VeHni18FXvTPDMg9fpr+dmS94ovTn4lvW2/13Uu8m53Pf499Uf
DD70fPT/eO9T+qdP/wJOwPvu
                "], "RGB", "XYZ"], Interleaving -> True], Selectable -> 
             False], BaseStyle -> "ImageGraphics", ImageSizeRaw -> {40, 40}, 
            PlotRange -> {{0, 40}, {0, 40}}], Appearance -> Automatic, 
           ButtonFunction :> $CellContext`GUIImportImage, Evaluator -> 
           Automatic, Method -> "Queued"], 
          "\"Import a retinal image and open it's corrected model if \
available. \\n If the corrected model is not available the original model \
will be loaded\"", TooltipDelay -> 0.5, TooltipStyle -> "TextStyling"], 
         Annotation[#, 
          "Import a retinal image and open it's corrected model if available. \
\n If the corrected model is not available the original model will be loaded",
           "Tooltip"]& ],TagBox[
         TooltipBox[
          ButtonBox[
           GraphicsBox[
            TagBox[
             RasterBox[CompressedData["
1:eJzt1j1Lw0AYB/Bgi/ZD6OAifg37Eeri2oIuDpIqSAc/gtBVcCkuEhBBFOro
4OCmk4Mvm4PgJC5Oj/cnPvQ8Lpc7cxcLXuDfpPf6I0+bdrG31dmYSZJkuyVe
Ot3dlX6/O1htijftwc56ryEulr+DRiKKCZg0TctChhjnRl/0WfhagXxznnwX
IrOefVjv3JMP+5wajK6+psgJ+j36kEykUdGH+cfc79mHHGmMtj7MG8n91o6h
OE1jptlWlIMlovsx0edHnufrvE0d9/5KdLWvX8PUp79PRDeHdmPZdraZh43q
OOw/auvXMPVV9cFzm03e45rn474gcHMbrtGGeTijjfsQbkdgRi1wjePtKW9z
8eFQfdhD3hd7yOaXO6JsbdIm+3Bc7v2cyz51vI0PtdTVl9dRa4J+fCZks+qT
x3ObXAMXH/Zho7x3kQ+fNRwYa+NDPbneal1CfN9RV9wLdqKWPtev+gzkGhd9
z6va3P//zYs8lPyuqXkUWVDXstn/Fz5Xo9YW2GdrLLTV4CszGm01+YqMpbYa
farRylazj41jW9sf+JzjyefynHNK9EVf9P1vX0xMyHwBusoqqw==
              "], {{0, 40}, {40, 0}}, {0, 255}, ColorFunction -> RGBColor], 
             BoxForm`ImageTag[
             "Byte", ColorSpace -> ColorProfileData[CompressedData["
1:eJydlndUVNcWxs+9d3qhzTAUKUPvXWAA6b1Jr6IyzAwwlAGGGRDEhogKRBQR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                "], "RGB", "XYZ"], Interleaving -> True], Selectable -> 
             False], BaseStyle -> "ImageGraphics", ImageSizeRaw -> {40, 40}, 
            PlotRange -> {{0, 40}, {0, 40}}], Appearance -> Automatic, 
           ButtonFunction :> $CellContext`GUILoadOriginalModel, Enabled -> 
           Dynamic[$CellContext`EnableLoadOriginalModel], Evaluator -> 
           Automatic, Method -> "Queued"], 
          "\"This option is only available if the corrected model has been \
loaded. \\n If however you wish to load the original model instead use this \
button.\"", TooltipDelay -> 0.5, TooltipStyle -> "TextStyling"], 
         Annotation[#, 
          "This option is only available if the corrected model has been \
loaded. \n If however you wish to load the original model instead use this \
button.", "Tooltip"]& ],TagBox[
         TooltipBox[
          ButtonBox[
           GraphicsBox[
            TagBox[
             RasterBox[CompressedData["
1:eJzt188rg3EAx/GZKQlJI1HKbSItHBykrMhxNi5zscVKKX03xQ7+hB3kKifK
QUpJSS4cHJSUZgrlIsUByQl7fL49j/r2tOfZ9/v8mMVzeK3tebbv896ePd/v
1habC8XdLpcrWYmbUHRhMJGIpsIePAik5qdj5bjjU9CNkiQ5LEAIscsq1Iq+
roh9L5CFjhLuk+ANIiXc92MFKkq4jzqBFsG+PrjMM5aeZ1iEGmbsZojDOpxD
TuO1jxAQ6MsItm2AVxnPDWE4hC+BMT4hBWUcfbxjvsMEM9YIXAi+N7UdqBPo
4/le1cOmyS7WNfgt6qNz2Z2Fbey5mTTZ10/k68LqNlbaYF8XyT9fWOkKOg30
eW06p6wtoqzVBvq2bez6gCRh5hnBvqCNbQ8woD6mQB+de0XXFV5H0JTvfAn0
jXMei85fazADQ9AODfCa57l0zUuDRznGsIm+vQLvf4ror/Xq6532jjHnZonI
a6KRvkYir5HqrgPo0WnS6qProI/Zt6vxmfD2RVTb72GUs0vdR39PVKv2aV6T
nH3LzLZjIn+fRNqoJ5jV2Ge2b195TH83VRloo/w6+8z23cCpibZCzPbdQqtN
bVb0BW1ss6LPbn+1r9hyHH3ZX+zLcPT1Evn/qsj/Q7Posc6gu1Cfw+Fw/Dff
+/G1GA==
              "], {{0, 40}, {40, 0}}, {0, 255}, ColorFunction -> RGBColor], 
             BoxForm`ImageTag[
             "Byte", ColorSpace -> ColorProfileData[CompressedData["
1:eJydlndUVNcWxs+9d3qhzTAUKUPvXWAA6b1Jr6IyzAwwlAGGGRDEhogKRBQR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                "], "RGB", "XYZ"], Interleaving -> True], Selectable -> 
             False], BaseStyle -> "ImageGraphics", ImageSizeRaw -> {40, 40}, 
            PlotRange -> {{0, 40}, {0, 40}}], Appearance -> Automatic, 
           ButtonFunction :> $CellContext`GUIExportImage, Evaluator -> 
           Automatic, Method -> "Queued"], 
          "\"Export the model. The model will be named with a postfix \
_Corrected.dat. \\nNotice that any other corrected model will be \
overwritten\"", TooltipDelay -> 0.5, TooltipStyle -> "TextStyling"], 
         Annotation[#, 
          "Export the model. The model will be named with a postfix \
_Corrected.dat. \nNotice that any other corrected model will be overwritten", 
          "Tooltip"]& ],TagBox[
         TooltipBox[
          ButtonBox[
           GraphicsBox[
            TagBox[
             RasterBox[CompressedData["
1:eJztmL1PFEEYhy9oQachQUKUgobYmlBQ0HAtzeVMFBr1SLQhxuTOqMTwJ9AK
BVEq5COYoA2tHyQbpJDKwhATSExAApKggiLD+/Pudxkuu8PO3twuxU3ycLOz
OzvPvO/ssXPtAw+y9xpSqVShUf5kc4978vnc0PXzcpAeenh34JxUrpZAo1Kq
jiM8iacFzcId4bmwJGwK+8KB8F34KEwIt4VLNveu0q9LeCUcCiokf4R5obuG
fm3CnIVTEK+Fdsd+GWHHgRvZFW448isIRw7dCO75tEq/RzXwquRJRL9MjeLm
F8c+S7/LwnYMbvp6LD8zIfxmY3Qjb0L6dSbgRrpD+E0n6Dd/il+TV/wflZTf
X6HF4NfPa3+uriqW/Y0Ntb24qJY7Opz6fB0ZUevj45XtOYPfGK9DgeOX4WG1
ubDw/xifLv0494r2CYPfh6C++jHmjDrK7spKOa6YC+Z0uLenvs3MlPtiXmgD
nCP7s2h+ywa/NVP8kA8cM5Y4RkHuOSbgdWiDJwrmpNc/Dw6eGEPz2zL4/dD9
9IL7MBYouCfjxbhyzeprFW104Nw4n4D8HoT1Y1/cj06VedHzAyfGiH39in7O
0m/Nz4+5QOyQG9YZE+aHOUc/rDW0YX2ijn64Duc/pdMnxrDI77ug5wNj8Bgx
YhzxibExJtv0NYWYIv7MvX6OzxnnUmLJ4PfM5fdHRF4Y/G6eAb9bBr+Lwu8E
3bCPajb4gZcJ+mFfeNr7yzUvnvdmP7pC+IHJpGIX0q9V2IrRDXvXNgs/0BtT
njFG1rPbH5F8DH5R95fkvvCvRnEr+I1p6cdcu1yPWG+ZoPEi+PGZmfSqX5PY
u14xjRXRT/9+nBJ+WThhz4V9YWeYMar0Ixe84m9QeKd4K6x7xd8cdkr198Ko
V9xzNdncO8ivTp24OQYx4lLK
              "], {{0, 40}, {40, 0}}, {0, 255}, ColorFunction -> RGBColor], 
             BoxForm`ImageTag[
             "Byte", ColorSpace -> ColorProfileData[CompressedData["
1:eJydlndUVNcWxs+9d3qhzTAUKUPvXWAA6b1Jr6IyzAwwlAGGGRDEhogKRBQR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                "], "RGB", "XYZ"], Interleaving -> True], Selectable -> 
             False], BaseStyle -> "ImageGraphics", ImageSizeRaw -> {40, 40}, 
            PlotRange -> {{0, 40}, {0, 40}}], Appearance -> Automatic, 
           ButtonFunction :> $CellContext`GUIResetModel, Evaluator -> 
           Automatic, Method -> "Queued"], 
          "\"Reset the model to the state in which you have opend it.\"", 
          TooltipDelay -> 0.5, TooltipStyle -> "TextStyling"], 
         Annotation[#, 
          "Reset the model to the state in which you have opend it.", 
          "Tooltip"]& ]},
       "RowDefault"]}
    },
    DefaultBaseStyle->"Column",
    GridBoxAlignment->{"Columns" -> {{Left}}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Column"],
  Background->GrayLevel[0.85],
  StripOnInput->False]], "Input",
 CellChangeTimes->{{3.577454932481182*^9, 3.5774549441768513`*^9}}],

Cell["\<\
Operations which communicate with the datafiles. \
\>", "Text",
 CellChangeTimes->{{3.577456486045041*^9, 3.5774565361489067`*^9}}],

Cell[CellGroupData[{

Cell["\<\

1. Import\
\>", "Subtitle",
 CellChangeTimes->{{3.5774549899334683`*^9, 3.577454992692626*^9}}],

Cell[BoxData[
 FrameBox[
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJzt1kEOwUAUgOGiwSFY2LkGR+AEmrCVQSJuILFgYWEhErERidiQuAs9y5jX
aFK0M1N9byzM4m/avpn2W07N67d6ecdxhmVxaXXGjcGgM2m74qE5GXW9grip
P4OXnHMbYYwxVVySdK/1WZ+Gr0zkKyH5LqIisg++d0bywX9OEmNanys6whzR
Bx1EhYw+2L8P58g+aBdj1PXBvm10TuCDNqJcSh+sX7/PiXzQKmJU+WDdMm5O
6IMWmr550pzYB80U86lsbsCXKSTfjcjnI/kqBEZfVEXyYRsDG8M/v2AY76GN
wJfV+GIj8n1r/LAR+tIaY23EPl1jos2AT2WU2gz5koxKm0Hfu1HLZtgXGq+6
th/4UofkozgbBFmf9Vnff/tsNsoeNWqDOQ==
     "], {{0, 40}, {40, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> ColorProfileData[CompressedData["
1:eJydlndUVNcWxs+9d3qhzTAUKUPvXWAA6b1Jr6IyzAwwlAGGGRDEhogKRBQR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       "], "RGB", "XYZ"], Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSizeRaw->{40, 40},
   PlotRange->{{0, 40}, {0, 40}}],
  StripOnInput->False]], "Output",
 CellChangeTimes->{3.577456311455055*^9}],

Cell["\<\
The import function is used to import a retinal image (and it\
\[CloseCurlyQuote]s model). The first thing that the import does do is import \
the selected image. Afther that the import tries to load the corrected model. \
The corrected model is the model that has a postfix _Corrected.dat behind is. \
Also the name of the corrected model has the samen name as the retinal image.

If however there is no _Corrected model the original model will try to load. \
Also the data file of the original model contains the name of the image. 

For example the file tree is shown below.\
\>", "Text",
 CellChangeTimes->{{3.577183169565354*^9, 3.5771831721720934`*^9}, {
  3.57718811357885*^9, 3.57718830143285*^9}, {3.57718850510785*^9, 
  3.57718864369285*^9}}],

Cell["\<\
imagename.jpg
/Results/imagename.dat
/Results/imagename_Corrected.dat\
\>", "Program",
 CellChangeTimes->{{3.5771883129528503`*^9, 3.57718834767185*^9}, {
  3.57718838262185*^9, 3.5771884144408503`*^9}, {3.57718881144285*^9, 
  3.5771888117238503`*^9}}],

Cell[CellGroupData[{

Cell["Errors", "Subsubsection",
 CellChangeTimes->{{3.5771886592358503`*^9, 3.57718866915485*^9}}],

Cell["\<\
1. Make sure the models are in the folder /Results
2. Make sure the model is named the same as the image.
3. If there is a corrected model, make sure it is also in the /Result folder \
with the name containing the imagename and a postfix _Corrected.dat\
\>", "Text",
 CellChangeTimes->{{3.5771886924198503`*^9, 3.57718869835385*^9}, {
  3.57718874314485*^9, 3.5771888697358503`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["2. Load ogirinal datafile", "Subtitle",
 CellChangeTimes->{{3.5774550297327447`*^9, 3.577455042044449*^9}, 
   3.5774562929489965`*^9}],

Cell[BoxData[
 FrameBox[
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJzt1j1Lw0AYB/Bgi/ZD6OAifg37Eeri2oIuDpIqSAc/gtBVcCkuEhBBFOro
4OCmk4Mvm4PgJC5Oj/cnPvQ8Lpc7cxcLXuDfpPf6I0+bdrG31dmYSZJkuyVe
Ot3dlX6/O1htijftwc56ryEulr+DRiKKCZg0TctChhjnRl/0WfhagXxznnwX
IrOefVjv3JMP+5wajK6+psgJ+j36kEykUdGH+cfc79mHHGmMtj7MG8n91o6h
OE1jptlWlIMlovsx0edHnufrvE0d9/5KdLWvX8PUp79PRDeHdmPZdraZh43q
OOw/auvXMPVV9cFzm03e45rn474gcHMbrtGGeTijjfsQbkdgRi1wjePtKW9z
8eFQfdhD3hd7yOaXO6JsbdIm+3Bc7v2cyz51vI0PtdTVl9dRa4J+fCZks+qT
x3ObXAMXH/Zho7x3kQ+fNRwYa+NDPbneal1CfN9RV9wLdqKWPtev+gzkGhd9
z6va3P//zYs8lPyuqXkUWVDXstn/Fz5Xo9YW2GdrLLTV4CszGm01+YqMpbYa
farRylazj41jW9sf+JzjyefynHNK9EVf9P1vX0xMyHwBusoqqw==
     "], {{0, 40}, {40, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> ColorProfileData[CompressedData["
1:eJydlndUVNcWxs+9d3qhzTAUKUPvXWAA6b1Jr6IyzAwwlAGGGRDEhogKRBQR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       "], "RGB", "XYZ"], Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSizeRaw->{40, 40},
   PlotRange->{{0, 40}, {0, 40}}],
  StripOnInput->False]], "Output",
 CellChangeTimes->{3.5774564086976166`*^9}],

Cell["\<\
This buttons allows you to load the orignal datafile. This is the model \
without any manual modifications. This buttons is only available if a \
corrected model has been loaded.\
\>", "Text",
 CellChangeTimes->{{3.577455107479192*^9, 3.5774552153723626`*^9}, {
  3.577455255972685*^9, 3.577455311748875*^9}, {3.577455448925721*^9, 
  3.5774554500927877`*^9}}],

Cell[TextData[{
 StyleBox["IMPORTANT: ",
  FontWeight->"Bold",
  FontColor->RGBColor[1, 0, 0]],
 StyleBox["If the model is exported again it will overwrite the previous \
_Corrected model. ",
  FontColor->GrayLevel[0]]
}], "Text",
 CellChangeTimes->{{3.577455451424864*^9, 3.5774554689318657`*^9}}],

Cell[CellGroupData[{

Cell["Errors", "Subsubsection",
 CellChangeTimes->{{3.5774555290093017`*^9, 3.577455545004216*^9}}],

Cell["\<\
1. No original datafile has been found. Make sure the name of the original \
datafile has not been changed. The data filename should be the same as the \
imagename.\
\>", "Text",
 CellChangeTimes->{{3.5774555574389277`*^9, 3.5774555589890165`*^9}, {
  3.5774556122060604`*^9, 3.5774556297620645`*^9}, {3.5774556666931767`*^9, 
  3.577455747276786*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["3. Export model", "Subtitle",
 CellChangeTimes->{{3.5774550452926345`*^9, 3.577455048124797*^9}}],

Cell[BoxData[
 FrameBox[
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJzt188rg3EAx/GZKQlJI1HKbSItHBykrMhxNi5zscVKKX03xQ7+hB3kKifK
QUpJSS4cHJSUZgrlIsUByQl7fL49j/r2tOfZ9/v8mMVzeK3tebbv896ePd/v
1habC8XdLpcrWYmbUHRhMJGIpsIePAik5qdj5bjjU9CNkiQ5LEAIscsq1Iq+
roh9L5CFjhLuk+ANIiXc92MFKkq4jzqBFsG+PrjMM5aeZ1iEGmbsZojDOpxD
TuO1jxAQ6MsItm2AVxnPDWE4hC+BMT4hBWUcfbxjvsMEM9YIXAi+N7UdqBPo
4/le1cOmyS7WNfgt6qNz2Z2Fbey5mTTZ10/k68LqNlbaYF8XyT9fWOkKOg30
eW06p6wtoqzVBvq2bez6gCRh5hnBvqCNbQ8woD6mQB+de0XXFV5H0JTvfAn0
jXMei85fazADQ9AODfCa57l0zUuDRznGsIm+vQLvf4ror/Xq6532jjHnZonI
a6KRvkYir5HqrgPo0WnS6qProI/Zt6vxmfD2RVTb72GUs0vdR39PVKv2aV6T
nH3LzLZjIn+fRNqoJ5jV2Ge2b195TH83VRloo/w6+8z23cCpibZCzPbdQqtN
bVb0BW1ss6LPbn+1r9hyHH3ZX+zLcPT1Evn/qsj/Q7Posc6gu1Cfw+Fw/Dff
+/G1GA==
     "], {{0, 40}, {40, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> ColorProfileData[CompressedData["
1:eJydlndUVNcWxs+9d3qhzTAUKUPvXWAA6b1Jr6IyzAwwlAGGGRDEhogKRBQR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       "], "RGB", "XYZ"], Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSizeRaw->{40, 40},
   PlotRange->{{0, 40}, {0, 40}}],
  StripOnInput->False]], "Output",
 CellChangeTimes->{3.57745644091146*^9}],

Cell[TextData[{
 "This option wil export the model. It saves the file with a postfix: \
_Corrected. ",
 StyleBox["IMPORTANT:",
  FontWeight->"Bold",
  FontColor->RGBColor[1, 0, 0]],
 " If this file already exists it will be overwritten without any warning."
}], "Text",
 CellChangeTimes->{{3.577455753559145*^9, 3.5774557681809816`*^9}, {
  3.5774558099333696`*^9, 3.5774558631334124`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["4. Reset the model", "Subtitle",
 CellChangeTimes->{{3.57745505185401*^9, 3.5774550665968533`*^9}}],

Cell[BoxData[
 FrameBox[
  GraphicsBox[
   TagBox[RasterBox[CompressedData["
1:eJztmL1PFEEYhy9oQachQUKUgobYmlBQ0HAtzeVMFBr1SLQhxuTOqMTwJ9AK
BVEq5COYoA2tHyQbpJDKwhATSExAApKggiLD+/Pudxkuu8PO3twuxU3ycLOz
OzvPvO/ssXPtAw+y9xpSqVShUf5kc4978vnc0PXzcpAeenh34JxUrpZAo1Kq
jiM8iacFzcId4bmwJGwK+8KB8F34KEwIt4VLNveu0q9LeCUcCiokf4R5obuG
fm3CnIVTEK+Fdsd+GWHHgRvZFW448isIRw7dCO75tEq/RzXwquRJRL9MjeLm
F8c+S7/LwnYMbvp6LD8zIfxmY3Qjb0L6dSbgRrpD+E0n6Dd/il+TV/wflZTf
X6HF4NfPa3+uriqW/Y0Ntb24qJY7Opz6fB0ZUevj45XtOYPfGK9DgeOX4WG1
ubDw/xifLv0494r2CYPfh6C++jHmjDrK7spKOa6YC+Z0uLenvs3MlPtiXmgD
nCP7s2h+ywa/NVP8kA8cM5Y4RkHuOSbgdWiDJwrmpNc/Dw6eGEPz2zL4/dD9
9IL7MBYouCfjxbhyzeprFW104Nw4n4D8HoT1Y1/cj06VedHzAyfGiH39in7O
0m/Nz4+5QOyQG9YZE+aHOUc/rDW0YX2ijn64Duc/pdMnxrDI77ug5wNj8Bgx
YhzxibExJtv0NYWYIv7MvX6OzxnnUmLJ4PfM5fdHRF4Y/G6eAb9bBr+Lwu8E
3bCPajb4gZcJ+mFfeNr7yzUvnvdmP7pC+IHJpGIX0q9V2IrRDXvXNgs/0BtT
njFG1rPbH5F8DH5R95fkvvCvRnEr+I1p6cdcu1yPWG+ZoPEi+PGZmfSqX5PY
u14xjRXRT/9+nBJ+WThhz4V9YWeYMar0Ixe84m9QeKd4K6x7xd8cdkr198Ko
V9xzNdncO8ivTp24OQYx4lLK
     "], {{0, 40}, {40, 0}}, {0, 255},
     ColorFunction->RGBColor],
    BoxForm`ImageTag["Byte", ColorSpace -> ColorProfileData[CompressedData["
1:eJydlndUVNcWxs+9d3qhzTAUKUPvXWAA6b1Jr6IyzAwwlAGGGRDEhogKRBQR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       "], "RGB", "XYZ"], Interleaving -> True],
    Selectable->False],
   BaseStyle->"ImageGraphics",
   ImageSizeRaw->{40, 40},
   PlotRange->{{0, 40}, {0, 40}}],
  StripOnInput->False]], "Output",
 CellChangeTimes->{3.5774564640257816`*^9}],

Cell["\<\
This will reset the model to the point when you loaded the model. Note that \
If a original model has been loaded this option will do the same as loading \
the original datafile.\
\>", "Text",
 CellChangeTimes->{{3.577455880810424*^9, 3.577455914549353*^9}, {
  3.577455998573159*^9, 3.5774560510451603`*^9}, {3.5774560867172008`*^9, 
  3.5774561957254353`*^9}, {3.5774562643813624`*^9, 3.577456283252442*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.577455023566392*^9, 3.577455026317549*^9}}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{944, 1002},
WindowMargins->{{Automatic, 0}, {0, Automatic}},
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (November 20, 2012)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 288, 4, 90, "Title"],
Cell[870, 28, 22737, 399, 98, "Input"],
Cell[23610, 429, 141, 3, 30, "Text"],
Cell[CellGroupData[{
Cell[23776, 436, 106, 4, 77, "Subtitle"],
Cell[23885, 442, 4436, 79, 67, "Output"],
Cell[28324, 523, 763, 14, 163, "Text"],
Cell[29090, 539, 263, 7, 80, "Program"],
Cell[CellGroupData[{
Cell[29378, 550, 98, 1, 34, "Subsubsection"],
Cell[29479, 553, 393, 7, 87, "Text"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[29921, 566, 141, 2, 49, "Subtitle"],
Cell[30065, 570, 4637, 82, 67, "Output"],
Cell[34705, 654, 370, 7, 49, "Text"],
Cell[35078, 663, 298, 8, 30, "Text"],
Cell[CellGroupData[{
Cell[35401, 675, 99, 1, 34, "Subsubsection"],
Cell[35503, 678, 362, 7, 49, "Text"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[35914, 691, 103, 1, 49, "Subtitle"],
Cell[36020, 694, 4712, 84, 67, "Output"],
Cell[40735, 780, 390, 9, 49, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41162, 794, 105, 1, 49, "Subtitle"],
Cell[41270, 797, 4975, 88, 67, "Output"],
Cell[46248, 887, 420, 7, 49, "Text"],
Cell[46671, 896, 92, 1, 31, "Input"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
